/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var G=["require","exports","vs/base/common/platform","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/range","vs/base/common/errors","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/event","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/base/common/uri","vs/base/common/diff/diffChange","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/editor/common/core/characterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Y=function(y){for(var n=[],D=0,T=y.length;D<T;D++)n[D]=G[y[D]];return n},Ne=this,pe=typeof global=="object"?global:{},ee;(function(y){y.global=Ne;var n=function(){function D(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(D.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),D.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=D._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof y.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},D._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},D}();y.Environment=n})(ee||(ee={}));var ee;(function(y){var n=function(){function M(u,E,o){this.type=u,this.detail=E,this.timestamp=o}return M}();y.LoaderEvent=n;var D=function(){function M(u){this._events=[new n(1,"",u)]}return M.prototype.record=function(u,E){this._events.push(new n(u,E,y.Utilities.getHighPerformanceTimestamp()))},M.prototype.getEvents=function(){return this._events},M}();y.LoaderEventRecorder=D;var T=function(){function M(){}return M.prototype.record=function(u,E){},M.prototype.getEvents=function(){return[]},M.INSTANCE=new M,M}();y.NullLoaderEventRecorder=T})(ee||(ee={}));var ee;(function(y){var n=function(){function D(){}return D.fileUriToFilePath=function(T,M){if(M=decodeURI(M).replace(/%23/g,"#"),T){if(/^file:\/\/\//.test(M))return M.substr(8);if(/^file:\/\//.test(M))return M.substr(5)}else if(/^file:\/\//.test(M))return M.substr(7);return M},D.startsWith=function(T,M){return T.length>=M.length&&T.substr(0,M.length)===M},D.endsWith=function(T,M){return T.length>=M.length&&T.substr(T.length-M.length)===M},D.containsQueryString=function(T){return/^[^\#]*\?/gi.test(T)},D.isAbsolutePath=function(T){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(T)},D.forEachProperty=function(T,M){if(T){var u=void 0;for(u in T)T.hasOwnProperty(u)&&M(u,T[u])}},D.isEmpty=function(T){var M=!0;return D.forEachProperty(T,function(){M=!1}),M},D.recursiveClone=function(T){if(!T||typeof T!="object"||T instanceof RegExp||!Array.isArray(T)&&Object.getPrototypeOf(T)!==Object.prototype)return T;var M=Array.isArray(T)?[]:{};return D.forEachProperty(T,function(u,E){E&&typeof E=="object"?M[u]=D.recursiveClone(E):M[u]=E}),M},D.generateAnonymousModule=function(){return"===anonymous"+D.NEXT_ANONYMOUS_ID+++"==="},D.isAnonymousModule=function(T){return D.startsWith(T,"===anonymous")},D.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=y.global.performance&&typeof y.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?y.global.performance.now():Date.now()},D.NEXT_ANONYMOUS_ID=1,D.PERFORMANCE_NOW_PROBED=!1,D.HAS_PERFORMANCE_NOW=!1,D}();y.Utilities=n})(ee||(ee={}));var ee;(function(y){function n(M){if(M instanceof Error)return M;var u=new Error(M.message||String(M)||"Unknown Error");return M.stack&&(u.stack=M.stack),u}y.ensureError=n;var D=function(){function M(){}return M.validateConfigurationOptions=function(u){function E(l){if(l.phase==="loading"){console.error('Loading "'+l.moduleId+'" failed'),console.error(l),console.error("Here are the modules that depend on it:"),console.error(l.neededBy);return}if(l.phase==="factory"){console.error('The factory method of "'+l.moduleId+'" has thrown an exception'),console.error(l);return}}if(u=u||{},typeof u.baseUrl!="string"&&(u.baseUrl=""),typeof u.isBuild!="boolean"&&(u.isBuild=!1),typeof u.paths!="object"&&(u.paths={}),typeof u.config!="object"&&(u.config={}),typeof u.catchError=="undefined"&&(u.catchError=!1),typeof u.recordStats=="undefined"&&(u.recordStats=!1),typeof u.urlArgs!="string"&&(u.urlArgs=""),typeof u.onError!="function"&&(u.onError=E),Array.isArray(u.ignoreDuplicateModules)||(u.ignoreDuplicateModules=[]),u.baseUrl.length>0&&(y.Utilities.endsWith(u.baseUrl,"/")||(u.baseUrl+="/")),typeof u.cspNonce!="string"&&(u.cspNonce=""),typeof u.preferScriptTags=="undefined"&&(u.preferScriptTags=!1),Array.isArray(u.nodeModules)||(u.nodeModules=[]),u.nodeCachedData&&typeof u.nodeCachedData=="object"&&(typeof u.nodeCachedData.seed!="string"&&(u.nodeCachedData.seed="seed"),(typeof u.nodeCachedData.writeDelay!="number"||u.nodeCachedData.writeDelay<0)&&(u.nodeCachedData.writeDelay=1e3*7),!u.nodeCachedData.path||typeof u.nodeCachedData.path!="string")){var o=n(new Error("INVALID cached data configuration, 'path' MUST be set"));o.phase="configuration",u.onError(o),u.nodeCachedData=void 0}return u},M.mergeConfigurationOptions=function(u,E){u===void 0&&(u=null),E===void 0&&(E=null);var o=y.Utilities.recursiveClone(E||{});return y.Utilities.forEachProperty(u,function(l,a){l==="ignoreDuplicateModules"&&typeof o.ignoreDuplicateModules!="undefined"?o.ignoreDuplicateModules=o.ignoreDuplicateModules.concat(a):l==="paths"&&typeof o.paths!="undefined"?y.Utilities.forEachProperty(a,function(v,w){return o.paths[v]=w}):l==="config"&&typeof o.config!="undefined"?y.Utilities.forEachProperty(a,function(v,w){return o.config[v]=w}):o[l]=y.Utilities.recursiveClone(a)}),M.validateConfigurationOptions(o)},M}();y.ConfigurationOptionsUtil=D;var T=function(){function M(u,E){if(this._env=u,this.options=D.mergeConfigurationOptions(E),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var o=this.options.nodeRequire.main.filename,l=Math.max(o.lastIndexOf("/"),o.lastIndexOf("\\"));this.options.baseUrl=o.substring(0,l+1)}if(this.options.nodeMain&&this._env.isNode){var o=this.options.nodeMain,l=Math.max(o.lastIndexOf("/"),o.lastIndexOf("\\"));this.options.baseUrl=o.substring(0,l+1)}}}return M.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var u=0;u<this.options.ignoreDuplicateModules.length;u++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[u]]=!0},M.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var u=0,E=this.options.nodeModules;u<E.length;u++){var o=E[u];this.nodeModulesMap[o]=!0}},M.prototype._createSortedPathsRules=function(){var u=this;this.sortedPathsRules=[],y.Utilities.forEachProperty(this.options.paths,function(E,o){Array.isArray(o)?u.sortedPathsRules.push({from:E,to:o}):u.sortedPathsRules.push({from:E,to:[o]})}),this.sortedPathsRules.sort(function(E,o){return o.from.length-E.from.length})},M.prototype.cloneAndMerge=function(u){return new M(this._env,D.mergeConfigurationOptions(u,this.options))},M.prototype.getOptionsLiteral=function(){return this.options},M.prototype._applyPaths=function(u){for(var E,o=0,l=this.sortedPathsRules.length;o<l;o++)if(E=this.sortedPathsRules[o],y.Utilities.startsWith(u,E.from)){for(var a=[],v=0,w=E.to.length;v<w;v++)a.push(E.to[v]+u.substr(E.from.length));return a}return[u]},M.prototype._addUrlArgsToUrl=function(u){return y.Utilities.containsQueryString(u)?u+"&"+this.options.urlArgs:u+"?"+this.options.urlArgs},M.prototype._addUrlArgsIfNecessaryToUrl=function(u){return this.options.urlArgs?this._addUrlArgsToUrl(u):u},M.prototype._addUrlArgsIfNecessaryToUrls=function(u){if(this.options.urlArgs)for(var E=0,o=u.length;E<o;E++)u[E]=this._addUrlArgsToUrl(u[E]);return u},M.prototype.moduleIdToPaths=function(u){var E=this.nodeModulesMap[u]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(u);if(E)return this.isBuild()?["empty:"]:["node|"+u];var o=u,l;if(!y.Utilities.endsWith(o,".js")&&!y.Utilities.isAbsolutePath(o)){l=this._applyPaths(o);for(var a=0,v=l.length;a<v;a++)this.isBuild()&&l[a]==="empty:"||(y.Utilities.isAbsolutePath(l[a])||(l[a]=this.options.baseUrl+l[a]),!y.Utilities.endsWith(l[a],".js")&&!y.Utilities.containsQueryString(l[a])&&(l[a]=l[a]+".js"))}else!y.Utilities.endsWith(o,".js")&&!y.Utilities.containsQueryString(o)&&(o=o+".js"),l=[o];return this._addUrlArgsIfNecessaryToUrls(l)},M.prototype.requireToUrl=function(u){var E=u;return y.Utilities.isAbsolutePath(E)||(E=this._applyPaths(E)[0],y.Utilities.isAbsolutePath(E)||(E=this.options.baseUrl+E)),this._addUrlArgsIfNecessaryToUrl(E)},M.prototype.isBuild=function(){return this.options.isBuild},M.prototype.isDuplicateMessageIgnoredFor=function(u){return this.ignoreDuplicateModulesMap.hasOwnProperty(u)},M.prototype.getConfigForModule=function(u){if(this.options.config)return this.options.config[u]},M.prototype.shouldCatchError=function(){return this.options.catchError},M.prototype.shouldRecordStats=function(){return this.options.recordStats},M.prototype.onError=function(u){this.options.onError(u)},M}();y.Configuration=T})(ee||(ee={}));var ee;(function(y){var n=function(){function l(a){this._env=a,this._scriptLoader=null,this._callbackMap={}}return l.prototype.load=function(a,v,w,m){var c=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new M;else if(this._env.isElectronRenderer){var e=a.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new D:this._scriptLoader=new u(this._env)}else this._env.isNode?this._scriptLoader=new u(this._env):this._scriptLoader=new D;var N={callback:w,errorback:m};if(this._callbackMap.hasOwnProperty(v)){this._callbackMap[v].push(N);return}this._callbackMap[v]=[N],this._scriptLoader.load(a,v,function(){return c.triggerCallback(v)},function(p){return c.triggerErrorback(v,p)})},l.prototype.triggerCallback=function(a){var v=this._callbackMap[a];delete this._callbackMap[a];for(var w=0;w<v.length;w++)v[w].callback()},l.prototype.triggerErrorback=function(a,v){var w=this._callbackMap[a];delete this._callbackMap[a];for(var m=0;m<w.length;m++)w[m].errorback(v)},l}(),D=function(){function l(){}return l.prototype.attachListeners=function(a,v,w){var m=function(){a.removeEventListener("load",c),a.removeEventListener("error",e)},c=function(N){m(),v()},e=function(N){m(),w(N)};a.addEventListener("load",c),a.addEventListener("error",e)},l.prototype.load=function(a,v,w,m){if(/^node\|/.test(v)){var c=a.getConfig().getOptionsLiteral(),e=E(a.getRecorder(),c.nodeRequire||y.global.nodeRequire),N=v.split("|"),p=null;try{p=e(N[1])}catch(r){m(r);return}a.enqueueDefineAnonymousModule([],function(){return p}),w()}else{var L=document.createElement("script");L.setAttribute("async","async"),L.setAttribute("type","text/javascript"),this.attachListeners(L,w,m);var A=a.getConfig().getOptionsLiteral().trustedTypesPolicy;A&&(v=A.createScriptURL(v)),L.setAttribute("src",v);var i=a.getConfig().getOptionsLiteral().cspNonce;i&&L.setAttribute("nonce",i),document.getElementsByTagName("head")[0].appendChild(L)}},l}();function T(l){var a=l.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var v=a?self.eval(a.createScript("","true")):new Function("true");return v.call(self),!0}catch(w){return!1}}var M=function(){function l(){this._cachedCanUseEval=null}return l.prototype._canUseEval=function(a){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=T(a)),this._cachedCanUseEval},l.prototype.load=function(a,v,w,m){if(/^node\|/.test(v)){var c=a.getConfig().getOptionsLiteral(),e=E(a.getRecorder(),c.nodeRequire||y.global.nodeRequire),N=v.split("|"),p=null;try{p=e(N[1])}catch(i){m(i);return}a.enqueueDefineAnonymousModule([],function(){return p}),w()}else{var L=a.getConfig().getOptionsLiteral().trustedTypesPolicy,A=/^((http:)|(https:)|(file:))/.test(v)&&v.substring(0,self.origin.length)!==self.origin;if(!A&&this._canUseEval(a)){fetch(v).then(function(i){if(i.status!==200)throw new Error(i.statusText);return i.text()}).then(function(i){i=i+`
//# sourceURL=`+v;var r=L?self.eval(L.createScript("",i)):new Function(i);r.call(self),w()}).then(void 0,m);return}try{L&&(v=L.createScriptURL(v)),importScripts(v),w()}catch(i){m(i)}}},l}(),u=function(){function l(a){this._env=a,this._didInitialize=!1,this._didPatchNodeRequire=!1}return l.prototype._init=function(a){this._didInitialize||(this._didInitialize=!0,this._fs=a("fs"),this._vm=a("vm"),this._path=a("path"),this._crypto=a("crypto"))},l.prototype._initNodeRequire=function(a,v){var w=v.getConfig().getOptionsLiteral().nodeCachedData;if(!w||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var m=this,c=a("module");function e(N){var p=N.constructor,L=function(i){try{return N.require(i)}finally{}};return L.resolve=function(i,r){return p._resolveFilename(i,N,!1,r)},L.resolve.paths=function(i){return p._resolveLookupPaths(i,N)},L.main=process.mainModule,L.extensions=p._extensions,L.cache=p._cache,L}c.prototype._compile=function(N,p){var L=c.wrap(N.replace(/^#!.*/,"")),A=v.getRecorder(),i=m._getCachedDataPath(w,p),r={filename:p},s;try{var f=m._fs.readFileSync(i);s=f.slice(0,16),r.cachedData=f.slice(16),A.record(60,i)}catch(R){A.record(61,i)}var _=new m._vm.Script(L,r),h=_.runInThisContext(r),d=m._path.dirname(p),g=e(this),P=[this.exports,g,this,p,d,process,pe,Buffer],F=h.apply(this.exports,P);return m._handleCachedData(_,L,i,!r.cachedData,v),m._verifyCachedData(_,L,i,s,v),F}},l.prototype.load=function(a,v,w,m){var c=this,e=a.getConfig().getOptionsLiteral(),N=E(a.getRecorder(),e.nodeRequire||y.global.nodeRequire),p=e.nodeInstrumenter||function(h){return h};this._init(N),this._initNodeRequire(N,a);var L=a.getRecorder();if(/^node\|/.test(v)){var A=v.split("|"),i=null;try{i=N(A[1])}catch(h){m(h);return}a.enqueueDefineAnonymousModule([],function(){return i}),w()}else{v=y.Utilities.fileUriToFilePath(this._env.isWindows,v);var r=this._path.normalize(v),s=this._getElectronRendererScriptPathOrUri(r),f=Boolean(e.nodeCachedData),_=f?this._getCachedDataPath(e.nodeCachedData,v):void 0;this._readSourceAndCachedData(r,_,L,function(h,d,g,P){if(h){m(h);return}var F;d.charCodeAt(0)===l._BOM?F=l._PREFIX+d.substring(1)+l._SUFFIX:F=l._PREFIX+d+l._SUFFIX,F=p(F,r);var R={filename:s,cachedData:g},I=c._createAndEvalScript(a,F,R,w,m);c._handleCachedData(I,F,_,f&&!g,a),c._verifyCachedData(I,F,_,P,a)})}},l.prototype._createAndEvalScript=function(a,v,w,m,c){var e=a.getRecorder();e.record(31,w.filename);var N=new this._vm.Script(v,w),p=N.runInThisContext(w),L=a.getGlobalAMDDefineFunc(),A=!1,i=function(){return A=!0,L.apply(null,arguments)};return i.amd=L.amd,p.call(y.global,a.getGlobalAMDRequireFunc(),i,w.filename,this._path.dirname(w.filename)),e.record(32,w.filename),A?m():c(new Error("Didn't receive define call in "+w.filename+"!")),N},l.prototype._getElectronRendererScriptPathOrUri=function(a){if(!this._env.isElectronRenderer)return a;var v=a.match(/^([a-z])\:(.*)/i);return v?"file:///"+(v[1].toUpperCase()+":"+v[2]).replace(/\\/g,"/"):"file://"+a},l.prototype._getCachedDataPath=function(a,v){var w=this._crypto.createHash("md5").update(v,"utf8").update(a.seed,"utf8").update(process.arch,"").digest("hex"),m=this._path.basename(v).replace(/\.js$/,"");return this._path.join(a.path,m+"-"+w+".code")},l.prototype._handleCachedData=function(a,v,w,m,c){var e=this;a.cachedDataRejected?this._fs.unlink(w,function(N){c.getRecorder().record(62,w),e._createAndWriteCachedData(a,v,w,c),N&&c.getConfig().onError(N)}):m&&this._createAndWriteCachedData(a,v,w,c)},l.prototype._createAndWriteCachedData=function(a,v,w,m){var c=this,e=Math.ceil(m.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),N=-1,p=0,L=void 0,A=function(){setTimeout(function(){L||(L=c._crypto.createHash("md5").update(v,"utf8").digest());var i=a.createCachedData();if(!(i.length===0||i.length===N||p>=5)){if(i.length<N){A();return}N=i.length,c._fs.writeFile(w,Buffer.concat([L,i]),function(r){r&&m.getConfig().onError(r),m.getRecorder().record(63,w),A()})}},e*Math.pow(4,p++))};A()},l.prototype._readSourceAndCachedData=function(a,v,w,m){if(!v)this._fs.readFile(a,{encoding:"utf8"},m);else{var c=void 0,e=void 0,N=void 0,p=2,L=function(A){A?m(A):--p==0&&m(void 0,c,e,N)};this._fs.readFile(a,{encoding:"utf8"},function(A,i){c=i,L(A)}),this._fs.readFile(v,function(A,i){!A&&i&&i.length>0?(N=i.slice(0,16),e=i.slice(16),w.record(60,v)):w.record(61,v),L()})}},l.prototype._verifyCachedData=function(a,v,w,m,c){var e=this;!m||a.cachedDataRejected||setTimeout(function(){var N=e._crypto.createHash("md5").update(v,"utf8").digest();m.equals(N)||(c.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+w+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(w,function(p){p&&c.getConfig().onError(p)}))},Math.ceil(5e3*(1+Math.random())))},l._BOM=65279,l._PREFIX="(function (require, define, __filename, __dirname) { ",l._SUFFIX=`
});`,l}();function E(l,a){if(a.__$__isRecorded)return a;var v=function(m){l.record(33,m);try{return a(m)}finally{l.record(34,m)}};return v.__$__isRecorded=!0,v}y.ensureRecordedNodeRequire=E;function o(l){return new n(l)}y.createScriptLoader=o})(ee||(ee={}));var ee;(function(y){var n=function(){function o(l){var a=l.lastIndexOf("/");a!==-1?this.fromModulePath=l.substr(0,a+1):this.fromModulePath=""}return o._normalizeModuleId=function(l){var a=l,v;for(v=/\/\.\//;v.test(a);)a=a.replace(v,"/");for(a=a.replace(/^\.\//g,""),v=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;v.test(a);)a=a.replace(v,"/");return a=a.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),a},o.prototype.resolveModule=function(l){var a=l;return y.Utilities.isAbsolutePath(a)||(y.Utilities.startsWith(a,"./")||y.Utilities.startsWith(a,"../"))&&(a=o._normalizeModuleId(this.fromModulePath+a)),a},o.ROOT=new o(""),o}();y.ModuleIdResolver=n;var D=function(){function o(l,a,v,w,m,c){this.id=l,this.strId=a,this.dependencies=v,this._callback=w,this._errorback=m,this.moduleIdResolver=c,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return o._safeInvokeFunction=function(l,a){try{return{returnedValue:l.apply(y.global,a),producedError:null}}catch(v){return{returnedValue:null,producedError:v}}},o._invokeFactory=function(l,a,v,w){return l.isBuild()&&!y.Utilities.isAnonymousModule(a)?{returnedValue:null,producedError:null}:l.shouldCatchError()?this._safeInvokeFunction(v,w):{returnedValue:v.apply(y.global,w),producedError:null}},o.prototype.complete=function(l,a,v){this._isComplete=!0;var w=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);var m=o._invokeFactory(a,this.strId,this._callback,v);w=m.producedError,l.record(22,this.strId),!w&&typeof m.returnedValue!="undefined"&&(!this.exportsPassedIn||y.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(w){var c=y.ensureError(w);c.phase="factory",c.moduleId=this.strId,this.error=c,a.onError(c)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},o.prototype.onDependencyError=function(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1},o.prototype.isComplete=function(){return this._isComplete},o}();y.Module=D;var T=function(){function o(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return o.prototype.getMaxModuleId=function(){return this._nextId},o.prototype.getModuleId=function(l){var a=this._strModuleIdToIntModuleId.get(l);return typeof a=="undefined"&&(a=this._nextId++,this._strModuleIdToIntModuleId.set(l,a),this._intModuleIdToStrModuleId[a]=l),a},o.prototype.getStrModuleId=function(l){return this._intModuleIdToStrModuleId[l]},o}(),M=function(){function o(l){this.id=l}return o.EXPORTS=new o(0),o.MODULE=new o(1),o.REQUIRE=new o(2),o}();y.RegularDependency=M;var u=function(){function o(l,a,v){this.id=l,this.pluginId=a,this.pluginParam=v}return o}();y.PluginDependency=u;var E=function(){function o(l,a,v,w,m){m===void 0&&(m=0),this._env=l,this._scriptLoader=a,this._loaderAvailableTimestamp=m,this._defineFunc=v,this._requireFunc=w,this._moduleIdProvider=new T,this._config=new y.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return o.prototype.reset=function(){return new o(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},o.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},o.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},o._findRelevantLocationInStack=function(l,a){for(var v=function(r){return r.replace(/\\/g,"/")},w=v(l),m=a.split(/\n/),c=0;c<m.length;c++){var e=m[c].match(/(.*):(\d+):(\d+)\)?$/);if(e){var N=e[1],p=e[2],L=e[3],A=Math.max(N.lastIndexOf(" ")+1,N.lastIndexOf("(")+1);if(N=N.substr(A),N=v(N),N===w){var i={line:parseInt(p,10),col:parseInt(L,10)};return i.line===1&&(i.col-="(function (require, define, __filename, __dirname) { ".length),i}}}throw new Error("Could not correlate define call site for needle "+l)},o.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var l=[],a=0,v=0,w=this._modules2.length;v<w;v++){var m=this._modules2[v];if(!!m){var c=this._buildInfoPath[m.id]||null,e=this._buildInfoDefineStack[m.id]||null,N=this._buildInfoDependencies[m.id];l[a++]={id:m.strId,path:c,defineLocation:c&&e?o._findRelevantLocationInStack(c,e):null,dependencies:N,shim:null,exports:m.exports}}}return l},o.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new y.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=y.NullLoaderEventRecorder.INSTANCE),this._recorder},o.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},o.prototype.enqueueDefineAnonymousModule=function(l,a){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var v=null;this._config.isBuild()&&(v=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:v,dependencies:l,callback:a}},o.prototype.defineModule=function(l,a,v,w,m,c){var e=this;c===void 0&&(c=new n(l));var N=this._moduleIdProvider.getModuleId(l);if(this._modules2[N]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}var p=new D(N,l,this._normalizeDependencies(a,c),v,w,c);this._modules2[N]=p,this._config.isBuild()&&(this._buildInfoDefineStack[N]=m,this._buildInfoDependencies[N]=(p.dependencies||[]).map(function(L){return e._moduleIdProvider.getStrModuleId(L.id)})),this._resolve(p)},o.prototype._normalizeDependency=function(l,a){if(l==="exports")return M.EXPORTS;if(l==="module")return M.MODULE;if(l==="require")return M.REQUIRE;var v=l.indexOf("!");if(v>=0){var w=a.resolveModule(l.substr(0,v)),m=a.resolveModule(l.substr(v+1)),c=this._moduleIdProvider.getModuleId(w+"!"+m),e=this._moduleIdProvider.getModuleId(w);return new u(c,e,m)}return new M(this._moduleIdProvider.getModuleId(a.resolveModule(l)))},o.prototype._normalizeDependencies=function(l,a){for(var v=[],w=0,m=0,c=l.length;m<c;m++)v[w++]=this._normalizeDependency(l[m],a);return v},o.prototype._relativeRequire=function(l,a,v,w){if(typeof a=="string")return this.synchronousRequire(a,l);this.defineModule(y.Utilities.generateAnonymousModule(),a,v,w,null,l)},o.prototype.synchronousRequire=function(l,a){a===void 0&&(a=new n(l));var v=this._normalizeDependency(l,a),w=this._modules2[v.id];if(!w)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!w.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(w.error)throw w.error;return w.exports},o.prototype.configure=function(l,a){var v=this._config.shouldRecordStats();a?this._config=new y.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!v&&(this._recorder=null)},o.prototype.getConfig=function(){return this._config},o.prototype._onLoad=function(l){if(this._currentAnonymousDefineCall!==null){var a=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),a.dependencies,a.callback,null,a.stack)}},o.prototype._createLoadError=function(l,a){var v=this,w=this._moduleIdProvider.getStrModuleId(l),m=(this._inverseDependencies2[l]||[]).map(function(e){return v._moduleIdProvider.getStrModuleId(e)}),c=y.ensureError(a);return c.phase="loading",c.moduleId=w,c.neededBy=m,c},o.prototype._onLoadError=function(l,a){var v=this._createLoadError(l,a);this._modules2[l]||(this._modules2[l]=new D(l,this._moduleIdProvider.getStrModuleId(l),[],function(){},null,null));for(var w=[],m=0,c=this._moduleIdProvider.getMaxModuleId();m<c;m++)w[m]=!1;var e=!1,N=[];for(N.push(l),w[l]=!0;N.length>0;){var p=N.shift(),L=this._modules2[p];L&&(e=L.onDependencyError(v)||e);var A=this._inverseDependencies2[p];if(A)for(var m=0,c=A.length;m<c;m++){var i=A[m];w[i]||(N.push(i),w[i]=!0)}}e||this._config.onError(v)},o.prototype._hasDependencyPath=function(l,a){var v=this._modules2[l];if(!v)return!1;for(var w=[],m=0,c=this._moduleIdProvider.getMaxModuleId();m<c;m++)w[m]=!1;var e=[];for(e.push(v),w[l]=!0;e.length>0;){var N=e.shift(),p=N.dependencies;if(p)for(var m=0,c=p.length;m<c;m++){var L=p[m];if(L.id===a)return!0;var A=this._modules2[L.id];A&&!w[L.id]&&(w[L.id]=!0,e.push(A))}}return!1},o.prototype._findCyclePath=function(l,a,v){if(l===a||v===50)return[l];var w=this._modules2[l];if(!w)return null;var m=w.dependencies;if(m)for(var c=0,e=m.length;c<e;c++){var N=this._findCyclePath(m[c].id,a,v+1);if(N!==null)return N.push(l),N}return null},o.prototype._createRequire=function(l){var a=this,v=function(w,m,c){return a._relativeRequire(l,w,m,c)};return v.toUrl=function(w){return a._config.requireToUrl(l.resolveModule(w))},v.getStats=function(){return a.getLoaderEvents()},v.hasDependencyCycle=function(){return a._hasDependencyCycle},v.config=function(w,m){m===void 0&&(m=!1),a.configure(w,m)},v.__$__nodeRequire=y.global.nodeRequire,v},o.prototype._loadModule=function(l){var a=this;if(!(this._modules2[l]||this._knownModules2[l])){this._knownModules2[l]=!0;var v=this._moduleIdProvider.getStrModuleId(l),w=this._config.moduleIdToPaths(v),m=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(v.indexOf("/")===-1||m.test(v))&&w.push("node|"+v);var c=-1,e=function(N){if(c++,c>=w.length)a._onLoadError(l,N);else{var p=w[c],L=a.getRecorder();if(a._config.isBuild()&&p==="empty:"){a._buildInfoPath[l]=p,a.defineModule(a._moduleIdProvider.getStrModuleId(l),[],null,null,null),a._onLoad(l);return}L.record(10,p),a._scriptLoader.load(a,p,function(){a._config.isBuild()&&(a._buildInfoPath[l]=p),L.record(11,p),a._onLoad(l)},function(A){L.record(12,p),e(A)})}};e(null)}},o.prototype._loadPluginDependency=function(l,a){var v=this;if(!(this._modules2[a.id]||this._knownModules2[a.id])){this._knownModules2[a.id]=!0;var w=function(m){v.defineModule(v._moduleIdProvider.getStrModuleId(a.id),[],m,null,null)};w.error=function(m){v._config.onError(v._createLoadError(a.id,m))},l.load(a.pluginParam,this._createRequire(n.ROOT),w,this._config.getOptionsLiteral())}},o.prototype._resolve=function(l){var a=this,v=l.dependencies;if(v)for(var w=0,m=v.length;w<m;w++){var c=v[w];if(c===M.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(c===M.MODULE){l.unresolvedDependenciesCount--;continue}if(c===M.REQUIRE){l.unresolvedDependenciesCount--;continue}var e=this._modules2[c.id];if(e&&e.isComplete()){if(e.error){l.onDependencyError(e.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(c.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(c.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");var N=this._findCyclePath(c.id,l.id,0)||[];N.reverse(),N.push(c.id),console.warn(N.map(function(A){return a._moduleIdProvider.getStrModuleId(A)}).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[c.id]=this._inverseDependencies2[c.id]||[],this._inverseDependencies2[c.id].push(l.id),c instanceof u){var p=this._modules2[c.pluginId];if(p&&p.isComplete()){this._loadPluginDependency(p.exports,c);continue}var L=this._inversePluginDependencies2.get(c.pluginId);L||(L=[],this._inversePluginDependencies2.set(c.pluginId,L)),L.push(c),this._loadModule(c.pluginId);continue}this._loadModule(c.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)},o.prototype._onModuleComplete=function(l){var a=this,v=this.getRecorder();if(!l.isComplete()){var w=l.dependencies,m=[];if(w)for(var c=0,e=w.length;c<e;c++){var N=w[c];if(N===M.EXPORTS){m[c]=l.exports;continue}if(N===M.MODULE){m[c]={id:l.strId,config:function(){return a._config.getConfigForModule(l.strId)}};continue}if(N===M.REQUIRE){m[c]=this._createRequire(l.moduleIdResolver);continue}var p=this._modules2[N.id];if(p){m[c]=p.exports;continue}m[c]=null}l.complete(v,this._config,m);var L=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,L)for(var c=0,e=L.length;c<e;c++){var A=L[c],i=this._modules2[A];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var r=this._inversePluginDependencies2.get(l.id);if(r){this._inversePluginDependencies2.delete(l.id);for(var c=0,e=r.length;c<e;c++)this._loadPluginDependency(l.exports,r[c])}}},o}();y.ModuleManager=E})(ee||(ee={}));var z,ee;(function(y){var n=new y.Environment,D=null,T=function(o,l,a){typeof o!="string"&&(a=l,l=o,o=null),(typeof l!="object"||!Array.isArray(l))&&(a=l,l=null),l||(l=["require","exports","module"]),o?D.defineModule(o,l,a,null,null):D.enqueueDefineAnonymousModule(l,a)};T.amd={jQuery:!0};var M=function(o,l){l===void 0&&(l=!1),D.configure(o,l)},u=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){M(arguments[0]);return}if(typeof arguments[0]=="string")return D.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){D.defineModule(y.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};u.config=M,u.getConfig=function(){return D.getConfig().getOptionsLiteral()},u.reset=function(){D=D.reset()},u.getBuildInfo=function(){return D.getBuildInfo()},u.getStats=function(){return D.getLoaderEvents()},u.define=T;function E(){if(typeof y.global.require!="undefined"||typeof require!="undefined"){var o=y.global.require||require;if(typeof o=="function"&&typeof o.resolve=="function"){var l=y.ensureRecordedNodeRequire(D.getRecorder(),o);y.global.nodeRequire=l,u.nodeRequire=l,u.__$__nodeRequire=l}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?(module.exports=u,require=u):(n.isElectronRenderer||(y.global.define=T),y.global.require=u)}y.init=E,(typeof y.global.define!="function"||!y.global.define.amd)&&(D=new y.ModuleManager(n,y.createScriptLoader(n),T,u,y.Utilities.getHighPerformanceTimestamp()),typeof y.global.require!="undefined"&&typeof y.global.require!="function"&&u.config(y.global.require),z=function(){return T.apply(null,arguments)},z.amd=T.amd,typeof doNotInitLoader=="undefined"&&E())})(ee||(ee={}));var Ee=this,de;(function(y){var n=Ee||{},D=n.Plugin&&n.Plugin.Resources?n.Plugin.Resources:void 0,T=n&&n.document&&n.document.location&&n.document.location.hash.indexOf("pseudo=true")>=0;function M(a,v){var w;return v.length===0?w=a:w=a.replace(/\{(\d+)\}/g,function(m,c){var e=c[0];return typeof v[e]!="undefined"?v[e]:m}),T&&(w="\uFF3B"+w.replace(/[aouei]/g,"$&$&")+"\uFF3D"),w}function u(a,v){var w=a[v];return w||(w=a["*"],w)?w:null}function E(a,v){for(var w=[],m=0;m<arguments.length-2;m++)w[m]=arguments[m+2];return M(v,w)}function o(a){return function(v,w){var m=Array.prototype.slice.call(arguments,2);return M(a[v],m)}}var l=function(){function a(){this.localize=E}return a.prototype.setPseudoTranslation=function(v){T=v},a.prototype.create=function(v,w){return{localize:o(w[v])}},a.prototype.load=function(v,w,m,c){if(c=c||{},!v||v.length===0)m({localize:E});else{var e=void 0;if(D&&D.getString)e=".nls.keys",w([v+e],function(L){m({localize:function(A,i){if(!L[A])return"NLS error: unknown key "+A;var r=L[A].keys;if(i>=r.length)return"NLS error unknown index "+i;var s=r[i],f=[];f[0]=A+"_"+s;for(var _=0;_<arguments.length-2;_++)f[_+1]=arguments[_+2];return D.getString.apply(D,f)}})});else if(c.isBuild)w([v+".nls",v+".nls.keys"],function(L,A){a.BUILD_MAP[v]=L,a.BUILD_MAP_KEYS[v]=A,m(L)});else{var N=c["vs/nls"]||{},p=N.availableLanguages?u(N.availableLanguages,v):null;e=".nls",p!==null&&p!==a.DEFAULT_TAG&&(e=e+"."+p),w([v+e],function(L){Array.isArray(L)?L.localize=o(L):L.localize=o(L[v]),m(L)})}}},a.prototype._getEntryPointsMap=function(){return n.nlsPluginEntryPoints=n.nlsPluginEntryPoints||{},n.nlsPluginEntryPoints},a.prototype.write=function(v,w,m){var c=m.getEntryPoint(),e=this._getEntryPointsMap();e[c]=e[c]||[],e[c].push(w),w!==c&&m.asModule(v+"!"+w,"define(['vs/nls', 'vs/nls!"+c+`'], function(nls, data) { return nls.create("`+w+'", data); });')},a.prototype.writeFile=function(v,w,m,c,e){var N=this._getEntryPointsMap();if(N.hasOwnProperty(w)){for(var p=m.toUrl(w+".nls.js"),L=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],A=N[w],i={},r=0;r<A.length;r++)i[A[r]]=a.BUILD_MAP[A[r]];L.push('define("'+w+'.nls", '+JSON.stringify(i,null,"	")+");"),c(p,L.join(`\r
`))}},a.prototype.finishBuild=function(v){v("nls.metadata.json",JSON.stringify({keys:a.BUILD_MAP_KEYS,messages:a.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},a.DEFAULT_TAG="i-default",a.BUILD_MAP={},a.BUILD_MAP_KEYS={},a}();y.NLSPlugin=l,function(){z("vs/nls",new l)}()})(de||(de={})),z(G[15],Y([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class D{constructor(M,u,E,o){this.originalStart=M,this.originalLength=u,this.modifiedStart=E,this.modifiedLength=o}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=D}),z(G[6],Y([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createErrorWithActions=n.isErrorWithActions=n.ExpectedError=n.NotSupportedError=n.NotImplementedError=n.getErrorMessage=n.disposed=n.readonly=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isPromiseCanceledError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.setUnexpectedErrorHandler=n.errorHandler=n.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(f){setTimeout(()=>{throw f.stack?new Error(f.message+`

`+f.stack):f},0)}}addListener(f){return this.listeners.push(f),()=>{this._removeListener(f)}}emit(f){this.listeners.forEach(_=>{_(f)})}_removeListener(f){this.listeners.splice(this.listeners.indexOf(f),1)}setUnexpectedErrorHandler(f){this.unexpectedErrorHandler=f}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(f){this.unexpectedErrorHandler(f),this.emit(f)}onUnexpectedExternalError(f){this.unexpectedErrorHandler(f)}}n.ErrorHandler=D,n.errorHandler=new D;function T(s){n.errorHandler.setUnexpectedErrorHandler(s)}n.setUnexpectedErrorHandler=T;function M(s){l(s)||n.errorHandler.onUnexpectedError(s)}n.onUnexpectedError=M;function u(s){l(s)||n.errorHandler.onUnexpectedExternalError(s)}n.onUnexpectedExternalError=u;function E(s){if(s instanceof Error){let{name:f,message:_}=s;const h=s.stacktrace||s.stack;return{$isError:!0,name:f,message:_,stack:h}}return s}n.transformErrorForSerialization=E;const o="Canceled";function l(s){return s instanceof Error&&s.name===o&&s.message===o}n.isPromiseCanceledError=l;class a extends Error{constructor(){super(o);this.name=this.message}}n.CancellationError=a;function v(){const s=new Error(o);return s.name=s.message,s}n.canceled=v;function w(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}n.illegalArgument=w;function m(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}n.illegalState=m;function c(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}n.readonly=c;function e(s){const f=new Error(`${s} has been disposed`);return f.name="DISPOSED",f}n.disposed=e;function N(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}n.getErrorMessage=N;class p extends Error{constructor(f){super("NotImplemented");f&&(this.message=f)}}n.NotImplementedError=p;class L extends Error{constructor(f){super("NotSupported");f&&(this.message=f)}}n.NotSupportedError=L;class A extends Error{constructor(){super(...arguments);this.isExpected=!0}}n.ExpectedError=A;function i(s){const f=s;return f instanceof Error&&Array.isArray(f.actions)}n.isErrorWithActions=i;function r(s,f=Object.create(null)){const _=new Error(s);return f.actions&&(_.actions=f.actions),_}n.createErrorWithActions=r}),z(G[7],Y([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function D(T){const M=this;let u=!1,E;return function(){return u||(u=!0,E=T.apply(M,arguments)),E}}n.once=D}),z(G[16],Y([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var D;(function(T){function M(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}T.is=M;const u=Object.freeze([]);function E(){return u}T.empty=E;function*o(s){yield s}T.single=o;function l(s){return s||u}T.from=l;function a(s){return!s||s[Symbol.iterator]().next().done===!0}T.isEmpty=a;function v(s){return s[Symbol.iterator]().next().value}T.first=v;function w(s,f){for(const _ of s)if(f(_))return!0;return!1}T.some=w;function m(s,f){for(const _ of s)if(f(_))return _}T.find=m;function*c(s,f){for(const _ of s)f(_)&&(yield _)}T.filter=c;function*e(s,f){let _=0;for(const h of s)yield f(h,_++)}T.map=e;function*N(...s){for(const f of s)for(const _ of f)yield _}T.concat=N;function*p(s){for(const f of s)for(const _ of f)yield _}T.concatNested=p;function L(s,f,_){let h=_;for(const d of s)h=f(h,d);return h}T.reduce=L;function*A(s,f,_=s.length){for(f<0&&(f+=s.length),_<0?_+=s.length:_>s.length&&(_=s.length);f<_;f++)yield s[f]}T.slice=A;function i(s,f=Number.POSITIVE_INFINITY){const _=[];if(f===0)return[_,s];const h=s[Symbol.iterator]();for(let d=0;d<f;d++){const g=h.next();if(g.done)return[_,T.empty()];_.push(g.value)}return[_,{[Symbol.iterator](){return h}}]}T.consume=i;function r(s,f,_=(h,d)=>h===d){const h=s[Symbol.iterator](),d=f[Symbol.iterator]();for(;;){const g=h.next(),P=d.next();if(g.done!==P.done)return!1;if(g.done)return!0;if(!_(g.value,P.value))return!1}}T.equals=r})(D=n.Iterable||(n.Iterable={}))}),z(G[17],Y([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyMod=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.ScanCodeUtils=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=n.ScanCode=n.KeyCode=void 0;var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.MAX_VALUE=126]="MAX_VALUE"})(D=n.KeyCode||(n.KeyCode={}));var T;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(T=n.ScanCode||(n.ScanCode={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(N,p){this._keyCodeToStr[N]=p,this._strToKeyCode[p.toLowerCase()]=N}keyCodeToStr(N){return this._keyCodeToStr[N]}strToKeyCode(N){return this._strToKeyCode[N.toLowerCase()]||0}}const u=new M,E=new M,o=new M;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const l=[],a=Object.create(null),v=Object.create(null);n.ScanCodeUtils={lowerCaseToEnum:e=>v[e]||0,toEnum:e=>a[e]||0,toString:e=>l[e]||"None"},n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=126;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",N=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",0,e,0,e,e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_CLEAR",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]];let p=[],L=[];for(const A of N){const[i,r,s,f,_,h,d,g,P,F]=A;if(L[s]||(L[s]=!0,l[s]=f,a[f]=s,v[f.toLowerCase()]=s,r&&(n.IMMUTABLE_CODE_TO_KEY_CODE[s]=_,_!==0&&_!==3&&_!==5&&_!==4&&_!==6&&_!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[_]=s))),!p[_]){if(p[_]=!0,!h)throw new Error(`String representation missing for key code ${_} around scan code ${f}`);u.define(_,h),E.define(_,P||h),o.define(_,F||P||h)}d&&(n.EVENT_KEY_CODE_MAP[d]=_),g&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[g]=_)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var w;(function(e){function N(s){return u.keyCodeToStr(s)}e.toString=N;function p(s){return u.strToKeyCode(s)}e.fromString=p;function L(s){return E.keyCodeToStr(s)}e.toUserSettingsUS=L;function A(s){return o.keyCodeToStr(s)}e.toUserSettingsGeneral=A;function i(s){return E.strToKeyCode(s)||o.strToKeyCode(s)}e.fromUserSettings=i;function r(s){if(s>=93&&s<=108)return null;switch(s){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return u.keyCodeToStr(s)}e.toElectronAccelerator=r})(w=n.KeyCodeUtils||(n.KeyCodeUtils={}));var m;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(m=n.KeyMod||(n.KeyMod={}));function c(e,N){const p=(N&65535)<<16>>>0;return(e|p)>>>0}n.KeyChord=c}),z(G[8],Y([0,1,7,16]),function(y,n,D,T){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.disposeOnReturn=n.ImmortalReference=n.AsyncReferenceCollection=n.ReferenceCollection=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.MultiDisposeError=n.markAsSingleton=n.setDisposableTracker=void 0;const M=!1;let u=null;function E(d){u=d}if(n.setDisposableTracker=E,M){const d="__is_disposable_tracked__";E(new class{trackDisposable(g){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[d]||console.log(P)},3e3)}setParent(g,P){if(g&&g!==A.None)try{g[d]=!0}catch{}}markAsDisposed(g){if(g&&g!==A.None)try{g[d]=!0}catch{}}markAsSingleton(g){}})}function o(d){return u?.trackDisposable(d),d}function l(d){u?.markAsDisposed(d)}function a(d,g){u?.setParent(d,g)}function v(d,g){if(!!u)for(const P of d)u.setParent(P,g)}function w(d){return u?.markAsSingleton(d),d}n.markAsSingleton=w;class m extends Error{constructor(g){super(`Encountered errors while disposing of store. Errors: [${g.join(", ")}]`);this.errors=g}}n.MultiDisposeError=m;function c(d){return typeof d.dispose=="function"&&d.dispose.length===0}n.isDisposable=c;function e(d){if(T.Iterable.is(d)){let g=[];for(const P of d)if(P)try{P.dispose()}catch(F){g.push(F)}if(g.length===1)throw g[0];if(g.length>1)throw new m(g);return Array.isArray(d)?[]:d}else if(d)return d.dispose(),d}n.dispose=e;function N(...d){const g=p(()=>e(d));return v(d,g),g}n.combinedDisposable=N;function p(d){const g=o({dispose:(0,D.once)(()=>{l(g),d()})});return g}n.toDisposable=p;class L{constructor(){this._toDispose=new Set,this._isDisposed=!1,o(this)}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return a(g,this),this._isDisposed?L.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(g),g}}n.DisposableStore=L,L.DISABLE_DISPOSED_WARNING=!1;class A{constructor(){this._store=new L,o(this),a(this._store,this)}dispose(){l(this),this._store.dispose()}_register(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(g)}}n.Disposable=A,A.None=Object.freeze({dispose(){}});class i{constructor(){this._isDisposed=!1,o(this)}get value(){return this._isDisposed?void 0:this._value}set value(g){this._isDisposed||g===this._value||(this._value?.dispose(),g&&a(g,this),this._value=g)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,l(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const g=this._value;return this._value=void 0,g&&a(g,null),g}}n.MutableDisposable=i;class r{constructor(g){this._disposable=g,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}n.RefCountedDisposable=r;class s{constructor(){this.references=new Map}acquire(g,...P){let F=this.references.get(g);F||(F={counter:0,object:this.createReferencedObject(g,...P)},this.references.set(g,F));const{object:R}=F,I=(0,D.once)(()=>{--F.counter==0&&(this.destroyReferencedObject(g,F.object),this.references.delete(g))});return F.counter++,{object:R,dispose:I}}}n.ReferenceCollection=s;class f{constructor(g){this.referenceCollection=g}async acquire(g,...P){const F=this.referenceCollection.acquire(g,...P);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(R){throw F.dispose(),R}}}n.AsyncReferenceCollection=f;class _{constructor(g){this.object=g}dispose(){}}n.ImmortalReference=_;function h(d){const g=new L;try{d(g)}finally{g.dispose()}}n.disposeOnReturn=h}),z(G[18],Y([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class D{constructor(u){this.element=u,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class T{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let u=this._first;for(;u!==D.Undefined;){const E=u.next;u.prev=D.Undefined,u.next=D.Undefined,u=E}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(u){return this._insert(u,!1)}push(u){return this._insert(u,!0)}_insert(u,E){const o=new D(u);if(this._first===D.Undefined)this._first=o,this._last=o;else if(E){const a=this._last;this._last=o,o.prev=a,a.next=o}else{const a=this._first;this._first=o,o.next=a,a.prev=o}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(o))}}shift(){if(this._first!==D.Undefined){const u=this._first.element;return this._remove(this._first),u}}pop(){if(this._last!==D.Undefined){const u=this._last.element;return this._remove(this._last),u}}_remove(u){if(u.prev!==D.Undefined&&u.next!==D.Undefined){const E=u.prev;E.next=u.next,u.next.prev=E}else u.prev===D.Undefined&&u.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):u.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):u.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let u=this._first;for(;u!==D.Undefined;)yield u.element,u=u.next}}n.LinkedList=T}),z(G[2],Y([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isLittleEndian=n.OS=n.OperatingSystem=n.setImmediate=n.translationsConfigFile=n.locale=n.Language=n.language=n.userAgent=n.platform=n.isIOS=n.isWeb=n.isNative=n.isLinuxSnap=n.isLinux=n.isMacintosh=n.isWindows=n.PlatformToString=n.Platform=n.isElectronSandboxed=n.globals=void 0;const D="en";let T=!1,M=!1,u=!1,E=!1,o=!1,l=!1,a=!1,v,w=D,m,c;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let e;typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.process!="undefined"?e=n.globals.vscode.process:typeof process!="undefined"&&(e=process);const N=typeof e?.versions?.electron=="string"&&e.type==="renderer";if(n.isElectronSandboxed=N&&e?.sandboxed,typeof navigator=="object"&&!N)c=navigator.userAgent,T=c.indexOf("Windows")>=0,M=c.indexOf("Macintosh")>=0,a=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,u=c.indexOf("Linux")>=0,l=!0,v=navigator.language,w=v;else if(typeof e=="object"){T=e.platform==="win32",M=e.platform==="darwin",u=e.platform==="linux",E=u&&!!e.env.SNAP&&!!e.env.SNAP_REVISION,v=D,w=D;const h=e.env.VSCODE_NLS_CONFIG;if(h)try{const d=JSON.parse(h),g=d.availableLanguages["*"];v=d.locale,w=g||D,m=d._translationsConfigFile}catch(d){}o=!0}else console.error("Unable to resolve platform.");var p;(function(h){h[h.Web=0]="Web",h[h.Mac=1]="Mac",h[h.Linux=2]="Linux",h[h.Windows=3]="Windows"})(p=n.Platform||(n.Platform={}));function L(h){switch(h){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}n.PlatformToString=L;let A=0;M?A=1:T?A=3:u&&(A=2),n.isWindows=T,n.isMacintosh=M,n.isLinux=u,n.isLinuxSnap=E,n.isNative=o,n.isWeb=l,n.isIOS=a,n.platform=A,n.userAgent=c,n.language=w;var i;(function(h){function d(){return n.language}h.value=d;function g(){return n.language.length===2?n.language==="en":n.language.length>=3?n.language[0]==="e"&&n.language[1]==="n"&&n.language[2]==="-":!1}h.isDefaultVariant=g;function P(){return n.language==="en"}h.isDefault=P})(i=n.Language||(n.Language={})),n.locale=v,n.translationsConfigFile=m,n.setImmediate=function(){if(n.globals.setImmediate)return n.globals.setImmediate.bind(n.globals);if(typeof n.globals.postMessage=="function"&&!n.globals.importScripts){let g=[];n.globals.addEventListener("message",F=>{if(F.data&&F.data.vscodeSetImmediateId)for(let R=0,I=g.length;R<I;R++){const S=g[R];if(S.id===F.data.vscodeSetImmediateId){g.splice(R,1),S.callback();return}}});let P=0;return F=>{const R=++P;g.push({id:R,callback:F}),n.globals.postMessage({vscodeSetImmediateId:R},"*")}}if(typeof e?.nextTick=="function")return e.nextTick.bind(e);const d=Promise.resolve();return g=>d.then(g)}();var r;(function(h){h[h.Windows=1]="Windows",h[h.Macintosh=2]="Macintosh",h[h.Linux=3]="Linux"})(r=n.OperatingSystem||(n.OperatingSystem={})),n.OS=M||a?2:T?1:3;let s=!0,f=!1;function _(){if(!f){f=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,s=new Uint16Array(h.buffer)[0]===(2<<8)+1}return s}n.isLittleEndian=_}),z(G[19],Y([0,1,2]),function(y,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.arch=n.nextTick=n.platform=n.env=n.cwd=void 0;let T;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const M=D.globals.vscode.process;T={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()},nextTick(u){return(0,D.setImmediate)(u)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(M){return process.nextTick(M)}}:T={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},nextTick(M){return(0,D.setImmediate)(M)},get env(){return{}},cwd(){return"/"}};n.cwd=T.cwd,n.env=T.env,n.platform=T.platform,n.nextTick=T.nextTick,n.arch=T.arch}),z(G[20],Y([0,1,19]),function(y,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.delimiter=n.sep=n.toNamespacedPath=n.parse=n.format=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.join=n.isAbsolute=n.normalize=n.posix=n.win32=void 0;const T=65,M=97,u=90,E=122,o=46,l=47,a=92,v=58,w=63;class m extends Error{constructor(r,s,f){let _;typeof s=="string"&&s.indexOf("not ")===0?(_="must not be",s=s.replace(/^not /,"")):_="must be";const h=r.indexOf(".")!==-1?"property":"argument";let d=`The "${r}" ${h} ${_} of type ${s}`;d+=`. Received type ${typeof f}`,super(d),this.code="ERR_INVALID_ARG_TYPE"}}function c(i,r){if(typeof i!="string")throw new m(r,"string",i)}function e(i){return i===l||i===a}function N(i){return i===l}function p(i){return i>=T&&i<=u||i>=M&&i<=E}function L(i,r,s,f){let _="",h=0,d=-1,g=0,P=0;for(let F=0;F<=i.length;++F){if(F<i.length)P=i.charCodeAt(F);else{if(f(P))break;P=l}if(f(P)){if(!(d===F-1||g===1))if(g===2){if(_.length<2||h!==2||_.charCodeAt(_.length-1)!==o||_.charCodeAt(_.length-2)!==o){if(_.length>2){const R=_.lastIndexOf(s);R===-1?(_="",h=0):(_=_.slice(0,R),h=_.length-1-_.lastIndexOf(s)),d=F,g=0;continue}else if(_.length!==0){_="",h=0,d=F,g=0;continue}}r&&(_+=_.length>0?`${s}..`:"..",h=2)}else _.length>0?_+=`${s}${i.slice(d+1,F)}`:_=i.slice(d+1,F),h=F-d-1;d=F,g=0}else P===o&&g!==-1?++g:g=-1}return _}function A(i,r){if(r===null||typeof r!="object")throw new m("pathObject","Object",r);const s=r.dir||r.root,f=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${f}`:`${s}${i}${f}`:f}n.win32={resolve(...i){let r="",s="",f=!1;for(let _=i.length-1;_>=-1;_--){let h;if(_>=0){if(h=i[_],c(h,"path"),h.length===0)continue}else r.length===0?h=D.cwd():(h=D.env[`=${r}`]||D.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==r.toLowerCase()&&h.charCodeAt(2)===a)&&(h=`${r}\\`));const d=h.length;let g=0,P="",F=!1;const R=h.charCodeAt(0);if(d===1)e(R)&&(g=1,F=!0);else if(e(R))if(F=!0,e(h.charCodeAt(1))){let I=2,S=I;for(;I<d&&!e(h.charCodeAt(I));)I++;if(I<d&&I!==S){const O=h.slice(S,I);for(S=I;I<d&&e(h.charCodeAt(I));)I++;if(I<d&&I!==S){for(S=I;I<d&&!e(h.charCodeAt(I));)I++;(I===d||I!==S)&&(P=`\\\\${O}\\${h.slice(S,I)}`,g=I)}}}else g=1;else p(R)&&h.charCodeAt(1)===v&&(P=h.slice(0,2),g=2,d>2&&e(h.charCodeAt(2))&&(F=!0,g=3));if(P.length>0)if(r.length>0){if(P.toLowerCase()!==r.toLowerCase())continue}else r=P;if(f){if(r.length>0)break}else if(s=`${h.slice(g)}\\${s}`,f=F,F&&r.length>0)break}return s=L(s,!f,"\\",e),f?`${r}\\${s}`:`${r}${s}`||"."},normalize(i){c(i,"path");const r=i.length;if(r===0)return".";let s=0,f,_=!1;const h=i.charCodeAt(0);if(r===1)return N(h)?"\\":i;if(e(h))if(_=!0,e(i.charCodeAt(1))){let g=2,P=g;for(;g<r&&!e(i.charCodeAt(g));)g++;if(g<r&&g!==P){const F=i.slice(P,g);for(P=g;g<r&&e(i.charCodeAt(g));)g++;if(g<r&&g!==P){for(P=g;g<r&&!e(i.charCodeAt(g));)g++;if(g===r)return`\\\\${F}\\${i.slice(P)}\\`;g!==P&&(f=`\\\\${F}\\${i.slice(P,g)}`,s=g)}}}else s=1;else p(h)&&i.charCodeAt(1)===v&&(f=i.slice(0,2),s=2,r>2&&e(i.charCodeAt(2))&&(_=!0,s=3));let d=s<r?L(i.slice(s),!_,"\\",e):"";return d.length===0&&!_&&(d="."),d.length>0&&e(i.charCodeAt(r-1))&&(d+="\\"),f===void 0?_?`\\${d}`:d:_?`${f}\\${d}`:`${f}${d}`},isAbsolute(i){c(i,"path");const r=i.length;if(r===0)return!1;const s=i.charCodeAt(0);return e(s)||r>2&&p(s)&&i.charCodeAt(1)===v&&e(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,s;for(let h=0;h<i.length;++h){const d=i[h];c(d,"path"),d.length>0&&(r===void 0?r=s=d:r+=`\\${d}`)}if(r===void 0)return".";let f=!0,_=0;if(typeof s=="string"&&e(s.charCodeAt(0))){++_;const h=s.length;h>1&&e(s.charCodeAt(1))&&(++_,h>2&&(e(s.charCodeAt(2))?++_:f=!1))}if(f){for(;_<r.length&&e(r.charCodeAt(_));)_++;_>=2&&(r=`\\${r.slice(_)}`)}return n.win32.normalize(r)},relative(i,r){if(c(i,"from"),c(r,"to"),i===r)return"";const s=n.win32.resolve(i),f=n.win32.resolve(r);if(s===f||(i=s.toLowerCase(),r=f.toLowerCase(),i===r))return"";let _=0;for(;_<i.length&&i.charCodeAt(_)===a;)_++;let h=i.length;for(;h-1>_&&i.charCodeAt(h-1)===a;)h--;const d=h-_;let g=0;for(;g<r.length&&r.charCodeAt(g)===a;)g++;let P=r.length;for(;P-1>g&&r.charCodeAt(P-1)===a;)P--;const F=P-g,R=d<F?d:F;let I=-1,S=0;for(;S<R;S++){const H=i.charCodeAt(_+S);if(H!==r.charCodeAt(g+S))break;H===a&&(I=S)}if(S!==R){if(I===-1)return f}else{if(F>R){if(r.charCodeAt(g+S)===a)return f.slice(g+S+1);if(S===2)return f.slice(g+S)}d>R&&(i.charCodeAt(_+S)===a?I=S:S===2&&(I=3)),I===-1&&(I=0)}let O="";for(S=_+I+1;S<=h;++S)(S===h||i.charCodeAt(S)===a)&&(O+=O.length===0?"..":"\\..");return g+=I,O.length>0?`${O}${f.slice(g,P)}`:(f.charCodeAt(g)===a&&++g,f.slice(g,P))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const r=n.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===a){if(r.charCodeAt(1)===a){const s=r.charCodeAt(2);if(s!==w&&s!==o)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(p(r.charCodeAt(0))&&r.charCodeAt(1)===v&&r.charCodeAt(2)===a)return`\\\\?\\${r}`;return i},dirname(i){c(i,"path");const r=i.length;if(r===0)return".";let s=-1,f=0;const _=i.charCodeAt(0);if(r===1)return e(_)?i:".";if(e(_)){if(s=f=1,e(i.charCodeAt(1))){let g=2,P=g;for(;g<r&&!e(i.charCodeAt(g));)g++;if(g<r&&g!==P){for(P=g;g<r&&e(i.charCodeAt(g));)g++;if(g<r&&g!==P){for(P=g;g<r&&!e(i.charCodeAt(g));)g++;if(g===r)return i;g!==P&&(s=f=g+1)}}}}else p(_)&&i.charCodeAt(1)===v&&(s=r>2&&e(i.charCodeAt(2))?3:2,f=s);let h=-1,d=!0;for(let g=r-1;g>=f;--g)if(e(i.charCodeAt(g))){if(!d){h=g;break}}else d=!1;if(h===-1){if(s===-1)return".";h=s}return i.slice(0,h)},basename(i,r){r!==void 0&&c(r,"ext"),c(i,"path");let s=0,f=-1,_=!0,h;if(i.length>=2&&p(i.charCodeAt(0))&&i.charCodeAt(1)===v&&(s=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let d=r.length-1,g=-1;for(h=i.length-1;h>=s;--h){const P=i.charCodeAt(h);if(e(P)){if(!_){s=h+1;break}}else g===-1&&(_=!1,g=h+1),d>=0&&(P===r.charCodeAt(d)?--d==-1&&(f=h):(d=-1,f=g))}return s===f?f=g:f===-1&&(f=i.length),i.slice(s,f)}for(h=i.length-1;h>=s;--h)if(e(i.charCodeAt(h))){if(!_){s=h+1;break}}else f===-1&&(_=!1,f=h+1);return f===-1?"":i.slice(s,f)},extname(i){c(i,"path");let r=0,s=-1,f=0,_=-1,h=!0,d=0;i.length>=2&&i.charCodeAt(1)===v&&p(i.charCodeAt(0))&&(r=f=2);for(let g=i.length-1;g>=r;--g){const P=i.charCodeAt(g);if(e(P)){if(!h){f=g+1;break}continue}_===-1&&(h=!1,_=g+1),P===o?s===-1?s=g:d!==1&&(d=1):s!==-1&&(d=-1)}return s===-1||_===-1||d===0||d===1&&s===_-1&&s===f+1?"":i.slice(s,_)},format:A.bind(null,"\\"),parse(i){c(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const s=i.length;let f=0,_=i.charCodeAt(0);if(s===1)return e(_)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(e(_)){if(f=1,e(i.charCodeAt(1))){let I=2,S=I;for(;I<s&&!e(i.charCodeAt(I));)I++;if(I<s&&I!==S){for(S=I;I<s&&e(i.charCodeAt(I));)I++;if(I<s&&I!==S){for(S=I;I<s&&!e(i.charCodeAt(I));)I++;I===s?f=I:I!==S&&(f=I+1)}}}}else if(p(_)&&i.charCodeAt(1)===v){if(s<=2)return r.root=r.dir=i,r;if(f=2,e(i.charCodeAt(2))){if(s===3)return r.root=r.dir=i,r;f=3}}f>0&&(r.root=i.slice(0,f));let h=-1,d=f,g=-1,P=!0,F=i.length-1,R=0;for(;F>=f;--F){if(_=i.charCodeAt(F),e(_)){if(!P){d=F+1;break}continue}g===-1&&(P=!1,g=F+1),_===o?h===-1?h=F:R!==1&&(R=1):h!==-1&&(R=-1)}return g!==-1&&(h===-1||R===0||R===1&&h===g-1&&h===d+1?r.base=r.name=i.slice(d,g):(r.name=i.slice(d,h),r.base=i.slice(d,g),r.ext=i.slice(h,g))),d>0&&d!==f?r.dir=i.slice(0,d-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},n.posix={resolve(...i){let r="",s=!1;for(let f=i.length-1;f>=-1&&!s;f--){const _=f>=0?i[f]:D.cwd();c(_,"path"),_.length!==0&&(r=`${_}/${r}`,s=_.charCodeAt(0)===l)}return r=L(r,!s,"/",N),s?`/${r}`:r.length>0?r:"."},normalize(i){if(c(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===l,s=i.charCodeAt(i.length-1)===l;return i=L(i,!r,"/",N),i.length===0?r?"/":s?"./":".":(s&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return c(i,"path"),i.length>0&&i.charCodeAt(0)===l},join(...i){if(i.length===0)return".";let r;for(let s=0;s<i.length;++s){const f=i[s];c(f,"path"),f.length>0&&(r===void 0?r=f:r+=`/${f}`)}return r===void 0?".":n.posix.normalize(r)},relative(i,r){if(c(i,"from"),c(r,"to"),i===r||(i=n.posix.resolve(i),r=n.posix.resolve(r),i===r))return"";const s=1,f=i.length,_=f-s,h=1,d=r.length-h,g=_<d?_:d;let P=-1,F=0;for(;F<g;F++){const I=i.charCodeAt(s+F);if(I!==r.charCodeAt(h+F))break;I===l&&(P=F)}if(F===g)if(d>g){if(r.charCodeAt(h+F)===l)return r.slice(h+F+1);if(F===0)return r.slice(h+F)}else _>g&&(i.charCodeAt(s+F)===l?P=F:F===0&&(P=0));let R="";for(F=s+P+1;F<=f;++F)(F===f||i.charCodeAt(F)===l)&&(R+=R.length===0?"..":"/..");return`${R}${r.slice(h+P)}`},toNamespacedPath(i){return i},dirname(i){if(c(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===l;let s=-1,f=!0;for(let _=i.length-1;_>=1;--_)if(i.charCodeAt(_)===l){if(!f){s=_;break}}else f=!1;return s===-1?r?"/":".":r&&s===1?"//":i.slice(0,s)},basename(i,r){r!==void 0&&c(r,"ext"),c(i,"path");let s=0,f=-1,_=!0,h;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let d=r.length-1,g=-1;for(h=i.length-1;h>=0;--h){const P=i.charCodeAt(h);if(P===l){if(!_){s=h+1;break}}else g===-1&&(_=!1,g=h+1),d>=0&&(P===r.charCodeAt(d)?--d==-1&&(f=h):(d=-1,f=g))}return s===f?f=g:f===-1&&(f=i.length),i.slice(s,f)}for(h=i.length-1;h>=0;--h)if(i.charCodeAt(h)===l){if(!_){s=h+1;break}}else f===-1&&(_=!1,f=h+1);return f===-1?"":i.slice(s,f)},extname(i){c(i,"path");let r=-1,s=0,f=-1,_=!0,h=0;for(let d=i.length-1;d>=0;--d){const g=i.charCodeAt(d);if(g===l){if(!_){s=d+1;break}continue}f===-1&&(_=!1,f=d+1),g===o?r===-1?r=d:h!==1&&(h=1):r!==-1&&(h=-1)}return r===-1||f===-1||h===0||h===1&&r===f-1&&r===s+1?"":i.slice(r,f)},format:A.bind(null,"/"),parse(i){c(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const s=i.charCodeAt(0)===l;let f;s?(r.root="/",f=1):f=0;let _=-1,h=0,d=-1,g=!0,P=i.length-1,F=0;for(;P>=f;--P){const R=i.charCodeAt(P);if(R===l){if(!g){h=P+1;break}continue}d===-1&&(g=!1,d=P+1),R===o?_===-1?_=P:F!==1&&(F=1):_!==-1&&(F=-1)}if(d!==-1){const R=h===0&&s?1:h;_===-1||F===0||F===1&&_===d-1&&_===h+1?r.base=r.name=i.slice(R,d):(r.name=i.slice(R,_),r.base=i.slice(R,d),r.ext=i.slice(_,d))}return h>0?r.dir=i.slice(0,h-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=D.platform==="win32"?n.win32.normalize:n.posix.normalize,n.isAbsolute=D.platform==="win32"?n.win32.isAbsolute:n.posix.isAbsolute,n.join=D.platform==="win32"?n.win32.join:n.posix.join,n.resolve=D.platform==="win32"?n.win32.resolve:n.posix.resolve,n.relative=D.platform==="win32"?n.win32.relative:n.posix.relative,n.dirname=D.platform==="win32"?n.win32.dirname:n.posix.dirname,n.basename=D.platform==="win32"?n.win32.basename:n.posix.basename,n.extname=D.platform==="win32"?n.win32.extname:n.posix.extname,n.format=D.platform==="win32"?n.win32.format:n.posix.format,n.parse=D.platform==="win32"?n.win32.parse:n.posix.parse,n.toNamespacedPath=D.platform==="win32"?n.win32.toNamespacedPath:n.posix.toNamespacedPath,n.sep=D.platform==="win32"?n.win32.sep:n.posix.sep,n.delimiter=D.platform==="win32"?n.win32.delimiter:n.posix.delimiter}),z(G[9],Y([0,1,2]),function(y,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const T=D.globals.performance&&typeof D.globals.performance.now=="function";class M{constructor(E){this._highResolution=T&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new M(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}n.StopWatch=M}),z(G[10],Y([0,1,6,7,8,18,9]),function(y,n,D,T,M,u,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.AsyncEmitter=n.Emitter=n.setGlobalLeakWarningThreshold=n.Event=void 0;var o;(function(r){r.None=()=>M.Disposable.None;function s(W){return(B,C=null,j)=>{let Q=!1,Z;return Z=W(x=>{if(!Q)return Z?Z.dispose():Q=!0,B.call(C,x)},null,j),Q&&Z.dispose(),Z}}r.once=s;function f(W,B){return F((C,j=null,Q)=>W(Z=>C.call(j,B(Z)),null,Q))}r.map=f;function _(W,B){return F((C,j=null,Q)=>W(Z=>{B(Z),C.call(j,Z)},null,Q))}r.forEach=_;function h(W,B){return F((C,j=null,Q)=>W(Z=>B(Z)&&C.call(j,Z),null,Q))}r.filter=h;function d(W){return W}r.signal=d;function g(...W){return(B,C=null,j)=>(0,M.combinedDisposable)(...W.map(Q=>Q(Z=>B.call(C,Z),null,j)))}r.any=g;function P(W,B,C){let j=C;return f(W,Q=>(j=B(j,Q),j))}r.reduce=P;function F(W){let B;const C=new m({onFirstListenerAdd(){B=W(C.fire,C)},onLastListenerRemove(){B.dispose()}});return C.event}function R(W,B,C=100,j=!1,Q){let Z,x,te,ae=0;const oe=new m({leakWarningThreshold:Q,onFirstListenerAdd(){Z=W(he=>{ae++,x=B(x,he),j&&!te&&(oe.fire(x),x=void 0),clearTimeout(te),te=setTimeout(()=>{const me=x;x=void 0,te=void 0,(!j||ae>1)&&oe.fire(me),ae=0},C)})},onLastListenerRemove(){Z.dispose()}});return oe.event}r.debounce=R;function I(W,B=(C,j)=>C===j){let C=!0,j;return h(W,Q=>{const Z=C||!B(Q,j);return C=!1,j=Q,Z})}r.latch=I;function S(W,B){return[r.filter(W,B),r.filter(W,C=>!B(C))]}r.split=S;function O(W,B=!1,C=[]){let j=C.slice(),Q=W(te=>{j?j.push(te):x.fire(te)});const Z=()=>{j&&j.forEach(te=>x.fire(te)),j=null},x=new m({onFirstListenerAdd(){Q||(Q=W(te=>x.fire(te)))},onFirstListenerDidAdd(){j&&(B?setTimeout(Z):Z())},onLastListenerRemove(){Q&&Q.dispose(),Q=null}});return x.event}r.buffer=O;class H{constructor(B){this.event=B}map(B){return new H(f(this.event,B))}forEach(B){return new H(_(this.event,B))}filter(B){return new H(h(this.event,B))}reduce(B,C){return new H(P(this.event,B,C))}latch(){return new H(I(this.event))}debounce(B,C=100,j=!1,Q){return new H(R(this.event,B,C,j,Q))}on(B,C,j){return this.event(B,C,j)}once(B,C,j){return s(this.event)(B,C,j)}}function X(W){return new H(W)}r.chain=X;function $(W,B,C=j=>j){const j=(...te)=>x.fire(C(...te)),Q=()=>W.on(B,j),Z=()=>W.removeListener(B,j),x=new m({onFirstListenerAdd:Q,onLastListenerRemove:Z});return x.event}r.fromNodeEventEmitter=$;function K(W,B,C=j=>j){const j=(...te)=>x.fire(C(...te)),Q=()=>W.addEventListener(B,j),Z=()=>W.removeEventListener(B,j),x=new m({onFirstListenerAdd:Q,onLastListenerRemove:Z});return x.event}r.fromDOMEventEmitter=K;function t(W){return new Promise(B=>s(W)(B))}r.toPromise=t})(o=n.Event||(n.Event={}));class l{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${l._idPool++}`}start(s){this._stopWatch=new E.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}l._idPool=0;let a=-1;function v(r){const s=a;return a=r,{dispose(){a=s}}}n.setGlobalLeakWarningThreshold=v;class w{constructor(s,f=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s){let f=a;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),f<=0||s<f)return;this._stacks||(this._stacks=new Map);const _=new Error().stack.split(`
`).slice(3).join(`
`),h=this._stacks.get(_)||0;if(this._stacks.set(_,h+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let d,g=0;for(const[P,F]of this._stacks)(!d||g<F)&&(d=P,g=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${g}):`),console.warn(d)}return()=>{const d=this._stacks.get(_)||0;this._stacks.set(_,d-1)}}}class m{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=a>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new l(this._options._profName):void 0}get event(){return this._event||(this._event=(s,f,_)=>{this._listeners||(this._listeners=new u.LinkedList);const h=this._listeners.isEmpty();h&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const d=this._listeners.push(f?[s,f]:s);h&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,f);const g=this._leakageMon?.check(this._listeners.size),P=(0,M.toDisposable)(()=>{g&&g(),this._disposed||(d(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return _ instanceof M.DisposableStore?_.add(P):Array.isArray(_)&&_.push(P),P}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new u.LinkedList);for(let f of this._listeners)this._deliveryQueue.push([f,s]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[f,_]=this._deliveryQueue.shift();try{typeof f=="function"?f.call(void 0,_):f[0].call(f[1],_)}catch(h){(0,D.onUnexpectedError)(h)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}n.Emitter=m;class c extends m{async fireAsync(s,f,_){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new u.LinkedList);for(const h of this._listeners)this._asyncDeliveryQueue.push([h,s]);for(;this._asyncDeliveryQueue.size>0&&!f.isCancellationRequested;){const[h,d]=this._asyncDeliveryQueue.shift(),g=[],P={...d,waitUntil:F=>{if(Object.isFrozen(g))throw new Error("waitUntil can NOT be called asynchronous");_&&(F=_(F,typeof h=="function"?h:h[0])),g.push(F)}};try{typeof h=="function"?h.call(void 0,P):h[0].call(h[1],P)}catch(F){(0,D.onUnexpectedError)(F);continue}Object.freeze(g),await Promise.allSettled(g).then(F=>{for(const R of F)R.status==="rejected"&&(0,D.onUnexpectedError)(R.reason)})}}}}n.AsyncEmitter=c;class e extends m{constructor(s){super(s);this._isPaused=0,this._eventQueue=new u.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}n.PauseableEmitter=e;class N extends e{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}n.DebounceEmitter=N;class p extends m{constructor(s){super(s);this._queuedEvents=[],this._mergeFn=s?.merge}fire(s){this._queuedEvents.push(s),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(f=>super.fire(f)),this._queuedEvents=[]})}}n.MicrotaskEmitter=p;class L{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const f={event:s,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const _=()=>{this.hasListeners&&this.unhook(f);const h=this.events.indexOf(f);this.events.splice(h,1)};return(0,M.toDisposable)((0,T.once)(_))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(f=>this.emitter.fire(f))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=L;class A{constructor(){this.buffers=[]}wrapEvent(s){return(f,_,h)=>s(d=>{const g=this.buffers[this.buffers.length-1];g?g.push(()=>f.call(_,d)):f.call(_,d)},void 0,h)}bufferEvents(s){const f=[];this.buffers.push(f);const _=s();return this.buffers.pop(),f.forEach(h=>h()),_}}n.EventBufferer=A;class i{constructor(){this.listening=!1,this.inputEvent=o.None,this.inputEventListener=M.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=i}),z(G[21],Y([0,1,10]),function(y,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const T=Object.freeze(function(o,l){const a=setTimeout(o.bind(l),0);return{dispose(){clearTimeout(a)}}});var M;(function(o){function l(a){return a===o.None||a===o.Cancelled||a instanceof u?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}o.isCancellationToken=l,o.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),o.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(M=n.CancellationToken||(n.CancellationToken={}));class u{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new u),this._token}cancel(){this._token?this._token instanceof u&&this._token.cancel():this._token=M.Cancelled}dispose(l=!1){l&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof u&&this._token.dispose():this._token=M.None}}n.CancellationTokenSource=E}),z(G[4],Y([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getLeftDeleteOffset=n.GraphemeBreakType=n.breakBetweenGraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.getNLines=n.uppercaseFirstLetter=n.containsUppercaseCharacter=n.fuzzyContains=n.stripUTF8BOM=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.removeAnsiEscapeCodes=n.lcut=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsEmoji=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpContainsBackreference=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.truncate=n.count=n.escapeRegExpCharacters=n.escape=n.format2=n.format=n.isFalsyOrWhitespace=void 0;function D(b){return!b||typeof b!="string"?!0:b.trim().length===0}n.isFalsyOrWhitespace=D;const T=/{(\d+)}/g;function M(b,...U){return U.length===0?b:b.replace(T,function(k,V){const q=parseInt(V,10);return isNaN(q)||q<0||q>=U.length?k:U[q]})}n.format=M;const u=/{([^}]+)}/g;function E(b,U){return b.replace(u,(k,V)=>U[V]??k)}n.format2=E;function o(b){return b.replace(/[<>&]/g,function(U){switch(U){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return U}})}n.escape=o;function l(b){return b.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=l;function a(b,U){let k=0;const V=U.charCodeAt(0);for(let q=b.length-1;q>=0;q--)b.charCodeAt(q)===V&&k++;return k}n.count=a;function v(b,U,k="\u2026"){return b.length<=U?b:`${b.substr(0,U)}${k}`}n.truncate=v;function w(b,U=" "){const k=m(b,U);return c(k,U)}n.trim=w;function m(b,U){if(!b||!U)return b;const k=U.length;if(k===0||b.length===0)return b;let V=0;for(;b.indexOf(U,V)===V;)V=V+k;return b.substring(V)}n.ltrim=m;function c(b,U){if(!b||!U)return b;const k=U.length,V=b.length;if(k===0||V===0)return b;let q=V,J=-1;for(;J=b.lastIndexOf(U,q-1),!(J===-1||J+k!==q);){if(J===0)return"";q=J}return b.substring(0,q)}n.rtrim=c;function e(b){return b.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=e;function N(b){return b.replace(/\*/g,"")}n.stripWildcards=N;function p(b,U,k={}){if(!b)throw new Error("Cannot create regex from empty string");U||(b=l(b)),k.wholeWord&&(/\B/.test(b.charAt(0))||(b="\\b"+b),/\B/.test(b.charAt(b.length-1))||(b=b+"\\b"));let V="";return k.global&&(V+="g"),k.matchCase||(V+="i"),k.multiline&&(V+="m"),k.unicode&&(V+="u"),new RegExp(b,V)}n.createRegExp=p;function L(b){return b.source==="^"||b.source==="^$"||b.source==="$"||b.source==="^\\s*$"?!1:!!(b.exec("")&&b.lastIndex===0)}n.regExpLeadsToEndlessLoop=L;function A(b){return!!b.match(/([^\\]|^)(\\\\)*\\\d+/)}n.regExpContainsBackreference=A;function i(b){return(b.global?"g":"")+(b.ignoreCase?"i":"")+(b.multiline?"m":"")+(b.unicode?"u":"")}n.regExpFlags=i;function r(b){return b.split(/\r\n|\r|\n/)}n.splitLines=r;function s(b){for(let U=0,k=b.length;U<k;U++){const V=b.charCodeAt(U);if(V!==32&&V!==9)return U}return-1}n.firstNonWhitespaceIndex=s;function f(b,U=0,k=b.length){for(let V=U;V<k;V++){const q=b.charCodeAt(V);if(q!==32&&q!==9)return b.substring(U,V)}return b.substring(U,k)}n.getLeadingWhitespace=f;function _(b,U=b.length-1){for(let k=U;k>=0;k--){const V=b.charCodeAt(k);if(V!==32&&V!==9)return k}return-1}n.lastNonWhitespaceIndex=_;function h(b,U){return b<U?-1:b>U?1:0}n.compare=h;function d(b,U,k=0,V=b.length,q=0,J=U.length){for(;k<V&&q<J;k++,q++){let se=b.charCodeAt(k),re=U.charCodeAt(q);if(se<re)return-1;if(se>re)return 1}const ne=V-k,ie=J-q;return ne<ie?-1:ne>ie?1:0}n.compareSubstring=d;function g(b,U){return P(b,U,0,b.length,0,U.length)}n.compareIgnoreCase=g;function P(b,U,k=0,V=b.length,q=0,J=U.length){for(;k<V&&q<J;k++,q++){let se=b.charCodeAt(k),re=U.charCodeAt(q);if(se===re)continue;if(se>=128||re>=128)return d(b.toLowerCase(),U.toLowerCase(),k,V,q,J);F(se)&&(se-=32),F(re)&&(re-=32);const le=se-re;if(le!==0)return le}const ne=V-k,ie=J-q;return ne<ie?-1:ne>ie?1:0}n.compareSubstringIgnoreCase=P;function F(b){return b>=97&&b<=122}n.isLowerAsciiLetter=F;function R(b){return b>=65&&b<=90}n.isUpperAsciiLetter=R;function I(b,U){return b.length===U.length&&P(b,U)===0}n.equalsIgnoreCase=I;function S(b,U){const k=U.length;return U.length>b.length?!1:P(b,U,0,k)===0}n.startsWithIgnoreCase=S;function O(b,U){let k,V=Math.min(b.length,U.length);for(k=0;k<V;k++)if(b.charCodeAt(k)!==U.charCodeAt(k))return k;return V}n.commonPrefixLength=O;function H(b,U){let k,V=Math.min(b.length,U.length);const q=b.length-1,J=U.length-1;for(k=0;k<V;k++)if(b.charCodeAt(q-k)!==U.charCodeAt(J-k))return k;return V}n.commonSuffixLength=H;function X(b){return 55296<=b&&b<=56319}n.isHighSurrogate=X;function $(b){return 56320<=b&&b<=57343}n.isLowSurrogate=$;function K(b,U){return(b-55296<<10)+(U-56320)+65536}n.computeCodePoint=K;function t(b,U,k){const V=b.charCodeAt(k);if(X(V)&&k+1<U){const q=b.charCodeAt(k+1);if($(q))return K(V,q)}return V}n.getNextCodePoint=t;function W(b,U){const k=b.charCodeAt(U-1);if($(k)&&U>1){const V=b.charCodeAt(U-2);if(X(V))return K(V,k)}return k}function B(b,U){const k=ue.getInstance(),V=U,q=b.length,J=t(b,q,U);U+=J>=65536?2:1;let ne=k.getGraphemeBreakType(J);for(;U<q;){const ie=t(b,q,U),se=k.getGraphemeBreakType(ie);if(ce(ne,se))break;U+=ie>=65536?2:1,ne=se}return U-V}n.nextCharLength=B;function C(b,U){const k=ue.getInstance(),V=U,q=W(b,U);U-=q>=65536?2:1;let J=k.getGraphemeBreakType(q);for(;U>0;){const ne=W(b,U),ie=k.getGraphemeBreakType(ne);if(ce(ie,J))break;U-=ne>=65536?2:1,J=ie}return V-U}n.prevCharLength=C;function j(b,U){const k=ue.getInstance(),V=b.length,q=U,J=t(b,V,U),ne=k.getGraphemeBreakType(J);U+=J>=65536?2:1;let ie=ne;for(;U<V;){const re=t(b,V,U),le=k.getGraphemeBreakType(re);if(ce(ie,le))break;U+=re>=65536?2:1,ie=le}const se=U;for(U=q,ie=ne;U>0;){const re=W(b,U),le=k.getGraphemeBreakType(re);if(ce(le,ie))break;U-=re>=65536?2:1,ie=le}return[U,se]}function Q(b,U){return U>0&&$(b.charCodeAt(U))?j(b,U-1):j(b,U)}n.getCharContainingOffset=Q;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function x(b){return Z.test(b)}n.containsRTL=x;const te=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ae(b){return te.test(b)}n.containsEmoji=ae;const oe=/^[\t\n\r\x20-\x7E]*$/;function he(b){return oe.test(b)}n.isBasicASCII=he,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function me(b){return n.UNUSUAL_LINE_TERMINATORS.test(b)}n.containsUnusualLineTerminators=me;function be(b){for(let U=0,k=b.length;U<k;U++)if(ge(b.charCodeAt(U)))return!0;return!1}n.containsFullWidthCharacter=be;function ge(b){return b=+b,b>=11904&&b<=55215||b>=63744&&b<=64255||b>=65281&&b<=65374}n.isFullWidthCharacter=ge;function _e(b){return b>=127462&&b<=127487||b===8986||b===8987||b===9200||b===9203||b>=9728&&b<=10175||b===11088||b===11093||b>=127744&&b<=128591||b>=128640&&b<=128764||b>=128992&&b<=129003||b>=129280&&b<=129535||b>=129648&&b<=129750}n.isEmojiImprecise=_e;function Ae(b,U){if(b.length<U)return b;const k=/\b/g;let V=0;for(;k.test(b)&&!(b.length-k.lastIndex<U);)V=k.lastIndex,k.lastIndex+=1;return b.substring(V).replace(/^\s/,"")}n.lcut=Ae;const we=/\x1B\x5B[12]?K/g,Me=/\x1b\[\d+m/g,De=/\x1b\[0?m/g;function Pe(b){return b&&(b=b.replace(we,""),b=b.replace(Me,""),b=b.replace(De,"")),b}n.removeAnsiEscapeCodes=Pe,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ve(b){return!!(b&&b.length>0&&b.charCodeAt(0)===65279)}n.startsWithUTF8BOM=ve;function Re(b){return ve(b)?b.substr(1):b}n.stripUTF8BOM=Re;function Fe(b,U){if(!b||!U||b.length<U.length)return!1;const k=U.length,V=b.toLowerCase();let q=0,J=-1;for(;q<k;){const ne=V.indexOf(U[q],J+1);if(ne<0)return!1;J=ne,q++}return!0}n.fuzzyContains=Fe;function Ie(b,U=!1){return b?(U&&(b=b.replace(/\\./g,"")),b.toLowerCase()!==b):!1}n.containsUppercaseCharacter=Ie;function Te(b){return b.charAt(0).toUpperCase()+b.slice(1)}n.uppercaseFirstLetter=Te;function Ue(b,U=1){if(U===0)return"";let k=-1;do k=b.indexOf(`
`,k+1),U--;while(U>0&&k>=0);return k===-1?b:(b[k-1]==="\r"&&k--,b.substr(0,k))}n.getNLines=Ue;function ye(b){const U=90-65+1;return b=b%(2*U),b<U?String.fromCharCode(97+b):String.fromCharCode(65+b-U)}n.singleLetterHash=ye;function ke(b){return ue.getInstance().getGraphemeBreakType(b)}n.getGraphemeBreakType=ke;function ce(b,U){return b===0?U!==5&&U!==7:b===2&&U===3?!1:b===4||b===2||b===3||U===4||U===2||U===3?!0:!(b===8&&(U===8||U===9||U===11||U===12)||(b===11||b===9)&&(U===9||U===10)||(b===12||b===10)&&U===10||U===5||U===13||U===7||b===1||b===13&&U===14||b===6&&U===6)}n.breakBetweenGraphemeBreakType=ce;var Se;(function(b){b[b.Other=0]="Other",b[b.Prepend=1]="Prepend",b[b.CR=2]="CR",b[b.LF=3]="LF",b[b.Control=4]="Control",b[b.Extend=5]="Extend",b[b.Regional_Indicator=6]="Regional_Indicator",b[b.SpacingMark=7]="SpacingMark",b[b.L=8]="L",b[b.V=9]="V",b[b.T=10]="T",b[b.LV=11]="LV",b[b.LVT=12]="LVT",b[b.ZWJ=13]="ZWJ",b[b.Extended_Pictographic=14]="Extended_Pictographic"})(Se=n.GraphemeBreakType||(n.GraphemeBreakType={}));class ue{constructor(){this._data=Be()}static getInstance(){return ue._INSTANCE||(ue._INSTANCE=new ue),ue._INSTANCE}getGraphemeBreakType(U){if(U<32)return U===10?3:U===13?2:4;if(U<127)return 0;const k=this._data,V=k.length/3;let q=1;for(;q<=V;)if(U<k[3*q])q=2*q;else if(U>k[3*q+1])q=2*q+1;else return k[3*q+2];return 0}}ue._INSTANCE=null;function Be(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Oe(b,U){if(b===0)return 0;const k=Ve(b,U);if(k!==void 0)return k;const V=W(U,b);return b-=fe(V),b}n.getLeftDeleteOffset=Oe;function Ve(b,U){let k=W(U,b);for(b-=fe(k);We(k)||k===65039||k===8419;){if(b===0)return;k=W(U,b),b-=fe(k)}if(!!_e(k)){if(b>=0){const V=W(U,b);V===8205&&(b-=fe(V))}return b}}function fe(b){return b>=65536?2:1}function We(b){return 127995<=b&&b<=127999}var Le;(function(b){b[b.zwj=8205]="zwj",b[b.emojiVariantSelector=65039]="emojiVariantSelector",b[b.enclosingKeyCap=8419]="enclosingKeyCap"})(Le||(Le={}))}),z(G[22],Y([0,1,4]),function(y,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.Hasher=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function T(L){return M(L,0)}n.hash=T;function M(L,A){switch(typeof L){case"object":return L===null?u(349,A):Array.isArray(L)?l(L,A):a(L,A);case"string":return o(L,A);case"boolean":return E(L,A);case"number":return u(L,A);case"undefined":return u(937,A);default:return u(617,A)}}n.doHash=M;function u(L,A){return(A<<5)-A+L|0}n.numberHash=u;function E(L,A){return u(L?433:863,A)}function o(L,A){A=u(149417,A);for(let i=0,r=L.length;i<r;i++)A=u(L.charCodeAt(i),A);return A}n.stringHash=o;function l(L,A){return A=u(104579,A),L.reduce((i,r)=>M(r,i),A)}function a(L,A){return A=u(181387,A),Object.keys(L).sort().reduce((i,r)=>(i=o(r,i),M(L[r],i)),A)}class v{constructor(){this._value=0}get value(){return this._value}hash(A){return this._value=M(A,this._value),this._value}}n.Hasher=v;var w;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function m(L,A,i=32){const r=i-A,s=~((1<<r)-1);return(L<<A|(s&L)>>>r)>>>0}function c(L,A=0,i=L.byteLength,r=0){for(let s=0;s<i;s++)L[A+s]=r}function e(L,A,i="0"){for(;L.length<A;)L=i+L;return L}function N(L,A=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(i=>i.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),A/4)}n.toHexString=N;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(A){const i=A.length;if(i===0)return;const r=this._buff;let s=this._buffLen,f=this._leftoverHighSurrogate,_,h;for(f!==0?(_=f,h=-1,f=0):(_=A.charCodeAt(0),h=0);;){let d=_;if(D.isHighSurrogate(_))if(h+1<i){const g=A.charCodeAt(h+1);D.isLowSurrogate(g)?(h++,d=D.computeCodePoint(_,g)):d=65533}else{f=_;break}else D.isLowSurrogate(_)&&(d=65533);if(s=this._push(r,s,d),h++,h<i)_=A.charCodeAt(h);else break}this._buffLen=s,this._leftoverHighSurrogate=f}_push(A,i,r){return r<128?A[i++]=r:r<2048?(A[i++]=192|(r&1984)>>>6,A[i++]=128|(r&63)>>>0):r<65536?(A[i++]=224|(r&61440)>>>12,A[i++]=128|(r&4032)>>>6,A[i++]=128|(r&63)>>>0):(A[i++]=240|(r&1835008)>>>18,A[i++]=128|(r&258048)>>>12,A[i++]=128|(r&4032)>>>6,A[i++]=128|(r&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,A[0]=A[64+0],A[1]=A[64+1],A[2]=A[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),N(this._h0)+N(this._h1)+N(this._h2)+N(this._h3)+N(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const A=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(A/4294967296),!1),this._buffDV.setUint32(60,A%4294967296,!1),this._step()}_step(){const A=p._bigBlock32,i=this._buffDV;for(let F=0;F<64;F+=4)A.setUint32(F,i.getUint32(F,!1),!1);for(let F=64;F<320;F+=4)A.setUint32(F,m(A.getUint32(F-12,!1)^A.getUint32(F-32,!1)^A.getUint32(F-56,!1)^A.getUint32(F-64,!1),1),!1);let r=this._h0,s=this._h1,f=this._h2,_=this._h3,h=this._h4,d,g,P;for(let F=0;F<80;F++)F<20?(d=s&f|~s&_,g=1518500249):F<40?(d=s^f^_,g=1859775393):F<60?(d=s&f|s&_|f&_,g=2400959708):(d=s^f^_,g=3395469782),P=m(r,5)+d+h+g+A.getUint32(F*4,!1)&4294967295,h=_,_=f,f=m(s,30),s=r,r=P;this._h0=this._h0+r&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+f&4294967295,this._h3=this._h3+_&4294967295,this._h4=this._h4+h&4294967295}}n.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),z(G[11],Y([0,1,15,22]),function(y,n,D,T){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.MyArray=n.Debug=n.stringDiff=n.StringDiffSequence=void 0;class M{constructor(m){this.source=m}getElements(){const m=this.source,c=new Int32Array(m.length);for(let e=0,N=m.length;e<N;e++)c[e]=m.charCodeAt(e);return c}}n.StringDiffSequence=M;function u(w,m,c){return new v(new M(w),new M(m)).ComputeDiff(c).changes}n.stringDiff=u;class E{static Assert(m,c){if(!m)throw new Error(c)}}n.Debug=E;class o{static Copy(m,c,e,N,p){for(let L=0;L<p;L++)e[N+L]=m[c+L]}static Copy2(m,c,e,N,p){for(let L=0;L<p;L++)e[N+L]=m[c+L]}}n.MyArray=o;var l;(function(w){w[w.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class a{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new D.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(m,c){this.m_originalStart=Math.min(this.m_originalStart,m),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_originalCount++}AddModifiedElement(m,c){this.m_originalStart=Math.min(this.m_originalStart,m),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class v{constructor(m,c,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=m,this._modifiedSequence=c;const[N,p,L]=v._getElements(m),[A,i,r]=v._getElements(c);this._hasStrings=L&&r,this._originalStringElements=N,this._originalElementsOrHash=p,this._modifiedStringElements=A,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(m){return m.length>0&&typeof m[0]=="string"}static _getElements(m){const c=m.getElements();if(v._isStringArray(c)){const e=new Int32Array(c.length);for(let N=0,p=c.length;N<p;N++)e[N]=(0,T.stringHash)(c[N],0);return[c,e,!0]}return c instanceof Int32Array?[[],c,!1]:[[],new Int32Array(c),!1]}ElementsAreEqual(m,c){return this._originalElementsOrHash[m]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[m]===this._modifiedStringElements[c]:!0}ElementsAreStrictEqual(m,c){if(!this.ElementsAreEqual(m,c))return!1;const e=v._getStrictElement(this._originalSequence,m),N=v._getStrictElement(this._modifiedSequence,c);return e===N}static _getStrictElement(m,c){return typeof m.getStrictElement=="function"?m.getStrictElement(c):null}OriginalElementsAreEqual(m,c){return this._originalElementsOrHash[m]!==this._originalElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[m]===this._originalStringElements[c]:!0}ModifiedElementsAreEqual(m,c){return this._modifiedElementsOrHash[m]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._modifiedStringElements[m]===this._modifiedStringElements[c]:!0}ComputeDiff(m){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,m)}_ComputeDiff(m,c,e,N,p){const L=[!1];let A=this.ComputeDiffRecursive(m,c,e,N,L);return p&&(A=this.PrettifyChanges(A)),{quitEarly:L[0],changes:A}}ComputeDiffRecursive(m,c,e,N,p){for(p[0]=!1;m<=c&&e<=N&&this.ElementsAreEqual(m,e);)m++,e++;for(;c>=m&&N>=e&&this.ElementsAreEqual(c,N);)c--,N--;if(m>c||e>N){let f;return e<=N?(E.Assert(m===c+1,"originalStart should only be one more than originalEnd"),f=[new D.DiffChange(m,0,e,N-e+1)]):m<=c?(E.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),f=[new D.DiffChange(m,c-m+1,e,0)]):(E.Assert(m===c+1,"originalStart should only be one more than originalEnd"),E.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const L=[0],A=[0],i=this.ComputeRecursionPoint(m,c,e,N,L,A,p),r=L[0],s=A[0];if(i!==null)return i;if(!p[0]){const f=this.ComputeDiffRecursive(m,r,e,s,p);let _=[];return p[0]?_=[new D.DiffChange(r+1,c-(r+1)+1,s+1,N-(s+1)+1)]:_=this.ComputeDiffRecursive(r+1,c,s+1,N,p),this.ConcatenateChanges(f,_)}return[new D.DiffChange(m,c-m+1,e,N-e+1)]}WALKTRACE(m,c,e,N,p,L,A,i,r,s,f,_,h,d,g,P,F,R){let I=null,S=null,O=new a,H=c,X=e,$=h[0]-P[0]-N,K=-1073741824,t=this.m_forwardHistory.length-1;do{const W=$+m;W===H||W<X&&r[W-1]<r[W+1]?(f=r[W+1],d=f-$-N,f<K&&O.MarkNextChange(),K=f,O.AddModifiedElement(f+1,d),$=W+1-m):(f=r[W-1]+1,d=f-$-N,f<K&&O.MarkNextChange(),K=f-1,O.AddOriginalElement(f,d+1),$=W-1-m),t>=0&&(r=this.m_forwardHistory[t],m=r[0],H=1,X=r.length-1)}while(--t>=-1);if(I=O.getReverseChanges(),R[0]){let W=h[0]+1,B=P[0]+1;if(I!==null&&I.length>0){const C=I[I.length-1];W=Math.max(W,C.getOriginalEnd()),B=Math.max(B,C.getModifiedEnd())}S=[new D.DiffChange(W,_-W+1,B,g-B+1)]}else{O=new a,H=L,X=A,$=h[0]-P[0]-i,K=1073741824,t=F?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const W=$+p;W===H||W<X&&s[W-1]>=s[W+1]?(f=s[W+1]-1,d=f-$-i,f>K&&O.MarkNextChange(),K=f+1,O.AddOriginalElement(f+1,d+1),$=W+1-p):(f=s[W-1],d=f-$-i,f>K&&O.MarkNextChange(),K=f,O.AddModifiedElement(f+1,d+1),$=W-1-p),t>=0&&(s=this.m_reverseHistory[t],p=s[0],H=1,X=s.length-1)}while(--t>=-1);S=O.getChanges()}return this.ConcatenateChanges(I,S)}ComputeRecursionPoint(m,c,e,N,p,L,A){let i=0,r=0,s=0,f=0,_=0,h=0;m--,e--,p[0]=0,L[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const d=c-m+(N-e),g=d+1,P=new Int32Array(g),F=new Int32Array(g),R=N-e,I=c-m,S=m-e,O=c-N,X=(I-R)%2==0;P[R]=m,F[I]=c,A[0]=!1;for(let $=1;$<=d/2+1;$++){let K=0,t=0;s=this.ClipDiagonalBound(R-$,$,R,g),f=this.ClipDiagonalBound(R+$,$,R,g);for(let B=s;B<=f;B+=2){B===s||B<f&&P[B-1]<P[B+1]?i=P[B+1]:i=P[B-1]+1,r=i-(B-R)-S;const C=i;for(;i<c&&r<N&&this.ElementsAreEqual(i+1,r+1);)i++,r++;if(P[B]=i,i+r>K+t&&(K=i,t=r),!X&&Math.abs(B-I)<=$-1&&i>=F[B])return p[0]=i,L[0]=r,C<=F[B]&&1447>0&&$<=1447+1?this.WALKTRACE(R,s,f,S,I,_,h,O,P,F,i,c,p,r,N,L,X,A):null}const W=(K-m+(t-e)-$)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(K,W))return A[0]=!0,p[0]=K,L[0]=t,W>0&&1447>0&&$<=1447+1?this.WALKTRACE(R,s,f,S,I,_,h,O,P,F,i,c,p,r,N,L,X,A):(m++,e++,[new D.DiffChange(m,c-m+1,e,N-e+1)]);_=this.ClipDiagonalBound(I-$,$,I,g),h=this.ClipDiagonalBound(I+$,$,I,g);for(let B=_;B<=h;B+=2){B===_||B<h&&F[B-1]>=F[B+1]?i=F[B+1]-1:i=F[B-1],r=i-(B-I)-O;const C=i;for(;i>m&&r>e&&this.ElementsAreEqual(i,r);)i--,r--;if(F[B]=i,X&&Math.abs(B-R)<=$&&i<=P[B])return p[0]=i,L[0]=r,C>=P[B]&&1447>0&&$<=1447+1?this.WALKTRACE(R,s,f,S,I,_,h,O,P,F,i,c,p,r,N,L,X,A):null}if($<=1447){let B=new Int32Array(f-s+2);B[0]=R-s+1,o.Copy2(P,s,B,1,f-s+1),this.m_forwardHistory.push(B),B=new Int32Array(h-_+2),B[0]=I-_+1,o.Copy2(F,_,B,1,h-_+1),this.m_reverseHistory.push(B)}}return this.WALKTRACE(R,s,f,S,I,_,h,O,P,F,i,c,p,r,N,L,X,A)}PrettifyChanges(m){for(let c=0;c<m.length;c++){const e=m[c],N=c<m.length-1?m[c+1].originalStart:this._originalElementsOrHash.length,p=c<m.length-1?m[c+1].modifiedStart:this._modifiedElementsOrHash.length,L=e.originalLength>0,A=e.modifiedLength>0;for(;e.originalStart+e.originalLength<N&&e.modifiedStart+e.modifiedLength<p&&(!L||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!A||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const r=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!r)break;e.originalStart++,e.modifiedStart++}let i=[null];if(c<m.length-1&&this.ChangesOverlap(m[c],m[c+1],i)){m[c]=i[0],m.splice(c+1,1),c--;continue}}for(let c=m.length-1;c>=0;c--){const e=m[c];let N=0,p=0;if(c>0){const f=m[c-1];N=f.originalStart+f.originalLength,p=f.modifiedStart+f.modifiedLength}const L=e.originalLength>0,A=e.modifiedLength>0;let i=0,r=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let f=1;;f++){const _=e.originalStart-f,h=e.modifiedStart-f;if(_<N||h<p||L&&!this.OriginalElementsAreEqual(_,_+e.originalLength)||A&&!this.ModifiedElementsAreEqual(h,h+e.modifiedLength))break;const g=(_===N&&h===p?5:0)+this._boundaryScore(_,e.originalLength,h,e.modifiedLength);g>r&&(r=g,i=f)}e.originalStart-=i,e.modifiedStart-=i;const s=[null];if(c>0&&this.ChangesOverlap(m[c-1],m[c],s)){m[c-1]=s[0],m.splice(c,1),c++;continue}}if(this._hasStrings)for(let c=1,e=m.length;c<e;c++){const N=m[c-1],p=m[c],L=p.originalStart-N.originalStart-N.originalLength,A=N.originalStart,i=p.originalStart+p.originalLength,r=i-A,s=N.modifiedStart,f=p.modifiedStart+p.modifiedLength,_=f-s;if(L<5&&r<20&&_<20){const h=this._findBetterContiguousSequence(A,r,s,_,L);if(h){const[d,g]=h;(d!==N.originalStart+N.originalLength||g!==N.modifiedStart+N.modifiedLength)&&(N.originalLength=d-N.originalStart,N.modifiedLength=g-N.modifiedStart,p.originalStart=d+L,p.modifiedStart=g+L,p.originalLength=i-p.originalStart,p.modifiedLength=f-p.modifiedStart)}}}return m}_findBetterContiguousSequence(m,c,e,N,p){if(c<p||N<p)return null;const L=m+c-p+1,A=e+N-p+1;let i=0,r=0,s=0;for(let f=m;f<L;f++)for(let _=e;_<A;_++){const h=this._contiguousSequenceScore(f,_,p);h>0&&h>i&&(i=h,r=f,s=_)}return i>0?[r,s]:null}_contiguousSequenceScore(m,c,e){let N=0;for(let p=0;p<e;p++){if(!this.ElementsAreEqual(m+p,c+p))return 0;N+=this._originalStringElements[m+p].length}return N}_OriginalIsBoundary(m){return m<=0||m>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[m])}_OriginalRegionIsBoundary(m,c){if(this._OriginalIsBoundary(m)||this._OriginalIsBoundary(m-1))return!0;if(c>0){const e=m+c;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(m){return m<=0||m>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[m])}_ModifiedRegionIsBoundary(m,c){if(this._ModifiedIsBoundary(m)||this._ModifiedIsBoundary(m-1))return!0;if(c>0){const e=m+c;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(m,c,e,N){const p=this._OriginalRegionIsBoundary(m,c)?1:0,L=this._ModifiedRegionIsBoundary(e,N)?1:0;return p+L}ConcatenateChanges(m,c){let e=[];if(m.length===0||c.length===0)return c.length>0?c:m;if(this.ChangesOverlap(m[m.length-1],c[0],e)){const N=new Array(m.length+c.length-1);return o.Copy(m,0,N,0,m.length-1),N[m.length-1]=e[0],o.Copy(c,1,N,m.length,c.length-1),N}else{const N=new Array(m.length+c.length);return o.Copy(m,0,N,0,m.length),o.Copy(c,0,N,m.length,c.length),N}}ChangesOverlap(m,c,e){if(E.Assert(m.originalStart<=c.originalStart,"Left change is not less than or equal to right change"),E.Assert(m.modifiedStart<=c.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=c.originalStart||m.modifiedStart+m.modifiedLength>=c.modifiedStart){const N=m.originalStart;let p=m.originalLength;const L=m.modifiedStart;let A=m.modifiedLength;return m.originalStart+m.originalLength>=c.originalStart&&(p=c.originalStart+c.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=c.modifiedStart&&(A=c.modifiedStart+c.modifiedLength-m.modifiedStart),e[0]=new D.DiffChange(N,p,L,A),!0}else return e[0]=null,!1}ClipDiagonalBound(m,c,e,N){if(m>=0&&m<N)return m;const p=e,L=N-e-1,A=c%2==0;if(m<0){const i=p%2==0;return A===i?0:1}else{const i=L%2==0;return A===i?N-1:N-2}}}n.LcsDiff=v}),z(G[12],Y([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isPromise=n.assertNever=n.NotImplementedProxy=n.withUndefinedAsNull=n.withNullAsUndefined=n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.validateConstraint=n.validateConstraints=n.areFunctions=n.isFunction=n.isEmptyObject=n.assertAllDefined=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isObject=n.isStringArray=n.isString=n.isArray=void 0;function D(R){return Array.isArray(R)}n.isArray=D;function T(R){return typeof R=="string"}n.isString=T;function M(R){return Array.isArray(R)&&R.every(I=>T(I))}n.isStringArray=M;function u(R){return typeof R=="object"&&R!==null&&!Array.isArray(R)&&!(R instanceof RegExp)&&!(R instanceof Date)}n.isObject=u;function E(R){return typeof R=="number"&&!isNaN(R)}n.isNumber=E;function o(R){return!!R&&typeof R[Symbol.iterator]=="function"}n.isIterable=o;function l(R){return R===!0||R===!1}n.isBoolean=l;function a(R){return typeof R=="undefined"}n.isUndefined=a;function v(R){return!w(R)}n.isDefined=v;function w(R){return a(R)||R===null}n.isUndefinedOrNull=w;function m(R,I){if(!R)throw new Error(I?`Unexpected type, expected '${I}'`:"Unexpected type")}n.assertType=m;function c(R){if(w(R))throw new Error("Assertion Failed: argument is undefined or null");return R}n.assertIsDefined=c;function e(...R){const I=[];for(let S=0;S<R.length;S++){const O=R[S];if(w(O))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);I.push(O)}return I}n.assertAllDefined=e;const N=Object.prototype.hasOwnProperty;function p(R){if(!u(R))return!1;for(let I in R)if(N.call(R,I))return!1;return!0}n.isEmptyObject=p;function L(R){return typeof R=="function"}n.isFunction=L;function A(...R){return R.length>0&&R.every(L)}n.areFunctions=A;function i(R,I){const S=Math.min(R.length,I.length);for(let O=0;O<S;O++)r(R[O],I[O])}n.validateConstraints=i;function r(R,I){if(T(I)){if(typeof R!==I)throw new Error(`argument does not match constraint: typeof ${I}`)}else if(L(I)){try{if(R instanceof I)return}catch{}if(!w(R)&&R.constructor===I||I.length===1&&I.call(void 0,R)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=r;function s(R){let I=[],S=Object.getPrototypeOf(R);for(;Object.prototype!==S;)I=I.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return I}n.getAllPropertyNames=s;function f(R){const I=[];for(const S of s(R))typeof R[S]=="function"&&I.push(S);return I}n.getAllMethodNames=f;function _(R,I){const S=H=>function(){const X=Array.prototype.slice.call(arguments,0);return I(H,X)};let O={};for(const H of R)O[H]=S(H);return O}n.createProxyObject=_;function h(R){return R===null?void 0:R}n.withNullAsUndefined=h;function d(R){return typeof R=="undefined"?null:R}n.withUndefinedAsNull=d;function g(R){return class{constructor(){return new Proxy({},{get(I,S){if(I[S])return I[S];throw new Error(`Not Implemented: ${R}->${String(S)}`)}})}}}n.NotImplementedProxy=g;function P(R,I="Unreachable"){throw new Error(I)}n.assertNever=P;function F(R){return!!R&&typeof R.then=="function"&&typeof R.catch=="function"}n.isPromise=F}),z(G[13],Y([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=n.Constants=void 0;var D;(function(u){u[u.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",u[u.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",u[u.MAX_UINT_8=255]="MAX_UINT_8",u[u.MAX_UINT_16=65535]="MAX_UINT_16",u[u.MAX_UINT_32=4294967295]="MAX_UINT_32",u[u.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D=n.Constants||(n.Constants={}));function T(u){return u<0?0:u>255?255:u|0}n.toUint8=T;function M(u){return u<0?0:u>4294967295?4294967295:u|0}n.toUint32=M}),z(G[14],Y([0,1,20,2]),function(y,n,D,T){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const M=/^\w[\w\d+.-]*$/,u=/^\//,E=/^\/\//;function o(h,d){if(!h.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!M.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!u.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(h,d){return!h&&!d?"file":h}function a(h,d){switch(h){case"https":case"http":case"file":d?d[0]!==w&&(d=w+d):d=w;break}return d}const v="",w="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{constructor(d,g,P,F,R,I=!1){typeof d=="object"?(this.scheme=d.scheme||v,this.authority=d.authority||v,this.path=d.path||v,this.query=d.query||v,this.fragment=d.fragment||v):(this.scheme=l(d,I),this.authority=g||v,this.path=a(this.scheme,P||v),this.query=F||v,this.fragment=R||v,o(this,I))}static isUri(d){return d instanceof c?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}get fsPath(){return i(this,!1)}with(d){if(!d)return this;let{scheme:g,authority:P,path:F,query:R,fragment:I}=d;return g===void 0?g=this.scheme:g===null&&(g=v),P===void 0?P=this.authority:P===null&&(P=v),F===void 0?F=this.path:F===null&&(F=v),R===void 0?R=this.query:R===null&&(R=v),I===void 0?I=this.fragment:I===null&&(I=v),g===this.scheme&&P===this.authority&&F===this.path&&R===this.query&&I===this.fragment?this:new N(g,P,F,R,I)}static parse(d,g=!1){const P=m.exec(d);return P?new N(P[2]||v,_(P[4]||v),_(P[5]||v),_(P[7]||v),_(P[9]||v),g):new N(v,v,v,v,v)}static file(d){let g=v;if(T.isWindows&&(d=d.replace(/\\/g,w)),d[0]===w&&d[1]===w){const P=d.indexOf(w,2);P===-1?(g=d.substring(2),d=w):(g=d.substring(2,P),d=d.substring(P)||w)}return new N("file",g,d,v,v)}static from(d){const g=new N(d.scheme,d.authority,d.path,d.query,d.fragment);return o(g,!0),g}static joinPath(d,...g){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let P;return T.isWindows&&d.scheme==="file"?P=c.file(D.win32.join(i(d,!0),...g)).path:P=D.posix.join(d.path,...g),d.with({path:P})}toString(d=!1){return r(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof c)return d;{const g=new N(d);return g._formatted=d.external,g._fsPath=d._sep===e?d.fsPath:null,g}}else return d}}n.URI=c;const e=T.isWindows?1:void 0;class N extends c{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(d=!1){return d?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const d={$mid:1};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=e),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function L(h,d){let g,P=-1;for(let F=0;F<h.length;F++){const R=h.charCodeAt(F);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||d&&R===47)P!==-1&&(g+=encodeURIComponent(h.substring(P,F)),P=-1),g!==void 0&&(g+=h.charAt(F));else{g===void 0&&(g=h.substr(0,F));const I=p[R];I!==void 0?(P!==-1&&(g+=encodeURIComponent(h.substring(P,F)),P=-1),g+=I):P===-1&&(P=F)}}return P!==-1&&(g+=encodeURIComponent(h.substring(P))),g!==void 0?g:h}function A(h){let d;for(let g=0;g<h.length;g++){const P=h.charCodeAt(g);P===35||P===63?(d===void 0&&(d=h.substr(0,g)),d+=p[P]):d!==void 0&&(d+=h[g])}return d!==void 0?d:h}function i(h,d){let g;return h.authority&&h.path.length>1&&h.scheme==="file"?g=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===47&&(h.path.charCodeAt(1)>=65&&h.path.charCodeAt(1)<=90||h.path.charCodeAt(1)>=97&&h.path.charCodeAt(1)<=122)&&h.path.charCodeAt(2)===58?d?g=h.path.substr(1):g=h.path[1].toLowerCase()+h.path.substr(2):g=h.path,T.isWindows&&(g=g.replace(/\//g,"\\")),g}n.uriToFsPath=i;function r(h,d){const g=d?A:L;let P="",{scheme:F,authority:R,path:I,query:S,fragment:O}=h;if(F&&(P+=F,P+=":"),(R||F==="file")&&(P+=w,P+=w),R){let H=R.indexOf("@");if(H!==-1){const X=R.substr(0,H);R=R.substr(H+1),H=X.indexOf(":"),H===-1?P+=g(X,!1):(P+=g(X.substr(0,H),!1),P+=":",P+=g(X.substr(H+1),!1)),P+="@"}R=R.toLowerCase(),H=R.indexOf(":"),H===-1?P+=g(R,!1):(P+=g(R.substr(0,H),!1),P+=R.substr(H))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const H=I.charCodeAt(1);H>=65&&H<=90&&(I=`/${String.fromCharCode(H+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const H=I.charCodeAt(0);H>=65&&H<=90&&(I=`${String.fromCharCode(H+32)}:${I.substr(2)}`)}P+=g(I,!0)}return S&&(P+="?",P+=g(S,!1)),O&&(P+="#",P+=d?O:L(O,!1)),P}function s(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+s(h.substr(3)):h}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function _(h){return h.match(f)?h.replace(f,d=>s(d)):h}}),z(G[34],Y([0,1,6,8,2,12]),function(y,n,D,T,M,u){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const E="$initialize";let o=!1;function l(c){!M.isWeb||(o||(o=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(c.message))}n.logOnceWebWorkerWarning=l;class a{constructor(e){this._workerId=-1,this._handler=e,this._lastSentReq=0,this._pendingReplies=Object.create(null)}setWorkerId(e){this._workerId=e}sendMessage(e,N){let p=String(++this._lastSentReq);return new Promise((L,A)=>{this._pendingReplies[p]={resolve:L,reject:A},this._send({vsWorker:this._workerId,req:p,method:e,args:N})})}handleMessage(e){!e||!e.vsWorker||this._workerId!==-1&&e.vsWorker!==this._workerId||this._handleMessage(e)}_handleMessage(e){if(e.seq){let A=e;if(!this._pendingReplies[A.seq]){console.warn("Got reply to unknown seq");return}let i=this._pendingReplies[A.seq];if(delete this._pendingReplies[A.seq],A.err){let r=A.err;A.err.$isError&&(r=new Error,r.name=A.err.name,r.message=A.err.message,r.stack=A.err.stack),i.reject(r);return}i.resolve(A.res);return}let N=e,p=N.req;this._handler.handleMessage(N.method,N.args).then(A=>{this._send({vsWorker:this._workerId,seq:p,res:A,err:void 0})},A=>{A.detail instanceof Error&&(A.detail=(0,D.transformErrorForSerialization)(A.detail)),this._send({vsWorker:this._workerId,seq:p,res:void 0,err:(0,D.transformErrorForSerialization)(A)})})}_send(e){let N=[];if(e.req){const p=e;for(let L=0;L<p.args.length;L++)p.args[L]instanceof ArrayBuffer&&N.push(p.args[L])}else{const p=e;p.res instanceof ArrayBuffer&&N.push(p.res)}this._handler.sendMessage(e,N)}}class v extends T.Disposable{constructor(e,N,p){super();let L=null;this._worker=this._register(e.create("vs/base/common/worker/simpleWorker",s=>{this._protocol.handleMessage(s)},s=>{L&&L(s)})),this._protocol=new a({sendMessage:(s,f)=>{this._worker.postMessage(s,f)},handleMessage:(s,f)=>{if(typeof p[s]!="function")return Promise.reject(new Error("Missing method "+s+" on main thread host."));try{return Promise.resolve(p[s].apply(p,f))}catch(_){return Promise.reject(_)}}}),this._protocol.setWorkerId(this._worker.getId());let A=null;typeof self.require!="undefined"&&typeof self.require.getConfig=="function"?A=self.require.getConfig():typeof self.requirejs!="undefined"&&(A=self.requirejs.s.contexts._.config);const i=u.getAllMethodNames(p);this._onModuleLoaded=this._protocol.sendMessage(E,[this._worker.getId(),JSON.parse(JSON.stringify(A)),N,i]);const r=(s,f)=>this._request(s,f);this._lazyProxy=new Promise((s,f)=>{L=f,this._onModuleLoaded.then(_=>{s(u.createProxyObject(_,r))},_=>{f(_),this._onError("Worker failed to load "+N,_)})})}getProxyObject(){return this._lazyProxy}_request(e,N){return new Promise((p,L)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(e,N).then(p,L)},L)})}_onError(e,N){console.error(e),console.info(N)}}n.SimpleWorkerClient=v;class w{constructor(e,N){this._requestHandlerFactory=N,this._requestHandler=null,this._protocol=new a({sendMessage:(p,L)=>{e(p,L)},handleMessage:(p,L)=>this._handleMessage(p,L)})}onmessage(e){this._protocol.handleMessage(e)}_handleMessage(e,N){if(e===E)return this.initialize(N[0],N[1],N[2],N[3]);if(!this._requestHandler||typeof this._requestHandler[e]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+e));try{return Promise.resolve(this._requestHandler[e].apply(this._requestHandler,N))}catch(p){return Promise.reject(p)}}initialize(e,N,p,L){this._protocol.setWorkerId(e);const A=(r,s)=>this._protocol.sendMessage(r,s),i=u.createProxyObject(L,A);return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(i),Promise.resolve(u.getAllMethodNames(this._requestHandler))):(N&&(typeof N.baseUrl!="undefined"&&delete N.baseUrl,typeof N.paths!="undefined"&&typeof N.paths.vs!="undefined"&&delete N.paths.vs,typeof N.trustedTypesPolicy!==void 0&&delete N.trustedTypesPolicy,N.catchError=!0,self.require.config(N)),new Promise((r,s)=>{self.require([p],f=>{if(this._requestHandler=f.create(i),!this._requestHandler){s(new Error("No RequestHandler!"));return}r(u.getAllMethodNames(this._requestHandler))},s)}))}}n.SimpleWorkerServer=w;function m(c){return new w(c,null)}n.create=m}),z(G[23],Y([0,1,13]),function(y,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class T{constructor(o){let l=(0,D.toUint8)(o);this._defaultValue=l,this._asciiMap=T._createAsciiMap(l),this._map=new Map}static _createAsciiMap(o){let l=new Uint8Array(256);for(let a=0;a<256;a++)l[a]=o;return l}set(o,l){let a=(0,D.toUint8)(l);o>=0&&o<256?this._asciiMap[o]=a:this._map.set(o,a)}get(o){return o>=0&&o<256?this._asciiMap[o]:this._map.get(o)||this._defaultValue}}n.CharacterClassifier=T;var M;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(M||(M={}));class u{constructor(){this._actual=new T(0)}add(o){this._actual.set(o,1)}has(o){return this._actual.get(o)===1}}n.CharacterSet=u}),z(G[3],Y([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class D{constructor(M,u){this.lineNumber=M,this.column=u}with(M=this.lineNumber,u=this.column){return M===this.lineNumber&&u===this.column?this:new D(M,u)}delta(M=0,u=0){return this.with(this.lineNumber+M,this.column+u)}equals(M){return D.equals(this,M)}static equals(M,u){return!M&&!u?!0:!!M&&!!u&&M.lineNumber===u.lineNumber&&M.column===u.column}isBefore(M){return D.isBefore(this,M)}static isBefore(M,u){return M.lineNumber<u.lineNumber?!0:u.lineNumber<M.lineNumber?!1:M.column<u.column}isBeforeOrEqual(M){return D.isBeforeOrEqual(this,M)}static isBeforeOrEqual(M,u){return M.lineNumber<u.lineNumber?!0:u.lineNumber<M.lineNumber?!1:M.column<=u.column}static compare(M,u){let E=M.lineNumber|0,o=u.lineNumber|0;if(E===o){let l=M.column|0,a=u.column|0;return l-a}return E-o}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(M){return new D(M.lineNumber,M.column)}static isIPosition(M){return M&&typeof M.lineNumber=="number"&&typeof M.column=="number"}}n.Position=D}),z(G[5],Y([0,1,3]),function(y,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class T{constructor(u,E,o,l){u>o||u===o&&E>l?(this.startLineNumber=o,this.startColumn=l,this.endLineNumber=u,this.endColumn=E):(this.startLineNumber=u,this.startColumn=E,this.endLineNumber=o,this.endColumn=l)}isEmpty(){return T.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return T.containsPosition(this,u)}static containsPosition(u,E){return!(E.lineNumber<u.startLineNumber||E.lineNumber>u.endLineNumber||E.lineNumber===u.startLineNumber&&E.column<u.startColumn||E.lineNumber===u.endLineNumber&&E.column>u.endColumn)}containsRange(u){return T.containsRange(this,u)}static containsRange(u,E){return!(E.startLineNumber<u.startLineNumber||E.endLineNumber<u.startLineNumber||E.startLineNumber>u.endLineNumber||E.endLineNumber>u.endLineNumber||E.startLineNumber===u.startLineNumber&&E.startColumn<u.startColumn||E.endLineNumber===u.endLineNumber&&E.endColumn>u.endColumn)}strictContainsRange(u){return T.strictContainsRange(this,u)}static strictContainsRange(u,E){return!(E.startLineNumber<u.startLineNumber||E.endLineNumber<u.startLineNumber||E.startLineNumber>u.endLineNumber||E.endLineNumber>u.endLineNumber||E.startLineNumber===u.startLineNumber&&E.startColumn<=u.startColumn||E.endLineNumber===u.endLineNumber&&E.endColumn>=u.endColumn)}plusRange(u){return T.plusRange(this,u)}static plusRange(u,E){let o,l,a,v;return E.startLineNumber<u.startLineNumber?(o=E.startLineNumber,l=E.startColumn):E.startLineNumber===u.startLineNumber?(o=E.startLineNumber,l=Math.min(E.startColumn,u.startColumn)):(o=u.startLineNumber,l=u.startColumn),E.endLineNumber>u.endLineNumber?(a=E.endLineNumber,v=E.endColumn):E.endLineNumber===u.endLineNumber?(a=E.endLineNumber,v=Math.max(E.endColumn,u.endColumn)):(a=u.endLineNumber,v=u.endColumn),new T(o,l,a,v)}intersectRanges(u){return T.intersectRanges(this,u)}static intersectRanges(u,E){let o=u.startLineNumber,l=u.startColumn,a=u.endLineNumber,v=u.endColumn,w=E.startLineNumber,m=E.startColumn,c=E.endLineNumber,e=E.endColumn;return o<w?(o=w,l=m):o===w&&(l=Math.max(l,m)),a>c?(a=c,v=e):a===c&&(v=Math.min(v,e)),o>a||o===a&&l>v?null:new T(o,l,a,v)}equalsRange(u){return T.equalsRange(this,u)}static equalsRange(u,E){return!!u&&!!E&&u.startLineNumber===E.startLineNumber&&u.startColumn===E.startColumn&&u.endLineNumber===E.endLineNumber&&u.endColumn===E.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(u){return new D.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(u){return new D.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,E){return new T(this.startLineNumber,this.startColumn,u,E)}setStartPosition(u,E){return new T(u,E,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(u){return new T(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}static fromPositions(u,E=u){return new T(u.lineNumber,u.column,E.lineNumber,E.column)}static lift(u){return u?new T(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,E){return!(u.endLineNumber<E.startLineNumber||u.endLineNumber===E.startLineNumber&&u.endColumn<E.startColumn||E.endLineNumber<u.startLineNumber||E.endLineNumber===u.startLineNumber&&E.endColumn<u.startColumn)}static areIntersecting(u,E){return!(u.endLineNumber<E.startLineNumber||u.endLineNumber===E.startLineNumber&&u.endColumn<=E.startColumn||E.endLineNumber<u.startLineNumber||E.endLineNumber===u.startLineNumber&&E.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,E){if(u&&E){const a=u.startLineNumber|0,v=E.startLineNumber|0;if(a===v){const w=u.startColumn|0,m=E.startColumn|0;if(w===m){const c=u.endLineNumber|0,e=E.endLineNumber|0;if(c===e){const N=u.endColumn|0,p=E.endColumn|0;return N-p}return c-e}return w-m}return a-v}return(u?1:0)-(E?1:0)}static compareRangesUsingEnds(u,E){return u.endLineNumber===E.endLineNumber?u.endColumn===E.endColumn?u.startLineNumber===E.startLineNumber?u.startColumn-E.startColumn:u.startLineNumber-E.startLineNumber:u.endColumn-E.endColumn:u.endLineNumber-E.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}}n.Range=T}),z(G[24],Y([0,1,3,5]),function(y,n,D,T){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=n.SelectionDirection=void 0;var M;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(M=n.SelectionDirection||(n.SelectionDirection={}));class u extends T.Range{constructor(o,l,a,v){super(o,l,a,v);this.selectionStartLineNumber=o,this.selectionStartColumn=l,this.positionLineNumber=a,this.positionColumn=v}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(o){return u.selectionsEqual(this,o)}static selectionsEqual(o,l){return o.selectionStartLineNumber===l.selectionStartLineNumber&&o.selectionStartColumn===l.selectionStartColumn&&o.positionLineNumber===l.positionLineNumber&&o.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(o,l){return this.getDirection()===0?new u(this.startLineNumber,this.startColumn,o,l):new u(o,l,this.startLineNumber,this.startColumn)}getPosition(){return new D.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(o,l){return this.getDirection()===0?new u(o,l,this.endLineNumber,this.endColumn):new u(this.endLineNumber,this.endColumn,o,l)}static fromPositions(o,l=o){return new u(o.lineNumber,o.column,l.lineNumber,l.column)}static liftSelection(o){return new u(o.selectionStartLineNumber,o.selectionStartColumn,o.positionLineNumber,o.positionColumn)}static selectionsArrEqual(o,l){if(o&&!l||!o&&l)return!1;if(!o&&!l)return!0;if(o.length!==l.length)return!1;for(let a=0,v=o.length;a<v;a++)if(!this.selectionsEqual(o[a],l[a]))return!1;return!0}static isISelection(o){return o&&typeof o.selectionStartLineNumber=="number"&&typeof o.selectionStartColumn=="number"&&typeof o.positionLineNumber=="number"&&typeof o.positionColumn=="number"}static createWithDirection(o,l,a,v,w){return w===0?new u(o,l,a,v):new u(a,v,o,l)}}n.Selection=u}),z(G[25],Y([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationResult2=n.TokenizationResult=n.Token=void 0;class D{constructor(E,o,l){this._tokenBrand=void 0,this.offset=E|0,this.type=o,this.language=l}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=D;class T{constructor(E,o){this._tokenizationResultBrand=void 0,this.tokens=E,this.endState=o}}n.TokenizationResult=T;class M{constructor(E,o){this._tokenizationResult2Brand=void 0,this.tokens=E,this.endState=o}}n.TokenizationResult2=M}),z(G[26],Y([0,1,11,4]),function(y,n,D,T){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=void 0;const M=3;function u(N,p,L,A){return new D.LcsDiff(N,p,L).ComputeDiff(A)}class E{constructor(p){const L=[],A=[];for(let i=0,r=p.length;i<r;i++)L[i]=m(p[i],1),A[i]=c(p[i],1);this.lines=p,this._startColumns=L,this._endColumns=A}getElements(){const p=[];for(let L=0,A=this.lines.length;L<A;L++)p[L]=this.lines[L].substring(this._startColumns[L]-1,this._endColumns[L]-1);return p}getStrictElement(p){return this.lines[p]}getStartLineNumber(p){return p+1}getEndLineNumber(p){return p+1}createCharSequence(p,L,A){const i=[],r=[],s=[];let f=0;for(let _=L;_<=A;_++){const h=this.lines[_],d=p?this._startColumns[_]:1,g=p?this._endColumns[_]:h.length+1;for(let P=d;P<g;P++)i[f]=h.charCodeAt(P-1),r[f]=_+1,s[f]=P,f++}return new o(i,r,s)}}class o{constructor(p,L,A){this._charCodes=p,this._lineNumbers=L,this._columns=A}getElements(){return this._charCodes}getStartLineNumber(p){return this._lineNumbers[p]}getStartColumn(p){return this._columns[p]}getEndLineNumber(p){return this._lineNumbers[p]}getEndColumn(p){return this._columns[p]+1}}class l{constructor(p,L,A,i,r,s,f,_){this.originalStartLineNumber=p,this.originalStartColumn=L,this.originalEndLineNumber=A,this.originalEndColumn=i,this.modifiedStartLineNumber=r,this.modifiedStartColumn=s,this.modifiedEndLineNumber=f,this.modifiedEndColumn=_}static createFromDiffChange(p,L,A){let i,r,s,f,_,h,d,g;return p.originalLength===0?(i=0,r=0,s=0,f=0):(i=L.getStartLineNumber(p.originalStart),r=L.getStartColumn(p.originalStart),s=L.getEndLineNumber(p.originalStart+p.originalLength-1),f=L.getEndColumn(p.originalStart+p.originalLength-1)),p.modifiedLength===0?(_=0,h=0,d=0,g=0):(_=A.getStartLineNumber(p.modifiedStart),h=A.getStartColumn(p.modifiedStart),d=A.getEndLineNumber(p.modifiedStart+p.modifiedLength-1),g=A.getEndColumn(p.modifiedStart+p.modifiedLength-1)),new l(i,r,s,f,_,h,d,g)}}function a(N){if(N.length<=1)return N;const p=[N[0]];let L=p[0];for(let A=1,i=N.length;A<i;A++){const r=N[A],s=r.originalStart-(L.originalStart+L.originalLength),f=r.modifiedStart-(L.modifiedStart+L.modifiedLength);Math.min(s,f)<M?(L.originalLength=r.originalStart+r.originalLength-L.originalStart,L.modifiedLength=r.modifiedStart+r.modifiedLength-L.modifiedStart):(p.push(r),L=r)}return p}class v{constructor(p,L,A,i,r){this.originalStartLineNumber=p,this.originalEndLineNumber=L,this.modifiedStartLineNumber=A,this.modifiedEndLineNumber=i,this.charChanges=r}static createFromDiffResult(p,L,A,i,r,s,f){let _,h,d,g,P;if(L.originalLength===0?(_=A.getStartLineNumber(L.originalStart)-1,h=0):(_=A.getStartLineNumber(L.originalStart),h=A.getEndLineNumber(L.originalStart+L.originalLength-1)),L.modifiedLength===0?(d=i.getStartLineNumber(L.modifiedStart)-1,g=0):(d=i.getStartLineNumber(L.modifiedStart),g=i.getEndLineNumber(L.modifiedStart+L.modifiedLength-1)),s&&L.originalLength>0&&L.originalLength<20&&L.modifiedLength>0&&L.modifiedLength<20&&r()){const F=A.createCharSequence(p,L.originalStart,L.originalStart+L.originalLength-1),R=i.createCharSequence(p,L.modifiedStart,L.modifiedStart+L.modifiedLength-1);let I=u(F,R,r,!0).changes;f&&(I=a(I)),P=[];for(let S=0,O=I.length;S<O;S++)P.push(l.createFromDiffChange(I[S],F,R))}return new v(_,h,d,g,P)}}class w{constructor(p,L,A){this.shouldComputeCharChanges=A.shouldComputeCharChanges,this.shouldPostProcessCharChanges=A.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=A.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=A.shouldMakePrettyDiff,this.originalLines=p,this.modifiedLines=L,this.original=new E(p),this.modified=new E(L),this.continueLineDiff=e(A.maxComputationTime),this.continueCharDiff=e(A.maxComputationTime===0?0:Math.min(A.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const p=u(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),L=p.changes,A=p.quitEarly;if(this.shouldIgnoreTrimWhitespace){const f=[];for(let _=0,h=L.length;_<h;_++)f.push(v.createFromDiffResult(this.shouldIgnoreTrimWhitespace,L[_],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:A,changes:f}}const i=[];let r=0,s=0;for(let f=-1,_=L.length;f<_;f++){const h=f+1<_?L[f+1]:null,d=h?h.originalStart:this.originalLines.length,g=h?h.modifiedStart:this.modifiedLines.length;for(;r<d&&s<g;){const P=this.originalLines[r],F=this.modifiedLines[s];if(P!==F){{let R=m(P,1),I=m(F,1);for(;R>1&&I>1;){const S=P.charCodeAt(R-2),O=F.charCodeAt(I-2);if(S!==O)break;R--,I--}(R>1||I>1)&&this._pushTrimWhitespaceCharChange(i,r+1,1,R,s+1,1,I)}{let R=c(P,1),I=c(F,1);const S=P.length+1,O=F.length+1;for(;R<S&&I<O;){const H=P.charCodeAt(R-1),X=P.charCodeAt(I-1);if(H!==X)break;R++,I++}(R<S||I<O)&&this._pushTrimWhitespaceCharChange(i,r+1,R,S,s+1,I,O)}}r++,s++}h&&(i.push(v.createFromDiffResult(this.shouldIgnoreTrimWhitespace,h,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),r+=h.originalLength,s+=h.modifiedLength)}return{quitEarly:A,changes:i}}_pushTrimWhitespaceCharChange(p,L,A,i,r,s,f){if(this._mergeTrimWhitespaceCharChange(p,L,A,i,r,s,f))return;let _;this.shouldComputeCharChanges&&(_=[new l(L,A,L,i,r,s,r,f)]),p.push(new v(L,L,r,r,_))}_mergeTrimWhitespaceCharChange(p,L,A,i,r,s,f){const _=p.length;if(_===0)return!1;const h=p[_-1];return h.originalEndLineNumber===0||h.modifiedEndLineNumber===0?!1:h.originalEndLineNumber+1===L&&h.modifiedEndLineNumber+1===r?(h.originalEndLineNumber=L,h.modifiedEndLineNumber=r,this.shouldComputeCharChanges&&h.charChanges&&h.charChanges.push(new l(L,A,L,i,r,s,r,f)),!0):!1}}n.DiffComputer=w;function m(N,p){const L=T.firstNonWhitespaceIndex(N);return L===-1?p:L+1}function c(N,p){const L=T.lastNonWhitespaceIndex(N);return L===-1?p:L+2}function e(N){if(N===0)return()=>!0;const p=Date.now();return()=>Date.now()-p<N}}),z(G[27],Y([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function D(o=""){let l="(-?\\d*\\.\\d\\w*)|([^";for(const a of n.USUAL_WORD_SEPARATORS)o.indexOf(a)>=0||(l+="\\"+a);return l+="\\s]+)",new RegExp(l,"g")}n.DEFAULT_WORD_REGEXP=D();function T(o){let l=n.DEFAULT_WORD_REGEXP;if(o&&o instanceof RegExp)if(o.global)l=o;else{let a="g";o.ignoreCase&&(a+="i"),o.multiline&&(a+="m"),o.unicode&&(a+="u"),l=new RegExp(o.source,a)}return l.lastIndex=0,l}n.ensureValidWordDefinition=T;const M={maxLen:1e3,windowSize:15,timeBudget:150};function u(o,l,a,v,w=M){if(a.length>w.maxLen){let p=o-w.maxLen/2;return p<0?p=0:v+=p,a=a.substring(p,o+w.maxLen/2),u(o,l,a,v,w)}const m=Date.now(),c=o-1-v;let e=-1,N=null;for(let p=1;!(Date.now()-m>=w.timeBudget);p++){const L=c-w.windowSize*p;l.lastIndex=Math.max(0,L);const A=E(l,a,c,e);if(!A&&N||(N=A,L<=0))break;e=L}if(N){let p={word:N[0],startColumn:v+1+N.index,endColumn:v+1+N.index+N[0].length};return l.lastIndex=0,p}return null}n.getWordAtText=u;function E(o,l,a,v){let w;for(;w=o.exec(l);){const m=w.index||0;if(m<=a&&o.lastIndex>=a)return w;if(v>0&&m>v)return null}return null}}),z(G[28],Y([0,1,23]),function(y,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.Uint8Matrix=n.State=void 0;var T;(function(c){c[c.Invalid=0]="Invalid",c[c.Start=1]="Start",c[c.H=2]="H",c[c.HT=3]="HT",c[c.HTT=4]="HTT",c[c.HTTP=5]="HTTP",c[c.F=6]="F",c[c.FI=7]="FI",c[c.FIL=8]="FIL",c[c.BeforeColon=9]="BeforeColon",c[c.AfterColon=10]="AfterColon",c[c.AlmostThere=11]="AlmostThere",c[c.End=12]="End",c[c.Accept=13]="Accept",c[c.LastKnownState=14]="LastKnownState"})(T=n.State||(n.State={}));class M{constructor(e,N,p){const L=new Uint8Array(e*N);for(let A=0,i=e*N;A<i;A++)L[A]=p;this._data=L,this.rows=e,this.cols=N}get(e,N){return this._data[e*this.cols+N]}set(e,N,p){this._data[e*this.cols+N]=p}}n.Uint8Matrix=M;class u{constructor(e){let N=0,p=0;for(let A=0,i=e.length;A<i;A++){let[r,s,f]=e[A];s>N&&(N=s),r>p&&(p=r),f>p&&(p=f)}N++,p++;let L=new M(p,N,0);for(let A=0,i=e.length;A<i;A++){let[r,s,f]=e[A];L.set(r,s,f)}this._states=L,this._maxCharCode=N}nextState(e,N){return N<0||N>=this._maxCharCode?0:this._states.get(e,N)}}n.StateMachine=u;let E=null;function o(){return E===null&&(E=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),E}var l;(function(c){c[c.None=0]="None",c[c.ForceTermination=1]="ForceTermination",c[c.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let a=null;function v(){if(a===null){a=new D.CharacterClassifier(0);const c=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let N=0;N<c.length;N++)a.set(c.charCodeAt(N),1);const e=".,;";for(let N=0;N<e.length;N++)a.set(e.charCodeAt(N),2)}return a}class w{static _createLink(e,N,p,L,A){let i=A-1;do{const r=N.charCodeAt(i);if(e.get(r)!==2)break;i--}while(i>L);if(L>0){const r=N.charCodeAt(L-1),s=N.charCodeAt(i);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&i--}return{range:{startLineNumber:p,startColumn:L+1,endLineNumber:p,endColumn:i+2},url:N.substring(L,i+1)}}static computeLinks(e,N=o()){const p=v();let L=[];for(let A=1,i=e.getLineCount();A<=i;A++){const r=e.getLineContent(A),s=r.length;let f=0,_=0,h=0,d=1,g=!1,P=!1,F=!1,R=!1;for(;f<s;){let I=!1;const S=r.charCodeAt(f);if(d===13){let O;switch(S){case 40:g=!0,O=0;break;case 41:O=g?0:1;break;case 91:F=!0,P=!0,O=0;break;case 93:F=!1,O=P?0:1;break;case 123:R=!0,O=0;break;case 125:O=R?0:1;break;case 39:O=h===34||h===96?0:1;break;case 34:O=h===39||h===96?0:1;break;case 96:O=h===39||h===34?0:1;break;case 42:O=h===42?1:0;break;case 124:O=h===124?1:0;break;case 32:O=F?0:1;break;default:O=p.get(S)}O===1&&(L.push(w._createLink(p,r,A,_,f)),I=!0)}else if(d===12){let O;S===91?(P=!0,O=0):O=p.get(S),O===1?I=!0:d=13}else d=N.nextState(d,S),d===0&&(I=!0);I&&(d=1,g=!1,P=!1,R=!1,_=f+1,h=S),f++}d===13&&L.push(w._createLink(p,r,A,_,s))}return L}}n.LinkComputer=w;function m(c){return!c||typeof c.getLineCount!="function"||typeof c.getLineContent!="function"?[]:w.computeLinks(c)}n.computeLinks=m}),z(G[29],Y([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class D{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(M,u,E,o,l){if(M&&u){let a=this.doNavigateValueSet(u,l);if(a)return{range:M,value:a}}if(E&&o){let a=this.doNavigateValueSet(o,l);if(a)return{range:E,value:a}}return null}doNavigateValueSet(M,u){let E=this.numberReplace(M,u);return E!==null?E:this.textReplace(M,u)}numberReplace(M,u){let E=Math.pow(10,M.length-(M.lastIndexOf(".")+1)),o=Number(M),l=parseFloat(M);return!isNaN(o)&&!isNaN(l)&&o===l?o===0&&!u?null:(o=Math.floor(o*E),o+=u?E:-E,String(o/E)):null}textReplace(M,u){return this.valueSetsReplace(this._defaultValueSet,M,u)}valueSetsReplace(M,u,E){let o=null;for(let l=0,a=M.length;o===null&&l<a;l++)o=this.valueSetReplace(M[l],u,E);return o}valueSetReplace(M,u,E){let o=M.indexOf(u);return o>=0?(o+=E?1:-1,o<0?o=M.length-1:o%=M.length,M[o]):null}}n.BasicInplaceReplace=D,D.INSTANCE=new D}),z(G[30],Y([0,1]),function(y,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.AccessibilitySupport=void 0;var D;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(D=n.AccessibilitySupport||(n.AccessibilitySupport={}));var T;(function(t){t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(T=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var M;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(M=n.CompletionItemKind||(n.CompletionItemKind={}));var u;(function(t){t[t.Deprecated=1]="Deprecated"})(u=n.CompletionItemTag||(n.CompletionItemTag={}));var E;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var o;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(o=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var l;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(l=n.CursorChangeReason||(n.CursorChangeReason={}));var a;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(a=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var v;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(v=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var w;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(w=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var m;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.autoClosingBrackets=5]="autoClosingBrackets",t[t.autoClosingDelete=6]="autoClosingDelete",t[t.autoClosingOvertype=7]="autoClosingOvertype",t[t.autoClosingQuotes=8]="autoClosingQuotes",t[t.autoIndent=9]="autoIndent",t[t.automaticLayout=10]="automaticLayout",t[t.autoSurround=11]="autoSurround",t[t.bracketPairColorization=12]="bracketPairColorization",t[t.guides=13]="guides",t[t.codeLens=14]="codeLens",t[t.codeLensFontFamily=15]="codeLensFontFamily",t[t.codeLensFontSize=16]="codeLensFontSize",t[t.colorDecorators=17]="colorDecorators",t[t.columnSelection=18]="columnSelection",t[t.comments=19]="comments",t[t.contextmenu=20]="contextmenu",t[t.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",t[t.cursorBlinking=22]="cursorBlinking",t[t.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",t[t.cursorStyle=24]="cursorStyle",t[t.cursorSurroundingLines=25]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",t[t.cursorWidth=27]="cursorWidth",t[t.disableLayerHinting=28]="disableLayerHinting",t[t.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",t[t.domReadOnly=30]="domReadOnly",t[t.dragAndDrop=31]="dragAndDrop",t[t.emptySelectionClipboard=32]="emptySelectionClipboard",t[t.extraEditorClassName=33]="extraEditorClassName",t[t.fastScrollSensitivity=34]="fastScrollSensitivity",t[t.find=35]="find",t[t.fixedOverflowWidgets=36]="fixedOverflowWidgets",t[t.folding=37]="folding",t[t.foldingStrategy=38]="foldingStrategy",t[t.foldingHighlight=39]="foldingHighlight",t[t.foldingImportsByDefault=40]="foldingImportsByDefault",t[t.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=42]="fontFamily",t[t.fontInfo=43]="fontInfo",t[t.fontLigatures=44]="fontLigatures",t[t.fontSize=45]="fontSize",t[t.fontWeight=46]="fontWeight",t[t.formatOnPaste=47]="formatOnPaste",t[t.formatOnType=48]="formatOnType",t[t.glyphMargin=49]="glyphMargin",t[t.gotoLocation=50]="gotoLocation",t[t.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",t[t.hover=52]="hover",t[t.inDiffEditor=53]="inDiffEditor",t[t.inlineSuggest=54]="inlineSuggest",t[t.letterSpacing=55]="letterSpacing",t[t.lightbulb=56]="lightbulb",t[t.lineDecorationsWidth=57]="lineDecorationsWidth",t[t.lineHeight=58]="lineHeight",t[t.lineNumbers=59]="lineNumbers",t[t.lineNumbersMinChars=60]="lineNumbersMinChars",t[t.linkedEditing=61]="linkedEditing",t[t.links=62]="links",t[t.matchBrackets=63]="matchBrackets",t[t.minimap=64]="minimap",t[t.mouseStyle=65]="mouseStyle",t[t.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=67]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",t[t.multiCursorModifier=69]="multiCursorModifier",t[t.multiCursorPaste=70]="multiCursorPaste",t[t.occurrencesHighlight=71]="occurrencesHighlight",t[t.overviewRulerBorder=72]="overviewRulerBorder",t[t.overviewRulerLanes=73]="overviewRulerLanes",t[t.padding=74]="padding",t[t.parameterHints=75]="parameterHints",t[t.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",t[t.quickSuggestions=78]="quickSuggestions",t[t.quickSuggestionsDelay=79]="quickSuggestionsDelay",t[t.readOnly=80]="readOnly",t[t.renameOnType=81]="renameOnType",t[t.renderControlCharacters=82]="renderControlCharacters",t[t.renderFinalNewline=83]="renderFinalNewline",t[t.renderLineHighlight=84]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=86]="renderValidationDecorations",t[t.renderWhitespace=87]="renderWhitespace",t[t.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",t[t.roundedSelection=89]="roundedSelection",t[t.rulers=90]="rulers",t[t.scrollbar=91]="scrollbar",t[t.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=93]="scrollBeyondLastLine",t[t.scrollPredominantAxis=94]="scrollPredominantAxis",t[t.selectionClipboard=95]="selectionClipboard",t[t.selectionHighlight=96]="selectionHighlight",t[t.selectOnLineNumbers=97]="selectOnLineNumbers",t[t.showFoldingControls=98]="showFoldingControls",t[t.showUnused=99]="showUnused",t[t.snippetSuggestions=100]="snippetSuggestions",t[t.smartSelect=101]="smartSelect",t[t.smoothScrolling=102]="smoothScrolling",t[t.stickyTabStops=103]="stickyTabStops",t[t.stopRenderingLineAfter=104]="stopRenderingLineAfter",t[t.suggest=105]="suggest",t[t.suggestFontSize=106]="suggestFontSize",t[t.suggestLineHeight=107]="suggestLineHeight",t[t.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",t[t.suggestSelection=109]="suggestSelection",t[t.tabCompletion=110]="tabCompletion",t[t.tabIndex=111]="tabIndex",t[t.unusualLineTerminators=112]="unusualLineTerminators",t[t.useShadowDOM=113]="useShadowDOM",t[t.useTabStops=114]="useTabStops",t[t.wordSeparators=115]="wordSeparators",t[t.wordWrap=116]="wordWrap",t[t.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=119]="wordWrapColumn",t[t.wordWrapOverride1=120]="wordWrapOverride1",t[t.wordWrapOverride2=121]="wordWrapOverride2",t[t.wrappingIndent=122]="wrappingIndent",t[t.wrappingStrategy=123]="wrappingStrategy",t[t.showDeprecated=124]="showDeprecated",t[t.inlayHints=125]="inlayHints",t[t.editorClassName=126]="editorClassName",t[t.pixelRatio=127]="pixelRatio",t[t.tabFocusMode=128]="tabFocusMode",t[t.layoutInfo=129]="layoutInfo",t[t.wrappingInfo=130]="wrappingInfo"})(m=n.EditorOption||(n.EditorOption={}));var c;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(c=n.EndOfLinePreference||(n.EndOfLinePreference={}));var e;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(e=n.EndOfLineSequence||(n.EndOfLineSequence={}));var N;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(N=n.IndentAction||(n.IndentAction={}));var p;(function(t){t[t.Other=0]="Other",t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(p=n.InlayHintKind||(n.InlayHintKind={}));var L;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(L=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var A;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(A=n.KeyCode||(n.KeyCode={}));var i;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(i=n.MarkerSeverity||(n.MarkerSeverity={}));var r;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(r=n.MarkerTag||(n.MarkerTag={}));var s;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(s=n.MinimapPosition||(n.MinimapPosition={}));var f;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(f=n.MouseTargetType||(n.MouseTargetType={}));var _;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(_=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var h;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(h=n.OverviewRulerLane||(n.OverviewRulerLane={}));var d;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(d=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var g;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(g=n.RenderMinimap||(n.RenderMinimap={}));var P;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(P=n.ScrollType||(n.ScrollType={}));var F;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(F=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var R;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(R=n.SelectionDirection||(n.SelectionDirection={}));var I;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(I=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var S;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(S=n.SymbolKind||(n.SymbolKind={}));var O;(function(t){t[t.Deprecated=1]="Deprecated"})(O=n.SymbolTag||(n.SymbolTag={}));var H;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(H=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var X;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(X=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var $;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var K;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(K=n.WrappingIndent||(n.WrappingIndent={}))}),z(G[31],Y([0,1,21,10,17,14,3,5,24,25,30]),function(y,n,D,T,M,u,E,o,l,a,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class w{static chord(e,N){return(0,M.KeyChord)(e,N)}}n.KeyMod=w,w.CtrlCmd=2048,w.Shift=1024,w.Alt=512,w.WinCtrl=256;function m(){return{editor:void 0,languages:void 0,CancellationTokenSource:D.CancellationTokenSource,Emitter:T.Emitter,KeyCode:v.KeyCode,KeyMod:w,Position:E.Position,Range:o.Range,Selection:l.Selection,SelectionDirection:v.SelectionDirection,MarkerSeverity:v.MarkerSeverity,MarkerTag:v.MarkerTag,Uri:u.URI,Token:a.Token}}n.createMonacoBaseAPI=m}),z(G[32],Y([0,1,13]),function(y,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumComputer=n.PrefixSumIndexOfResult=void 0;class T{constructor(E,o){this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=o}}n.PrefixSumIndexOfResult=T;class M{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,o){E=(0,D.toUint32)(E);const l=this.values,a=this.prefixSum,v=o.length;return v===0?!1:(this.values=new Uint32Array(l.length+v),this.values.set(l.subarray(0,E),0),this.values.set(l.subarray(E),E+v),this.values.set(o,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(a.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(E,o){return E=(0,D.toUint32)(E),o=(0,D.toUint32)(o),this.values[E]===o?!1:(this.values[E]=o,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,o){E=(0,D.toUint32)(E),o=(0,D.toUint32)(o);const l=this.values,a=this.prefixSum;if(E>=l.length)return!1;let v=l.length-E;return o>=v&&(o=v),o===0?!1:(this.values=new Uint32Array(l.length-o),this.values.set(l.subarray(0,E),0),this.values.set(l.subarray(E+o),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(a.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(E){return E<0?0:(E=(0,D.toUint32)(E),this._getPrefixSum(E))}_getPrefixSum(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let o=this.prefixSumValidIndex[0]+1;o===0&&(this.prefixSum[0]=this.values[0],o++),E>=this.values.length&&(E=this.values.length-1);for(let l=o;l<=E;l++)this.prefixSum[l]=this.prefixSum[l-1]+this.values[l];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let o=0,l=this.values.length-1,a=0,v=0,w=0;for(;o<=l;)if(a=o+(l-o)/2|0,v=this.prefixSum[a],w=v-this.values[a],E<w)l=a-1;else if(E>=v)o=a+1;else break;return new T(a,E-w)}}n.PrefixSumComputer=M}),z(G[33],Y([0,1,4,3,32]),function(y,n,D,T,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class u{constructor(o,l,a,v){this._uri=o,this._lines=l,this._eol=a,this._versionId=v,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(o){o.eol&&o.eol!==this._eol&&(this._eol=o.eol,this._lineStarts=null);const l=o.changes;for(const a of l)this._acceptDeleteRange(a.range),this._acceptInsertText(new T.Position(a.range.startLineNumber,a.range.startColumn),a.text);this._versionId=o.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const o=this._eol.length,l=this._lines.length,a=new Uint32Array(l);for(let v=0;v<l;v++)a[v]=this._lines[v].length+o;this._lineStarts=new M.PrefixSumComputer(a)}}_setLineText(o,l){this._lines[o]=l,this._lineStarts&&this._lineStarts.changeValue(o,this._lines[o].length+this._eol.length)}_acceptDeleteRange(o){if(o.startLineNumber===o.endLineNumber){if(o.startColumn===o.endColumn)return;this._setLineText(o.startLineNumber-1,this._lines[o.startLineNumber-1].substring(0,o.startColumn-1)+this._lines[o.startLineNumber-1].substring(o.endColumn-1));return}this._setLineText(o.startLineNumber-1,this._lines[o.startLineNumber-1].substring(0,o.startColumn-1)+this._lines[o.endLineNumber-1].substring(o.endColumn-1)),this._lines.splice(o.startLineNumber,o.endLineNumber-o.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(o.startLineNumber,o.endLineNumber-o.startLineNumber)}_acceptInsertText(o,l){if(l.length===0)return;let a=(0,D.splitLines)(l);if(a.length===1){this._setLineText(o.lineNumber-1,this._lines[o.lineNumber-1].substring(0,o.column-1)+a[0]+this._lines[o.lineNumber-1].substring(o.column-1));return}a[a.length-1]+=this._lines[o.lineNumber-1].substring(o.column-1),this._setLineText(o.lineNumber-1,this._lines[o.lineNumber-1].substring(0,o.column-1)+a[0]);let v=new Uint32Array(a.length-1);for(let w=1;w<a.length;w++)this._lines.splice(o.lineNumber+w-1,0,a[w]),v[w-1]=a[w].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(o.lineNumber,v)}}n.MirrorTextModel=u}),z(G[35],Y([0,1,11,2,14,3,5,26,33,27,28,29,31,12,9]),function(y,n,D,T,M,u,E,o,l,a,v,w,m,c,e){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=n.MirrorModel=void 0;class N extends l.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,r){let s=(0,a.getWordAtText)(i.column,(0,a.ensureValidWordDefinition)(r),this._lines[i.lineNumber-1],0);return s?new E.Range(i.lineNumber,s.startColumn,i.lineNumber,s.endColumn):null}getWordUntilPosition(i,r){const s=this.getWordAtPosition(i,r);return s?{word:this._lines[i.lineNumber-1].substring(s.startColumn-1,i.column-1),startColumn:s.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const r=this._lines,s=this._wordenize.bind(this);let f=0,_="",h=0,d=[];return{*[Symbol.iterator](){for(;;)if(h<d.length){const g=_.substring(d[h].start,d[h].end);h+=1,yield g}else if(f<r.length)_=r[f],d=s(_,i),h=0,f+=1;else break}}}getLineWords(i,r){let s=this._lines[i-1],f=this._wordenize(s,r),_=[];for(const h of f)_.push({word:s.substring(h.start,h.end),startColumn:h.start+1,endColumn:h.end+1});return _}_wordenize(i,r){const s=[];let f;for(r.lastIndex=0;(f=r.exec(i))&&f[0].length!==0;)s.push({start:f.index,end:f.index+f[0].length});return s}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);let r=this._eol,s=i.startLineNumber-1,f=i.endLineNumber-1,_=[];_.push(this._lines[s].substring(i.startColumn-1));for(let h=s+1;h<f;h++)_.push(this._lines[h]);return _.push(this._lines[f].substring(0,i.endColumn-1)),_.join(r)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();let r=this._lineStarts.getIndexOf(i),s=this._lines[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,s)}}_validateRange(i){const r=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),s=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return r.lineNumber!==i.startLineNumber||r.column!==i.startColumn||s.lineNumber!==i.endLineNumber||s.column!==i.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:s.lineNumber,endColumn:s.column}:i}_validatePosition(i){if(!u.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:r,column:s}=i,f=!1;if(r<1)r=1,s=1,f=!0;else if(r>this._lines.length)r=this._lines.length,s=this._lines[r-1].length+1,f=!0;else{let _=this._lines[r-1].length+1;s<1?(s=1,f=!0):s>_&&(s=_,f=!0)}return f?{lineNumber:r,column:s}:i}}n.MirrorModel=N;class p{constructor(i,r){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=r,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){let i=[];return Object.keys(this._models).forEach(r=>i.push(this._models[r])),i}acceptNewModel(i){this._models[i.url]=new N(M.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,r){if(!this._models[i])return;this._models[i].onEvents(r)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeDiff(i,r,s,f){const _=this._getModel(i),h=this._getModel(r);if(!_||!h)return null;const d=_.getLinesContent(),g=h.getLinesContent(),F=new o.DiffComputer(d,g,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:f}).computeDiff(),R=F.changes.length>0?!1:this._modelsAreIdentical(_,h);return{quitEarly:F.quitEarly,identical:R,changes:F.changes}}_modelsAreIdentical(i,r){const s=i.getLineCount(),f=r.getLineCount();if(s!==f)return!1;for(let _=1;_<=s;_++){const h=i.getLineContent(_),d=r.getLineContent(_);if(h!==d)return!1}return!0}async computeDirtyDiff(i,r,s){let f=this._getModel(i),_=this._getModel(r);if(!f||!_)return null;let h=f.getLinesContent(),d=_.getLinesContent();return new o.DiffComputer(h,d,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,r){const s=this._getModel(i);if(!s)return r;const f=[];let _;r=r.slice(0).sort((h,d)=>{if(h.range&&d.range)return E.Range.compareRangesUsingStarts(h.range,d.range);let g=h.range?0:1,P=d.range?0:1;return g-P});for(let{range:h,text:d,eol:g}of r){if(typeof g=="number"&&(_=g),E.Range.isEmpty(h)&&!d)continue;const P=s.getValueInRange(h);if(d=d.replace(/\r\n|\n|\r/g,s.eol),P===d)continue;if(Math.max(d.length,P.length)>p._diffLimit){f.push({range:h,text:d});continue}const F=(0,D.stringDiff)(P,d,!1),R=s.offsetAt(E.Range.lift(h).getStartPosition());for(const I of F){const S=s.positionAt(R+I.originalStart),O=s.positionAt(R+I.originalStart+I.originalLength),H={text:d.substr(I.modifiedStart,I.modifiedLength),range:{startLineNumber:S.lineNumber,startColumn:S.column,endLineNumber:O.lineNumber,endColumn:O.column}};s.getValueInRange(H.range)!==H.text&&f.push(H)}}return typeof _=="number"&&f.push({eol:_,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),f}async computeLinks(i){let r=this._getModel(i);return r?(0,v.computeLinks)(r):null}async textualSuggest(i,r,s,f){const _=new e.StopWatch(!0),h=new RegExp(s,f),d=new Set;e:for(let g of i){const P=this._getModel(g);if(!!P){for(let F of P.words(h))if(!(F===r||!isNaN(Number(F)))&&(d.add(F),d.size>p._suggestionsLimit))break e}}return{words:Array.from(d),duration:_.elapsed()}}async computeWordRanges(i,r,s,f){let _=this._getModel(i);if(!_)return Object.create(null);const h=new RegExp(s,f),d=Object.create(null);for(let g=r.startLineNumber;g<r.endLineNumber;g++){let P=_.getLineWords(g,h);for(const F of P){if(!isNaN(Number(F.word)))continue;let R=d[F.word];R||(R=[],d[F.word]=R),R.push({startLineNumber:g,startColumn:F.startColumn,endLineNumber:g,endColumn:F.endColumn})}}return d}async navigateValueSet(i,r,s,f,_){let h=this._getModel(i);if(!h)return null;let d=new RegExp(f,_);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});let g=h.getValueInRange(r),P=h.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},d);if(!P)return null;let F=h.getValueInRange(P);return w.BasicInplaceReplace.INSTANCE.navigateValueSet(r,g,P,F,s)}loadForeignModule(i,r,s){const f=(d,g)=>this._host.fhr(d,g);let h={host:c.createProxyObject(s,f),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(h,r),Promise.resolve(c.getAllMethodNames(this._foreignModule))):new Promise((d,g)=>{y([i],P=>{this._foreignModule=P.create(h,r),d(c.getAllMethodNames(this._foreignModule))},g)})}fmr(i,r){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,r))}catch(s){return Promise.reject(s)}}}n.EditorSimpleWorker=p,p._diffLimit=1e5,p._suggestionsLimit=1e4;function L(A){return new p(A,null)}n.create=L,typeof importScripts=="function"&&(T.globals.monaco=(0,m.createMonacoBaseAPI)())}),function(){const y=self.MonacoEnvironment,n=y&&y.baseUrl?y.baseUrl:"../../../",D=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:l=>l,createScript:(l,...a)=>{const v=a.slice(0,-1).join(","),w=a.pop().toString();return`(function anonymous(${v}) {
${w}
})`}}):void 0;function T(){try{return(D?self.eval(D.createScript("","true")):new Function("true")).call(self),!0}catch(l){return!1}}function M(){return new Promise((l,a)=>{if(typeof self.define=="function"&&self.define.amd)return l();const v=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(v)&&v.substring(0,self.origin.length)!==self.origin)&&T()){fetch(v).then(m=>{if(m.status!==200)throw new Error(m.statusText);return m.text()}).then(m=>{m=`${m}
//# sourceURL=${v}`,(D?self.eval(D.createScript("",m)):new Function(m)).call(self),l()}).then(void 0,a);return}D?importScripts(D.createScriptURL(v)):importScripts(v),l()})}const u=function(l){M().then(()=>{require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//}),require([l],function(a){setTimeout(function(){let v=a.create((w,m)=>{self.postMessage(w,m)},null);for(self.onmessage=w=>v.onmessage(w.data,w.ports);o.length>0;)self.onmessage(o.shift())},0)})})};let E=!0,o=[];self.onmessage=l=>{if(!E){o.push(l);return}E=!1,u(l.data)}}()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/97018d742e4ce3dfbcdb0a02c42c16c6c152e4e1/core/vs/base/worker/workerMain.js.map
