/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/errors","vs/base/common/path","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/common/types","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/objects","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/process","vs/base/parts/ipc/common/ipc","os","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","child_process","vs/platform/product/common/product","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/parts/ipc/node/ipc.cp","vs/platform/files/common/watcher","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensionHostStarter","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","string_decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensions/node/extensionHostStarter","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","util","minimist","path","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(J){for(var e=[],R=0,L=J.length;R<L;R++)e[R]=te[J[R]];return e};define(te[99],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function R(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=R}),define(te[66],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const R=Object.prototype.hasOwnProperty;function L(n){const I=[];for(let v in n)R.call(n,v)&&I.push(n[v]);return I}e.values=L;function D(n,I){for(let v in n)if(R.call(n,v)&&I({key:v,value:n[v]},function(){delete n[v]})===!1)return}e.forEach=D;function k(n,I){const v=Object.create(null);for(const E of n){const h=I(E);let S=v[h];S||(S=v[h]=[]),S.push(E)}return v}e.groupBy=k;function A(n){const I=Object.create(null);return n&&n.forEach((v,E)=>{I[E]=v}),I}e.fromMap=A;function P(n,I){const v=[],E=[];for(let h of n)I.has(h)||v.push(h);for(let h of I)n.has(h)||E.push(h);return{removed:v,added:E}}e.diffSets=P;function w(n,I){const v=[],E=[];for(let[h,S]of n)I.has(h)||v.push(S);for(let[h,S]of I)n.has(h)||E.push(S);return{removed:v,added:E}}e.diffMaps=w;class b{constructor(){this.map=new Map}add(I,v){let E=this.map.get(I);E||(E=new Set,this.map.set(I,E)),E.add(v)}delete(I,v){const E=this.map.get(I);!E||(E.delete(v),E.size===0&&this.map.delete(I))}forEach(I,v){const E=this.map.get(I);!E||E.forEach(v)}}e.SetMap=b}),define(te[67],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(A){return(P,w,b)=>{let n=null,I=null;if(typeof b.value=="function"?(n="value",I=b.value):typeof b.get=="function"&&(n="get",I=b.get),!I)throw new Error("not supported");b[n]=A(I,w)}}e.createDecorator=R;function L(A,P,w){let b=null,n=null;if(typeof w.value=="function"?(b="value",n=w.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(b="get",n=w.get),!n)throw new Error("not supported");const I=`$memoize$${P}`;w[b]=function(...v){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,v)}),this[I]}}e.memoize=L;function D(A,P,w){return R((b,n)=>{const I=`$debounce$${n}`,v=`$debounce$result$${n}`;return function(...E){this[v]||(this[v]=w?w():void 0),clearTimeout(this[I]),P&&(this[v]=P(this[v],...E),E=[this[v]]),this[I]=setTimeout(()=>{b.apply(this,E),this[v]=w?w():void 0},A)}})}e.debounce=D;function k(A,P,w){return R((b,n)=>{const I=`$throttle$timer$${n}`,v=`$throttle$result$${n}`,E=`$throttle$lastRun$${n}`,h=`$throttle$pending$${n}`;return function(...S){if(this[v]||(this[v]=w?w():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...S)),this[h])return;const f=this[E]+A;f<=Date.now()?(this[E]=Date.now(),b.apply(this,[this[v]]),this[v]=w?w():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[E]=Date.now(),b.apply(this,[this[v]]),this[v]=w?w():void 0},f-Date.now()))}})}e.throttle=k}),define(te[8],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=R,e.errorHandler=new R;function L(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=L;function D(a){w(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=D;function k(a){w(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=k;function A(a){if(a instanceof Error){let{name:t,message:s}=a;const r=a.stacktrace||a.stack;return{$isError:!0,name:t,message:s,stack:r}}return a}e.transformErrorForSerialization=A;const P="Canceled";function w(a){return a instanceof Error&&a.name===P&&a.message===P}e.isPromiseCanceledError=w;class b extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=b;function n(){const a=new Error(P);return a.name=a.message,a}e.canceled=n;function I(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=I;function v(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=v;function E(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function h(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function S(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=S;class f extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=f;class p extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=p;class m extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=m;function y(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=y;function c(a,t=Object.create(null)){const s=new Error(a);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=c}),define(te[17],ne([0,1,8]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(U,V=0){return U[U.length-(1+V)]}e.tail=L;function D(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=D;function k(U,V,B=(Q,Z)=>Q===Z){if(U===V)return!0;if(!U||!V||U.length!==V.length)return!1;for(let Q=0,Z=U.length;Q<Z;Q++)if(!B(U[Q],V[Q]))return!1;return!0}e.equals=k;function A(U,V,B){let Q=0,Z=U.length-1;for(;Q<=Z;){const K=(Q+Z)/2|0,H=B(U[K],V);if(H<0)Q=K+1;else if(H>0)Z=K-1;else return K}return-(Q+1)}e.binarySearch=A;function P(U,V){let B=0,Q=U.length;if(Q===0)return 0;for(;B<Q;){const Z=Math.floor((B+Q)/2);V(U[Z])?Q=Z:B=Z+1}return B}e.findFirstInSorted=P;function w(U,V,B){if(U=U|0,U>=V.length)throw new TypeError("invalid index");let Q=V[Math.floor(V.length*Math.random())],Z=[],K=[],H=[];for(let re of V){const ie=B(re,Q);ie<0?Z.push(re):ie>0?K.push(re):H.push(re)}return U<Z.length?w(U,Z,B):U<Z.length+H.length?H[0]:w(U-(Z.length+H.length),K,B)}e.quickSelect=w;function b(U,V){const B=[];let Q;for(const Z of U.slice(0).sort(V))!Q||V(Q[0],Z)!==0?(Q=[Z],B.push(Q)):Q.push(Z);return B}e.groupBy=b;function n(U,V,B){const Q=[];function Z(re,ie,ce){if(ie===0&&ce.length===0)return;const le=Q[Q.length-1];le&&le.start+le.deleteCount===re?(le.deleteCount+=ie,le.toInsert.push(...ce)):Q.push({start:re,deleteCount:ie,toInsert:ce})}let K=0,H=0;for(;;){if(K===U.length){Z(K,0,V.slice(H));break}if(H===V.length){Z(K,U.length-K,[]);break}const re=U[K],ie=V[H],ce=B(re,ie);ce===0?(K+=1,H+=1):ce<0?(Z(K,1,[]),K+=1):ce>0&&(Z(K,0,[ie]),H+=1)}return Q}e.sortedDiff=n;function I(U,V,B){const Q=n(U,V,B),Z=[],K=[];for(const H of Q)Z.push(...U.slice(H.start,H.start+H.deleteCount)),K.push(...H.toInsert);return{removed:Z,added:K}}e.delta=I;function v(U,V,B){if(B===0)return[];const Q=U.slice(0,B).sort(V);return h(U,V,Q,B,U.length),Q}e.top=v;function E(U,V,B,Q,Z){return B===0?Promise.resolve([]):new Promise((K,H)=>{(async()=>{const re=U.length,ie=U.slice(0,B).sort(V);for(let ce=B,le=Math.min(B+Q,re);ce<re;ce=le,le=Math.min(le+Q,re)){if(ce>B&&await new Promise(de=>setTimeout(de)),Z&&Z.isCancellationRequested)throw(0,R.canceled)();h(U,V,ie,ce,le)}return ie})().then(K,H)})}e.topAsync=E;function h(U,V,B,Q,Z){for(const K=B.length;Q<Z;Q++){const H=U[Q];if(V(H,B[K-1])<0){B.pop();const re=P(B,ie=>V(H,ie)<0);B.splice(re,0,H)}}}function S(U){return U.filter(V=>!!V)}e.coalesce=S;function f(U){let V=0;for(let B=0;B<U.length;B++)U[B]&&(U[V]=U[B],V+=1);U.length=V}e.coalesceInPlace=f;function p(U,V,B){U.splice(B,0,U.splice(V,1)[0])}e.move=p;function m(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=m;function y(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=y;function c(U,V=B=>B){const B=new Set;return U.filter(Q=>{const Z=V(Q);return B.has(Z)?!1:(B.add(Z),!0)})}e.distinct=c;function a(U){const V=Object.create(null);return B=>{const Q=U(B);return V[Q]?!1:(V[Q]=!0,!0)}}e.uniqueFilter=a;function t(U,V){const B=s(U,V);if(B!==-1)return U[B]}e.findLast=t;function s(U,V){for(let B=U.length-1;B>=0;B--){const Q=U[B];if(V(Q))return B}return-1}e.lastIndex=s;function r(U,V){return U.length>0?U[0]:V}e.firstOrDefault=r;function i(U,V,B=(Q,Z)=>Q===Z){let Q=0;for(let Z=0,K=Math.min(U.length,V.length);Z<K&&B(U[Z],V[Z]);Z++)Q++;return Q}e.commonPrefixLength=i;function o(U){return[].concat(...U)}e.flatten=o;function l(U,V){let B=typeof V=="number"?U:0;typeof V=="number"?B=U:(B=0,V=U);const Q=[];if(B<=V)for(let Z=B;Z<V;Z++)Q.push(Z);else for(let Z=B;Z>V;Z--)Q.push(Z);return Q}e.range=l;function u(U,V,B){return U.reduce((Q,Z)=>(Q[V(Z)]=B?B(Z):Z,Q),Object.create(null))}e.index=u;function d(U,V){return U.push(V),()=>g(U,V)}e.insert=d;function g(U,V){const B=U.indexOf(V);if(B>-1)return U.splice(B,1),V}e.remove=g;function T(U,V,B){const Q=U.slice(0,V),Z=U.slice(V);return Q.concat(B,Z)}e.arrayInsert=T;function _(U,V){let B;if(typeof V=="number"){let Q=V;B=()=>{const Z=Math.sin(Q++)*179426549;return Z-Math.floor(Z)}}else B=Math.random;for(let Q=U.length-1;Q>0;Q-=1){const Z=Math.floor(B()*(Q+1)),K=U[Q];U[Q]=U[Z],U[Z]=K}}e.shuffle=_;function O(U,V){const B=U.indexOf(V);B>-1&&(U.splice(B,1),U.unshift(V))}e.pushToStart=O;function F(U,V){const B=U.indexOf(V);B>-1&&(U.splice(B,1),U.push(V))}e.pushToEnd=F;function C(U,V){return Array.isArray(U)?U.map(V):V(U)}e.mapArrayOrNot=C;function N(U){return Array.isArray(U)?U:[U]}e.asArray=N;function z(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=z;function M(U,V){for(const B of U){const Q=V(B);if(Q!==void 0)return Q}}e.mapFind=M;function q(U,V,B){const Q=j(U,V),Z=U.length,K=B.length;U.length=Z+K;for(let H=Z-1;H>=Q;H--)U[H+K]=U[H];for(let H=0;H<K;H++)U[H+Q]=B[H]}e.insertInto=q;function W(U,V,B,Q){const Z=j(U,V),K=U.splice(Z,B);return q(U,Z,Q),K}e.splice=W;function j(U,V){return V<0?Math.max(V+U.length,0):Math.min(V,U.length)}function x(U,V){let B=Number.MAX_SAFE_INTEGER,Q=0;return U.forEach((Z,K)=>{const H=V(Z);H<B&&(B=H,Q=K)}),Q}e.minIndex=x;function $(U,V){let B=Number.MIN_SAFE_INTEGER,Q=0;return U.forEach((Z,K)=>{const H=V(Z);H>B&&(B=H,Q=K)}),Q}e.maxIndex=$;class G{constructor(V){this.items=V,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(V){let B=this.firstIdx;for(;B<this.items.length&&V(this.items[B]);)B++;const Q=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,Q}takeFromEndWhile(V){let B=this.lastIdx;for(;B>=0&&V(this.items[B]);)B--;const Q=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,Q}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=G}),define(te[68],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(L){const D=this;let k=!1,A;return function(){return k||(k=!0,A=L.apply(D,arguments)),A}}e.once=R}),define(te[56],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(L){function D(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}L.is=D;const k=Object.freeze([]);function A(){return k}L.empty=A;function*P(a){yield a}L.single=P;function w(a){return a||k}L.from=w;function b(a){return!a||a[Symbol.iterator]().next().done===!0}L.isEmpty=b;function n(a){return a[Symbol.iterator]().next().value}L.first=n;function I(a,t){for(const s of a)if(t(s))return!0;return!1}L.some=I;function v(a,t){for(const s of a)if(t(s))return s}L.find=v;function*E(a,t){for(const s of a)t(s)&&(yield s)}L.filter=E;function*h(a,t){let s=0;for(const r of a)yield t(r,s++)}L.map=h;function*S(...a){for(const t of a)for(const s of t)yield s}L.concat=S;function*f(a){for(const t of a)for(const s of t)yield s}L.concatNested=f;function p(a,t,s){let r=s;for(const i of a)r=t(r,i);return r}L.reduce=p;function*m(a,t,s=a.length){for(t<0&&(t+=a.length),s<0?s+=a.length:s>a.length&&(s=a.length);t<s;t++)yield a[t]}L.slice=m;function y(a,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,a];const r=a[Symbol.iterator]();for(let i=0;i<t;i++){const o=r.next();if(o.done)return[s,L.empty()];s.push(o.value)}return[s,{[Symbol.iterator](){return r}}]}L.consume=y;function c(a,t,s=(r,i)=>r===i){const r=a[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const o=r.next(),l=i.next();if(o.done!==l.done)return!1;if(o.done)return!0;if(!s(o.value,l.value))return!1}}L.equals=c})(R=e.Iterable||(e.Iterable={}))}),define(te[36],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function A(t,s=!1){let r=0,i=t.length,o="",l=0,u=16,d=0;function g(z){let M=0,q=0;for(;M<z;){const W=t.charCodeAt(r);if(W>=48&&W<=57)q=q*16+W-48;else if(W>=65&&W<=70)q=q*16+W-65+10;else if(W>=97&&W<=102)q=q*16+W-97+10;else break;r++,M++}return M<z&&(q=-1),q}function T(z){r=z,o="",l=0,u=16,d=0}function _(){const z=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&b(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&b(t.charCodeAt(r)))for(r++;r<t.length&&b(t.charCodeAt(r));)r++;else return d=3,t.substring(z,r);let M=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&b(t.charCodeAt(r))){for(r++;r<t.length&&b(t.charCodeAt(r));)r++;M=r}else d=3;return t.substring(z,M)}function O(){let z="",M=r;for(;;){if(r>=i){z+=t.substring(M,r),d=2;break}const q=t.charCodeAt(r);if(q===34){z+=t.substring(M,r),r++;break}if(q===92){if(z+=t.substring(M,r),r++,r>=i){d=2;break}switch(t.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const j=g(4);j>=0?z+=String.fromCharCode(j):d=4;break;default:d=5}M=r;continue}if(q>=0&&q<=31)if(w(q)){z+=t.substring(M,r),d=2;break}else d=6;r++}return z}function F(){if(o="",d=0,l=r,r>=i)return l=i,u=17;let z=t.charCodeAt(r);if(P(z)){do r++,o+=String.fromCharCode(z),z=t.charCodeAt(r);while(P(z));return u=15}if(w(z))return r++,o+=String.fromCharCode(z),z===13&&t.charCodeAt(r)===10&&(r++,o+=`
`),u=14;switch(z){case 123:return r++,u=1;case 125:return r++,u=2;case 91:return r++,u=3;case 93:return r++,u=4;case 58:return r++,u=6;case 44:return r++,u=5;case 34:return r++,o=O(),u=10;case 47:const M=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!w(t.charCodeAt(r));)r++;return o=t.substring(M,r),u=12}if(t.charCodeAt(r+1)===42){r+=2;const q=i-1;let W=!1;for(;r<q;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,W=!0;break}r++}return W||(r++,d=1),o=t.substring(M,r),u=13}return o+=String.fromCharCode(z),r++,u=16;case 45:if(o+=String.fromCharCode(z),r++,r===i||!b(t.charCodeAt(r)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),u=11;default:for(;r<i&&C(z);)r++,z=t.charCodeAt(r);if(l!==r){switch(o=t.substring(l,r),o){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return o+=String.fromCharCode(z),r++,u=16}}function C(z){if(P(z)||w(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let z;do z=F();while(z>=12&&z<=15);return z}return{setPosition:T,getPosition:()=>r,scan:s?N:F,getToken:()=>u,getTokenValue:()=>o,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>d}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function I(t,s){const r=[],i=new Object;let o;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function d(g,T,_,O){l.value=g,l.offset=T,l.length=_,l.type=O,l.colonOffset=void 0,o=l}try{y(t,{onObjectBegin:(g,T)=>{if(s<=g)throw i;o=void 0,u=s>g,r.push("")},onObjectProperty:(g,T,_)=>{if(s<T||(d(g,T,_,"property"),r[r.length-1]=g,s<=T+_))throw i},onObjectEnd:(g,T)=>{if(s<=g)throw i;o=void 0,r.pop()},onArrayBegin:(g,T)=>{if(s<=g)throw i;o=void 0,r.push(0)},onArrayEnd:(g,T)=>{if(s<=g)throw i;o=void 0,r.pop()},onLiteralValue:(g,T,_)=>{if(s<T||(d(g,T,_,a(g)),s<=T+_))throw i},onSeparator:(g,T,_)=>{if(s<=T)throw i;if(g===":"&&o&&o.type==="property")o.colonOffset=T,u=!1,o=void 0;else if(g===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(u=!0,r[r.length-1]=""),o=void 0}}})}catch(g){if(g!==i)throw g}return{path:r,previousNode:o,isAtPropertyKey:u,matches:g=>{let T=0;for(let _=0;T<g.length&&_<r.length;_++)if(g[T]===r[_]||g[T]==="*")T++;else if(g[T]!=="**")return!1;return T===g.length}}}e.getLocation=I;function v(t,s=[],r=k.DEFAULT){let i=null,o=[];const l=[];function u(g){Array.isArray(o)?o.push(g):i!==null&&(o[i]=g)}return y(t,{onObjectBegin:()=>{const g={};u(g),l.push(o),o=g,i=null},onObjectProperty:g=>{i=g},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const g=[];u(g),l.push(o),o=g,i=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:u,onError:(g,T,_)=>{s.push({error:g,offset:T,length:_})}},r),o[0]}e.parse=v;function E(t,s=[],r=k.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(g){i.type==="property"&&(i.length=g-i.offset,i=i.parent)}function l(g){return i.children.push(g),g}y(t,{onObjectBegin:g=>{i=l({type:"object",offset:g,length:-1,parent:i,children:[]})},onObjectProperty:(g,T,_)=>{i=l({type:"property",offset:T,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:g,offset:T,length:_,parent:i})},onObjectEnd:(g,T)=>{i.length=g+T-i.offset,i=i.parent,o(g+T)},onArrayBegin:(g,T)=>{i=l({type:"array",offset:g,length:-1,parent:i,children:[]})},onArrayEnd:(g,T)=>{i.length=g+T-i.offset,i=i.parent,o(g+T)},onLiteralValue:(g,T,_)=>{l({type:a(g),offset:T,length:_,parent:i,value:g}),o(T+_)},onSeparator:(g,T,_)=>{i.type==="property"&&(g===":"?i.colonOffset=T:g===","&&o(T))},onError:(g,T,_)=>{s.push({error:g,offset:T,length:_})}},r);const d=i.children[0];return d&&delete d.parent,d}e.parseTree=E;function h(t,s){if(!t)return;let r=t;for(let i of s)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===i){r=l.children[1],o=!0;break}if(!o)return}else{const o=i;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=h;function S(t){if(!t.parent||!t.parent.children)return[];const s=S(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=S;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":const s=Object.create(null);for(let r of t.children){const i=r.children[1];i&&(s[r.children[0].value]=f(i))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=f;function p(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=p;function m(t,s,r=!1){if(p(t,s,r)){const i=t.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=s;o++){const l=m(i[o],s,r);if(l)return l}return t}}e.findNodeAtOffset=m;function y(t,s,r=k.DEFAULT){const i=A(t,!1);function o(B){return B?()=>B(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(B){return B?Q=>B(Q,i.getTokenOffset(),i.getTokenLength()):()=>!0}const u=o(s.onObjectBegin),d=l(s.onObjectProperty),g=o(s.onObjectEnd),T=o(s.onArrayBegin),_=o(s.onArrayEnd),O=l(s.onLiteralValue),F=l(s.onSeparator),C=o(s.onComment),N=l(s.onError),z=r&&r.disallowComments,M=r&&r.allowTrailingComma;function q(){for(;;){const B=i.scan();switch(i.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:z||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(B){case 12:case 13:z?W(10):C();break;case 16:W(1);break;case 15:case 14:break;default:return B}}}function W(B,Q=[],Z=[]){if(N(B),Q.length+Z.length>0){let K=i.getToken();for(;K!==17;){if(Q.indexOf(K)!==-1){q();break}else if(Z.indexOf(K)!==-1)break;K=q()}}}function j(B){const Q=i.getTokenValue();return B?O(Q):d(Q),q(),!0}function x(){switch(i.getToken()){case 11:let B=0;try{B=JSON.parse(i.getTokenValue()),typeof B!="number"&&(W(2),B=0)}catch(Q){W(2)}O(B);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return q(),!0}function $(){return i.getToken()!==10?(W(3,[],[2,5]),!1):(j(!1),i.getToken()===6?(F(":"),q(),V()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function G(){u(),q();let B=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(B||W(4,[],[]),F(","),q(),i.getToken()===2&&M)break}else B&&W(6,[],[]);$()||W(4,[],[2,5]),B=!0}return g(),i.getToken()!==2?W(7,[2],[]):q(),!0}function U(){T(),q();let B=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(B||W(4,[],[]),F(","),q(),i.getToken()===4&&M)break}else B&&W(6,[],[]);V()||W(4,[],[4,5]),B=!0}return _(),i.getToken()!==4?W(8,[4],[]):q(),!0}function V(){switch(i.getToken()){case 3:return U();case 1:return G();case 10:return j(!0);default:return x()}}return q(),i.getToken()===17?r.allowEmptyContent?!0:(W(4,[],[]),!1):V()?(i.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=y;function c(t,s){let r=A(t),i=[],o,l=0,u;do switch(u=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:l!==u&&i.push(t.substring(l,u)),s!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,s)),l=r.getPosition();break}while(o!==17);return i.join("")}e.stripComments=c;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(te[50],ne([0,1,36]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(w,b,n){let I,v,E,h,S;if(b){for(h=b.offset,S=h+b.length,E=h;E>0&&!P(w,E-1);)E--;let l=S;for(;l<w.length&&!P(w,l);)l++;v=w.substring(E,l),I=k(v,n)}else v=w,I=0,E=0,h=0,S=w.length;const f=A(n,w);let p=!1,m=0,y;n.insertSpaces?y=D(" ",n.tabSize||4):y="	";const c=(0,R.createScanner)(v,!1);let a=!1;function t(){return f+D(y,I+m)}function s(){let l=c.scan();for(p=!1;l===15||l===14;)p=p||l===14,l=c.scan();return a=l===16||c.getTokenError()!==0,l}const r=[];function i(l,u,d){!a&&u<S&&d>h&&w.substring(u,d)!==l&&r.push({offset:u,length:d-u,content:l})}let o=s();if(o!==17){const l=c.getTokenOffset()+E,u=D(y,I);i(u,E,l)}for(;o!==17;){let l=c.getTokenOffset()+c.getTokenLength()+E,u=s(),d="";for(;!p&&(u===12||u===13);){const T=c.getTokenOffset()+E;i(" ",l,T),l=c.getTokenOffset()+c.getTokenLength()+E,d=u===12?t():"",u=s()}if(u===2)o!==1&&(m--,d=t());else if(u===4)o!==3&&(m--,d=t());else{switch(o){case 3:case 1:m++,d=t();break;case 5:case 12:d=t();break;case 13:p?d=t():d=" ";break;case 6:d=" ";break;case 10:if(u===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?d=" ":u!==5&&u!==17&&(a=!0);break;case 16:a=!0;break}p&&(u===12||u===13)&&(d=t())}const g=c.getTokenOffset()+E;i(d,l,g),o=u}return r}e.format=L;function D(w,b){let n="";for(let I=0;I<b;I++)n+=w;return n}function k(w,b){let n=0,I=0;const v=b.tabSize||4;for(;n<w.length;){const E=w.charAt(n);if(E===" ")I++;else if(E==="	")I+=v;else break;n++}return Math.floor(I/v)}function A(w,b){for(let n=0;n<b.length;n++){const I=b.charAt(n);if(I==="\r")return n+1<b.length&&b.charAt(n+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=A;function P(w,b){return`\r
`.indexOf(w.charAt(b))!==-1}e.isEOL=P}),define(te[44],ne([0,1,36,50]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(b,n,I){return k(b,n,void 0,I)}e.removeProperty=D;function k(b,n,I,v,E){const h=n.slice(),S=[],f=(0,R.parseTree)(b,S);let p,m;for(;h.length>0&&(m=h.pop(),p=(0,R.findNodeAtLocation)(f,h),p===void 0&&I!==void 0);)typeof m=="string"?I={[m]:I}:I=[I];if(p)if(p.type==="object"&&typeof m=="string"&&Array.isArray(p.children)){const y=(0,R.findNodeAtLocation)(p,[m]);if(y!==void 0)if(I===void 0){if(!y.parent)throw new Error("Malformed AST");const c=p.children.indexOf(y.parent);let a,t=y.parent.offset+y.parent.length;if(c>0){const s=p.children[c-1];a=s.offset+s.length}else a=p.offset+1,p.children.length>1&&(t=p.children[1].offset);return A(b,{offset:a,length:t-a,content:""},v)}else return A(b,{offset:y.offset,length:y.length,content:JSON.stringify(I)},v);else{if(I===void 0)return[];const c=`${JSON.stringify(m)}: ${JSON.stringify(I)}`,a=E?E(p.children.map(s=>s.children[0].value)):p.children.length;let t;if(a>0){const s=p.children[a-1];t={offset:s.offset+s.length,length:0,content:","+c}}else p.children.length===0?t={offset:p.offset+1,length:0,content:c}:t={offset:p.offset+1,length:0,content:c+","};return A(b,t,v)}}else if(p.type==="array"&&typeof m=="number"&&Array.isArray(p.children))if(I!==void 0){const y=`${JSON.stringify(I)}`;let c;if(p.children.length===0||m===0)c={offset:p.offset+1,length:0,content:p.children.length===0?y:y+","};else{const a=m===-1||m>p.children.length?p.children.length:m,t=p.children[a-1];c={offset:t.offset+t.length,length:0,content:","+y}}return A(b,c,v)}else{const y=m,c=p.children[y];let a;if(p.children.length===1)a={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===y){const t=p.children[y-1],s=t.offset+t.length,r=p.offset+p.length;a={offset:s,length:r-2-s,content:""}}else a={offset:c.offset,length:p.children[y+1].offset-c.offset,content:""};return A(b,a,v)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${p.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return A(b,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(I)},v)}}e.setProperty=k;function A(b,n,I){let v=P(b,n),E=n.offset,h=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;E>0&&!(0,L.isEOL)(v,E-1);)E--;for(;h<v.length&&!(0,L.isEOL)(v,h);)h++}const S=(0,L.format)(v,{offset:E,length:h-E},I);for(let p=S.length-1;p>=0;p--){const m=S[p];v=P(v,m),E=Math.min(E,m.offset),h=Math.max(h,m.offset+m.length),h+=m.content.length-m.length}const f=b.length-(v.length-h)-E;return[{offset:E,length:f,content:v.substring(E,h)}]}e.withFormatting=A;function P(b,n){return b.substring(0,n.offset)+n.content+b.substring(n.offset+n.length)}e.applyEdit=P;function w(b,n){let I=n.slice(0).sort((E,h)=>{const S=E.offset-h.offset;return S===0?E.length-h.length:S}),v=b.length;for(let E=I.length-1;E>=0;E--){let h=I[E];if(h.offset+h.length<=v)b=P(b,h);else throw new Error("Overlapping edit");v=h.offset}return b}e.applyEdits=w}),define(te[2],ne([0,1,68,56]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let k=null;function A(i){k=i}if(e.setDisposableTracker=A,D){const i="__is_disposable_tracked__";A(new class{trackDisposable(o){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[i]||console.log(l)},3e3)}setParent(o,l){if(o&&o!==m.None)try{o[i]=!0}catch{}}markAsDisposed(o){if(o&&o!==m.None)try{o[i]=!0}catch{}}markAsSingleton(o){}})}function P(i){return k?.trackDisposable(i),i}function w(i){k?.markAsDisposed(i)}function b(i,o){k?.setParent(i,o)}function n(i,o){if(!!k)for(const l of i)k.setParent(l,o)}function I(i){return k?.markAsSingleton(i),i}e.markAsSingleton=I;class v extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=v;function E(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=E;function h(i){if(L.Iterable.is(i)){let o=[];for(const l of i)if(l)try{l.dispose()}catch(u){o.push(u)}if(o.length===1)throw o[0];if(o.length>1)throw new v(o);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=h;function S(...i){const o=f(()=>h(i));return n(i,o),o}e.combinedDisposable=S;function f(i){const o=P({dispose:(0,R.once)(()=>{w(o),i()})});return o}e.toDisposable=f;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return b(o,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new p,P(this),b(this._store,this)}dispose(){w(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class y{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&b(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&b(o,null),o}}e.MutableDisposable=y;class c{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class a{constructor(){this.references=new Map}acquire(o,...l){let u=this.references.get(o);u||(u={counter:0,object:this.createReferencedObject(o,...l)},this.references.set(o,u));const{object:d}=u,g=(0,R.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(o,u.object),this.references.delete(o))});return u.counter++,{object:d,dispose:g}}}e.ReferenceCollection=a;class t{constructor(o){this.referenceCollection=o}async acquire(o,...l){const u=this.referenceCollection.acquire(o,...l);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(d){throw u.dispose(),d}}}e.AsyncReferenceCollection=t;class s{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=s;function r(i){const o=new p;try{i(o)}finally{o.dispose()}}e.disposeOnReturn=r}),define(te[100],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(k){this.element=k,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class L{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let k=this._first;for(;k!==R.Undefined;){const A=k.next;k.prev=R.Undefined,k.next=R.Undefined,k=A}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,A){const P=new R(k);if(this._first===R.Undefined)this._first=P,this._last=P;else if(A){const b=this._last;this._last=P,P.prev=b,b.next=P}else{const b=this._first;this._first=P,P.next=b,b.prev=P}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(P))}}shift(){if(this._first!==R.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==R.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==R.Undefined&&k.next!==R.Undefined){const A=k.prev;A.next=k.next,k.next.prev=A}else k.prev===R.Undefined&&k.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):k.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):k.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==R.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(){function J(D){const k=[];typeof D=="number"&&k.push("code/timeOrigin",D);function A(w){k.push(w,Date.now())}function P(){const w=[];for(let b=0;b<k.length;b+=2)w.push({name:k[b],startTime:k[b+1]});return w}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const A of performance.getEntriesByType("mark"))k.push({name:A.name,startTime:Math.round(D+A.startTime)});return k}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function R(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=R(L))}(),define(te[4],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const R="en";let L=!1,D=!1,k=!1,A=!1,P=!1,w=!1,b=!1,n,I=R,v,E;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const S=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=S&&h?.sandboxed,typeof navigator=="object"&&!S)E=navigator.userAgent,L=E.indexOf("Windows")>=0,D=E.indexOf("Macintosh")>=0,b=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=E.indexOf("Linux")>=0,w=!0,n=navigator.language,I=n;else if(typeof h=="object"){L=h.platform==="win32",D=h.platform==="darwin",k=h.platform==="linux",A=k&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,n=R,I=R;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const i=JSON.parse(r),o=i.availableLanguages["*"];n=i.locale,I=o||R,v=i._translationsConfigFile}catch(i){}P=!0}else console.error("Unable to resolve platform.");var f;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function p(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let m=0;D?m=1:L?m=3:k&&(m=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=k,e.isLinuxSnap=A,e.isNative=P,e.isWeb=w,e.isIOS=b,e.platform=m,e.userAgent=E,e.language=I;var y;(function(r){function i(){return e.language}r.value=i;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=o;function l(){return e.language==="en"}r.isDefault=l})(y=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=v,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let d=0,g=o.length;d<g;d++){const T=o[d];if(T.id===u.data.vscodeSetImmediateId){o.splice(d,1),T.callback();return}}});let l=0;return u=>{const d=++l;o.push({id:d,callback:u}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const i=Promise.resolve();return o=>i.then(o)}();var c;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||b?2:L?1:3;let a=!0,t=!1;function s(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,a=new Uint16Array(r.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=s}),define(te[31],ne([0,1,4]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.process!="undefined"){const D=R.globals.vscode.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(k){return(0,R.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:L={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,R.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(te[9],ne([0,1,31]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,k=90,A=122,P=46,w=47,b=92,n=58,I=63;class v extends Error{constructor(c,a,t){let s;typeof a=="string"&&a.indexOf("not ")===0?(s="must not be",a=a.replace(/^not /,"")):s="must be";const r=c.indexOf(".")!==-1?"property":"argument";let i=`The "${c}" ${r} ${s} of type ${a}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function E(y,c){if(typeof y!="string")throw new v(c,"string",y)}function h(y){return y===w||y===b}function S(y){return y===w}function f(y){return y>=L&&y<=k||y>=D&&y<=A}function p(y,c,a,t){let s="",r=0,i=-1,o=0,l=0;for(let u=0;u<=y.length;++u){if(u<y.length)l=y.charCodeAt(u);else{if(t(l))break;l=w}if(t(l)){if(!(i===u-1||o===1))if(o===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const d=s.lastIndexOf(a);d===-1?(s="",r=0):(s=s.slice(0,d),r=s.length-1-s.lastIndexOf(a)),i=u,o=0;continue}else if(s.length!==0){s="",r=0,i=u,o=0;continue}}c&&(s+=s.length>0?`${a}..`:"..",r=2)}else s.length>0?s+=`${a}${y.slice(i+1,u)}`:s=y.slice(i+1,u),r=u-i-1;i=u,o=0}else l===P&&o!==-1?++o:o=-1}return s}function m(y,c){if(c===null||typeof c!="object")throw new v("pathObject","Object",c);const a=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return a?a===c.root?`${a}${t}`:`${a}${y}${t}`:t}e.win32={resolve(...y){let c="",a="",t=!1;for(let s=y.length-1;s>=-1;s--){let r;if(s>=0){if(r=y[s],E(r,"path"),r.length===0)continue}else c.length===0?r=R.cwd():(r=R.env[`=${c}`]||R.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==c.toLowerCase()&&r.charCodeAt(2)===b)&&(r=`${c}\\`));const i=r.length;let o=0,l="",u=!1;const d=r.charCodeAt(0);if(i===1)h(d)&&(o=1,u=!0);else if(h(d))if(u=!0,h(r.charCodeAt(1))){let g=2,T=g;for(;g<i&&!h(r.charCodeAt(g));)g++;if(g<i&&g!==T){const _=r.slice(T,g);for(T=g;g<i&&h(r.charCodeAt(g));)g++;if(g<i&&g!==T){for(T=g;g<i&&!h(r.charCodeAt(g));)g++;(g===i||g!==T)&&(l=`\\\\${_}\\${r.slice(T,g)}`,o=g)}}}else o=1;else f(d)&&r.charCodeAt(1)===n&&(l=r.slice(0,2),o=2,i>2&&h(r.charCodeAt(2))&&(u=!0,o=3));if(l.length>0)if(c.length>0){if(l.toLowerCase()!==c.toLowerCase())continue}else c=l;if(t){if(c.length>0)break}else if(a=`${r.slice(o)}\\${a}`,t=u,u&&c.length>0)break}return a=p(a,!t,"\\",h),t?`${c}\\${a}`:`${c}${a}`||"."},normalize(y){E(y,"path");const c=y.length;if(c===0)return".";let a=0,t,s=!1;const r=y.charCodeAt(0);if(c===1)return S(r)?"\\":y;if(h(r))if(s=!0,h(y.charCodeAt(1))){let o=2,l=o;for(;o<c&&!h(y.charCodeAt(o));)o++;if(o<c&&o!==l){const u=y.slice(l,o);for(l=o;o<c&&h(y.charCodeAt(o));)o++;if(o<c&&o!==l){for(l=o;o<c&&!h(y.charCodeAt(o));)o++;if(o===c)return`\\\\${u}\\${y.slice(l)}\\`;o!==l&&(t=`\\\\${u}\\${y.slice(l,o)}`,a=o)}}}else a=1;else f(r)&&y.charCodeAt(1)===n&&(t=y.slice(0,2),a=2,c>2&&h(y.charCodeAt(2))&&(s=!0,a=3));let i=a<c?p(y.slice(a),!s,"\\",h):"";return i.length===0&&!s&&(i="."),i.length>0&&h(y.charCodeAt(c-1))&&(i+="\\"),t===void 0?s?`\\${i}`:i:s?`${t}\\${i}`:`${t}${i}`},isAbsolute(y){E(y,"path");const c=y.length;if(c===0)return!1;const a=y.charCodeAt(0);return h(a)||c>2&&f(a)&&y.charCodeAt(1)===n&&h(y.charCodeAt(2))},join(...y){if(y.length===0)return".";let c,a;for(let r=0;r<y.length;++r){const i=y[r];E(i,"path"),i.length>0&&(c===void 0?c=a=i:c+=`\\${i}`)}if(c===void 0)return".";let t=!0,s=0;if(typeof a=="string"&&h(a.charCodeAt(0))){++s;const r=a.length;r>1&&h(a.charCodeAt(1))&&(++s,r>2&&(h(a.charCodeAt(2))?++s:t=!1))}if(t){for(;s<c.length&&h(c.charCodeAt(s));)s++;s>=2&&(c=`\\${c.slice(s)}`)}return e.win32.normalize(c)},relative(y,c){if(E(y,"from"),E(c,"to"),y===c)return"";const a=e.win32.resolve(y),t=e.win32.resolve(c);if(a===t||(y=a.toLowerCase(),c=t.toLowerCase(),y===c))return"";let s=0;for(;s<y.length&&y.charCodeAt(s)===b;)s++;let r=y.length;for(;r-1>s&&y.charCodeAt(r-1)===b;)r--;const i=r-s;let o=0;for(;o<c.length&&c.charCodeAt(o)===b;)o++;let l=c.length;for(;l-1>o&&c.charCodeAt(l-1)===b;)l--;const u=l-o,d=i<u?i:u;let g=-1,T=0;for(;T<d;T++){const O=y.charCodeAt(s+T);if(O!==c.charCodeAt(o+T))break;O===b&&(g=T)}if(T!==d){if(g===-1)return t}else{if(u>d){if(c.charCodeAt(o+T)===b)return t.slice(o+T+1);if(T===2)return t.slice(o+T)}i>d&&(y.charCodeAt(s+T)===b?g=T:T===2&&(g=3)),g===-1&&(g=0)}let _="";for(T=s+g+1;T<=r;++T)(T===r||y.charCodeAt(T)===b)&&(_+=_.length===0?"..":"\\..");return o+=g,_.length>0?`${_}${t.slice(o,l)}`:(t.charCodeAt(o)===b&&++o,t.slice(o,l))},toNamespacedPath(y){if(typeof y!="string")return y;if(y.length===0)return"";const c=e.win32.resolve(y);if(c.length<=2)return y;if(c.charCodeAt(0)===b){if(c.charCodeAt(1)===b){const a=c.charCodeAt(2);if(a!==I&&a!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(f(c.charCodeAt(0))&&c.charCodeAt(1)===n&&c.charCodeAt(2)===b)return`\\\\?\\${c}`;return y},dirname(y){E(y,"path");const c=y.length;if(c===0)return".";let a=-1,t=0;const s=y.charCodeAt(0);if(c===1)return h(s)?y:".";if(h(s)){if(a=t=1,h(y.charCodeAt(1))){let o=2,l=o;for(;o<c&&!h(y.charCodeAt(o));)o++;if(o<c&&o!==l){for(l=o;o<c&&h(y.charCodeAt(o));)o++;if(o<c&&o!==l){for(l=o;o<c&&!h(y.charCodeAt(o));)o++;if(o===c)return y;o!==l&&(a=t=o+1)}}}}else f(s)&&y.charCodeAt(1)===n&&(a=c>2&&h(y.charCodeAt(2))?3:2,t=a);let r=-1,i=!0;for(let o=c-1;o>=t;--o)if(h(y.charCodeAt(o))){if(!i){r=o;break}}else i=!1;if(r===-1){if(a===-1)return".";r=a}return y.slice(0,r)},basename(y,c){c!==void 0&&E(c,"ext"),E(y,"path");let a=0,t=-1,s=!0,r;if(y.length>=2&&f(y.charCodeAt(0))&&y.charCodeAt(1)===n&&(a=2),c!==void 0&&c.length>0&&c.length<=y.length){if(c===y)return"";let i=c.length-1,o=-1;for(r=y.length-1;r>=a;--r){const l=y.charCodeAt(r);if(h(l)){if(!s){a=r+1;break}}else o===-1&&(s=!1,o=r+1),i>=0&&(l===c.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=o))}return a===t?t=o:t===-1&&(t=y.length),y.slice(a,t)}for(r=y.length-1;r>=a;--r)if(h(y.charCodeAt(r))){if(!s){a=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":y.slice(a,t)},extname(y){E(y,"path");let c=0,a=-1,t=0,s=-1,r=!0,i=0;y.length>=2&&y.charCodeAt(1)===n&&f(y.charCodeAt(0))&&(c=t=2);for(let o=y.length-1;o>=c;--o){const l=y.charCodeAt(o);if(h(l)){if(!r){t=o+1;break}continue}s===-1&&(r=!1,s=o+1),l===P?a===-1?a=o:i!==1&&(i=1):a!==-1&&(i=-1)}return a===-1||s===-1||i===0||i===1&&a===s-1&&a===t+1?"":y.slice(a,s)},format:m.bind(null,"\\"),parse(y){E(y,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return c;const a=y.length;let t=0,s=y.charCodeAt(0);if(a===1)return h(s)?(c.root=c.dir=y,c):(c.base=c.name=y,c);if(h(s)){if(t=1,h(y.charCodeAt(1))){let g=2,T=g;for(;g<a&&!h(y.charCodeAt(g));)g++;if(g<a&&g!==T){for(T=g;g<a&&h(y.charCodeAt(g));)g++;if(g<a&&g!==T){for(T=g;g<a&&!h(y.charCodeAt(g));)g++;g===a?t=g:g!==T&&(t=g+1)}}}}else if(f(s)&&y.charCodeAt(1)===n){if(a<=2)return c.root=c.dir=y,c;if(t=2,h(y.charCodeAt(2))){if(a===3)return c.root=c.dir=y,c;t=3}}t>0&&(c.root=y.slice(0,t));let r=-1,i=t,o=-1,l=!0,u=y.length-1,d=0;for(;u>=t;--u){if(s=y.charCodeAt(u),h(s)){if(!l){i=u+1;break}continue}o===-1&&(l=!1,o=u+1),s===P?r===-1?r=u:d!==1&&(d=1):r!==-1&&(d=-1)}return o!==-1&&(r===-1||d===0||d===1&&r===o-1&&r===i+1?c.base=c.name=y.slice(i,o):(c.name=y.slice(i,r),c.base=y.slice(i,o),c.ext=y.slice(r,o))),i>0&&i!==t?c.dir=y.slice(0,i-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...y){let c="",a=!1;for(let t=y.length-1;t>=-1&&!a;t--){const s=t>=0?y[t]:R.cwd();E(s,"path"),s.length!==0&&(c=`${s}/${c}`,a=s.charCodeAt(0)===w)}return c=p(c,!a,"/",S),a?`/${c}`:c.length>0?c:"."},normalize(y){if(E(y,"path"),y.length===0)return".";const c=y.charCodeAt(0)===w,a=y.charCodeAt(y.length-1)===w;return y=p(y,!c,"/",S),y.length===0?c?"/":a?"./":".":(a&&(y+="/"),c?`/${y}`:y)},isAbsolute(y){return E(y,"path"),y.length>0&&y.charCodeAt(0)===w},join(...y){if(y.length===0)return".";let c;for(let a=0;a<y.length;++a){const t=y[a];E(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(y,c){if(E(y,"from"),E(c,"to"),y===c||(y=e.posix.resolve(y),c=e.posix.resolve(c),y===c))return"";const a=1,t=y.length,s=t-a,r=1,i=c.length-r,o=s<i?s:i;let l=-1,u=0;for(;u<o;u++){const g=y.charCodeAt(a+u);if(g!==c.charCodeAt(r+u))break;g===w&&(l=u)}if(u===o)if(i>o){if(c.charCodeAt(r+u)===w)return c.slice(r+u+1);if(u===0)return c.slice(r+u)}else s>o&&(y.charCodeAt(a+u)===w?l=u:u===0&&(l=0));let d="";for(u=a+l+1;u<=t;++u)(u===t||y.charCodeAt(u)===w)&&(d+=d.length===0?"..":"/..");return`${d}${c.slice(r+l)}`},toNamespacedPath(y){return y},dirname(y){if(E(y,"path"),y.length===0)return".";const c=y.charCodeAt(0)===w;let a=-1,t=!0;for(let s=y.length-1;s>=1;--s)if(y.charCodeAt(s)===w){if(!t){a=s;break}}else t=!1;return a===-1?c?"/":".":c&&a===1?"//":y.slice(0,a)},basename(y,c){c!==void 0&&E(c,"ext"),E(y,"path");let a=0,t=-1,s=!0,r;if(c!==void 0&&c.length>0&&c.length<=y.length){if(c===y)return"";let i=c.length-1,o=-1;for(r=y.length-1;r>=0;--r){const l=y.charCodeAt(r);if(l===w){if(!s){a=r+1;break}}else o===-1&&(s=!1,o=r+1),i>=0&&(l===c.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=o))}return a===t?t=o:t===-1&&(t=y.length),y.slice(a,t)}for(r=y.length-1;r>=0;--r)if(y.charCodeAt(r)===w){if(!s){a=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":y.slice(a,t)},extname(y){E(y,"path");let c=-1,a=0,t=-1,s=!0,r=0;for(let i=y.length-1;i>=0;--i){const o=y.charCodeAt(i);if(o===w){if(!s){a=i+1;break}continue}t===-1&&(s=!1,t=i+1),o===P?c===-1?c=i:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||t===-1||r===0||r===1&&c===t-1&&c===a+1?"":y.slice(c,t)},format:m.bind(null,"/"),parse(y){E(y,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return c;const a=y.charCodeAt(0)===w;let t;a?(c.root="/",t=1):t=0;let s=-1,r=0,i=-1,o=!0,l=y.length-1,u=0;for(;l>=t;--l){const d=y.charCodeAt(l);if(d===w){if(!o){r=l+1;break}continue}i===-1&&(o=!1,i=l+1),d===P?s===-1?s=l:u!==1&&(u=1):s!==-1&&(u=-1)}if(i!==-1){const d=r===0&&a?1:r;s===-1||u===0||u===1&&s===i-1&&s===r+1?c.base=c.name=y.slice(d,i):(c.name=y.slice(d,s),c.base=y.slice(d,i),c.ext=y.slice(s,i))}return r>0?c.dir=y.slice(0,r-1):a&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[101],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var L;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(k,...A){const P=A.reduce((n,I)=>(n[I]=!0,n),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(n=>!P[n]).forEach(n=>{for(let I=0;I<w.length;I++)if(n.search(w[I])!==-1){delete k[n];break}})}e.sanitizeProcessEnvironment=D}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var L in R)(typeof exports=="object"?exports:J)[L]=R[L]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function R(L){if(e[L])return e[L].exports;var D=e[L]={i:L,l:!1,exports:{}};return J[L].call(D.exports,D,D.exports,R),D.l=!0,D.exports}return R.m=J,R.c=e,R.d=function(L,D,k){R.o(L,D)||Object.defineProperty(L,D,{enumerable:!0,get:k})},R.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},R.t=function(L,D){if(1&D&&(L=R(L)),8&D||4&D&&typeof L=="object"&&L&&L.__esModule)return L;var k=Object.create(null);if(R.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:L}),2&D&&typeof L!="string")for(var A in L)R.d(k,A,function(P){return L[P]}.bind(null,A));return k},R.n=function(L){var D=L&&L.__esModule?function(){return L.default}:function(){return L};return R.d(D,"a",D),D},R.o=function(L,D){return Object.prototype.hasOwnProperty.call(L,D)},R.p="",R(R.s=0)}([function(J,e,R){(function(L){var D;e=J.exports=Z,D=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],w=e.src=[],b=0,n=b++;w[n]="0|[1-9]\\d*";var I=b++;w[I]="[0-9]+";var v=b++;w[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=b++;w[E]="("+w[n]+")\\.("+w[n]+")\\.("+w[n]+")";var h=b++;w[h]="("+w[I]+")\\.("+w[I]+")\\.("+w[I]+")";var S=b++;w[S]="(?:"+w[n]+"|"+w[v]+")";var f=b++;w[f]="(?:"+w[I]+"|"+w[v]+")";var p=b++;w[p]="(?:-("+w[S]+"(?:\\."+w[S]+")*))";var m=b++;w[m]="(?:-?("+w[f]+"(?:\\."+w[f]+")*))";var y=b++;w[y]="[0-9A-Za-z-]+";var c=b++;w[c]="(?:\\+("+w[y]+"(?:\\."+w[y]+")*))";var a=b++,t="v?"+w[E]+w[p]+"?"+w[c]+"?";w[a]="^"+t+"$";var s="[v=\\s]*"+w[h]+w[m]+"?"+w[c]+"?",r=b++;w[r]="^"+s+"$";var i=b++;w[i]="((?:<|>)?=?)";var o=b++;w[o]=w[I]+"|x|X|\\*";var l=b++;w[l]=w[n]+"|x|X|\\*";var u=b++;w[u]="[v=\\s]*("+w[l]+")(?:\\.("+w[l]+")(?:\\.("+w[l]+")(?:"+w[p]+")?"+w[c]+"?)?)?";var d=b++;w[d]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[m]+")?"+w[c]+"?)?)?";var g=b++;w[g]="^"+w[i]+"\\s*"+w[u]+"$";var T=b++;w[T]="^"+w[i]+"\\s*"+w[d]+"$";var _=b++;w[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=b++;w[O]="(?:~>?)";var F=b++;w[F]="(\\s*)"+w[O]+"\\s+",P[F]=new RegExp(w[F],"g");var C=b++;w[C]="^"+w[O]+w[u]+"$";var N=b++;w[N]="^"+w[O]+w[d]+"$";var z=b++;w[z]="(?:\\^)";var M=b++;w[M]="(\\s*)"+w[z]+"\\s+",P[M]=new RegExp(w[M],"g");var q=b++;w[q]="^"+w[z]+w[u]+"$";var W=b++;w[W]="^"+w[z]+w[d]+"$";var j=b++;w[j]="^"+w[i]+"\\s*("+s+")$|^$";var x=b++;w[x]="^"+w[i]+"\\s*("+t+")$|^$";var $=b++;w[$]="(\\s*)"+w[i]+"\\s*("+s+"|"+w[u]+")",P[$]=new RegExp(w[$],"g");var G=b++;w[G]="^\\s*("+w[u]+")\\s+-\\s+("+w[u]+")\\s*$";var U=b++;w[U]="^\\s*("+w[d]+")\\s+-\\s+("+w[d]+")\\s*$";var V=b++;w[V]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)D(B,w[B]),P[B]||(P[B]=new RegExp(w[B]));function Q(ee,ae){if(ee instanceof Z)return ee;if(typeof ee!="string"||ee.length>k||!(ae?P[r]:P[a]).test(ee))return null;try{return new Z(ee,ae)}catch(oe){return null}}function Z(ee,ae){if(ee instanceof Z){if(ee.loose===ae)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof Z))return new Z(ee,ae);D("SemVer",ee,ae),this.loose=ae;var oe=ee.trim().match(ae?P[r]:P[a]);if(!oe)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+oe[1],this.minor=+oe[2],this.patch=+oe[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");oe[4]?this.prerelease=oe[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var Se=+pe;if(Se>=0&&Se<A)return Se}return pe}):this.prerelease=[],this.build=oe[5]?oe[5].split("."):[],this.format()}e.parse=Q,e.valid=function(ee,ae){var oe=Q(ee,ae);return oe?oe.version:null},e.clean=function(ee,ae){var oe=Q(ee.trim().replace(/^[=v]+/,""),ae);return oe?oe.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ee){return D("SemVer.compare",this.version,this.loose,ee),ee instanceof Z||(ee=new Z(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},Z.prototype.compareMain=function(ee){return ee instanceof Z||(ee=new Z(ee,this.loose)),H(this.major,ee.major)||H(this.minor,ee.minor)||H(this.patch,ee.patch)},Z.prototype.comparePre=function(ee){if(ee instanceof Z||(ee=new Z(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ae=0;do{var oe=this.prerelease[ae],pe=ee.prerelease[ae];if(D("prerelease compare",ae,oe,pe),oe===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(oe===void 0)return-1;if(oe!==pe)return H(oe,pe)}while(++ae)},Z.prototype.inc=function(ee,ae){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var oe=this.prerelease.length;--oe>=0;)typeof this.prerelease[oe]=="number"&&(this.prerelease[oe]++,oe=-2);oe===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ae,oe,pe){typeof oe=="string"&&(pe=oe,oe=void 0);try{return new Z(ee,oe).inc(ae,pe).version}catch(Se){return null}},e.diff=function(ee,ae){if(le(ee,ae))return null;var oe=Q(ee),pe=Q(ae);if(oe.prerelease.length||pe.prerelease.length){for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==pe[Se])return"pre"+Se;return"prerelease"}for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==pe[Se])return Se},e.compareIdentifiers=H;var K=/^[0-9]+$/;function H(ee,ae){var oe=K.test(ee),pe=K.test(ae);return oe&&pe&&(ee=+ee,ae=+ae),oe&&!pe?-1:pe&&!oe?1:ee<ae?-1:ee>ae?1:0}function re(ee,ae,oe){return new Z(ee,oe).compare(new Z(ae,oe))}function ie(ee,ae,oe){return re(ee,ae,oe)>0}function ce(ee,ae,oe){return re(ee,ae,oe)<0}function le(ee,ae,oe){return re(ee,ae,oe)===0}function de(ee,ae,oe){return re(ee,ae,oe)!==0}function fe(ee,ae,oe){return re(ee,ae,oe)>=0}function be(ee,ae,oe){return re(ee,ae,oe)<=0}function Ce(ee,ae,oe,pe){var Se;switch(ae){case"===":typeof ee=="object"&&(ee=ee.version),typeof oe=="object"&&(oe=oe.version),Se=ee===oe;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof oe=="object"&&(oe=oe.version),Se=ee!==oe;break;case"":case"=":case"==":Se=le(ee,oe,pe);break;case"!=":Se=de(ee,oe,pe);break;case">":Se=ie(ee,oe,pe);break;case">=":Se=fe(ee,oe,pe);break;case"<":Se=ce(ee,oe,pe);break;case"<=":Se=be(ee,oe,pe);break;default:throw new TypeError("Invalid operator: "+ae)}return Se}function Ee(ee,ae){if(ee instanceof Ee){if(ee.loose===ae)return ee;ee=ee.value}if(!(this instanceof Ee))return new Ee(ee,ae);D("comparator",ee,ae),this.loose=ae,this.parse(ee),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ee,ae){return H(ae,ee)},e.major=function(ee,ae){return new Z(ee,ae).major},e.minor=function(ee,ae){return new Z(ee,ae).minor},e.patch=function(ee,ae){return new Z(ee,ae).patch},e.compare=re,e.compareLoose=function(ee,ae){return re(ee,ae,!0)},e.rcompare=function(ee,ae,oe){return re(ae,ee,oe)},e.sort=function(ee,ae){return ee.sort(function(oe,pe){return e.compare(oe,pe,ae)})},e.rsort=function(ee,ae){return ee.sort(function(oe,pe){return e.rcompare(oe,pe,ae)})},e.gt=ie,e.lt=ce,e.eq=le,e.neq=de,e.gte=fe,e.lte=be,e.cmp=Ce,e.Comparator=Ee;var Ae={};function Pe(ee,ae){if(ee instanceof Pe)return ee.loose===ae?ee:new Pe(ee.raw,ae);if(ee instanceof Ee)return new Pe(ee.value,ae);if(!(this instanceof Pe))return new Pe(ee,ae);if(this.loose=ae,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(oe){return this.parseRange(oe.trim())},this).filter(function(oe){return oe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Le(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Ne(ee,ae,oe,pe,Se,_e,Re,Y,se,ue,ge,me,Ie){return((ae=Le(oe)?"":Le(pe)?">="+oe+".0.0":Le(Se)?">="+oe+"."+pe+".0":">="+ae)+" "+(Y=Le(se)?"":Le(ue)?"<"+(+se+1)+".0.0":Le(ge)?"<"+se+"."+(+ue+1)+".0":me?"<="+se+"."+ue+"."+ge+"-"+me:"<="+Y)).trim()}function Fe(ee,ae){for(var oe=0;oe<ee.length;oe++)if(!ee[oe].test(ae))return!1;if(ae.prerelease.length){for(oe=0;oe<ee.length;oe++)if(D(ee[oe].semver),ee[oe].semver!==Ae&&ee[oe].semver.prerelease.length>0){var pe=ee[oe].semver;if(pe.major===ae.major&&pe.minor===ae.minor&&pe.patch===ae.patch)return!0}return!1}return!0}function $e(ee,ae,oe){try{ae=new Pe(ae,oe)}catch(pe){return!1}return ae.test(ee)}function xe(ee,ae,oe,pe){var Se,_e,Re,Y,se;switch(ee=new Z(ee,pe),ae=new Pe(ae,pe),oe){case">":Se=ie,_e=be,Re=ce,Y=">",se=">=";break;case"<":Se=ce,_e=fe,Re=ie,Y="<",se="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(ee,ae,pe))return!1;for(var ue=0;ue<ae.set.length;++ue){var ge=ae.set[ue],me=null,Ie=null;if(ge.forEach(function(ke){ke.semver===Ae&&(ke=new Ee(">=0.0.0")),me=me||ke,Ie=Ie||ke,Se(ke.semver,me.semver,pe)?me=ke:Re(ke.semver,Ie.semver,pe)&&(Ie=ke)}),me.operator===Y||me.operator===se||(!Ie.operator||Ie.operator===Y)&&_e(ee,Ie.semver)||Ie.operator===se&&Re(ee,Ie.semver))return!1}return!0}Ee.prototype.parse=function(ee){var ae=this.loose?P[j]:P[x],oe=ee.match(ae);if(!oe)throw new TypeError("Invalid comparator: "+ee);this.operator=oe[1],this.operator==="="&&(this.operator=""),oe[2]?this.semver=new Z(oe[2],this.loose):this.semver=Ae},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(ee){return D("Comparator.test",ee,this.loose),this.semver===Ae||(typeof ee=="string"&&(ee=new Z(ee,this.loose)),Ce(ee,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(ee,ae){if(!(ee instanceof Ee))throw new TypeError("a Comparator is required");var oe;if(this.operator==="")return oe=new Pe(ee.value,ae),$e(this.value,oe,ae);if(ee.operator==="")return oe=new Pe(this.value,ae),$e(ee.semver,oe,ae);var pe=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),_e=this.semver.version===ee.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Y=Ce(this.semver,"<",ee.semver,ae)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),se=Ce(this.semver,">",ee.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return pe||Se||_e&&Re||Y||se},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(ee){var ae=this.loose;ee=ee.trim(),D("range",ee,ae);var oe=ae?P[U]:P[G];ee=ee.replace(oe,Ne),D("hyphen replace",ee),ee=ee.replace(P[$],"$1$2$3"),D("comparator trim",ee,P[$]),ee=(ee=(ee=ee.replace(P[F],"$1~")).replace(P[M],"$1^")).split(/\s+/).join(" ");var pe=ae?P[j]:P[x],Se=ee.split(" ").map(function(_e){return function(Re,Y){return D("comp",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(ge){return function(me,Ie){D("caret",me,Ie);var ke=Ie?P[W]:P[q];return me.replace(ke,function(Te,ye,we,De,Oe){var Ue;return D("caret",me,Te,ye,we,De,Oe),Le(ye)?Ue="":Le(we)?Ue=">="+ye+".0.0 <"+(+ye+1)+".0.0":Le(De)?Ue=ye==="0"?">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+".0 <"+(+ye+1)+".0.0":Oe?(D("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ue=ye==="0"?we==="0"?">="+ye+"."+we+"."+De+Oe+" <"+ye+"."+we+"."+(+De+1):">="+ye+"."+we+"."+De+Oe+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+De+Oe+" <"+(+ye+1)+".0.0"):(D("no pr"),Ue=ye==="0"?we==="0"?">="+ye+"."+we+"."+De+" <"+ye+"."+we+"."+(+De+1):">="+ye+"."+we+"."+De+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+De+" <"+(+ye+1)+".0.0"),D("caret return",Ue),Ue})}(ge,ue)}).join(" ")}(Re,Y),D("caret",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(ge){return function(me,Ie){var ke=Ie?P[N]:P[C];return me.replace(ke,function(Te,ye,we,De,Oe){var Ue;return D("tilde",me,Te,ye,we,De,Oe),Le(ye)?Ue="":Le(we)?Ue=">="+ye+".0.0 <"+(+ye+1)+".0.0":Le(De)?Ue=">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":Oe?(D("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ue=">="+ye+"."+we+"."+De+Oe+" <"+ye+"."+(+we+1)+".0"):Ue=">="+ye+"."+we+"."+De+" <"+ye+"."+(+we+1)+".0",D("tilde return",Ue),Ue})}(ge,ue)}).join(" ")}(Re,Y),D("tildes",Re),Re=function(se,ue){return D("replaceXRanges",se,ue),se.split(/\s+/).map(function(ge){return function(me,Ie){me=me.trim();var ke=Ie?P[T]:P[g];return me.replace(ke,function(Te,ye,we,De,Oe,Ue){D("xRange",me,Te,ye,we,De,Oe,Ue);var Qe=Le(we),Ke=Qe||Le(De),We=Ke||Le(Oe);return ye==="="&&We&&(ye=""),Qe?Te=ye===">"||ye==="<"?"<0.0.0":"*":ye&&We?(Ke&&(De=0),We&&(Oe=0),ye===">"?(ye=">=",Ke?(we=+we+1,De=0,Oe=0):We&&(De=+De+1,Oe=0)):ye==="<="&&(ye="<",Ke?we=+we+1:De=+De+1),Te=ye+we+"."+De+"."+Oe):Ke?Te=">="+we+".0.0 <"+(+we+1)+".0.0":We&&(Te=">="+we+"."+De+".0 <"+we+"."+(+De+1)+".0"),D("xRange return",Te),Te})}(ge,ue)}).join(" ")}(Re,Y),D("xrange",Re),Re=function(se,ue){return D("replaceStars",se,ue),se.trim().replace(P[V],"")}(Re,Y),D("stars",Re),Re}(_e,ae)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(_e){return!!_e.match(pe)})),Se=Se.map(function(_e){return new Ee(_e,ae)})},Pe.prototype.intersects=function(ee,ae){if(!(ee instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(oe){return oe.every(function(pe){return ee.set.some(function(Se){return Se.every(function(_e){return pe.intersects(_e,ae)})})})})},e.toComparators=function(ee,ae){return new Pe(ee,ae).set.map(function(oe){return oe.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new Z(ee,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Fe(this.set[ae],ee))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(ee,ae,oe){var pe=null,Se=null;try{var _e=new Pe(ae,oe)}catch(Re){return null}return ee.forEach(function(Re){_e.test(Re)&&(pe&&Se.compare(Re)!==-1||(Se=new Z(pe=Re,oe)))}),pe},e.minSatisfying=function(ee,ae,oe){var pe=null,Se=null;try{var _e=new Pe(ae,oe)}catch(Re){return null}return ee.forEach(function(Re){_e.test(Re)&&(pe&&Se.compare(Re)!==1||(Se=new Z(pe=Re,oe)))}),pe},e.validRange=function(ee,ae){try{return new Pe(ee,ae).range||"*"}catch(oe){return null}},e.ltr=function(ee,ae,oe){return xe(ee,ae,"<",oe)},e.gtr=function(ee,ae,oe){return xe(ee,ae,">",oe)},e.outside=xe,e.prerelease=function(ee,ae){var oe=Q(ee,ae);return oe&&oe.prerelease.length?oe.prerelease:null},e.intersects=function(ee,ae,oe){return ee=new Pe(ee,oe),ae=new Pe(ae,oe),ee.intersects(ae)},e.coerce=function(ee){if(ee instanceof Z)return ee;if(typeof ee!="string")return null;var ae=ee.match(P[_]);return ae==null?null:Q((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,R(1))},function(J,e){var R,L,D=J.exports={};function k(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(f){if(R===setTimeout)return setTimeout(f,0);if((R===k||!R)&&setTimeout)return R=setTimeout,setTimeout(f,0);try{return R(f,0)}catch(p){try{return R.call(null,f,0)}catch(m){return R.call(this,f,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:k}catch(f){R=k}try{L=typeof clearTimeout=="function"?clearTimeout:A}catch(f){L=A}})();var w,b=[],n=!1,I=-1;function v(){n&&w&&(n=!1,w.length?b=w.concat(b):I=-1,b.length&&E())}function E(){if(!n){var f=P(v);n=!0;for(var p=b.length;p;){for(w=b,b=[];++I<p;)w&&w[I].run();I=-1,p=b.length}w=null,n=!1,function(m){if(L===clearTimeout)return clearTimeout(m);if((L===A||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(m);try{L(m)}catch(y){try{return L.call(null,m)}catch(c){return L.call(this,m)}}}(f)}}function h(f,p){this.fun=f,this.array=p}function S(){}D.nextTick=function(f){var p=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)p[m-1]=arguments[m];b.push(new h(f,p)),b.length!==1||n||P(E)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=S,D.addListener=S,D.once=S,D.off=S,D.removeListener=S,D.removeAllListeners=S,D.emit=S,D.prependListener=S,D.prependOnceListener=S,D.listeners=function(f){return[]},D.binding=function(f){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(f){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(te[102],ne([0,1,4]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=R.globals.performance&&typeof R.globals.performance.now=="function";class D{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new D(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=D}),define(te[3],ne([0,1,8,68,2,100,102]),function(J,e,R,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(c){c.None=()=>D.Disposable.None;function a(M){return(q,W=null,j)=>{let x=!1,$;return $=M(G=>{if(!x)return $?$.dispose():x=!0,q.call(W,G)},null,j),x&&$.dispose(),$}}c.once=a;function t(M,q){return u((W,j=null,x)=>M($=>W.call(j,q($)),null,x))}c.map=t;function s(M,q){return u((W,j=null,x)=>M($=>{q($),W.call(j,$)},null,x))}c.forEach=s;function r(M,q){return u((W,j=null,x)=>M($=>q($)&&W.call(j,$),null,x))}c.filter=r;function i(M){return M}c.signal=i;function o(...M){return(q,W=null,j)=>(0,D.combinedDisposable)(...M.map(x=>x($=>q.call(W,$),null,j)))}c.any=o;function l(M,q,W){let j=W;return t(M,x=>(j=q(j,x),j))}c.reduce=l;function u(M){let q;const W=new v({onFirstListenerAdd(){q=M(W.fire,W)},onLastListenerRemove(){q.dispose()}});return W.event}function d(M,q,W=100,j=!1,x){let $,G,U,V=0;const B=new v({leakWarningThreshold:x,onFirstListenerAdd(){$=M(Q=>{V++,G=q(G,Q),j&&!U&&(B.fire(G),G=void 0),clearTimeout(U),U=setTimeout(()=>{const Z=G;G=void 0,U=void 0,(!j||V>1)&&B.fire(Z),V=0},W)})},onLastListenerRemove(){$.dispose()}});return B.event}c.debounce=d;function g(M,q=(W,j)=>W===j){let W=!0,j;return r(M,x=>{const $=W||!q(x,j);return W=!1,j=x,$})}c.latch=g;function T(M,q){return[c.filter(M,q),c.filter(M,W=>!q(W))]}c.split=T;function _(M,q=!1,W=[]){let j=W.slice(),x=M(U=>{j?j.push(U):G.fire(U)});const $=()=>{j&&j.forEach(U=>G.fire(U)),j=null},G=new v({onFirstListenerAdd(){x||(x=M(U=>G.fire(U)))},onFirstListenerDidAdd(){j&&(q?setTimeout($):$())},onLastListenerRemove(){x&&x.dispose(),x=null}});return G.event}c.buffer=_;class O{constructor(q){this.event=q}map(q){return new O(t(this.event,q))}forEach(q){return new O(s(this.event,q))}filter(q){return new O(r(this.event,q))}reduce(q,W){return new O(l(this.event,q,W))}latch(){return new O(g(this.event))}debounce(q,W=100,j=!1,x){return new O(d(this.event,q,W,j,x))}on(q,W,j){return this.event(q,W,j)}once(q,W,j){return a(this.event)(q,W,j)}}function F(M){return new O(M)}c.chain=F;function C(M,q,W=j=>j){const j=(...U)=>G.fire(W(...U)),x=()=>M.on(q,j),$=()=>M.removeListener(q,j),G=new v({onFirstListenerAdd:x,onLastListenerRemove:$});return G.event}c.fromNodeEventEmitter=C;function N(M,q,W=j=>j){const j=(...U)=>G.fire(W(...U)),x=()=>M.addEventListener(q,j),$=()=>M.removeEventListener(q,j),G=new v({onFirstListenerAdd:x,onLastListenerRemove:$});return G.event}c.fromDOMEventEmitter=N;function z(M){return new Promise(q=>a(M)(q))}c.toPromise=z})(P=e.Event||(e.Event={}));class w{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${w._idPool++}`}start(a){this._stopWatch=new A.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let b=-1;function n(c){const a=b;return b=c,{dispose(){b=a}}}e.setGlobalLeakWarningThreshold=n;class I{constructor(a,t=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let t=b;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||a<t)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(s)||0;if(this._stacks.set(s,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let i,o=0;for(const[l,u]of this._stacks)(!i||o<u)&&(i=l,o=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${o}):`),console.warn(i)}return()=>{const i=this._stacks.get(s)||0;this._stacks.set(s,i-1)}}}class v{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=b>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(a,t,s)=>{this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(t?[a,t]:a);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,t);const o=this._leakageMon?.check(this._listeners.size),l=(0,D.toDisposable)(()=>{o&&o(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof D.DisposableStore?s.add(l):Array.isArray(s)&&s.push(l),l}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,s]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,s):t[0].call(t[1],s)}catch(r){(0,R.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=v;class E extends v{async fireAsync(a,t,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,a]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),o=[],l={...i,waitUntil:u=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");s&&(u=s(u,typeof r=="function"?r:r[0])),o.push(u)}};try{typeof r=="function"?r.call(void 0,l):r[0].call(r[1],l)}catch(u){(0,R.onUnexpectedError)(u);continue}Object.freeze(o),await Promise.allSettled(o).then(u=>{for(const d of u)d.status==="rejected"&&(0,R.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=E;class h extends v{constructor(a){super(a);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=h;class S extends h{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=S;class f extends v{constructor(a){super(a);this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=f;class p{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const t={event:a,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const s=()=>{this.hasListeners&&this.unhook(t);const r=this.events.indexOf(t);this.events.splice(r,1)};return(0,D.toDisposable)((0,L.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(t=>this.emitter.fire(t))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=p;class m{constructor(){this.buffers=[]}wrapEvent(a){return(t,s,r)=>a(i=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>t.call(s,i)):t.call(s,i)},void 0,r)}bufferEvents(a){const t=[];this.buffers.push(t);const s=a();return this.buffers.pop(),t.forEach(r=>r()),s}}e.EventBufferer=m;class y{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=D.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=y}),define(te[27],ne([0,1,3]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,w){const b=setTimeout(P.bind(w),0);return{dispose(){clearTimeout(b)}}});var D;(function(P){function w(b){return b===P.None||b===P.Cancelled||b instanceof k?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=w,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=D.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=A}),define(te[51],ne([0,1,3]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new R.Emitter}add(I){const v=this._icons.get(I.id);v?I.description?v.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function k(n,I){return new P(n,I)}e.registerCodicon=k;function A(n){return n?n.replace(/\$\((.*?)\)/g,(I,v)=>` ${v} `).trim():""}e.getCodiconAriaLabel=A;class P{constructor(I,v,E){this.id=I,this.definition=v,this.description=E,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function w(n,I){const v=["codicon","codicon-"+n];return I&&v.push("codicon-modifier-"+I),v}e.getClassNamesArray=w;var b;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function v(S){if(S instanceof P)return["codicon","codicon-"+S.id];const f=I.exec(S.id);if(!f)return v(P.error);let[,p,m]=f;const y=["codicon","codicon-"+p];return m&&y.push("codicon-modifier-"+m.substr(1)),y}n.asClassNameArray=v;function E(S){return v(S).join(" ")}n.asClassName=E;function h(S){return"."+v(S).join(".")}n.asCSSSelector=h})(b=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"})}(P=e.Codicon||(e.Codicon={}))}),define(te[52],ne([0,1,8,2]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(y){const c=y;return c?[c.on,c.pause,c.resume,c.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=D;function k(y){const c=y;return c?D(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=k;function A(y,c){return new P(y,c)}e.newWriteableStream=A;class P{constructor(c,a){this.reducer=c,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(a=>a(c))}emitError(c){this.listeners.error.length===0?(0,R.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(a=>a(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,a){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(c,a){if(this.state.destroyed)return;let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(a);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(y,c){const a=[];let t;for(;(t=y.read())!==null;)a.push(t);return c(a)}e.consumeReadable=w;function b(y,c,a){const t=[];let s;for(;(s=y.read())!==null&&t.length<a;)t.push(s);return s===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return y.read()}}}e.peekReadable=b;function n(y,c){return new Promise((a,t)=>{const s=[];I(y,{onData:r=>{c&&s.push(r)},onError:r=>{c?t(r):a(void 0)},onEnd:()=>{a(c?c(s):void 0)}})})}e.consumeStream=n;function I(y,c){y.on("error",a=>c.onError(a)),y.on("end",()=>c.onEnd()),y.on("data",a=>c.onData(a))}e.listenStream=I;function v(y,c){return new Promise((a,t)=>{const s=new L.DisposableStore,r=[],i=u=>{if(r.push(u),r.length>c)return s.dispose(),y.pause(),a({stream:y,buffer:r,ended:!1})},o=u=>t(u),l=()=>a({stream:y,buffer:r,ended:!0});s.add((0,L.toDisposable)(()=>y.removeListener("error",o))),y.on("error",o),s.add((0,L.toDisposable)(()=>y.removeListener("end",l))),y.on("end",l),s.add((0,L.toDisposable)(()=>y.removeListener("data",i))),y.on("data",i)})}e.peekStream=v;function E(y,c){const a=A(c);return a.end(y),a}e.toStream=E;function h(){const y=A(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=h;function S(y){let c=!1;return{read:()=>c?null:(c=!0,y)}}e.toReadable=S;function f(y,c,a){const t=A(a);return I(y,{onData:s=>t.write(c.data(s)),onError:s=>t.error(c.error?c.error(s):s),onEnd:()=>t.end()}),t}e.transform=f;function p(y,c,a){let t=!1;return{read:()=>{const s=c.read();return t?s:(t=!0,s!==null?a([y,s]):y)}}}e.prefixedReadable=p;function m(y,c,a){let t=!1;const s=A(a);return I(c,{onData:r=>t?s.write(r):(t=!0,s.write(a([y,r]))),onError:r=>s.error(r),onEnd:()=>{t||(t=!0,s.write(y)),s.end()}}),s}e.prefixedStream=m}),define(te[22],ne([0,1,52]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let D,k;class A{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return L?new A(Buffer.allocUnsafe(i)):new A(new Uint8Array(i))}static wrap(i){return L&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new A(i)}static fromString(i,o){return!(o?.dontUseNodeBuffer||!1)&&L?new A(Buffer.from(i)):(D||(D=new TextEncoder),new A(D.encode(i)))}static concat(i,o){if(typeof o=="undefined"){o=0;for(let d=0,g=i.length;d<g;d++)o+=i[d].byteLength}const l=A.alloc(o);let u=0;for(let d=0,g=i.length;d<g;d++){const T=i[d];l.set(T,u),u+=T.byteLength}return l}toString(){return L?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(i,o){return new A(this.buffer.subarray(i,o))}set(i,o){i instanceof A?this.buffer.set(i.buffer,o):this.buffer.set(i,o)}readUInt32BE(i){return b(this.buffer,i)}writeUInt32BE(i,o){n(this.buffer,i,o)}readUInt32LE(i){return I(this.buffer,i)}writeUInt32LE(i,o){v(this.buffer,i,o)}readUInt8(i){return E(this.buffer,i)}writeUInt8(i,o){h(this.buffer,i,o)}}e.VSBuffer=A;function P(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=P;function w(r,i,o){r[o+0]=i&255,i=i>>>8,r[o+1]=i&255}e.writeUInt16LE=w;function b(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=b;function n(r,i,o){r[o+3]=i,i=i>>>8,r[o+2]=i,i=i>>>8,r[o+1]=i,i=i>>>8,r[o]=i}e.writeUInt32BE=n;function I(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=I;function v(r,i,o){r[o+0]=i&255,i=i>>>8,r[o+1]=i&255,i=i>>>8,r[o+2]=i&255,i=i>>>8,r[o+3]=i&255}e.writeUInt32LE=v;function E(r,i){return r[i]}e.readUInt8=E;function h(r,i,o){r[o]=i}e.writeUInt8=h;function S(r){return R.consumeReadable(r,i=>A.concat(i))}e.readableToBuffer=S;function f(r){return R.toReadable(r)}e.bufferToReadable=f;function p(r){return R.consumeStream(r,i=>A.concat(i))}e.streamToBuffer=p;async function m(r){return r.ended?A.concat(r.buffer):A.concat([...r.buffer,await p(r.stream)])}e.bufferedStreamToBuffer=m;function y(r){return R.toStream(r,i=>A.concat(i))}e.bufferToStream=y;function c(r){return R.transform(r,{data:i=>typeof i=="string"?A.fromString(i):A.wrap(i)},i=>A.concat(i))}e.streamToBufferReadableStream=c;function a(r){return R.newWriteableStream(i=>A.concat(i),r)}e.newWriteableBufferStream=a;function t(r,i){return R.prefixedReadable(r,i,o=>A.concat(o))}e.prefixedBufferReadable=t;function s(r,i){return R.prefixedStream(r,i,o=>A.concat(o))}e.prefixedBufferStream=s}),define(te[25],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=R;const L=/{(\d+)}/g;function D(Y,...se){return se.length===0?Y:Y.replace(L,function(ue,ge){const me=parseInt(ge,10);return isNaN(me)||me<0||me>=se.length?ue:se[me]})}e.format=D;const k=/{([^}]+)}/g;function A(Y,se){return Y.replace(k,(ue,ge)=>se[ge]??ue)}e.format2=A;function P(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=P;function w(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function b(Y,se){let ue=0;const ge=se.charCodeAt(0);for(let me=Y.length-1;me>=0;me--)Y.charCodeAt(me)===ge&&ue++;return ue}e.count=b;function n(Y,se,ue="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${ue}`}e.truncate=n;function I(Y,se=" "){const ue=v(Y,se);return E(ue,se)}e.trim=I;function v(Y,se){if(!Y||!se)return Y;const ue=se.length;if(ue===0||Y.length===0)return Y;let ge=0;for(;Y.indexOf(se,ge)===ge;)ge=ge+ue;return Y.substring(ge)}e.ltrim=v;function E(Y,se){if(!Y||!se)return Y;const ue=se.length,ge=Y.length;if(ue===0||ge===0)return Y;let me=ge,Ie=-1;for(;Ie=Y.lastIndexOf(se,me-1),!(Ie===-1||Ie+ue!==me);){if(Ie===0)return"";me=Ie}return Y.substring(0,me)}e.rtrim=E;function h(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function S(Y){return Y.replace(/\*/g,"")}e.stripWildcards=S;function f(Y,se,ue={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=w(Y)),ue.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ge="";return ue.global&&(ge+="g"),ue.matchCase||(ge+="i"),ue.multiline&&(ge+="m"),ue.unicode&&(ge+="u"),new RegExp(Y,ge)}e.createRegExp=f;function p(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function m(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function y(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=y;function c(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=c;function a(Y){for(let se=0,ue=Y.length;se<ue;se++){const ge=Y.charCodeAt(se);if(ge!==32&&ge!==9)return se}return-1}e.firstNonWhitespaceIndex=a;function t(Y,se=0,ue=Y.length){for(let ge=se;ge<ue;ge++){const me=Y.charCodeAt(ge);if(me!==32&&me!==9)return Y.substring(se,ge)}return Y.substring(se,ue)}e.getLeadingWhitespace=t;function s(Y,se=Y.length-1){for(let ue=se;ue>=0;ue--){const ge=Y.charCodeAt(ue);if(ge!==32&&ge!==9)return ue}return-1}e.lastNonWhitespaceIndex=s;function r(Y,se){return Y<se?-1:Y>se?1:0}e.compare=r;function i(Y,se,ue=0,ge=Y.length,me=0,Ie=se.length){for(;ue<ge&&me<Ie;ue++,me++){let ye=Y.charCodeAt(ue),we=se.charCodeAt(me);if(ye<we)return-1;if(ye>we)return 1}const ke=ge-ue,Te=Ie-me;return ke<Te?-1:ke>Te?1:0}e.compareSubstring=i;function o(Y,se){return l(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=o;function l(Y,se,ue=0,ge=Y.length,me=0,Ie=se.length){for(;ue<ge&&me<Ie;ue++,me++){let ye=Y.charCodeAt(ue),we=se.charCodeAt(me);if(ye===we)continue;if(ye>=128||we>=128)return i(Y.toLowerCase(),se.toLowerCase(),ue,ge,me,Ie);u(ye)&&(ye-=32),u(we)&&(we-=32);const De=ye-we;if(De!==0)return De}const ke=ge-ue,Te=Ie-me;return ke<Te?-1:ke>Te?1:0}e.compareSubstringIgnoreCase=l;function u(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=u;function d(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=d;function g(Y,se){return Y.length===se.length&&l(Y,se)===0}e.equalsIgnoreCase=g;function T(Y,se){const ue=se.length;return se.length>Y.length?!1:l(Y,se,0,ue)===0}e.startsWithIgnoreCase=T;function _(Y,se){let ue,ge=Math.min(Y.length,se.length);for(ue=0;ue<ge;ue++)if(Y.charCodeAt(ue)!==se.charCodeAt(ue))return ue;return ge}e.commonPrefixLength=_;function O(Y,se){let ue,ge=Math.min(Y.length,se.length);const me=Y.length-1,Ie=se.length-1;for(ue=0;ue<ge;ue++)if(Y.charCodeAt(me-ue)!==se.charCodeAt(Ie-ue))return ue;return ge}e.commonSuffixLength=O;function F(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=F;function C(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=C;function N(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=N;function z(Y,se,ue){const ge=Y.charCodeAt(ue);if(F(ge)&&ue+1<se){const me=Y.charCodeAt(ue+1);if(C(me))return N(ge,me)}return ge}e.getNextCodePoint=z;function M(Y,se){const ue=Y.charCodeAt(se-1);if(C(ue)&&se>1){const ge=Y.charCodeAt(se-2);if(F(ge))return N(ge,ue)}return ue}function q(Y,se){const ue=ee.getInstance(),ge=se,me=Y.length,Ie=z(Y,me,se);se+=Ie>=65536?2:1;let ke=ue.getGraphemeBreakType(Ie);for(;se<me;){const Te=z(Y,me,se),ye=ue.getGraphemeBreakType(Te);if($e(ke,ye))break;se+=Te>=65536?2:1,ke=ye}return se-ge}e.nextCharLength=q;function W(Y,se){const ue=ee.getInstance(),ge=se,me=M(Y,se);se-=me>=65536?2:1;let Ie=ue.getGraphemeBreakType(me);for(;se>0;){const ke=M(Y,se),Te=ue.getGraphemeBreakType(ke);if($e(Te,Ie))break;se-=ke>=65536?2:1,Ie=Te}return ge-se}e.prevCharLength=W;function j(Y,se){const ue=ee.getInstance(),ge=Y.length,me=se,Ie=z(Y,ge,se),ke=ue.getGraphemeBreakType(Ie);se+=Ie>=65536?2:1;let Te=ke;for(;se<ge;){const we=z(Y,ge,se),De=ue.getGraphemeBreakType(we);if($e(Te,De))break;se+=we>=65536?2:1,Te=De}const ye=se;for(se=me,Te=ke;se>0;){const we=M(Y,se),De=ue.getGraphemeBreakType(we);if($e(De,Te))break;se-=we>=65536?2:1,Te=De}return[se,ye]}function x(Y,se){return se>0&&C(Y.charCodeAt(se))?j(Y,se-1):j(Y,se)}e.getCharContainingOffset=x;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function G(Y){return $.test(Y)}e.containsRTL=G;const U=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function V(Y){return U.test(Y)}e.containsEmoji=V;const B=/^[\t\n\r\x20-\x7E]*$/;function Q(Y){return B.test(Y)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=Z;function K(Y){for(let se=0,ue=Y.length;se<ue;se++)if(H(Y.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=K;function H(Y){return Y=+Y,Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=H;function re(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=re;function ie(Y,se){if(Y.length<se)return Y;const ue=/\b/g;let ge=0;for(;ue.test(Y)&&!(Y.length-ue.lastIndex<se);)ge=ue.lastIndex,ue.lastIndex+=1;return Y.substring(ge).replace(/^\s/,"")}e.lcut=ie;const ce=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,de=/\x1b\[0?m/g;function fe(Y){return Y&&(Y=Y.replace(ce,""),Y=Y.replace(le,""),Y=Y.replace(de,"")),Y}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function Ce(Y){return be(Y)?Y.substr(1):Y}e.stripUTF8BOM=Ce;function Ee(Y,se){if(!Y||!se||Y.length<se.length)return!1;const ue=se.length,ge=Y.toLowerCase();let me=0,Ie=-1;for(;me<ue;){const ke=ge.indexOf(se[me],Ie+1);if(ke<0)return!1;Ie=ke,me++}return!0}e.fuzzyContains=Ee;function Ae(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=Ae;function Pe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Pe;function Le(Y,se=1){if(se===0)return"";let ue=-1;do ue=Y.indexOf(`
`,ue+1),se--;while(se>0&&ue>=0);return ue===-1?Y:(Y[ue-1]==="\r"&&ue--,Y.substr(0,ue))}e.getNLines=Le;function Ne(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=Ne;function Fe(Y){return ee.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Fe;function $e(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}e.breakBetweenGraphemeBreakType=$e;var xe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ee{constructor(){this._data=ae()}static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ue=this._data,ge=ue.length/3;let me=1;for(;me<=ge;)if(se<ue[3*me])me=2*me;else if(se>ue[3*me+1])me=2*me+1;else return ue[3*me+2];return 0}}ee._INSTANCE=null;function ae(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function oe(Y,se){if(Y===0)return 0;const ue=pe(Y,se);if(ue!==void 0)return ue;const ge=M(se,Y);return Y-=Se(ge),Y}e.getLeftDeleteOffset=oe;function pe(Y,se){let ue=M(se,Y);for(Y-=Se(ue);_e(ue)||ue===65039||ue===8419;){if(Y===0)return;ue=M(se,Y),Y-=Se(ue)}if(!!re(ue)){if(Y>=0){const ge=M(se,Y);ge===8205&&(Y-=Se(ge))}return Y}}function Se(Y){return Y>=65536?2:1}function _e(Y){return 127995<=Y&&Y<=127999}var Re;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Re||(Re={}))}),define(te[103],ne([0,1,25]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(p){return D(p,0)}e.hash=L;function D(p,m){switch(typeof p){case"object":return p===null?k(349,m):Array.isArray(p)?w(p,m):b(p,m);case"string":return P(p,m);case"boolean":return A(p,m);case"number":return k(p,m);case"undefined":return k(937,m);default:return k(617,m)}}e.doHash=D;function k(p,m){return(m<<5)-m+p|0}e.numberHash=k;function A(p,m){return k(p?433:863,m)}function P(p,m){m=k(149417,m);for(let y=0,c=p.length;y<c;y++)m=k(p.charCodeAt(y),m);return m}e.stringHash=P;function w(p,m){return m=k(104579,m),p.reduce((y,c)=>D(c,y),m)}function b(p,m){return m=k(181387,m),Object.keys(p).sort().reduce((y,c)=>(y=P(c,y),D(p[c],y)),m)}class n{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=D(m,this._value),this._value}}e.Hasher=n;var I;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function v(p,m,y=32){const c=y-m,a=~((1<<c)-1);return(p<<m|(a&p)>>>c)>>>0}function E(p,m=0,y=p.byteLength,c=0){for(let a=0;a<y;a++)p[m+a]=c}function h(p,m,y="0"){for(;p.length<m;)p=y+p;return p}function S(p,m=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(y=>y.toString(16).padStart(2,"0")).join(""):h((p>>>0).toString(16),m/4)}e.toHexString=S;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const y=m.length;if(y===0)return;const c=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,s,r;for(t!==0?(s=t,r=-1,t=0):(s=m.charCodeAt(0),r=0);;){let i=s;if(R.isHighSurrogate(s))if(r+1<y){const o=m.charCodeAt(r+1);R.isLowSurrogate(o)?(r++,i=R.computeCodePoint(s,o)):i=65533}else{t=s;break}else R.isLowSurrogate(s)&&(i=65533);if(a=this._push(c,a,i),r++,r<y)s=m.charCodeAt(r);else break}this._buffLen=a,this._leftoverHighSurrogate=t}_push(m,y,c){return c<128?m[y++]=c:c<2048?(m[y++]=192|(c&1984)>>>6,m[y++]=128|(c&63)>>>0):c<65536?(m[y++]=224|(c&61440)>>>12,m[y++]=128|(c&4032)>>>6,m[y++]=128|(c&63)>>>0):(m[y++]=240|(c&1835008)>>>18,m[y++]=128|(c&258048)>>>12,m[y++]=128|(c&4032)>>>6,m[y++]=128|(c&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=f._bigBlock32,y=this._buffDV;for(let u=0;u<64;u+=4)m.setUint32(u,y.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)m.setUint32(u,v(m.getUint32(u-12,!1)^m.getUint32(u-32,!1)^m.getUint32(u-56,!1)^m.getUint32(u-64,!1),1),!1);let c=this._h0,a=this._h1,t=this._h2,s=this._h3,r=this._h4,i,o,l;for(let u=0;u<80;u++)u<20?(i=a&t|~a&s,o=1518500249):u<40?(i=a^t^s,o=1859775393):u<60?(i=a&t|a&s|t&s,o=2400959708):(i=a^t^s,o=3395469782),l=v(c,5)+i+r+o+m.getUint32(u*4,!1)&4294967295,r=s,s=t,t=v(a,30),a=c,c=l;this._h0=this._h0+c&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))}),define(te[18],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function R(d){return Array.isArray(d)}e.isArray=R;function L(d){return typeof d=="string"}e.isString=L;function D(d){return Array.isArray(d)&&d.every(g=>L(g))}e.isStringArray=D;function k(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=k;function A(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=A;function P(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=P;function w(d){return d===!0||d===!1}e.isBoolean=w;function b(d){return typeof d=="undefined"}e.isUndefined=b;function n(d){return!I(d)}e.isDefined=n;function I(d){return b(d)||d===null}e.isUndefinedOrNull=I;function v(d,g){if(!d)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}e.assertType=v;function E(d){if(I(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=E;function h(...d){const g=[];for(let T=0;T<d.length;T++){const _=d[T];if(I(_))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);g.push(_)}return g}e.assertAllDefined=h;const S=Object.prototype.hasOwnProperty;function f(d){if(!k(d))return!1;for(let g in d)if(S.call(d,g))return!1;return!0}e.isEmptyObject=f;function p(d){return typeof d=="function"}e.isFunction=p;function m(...d){return d.length>0&&d.every(p)}e.areFunctions=m;function y(d,g){const T=Math.min(d.length,g.length);for(let _=0;_<T;_++)c(d[_],g[_])}e.validateConstraints=y;function c(d,g){if(L(g)){if(typeof d!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(p(g)){try{if(d instanceof g)return}catch{}if(!I(d)&&d.constructor===g||g.length===1&&g.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function a(d){let g=[],T=Object.getPrototypeOf(d);for(;Object.prototype!==T;)g=g.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return g}e.getAllPropertyNames=a;function t(d){const g=[];for(const T of a(d))typeof d[T]=="function"&&g.push(T);return g}e.getAllMethodNames=t;function s(d,g){const T=O=>function(){const F=Array.prototype.slice.call(arguments,0);return g(O,F)};let _={};for(const O of d)_[O]=T(O);return _}e.createProxyObject=s;function r(d){return d===null?void 0:d}e.withNullAsUndefined=r;function i(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=i;function o(d){return class{constructor(){return new Proxy({},{get(g,T){if(g[T])return g[T];throw new Error(`Not Implemented: ${d}->${String(T)}`)}})}}}e.NotImplementedProxy=o;function l(d,g="Unreachable"){throw new Error(g)}e.assertNever=l;function u(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=u}),define(te[39],ne([0,1,9,4,25,18]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(r){return r===47||r===92}e.isPathSeparator=A;function P(r){return r.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=P;function w(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=w;function b(r,i=R.posix.sep){if(!r)return"";const o=r.length,l=r.charCodeAt(0);if(A(l)){if(A(r.charCodeAt(1))&&!A(r.charCodeAt(2))){let d=3;const g=d;for(;d<o&&!A(r.charCodeAt(d));d++);if(g!==d&&!A(r.charCodeAt(d+1))){for(d+=1;d<o;d++)if(A(r.charCodeAt(d)))return r.slice(0,d+1).replace(/[\\/]/g,i)}}return i}else if(p(l)&&r.charCodeAt(1)===58)return A(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<o;u++)if(A(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.getRoot=b;function n(r){if(!L.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let o=2;const l=o;for(;o<r.length&&(i=r.charCodeAt(o),i!==92);o++);return!(l===o||(i=r.charCodeAt(o+1),isNaN(i)||i===92))}e.isUNC=n;const I=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,i=L.isWindows){const o=i?I:v;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||i&&E.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function S(r,i,o){const l=r===i;return!o||l?l:!r||!i?!1:(0,D.equalsIgnoreCase)(r,i)}e.isEqual=S;function f(r,i,o,l=R.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(o){if(!(0,D.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let d=i.length;return i.charAt(i.length-1)===l&&d--,r.charAt(d)===l}return i.charAt(i.length-1)!==l&&(i+=l),r.indexOf(i)===0}e.isEqualOrParent=f;function p(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=p;function m(r,i){return L.isWindows&&r.endsWith(":")&&(r+=R.sep),(0,R.isAbsolute)(r)||(r=(0,R.join)(i,r)),r=(0,R.normalize)(r),L.isWindows?(r=(0,D.rtrim)(r,R.sep),r.endsWith(":")&&(r+=R.sep)):(r=(0,D.rtrim)(r,R.sep),r||(r=R.sep)),r}e.sanitizeFilePath=m;function y(r){const i=(0,R.normalize)(r);return L.isWindows?r.length>3?!1:c(i)&&(r.length===2||i.charCodeAt(2)===92):i===R.posix.sep}e.isRootOrDriveLetter=y;function c(r){return L.isWindows?p(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function a(r){return c(r)?r[0]:void 0}e.getDriveLetter=a;function t(r,i,o){return i.length>r.length?-1:r===i?0:(o&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=t;function s(r){const i=r.split(":");let o,l,u;if(i.forEach(d=>{const g=Number(d);(0,k.isNumber)(g)?l===void 0?l=g:u===void 0&&(u=g):o=o?[o,d].join(":"):d}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:l!==void 0?l:void 0,column:u!==void 0?u:l!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(te[26],ne([0,1,18]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const f=Array.isArray(S)?[]:{};return Object.keys(S).forEach(p=>{S[p]&&typeof S[p]=="object"?f[p]=L(S[p]):f[p]=S[p]}),f}e.deepClone=L;function D(S){if(!S||typeof S!="object")return S;const f=[S];for(;f.length>0;){const p=f.shift();Object.freeze(p);for(const m in p)if(k.call(p,m)){const y=p[m];typeof y=="object"&&!Object.isFrozen(y)&&f.push(y)}}return S}e.deepFreeze=D;const k=Object.prototype.hasOwnProperty;function A(S,f){return P(S,f,new Set)}e.cloneAndChange=A;function P(S,f,p){if((0,R.isUndefinedOrNull)(S))return S;const m=f(S);if(typeof m!="undefined")return m;if((0,R.isArray)(S)){const y=[];for(const c of S)y.push(P(c,f,p));return y}if((0,R.isObject)(S)){if(p.has(S))throw new Error("Cannot clone recursive data-structure");p.add(S);const y={};for(let c in S)k.call(S,c)&&(y[c]=P(S[c],f,p));return p.delete(S),y}return S}function w(S,f,p=!0){return(0,R.isObject)(S)?((0,R.isObject)(f)&&Object.keys(f).forEach(m=>{m in S?p&&((0,R.isObject)(S[m])&&(0,R.isObject)(f[m])?w(S[m],f[m],p):S[m]=f[m]):S[m]=f[m]}),S):f}e.mixin=w;function b(S,f){if(S===f)return!0;if(S==null||f===null||f===void 0||typeof S!=typeof f||typeof S!="object"||Array.isArray(S)!==Array.isArray(f))return!1;let p,m;if(Array.isArray(S)){if(S.length!==f.length)return!1;for(p=0;p<S.length;p++)if(!b(S[p],f[p]))return!1}else{const y=[];for(m in S)y.push(m);y.sort();const c=[];for(m in f)c.push(m);if(c.sort(),!b(y,c))return!1;for(p=0;p<y.length;p++)if(!b(S[y[p]],f[y[p]]))return!1}return!0}e.equals=b;function n(S){const f=new Set;return JSON.stringify(S,(p,m)=>{if((0,R.isObject)(m)||Array.isArray(m)){if(f.has(m))return"[Circular]";f.add(m)}return m})}e.safeStringify=n;function I(S,f,p){const m=f(S);return typeof m=="undefined"?p:m}e.getOrDefault=I;function v(S,f){const p=Object.create(null);return!S||!f||Object.keys(f).forEach(y=>{const c=S[y],a=f[y];b(c,a)||(p[y]=a)}),p}e.distinct=v;function E(S,f){const p=f.toLowerCase(),m=Object.keys(S).find(y=>y.toLowerCase()===p);return m?S[m]:S[f]}e.getCaseInsensitive=E;function h(S,f){const p=Object.create(null);for(const m of Object.keys(S))f(m,S[m])&&(p[m]=S[m]);return p}e.filter=h}),define(te[7],ne([0,1,9,4]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,k=/^\//,A=/^\/\//;function P(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!D.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!k.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(r,i){return!r&&!i?"file":r}function b(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const n="",I="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(i,o,l,u,d,g=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=w(i,g),this.authority=o||n,this.path=b(this.scheme,l||n),this.query=u||n,this.fragment=d||n,P(this,g))}static isUri(i){return i instanceof E?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return y(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:l,path:u,query:d,fragment:g}=i;return o===void 0?o=this.scheme:o===null&&(o=n),l===void 0?l=this.authority:l===null&&(l=n),u===void 0?u=this.path:u===null&&(u=n),d===void 0?d=this.query:d===null&&(d=n),g===void 0?g=this.fragment:g===null&&(g=n),o===this.scheme&&l===this.authority&&u===this.path&&d===this.query&&g===this.fragment?this:new S(o,l,u,d,g)}static parse(i,o=!1){const l=v.exec(i);return l?new S(l[2]||n,s(l[4]||n),s(l[5]||n),s(l[7]||n),s(l[9]||n),o):new S(n,n,n,n,n)}static file(i){let o=n;if(L.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const l=i.indexOf(I,2);l===-1?(o=i.substring(2),i=I):(o=i.substring(2,l),i=i.substring(l)||I)}return new S("file",o,i,n,n)}static from(i){const o=new S(i.scheme,i.authority,i.path,i.query,i.fragment);return P(o,!0),o}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&i.scheme==="file"?l=E.file(R.win32.join(y(i,!0),...o)).path:l=R.posix.join(i.path,...o),i.with({path:l})}toString(i=!1){return c(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof E)return i;{const o=new S(i);return o._formatted=i.external,o._fsPath=i._sep===h?i.fsPath:null,o}}else return i}}e.URI=E;const h=L.isWindows?1:void 0;class S extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(i=!1){return i?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=h),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(r,i){let o,l=-1;for(let u=0;u<r.length;u++){const d=r.charCodeAt(u);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||i&&d===47)l!==-1&&(o+=encodeURIComponent(r.substring(l,u)),l=-1),o!==void 0&&(o+=r.charAt(u));else{o===void 0&&(o=r.substr(0,u));const g=f[d];g!==void 0?(l!==-1&&(o+=encodeURIComponent(r.substring(l,u)),l=-1),o+=g):l===-1&&(l=u)}}return l!==-1&&(o+=encodeURIComponent(r.substring(l))),o!==void 0?o:r}function m(r){let i;for(let o=0;o<r.length;o++){const l=r.charCodeAt(o);l===35||l===63?(i===void 0&&(i=r.substr(0,o)),i+=f[l]):i!==void 0&&(i+=r[o])}return i!==void 0?i:r}function y(r,i){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,L.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=y;function c(r,i){const o=i?m:p;let l="",{scheme:u,authority:d,path:g,query:T,fragment:_}=r;if(u&&(l+=u,l+=":"),(d||u==="file")&&(l+=I,l+=I),d){let O=d.indexOf("@");if(O!==-1){const F=d.substr(0,O);d=d.substr(O+1),O=F.indexOf(":"),O===-1?l+=o(F,!1):(l+=o(F.substr(0,O),!1),l+=":",l+=o(F.substr(O+1),!1)),l+="@"}d=d.toLowerCase(),O=d.indexOf(":"),O===-1?l+=o(d,!1):(l+=o(d.substr(0,O),!1),l+=d.substr(O))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const O=g.charCodeAt(1);O>=65&&O<=90&&(g=`/${String.fromCharCode(O+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const O=g.charCodeAt(0);O>=65&&O<=90&&(g=`${String.fromCharCode(O+32)}:${g.substr(2)}`)}l+=o(g,!0)}return T&&(l+="?",l+=o(T,!1)),_&&(l+="#",l+=i?_:p(_,!1)),l}function a(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+a(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,i=>a(i)):r}}),define(te[104],ne([0,1,7]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(b){const n=b;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=L;function D(b){const n=[];let I;try{const v=JSON.parse(b.arguments),E=v[v.length-1];E&&E.__$stack&&(v.pop(),I=E.__$stack),n.push(...v)}catch(v){n.push("Unable to log remote console arguments",b.arguments)}return{args:n,stack:I}}e.parse=D;function k(b){if(typeof b!="string")return k(D(b).stack);const n=b;if(n){const I=A(n),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(v&&v.length===4)return{uri:R.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=k;function A(b){if(!b)return b;const n=b.indexOf(`
`);return n===-1?b:b.substring(0,n)}function P(b,n){const{args:I,stack:v}=D(b),E=typeof I[0]=="string"&&I.length===1;let h=A(v);h&&(h=`(${h.trim()})`);let S=[];if(typeof I[0]=="string"?h&&E?S=[`%c[${n}] %c${I[0]} %c${h}`,w("blue"),w(""),w("grey")]:S=[`%c[${n}] %c${I[0]}`,w("blue"),w(""),...I.slice(1)]:S=[`%c[${n}]%`,w("blue"),...I],h&&!E&&S.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,S)}e.log=P;function w(b){return`color: ${b}`}});var yt=this&&this.__classPrivateFieldSet||function(J,e,R,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(J,R):D?D.value=R:e.set(J,R),R},Be=this&&this.__classPrivateFieldGet||function(J,e,R,L){if(R==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return R==="m"?L:R==="a"?L.call(J):L?L.value:e.get(J)};define(te[40],ne([0,1,17,25,7]),function(J,e,R,L,D){"use strict";var k,A,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function w(r,i,o){let l=r.get(i);return l===void 0&&(l=o,r.set(i,l)),l}e.getOrSet=w;function b(r){const i=[];return r.forEach((o,l)=>{i.push(`${l} => ${o}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=b;function n(r){const i=[];return r.forEach(o=>{i.push(o)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=n;class I{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const o=i.charCodeAt(0),l=this._value.charCodeAt(this._pos);return o-l}value(){return this._value[this._pos]}}e.StringIterator=I;class v{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,L.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=v;class E{constructor(i=!0,o=!0){this._splitOnBackslash=i,this._caseSensitive=o}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,L.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var h;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(h||(h={}));class S{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,L.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(p||(p={}));class m{constructor(i){this._iter=i}static forUris(i=()=>!1){return new m(new S(i))}static forPaths(){return new m(new E)}static forStrings(){return new m(new I)}static forConfigKeys(){return new m(new v)}clear(){this._root=void 0}fill(i,o){if(o){const l=o.slice(0);(0,R.shuffle)(l);for(let u of l)this.set(u,i)}else{const l=i.slice(0);(0,R.shuffle)(l);for(let u of l)this.set(u[0],u[1])}}set(i,o){const l=this._iter.reset(i);let u;this._root||(this._root=new f,this._root.segment=l.value());const d=[];for(u=this._root;;){const T=l.cmp(u.segment);if(T>0)u.left||(u.left=new f,u.left.segment=l.value()),d.push([-1,u]),u=u.left;else if(T<0)u.right||(u.right=new f,u.right.segment=l.value()),d.push([1,u]),u=u.right;else if(l.hasNext())l.next(),u.mid||(u.mid=new f,u.mid.segment=l.value()),d.push([0,u]),u=u.mid;else break}const g=u.value;u.value=o,u.key=i;for(let T=d.length-1;T>=0;T--){const _=d[T][1];_.updateHeight();const O=_.balanceFactor();if(O<-1||O>1){const F=d[T][0],C=d[T+1][0];if(F===1&&C===1)d[T][1]=_.rotateLeft();else if(F===-1&&C===-1)d[T][1]=_.rotateRight();else if(F===1&&C===-1)_.right=d[T+1][1]=d[T+1][1].rotateRight(),d[T][1]=_.rotateLeft();else if(F===-1&&C===1)_.left=d[T+1][1]=d[T+1][1].rotateLeft(),d[T][1]=_.rotateRight();else throw new Error;if(T>0)switch(d[T-1][0]){case-1:d[T-1][1].left=d[T][1];break;case 1:d[T-1][1].right=d[T][1];break;case 0:d[T-1][1].mid=d[T][1];break}else this._root=d[0][1]}}return g}get(i){return this._getNode(i)?.value}_getNode(i){const o=this._iter.reset(i);let l=this._root;for(;l;){const u=o.cmp(l.segment);if(u>0)l=l.left;else if(u<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else break}return l}has(i){const o=this._getNode(i);return!(o?.value===void 0&&o?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,o){const l=this._iter.reset(i),u=[];let d=this._root;for(;d;){const g=l.cmp(d.segment);if(g>0)u.push([-1,d]),d=d.left;else if(g<0)u.push([1,d]),d=d.right;else if(l.hasNext())l.next(),u.push([0,d]),d=d.mid;else break}if(!!d){if(o?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const g=this._min(d.right),{key:T,value:_,segment:O}=g;this._delete(g.key,!1),d.key=T,d.value=_,d.segment=O}else{const g=d.left??d.right;if(u.length>0){const[T,_]=u[u.length-1];switch(T){case-1:_.left=g;break;case 0:_.mid=g;break;case 1:_.right=g;break}}else this._root=g}for(let g=u.length-1;g>=0;g--){const T=u[g][1];T.updateHeight();const _=T.balanceFactor();if(_>1?(T.right.balanceFactor()>=0||(T.right=u[g+1][1]=u[g+1][1].rotateRight()),u[g][1]=T.rotateLeft()):_<-1&&(T.left.balanceFactor()<=0||(T.left=u[g+1][1]=u[g+1][1].rotateLeft()),u[g][1]=T.rotateRight()),g>0)switch(u[g-1][0]){case-1:u[g-1][1].left=u[g][1];break;case 1:u[g-1][1].right=u[g][1];break;case 0:u[g-1][1].mid=u[g][1];break}else this._root=u[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const o=this._iter.reset(i);let l=this._root,u;for(;l;){const d=o.cmp(l.segment);if(d>0)l=l.left;else if(d<0)l=l.right;else if(o.hasNext())o.next(),u=l.value||u,l=l.mid;else break}return l&&l.value||u}findSuperstr(i){const o=this._iter.reset(i);let l=this._root;for(;l;){const u=o.cmp(l.segment);if(u>0)l=l.left;else if(u<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(i){for(const[o,l]of this)i(l,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=o=>{if(!o)return!0;const l=o.balanceFactor();return l<-1||l>1?!1:i(o.left)&&i(o.right)};return i(this._root)}}e.TernarySearchTree=m;class y{constructor(i,o){this[k]="ResourceMap",i instanceof y?(this.map=new Map(i.map),this.toKey=o??y.defaultToKey):(this.map=new Map,this.toKey=i??y.defaultToKey)}set(i,o){return this.map.set(this.toKey(i),o),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,o){typeof o!="undefined"&&(i=i.bind(o));for(let[l,u]of this.map)i(u,D.URI.parse(l),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield D.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[D.URI.parse(i[0]),i[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[D.URI.parse(i[0]),i[1]]}}e.ResourceMap=y,y.defaultToKey=r=>r.toString();var c;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class a{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,o=0){const l=this._map.get(i);if(!!l)return o!==0&&this.touch(l,o),l.value}set(i,o,l=0){let u=this._map.get(i);if(u)u.value=o,l!==0&&this.touch(u,l);else{switch(u={key:i,value:o,next:void 0,previous:void 0},l){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(i,u),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const o=this._map.get(i);if(!!o)return this._map.delete(i),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,o){const l=this._state;let u=this._head;for(;u;){if(o?i.bind(o)(u.value,u.key,this):i(u.value,u.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const i=this,o=this._state;let l=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const d={value:l.key,done:!1};return l=l.next,d}else return{value:void 0,done:!0}}};return u}values(){const i=this,o=this._state;let l=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const d={value:l.value,done:!1};return l=l.next,d}else return{value:void 0,done:!0}}};return u}entries(){const i=this,o=this._state;let l=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const d={value:[l.key,l.value],done:!1};return l=l.next,d}else return{value:void 0,done:!0}}};return u}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let o=this._head,l=this.size;for(;o&&l>i;)this._map.delete(o.key),o=o.next,l--;this._head=o,this._size=l,o&&(o.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const o=i.next,l=i.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}i.next=void 0,i.previous=void 0,this._state++}touch(i,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(i===this._head)return;const l=i.next,u=i.previous;i===this._tail?(u.next=void 0,this._tail=u):(l.previous=u,u.next=l),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(o===2){if(i===this._tail)return;const l=i.next,u=i.previous;i===this._head?(l.previous=void 0,this._head=l):(l.previous=u,u.next=l),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((o,l)=>{i.push([l,o])}),i}fromJSON(i){this.clear();for(const[o,l]of i)this.set(o,l)}}e.LinkedMap=a;class t extends a{constructor(i,o=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,o=2){return super.get(i,o)}peek(i){return super.get(i,0)}set(i,o){return super.set(i,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=t;class s{constructor(i){P.set(this,void 0),yt(this,P,i,"f")}get size(){return Be(this,P,"f").size}forEach(i,o){Be(this,P,"f").forEach(i,o)}get(i){return Be(this,P,"f").get(i)}has(i){return Be(this,P,"f").has(i)}entries(){return Be(this,P,"f").entries()}keys(){return Be(this,P,"f").keys()}values(){return Be(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Be(this,P,"f").entries()}}e.ReadonlyMapView=s}),define(te[105],ne([0,1,22,25,7]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(n){return JSON.stringify(n,w)}e.stringify=k;function A(n){let I=JSON.parse(n);return I=b(I),I}e.parse=A;var P;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function w(n,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function b(n,I=0){if(!n||I>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return D.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof R.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let v=0;v<n.length;++v)n[v]=b(n[v],I+1);else for(const v in n)Object.hasOwnProperty.call(n,v)&&(n[v]=b(n[v],I+1))}return n}e.revive=b}),define(te[15],ne([0,1,4,7]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,b,n){this._hosts[w]=b,this._ports[w]=n}setConnectionToken(w,b){this._connectionTokens[w]=b}rewrite(w){if(this._delegate)return this._delegate(w);const b=w.authority;let n=this._hosts[b];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const I=this._ports[b],v=this._connectionTokens[b];let E=`path=${encodeURIComponent(w.path)}`;return typeof v=="string"&&(E+=`&tkn=${encodeURIComponent(v)}`),L.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${n}:${I}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new k;class A{asBrowserUri(w,b){const n=this.toUri(w,b);return n.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===D.file&&(R.isNative||typeof R.globals.importScripts=="function"&&R.globals.origin===`${D.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?n.with({scheme:D.vscodeFileResource,authority:n.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(w,b){const n=this.toUri(w,b);return n.scheme===D.vscodeFileResource?n.with({scheme:D.file,authority:n.authority!==A.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(w,b){return L.URI.isUri(w)?w:L.URI.parse(b.toUrl(w))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(te[69],ne([0,1,40]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new R.LRUCache(1e4);function D(b){return w(b,"NFC",L)}e.normalizeNFC=D;const k=new R.LRUCache(1e4);function A(b){return w(b,"NFD",k)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function w(b,n,I){if(!b)return b;const v=I.get(b);if(v)return v;let E;return P.test(b)?E=b.normalize(n):E=b,I.set(b,E),E}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(n){return A(n).replace(b,"")}}()}),define(te[16],ne([0,1,39,15,9,4,25,7]),function(J,e,R,L,D,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(E){return(0,P.uriToFsPath)(E,!0)}e.originalFSPath=w;class b{constructor(h){this._ignorePathCasing=h}compare(h,S,f=!1){return h===S?0:(0,A.compare)(this.getComparisonKey(h,f),this.getComparisonKey(S,f))}isEqual(h,S,f=!1){return h===S?!0:!h||!S?!1:this.getComparisonKey(h,f)===this.getComparisonKey(S,f)}getComparisonKey(h,S=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,S,f=!1){if(h.scheme===S.scheme){if(h.scheme===L.Schemas.file)return R.isEqualOrParent(w(h),w(S),this._ignorePathCasing(h))&&h.query===S.query&&(f||h.fragment===S.fragment);if((0,e.isEqualAuthority)(h.authority,S.authority))return R.isEqualOrParent(h.path,S.path,this._ignorePathCasing(h),"/")&&h.query===S.query&&(f||h.fragment===S.fragment)}return!1}joinPath(h,...S){return P.URI.joinPath(h,...S)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let S;return h.scheme===L.Schemas.file?S=P.URI.file(D.dirname(w(h))).path:(S=D.posix.dirname(h.path),h.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),S="/")),h.with({path:S})}normalizePath(h){if(!h.path.length)return h;let S;return h.scheme===L.Schemas.file?S=P.URI.file(D.normalize(w(h))).path:S=D.posix.normalize(h.path),h.with({path:S})}relativePath(h,S){if(h.scheme!==S.scheme||!(0,e.isEqualAuthority)(h.authority,S.authority))return;if(h.scheme===L.Schemas.file){const m=D.relative(w(h),w(S));return k.isWindows?R.toSlashes(m):m}let f=h.path||"/",p=S.path||"/";if(this._ignorePathCasing(h)){let m=0;for(const y=Math.min(f.length,p.length);m<y&&!(f.charCodeAt(m)!==p.charCodeAt(m)&&f.charAt(m).toLowerCase()!==p.charAt(m).toLowerCase());m++);f=p.substr(0,m)+f.substr(m)}return D.posix.relative(f,p)}resolvePath(h,S){if(h.scheme===L.Schemas.file){const f=P.URI.file(D.resolve(w(h),S));return h.with({authority:f.authority,path:f.path})}return S=R.toPosixPath(S),h.with({path:D.posix.resolve(h.path,S)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,S){return h===S||(0,A.equalsIgnoreCase)(h,S)}hasTrailingPathSeparator(h,S=D.sep){if(h.scheme===L.Schemas.file){const f=w(h);return f.length>R.getRoot(f).length&&f[f.length-1]===S}else{const f=h.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,S=D.sep){return(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,S=D.sep){let f=!1;if(h.scheme===L.Schemas.file){const p=w(h);f=p!==void 0&&p.length===R.getRoot(p).length&&p[p.length-1]===S}else{S="/";const p=h.path;f=p.length===1&&p.charCodeAt(p.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(E=>E.scheme===L.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new b(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(E,h){const S=[];for(let f=0;f<E.length;f++){const p=h(E[f]);E.some((m,y)=>y===f?!1:(0,e.isEqualOrParent)(p,h(m)))||S.push(E[f])}return S}e.distinctParents=n;var I;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function h(S){const f=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(y=>{const[c,a]=y.split(":");c&&a&&f.set(c,a)});const m=S.path.substring(0,S.path.indexOf(";"));return m&&f.set(E.META_DATA_MIME,m),f}E.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function v(E,h,S){if(h){let f=E.path;return f&&f[0]!==D.posix.sep&&(f=D.posix.sep+f),E.with({scheme:S,authority:h,path:f})}return E.with({scheme:S})}e.toLocalResource=v}),define(te[5],ne([0,1,27,8,3,2,16]),function(J,e,R,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(W){return!!W&&typeof W.then=="function"}e.isThenable=P;function w(W){const j=new R.CancellationTokenSource,x=W(j.token),$=new Promise((G,U)=>{const V=j.token.onCancellationRequested(()=>{V.dispose(),j.dispose(),U((0,L.canceled)())});Promise.resolve(x).then(B=>{V.dispose(),j.dispose(),G(B)},B=>{V.dispose(),j.dispose(),U(B)})});return new class{cancel(){j.cancel()}then(G,U){return $.then(G,U)}catch(G){return this.then(void 0,G)}finally(G){return $.finally(G)}}}e.createCancelablePromise=w;function b(W,j,x){return Promise.race([W,new Promise($=>j.onCancellationRequested(()=>$(x)))])}e.raceCancellation=b;async function n(W){let j=-1;const x=W.map((G,U)=>G.then(V=>(j=U,V))),$=await Promise.race(x);return W.forEach((G,U)=>{U!==j&&G.cancel()}),$}e.raceCancellablePromises=n;function I(W,j,x){let $;const G=setTimeout(()=>{$?.(void 0),x?.()},j);return Promise.race([W.finally(()=>clearTimeout(G)),new Promise(U=>$=U)])}e.raceTimeout=I;function v(W){return new Promise((j,x)=>{const $=W();P($)?$.then(j,x):j($)})}e.asPromise=v;class E{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(j){if(this.activePromise){if(this.queuedPromiseFactory=j,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(x,x).then($)})}return new Promise((x,$)=>{this.queuedPromise.then(x,$)})}return this.activePromise=j(),new Promise((x,$)=>{this.activePromise.then(G=>{this.activePromise=null,x(G)},G=>{this.activePromise=null,$(G)})})}}e.Throttler=E;class h{constructor(){this.current=Promise.resolve(null)}queue(j){return this.current=this.current.then(()=>j(),()=>j())}}e.Sequencer=h;class S{constructor(){this.promiseMap=new Map}queue(j,x){const G=(this.promiseMap.get(j)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(j)===G&&this.promiseMap.delete(j)});return this.promiseMap.set(j,G),G}}e.SequencerByKey=S;class f{constructor(j){this.defaultDelay=j,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(j,x=this.defaultDelay){return this.task=j,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,G)=>{this.doResolve=$,this.doReject=G}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=f;class p{constructor(j){this.delayer=new f(j),this.throttler=new E}trigger(j,x){return this.delayer.trigger(()=>this.throttler.queue(j),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class m{constructor(){this._isOpen=!1,this._promise=new Promise((j,x)=>{this._completePromise=j})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class y extends m{constructor(j){super();this._timeout=setTimeout(()=>this.open(),j)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=y;function c(W,j){return j?new Promise((x,$)=>{const G=setTimeout(()=>{U.dispose(),x()},W),U=j.onCancellationRequested(()=>{clearTimeout(G),U.dispose(),$((0,L.canceled)())})}):w(x=>c(W,x))}e.timeout=c;function a(W,j=0){const x=setTimeout(W,j);return(0,k.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=a;function t(W){const j=[];let x=0;const $=W.length;function G(){return x<$?W[x++]():null}function U(V){V!=null&&j.push(V);const B=G();return B?B.then(U):Promise.resolve(j)}return Promise.resolve(null).then(U)}e.sequence=t;function s(W,j=$=>!!$,x=null){let $=0;const G=W.length,U=()=>{if($>=G)return Promise.resolve(x);const V=W[$++];return Promise.resolve(V()).then(Q=>j(Q)?Promise.resolve(Q):U())};return U()}e.first=s;function r(W,j=$=>!!$,x=null){if(W.length===0)return Promise.resolve(x);let $=W.length;const G=()=>{$=-1;for(const U of W)U.cancel?.()};return new Promise((U,V)=>{for(const B of W)B.then(Q=>{--$>=0&&j(Q)?(G(),U(Q)):$===0&&U(x)}).catch(Q=>{--$>=0&&(G(),V(Q))})})}e.firstParallel=r;class i{constructor(j){this._size=0,this.maxDegreeOfParalellism=j,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(j){return this._size++,new Promise((x,$)=>{this.outstandingPromises.push({factory:j,c:x,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const j=this.outstandingPromises.shift();this.runningPromises++;const x=j.factory();x.then(j.c,j.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class o extends i{constructor(){super(1)}}e.Queue=o;class l{constructor(){this.queues=new Map}queueFor(j,x=A.extUri){const $=x.getComparisonKey(j);let G=this.queues.get($);return G||(G=new o,D.Event.once(G.onFinished)(()=>{G?.dispose(),this.queues.delete($)}),this.queues.set($,G)),G}dispose(){this.queues.forEach(j=>j.dispose()),this.queues.clear()}}e.ResourceQueue=l;class u{constructor(j,x){this._token=-1,typeof j=="function"&&typeof x=="number"&&this.setIfNotSet(j,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(j,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,j()},x)}setIfNotSet(j,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,j()},x))}}e.TimeoutTimer=u;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(j,x){this.cancel(),this._token=setInterval(()=>{j()},x)}}e.IntervalTimer=d;class g{constructor(j,x){this.timeoutToken=-1,this.runner=j,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(j=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,j)}get delay(){return this.timeout}set delay(j){this.timeout=j}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=g;class T{constructor(j,x){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.runner=j,this.timeout=x,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(j=this.timeout){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(j/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class _ extends g{constructor(j,x){super(j,x);this.units=[]}work(j){this.units.push(j),this.isScheduled()||this.schedule()}doRun(){const j=this.units;this.units=[],this.runner&&this.runner(j)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_;class O extends k.Disposable{constructor(j,x,$,G){super();this.maxWorkChunkSize=j,this.maxPendingWork=x,this.throttleDelay=$,this.handler=G,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(j){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+j.length>this.maxPendingWork)return!1}else if(this.pending+j.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...j),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new g(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{const j=setTimeout(()=>{const $=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0,clearTimeout(j))}}}:e.runWhenIdle=(W,j)=>{const x=requestIdleCallback(W,typeof j=="number"?{timeout:j}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(x))}}}}();class F{constructor(j){this._didRun=!1,this._executor=()=>{try{this._value=j()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function C(W,j,x){let $;for(let G=0;G<x;G++)try{return await W()}catch(U){$=U,await c(j)}throw $}e.retry=C;class N{hasPending(j){return this._pending?typeof j=="number"?this._pending.taskId===j:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(j,x,$){return this._pending={taskId:j,cancel:()=>$?.(),promise:x},x.then(()=>this.donePending(j),()=>this.donePending(j)),x}donePending(j){this._pending&&j===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const j=this._next;this._next=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this._next)this._next.run=j;else{let x,$;const G=new Promise((U,V)=>{x=U,$=V});this._next={run:j,promise:G,promiseResolve:x,promiseReject:$}}return this._next.promise}}e.TaskSequentializer=N;class z{constructor(j){this.interval=j,this.lastIncrementTime=0,this.value=0}increment(){const j=Date.now();return j-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=j,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((j,x)=>{this.completeCallback=j,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(j){return new Promise(x=>{this.completeCallback(j),this.resolved=!0,x()})}error(j){return new Promise(x=>{this.errorCallback(j),this.rejected=!0,x()})}cancel(){new Promise(j=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,j()})}}e.DeferredPromise=M;var q;(function(W){async function j($){let G;const U=await Promise.all($.map(V=>V.then(B=>B,B=>{G||(G=B)})));if(typeof G!="undefined")throw G;return U}W.settled=j;function x($){return new Promise(async(G,U)=>{try{await $(G,U)}catch(V){U(V)}})}W.withAsyncBody=x})(q=e.Promises||(e.Promises={}))}),define(te[106],ne([0,1,5,39,40,9,25]),function(J,e,R,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const w="**",b="/",n="[/\\\\]",I="[^/\\\\]",v=/\//g;function E($){switch($){case 0:return"";case 1:return`${I}*?`;default:return`(?:${n}|${I}+${n}|${n}${I}+)*?`}}function h($,G){if(!$)return[];const U=[];let V=!1,B=!1,Q="";for(const Z of $){switch(Z){case G:if(!V&&!B){U.push(Q),Q="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":B=!0;break;case"]":B=!1;break}Q+=Z}return Q&&U.push(Q),U}e.splitGlobAware=h;function S($){if(!$)return"";let G="";const U=h($,b);if(U.every(V=>V===w))G=".*";else{let V=!1;U.forEach((B,Q)=>{if(B===w){V||(G+=E(2),V=!0);return}let Z=!1,K="",H=!1,re="";for(const ie of B){if(ie!=="}"&&Z){K+=ie;continue}if(H&&(ie!=="]"||!re)){let ce;ie==="-"?ce=ie:(ie==="^"||ie==="!")&&!re?ce="^":ie===b?ce="":ce=A.escapeRegExpCharacters(ie),re+=ce;continue}switch(ie){case"{":Z=!0;continue;case"[":H=!0;continue;case"}":G+=`(?:${h(K,",").map(de=>S(de)).join("|")})`,Z=!1,K="";break;case"]":G+="["+re+"]",H=!1,re="";break;case"?":G+=I;continue;case"*":G+=E(1);continue;default:G+=A.escapeRegExpCharacters(ie)}}Q<U.length-1&&(U[Q+1]!==w||Q+2<U.length)&&(G+=n),V=!1})}return G}const f=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,y=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.LRUCache(1e4),s=function(){return!1},r=function(){return null};function i($,G){if(!$)return r;let U;typeof $!="string"?U=$.pattern:U=$,U=U.trim();const V=`${U}_${!!G.trimForExclusions}`;let B=t.get(V);if(B)return o(B,$);let Q;if(f.test(U)){const Z=U.substr(4);B=function(K,H){return typeof K=="string"&&K.endsWith(Z)?U:null}}else(Q=p.exec(l(U,G)))?B=u(Q[1],U):(G.trimForExclusions?y:m).test(U)?B=d(U,G):(Q=c.exec(l(U,G)))?B=g(Q[1].substr(1),U,!0):(Q=a.exec(l(U,G)))?B=g(Q[1],U,!1):B=T(U);return t.set(V,B),o(B,$)}function o($,G){return typeof G=="string"?$:function(U,V){return L.isEqualOrParent(U,G.base)?$(k.relative(G.base,U),V):null}}function l($,G){return G.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function u($,G){const U=`/${$}`,V=`\\${$}`,B=function(Z,K){return typeof Z!="string"?null:K?K===$?G:null:Z===$||Z.endsWith(U)||Z.endsWith(V)?G:null},Q=[$];return B.basenames=Q,B.patterns=[G],B.allBasenames=Q,B}function d($,G){const U=x($.slice(1,-1).split(",").map(K=>i(K,G)).filter(K=>K!==r),$),V=U.length;if(!V)return r;if(V===1)return U[0];const B=function(K,H){for(let re=0,ie=U.length;re<ie;re++)if(U[re](K,H))return $;return null},Q=U.find(K=>!!K.allBasenames);Q&&(B.allBasenames=Q.allBasenames);const Z=U.reduce((K,H)=>H.allPaths?K.concat(H.allPaths):K,[]);return Z.length&&(B.allPaths=Z),B}function g($,G,U){const V=k.sep===k.posix.sep,B=V?$:$.replace(v,k.sep),Q=k.sep+B,Z=k.posix.sep+$,K=U?function(H,re){return typeof H=="string"&&(H===B||H.endsWith(Q)||!V&&(H===$||H.endsWith(Z)))?G:null}:function(H,re){return typeof H=="string"&&(H===B||!V&&H===$)?G:null};return K.allPaths=[(U?"*/":"./")+$],K}function T($){try{const G=new RegExp(`^${S($)}$`);return function(U){return G.lastIndex=0,typeof U=="string"&&G.test(U)?$:null}}catch(G){return r}}function _($,G,U){return!$||typeof G!="string"?!1:O($)(G,void 0,U)}e.match=_;function O($,G={}){if(!$)return s;if(typeof $=="string"||z($)){const U=i($,G);if(U===r)return s;const V=function(B,Q){return!!U(B,Q)};return U.allBasenames&&(V.allBasenames=U.allBasenames),U.allPaths&&(V.allPaths=U.allPaths),V}return W($,G)}e.parse=O;function F($){if(!$)return;let G;return U=>(G||(G=($()||Promise.resolve([])).then(V=>V?N(V):{})),G.then(V=>!!V[U]))}e.hasSiblingPromiseFn=F;function C($){if(!$)return;let G;return U=>{if(!G){const V=$();G=V?N(V):{}}return!!G[U]}}e.hasSiblingFn=C;function N($){const G={};for(const U of $)G[U]=!0;return G}function z($){const G=$;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=z;function M($){return $.allBasenames||[]}e.getBasenameTerms=M;function q($){return $.allPaths||[]}e.getPathTerms=q;function W($,G){const U=x(Object.getOwnPropertyNames($).map(K=>j(K,$[K],G)).filter(K=>K!==r)),V=U.length;if(!V)return r;if(!U.some(K=>!!K.requiresSiblings)){if(V===1)return U[0];const K=function(ie,ce){for(let le=0,de=U.length;le<de;le++){const fe=U[le](ie,ce);if(fe)return fe}return null},H=U.find(ie=>!!ie.allBasenames);H&&(K.allBasenames=H.allBasenames);const re=U.reduce((ie,ce)=>ce.allPaths?ie.concat(ce.allPaths):ie,[]);return re.length&&(K.allPaths=re),K}const B=function(K,H,re){let ie;for(let ce=0,le=U.length;ce<le;ce++){const de=U[ce];de.requiresSiblings&&re&&(H||(H=k.basename(K)),ie||(ie=H.substr(0,H.length-k.extname(K).length)));const fe=de(K,H,ie,re);if(fe)return fe}return null},Q=U.find(K=>!!K.allBasenames);Q&&(B.allBasenames=Q.allBasenames);const Z=U.reduce((K,H)=>H.allPaths?K.concat(H.allPaths):K,[]);return Z.length&&(B.allPaths=Z),B}function j($,G,U){if(G===!1)return r;const V=i($,U);if(V===r)return r;if(typeof G=="boolean")return V;if(G){const B=G.when;if(typeof B=="string"){const Q=(Z,K,H,re)=>{if(!re||!V(Z,K))return null;const ie=B.replace("$(basename)",H),ce=re(ie);return(0,R.isThenable)(ce)?ce.then(le=>le?$:null):ce?$:null};return Q.requiresSiblings=!0,Q}}return V}function x($,G){const U=$.filter(K=>!!K.basenames);if(U.length<2)return $;const V=U.reduce((K,H)=>{const re=H.basenames;return re?K.concat(re):K},[]);let B;if(G){B=[];for(let K=0,H=V.length;K<H;K++)B.push(G)}else B=U.reduce((K,H)=>{const re=H.patterns;return re?K.concat(re):K},[]);const Q=function(K,H){if(typeof K!="string")return null;if(!H){let ie;for(ie=K.length;ie>0;ie--){const ce=K.charCodeAt(ie-1);if(ce===47||ce===92)break}H=K.substr(ie)}const re=V.indexOf(H);return re!==-1?B[re]:null};Q.basenames=V,Q.patterns=B,Q.allBasenames=V;const Z=$.filter(K=>!K.basenames);return Z.push(Q),Z}}),define(te[107],ne([0,1,106,15,9,16,25]),function(J,e,R,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(P=e.Mimes||(e.Mimes={}));let w=[],b=[],n=[];function I(i,o=!1){const l=v(i);w.push(l),l.userConfigured?n.push(l):b.push(l),o&&!l.userConfigured&&w.forEach(u=>{u.mime===l.mime||u.userConfigured||(l.extension&&u.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&u.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&u.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&u.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=I;function v(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,R.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(D.posix.sep)>=0:!1}}function E(i){i?(w=w.filter(o=>!o.userConfigured),n=[]):(w=[],b=[],n=[])}e.clearTextMimes=E;function h(i,o){let l;if(i)switch(i.scheme){case L.Schemas.file:l=i.fsPath;break;case L.Schemas.data:l=k.DataUri.parseMetaData(i).get(k.DataUri.META_DATA_LABEL);break;default:l=i.path}if(!l)return[P.unknown];l=l.toLowerCase();const u=(0,D.basename)(l),d=S(l,u,n);if(d)return[d,P.text];const g=S(l,u,b);if(g)return[g,P.text];if(o){const T=f(o);if(T)return[T,P.text]}return[P.unknown]}e.guessMimeTypes=h;function S(i,o,l){let u=null,d=null,g=null;for(let T=l.length-1;T>=0;T--){const _=l[T];if(o===_.filenameLowercase){u=_;break}if(_.filepattern&&(!d||_.filepattern.length>d.filepattern.length)){const O=_.filepatternOnPath?i:o;_.filepatternLowercase?.(O)&&(d=_)}_.extension&&(!g||_.extension.length>g.extension.length)&&o.endsWith(_.extensionLowercase)&&(g=_)}return u?u.mime:d?d.mime:g?g.mime:null}function f(i){if((0,A.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let o=w.length-1;o>=0;o--){const l=w[o];if(!l.firstline)continue;const u=i.match(l.firstline);if(u&&u.length>0)return l.mime}return null}function p(i){return i?typeof i=="string"?i===P.binary||i===P.text||i===P.unknown:i.length===1&&p(i[0]):!0}e.isUnspecific=p;const m={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(i){const o=(0,D.extname)(i),l=m[o.toLowerCase()];return l!==void 0?l:a(i)}e.getMediaOrTextMime=c;function a(i){const o=(0,D.extname)(i);return y[o.toLowerCase()]}e.getMediaMime=a;function t(i){for(const o in y)if(y[o]===i)return o}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function r(i,o){const l=s.exec(i);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:o?void 0:i}e.normalizeMimeType=r}),define(te[108],ne([0,1,7]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class D{constructor(I){this._uriTransformer=I}transformIncoming(I){const v=this._uriTransformer.transformIncoming(I);return v===I?I:L(R.URI.from(v))}transformOutgoing(I){const v=this._uriTransformer.transformOutgoing(I);return v===I?I:L(R.URI.from(v))}transformOutgoingURI(I){const v=this._uriTransformer.transformOutgoing(I);return v===I?I:R.URI.from(v)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function k(n,I,v){if(!n||v>200)return null;if(typeof n=="object"){if(n instanceof R.URI)return I.transformOutgoing(n);for(let E in n)if(Object.hasOwnProperty.call(n,E)){const h=k(n[E],I,v+1);h!==null&&(n[E]=h)}}return null}function A(n,I){const v=k(n,I,0);return v===null?n:v}e.transformOutgoingURIs=A;function P(n,I,v,E){if(!n||E>200)return null;if(typeof n=="object"){if(n.$mid===1)return v?R.URI.revive(I.transformIncoming(n)):I.transformIncoming(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const S=P(n[h],I,v,E+1);S!==null&&(n[h]=S)}}return null}function w(n,I){const v=P(n,I,!1,0);return v===null?n:v}e.transformIncomingURIs=w;function b(n,I){const v=P(n,I,!0,0);return v===null?n:v}e.transformAndReviveIncomingURIs=b}),define(te[28],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(w){return R.test(w)}e.isUUID=L;const D=new Uint8Array(16),k=[];for(let w=0;w<256;w++)k.push(w.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(w){for(let b=0;b<w.length;b++)w[b]=Math.floor(Math.random()*256);return w};function P(){A(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let w=0,b="";return b+=k[D[w++]],b+=k[D[w++]],b+=k[D[w++]],b+=k[D[w++]],b+="-",b+=k[D[w++]],b+=k[D[w++]],b+="-",b+=k[D[w++]],b+=k[D[w++]],b+="-",b+=k[D[w++]],b+=k[D[w++]],b+="-",b+=k[D[w++]],b+=k[D[w++]],b+=k[D[w++]],b+=k[D[w++]],b+=k[D[w++]],b+=k[D[w++]],b}e.generateUuid=P}),define(te[109],ne([0,1,110]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new R.StringDecoder(k),this.remaining=null}write(k){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(P.length<1)return A;let w=0,b,n=w;for(;n<P.length;)if(b=P.charCodeAt(n),b===13||b===10){if(A.push(P.substring(w,n)),n++,n<P.length){const I=b;b=P.charCodeAt(n),(I===13&&b===10||I===10&&b===13)&&n++}w=n}else n++;return this.remaining=w<P.length?P.substr(w):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(te[111],ne([0,1,33]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(P){const w=P.replace(/\-/g,":").toLowerCase();return!L.has(w)}function k(){return new Promise(async(P,w)=>{const b=setTimeout(()=>w("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await A())}catch(n){w(n)}finally{clearTimeout(b)}})}e.getMac=k;function A(){return new Promise((P,w)=>{try{const b=(0,R.networkInterfaces)();for(let n in b){const I=b[n];if(I){for(const{mac:v}of I)if(D(v))return P(v)}}w("Unable to retrieve mac address (unexpected format)")}catch(b){w(b)}})}}),define(te[112],ne([0,1,33,8,40,28,111]),function(J,e,R,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,I=0;const v=(0,R.networkInterfaces)();for(let E in v){const h=v[E];if(h)for(const{mac:S,internal:f}of h)f||(I+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(n+=1))}this._value=I>0?n/I:0}return this._value}};let P;async function w(){return P||(P=(async()=>await b()||k.generateUuid())()),P}e.getMachineId=w;async function b(){try{const n=await new Promise((v,E)=>{J(["crypto"],v,E)}),I=await(0,A.getMac)();return n.createHash("sha256").update(I,"utf8").digest("hex")}catch(n){L.onUnexpectedError(n);return}}}),define(te[19],ne([0,1,53,33,240,5,39,69,9,4,16,7,28]),function(J,e,R,L,D,k,A,P,w,b,n,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function h(M,q=E.UNLINK){if((0,A.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return q===E.UNLINK?f(M):S(M)}async function S(M){try{const q=(0,w.join)((0,L.tmpdir)(),(0,v.generateUuid)());try{await e.Promises.rename(M,q)}catch(W){return f(M)}f(q).catch(W=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function f(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function p(M){if((0,A.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");R.rmdirSync(M,{recursive:!0})}e.rimrafSync=p;async function m(M,q){return a(await(q?y(M):(0,D.promisify)(R.readdir)(M)))}async function y(M){try{return await(0,D.promisify)(R.readdir)(M,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const q=[],W=await m(M);for(const j of W){let x=!1,$=!1,G=!1;try{const U=await e.Promises.lstat((0,w.join)(M,j));x=U.isFile(),$=U.isDirectory(),G=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}q.push({name:j,isFile:()=>x,isDirectory:()=>$,isSymbolicLink:()=>G})}return q}function c(M){return a(R.readdirSync(M))}e.readdirSync=c;function a(M){return M.map(q=>typeof q=="string"?b.isMacintosh?(0,P.normalizeNFC)(q):q:(q.name=b.isMacintosh?(0,P.normalizeNFC)(q.name):q.name,q))}async function t(M){const q=await m(M),W=[];for(const j of q)await r.existsDirectory((0,w.join)(M,j))&&W.push(j);return W}function s(M,q=1e3){return new Promise(W=>{let j=!1;const x=setInterval(()=>{j||(j=!0,R.access(M,$=>{j=!1,$&&(clearInterval(x),W(void 0))}))},q)})}e.whenDeleted=s;var r;(function(M){async function q(x){let $;try{if($=await e.Promises.lstat(x),!$.isSymbolicLink())return{stat:$}}catch(G){}try{return{stat:await e.Promises.stat(x),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(b.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw U}throw G}}M.stat=q;async function W(x){try{const{stat:$,symbolicLink:G}=await M.stat(x);return $.isFile()&&G?.dangling!==!0}catch($){}return!1}M.existsFile=W;async function j(x){try{const{stat:$,symbolicLink:G}=await M.stat(x);return $.isDirectory()&&G?.dangling!==!0}catch($){}return!1}M.existsDirectory=j})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new k.ResourceQueue;function o(M,q,W){return i.queueFor(I.URI.file(M),n.extUriBiasedIgnorePathCase).queue(()=>{const j=g(W);return new Promise((x,$)=>u(M,q,j,G=>G?$(G):x()))})}let l=!0;function u(M,q,W,j){if(!l)return R.writeFile(M,q,{mode:W.mode,flag:W.flag},j);R.open(M,W.flag,W.mode,(x,$)=>{if(x)return j(x);R.writeFile($,q,G=>{if(G)return R.close($,()=>j(G));R.fdatasync($,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),l=!1),R.close($,V=>j(V))))})})}function d(M,q,W){const j=g(W);if(!l)return R.writeFileSync(M,q,{mode:j.mode,flag:j.flag});const x=R.openSync(M,j.flag,j.mode);try{R.writeFileSync(x,q);try{R.fdatasyncSync(x)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),l=!1}}finally{R.closeSync(x)}}e.writeFileSync=d;function g(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function T(M,q){if(M===q)return;async function W(j){try{const x=await e.Promises.lstat(j);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(j,x.atime,new Date)}catch(x){}}try{await e.Promises.rename(M,q),await W(q)}catch(j){if(M.toLowerCase()!==q.toLowerCase()&&j.code==="EXDEV"||M.endsWith("."))await _(M,q,{preserveSymlinks:!1}),await h(M,E.MOVE),await W(q);else throw j}}async function _(M,q,W){return F(M,q,{root:{source:M,target:q},options:W,handledSourcePaths:new Set})}const O=511;async function F(M,q,W){if(W.handledSourcePaths.has(M))return;W.handledSourcePaths.add(M);const{stat:j,symbolicLink:x}=await r.stat(M);if(x){if(W.options.preserveSymlinks)try{return await z(M,q,W)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(x.dangling)return}return j.isDirectory()?C(M,q,j.mode&O,W):N(M,q,j.mode&O)}async function C(M,q,W,j){await e.Promises.mkdir(q,{recursive:!0,mode:W});const x=await m(M);for(const $ of x)await F((0,w.join)(M,$),(0,w.join)(q,$),j)}async function N(M,q,W){await e.Promises.copyFile(M,q),await e.Promises.chmod(q,W)}async function z(M,q,W){let j=await e.Promises.readlink(M);(0,A.isEqualOrParent)(j,W.root.source,!b.isLinux)&&(j=(0,w.join)(W.root.target,j.substr(W.root.source.length+1))),await e.Promises.symlink(j,q)}e.Promises=new class{get access(){return(0,D.promisify)(R.access)}get stat(){return(0,D.promisify)(R.stat)}get lstat(){return(0,D.promisify)(R.lstat)}get utimes(){return(0,D.promisify)(R.utimes)}get read(){return(0,D.promisify)(R.read)}get readFile(){return(0,D.promisify)(R.readFile)}get write(){return(0,D.promisify)(R.write)}get appendFile(){return(0,D.promisify)(R.appendFile)}get fdatasync(){return(0,D.promisify)(R.fdatasync)}get truncate(){return(0,D.promisify)(R.truncate)}get rename(){return(0,D.promisify)(R.rename)}get copyFile(){return(0,D.promisify)(R.copyFile)}get open(){return(0,D.promisify)(R.open)}get close(){return(0,D.promisify)(R.close)}get symlink(){return(0,D.promisify)(R.symlink)}get readlink(){return(0,D.promisify)(R.readlink)}get chmod(){return(0,D.promisify)(R.chmod)}get mkdir(){return(0,D.promisify)(R.mkdir)}get unlink(){return(0,D.promisify)(R.unlink)}get rmdir(){return(0,D.promisify)(R.rmdir)}get realpath(){return(0,D.promisify)(R.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return t}get writeFile(){return o}get rm(){return h}get move(){return T}get copy(){return _}}}),define(te[113],ne([0,1,53,9,25,19]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(n){const I=(0,L.dirname)(n);if(n===I)return n;const v=((0,L.basename)(n)||n).toLowerCase();try{const h=(0,k.readdirSync)(I).filter(S=>S.toLowerCase()===v);if(h.length===1){const S=A(I);if(S)return(0,L.join)(S,h[0])}else if(h.length>1){const S=h.indexOf(v);if(S>=0){const f=A(I);if(f)return(0,L.join)(f,h[S])}}}catch(E){}return null}e.realcaseSync=A;async function P(n){try{return await k.Promises.realpath(n)}catch(I){const v=b(n);return await k.Promises.access(v,R.constants.R_OK),v}}e.realpath=P;function w(n){try{return R.realpathSync(n)}catch(I){const v=b(n);return R.accessSync(v,R.constants.R_OK),v}}e.realpathSync=w;function b(n){return(0,D.rtrim)((0,L.normalize)(n),L.sep)}}),define(te[114],ne([0,1,57]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(P,w,b,n=1){let I=!1;return new Promise(v=>{const E=setTimeout(()=>{if(!I)return I=!0,v(0)},b);D(P,w,n,h=>{if(!I)return I=!0,clearTimeout(E),v(h)})})}e.findFreePort=L;function D(P,w,b,n){if(w===0)return n(0);const I=new R.Socket;I.once("connect",()=>(A(I),D(P+b,w-1,b,n))),I.once("data",()=>{}),I.once("error",v=>(A(I),v.code!=="ECONNREFUSED"?D(P+b,w-1,b,n):n(P))),I.connect(P,"127.0.0.1")}function k(P,w,b){let n=!1,I,v=1;const E=R.createServer({pauseOnConnect:!0});function h(S,f){n||(n=!0,E.removeAllListeners(),E.close(),I&&clearTimeout(I),f(S))}return new Promise(S=>{I=setTimeout(()=>{h(0,S)},b),E.on("listening",()=>{h(P,S)}),E.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&v<w?(P++,v++,E.listen(P,"127.0.0.1")):h(0,S)}),E.on("close",()=>{h(0,S)}),E.listen(P,"127.0.0.1")})}e.findFreePortFaster=k;function A(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(w){console.error(w)}}}),define(te[70],ne([0,1,33,9,19]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var w;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(w||(w={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class I{constructor(a,t,s){this.exePath=a,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:c=!1}={}){return c?b===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:c=!1,findPreview:a=!1}={}){const t=v({useAlternateBitness:c});if(!t)return null;const s=L.join(t,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(s))return null;let r=-1,i=null;for(const u of await D.Promises.readdir(s)){let d=-1;if(a){const T=u.indexOf("-");if(T<0)continue;const _=u.substring(0,T);if(!k.test(_)||u.substring(T+1)!=="preview")continue;d=parseInt(_,10)}else{if(!k.test(u))continue;d=parseInt(u,10)}if(d<=r)continue;const g=L.join(s,u,"pwsh.exe");!await D.SymlinkSupport.existsFile(g)||(i=g,r=d)}if(!i)return null;const o=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new I(i,`PowerShell${l}${o}`,!0)}async function h({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const a=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=c?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await D.Promises.readdir(a))if(t.test(r)){const i=L.join(a,r,"pwsh.exe");return new I(i,s)}return null}function S(){const c=L.join(R.homedir(),".dotnet","tools","pwsh.exe");return new I(c,".NET Core PowerShell Global Tool")}function f(){const c=L.join(process.env.windir,b===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(c,"Windows PowerShell",!0)}async function*p(){let c=await E();c&&(yield c),c=await E({useAlternateBitness:!0}),c&&(yield c),c=await h(),c&&(yield c),c=S(),c&&(yield c),c=await E({findPreview:!0}),c&&(yield c),c=await h({findPreview:!0}),c&&(yield c),c=await E({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=f(),c&&(yield c)}async function*m(){for await(const c of p())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=m;async function y(){for await(const c of m())return c;return null}e.getFirstAvailablePowerShellInstallation=y}),define(te[115],ne([0,1,41,15]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(A){return new Promise((P,w)=>{let b;const n=new Map;function I(E,h,S,f,p){const m=n.get(h);if(E===A||m){const y={name:v(S),cmd:S,pid:E,ppid:h,load:f,mem:p};n.set(E,y),E===A&&(b=y),m&&(m.children||(m.children=[]),m.children.push(y),m.children.length>1&&(m.children=m.children.sort((c,a)=>c.pid-a.pid)))}}function v(E){const h=/--disable-blink-features=Auxclick/,S=/\\watcher\\win32\\CodeHelper\.exe/,f=/--crashes-directory/,p=/\\pipe\\winpty-control/,m=/conhost\.exe/,y=/--type=([a-zA-Z-]+)/;if(S.exec(E))return"watcherService ";if(f.exec(E))return"electron-crash-reporter";if(p.exec(E))return"winpty-process";if(m.exec(E))return"console-window-host (Windows internal process)";let c=y.exec(E);if(c&&c.length===2)return c[1]==="renderer"?h.exec(E)?"shared-process":"window":c[1];const a=/[a-zA-Z-]+\.js/g;let t="";do c=a.exec(E),c&&(t+=c+" ");while(c);return t&&E.indexOf("node ")<0&&E.indexOf("node.exe")<0?`electron_node ${t}`:E}if(process.platform==="win32"){const E=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,S)=>{J(["windows-process-tree"],h,S)}).then(h=>{h.getProcessList(A,S=>{h.getProcessCpuUsage(S,f=>{const p=new Map;f.forEach(m=>{const y=E(m.commandLine||"");p.set(m.pid,{name:v(y),cmd:y,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),b=p.get(A),b?(p.forEach(m=>{const y=p.get(m.ppid);y&&(y.children||(y.children=[]),y.children.push(m))}),p.forEach(m=>{m.children&&(m.children=m.children.sort((y,c)=>y.pid-c.pid))}),P(b)):w(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let E=function(){let h=[b];const S=[];for(;h.length;){const p=h.shift();p&&(S.push(p.pid),p.children&&(h=h.concat(p.children)))}let f=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);f+=" "+S.join(" "),(0,R.exec)(f,{},(p,m,y)=>{if(p||y)w(p||new Error(y.toString()));else{const c=m.toString().split(`
`);for(let a=0;a<S.length;a++){const t=n.get(S[a]);t.load=parseFloat(c[a])}if(!b){w(new Error(`Root process ${A} not found`));return}P(b)}})};(0,R.exec)("which ps",{},(h,S,f)=>{if(h||f)if(process.platform!=="linux")w(h||new Error(f.toString()));else{const p=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,R.exec)(p,{},(m,y,c)=>{m||c?w(m||new Error(c.toString())):(k(y,I),E())})}else{const p=S.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${p} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,c,a)=>{y||a&&!a.includes("screen size is bogus")?w(y||new Error(a.toString())):(k(c,I),process.platform==="linux"?E():b?P(b):w(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=D;function k(A,P){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=A.toString().split(`
`);for(const n of b){const I=w.exec(n.trim());I&&I.length===6&&P(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(te[116],ne([0,1,53,27,39,2,69,9,4,19]),function(J,e,R,L,D,k,A,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function n(h,S,f){return v({path:h,isDirectory:!1},S,f)}e.watchFile=n;function I(h,S,f){return v({path:h,isDirectory:!0},S,f)}e.watchFolder=I,e.CHANGE_BUFFER_DELAY=100;function v(h,S,f){if(w.isMacintosh&&(0,D.isEqualOrParent)(h.path,"/Volumes/"))return f(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const p=(0,P.basename)(h.path),m=new Map;let y=!1,c=[(0,k.toDisposable)(()=>{m.forEach(a=>(0,k.dispose)(a)),m.clear()})];try{const a=(0,R.watch)(h.path);c.push((0,k.toDisposable)(()=>{a.removeAllListeners(),a.close()}));const t=new Set;h.isDirectory&&b.Promises.readdir(h.path).then(s=>s.forEach(r=>t.add(r))),a.on("error",(s,r)=>{y||f(`Failed to watch ${h.path} for changes using fs.watch() (${s}, ${r})`)}),a.on("change",(s,r)=>{if(y)return;let i="";if(r&&(i=r.toString(),w.isMacintosh&&(i=(0,A.normalizeNFC)(i))),!i||s!=="change"&&s!=="rename")return;const o=h.isDirectory?(0,P.join)(h.path,i):h.path;if(h.isDirectory)if(s==="rename"){const l=m.get(o);l&&(0,k.dispose)(l);const u=setTimeout(async()=>{m.delete(o);const d=await b.Promises.exists(o);if(y)return;let g;d?t.has(i)?g="changed":(g="added",t.add(i)):(t.delete(i),g="deleted"),S(g,o)},e.CHANGE_BUFFER_DELAY);m.set(o,(0,k.toDisposable)(()=>clearTimeout(u)))}else{let l;t.has(i)?l="changed":(l="added",t.add(i)),S(l,o)}else if(s==="rename"||i!==p){const l=setTimeout(async()=>{const u=await b.Promises.exists(o);y||(u?(S("changed",o),c=[v(h,S,f)]):S("deleted",o))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(c),c=[(0,k.toDisposable)(()=>clearTimeout(l))]}else S("changed",o)})}catch(a){b.Promises.exists(h.path).then(t=>{t&&!y&&f(`Failed to watch ${h.path} for changes using fs.watch() (${a.toString()})`)})}return(0,k.toDisposable)(()=>{y=!0,c=(0,k.dispose)(c)})}async function E(h,S,f,p=512){const m=await b.Promises.open(h,"r"),y=Buffer.allocUnsafe(p),c=new L.CancellationTokenSource(f);let a,t=!1;const s=n(h,async r=>{if(r==="changed"){if(t)return;t=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:i}=await b.Promises.read(m,y,0,p,null);if(!i||c.token.isCancellationRequested)break;S(y.slice(0,i))}}catch(i){a=new Error(i),c.dispose(!0)}finally{t=!1}}},r=>{a=new Error(r),c.dispose(!0)});return new Promise((r,i)=>{c.token.onCancellationRequested(async()=>{s.dispose(),await b.Promises.close(m),a?i(a):r()})})}e.watchFileContents=E});var he=this&&this.__decorate||function(J,e,R,L){var D=arguments.length,k=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,R):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(J,e,R,L);else for(var P=J.length-1;P>=0;P--)(A=J[P])&&(k=(D<3?A(k):D>3?A(e,R,k):A(e,R))||k);return D>3&&k&&Object.defineProperty(e,R,k),k};define(te[32],ne([0,1,17,5,22,27,67,8,3,2,105,25,18]),function(J,e,R,L,D,k,A,P,w,b,n,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function h(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function f(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(p||(p={}));class m{constructor($){this.buffer=$,this.pos=0}read($){const G=this.buffer.slice(this.pos,this.pos+$);return this.pos+=G.byteLength,G}}class y{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}var c;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(c||(c={}));function a(x){const $=D.VSBuffer.alloc(4);return $.writeUInt32BE(x,0),$}function t(x){return x.read(4).readUInt32BE(0)}function s(x){const $=D.VSBuffer.alloc(1);return $.writeUInt8(x,0),$}const r={Undefined:s(c.Undefined),String:s(c.String),Buffer:s(c.Buffer),VSBuffer:s(c.VSBuffer),Array:s(c.Array),Object:s(c.Object)},i=typeof Buffer!="undefined";function o(x,$){if(typeof $=="undefined")x.write(r.Undefined);else if(typeof $=="string"){const G=D.VSBuffer.fromString($);x.write(r.String),x.write(a(G.byteLength)),x.write(G)}else if(i&&Buffer.isBuffer($)){const G=D.VSBuffer.wrap($);x.write(r.Buffer),x.write(a(G.byteLength)),x.write(G)}else if($ instanceof D.VSBuffer)x.write(r.VSBuffer),x.write(a($.byteLength)),x.write($);else if(Array.isArray($)){x.write(r.Array),x.write(a($.length));for(const G of $)o(x,G)}else{const G=D.VSBuffer.fromString(JSON.stringify($));x.write(r.Object),x.write(a(G.byteLength)),x.write(G)}}function l(x){switch(x.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return x.read(t(x)).toString();case c.Buffer:return x.read(t(x)).buffer;case c.VSBuffer:return x.read(t(x));case c.Array:{const G=t(x),U=[];for(let V=0;V<G;V++)U.push(l(x));return U}case c.Object:return JSON.parse(x.read(t(x)).toString())}}class u{constructor($,G,U=null,V=1e3){this.protocol=$,this.ctx=G,this.logger=U,this.timeoutDelay=V,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel($,G){this.channels.set($,G),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const G=this.send([$.type]);this.logger&&this.logger.logOutgoing(G,0,1,f($.type));return}case 201:case 202:case 204:case 203:{const G=this.send([$.type,$.id],$.data);this.logger&&this.logger.logOutgoing(G,$.id,1,f($.type),$.data);return}}}send($,G=void 0){const U=new y;return o(U,$),o(U,G),this.sendBuffer(U.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch(G){return 0}}onRawMessage($){const G=new m($),U=l(G),V=l(G),B=U[0];switch(B){case 100:return this.logger&&this.logger.logIncoming($.byteLength,U[1],1,`${h(B)}: ${U[2]}.${U[3]}`,V),this.onPromise({type:B,id:U[1],channelName:U[2],name:U[3],arg:V});case 102:return this.logger&&this.logger.logIncoming($.byteLength,U[1],1,`${h(B)}: ${U[2]}.${U[3]}`,V),this.onEventListen({type:B,id:U[1],channelName:U[2],name:U[3],arg:V});case 101:return this.logger&&this.logger.logIncoming($.byteLength,U[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:U[1]});case 103:return this.logger&&this.logger.logIncoming($.byteLength,U[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:U[1]})}}onPromise($){const G=this.channels.get($.channelName);if(!G){this.collectPendingRequest($);return}const U=new k.CancellationTokenSource;let V;try{V=G.call(this.ctx,$.name,$.arg,U.token)}catch(Z){V=Promise.reject(Z)}const B=$.id;V.then(Z=>{this.sendResponse({id:B,data:Z,type:201}),this.activeRequests.delete($.id)},Z=>{Z instanceof Error?this.sendResponse({id:B,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:B,data:Z,type:203}),this.activeRequests.delete($.id)});const Q=(0,b.toDisposable)(()=>U.cancel());this.activeRequests.set($.id,Q)}onEventListen($){const G=this.channels.get($.channelName);if(!G){this.collectPendingRequest($);return}const U=$.id,B=G.listen(this.ctx,$.name,$.arg)(Q=>this.sendResponse({id:U,data:Q,type:204}));this.activeRequests.set($.id,B)}disposeActiveRequest($){const G=this.activeRequests.get($.id);G&&(G.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let G=this.pendingRequests.get($.channelName);G||(G=[],this.pendingRequests.set($.channelName,G));const U=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:$,timeoutTimer:U})}flushPendingRequests($){const G=this.pendingRequests.get($);if(G){for(const U of G)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach($=>$.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var d;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class g{constructor($,G=null){this.protocol=$,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=G}getChannel($){const G=this;return{call(U,V,B){return G.isDisposed?Promise.reject(P.canceled()):G.requestPromise($,U,V,B)},listen(U,V){return G.isDisposed?Promise.reject(P.canceled()):G.requestEvent($,U,V)}}}requestPromise($,G,U,V=k.CancellationToken.None){const B=this.lastRequestId++,Z={id:B,type:100,channelName:$,name:G,arg:U};if(V.isCancellationRequested)return Promise.reject(P.canceled());let K;return new Promise((re,ie)=>{if(V.isCancellationRequested)return ie(P.canceled());const ce=()=>{const be=Ce=>{switch(Ce.type){case 201:this.handlers.delete(B),re(Ce.data);break;case 202:this.handlers.delete(B);const Ee=new Error(Ce.data.message);Ee.stack=Ce.data.stack,Ee.name=Ce.data.name,ie(Ee);break;case 203:this.handlers.delete(B),ie(Ce.data);break}};this.handlers.set(B,be),this.sendRequest(Z)};let le=null;this.state===p.Idle?ce():(le=(0,L.createCancelablePromise)(be=>this.whenInitialized()),le.then(()=>{le=null,ce()}));const de=()=>{le?(le.cancel(),le=null):this.sendRequest({id:B,type:101}),ie(P.canceled())},fe=V.onCancellationRequested(de);K=(0,b.combinedDisposable)((0,b.toDisposable)(de),fe),this.activeRequests.add(K)}).finally(()=>{this.activeRequests.delete(K)})}requestEvent($,G,U){const V=this.lastRequestId++,Q={id:V,type:102,channelName:$,name:G,arg:U};let Z=null;const K=new w.Emitter({onFirstListenerAdd:()=>{Z=(0,L.createCancelablePromise)(re=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(K),this.sendRequest(Q)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(K),this.sendRequest({id:V,type:103}))}}),H=re=>K.fire(re.data);return this.handlers.set(V,H),K.event}sendRequest($){switch($.type){case 100:case 102:{const G=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger&&this.logger.logOutgoing(G,$.id,0,`${h($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const G=this.send([$.type,$.id]);this.logger&&this.logger.logOutgoing(G,$.id,0,h($.type));return}}}send($,G=void 0){const U=new y;return o(U,$),o(U,G),this.sendBuffer(U.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch(G){return 0}}onBuffer($){const G=new m($),U=l(G),V=l(G),B=U[0];switch(B){case 200:return this.logger&&this.logger.logIncoming($.byteLength,0,0,f(B)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming($.byteLength,U[1],0,f(B),V),this.onResponse({type:U[0],id:U[1],data:V})}}onResponse($){if($.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const G=this.handlers.get($.id);G&&G($)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach($=>$.dispose()),this.activeRequests.clear()}}he([A.memoize],g.prototype,"onDidInitializePromise",null),e.ChannelClient=g;class T{constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,$(({protocol:G,onDidClientDisconnect:U})=>{w.Event.once(G.onMessage)(B=>{const Q=new m(B),Z=l(Q),K=new u(G,Z),H=new g(G);this.channels.forEach((ie,ce)=>K.registerChannel(ce,ie));const re={channelServer:K,channelClient:H,ctx:Z};this._connections.add(re),this._onDidAddConnection.fire(re),U(()=>{K.dispose(),H.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const $=[];return this._connections.forEach(G=>$.push(G)),$}getChannel($,G){const U=this;return{call(V,B,Q){let Z;if((0,v.isFunction)(G)){let H=(0,R.getRandomElement)(U.connections.filter(G));Z=H?Promise.resolve(H):w.Event.toPromise(w.Event.filter(U.onDidAddConnection,G))}else Z=G.routeCall(U,V,B);const K=Z.then(H=>H.channelClient.getChannel($));return O(K).call(V,B,Q)},listen(V,B){if((0,v.isFunction)(G))return U.getMulticastEvent($,G,V,B);const Q=G.routeEvent(U,V,B).then(Z=>Z.channelClient.getChannel($));return O(Q).listen(V,B)}}}getMulticastEvent($,G,U,V){const B=this;let Q=new b.DisposableStore;const Z=new w.Emitter({onFirstListenerAdd:()=>{Q=new b.DisposableStore;const K=new w.EventMultiplexer,H=new Map,re=ce=>{const de=ce.channelClient.getChannel($).listen(U,V),fe=K.add(de);H.set(ce,fe)},ie=ce=>{const le=H.get(ce);!le||(le.dispose(),H.delete(ce))};B.connections.filter(G).forEach(re),w.Event.filter(B.onDidAddConnection,G)(re,void 0,Q),B.onDidRemoveConnection(ie,void 0,Q),K.event(Z.fire,Z,Q),Q.add(K)},onLastListenerRemove:()=>{Q.dispose()}});return Z.event}registerChannel($,G){this.channels.set($,G),this._connections.forEach(U=>{U.channelServer.registerChannel($,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class _{constructor($,G,U=null){const V=new y;o(V,G),$.send(V.buffer),this.channelClient=new g($,U),this.channelServer=new u($,G,U)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,G){this.channelServer.registerChannel($,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(x){return{call($,G,U){return x.then(V=>V.call($,G,U))},listen($,G){const U=new w.Relay;return x.then(V=>U.input=V.listen($,G)),U.event}}}e.getDelayedChannel=O;function F(x){let $=!1;return{call(G,U,V){return $?x.call(G,U,V):(0,L.timeout)(0).then(()=>$=!0).then(()=>x.call(G,U,V))},listen(G,U){if($)return x.listen(G,U);const V=new w.Relay;return(0,L.timeout)(0).then(()=>$=!0).then(()=>V.input=x.listen(G,U)),V.event}}}e.getNextTickChannel=F;class C{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const G of $.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await w.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=C;var N;(function(x){function $(B,Q){const Z=B,K=Q&&Q.disableMarshalling,H=new Map;for(const re in Z)U(re)&&H.set(re,w.Event.buffer(Z[re],!0));return new class{listen(re,ie,ce){const le=H.get(ie);if(le)return le;if(V(ie)){const de=Z[ie];if(typeof de=="function")return de.call(Z,ce)}throw new Error(`Event not found: ${ie}`)}call(re,ie,ce){const le=Z[ie];if(typeof le=="function"){if(!K&&Array.isArray(ce))for(let de=0;de<ce.length;de++)ce[de]=(0,n.revive)(ce[de]);return le.apply(Z,ce)}throw new Error(`Method not found: ${ie}`)}}}x.fromService=$;function G(B,Q){const Z=Q&&Q.disableMarshalling;return new Proxy({},{get(K,H){if(typeof H=="string")return Q?.properties?.has(H)?Q.properties.get(H):V(H)?function(re){return B.listen(H,re)}:U(H)?B.listen(H):async function(...re){let ie;Q&&!(0,v.isUndefinedOrNull)(Q.context)?ie=[Q.context,...re]:ie=re;const ce=await B.call(H,ie);return Z?ce:(0,n.revive)(ce)};throw new Error(`Property not found: ${String(H)}`)}})}x.toService=G;function U(B){return B[0]==="o"&&B[1]==="n"&&I.isUpperAsciiLetter(B.charCodeAt(2))}function V(B){return/^onDynamic/.test(B)&&I.isUpperAsciiLetter(B.charCodeAt(9))}})(N=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let $=x.toString();if($!=="[object Object]")return $}return x}function q(x){return Array.isArray(x)?x.map(M):M(x)}function W(x,$,G,U,V,B,Q){Q=q(Q);const Z=z[V],K=Z[U%Z.length];let H=[`%c[${x}]%c[${String($).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${K}`];/\($/.test(B)?(H=H.concat(Q),H.push(")")):H.push(Q),console.log.apply(console,H)}e.logWithColors=W;class j{constructor($,G){this._outgoingPrefix=$,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,G,U,V,B){this._totalOutgoing+=$,W(this._outgoingPrefix,this._totalOutgoing,$,G,U,V,B)}logIncoming($,G,U,V,B){this._totalIncoming+=$,W(this._incomingPrefix,this._totalIncoming,$,G,U,V,B)}}e.IPCLogger=j}),define(te[117],ne([0,1,22,3,32]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(w){this.port=w,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",b=>R.VSBuffer.wrap(b.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class A extends D.IPCClient{constructor(w,b){const n=new k(w);super(n,b);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=A}),define(te[71],ne([0,1,22,3,2,4,31,32]),function(J,e,R,L,D,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var w;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function n(){return b||(b=R.VSBuffer.alloc(0)),b}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,o){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const g=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=i),g}if(this._chunks[0].byteLength>i){const g=this._chunks[0].slice(0,i);return o&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),g}let l=R.VSBuffer.alloc(i),u=0,d=0;for(;i>0;){const g=this._chunks[d];if(g.byteLength>i){const T=g.slice(0,i);l.set(T,u),u+=i,o&&(this._chunks[d]=g.slice(i),this._totalLength-=i),i-=i}else l.set(g,u),u+=g.byteLength,o?(this._chunks.shift(),this._totalLength-=g.byteLength):d++,i-=g.byteLength}return l}}e.ChunkStream=I;var v;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(v||(v={}));var E;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(i,o,l,u){this.type=i,this.id=o,this.ack=l,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class S extends D.Disposable{constructor(i){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const l=this._state.messageType,u=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(l,u,d,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=R.VSBuffer.alloc(13);o.writeUInt8(i.type,0),o.writeUInt32BE(i.id,1),o.writeUInt32BE(i.ack,5),o.writeUInt32BE(i.data.byteLength,9),this._writeSoon(o,i.data)}_bufferAdd(i,o){const l=this._totalLength===0;return this._data.push(i,o),this._totalLength+=i.byteLength+o.byteLength,l}_bufferTake(){const i=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,o){this._bufferAdd(i,o)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class p extends D.Disposable{constructor(i){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new S(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new h(1,0,0,i))}}e.Protocol=p;class m extends P.IPCClient{constructor(i,o,l=null){super(i,o,l);this.protocol=i}static fromSocket(i,o){return new m(new p(i),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=m;class y{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,A.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=y;class c{constructor(i){this.data=i,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],o=0,l=this._first;for(;l;)i[o++]=l.data,l=l.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const o=new c(i);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let o=0;o<t._HISTORY_LENGTH;o++)this.lastRuns[o]=i-1e3*o;setInterval(()=>{for(let o=t._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),o=(1+t._HISTORY_LENGTH)*1e3;let l=0;for(let u=0;u<t._HISTORY_LENGTH;u++)i-this.lastRuns[u]<=o&&l++;return 1-l/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(i,o=null,l=t.getInstance()){this._onControlMessage=new y,this.onControlMessage=this._onControlMessage.event,this._onMessage=new y,this.onMessage=this._onMessage.event,this._onDidDispose=new y,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new y,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new y,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new S(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new h(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const o=new h(4,0,0,n());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,o){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new S(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let o=0,l=i.length;o<l;o++)this._socketWriter.write(i[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new h(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const o=this._outgoingUnackMsg.toArray();for(let l=0,u=o.length;l<u;l++)this._socketWriter.write(o[l]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new h(1,o,this._incomingAckId,i);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(i){const o=new h(2,0,0,i);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),o=Date.now()-i.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new h(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=s}),define(te[118],ne([0,1,72,3,32,117]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends D.IPCServer{static getOnDidClientConnect(){const w=L.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(b,n)=>n);return L.Event.map(w,b=>{const{port1:n,port2:I}=new MessageChannel,E={protocol:new k.Protocol(n),onDidClientDisconnect:L.Event.fromDOMEventEmitter(n,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[I]),E})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(te[119],ne([0,1,22,8]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(P,w){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((n,I)=>{b.open(P.type||"GET",P.url||"",!0,P.user,P.password),k(b,P),b.responseType="arraybuffer",b.onerror=v=>I(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=v=>{n({res:{statusCode:b.status,headers:A(b)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=v=>I(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(b.timeout=P.timeout),b.send(P.data),w.onCancellationRequested(()=>{b.abort(),I((0,L.canceled)())})})}e.request=D;function k(P,w){if(w.headers){e:for(let b in w.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(b,w.headers[b])}}}function A(P){const w=Object.create(null);for(const b of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const n=b.indexOf(":");w[b.substr(0,n).trim().toLowerCase()]=b.substr(n+1).trim()}return w}}),define(te[73],ne([0,1,5,3,2,18]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function P(I){const v=I;return v?.changed instanceof Map||v?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var w;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(w||(w={}));class b extends D.Disposable{constructor(v,E=Object.create(null)){super();this.database=v,this.options=E,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=w.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){v.changed?.forEach((E,h)=>this.accept(h,E)),v.deleted?.forEach(E=>this.accept(E,void 0))}accept(v,E){if(this.state===w.Closed)return;let h=!1;(0,k.isUndefinedOrNull)(E)?h=this.cache.delete(v):this.cache.get(v)!==E&&(this.cache.set(v,E),h=!0),h&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===w.None&&(this.state=w.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,E){const h=this.cache.get(v);return(0,k.isUndefinedOrNull)(h)?E:h}getBoolean(v,E){const h=this.get(v);return(0,k.isUndefinedOrNull)(h)?E:h==="true"}getNumber(v,E){const h=this.get(v);return(0,k.isUndefinedOrNull)(h)?E:parseInt(h,10)}async set(v,E){if(this.state===w.Closed)return;if((0,k.isUndefinedOrNull)(E))return this.delete(v);const h=String(E);if(this.cache.get(v)!==h)return this.cache.set(v,h),this.pendingInserts.set(v,h),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async delete(v){if(!(this.state===w.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=w.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(v){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class n{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert&&v.insert.forEach((E,h)=>this.items.set(h,E)),v.delete&&v.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=n}),define(te[120],ne([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[58],ne([0,1,120]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,k=D*24,A=k*7,P=k*30,w=k*365;function b(I,v){typeof I!="number"&&(I=I.getTime());const E=Math.round((new Date().getTime()-I)/1e3);if(E<-30)return(0,R.localize)(0,null,b(new Date().getTime()+E*1e3,!1));if(E<30)return(0,R.localize)(1,null);let h;return E<L?(h=E,v?h===1?(0,R.localize)(2,null,h):(0,R.localize)(3,null,h):h===1?(0,R.localize)(4,null,h):(0,R.localize)(5,null,h)):E<D?(h=Math.floor(E/L),v?h===1?(0,R.localize)(6,null,h):(0,R.localize)(7,null,h):h===1?(0,R.localize)(8,null,h):(0,R.localize)(9,null,h)):E<k?(h=Math.floor(E/D),v?h===1?(0,R.localize)(10,null,h):(0,R.localize)(11,null,h):h===1?(0,R.localize)(12,null,h):(0,R.localize)(13,null,h)):E<A?(h=Math.floor(E/k),v?h===1?(0,R.localize)(14,null,h):(0,R.localize)(15,null,h):h===1?(0,R.localize)(16,null,h):(0,R.localize)(17,null,h)):E<P?(h=Math.floor(E/A),v?h===1?(0,R.localize)(18,null,h):(0,R.localize)(19,null,h):h===1?(0,R.localize)(20,null,h):(0,R.localize)(21,null,h)):E<w?(h=Math.floor(E/P),v?h===1?(0,R.localize)(22,null,h):(0,R.localize)(23,null,h):h===1?(0,R.localize)(24,null,h):(0,R.localize)(25,null,h)):(h=Math.floor(E/w),v?h===1?(0,R.localize)(26,null,h):(0,R.localize)(27,null,h):h===1?(0,R.localize)(28,null,h):(0,R.localize)(29,null,h))}e.fromNow=b;function n(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(te[121],ne([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[37],ne([0,1,17,18,121]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(b,n){return n&&(b.stack||b.stacktrace)?D.localize(0,null,P(b),A(b.stack)||A(b.stacktrace)):P(b)}function A(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?D.localize(1,null,b.message):b.message||D.localize(2,null)}function w(b=null,n=!1){if(!b)return D.localize(3,null);if(Array.isArray(b)){const I=R.coalesce(b),v=w(I[0],n);return I.length>1?D.localize(4,null,v,I.length):v}if(L.isString(b))return b;if(b.detail){const I=b.detail;if(I.error)return k(I.error,n);if(I.exception)return k(I.exception,n)}return b.stack?k(b,n):b.message?b.message:D.localize(5,null)}e.toErrorMessage=w}),define(te[122],ne([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(te[74],ne([0,1,41,39,15,26,9,4,31,101,18,109,19,122]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function h(t){switch(t){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(t,s){if(P.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};s&&(r.cwd=s);const i=R.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],r);return new Promise(o=>{i.once("error",l=>{o({success:!1,error:l})}),i.once("exit",(l,u)=>{o(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?h(r.status):1})}else if(P.isLinux||P.isMacintosh)try{const r=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(i=>{R.execFile(r,[t.pid.toString()],{encoding:"utf8",shell:!0},(o,l,u)=>{i(o?{success:!1,error:o}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}function f(t){!t||(delete t.DEBUG,P.isMacintosh&&delete t.DYLD_LIBRARY_PATH,P.isLinux&&delete t.LD_PRELOAD)}e.removeDangerousEnvVariables=f;function p(t=w.env){return t.comspec||"cmd.exe"}e.getWindowsShell=p;class m{constructor(s,r,i,o){if(r!==void 0&&i!==void 0&&o!==void 0)this.cmd=s,this.args=r,this.shell=i,this.options=o;else{const l=s;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(w.env).forEach(u=>{l[u]=w.env[u]}),Object.keys(this.options.env).forEach(u=>{l[u]=this.options.env[u]}),this.options.env=l}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const r=s.lastIndexOf(A.sep);return r!==-1&&(s=s.substring(r+1)),m.WellKnowCommands[s]?s:"other"}start(s){return P.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(w.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(r=>{let i,o;const l=new Promise((u,d)=>{i=u,o=d});if(r){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=R.exec(u,this.options,(d,g,T)=>{this.childProcess=null;const _=d;_&&_.killed?o({killed:this.terminateRequested,stdout:g.toString(),stderr:T.toString()}):this.handleExec(i,s,d,g,T)})}else{let u=null;const d=g=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(g,i,s,o);const T={terminated:this.terminateRequested};n.isNumber(g)&&(T.cmdCode=g),i(T)};if(this.shell&&P.isWindows){const g=k.deepClone(this.options);g.windowsVerbatimArguments=!0,g.detached=!1;let T=!1,_=!1;const O=[];let F=this.ensureQuotes(this.cmd);O.push(F.value),T=F.quoted,this.args&&this.args.forEach(N=>{F=this.ensureQuotes(N),O.push(F.value),_=_&&F.quoted});const C=["/s","/c"];T?_?C.push('"'+O.join(" ")+'"'):O.length>1?C.push('"'+O[0]+'" '+O.slice(1).join(" ")):C.push('"'+O[0]+'"'):C.push(O.join(" ")),u=R.spawn(p(),C,g)}else this.cmd&&(u=R.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(n.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",g=>{this.childProcess=null,o({terminated:this.terminateRequested,error:g})}),u.pid&&(this.childProcess.on("close",d),this.handleSpawn(u,i,s,o,!0)))}return l})}handleClose(s,r,i,o){}ensureQuotes(s){return m.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,S(s,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!P.isWindows)return s(!1);const r=R.spawn(p(),["/s","/c"]);r.on("error",i=>s(!0)),r.on("exit",i=>s(!1))})}}e.AbstractProcess=m,m.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},m.regexp=/^[^"].* .*[^"]/;class y extends m{constructor(s,r,i,o){super(s,r,i,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,r,i,o,l){[o,l].forEach((u,d)=>{const g=new I.LineDecoder;g.write(u).forEach(O=>{r({line:O,source:d===0?0:1})});const _=g.end();_&&r({line:_,source:d===0?0:1})}),s({terminated:this.terminateRequested,error:i})}handleSpawn(s,r,i,o,l){const u=new I.LineDecoder,d=new I.LineDecoder;s.stdout.on("data",g=>{u.write(g).forEach(_=>i({line:_,source:0}))}),s.stderr.on("data",g=>{d.write(g).forEach(_=>i({line:_,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=d}handleClose(s,r,i,o){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&i({line:l,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&i({line:u,source:1})}}e.LineProcess=y;function c(t){let s=[],r=!1;const i=function(o){if(r){s.push(o);return}(!t.send(o,u=>{if(u&&console.error(u),r=!1,s.length>0){const d=s.slice(0);s=[],d.forEach(g=>i(g))}})||P.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=c;var a;(function(t){async function s(r,i,o){if(A.isAbsolute(r))return r;if(i===void 0&&(i=w.cwd()),A.dirname(r)!=="."||(o===void 0&&n.isString(w.env.PATH)&&(o=w.env.PATH.split(A.delimiter)),o===void 0||o.length===0))return A.join(i,r);async function u(d){if(await v.Promises.exists(d)){let g;try{g=await v.Promises.stat(d)}catch(T){T.message.startsWith("EACCES")&&(g=await v.Promises.lstat(d))}return g?!g.isDirectory():!1}return!1}for(let d of o){let g;if(A.isAbsolute(d)?g=A.join(d,r):g=A.join(i,d,r),await u(g))return g;let T=g+".com";if(await u(T)||(T=g+".exe",await u(T)))return T}return A.join(i,r)}t.findExecutable=s})(a=e.win32||(e.win32={}))}),define(te[123],ne([0,1,33,4,70,74]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(E,h){return E===1?L.isWindows?I():k.getWindowsShell(h):b(E,h)}e.getSystemShell=A;function P(E,h){return E===1?L.isWindows?v(h):k.getWindowsShell(h):b(E,h)}e.getSystemShellSync=P;let w=null;function b(E,h){if(L.isLinux&&E===2||L.isMacintosh&&E===3)return"/bin/bash";if(!w){let S;if(L.isWindows)S="/bin/bash";else{if(S=h.SHELL,!S)try{S=(0,R.userInfo)().shell}catch(f){}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}w=S}return w}let n=null;async function I(){return n||(n=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),n}function v(E){if(n)return n;const h=L.isWindows&&parseFloat((0,R.release)())>=10,S=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${E.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?f:k.getWindowsShell(E)}}),define(te[45],ne([0,1,41,5,22,27,104,8,3,2,26,74,32]),function(J,e,R,L,D,k,A,P,w,b,n,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class E extends v.ChannelServer{constructor(f){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch(m){}},onMessage:w.Event.fromNodeEventEmitter(process,"message",p=>D.VSBuffer.wrap(Buffer.from(p,"base64")))},f);process.once("disconnect",()=>this.dispose())}}e.Server=E;class h{constructor(f,p){this.modulePath=f,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new w.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new L.Delayer(m),this.child=null,this._client=null}getChannel(f){const p=this;return{call(m,y,c){return p.requestPromise(f,m,y,c)},listen(m,y){return p.requestEvent(f,m,y)}}}requestPromise(f,p,m,y=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(f),a=(0,L.createCancelablePromise)(r=>c.call(p,m,r)),t=y.onCancellationRequested(()=>a.cancel()),s=(0,b.toDisposable)(()=>a.cancel());return this.activeRequests.add(s),a.finally(()=>{t.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(f,p,m){if(!this.disposeDelayer)return w.Event.None;this.disposeDelayer.cancel();let y;const c=new w.Emitter({onFirstListenerAdd:()=>{y=this.getCachedChannel(f).listen(p,m)(c.fire,c),this.activeRequests.add(y)},onLastListenerRemove:()=>{this.activeRequests.delete(y),y.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,n.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,I.removeDangerousEnvVariables)(p.env),this.child=(0,R.fork)(this.modulePath,f,p);const m=new w.Emitter;w.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,A.isRemoteConsoleLog)(i)){(0,A.log)(i,`IPC Library: ${this.options.serverName}`);return}m.fire(D.VSBuffer.wrap(Buffer.from(i,"base64")))});const c=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,a=i=>this.child&&this.child.connected&&c.send(i.buffer.toString("base64")),t=m.event,s={send:a,onMessage:t};this._client=new v.ChannelClient(s);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,o)=>{process.removeListener("exit",r),this.activeRequests.forEach(l=>(0,b.dispose)(l)),this.activeRequests.clear(),i!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:o})})}return this._client}getCachedChannel(f){let p=this.channels.get(f);return p||(p=this.client.getChannel(f),this.channels.set(f,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[124],ne([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[125],ne([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[126],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[127],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[128],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(te[129],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[130],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[131],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[132],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[133],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[134],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[135],ne([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[136],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[137],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[138],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[139],ne([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[140],ne([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[141],ne([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[142],ne([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[143],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[144],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[145],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[146],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[147],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[148],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[75],ne([0,1,58,67,15,9,31,16,7]),function(J,e,R,L,D,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(S,f,p){this._args=S,this.paths=f,this.productService=p}get appRoot(){return(0,k.dirname)(D.FileAccess.asFileUri("",J).fsPath)}get userHome(){return w.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return w.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(w.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return w.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return w.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=A.env.VSCODE_PORTABLE;return S?w.URI.file((0,k.join)(S,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,k.resolve)(S):(0,k.normalize)((0,k.join)(D.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,k.resolve)(S):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,k.resolve)(S);const f=A.env.VSCODE_EXTENSIONS;if(f)return f;const p=A.env.VSCODE_PORTABLE;return p?(0,k.join)(p,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(f=>/^[^:/?#]+?:\/\//.test(f)?w.URI.parse(f):w.URI.file((0,k.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?w.URI.parse(S):w.URI.file((0,k.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return w.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],b.prototype,"appRoot",null),he([L.memoize],b.prototype,"userHome",null),he([L.memoize],b.prototype,"userDataPath",null),he([L.memoize],b.prototype,"appSettingsHome",null),he([L.memoize],b.prototype,"tmpDir",null),he([L.memoize],b.prototype,"userRoamingDataHome",null),he([L.memoize],b.prototype,"settingsResource",null),he([L.memoize],b.prototype,"userDataSyncHome",null),he([L.memoize],b.prototype,"userDataSyncLogResource",null),he([L.memoize],b.prototype,"sync",null),he([L.memoize],b.prototype,"machineSettingsResource",null),he([L.memoize],b.prototype,"globalStorageHome",null),he([L.memoize],b.prototype,"workspaceStorageHome",null),he([L.memoize],b.prototype,"keybindingsResource",null),he([L.memoize],b.prototype,"keyboardLayoutResource",null),he([L.memoize],b.prototype,"argvResource",null),he([L.memoize],b.prototype,"snippetsHome",null),he([L.memoize],b.prototype,"isExtensionDevelopment",null),he([L.memoize],b.prototype,"untitledWorkspacesHome",null),he([L.memoize],b.prototype,"installSourcePath",null),he([L.memoize],b.prototype,"builtinExtensionsPath",null),he([L.memoize],b.prototype,"extensionsPath",null),he([L.memoize],b.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],b.prototype,"extensionDevelopmentKind",null),he([L.memoize],b.prototype,"extensionTestsLocationURI",null),he([L.memoize],b.prototype,"debugExtensionHost",null),he([L.memoize],b.prototype,"serviceMachineIdResource",null),he([L.memoize],b.prototype,"telemetryLogResource",null),he([L.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function n(h,S){return E(h["inspect-extensions"],h["inspect-brk-extensions"],5870,S,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=n;function I(h,S){return E(h["inspect-search"],h["inspect-brk-search"],5876,S,h.extensionEnvironment)}e.parseSearchPort=I;function v(h,S){return E(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,S,h.extensionEnvironment)}e.parsePtyHostPort=v;function E(h,S,f,p,m,y){const a=Number(S||h)||(p?null:f),t=a?Boolean(!!S):!1;let s;if(y)try{s=JSON.parse(y)}catch{}return{port:a,break:t,debugId:m,env:s}}}),define(te[149],ne([0,1,241,4,126]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(h,S,f=A){const p={},m=[],y=[];for(let s in S){const r=S[s];r.alias&&(p[s]=r.alias),r.type==="string"||r.type==="string[]"?(m.push(s),r.deprecates&&m.push(r.deprecates)):r.type==="boolean"&&(y.push(s),r.deprecates&&y.push(r.deprecates))}const c=R(h,{string:m,boolean:y,alias:p}),a={},t=c;a._=c._.map(s=>String(s)).filter(s=>s.length>0),delete t._;for(let s in S){const r=S[s];r.alias&&delete t[r.alias];let i=t[s];r.deprecates&&t.hasOwnProperty(r.deprecates)&&(i||(i=t[r.deprecates]),delete t[r.deprecates]),typeof i!="undefined"&&(r.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):r.type==="string"&&Array.isArray(i)&&(i=i.pop(),f.onMultipleValues(s,i)),a[s]=i),delete t[s]}for(let s in t)f.onUnknownOption(s);return a}e.parseArgs=P;function w(h,S){let f="";return S.args&&(Array.isArray(S.args)?f=` <${S.args.join("> <")}>`:f=` <${S.args}>`),S.alias?`-${S.alias} --${h}${f}`:`--${h}${f}`}function b(h,S){let f=0,p=[];for(const a in h){const t=h[a],s=w(a,t);f=Math.max(f,s.length),p.push([s,t.description])}let m=f+2+1;if(S-m<25)return p.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let y=S-m-1,c=[];for(const a of p){let t=a[0],s=I(a[1],y),r=n(m-t.length-2);c.push("  "+t+r+s[0]);for(let i=1;i<s.length;i++)c.push(n(m)+s[i])}return c}e.formatOptions=b;function n(h){return" ".repeat(h)}function I(h,S){let f=[];for(;h.length;){let p=h.length<S?h.length:h.lastIndexOf(" ",S),m=h.slice(0,p).trim();h=h.slice(p),f.push(m)}return f}function v(h,S,f,p,m=!0){const y=process.stdout.isTTY&&process.stdout.columns||80;let c=[`${h} ${f}`];c.push(""),c.push(`${(0,D.localize)(32,null)}: ${S} [${(0,D.localize)(33,null)}][${(0,D.localize)(34,null)}...]`),c.push(""),m&&(L.isWindows?c.push((0,D.localize)(35,null,S)):c.push((0,D.localize)(36,null,S)),c.push(""));const a={};for(const t in p){const s=p[t];if(s.description&&s.cat){let r=a[s.cat];r||(a[s.cat]=r={}),r[t]=s}}for(let t in a){const s=t;let r=a[s];r&&(c.push(k[s]),c.push(...b(r,y)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=v;function E(h,S){return`${h||(0,D.localize)(37,null)}
${S||(0,D.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=E}),function(){"use strict";function J(e,R,L,D){function k(P){const w=A(P),b=[w];return e.isAbsolute(w)||b.unshift(D),e.resolve(...b)}function A(P){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,L);const n=P["user-data-dir"];if(n)return n;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(I,"AppData","Roaming")}break;case"darwin":b=e.join(R.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,L)}return{getUserDataPath:k}}if(typeof define=="function")define(te[150],ne([0,242,33,15,16,31]),function(e,R,L,D,k,A){const P=k.dirname(D.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(k.joinPath(P,"package.json").fsPath);return J(R,L,w.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),L=require("os");module.exports=J(R,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[151],ne([0,1,33,75,150]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends L.AbstractNativeEnvironmentService{constructor(P,w){super(P,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,D.getUserDataPath)(P)},w)}}e.NativeEnvironmentService=k}),define(te[152],ne([0,1,7]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,w=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(f){const p=f.match(A);return p?p[1]:null}function n(f){if(f.indexOf("://")===-1){const p=f.match(L);return p?b(p[2]):null}try{const p=R.URI.parse(f);if(p.authority)return b(p.authority)}catch(p){}return null}function I(f,p){const m=new Set;let y;for(;y=P.exec(f);){const a=n(y[1]);a&&m.add(a)}const c=new Set(p);return Array.from(m).map(a=>c.has(a)?a:a.replace(w,"a"))}e.getDomainsOfRemotes=I;function v(f){const p=f.match(k);return p?p[2]:null}function E(f,p,m){return f&&p?(m&&p.endsWith(".git")&&(p=p.substr(0,p.length-4)),p.indexOf("/")===0?`${f}${p}`:`${f}/${p}`):null}function h(f,p){if(f.indexOf("://")===-1){const m=f.match(D);if(m)return E(m[2],m[3],p)}try{const m=R.URI.parse(f);if(m.authority)return E(v(m.authority),m.path,p)}catch(m){}return null}function S(f,p=!1){const m=[];let y;for(;y=P.exec(f);){const c=h(y[1],p);c&&m.push(c)}return m}e.getRemotes=S}),define(te[153],ne([0,1,26]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function D(k,A){const P=w=>{if(typeof w!="string")return;const b=L.exec(w);if(!b)return;const n=A[b[1]]??w;return typeof n=="string"?n:typeof n.message=="string"?n.message:w};return(0,R.cloneAndChange)(k,P)}e.localizeManifest=D}),define(te[154],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,A,P,w){return this.channel.call("promptImportantExtensionsInstallNotification",[k,A,P,w])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class L{constructor(k){this.service=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,P){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(te[76],ne([0,1,135]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function k(v){return v=v.trim(),v==="*"||L.test(v)}e.isValidVersionStr=k;function A(v){if(!k(v))return null;if(v=v.trim(),v==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=v.match(L);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=A;function P(v){if(!v)return null;let E=v.majorBase,h=v.majorMustEqual,S=v.minorBase,f=v.minorMustEqual,p=v.patchBase,m=v.patchMustEqual;v.hasCaret&&(E===0||(f=!1),m=!1);let y=0;if(v.preRelease){const c=D.exec(v.preRelease);if(c){const[,a,t,s]=c;y=Date.UTC(Number(a),Number(t)-1,Number(s))}}return{majorBase:E,majorMustEqual:h,minorBase:S,minorMustEqual:f,patchBase:p,patchMustEqual:m,isMinimum:v.hasGreaterEquals,notBefore:y}}e.normalizeVersion=P;function w(v,E,h){let S;typeof v=="string"?S=P(A(v)):S=v;let f;E instanceof Date?f=E.getTime():typeof E=="string"&&(f=new Date(E).getTime());let p;if(typeof h=="string"?p=P(A(h)):p=h,!S||!p)return!1;let m=S.majorBase,y=S.minorBase,c=S.patchBase,a=p.majorBase,t=p.minorBase,s=p.patchBase,r=p.notBefore,i=p.majorMustEqual,o=p.minorMustEqual,l=p.patchMustEqual;return p.isMinimum?m>a?!0:m<a?!1:y>t?!0:y<t||f&&f<r?!1:c>=s:(m===1&&a===0&&(!i||!o||!l)&&(a=1,t=0,s=0,i=!0,o=!1,l=!1),m<a?!1:m>a?!i:y<t?!1:y>t?!o:c<s?!1:c>s?!l:!(f&&f<r))}e.isValidVersion=w;function b(v,E,h,S){return h.isBuiltin||typeof h.main=="undefined"?!0:I(v,E,h.engines.vscode,S)}e.isValidExtensionVersion=b;function n(v,E,h){return v==="*"||I(E,h,v)}e.isEngineValid=n;function I(v,E,h,S=[]){let f=P(A(h));if(!f)return S.push(R.localize(0,null,h)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return S.push(R.localize(1,null,h)),!1}else if(!f.majorMustEqual)return S.push(R.localize(2,null,h)),!1;return w(v,E,f)?!0:(S.push(R.localize(3,null,v,h)),!1)}}),define(te[54],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(D,k=[],A=!1){this.ctor=D,this.staticArguments=k,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=R}),define(te[77],ne([0,1,54]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function D(A,P,w){P instanceof R.SyncDescriptor||(P=new R.SyncDescriptor(P,[],w)),L.push([A,P])}e.registerSingleton=D;function k(){return L}e.getSingletonServiceDescriptors=k}),define(te[155],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=R;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let A of this._nodes.values())A.outgoing.size===0&&k.push(A);return k}insertEdge(k,A){const P=this.lookupOrInsertNode(k),w=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),w),w.incoming.set(this._hashFn(k),P)}removeNode(k){const A=this._hashFn(k);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(k){const A=this._hashFn(k);let P=this._nodes.get(A);return P||(P=new R(k),this._nodes.set(A,P)),P}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[A,P]of this._nodes)k.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,A]of this._nodes){const P=new Set([k]),w=this._findCycle(A,P);if(w)return w}}_findCycle(k,A){for(let[P,w]of k.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const b=this._findCycle(w,A);if(b)return b;A.delete(P)}}}e.Graph=L}),define(te[6],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function w(b){return b[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=w})(R=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(P,w,b,n){w[R.DI_TARGET]===w?w[R.DI_DEPENDENCIES].push({id:P,index:b,optional:n}):(w[R.DI_DEPENDENCIES]=[{id:P,index:b,optional:n}],w[R.DI_TARGET]=w)}function D(P){if(R.serviceIds.has(P))return R.serviceIds.get(P);const w=function(b,n,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(w,b,I,!1)};return w.toString=()=>P,R.serviceIds.set(P,w),w}e.createDecorator=D;function k(P){return P}e.refineServiceDecorator=k;function A(P){return function(w,b,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(P,w,n,!0)}}e.optional=A}),define(te[156],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(te[157],ne([0,1,4,25,6]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=R.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",R.isMacintosh),A.set("isLinux",R.isLinux),A.set("isWindows",R.isWindows),A.set("isWeb",R.isWeb),A.set("isMacNative",R.isMacintosh&&!R.isWeb),A.set("isEdge",k.indexOf("Edg/")>=0),A.set("isFirefox",k.indexOf("Firefox")>=0),A.set("isChrome",k.indexOf("Chrome")>=0),A.set("isSafari",k.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var w;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(w=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return v.INSTANCE}static true(){return E.INSTANCE}static has(C){return h.create(C)}static equals(C,N){return S.create(C,N)}static notEquals(C,N){return m.create(C,N)}static regex(C,N){return r.create(C,N)}static in(C,N){return f.create(C,N)}static not(C){return y.create(C)}static and(...C){return l.create(C,null)}static or(...C){return u.create(C,null,!0)}static greater(C,N){return c.create(C,N)}static less(C,N){return t.create(C,N)}static deserialize(C,N=!1){if(!!C)return this._deserializeOrExpression(C,N)}static _deserializeOrExpression(C,N){let z=C.split("||");return u.create(z.map(M=>this._deserializeAndExpression(M,N)),null,!0)}static _deserializeAndExpression(C,N){let z=C.split("&&");return l.create(z.map(M=>this._deserializeOne(M,N)),null)}static _deserializeOne(C,N){if(C=C.trim(),C.indexOf("!=")>=0){let z=C.split("!=");return m.create(z[0].trim(),this._deserializeValue(z[1],N))}if(C.indexOf("==")>=0){let z=C.split("==");return S.create(z[0].trim(),this._deserializeValue(z[1],N))}if(C.indexOf("=~")>=0){let z=C.split("=~");return r.create(z[0].trim(),this._deserializeRegexValue(z[1],N))}if(C.indexOf(" in ")>=0){let z=C.split(" in ");return f.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(C)){const z=C.split(">=");return a.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(C)){const z=C.split(">");return c.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(C)){const z=C.split("<=");return s.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(C)){const z=C.split("<");return t.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(C)?y.create(C.substr(1).trim()):h.create(C)}static _deserializeValue(C,N){if(C=C.trim(),C==="true")return!0;if(C==="false")return!1;let z=/^'([^']*)'$/.exec(C);return z?z[1].trim():C}static _deserializeRegexValue(C,N){if((0,L.isFalsyOrWhitespace)(C)){if(N)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=C.indexOf("/"),M=C.lastIndexOf("/");if(z===M||z<0){if(N)throw new Error(`bad regexp-value '${C}', missing /-enclosure`);return console.warn(`bad regexp-value '${C}', missing /-enclosure`),null}let q=C.slice(z+1,M),W=C[M+1]==="i"?"i":"";try{return new RegExp(q,W)}catch(j){if(N)throw new Error(`bad regexp-value '${C}', parse error: ${j}`);return console.warn(`bad regexp-value '${C}', parse error: ${j}`),null}}}e.ContextKeyExpr=b;function n(F,C){const N=F?F.substituteConstants():void 0,z=C?C.substituteConstants():void 0;return!N&&!z?!0:!N||!z?!1:N.equals(z)}e.expressionsAreEqualWithConstantSubstitution=n;function I(F,C){return F.cmp(C)}class v{constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=v,v.INSTANCE=new v;class E{constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return v.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class h{constructor(C,N){this.key=C,this.negated=N,this.type=2}static create(C,N=null){const z=A.get(C);return typeof z=="boolean"?z?E.INSTANCE:v.INSTANCE:new h(C,N)}cmp(C){return C.type!==this.type?this.type-C.type:g(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=A.get(this.key);return typeof C=="boolean"?C?E.INSTANCE:v.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class S{constructor(C,N,z){this.key=C,this.value=N,this.negated=z,this.type=4}static create(C,N,z=null){if(typeof N=="boolean")return N?h.create(C,z):y.create(C,z);const M=A.get(C);return typeof M=="boolean"?N===(M?"true":"false")?E.INSTANCE:v.INSTANCE:new S(C,N,z)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=A.get(this.key);if(typeof C=="boolean"){const N=C?"true":"false";return this.value===N?E.INSTANCE:v.INSTANCE}return this}evaluate(C){return C.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(C){return C.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=S;class f{constructor(C,N){this.key=C,this.valueKey=N,this.type=10,this.negated=null}static create(C,N){return new f(C,N)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.valueKey,C.key,C.valueKey)}equals(C){return C.type===this.type?this.key===C.key&&this.valueKey===C.valueKey:!1}substituteConstants(){return this}evaluate(C){const N=C.getValue(this.valueKey),z=C.getValue(this.key);return Array.isArray(N)?N.indexOf(z)>=0:typeof z=="string"&&typeof N=="object"&&N!==null?P.call(N,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(C){return C.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=p.create(this)),this.negated}}e.ContextKeyInExpr=f;class p{constructor(C){this._actual=C,this.type=11}static create(C){return new p(C)}cmp(C){return C.type!==this.type?this.type-C.type:this._actual.cmp(C._actual)}equals(C){return C.type===this.type?this._actual.equals(C._actual):!1}substituteConstants(){return this}evaluate(C){return!this._actual.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(C){return new p(this._actual.map(C))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class m{constructor(C,N,z){this.key=C,this.value=N,this.negated=z,this.type=5}static create(C,N,z=null){if(typeof N=="boolean")return N?y.create(C,z):h.create(C,z);const M=A.get(C);return typeof M=="boolean"?N===(M?"true":"false")?v.INSTANCE:E.INSTANCE:new m(C,N,z)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=A.get(this.key);if(typeof C=="boolean"){const N=C?"true":"false";return this.value===N?v.INSTANCE:E.INSTANCE}return this}evaluate(C){return C.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(C){return C.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class y{constructor(C,N){this.key=C,this.negated=N,this.type=3}static create(C,N=null){const z=A.get(C);return typeof z=="boolean"?z?v.INSTANCE:E.INSTANCE:new y(C,N)}cmp(C){return C.type!==this.type?this.type-C.type:g(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=A.get(this.key);return typeof C=="boolean"?C?v.INSTANCE:E.INSTANCE:this}evaluate(C){return!C.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(C){return C.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=y;class c{constructor(C,N,z){this.key=C,this.value=N,this.negated=z,this.type=12}static create(C,N,z=null){return new c(C,N,z)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return parseFloat(C.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class a{constructor(C,N,z){this.key=C,this.value=N,this.negated=z,this.type=13}static create(C,N,z=null){return new a(C,N,z)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return parseFloat(C.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=a;class t{constructor(C,N,z){this.key=C,this.value=N,this.negated=z,this.type=14}static create(C,N,z=null){return new t(C,N,z)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return parseFloat(C.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class s{constructor(C,N,z){this.key=C,this.value=N,this.negated=z,this.type=15}static create(C,N,z=null){return new s(C,N,z)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return parseFloat(C.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class r{constructor(C,N){this.key=C,this.regexp=N,this.type=7,this.negated=null}static create(C,N){return new r(C,N)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.key<C.key)return-1;if(this.key>C.key)return 1;const N=this.regexp?this.regexp.source:"",z=C.regexp?C.regexp.source:"";return N<z?-1:N>z?1:0}equals(C){if(C.type===this.type){const N=this.regexp?this.regexp.source:"",z=C.regexp?C.regexp.source:"";return this.key===C.key&&N===z}return!1}substituteConstants(){return this}evaluate(C){let N=C.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const C=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${C}`}keys(){return[this.key]}map(C){return C.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class i{constructor(C){this._actual=C,this.type=8}static create(C){return new i(C)}cmp(C){return C.type!==this.type?this.type-C.type:this._actual.cmp(C._actual)}equals(C){return C.type===this.type?this._actual.equals(C._actual):!1}substituteConstants(){return this}evaluate(C){return!this._actual.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(C){return new i(this._actual.map(C))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function o(F){let C=null;for(let N=0,z=F.length;N<z;N++){const M=F[N].substituteConstants();if(F[N]!==M&&C===null){C=[];for(let q=0;q<N;q++)C[q]=F[q]}C!==null&&(C[N]=M)}return C===null?F:C}class l{constructor(C,N){this.expr=C,this.negated=N,this.type=6}static create(C,N){return l._normalizeArr(C,N)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let N=0,z=this.expr.length;N<z;N++){const M=I(this.expr[N],C.expr[N]);if(M!==0)return M}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let N=0,z=this.expr.length;N<z;N++)if(!this.expr[N].equals(C.expr[N]))return!1;return!0}return!1}substituteConstants(){const C=o(this.expr);return C===this.expr?this:l.create(C,this.negated)}evaluate(C){for(let N=0,z=this.expr.length;N<z;N++)if(!this.expr[N].evaluate(C))return!1;return!0}static _normalizeArr(C,N){const z=[];let M=!1;for(const q of C)if(!!q){if(q.type===1){M=!0;continue}if(q.type===0)return v.INSTANCE;if(q.type===6){z.push(...q.expr);continue}z.push(q)}if(z.length===0&&M)return E.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(I);for(let q=1;q<z.length;q++)z[q-1].equals(z[q])&&(z.splice(q,1),q--);if(z.length===1)return z[0];for(;z.length>1;){const q=z[z.length-1];if(q.type!==9)break;z.pop();const W=z.pop(),j=z.length===0,x=u.create(q.expr.map($=>l.create([$,W],null)),null,j);x&&(z.push(x),z.sort(I))}return z.length===1?z[0]:new l(z,N)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(let N of this.expr)C.push(...N.keys());return C}map(C){return new l(this.expr.map(N=>N.map(C)),null)}negate(){if(!this.negated){const C=[];for(let N of this.expr)C.push(N.negate());this.negated=u.create(C,this,!0)}return this.negated}}class u{constructor(C,N){this.expr=C,this.negated=N,this.type=9}static create(C,N,z){return u._normalizeArr(C,N,z)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let N=0,z=this.expr.length;N<z;N++){const M=I(this.expr[N],C.expr[N]);if(M!==0)return M}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let N=0,z=this.expr.length;N<z;N++)if(!this.expr[N].equals(C.expr[N]))return!1;return!0}return!1}substituteConstants(){const C=o(this.expr);return C===this.expr?this:u.create(C,this.negated,!1)}evaluate(C){for(let N=0,z=this.expr.length;N<z;N++)if(this.expr[N].evaluate(C))return!0;return!1}static _normalizeArr(C,N,z){let M=[],q=!1;if(C){for(let W=0,j=C.length;W<j;W++){const x=C[W];if(!!x){if(x.type===0){q=!0;continue}if(x.type===1)return E.INSTANCE;if(x.type===9){M=M.concat(x.expr);continue}M.push(x)}}if(M.length===0&&q)return v.INSTANCE;M.sort(I)}if(M.length!==0){if(M.length===1)return M[0];for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];if(z){for(let W=0;W<M.length;W++)for(let j=W+1;j<M.length;j++)_(M[W],M[j])&&(M.splice(j,1),j--);if(M.length===1)return M[0]}return new u(M,N)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(let N of this.expr)C.push(...N.keys());return C}map(C){return new u(this.expr.map(N=>N.map(C)),null)}negate(){if(!this.negated){let C=[];for(let N of this.expr)C.push(N.negate());for(;C.length>1;){const N=C.shift(),z=C.shift(),M=[];for(const W of O(N))for(const j of O(z))M.push(l.create([W,j],null));const q=C.length===0;C.unshift(u.create(M,null,q))}this.negated=C[0]}return this.negated}}class d extends h{constructor(C,N,z){super(C,null);this._defaultValue=N,typeof z=="object"?d._info.push({...z,key:C}):z!==!0&&d._info.push({key:C,description:z,type:N!=null?typeof N:void 0})}static all(){return d._info.values()}bindTo(C){return C.createKey(this.key,this._defaultValue)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return S.create(this.key,C)}notEqualsTo(C){return m.create(this.key,C)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(F,C){return F<C?-1:F>C?1:0}function T(F,C,N,z){return F<N?-1:F>N?1:C<z?-1:C>z?1:0}function _(F,C){if(C.type===6&&F.type!==9&&F.type!==6){for(const M of C.expr)if(F.equals(M))return!0}const N=F.negate(),z=O(N).concat(O(C));z.sort(I);for(let M=0;M<z.length;M++){const W=z[M].negate();for(let j=M+1;j<z.length;j++){const x=z[j];if(W.equals(x))return!0}}return!1}e.implies=_;function O(F){return F.type===9?F.expr:[F]}}),define(te[78],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function L(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=L}),define(te[79],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(te[13],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(te[29],ne([0,1,15,130,6]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var k;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));function A(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=A;function P(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function w(m,y){switch(m){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=w;function b(m,y){return y==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function n(m,y,c){return b(y,c)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===c?!0:I(c).includes(m)}e.isTargetPlatformCompatible=n;function I(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function v(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=v;var E;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var h;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var S;(function(m){m.Install="install",m.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var f;(function(m){m[m.None=0]="None",m[m.Install=1]="Install",m[m.Update=2]="Update"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class p extends Error{constructor(y,c){super(y);this.code=c,this.name=c}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")});var X=this&&this.__param||function(J,e){return function(R,L){e(R,L,J)}};define(te[158],ne([0,1,2,29]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let D=class extends R.Disposable{constructor(A){super();this.extensionManagementService=A,this._register(A),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};D=he([X(0,L.IExtensionManagementService)],D),e.DeprecatedExtensionsCleaner=D}),define(te[159],ne([0,1,3,2,26,7,108,29]),function(J,e,R,L,D,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function w(S,f){return k.URI.revive(f?f.transformIncoming(S):S)}function b(S,f){return f?f.transformOutgoingURI(S):S}function n(S,f){f=f||A.DefaultURITransformer;const p=S.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...S,manifest:void 0},f),manifest:p}}function I(S,f){return f?(0,D.cloneAndChange)(S,p=>p instanceof k.URI?f.transformOutgoingURI(p):void 0):S}class v{constructor(f,p){this.service=f,this.getUriTransformer=p,this.onInstallExtension=R.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,p){const m=this.getUriTransformer(f);switch(p){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,y=>y.map(c=>({...c,local:c.local?I(c.local,m):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,p,m){const y=this.getUriTransformer(f);switch(p){case"zip":return this.service.zip(n(m[0],y)).then(c=>b(c,y));case"unzip":return this.service.unzip(w(m[0],y));case"install":return this.service.install(w(m[0],y),m[1]);case"getManifest":return this.service.getManifest(w(m[0],y));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(m[0]);case"installFromGallery":return this.service.installFromGallery(m[0],m[1]);case"uninstall":return this.service.uninstall(n(m[0],y),m[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(n(m[0],y));case"getInstalled":return this.service.getInstalled(m[0]).then(c=>c.map(a=>I(a,y)));case"updateMetadata":return this.service.updateMetadata(n(m[0],y),m[1]).then(c=>I(c,y));case"updateExtensionScope":return this.service.updateExtensionScope(n(m[0],y),m[1]).then(c=>I(c,y));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=v;class E extends L.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(p=>this._onInstallExtension.fire({identifier:p.identifier,source:this.isUriComponents(p.source)?k.URI.revive(p.source):p.source}))),this._register(this.channel.listen("onDidInstallExtensions")(p=>this._onDidInstallExtensions.fire(p.map(m=>({...m,local:m.local?n(m.local,null):m.local,source:this.isUriComponents(m.source)?k.URI.revive(m.source):m.source}))))),this._register(this.channel.listen("onUninstallExtension")(p=>this._onUninstallExtension.fire(p))),this._register(this.channel.listen("onDidUninstallExtension")(p=>this._onDidUninstallExtension.fire(p)))}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(f){const p=await this.getTargetPlatform();return f.allTargetPlatforms.some(m=>(0,P.isTargetPlatformCompatible)(m,f.allTargetPlatforms,p))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(p=>k.URI.revive(p)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,p){return Promise.resolve(this.channel.call("install",[f,p])).then(m=>n(m,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}installFromGallery(f,p){return Promise.resolve(this.channel.call("installFromGallery",[f,p])).then(m=>n(m,null))}uninstall(f,p){return Promise.resolve(this.channel.call("uninstall",[f,p]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(p=>p.map(m=>n(m,null)))}updateMetadata(f,p){return Promise.resolve(this.channel.call("updateMetadata",[f,p])).then(m=>n(m,null))}updateExtensionScope(f,p){return Promise.resolve(this.channel.call("updateExtensionScope",[f,p])).then(m=>n(m,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=E;class h{constructor(f){this.service=f}listen(f,p){throw new Error("Invalid listen")}call(f,p,m){switch(p){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(m[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[80],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function D(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var k;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[81],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,R.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[14],ne([0,1,40,9,25,18,7,137,6]),function(J,e,R,L,D,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function b(M){return M.create===!0}e.isFileOpenForWriteOptions=b;var n;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var I;(function(M){M[M.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var v;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=E;function h(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=h;function S(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=S;function f(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=f;var p;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(q,W){super(q);this.code=W}}e.FileSystemProviderError=m;function y(M,q){const W=new m(M.toString(),q);return a(W,q),W}e.createFileSystemProviderError=y;function c(M){return M||y((0,P.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=c;function a(M,q){return M.name=q?`${q} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=a;function t(M){if(!M)return p.Unknown;if(M instanceof m)return M.code;const q=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!q)return p.Unknown;switch(q[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=t;function s(M){if(M instanceof d)return M.fileOperationResult;switch(t(M)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(q,W,j){this.resource=q,this.operation=W,this.target=j}isOperation(q){return this.operation===q}}e.FileOperationEvent=i;var o;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(q,W){this.added=void 0,this.updated=void 0,this.deleted=void 0;const j=new Map;for(const x of q){const $=j.get(x.type);$?$.push([x.resource,x]):j.set(x.type,[[x.resource,x]])}for(const[x,$]of j)switch(x){case 1:this.added=R.TernarySearchTree.forUris(()=>W),this.added.fill($);break;case 0:this.updated=R.TernarySearchTree.forUris(()=>W),this.updated.fill($);break;case 2:this.deleted=R.TernarySearchTree.forUris(()=>W),this.deleted.fill($);break}}contains(q,...W){return this.doContains(q,{includeChildren:!1},...W)}affects(q,...W){return this.doContains(q,{includeChildren:!0},...W)}doContains(q,W,...j){if(!q)return!1;const x=j.length>0;return!!((!x||j.includes(1))&&(this.added?.get(q)||W.includeChildren&&this.added?.findSuperstr(q))||(!x||j.includes(0))&&(this.updated?.get(q)||W.includeChildren&&this.updated?.findSuperstr(q))||(!x||j.includes(2))&&(this.deleted?.findSubstr(q)||W.includeChildren&&this.deleted?.findSuperstr(q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function u(M,q,W){return!M||!q||M===q||q.length>M.length?!1:(q.charAt(q.length-1)!==L.sep&&(q+=L.sep),W?(0,D.startsWithIgnoreCase)(M,q):M.indexOf(q)===0)}e.isParent=u;class d extends Error{constructor(q,W,j){super(q);this.fileOperationResult=W,this.options=j}}e.FileOperationError=d;class g extends d{constructor(q,W,j){super(q,2,j);this.stat=W}}e.NotModifiedSinceFileOperationError=g;var T;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=O;async function F(M,q){if(!q.hasProvider(A.URI.from({scheme:M.scheme})))return new Promise(W=>{const j=q.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===M.scheme&&x.added&&(j.dispose(),W())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class C{static formatSize(q){return(0,k.isNumber)(q)||(q=0),q<C.KB?(0,P.localize)(1,null,q.toFixed(0)):q<C.MB?(0,P.localize)(2,null,(q/C.KB).toFixed(2)):q<C.GB?(0,P.localize)(3,null,(q/C.MB).toFixed(2)):q<C.TB?(0,P.localize)(4,null,(q/C.GB).toFixed(2)):(0,P.localize)(5,null,(q/C.TB).toFixed(2))}}e.ByteSize=C,C.KB=1024,C.MB=C.KB*C.KB,C.GB=C.MB*C.KB,C.TB=C.GB*C.KB;var N;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(N=e.Arch||(e.Arch={}));function z(M){return{maxFileSize:M===0?300*C.MB:16*C.GB,maxHeapSize:M===0?700*C.MB:2*700*C.MB}}e.getPlatformLimits=z}),define(te[160],ne([0,1,82,52,14]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(P){this.fileService=P}async checksum(P){const w=(await this.fileService.readFileStream(P)).value;return new Promise((b,n)=>{const I=(0,R.createHash)("md5");(0,L.listenStream)(w,{onData:v=>I.update(v.buffer),onError:v=>n(v),onEnd:()=>b(I.digest("base64").replace(/=+$/,""))})})}};k=he([X(0,D.IFileService)],k),e.ChecksumService=k}),define(te[161],ne([0,1,243,127,149,14]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(v,E){const h={onUnknownOption:f=>{console.warn((0,L.localize)(0,null,f))},onMultipleValues:(f,p)=>{console.warn((0,L.localize)(1,null,f,p))}},S=(0,D.parseArgs)(v,D.OPTIONS,E?h:void 0);return S.goto&&S._.forEach(f=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,L.localize)(2,null))),S["max-memory"]&&R(parseInt(S["max-memory"])>=k.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${k.MIN_MAX_MEMORY_SIZE_MB} MB.`),S}function P(v){const E=v.findIndex(h=>!/^-/.test(h));if(E>-1)return[...v.slice(0,E),...v.slice(E+1)]}function w(v){let[,...E]=v;process.env.VSCODE_DEV&&(E=P(E)||[]);const h=!I(process.env);return A(E,h)}e.parseMainProcessArgv=w;function b(v){const[,,...E]=v;return A(E,!0)}e.parseCLIProcessArgv=b;function n(v,...E){const h=v.indexOf("--");return h===-1?v.push(...E):v.splice(h,0,...E),v}e.addArg=n;function I(v){return v.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(te[162],ne([0,1,41,9,128,27,37,8,4,28,123,161,5]),function(J,e,R,L,D,k,A,P,w,b,n,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const E=1e4;let h;async function S(p,m,y){return m["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(y)&&!m["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(y)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=v.Promises.withAsyncBody(async(c,a)=>{const t=new k.CancellationTokenSource,s=setTimeout(()=>{t.dispose(!0),a(new Error((0,D.localize)(0,null)))},E);try{c(await f(p,t.token))}catch(r){!(0,P.isPromiseCanceledError)(r)&&!t.token.isCancellationRequested?a(new Error((0,D.localize)(1,null,(0,A.toErrorMessage)(r)))):c({})}finally{clearTimeout(s),t.dispose()}})),h)}e.resolveShellEnv=S;async function f(p,m){const y=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",y);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",c);const a=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",s);const r=await(0,n.getSystemShell)(w.OS,s);return p.trace("getUnixShellEnvironment#shell",r),new Promise((i,o)=>{if(m.isCancellationRequested)return o((0,P.canceled)());const l=(0,L.basename)(r);let u,d;/^pwsh(-preview)?$/.test(l)?(u=`& '${process.execPath}' -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,d=["-Login","-Command"]):(u=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,d=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),u);const g=(0,R.spawn)(r,[...d,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});m.onCancellationRequested(()=>(g.kill(),o((0,P.canceled)()))),g.on("error",O=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(O)),o(O)});const T=[];g.stdout.on("data",O=>T.push(O));const _=[];g.stderr.on("data",O=>_.push(O)),g.on("close",(O,F)=>{const C=Buffer.concat(T).toString("utf8");p.trace("getUnixShellEnvironment#raw",C);const N=Buffer.concat(_).toString("utf8");if(N.trim()&&p.trace("getUnixShellEnvironment#stderr",N),O||F)return o(new Error((0,D.localize)(2,null,O,F)));const z=t.exec(C),M=z?z[1]:"{}";try{const q=JSON.parse(M);y?q.ELECTRON_RUN_AS_NODE=y:delete q.ELECTRON_RUN_AS_NODE,c?q.ELECTRON_NO_ATTACH_CONSOLE=c:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",q),i(q)}catch(q){p.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(q)),o(q)}})})}}),define(te[46],ne([0,1,2,4,7,14]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=e.WatcherService=void 0;class A extends R.Disposable{}e.WatcherService=A;function P(n){return n.map(I=>({type:I.type,resource:D.URI.file(I.path)}))}e.toFileChanges=P;function w(n){const I=new b;for(const v of n)I.processEvent(v);return I.normalize()}e.normalizeFileChanges=w;class b{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(I){return L.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const v=this.mapPathToChange.get(this.toKey(I));let E=!1;if(v){const h=v.type,S=I.type;v.path!==I.path&&I.type===2?E=!0:h===1&&S===2?(this.mapPathToChange.delete(this.toKey(I)),this.normalized.delete(v)):h===2&&S===1?v.type=0:h===1&&S===0||(v.type=S)}else E=!0;E&&(this.normalized.add(I),this.mapPathToChange.set(this.toKey(I),I))}normalize(){const I=[],v=[];return Array.from(this.normalized).filter(E=>E.type!==2?(I.push(E),!1):!0).sort((E,h)=>E.path.length-h.path.length).filter(E=>v.some(h=>(0,k.isParent)(E.path,h,!L.isLinux))?!1:(v.push(E.path),!0)).concat(I)}}}),define(te[163],ne([0,1,5,2,9,113,19,116,46]),function(J,e,R,L,D,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends L.Disposable{constructor(I,v,E,h){super();this.path=I,this.onDidFilesChange=v,this.onLogMessage=E,this.verboseLogging=h,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:v}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(v)try{E=await(0,k.realpath)(E)}catch(h){if(this.onError(h),v.dangling)return}I.isDirectory()?this._register((0,P.watchFolder)(E,(h,S)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(S))})},h=>this.onError(h))):this._register((0,P.watchFile)(E,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,w.normalizeFileChanges)(v);if(this.verboseLogging)for(const h of E)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);E.length>0&&this.onDidFilesChange(E)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b}),define(te[164],ne([0,1,15,32,45,46]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends k.WatcherService{constructor(w,b,n){super();this.onDidFilesChange=w,this.onLogMessage=b,this.verboseLogging=n,this.isDisposed=!1,this.startWatching()}startWatching(){const w=this._register(new D.Client(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b)))}async setVerboseLogging(w){this.verboseLogging=w,this.isDisposed||await this.service?.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}async watch(w){this.isDisposed||await this.service?.watch(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A}),define(te[165],ne([0,1,2,15,32,45,46]),function(J,e,R,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends A.WatcherService{constructor(b,n,I){super();this.onDidFilesChange=b,this.onLogMessage=n,this.verboseLogging=I,this.serviceDisposables=this._register(new R.MutableDisposable),this.requests=void 0,this.restartCounter=0,this.init()}init(){const b=new R.DisposableStore;this.serviceDisposables.value=b;const n=b.add(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));b.add(n.onDidProcessExit(()=>{this.restartCounter<=P.MAX_RESTARTS&&this.requests?(this.error("terminated unexpectedly and is restarted again..."),this.restart(this.requests)):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!")})),this.service=D.ProxyChannel.toService((0,D.getNextTickChannel)(n.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),b.add(this.service.onDidChangeFile(I=>this.onDidFilesChange(I))),b.add(this.service.onDidLogMessage(I=>this.onLogMessage(I)))}restart(b){this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.init(),this.watch(b)}async watch(b){this.requests=b,await this.service?.watch(b)}async setVerboseLogging(b){this.verboseLogging=b,await this.service?.setVerboseLogging(b)}error(b){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${b}`})}dispose(){return this.service=void 0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(te[166],ne([0,1,15,32,45,46]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends k.WatcherService{constructor(w,b,n,I={}){super();this.onDidFilesChange=w,this.onLogMessage=b,this.verboseLogging=n,this.watcherOptions=I,this.isDisposed=!1,this.restartCounter=0,this.requests=void 0,this.startWatching()}startWatching(){const w=this._register(new D.Client(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherServiceChokidar"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS&&this.requests?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching(),this.service?.watch(this.requests)):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(w.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b)))}async setVerboseLogging(w){this.verboseLogging=w,this.isDisposed||await this.service?.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${w}`})}async watch(w){this.requests=w,await this.service?.watch(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(te[83],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...D){this._entries=new Map;for(let[k,A]of D)this.set(k,A)}set(D,k){const A=this._entries.get(D);return this._entries.set(D,k),A}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=R}),define(te[167],ne([0,1,5,8,54,155,6,83]),function(J,e,R,L,D,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class b extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class n{constructor(h=new P.ServiceCollection,S=!1,f){this._activeInstantiations=new Set,this._services=h,this._strict=S,this._parent=f,this._services.set(A.IInstantiationService,this)}createChild(h){return new n(h,this._strict,this)}invokeFunction(h,...S){let f=v.traceInvocation(h),p=!1;try{return h({get:(y,c)=>{if(p)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(y,f);if(!a&&c!==A.optional)throw new Error(`[invokeFunction] unknown service '${y}'`);return a}},...S)}finally{p=!0,f.stop()}}createInstance(h,...S){let f,p;return h instanceof D.SyncDescriptor?(f=v.traceCreation(h.ctor),p=this._createInstance(h.ctor,h.staticArguments.concat(S),f)):(f=v.traceCreation(h),p=this._createInstance(h,S,f)),f.stop(),p}_createInstance(h,S=[],f){let p=A._util.getServiceDependencies(h).sort((c,a)=>c.index-a.index),m=[];for(const c of p){let a=this._getOrCreateServiceInstance(c.id,f);if(!a&&this._strict&&!c.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${c.id}.`);m.push(a)}let y=p.length>0?p[0].index:S.length;if(S.length!==y){console.warn(`[createInstance] First service dependency of ${h.name} at position ${y+1} conflicts with ${S.length} static arguments`);let c=y-S.length;c>0?S=S.concat(new Array(c)):S=S.slice(0,y)}return new h(...[...S,...m])}_setServiceInstance(h,S){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,S);else if(this._parent)this._parent._setServiceInstance(h,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let S=this._services.get(h);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):S}_getOrCreateServiceInstance(h,S){let f=this._getServiceInstanceOrDescriptor(h);return f instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,f,S.branch(h,!0)):(S.branch(h,!1),f)}_safeCreateAndCacheServiceInstance(h,S,f){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,S,f)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,S,f){const p=new k.Graph(c=>c.id.toString());let m=0;const y=[{id:h,desc:S,_trace:f}];for(;y.length;){const c=y.pop();if(p.lookupOrInsertNode(c),m++>1e3)throw new b(p);for(let a of A._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${h} depends on ${a.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const s={id:a.id,desc:t,_trace:c._trace.branch(a.id,!0)};p.insertEdge(c,s),y.push(s)}}}for(;;){const c=p.roots();if(c.length===0){if(!p.isEmpty())throw new b(p);break}for(const{data:a}of c){if(this._getServiceInstanceOrDescriptor(a.id)instanceof D.SyncDescriptor){const s=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,s)}p.removeNode(a)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,S,f=[],p,m){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(S,f,p,m);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,S,f,p,m);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(h,S=[],f,p){if(f){const m=new R.IdleValue(()=>this._createInstance(h,S,p));return new Proxy(Object.create(null),{get(y,c){if(c in y)return y[c];let a=m.value,t=a[c];return typeof t!="function"||(t=t.bind(a),y[c]=t),t},set(y,c,a){return m.value[c]=a,!0}})}else return this._createInstance(h,S,p)}}e.InstantiationService=n;var I;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(I||(I={}));class v{constructor(h,S){this.type=h,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return w?new v(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(h){return w?new v(0,h.name):v._None}branch(h,S){let f=new v(2,h.toString());return this._dep.push([h,S,f]),f}stop(){let h=Date.now()-this._start;v._totals+=h;let S=!1;function f(m,y){let c=[],a=new Array(m+1).join("	");for(const[t,s,r]of y._dep)if(s&&r){S=!0,c.push(`${a}CREATES -> ${t}`);let i=f(m+1,r);i&&c.push(i)}else c.push(`${a}uses -> ${t}`);return c.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(h>2||S)&&console.log(p.join(`
`))}}v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(te[168],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(D,k){this.server=D,this.router=k}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,k){this.server.registerChannel(D,k)}}e.MessagePortMainProcessService=R}),define(te[169],ne([0,1,32,54,77,6]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(E,h,S){const f=S.getChannel(E);return P(h)?new h.channelClientCtor(f):R.ProxyChannel.toService(f,h?.proxyOptions)}}function P(v){return!!v?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let w=class extends A{constructor(E,h,S){super(E,h,S)}};w=he([X(2,e.IMainProcessService)],w);function b(v,E,h){(0,D.registerSingleton)(v,new L.SyncDescriptor(w,[E,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let n=class extends A{constructor(E,h,S){super(E,h,S)}};n=he([X(2,e.ISharedProcessService)],n);function I(v,E,h){(0,D.registerSingleton)(v,new L.SyncDescriptor(n,[E,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=I}),define(te[59],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,R.createDecorator)("localizationsService");function L(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const k of D.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}e.isValidLocalization=L}),define(te[170],ne([0,1,2,59]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends R.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=he([X(0,L.ILocalizationsService)],D),e.LocalizationsUpdater=D}),define(te[10],ne([0,1,37,3,2,4,6]),function(J,e,R,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function P(){return new Date().toISOString()}var w;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;class b extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class n extends b{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(w.Trace)&&this.log(w.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(w.Debug)&&this.log(w.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(w.Info)&&this.log(w.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(w.Warning)&&this.log(w.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(w.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(w.Error,this.format(r))}else this.log(w.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(w.Critical)&&this.log(w.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let r=0;r<t.length;r++){let i=t[r];if(typeof i=="object")try{i=JSON.stringify(i)}catch(o){}s+=(r>0?" ":"")+i}return s}}e.AbstractMessageLogger=n;class I extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...s){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}debug(t,...s){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}info(t,...s){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}warn(t,...s){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...s):console.warn(`[main ${P()}]`,t,...s))}error(t,...s){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...s):console.error(`[main ${P()}]`,t,...s))}critical(t,...s){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...s):console.error(`[main ${P()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class v extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=v;class E extends b{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,R.toErrorMessage)(t,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class h extends b{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const r of this.logServices)r.trace(t,...s)}debug(t,...s){for(const r of this.logServices)r.debug(t,...s)}info(t,...s){for(const r of this.logServices)r.info(t,...s)}warn(t,...s){for(const r of this.logServices)r.warn(t,...s)}error(t,...s){for(const r of this.logServices)r.error(t,...s)}critical(t,...s){for(const r of this.logServices)r.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class S extends D.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=S;class f extends D.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,s?.always?w.Trace:this.logLevel,s),this.loggers.set(t.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=f;class p{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return w.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=p;function m(a){if(a.verbose)return w.Trace;if(typeof a.logLevel=="string"){const t=y(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=m;function y(a){switch(a){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=y;function c(a){switch(a){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=c}),define(te[171],ne([0,1,5,8,2,9,19,13,10]),function(J,e,R,L,D,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends D.Disposable{constructor(I,v){super();this.environmentService=I,this.logService=v,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const I=(0,k.basename)(this.environmentService.logsPath),v=(0,k.dirname)(this.environmentService.logsPath),S=(await A.Promises.readdir(v)).filter(p=>/^\d{8}T\d{6}$/.test(p)).sort().filter(p=>p!==I),f=S.slice(0,Math.max(0,S.length-9));f.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(p=>A.Promises.rm((0,k.join)(v,p)))))}catch(I){(0,L.onUnexpectedError)(I)}}};b=he([X(0,P.IEnvironmentService),X(1,w.ILogService)],b),e.LogsDataCleaner=b}),define(te[172],ne([0,1,5,8,2,9,19,13,10]),function(J,e,R,L,D,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class mt extends D.Disposable{constructor(I,v,E){super();this.backupWorkspacesPath=I,this.environmentService=v,this.logService=E,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const I=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),E=JSON.parse(I).emptyWorkspaceInfos.map(S=>S.backupFolder),h=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async S=>{S.length!==mt.NON_EMPTY_WORKSPACE_ID_LENGTH&&E.indexOf(S)===-1&&(this.logService.trace(`[storage cleanup]: Deleting storage folder ${S}.`),await A.Promises.rm((0,k.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(I){(0,L.onUnexpectedError)(I)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b=he([X(1,P.INativeEnvironmentService),X(2,w.ILogService)],b),e.StorageDataCleaner=b}),define(te[173],ne([0,1,41,5,37,3,2,15,9,19,13,10]),function(J,e,R,L,D,k,A,P,w,b,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends A.Disposable{constructor(h,S){super();this.environmentService=h,this.logService=S,this.processesLimiter=new L.Limiter(5)}async postUninstall(h){const S=this.parseScript(h,"uninstall");return S&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),f=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${f}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,f=>this.logService.error("Error while removing extension storage path",f))}parseScript(h,S){const f=`vscode:${S}`;if(h.location.scheme===P.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[f]=="string"){const p=h.manifest.scripts[f].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${f} should be a node script`),null):{script:(0,w.join)(h.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(h,S,f,p,m){return new Promise((y,c)=>{const a=this.start(h,S,f,m);let t;const s=r=>{t&&(clearTimeout(t),t=null),r?c(r):y(void 0)};a.on("error",r=>{s((0,D.toErrorMessage)(r)||"Unknown")}),a.on("exit",(r,i)=>{s(r?`post-${S} process exited with code ${r}`:void 0)}),p&&(t=setTimeout(()=>{t=null,a.kill(),c("timed out")},5e3))})}start(h,S,f,p){const m={silent:!0,execArgv:void 0},y=(0,R.fork)(h,[`--type=extension-post-${S}`,...f],m);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const c=k.Event.fromNodeEventEmitter(y.stdout,"data"),a=k.Event.fromNodeEventEmitter(y.stderr,"data");c(r=>this.logService.info(p.identifier.id,p.manifest.version,`post-${S}`,r)),a(r=>this.logService.error(p.identifier.id,p.manifest.version,`post-${S}`,r));const t=k.Event.any(k.Event.map(c,r=>({data:`%c${r}`,format:[""]})),k.Event.map(a,r=>({data:`%c${r}`,format:["color: red"]})));return k.Event.debounce(t,(r,i)=>r?{data:r.data+i.data,format:[...r.format,...i.format]}:{data:i.data,format:i.format},100)(r=>{console.group(p.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),y}getExtensionStoragePath(h){return(0,w.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};v=he([X(0,n.IEnvironmentService),X(1,I.ILogService)],v),e.ExtensionsLifecycle=v}),define(te[174],ne([0,1,8,2,81,3,41,15,110,4,10,77,26,31]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let h=class extends L.Disposable{constructor(p,m){super();this.id=p,this._logService=m,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null}register(p){this._register(p)}start(p){this._process=(0,A.fork)(P.FileAccess.asFileUri("bootstrap-fork",J).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,v.mixin)({cwd:(0,E.cwd)()},p));const m=this._process.pid;this._logService.info(`Starting extension host with pid ${m}.`);const y=new w.StringDecoder("utf-8");this._process.stdout?.on("data",a=>{const t=typeof a=="string"?a:y.write(a);this._onStdout.fire(t)});const c=new w.StringDecoder("utf-8");return this._process.stderr?.on("data",a=>{const t=typeof a=="string"?a:c.write(a);this._onStderr.fire(t)}),this._process.on("message",a=>{this._onMessage.fire(a)}),this._process.on("error",a=>{this._onError.fire({error:(0,R.transformErrorForSerialization)(a)})}),this._process.on("exit",(a,t)=>{this._onExit.fire({pid:m,code:a,signal:t})}),{pid:m}}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):b.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}};h=he([X(1,n.ILogService)],h);let S=class vt{constructor(p){this._logService=p,this._extHosts=new Map}dispose(){}_getExtHost(p){const m=this._extHosts.get(p);if(!m)throw new Error("Unknown extension host!");return m}onDynamicStdout(p){return this._getExtHost(p).onStdout}onDynamicStderr(p){return this._getExtHost(p).onStderr}onDynamicMessage(p){return this._getExtHost(p).onMessage}onDynamicError(p){return this._getExtHost(p).onError}onDynamicExit(p){return this._getExtHost(p).onExit}async createExtensionHost(){const p=String(++vt._lastId),m=new h(p,this._logService);return this._extHosts.set(p,m),m.onExit(({pid:y,code:c,signal:a})=>{this._logService.info(`Extension host with pid ${y} exited with code: ${c}, signal: ${a}.`),setTimeout(()=>{m.dispose(),this._extHosts.delete(p)})}),{id:p}}async start(p,m){return this._getExtHost(p).start(m)}async enableInspectPort(p){const m=this._extHosts.get(p);return m?m.enableInspectPort():!1}async kill(p){const m=this._extHosts.get(p);!m||m.kill()}};S._lastId=0,S=he([X(0,n.ILogService)],S),e.ExtensionHostStarter=S,(0,I.registerSingleton)(D.IExtensionHostStarter,S,!0)}),define(te[175],ne([0,1,17,5,3,2,9,46,10]),function(J,e,R,L,D,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends k.Disposable{constructor(I){super();this.logService=I,this._onDidErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(I,v){return v.recursive?this.watchRecursive(I,v):this.watchNonRecursive(I)}watchRecursive(I,v){const E={path:this.toFilePath(I),excludes:v.excludes},h=(0,R.insert)(this.recursiveFoldersToWatch,E);return this.refreshRecursiveWatchers(),(0,k.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(I=>this.logService.error(I))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(this.recursiveFoldersToWatch.length,I=>this._onDidChangeFile.fire((0,P.toFileChanges)(I)),I=>this.onWatcherLogMessage(I),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))),this.recursiveWatcher.watch(this.recursiveFoldersToWatch)}watchNonRecursive(I){const v=this.createNonRecursiveWatcher(this.toFilePath(I),h=>this._onDidChangeFile.fire((0,P.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===w.LogLevel.Trace),E=this.logService.onDidChangeLogLevel(()=>{v.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)});return(0,k.combinedDisposable)(v,E)}onWatcherLogMessage(I){I.type==="error"&&this._onDidErrorOccur.fire(I.message),this.logService[I.type](I.message)}toFilePath(I){return(0,A.normalize)(I.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(te[84],ne([0,1,3,7,10]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(v){this.service=v,this.onDidChangeLogLevel=R.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,E){switch(E){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${E}`)}async call(v,E,h){switch(E){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${E}`)}}e.LogLevelChannel=k;class A{constructor(v){this.channel=v}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(v){A.setLevel(this.channel,v)}static setLevel(v,E){return v.call("setLevel",E)}}e.LogLevelChannelClient=A;class P{constructor(v){this.loggerService=v,this.loggers=new Map}listen(v,E){throw new Error(`Event not found: ${E}`)}async call(v,E,h){switch(E){case"createLogger":this.createLogger(L.URI.revive(h[0]),h[1]);return;case"log":return this.log(L.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${E}`)}createLogger(v,E){this.loggers.set(v.toString(),this.loggerService.createLogger(v,E))}consoleLog(v,E){let h=console.log;switch(v){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...E)}log(v,E){const h=this.loggers.get(v.toString());if(!h)throw new Error("Create the logger before logging");for(const[S,f]of E)switch(S){case D.LogLevel.Trace:h.trace(f);break;case D.LogLevel.Debug:h.debug(f);break;case D.LogLevel.Info:h.info(f);break;case D.LogLevel.Warning:h.warn(f);break;case D.LogLevel.Error:h.error(f);break;case D.LogLevel.Critical:h.critical(f);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class w extends D.AbstractLoggerService{constructor(v,E,h){super(v,E);this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(v,E)=>{this.channel.call("consoleLog",[v,E])}})}doCreateLogger(v,E,h){return new b(this.channel,v,E,h)}}e.LoggerChannelClient=w;class b extends D.AbstractMessageLogger{constructor(v,E,h,S){super(S?.always);this.channel=v,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[E,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(v,E){const h=[[v,E]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(v){this.channel.call("log",[this.file,v])}}class n extends D.LogService{constructor(v,E){super(E);this.parent=v,this._register(v.onDidChangeLogLevel(h=>E.setLevel(h)))}setLevel(v){super.setLevel(v),this.parent.setLevel(v)}}e.FollowerLogService=n}),define(te[60],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(te[42],ne([0,1,15,4,31,16]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const P=(0,k.dirname)(R.FileAccess.asFileUri("",J));A=J.__$__nodeRequire((0,k.joinPath)(P,"product.json").fsPath);const w=J.__$__nodeRequire((0,k.joinPath)(P,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:w.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(te[85],ne([0,1,22,8,138,14,42]),function(J,e,R,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(I,v,E,h,S,f){let p;try{await w(I,v,E,h,S,f)}catch(m){p=m}finally{p&&S.errorTransformer&&(p=S.errorTransformer(p)),typeof p!="undefined"&&E.error(p),E.end()}}e.readFileIntoStream=P;async function w(I,v,E,h,S,f){b(f);const p=await I.open(v,{create:!1});try{b(f);let m=0,y=0,c=S&&typeof S.length=="number"?S.length:void 0,a=R.VSBuffer.alloc(Math.min(S.bufferSize,typeof c=="number"?c:S.bufferSize)),t=S&&typeof S.position=="number"?S.position:0,s=0;do y=await I.read(p,t,a.buffer,s,a.byteLength-s),t+=y,s+=y,m+=y,typeof c=="number"&&(c-=y),s===a.byteLength&&(await E.write(h(a)),a=R.VSBuffer.alloc(Math.min(S.bufferSize,typeof c=="number"?c:S.bufferSize)),s=0);while(y>0&&(typeof c!="number"||c>0)&&b(f)&&n(m,S));if(s>0){let r=s;typeof c=="number"&&(r=Math.min(s,c)),E.write(h(a.slice(0,r)))}}catch(m){throw(0,k.ensureFileSystemProviderError)(m)}finally{await I.close(p)}}function b(I){if(I.isCancellationRequested)throw(0,L.canceled)();return!0}function n(I,v){if(v?.limits){if(typeof v.limits.memory=="number"&&I>v.limits.memory)throw(0,k.createFileSystemProviderError)((0,D.localize)(0,null,A.default.nameShort),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&I>v.limits.size)throw(0,k.createFileSystemProviderError)((0,D.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[176],ne([0,1,17,5,22,27,3,56,2,40,15,177,16,52,136,14,85,10]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class Ge extends w.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new A.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ge.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ge.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ge.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new S.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ge.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ge.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ge.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new S.FileChangesEvent(a,!0)))),this.watchedResources=b.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(c,a){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:a});const t=new w.DisposableStore;return t.add(a.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:c}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:a}),this.provider.delete(c),(0,w.dispose)(t)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(t){a.push(t)}}),!this.provider.has(c)&&await L.Promises.settled(a)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,a){const t=this.provider.get(c.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return P.Iterable.map(this.provider,([c,a])=>({scheme:c,capabilities:a.capabilities}))}async withProvider(c){if(!(0,v.isAbsolutePath)(c))throw new S.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const a=this.provider.get(c.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,h.localize)(1,null,c.toString()),t}return a}async withReadProvider(c){const a=await this.withProvider(c);if((0,S.hasOpenReadWriteCloseCapability)(a)||(0,S.hasReadWriteCapability)(a)||(0,S.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const a=await this.withProvider(c);if((0,S.hasOpenReadWriteCloseCapability)(a)||(0,S.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,a){try{return await this.doResolveFile(c,a)}catch(t){throw(0,S.toFileSystemProviderErrorCode)(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,S.ensureFileSystemProviderError)(t)}}async doResolveFile(c,a){const t=await this.withProvider(c),s=this.isPathCaseSensitive(t),r=a?.resolveTo,i=a?.resolveSingleChildDescendants,o=a?.resolveMetadata,l=await t.stat(c);let u;return this.toFileStat(t,c,l,void 0,!!o,(d,g)=>(u||(u=b.TernarySearchTree.forUris(()=>!s),u.set(c,!0),r&&u.fill(!0,r)),u.get(d.resource)||u.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&i?g===1:!1))}async toFileStat(c,a,t,s,r,i){const{providerExtUri:o}=this.getExtUri(c),l={resource:a,name:o.basename(a),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&S.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,S.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&i(l,s)){try{const u=await c.readdir(a),d=await L.Promises.settled(u.map(async([g,T])=>{try{const _=o.joinPath(a,g),O=r?await c.stat(_):{type:T};return await this.toFileStat(c,_,O,u.length,r,i)}catch(_){return this.logService.trace(_),null}}));l.children=(0,R.coalesce)(d)}catch(u){this.logService.trace(u),l.children=[]}return l}return l}async resolveAll(c){return L.Promises.settled(c.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(c){const a=await this.withProvider(c);try{return!!await a.stat(c)}catch(t){return!1}}async canCreateFile(c,a){try{await this.doValidateCreateFile(c,a)}catch(t){return t}return!0}async doValidateCreateFile(c,a){if(!a?.overwrite&&await this.exists(c))throw new S.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,a)}async createFile(c,a=D.VSBuffer.fromString(""),t){await this.doValidateCreateFile(c,t);const s=await this.writeFile(c,a);return this._onDidRunOperation.fire(new S.FileOperationEvent(c,0,s)),s}async writeFile(c,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:r}=this.getExtUri(s);try{await this.validateWriteFile(s,c,t)||await this.mkdirp(s,r.dirname(c));let o;if((0,S.hasReadWriteCapability)(s)&&!(a instanceof D.VSBuffer))if((0,E.isReadableStream)(a)){const l=await(0,E.peekStream)(a,3);l.ended?o=D.VSBuffer.concat(l.buffer):o=l}else o=(0,E.peekReadable)(a,l=>D.VSBuffer.concat(l),3);else o=a;!(0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasReadWriteCapability)(s)&&o instanceof D.VSBuffer?await this.doWriteUnbuffered(s,c,t,o):await this.doWriteBuffered(s,c,t,o instanceof D.VSBuffer?(0,D.bufferToReadable)(o):o)}catch(i){throw new S.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,S.ensureFileSystemProviderError)(i).toString()),(0,S.toFileOperationResult)(i),t)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,a,t){if(!!t?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(a)));let r;try{r=await c.stat(a)}catch(i){return}if((r.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,h.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,r),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,S.etag)({mtime:t.mtime,size:r.size}))throw new S.FileOperationError((0,h.localize)(7,null),3,t);return r}async readFile(c,a){const t=await this.withReadProvider(c);return a?.atomic?this.doReadFileAtomic(t,c,a):this.doReadFile(t,c,a)}async doReadFileAtomic(c,a,t){return new Promise((s,r)=>{this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{try{const i=await this.doReadFile(c,a,t);s(i)}catch(i){r(i)}})})}async doReadFile(c,a,t){const s=await this.doReadFileStream(c,a,{...t,preferUnbuffered:!0});return{...s,value:await(0,D.streamToBuffer)(s.value)}}async readFileStream(c,a){const t=await this.withReadProvider(c);return this.doReadFileStream(t,c,a)}async doReadFileStream(c,a,t){const s=new k.CancellationTokenSource,r=this.validateReadFile(a,t).then(o=>o,o=>{throw s.cancel(),o});let i;try{return typeof t?.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await r,!((0,S.hasOpenReadWriteCloseCapability)(c)||(0,S.hasFileReadStreamCapability)(c))||(0,S.hasReadWriteCapability)(c)&&t?.preferUnbuffered?i=this.readFileUnbuffered(c,a,t):(0,S.hasFileReadStreamCapability)(c)?i=this.readFileStreamed(c,a,s.token,t):i=this.readFileBuffered(c,a,s.token,t),{...await r,value:i}}catch(o){i&&await(0,E.consumeStream)(i);const l=(0,h.localize)(8,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(o).toString());throw o instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(l,o.stat,t):new S.FileOperationError(l,(0,S.toFileOperationResult)(o),t)}}readFileStreamed(c,a,t,s=Object.create(null)){const r=c.readFileStream(a,s,t);return(0,E.transform)(r,{data:i=>i instanceof D.VSBuffer?i:D.VSBuffer.wrap(i),error:i=>new S.FileOperationError((0,h.localize)(9,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(i).toString()),(0,S.toFileOperationResult)(i),s)},i=>D.VSBuffer.concat(i))}readFileBuffered(c,a,t,s=Object.create(null)){const r=(0,D.newWriteableBufferStream)();return(0,f.readFileIntoStream)(c,a,r,i=>i,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:i=>new S.FileOperationError((0,h.localize)(10,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(i).toString()),(0,S.toFileOperationResult)(i),s)},t),r}readFileUnbuffered(c,a,t){const s=(0,E.newWriteableStream)(r=>D.VSBuffer.concat(r));return(async()=>{try{let r=await c.readFile(a);typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(a,r.byteLength,t),s.end(D.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(c,a){const t=await this.resolve(c,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,a);if(typeof a?.etag=="string"&&a.etag!==S.ETAG_DISABLED&&a.etag===t.etag)throw new S.NotModifiedSinceFileOperationError((0,h.localize)(12,null),t,a);return this.validateReadFileLimits(c,t.size,a),t}validateReadFileLimits(c,a,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&a>t.limits.size&&(s=7),typeof s=="number")throw new S.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,a,t){return this.doCanMoveCopy(c,a,"move",t)}async canCopy(c,a,t){return this.doCanMoveCopy(c,a,"copy",t)}async doCanMoveCopy(c,a,t,s){if(c.toString()!==a.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(r,c,i,a,t,s)}catch(r){return r}return!0}async move(c,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),i=await this.doMoveCopy(s,c,r,a,"move",!!t),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,i==="move"?2:3,o)),o}async copy(c,a,t){const s=await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),i=await this.doMoveCopy(s,c,r,a,"copy",!!t),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,i==="copy"?3:2,o)),o}async doMoveCopy(c,a,t,s,r,i){if(a.toString()===s.toString())return r;const{exists:o,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,a,t,s,r,i);if(o&&!l&&i&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),r==="copy"){if(c===t&&(0,S.hasFileFolderCopyCapability)(c))await c.copy(a,s,{overwrite:i});else{const u=await this.resolve(a);u.isDirectory?await this.doCopyFolder(c,u,t,s):await this.doCopyFile(c,a,t,s)}return r}else return c===t?(await c.rename(a,s,{overwrite:i}),r):(await this.doMoveCopy(c,a,t,s,"copy",i),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(c,a,t,s){if((0,S.hasOpenReadWriteCloseCapability)(c)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(c,a,t,s);if((0,S.hasOpenReadWriteCloseCapability)(c)&&(0,S.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(c,a,t,s);if((0,S.hasReadWriteCapability)(c)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(c,a,t,s);if((0,S.hasReadWriteCapability)(c)&&(0,S.hasReadWriteCapability)(t))return this.doPipeUnbuffered(c,a,t,s)}async doCopyFolder(c,a,t,s){await t.mkdir(s),Array.isArray(a.children)&&await L.Promises.settled(a.children.map(async r=>{const i=this.getExtUri(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(c,await this.resolve(r.resource),t,i):this.doCopyFile(c,r.resource,t,i)}))}async doValidateMoveCopy(c,a,t,s,r,i){let o=!1;if(c===t){const{providerExtUri:u,isPathCaseSensitive:d}=this.getExtUri(c);if(d||(o=u.isEqual(a,s)),o&&r==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(a),this.resourceForError(s)));if(!o&&u.isEqualOrParent(s,a))throw new Error((0,h.localize)(15,null,this.resourceForError(a),this.resourceForError(s)))}const l=await this.exists(s);if(l&&!o){if(!i)throw new S.FileOperationError((0,h.localize)(16,null,this.resourceForError(a),this.resourceForError(s)),4);if(c===t){const{providerExtUri:u}=this.getExtUri(c);if(u.isEqualOrParent(a,s))throw new Error((0,h.localize)(17,null,this.resourceForError(a),this.resourceForError(s)))}}return{exists:l,isSameResourceWithDifferentPathCase:o}}getExtUri(c){const a=this.isPathCaseSensitive(c);return{providerExtUri:a?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(a,c);const t=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,0,t)),t}async mkdirp(c,a){const t=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(a,s.dirname(a));)try{if(((await c.stat(a)).type&S.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(a)));break}catch(r){if((0,S.toFileSystemProviderErrorCode)(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(a)),a=s.dirname(a)}for(let r=t.length-1;r>=0;r--){a=s.joinPath(a,t[r]);try{await c.mkdir(a)}catch(i){if((0,S.toFileSystemProviderErrorCode)(i)!==S.FileSystemProviderErrorCode.FileExists)throw i}}}async canDelete(c,a){try{await this.doValidateDelete(c,a)}catch(t){return t}return!0}async doValidateDelete(c,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let r;try{r=await t.stat(c)}catch(o){}if(r)this.throwIfFileIsReadonly(c,r);else throw new S.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!a?.recursive){const o=await this.resolve(c);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return t}async del(c,a){const t=await this.doValidateDelete(c,a),s=!!a?.useTrash,r=!!a?.recursive;await t.delete(c,{recursive:r,useTrash:s}),this._onDidRunOperation.fire(new S.FileOperationEvent(c,1))}onDidChangeFile(c,a){this._onDidChangeFilesRaw.fire({changes:c});let t,s;{for(const r of c)this.watchedResources.has(r.resource)?(t||(t=[]),t.push(r)):(s||(s=[]),s.push(r));t&&this._onDidFilesChange.fire(new S.FileChangesEvent(t,!a))}if(s){const r=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(s)&&Ge.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,a={recursive:!1,excludes:[]}){const t=new w.DisposableStore;let s=!1,r=()=>{s=!0};return t.add((0,w.toDisposable)(()=>r())),this.doWatch(c,a).then(i=>{s?(0,w.dispose)(i):r=()=>(0,w.dispose)(i)},i=>this.logService.error(i)),a.recursive||(this.watchedResources.set(c,(this.watchedResources.get(c)??0)+1),t.add((0,w.toDisposable)(()=>{const i=this.watchedResources.get(c);typeof i=="number"&&(i<=1?this.watchedResources.delete(c):this.watchedResources.set(c,i-1))}))),t}async doWatch(c,a){const t=await this.withProvider(c),s=this.toWatchKey(t,c,a);let r=this.activeWatchers.get(s);return r||(r={count:0,disposable:t.watch(c,a)},this.activeWatchers.set(s,r)),r.count+=1,(0,w.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,w.dispose)(r.disposable),this.activeWatchers.delete(s)))})}toWatchKey(c,a,t){const{providerExtUri:s}=this.getExtUri(c);return[s.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,w.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{const r=await c.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,E.isReadableStream)(s)||(0,E.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,r,s):await this.doWriteReadableBufferedQueued(c,r,s)}catch(i){throw(0,S.ensureFileSystemProviderError)(i)}finally{await c.close(r)}})}async doWriteStreamBufferedQueued(c,a,t){let s=0,r;if((0,E.isReadableBufferedStream)(t)){if(t.buffer.length>0){const i=D.VSBuffer.concat(t.buffer);await this.doWriteBuffer(c,a,i,i.byteLength,s,0),s+=i.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((i,o)=>{(0,E.listenStream)(r,{onData:async l=>{r.pause();try{await this.doWriteBuffer(c,a,l,l.byteLength,s,0)}catch(u){return o(u)}s+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>o(l),onEnd:()=>i()})})}async doWriteReadableBufferedQueued(c,a,t){let s=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(c,a,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(c,a,t,s,r,i){let o=0;for(;o<s;)o+=await c.write(a,r+o,t.buffer,i+o,s-o)}async doWriteUnbuffered(c,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,a,t,s))}async doWriteUnbufferedQueued(c,a,t,s){let r;s instanceof D.VSBuffer?r=s:(0,E.isReadableStream)(s)?r=await(0,D.streamToBuffer)(s):(0,E.isReadableBufferedStream)(s)?r=await(0,D.bufferedStreamToBuffer)(s):r=(0,D.readableToBuffer)(s),await c.writeFile(a,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(c,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,a,t,s))}async doPipeBufferedQueued(c,a,t,s){let r,i;try{r=await c.open(a,{create:!1}),i=await t.open(s,{create:!0,unlock:!1});const o=D.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,u=0,d=0;do d=await c.read(r,l,o.buffer,u,o.byteLength-u),await this.doWriteBuffer(t,i,o,d,l,u),l+=d,u+=d,u===o.byteLength&&(u=0);while(d>0)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await L.Promises.settled([typeof r=="number"?c.close(r):Promise.resolve(),typeof i=="number"?t.close(i):Promise.resolve()])}}async doPipeUnbuffered(c,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,a,t,s))}async doPipeUnbufferedQueued(c,a,t,s){return t.writeFile(s,await c.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,a,t,s))}async doPipeUnbufferedToBufferedQueued(c,a,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const i=await c.readFile(a);await this.doWriteBuffer(t,r,D.VSBuffer.wrap(i),i.byteLength,0,0)}catch(i){throw(0,S.ensureFileSystemProviderError)(i)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(c,a,t,s){const r=await(0,D.streamToBuffer)(this.readFileBuffered(c,a,k.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,r)}throwIfFileSystemIsReadonly(c,a){if(c.capabilities&2048)throw new S.FileOperationError((0,h.localize)(22,null,this.resourceForError(a)),6);return c}throwIfFileIsReadonly(c,a){if((a.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===n.Schemas.file?c.fsPath:c.toString(!0)}};m.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},m=he([X(0,p.ILogService)],m),e.FileService=m}),define(te[178],ne([0,1,53,244,5,22,3,39,9,4,16,52,19,139,14,85,163,164,165,166,42,175,37]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f,p,m,y,c,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(R)}catch(r){console.error(`Error enabling graceful-fs: ${(0,t.toErrorMessage)(r)}`)}})();class s extends a.AbstractDiskFileSystemProvider{constructor(i,o){super(i);this.options=o,this.onDidChangeCapabilities=A.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:o,symbolicLink:l}=await v.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(o,l),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(i){try{const o=await v.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),l=[];return await Promise.all(o.map(async u=>{try{let d;u.isSymbolicLink()?d=(await this.stat((0,n.joinPath)(i,u.name))).type:d=this.toType(u),l.push([u.name,d])}catch(d){this.logService.trace(d)}})),l}catch(o){throw this.toFileSystemProviderError(o)}}toType(i,o){let l;return o?.dangling?l=h.FileType.Unknown:i.isFile()?l=h.FileType.File:i.isDirectory()?l=h.FileType.Directory:l=h.FileType.Unknown,o&&(l|=h.FileType.SymbolicLink),l}async readFile(i){try{const o=this.toFilePath(i);return await v.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(i,o,l){const u=(0,I.newWriteableStream)(d=>k.VSBuffer.concat(d.map(g=>k.VSBuffer.wrap(g))).buffer);return(0,S.readFileIntoStream)(this,i,u,d=>d.buffer,{...o,bufferSize:256*1024},l),u}async writeFile(i,o,l){let u;try{const d=this.toFilePath(i);if(!l.create||!l.overwrite){if(await v.Promises.exists(d)){if(!l.overwrite)throw(0,h.createFileSystemProviderError)((0,E.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,h.createFileSystemProviderError)((0,E.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(i,{create:!0,unlock:l.unlock}),await this.write(u,0,o,0,o.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(i,d)}finally{typeof u=="number"&&await this.close(u)}}async open(i,o){try{const l=this.toFilePath(i);if((0,h.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:g}=await v.SymlinkSupport.stat(l);g.mode&128||await v.Promises.chmod(l,g.mode|128)}catch(g){this.logService.trace(g)}let u;if((0,h.isFileOpenForWriteOptions)(o)){if(b.isWindows)try{await v.Promises.truncate(l,0),u="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}u||(u="w")}else u="r";const d=await v.Promises.open(l,u);return this.mapHandleToPos.set(d,0),(0,h.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(d,i),d}catch(l){throw(0,h.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(i,l):this.toFileSystemProviderError(l)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await v.Promises.fdatasync(i)}catch(o){this.canFlush=!1,this.logService.error(o)}return await v.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}}async read(i,o,l,u,d){const g=this.normalizePos(i,o);let T=null;try{const _=await v.Promises.read(i,l,u,d,g);return typeof _=="number"?T=_:T=_.bytesRead,T}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(i,g,T)}}normalizePos(i,o){return o===this.mapHandleToPos.get(i)?null:o}updatePos(i,o,l){const u=this.mapHandleToPos.get(i);typeof u=="number"&&(typeof o=="number"||(typeof l=="number"?this.mapHandleToPos.set(i,u+l):this.mapHandleToPos.delete(i)))}async write(i,o,l,u,d){return(0,D.retry)(()=>this.doWrite(i,o,l,u,d),100,3)}async doWrite(i,o,l,u,d){const g=this.normalizePos(i,o);let T=null;try{const _=await v.Promises.write(i,l,u,d,g);return typeof _=="number"?T=_:T=_.bytesWritten,T}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),_)}finally{this.updatePos(i,g,T)}}async mkdir(i){try{await v.Promises.mkdir(this.toFilePath(i))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(i,o){try{const l=this.toFilePath(i);await this.doDelete(l,o)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(i,o){o.recursive?await v.Promises.rm(i,v.RimRafMode.MOVE):await v.Promises.unlink(i)}async rename(i,o,l){const u=this.toFilePath(i),d=this.toFilePath(o);if(u!==d)try{await this.validateTargetDeleted(i,o,"move",l.overwrite),await v.Promises.move(u,d)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,E.localize)(2,null,(0,w.basename)(u),(0,w.basename)((0,w.dirname)(d)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(i,o,l){const u=this.toFilePath(i),d=this.toFilePath(o);if(u!==d)try{await this.validateTargetDeleted(i,o,"copy",l.overwrite),await v.Promises.copy(u,d,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,E.localize)(3,null,(0,w.basename)(u),(0,w.basename)((0,w.dirname)(d)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(i,o,l,u){const d=this.toFilePath(i),g=this.toFilePath(o);let T=!1;if(!!(this.capabilities&1024)||(T=(0,P.isEqual)(d,g,!0)),T&&l==="copy")throw(0,h.createFileSystemProviderError)((0,E.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!T&&await v.Promises.exists(g)){if(!u)throw(0,h.createFileSystemProviderError)((0,E.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(i,o,l,u){let d,g;if(this.options?.watcher?.usePolling)d=y.FileWatcher,g=this.options?.watcher;else{let T=!1;this.options?.legacyWatcher==="on"||this.options?.legacyWatcher==="off"?T=this.options.legacyWatcher==="on":c.default.quality==="stable"&&(T=i===1),T?b.isLinux?d=y.FileWatcher:d=p.FileWatcher:d=m.FileWatcher}return new d(T=>o(T),T=>l(T),u,g)}createNonRecursiveWatcher(i,o,l,u){return new f.FileWatcher(i,d=>o(d),d=>l(d),u)}toFileSystemProviderError(i){if(i instanceof h.FileSystemProviderError)return i;let o;switch(i.code){case"ENOENT":o=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=h.FileSystemProviderErrorCode.NoPermissions;break;default:o=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(i,o)}async toFileSystemProviderWriteError(i,o){let l=this.toFileSystemProviderError(o);if(i&&l.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await v.SymlinkSupport.stat(this.toFilePath(i));u.mode&128||(l=(0,h.createFileSystemProviderError)(o,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return l}}e.DiskFileSystemProvider=s}),define(te[30],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService")}),define(te[179],ne([0,1,5,8,2,9,19,10,30]),function(J,e,R,L,D,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends D.Disposable{constructor(I,v,E){super();this.productService=v,this.logService=E,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,I&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(I)},30*1e3)).schedule()}async cleanUpCodeCaches(I){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const v=Date.now(),E=(0,k.dirname)(I),h=(0,k.basename)(I),S=await A.Promises.readdir(E);await Promise.all(S.map(async f=>{if(f===h)return;const p=(0,k.join)(E,f),m=await A.Promises.stat(p);if(m.isDirectory()&&v-m.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),A.Promises.rm(p)}))}catch(v){(0,L.onUnexpectedError)(v)}}};b=he([X(1,w.IProductService),X(2,P.ILogService)],b),e.CodeCacheCleaner=b}),define(te[180],ne([0,1,5,8,2,9,19,13,10,30]),function(J,e,R,L,D,k,A,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends D.Disposable{constructor(v,E,h){super();this.environmentService=v,this.logService=E,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const v=Object.create(null),E=JSON.parse(await A.Promises.readFile((0,k.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let m of Object.keys(E)){const y=E[m];v[`${y.hash}.${m}`]=!0}const h=(0,k.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(h))return;const f=await A.Promises.readdir(h);for(const m of f){if(v[m]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${m}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${m}`),await A.Promises.rm((0,k.join)(h,m))}const p=Date.now();for(const m of Object.keys(v)){const y=(0,k.join)(h,m),c=await A.Promises.readdir(y);for(const a of c){if(a==="tcf.json")continue;const t=(0,k.join)(y,a),s=await A.Promises.stat(t);s.isDirectory()&&p-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(m,a)}`),await A.Promises.rm(t))}}}catch(v){(0,L.onUnexpectedError)(v)}}};n=he([X(0,P.INativeEnvironmentService),X(1,w.ILogService),X(2,b.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(te[34],ne([0,1,99,18]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(A,P){R.ok(L.isString(A)),R.ok(L.isObject(P)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new D}),define(te[86],ne([0,1,3,34]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class k{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,b){this.schemasById[D(w)]=b,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new k;L.Registry.add(e.Extensions.JSONContribution,A)}),define(te[38],ne([0,1,17,3,18,125,86,34]),function(J,e,R,L,D,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const n=P.Registry.as(A.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(y,c=!0){this.registerConfigurations([y],c)}registerConfigurations(y,c=!0){const a=this.doRegisterConfigurations(y,c);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(y){const c=this.doDeregisterConfigurations(y);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}updateConfigurations({add:y,remove:c}){const a=[];a.push(...this.doDeregisterConfigurations(c)),a.push(...this.doRegisterConfigurations(y,!1)),n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,R.distinct)(a))}registerDefaultConfigurations(y){const c=[],a=[];for(const t of y)for(const s in t)if(c.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]={...this.defaultValues[s]||{},...t[s]};const r={type:"object",default:this.defaultValues[s],description:k.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};a.push(E(s)),this.configurationProperties[s]=r,this.defaultLanguageConfigurationOverridesNode.properties[s]=r}else{this.defaultValues[s]=t[s];const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(y){const c=[];for(const a of y)for(const t in a)if(c.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...y){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(y){for(const c of y)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(y,c){const a=[];return y.forEach(t=>{a.push(...this.validateAndRegisterProperties(t,c,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),a}doDeregisterConfigurations(y){const c=[],a=t=>{if(t.properties)for(const s in t.properties)c.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,t.properties[s]);t.allOf&&t.allOf.forEach(s=>a(s))};for(const t of y){a(t);const s=this.configurationContributors.indexOf(t);s!==-1&&this.configurationContributors.splice(s,1)}return c}validateAndRegisterProperties(y,c=!0,a,t=3){t=D.isUndefinedOrNull(y.scope)?t:y.scope;let s=[],r=y.properties;if(r)for(let o in r){if(c&&f(o)){delete r[o];continue}const l=r[o];if(this.updatePropertyDefaultValue(o,l),e.OVERRIDE_PROPERTY_PATTERN.test(o)?l.scope=void 0:(l.scope=D.isUndefinedOrNull(l.scope)?t:l.scope,l.restricted=D.isUndefinedOrNull(l.restricted)?!!a?.restrictedConfigurations?.includes(o):l.restricted),r[o].hasOwnProperty("included")&&!r[o].included){this.excludedConfigurationProperties[o]=r[o],delete r[o];continue}else this.configurationProperties[o]=r[o];!r[o].deprecationMessage&&r[o].markdownDeprecationMessage&&(r[o].deprecationMessage=r[o].markdownDeprecationMessage),s.push(o)}let i=y.allOf;if(i)for(let o of i)s.push(...this.validateAndRegisterProperties(o,c,a,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(y){const c=a=>{let t=a.properties;if(t)for(const r in t)this.updateSchema(r,t[r]);let s=a.allOf;s&&s.forEach(c)};c(y)}updateSchema(y,c){switch(e.allSettings.properties[y]=c,c.scope){case 1:e.applicationSettings.properties[y]=c;break;case 2:e.machineSettings.properties[y]=c;break;case 6:e.machineOverridableSettings.properties[y]=c;break;case 3:e.windowSettings.properties[y]=c;break;case 4:e.resourceSettings.properties[y]=c;break;case 5:e.resourceSettings.properties[y]=c,this.resourceLanguageSettingsSchema.properties[y]=c;break}}removeFromSchema(y,c){switch(delete e.allSettings.properties[y],c.scope){case 1:delete e.applicationSettings.properties[y];break;case 2:delete e.machineSettings.properties[y];break;case 6:delete e.machineOverridableSettings.properties[y];break;case 3:delete e.windowSettings.properties[y];break;case 4:case 5:delete e.resourceSettings.properties[y];break}}updateOverridePropertyPatternKey(){for(const y of this.overrideIdentifiers.values()){const c=`[${y}]`,a={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,a),e.allSettings.properties[c]=a,e.applicationSettings.properties[c]=a,e.machineSettings.properties[c]=a,e.machineOverridableSettings.properties[c]=a,e.windowSettings.properties[c]=a,e.resourceSettings.properties[c]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(y,c){let a=this.defaultValues[y];D.isUndefined(a)&&(a=c.default),D.isUndefined(a)&&(a=h(c.type)),c.default=a}}const v="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(v);function E(m){return m.substring(1,m.length-1)}e.overrideIdentifierFromKey=E;function h(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const S=new I;P.Registry.add(e.Extensions.Configuration,S);function f(m){return m.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(m)?k.localize(5,null,m):S.getConfigurationProperties()[m]!==void 0?k.localize(6,null,m):null:k.localize(4,null)}e.validateProperty=f;function p(){const m=[],y=S.getConfigurationProperties();for(const c of Object.keys(y))m.push([c,y[c].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=p}),define(te[20],ne([0,1,26,18,7,38,6,34]),function(J,e,R,L,D,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function w(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof D.URI)}e.isConfigurationOverrides=w;var b;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function I(s,r){const i=r?s?r.keys.filter(_=>s.keys.indexOf(_)===-1):[...r.keys]:[],o=s?r?s.keys.filter(_=>r.keys.indexOf(_)===-1):[...s.keys]:[],l=[];if(r&&s){for(const _ of s.keys)if(r.keys.indexOf(_)!==-1){const O=p(s.contents,_),F=p(r.contents,_);R.equals(O,F)||l.push(_)}}const u=[],d=_=>{const O={};for(const F of _)for(const C of F.identifiers)O[a(C)]=F;return O},g=r?d(r.overrides):{},T=s?d(s.overrides):{};if(Object.keys(g).length)for(const _ of i){const O=g[_];O&&u.push([(0,k.overrideIdentifierFromKey)(_),O.keys])}if(Object.keys(T).length)for(const _ of o){const O=T[_];O&&u.push([(0,k.overrideIdentifierFromKey)(_),O.keys])}if(Object.keys(g).length&&Object.keys(T).length)for(const _ of l){const O=T[_],F=g[_];if(O&&F){const C=I({contents:O.contents,keys:O.keys,overrides:[]},{contents:F.contents,keys:F.keys,overrides:[]});u.push([(0,k.overrideIdentifierFromKey)(_),[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:o,updated:l,overrides:u}}e.compare=I;function v(s,r){const i=[];for(const o of Object.keys(s))if(k.OVERRIDE_PROPERTY_PATTERN.test(o)){const l={};for(const u in s[o])l[u]=s[o][u];i.push({identifiers:[(0,k.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(l),contents:E(l,r)})}return i}e.toOverrides=v;function E(s,r){const i=Object.create(null);for(let o in s)h(i,o,s[o],r);return i}e.toValuesTree=E;function h(s,r,i,o){const l=r.split("."),u=l.pop();let d=s;for(let g=0;g<l.length;g++){let T=l[g],_=d[T];switch(typeof _){case"undefined":_=d[T]=Object.create(null);break;case"object":break;default:o(`Ignoring ${r} as ${l.slice(0,g+1).join(".")} is ${JSON.stringify(_)}`);return}d=_}if(typeof d=="object"&&d!==null)try{d[u]=i}catch(g){o(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(d)}`)}else o(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=h;function S(s,r){const i=r.split(".");f(s,i)}e.removeFromValueTree=S;function f(s,r){const i=r.shift();if(r.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const o=s[i];typeof o=="object"&&!Array.isArray(o)&&(f(o,r),Object.keys(o).length===0&&delete s[i])}}function p(s,r,i){function o(d,g){let T=d;for(const _ of g){if(typeof T!="object"||T===null)return;T=T[_]}return T}const l=r.split("."),u=o(s,l);return typeof u=="undefined"?i:u}e.getConfigurationValue=p;function m(s,r,i){Object.keys(r).forEach(o=>{o!=="__proto__"&&(o in s?L.isObject(s[o])&&L.isObject(r[o])?m(s[o],r[o],i):i&&(s[o]=r[o]):s[o]=r[o])})}e.merge=m;function y(){const s=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=y;function c(){const s=Object.create(null),r=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let i in r){let o=r[i].default;h(s,i,o,l=>console.error(`Conflict in default settings: ${l}`))}return s}e.getDefaultValues=c;function a(s){return`[${s}]`}e.keyFromOverrideIdentifier=a;function t(s,r,i){const o=s.inspect(r),l=s.inspect(i);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:o.defaultValue}e.getMigratedSettingValue=t}),define(te[87],ne([0,1,17,3,36,2,40,26,18,7,20,38,34]),function(J,e,R,L,D,k,A,P,w,b,n,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(t={},s=[],r=[]){this._contents=t,this._keys=s,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?(0,n.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){let s=this.overrideConfigurations.get(t);return s||(s=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,s)),s}merge(...t){const s=P.deepClone(this.contents),r=P.deepClone(this.overrides),i=[...this.keys];for(const o of t){this.mergeContents(s,o.contents);for(const l of o.overrides){const[u]=r.filter(d=>R.equals(d.identifiers,l.identifiers));u?this.mergeContents(u.contents,l.contents):r.push(P.deepClone(l))}for(const l of o.keys)i.indexOf(l)===-1&&i.push(l)}return new E(s,i,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const i of R.distinct([...Object.keys(this.contents),...Object.keys(s)])){let o=this.contents[i],l=s[i];l&&(typeof o=="object"&&typeof l=="object"?(o=P.deepClone(o),this.mergeContents(o,l)):o=l),r[i]=o}return new E(r,this.keys,this.overrides)}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&w.isObject(t[r])&&w.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=P.deepClone(s[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,n.addToValueTree)(this.contents,t,s,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let r=0;r<s;r++)t.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=E;class h extends E{constructor(){const t=(0,n.getDefaultValues)(),s=(0,n.getConfigurationKeys)(),r=[];for(const i of Object.keys(t))I.OVERRIDE_PROPERTY_PATTERN.test(i)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,s,r)}}e.DefaultConfigurationModel=h;class S{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!w.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:i,overrides:o,restricted:l}=this.doParseRaw(t,s);this._configurationModel=new E(r,i,o),this._restrictedConfigurations=l||[]}doParseContent(t){let s={},r=null,i=[],o=[],l=[];function u(g){Array.isArray(i)?i.push(g):r!==null&&(i[r]=g)}let d={onObjectBegin:()=>{let g={};u(g),o.push(i),i=g,r=null},onObjectProperty:g=>{r=g},onObjectEnd:()=>{i=o.pop()},onArrayBegin:()=>{let g=[];u(g),o.push(i),i=g,r=null},onArrayEnd:()=>{i=o.pop()},onLiteralValue:u,onError:(g,T,_)=>{l.push({error:g,offset:T,length:_})}};if(t)try{D.visit(t,d),s=i[0]||{}}catch(g){console.error(`Error while parsing settings file ${this._name}: ${g}`),this._parseErrors=[g]}return s}doParseRaw(t,s){const r=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,r,!0,s);t=i.raw;const o=(0,n.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),l=Object.keys(t),u=(0,n.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:o,keys:l,overrides:u,restricted:i.restricted}}filter(t,s,r,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const o={},l=[];for(let u in t)if(I.OVERRIDE_PROPERTY_PATTERN.test(u)&&r){const d=this.filter(t[u],s,!1,i);o[u]=d.raw,l.push(...d.restricted)}else{const d=s[u],g=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&l.push(u),(g===void 0||i.scopes===void 0||i.scopes.includes(g))&&(i.skipRestricted&&d?.restricted||(o[u]=t[u]))}return{raw:o,restricted:l}}}e.ConfigurationModelParser=S;class f extends k.Disposable{constructor(t,s,r,i){super();this.userSettingsResource=t,this.scopes=s,this.fileService=i,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class p{constructor(t,s,r=new E,i=new E,o=new A.ResourceMap,l=new E,u=new A.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=o,this._memoryConfiguration=l,this._memoryConfigurationByResource=u,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(t)}updateValue(t,s,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new E,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,s===void 0?i.removeValue(t):i.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const i=this.getConsolidateConfigurationModel(s,r),o=this.getFolderConfigurationModelForResource(s.resource,r),l=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),g=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),T=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),_=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=o?s.overrideIdentifier?o.freeze().override(s.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,F=s.overrideIdentifier?l.override(s.overrideIdentifier).getValue(t):l.getValue(t),C=i.getValue(t),N=R.distinct(R.flatten(i.overrides.map(z=>z.identifiers))).filter(z=>i.getOverrideValue(t,z)!==void 0);return{defaultValue:u,userValue:d,userLocalValue:g,userRemoteValue:T,workspaceValue:_,workspaceFolderValue:O,memoryValue:F,value:C,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:g!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:_!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:o?.freeze().getValue(t),override:s.overrideIdentifier?o?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:l.getValue(t),override:s.overrideIdentifier?l.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:N.length?N:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=s.filter(i=>I.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const o=(0,I.overrideIdentifierFromKey)(i),l=this._defaultConfiguration.getKeysForOverrideIdentifier(o),u=t.getKeysForOverrideIdentifier(o),d=[...u.filter(g=>l.indexOf(g)===-1),...l.filter(g=>u.indexOf(g)===-1),...l.filter(g=>!P.equals(this._defaultConfiguration.override(o).getValue(g),t.override(o).getValue(g)))];return[o,d]});return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:i,overrides:o}=(0,n.compare)(this.localUserConfiguration,t),l=[...s,...r,...i];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:i,overrides:o}=(0,n.compare)(this.remoteUserConfiguration,t);let l=[...s,...r,...i];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:i,overrides:o}=(0,n.compare)(this.workspaceConfiguration,t);let l=[...s,...r,...i];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:o}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:i,updated:o,removed:l,overrides:u}=(0,n.compare)(r,s);let d=[...i,...o,...l];return(d.length||!r)&&this.updateFolderConfiguration(t,s),{keys:d,overrides:u}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:i,removed:o,overrides:l}=(0,n.compare)(s,void 0);return{keys:[...r,...i,...o],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const i=s.getFolder(t);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const o=this._memoryConfigurationByResource.get(t);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(s=r.merge(i),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:i,keys:o}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:i,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((l,u)=>(l.set(b.URI.revive(u[0]),this.parseConfigurationModel(u[1])),l),new A.ResourceMap);return new p(s,r,new E,i,o,new E,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new E(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=p;function m(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,s=new Map;for(const i of a)i.keys.forEach(o=>t.add(o)),i.overrides.forEach(([o,l])=>{const u=(0,A.getOrSet)(s,o,new Set);l.forEach(d=>u.add(d))});const r=[];return s.forEach((i,o)=>r.push([o,[...i.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=m;class y{constructor(t,s,r,i){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(u=>o.add(u)),t.overrides.forEach(([,u])=>u.forEach(d=>o.add(d))),this.affectedKeys=[...o.values()];const l=new E;this.affectedKeys.forEach(u=>l.setValue(u,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!P.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let r=(0,n.toValuesTree)({[s]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(t=t[i],!t)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=y;class c extends y{constructor(t,s,r,i){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=c}),define(te[181],ne([0,1,5,3,2,16,20,87,38,34]),function(J,e,R,L,D,k,A,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends D.Disposable{constructor(v,E){super();this.settingsResource=v,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,E)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const v=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,v)}getConfigurationData(){return this.configuration.toData()}getValue(v,E){const h=typeof v=="string"?v:void 0,S=(0,A.isConfigurationOverrides)(v)?v:(0,A.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(h,S,void 0)}updateValue(v,E,h,S){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const E=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(h,E,1)}onDidDefaultConfigurationChange(v){const E=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,v);this.trigger(h,E,6)}trigger(v,E,h){const S=new P.ConfigurationChangeEvent(v,{data:E},this.configuration);S.source=h,S.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(v){switch(v){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(te[182],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var L;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(A,P=L.Unknown,w){super(A);this._message=A,this._code=P,this._detail=w,this.isHandled=P===L.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(A){return A instanceof D&&A._code===L.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof D&&A._code===L.NoResolverFound}static isHandled(A){return A instanceof D&&A.isHandled}}e.RemoteAuthorityResolverError=D}),define(te[183],ne([0,1,5,22,27,8,3,2,28,71,182]),function(J,e,R,L,D,k,A,P,w,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var v;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function E(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(U){const V=new D.CancellationTokenSource;return setTimeout(()=>V.cancel(),U),V.token}function S(U,V){if(U.isCancellationRequested||V.isCancellationRequested)return D.CancellationToken.Cancelled;const B=new D.CancellationTokenSource;return U.onCancellationRequested(()=>B.cancel()),V.onCancellationRequested(()=>B.cancel()),B.token}class f{constructor(V){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((B,Q)=>{this._resolvePromise=B,this._rejectPromise=Q}),V.isCancellationRequested?this._timeout():this._disposables.add(V.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(V){this._state==="pending"?this._disposables.add(V):V.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const V=new Error("Time limit reached");return V.code="ETIMEDOUT",V.syscall="connect",V}resolve(V){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(V))}reject(V){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(V))}}function p(U,V){const B=new f(V);return B.registerDisposable(U.onControlMessage(Q=>{const Z=JSON.parse(Q.toString()),K=W(Z);K?B.reject(K):B.resolve(Z)})),B.promise}function m(U,V,B,Q,Z,K){const H=new f(K);return V.connect(B,Q,Z,(re,ie)=>{H.didTimeout?(re&&U.error(re),ie?.dispose()):re||!ie?H.reject(re):H.resolve(ie)}),H.promise}function y(U,V){const B=new f(V);return U.then(Q=>{B.didTimeout||B.resolve(Q)},Q=>{B.didTimeout||B.reject(Q)}),B.promise}async function c(U,V,B,Q){const Z=$(U,V);U.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let K;try{K=await m(U.logService,U.socketFactory,U.host,U.port,`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,Q)}catch(le){throw U.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),U.logService.error(le),le}U.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let H,re;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(K,null),H=U.reconnectionProtocol,re=!1):(H=new b.PersistentProtocol(K,null),re=!0),U.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const ie=await y(U.signService.createNewMessage((0,w.generateUuid)()),Q),ce={type:"auth",auth:U.connectionToken||"00000000000000000000",data:ie.data};H.sendControl(L.VSBuffer.fromString(JSON.stringify(ce)));try{const le=await p(H,S(Q,h(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(U.logService.trace(`${Z} 4/6. received SignRequest control message.`),!await y(U.signService.validate(ie,le.signedData),Q)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const fe=await y(U.signService.sign(le.data),Q),be={type:"connectionType",commit:U.commit,signedData:fe,desiredConnectionType:V};return B&&(be.args=B),U.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(L.VSBuffer.fromString(JSON.stringify(be))),{protocol:H,ownsProtocol:re}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(U.logService.error(`${Z} the handshake timed out. Error:`),U.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${Z} received error control message when negotiating connection. Error:`),U.logService.error(le)),re&&q(H),le}}async function a(U,V,B,Q){const Z=Date.now(),K=$(U,V),{protocol:H,ownsProtocol:re}=await c(U,V,B,Q),ie=new f(Q);return ie.registerDisposable(H.onControlMessage(ce=>{const le=JSON.parse(ce.toString()),de=W(le);de?(U.logService.error(`${K} received error control message when negotiating connection. Error:`),U.logService.error(de),re&&q(H),ie.reject(de)):(U.reconnectionProtocol&&U.reconnectionProtocol.endAcceptReconnection(),U.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${G(Z)}!`),ie.resolve({protocol:H,firstMessage:le}))})),ie.promise}async function t(U,V){const{protocol:B}=await a(U,1,void 0,V);return{protocol:B}}async function s(U,V,B){const{protocol:Q,firstMessage:Z}=await a(U,2,V,B),K=Z&&Z.debugPort;return{protocol:Q,debugPort:K}}async function r(U,V,B){const Q=Date.now(),Z=$(U,3),{protocol:K}=await c(U,3,V,B);return U.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${G(Q)}!`),K}async function i(U,V,B){const{host:Q,port:Z,connectionToken:K}=await U.addressProvider.getAddress();return{commit:U.commit,host:Q,port:Z,connectionToken:K,reconnectionToken:V,reconnectionProtocol:B,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function o(U,V,B){try{const Q=(0,w.generateUuid)(),Z=await i(U,Q,null),{protocol:K}=await t(Z,D.CancellationToken.None);return new z(U,V,B,Q,K)}catch(Q){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(Q),N.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(Q)),Q}}e.connectRemoteAgentManagement=o;async function l(U,V){try{const B=(0,w.generateUuid)(),Q=await i(U,B,null),{protocol:Z,debugPort:K}=await s(Q,V,D.CancellationToken.None);return new M(U,V,B,Z,K)}catch(B){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(B),N.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentExtensionHost=l;async function u(U,V,B){const Q=await i(U,(0,w.generateUuid)(),null);return await r(Q,{host:V,port:B},D.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function d(U){return(0,R.createCancelablePromise)(V=>new Promise((B,Q)=>{const Z=setTimeout(B,U*1e3);V.onCancellationRequested(()=>{clearTimeout(Z),B()})}))}var g;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(g=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class T{constructor(V,B){this.reconnectionToken=V,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=T;class _{constructor(V,B,Q,Z){this.reconnectionToken=V,this.millisSinceLastIncomingData=B,this.durationSeconds=Q,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(V,B,Q){this.reconnectionToken=V,this.millisSinceLastIncomingData=B,this.attempt=Q,this.type=2}}e.ReconnectionRunningEvent=O;class F{constructor(V,B,Q){this.reconnectionToken=V,this.millisSinceLastIncomingData=B,this.attempt=Q,this.type=4}}e.ConnectionGainEvent=F;class C{constructor(V,B,Q,Z){this.reconnectionToken=V,this.millisSinceLastIncomingData=B,this.attempt=Q,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=C;class N extends P.Disposable{constructor(V,B,Q,Z){super();this._connectionType=V,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=B,this.reconnectionToken=Q,this.protocol=Z,this._isReconnecting=!1,this._onDidStateChange.fire(new F(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(K=>{const H=x(this._connectionType,this.reconnectionToken,!0);K?K.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${K.hadError}).`),K.error&&this._options.logService.error(K.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${K.wasClean}, code: ${K.code}, reason: ${K.reason}).`),K.event&&this._options.logService.error(K.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(()=>{const K=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${K} received socket timeout event.`),this._beginReconnecting()})),N._instances.push(this),N._permanentFailure&&this._gotoPermanentFailure(N._permanentFailureMillisSinceLastIncomingData,N._permanentFailureAttempt,N._permanentFailureHandled)}static triggerPermanentFailure(V,B,Q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=V,this._permanentFailureAttempt=B,this._permanentFailureHandled=Q,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(N._permanentFailure)return;const V=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${V} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const Z=Q<B.length?B[Q]:B[B.length-1];try{if(Z>0){const H=d(Z);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,H)),this._options.logService.info(`${V} waiting for ${Z} seconds before reconnecting...`);try{await H}catch{}}if(N._permanentFailure){this._options.logService.error(`${V} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this._options.logService.info(`${V} resolving connection...`);const K=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${V} connecting to ${K.host}:${K.port}...`),await this._reconnect(K,h(I)),this._options.logService.info(`${V} reconnected!`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${V} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(K),N.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this._options.logService.error(`${V} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(K),N.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(K)){this._options.logService.info(`${V} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this._options.logService.info(`${V} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if((0,k.isPromiseCanceledError)(K)){this._options.logService.info(`${V} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if(K instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${V} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(K),N.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,n.RemoteAuthorityResolverError.isHandled(K));break}this._options.logService.error(`${V} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(K),N.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!N._permanentFailure)}_gotoPermanentFailure(V,B,Q){this._onDidStateChange.fire(new C(this.reconnectionToken,V,B,Q)),q(this.protocol)}}N._permanentFailure=!1,N._permanentFailureMillisSinceLastIncomingData=0,N._permanentFailureAttempt=0,N._permanentFailureHandled=!1,N._instances=[];class z extends N{constructor(V,B,Q,Z,K){super(1,V,Z,K);this.client=this._register(new b.Client(K,{remoteAuthority:B,clientId:Q},V.ipcLogger))}async _reconnect(V,B){await t(V,B)}}e.ManagementPersistentConnection=z;class M extends N{constructor(V,B,Q,Z,K){super(2,V,Q,Z);this._startArguments=B,this.debugPort=K}async _reconnect(V,B){await s(V,this._startArguments,B)}}e.ExtensionHostPersistentConnection=M;function q(U){try{U.acceptDisconnect();const V=U.getSocket();U.dispose(),V.dispose()}catch(V){(0,k.onUnexpectedError)(V)}}function W(U){if(U&&U.type==="error"){const V=new Error(`Connection error: ${U.reason}`);return V.code="VSCODE_CONNECTION_ERROR",V}return null}function j(U,V){for(;U.length<V;)U+=" ";return U}function x(U,V,B){return`[remote-connection][${j(E(U),13)}][${V.substr(0,5)}\u2026][${B?"reconnect":"initial"}]`}function $(U,V){return`${x(V,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function G(U){return`${Date.now()-U} ms`}}),define(te[184],ne([0,1,15]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(b){return b.scheme===R.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=L;function D(b){if(!b)return;const n=b.indexOf("+");return n<0?b:b.substr(0,n)}e.getRemoteName=D;function k(b){return b.scheme!==R.Schemas.file&&b.scheme!==R.Schemas.vscodeRemote}e.isVirtualResource=k;function A(b){if(b.folders.length)return b.folders.every(n=>k(n.uri))?b.folders[0].uri:void 0;if(b.configuration&&k(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=A;function P(b){return A(b)?.scheme}e.getVirtualWorkspaceScheme=P;function w(b){return A(b)!==void 0}e.isVirtualWorkspace=w}),define(te[88],ne([0,1,25,6,184]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=k;function A(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class w{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,h){if(typeof E=="undefined"||E===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof E=="string"||typeof h=="string"){let S=typeof E=="string"?E:E.value,f=typeof h=="string"?h:h.value;return R.equalsIgnoreCase(S,f)}return E._lower===h._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=w;function b(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function n(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=n;function I(v,E){if(E&&v.enableProposedApi){const h=`onResolveRemoteAuthority:${(0,D.getRemoteName)(E)}`;return v.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[35],ne([0,1,25,88]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,S){return h.uuid&&S.uuid?h.uuid===S.uuid:h.id===S.id?!0:(0,R.compareIgnoreCase)(h.id,S.id)===0}e.areSameExtensions=D;class k{constructor(S,f){this.version=f,this.id=S.id,this.uuid=S.uuid}key(){return`${this.id}-${this.version}`}equals(S){return S instanceof k?D(this,S)&&this.version===S.version:!1}}e.ExtensionIdentifierWithVersion=k;function A(h,S){return`${h}.${S}`}e.getExtensionId=A;function P(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function w(h,S){return P(A(h,S))}e.getGalleryExtensionId=w;function b(h,S){const f=[],p=m=>{for(const y of f)if(y.some(c=>D(S(c),S(m))))return y;return null};for(const m of h){const y=p(m);y?y.push(m):f.push([m])}return f}e.groupByExtension=b;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function I(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function v(h){const S=new Set;for(const f of h)f.malicious&&S.add(f.id.id);return S}e.getMaliciousExtensionsSet=v;function E(h,S){const f=[],p=S.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const m=p.shift();if(m&&f.every(y=>!D(y.identifier,{id:m}))){const y=h.filter(c=>D(c.identifier,{id:m}));y.length===1&&(f.push(y[0]),p.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}e.getExtensionDependencies=E}),define(te[185],ne([0,1,5,8,2,4,16,61,7,28,19,13,29,35,14,10]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const f=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let p=class extends D.Disposable{constructor(y,c,a,t){super();this.fileService=c,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=w.URI.file(y.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(y,c){await this.cleanUpPromise;const a=this.getName(y),t=(0,A.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const s=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(y,s,c);try{await this.rename(s,t,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(s)}catch(i){}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",y.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,s.path),r}}return t}async delete(y){await this.cleanUpPromise,await this.fileService.del(y)}async rename(y,c,a){try{await n.Promises.rename(y.fsPath,c.fsPath)}catch(t){if(k.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${y} to ${c} with 'EPERM' error. Trying again...`),this.rename(y,c,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const y=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(y.children){const c=[],a=[];for(const r of y.children){const i=this.parse(r.name);i&&a.push([i,r])}const t=(0,E.groupByExtension)(a,([r])=>r),s=[];for(const r of t)r.sort((i,o)=>P.rcompare(i[0].version,o[0].version)),c.push(...r.slice(1).map(i=>i[1].resource)),s.push(r[0][1]);s.sort((r,i)=>r.mtime-i.mtime),c.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(r=>r.resource)),await R.Promises.settled(c.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(y){this.logService.error(y)}}getName(y){return this.cache?`${new E.ExtensionIdentifierWithVersion(y.identifier,y.version).key().toLowerCase()}${y.properties.targetPlatform!=="undefined"?`-${y.properties.targetPlatform}`:""}`:(0,b.generateUuid)()}parse(y){const c=f.exec(y);return c&&c[1]&&c[2]?new E.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};p=he([X(0,I.INativeEnvironmentService),X(1,h.IFileService),X(2,v.IExtensionGalleryService),X(3,S.ILogService)],p),e.ExtensionsDownloader=p}),define(te[186],ne([0,1,2,9,19,88]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends R.Disposable{constructor(w,b){super();this.environmentService=w,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(b.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(w){w.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(w){w.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(te[187],ne([0,1,3,2,16,7,13,35,14,10]),function(J,e,R,L,D,k,A,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends L.Disposable{constructor(v,E,h,S){super();this.extensionsManagementService=v,this.logService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(m=>{this.installedExtensions=m.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(v.onInstallExtension(m=>this.onInstallExtension(m))),this._register(v.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(v.onDidUninstallExtension(m=>this.onDidUninstallExtension(m)));const f=k.URI.file(h.extensionsPath),p=new D.ExtUri(m=>!E.hasCapability(m,1024));this._register(E.watch(f)),this._register(R.Event.filter(E.onDidChangeFilesRaw,m=>m.changes.some(y=>this.doesChangeAffects(y,f,p)))(()=>this.onDidChange()))}doesChangeAffects(v,E,h){return h.isEqual(h.dirname(v.resource),E)?h.isEqual(v.resource,h.joinPath(E,".obsolete"))?!0:!(v.type!==1&&v.type!==2||h.basename(v.resource).startsWith(".")):!1}onInstallExtension(v){this.addInstallingExtension(v.identifier)}onDidInstallExtensions(v){for(const E of v)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(v){v.error||this.removeInstalledExtension(v.identifier)}addInstallingExtension(v){this.removeInstallingExtension(v),this.installingExtensions.push(v)}removeInstallingExtension(v){this.installingExtensions=this.installingExtensions.filter(E=>!(0,P.areSameExtensions)(E,v))}addInstalledExtension(v){this.installedExtensions&&(this.removeInstalledExtension(v),this.installedExtensions.push(v))}removeInstalledExtension(v){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,P.areSameExtensions)(E,v)))}async onDidChange(){if(this.installedExtensions){const v=await this.extensionsManagementService.getInstalled(1),E=v.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(f=>(0,P.areSameExtensions)(f,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),h=this.installedExtensions.filter(S=>this.installingExtensions.some(f=>(0,P.areSameExtensions)(f,S))?!1:v.every(f=>!(0,P.areSameExtensions)(f.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=v.map(S=>S.identifier),(E.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:h})}}};n=he([X(1,w.IFileService),X(2,A.INativeEnvironmentService),X(3,b.ILogService)],n),e.ExtensionsWatcher=n}),define(te[188],ne([0,1,82,17,5,2,15,9,19,13,29,35,59,10]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends k.Disposable{constructor(p,m,y){super();this.extensionManagementService=p,this.logService=y,this.cache=this._register(new S(m,y)),this.extensionManagementService.registerParticipant({postInstall:async c=>this.postInstallExtension(c),postUninstall:async c=>this.postUninstallExtension(c)})}async getLanguageIds(){const p=await this.cache.getLanguagePacks(),m=["en",...Object.keys(p)];return(0,L.distinct)(m)}async postInstallExtension(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",p.identifier.id),await this.update())}async postUninstallExtension(p){const m=await this.cache.getLanguagePacks();Object.keys(m).some(y=>m[y]&&m[y].extensions.some(c=>(0,I.areSameExtensions)(c.extensionIdentifier,p.identifier)))&&(this.logService.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,m]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),y=await this.cache.update(m);return!(0,L.equals)(Object.keys(p),Object.keys(y))}};h=he([X(0,n.IExtensionManagementService),X(1,b.INativeEnvironmentService),X(2,E.ILogService)],h),e.LocalizationsService=h;let S=class extends k.Disposable{constructor(p,m){super();this.logService=m,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(p.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(p){return this.withLanguagePacks(m=>{Object.keys(m).forEach(y=>delete m[y]),this.createLanguagePacksFromExtensions(m,...p)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(p,...m){for(const y of m)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(p,y);Object.keys(p).forEach(y=>this.updateHash(p[y]))}createLanguagePacksFromExtension(p,m){const y=m.identifier,c=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const a of c)if(m.location.scheme===A.Schemas.file&&(0,v.isValidLocalization)(a)){let t=p[a.languageId];t||(t={hash:"",extensions:[],translations:{}},p[a.languageId]=t);let s=t.extensions.filter(r=>(0,I.areSameExtensions)(r.extensionIdentifier,y))[0];s?s.version=m.manifest.version:t.extensions.push({extensionIdentifier:y,version:m.manifest.version});for(const r of a.translations)t.translations[r.id]=(0,P.join)(m.location.fsPath,r.path)}}updateHash(p){if(p){const m=(0,R.createHash)("md5");for(const y of p.extensions)m.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);p.hash=m.digest("hex")}}withLanguagePacks(p=()=>null){return this.languagePacksFileLimiter.queue(()=>{let m=null;return w.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch(c){return{}}}).then(y=>(m=p(y),y)).then(y=>{for(const a of Object.keys(y))y[a]||delete y[a];this.languagePacks=y,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),w.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>m,y=>this.logService.error(y))})}};S=he([X(0,b.INativeEnvironmentService),X(1,E.ILogService)],S)}),define(te[189],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[62],ne([0,1,3,4,6,10]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService");var A;(function(h){h.Http="http",h.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const S=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!S)return{address:S[1],port:+S[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=n,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=I;function v(h,S){return S?S!==1&&h<1024:!L.isWindows&&h<1024}e.isPortPrivileged=v;let E=class{constructor(S){this.logService=S,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(S,f){return this._tunnelProvider=S,S?(this._canElevate=f.elevation,this._privacyOptions=f.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const S=[],f=Array.from(this._tunnels.values());for(let p of f){const m=Array.from(p.values());for(let y of m){const c=await y.value;c&&S.push(c)}}return S}async dispose(){for(const S of this._tunnels.values()){for(const{value:f}of S.values())await f.then(p=>p?.dispose());S.clear()}this._tunnels.clear()}openTunnel(S,f,p,m,y=!1,c=P.Private,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${p} on local port ${m}.`),!S)return;f||(f="localhost");const t=this.retainOrCreateTunnel(S,f,p,m,y,c,a);return t?t.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(s);return(s.tunnelRemoteHost!==f||s.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(S){return{tunnelRemotePort:S.tunnelRemotePort,tunnelRemoteHost:S.tunnelRemoteHost,tunnelLocalPort:S.tunnelLocalPort,localAddress:S.localAddress,privacy:S.privacy,protocol:S.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${S.tunnelRemoteHost}:${S.tunnelRemotePort} `);const f=this._tunnels.get(S.tunnelRemoteHost);if(f){const p=f.get(S.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(S.tunnelRemoteHost,S.tunnelRemotePort,p))}}}}async tryDisposeTunnel(S,f,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${S}:${f}.`);const m=p.value.then(async y=>{y&&(await y.dispose(!0),this._onTunnelClosed.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this._tunnels.has(S)&&this._tunnels.get(S).delete(f),m}}async closeTunnel(S,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${S}:${f} `);const p=this._tunnels.get(S);if(p&&p.has(f)){const m=p.get(f);m.refcount=0,await this.tryDisposeTunnel(S,f,m)}}addTunnelToMap(S,f,p){this._tunnels.has(S)||this._tunnels.set(S,new Map),this._tunnels.get(S).set(f,{refcount:1,value:p})}async removeEmptyTunnelFromMap(S,f){const p=this._tunnels.get(S);p&&(await p.get(f)||p.delete(f),p.size===0&&this._tunnels.delete(S))}getTunnelFromMap(S,f){let p=[S];n(S)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):I(S)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const m=p.map(y=>this._tunnels.get(y));for(const y of m){const c=y?.get(f);if(c)return c}}canTunnel(S){return!!b(S)}createWithProvider(S,f,p,m,y,c,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${p} on local port ${m}.`);const s={elevationRequired:y?v(m===void 0?p:m):!1},r={remoteAddress:{host:f,port:p},localAddressPort:m,privacy:c,public:c!==P.Private,protocol:a},i=S.forwardPort(r,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(f,p,i),i}};E=he([X(0,k.ILogService)],E),e.AbstractTunnelService=E}),define(te[190],ne([0,1,10,62,2,8,5]),function(J,e,R,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends D.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(n){this._address=n,this._addressPromise&&(this._addressPromise.complete(n),this._addressPromise=null)}setTunnel(n){this._register(n)}}let w=class pt extends D.Disposable{constructor(n,I){super();this._tunnelService=n,this._logService=I,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(n=>n.dispose())}async createTunnel(){return{id:String(++pt._lastId)}}async startTunnel(n,I,v,E,h){const S=new P,f=await Promise.resolve(this._tunnelService.openTunnel(S,I,v,E,h));if(!f)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${I}:${v} (remote).`),S.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(n))throw this._disposedTunnels.delete(n),S.dispose(),await f.dispose(),(0,k.canceled)();return S.setTunnel(f),this._tunnels.set(n,S),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${n}: ${f.localAddress} (local) to ${I}:${v} (remote).`),{tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress}}async setAddress(n,I){const v=this._tunnels.get(n);!v||v.setAddress(I)}async destroyTunnel(n){const I=this._tunnels.get(n);if(I){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${n}.`),this._tunnels.delete(n),await I.dispose();return}this._disposedTunnels.add(n)}};w._lastId=0,w=he([X(0,L.ITunnelService),X(1,R.ILogService)],w),e.SharedProcessTunnelService=w}),define(te[191],ne([0,1,119,20,10]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(P,w){this.configurationService=P,this.logService=w}request(P,w){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,R.request)(P,w)}async resolveProxy(P){}};k=he([X(0,L.IConfigurationService),X(1,D.ILogService)],k),e.RequestService=k}),define(te[43],ne([0,1,22,140,38,6,34]),function(J,e,R,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function P(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=P;function w(h){return h.res.statusCode===204}async function b(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);return w(h)?null:(await(0,R.streamToBuffer)(h.stream)).toString()}e.asText=b;async function n(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);if(w(h))return null;const f=(await(0,R.streamToBuffer)(h.stream)).toString();try{return JSON.parse(f)}catch(p){throw p.message+=`:
`+f,p}}e.asJson=n;function I(h){E(h)}e.updateProxyConfigurationsScope=I;let v;function E(h){const S=A.Registry.as(D.Extensions.Configuration),f=v;v={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[v],remove:f?[f]:[]})}E(2)}),define(te[192],ne([0,1,27,15,14,43]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(w,b){this.requestService=w,this.fileService=b}async download(w,b,n=R.CancellationToken.None){if(w.scheme===L.Schemas.file||w.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(w,b);return}const I={type:"GET",url:w.toString()},v=await this.requestService.request(I,n);if(v.res.statusCode===200)await this.fileService.writeFile(b,v.stream);else{const E=await(0,k.asText)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${E}`)}}};A=he([X(0,k.IRequestService),X(1,D.IFileService)],A),e.DownloadService=A}),define(te[193],ne([0,1,17,27,66,2,16,152,14,10,30,43]),function(J,e,R,L,D,k,A,P,w,b,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let v=class extends k.Disposable{constructor(h,S,f,p){super();this.fileService=h,this.productService=S,this.requestService=f,this.logService=p,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,D.forEach)(this.productService.configBasedExtensionTips,({value:m})=>this.allConfigBasedTips.set(m.configPath,m))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const S=[];for(const[f,p]of this.allConfigBasedTips)if(!(p.configScheme&&p.configScheme!==h.scheme))try{const m=await this.fileService.readFile((0,A.joinPath)(h,f)),y=new Map;(0,D.forEach)(p.recommendations,({key:a,value:t})=>{if((0,R.isNonEmptyArray)(t.remotes))for(const s of t.remotes)y.set(s,{extensionId:a,extensionName:t.name,configName:p.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else S.push({extensionId:a,extensionName:t.name,configName:p.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const c=(0,P.getDomainsOfRemotes)(m.value.toString(),[...y.keys()]);for(const a of c){const t=y.get(a);t&&S.push(t)}}catch(m){}return S}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(h.res.statusCode!==200)return[];const S=await(0,I.asJson)(h);return S?S.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};v=he([X(0,w.IFileService),X(1,n.IProductService),X(2,I.IRequestService),X(3,b.ILogService)],v),e.ExtensionTipsService=v}),define(te[47],ne([0,1,22,28]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(k,A,P){let w=P&&P.get("storage.serviceMachineId",0)||null;if(w)return w;try{const n=(await A.readFile(k.serviceMachineIdResource)).value.toString();w=(0,L.isUUID)(n)?n:null}catch(b){w=null}if(!w){w=(0,L.generateUuid)();try{await A.writeFile(k.serviceMachineIdResource,R.VSBuffer.fromString(w))}catch(b){}}return P&&P.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=D}),define(te[89],ne([0,1,103,6]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(k){return(0,R.hash)({moduleId:k.process.moduleId,windowId:k.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,L.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[194],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var R;(function(L){L.Spawn="vscode:shared-process->shared-process-worker=spawn",L.Terminate="vscode:shared-process->shared-process-worker=terminate",L.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",L.Ready="vscode:shared-process-worker->shared-process=ready",L.Ack="vscode:shared-process-worker->shared-process=ack",L.Trace="vscode:shared-process-worker->shared-process=trace",L.Info="vscode:shared-process-worker->shared-process=info",L.Warn="vscode:shared-process-worker->shared-process=warn",L.Error="vscode:shared-process-worker->shared-process=error"})(R=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[195],ne([0,1,72,27,3,2,15,28,10,89,194]),function(J,e,R,L,D,k,A,P,w,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let I=class{constructor(h){this.logService=h,this.workers=new Map,this.processes=new Map}async createWorker(h){const S=`window: ${h.reply.windowId}, moduleId: ${h.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${S})`);const f=(0,b.hash)(h);this.processes.has(f)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${S})`),this.disposeWorker(h));const p=new L.CancellationTokenSource;let m,y,c;if(this.processes.set(f,(0,k.toDisposable)(()=>{p.dispose(!0),m?.terminate(h,L.CancellationToken.None),y?.close(),c?.close(),this.processes.delete(f)})),m=await this.getOrCreateWebWorker(h),p.token.isCancellationRequested)return;const{port1:a,port2:t}=new MessageChannel;y=a,c=t,await m.spawn(h,c,p.token),!p.token.isCancellationRequested&&(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${S})`),R.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",h,[y]))}getOrCreateWebWorker(h){let S=this.workers.get(h.process.moduleId);if(!S){this.logService.trace(`SharedProcess: creating new web worker (${h.process.moduleId})`);const f=new v(h.process.type,this.logService);S=f.init(),f.onDidProcessSelfTerminate(p=>{this.disposeWorker(p)}),this.workers.set(h.process.moduleId,S)}return S}async disposeWorker(h){const S=this.processes.get((0,b.hash)(h));S&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${h.reply.windowId}, moduleId: ${h.process.moduleId})`),S.dispose())}};I=he([X(0,w.ILogService)],I),e.SharedProcessWorkerService=I;class v extends k.Disposable{constructor(h,S){super();this.type=h,this.logService=S,this._onDidProcessSelfTerminate=this._register(new D.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){let h;const S=new Promise(p=>h=p),f=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return f.onerror=p=>{this.logService.error(`SharedProcess: worker error (${this.type})`,p.message)},f.onmessageerror=p=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,p)},f.onmessage=p=>{const{id:m,message:y,configuration:c,nonce:a}=p.data;switch(m){case n.SharedProcessWorkerMessages.Ready:h(f);break;case n.SharedProcessWorkerMessages.Ack:if(a){const t=this.mapMessageNonceToPendingMessageResolve.get(a);t&&(this.mapMessageNonceToPendingMessageResolve.delete(a),t())}break;case n.SharedProcessWorkerMessages.SelfTerminated:c&&this._onDidProcessSelfTerminate.fire(c);break;case n.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,y);break;case n.SharedProcessWorkerMessages.Info:y&&this.logService.info(y);break;case n.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,y);break;case n.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,y);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,p)}},f.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S}async send(h,S,f){const p=await this.workerReady;if(!S.isCancellationRequested)return new Promise(m=>{const y=(0,P.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(y,m);const c={...h,nonce:y};f?p.postMessage(c,[f]):p.postMessage(c),S.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(y)&&m()})})}spawn(h,S,f){const p={id:n.SharedProcessWorkerMessages.Spawn,configuration:h,environment:{bootstrapPath:A.FileAccess.asFileUri("bootstrap-fork",J).fsPath}};return this.send(p,f,S)}terminate(h,S){const f={id:n.SharedProcessWorkerMessages.Terminate,configuration:h};return this.send(f,S)}}}),define(te[90],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[196],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{constructor(){this.validators=new Map}vsda(){return new Promise((D,k)=>J(["vsda"],D,k))}async createNewMessage(D){try{const k=await this.vsda(),A=new k.validator;if(A){const P=String(R._nextId++);return this.validators.set(P,A),{id:P,data:A.createNewMessage(D)}}}catch(k){}return{id:"",data:D}}async validate(D,k){if(!D.id)return!0;const A=this.validators.get(D.id);if(!A)return!1;this.validators.delete(D.id);try{return A.validate(k)==="ok"}catch(P){return!1}}async sign(D){try{const k=await this.vsda(),A=new k.signer;if(A)return A.sign(D)}catch(k){}return D}}e.SignService=R,R._nextId=1}),define(te[23],ne([0,1,5,3,2,18,73,6]),function(J,e,R,L,D,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const w="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var b;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(S){S[S.GLOBAL=0]="GLOBAL",S[S.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var I;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class v extends D.Disposable{constructor(f={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,p){p===w?(f===0?this._globalKeyTargets=void 0:f===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:f})):this._onDidChangeValue.fire({scope:f,key:p,target:this.getKeyTargets(f)[p]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,p,m){return this.getStorage(p)?.get(f,m)}getBoolean(f,p,m){return this.getStorage(p)?.getBoolean(f,m)}getNumber(f,p,m){return this.getStorage(p)?.getNumber(f,m)}store(f,p,m,y){if((0,k.isUndefinedOrNull)(p)){this.remove(f,m);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,m,y),this.getStorage(m)?.set(f,p)})}remove(f,p){this.withPausedEmitters(()=>{this.updateKeyTarget(f,p,void 0),this.getStorage(p)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,p){const m=[],y=this.getKeyTargets(f);for(const c of Object.keys(y))y[c]===p&&m.push(c);return m}updateKeyTarget(f,p,m){const y=this.getKeyTargets(p);typeof m=="number"?y[f]!==m&&(y[f]=m,this.getStorage(p)?.set(w,JSON.stringify(y))):typeof y[f]=="number"&&(delete y[f],this.getStorage(p)?.set(w,JSON.stringify(y)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(f){return f===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(f){const p=this.get(w,f);if(p)try{return JSON.parse(p)}catch(m){}return Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=b.NONE){this._onWillSaveState.fire({reason:f}),await R.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const f=this.getStorage(0)?.items??new Map,p=this.getStorage(1)?.items??new Map;return h(f,p,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;class E extends v{constructor(){super();this.globalStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.globalStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f)))}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(f){}}e.InMemoryStorageService=E;async function h(S,f,p,m){const y=o=>{try{return JSON.parse(o)}catch(l){return o}},c=new Map,a=new Map;S.forEach((o,l)=>{c.set(l,o),a.set(l,y(o))});const t=new Map,s=new Map;f.forEach((o,l)=>{t.set(l,o),s.set(l,y(o))}),console.group(`Storage: Global (path: ${p})`);let r=[];c.forEach((o,l)=>{r.push({key:l,value:o})}),console.table(r),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${m})`);let i=[];t.forEach((o,l)=>{i.push({key:l,value:o})}),console.table(i),console.groupEnd(),console.log(s)}e.logStorage=h}),define(te[197],ne([0,1,3,2,18,29,35,23]),function(J,e,R,L,D,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let w=class extends L.Disposable{constructor(I){super();this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(I)),this._register(this.storageManger.onDidChange(v=>this._onDidChangeEnablement.fire({extensions:v,source:"storage"})))}async enableExtension(I,v){return this._removeFromDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:v}),!0):!1}async disableExtension(I,v){return this._addToDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:v}),!0):!1}getDisabledExtensions(){return this._getExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(I){let v=this.getDisabledExtensions();return v.every(E=>!(0,A.areSameExtensions)(E,I))?(v.push(I),this._setDisabledExtensions(v),!0):!1}_removeFromDisabledExtensions(I){let v=this.getDisabledExtensions();for(let E=0;E<v.length;E++){const h=v[E];if((0,A.areSameExtensions)(h,I))return v.splice(E,1),this._setDisabledExtensions(v),!0}return!1}_setDisabledExtensions(I){this._setExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH,I)}_getExtensions(I){return this.storageManger.get(I,0)}_setExtensions(I,v){this.storageManger.set(I,v,0)}};w=he([X(0,P.IStorageService)],w),e.GlobalExtensionEnablementService=w;class b extends L.Disposable{constructor(I){super();this.storageService=I,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(I.onDidChangeValue(v=>this.onDidStorageChange(v)))}get(I,v){let E;return v===0?((0,D.isUndefinedOrNull)(this.storage[I])&&(this.storage[I]=this._get(I,v)),E=this.storage[I]):E=this._get(I,v),JSON.parse(E)}set(I,v,E){let h=JSON.stringify(v.map(({id:f,uuid:p})=>({id:f,uuid:p})));this._get(I,E)!==h&&(E===0&&(v.length?this.storage[I]=h:delete this.storage[I]),this._set(I,v.length?h:void 0,E))}onDidStorageChange(I){if(I.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[I.key])&&this._get(I.key,I.scope)!==this.storage[I.key]){const E=this.get(I.key,I.scope);delete this.storage[I.key];const h=this.get(I.key,I.scope),S=E.filter(p=>!h.some(m=>(0,A.areSameExtensions)(p,m))),f=h.filter(p=>!E.some(m=>(0,A.areSameExtensions)(m,p)));(S.length||f.length)&&this._onDidChange.fire([...S,...f])}}_get(I,v){return this.storageService.get(I,v,"[]")}_set(I,v,E){v?this.storageService.store(I,v,E,1):this.storageService.remove(I,E)}}e.StorageManager=b}),define(te[198],ne([0,1,3,2]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class D extends L.Disposable{constructor(b,n){super();this.channel=b,this.workspace=n}async getItems(){const b={workspace:this.workspace},n=await this.channel.call("getItems",b);return new Map(n)}updateItems(b){const n={workspace:this.workspace};return b.insert&&(n.insert=Array.from(b.insert.entries())),b.delete&&(n.delete=Array.from(b.delete.values())),this.channel.call("updateItems",n)}}class k extends D{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class A extends D{constructor(b,n){super(b,n);this.onDidChangeItemsExternal=R.Event.None}async close(){const b={workspace:this.workspace};return this.channel.call("close",b)}}class P extends L.Disposable{constructor(b,n){super();this.channel=b,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new k(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(te[199],ne([0,1,5,2,177,16,73,23,198]),function(J,e,R,L,D,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends P.AbstractStorageService{constructor(I,v,E){super();this.mainProcessService=v,this.environmentService=E,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new w.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),v=new A.Storage(I.globalStorage);return this._register(v.onDidChangeStorage(E=>this.emitDidChangeValue(0,E))),v}createWorkspaceStorage(I){const v=new w.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(v.workspaceStorage){const E=new A.Storage(v.workspaceStorage);return this.workspaceStorageDisposable.value=E.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)),this.workspaceStorageId=I?.id,E}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,D.mark)("code/willInitStorage");try{await R.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,D.mark)("code/didInitStorage")}}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(P.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const v=this.workspaceStorage,E=v?.items??new Map;v&&(await v.close(),v.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[h,S]of E)this.workspaceStorage.set(h,S)}}e.NativeStorageService=b}),define(te[200],ne([0,1,4,31,7,28]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(b){if(R.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function P(b,n,I,v,E,h,S,f,p,m){const y=Object.create(null);y["common.machineId"]=S,y.sessionID=(0,k.generateUuid)()+Date.now(),y.commitHash=E,y.version=h,y["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,R.PlatformToString)(R.platform),y["common.nodePlatform"]=L.platform,y["common.nodeArch"]=v,y["common.product"]=m||"desktop";const c=w(f||[]);c&&(y["common.msftInternal"]=c);let a=0;const t=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),R.isLinuxSnap&&(y["common.snap"]="true");const s=A(I);s&&(y["common.platformDetail"]=s);try{const r=await b.readFile(D.URI.file(p));y["common.source"]=r.value.toString().slice(0,30)}catch(r){}return y}e.resolveCommonProperties=P;function w(b){const n=L.env.USERDNSDOMAIN;if(!n)return!1;const I=n.toLowerCase();return b.some(v=>I===v)}e.verifyMicrosoftInternalDomain=w}),define(te[21],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[201],ne([0,1,33,56,5,36,15,9,4,7,112,19,115,78,14,30,21]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function p(t,s){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,o=new Map,l=2e4;function u(T,_,O,F){const C=_.substring(T.length+1);return D.Promises.withAsyncBody(async N=>{let z;try{z=await I.Promises.readdir(_,{withFileTypes:!0})}catch(W){N();return}if(F.count>=l){F.count+=z.length,F.maxReached=!0,N();return}let M=z.length;if(M===0){N();return}let q=z;F.count+z.length>l&&(F.maxReached=!0,M=l-F.count,q=z.slice(0,M)),F.count+=z.length;for(const W of q)if(W.isDirectory()){if(O.includes(W.name)||await u(T,(0,P.join)(_,W.name),O,F),--M==0){N();return}}else{const j=W.name.lastIndexOf(".");if(j>=0){const x=W.name.substring(j+1);x&&i.set(x,(i.get(x)??0)+1)}for(const x of r)x.relativePathPattern?.test(C)!==!1&&x.filePattern.test(W.name)&&o.set(x.tag,(o.get(x.tag)??0)+1);if(--M==0){N();return}}})}const d={count:0,maxReached:!1};await u(t,t,s,d);const g=await c(t);return{configFiles:m(o),fileTypes:m(i),fileCount:d.count,maxFilesReached:d.maxReached,launchConfigFiles:g}}e.collectWorkspaceStats=p;function m(t){return[...L.Iterable.map(t.entries(),([s,r])=>({name:s,count:r}))].sort((s,r)=>r.count-s.count)}function y(){const t={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(n.virtualMachineHint.value()*100)}%`},s=R.cpus();return s&&s.length>0&&(t.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),t}e.getMachineInfo=y;async function c(t){try{const s=new Map,r=(0,P.join)(t,".vscode","launch.json"),i=await I.Promises.readFile(r),o=[],l=(0,k.parse)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${r}`),[];if((0,k.getNodeType)(l)==="object"&&l.configurations)for(const u of l.configurations){const d=u.type;d&&(s.has(d)?s.set(d,s.get(d)+1):s.set(d,1))}return m(s)}catch(s){return[]}}e.collectLaunchConfigs=c;let a=class{constructor(s,r){this.telemetryService=s,this.productService=r}formatMachineInfo(s){const r=[];return r.push(`OS Version:       ${s.os}`),r.push(`CPUs:             ${s.cpus}`),r.push(`Memory (System):  ${s.memory}`),r.push(`VM:               ${s.vmHint}`),r.join(`
`)}formatEnvironment(s){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const i=R.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||r.push(`Load (avg):       ${R.loadavg().map(o=>Math.round(o)).join(", ")}`),r.push(`VM:               ${Math.round(n.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${s.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(s.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(s,r){return Promise.all([(0,v.listProcesses)(s.mainPID),this.formatWorkspaceMetadata(s)]).then(async i=>{let[o,l]=i,u=this.formatProcessList(s,o);return r.forEach(d=>{if((0,E.isRemoteDiagnosticError)(d))u+=`
${d.errorMessage}`,l+=`
${d.errorMessage}`;else if(u+=`

Remote: ${d.hostName}`,d.processes&&(u+=`
${this.formatProcessList(s,d.processes)}`),d.workspaceMetadata){l+=`
|  Remote: ${d.hostName}`;for(const g of Object.keys(d.workspaceMetadata)){const T=d.workspaceMetadata[g];let _=`${T.fileCount} files`;T.maxFilesReached&&(_=`more than ${_}`),l+=`|    Folder (${g}): ${_}`,l+=this.formatWorkspaceStats(T)}}}),{processInfo:u,workspaceInfo:l}})}async getSystemInfo(s,r){const{memory:i,vmHint:o,os:l,cpus:u}=y(),d={os:l,memory:i,cpus:u,vmHint:o,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:r};return w.isWindows||(d.load=`${R.loadavg().map(g=>Math.round(g)).join(", ")}`),w.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(s,r){const i=[];return(0,v.listProcesses)(s.mainPID).then(async o=>(i.push(""),i.push(this.formatEnvironment(s)),i.push(""),i.push(this.formatProcessList(s,o)),s.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(s))),r.forEach(l=>{if((0,E.isRemoteDiagnosticError)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.formatMachineInfo(l.machineInfo)),l.processes&&i.push(this.formatProcessList(s,l.processes)),l.workspaceMetadata)for(const u of Object.keys(l.workspaceMetadata)){const d=l.workspaceMetadata[u];let g=`${d.fileCount} files`;d.maxFilesReached&&(g=`more than ${g}`),i.push(`Folder (${u}): ${g}`),i.push(this.formatWorkspaceStats(d))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(s){const r=[],i=60;let o=0;const l=(T,_)=>{const O=` ${T}(${_})`;o+O.length>i?(r.push(u),u="|                 ",o=u.length):o+=O.length,u+=O};let u="|      File types:";const d=10;let g=s.fileTypes.length>d?d:s.fileTypes.length;for(let T=0;T<g;T++){const _=s.fileTypes[T];l(_.name,_.count)}if(r.push(u),s.configFiles.length>=0&&(u="|      Conf files:",o=0,s.configFiles.forEach(T=>{l(T.name,T.count)}),r.push(u)),s.launchConfigFiles.length>0){let T="|      Launch Configs:";s.launchConfigFiles.forEach(_=>{T+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),r.push(T)}return r.join(`
`)}expandGPUFeatures(s){const r=Math.max(...Object.keys(s).map(i=>i.length));return Object.keys(s).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${s[i]}`).join(`
                  `)}formatWorkspaceMetadata(s){const r=[],i=[];return s.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(r.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const u=b.URI.revive(l);if(u.scheme===A.Schemas.file){const d=u.fsPath;i.push(p(d,["node_modules",".git"]).then(g=>{let T=`${g.fileCount} files`;g.maxFilesReached&&(T=`more than ${T}`),r.push(`|    Folder (${(0,P.basename)(d)}): ${T}`),r.push(this.formatWorkspaceStats(g))}).catch(g=>{r.push(`|      Error: Unable to collect workspace stats for folder ${d} (${g.toString()})`)}))}else r.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>r.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(s,r){const i=new Map;s.windows.forEach(l=>i.set(l.pid,l.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(s.mainPID,i,o,r,0),o.join(`
`)}formatProcessItem(s,r,i,o,l){const u=l===0;let d;u?d=o.pid===s?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(l)} ${o.name}`,o.name==="window"&&(d=`${d} (${r.get(o.pid)})`));const g=process.platform==="win32"?o.mem:R.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(g/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(o.children)&&o.children.forEach(T=>this.formatProcessItem(s,r,i,T,l+1))}async reportWorkspaceStats(s){for(const{uri:r}of s.folders){const i=b.URI.revive(r);if(i.scheme!==A.Schemas.file)continue;const o=i.fsPath;try{const l=await p(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),l.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),l.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),l.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};a=he([X(0,f.ITelemetryService),X(1,S.IProductService)],a),e.DiagnosticsService=a}),define(te[202],ne([0,1,17,5,27,8,3,2,4,7,129,29,35,10,42,21]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let f=class extends P.Disposable{constructor(a,t,s){super();this.galleryService=a,this.telemetryService=t,this.logService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const t=await this.getTargetPlatform();return a.allTargetPlatforms.some(s=>(0,I.isTargetPlatformCompatible)(s,a.allTargetPlatforms,t))}async installFromGallery(a,t={}){if(!this.galleryService.isEnabled())throw new Error(n.localize(0,null));if(!await this.canInstall(a)){const r=await this.getTargetPlatform(),i=new I.ExtensionManagementError(n.localize(1,null,a.identifier.id,h.default.nameLong,(0,I.TargetPlatformToString)(r)),e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",a.identifier.id,i.message),m(this.telemetryService,"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(a),void 0,i),i}try{a=await this.checkAndGetCompatibleVersion(a,!t.installGivenVersion)}catch(r){throw this.logService.error((0,k.getErrorMessage)(r)),m(this.telemetryService,"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(a),void 0,r),r}const s=await this.galleryService.getManifest(a,D.CancellationToken.None);if(s===null){const r=new I.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",a.identifier.id,r.message),m(this.telemetryService,"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(a),void 0,r),r}if(s.version!==a.version){const r=new I.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error(r.message),m(this.telemetryService,"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(a),void 0,r),r}return this.installExtension(s,a,t)}async uninstall(a,t={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,t)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(n.localize(2,null));const t=await this.findGalleryExtension(a);if(!t)throw new Error(n.localize(3,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const a=new Date().getTime();return(!this.reportedExtensions||a-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=a),this.reportedExtensions}registerParticipant(a){this.participants.push(a)}async installExtension(a,t,s){if(!b.URI.isUri(t)){let u=this.installingExtensions.get(new v.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(u)return this.logService.info("Extensions is already requested to install",t.identifier.id),u.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],i=[],o=this.createInstallExtensionTask(a,t,s);b.URI.isUri(t)||this.installingExtensions.set(new v.ExtensionIdentifierWithVersion(o.identifier,a.version).key(),o),this._onInstallExtension.fire({identifier:o.identifier,source:t}),this.logService.info("Installing extension:",o.identifier.id),r.push({task:o,manifest:a});let l=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",o.identifier.id);else try{const d=await this.getAllDepsAndPackExtensionsToInstall(o.identifier,a,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:g,manifest:T}of d)if(l=l||!!T.extensionDependencies?.some(_=>(0,v.areSameExtensions)({id:_},o.identifier)),this.installingExtensions.has(new v.ExtensionIdentifierWithVersion(g.identifier,g.version).key()))this.logService.info("Extension is already requested to install",g.identifier.id);else{const _=this.createInstallExtensionTask(T,g,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new v.ExtensionIdentifierWithVersion(_.identifier,T.version).key(),_),this._onInstallExtension.fire({identifier:_.identifier,source:g}),this.logService.info("Installing extension:",_.identifier.id),r.push({task:_,manifest:T})}}catch(d){if(b.URI.isUri(o.source))(0,R.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",o.identifier.id,d.message),(0,R.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",o.identifier.id,d.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",o.identifier.id),this.logService.error(d),d}const u=r.reduce((d,{task:g,manifest:T})=>(d.set(g.identifier.id.toLowerCase(),{task:g,manifest:T}),d),new Map);for(;u.size;){let d;const g=[...u.values()].filter(({manifest:T})=>!T.extensionDependencies?.some(_=>u.has(_.toLowerCase())));g.length?d=u.size===1?g:g.filter(({task:T})=>!(T===o&&!l)):(this.logService.info("Found extensions with circular dependencies",g.map(({task:T})=>T.identifier.id)),d=[...u.values()]),await this.joinAllSettled(d.map(async({task:T})=>{const _=new Date().getTime();try{const O=await T.run();if(await this.joinAllSettled(this.participants.map(F=>F.postInstall(O,T.source,s,D.CancellationToken.None))),!b.URI.isUri(T.source)&&(m(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-_,void 0),w.isWeb&&T.operation===1))try{await this.galleryService.reportStatistic(O.manifest.publisher,O.manifest.name,O.manifest.version,"install")}catch(F){}i.push({local:O,identifier:T.identifier,operation:T.operation,source:T.source})}catch(O){throw b.URI.isUri(T.source)||m(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-_,O),this.logService.error("Error while installing the extension:",T.identifier.id),this.logService.error(O),O}finally{u.delete(T.identifier.id.toLowerCase())}}))}return i.forEach(({identifier:d})=>this.logService.info("Extension installed successfully:",d.id)),this._onDidInstallExtensions.fire(i),i.filter(({identifier:d})=>(0,v.areSameExtensions)(d,o.identifier))[0].local}catch(u){if(r.forEach(({task:d})=>d.cancel()),i.length)try{const d=await Promise.allSettled(i.map(({local:g})=>this.createUninstallExtensionTask(g,{versionOnly:!0}).run()));for(let g=0;g<d.length;g++){const T=d[g],{identifier:_}=i[g];T.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",_.id):this.logService.warn("Rollback: Error while uninstalling extension",_.id,(0,k.getErrorMessage)(T.reason))}}catch(d){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(d),i.map(({identifier:g})=>g.id))}throw this.logService.error("Failed to install extension:",o.identifier.id,(0,k.getErrorMessage)(u)),this._onDidInstallExtensions.fire(r.map(({task:d})=>({identifier:d.identifier,operation:1,source:d.source}))),u instanceof Error&&(u.name=u&&u.code?u.code:e.ERROR_UNKNOWN),u}finally{for(const{task:u,manifest:d}of r)if(!b.URI.isUri(u.source)){const g=new v.ExtensionIdentifierWithVersion(u.identifier,d.version).key();this.installingExtensions.delete(g)||this.logService.warn("Installation task is not found in the cache",g)}}}async joinAllSettled(a){const t=[],s=[],r=await Promise.allSettled(a);for(const i of r)i.status==="fulfilled"?t.push(i.value):s.push(i.reason);if(s.length)throw p(s);return t}async getAllDepsAndPackExtensionsToInstall(a,t,s){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const i=[a,...r.map(u=>u.identifier)],o=[],l=async(u,d)=>{const g=d.extensionDependencies||[],T=[...g];if(d.extensionPack){const _=s?r.find(O=>(0,v.areSameExtensions)(O.identifier,u)):void 0;for(const O of d.extensionPack)_&&_.manifest.extensionPack&&_.manifest.extensionPack.some(F=>(0,v.areSameExtensions)({id:F},{id:O}))||T.every(F=>!(0,v.areSameExtensions)({id:F},{id:O}))&&T.push(O)}if(T.length){const _=[...i,...o.map(F=>F.gallery.identifier)],O=T.filter(F=>_.every(C=>!(0,v.areSameExtensions)(C,{id:F})));if(O.length){const F=await this.galleryService.query({names:O,pageSize:T.length},D.CancellationToken.None);for(const C of F.firstPage){if(_.find(q=>(0,v.areSameExtensions)(q,C.identifier)))continue;if(!g.some(q=>(0,v.areSameExtensions)({id:q},C.identifier))&&!await this.canInstall(C)){this.logService.info("Skipping the packed extension as it cannot be installed",C.identifier.id);continue}const z=await this.checkAndGetCompatibleVersion(C,!0),M=await this.galleryService.getManifest(z,D.CancellationToken.None);if(M===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${z.identifier.id}`,e.INSTALL_ERROR_VALIDATING);o.push({gallery:z,manifest:M}),await l(z.identifier,M)}}}};return await l(a,t),r=await this.getInstalled(),o.filter(u=>!r.some(d=>(0,v.areSameExtensions)(d.identifier,u.gallery.identifier)))}async checkAndGetCompatibleVersion(a,t){if(await this.isMalicious(a))throw new I.ExtensionManagementError(n.localize(4,null,a.identifier.id),I.INSTALL_ERROR_MALICIOUS);const s=await this.getCompatibleVersion(a,t);if(!s)throw new I.ExtensionManagementError(n.localize(5,null,a.identifier.id,h.default.version),I.INSTALL_ERROR_INCOMPATIBLE);return s}async getCompatibleVersion(a,t){const s=await this.getTargetPlatform();let r=null;return await this.galleryService.isExtensionCompatible(a,s)&&(r=a),!r&&t&&(r=await this.galleryService.getCompatibleExtension(a,s)),r}async isMalicious(a){const t=await this.getExtensionsReport();return(0,v.getMaliciousExtensionsSet)(t).has(a.identifier.id)}async unininstallExtension(a,t){const s=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),s.waitUntilTaskIsFinished();const r=(u,d)=>{const g=this.createUninstallExtensionTask(u,d);return this.uninstallingExtensions.set(g.extension.identifier.id.toLowerCase(),g),this.logService.info("Uninstalling extension:",u.identifier.id),this._onUninstallExtension.fire(u.identifier),g},i=(u,d)=>{d?this.logService.error("Failed to uninstall extension:",u.identifier.id,d.message):this.logService.info("Successfully uninstalled extension:",u.identifier.id),m(this.telemetryService,"extensionGallery:uninstall",(0,v.getLocalExtensionTelemetryData)(u),void 0,d),this._onDidUninstallExtension.fire({identifier:u.identifier,error:d?.code})},o=[],l=[];try{o.push(r(a,{}));const u=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const d=this.getAllPackExtensionsToUninstall(a,u);for(const g of d)this.uninstallingExtensions.has(g.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",g.identifier.id):o.push(r(g,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(o.map(d=>d.extension),u,a),await this.joinAllSettled(o.map(async d=>{try{if(await d.run(),await this.joinAllSettled(this.participants.map(g=>g.postUninstall(d.extension,t,D.CancellationToken.None))),d.extension.identifier.uuid)try{await this.galleryService.reportStatistic(d.extension.manifest.publisher,d.extension.manifest.name,d.extension.manifest.version,"uninstall")}catch(g){}i(d.extension)}catch(g){const T=g instanceof I.ExtensionManagementError?g:new I.ExtensionManagementError((0,k.getErrorMessage)(g),e.ERROR_UNKNOWN);throw i(d.extension,T),T}finally{l.push(d)}}))}catch(u){const d=u instanceof I.ExtensionManagementError?u:new I.ExtensionManagementError((0,k.getErrorMessage)(u),e.ERROR_UNKNOWN);for(const g of o){try{g.cancel()}catch(T){}l.includes(g)||i(g.extension,d)}throw d}finally{for(const u of o)this.uninstallingExtensions.delete(u.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",u.extension.identifier.id)}}checkForDependents(a,t,s){for(const r of a){const i=this.getDependents(r,t);if(i.length){const o=i.filter(l=>!a.some(u=>(0,v.areSameExtensions)(u.identifier,l.identifier)));if(o.length)throw new Error(this.getDependentsErrorMessage(r,o,s))}}}getDependentsErrorMessage(a,t,s){return s===a?t.length===1?n.localize(6,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?n.localize(7,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):n.localize(8,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?n.localize(9,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?n.localize(10,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):n.localize(11,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(a,t,s=[]){if(s.indexOf(a)!==-1)return[];s.push(a);const r=a.manifest.extensionPack?a.manifest.extensionPack:[];if(r.length){const i=t.filter(l=>!l.isBuiltin&&r.some(u=>(0,v.areSameExtensions)({id:u},l.identifier))),o=[];for(const l of i)o.push(...this.getAllPackExtensionsToUninstall(l,t,s));return[...i,...o]}return[]}getDependents(a,t){return t.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(r=>(0,v.areSameExtensions)({id:r},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const t=await this.findGalleryExtensionById(a.identifier.uuid);return t||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},D.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},D.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${a.length} reported extensions from service`),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};f=he([X(0,I.IExtensionGalleryService),X(1,S.ITelemetryService),X(2,E.ILogService)],f),e.AbstractExtensionManagementService=f;function p(c){const a=Array.isArray(c)?c:[c];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((t,s)=>new Error(`${t.message}${t.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=p;function m(c,a,t,s,r){const i=r?r instanceof I.ExtensionManagementError?r.code:e.ERROR_UNKNOWN:void 0;c.publicLogError(a,{...t,success:!r,duration:s,errorcode:i})}e.reportTelemetry=m;class y{constructor(){this.barrier=new L.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(a=>new Promise((t,s)=>{const r=a.onCancellationRequested(()=>{r.dispose(),s((0,k.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=y}),define(te[203],ne([0,1,17,5,66,3,9,4,31,7,131,13,29,193,80,14,10,60,30,43,23,21]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f,p,m,y,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let r=class extends E.ExtensionTipsService{constructor(o,l,u,d,g,T,_,O,F,C){super(_,O,F,C);this.environmentService=o,this.telemetryService=l,this.extensionManagementService=u,this.storageService=d,this.nativeHostService=g,this.extensionRecommendationNotificationService=T,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,D.forEach)(O.exeBasedExtensionTips,({key:N,value:z})=>{const M=[],q=[],W=[];(0,D.forEach)(z.recommendations,({key:j,value:x})=>{x.important?z.important?M.push({extensionId:j,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):q.push({extensionId:j,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):W.push({extensionId:j,extensionName:x.name,isExtensionPack:!!x.isExtensionPack})}),M.length&&this.highImportanceExecutableTips.set(N,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:M}),q.length&&this.mediumImportanceExecutableTips.set(N,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:q}),W.length&&this.allOtherExecutableTips.set(N,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:W})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,u)}groupImportantTipsByExe(o,l){const u=new Map;o.forEach(O=>u.set(O.extensionId.toLowerCase(),O));const{installed:d,uninstalled:g}=this.groupByInstalled([...u.keys()],l);for(const O of d){const F=u.get(O);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:F.exeName})}for(const O of g){const F=u.get(O);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:F.exeName})}const T=this.getPromptedExecutableTips(),_=new Map;for(const O of g){const F=u.get(O);if(F&&(!T[F.exeName]||!T[F.exeName].includes(F.extensionId))){let C=_.get(F.exeName);C||(C=[],_.set(F.exeName,C)),C.push(F)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":const d=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const g=this._register((0,L.disposableTimeout)(()=>{g.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),l=Date.now()-o,u=7*24*60*60*1e3;if(l<u){const T=this._register((0,L.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},u-l));return}const[d,g]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(g).then(T=>{switch(T){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(g[0].exeName,g);const _=this._register((0,L.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const F=this._register((0,L.disposableTimeout)(()=>{F.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(o){const l=o.map(({extensionId:d})=>d.toLowerCase()),u=(0,n.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,u,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(s,0);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(s,o,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(o,l){const u=this.getPromptedExecutableTips();u[o]=l.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(u),0,0)}groupByInstalled(o,l){const u=[],d=[],g=l.reduce((T,_)=>(T.add(_.identifier.id.toLowerCase()),T),new Set);return o.forEach(T=>{g.has(T.toLowerCase())?u.push(T):d.push(T)}),{installed:u,uninstalled:d}}async getValidExecutableBasedExtensionTips(o){const l=[],u=new Map;for(const d of o.keys()){const g=o.get(d);if(!g||!(0,R.isNonEmptyArray)(g.recommendations))continue;const T=[];P.isWindows?g.windowsPath&&T.push(g.windowsPath.replace("%USERPROFILE%",w.env.USERPROFILE).replace("%ProgramFiles(x86)%",w.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",w.env.ProgramFiles).replace("%APPDATA%",w.env.APPDATA).replace("%WINDIR%",w.env.WINDIR)):(T.push((0,A.join)("/usr/local/bin",d)),T.push((0,A.join)("/usr/bin",d)),T.push((0,A.join)(this.environmentService.userHome.fsPath,d)));for(const _ of T){let O=u.get(_);if(O===void 0&&(O=await this.fileService.exists(b.URI.file(_)),u.set(_,O)),O)for(const{extensionId:F,extensionName:C,isExtensionPack:N}of g.recommendations)l.push({extensionId:F,extensionName:C,isExtensionPack:N,exeName:d,exeFriendlyName:g.exeFriendlyName,windowsPath:g.windowsPath})}}return l}};r=he([X(0,I.INativeEnvironmentService),X(1,a.ITelemetryService),X(2,v.IExtensionManagementService),X(3,c.IStorageService),X(4,p.INativeHostService),X(5,h.IExtensionRecommendationNotificationService),X(6,S.IFileService),X(7,m.IProductService),X(8,y.IRequestService),X(9,f.ILogService)],r),e.ExtensionTipsService=r}),define(te[91],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(k){this.appenders=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,{eventName:P,data:w}){return this.appenders.forEach(b=>b.log(P,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class L{constructor(k){this.channel=k}log(k,A){return this.channel.call("log",{eventName:k,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[48],ne([0,1,26,18,20,21]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class A{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(p,m){return Promise.resolve(void 0)}publicLog2(p,m){return this.publicLog(p,m)}publicLogError(p,m){return Promise.resolve(void 0)}publicLogError2(p,m){return this.publicLogError(p,m)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=A,e.NullTelemetryService=new A;class P{async publicLog(p,m,y){}async publicLogError(p,m,y){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(f,p){return p.onDidChangeConfiguration(m=>{m.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(m.source),configurationKeys:h(m.sourceConfig)})})}e.configurationTelemetry=w;function b(f,p){return!(p.disableTelemetry||!f.enableTelemetry)}e.supportsTelemetry=b;function n(f){const p=f.getValue(k.TELEMETRY_SETTING_ID),m=f.getValue("telemetry.enableCrashReporter");if(f.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||m===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=n;function I(f){const p=Object.create(null),m=Object.create(null),y=Object.create(null);E(f,y);for(let c in y){c=c.length>150?c.substr(c.length-149):c;const a=y[c];typeof a=="number"?m[c]=a:typeof a=="boolean"?m[c]=a?1:0:typeof a=="string"?p[c]=a.substring(0,1023):typeof a!="undefined"&&a!==null&&(p[c]=a)}return{properties:p,measurements:m}}e.validateTelemetryData=I;function v(f){if(!f)return"none";let p="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(y=>{f.indexOf(`${y}+`)===0&&(p=y)}),p}e.cleanRemoteAuthority=v;function E(f,p,m=0,y){if(!!f)for(let c of Object.getOwnPropertyNames(f)){const a=f[c],t=y?y+c:c;Array.isArray(a)?p[t]=(0,R.safeStringify)(a):a instanceof Date?p[t]=a.toISOString():(0,L.isObject)(a)?m<2?E(a,p,m+1,t+"."):p[t]=(0,R.safeStringify)(a):p[t]=a}}function h(f){if(!f)return[];const p=[];return S(p,"",f),p}function S(f,p,m){m&&typeof m=="object"&&!Array.isArray(m)?Object.keys(m).forEach(y=>S(f,p?`${p}.${y}`:y,m[y])):f.push(p)}}),define(te[204],ne([0,1,17,27,8,26,4,31,7,20,13,29,35,76,14,10,30,43,47,23,21,48]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f,p,m,y,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=A.isWeb?"web":(0,I.getTargetPlatform)(A.platform,P.arch);var s;(function(K){K[K.None=0]="None",K[K.IncludeVersions=1]="IncludeVersions",K[K.IncludeFiles=2]="IncludeFiles",K[K.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",K[K.IncludeSharedAccounts=8]="IncludeSharedAccounts",K[K.IncludeVersionProperties=16]="IncludeVersionProperties",K[K.ExcludeNonValidated=32]="ExcludeNonValidated",K[K.IncludeInstallationTargets=64]="IncludeInstallationTargets",K[K.IncludeAssetUri=128]="IncludeAssetUri",K[K.IncludeStatistics=256]="IncludeStatistics",K[K.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",K[K.Unpublished=4096]="Unpublished"})(s||(s={}));function r(...K){return String(K.reduce((H,re)=>H|re,0))}var i;(function(K){K[K.Tag=1]="Tag",K[K.ExtensionId=4]="ExtensionId",K[K.Category=5]="Category",K[K.ExtensionName=7]="ExtensionName",K[K.Target=8]="Target",K[K.Featured=9]="Featured",K[K.SearchText=10]="SearchText",K[K.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class g{constructor(H=d){this.state=H}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(H,re=this.state.pageSize){return new g({...this.state,pageNumber:H,pageSize:re})}withFilter(H,...re){const ie=[...this.state.criteria,...re.length?re.map(ce=>({filterType:H,value:ce})):[{filterType:H}]];return new g({...this.state,criteria:ie})}withSortBy(H){return new g({...this.state,sortBy:H})}withSortOrder(H){return new g({...this.state,sortOrder:H})}withFlags(...H){return new g({...this.state,flags:H.reduce((re,ie)=>re|ie,0)})}withAssetTypes(...H){return new g({...this.state,assetTypes:H})}get raw(){const{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le,flags:de,assetTypes:fe}=this.state;return{filters:[{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le}],assetTypes:fe,flags:de}}get searchText(){const H=this.state.criteria.filter(re=>re.filterType===i.SearchText)[0];return H&&H.value?H.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(H=>String(H.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(K,H){const re=(K||[]).filter(ie=>ie.statisticName===H)[0];return re?re.value:0}function _(K){const H="Microsoft.VisualStudio.Code.Translation.";return K.files.filter(ie=>ie.assetType.indexOf(H)===0).reduce((ie,ce)=>{const le=N(K,ce.assetType);return le&&ie.push([ce.assetType.substring(H.length),le]),ie},[])}function O(K){if(K.properties){const H=K.properties.filter(ce=>ce.key===o.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=H.filter(ce=>re.test(ce.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return N(K,o.Repository)}function F(K){return{uri:`${K.fallbackAssetUri}/${o.VSIX}?redirect=true${K.targetPlatform?`&targetPlatform=${K.targetPlatform}`:""}`,fallbackUri:`${K.fallbackAssetUri}/${o.VSIX}${K.targetPlatform?`?targetPlatform=${K.targetPlatform}`:""}`}}function C(K){const H=N(K,o.Icon);if(H)return H;const re=I.DefaultIconPath;return{uri:re,fallbackUri:re}}function N(K,H){return K.files.filter(ie=>ie.assetType===H)[0]?{uri:`${K.assetUri}/${H}`,fallbackUri:`${K.fallbackAssetUri}/${H}`}:null}function z(K,H){const re=K.properties?K.properties.filter(ce=>ce.key===H):[],ie=re.length>0&&re[0].value;return ie?ie.split(",").map(ce=>(0,v.adoptToGalleryExtensionId)(ce)):[]}function M(K){const H=K.properties?K.properties.filter(re=>re.key===l.Engine):[];return H.length>0&&H[0].value||""}function q(K){const H=K.properties?K.properties.filter(ie=>ie.key===l.LocalizedLanguages):[],re=H.length>0&&H[0].value||"";return re?re.split(","):[]}function W(K){return K.indexOf("preview")!==-1}function j(K){return K.targetPlatform?(0,I.toTargetPlatform)(K.targetPlatform):"undefined"}function x(K){const H=(0,R.distinct)(K.versions.map(j)),re=!!K.tags?.includes(I.WEB_EXTENSION_TAG),ie=H.indexOf("web");return re?ie===-1&&H.push("web"):ie!==-1&&H.splice(ie,1),H}function $(K,H){const re=(0,I.getFallbackTargetPlarforms)(H);for(let ie=0;ie<K.length;ie++){const ce=K[ie];if(ce.version===K[ie-1]?.version){let le=ie;const de=j(ce);if(de===H)for(;le>0&&K[le-1].version===ce.version;)le--;else if(re.includes(de))for(;le>0&&K[le-1].version===ce.version&&j(K[le-1])!==H;)le--;le!==ie&&(K.splice(ie,1),K.splice(le,0,ce))}}return K}e.sortExtensionVersions=$;function G(K,H,re,ie,ce){const le=x(K);let de=K.versions[0];return de=K.versions.find(fe=>fe.version===de.version&&(0,I.isTargetPlatformCompatible)(j(fe),le,ce))||de,U(K,de,le,H,re,ie)}function U(K,H,re,ie,ce,le){const de={manifest:N(H,o.Manifest),readme:N(H,o.Details),changelog:N(H,o.Changelog),license:N(H,o.License),repository:O(H),download:F(H),icon:C(H),coreTranslations:_(H)};return{identifier:{id:(0,v.getGalleryExtensionId)(K.publisher.publisherName,K.extensionName),uuid:K.extensionId},name:K.extensionName,version:H.version,displayName:K.displayName,publisherId:K.publisher.publisherId,publisher:K.publisher.publisherName,publisherDisplayName:K.publisher.displayName,description:K.shortDescription||"",installCount:T(K.statistics,"install"),rating:T(K.statistics,"averagerating"),ratingCount:T(K.statistics,"ratingcount"),categories:K.categories||[],tags:K.tags||[],releaseDate:Date.parse(K.releaseDate),lastUpdated:Date.parse(K.lastUpdated),allTargetPlatforms:re,assets:de,properties:{dependencies:z(H,l.Dependency),extensionPack:z(H,l.ExtensionPack),engine:M(H),localizedLanguages:q(H),targetPlatform:j(H)},preview:W(K.flags),telemetryData:{index:(ce.pageNumber-1)*ce.pageSize+ie,querySource:le}}}let V=class{constructor(H,re,ie,ce,le,de,fe,be){this.requestService=re,this.logService=ie,this.environmentService=ce,this.telemetryService=le,this.fileService=de,this.productService=fe,this.configurationService=be;const Ce=fe.extensionsGallery;this.extensionsGalleryUrl=Ce&&Ce.serviceUrl,this.extensionsControlUrl=Ce&&Ce.controlUrl,this.commonHeadersPromise=Z(fe.version,fe,this.environmentService,this.configurationService,this.fileService,H)}api(H=""){return`${this.extensionsGalleryUrl}${H}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(H,re){const ie=[];let ce=new g().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,H.length).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExtensionName,...H.map(({id:de})=>de.toLowerCase()));H.every(de=>!de.version)&&(ce=ce.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,t,L.CancellationToken.None);for(let de=0;de<le.length;de++){const fe=le[de];if(!fe.versions.length)continue;const be=(0,v.getGalleryExtensionId)(fe.publisher.publisherName,fe.extensionName),Ce=H.find(Ee=>(0,v.areSameExtensions)(Ee,{id:be}))?.version;if(Ce){const Ee=fe.versions.find(Ae=>Ae.version===Ce);Ee&&ie.push(U(fe,Ee,x(fe),de,ce))}else ie.push(G(fe,de,ce,void 0,t))}return ie}async getCompatibleExtension(H,re){const ie=(0,I.isIExtensionIdentifier)(H)?null:H;if(ie){if((0,I.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(ie,re))return ie}const{id:ce,uuid:le}=ie?ie.identifier:H;let de=new g().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");le?de=de.withFilter(i.ExtensionId,le):de=de.withFilter(i.ExtensionName,ce);const{galleryExtensions:fe}=await this.queryGallery(de,re,L.CancellationToken.None),[be]=fe;if(!be||!be.versions.length)return null;const Ce=x(be);if((0,I.isNotWebExtensionInWebTargetPlatform)(Ce,re))return null;for(let Ee of be.versions){if(!M(Ee)){const Ae=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:l.Engine,value:Ae}]}}if(await this.isRawExtensionVersionCompatible(Ee,Ce,re))return U(be,Ee,Ce,0,de)}return null}async isExtensionCompatible(H,re){if(!(0,I.isTargetPlatformCompatible)(H.properties.targetPlatform,H.allTargetPlatforms,re))return!1;let ie=H.properties.engine;if(!ie){const ce=await this.getManifest(H,L.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");ie=ce.engines.vscode}return(0,E.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(H,re,ie){if(!(0,I.isTargetPlatformCompatible)(j(H),re,ie))return!1;const ce=await this.getEngine(H);return(0,E.isEngineValid)(ce,this.productService.version,this.productService.date)}async query(H,re){const ie=L.CancellationToken.isCancellationToken(H)?{}:H,ce=L.CancellationToken.isCancellationToken(H)?H:re;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=ie.text||"";const de=(0,k.getOrDefault)(ie,Pe=>Pe.pageSize,50);let fe=new g().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,de).withFilter(i.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Le,Ne)=>(fe=fe.withFilter(i.Category,Ne||Le),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Le,Ne)=>(fe=fe.withFilter(i.Tag,Ne||Le),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(fe=fe.withFilter(i.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),fe=fe.withFilter(i.SearchText,le)),fe=fe.withSortBy(0)):ie.ids?fe=fe.withFilter(i.ExtensionId,...ie.ids):ie.names?fe=fe.withFilter(i.ExtensionName,...ie.names):fe=fe.withSortBy(4),typeof ie.sortBy=="number"&&(fe=fe.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(fe=fe.withSortOrder(ie.sortOrder));const{galleryExtensions:be,total:Ce}=await this.queryGallery(fe,t,ce),Ee=be.map((Pe,Le)=>G(Pe,Le,fe,ie.source,t)),Ae=async(Pe,Le)=>{if(Le.isCancellationRequested)throw(0,D.canceled)();const Ne=fe.withPage(Pe+1),{galleryExtensions:Fe}=await this.queryGallery(Ne,t,Le);return Fe.map(($e,xe)=>G($e,xe,Ne,ie.source,t))};return{firstPage:Ee,total:Ce,pageSize:fe.pageSize,getPage:Ae}}async queryGallery(H,re,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");H=H.withFlags(H.flags,s.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,r(s.Unpublished));const ce=await this.commonHeadersPromise,le=JSON.stringify(H.raw),de={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},fe=new Date().getTime();let be,Ce,Ee=0;try{if(be=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:de},ie),be.res.statusCode&&be.res.statusCode>=400&&be.res.statusCode<500)return{galleryExtensions:[],total:Ee};const Ae=await(0,p.asJson)(be);if(Ae){const Pe=Ae.results[0],Le=Pe.extensions;Le.forEach(Fe=>$(Fe.versions,re));const Ne=Pe.resultMetadata&&Pe.resultMetadata.filter(Fe=>Fe.metadataType==="ResultCount")[0];return Ee=Ne&&Ne.metadataItems.filter(Fe=>Fe.name==="TotalCount")[0].count||0,{galleryExtensions:Le,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(Ae){throw Ce=Ae,Ae}finally{this.telemetryService.publicLog2("galleryService:query",{...H.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-fe,success:!!be&&(0,p.isSuccess)(be),responseBodySize:be?.res.headers["Content-Length"],statusCode:be?String(be.res.statusCode):void 0,errorCode:Ce?(0,D.isPromiseCanceledError)(Ce)?"canceled":(0,D.getErrorMessage)(Ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(H,re,ie,ce){if(!this.isEnabled())return;const le=A.isWeb?this.api(`/itemName/${H}.${re}/version/${ie}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${H}/extensions/${re}/${ie}/stats?statType=${ce}`),de=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",be={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:le,headers:be},L.CancellationToken.None)}catch(Ce){}}async download(H,re,ie){this.logService.trace("ExtensionGalleryService#download",H.identifier.id);const ce=(0,v.getGalleryExtensionTelemetryData)(H),le=new Date().getTime(),de=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Ee}),fe=ie===1?"install":ie===2?"update":"",be=fe?{uri:`${H.assets.download.uri}${w.URI.parse(H.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${H.assets.download.fallbackUri}${w.URI.parse(H.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:H.assets.download,Ce=await this.getAsset(be);await this.fileService.writeFile(re,Ce.stream),de(new Date().getTime()-le)}async getReadme(H,re){if(H.assets.readme){const ie=await this.getAsset(H.assets.readme,{},re);return await(0,p.asText)(ie)||""}return""}async getManifest(H,re){if(H.assets.manifest){const ie=await this.getAsset(H.assets.manifest,{},re),ce=await(0,p.asText)(ie);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(H,re){const ie=N(H,o.Manifest);if(!ie)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},le=await this.getAsset(ie,{headers:ce});return await(0,p.asJson)(le)}async getCoreTranslation(H,re){const ie=H.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(ie){const ce=await this.getAsset(ie[1]),le=await(0,p.asText)(ce);return le?JSON.parse(le):null}return null}async getChangelog(H,re){if(H.assets.changelog){const ie=await this.getAsset(H.assets.changelog,{},re);return await(0,p.asText)(ie)||""}return""}async getAllCompatibleVersions(H,re){let ie=new g().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");H.identifier.uuid?ie=ie.withFilter(i.ExtensionId,H.identifier.uuid):ie=ie.withFilter(i.ExtensionName,H.identifier.id);const{galleryExtensions:ce}=await this.queryGallery(ie,re,L.CancellationToken.None);if(!ce.length)return[];const le=x(ce[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(le,re))return[];const de=[];for(const fe of ce[0].versions)try{de[de.length-1]?.version!==fe.version&&await this.isRawExtensionVersionCompatible(fe,le,re)&&de.push({version:fe.version,date:fe.lastUpdated})}catch(be){}return de}async getAsset(H,re={},ie=L.CancellationToken.None){const ce=await this.commonHeadersPromise,le={type:"GET"},de={...ce,...re.headers||{}};re={...re,...le,headers:de};const fe=H.uri,be=H.fallbackUri,Ce={...re,url:fe};try{const Ee=await this.requestService.request(Ce,ie);if(Ee.res.statusCode===200)return Ee;const Ae=await(0,p.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${Ae}`)}catch(Ee){if((0,D.isPromiseCanceledError)(Ee))throw Ee;const Ae=(0,D.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:fe,message:Ae});const Pe={...re,url:be};return this.requestService.request(Pe,ie)}}async getEngine(H){let re=M(H);if(!re){const ie=await this.getManifestFromRawExtensionVersion(H,L.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");re=ie.engines.vscode}return re}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const H=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(H.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,p.asJson)(H),ie=new Map;if(re)for(const ce of re.malicious){const le=ie.get(ce)||{id:{id:ce},malicious:!0,slow:!1};le.malicious=!0,ie.set(ce,le)}return[...ie.values()]}};V=he([X(1,p.IRequestService),X(2,S.ILogService),X(3,n.IEnvironmentService),X(4,c.ITelemetryService),X(5,h.IFileService),X(6,f.IProductService),X(7,b.IConfigurationService)],V);let B=class extends V{constructor(H,re,ie,ce,le,de,fe,be){super(H,re,ie,ce,le,de,fe,be)}};B=he([X(0,y.IStorageService),X(1,p.IRequestService),X(2,S.ILogService),X(3,n.IEnvironmentService),X(4,c.ITelemetryService),X(5,h.IFileService),X(6,f.IProductService),X(7,b.IConfigurationService)],B),e.ExtensionGalleryService=B;let Q=class extends V{constructor(H,re,ie,ce,le,de,fe){super(void 0,H,re,ie,ce,le,de,fe)}};Q=he([X(0,p.IRequestService),X(1,S.ILogService),X(2,n.IEnvironmentService),X(3,c.ITelemetryService),X(4,h.IFileService),X(5,f.IProductService),X(6,b.IConfigurationService)],Q),e.ExtensionGalleryServiceWithNoStorageService=Q;async function Z(K,H,re,ie,ce,le){const de={"X-Market-Client-Id":`VSCode ${K}`,"User-Agent":`VSCode ${K}`},fe=await(0,m.getServiceMachineId)(re,ce,le);return(0,a.supportsTelemetry)(H,re)&&(0,a.getTelemetryLevel)(ie)===3&&(de["X-Market-User-Id"]=fe),de}e.resolveMarketplaceHeaders=Z}),define(te[92],ne([0,1,2,13,10,48]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends R.Disposable{constructor(w,b,n=""){super();this.prefix=n;const I=w.getLogger(b.telemetryLogResource);I?this.logger=this._register(I):(this.logger=this._register(w.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(w,b){this.logger.trace(`${this.prefix}telemetry/${w}`,(0,k.validateTelemetryData)(b))}};A=he([X(0,D.ILoggerService),X(1,L.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(te[93],ne([0,1,2,26,4,25,141,20,38,42,34,21,48]),function(J,e,R,L,D,k,A,P,w,b,n,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(f,p){this._configurationService=p,this._experimentProperties={},this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let m of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(m),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(m=>{const y=/^[a-f0-9]+$/i.test(m["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!y})})}setExperimentProperty(f,p){this._experimentProperties[f]=p}_updateTelemetryLevel(){this._telemetryLevel=(0,v.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const f=await this._commonProperties;let p=f.sessionID,m=f["common.instanceId"],y=f["common.machineId"],c=f["common.firstSessionDate"],a=f["common.msftInternal"];return{sessionId:p,instanceId:m,machineId:y,firstSessionDate:c,msftInternal:a}}dispose(){this._disposables.dispose()}_log(f,p,m,y){return this.telemetryLevel<p?Promise.resolve(void 0):this._commonProperties.then(c=>{m=(0,L.mixin)(m,c),m=(0,L.mixin)(m,this._experimentProperties),m=(0,L.cloneAndChange)(m,a=>{if(typeof a=="string")return this._cleanupInfo(a,y)}),this._appenders.forEach(a=>a.log(f,m))},c=>{console.error(c)})}publicLog(f,p,m){return this._log(f,3,p,m)}publicLog2(f,p,m){return this.publicLog(f,p,m)}publicLogError(f,p){return this.sendErrorTelemetry?this._log(f,2,p,!0):Promise.resolve(void 0)}publicLogError2(f,p){return this.publicLogError(f,p)}_anonymizeFilePaths(f){let p=f;const m=[];for(let t of this._cleanupPatterns)for(;;){const s=t.exec(f);if(!s)break;m.push([s.index,t.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(p="";;){const t=c.exec(f);if(!t)break;!y.test(t[0])&&m.every(([s,r])=>t.index<s||t.index>=r)&&(p+=f.substring(a,t.index)+"<REDACTED: user-file-path>",a=c.lastIndex)}return a<f.length&&(p+=f.substr(a)),p}_removePropertiesWithPossibleUserInfo(f){if(!f)return f;const p=f.toLowerCase(),m=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(p)?"<REDACTED: secret>":m.test(p)?"<REDACTED: email>":f}_cleanupInfo(f,p){let m=f;p&&(m=this._anonymizeFilePaths(m));for(let y of this._cleanupPatterns)m=m.replace(y,"");return m=this._removePropertiesWithPossibleUserInfo(m),m}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=he([X(1,P.IConfigurationService)],E),e.TelemetryService=E;function h(){const S=(0,A.localize)(0,null,b.default.nameLong),f=b.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=D.isWeb?"":(0,A.localize)(3,null),m=(0,A.localize)(4,null),y=(0,A.localize)(5,null),c=(0,A.localize)(6,null),a=(0,A.localize)(7,null),t=`
|       | ${m} | ${y} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,A.localize)(8,null);return`
${S} ${f} ${p}

&nbsp;

${a}
${t}

&nbsp;

${s}
`}n.Registry.as(w.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),n.Registry.as(w.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,A.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,A.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[205],ne([0,1,8,26,48]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(P){const w=await new Promise((n,I)=>{J(["applicationinsights"],n,I)});let b;return w.defaultClient?(b=new w.TelemetryClient(P),b.channel.setUseDiskRetryCaching(!0)):(w.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),b=w.defaultClient),P.indexOf("AIF-")===0&&(b.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),b}class A{constructor(w,b,n){this._eventPrefix=w,this._defaultData=b,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(w){if(!!this._aiClient){if(typeof this._aiClient!="string"){w(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient)),this._asyncAIClient.then(b=>{w(b)},b=>{(0,R.onUnexpectedError)(b),console.error(b)})}}log(w,b){!this._aiClient||(b=(0,L.mixin)(b,this._defaultData),b=(0,D.validateTelemetryData)(b),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+w,properties:b.properties,measurements:b.measurements})))}flush(){return this._aiClient?new Promise(w=>{this._withAIClient(b=>{b.flush({callback:()=>{this._aiClient=void 0,w(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(te[206],ne([0,1,15,45,20,13,10,21,91,92,93]),function(J,e,R,L,D,k,A,P,w,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let I=class{constructor(E,h,S,f){this.configurationService=E,this.telemetryService=h,this.loggerService=S,this.environmentService=f,this.customTelemetryServices=new Map}async getCustomTelemetryService(E){if(!this.customTelemetryServices.has(E.id)){const{machineId:h,sessionId:S}=await this.telemetryService.getTelemetryInfo(),f=Object.create(null);f["common.vscodemachineid"]=h,f["common.vscodesessionid"]=S;const p=[E.id,JSON.stringify(f),E.aiKey],y=new L.Client(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:p,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new w.TelemetryAppenderClient(y),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${E.id}] `)];this.customTelemetryServices.set(E.id,new n.TelemetryService({appenders:c,sendErrorTelemetry:E.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(E.id)}async publicLog(E,h,S){await(await this.getCustomTelemetryService(E)).publicLog(h,S)}async publicLogError(E,h,S){await(await this.getCustomTelemetryService(E)).publicLogError(h,S)}};I=he([X(0,D.IConfigurationService),X(1,P.ITelemetryService),X(2,A.ILoggerService),X(3,k.IEnvironmentService)],I),e.CustomEndpointTelemetryService=I}),define(te[207],ne([0,1,5,27,3,2,10]),function(J,e,R,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends k.Disposable{constructor(b,n){super();this._logService=n,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((n,I)=>{const v=++this._lastRequestId;this._pendingRequests.set(v,n),this._onCreateRequest.fire({requestId:v,...b});const E=new L.CancellationTokenSource;(0,R.timeout)(this._timeout,E.token).then(()=>I(`Request ${v} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(v,[(0,k.toDisposable)(()=>E.cancel())])})}acceptReply(b,n){const I=this._pendingRequests.get(b);I?(this._pendingRequests.delete(b),(0,k.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),I(n)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};P=he([X(1,A.ILogService)],P),e.RequestStore=P}),define(te[94],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(A=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var w;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions"})(w=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var n;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(n=e.TerminalLocation||(e.TerminalLocation={}));var I;(function(f){f.TerminalView="view",f.Editor="editor"})(I=e.TerminalLocationString||(e.TerminalLocationString={}));var v;(function(f){f.CwdDetection="cwdDetection"})(v=e.ProcessCapability||(e.ProcessCapability={}));var E;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(E=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var S;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(S=e.ProfileSource||(e.ProfileSource={}))}),define(te[208],ne([0,1,6]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(te[209],ne([0,1,33,26,9,4,31,18,19]),function(J,e,R,L,D,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let v=0;return I&&I.length===4&&(v=parseInt(I[3])),v}e.getWindowsBuildNumber=b;async function n(I,v,E,h=A.env,S=w.Promises.exists){if(D.isAbsolute(I))return await S(I)?I:void 0;if(v===void 0&&(v=A.cwd()),D.dirname(I)!=="."){const y=D.join(v,I);return await S(y)?y:void 0}const p=(0,L.getCaseInsensitive)(h,"PATH");if(E===void 0&&(0,P.isString)(p)&&(E=p.split(D.delimiter)),E===void 0||E.length===0){const y=D.join(v,I);return await S(y)?y:void 0}for(let y of E){let c;if(D.isAbsolute(y)?c=D.join(y,I):c=D.join(v,y,I),await S(c))return c;if(k.isWindows){let a=c+".com";if(await S(a)||(a=c+".exe",await S(a)))return a}}const m=D.join(v,I);return await S(m)?m:void 0}e.findExecutable=n}),define(te[210],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var R;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(R=e.ColorScheme||(e.ColorScheme={}))}),define(te[95],ne([0,1,51,3,2,6,34,210]),function(J,e,R,L,D,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var w;(function(f){function p(m){return m&&typeof m=="object"&&typeof m.id=="string"}f.isThemeColor=p})(w=e.ThemeColor||(e.ThemeColor={}));function b(f){return{id:f}}e.themeColorFromId=b;var n;(function(f){function p(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||w.isThemeColor(s.color))}f.isThemeIcon=p;const m=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function y(s){const r=m.exec(s);if(!r)return;let[,i]=r;return{id:i}}f.fromString=y;function c(s,r){let i=s.id;const o=i.lastIndexOf("~");return o!==-1&&(i=i.substring(0,o)),r&&(i=`${i}~${r}`),{id:i}}f.modify=c;function a(s,r){return s.id===r.id&&s.color?.id===r.color?.id}f.isEqual=a;function t(s,r){return{id:s.id,color:r?b(r):void 0}}f.asThemeIcon=t,f.asClassNameArray=R.CSSIcon.asClassNameArray,f.asClassName=R.CSSIcon.asClassName,f.asCSSSelector=R.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function I(f){switch(f){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,D.toDisposable)(()=>{const m=this.themingParticipants.indexOf(p);this.themingParticipants.splice(m,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new v;A.Registry.add(e.Extensions.ThemingContribution,E);function h(f){return E.onColorThemeChange(f)}e.registerThemingParticipant=h;class S extends D.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(m=>this.onThemeChange(m)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,m){let y=this.theme.getColor(p);return y&&m&&(y=m(y,this.theme)),y?y.toString():null}}e.Themable=S}),define(te[211],ne([0,1,51,95]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function D(P,w){const b=P.map(n=>({name:n.profileName,description:k(n)}));return w&&b.push(...w.map(n=>({name:n.title,description:A(n)}))),{values:b.map(n=>n.name),markdownDescriptions:b.map(n=>n.description)}}e.createProfileSchemaEnums=D;function k(P){let w=`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:R.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?w+=`
- args: "${P.args}"`:w+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(w+=`
- overrideName: ${P.overrideName}`),P.color&&(w+=`
- color: ${P.color}`),P.env&&(w+=`
- env: ${JSON.stringify(P.env)}`),w}function A(P){return`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:R.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(te[212],ne([0,1,51,142,38,34,211]),function(J,e,R,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(R.iconRegistry.all,f=>f.id),markdownEnumDescriptions:Array.from(R.iconRegistry.all,f=>`$(${f.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},w={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},b=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),I=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),v={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:I},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(23,null),type:"string"},id:{description:(0,L.localize)(24,null),type:"string"},title:{description:(0,L.localize)(25,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(26,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(27,null),type:"string"},id:{description:(0,L.localize)(28,null),type:"string"},title:{description:(0,L.localize)(29,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(31,null),type:"string"},id:{description:(0,L.localize)(32,null),type:"string"},title:{description:(0,L.localize)(33,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(36,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(37,null),type:"boolean",default:!0}}};function E(){k.Registry.as(D.Extensions.Configuration).registerConfiguration(v),S()}e.registerTerminalPlatformConfiguration=E;let h;function S(f,p){const m=k.Registry.as(D.Extensions.Configuration);let y;f&&(y=(0,A.createProfileSchemaEnums)(f?.profiles,p));const c=h;h={id:"terminal",order:100,title:(0,L.localize)(38,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(39,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?y?.values:void 0,markdownEnumDescriptions:f?.os===3?y?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(40,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?y?.values:void 0,markdownEnumDescriptions:f?.os===2?y?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(41,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?y?.values:void 0,markdownEnumDescriptions:f?.os===1?y?.markdownDescriptions:void 0}}},m.updateConfigurations({add:[h],remove:c?[c]:[]})}e.registerTerminalDefaultProfileConfiguration=S}),define(te[213],ne([0,1,41,51,9,4,19,70,209,95]),function(J,e,R,L,D,k,A,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function I(t,s,r,i,o,l=process.env,u,d,g,T){return u=u||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},k.isWindows?v(r,i,u,l,d,o.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:o.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:o.getValue("terminal.integrated.defaultProfile.windows"),T,g):y(u,d,r,t&&typeof t=="object"?{...t}:o.getValue(k.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:o.getValue(k.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,g,l)}e.detectAvailableProfiles=I;async function v(t,s,r,i,o,l,u,d,g,T){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let F=!1;(0,w.getWindowsBuildNumber)()>=16299&&(F=!0),await S(g);const C=new Map;t&&(C.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),C.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),C.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),C.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),C.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),c(u,C);const N=await E(C.entries(),d,r,i,o,T);if(t||!t&&l)try{const z=await p(`${O}\\${F?"wsl":"bash"}.exe`,d);for(const M of z)(!u||!(M.profileName in u))&&N.push(M)}catch(z){s&&o?.info("WSL is not installed, so could not detect WSL profiles")}return N}async function E(t,s,r,i=process.env,o,l){const u=[];for(const[d,g]of t){if(g===null)continue;let T,_,O;if("source"in g){const N=n?.get(g.source);if(!N)continue;T=N.paths,_=g.args||N.args,g.icon?O=h(g.icon):N.icon&&(O=N.icon)}else T=Array.isArray(g.path)?g.path:[g.path],_=k.isWindows||Array.isArray(g.args)?g.args:void 0,O=h(g.icon)||void 0;const F=await l?.(T)||T.slice(),C=await a(d,s,F,r,i,_,g.env,g.overrideName,g.isAutoDetected,o);C?(C.isAutoDetected=g.isAutoDetected,C.icon=O,C.color=g.color,u.push(C)):o?.trace("profile not validated",d,T)}return u}function h(t){return typeof t=="string"?{id:t}:t}async function S(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await f(),icon:b.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function f(){const t=[];for await(const s of(0,P.enumeratePowerShellInstallations)())t.push(s.exePath);return t}async function p(t,s){const r=[],i=await new Promise((u,d)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le"},(g,T)=>{if(g)return d("Problem occurred when getting wsl distros");u(T)})});if(!i)return[];const o=new RegExp(/[\r?\n]/),l=i.split(o).filter(u=>u.trim().length>0&&u!=="");for(const u of l){if(u===""||u.startsWith("docker-desktop"))continue;const d=`${u} (WSL)`,g={profileName:d,path:t,args:["-d",`${u}`],isDefault:d===s,icon:m(u)};r.push(g)}return r}function m(t){return t.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):t.includes("Debian")?b.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function y(t,s,r,i,o,l,u,d){const g=new Map;if(r){const T=(await t.readFile("/etc/shells")).toString(),_=l||T.split(`
`).filter(F=>F.trim().indexOf("#")!==0&&F.trim().length>0),O=new Map;for(const F of _){let C=(0,D.basename)(F),N=O.get(C)||0;N++,N>1&&(C=`${C} (${N})`),O.set(C,N),g.set(C,{path:F,isAutoDetected:!0})}}return c(i,g),await E(g.entries(),o,t,d,s,u)}function c(t,s){if(!!t)for(const[r,i]of Object.entries(t))i===null||!("path"in i)&&!("source"in i)?s.delete(r):s.set(r,i)}async function a(t,s,r,i,o,l,u,d,g,T){if(r.length===0)return Promise.resolve(void 0);const _=r.shift();if(_==="")return a(t,s,r,i,o,l,u,d,g);const O={profileName:t,path:_,args:l,env:u,overrideName:d,isAutoDetected:g,isDefault:t===s};if((0,D.basename)(_)===_){const C=o.PATH?o.PATH.split(D.delimiter):void 0;return await(0,w.findExecutable)(_,void 0,C,void 0,i.existsFile)?O:a(t,s,r,i,o,l)}return await i.existsFile((0,D.normalize)(_))?O:a(t,s,r,i,o,l,u,d,g)}}),define(te[214],ne([0,1,3,2,15,4,32,45,20,13,75,162,10,84,21,207,94,212,213]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var y;(function(t){t[t.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let c=0,a=class extends L.Disposable{constructor(s,r,i,o,l){super();this._reconnectConstants=s,this._configurationService=r,this._environmentService=i,this._logService=o,this._telemetryService=l,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._logIfWslNotInstalled=!0,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new R.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new R.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new R.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new R.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new R.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,(0,p.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new S.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}async _resolveShellEnv(){if(k.isWindows)return process.env;try{return await(0,I.resolveShellEnv)(this._logService,{_:[]},process.env)}catch(s){return this._logService.error("ptyHost was unable to resolve shell environment",s),{}}}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,n.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?s.debugBrk=r.port:!r.break&&r.port&&(s.debug=r.port));const i=new P.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,s);this._onPtyHostStart.fire(),A.ProxyChannel.toService(i.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(d=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(d.code),this._isDisposed||(this._restartCount<=y.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}, giving up`))}));const l=i.getChannel(f.TerminalIpcChannels.Log);E.LogLevelChannelClient.setLevel(l,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{E.LogLevelChannelClient.setLevel(l,this._logService.getLevel())}));const u=A.ProxyChannel.toService(i.getChannel(f.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(d=>this._onProcessData.fire(d))),this._register(u.onProcessExit(d=>this._onProcessExit.fire(d))),this._register(u.onProcessReady(d=>this._onProcessReady.fire(d))),this._register(u.onProcessTitleChanged(d=>this._onProcessTitleChanged.fire(d))),this._register(u.onProcessShellTypeChanged(d=>this._onProcessShellTypeChanged.fire(d))),this._register(u.onProcessOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d))),this._register(u.onProcessResolvedShellLaunchConfig(d=>this._onProcessResolvedShellLaunchConfig.fire(d))),this._register(u.onProcessDidChangeHasChildProcesses(d=>this._onProcessDidChangeHasChildProcesses.fire(d))),this._register(u.onDidChangeProperty(d=>this._onDidChangeProperty.fire(d))),this._register(u.onProcessReplay(d=>this._onProcessReplay.fire(d))),this._register(u.onProcessOrphanQuestion(d=>this._onProcessOrphanQuestion.fire(d))),this._register(u.onDidRequestDetach(d=>this._onDidRequestDetach.fire(d))),[i,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,r,i,o,l,u,d,g,T,_,O){const F=setTimeout(()=>this._handleUnresponsiveCreateProcess(),f.HeartbeatConstants.CreateProcessTimeout),C=await this._proxy.createProcess(s,r,i,o,l,u,d,g,T,_,O);return clearTimeout(F),c=Math.max(c,C),C}updateTitle(s,r,i){return this._proxy.updateTitle(s,r,i)}updateIcon(s,r,i){return this._proxy.updateIcon(s,r,i)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,r){return this._proxy.shutdown(s,r)}input(s,r){return this._proxy.input(s,r)}processBinary(s,r){return this._proxy.processBinary(s,r)}resize(s,r,i){return this._proxy.resize(s,r,i)}acknowledgeDataEvent(s,r){return this._proxy.acknowledgeDataEvent(s,r)}setUnicodeVersion(s,r){return this._proxy.setUnicodeVersion(s,r)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,r,i,o=!1){const l=await this._shellEnv,u=this._logIfWslNotInstalled;return u&&(this._logIfWslNotInstalled=!1),(0,m.detectAvailableProfiles)(r,i,o,u,this._configurationService,l,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,r){return this._proxy.requestDetachInstance(s,r)}async acceptDetachInstanceReply(s,r){return this._proxy.acceptDetachInstanceReply(s,r)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s){return this._proxy.reviveTerminalProcesses(s)}async refreshProperty(s,r){return this._proxy.refreshProperty(s,r)}async updateProperty(s,r,i){return this._proxy.updateProperty(s,r,i)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:r})}async acceptPtyHostResolvedVariables(s,r){this._resolveVariablesRequestStore.acceptReply(s,r)}};a=he([X(1,w.IConfigurationService),X(2,b.IEnvironmentService),X(3,v.ILogService),X(4,h.ITelemetryService)],a),e.PtyHostService=a}),define(te[55],ne([0,1,44]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(A,P,w,b){const n=(0,R.setProperty)(A,P,w,b)[0];return n&&(A=A.substring(0,n.offset)+n.content+A.substring(n.offset+n.length)),A}e.edit=L;function D(A,P,w){let b=w;for(;b>=0;){if(A.charAt(b)===P.charAt(P.length-1)&&P.length===1)return b+1;if(b--,P.length===2&&b>=0&&A.charAt(b)===P.charAt(0))return b+2}return 0}e.getLineStartOffset=D;function k(A,P,w){let b=w;for(;b>=0;)if(A.charAt(b)===P.charAt(P.length-1)&&P.length===1||(b++,P.length===2&&b>=0&&A.charAt(b)===P.charAt(1)))return b;return A.length-1}e.getLineEndOffset=k}),define(te[215],ne([0,1,26,61]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(I,v,E,h,S){const f=[],p=[],m=[];if(!v){const _=I.filter(({identifier:O})=>S.every(F=>F.toLowerCase()!==O.id.toLowerCase()));return{local:{added:f,removed:p,updated:m},remote:_.length>0?{added:_,updated:[],removed:[],all:_}:null}}I=I.map(b),v=v.map(b),E=E?E.map(b):null;const y=new Map,c=_=>{_.uuid&&y.set(_.id.toLowerCase(),_.uuid)};I.forEach(({identifier:_})=>c(_)),v.forEach(({identifier:_})=>c(_)),E&&E.forEach(({identifier:_})=>c(_));const a=_=>{const O=_.identifier.uuid||y.get(_.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${_.identifier.id.toLowerCase()}`},t=(_,O)=>(_.set(a(O),O),_),s=I.reduce(t,new Map),r=v.reduce(t,new Map),i=v.reduce((_,O)=>{const F=a(O);O=(0,R.deepClone)(O);const C=s.get(F);return C&&(C.installed&&(O.installed=!0),O.version||(O.version=C.version)),t(_,O)},new Map),o=E?E.reduce(t,new Map):null,l=h.reduce(t,new Map),u=S.reduce((_,O)=>{const F=y.get(O.toLowerCase());return _.add(F?`uuid:${F}`:`id:${O.toLowerCase()}`)},new Set),d=k(s,r,u);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const _=k(o,s,u),O=k(o,r,u),F=(C,N)=>{const z=s.get(C);if(z){const M=r.get(C);return{...N?M:z,version:(M.version&&L.gt(M.version,z.version),z.version),state:A(z,M,o?.get(C))}}};for(const C of O.removed.values()){const N=s.get(C);N&&p.push(N.identifier)}for(const C of O.added.values())if(_.added.has(C)){if(d.updated.has(C)){const N=F(C,!0);N&&(m.push(n(N,C)),i.set(C,N))}}else{const N=r.get(C);N.installed&&f.push(n(N,C))}for(const C of O.updated.values()){const N=F(C,!0);N&&(m.push(n(N,C)),i.set(C,N))}for(const C of _.added.values())O.added.has(C)||i.set(C,s.get(C));for(const C of _.updated.values())if(!O.removed.has(C)&&!O.updated.has(C)){const N=F(C,!1);N&&(i.get(C)?.installed&&(N.installed=!0),i.set(C,N))}for(const C of _.removed.values())!l.has(C)&&!O.updated.has(C)&&o?.get(C)?.installed&&i.delete(C)}const g=[],T=k(r,i,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(T.added.size>0||T.updated.size>0||T.removed.size>0)&&i.forEach((_,O)=>g.push(n(_,O))),{local:{added:f,removed:p,updated:m},remote:g.length?{added:[...T.added].map(_=>i.get(_)),updated:[...T.updated].map(_=>i.get(_)),removed:[...T.removed].map(_=>r.get(_)),all:g}:null}}e.merge=D;function k(I,v,E,{checkInstalledProperty:h,checkVersionProperty:S}={checkInstalledProperty:!1,checkVersionProperty:!1}){const f=I?[...I.keys()].filter(a=>!E.has(a)):[],p=[...v.keys()].filter(a=>!E.has(a)),m=p.filter(a=>f.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),y=f.filter(a=>p.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),c=new Set;for(const a of f){if(y.has(a))continue;const t=I.get(a),s=v.get(a);(!s||t.disabled!==s.disabled||!w(t.state,s.state)||S&&t.version!==s.version||h&&t.installed!==s.installed)&&c.add(a)}return{added:m,removed:y,updated:c}}function A(I,v,E){const h=I.state,S=v.state,f=E?.state;if(!v.version||h&&L.gt(I.version,v.version))return h;if(S&&L.gt(v.version,I.version)||!h)return S;if(!S)return h;const p=(0,R.deepClone)(h),m=f?P(f,S):{added:Object.keys(S).reduce((c,a)=>(c.add(a),c),new Set),removed:new Set,updated:new Set},y=f?P(f,h):{added:Object.keys(h).reduce((c,a)=>(c.add(a),c),new Set),removed:new Set,updated:new Set};for(const c of[...m.added.values(),...m.updated.values()])p[c]=S[c];for(const c of m.removed.values())y.updated.has(c)||delete p[c];return p}function P(I,v){const E=Object.keys(I),h=Object.keys(v),S=h.filter(m=>E.indexOf(m)===-1).reduce((m,y)=>(m.add(y),m),new Set),f=E.filter(m=>h.indexOf(m)===-1).reduce((m,y)=>(m.add(y),m),new Set),p=new Set;for(const m of E){if(f.has(m))continue;const y=I[m],c=v[m];(0,R.equals)(y,c)||p.add(m)}return{added:S,removed:f,updated:p}}function w(I={},v={}){const{added:E,removed:h,updated:S}=P(I,v);return E.size===0&&h.size===0&&S.size===0}function b(I){return{...I,disabled:!!I.disabled,installed:!!I.installed}}function n(I,v){const E={identifier:{id:I.identifier.id,uuid:v.startsWith("uuid:")?v.substring("uuid:".length):void 0}};return I.version&&(E.version=I.version),I.disabled&&(E.disabled=!0),I.installed&&(E.installed=!0),I.state&&(E.state=I.state),E}}),define(te[96],ne([0,1,17,3,2,35,6,30,23]),function(J,e,R,L,D,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,A.createDecorator)("IExtensionsStorageSyncService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class it extends D.Disposable{constructor(v,E){super();this.storageService=v,this.productService=E,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(v){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(v.id)}@${v.version}`}static fromKey(v){const E=b.exec(v);if(E&&E[1])return{id:E[1],version:E[2]}}initialize(){const v=this.storageService.keys(0,1);for(const E of v){const h=it.fromKey(E);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(v){if(v.scope!==0)return;if(this.extensionsWithKeysForSync.has(v.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const E=it.fromKey(v.key);if(E){this.extensionsWithKeysForSync.add(E.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(v,E){this.storageService.store(it.toKey(v),JSON.stringify(E),0,1)}getKeysForSync(v){const E=this.productService.extensionSyncedKeys?.[v.id.toLowerCase()],h=this.storageService.get(it.toKey(v),0),S=h?JSON.parse(h):void 0;return S&&E?(0,R.distinct)([...S,...E]):S||E}};n=he([X(0,w.IStorageService),X(1,P.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(te[97],ne([0,1,17,20,6]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,w){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return b=b.filter(n=>n!==P&&n!==`-${P}`),w&&b.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(P,w){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return b=b.filter(n=>n!==P&&n!==`-${P}`),w&&b.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(P){const w=P.filter(v=>v.isMachineScoped).map(v=>v.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(v=>v.toLowerCase()),n=[],I=[];if(Array.isArray(b))for(const v of b)v.startsWith("-")?I.push(v.substring(1)):n.push(v);return(0,R.distinct)([...w,...n].filter(v=>I.indexOf(v)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(w=>w.toLowerCase())}};k=he([X(0,L.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(te[216],ne([0,1,17,36,26,157,55]),function(J,e,R,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(c){return(0,L.parse)(c)||[]}e.parseKeybindings=P;async function w(c,a,t,s,r){const i=P(c),o=P(a),l=t?P(t):null,u=[...i,...o,...l||[]].map(q=>q.key),d=await r.resolveUserBindings(u);let g=n(i,o,l,d);if(!g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!g.hasLocalForwarded&&g.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};if(g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const T=v(i),_=v(o),O=l?v(l):null,F=h(T,_,d),C=O?h(O,T,d):{added:[...T.keys()].reduce((q,W)=>(q.add(W),q),new Set),removed:new Set,updated:new Set},N=O?h(O,_,d):{added:[..._.keys()].reduce((q,W)=>(q.add(W),q),new Set),removed:new Set,updated:new Set},z=b(F,C,N);let M=c;for(const q of z.removed.values())z.conflicts.has(q)||(M=m(M,q,s));for(const q of z.added.values()){if(z.conflicts.has(q))continue;const W=_.get(q);if(W.some(j=>j.command!==`-${q}`&&g.conflicts.has(d[j.key]))){z.conflicts.add(q);continue}M=p(M,W,s)}for(const q of z.updated.values()){if(z.conflicts.has(q))continue;const W=_.get(q);if(W.some(j=>j.command!==`-${q}`&&g.conflicts.has(d[j.key]))){z.conflicts.add(q);continue}M=y(M,q,W,s)}return{mergeContent:M,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.merge=w;function b(c,a,t){const s=new Set,r=new Set,i=new Set,o=new Set;for(const l of a.removed.values())t.updated.has(l)&&o.add(l);for(const l of t.removed.values())o.has(l)||(a.updated.has(l)?o.add(l):r.add(l));for(const l of a.added.values())o.has(l)||t.added.has(l)&&c.updated.has(l)&&o.add(l);for(const l of t.added.values())o.has(l)||(a.added.has(l)?c.updated.has(l)&&o.add(l):s.add(l));for(const l of a.updated.values())o.has(l)||t.updated.has(l)&&c.updated.has(l)&&o.add(l);for(const l of t.updated.values())o.has(l)||(a.updated.has(l)?c.updated.has(l)&&o.add(l):i.add(l));return{added:s,removed:r,updated:i,conflicts:o}}function n(c,a,t,s){const r=new Set,i=I(c,s),o=I(a,s),l=t?I(t,s):null,u=E(i,o);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const d=l?E(l,i):{added:[...i.keys()].reduce((C,N)=>(C.add(N),C),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const g=l?E(l,o):{added:[...o.keys()].reduce((C,N)=>(C.add(N),C),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:T,removed:_,updated:O,conflicts:F}=b(u,d,g);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:T,removed:_,updated:O,conflicts:F}}function I(c,a){const t=new Map;for(const s of c){const r=a[s.key];let i=t.get(r);i||(i=[],t.set(r,i)),i.push(s)}return t}function v(c){const a=new Map;for(const t of c){const s=t.command[0]==="-"?t.command.substring(1):t.command;let r=a.get(s);r||(r=[],a.set(s,r)),r.push(t)}return a}function E(c,a){const t=[...c.keys()],s=[...a.keys()],r=s.filter(l=>t.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),i=t.filter(l=>s.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),o=new Set;for(const l of t){if(i.has(l))continue;const u=c.get(l).map(g=>({...g,key:l})),d=a.get(l).map(g=>({...g,key:l}));(0,R.equals)(u,d,(g,T)=>f(g,T))||o.add(l)}return{added:r,removed:i,updated:o}}function h(c,a,t){const s=[...c.keys()],r=[...a.keys()],i=r.filter(u=>s.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),o=s.filter(u=>r.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),l=new Set;for(const u of s){if(o.has(u))continue;const d=c.get(u).map(T=>({...T,key:t[T.key]})),g=a.get(u).map(T=>({...T,key:t[T.key]}));S(d,g)||l.add(u)}return{added:i,removed:o,updated:l}}function S(c,a){return!(!(0,R.equals)(c.filter(({command:t})=>t[0]!=="-"),a.filter(({command:t})=>t[0]!=="-"),(t,s)=>f(t,s))||!(0,R.equals)(c.filter(({command:t})=>t[0]==="-"),a.filter(({command:t})=>t[0]==="-"),(t,s)=>f(t,s)))}function f(c,a){if(c.command!==a.command||c.key!==a.key)return!1;const t=k.ContextKeyExpr.deserialize(c.when),s=k.ContextKeyExpr.deserialize(a.when);return!(t&&!s||!t&&s||t&&s&&!t.equals(s)||!D.equals(c.args,a.args))}function p(c,a,t){for(const s of a)c=A.edit(c,[-1],s,t);return c}function m(c,a,t){const s=P(c);for(let r=s.length-1;r>=0;r--)(s[r].command===a||s[r].command===`-${a}`)&&(c=A.edit(c,[r],void 0,t));return c}function y(c,a,t,s){const r=P(c),i=r.findIndex(o=>o.command===a||o.command===`-${a}`);for(let o=r.length-1;o>=0;o--)(r[o].command===a||r[o].command===`-${a}`)&&(c=A.edit(c,[o],void 0,s));for(let o=t.length-1;o>=0;o--)c=A.edit(c,[i],t[o],s);return c}}),define(te[217],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(k,A,P){const w={},b={},n=new Set;if(!A)return{local:{added:w,updated:b,removed:[...n.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const I=L(k,A);if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{local:{added:w,updated:b,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const v=L(P,k),E=L(P,A),h={},S={},f=new Set,p=new Set;for(const m of v.removed.values())E.updated.has(m)?w[m]=A[m]:f.add(m);for(const m of E.removed.values())p.has(m)||(v.updated.has(m)?p.add(m):n.add(m));for(const m of v.updated.values())p.has(m)||(E.updated.has(m)?I.updated.has(m)&&p.add(m):S[m]=k[m]);for(const m of E.updated.values())p.has(m)||(v.updated.has(m)?I.updated.has(m)&&p.add(m):k[m]!==void 0&&(b[m]=A[m]));for(const m of v.added.values())p.has(m)||(E.added.has(m)?I.updated.has(m)&&p.add(m):h[m]=k[m]);for(const m of E.added.values())p.has(m)||(v.added.has(m)?I.updated.has(m)&&p.add(m):w[m]=A[m]);return{local:{added:w,removed:[...n.values()],updated:b},remote:{added:h,removed:[...f.values()],updated:S},conflicts:[...p.values()]}}e.merge=R;function L(k,A){const P=k?Object.keys(k):[],w=A?Object.keys(A):[],b=w.filter(v=>P.indexOf(v)===-1).reduce((v,E)=>(v.add(E),v),new Set),n=P.filter(v=>w.indexOf(v)===-1).reduce((v,E)=>(v.add(E),v),new Set),I=new Set;for(const v of P){if(n.has(v))continue;const E=k[v],h=A[v];E!==h&&I.add(v)}return{added:b,removed:n,updated:I}}function D(k,A){const{added:P,removed:w,updated:b}=L(k,A);return P.size===0&&w.size===0&&b.size===0}e.areSame=D}),define(te[24],ne([0,1,17,16,18,147,38,29,6,86,34]),function(J,e,R,L,D,k,A,P,w,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const l=n.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(l).filter(u=>!!l[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function v(){const l=n.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(l).filter(T=>!!l[T].ignoreSync),d=Object.keys(l).filter(T=>l[T].scope===2||l[T].scope===6),g=I();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...d,...g])}e.getDefaultIgnoredSettings=v,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function E(){const l="vscode://schemas/ignoredSettings",u=n.Registry.as(A.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,k.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,k.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,k.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,k.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,k.localize)(4,null),default:[],scope:1,$ref:l,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=n.Registry.as(b.Extensions.JSONContribution),g=()=>{const T=I(),_=v().filter(N=>N!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter(N=>_.indexOf(N)===-1),F=_.filter(N=>T.indexOf(N)===-1),C={items:{type:"string",enum:[...O,...F.map(N=>`-${N}`)]}};d.registerSchema(l,C)};return u.onDidUpdateConfiguration(()=>g())}e.registerConfiguration=E;function h(l){return l&&(0,D.isObject)(l)&&(0,D.isString)(l.id)&&(0,D.isArray)(l.scopes)}e.isAuthenticationProvider=h;var S;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Extensions="extensions",l.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function f(l,u,d){return d.joinPath(u.userDataSyncHome,l,`lastSync${l}.json`)}e.getLastSyncResourceUri=f,e.IUserDataSyncStoreManagementService=(0,w.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,w.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,w.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function p(l){const u={};return u[e.HEADER_EXECUTION_ID]=l,u}e.createSyncHeaders=p;var m;(function(l){l.Unauthorized="Unauthorized",l.Conflict="Conflict",l.Gone="Gone",l.PreconditionFailed="PreconditionFailed",l.TooLarge="TooLarge",l.UpgradeRequired="UpgradeRequired",l.PreconditionRequired="PreconditionRequired",l.TooManyRequests="RemoteTooManyRequests",l.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",l.RequestFailed="RequestFailed",l.RequestCanceled="RequestCanceled",l.RequestTimeout="RequestTimeout",l.RequestProtocolNotSupported="RequestProtocolNotSupported",l.RequestPathNotEscaped="RequestPathNotEscaped",l.RequestHeadersNotObject="RequestHeadersNotObject",l.NoRef="NoRef",l.EmptyResponse="EmptyResponse",l.TurnedOff="TurnedOff",l.SessionExpired="SessionExpired",l.ServiceChanged="ServiceChanged",l.DefaultServiceChanged="DefaultServiceChanged",l.LocalTooManyRequests="LocalTooManyRequests",l.LocalPreconditionFailed="LocalPreconditionFailed",l.LocalInvalidContent="LocalInvalidContent",l.LocalError="LocalError",l.IncompatibleLocalContent="IncompatibleLocalContent",l.IncompatibleRemoteContent="IncompatibleRemoteContent",l.UnresolvedConflicts="UnresolvedConflicts",l.Unknown="Unknown"})(m=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class y extends Error{constructor(u,d,g,T){super(u);this.code=d,this.resource=g,this.operationId=T,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=y;class c extends y{constructor(u,d,g,T,_){super(u,g,void 0,_);this.url=d,this.serverCode=T}}e.UserDataSyncStoreError=c;class a extends y{constructor(u,d){super(u,d)}}e.UserDataAutoSyncError=a,function(l){function u(d){if(d instanceof l)return d;const g=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(g&&g[1]){const T=g[2]==="unknown"?void 0:g[2],_=g[3]==="unknown"?void 0:g[3];return new l(d.message,g[1],T,_)}return new l(d.message,"Unknown")}l.toUserDataSyncError=u}(y=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(l){l.Uninitialized="uninitialized",l.Idle="idle",l.Syncing="syncing",l.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var s;(function(l){l[l.None=0]="None",l[l.Added=1]="Added",l[l.Modified=2]="Modified",l[l.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var r;(function(l){l.Preview="preview",l.Conflict="conflict",l.Accepted="accepted"})(r=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(l){return`sync.enable.${l}`}e.getEnablementKey=i,e.IUserDataSyncResourceEnablementService=(0,w.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,w.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,w.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,w.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,w.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,w.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(l,u){if(l.scheme!==e.USER_DATA_SYNC_SCHEME)return l=l.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,L.isEqualOrParent)(l,(0,L.joinPath)(u.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(te[49],ne([0,1,17,5,22,27,3,36,2,16,25,18,7,143,20,13,14,47,23,21,24]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f,p,m,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function a(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=a;let t=class extends w.Disposable{constructor(l,u,d,g,T,_,O,F,C,N){super();this.resource=l,this.fileService=u,this.environmentService=d,this.userDataSyncStoreService=T,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=O,this.telemetryService=F,this.logService=C,this.configurationService=N,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,n.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(d.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(l,d,this.extUri),this.currentMachineIdPromise=(0,p.getServiceMachineId)(d,u,g)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,this.getUserDataSyncConfiguration(),k.CancellationToken.None)).resourcePreviews.some(({remoteChange:d})=>d!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const u=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,u={}){await this._sync(l,!0,this.getUserDataSyncConfiguration(),u)}async preview(l,u,d={}){return this._sync(l,!1,u,d)}async apply(l,u={}){try{this.syncHeaders={...u};const d=await this.doApply(l);return this.setStatus(d),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,u,d,g){try{if(this.syncHeaders={...g},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let T="idle";try{const _=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(l,_);return T=await this.performSync(O,_,u,d),T==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(T)}}finally{this.syncHeaders={}}}async replace(l){const u=await this.resolveContent(l);if(!u)return!1;const d=this.parseSyncData(u);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const g=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(null,g),_=await this.isRemoteDataFromCurrentMachine(T),O=await this.generateSyncPreview({ref:T.ref,syncData:d},g,_,this.getUserDataSyncConfiguration(),k.CancellationToken.None),F=[];for(const C of O){const N=await this.getAcceptResult(C,C.remoteResource,void 0,k.CancellationToken.None),{remoteChange:z}=await this.getAcceptResult(C,C.previewResource,C.remoteContent,k.CancellationToken.None);F.push([C,{...N,remoteChange:z!==0?z:2}])}await this.applyResult(T,g,F,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const u=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===u}async getLatestRemoteUserData(l,u){if(u){const d=l&&l.latest?l.latest[this.resource]:void 0;if(u.ref===d||d===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(l,u,d,g){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,E.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,u,d,g)}catch(T){if(T instanceof c.UserDataSyncError)switch(T.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,u,d,g);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(l,u,d,g)}throw T}}async doSync(l,u,d,g){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(_=>this.doGenerateSyncResourcePreview(l,u,d,g,_)));const T=await this.syncPreviewPromise;return this.updateConflicts(T.resourcePreviews),T.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":d?await this.doApply(!1):"syncing"}catch(T){throw this.syncPreviewPromise=null,T}}async merge(l){return await this.updateSyncResourcePreview(l,async u=>{const d=await this.getMergeResult(u,k.CancellationToken.None);await this.fileService.writeFile(u.previewResource,D.VSBuffer.fromString(d?.content||""));const g=d&&!d.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,k.CancellationToken.None):void 0;return u.acceptResult=g,u.mergeState=d.hasConflicts?"conflict":g?"accepted":"preview",u.localChange=g?g.localChange:d.localChange,u.remoteChange=g?g.remoteChange:d.remoteChange,u}),this.syncPreviewPromise}async accept(l,u){return await this.updateSyncResourcePreview(l,async d=>{const g=await this.getAcceptResult(d,l,u,k.CancellationToken.None);return d.acceptResult=g,d.mergeState="accepted",d.localChange=g.localChange,d.remoteChange=g.remoteChange,d}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async u=>{const d=await this.getMergeResult(u,k.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,D.VSBuffer.fromString(d.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=d.localChange,u.remoteChange=d.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(l,u){if(!this.syncPreviewPromise)return;let d=await this.syncPreviewPromise;const g=d.resourcePreviews.findIndex(({localResource:T,remoteResource:_,previewResource:O})=>this.extUri.isEqual(T,l)||this.extUri.isEqual(_,l)||this.extUri.isEqual(O,l));g!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async T=>{const _=[...d.resourcePreviews];return _[g]=await u(_[g]),{...d,resourcePreviews:_}}),d=await this.syncPreviewPromise,this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:d})=>d!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(d=>[d,d.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const u=l.filter(({mergeState:d})=>d==="conflict");(0,R.equals)(this._conflicts,u,(d,g)=>this.extUri.isEqual(d.previewResource,g.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:d})=>({created:u,uri:this.toRemoteBackupResource(d)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:d})=>({created:u,uri:this.toLocalBackupResource(d)}))}toRemoteBackupResource(l){return v.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return v.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const u=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(u))){const{content:d}=await this.getUserData(u);if(d)return this.parseSyncData(d)?.machineId}}async resolveContent(l){const u=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(u))){const{content:d}=await this.getUserData(u);return d}return this.extUri.isEqual(l,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(l){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const d of u.resourcePreviews){if(this.extUri.isEqual(d.acceptedResource,l))return d.acceptResult?d.acceptResult.content:null;if(this.extUri.isEqual(d.remoteResource,l))return d.remoteContent;if(this.extUri.isEqual(d.localResource,l))return d.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,u,d,g,T){const _=await this.isRemoteDataFromCurrentMachine(l),O=await this.generateSyncPreview(l,u,_,g,T),F=[];for(const C of O){const N=C.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(C.localChange===0&&C.remoteChange===0)F.push({...C,acceptedResource:N,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const z=d?await this.getMergeResult(C,T):void 0;if(T.isCancellationRequested)break;await this.fileService.writeFile(C.previewResource,D.VSBuffer.fromString(z?.content||""));const M=z&&!z.hasConflicts?await this.getAcceptResult(C,C.previewResource,void 0,T):void 0;F.push({...C,acceptResult:M,mergeState:z?.hasConflicts?"conflict":M?"accepted":"preview",localChange:M?M.localChange:z?z.localChange:C.localChange,remoteChange:M?M.remoteChange:z?z.remoteChange:C.remoteChange})}}return{remoteUserData:l,lastSyncUserData:u,resourcePreviews:F,isLastSyncFromCurrentMachine:_}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(l.value.toString()),d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&d&&u.version!==d,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${d}.`),await this.resetLocal(),null;const g=u;if(g.content===null)return{ref:u.ref,syncData:null};const T=JSON.parse(g.content);if(a(T))return{...u,syncData:T,content:void 0}}catch(l){l instanceof f.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),g={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:d,...u};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(g)))}async getRemoteUserData(l){const{ref:u,content:d}=await this.getUserData(l);let g=null;return d!==null&&(g=this.parseSyncData(d)),{ref:u,syncData:g}}parseSyncData(l){try{const u=JSON.parse(l);if(a(u))return u}catch(u){this.logService.error(u)}throw new c.UserDataSyncError((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,I.isString)(l)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:u}}else{const u=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(l,u){const d=await this.currentMachineIdPromise,g={version:this.version,machineId:d,content:l};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(g),u,this.syncHeaders),{ref:u,syncData:g}}async backupLocal(l){const u={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=he([X(1,f.IFileService),X(2,S.IEnvironmentService),X(3,m.IStorageService),X(4,c.IUserDataSyncStoreService),X(5,c.IUserDataSyncBackupStoreService),X(6,c.IUserDataSyncResourceEnablementService),X(7,y.ITelemetryService),X(8,c.IUserDataSyncLogService),X(9,h.IConfigurationService)],t),e.AbstractSynchroniser=t;let s=class extends t{constructor(l,u,d,g,T,_,O,F,C,N,z){super(u,d,g,T,_,O,F,C,N,z);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(M=>this.onFileChanges(M)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,u,d){try{u?await this.fileService.writeFile(this.file,D.VSBuffer.fromString(l),d?void 0:u):await this.fileService.createFile(this.file,D.VSBuffer.fromString(l),{overwrite:d})}catch(g){throw g instanceof f.FileOperationError&&g.fileOperationResult===1||g instanceof f.FileOperationError&&g.fileOperationResult===3?new c.UserDataSyncError(g.message,"LocalPreconditionFailed"):g}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};s=he([X(2,f.IFileService),X(3,S.IEnvironmentService),X(4,m.IStorageService),X(5,c.IUserDataSyncStoreService),X(6,c.IUserDataSyncBackupStoreService),X(7,c.IUserDataSyncResourceEnablementService),X(8,y.ITelemetryService),X(9,c.IUserDataSyncLogService),X(10,h.IConfigurationService)],s),e.AbstractFileSynchroniser=s;let r=class extends s{constructor(l,u,d,g,T,_,O,F,C,N,z,M){super(l,u,d,g,T,_,O,F,C,N,M);this.userDataSyncUtilService=z,this._formattingOptions=void 0}hasErrors(l){const u=[];return(0,P.parse)(l,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};r=he([X(2,f.IFileService),X(3,S.IEnvironmentService),X(4,m.IStorageService),X(5,c.IUserDataSyncStoreService),X(6,c.IUserDataSyncBackupStoreService),X(7,c.IUserDataSyncResourceEnablementService),X(8,y.ITelemetryService),X(9,c.IUserDataSyncLogService),X(10,c.IUserDataSyncUtilService),X(11,h.IConfigurationService)],r),e.AbstractJsonFileSynchroniser=r;let i=class{constructor(l,u,d,g){this.resource=l,this.environmentService=u,this.logService=d,this.fileService=g,this.extUri=this.fileService.hasCapability(u.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.lastSyncResource=(0,c.getLastSyncResourceUri)(this.resource,u,b.extUri)}async initialize({ref:l,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const d=this.parseSyncData(u);if(!d)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:l,syncData:d})}catch(T){this.logService.error(T)}}parseSyncData(l){try{const u=JSON.parse(l);if(a(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,u={}){const d={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(d)))}};i=he([X(1,S.IEnvironmentService),X(2,c.IUserDataSyncLogService),X(3,f.IFileService)],i),e.AbstractInitializer=i}),define(te[218],ne([0,1,5,27,8,3,44,50,25,7,20,13,29,35,14,23,21,49,215,96,97,24]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f,p,m,y,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function t(l,u){const d=JSON.parse(l.content);if(l.version===1||l.version===2){const g=(await u.getInstalled(0)).filter(T=>T.isBuiltin);for(const T of d)l.version===1&&(T.enabled===!1&&(T.disabled=!0),delete T.enabled),l.version===2&&g.every(_=>!(0,E.areSameExtensions)(_.identifier,T.identifier))&&(T.installed=!0)}return d}function s(l,u,d){const g=d.get((0,E.getExtensionId)(l,u),0)||"{}";return JSON.parse(g)}e.getExtensionStorageState=s;function r(l,u,d,g){g.store((0,E.getExtensionId)(l,u),JSON.stringify(d),0,1)}e.storeExtensionStorageState=r;let i=class ht extends p.AbstractSynchroniser{constructor(u,d,g,T,_,O,F,C,N,z,M,q,W,j){super("extensions",d,u,g,T,_,q,W,N,M);this.storageService=g,this.extensionManagementService=O,this.extensionEnablementService=F,this.ignoredExtensionsManagementService=C,this.extensionGalleryService=z,this.extensionsStorageSyncService=j,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.debounce(k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:$})=>!!$)),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(u,d){const g=u.syncData?await t(u.syncData,this.extensionManagementService):null,T=d?.skippedExtensions||[],_=d?.syncData?await t(d.syncData,this.extensionManagementService):null,O=await this.extensionManagementService.getInstalled(void 0,!0),F=this.getLocalExtensions(O),C=this.ignoredExtensionsManagementService.getIgnoredExtensions(O);g?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:N,remote:z}=(0,m.merge)(F,g,_,T,C),M={local:N,remote:z,content:this.getPreviewContent(F,N.added,N.updated,N.removed),localChange:N.added.length>0||N.removed.length>0||N.updated.length>0?2:0,remoteChange:z!==null?2:0};return[{skippedExtensions:T,localResource:this.localResource,localContent:this.format(F),localExtensions:F,remoteResource:this.remoteResource,remoteContent:g?this.format(g):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(u,d,g,T){const _=[...d,...g],O=new Set,F=C=>{O.add(C.id.toLowerCase()),C.uuid&&O.add(C.uuid)};_.forEach(({identifier:C})=>F(C)),T.forEach(F);for(const C of u)O.has(C.identifier.id.toLowerCase())||C.identifier.uuid&&O.has(C.identifier.uuid)||_.push(C);return this.format(_)}async getMergeResult(u,d){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,d,g,T){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(d,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(u){const d=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),T=(0,m.merge)(u.localExtensions,null,null,u.skippedExtensions,g),{local:_,remote:O}=T;return{content:u.localContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}async acceptRemote(u){const d=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),T=u.remoteContent?JSON.parse(u.remoteContent):null;if(T!==null){const _=(0,m.merge)(u.localExtensions,T,u.localExtensions,[],g),{local:O,remote:F}=_;return{content:u.remoteContent,local:O,remote:F,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,d,g,T){let{skippedExtensions:_,localExtensions:O}=g[0][0],{local:F,remote:C,localChange:N,remoteChange:z}=g[0][1];if(N===0&&z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),N!==0&&(await this.backupLocal(JSON.stringify(O)),_=await this.updateLocalExtensions(F.added,F.removed,F.updated,_)),C){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify(C.all);u=await this.updateRemoteUserData(M,T?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${C.added.length?` Added: ${JSON.stringify(C.added.map(q=>q.identifier.id))}.`:""}${C.updated.length?` Updated: ${JSON.stringify(C.updated.map(q=>q.identifier.id))}.`:""}${C.removed.length?` Removed: ${JSON.stringify(C.removed.map(q=>q.identifier.id))}.`:""}`)}d?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(u,{skippedExtensions:_}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${_.length?` Skipped: ${JSON.stringify(_.map(M=>M.identifier.id))}.`:""}`))}async getAssociatedResources({uri:u}){return[{resource:this.extUri.joinPath(u,"extensions.json"),comparableResource:ht.EXTENSIONS_DATA_URI}]}async resolveContent(u){if(this.extUri.isEqual(u,ht.EXTENSIONS_DATA_URI)){const g=await this.extensionManagementService.getInstalled(),T=this.ignoredExtensionsManagementService.getIgnoredExtensions(g),_=this.getLocalExtensions(g).filter(O=>!T.some(F=>(0,E.areSameExtensions)({id:F},O.identifier)));return this.format(_)}if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u))return this.resolvePreviewContent(u);let d=await super.resolveContent(u);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(u)),d){const g=this.parseSyncData(d);if(g)switch(this.extUri.basename(u)){case"extensions.json":return this.format(this.parseExtensions(g))}}return null}format(u){u.sort((T,_)=>!T.identifier.uuid&&_.identifier.uuid?-1:T.identifier.uuid&&!_.identifier.uuid?1:(0,w.compare)(T.identifier.id,_.identifier.id));const d=JSON.stringify(u),g=(0,P.format)(d,void 0,{});return(0,A.applyEdits)(d,g)}async hasLocalData(){try{const u=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(u).some(g=>g.installed||g.disabled))return!0}catch(u){}return!1}async updateLocalExtensions(u,d,g,T){const _=[],O=[],F=await this.extensionManagementService.getInstalled();if(d.length){const N=F.filter(({identifier:z,isBuiltin:M})=>!M&&d.some(q=>(0,E.areSameExtensions)(z,q)));await R.Promises.settled(N.map(async z=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,z.identifier.id),await this.extensionManagementService.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,z.identifier.id),_.push(z.identifier)}))}(u.length||g.length)&&await R.Promises.settled([...u,...g].map(async N=>{const z=F.find(q=>(0,E.areSameExtensions)(q.identifier,N.identifier));if(z&&z.isBuiltin){N.state&&z.manifest.version===N.version&&this.updateExtensionState(N.state,z.manifest.publisher,z.manifest.name,z.manifest.version),N.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,N.identifier.id),await this.extensionEnablementService.disableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,N.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,N.identifier.id),await this.extensionEnablementService.enableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,N.identifier.id)),_.push(N.identifier);return}const M=(await this.extensionGalleryService.getExtensions([N.identifier],L.CancellationToken.None))[0];if(N.state&&(z?z.manifest.version===N.version:!!M)){const q=z?z.manifest.publisher:M.publisher,W=z?z.manifest.name:M.name;this.updateExtensionState(N.state,q,W,z?.manifest.version)}if(M)try{N.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,N.identifier.id,M.version),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,N.identifier.id,M.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,N.identifier.id,M.version),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,N.identifier.id,M.version)),z||(await this.extensionManagementService.canInstall(M)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,N.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,N.identifier.id,M.version),_.push(M.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),O.push(N)))}catch(q){O.push(N),q instanceof v.ExtensionManagementError&&q.code===v.INSTALL_ERROR_INCOMPATIBLE?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):(this.logService.error(q),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,M.displayName||M.identifier.id))}else O.push(N),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,N.identifier.id)}));const C=[];for(const N of T)_.some(z=>(0,E.areSameExtensions)(z,N.identifier))||C.push(N);for(const N of O)C.some(z=>(0,E.areSameExtensions)(z.identifier,N.identifier))||C.push(N);return C}updateExtensionState(u,d,g,T){const _=s(d,g,this.storageService),O=T?this.extensionsStorageSyncService.getKeysForSync({id:(0,E.getGalleryExtensionId)(d,g),version:T}):void 0;O?O.forEach(F=>{_[F]=u[F]}):Object.keys(u).forEach(F=>_[F]=u[F]),r(d,g,_,this.storageService)}parseExtensions(u){return JSON.parse(u.content)}getLocalExtensions(u){const d=this.extensionEnablementService.getDisabledExtensions();return u.map(({identifier:g,isBuiltin:T,manifest:_})=>{const O={identifier:g,version:_.version};d.some(F=>(0,E.areSameExtensions)(F,g))&&(O.disabled=!0),T||(O.installed=!0);try{const F=this.extensionsStorageSyncService.getKeysForSync({id:g.id,version:_.version});if(F){const C=s(_.publisher,_.name,this.storageService);O.state=Object.keys(C).reduce((N,z)=>(F.includes(z)&&(N[z]=C[z]),N),{})}}catch(F){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(F))}return O})}};i.EXTENSIONS_DATA_URI=b.URI.from({scheme:a.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=he([X(0,I.IEnvironmentService),X(1,h.IFileService),X(2,S.IStorageService),X(3,a.IUserDataSyncStoreService),X(4,a.IUserDataSyncBackupStoreService),X(5,v.IExtensionManagementService),X(6,v.IGlobalExtensionEnablementService),X(7,c.IIgnoredExtensionsManagementService),X(8,a.IUserDataSyncLogService),X(9,v.IExtensionGalleryService),X(10,n.IConfigurationService),X(11,a.IUserDataSyncResourceEnablementService),X(12,f.ITelemetryService),X(13,y.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let o=class extends p.AbstractInitializer{constructor(u,d,g,T,_){super("extensions",T,_,g);this.extensionManagementService=u,this.ignoredExtensionsManagementService=d}async parseExtensions(u){return u.syncData?await t(u.syncData,this.extensionManagementService):null}generatePreview(u,d){const g=[],T=[],_=[];for(const O of u){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(O.identifier.id))continue;const F=d.find(C=>(0,E.areSameExtensions)(C.identifier,O.identifier));F?(g.push(F),O.disabled&&_.push(O.identifier)):O.installed&&(T.push(O.identifier),O.disabled&&_.push(O.identifier))}return{installedExtensions:g,newExtensions:T,disabledExtensions:_,remoteExtensions:u}}};o=he([X(0,v.IExtensionManagementService),X(1,c.IIgnoredExtensionsManagementService),X(2,h.IFileService),X(3,I.IEnvironmentService),X(4,a.IUserDataSyncLogService)],o),e.AbstractExtensionsInitializer=o}),define(te[219],ne([0,1,26,24]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(P,w,b,n,I){if(!w)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const v=k(P,w);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const E=b?k(b,w):{added:Object.keys(w).reduce((m,y)=>(m.add(y),m),new Set),removed:new Set,updated:new Set},h=b?k(b,P):{added:Object.keys(P).reduce((m,y)=>(m.add(y),m),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},f=R.deepClone(w),p=!b;for(const m of h.added.values())m!==L.SYNC_SERVICE_URL_TYPE&&p&&E.added.has(m)||(f[m]=P[m]);for(const m of h.updated.values())f[m]=P[m];for(const m of h.removed.values())n.unregistered.includes(m)||delete f[m];for(const m of E.added.values()){const y=w[m];if(n.machine.includes(m)){I.info(`GlobalState: Skipped adding ${m} in local storage because it is declared as machine scoped.`);continue}if(b&&h.added.has(m))continue;const c=P[m];c&&c.value===y.value||m===L.SYNC_SERVICE_URL_TYPE&&p&&h.added.has(m)||(c?S.updated[m]=y:S.added[m]=y)}for(const m of E.updated.values()){const y=w[m];if(n.machine.includes(m)){I.info(`GlobalState: Skipped updating ${m} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(m)||h.removed.has(m))continue;const c=P[m];c&&c.value===y.value||(S.updated[m]=y)}for(const m of E.removed.values()){if(n.machine.includes(m)){I.trace(`GlobalState: Skipped removing ${m} in local storage because it is declared as machine scoped.`);continue}h.updated.has(m)||h.removed.has(m)||S.removed.push(m)}return{local:S,remote:A(f,w)?null:f}}e.merge=D;function k(P,w){const b=Object.keys(P),n=Object.keys(w),I=n.filter(h=>b.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),v=b.filter(h=>n.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),E=new Set;for(const h of b){if(v.has(h))continue;const S=P[h],f=w[h];R.equals(S,f)||E.add(h)}return{added:I,removed:v,updated:E}}function A(P,w){const{added:b,removed:n,updated:I}=k(P,w);return b.size===0&&n.size===0&&I.size===0}}),define(te[220],ne([0,1,22,8,3,36,44,50,4,7,28,20,13,14,10,47,23,21,49,55,219,24]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f,p,m,y,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const t="globalState.argv.",s=["locale"];function r(d){const g=d.storage?Object.keys(d.storage).sort():[],T={};g.forEach(F=>T[F]=d.storage[F]),d.storage=T;const _=JSON.stringify(d),O=(0,P.format)(_,void 0,{});return(0,A.applyEdits)(_,O)}const i=1;let o=class ft extends m.AbstractSynchroniser{constructor(g,T,_,O,F,C,N,z,M){super("globalState",g,F,M,T,_,C,N,O,z);this.storageService=M,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(g.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(D.Event.any(D.Event.filter(g.onDidFilesChange,q=>q.contains(this.environmentService.argvResource)),D.Event.filter(M.onDidChangeValue,q=>q.scope===0&&q.target!==void 0?q.target===0:M.keys(0,0).includes(q.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(g,T,_){const O=g.syncData?JSON.parse(g.syncData.content):null;T=T===null&&_?g:T;const F=T&&T.syncData?JSON.parse(T.syncData.content):null,C=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const N=this.getStorageKeys(F),{local:z,remote:M}=(0,c.merge)(C.storage,O?O.storage:null,F?F.storage:null,N,this.logService),q={content:null,local:z,remote:M,localChange:Object.keys(z.added).length>0||Object.keys(z.updated).length>0||z.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:r(C),localUserData:C,remoteResource:this.remoteResource,remoteContent:O?r(O):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource,storageKeys:N}]}async getMergeResult(g,T){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,T,_,O){if(this.extUri.isEqual(T,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(T,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(T,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async acceptLocal(g){return{content:g.localContent,local:{added:{},removed:[],updated:{}},remote:g.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(g){if(g.remoteContent!==null){const T=JSON.parse(g.remoteContent),{local:_,remote:O}=(0,c.merge)(g.localUserData.storage,T.storage,null,g.storageKeys,this.logService);return{content:g.remoteContent,local:_,remote:O,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:g.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(g,T,_,O){let{localUserData:F}=_[0][0],{local:C,remote:N,localChange:z,remoteChange:M}=_[0][1];if(z===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),z!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(F)),await this.writeLocalGlobalState(C),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),M!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const q=JSON.stringify({storage:N});g=await this.updateRemoteUserData(q,O?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}T?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"globalState.json"),comparableResource:ft.GLOBAL_STATE_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,ft.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return r(_)}if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g))return this.resolvePreviewContent(g);let T=await super.resolveContent(g);if(T)return T;if(T=await super.resolveContent(this.extUri.dirname(g)),T){const _=this.parseSyncData(T);if(_)switch(this.extUri.basename(g)){case"globalState.json":return r(JSON.parse(_.content))}}return null}async hasLocalData(){try{const{storage:g}=await this.getLocalGlobalState();if(Object.keys(g).length>1||g[`${t}.locale`]?.value!=="en")return!0}catch(g){}return!1}async getLocalGlobalState(){const g={},T=await this.getLocalArgvContent(),_=(0,k.parse)(T);for(const O of s)_[O]!==void 0&&(g[`${t}${O}`]={version:1,value:_[O]});for(const O of this.storageService.keys(0,0)){const F=this.storageService.get(O,0);F&&(g[O]={version:1,value:F})}return{storage:g}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const g=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),g.value.toString()}catch(g){this.logService.debug((0,L.getErrorMessage)(g))}return"{}"}async writeLocalGlobalState({added:g,removed:T,updated:_}){const O={},F={},C=(z,M)=>{for(const q of z){if(q.startsWith(t)){O[q.substring(t.length)]=M?M[q].value:void 0;continue}if(M){const W=M[q];W.value!==String(this.storageService.get(q,0))&&(F[q]=W.value)}else this.storageService.get(q,0)!==void 0&&(F[q]=void 0)}};if(C(Object.keys(g),g),C(Object.keys(_),_),C(T),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(F).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const z of Object.keys(F))this.storageService.store(z,F[z],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(F))}}async updateArgv(g){const T=await this.getLocalArgvContent();let _=T;for(const O of Object.keys(g))_=(0,y.edit)(_,[O],g[O],{});T!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(g){const T=this.storageService.keys(0,0),_=this.storageService.keys(0,1),O=[...T,..._],F=g?.storage?Object.keys(g.storage).filter(C=>!C.startsWith(t)&&!O.includes(C)&&this.storageService.get(C,0)!==void 0):[];if(!w.isWeb){const C=[...a.ALL_SYNC_RESOURCES.map(N=>(0,a.getEnablementKey)(N)),a.SYNC_SERVICE_URL_TYPE];F.push(...C),_.push(...C)}return{user:T,machine:_,unregistered:F}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:a.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=he([X(0,E.IFileService),X(1,a.IUserDataSyncStoreService),X(2,a.IUserDataSyncBackupStoreService),X(3,a.IUserDataSyncLogService),X(4,v.IEnvironmentService),X(5,a.IUserDataSyncResourceEnablementService),X(6,p.ITelemetryService),X(7,I.IConfigurationService),X(8,f.IStorageService)],o),e.GlobalStateSynchroniser=o;let l=class extends m.AbstractInitializer{constructor(g,T,_,O){super("globalState",_,O,T);this.storageService=g}async doInitialize(g){const T=g.syncData?JSON.parse(g.syncData.content):null;if(!T){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},O={};for(const F of Object.keys(T.storage))F.startsWith(t)?_[F.substring(t.length)]=T.storage[F].value:this.storageService.get(F,0)===void 0&&(O[F]=T.storage[F].value);if(Object.keys(_).length){let F="{}";try{F=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(C){}for(const C of Object.keys(_))F=(0,y.edit)(F,[C],_[C],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(F))}if(Object.keys(O).length)for(const F of Object.keys(O))this.storageService.store(F,O[F],0,0)}};l=he([X(0,f.IStorageService),X(1,E.IFileService),X(2,v.IEnvironmentService),X(3,a.IUserDataSyncLogService)],l),e.GlobalStateInitializer=l;let u=class{constructor(g,T,_,O,F){this.userDataSyncStoreClient=g,this.storageService=T,this.environmentService=_,this.fileService=O,this.logService=F}getSyncStoreType(g){return this.parseGlobalState(g)?.storage[a.SYNC_SERVICE_URL_TYPE]?.value}async sync(g){const T=(0,a.createSyncHeaders)((0,n.generateUuid)());try{return await this.doSync(g,T)}catch(_){if(_ instanceof a.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(g,T)}throw _}}async doSync(g,T){const _=await this.userDataSyncStoreClient.read("globalState",null,T),O=this.parseGlobalState(_)||{storage:{}};O.storage[a.SYNC_SERVICE_URL_TYPE]={value:g,version:i};const F=await(0,S.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),C={version:i,machineId:F,content:r(O)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(C),_.ref,T)}parseGlobalState({content:g}){if(!g)return null;const T=JSON.parse(g);if((0,m.isSyncData)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};u=he([X(1,f.IStorageService),X(2,v.IEnvironmentService),X(3,E.IFileService),X(4,h.ILogService)],u),e.UserDataSyncStoreTypeSynchronizer=u}),define(te[221],ne([0,1,17,22,3,36,4,18,144,20,13,14,23,21,49,216,24]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function p(c,a,t){try{const s=JSON.parse(c);if(!a)return(0,P.isUndefined)(s.all)?null:s.all;switch(A.OS){case 2:return(0,P.isUndefined)(s.mac)?null:s.mac;case 3:return(0,P.isUndefined)(s.linux)?null:s.linux;case 1:return(0,P.isUndefined)(s.windows)?null:s.windows}}catch(s){return t.error(s),null}}e.getKeybindingsContentFromSyncContent=p;let m=class extends h.AbstractJsonFileSynchroniser{constructor(a,t,s,r,i,o,l,u,d,g){super(l.keybindingsResource,"keybindings",o,l,u,a,t,i,g,s,d,r);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(r.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(a,t,s,r){const i=a.syncData?p(a.syncData.content,r.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&s?a:t;const o=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),u=await this.getFormattingOptions();let d=null,g=!1,T=!1,_=!1;if(i){let F=l?l.value.toString():"[]";if(F=F||"[]",this.hasErrors(F))throw new f.UserDataSyncError((0,w.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==F||o!==i){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const C=await(0,S.merge)(F,i,o,u,this.userDataSyncUtilService);C.hasChanges&&(d=C.mergeContent,_=C.hasConflicts,g=_||C.mergeContent!==F,T=_||C.mergeContent!==i)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=l.value.toString(),T=!0);const O={content:d,localChange:g?l?2:1:0,remoteChange:T?2:0,hasConflicts:_};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:i,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(a,t){return a.previewResult}async getAcceptResult(a,t,s,r){if(this.extUri.isEqual(t,this.localResource))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(a,t,s,r){const{fileContent:i}=s[0][0];let{content:o,localChange:l,remoteChange:u}=s[0][1];if(l===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new f.UserDataSyncError((0,w.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),i&&await this.backupLocal(this.toSyncContent(i.value.toString())),await this.updateLocalFileContent(o||"[]",i,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(o||"[]",a.syncData?.content);a=await this.updateRemoteUserData(d,r?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(d){}t?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(a,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const t=(0,k.parse)(a.value.toString());if((0,R.isNonEmptyArray)(t))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"keybindings.json"),comparableResource:t}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let t=await super.resolveContent(a);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(a)),t){const s=this.parseSyncData(t);if(s)switch(this.extUri.basename(a)){case"keybindings.json":return p(s.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.syncKeybindingsPerPlatform()?null:p(a.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(a,t){let s={};try{s=JSON.parse(t||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=a,A.OS){case 2:s.mac=a;break;case 3:s.linux=a;break;case 1:s.windows=a;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};m=he([X(0,f.IUserDataSyncStoreService),X(1,f.IUserDataSyncBackupStoreService),X(2,f.IUserDataSyncLogService),X(3,b.IConfigurationService),X(4,f.IUserDataSyncResourceEnablementService),X(5,I.IFileService),X(6,n.IEnvironmentService),X(7,v.IStorageService),X(8,f.IUserDataSyncUtilService),X(9,E.ITelemetryService)],m),e.KeybindingsSynchroniser=m;let y=class extends h.AbstractInitializer{constructor(a,t,s){super("keybindings",t,s,a)}async doInitialize(a){const t=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(t)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,k.parse)(a.value.toString());return!(0,R.isNonEmptyArray)(t)}catch(a){return a.fileOperationResult===1}}getKeybindingsContentFromSyncContent(a){try{return p(a,!0,this.logService)}catch(t){return this.logService.error(t),null}}};y=he([X(0,I.IFileService),X(1,n.IEnvironmentService),X(2,f.IUserDataSyncLogService)],y),e.KeybindingsInitializer=y}),define(te[222],ne([0,1,17,36,44,50,26,55,24]),function(J,e,R,L,D,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function b(l,u,d){let g=[];d?g=I(d):g=n(u);const T=[],_=[...(0,w.getDisallowedIgnoredSettings)()];if(Array.isArray(g))for(const O of g)O.startsWith("-")?_.push(O.substring(1)):T.push(O);return(0,R.distinct)([...l,...T].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=b;function n(l){let u=l.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=l.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:l.getValue("settingsSync.ignoredSettings")||[]}function I(l){const u=(0,L.parse)(l);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function v(l,u,d,g){if(d.length){const T=o(u),_=(0,L.parse)(u),O=(0,L.parse)(l),F=[];for(const C of d){const N=_[C],z=O[C];N===void 0?l=P.edit(l,[C],void 0,g):z!==void 0?l=P.edit(l,[C],N,g):F.push(a(C,T))}F.sort((C,N)=>C.startOffset-N.startOffset),F.forEach(C=>l=p(C.setting.key,u,l,g))}return l}e.updateIgnoredSettings=v;function E(l,u,d,g,T,_){const O=v(l,u,g,_),F=d!==O,C=d!==u;if(!F&&!C)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!C)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(C&&!F)return{conflictsSettings:[],localContent:v(u,l,g,_),remoteContent:null,hasConflicts:!1};if(d===null&&S(l)){const H=h(l,u,g)?null:v(u,l,g,_);return{conflictsSettings:[],localContent:H,remoteContent:null,hasConflicts:!1}}let N=l,z=u;const M=(0,L.parse)(l),q=(0,L.parse)(u),W=d?(0,L.parse)(d):null,j=g.reduce((H,re)=>(H.add(re),H),new Set),x=f(M,q,j),$=f(W,M,j),G=f(W,q,j),U=new Map,V=new Set,B=H=>{V.add(H);const re=T.filter(({key:ie})=>ie===H)[0];re?(N=P.edit(N,[H],re.value,_),z=P.edit(z,[H],re.value,_)):U.set(H,{key:H,localValue:M[H],remoteValue:q[H]})};for(const H of $.removed.values())G.updated.has(H)?B(H):z=P.edit(z,[H],void 0,_);for(const H of G.removed.values())V.has(H)||($.updated.has(H)?B(H):N=P.edit(N,[H],void 0,_));for(const H of $.updated.values())V.has(H)||(G.updated.has(H)?x.updated.has(H)&&B(H):z=P.edit(z,[H],M[H],_));for(const H of G.updated.values())V.has(H)||($.updated.has(H)?x.updated.has(H)&&B(H):N=P.edit(N,[H],q[H],_));for(const H of $.added.values())V.has(H)||(G.added.has(H)?x.updated.has(H)&&B(H):z=p(H,N,z,_));for(const H of G.added.values())V.has(H)||($.added.has(H)?x.updated.has(H)&&B(H):N=p(H,z,N,_));const Q=U.size>0||!h(N,z,g),Z=Q||!h(N,l,[]),K=Q||!h(z,u,[]);return{localContent:Z?N:null,remoteContent:K?z:null,conflictsSettings:[...U.values()],hasConflicts:Q}}e.merge=E;function h(l,u,d){if(l===u)return!0;const g=(0,L.parse)(l),T=(0,L.parse)(u),_=d.reduce((C,N)=>(C.add(N),C),new Set),O=o(l).filter(C=>!(C.setting&&_.has(C.setting.key))),F=o(u).filter(C=>!(C.setting&&_.has(C.setting.key)));if(O.length!==F.length)return!1;for(let C=0;C<O.length;C++){const N=O[C],z=F[C];if(N.setting&&z.setting){if(N.setting.key!==z.setting.key||!A.equals(g[N.setting.key],T[N.setting.key]))return!1}else if(!N.setting&&!z.setting){if(N.value!==z.value)return!1}else return!1}return!0}e.areSame=h;function S(l){return l?o(l).length===0:!0}e.isEmpty=S;function f(l,u,d){const g=l?Object.keys(l).filter(C=>!d.has(C)):[],T=Object.keys(u).filter(C=>!d.has(C)),_=T.filter(C=>g.indexOf(C)===-1).reduce((C,N)=>(C.add(N),C),new Set),O=g.filter(C=>T.indexOf(C)===-1).reduce((C,N)=>(C.add(N),C),new Set),F=new Set;if(l)for(const C of g){if(O.has(C))continue;const N=l[C],z=u[C];A.equals(N,z)||F.add(C)}return{added:_,removed:O,updated:F}}function p(l,u,d,g){const T=(0,L.parse)(u),_=o(u),O=o(d),F=m(l,_,O);return y(d,l,T[l],F,O,g)}e.addSetting=p;function m(l,u,d){const g=u.findIndex(_=>_.setting?.key===l),T=u[g-1];if(T){if(T.setting){const O=a(T.setting.key,d);if(O)return{index:d.indexOf(O),insertAfter:!0}}else{const O=t(g,u);if(O){const F=a(O.setting.key,d);if(F){const C=s(d.indexOf(F),d),N=r(u,O,u[g]);if(C){const z=r(d,F,C),M=i(N,z);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.indexOf(C),insertAfter:!1}}else{const z=r(d,F,d[d.length-1]),M=i(N,z);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const _=u[g+1];if(_)if(_.setting){const O=a(_.setting.key,d);if(O)return{index:d.indexOf(O),insertAfter:!1}}else{const O=s(g,u);if(O){const F=a(O.setting.key,d);if(F){const C=t(d.indexOf(F),d),N=r(u,u[g],O);if(C){const z=r(d,C,F),M=i(N.reverse(),z.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:d.indexOf(C),insertAfter:!0}}else{const z=r(d,d[0],F),M=i(N.reverse(),z.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function y(l,u,d,g,T,_){let O;return g.index===-1?O=(0,D.setProperty)(l,[u],d,_):O=c(l,u,d,g,T,_).map(F=>(0,D.withFormatting)(l,F,_)[0]),(0,D.applyEdits)(l,O)}function c(l,u,d,g,T,_){const O=`${JSON.stringify(u)}: ${JSON.stringify(d)}`,F=(0,k.getEOL)(_,l),C=T[g.index];if(g.insertAfter){const N=[];if(C.setting)N.push({offset:C.endOffset,length:0,content:","+O});else{const z=s(g.index,T),M=t(g.index,T),q=M?.setting?.commaOffset;M&&q===void 0&&N.push({offset:M.endOffset,length:0,content:","});const W=q!==void 0&&q>C.endOffset;N.push({offset:W?q+1:C.endOffset,length:0,content:z?F+O+",":F+O})}return N}else{if(C.setting)return[{offset:C.startOffset,length:0,content:O+","}];const N=(T[g.index-1]&&!T[g.index-1].setting?F:"")+O+(s(g.index,T)?",":"")+F;return[{offset:C.startOffset,length:0,content:N}]}}function a(l,u){return u.filter(d=>d.setting?.key===l)[0]}function t(l,u){for(let d=l-1;d>=0;d--)if(u[d].setting)return u[d]}function s(l,u){for(let d=l+1;d<u.length;d++)if(u[d].setting)return u[d]}function r(l,u,d){const g=l.indexOf(u),T=l.indexOf(d);return l.filter((_,O)=>g<O&&O<T)}function i(l,u){if(l.length&&u.length){let d=0;for(;d<u.length&&d<l.length;d++)if(l[d].value!==u[d].value)return u[d-1];return u[d-1]}}function o(l){const u=[];let d=-1,g,T;const _={onObjectBegin:O=>{d++},onObjectProperty:(O,F,C)=>{d===0&&(g=F,T=O)},onObjectEnd:(O,F)=>{d--,d===0&&u.push({startOffset:g,endOffset:O+F,value:l.substring(g,O+F),setting:{key:T,commaOffset:void 0}})},onArrayBegin:(O,F)=>{d++},onArrayEnd:(O,F)=>{d--,d===0&&u.push({startOffset:g,endOffset:O+F,value:l.substring(g,O+F),setting:{key:T,commaOffset:void 0}})},onLiteralValue:(O,F,C)=>{d===0&&u.push({startOffset:g,endOffset:F+C,value:l.substring(g,F+C),setting:{key:T,commaOffset:void 0}})},onSeparator:(O,F,C)=>{if(d===0&&O===","){let N=u.length-1;for(;N>=0&&!u[N].setting;N--);const z=u[N];z&&u.splice(N,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:F}})}},onComment:(O,F)=>{d===0&&u.push({startOffset:O,endOffset:O+F,value:l.substring(O,O+F)})}};return(0,L.visit)(l,_),u}}),define(te[223],ne([0,1,22,3,44,145,20,87,13,29,14,23,21,49,55,222,24]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function p(t){return t&&t.settings&&typeof t.settings=="string"&&Object.keys(t).length===1}function m(t){const s=JSON.parse(t);return p(s)?s:{settings:t}}e.parseSettingsSyncContent=m;let y=class extends E.AbstractJsonFileSynchroniser{constructor(s,r,i,o,l,u,d,g,T,_,O){super(r.settingsResource,"settings",s,r,i,o,l,T,_,u,d,g);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const r=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(s,r),o=this.getSettingsSyncContent(i),l=new P.ConfigurationModelParser(f.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&l.parse(o.settings),l.configurationModel.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,r,i){const o=await this.getLocalFileContent(),l=await this.getFormattingOptions(),u=this.getSettingsSyncContent(s);r=r===null&&i?s:r;const d=r?this.getSettingsSyncContent(r):null,g=await this.getIgnoredSettings();let T=null,_=!1,O=!1,F=!1;if(u){let N=o?o.value.toString().trim():"{}";N=N||"{}",this.validateContent(N),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const z=(0,S.merge)(N,u.settings,d?d.settings:null,g,[],l);T=z.localContent||z.remoteContent,_=z.localContent!==null,O=z.remoteContent!==null,F=z.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),T=o.value.toString(),O=!0);const C={content:T,localChange:_?2:0,remoteChange:O?2:0,hasConflicts:F};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:C.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:C.remoteChange,previewResource:this.previewResource,previewResult:C,acceptedResource:this.acceptedResource}]}async getMergeResult(s,r){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,S.updateIgnoredSettings)(s.previewResult.content,"{}",o,i):null}}async getAcceptResult(s,r,i,o){const l=await this.getFormattingOptions(),u=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:s.fileContent?(0,S.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",u,l):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:s.remoteContent!==null?(0,S.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",u,l):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:i!==null?(0,S.updateIgnoredSettings)(i,s.fileContent?s.fileContent.value.toString():"{}",u,l):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(s,r,i,o){const{fileContent:l}=i[0][0];let{content:u,localChange:d,remoteChange:g}=i[0][1];if(d===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.validateContent(u),d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),l&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(l.value.toString()))),await this.updateLocalFileContent(u,l,o),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),g!==0){const T=await this.getFormattingOptions(),_=this.getSettingsSyncContent(s),O=await this.getIgnoredSettings(u);u=(0,S.updateIgnoredSettings)(u,_?_.settings:"{}",O,T),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(u)),o?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(T){}r?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const r=await this.getFormattingOptions(),i=(0,h.edit)(s.value.toString(),[f.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,S.isEmpty)(i)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"settings.json"),comparableResource:r}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let r=await super.resolveContent(s);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(s)),r){const i=this.parseSyncData(r);if(i){const o=this.parseSettingsSyncContent(i.content);if(o)switch(this.extUri.basename(s)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(s){let r=await super.resolvePreviewContent(s);if(r){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();r=(0,S.updateIgnoredSettings)(r,"{}",o,i)}return r}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return m(s)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,o=>o.some(({local:l})=>!!l)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,S.getIgnoredSettings)(r,this.configurationService,s)}validateContent(s){if(this.hasErrors(s))throw new f.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const s=await this.getLocalFileContent();if(!s)return;const r=JSON.parse(s.value.toString());if(!a(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let o=i.settings;const l=await this.getFormattingOptions();for(const u in r)if(["version","content","machineId"].indexOf(u)===-1&&r[u]!==void 0){const d=(0,D.setProperty)(o,[u],r[u],l);d.length&&(o=(0,D.applyEdits)(o,d))}await this.fileService.writeFile(this.file,R.VSBuffer.fromString(o))}catch(s){}}};y=he([X(0,n.IFileService),X(1,w.IEnvironmentService),X(2,I.IStorageService),X(3,f.IUserDataSyncStoreService),X(4,f.IUserDataSyncBackupStoreService),X(5,f.IUserDataSyncLogService),X(6,f.IUserDataSyncUtilService),X(7,A.IConfigurationService),X(8,f.IUserDataSyncResourceEnablementService),X(9,v.ITelemetryService),X(10,b.IExtensionManagementService)],y),e.SettingsSynchroniser=y;let c=class extends E.AbstractInitializer{constructor(s,r,i){super("settings",r,i,s)}async doInitialize(s){const r=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,R.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.environmentService.settingsResource);return(0,S.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return m(s)}catch(r){this.logService.error(r)}return null}};c=he([X(0,n.IFileService),X(1,w.IEnvironmentService),X(2,f.IUserDataSyncLogService)],c),e.SettingsInitializer=c;function a(t){return!!(t&&t.version!==void 0&&typeof t.version=="number"&&t.content!==void 0&&typeof t.content=="string"&&t.machineId!==void 0&&typeof t.machineId=="string")}}),define(te[224],ne([0,1,22,3,26,20,13,14,23,21,49,217,24]),function(J,e,R,L,D,k,A,P,w,b,n,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let E=class extends n.AbstractSynchroniser{constructor(f,p,m,y,c,a,t,s,r){super("snippets",p,f,m,y,c,s,r,a,t);this.version=1,this.snippetsFolder=f.snippetsHome,this._register(this.fileService.watch(f.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,i=>i.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(f,p,m){const y=await this.getSnippetsFileContents(),c=this.toSnippetsContents(y),a=f.syncData?this.parseSnippets(f.syncData):null;p=p===null&&m?f:p;const t=p&&p.syncData?this.parseSnippets(p.syncData):null;a?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,I.merge)(c,a,t);return this.getResourcePreviews(s,y,a||{})}async getMergeResult(f,p){return f.previewResult}async getAcceptResult(f,p,m,y){if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:f.fileContent?f.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:f.remoteContent,localChange:f.remoteContent!==null?f.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder))return m===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:m,localChange:m===null?f.fileContent!==null?3:0:2,remoteChange:m===null?f.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${p.toString()}`)}async applyResult(f,p,m,y){const c=m.map(([a,t])=>({...a,acceptResult:t}));c.every(({localChange:a,remoteChange:t})=>a===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),c.some(({localChange:a})=>a!==0)&&(await this.updateLocalBackup(c),await this.updateLocalSnippets(c,y)),c.some(({remoteChange:a})=>a!==0)&&(f=await this.updateRemoteSnippets(c,f,y)),p?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:a}of c)try{await this.fileService.del(a)}catch(t){}}getResourcePreviews(f,p,m){const y=new Map;for(const c of Object.keys(f.local.added)){const a={content:f.local.added[c],hasConflicts:!1,localChange:1,remoteChange:0};y.set(c,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(f.local.updated)){const a={content:f.local.updated[c],hasConflicts:!1,localChange:2,remoteChange:0};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[c],localContent:p[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of f.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[c],localContent:p[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(f.remote.added)){const a={content:f.remote.added[c],hasConflicts:!1,localChange:0,remoteChange:1};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[c],localContent:p[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(f.remote.updated)){const a={content:f.remote.updated[c],hasConflicts:!1,localChange:0,remoteChange:2};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[c],localContent:p[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of f.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of f.conflicts){const a={content:p[c]?p[c].value.toString():null,hasConflicts:!0,localChange:p[c]?2:1,remoteChange:m[c]?2:1};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[c]||null,localContent:p[c]?p[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(p))if(!y.has(c)){const a={content:p[c]?p[c].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[c]||null,localContent:p[c]?p[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...y.values()]}async getAssociatedResources({uri:f}){let p=await super.resolveContent(f);if(p){const m=this.parseSyncData(p);if(m){const y=this.parseSnippets(m),c=[];for(const a of Object.keys(y)){const t=this.extUri.joinPath(f,a),s=this.extUri.joinPath(this.snippetsFolder,a),r=await this.fileService.exists(s);c.push({resource:t,comparableResource:r?s:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})})}return c}}return[]}async resolveContent(f){if(this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(f);let p=await super.resolveContent(f);if(p)return p;if(p=await super.resolveContent(this.extUri.dirname(f)),p){const m=this.parseSyncData(p);if(m)return this.parseSnippets(m)[this.extUri.basename(f)]||null}return null}async hasLocalData(){try{const f=await this.getSnippetsFileContents();if(Object.keys(f).length)return!0}catch(f){}return!1}async updateLocalBackup(f){const p={};for(const m of f)m.fileContent&&(p[this.extUri.basename(m.localResource)]=m.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(p)))}async updateLocalSnippets(f,p){for(const{fileContent:m,acceptResult:y,localResource:c,remoteResource:a,localChange:t}of f)if(t!==0){const s=a?this.extUri.basename(a):this.extUri.basename(c),r=this.extUri.joinPath(this.snippetsFolder,s);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,R.VSBuffer.fromString(y.content),{overwrite:p}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,R.VSBuffer.fromString(y.content),p?void 0:m),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(f,p,m){const y=p.syncData?this.parseSnippets(p.syncData):{},c=(0,D.deepClone)(y);for(const{acceptResult:a,localResource:t,remoteResource:s,remoteChange:r}of f)if(r!==0){const i=t?this.extUri.basename(t):this.extUri.basename(s);r===3?delete c[i]:c[i]=a.content}return(0,I.areSame)(y,c)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),p=await this.updateRemoteUserData(JSON.stringify(c),m?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),p}parseSnippets(f){return JSON.parse(f.content)}toSnippetsContents(f){const p={};for(const m of Object.keys(f))p[m]=f[m].value.toString();return p}async getSnippetsFileContents(){const f={};let p;try{p=await this.fileService.resolve(this.snippetsFolder)}catch(m){if(m instanceof P.FileOperationError&&m.fileOperationResult===1)return f;throw m}for(const m of p.children||[]){const y=m.resource,c=this.extUri.extname(y);if(c===".json"||c===".code-snippets"){const a=this.extUri.relativePath(this.snippetsFolder,y),t=await this.fileService.readFile(y);f[a]=t}}return f}};E=he([X(0,A.IEnvironmentService),X(1,P.IFileService),X(2,w.IStorageService),X(3,v.IUserDataSyncStoreService),X(4,v.IUserDataSyncBackupStoreService),X(5,v.IUserDataSyncLogService),X(6,k.IConfigurationService),X(7,v.IUserDataSyncResourceEnablementService),X(8,b.ITelemetryService)],E),e.SnippetsSynchroniser=E;let h=class extends n.AbstractInitializer{constructor(f,p,m){super("snippets",p,m,f)}async doInitialize(f){const p=f.syncData?JSON.parse(f.syncData.content):null;if(!p){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const y of Object.keys(p)){const c=p[y];if(c){const a=this.extUri.joinPath(this.environmentService.snippetsHome,y);await this.fileService.createFile(a,R.VSBuffer.fromString(c)),this.logService.info("Created snippet",this.extUri.basename(a))}}await this.updateLastSyncUserData(f)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(f){return f.fileOperationResult===1}}};h=he([X(0,P.IFileService),X(1,A.IEnvironmentService),X(2,v.IUserDataSyncLogService)],h),e.SnippetsInitializer=h}),define(te[63],ne([0,1,3,2,6,24]),function(J,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let A=class extends L.Disposable{constructor(w){super();this.userDataSyncStoreService=w,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(w.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(w.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(w){(w&&this._account?w.token!==this._account.token||w.authenticationProviderId!==this._account.authenticationProviderId:w!==this._account)&&(this._account=w,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(w))}};A=he([X(0,k.IUserDataSyncStoreService)],A),e.UserDataSyncAccountService=A}),define(te[225],ne([0,1,5,22,58,2,16,20,13,14,24]),function(J,e,R,L,D,k,A,P,w,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let I=class extends k.Disposable{constructor(E,h,S,f){super();this.environmentService=E,this.fileService=h,this.configurationService=S,this.logService=f,n.ALL_SYNC_RESOURCES.forEach(p=>this.cleanUpBackup(p))}async getAllRefs(E){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,E),S=await this.fileService.resolve(h);return S.children?S.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.getCreationTime(p)})):[]}async resolveContent(E,h){if(!h){const S=await this.getAllRefs(E);S.length&&(h=S[S.length-1].ref)}if(h){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,E,h);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(E,h){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,E),f=(0,A.joinPath)(S,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(f,L.VSBuffer.fromString(h))}catch(p){this.logService.error(p)}try{this.cleanUpBackup(E)}catch(p){}}async cleanUpBackup(E){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,E);try{try{if(!await this.fileService.exists(h))return}catch(f){return}const S=await this.fileService.resolve(h);if(S.children){const f=S.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),p=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let m=f.filter(c=>Date.now()-this.getCreationTime(c)>p);const y=f.length-m.length;y<10&&(m=m.slice(10-y)),await R.Promises.settled(m.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(E){return E.ctime||new Date(parseInt(E.name.substring(0,4)),parseInt(E.name.substring(4,6))-1,parseInt(E.name.substring(6,8)),parseInt(E.name.substring(9,11)),parseInt(E.name.substring(11,13)),parseInt(E.name.substring(13,15))).getTime()}};I=he([X(0,w.IEnvironmentService),X(1,b.IFileService),X(2,P.IConfigurationService),X(3,n.IUserDataSyncLogService)],I),e.UserDataSyncBackupStoreService=I}),define(te[226],ne([0,1,2,7]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(v){this.service=v}listen(v,E){switch(E){case"onError":return this.service.onError}throw new Error(`Event not found: ${E}`)}call(v,E,h){switch(E){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class k{constructor(v){this.service=v}listen(v,E){throw new Error(`Event not found: ${E}`)}call(v,E,h){switch(E){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class A{constructor(v){this.channel=v}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(v){return this.channel.call("resolveUserKeybindings",[v])}async resolveFormattingOptions(v){return this.channel.call("resolveFormattingOptions",[v])}}e.UserDataSyncUtilServiceClient=A;class P{constructor(v){this.service=v}listen(v,E){switch(E){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${E}`)}async call(v,E,h){switch(E){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class w{constructor(v){this.service=v}listen(v,E){switch(E){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${E}`)}call(v,E,h){switch(E){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=w;class b{constructor(v){this.service=v}listen(v,E){switch(E){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${E}`)}call(v,E,h){switch(E){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class n extends R.Disposable{constructor(v){super();this.channel=v,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(v){return this.channel.call("switch",[v])}async getPreviousUserDataSyncStore(){const v=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(v)}revive(v){return{url:L.URI.revive(v.url),type:v.type,defaultUrl:L.URI.revive(v.defaultUrl),insidersUrl:L.URI.revive(v.insidersUrl),stableUrl:L.URI.revive(v.stableUrl),canSwitch:v.canSwitch,authenticationProviders:v.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(te[227],ne([0,1,13,10]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends L.AbstractLogger{constructor(A,P){super();this.logger=this._register(A.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}critical(A,...P){this.logger.critical(A,...P)}flush(){this.logger.flush()}};D=he([X(0,L.ILoggerService),X(1,R.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(te[64],ne([0,1,3,2,4,25,148,13,14,6,30,47,23,24]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let S=class tt extends L.Disposable{constructor(p,m,y,c,a,t){super();this.storageService=y,this.userDataSyncStoreService=c,this.logService=a,this.productService=t,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,I.getServiceMachineId)(p,m,y)}async getMachines(p){const m=await this.currentMachineIdPromise;return(await this.readMachinesData(p)).machines.map(c=>({...c,isCurrent:c.id===m}))}async addCurrentMachine(p){const m=await this.currentMachineIdPromise,y=await this.readMachinesData(p);y.machines.some(({id:c})=>c===m)||(y.machines.push({id:m,name:this.computeCurrentMachineName(y.machines)}),await this.writeMachinesData(y))}async removeCurrentMachine(p){const m=await this.currentMachineIdPromise,y=await this.readMachinesData(p),c=y.machines.filter(({id:a})=>a!==m);c.length!==y.machines.length&&(y.machines=c,await this.writeMachinesData(y))}async renameMachine(p,m,y){const c=await this.currentMachineIdPromise,a=await this.readMachinesData(y),t=a.machines.find(({id:s})=>s===p);t&&(t.name=m,await this.writeMachinesData(a),a.machines.some(({id:s})=>s===c)&&this.storageService.store(h,m,0,1))}async setEnablement(p,m){const y=await this.readMachinesData(),c=y.machines.find(({id:a})=>a===p);c&&(c.disabled=m?void 0:!0,await this.writeMachinesData(y))}computeCurrentMachineName(p){const m=this.storageService.get(h,0);if(m)return m;const y=`${this.productService.nameLong} (${(0,D.PlatformToString)(D.isWeb?0:D.platform)})`,c=new RegExp(`${(0,k.escapeRegExpCharacters)(y)}\\s#(\\d+)`);let a=0;for(const t of p){const s=c.exec(t.name),r=s?parseInt(s[1]):0;a=r>a?r:a}return`${y} #${a+1}`}async readMachinesData(p){this.userData=await this.readUserData(p);const m=this.parse(this.userData);if(m.version!==tt.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return m}async writeMachinesData(p){const m=JSON.stringify(p),y=await this.userDataSyncStoreService.write(tt.RESOURCE,m,this.userData?.ref||null);this.userData={ref:y,content:m},this._onDidChange.fire()}async readUserData(p){if(this.userData){const m=p&&p.latest?p.latest[tt.RESOURCE]:void 0;if(this.userData.ref===m)return this.userData;if(m===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(tt.RESOURCE,this.userData)}parse(p){if(p.content!==null)try{return JSON.parse(p.content)}catch(m){this.logService.error(m)}return{version:tt.VERSION,machines:[]}}};S.VERSION=1,S.RESOURCE="machines",S=he([X(0,P.IEnvironmentService),X(1,w.IFileService),X(2,v.IStorageService),X(3,E.IUserDataSyncStoreService),X(4,E.IUserDataSyncLogService),X(5,n.IProductService)],S),e.UserDataSyncMachinesService=S}),define(te[98],ne([0,1,5,58,37,8,3,2,4,16,7,146,13,30,23,21,24,63,64]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const y="sync.enable",c="sync.disableMachineEventually",a="sync.sessionId",t="sync.storeUrl",s="sync.productQuality";let r=class extends P.Disposable{constructor(u,d,g){super();this.storageService=u,this.environmentService=d,this.userDataSyncStoreManagementService=g,this._onDidChangeEnablement=new A.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(T=>this.onDidStorageChange(T)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(y,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(y,u,0,1)}onDidStorageChange(u){if(u.scope===0&&y===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=he([X(0,h.IStorageService),X(1,v.IEnvironmentService),X(2,f.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let i=class extends P.Disposable{constructor(u,d,g,T,_,O,F,C,N,z,M){super();this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=g,this.userDataSyncResourceEnablementService=T,this.userDataSyncService=_,this.logService=O,this.userDataSyncAccountService=F,this.telemetryService=C,this.userDataSyncMachinesService=N,this.storageService=z,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=M,this.syncTriggerDelayer=this._register(new R.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(d.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,d.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(F.onDidChangeAccount(()=>this.updateAutoSync())),this._register(g.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(A.Event.debounce(_.onDidChangeLocal,(q,W)=>q?[...q,W]:[W],1e3)(q=>this.triggerSync(q,!1,!1))),this._register(A.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,q])=>q)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(t,0);return u?n.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(t,u.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(u){u?this.storageService.store(s,u,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:u,message:d}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(g=>this.onDidFinishSync(g))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(d&&this.logService.info(d),this.autoSync.clear()):d&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(d))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,d,g){try{this.userDataSyncAccountService.account&&!g&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(T){if(d)this.logService.error(T),this.updateEnablement(!1);else throw T}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(y,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const d=f.UserDataSyncError.toUserDataSyncError(u);d instanceof f.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:d.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),d.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):d.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):d.code==="LocalTooManyRequests"||d.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):d.code==="UpgradeRequired"||d.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):d.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with newer version than of client. Requires client upgrade.`)):d.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with older version than of client. Requires server reset.`)):d.code==="ServiceChanged"||d.code==="DefaultServiceChanged"?w.isWeb&&d.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(d),this.successiveFailures++),this._onError.fire(d)}async disableMachineEventually(){this.storageService.store(c,!0,0,1),await(0,R.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(c,0,!1)}stopDisableMachineEventually(){this.storageService.remove(c,0)}async triggerSync(u,d,g){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(d&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",g)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};i=he([X(0,E.IProductService),X(1,f.IUserDataSyncStoreManagementService),X(2,f.IUserDataSyncStoreService),X(3,f.IUserDataSyncResourceEnablementService),X(4,f.IUserDataSyncService),X(5,f.IUserDataSyncLogService),X(6,p.IUserDataSyncAccountService),X(7,S.ITelemetryService),X(8,m.IUserDataSyncMachinesService),X(9,h.IStorageService),X(10,f.IUserDataAutoSyncEnablementService)],i),e.UserDataAutoSyncService=i;class o extends P.Disposable{constructor(u,d,g,T,_,O,F,C){super();this.lastSyncUrl=u,this.interval=d,this.userDataSyncStoreManagementService=g,this.userDataSyncStoreService=T,this.userDataSyncService=_,this.userDataSyncMachinesService=O,this.logService=F,this.storageService=C,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(u,d){const g=(0,R.createCancelablePromise)(async T=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(_){if((0,k.isPromiseCanceledError)(_))return}return this.doSync(u,d,T)});return this.syncPromise=g,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),d=this.userDataSyncStoreManagementService.userDataSyncStore;return!!d&&!!u&&(!(0,b.isEqual)(d.defaultUrl,u.defaultUrl)||!(0,b.isEqual)(d.insidersUrl,u.insidersUrl)||!(0,b.isEqual)(d.stableUrl,u.stableUrl))}async doSync(u,d,g){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let T;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,d),g.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new f.UserDataAutoSyncError((0,I.localize)(0,null),"DefaultServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(1,null),"ServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(2,null),"TurnedOff");const _=this.storageService.get(a,0);if(_&&this.manifest&&_!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new f.UserDataAutoSyncError((0,I.localize)(3,null),"DefaultServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(4,null),"ServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(5,null),"SessionExpired");const O=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(g.isCancellationRequested)return;const F=O.find(C=>C.isCurrent);if(F?.disabled)throw new f.UserDataAutoSyncError((0,I.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(C){throw new f.UserDataAutoSyncError((0,D.toErrorMessage)(C),C instanceof f.UserDataSyncError?C.code:"Unknown")}if(this.manifest&&this.manifest.session!==_&&this.storageService.store(a,this.manifest.session,0,1),g.isCancellationRequested)return;F||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(_){this.logService.error(_),T=_}this._onDidFinishSync.fire(T)}register(u){return super._register(u)}}o.INTERVAL_SYNCING="Interval"}),define(te[228],ne([0,1,3,2,4,23,21,24]),function(J,e,R,L,D,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let w=class extends L.Disposable{constructor(n,I){super();this.storageService=n,this.telemetryService=I,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(v=>this.onDidStorageChange(v)))}isResourceEnabled(n){return this.storageService.getBoolean((0,P.getEnablementKey)(n),0,!0)}setResourceEnablement(n,I){if(this.isResourceEnabled(n)!==I){const v=(0,P.getEnablementKey)(n);this.telemetryService.publicLog2(v,{enabled:I}),this.storeResourceEnablement(v,I)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,I){this.storageService.store(n,I,0,D.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const I=P.ALL_SYNC_RESOURCES.filter(v=>(0,P.getEnablementKey)(v)===n.key)[0];if(I){this._onDidChangeResourceEnablement.fire([I,this.isResourceEnabled(I)]);return}}}};w=he([X(0,k.IStorageService),X(1,A.ITelemetryService)],w),e.UserDataSyncResourceEnablementService=w}),define(te[229],ne([0,1,17,5,37,8,3,2,16,28,20,6,23,21,218,220,221,223,224,24]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f,p,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const c="sync.lastSyncTime";let a=class extends P.Disposable{constructor(i,o,l,u,d,g,T){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=o,this.instantiationService=l,this.configurationService=u,this.logService=d,this.telemetryService=g,this.storageService=T,this._status="uninitialized",this._onDidChangeStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new A.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new A.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new A.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new A.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(p.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(f.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(m.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(S.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(h.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(A.Event.any(...this.synchronisers.map(_=>A.Event.map(_.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(A.Event.any(...this.synchronisers.map(_=>A.Event.map(_.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(c,0,void 0),this.onDidChangeLocal=A.Event.any(...this.synchronisers.map(_=>A.Event.map(_.onDidChangeLocal,()=>_.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i,o){await this.checkEnablement();const l=(0,b.generateUuid)();try{const T=(0,y.createSyncHeaders)(l);o&&(T["Cache-Control"]="no-cache"),i=await this.userDataSyncStoreService.manifest(i,T)}catch(T){const _=y.UserDataSyncError.toUserDataSyncError(T);throw this.reportUserDataSyncError(_,l),_}let u=!1;const d=this;let g;return{manifest:i,run(){if(u)throw new Error("Can run a task only once");return g=(0,L.createCancelablePromise)(T=>d.sync(i,l,T)),g.finally(()=>g=void 0)},async stop(){if(g&&g.cancel(),d.status!=="idle")return d.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=(0,b.generateUuid)(),o=(0,y.createSyncHeaders)(i);let l;try{l=await this.userDataSyncStoreService.manifest(null,o)}catch(u){const d=y.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(d,i),d}return new t(i,l,o,this.synchronisers,this.configurationService,this.logService)}async sync(i,o,l){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),l.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const d=(0,y.createSyncHeaders)(o);for(const g of this.synchronisers){if(l.isCancellationRequested)return;try{await g.sync(i,d)}catch(T){let _=!1;if(T instanceof y.UserDataSyncError)switch(T.code){case"TooLarge":T=new y.UserDataSyncError(T.message,T.code,g.resource),_=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":_=!0;break}const O=y.UserDataSyncError.toUserDataSyncError(T);if(this.reportUserDataSyncError(O,o),_)throw O;this.logService.error(T),this.logService.error(`${g.resource}: ${(0,D.toErrorMessage)(T)}`),this._syncErrors.push([g.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(d){const g=y.UserDataSyncError.toUserDataSyncError(d);throw this.reportUserDataSyncError(g,o),g}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(o){this.logService.error(o)}}async replace(i){await this.checkEnablement();for(const o of this.synchronisers)if(await o.replace(i))return}async accept(i,o,l,u){await this.checkEnablement();const d=this.getSynchroniser(i);await d.accept(o,l),u&&await d.apply(!1,(0,y.createSyncHeaders)((0,b.generateUuid)()))}async resolveContent(i){for(const o of this.synchronisers){const l=await o.resolveContent(i);if(l)return l}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,o){return this.getSynchroniser(i).getAssociatedResources(o)}getMachineId(i,o){return this.getSynchroniser(i).getMachineId(o)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const o of i)if(await o.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(c,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(o){this.logService.error(`${i.resource}: ${(0,D.toErrorMessage)(o)}`),this.logService.error(o)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const o=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),o==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();(0,R.equals)(this._conflicts,i,([o,l],[u,d])=>o===o&&(0,R.equals)(l,d,(g,T)=>(0,w.isEqual)(g.previewResource,T.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(c,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,o){this.telemetryService.publicLog2("sync/error",{code:i.code,serverCode:i instanceof y.UserDataSyncStoreError?String(i.serverCode):void 0,url:i instanceof y.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:o,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(s)])}getSynchroniser(i){return this.synchronisers.find(o=>o.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};a=he([X(0,y.IUserDataSyncStoreService),X(1,y.IUserDataSyncStoreManagementService),X(2,I.IInstantiationService),X(3,n.IConfigurationService),X(4,y.IUserDataSyncLogService),X(5,E.ITelemetryService),X(6,v.IStorageService)],a),e.UserDataSyncService=a;class t extends P.Disposable{constructor(i,o,l,u,d,g){super();this.id=i,this.manifest=o,this.syncHeaders=l,this.synchronisers=u,this.configurationService=d,this.logService=g,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new A.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,o){try{return await this.performAction(i,l=>l.accept(i,o))}catch(l){throw this.logService.error(l),l}}async merge(i){try{return i?await this.performAction(i,o=>o.merge(i)):await this.mergeAll()}catch(o){throw this.logService.error(o),o}}async discard(i){try{return await this.performAction(i,o=>o.discard(i))}catch(o){throw this.logService.error(o),o}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,o]of this.previews)for(const l of o.resourcePreviews)l.mergeState==="conflict"&&i.push(l.previewResource);for(const o of i)await this.discard(o);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[o,l]of this.previews){this.synchronizingResources.push([o,l.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(g=>g.resource===o);for(const g of l.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&await u.merge(g.previewResource);const d=await u.apply(!1,this.syncHeaders);d&&i.push(this.toSyncResourcePreview(u.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,o]of this.previews){this.synchronizingResources.push([i,o.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(u=>u.resource===i);for(const u of o.resourcePreviews)await l.accept(u.remoteResource);await l.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,o]of this.previews){this.synchronizingResources.push([i,o.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(u=>u.resource===i);for(const u of o.resourcePreviews)await l.accept(u.localResource);await l.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(o){(0,k.isPromiseCanceledError)(o)||this.logService.error(o)}this.reset()}async performAction(i,o){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const l=this.previews.findIndex(([,C])=>C.resourcePreviews.some(({localResource:N,previewResource:z,remoteResource:M})=>(0,w.isEqual)(i,N)||(0,w.isEqual)(i,z)||(0,w.isEqual)(i,M)));if(l===-1)return this.previews;const[u,d]=this.previews[l],g=d.resourcePreviews.find(({localResource:C,remoteResource:N,previewResource:z})=>(0,w.isEqual)(C,i)||(0,w.isEqual)(N,i)||(0,w.isEqual)(z,i));if(!g)return this.previews;let T=this.synchronizingResources.find(C=>C[0]===u);T||(T=[u,[]],this.synchronizingResources.push(T)),T[1].some(C=>(0,w.isEqual)(C,g.localResource))||(T[1].push(g.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const _=this.synchronisers.find(C=>C.resource===this.previews[l][0]),O=await o(_);O?this.previews.splice(l,1,this.toSyncResourcePreview(_.resource,O)):this.previews.splice(l,1);const F=this.synchronizingResources.findIndex(C=>C[0]===u);return this.synchronizingResources[F][1].splice(T[1].findIndex(C=>(0,w.isEqual)(C,g.localResource)),1),T[1].length||(this.synchronizingResources.splice(F,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[o,l]of this.previews){this.synchronizingResources.push([o,l.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(g=>g.resource===o);let d=l;for(const g of l.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&(d=await u.merge(g.previewResource));d&&i.push(this.toSyncResourcePreview(u.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const o=[],l=await this.getUserDataSyncConfiguration();for(const u of this.synchronisers){if(i.isCancellationRequested)return[];const d=await u.preview(this.manifest,l,this.syncHeaders);d&&o.push(this.toSyncResourcePreview(u.resource,d))}return o}async getUserDataSyncConfiguration(){const i=this.configurationService.getValue(y.USER_DATA_SYNC_CONFIGURATION_SCOPE),o=await this.synchronisers.find(l=>l instanceof p.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...i,...o}}toSyncResourcePreview(i,o){return[i,{isLastSyncFromCurrentMachine:o.isLastSyncFromCurrentMachine,resourcePreviews:o.resourcePreviews.map(s)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function s(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(te[230],ne([0,1,3,2,18,7,24]),function(J,e,R,L,D,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(I,v){this.service=I,this.logService=v,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(I,v){switch(v){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${v}`)}async call(I,v,E){try{return await this._call(I,v,E)}catch(h){throw this.logService.error(h),h}}async _call(I,v,E){switch(v){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(k.URI.revive(E[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(E[0],k.URI.revive(E[1]),E[2],E[3]);case"resolveContent":return this.service.resolveContent(k.URI.revive(E[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(E[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(E[0]);case"getAssociatedResources":return this.service.getAssociatedResources(E[0],{created:E[1].created,uri:k.URI.revive(E[1].uri)});case"getMachineId":return this.service.getMachineId(E[0],{created:E[1].created,uri:k.URI.revive(E[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(v.startsWith("manualSync/")){const h=v.substring("manualSync/".length),S=E[0],f=this.getManualSyncTask(S);switch(E=E.slice(1),h){case"preview":return f.preview();case"accept":return f.accept(k.URI.revive(E[0]),E[1]);case"merge":return f.merge(k.URI.revive(E[0]));case"discard":return f.discard(k.URI.revive(E[0]));case"discardConflicts":return f.discardConflicts();case"apply":return f.apply();case"pull":return f.pull();case"push":return f.push();case"stop":return f.stop();case"_getStatus":return f.status;case"dispose":return this.disposeManualSyncTask(f)}}throw new Error("Invalid call")}getManualSyncTask(I){const v=this.manualSyncTasks.get(this.createKey(I));if(!v)throw new Error(`Manual sync taks not found: ${I}`);return v.manualSyncTask}async createManualSyncTask(){const I=new L.DisposableStore,v=I.add(await this.service.createManualSyncTask());return I.add(v.onSynchronizeResources(E=>this.onManualSynchronizeResources.fire({manualSyncTaskId:v.id,data:E}))),this.manualSyncTasks.set(this.createKey(v.id),{manualSyncTask:v,disposables:I}),{id:v.id,manifest:v.manifest,status:v.status}}disposeManualSyncTask(I){I.dispose();const v=this.createKey(I.id);this.manualSyncTasks.get(v)?.disposables.dispose(),this.manualSyncTasks.delete(v)}createKey(I){return`manualSyncTask-${I}`}}e.UserDataSyncChannel=P;class w extends L.Disposable{constructor(I){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(v,E,h){return I.call(v,E,h).then(null,S=>{throw A.UserDataSyncError.toUserDataSyncError(S)})},listen(v,E){return I.listen(v,E)}},this.channel.call("_getInitialData").then(([v,E,h])=>{this.updateStatus(v),this.updateConflicts(E),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(v=>this.updateConflicts(v))),this._register(this.channel.listen("onSyncErrors")(v=>this._onSyncErrors.fire(v.map(([E,h])=>[E,A.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:I,manifest:v,status:E}=await this.channel.call("createManualSyncTask"),h=this,S=new b(I,v,E,{async call(f,p,m){return h.channel.call(`manualSync/${f}`,[I,...(0,D.isArray)(p)?p:[p]],m)},listen(f,p){return R.Event.map(R.Event.filter(h.channel.listen(`manualSync/${f}`,p),m=>!S.isDiposed()&&m.manualSyncTaskId===I),m=>m.data)}});return S}replace(I){return this.channel.call("replace",[I])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(I,v,E,h){return this.channel.call("accept",[I,v,E,h])}resolveContent(I){return this.channel.call("resolveContent",[I])}async getLocalSyncResourceHandles(I){return(await this.channel.call("getLocalSyncResourceHandles",[I])).map(({created:E,uri:h})=>({created:E,uri:k.URI.revive(h)}))}async getRemoteSyncResourceHandles(I){return(await this.channel.call("getRemoteSyncResourceHandles",[I])).map(({created:E,uri:h})=>({created:E,uri:k.URI.revive(h)}))}async getAssociatedResources(I,v){return(await this.channel.call("getAssociatedResources",[I,v])).map(({resource:h,comparableResource:S})=>({resource:k.URI.revive(h),comparableResource:k.URI.revive(S)}))}async getMachineId(I,v){return this.channel.call("getMachineId",[I,v])}async updateStatus(I){this._status=I,this._onDidChangeStatus.fire(I)}async updateConflicts(I){this._conflicts=I.map(([v,E])=>[v,E.map(h=>({...h,localResource:k.URI.revive(h.localResource),remoteResource:k.URI.revive(h.remoteResource),previewResource:k.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(I){this._lastSyncTime!==I&&(this._lastSyncTime=I,this._onDidChangeLastSyncTime.fire(I))}}e.UserDataSyncChannelClient=w;class b extends L.Disposable{constructor(I,v,E,h){super();this.id=I,this.manifest=v,this._disposed=!1,this._status=E;const S=this;this.channel={async call(f,p,m){try{const y=await h.call(f,p,m);return S.isDiposed()||(S._status=await h.call("_getStatus")),y}catch(y){throw A.UserDataSyncError.toUserDataSyncError(y)}},listen(f,p){return h.listen(f,p)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const I=await this.channel.call("preview");return this.deserializePreviews(I)}async accept(I,v){const E=await this.channel.call("accept",[I,v]);return this.deserializePreviews(E)}async merge(I){const v=await this.channel.call("merge",[I]);return this.deserializePreviews(v)}async discard(I){const v=await this.channel.call("discard",[I]);return this.deserializePreviews(v)}async discardConflicts(){const I=await this.channel.call("discardConflicts");return this.deserializePreviews(I)}async apply(){const I=await this.channel.call("apply");return this.deserializePreviews(I)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(I){return I.map(([v,E])=>[v,{isLastSyncFromCurrentMachine:E.isLastSyncFromCurrentMachine,resourcePreviews:E.resourcePreviews.map(h=>({...h,localResource:k.URI.revive(h.localResource),remoteResource:k.URI.revive(h.remoteResource),previewResource:k.URI.revive(h.previewResource),acceptedResource:k.URI.revive(h.acceptedResource)}))}])}}}),define(te[231],ne([0,1,5,27,8,3,2,107,4,16,18,7,28,20,13,14,30,43,47,23,24]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f,p,m,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",t="sync.donot-make-requests-until",s="sync.user-session-id",r="sync.machine-session-id",i=100,o=1e3*60*5;let l=class extends A.Disposable{constructor(O,F,C){super();this.productService=O,this.configurationService=F,this.storageService=C,this._onDidChangeUserDataSyncStore=this._register(new k.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(k.Event.filter(C.onDidChangeValue,N=>N.key===c.SYNC_SERVICE_URL_TYPE&&N.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,O,0,w.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,F){O=w.isWeb&&O?.web?{...O,...O.web}:O;const C={...O||{},...F||{}};if(C&&(0,n.isString)(C.url)&&(0,n.isObject)(C.authenticationProviders)&&Object.keys(C.authenticationProviders).every(N=>(0,n.isArray)(C.authenticationProviders[N].scopes))){const N=C,z=!!N.canSwitch&&!F?.url,M=N.url===N.insidersUrl?"insiders":"stable",q=(z?this.userDataSyncStoreType:void 0)||M,W=F?.url||(q==="insiders"?N.insidersUrl:q==="stable"?N.stableUrl:N.url);return{url:I.URI.parse(W),type:q,defaultType:M,defaultUrl:I.URI.parse(N.url),stableUrl:I.URI.parse(N.stableUrl),insidersUrl:I.URI.parse(N.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(N.authenticationProviders).reduce((j,x)=>(j.push({id:x,scopes:N.authenticationProviders[x].scopes}),j),[])}}}};l=he([X(0,f.IProductService),X(1,E.IConfigurationService),X(2,y.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let u=class extends l{constructor(O,F,C){super(O,F,C);const N=this.storageService.get(a,0);N&&(this.previousConfigurationSyncStore=JSON.parse(N));const z=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];z?this.storageService.store(a,JSON.stringify(z),0,1):this.storageService.remove(a,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=he([X(0,f.IProductService),X(1,E.IConfigurationService),X(2,y.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let d=class extends A.Disposable{constructor(O,F,C,N,z,M,q){super();this.requestService=C,this.logService=N,this.storageService=q,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new k.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new k.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,m.getServiceMachineId)(z,M,q).then(W=>{const j={"X-Client-Name":`${F.applicationName}${w.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(j["X-Client-Commit"]=F.commit),j}),this.session=new T(i,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,F){this.authToken={token:O,type:F}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,b.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(F=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O),C={},N=await this.request(F.toString(),{type:"GET",headers:C},[],L.CancellationToken.None);return(await(0,p.asJson)(N)||[]).map(({url:M,created:q})=>({ref:(0,b.relativePath)(F,F.with({path:M})),created:q*1e3}))}async resolveContent(O,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const C=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,F).toString(),N={};N["Cache-Control"]="no-cache";const z=await this.request(C,{type:"GET",headers:N},[],L.CancellationToken.None);return await(0,p.asText)(z)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),C={};await this.request(F,{type:"DELETE",headers:C},[],L.CancellationToken.None)}async read(O,F,C={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();C={...C},C["Cache-Control"]="no-cache",F&&(C["If-None-Match"]=F.ref);const z=await this.request(N,{type:"GET",headers:C},[304],L.CancellationToken.None);let M=null;if(z.res.statusCode===304&&(M=F),M===null){const q=z.res.headers.etag;if(!q)throw new c.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",z.res.statusCode,z.res.headers[c.HEADER_OPERATION_ID]);const W=await(0,p.asText)(z);if(!W&&z.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",N,"EmptyResponse",z.res.statusCode,z.res.headers[c.HEADER_OPERATION_ID]);M={ref:q,content:W}}return M}async write(O,F,C,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();N={...N},N["Content-Type"]=P.Mimes.text,C&&(N["If-Match"]=C);const M=await this.request(z,{type:"POST",data:F,headers:N},[],L.CancellationToken.None),q=M.res.headers.etag;if(!q)throw new c.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",M.res.statusCode,M.res.headers[c.HEADER_OPERATION_ID]);return q}async manifest(O,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const C=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",O&&(F["If-None-Match"]=O.ref);const N=await this.request(C,{type:"GET",headers:F},[304],L.CancellationToken.None);let z=null;if(N.res.statusCode===304&&(z=O),!z){const q=N.res.headers.etag;if(!q)throw new c.UserDataSyncStoreError("Server did not return the ref",C,"NoRef",N.res.statusCode,N.res.headers[c.HEADER_OPERATION_ID]);const W=await(0,p.asText)(N);if(!W&&N.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",C,"EmptyResponse",N.res.statusCode,N.res.headers[c.HEADER_OPERATION_ID]);W&&(z={...JSON.parse(W),ref:q})}const M=this.storageService.get(s,0);return M&&z&&M!==z.session&&this.clearSession(),z===null&&M&&this.clearSession(),z&&this.storageService.store(s,z.session,0,1),z}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":P.Mimes.text};await this.request(O,{type:"DELETE",headers:F},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(r,0)}async request(O,F,C,N){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const z=await this.commonHeadersPromise;F.headers={...F.headers||{},...z,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:O,type:F.type,headers:{...F.headers,authorization:void 0}});let M;try{M=await this.session.request(O,F,N)}catch(x){if(!(x instanceof c.UserDataSyncStoreError)){let $="RequestFailed";const G=(0,D.getErrorMessage)(x).toLowerCase();G.includes("xhr timeout")?$="RequestTimeout":G.includes("protocol")&&G.includes("not supported")?$="RequestProtocolNotSupported":G.includes("request path contains unescaped characters")?$="RequestPathNotEscaped":G.includes("headers must be an object")?$="RequestHeadersNotObject":(0,D.isPromiseCanceledError)(x)&&($="RequestCanceled"),x=new c.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,$,void 0,void 0)}throw this.logService.info("Request failed",O),x}const q=M.res.headers[c.HEADER_OPERATION_ID],W={url:O,status:M.res.statusCode,"execution-id":F.headers[c.HEADER_EXECUTION_ID],"operation-id":q},j=(0,p.isSuccess)(M)||M.res.statusCode&&C.indexOf(M.res.statusCode)!==-1;if(j?this.logService.trace("Request succeeded",W):this.logService.info("Request failed",W),M.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",M.res.statusCode,q);if(this._onTokenSucceed.fire(),M.res.statusCode===409)throw new c.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",M.res.statusCode,q);if(M.res.statusCode===410)throw new c.UserDataSyncStoreError(`${F.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",M.res.statusCode,q);if(M.res.statusCode===412)throw new c.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",M.res.statusCode,q);if(M.res.statusCode===413)throw new c.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",M.res.statusCode,q);if(M.res.statusCode===426)throw new c.UserDataSyncStoreError(`${F.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",M.res.statusCode,q);if(M.res.statusCode===429){const x=M.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new c.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",M.res.statusCode,q)):new c.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",M.res.statusCode,q)}if(!j)throw new c.UserDataSyncStoreError("Server returned "+M.res.statusCode,O,"Unknown",M.res.statusCode,q);return M}addSessionHeaders(O){let F=this.storageService.get(r,0);F===void 0&&(F=(0,v.generateUuid)(),this.storageService.store(r,F,0,1)),O["X-Machine-Session-Id"]=F;const C=this.storageService.get(s,0);C!==void 0&&(O["X-User-Session-Id"]=C)}};d=he([X(1,f.IProductService),X(2,p.IRequestService),X(3,c.IUserDataSyncLogService),X(4,h.IEnvironmentService),X(5,S.IFileService),X(6,y.IStorageService)],d),e.UserDataSyncStoreClient=d;let g=class extends d{constructor(O,F,C,N,z,M,q){super(O.userDataSyncStore?.url,F,C,N,z,M,q);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};g=he([X(0,c.IUserDataSyncStoreManagementService),X(1,f.IProductService),X(2,p.IRequestService),X(3,c.IUserDataSyncLogService),X(4,h.IEnvironmentService),X(5,S.IFileService),X(6,y.IStorageService)],g),e.UserDataSyncStoreService=g;class T{constructor(O,F,C,N){this.limit=O,this.interval=F,this.requestService=C,this.logService=N,this.requests=[],this.startTime=void 0}request(O,F,C){if(this.isExpired()&&this.reset(),F.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(F,C)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=T}),define(te[232],ne([0,1,3,60,30,23,21,98,24,63,64]),function(J,e,R,L,D,k,A,P,w,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let I=class extends P.UserDataAutoSyncService{constructor(E,h,S,f,p,m,y,c,a,t,s,r){super(E,h,S,f,p,y,c,a,t,s,r);this._register(R.Event.debounce(R.Event.any(R.Event.map(m.onDidFocusWindow,()=>"windowFocus"),R.Event.map(m.onDidOpenWindow,()=>"windowOpen")),(i,o)=>i?[...i,o]:[o],1e3)(i=>this.triggerSync(i,!0,!1)))}};I=he([X(0,D.IProductService),X(1,w.IUserDataSyncStoreManagementService),X(2,w.IUserDataSyncStoreService),X(3,w.IUserDataSyncResourceEnablementService),X(4,w.IUserDataSyncService),X(5,L.INativeHostService),X(6,w.IUserDataSyncLogService),X(7,b.IUserDataSyncAccountService),X(8,A.ITelemetryService),X(9,n.IUserDataSyncMachinesService),X(10,k.IStorageService),X(11,w.IUserDataAutoSyncEnablementService)],I),e.UserDataAutoSyncService=I}),define(te[233],ne([0,1,5,3,2]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends D.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:w,getActiveWindowId:b}){super();this.disposables=this._register(new D.DisposableStore),L.Event.latch(L.Event.any(P,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>b()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(te[65],ne([0,1,53,5,9,18,19,124,245,246]),function(J,e,R,L,D,k,A,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,s){let r=s.message;switch(t){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=t,this.cause=s}}e.ExtractError=n;function I(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,r)=>s+r,t&61440)}function v(a){if(a instanceof n)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new n(t,a)}function E(a,t,s,r,i,o){const l=D.dirname(t),u=D.join(r,l);if(!u.startsWith(r))return Promise.reject(new Error(P.localize(0,null,t)));const d=D.join(r,t);let g;return o.onCancellationRequested(()=>{g&&g.destroy()}),Promise.resolve(A.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((T,_)=>{if(!o.isCancellationRequested)try{g=(0,R.createWriteStream)(d,{mode:s}),g.once("close",()=>T()),g.once("error",_),a.once("error",_),a.pipe(g)}catch(O){_(O)}}))}function h(a,t,s,r){let i=(0,L.createCancelablePromise)(()=>Promise.resolve()),o=0;return r.onCancellationRequested(()=>{i.cancel(),a.close()}),new Promise((l,u)=>{const d=new L.Sequencer,g=T=>{T.isCancellationRequested||(o++,a.readEntry())};a.once("error",u),a.once("close",()=>i.then(()=>{r.isCancellationRequested||a.entryCount===o?l():u(new n("Incomplete",new Error(P.localize(1,null,o,a.entryCount))))},u)),a.readEntry(),a.on("entry",T=>{if(r.isCancellationRequested)return;if(!s.sourcePathRegex.test(T.fileName)){g(r);return}const _=T.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(_)){const C=D.join(t,_);i=(0,L.createCancelablePromise)(N=>A.Promises.mkdir(C,{recursive:!0}).then(()=>g(N)).then(void 0,u));return}const O=f(a,T),F=I(T);i=(0,L.createCancelablePromise)(C=>d.queue(()=>O.then(N=>E(N,_,F,t,s,C).then(()=>g(C)))).then(null,u))})})}function S(a,t=!1){return new Promise((s,r)=>{(0,w.open)(a,t?{lazyEntries:!0}:void 0,(i,o)=>{i?r(v(i)):s((0,k.assertIsDefined)(o))})})}function f(a,t){return new Promise((s,r)=>{a.openReadStream(t,(i,o)=>{i?r(v(i)):s((0,k.assertIsDefined)(o))})})}function p(a,t){return new Promise((s,r)=>{const i=new b.ZipFile;t.forEach(l=>{l.contents?i.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&i.addFile(l.localPath,l.path)}),i.end();const o=(0,R.createWriteStream)(a);i.outputStream.pipe(o),i.outputStream.once("error",r),o.once("error",r),o.once("finish",()=>s(a))})}e.zip=p;function m(a,t,s={},r){const i=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let o=S(a,!0);return s.overwrite&&(o=o.then(l=>A.Promises.rm(t).then(()=>l))),o.then(l=>h(l,t,{sourcePathRegex:i},r))}e.extract=m;function y(a,t){return S(a).then(s=>new Promise((r,i)=>{s.on("entry",o=>{o.fileName===t&&f(s,o).then(l=>r(l),l=>i(l))}),s.once("close",()=>i(new Error(P.localize(2,null,t))))}))}function c(a,t){return y(a,t).then(s=>new Promise((r,i)=>{const o=[];s.once("error",i),s.on("data",l=>o.push(l)),s.on("end",()=>r(Buffer.concat(o)))}))}e.buffer=c}),define(te[234],ne([0,1,65,133]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(k){return(0,R.buffer)(k,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(P){throw new Error((0,L.localize)(0,null))}})}e.getManifest=D}),define(te[235],ne([0,1,17,5,8,2,15,9,4,16,61,7,28,19,65,134,13,29,35,153,14,10,30]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f,p,m,y,c,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const s="scanningSystem",r="scanningUser",i="extracting",o="deleting",l="renaming";let u=class extends k.Disposable{constructor(g,T,_,O,F){super();this.beforeRemovingExtension=g,this.fileService=T,this.logService=_,this.environmentService=O,this.productService=F,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(g){const T=[];(g===null||g===0)&&T.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(_).message,s)))),(g===null||g===1)&&T.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(_).message,r))));try{const _=await Promise.all(T);return(0,R.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(g){this.logService.trace("Started scanning user extensions");let[T,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter(O=>!T[new m.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),g&&(_=(0,m.groupByExtension)(_,F=>F.identifier).map(F=>F.sort((C,N)=>n.rcompare(C.manifest.version,N.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(g,T,_,O){const F=g.key(),C=P.join(this.extensionsPath,`.${(0,v.generateUuid)()}`),N=P.join(this.extensionsPath,F);try{await E.Promises.rm(N)}catch(M){try{await E.Promises.rm(N)}catch(q){}throw new p.ExtensionManagementError((0,S.localize)(0,null,N,g.id),o)}await this.extractAtLocation(g,T,C,O);let z=await this.scanExtension(I.URI.file(C),1);if(!z)throw new Error((0,S.localize)(1,null,C));await this.storeMetadata(z,{..._,installedTimestamp:Date.now()});try{await this.rename(g,C,N,Date.now()+2*60*1e3),this.logService.info("Renamed to",N)}catch(M){try{await E.Promises.rm(C)}catch(q){}if(M.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",g.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(M)}. Deleted from extracted location`,C),M}try{z=await this.scanExtension(I.URI.file(N),1)}catch(M){}if(z)return z;throw new Error((0,S.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(g,T){return this.setMetadata(g,T),await this.storeMetadata(g,{...T,installedTimestamp:g.installedTimestamp}),g}async storeMetadata(g,T){T.isMachineScoped=T.isMachineScoped||void 0,T.isBuiltin=T.isBuiltin||void 0,T.installedTimestamp=T.installedTimestamp||void 0;const _=P.join(g.location.fsPath,"package.json"),O=await E.Promises.readFile(_,"utf8"),{manifest:F}=await this.parseManifest(O);return F.__metadata=T,await E.Promises.writeFile(_,JSON.stringify(F,null,"	")),g}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...g){const T=g.map(_=>new m.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version));await this.withUninstalledExtensions(_=>{T.forEach(O=>_[O.key()]=!0)})}async setInstalled(g){await this.withUninstalledExtensions(O=>delete O[g.key()]);const _=(await this.scanExtensions(1)).find(O=>new m.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(g))||null;return _?(await this.storeMetadata(_,{installedTimestamp:Date.now()}),this.scanExtension(_.location,1)):null}async withUninstalledExtensions(g){return this.uninstalledFileLimiter.queue(async()=>{let T;try{T=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let _={};if(T)try{_=JSON.parse(T)}catch(O){}return g&&(g(_),Object.keys(_).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(_)):await E.Promises.rm(this.uninstalledPath)),_})}async removeExtension(g,T){this.logService.trace(`Deleting ${T} extension from disk`,g.identifier.id,g.location.fsPath),await E.Promises.rm(g.location.fsPath),this.logService.info("Deleted from disk",g.identifier.id,g.location.fsPath)}async removeUninstalledExtension(g){await this.removeExtension(g,"uninstalled"),await this.withUninstalledExtensions(T=>delete T[new m.ExtensionIdentifierWithVersion(g.identifier,g.manifest.version).key()])}async extractAtLocation(g,T,_,O){this.logService.trace(`Started extracting the extension from ${T} to ${_}`);try{await E.Promises.rm(_)}catch(F){throw new p.ExtensionManagementError(this.joinErrors(F).message,o)}try{await(0,h.extract)(T,_,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${_}:`,g.id)}catch(F){try{await E.Promises.rm(_)}catch(C){}throw new p.ExtensionManagementError(F.message,F instanceof h.ExtractError&&F.type?F.type:i)}}async rename(g,T,_,O){try{await E.Promises.rename(T,_)}catch(F){if(w.isWindows&&F&&F.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${T} to ${_} with 'EPERM' error. Trying again...`,g.id),this.rename(g,T,_,O);throw new p.ExtensionManagementError(F.message||(0,S.localize)(3,null,T,_),F.code||l)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const g=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return g;const T=this.scanDevSystemExtensions(),[_,O]=await Promise.all([g,T]);return[..._,...O]}async scanExtensionsInDir(g,T){const _=new L.Limiter(10),O=await this.fileService.resolve(I.URI.file(g));return O.children?(await Promise.all(O.children.filter(C=>C.isDirectory).map(C=>_.queue(async()=>T===1&&(0,b.basename)(C.resource).indexOf(".")===0?null:this.scanExtension(C.resource,T))))).filter(C=>C&&C.identifier):[]}async scanExtension(g,T){try{const _=await this.fileService.resolve(g);if(_.children){const{manifest:O,metadata:F}=await this.readManifest(g.fsPath),C=_.children.find(({name:q})=>/^readme(\.txt|\.md|)$/i.test(q))?.resource,N=_.children.find(({name:q})=>/^changelog(\.txt|\.md|)$/i.test(q))?.resource,z={id:(0,m.getGalleryExtensionId)(O.publisher,O.name)},M={type:T,identifier:z,manifest:O,location:g,readmeUrl:C,changelogUrl:N,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:T===0};return F&&(this.setMetadata(M,F),M.installedTimestamp=F.installedTimestamp),M}}catch(_){T!==0&&this.logService.trace(_)}return null}async scanDefaultSystemExtensions(){const g=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",g.length),g}async scanDevSystemExtensions(){const g=this.getDevSystemExtensionsList();if(g.length){const T=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",T.length),T.filter(_=>g.some(O=>(0,m.areSameExtensions)(_.identifier,{id:O})))}else return[]}setMetadata(g,T){g.publisherDisplayName=T.publisherDisplayName||null,g.publisherId=T.publisherId||null,g.identifier.uuid=T.id,g.isMachineScoped=!!T.isMachineScoped,g.isBuiltin=g.type===0||!!T.isBuiltin}async removeUninstalledExtensions(){const g=await this.getUninstalledExtensions(),T=await this.scanAllUserExtensions(),_=new Set;for(const C of T)g[new m.ExtensionIdentifierWithVersion(C.identifier,C.manifest.version).key()]||_.add(C.identifier.id.toLowerCase());const O=(0,m.groupByExtension)(T,C=>C.identifier);await L.Promises.settled(O.map(async C=>{const N=C.sort((z,M)=>n.rcompare(z.manifest.version,M.manifest.version))[0];_.has(N.identifier.id.toLowerCase())||await this.beforeRemovingExtension(N)}));const F=T.filter(C=>g[new m.ExtensionIdentifierWithVersion(C.identifier,C.manifest.version).key()]);await L.Promises.settled(F.map(C=>this.removeUninstalledExtension(C)))}async removeOutdatedExtensions(){const g=await this.scanAllUserExtensions(),T=[],_=(0,m.groupByExtension)(g,O=>O.identifier);T.push(...(0,R.flatten)(_.map(O=>O.sort((F,C)=>n.rcompare(F.manifest.version,C.manifest.version)).slice(1)))),await L.Promises.settled(T.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(g=>g.name)}joinErrors(g){const T=Array.isArray(g)?g:[g];return T.length===1?T[0]instanceof Error?T[0]:new Error(T[0]):T.reduce((_,O)=>new Error(`${_.message}${_.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(A.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(g){const T=[E.Promises.readFile(P.join(g,"package.json"),"utf8").then(C=>this.parseManifest(C)),E.Promises.readFile(P.join(g,"package.nls.json"),"utf8").then(void 0,C=>C.code!=="ENOENT"?Promise.reject(C):"{}").then(C=>JSON.parse(C))],[{manifest:_,metadata:O},F]=await Promise.all(T);return{manifest:(0,y.localizeManifest)(_,F),metadata:O}}parseManifest(g){return new Promise((T,_)=>{try{const O=JSON.parse(g),F=O.__metadata||null;T({manifest:O,metadata:F})}catch(O){_(new Error((0,S.localize)(4,null)))}})}};u=he([X(1,c.IFileService),X(2,a.ILogService),X(3,f.INativeEnvironmentService),X(4,t.IProductService)],u),e.ExtensionsScanner=u}),define(te[236],ne([0,1,37,8,15,9,4,31,16,61,7,28,19,65,132,79,13,202,29,35,185,173,234,186,235,187,76,14,6,10,42,21]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f,p,m,y,c,a,t,s,r,i,o,l,u,d,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const _="unsetUninstalled",O="downloading";let F=class extends p.AbstractExtensionManagementService{constructor(W,j,x,$,G,U,V){super(W,j,x);this.environmentService=$,this.downloadService=G,this.fileService=V;const B=this._register(U.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(U.createInstance(r.ExtensionsScanner,Z=>B.postUninstall(Z))),this.manifestCache=this._register(new s.ExtensionsManifestCache($,this)),this.extensionsDownloader=this._register(U.createInstance(c.ExtensionsDownloader));const Q=this._register(new i.ExtensionsWatcher(this,V,$,x));this._register(Q.onDidChangeExtensionsByAnotherSource(({added:Z,removed:K})=>{Z.length&&this._onDidInstallExtensions.fire(Z.map(H=>({identifier:H.identifier,operation:0,local:H}))),K.forEach(H=>this._onDidUninstallExtension.fire({identifier:H}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const W=await this.isAlpineLinux(),j=(0,m.getTargetPlatform)(W?"alpine":A.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",j),j})()),this._targetPlatformPromise}async isAlpineLinux(){if(!A.isLinux)return!1;let W;try{W=(await this.fileService.readFile(n.URI.file("/etc/os-release"))).value.toString()}catch(j){try{W=(await this.fileService.readFile(n.URI.file("/usr/lib/os-release"))).value.toString()}catch(x){this.logService.debug("Error while getting the os-release file.",(0,L.getErrorMessage)(x))}}return!!W&&(W.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const j=await this.collectFiles(W),x=await(0,E.zip)((0,w.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)()).fsPath,j);return n.URI.file(x)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const j=await this.downloadVsix(W),x=k.resolve(j.fsPath);return(0,t.getManifest)(x)}getInstalled(W=null){return this.extensionsScanner.scanExtensions(W)}async install(W,j={}){this.logService.trace("ExtensionManagementService#install",W.toString());const x=await this.downloadVsix(W),$=await(0,t.getManifest)(k.resolve(x.fsPath));if($.engines&&$.engines.vscode&&!(0,o.isEngineValid)($.engines.vscode,g.default.version,g.default.date))throw new Error(h.localize(0,null,(0,y.getGalleryExtensionId)($.publisher,$.name),g.default.version));return this.installExtension($,x,j)}async updateMetadata(W,j){return this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},...j}),this.manifestCache.invalidate(),W}async updateExtensionScope(W,j){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},isMachineScoped:j}),this.manifestCache.invalidate(),W}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(W){if(W.scheme===D.Schemas.file)return W;const j=(0,w.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)());return await this.downloadService.download(W,j),j}createInstallExtensionTask(W,j,x){return n.URI.isUri(j)?new z(W,j,x,this.galleryService,this.extensionsScanner,this.logService):new N(j,x,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(W,j){return new M(W,j,this.extensionsScanner)}async collectFiles(W){const j=async $=>{let G=await v.Promises.readdir($);G=G.map(B=>k.join($,B));const U=await Promise.all(G.map(B=>v.Promises.stat(B)));let V=Promise.resolve([]);return U.forEach((B,Q)=>{const Z=G[Q];B.isFile()&&(V=V.then(K=>[...K,Z])),B.isDirectory()&&(V=V.then(K=>j(Z).then(H=>[...K,...H])))}),V};return(await j(W.location.fsPath)).map($=>({path:`extension/${k.relative(W.location.fsPath,$)}`,localPath:$}))}};F=he([X(0,m.IExtensionGalleryService),X(1,T.ITelemetryService),X(2,d.ILogService),X(3,f.INativeEnvironmentService),X(4,S.IDownloadService),X(5,u.IInstantiationService),X(6,l.IFileService)],F),e.ExtensionManagementService=F;class C extends p.AbstractExtensionTask{constructor(W,j,x,$){super();this.identifier=W,this.source=j,this.extensionsScanner=x,this.logService=$,this._operation=1}get operation(){return this._operation}async installExtension(W,j){try{const x=await this.unsetUninstalledAndGetLocal(W.identifierWithVersion);if(x)return W.metadata?this.extensionsScanner.saveMetadataForLocalExtension(x,W.metadata):x}catch(x){throw A.isMacintosh?new m.ExtensionManagementError(h.localize(1,null),_):new m.ExtensionManagementError(h.localize(2,null),_)}return this.extract(W,j)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const x=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),x}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.key()]}async extract({zipPath:W,identifierWithVersion:j,metadata:x},$){let G=await this.extensionsScanner.extractUserExtension(j,W,x,$);return this.logService.info("Extracting completed.",j.id),G}}class N extends C{constructor(W,j,x,$,G){super(W.identifier,W,$,G);this.gallery=W,this.options=j,this.extensionsDownloader=x}async doRun(W){const x=(await this.extensionsScanner.scanExtensions(null)).find(G=>(0,y.areSameExtensions)(G.identifier,this.gallery.identifier));x&&(this._operation=2);const $=await this.downloadInstallableExtension(this.gallery,this._operation);$.metadata.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,$.metadata.isBuiltin=this.options.isBuiltin||x?.isBuiltin;try{const G=await this.installExtension($,W);return x&&b.neq(x.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(x),G}catch(G){throw await this.deleteDownloadedVSIX($.zipPath),G}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(n.URI.file(W))}catch(j){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,L.getErrorMessage)(j))}}async downloadInstallableExtension(W,j){const x={id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName};let $;try{this.logService.trace("Started downloading extension:",W.identifier.id),$=(await this.extensionsDownloader.downloadExtension(W,j)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,$)}catch(G){throw new m.ExtensionManagementError((0,p.joinErrors)(G).message,O)}try{const G=await(0,t.getManifest)($);return{zipPath:$,identifierWithVersion:new y.ExtensionIdentifierWithVersion(W.identifier,G.version),metadata:x}}catch(G){throw await this.deleteDownloadedVSIX($),new m.ExtensionManagementError((0,p.joinErrors)(G).message,p.INSTALL_ERROR_VALIDATING)}}}class z extends C{constructor(W,j,x,$,G,U){super({id:(0,y.getGalleryExtensionId)(W.publisher,W.name)},j,G,U);this.manifest=W,this.location=j,this.options=x,this.galleryService=$}async doRun(W){const j=new y.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),$=(await this.extensionsScanner.scanExtensions(1)).find(U=>(0,y.areSameExtensions)(this.identifier,U.identifier)),G=await this.getMetadata(this.identifier.id,W);if(G.isMachineScoped=this.options.isMachineScoped||$?.isMachineScoped,G.isBuiltin=this.options.isBuiltin||$?.isBuiltin,$)if(this._operation=2,j.equals(new y.ExtensionIdentifierWithVersion($.identifier,$.manifest.version)))try{await this.extensionsScanner.removeExtension($,"existing")}catch(U){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else b.gt($.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled($);else{const U=await this.unsetUninstalledAndGetLocal(j);if(U)try{await this.extensionsScanner.removeExtension(U,"existing")}catch(V){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:k.resolve(this.location.fsPath),identifierWithVersion:j,metadata:G},W)}async getMetadata(W,j){try{const x=(await this.galleryService.query({names:[W],pageSize:1},j)).firstPage[0];if(x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId}}catch(x){}return{}}}class M extends p.AbstractExtensionTask{constructor(W,j,x){super();this.extension=W,this.options=j,this.extensionsScanner=x}async doRun(W){const j=[],x=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const $=new y.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);j.push(...x.filter(G=>$.equals(new y.ExtensionIdentifierWithVersion(G.identifier,G.manifest.version))))}else j.push(...x.filter($=>(0,y.areSameExtensions)($.identifier,this.extension.identifier)));if(!j.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...j),this.options.remove)for(const $ of j)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension($)}catch(G){throw new Error(h.localize(6,null,(0,R.toErrorMessage)(G)))}}}}),define(te[237],ne([0,1,82,57,33,22,8,3,2,9,4,28,32,71,247]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class S{constructor(u){this.socket=u,this._errorListener=d=>{if(d){if(d.code==="EPIPE")return;(0,A.onUnexpectedError)(d)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const d=g=>u(k.VSBuffer.wrap(g));return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(u){const d=g=>{u({type:0,hadError:g,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,A.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,A.onUnexpectedError)(d)}}end(){this.socket.end()}drain(){return new Promise((u,d)=>{if(this.socket.bufferSize===0){u();return}const g=()=>{this.socket.off("close",g),this.socket.off("end",g),this.socket.off("error",g),this.socket.off("timeout",g),this.socket.off("drain",g),u()};this.socket.on("close",g),this.socket.on("end",g),this.socket.on("error",g),this.socket.on("timeout",g),this.socket.on("drain",g)})}}e.NodeSocket=S;var f;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var p;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(p||(p={}));class m extends w.Disposable{constructor(u,d,g,T){super();this._onDidZlibFlush=this._register(new P.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=d,this._recordInflateBytes=T,d?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",_=>{console.error(_),(0,A.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibInflate.on("data",_=>{this._pendingInflateData.push(_)}),g&&(this._zlibInflate.write(g.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{console.error(_),(0,A.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibDeflate.on("data",_=>{this._pendingDeflateData.push(_)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new E.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let d=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,d=d.slice(0,d.length-4),this._isEnded||this._write(k.VSBuffer.wrap(d),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,d){let g=2;u.byteLength<126?g+=0:u.byteLength<2**16?g+=2:g+=8;const T=k.VSBuffer.alloc(g);if(d?T.writeUInt8(194,0):T.writeUInt8(130,0),u.byteLength<126)T.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){T.writeUInt8(126,1);let _=1;T.writeUInt8(u.byteLength>>>8&255,++_),T.writeUInt8(u.byteLength>>>0&255,++_)}else{T.writeUInt8(127,1);let _=1;T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(u.byteLength>>>24&255,++_),T.writeUInt8(u.byteLength>>>16&255,++_),T.writeUInt8(u.byteLength>>>8&255,++_),T.writeUInt8(u.byteLength>>>0&255,++_)}this._totalOutgoingWireBytes+=T.byteLength+u.byteLength,this.socket.write(k.VSBuffer.concat([T,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const d=this._incomingData.peek(this._state.readLen),g=d.readUInt8(0),T=(g&128)>>>7,_=(g&64)>>>6,O=d.readUInt8(1),F=(O&128)>>>7,C=O&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(C===126?2:0)+(C===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0}else if(this._state.state===2){const d=this._incomingData.read(this._state.readLen),g=d.readUInt8(1),T=(g&128)>>>7;let _=g&127,O=1;_===126?_=d.readUInt8(++O)*2**8+d.readUInt8(++O):_===127&&(_=d.readUInt8(++O)*0+d.readUInt8(++O)*0+d.readUInt8(++O)*0+d.readUInt8(++O)*0+d.readUInt8(++O)*2**24+d.readUInt8(++O)*2**16+d.readUInt8(++O)*2**8+d.readUInt8(++O));let F=0;T&&(F=d.readUInt8(++O)*2**24+d.readUInt8(++O)*2**16+d.readUInt8(++O)*2**8+d.readUInt8(++O)),this._state.state=3,this._state.readLen=_,this._state.mask=F}else if(this._state.state===3){const d=this._incomingData.read(this._state.readLen);y(d,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(d.buffer)),this._zlibInflate.write(d.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const g=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=g.length,this._onData.fire(k.VSBuffer.wrap(g))})):(this._totalIncomingDataBytes+=d.byteLength,this._onData.fire(d))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await P.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=m;function y(l,u){if(u===0)return;let d=l.byteLength>>>2;for(let C=0;C<d;C++){const N=l.readUInt32BE(C*4);l.writeUInt32BE(N^u,C*4)}let g=d*4,T=l.byteLength-g;const _=u>>>24&255,O=u>>>16&255,F=u>>>8&255;T>=1&&l.writeUInt8(l.readUInt8(g)^_,g),T>=2&&l.writeUInt8(l.readUInt8(g+1)^O,g+1),T>=3&&l.writeUInt8(l.readUInt8(g+2)^F,g+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function a(){const l=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):u=(0,b.join)((0,D.tmpdir)(),`vscode-ipc-${l}.sock`),s(u),u}e.createRandomIPCHandle=a;function t(l,u,d){const g=(0,R.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${g}-${d}-${u}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${g.substr(0,8)}-${d}-${u}.sock`):T=(0,b.join)(l,`${d}-${u}.sock`),s(T),T}e.createStaticIPCHandle=t;function s(l){const u=c[n.platform];typeof u=="number"&&l.length>=u&&console.warn(`WARNING: IPC handle "${l}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends v.IPCServer{constructor(u){super(r.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const d=P.Event.fromNodeEventEmitter(u,"connection");return P.Event.map(d,g=>({protocol:new E.Protocol(new S(g)),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(g,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function i(l){return new Promise((u,d)=>{const g=(0,L.createServer)();g.on("error",d),g.listen(l,()=>{g.removeListener("error",d),u(new r(g))})})}e.serve=i;function o(l,u){return new Promise((d,g)=>{const T=(0,L.createConnection)(l,()=>{T.removeListener("error",g),d(E.Client.fromSocket(new S(T),u))});T.once("error",g)})}e.connect=o}),define(te[238],ne([0,1,57,237]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,k,A,P){const w=n=>P(n,void 0),b=R.createConnection({host:D,port:k},()=>{b.removeListener("error",w);const n=Buffer.alloc(16);for(let h=0;h<16;h++)n[h]=Math.round(Math.random()*256);const I=n.toString("base64");let v=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${k}/?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];b.write(v.join(`\r
`)+`\r
\r
`);const E=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",E),P(void 0,new L.NodeSocket(b)))};b.on("data",E)});b.once("error",w)}}}),define(te[239],ne([0,1,57,114,238,5,2,20,10,30,183,62,90]),function(J,e,R,L,D,k,A,P,w,b,n,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function E(p,m,y,c,a){return new h(p,m,y,c,a).waitForReady()}class h extends A.Disposable{constructor(m,y,c,a,t){super();this.defaultTunnelHost=y,this.suggestedLocalPort=t,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=m,this._server=R.createServer(),this._barrier=new k.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=a,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(y=>{y()})}async waitForReady(){let m=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),y=null;return this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),y=this._server.address(),y||(m=0,this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),y=this._server.address()),this.tunnelLocalPort=y.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${y.port}`,this}async _onConnection(m){m.pause();const y=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,n.connectRemoteAgentTunnel)(this._options,y,this.tunnelRemotePort),a=c.getSocket().socket,t=c.readEntireBuffer();c.dispose(),t.byteLength>0&&m.write(t.buffer),m.on("end",()=>{this._socketsDispose.delete(m.localAddress),a.end()}),m.on("close",()=>a.end()),m.on("error",()=>{this._socketsDispose.delete(m.localAddress),a.destroy()}),a.on("end",()=>m.end()),a.on("close",()=>m.end()),a.on("error",()=>{m.destroy()}),m.pipe(a),a.pipe(m),this._socketsDispose.set(m.localAddress,()=>{m.end(),a.end()})}}let S=class extends I.AbstractTunnelService{constructor(m,y,c,a,t){super(y);this.socketFactory=m,this.signService=c,this.productService=a,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(m,y,c,a,t,s,r){const i=this.getTunnelFromMap(y,c);if(i)return++i.refcount,i.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,y,c,a,t,s,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${y}:${c} on local port ${a}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:m,signService:this.signService,logService:this.logService,ipcLogger:null},l=E(o,this.defaultTunnelHost,y,c,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(y,c,l),l}}};S=he([X(1,w.ILogService),X(2,v.ISignService),X(3,b.IProductService),X(4,P.IConfigurationService)],S),e.BaseTunnelService=S;let f=class extends S{constructor(m,y,c,a){super(D.nodeSocketFactory,m,y,c,a)}};f=he([X(0,w.ILogService),X(1,v.ISignService),X(2,b.IProductService),X(3,P.IConfigurationService)],f),e.TunnelService=f}),define(te[248],ne([0,1,72,33,37,8,2,15,16,7,32,118,179,158,180,170,171,172,156,160,20,181,78,201,79,192,13,151,197,204,29,159,203,236,80,154,14,176,178,54,6,167,83,168,169,59,188,10,84,60,42,30,191,43,23,199,200,21,91,92,93,48,205,206,94,208,214,96,97,98,24,63,225,226,227,64,228,229,230,231,232,233,81,174,90,196,62,239,189,190,89,195]),function(J,e,R,L,D,k,A,P,w,b,n,I,v,E,h,S,f,p,m,y,c,a,t,s,r,i,o,l,u,d,g,T,_,O,F,C,N,z,M,q,W,j,x,$,G,U,V,B,Q,Z,K,H,re,ie,ce,le,de,fe,be,Ce,Ee,Ae,Pe,Le,Ne,Fe,$e,xe,ee,ae,oe,pe,Se,_e,Re,Y,se,ue,ge,me,Ie,ke,Te,ye,we,De,Oe,Ue,Qe,Ke,We,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class wt extends A.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new I.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Me="vscode:electron-main->shared-process=disposeWorker",ze=(Ye,qe)=>this.onDisposeWorker(qe);R.ipcRenderer.on(Me,ze),this._register((0,A.toDisposable)(()=>R.ipcRenderer.removeListener(Me,ze)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,oe.registerConfiguration)(),ve.invokeFunction(Me=>{const ze=Me.get(B.ILogService);ze.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler(ze)}),this._register((0,A.combinedDisposable)(ve.createInstance(v.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(h.LanguagePackCachedDataCleaner),ve.createInstance(p.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(f.LogsDataCleaner),ve.createInstance(S.LocalizationsUpdater),ve.createInstance(E.DeprecatedExtensionsCleaner)))}async initServices(){const ve=new x.ServiceCollection,Me={_serviceBrand:void 0,...K.default};ve.set(H.IProductService,Me);const ze=new n.StaticRouter(je=>je==="main"),Ye=new $.MessagePortMainProcessService(this.server,ze);ve.set(G.IMainProcessService,Ye);const qe=new l.NativeEnvironmentService(this.configuration.args,Me);ve.set(o.INativeEnvironmentService,qe);const rt=new Q.LogLevelChannelClient(this.server.getChannel("logLevel",ze)),Ze=new Q.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Ye.getChannel("logger"));ve.set(B.ILoggerService,Ze);const at=this._register(new B.MultiplexLogService([this._register(new B.ConsoleLogger(this.configuration.logLevel)),this._register(Ze.createLogger((0,w.joinPath)(b.URI.file(qe.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ve=this._register(new Q.FollowerLogService(rt,at));ve.set(B.ILogService,Ve),this.sharedProcessWorkerService=new St.SharedProcessWorkerService(Ve),ve.set(We.ISharedProcessWorkerService,this.sharedProcessWorkerService);const et=this._register(new z.FileService(Ve));ve.set(N.IFileService,et);const ot=this._register(new M.DiskFileSystemProvider(Ve));et.registerProvider(P.Schemas.file,ot);const He=this._register(new a.ConfigurationService(qe.settingsResource,et));ve.set(c.IConfigurationService,He);const nt=new le.NativeStorageService(void 0,Ye,qe);ve.set(ce.IStorageService,nt),this._register((0,A.toDisposable)(()=>nt.flush())),await Promise.all([He.initialize(),nt.initialize()]),ve.set(ie.IRequestService,new q.SyncDescriptor(re.RequestService)),ve.set(m.IChecksumService,new q.SyncDescriptor(y.ChecksumService));const st=n.ProxyChannel.toService(Ye.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(Z.INativeHostService,st),ve.set(r.IDownloadService,new q.SyncDescriptor(i.DownloadService));const ct=this._register(new ke.ActiveWindowManager(st)),lt=new n.StaticRouter(je=>ct.getActiveClientId().then(ut=>je===ut));ve.set(F.IExtensionRecommendationNotificationService,new C.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",lt)));let Je;const Xe=[];if((0,Ae.supportsTelemetry)(Me,qe)){const je=new Ce.TelemetryLogAppender(Ze,qe);Xe.push(je);const{appRoot:ut,extensionsPath:It,installSourcePath:Ct}=qe;if(Me.aiConfig&&Me.aiConfig.asimovKey){const gt=new Pe.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey);this._register((0,A.toDisposable)(()=>gt.flush())),Xe.push(gt)}Je=new Ee.TelemetryService({appenders:Xe,commonProperties:(0,de.resolveCommonProperties)(et,(0,L.release)(),(0,L.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,Ct),sendErrorTelemetry:!0,piiPaths:[ut,It]},He)}else{Je=Ae.NullTelemetryService;const je=Ae.NullAppender;Xe.push(je)}this.server.registerChannel("telemetryAppender",new be.TelemetryAppenderChannel(Xe)),ve.set(fe.ITelemetryService,Je);const bt=new Le.CustomEndpointTelemetryService(He,Je,Ze,qe);return ve.set(fe.ICustomEndpointTelemetryService,bt),ve.set(g.IExtensionManagementService,new q.SyncDescriptor(O.ExtensionManagementService)),ve.set(g.IExtensionGalleryService,new q.SyncDescriptor(d.ExtensionGalleryService)),ve.set(g.IExtensionTipsService,new q.SyncDescriptor(_.ExtensionTipsService)),ve.set(U.ILocalizationsService,new q.SyncDescriptor(V.LocalizationsService)),ve.set(t.IDiagnosticsService,new q.SyncDescriptor(s.DiagnosticsService)),ve.set(pe.IUserDataSyncAccountService,new q.SyncDescriptor(pe.UserDataSyncAccountService)),ve.set(oe.IUserDataSyncLogService,new q.SyncDescriptor(Re.UserDataSyncLogService)),ve.set(oe.IUserDataSyncUtilService,new _e.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",je=>je.ctx!=="main"))),ve.set(g.IGlobalExtensionEnablementService,new q.SyncDescriptor(u.GlobalExtensionEnablementService)),ve.set(ee.IIgnoredExtensionsManagementService,new q.SyncDescriptor(ee.IgnoredExtensionsManagementService)),ve.set(xe.IExtensionsStorageSyncService,new q.SyncDescriptor(xe.ExtensionsStorageSyncService)),ve.set(oe.IUserDataSyncStoreManagementService,new q.SyncDescriptor(me.UserDataSyncStoreManagementService)),ve.set(oe.IUserDataSyncStoreService,new q.SyncDescriptor(me.UserDataSyncStoreService)),ve.set(Y.IUserDataSyncMachinesService,new q.SyncDescriptor(Y.UserDataSyncMachinesService)),ve.set(oe.IUserDataSyncBackupStoreService,new q.SyncDescriptor(Se.UserDataSyncBackupStoreService)),ve.set(oe.IUserDataAutoSyncEnablementService,new q.SyncDescriptor(ae.UserDataAutoSyncEnablementService)),ve.set(oe.IUserDataSyncResourceEnablementService,new q.SyncDescriptor(se.UserDataSyncResourceEnablementService)),ve.set(oe.IUserDataSyncService,new q.SyncDescriptor(ue.UserDataSyncService)),ve.set(Fe.ILocalPtyService,this._register(new $e.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:He.getValue("terminal.integrated.persistentSessionScrollback")??100},He,qe,Ve,Je))),ve.set(Te.IExtensionHostStarter,this._register(new ye.ExtensionHostStarter(Ve))),ve.set(we.ISignService,new q.SyncDescriptor(De.SignService)),ve.set(Oe.ITunnelService,new q.SyncDescriptor(Ue.TunnelService)),ve.set(Qe.ISharedProcessTunnelService,new q.SyncDescriptor(Ke.SharedProcessTunnelService)),new j.InstantiationService(ve)}initChannels(ve){const Me=new T.ExtensionManagementChannel(ve.get(g.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const ze=n.ProxyChannel.fromService(ve.get(U.ILocalizationsService));this.server.registerChannel("localizations",ze);const Ye=n.ProxyChannel.fromService(ve.get(t.IDiagnosticsService));this.server.registerChannel("diagnostics",Ye);const qe=new T.ExtensionTipsChannel(ve.get(g.IExtensionTipsService));this.server.registerChannel("extensionTipsService",qe);const rt=n.ProxyChannel.fromService(ve.get(m.IChecksumService));this.server.registerChannel("checksum",rt);const Ze=new _e.UserDataSyncMachinesServiceChannel(ve.get(Y.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ze);const at=n.ProxyChannel.fromService(ve.get(fe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Ve=new _e.UserDataSyncAccountServiceChannel(ve.get(pe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const et=new _e.UserDataSyncStoreManagementServiceChannel(ve.get(oe.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",et);const ot=new ge.UserDataSyncChannel(ve.get(oe.IUserDataSyncService),ve.get(B.ILogService));this.server.registerChannel("userDataSync",ot);const He=this._register(ve.get(W.IInstantiationService).createInstance(Ie.UserDataAutoSyncService)),nt=new _e.UserDataAutoSyncChannel(He);this.server.registerChannel("userDataAutoSync",nt);const st=ve.get(Fe.ILocalPtyService),ct=n.ProxyChannel.fromService(st);this.server.registerChannel(Ne.TerminalIpcChannels.LocalPty,ct);const lt=n.ProxyChannel.fromService(ve.get(Te.IExtensionHostStarter));this.server.registerChannel(Te.ipcExtensionHostStarterChannelName,lt);const Je=n.ProxyChannel.fromService(ve.get(Qe.ISharedProcessTunnelService));this.server.registerChannel(Qe.ipcSharedProcessTunnelChannelName,Je);const Xe=n.ProxyChannel.fromService(ve.get(We.ISharedProcessWorkerService));this.server.registerChannel(We.ipcSharedProcessWorkerChannelName,Xe)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Me=>{(0,k.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,k.setUnexpectedErrorHandler)(Me=>{const ze=(0,D.toErrorMessage)(Me,!0);!ze||ve.error(`[uncaught exception in sharedProcess]: ${ze}`)})}}async function Et(dt){const ve=new wt(dt);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Et})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/97018d742e4ce3dfbcdb0a02c42c16c6c152e4e1/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
