/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/network","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/base/common/event","vs/base/common/types","vs/base/common/platform","vs/base/node/pfs","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/errorMessage","vs/base/common/process","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","os","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","child_process","vs/base/parts/ipc/node/ipc.cp","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","fs","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/base/common/map","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","vs/base/common/performance","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(V){for(var t=[],C=0,b=V.length;C<b;C++)t[C]=Y[V[C]];return t};define(Y[56],Q([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function C(b,w){if(!b)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}t.ok=C}),define(Y[46],Q([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function C(R){return(L,l,d)=>{let E=null,I=null;if(typeof d.value=="function"?(E="value",I=d.value):typeof d.get=="function"&&(E="get",I=d.get),!I)throw new Error("not supported");d[E]=R(I,l)}}t.createDecorator=C;function b(R,L,l){let d=null,E=null;if(typeof l.value=="function"?(d="value",E=l.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(d="get",E=l.get),!E)throw new Error("not supported");const I=`$memoize$${L}`;l[d]=function(...g){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,g)}),this[I]}}t.memoize=b;function w(R,L,l){return C((d,E)=>{const I=`$debounce$${E}`,g=`$debounce$result$${E}`;return function(...S){this[g]||(this[g]=l?l():void 0),clearTimeout(this[I]),L&&(this[g]=L(this[g],...S),S=[this[g]]),this[I]=setTimeout(()=>{d.apply(this,S),this[g]=l?l():void 0},R)}})}t.debounce=w;function D(R,L,l){return C((d,E)=>{const I=`$throttle$timer$${E}`,g=`$throttle$result$${E}`,S=`$throttle$lastRun$${E}`,c=`$throttle$pending$${E}`;return function(...u){if(this[g]||(this[g]=l?l():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),L&&(this[g]=L(this[g],...u)),this[c])return;const m=this[S]+R;m<=Date.now()?(this[S]=Date.now(),d.apply(this,[this[g]]),this[g]=l?l():void 0):(this[c]=!0,this[I]=setTimeout(()=>{this[c]=!1,this[S]=Date.now(),d.apply(this,[this[g]]),this[g]=l?l():void 0},m-Date.now()))}})}t.throttle=D}),define(Y[57],Q([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var C;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(C=t.ScanError||(t.ScanError={}));var b;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(b=t.SyntaxKind||(t.SyntaxKind={}));var w;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(w=t.ParseErrorCode||(t.ParseErrorCode={}));var D;(function(e){e.DEFAULT={allowTrailingComma:!0}})(D=t.ParseOptions||(t.ParseOptions={}));function R(e,i=!1){let n=0,r=e.length,a="",y=0,P=16,O=0;function v(te){let ue=0,ae=0;for(;ue<te;){const $=e.charCodeAt(n);if($>=48&&$<=57)ae=ae*16+$-48;else if($>=65&&$<=70)ae=ae*16+$-65+10;else if($>=97&&$<=102)ae=ae*16+$-97+10;else break;n++,ue++}return ue<te&&(ae=-1),ae}function T(te){n=te,a="",y=0,P=16,O=0}function F(){const te=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&d(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&d(e.charCodeAt(n)))for(n++;n<e.length&&d(e.charCodeAt(n));)n++;else return O=3,e.substring(te,n);let ue=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&d(e.charCodeAt(n))){for(n++;n<e.length&&d(e.charCodeAt(n));)n++;ue=n}else O=3;return e.substring(te,ue)}function U(){let te="",ue=n;for(;;){if(n>=r){te+=e.substring(ue,n),O=2;break}const ae=e.charCodeAt(n);if(ae===34){te+=e.substring(ue,n),n++;break}if(ae===92){if(te+=e.substring(ue,n),n++,n>=r){O=2;break}switch(e.charCodeAt(n++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const ie=v(4);ie>=0?te+=String.fromCharCode(ie):O=4;break;default:O=5}ue=n;continue}if(ae>=0&&ae<=31)if(l(ae)){te+=e.substring(ue,n),O=2;break}else O=6;n++}return te}function K(){if(a="",O=0,y=n,n>=r)return y=r,P=17;let te=e.charCodeAt(n);if(L(te)){do n++,a+=String.fromCharCode(te),te=e.charCodeAt(n);while(L(te));return P=15}if(l(te))return n++,a+=String.fromCharCode(te),te===13&&e.charCodeAt(n)===10&&(n++,a+=`
`),P=14;switch(te){case 123:return n++,P=1;case 125:return n++,P=2;case 91:return n++,P=3;case 93:return n++,P=4;case 58:return n++,P=6;case 44:return n++,P=5;case 34:return n++,a=U(),P=10;case 47:const ue=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<r&&!l(e.charCodeAt(n));)n++;return a=e.substring(ue,n),P=12}if(e.charCodeAt(n+1)===42){n+=2;const ae=r-1;let $=!1;for(;n<ae;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,$=!0;break}n++}return $||(n++,O=1),a=e.substring(ue,n),P=13}return a+=String.fromCharCode(te),n++,P=16;case 45:if(a+=String.fromCharCode(te),n++,n===r||!d(e.charCodeAt(n)))return P=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=F(),P=11;default:for(;n<r&&ee(te);)n++,te=e.charCodeAt(n);if(y!==n){switch(a=e.substring(y,n),a){case"true":return P=8;case"false":return P=9;case"null":return P=7}return P=16}return a+=String.fromCharCode(te),n++,P=16}}function ee(te){if(L(te)||l(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let te;do te=K();while(te>=12&&te<=15);return te}return{setPosition:T,getPosition:()=>n,scan:i?oe:K,getToken:()=>P,getTokenValue:()=>a,getTokenOffset:()=>y,getTokenLength:()=>n-y,getTokenError:()=>O}}t.createScanner=R;function L(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function l(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var E;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(E||(E={}));function I(e,i){const n=[],r=new Object;let a;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let P=!1;function O(v,T,F,U){y.value=v,y.offset=T,y.length=F,y.type=U,y.colonOffset=void 0,a=y}try{f(e,{onObjectBegin:(v,T)=>{if(i<=v)throw r;a=void 0,P=i>v,n.push("")},onObjectProperty:(v,T,F)=>{if(i<T||(O(v,T,F,"property"),n[n.length-1]=v,i<=T+F))throw r},onObjectEnd:(v,T)=>{if(i<=v)throw r;a=void 0,n.pop()},onArrayBegin:(v,T)=>{if(i<=v)throw r;a=void 0,n.push(0)},onArrayEnd:(v,T)=>{if(i<=v)throw r;a=void 0,n.pop()},onLiteralValue:(v,T,F)=>{if(i<T||(O(v,T,F,s(v)),i<=T+F))throw r},onSeparator:(v,T,F)=>{if(i<=T)throw r;if(v===":"&&a&&a.type==="property")a.colonOffset=T,P=!1,a=void 0;else if(v===","){const U=n[n.length-1];typeof U=="number"?n[n.length-1]=U+1:(P=!0,n[n.length-1]=""),a=void 0}}})}catch(v){if(v!==r)throw v}return{path:n,previousNode:a,isAtPropertyKey:P,matches:v=>{let T=0;for(let F=0;T<v.length&&F<n.length;F++)if(v[T]===n[F]||v[T]==="*")T++;else if(v[T]!=="**")return!1;return T===v.length}}}t.getLocation=I;function g(e,i=[],n=D.DEFAULT){let r=null,a=[];const y=[];function P(v){Array.isArray(a)?a.push(v):r!==null&&(a[r]=v)}return f(e,{onObjectBegin:()=>{const v={};P(v),y.push(a),a=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{a=y.pop()},onArrayBegin:()=>{const v=[];P(v),y.push(a),a=v,r=null},onArrayEnd:()=>{a=y.pop()},onLiteralValue:P,onError:(v,T,F)=>{i.push({error:v,offset:T,length:F})}},n),a[0]}t.parse=g;function S(e,i=[],n=D.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(v){r.type==="property"&&(r.length=v-r.offset,r=r.parent)}function y(v){return r.children.push(v),v}f(e,{onObjectBegin:v=>{r=y({type:"object",offset:v,length:-1,parent:r,children:[]})},onObjectProperty:(v,T,F)=>{r=y({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:v,offset:T,length:F,parent:r})},onObjectEnd:(v,T)=>{r.length=v+T-r.offset,r=r.parent,a(v+T)},onArrayBegin:(v,T)=>{r=y({type:"array",offset:v,length:-1,parent:r,children:[]})},onArrayEnd:(v,T)=>{r.length=v+T-r.offset,r=r.parent,a(v+T)},onLiteralValue:(v,T,F)=>{y({type:s(v),offset:T,length:F,parent:r,value:v}),a(T+F)},onSeparator:(v,T,F)=>{r.type==="property"&&(v===":"?r.colonOffset=T:v===","&&a(T))},onError:(v,T,F)=>{i.push({error:v,offset:T,length:F})}},n);const O=r.children[0];return O&&delete O.parent,O}t.parseTree=S;function c(e,i){if(!e)return;let n=e;for(let r of i)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const y of n.children)if(Array.isArray(y.children)&&y.children[0].value===r){n=y.children[1],a=!0;break}if(!a)return}else{const a=r;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}t.findNodeAtLocation=c;function u(e){if(!e.parent||!e.parent.children)return[];const i=u(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=u;function m(e){switch(e.type){case"array":return e.children.map(m);case"object":const i=Object.create(null);for(let n of e.children){const r=n.children[1];r&&(i[n.children[0].value]=m(r))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=m;function p(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=p;function h(e,i,n=!1){if(p(e,i,n)){const r=e.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=i;a++){const y=h(r[a],i,n);if(y)return y}return e}}t.findNodeAtOffset=h;function f(e,i,n=D.DEFAULT){const r=R(e,!1);function a(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function y(B){return B?ne=>B(ne,r.getTokenOffset(),r.getTokenLength()):()=>!0}const P=a(i.onObjectBegin),O=y(i.onObjectProperty),v=a(i.onObjectEnd),T=a(i.onArrayBegin),F=a(i.onArrayEnd),U=y(i.onLiteralValue),K=y(i.onSeparator),ee=a(i.onComment),oe=y(i.onError),te=n&&n.disallowComments,ue=n&&n.allowTrailingComma;function ae(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:te||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(B){case 12:case 13:te?$(10):ee();break;case 16:$(1);break;case 15:case 14:break;default:return B}}}function $(B,ne=[],J=[]){if(oe(B),ne.length+J.length>0){let z=r.getToken();for(;z!==17;){if(ne.indexOf(z)!==-1){ae();break}else if(J.indexOf(z)!==-1)break;z=ae()}}}function ie(B){const ne=r.getTokenValue();return B?U(ne):O(ne),ae(),!0}function M(){switch(r.getToken()){case 11:let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&($(2),B=0)}catch(ne){$(2)}U(B);break;case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return ae(),!0}function A(){return r.getToken()!==10?($(3,[],[2,5]),!1):(ie(!1),r.getToken()===6?(K(":"),ae(),H()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function x(){P(),ae();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||$(4,[],[]),K(","),ae(),r.getToken()===2&&ue)break}else B&&$(6,[],[]);A()||$(4,[],[2,5]),B=!0}return v(),r.getToken()!==2?$(7,[2],[]):ae(),!0}function G(){T(),ae();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||$(4,[],[]),K(","),ae(),r.getToken()===4&&ue)break}else B&&$(6,[],[]);H()||$(4,[],[4,5]),B=!0}return F(),r.getToken()!==4?$(8,[4],[]):ae(),!0}function H(){switch(r.getToken()){case 3:return G();case 1:return x();case 10:return ie(!0);default:return M()}}return ae(),r.getToken()===17?n.allowEmptyContent?!0:($(4,[],[]),!1):H()?(r.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}t.visit=f;function o(e,i){let n=R(e),r=[],a,y=0,P;do switch(P=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:y!==P&&r.push(e.substring(y,P)),i!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,i)),y=n.getPosition();break}while(a!==17);return r.join("")}t.stripComments=o;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function V(w){const D=[];typeof w=="number"&&D.push("code/timeOrigin",w);function R(l){D.push(l,Date.now())}function L(){const l=[];for(let d=0;d<D.length;d+=2)l.push({name:D[d],startTime:D[d+1]});return l}return{mark:R,getMarks:L}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const R of performance.getEntriesByType("mark"))D.push({name:R.name,startTime:Math.round(w+R.startTime)});return D}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function C(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=t()),w.MonacoPerformanceMarks}var b;typeof global=="object"?b=global:typeof self=="object"?b=self:b={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(b)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(b):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),b.perf=C(b))}(),define(Y[58],Q([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var C;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(C=t.Source||(t.Source={}));var b;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(b=t.TerminateResponseCode||(t.TerminateResponseCode={}));function w(D,...R){const L=R.reduce((E,I)=>(E[I]=!0,E),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(E=>!L[E]).forEach(E=>{for(let I=0;I<l.length;I++)if(E.search(l[I])!==-1){delete D[E];break}})}t.sanitizeProcessEnvironment=w}),function(V,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var C=t();for(var b in C)(typeof exports=="object"?exports:V)[b]=C[b]}}(typeof self!="undefined"?self:this,function(){return function(V){var t={};function C(b){if(t[b])return t[b].exports;var w=t[b]={i:b,l:!1,exports:{}};return V[b].call(w.exports,w,w.exports,C),w.l=!0,w.exports}return C.m=V,C.c=t,C.d=function(b,w,D){C.o(b,w)||Object.defineProperty(b,w,{enumerable:!0,get:D})},C.r=function(b){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(b,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(b,"__esModule",{value:!0})},C.t=function(b,w){if(1&w&&(b=C(b)),8&w||4&w&&typeof b=="object"&&b&&b.__esModule)return b;var D=Object.create(null);if(C.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:b}),2&w&&typeof b!="string")for(var R in b)C.d(D,R,function(L){return b[L]}.bind(null,R));return D},C.n=function(b){var w=b&&b.__esModule?function(){return b.default}:function(){return b};return C.d(w,"a",w),w},C.o=function(b,w){return Object.prototype.hasOwnProperty.call(b,w)},C.p="",C(C.s=0)}([function(V,t,C){(function(b){var w;t=V.exports=J,w=typeof b=="object"&&b.env&&b.env.NODE_DEBUG&&/\bsemver\b/i.test(b.env.NODE_DEBUG)?function(){var k=Array.prototype.slice.call(arguments,0);k.unshift("SEMVER"),console.log.apply(console,k)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var D=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,L=t.re=[],l=t.src=[],d=0,E=d++;l[E]="0|[1-9]\\d*";var I=d++;l[I]="[0-9]+";var g=d++;l[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=d++;l[S]="("+l[E]+")\\.("+l[E]+")\\.("+l[E]+")";var c=d++;l[c]="("+l[I]+")\\.("+l[I]+")\\.("+l[I]+")";var u=d++;l[u]="(?:"+l[E]+"|"+l[g]+")";var m=d++;l[m]="(?:"+l[I]+"|"+l[g]+")";var p=d++;l[p]="(?:-("+l[u]+"(?:\\."+l[u]+")*))";var h=d++;l[h]="(?:-?("+l[m]+"(?:\\."+l[m]+")*))";var f=d++;l[f]="[0-9A-Za-z-]+";var o=d++;l[o]="(?:\\+("+l[f]+"(?:\\."+l[f]+")*))";var s=d++,e="v?"+l[S]+l[p]+"?"+l[o]+"?";l[s]="^"+e+"$";var i="[v=\\s]*"+l[c]+l[h]+"?"+l[o]+"?",n=d++;l[n]="^"+i+"$";var r=d++;l[r]="((?:<|>)?=?)";var a=d++;l[a]=l[I]+"|x|X|\\*";var y=d++;l[y]=l[E]+"|x|X|\\*";var P=d++;l[P]="[v=\\s]*("+l[y]+")(?:\\.("+l[y]+")(?:\\.("+l[y]+")(?:"+l[p]+")?"+l[o]+"?)?)?";var O=d++;l[O]="[v=\\s]*("+l[a]+")(?:\\.("+l[a]+")(?:\\.("+l[a]+")(?:"+l[h]+")?"+l[o]+"?)?)?";var v=d++;l[v]="^"+l[r]+"\\s*"+l[P]+"$";var T=d++;l[T]="^"+l[r]+"\\s*"+l[O]+"$";var F=d++;l[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=d++;l[U]="(?:~>?)";var K=d++;l[K]="(\\s*)"+l[U]+"\\s+",L[K]=new RegExp(l[K],"g");var ee=d++;l[ee]="^"+l[U]+l[P]+"$";var oe=d++;l[oe]="^"+l[U]+l[O]+"$";var te=d++;l[te]="(?:\\^)";var ue=d++;l[ue]="(\\s*)"+l[te]+"\\s+",L[ue]=new RegExp(l[ue],"g");var ae=d++;l[ae]="^"+l[te]+l[P]+"$";var $=d++;l[$]="^"+l[te]+l[O]+"$";var ie=d++;l[ie]="^"+l[r]+"\\s*("+i+")$|^$";var M=d++;l[M]="^"+l[r]+"\\s*("+e+")$|^$";var A=d++;l[A]="(\\s*)"+l[r]+"\\s*("+i+"|"+l[P]+")",L[A]=new RegExp(l[A],"g");var x=d++;l[x]="^\\s*("+l[P]+")\\s+-\\s+("+l[P]+")\\s*$";var G=d++;l[G]="^\\s*("+l[O]+")\\s+-\\s+("+l[O]+")\\s*$";var H=d++;l[H]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)w(B,l[B]),L[B]||(L[B]=new RegExp(l[B]));function ne(k,W){if(k instanceof J)return k;if(typeof k!="string"||k.length>D||!(W?L[n]:L[s]).test(k))return null;try{return new J(k,W)}catch(q){return null}}function J(k,W){if(k instanceof J){if(k.loose===W)return k;k=k.version}else if(typeof k!="string")throw new TypeError("Invalid Version: "+k);if(k.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof J))return new J(k,W);w("SemVer",k,W),this.loose=W;var q=k.trim().match(W?L[n]:L[s]);if(!q)throw new TypeError("Invalid Version: "+k);if(this.raw=k,this.major=+q[1],this.minor=+q[2],this.patch=+q[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");q[4]?this.prerelease=q[4].split(".").map(function(le){if(/^[0-9]+$/.test(le)){var he=+le;if(he>=0&&he<R)return he}return le}):this.prerelease=[],this.build=q[5]?q[5].split("."):[],this.format()}t.parse=ne,t.valid=function(k,W){var q=ne(k,W);return q?q.version:null},t.clean=function(k,W){var q=ne(k.trim().replace(/^[=v]+/,""),W);return q?q.version:null},t.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(k){return w("SemVer.compare",this.version,this.loose,k),k instanceof J||(k=new J(k,this.loose)),this.compareMain(k)||this.comparePre(k)},J.prototype.compareMain=function(k){return k instanceof J||(k=new J(k,this.loose)),N(this.major,k.major)||N(this.minor,k.minor)||N(this.patch,k.patch)},J.prototype.comparePre=function(k){if(k instanceof J||(k=new J(k,this.loose)),this.prerelease.length&&!k.prerelease.length)return-1;if(!this.prerelease.length&&k.prerelease.length)return 1;if(!this.prerelease.length&&!k.prerelease.length)return 0;var W=0;do{var q=this.prerelease[W],le=k.prerelease[W];if(w("prerelease compare",W,q,le),q===void 0&&le===void 0)return 0;if(le===void 0)return 1;if(q===void 0)return-1;if(q!==le)return N(q,le)}while(++W)},J.prototype.inc=function(k,W){switch(k){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",W);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",W);break;case"prepatch":this.prerelease.length=0,this.inc("patch",W),this.inc("pre",W);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",W),this.inc("pre",W);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var q=this.prerelease.length;--q>=0;)typeof this.prerelease[q]=="number"&&(this.prerelease[q]++,q=-2);q===-1&&this.prerelease.push(0)}W&&(this.prerelease[0]===W?isNaN(this.prerelease[1])&&(this.prerelease=[W,0]):this.prerelease=[W,0]);break;default:throw new Error("invalid increment argument: "+k)}return this.format(),this.raw=this.version,this},t.inc=function(k,W,q,le){typeof q=="string"&&(le=q,q=void 0);try{return new J(k,q).inc(W,le).version}catch(he){return null}},t.diff=function(k,W){if(Z(k,W))return null;var q=ne(k),le=ne(W);if(q.prerelease.length||le.prerelease.length){for(var he in q)if((he==="major"||he==="minor"||he==="patch")&&q[he]!==le[he])return"pre"+he;return"prerelease"}for(var he in q)if((he==="major"||he==="minor"||he==="patch")&&q[he]!==le[he])return he},t.compareIdentifiers=N;var z=/^[0-9]+$/;function N(k,W){var q=z.test(k),le=z.test(W);return q&&le&&(k=+k,W=+W),q&&!le?-1:le&&!q?1:k<W?-1:k>W?1:0}function _(k,W,q){return new J(k,q).compare(new J(W,q))}function j(k,W,q){return _(k,W,q)>0}function X(k,W,q){return _(k,W,q)<0}function Z(k,W,q){return _(k,W,q)===0}function se(k,W,q){return _(k,W,q)!==0}function re(k,W,q){return _(k,W,q)>=0}function me(k,W,q){return _(k,W,q)<=0}function pe(k,W,q,le){var he;switch(W){case"===":typeof k=="object"&&(k=k.version),typeof q=="object"&&(q=q.version),he=k===q;break;case"!==":typeof k=="object"&&(k=k.version),typeof q=="object"&&(q=q.version),he=k!==q;break;case"":case"=":case"==":he=Z(k,q,le);break;case"!=":he=se(k,q,le);break;case">":he=j(k,q,le);break;case">=":he=re(k,q,le);break;case"<":he=X(k,q,le);break;case"<=":he=me(k,q,le);break;default:throw new TypeError("Invalid operator: "+W)}return he}function fe(k,W){if(k instanceof fe){if(k.loose===W)return k;k=k.value}if(!(this instanceof fe))return new fe(k,W);w("comparator",k,W),this.loose=W,this.parse(k),this.semver===be?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}t.rcompareIdentifiers=function(k,W){return N(W,k)},t.major=function(k,W){return new J(k,W).major},t.minor=function(k,W){return new J(k,W).minor},t.patch=function(k,W){return new J(k,W).patch},t.compare=_,t.compareLoose=function(k,W){return _(k,W,!0)},t.rcompare=function(k,W,q){return _(W,k,q)},t.sort=function(k,W){return k.sort(function(q,le){return t.compare(q,le,W)})},t.rsort=function(k,W){return k.sort(function(q,le){return t.rcompare(q,le,W)})},t.gt=j,t.lt=X,t.eq=Z,t.neq=se,t.gte=re,t.lte=me,t.cmp=pe,t.Comparator=fe;var be={};function ye(k,W){if(k instanceof ye)return k.loose===W?k:new ye(k.raw,W);if(k instanceof fe)return new ye(k.value,W);if(!(this instanceof ye))return new ye(k,W);if(this.loose=W,this.raw=k,this.set=k.split(/\s*\|\|\s*/).map(function(q){return this.parseRange(q.trim())},this).filter(function(q){return q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+k);this.format()}function we(k){return!k||k.toLowerCase()==="x"||k==="*"}function Fe(k,W,q,le,he,Re,Ee,Oe,Pe,Ce,Ne,De,Le){return((W=we(q)?"":we(le)?">="+q+".0.0":we(he)?">="+q+"."+le+".0":">="+W)+" "+(Oe=we(Pe)?"":we(Ce)?"<"+(+Pe+1)+".0.0":we(Ne)?"<"+Pe+"."+(+Ce+1)+".0":De?"<="+Pe+"."+Ce+"."+Ne+"-"+De:"<="+Oe)).trim()}function Me(k,W){for(var q=0;q<k.length;q++)if(!k[q].test(W))return!1;if(W.prerelease.length){for(q=0;q<k.length;q++)if(w(k[q].semver),k[q].semver!==be&&k[q].semver.prerelease.length>0){var le=k[q].semver;if(le.major===W.major&&le.minor===W.minor&&le.patch===W.patch)return!0}return!1}return!0}function ze(k,W,q){try{W=new ye(W,q)}catch(le){return!1}return W.test(k)}function xe(k,W,q,le){var he,Re,Ee,Oe,Pe;switch(k=new J(k,le),W=new ye(W,le),q){case">":he=j,Re=me,Ee=X,Oe=">",Pe=">=";break;case"<":he=X,Re=re,Ee=j,Oe="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(k,W,le))return!1;for(var Ce=0;Ce<W.set.length;++Ce){var Ne=W.set[Ce],De=null,Le=null;if(Ne.forEach(function(Ae){Ae.semver===be&&(Ae=new fe(">=0.0.0")),De=De||Ae,Le=Le||Ae,he(Ae.semver,De.semver,le)?De=Ae:Ee(Ae.semver,Le.semver,le)&&(Le=Ae)}),De.operator===Oe||De.operator===Pe||(!Le.operator||Le.operator===Oe)&&Re(k,Le.semver)||Le.operator===Pe&&Ee(k,Le.semver))return!1}return!0}fe.prototype.parse=function(k){var W=this.loose?L[ie]:L[M],q=k.match(W);if(!q)throw new TypeError("Invalid comparator: "+k);this.operator=q[1],this.operator==="="&&(this.operator=""),q[2]?this.semver=new J(q[2],this.loose):this.semver=be},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(k){return w("Comparator.test",k,this.loose),this.semver===be||(typeof k=="string"&&(k=new J(k,this.loose)),pe(k,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(k,W){if(!(k instanceof fe))throw new TypeError("a Comparator is required");var q;if(this.operator==="")return q=new ye(k.value,W),ze(this.value,q,W);if(k.operator==="")return q=new ye(this.value,W),ze(k.semver,q,W);var le=!(this.operator!==">="&&this.operator!==">"||k.operator!==">="&&k.operator!==">"),he=!(this.operator!=="<="&&this.operator!=="<"||k.operator!=="<="&&k.operator!=="<"),Re=this.semver.version===k.semver.version,Ee=!(this.operator!==">="&&this.operator!=="<="||k.operator!==">="&&k.operator!=="<="),Oe=pe(this.semver,"<",k.semver,W)&&(this.operator===">="||this.operator===">")&&(k.operator==="<="||k.operator==="<"),Pe=pe(this.semver,">",k.semver,W)&&(this.operator==="<="||this.operator==="<")&&(k.operator===">="||k.operator===">");return le||he||Re&&Ee||Oe||Pe},t.Range=ye,ye.prototype.format=function(){return this.range=this.set.map(function(k){return k.join(" ").trim()}).join("||").trim(),this.range},ye.prototype.toString=function(){return this.range},ye.prototype.parseRange=function(k){var W=this.loose;k=k.trim(),w("range",k,W);var q=W?L[G]:L[x];k=k.replace(q,Fe),w("hyphen replace",k),k=k.replace(L[A],"$1$2$3"),w("comparator trim",k,L[A]),k=(k=(k=k.replace(L[K],"$1~")).replace(L[ue],"$1^")).split(/\s+/).join(" ");var le=W?L[ie]:L[M],he=k.split(" ").map(function(Re){return function(Ee,Oe){return w("comp",Ee),Ee=function(Pe,Ce){return Pe.trim().split(/\s+/).map(function(Ne){return function(De,Le){w("caret",De,Le);var Ae=Le?L[$]:L[ae];return De.replace(Ae,function(ke,ge,ve,Se,Ie){var Te;return w("caret",De,ke,ge,ve,Se,Ie),we(ge)?Te="":we(ve)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":we(Se)?Te=ge==="0"?">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+".0 <"+(+ge+1)+".0.0":Ie?(w("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Te=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Se+Ie+" <"+ge+"."+ve+"."+(+Se+1):">="+ge+"."+ve+"."+Se+Ie+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Se+Ie+" <"+(+ge+1)+".0.0"):(w("no pr"),Te=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Se+" <"+ge+"."+ve+"."+(+Se+1):">="+ge+"."+ve+"."+Se+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Se+" <"+(+ge+1)+".0.0"),w("caret return",Te),Te})}(Ne,Ce)}).join(" ")}(Ee,Oe),w("caret",Ee),Ee=function(Pe,Ce){return Pe.trim().split(/\s+/).map(function(Ne){return function(De,Le){var Ae=Le?L[oe]:L[ee];return De.replace(Ae,function(ke,ge,ve,Se,Ie){var Te;return w("tilde",De,ke,ge,ve,Se,Ie),we(ge)?Te="":we(ve)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":we(Se)?Te=">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":Ie?(w("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Te=">="+ge+"."+ve+"."+Se+Ie+" <"+ge+"."+(+ve+1)+".0"):Te=">="+ge+"."+ve+"."+Se+" <"+ge+"."+(+ve+1)+".0",w("tilde return",Te),Te})}(Ne,Ce)}).join(" ")}(Ee,Oe),w("tildes",Ee),Ee=function(Pe,Ce){return w("replaceXRanges",Pe,Ce),Pe.split(/\s+/).map(function(Ne){return function(De,Le){De=De.trim();var Ae=Le?L[T]:L[v];return De.replace(Ae,function(ke,ge,ve,Se,Ie,Te){w("xRange",De,ke,ge,ve,Se,Ie,Te);var je=we(ve),Ve=je||we(Se),We=Ve||we(Ie);return ge==="="&&We&&(ge=""),je?ke=ge===">"||ge==="<"?"<0.0.0":"*":ge&&We?(Ve&&(Se=0),We&&(Ie=0),ge===">"?(ge=">=",Ve?(ve=+ve+1,Se=0,Ie=0):We&&(Se=+Se+1,Ie=0)):ge==="<="&&(ge="<",Ve?ve=+ve+1:Se=+Se+1),ke=ge+ve+"."+Se+"."+Ie):Ve?ke=">="+ve+".0.0 <"+(+ve+1)+".0.0":We&&(ke=">="+ve+"."+Se+".0 <"+ve+"."+(+Se+1)+".0"),w("xRange return",ke),ke})}(Ne,Ce)}).join(" ")}(Ee,Oe),w("xrange",Ee),Ee=function(Pe,Ce){return w("replaceStars",Pe,Ce),Pe.trim().replace(L[H],"")}(Ee,Oe),w("stars",Ee),Ee}(Re,W)}).join(" ").split(/\s+/);return this.loose&&(he=he.filter(function(Re){return!!Re.match(le)})),he=he.map(function(Re){return new fe(Re,W)})},ye.prototype.intersects=function(k,W){if(!(k instanceof ye))throw new TypeError("a Range is required");return this.set.some(function(q){return q.every(function(le){return k.set.some(function(he){return he.every(function(Re){return le.intersects(Re,W)})})})})},t.toComparators=function(k,W){return new ye(k,W).set.map(function(q){return q.map(function(le){return le.value}).join(" ").trim().split(" ")})},ye.prototype.test=function(k){if(!k)return!1;typeof k=="string"&&(k=new J(k,this.loose));for(var W=0;W<this.set.length;W++)if(Me(this.set[W],k))return!0;return!1},t.satisfies=ze,t.maxSatisfying=function(k,W,q){var le=null,he=null;try{var Re=new ye(W,q)}catch(Ee){return null}return k.forEach(function(Ee){Re.test(Ee)&&(le&&he.compare(Ee)!==-1||(he=new J(le=Ee,q)))}),le},t.minSatisfying=function(k,W,q){var le=null,he=null;try{var Re=new ye(W,q)}catch(Ee){return null}return k.forEach(function(Ee){Re.test(Ee)&&(le&&he.compare(Ee)!==1||(he=new J(le=Ee,q)))}),le},t.validRange=function(k,W){try{return new ye(k,W).range||"*"}catch(q){return null}},t.ltr=function(k,W,q){return xe(k,W,"<",q)},t.gtr=function(k,W,q){return xe(k,W,">",q)},t.outside=xe,t.prerelease=function(k,W){var q=ne(k,W);return q&&q.prerelease.length?q.prerelease:null},t.intersects=function(k,W,q){return k=new ye(k,q),W=new ye(W,q),k.intersects(W)},t.coerce=function(k){if(k instanceof J)return k;if(typeof k!="string")return null;var W=k.match(L[F]);return W==null?null:ne((W[1]||"0")+"."+(W[2]||"0")+"."+(W[3]||"0"))}}).call(this,C(1))},function(V,t){var C,b,w=V.exports={};function D(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function L(m){if(C===setTimeout)return setTimeout(m,0);if((C===D||!C)&&setTimeout)return C=setTimeout,setTimeout(m,0);try{return C(m,0)}catch(p){try{return C.call(null,m,0)}catch(h){return C.call(this,m,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:D}catch(m){C=D}try{b=typeof clearTimeout=="function"?clearTimeout:R}catch(m){b=R}})();var l,d=[],E=!1,I=-1;function g(){E&&l&&(E=!1,l.length?d=l.concat(d):I=-1,d.length&&S())}function S(){if(!E){var m=L(g);E=!0;for(var p=d.length;p;){for(l=d,d=[];++I<p;)l&&l[I].run();I=-1,p=d.length}l=null,E=!1,function(h){if(b===clearTimeout)return clearTimeout(h);if((b===R||!b)&&clearTimeout)return b=clearTimeout,clearTimeout(h);try{b(h)}catch(f){try{return b.call(null,h)}catch(o){return b.call(this,h)}}}(m)}}function c(m,p){this.fun=m,this.array=p}function u(){}w.nextTick=function(m){var p=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)p[h-1]=arguments[h];d.push(new c(m,p)),d.length!==1||E||L(S)},c.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=u,w.addListener=u,w.once=u,w.off=u,w.removeListener=u,w.removeAllListeners=u,w.emit=u,w.prependListener=u,w.prependOnceListener=u,w.listeners=function(m){return[]},w.binding=function(m){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(m){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(Y[38],Q([0,1,9,2]),function(V,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function w(f){const o=f;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=w;function D(f){const o=f;return o?w(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=D;function R(f,o){return new L(f,o)}t.newWriteableStream=R;class L{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,C.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(s);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(f,o){const s=[];let e;for(;(e=f.read())!==null;)s.push(e);return o(s)}t.consumeReadable=l;function d(f,o,s){const e=[];let i;for(;(i=f.read())!==null&&e.length<s;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return f.read()}}}t.peekReadable=d;function E(f,o){return new Promise((s,e)=>{const i=[];I(f,{onData:n=>{o&&i.push(n)},onError:n=>{o?e(n):s(void 0)},onEnd:()=>{s(o?o(i):void 0)}})})}t.consumeStream=E;function I(f,o){f.on("error",s=>o.onError(s)),f.on("end",()=>o.onEnd()),f.on("data",s=>o.onData(s))}t.listenStream=I;function g(f,o){return new Promise((s,e)=>{const i=new b.DisposableStore,n=[],r=P=>{if(n.push(P),n.length>o)return i.dispose(),f.pause(),s({stream:f,buffer:n,ended:!1})},a=P=>e(P),y=()=>s({stream:f,buffer:n,ended:!0});i.add((0,b.toDisposable)(()=>f.removeListener("error",a))),f.on("error",a),i.add((0,b.toDisposable)(()=>f.removeListener("end",y))),f.on("end",y),i.add((0,b.toDisposable)(()=>f.removeListener("data",r))),f.on("data",r)})}t.peekStream=g;function S(f,o){const s=R(o);return s.end(f),s}t.toStream=S;function c(){const f=R(()=>{throw new Error("not supported")});return f.end(),f}t.emptyStream=c;function u(f){let o=!1;return{read:()=>o?null:(o=!0,f)}}t.toReadable=u;function m(f,o,s){const e=R(s);return I(f,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=m;function p(f,o,s){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?s([f,i]):f)}}}t.prefixedReadable=p;function h(f,o,s){let e=!1;const i=R(s);return I(o,{onData:n=>e?i.write(n):(e=!0,i.write(s([f,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(f)),i.end()}}),i}t.prefixedStream=h}),define(Y[17],Q([0,1,38]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const b=typeof Buffer!="undefined";let w,D;class R{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return b?new R(Buffer.allocUnsafe(r)):new R(new Uint8Array(r))}static wrap(r){return b&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new R(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&b?new R(Buffer.from(r)):(w||(w=new TextEncoder),new R(w.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let O=0,v=r.length;O<v;O++)a+=r[O].byteLength}const y=R.alloc(a);let P=0;for(let O=0,v=r.length;O<v;O++){const T=r[O];y.set(T,P),P+=T.byteLength}return y}toString(){return b?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(r,a){return new R(this.buffer.subarray(r,a))}set(r,a){r instanceof R?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return d(this.buffer,r)}writeUInt32BE(r,a){E(this.buffer,r,a)}readUInt32LE(r){return I(this.buffer,r)}writeUInt32LE(r,a){g(this.buffer,r,a)}readUInt8(r){return S(this.buffer,r)}writeUInt8(r,a){c(this.buffer,r,a)}}t.VSBuffer=R;function L(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}t.readUInt16LE=L;function l(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255}t.writeUInt16LE=l;function d(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}t.readUInt32BE=d;function E(n,r,a){n[a+3]=r,r=r>>>8,n[a+2]=r,r=r>>>8,n[a+1]=r,r=r>>>8,n[a]=r}t.writeUInt32BE=E;function I(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}t.readUInt32LE=I;function g(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255,r=r>>>8,n[a+2]=r&255,r=r>>>8,n[a+3]=r&255}t.writeUInt32LE=g;function S(n,r){return n[r]}t.readUInt8=S;function c(n,r,a){n[a]=r}t.writeUInt8=c;function u(n){return C.consumeReadable(n,r=>R.concat(r))}t.readableToBuffer=u;function m(n){return C.toReadable(n)}t.bufferToReadable=m;function p(n){return C.consumeStream(n,r=>R.concat(r))}t.streamToBuffer=p;async function h(n){return n.ended?R.concat(n.buffer):R.concat([...n.buffer,await p(n.stream)])}t.bufferedStreamToBuffer=h;function f(n){return C.toStream(n,r=>R.concat(r))}t.bufferToStream=f;function o(n){return C.transform(n,{data:r=>typeof r=="string"?R.fromString(r):R.wrap(r)},r=>R.concat(r))}t.streamToBufferReadableStream=o;function s(n){return C.newWriteableStream(r=>R.concat(r),n)}t.newWriteableBufferStream=s;function e(n,r){return C.prefixedReadable(n,r,a=>R.concat(a))}t.prefixedBufferReadable=e;function i(n,r){return C.prefixedStream(n,r,a=>R.concat(a))}t.prefixedBufferStream=i}),define(Y[18],Q([0,1,11]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function b(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const m=Array.isArray(u)?[]:{};return Object.keys(u).forEach(p=>{u[p]&&typeof u[p]=="object"?m[p]=b(u[p]):m[p]=u[p]}),m}t.deepClone=b;function w(u){if(!u||typeof u!="object")return u;const m=[u];for(;m.length>0;){const p=m.shift();Object.freeze(p);for(const h in p)if(D.call(p,h)){const f=p[h];typeof f=="object"&&!Object.isFrozen(f)&&m.push(f)}}return u}t.deepFreeze=w;const D=Object.prototype.hasOwnProperty;function R(u,m){return L(u,m,new Set)}t.cloneAndChange=R;function L(u,m,p){if((0,C.isUndefinedOrNull)(u))return u;const h=m(u);if(typeof h!="undefined")return h;if((0,C.isArray)(u)){const f=[];for(const o of u)f.push(L(o,m,p));return f}if((0,C.isObject)(u)){if(p.has(u))throw new Error("Cannot clone recursive data-structure");p.add(u);const f={};for(let o in u)D.call(u,o)&&(f[o]=L(u[o],m,p));return p.delete(u),f}return u}function l(u,m,p=!0){return(0,C.isObject)(u)?((0,C.isObject)(m)&&Object.keys(m).forEach(h=>{h in u?p&&((0,C.isObject)(u[h])&&(0,C.isObject)(m[h])?l(u[h],m[h],p):u[h]=m[h]):u[h]=m[h]}),u):m}t.mixin=l;function d(u,m){if(u===m)return!0;if(u==null||m===null||m===void 0||typeof u!=typeof m||typeof u!="object"||Array.isArray(u)!==Array.isArray(m))return!1;let p,h;if(Array.isArray(u)){if(u.length!==m.length)return!1;for(p=0;p<u.length;p++)if(!d(u[p],m[p]))return!1}else{const f=[];for(h in u)f.push(h);f.sort();const o=[];for(h in m)o.push(h);if(o.sort(),!d(f,o))return!1;for(p=0;p<f.length;p++)if(!d(u[f[p]],m[f[p]]))return!1}return!0}t.equals=d;function E(u){const m=new Set;return JSON.stringify(u,(p,h)=>{if((0,C.isObject)(h)||Array.isArray(h)){if(m.has(h))return"[Circular]";m.add(h)}return h})}t.safeStringify=E;function I(u,m,p){const h=m(u);return typeof h=="undefined"?p:h}t.getOrDefault=I;function g(u,m){const p=Object.create(null);return!u||!m||Object.keys(m).forEach(f=>{const o=u[f],s=m[f];d(o,s)||(p[f]=s)}),p}t.distinct=g;function S(u,m){const p=m.toLowerCase(),h=Object.keys(u).find(f=>f.toLowerCase()===p);return h?u[h]:u[m]}t.getCaseInsensitive=S;function c(u,m){const p=Object.create(null);for(const h of Object.keys(u))m(h,u[h])&&(p[h]=u[h]);return p}t.filter=c}),define(Y[59],Q([0,1,8]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function b(d){const E=d;return E&&typeof E.type=="string"&&typeof E.severity=="string"}t.isRemoteConsoleLog=b;function w(d){const E=[];let I;try{const g=JSON.parse(d.arguments),S=g[g.length-1];S&&S.__$stack&&(g.pop(),I=S.__$stack),E.push(...g)}catch(g){E.push("Unable to log remote console arguments",d.arguments)}return{args:E,stack:I}}t.parse=w;function D(d){if(typeof d!="string")return D(w(d).stack);const E=d;if(E){const I=R(E),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(g&&g.length===4)return{uri:C.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}t.getFirstFrame=D;function R(d){if(!d)return d;const E=d.indexOf(`
`);return E===-1?d:d.substring(0,E)}function L(d,E){const{args:I,stack:g}=w(d),S=typeof I[0]=="string"&&I.length===1;let c=R(g);c&&(c=`(${c.trim()})`);let u=[];if(typeof I[0]=="string"?c&&S?u=[`%c[${E}] %c${I[0]} %c${c}`,l("blue"),l(""),l("grey")]:u=[`%c[${E}] %c${I[0]}`,l("blue"),l(""),...I.slice(1)]:u=[`%c[${E}]%`,l("blue"),...I],c&&!S&&u.push(c),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,u)}t.log=L;function l(d){return`color: ${d}`}}),define(Y[60],Q([0,1,17,27,8]),function(V,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function D(E){return JSON.stringify(E,l)}t.stringify=D;function R(E){let I=JSON.parse(E);return I=d(I),I}t.parse=R;var L;(function(E){E[E.Uri=1]="Uri",E[E.Regexp=2]="Regexp",E[E.ScmResource=3]="ScmResource",E[E.ScmResourceGroup=4]="ScmResourceGroup",E[E.ScmProvider=5]="ScmProvider",E[E.CommentController=6]="CommentController",E[E.CommentThread=7]="CommentThread",E[E.CommentThreadReply=8]="CommentThreadReply",E[E.CommentNode=9]="CommentNode",E[E.CommentThreadNode=10]="CommentThreadNode",E[E.TimelineActionContext=11]="TimelineActionContext",E[E.NotebookCellActionContext=12]="NotebookCellActionContext",E[E.TestItemContext=13]="TestItemContext"})(L=t.MarshalledId||(t.MarshalledId={}));function l(E,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,b.regExpFlags)(I)}:I}function d(E,I=0){if(!E||I>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return w.URI.revive(E);case 2:return new RegExp(E.source,E.flags)}if(E instanceof C.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let g=0;g<E.length;++g)E[g]=d(E[g],I+1);else for(const g in E)Object.hasOwnProperty.call(E,g)&&(E[g]=d(E[g],I+1))}return E}t.revive=d}),define(Y[61],Q([0,1,47,6,7,12,19,27,8]),function(V,t,C,b,w,D,R,L,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(r,a,y){if(typeof r=="string"&&(r=l.URI.file(r)),y){const O=y.getWorkspaceFolder(r);if(O){const v=y.getWorkspace().folders.length>1;let T;if((0,R.isEqual)(O.uri,r)?T="":T=(0,R.relativePath)(O.uri,r),v){const F=O.name?O.name:(0,R.basename)(O.uri);T=T?F+" \u2022 "+T:F}return T}}if(r.scheme!==b.Schemas.file&&r.scheme!==b.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,C.hasDriveLetter)(r.fsPath))return(0,w.normalize)(I(r.fsPath));let P=(0,w.normalize)(r.fsPath);return!D.isWindows&&a?.userHome&&(P=S(P,a.userHome.fsPath)),P}t.getPathLabel=d;function E(r){if(!r)return;typeof r=="string"&&(r=l.URI.file(r));const a=(0,R.basename)(r)||(r.scheme===b.Schemas.file?r.fsPath:r.path);return D.isWindows&&(0,C.isRootOrDriveLetter)(a)?I(a):a}t.getBaseLabel=E;function I(r){return(0,C.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}t.normalizeDriveLetter=I;let g=Object.create(null);function S(r,a){if(D.isWindows||!r||!a)return r;let y=g.original===a?g.normalized:void 0;return y||(y=`${(0,L.rtrim)(a,w.posix.sep)}${w.posix.sep}`,g={original:a,normalized:y}),(D.isLinux?r.startsWith(y):(0,L.startsWithIgnoreCase)(r,y))&&(r=`~/${r.substr(y.length)}`),r}t.tildify=S;function c(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=c;const u="\u2026",m="\\\\",p="~";function h(r,a=w.sep){const y=new Array(r.length);let P=!1;for(let O=0;O<r.length;O++){let v=r[O];if(v===""){y[O]=`.${a}`;continue}if(!v){y[O]=v;continue}P=!0;let T="";v.indexOf(m)===0?(T=v.substr(0,v.indexOf(m)+m.length),v=v.substr(v.indexOf(m)+m.length)):v.indexOf(a)===0?(T=v.substr(0,v.indexOf(a)+a.length),v=v.substr(v.indexOf(a)+a.length)):v.indexOf(p)===0&&(T=v.substr(0,v.indexOf(p)+p.length),v=v.substr(v.indexOf(p)+p.length));const F=v.split(a);for(let U=1;P&&U<=F.length;U++)for(let K=F.length-U;P&&K>=0;K--){P=!1;let ee=F.slice(K,K+U).join(a);for(let oe=0;!P&&oe<r.length;oe++)if(oe!==O&&r[oe]&&r[oe].indexOf(ee)>-1){const te=K+U===F.length,ue=K>0&&r[oe].indexOf(a)>-1?a+ee:ee,ae=r[oe].endsWith(ue);P=!te||ae}if(!P){let oe="";(F[0].endsWith(":")||T!=="")&&(K===1&&(K=0,U++,ee=F[0]+a+ee),K>0&&(oe=F[0]+a),oe=T+oe),K>0&&(oe=oe+u+a),oe=oe+ee,K+U<F.length&&(oe=oe+a+u),y[O]=oe}}P&&(y[O]=v)}return y}t.shorten=h;var f;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function o(r,a=Object.create(null)){const y=[];let P=!1,O="";for(const v of r)if(v==="$"||P&&v==="{")O&&y.push({value:O,type:f.TEXT}),O="",P=!0;else if(v==="}"&&P){const T=a[O];if(typeof T=="string")T.length&&y.push({value:T,type:f.VARIABLE});else if(T){const F=y[y.length-1];(!F||F.type!==f.SEPARATOR)&&y.push({value:T.label,type:f.SEPARATOR})}O="",P=!1}else O+=v;return O&&!P&&y.push({value:O,type:f.TEXT}),y.filter((v,T)=>{if(v.type===f.SEPARATOR){const F=y[T-1],U=y[T+1];return[F,U].every(K=>K&&(K.type===f.VARIABLE||K.type===f.TEXT)&&K.value.length>0)}return!0}).map(v=>v.value).join("")}t.template=o;function s(r,a){return D.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):r.replace(/&&|&/g,y=>y==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(r,a){return D.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):D.isWindows?r.replace(/&&|&/g,y=>y==="&"?"&&":"&"):r.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(r){return r.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(r){const a=r.indexOf("/")!==-1?w.posix:w.win32,y=a.basename(r),P=a.dirname(r);return y.length?{name:y,parentPath:P}:{name:P,parentPath:""}}t.splitName=n}),define(Y[62],Q([0,1,127]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class b{constructor(D="utf8"){this.stringDecoder=new C.StringDecoder(D),this.remaining=null}write(D){const R=[],L=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(L.length<1)return R;let l=0,d,E=l;for(;E<L.length;)if(d=L.charCodeAt(E),d===13||d===10){if(R.push(L.substring(l,E)),E++,E<L.length){const I=d;d=L.charCodeAt(E),(I===13&&d===10||I===10&&d===13)&&E++}l=E}else E++;return this.remaining=l<L.length?L.substr(l):null,R}end(){return this.remaining}}t.LineDecoder=b}),define(Y[63],Q([0,1,48,7,27,13]),function(V,t,C,b,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function R(E){const I=(0,b.dirname)(E);if(E===I)return E;const g=((0,b.basename)(E)||E).toLowerCase();try{const c=(0,D.readdirSync)(I).filter(u=>u.toLowerCase()===g);if(c.length===1){const u=R(I);if(u)return(0,b.join)(u,c[0])}else if(c.length>1){const u=c.indexOf(g);if(u>=0){const m=R(I);if(m)return(0,b.join)(m,c[u])}}}catch(S){}return null}t.realcaseSync=R;async function L(E){try{return await D.Promises.realpath(E)}catch(I){const g=d(E);return await D.Promises.access(g,C.constants.R_OK),g}}t.realpath=L;function l(E){try{return C.realpathSync(E)}catch(I){const g=d(E);return C.accessSync(g,C.constants.R_OK),g}}t.realpathSync=l;function d(E){return(0,w.rtrim)((0,b.normalize)(E),b.sep)}}),define(Y[64],Q([0,1,35,7,13]),function(V,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,R=/^Microsoft.PowerShell_.*/,L=/^Microsoft.PowerShellPreview_.*/;var l;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(l||(l={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class I{constructor(s,e,i){this.exePath=s,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:o=!1}={}){return o?d===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:o=!1,findPreview:s=!1}={}){const e=g({useAlternateBitness:o});if(!e)return null;const i=b.join(e,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(i))return null;let n=-1,r=null;for(const P of await w.Promises.readdir(i)){let O=-1;if(s){const T=P.indexOf("-");if(T<0)continue;const F=P.substring(0,T);if(!D.test(F)||P.substring(T+1)!=="preview")continue;O=parseInt(F,10)}else{if(!D.test(P))continue;O=parseInt(P,10)}if(O<=n)continue;const v=b.join(i,P,"pwsh.exe");!await w.SymlinkSupport.existsFile(v)||(r=v,n=O)}if(!r)return null;const a=e.includes("x86")?" (x86)":"",y=s?" Preview":"";return new I(r,`PowerShell${y}${a}`,!0)}async function c({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=b.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:L,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const n of await w.Promises.readdir(s))if(e.test(n)){const r=b.join(s,n,"pwsh.exe");return new I(r,i)}return null}function u(){const o=b.join(C.homedir(),".dotnet","tools","pwsh.exe");return new I(o,".NET Core PowerShell Global Tool")}function m(){const o=b.join(process.env.windir,d===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(o,"Windows PowerShell",!0)}async function*p(){let o=await S();o&&(yield o),o=await S({useAlternateBitness:!0}),o&&(yield o),o=await c(),o&&(yield o),o=u(),o&&(yield o),o=await S({findPreview:!0}),o&&(yield o),o=await c({findPreview:!0}),o&&(yield o),o=await S({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=m(),o&&(yield o)}async function*h(){for await(const o of p())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=h;async function f(){for await(const o of h())return o;return null}t.getFirstAvailablePowerShellInstallation=f});var de=this&&this.__decorate||function(V,t,C,b){var w=arguments.length,D=w<3?t:b===null?b=Object.getOwnPropertyDescriptor(t,C):b,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(V,t,C,b);else for(var L=V.length-1;L>=0;L--)(R=V[L])&&(D=(w<3?R(D):w>3?R(t,C,D):R(t,C))||D);return w>3&&D&&Object.defineProperty(t,C,D),D};define(Y[36],Q([0,1,20,3,17,24,46,9,10,2,60,27,11]),function(V,t,C,b,w,D,R,L,l,d,E,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var S;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(S=t.RequestType||(t.RequestType={}));function c(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(u=t.ResponseType||(t.ResponseType={}));function m(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(p||(p={}));class h{constructor(A){this.buffer=A,this.pos=0}read(A){const x=this.buffer.slice(this.pos,this.pos+A);return this.pos+=x.byteLength,x}}class f{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var o;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(o||(o={}));function s(M){const A=w.VSBuffer.alloc(4);return A.writeUInt32BE(M,0),A}function e(M){return M.read(4).readUInt32BE(0)}function i(M){const A=w.VSBuffer.alloc(1);return A.writeUInt8(M,0),A}const n={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},r=typeof Buffer!="undefined";function a(M,A){if(typeof A=="undefined")M.write(n.Undefined);else if(typeof A=="string"){const x=w.VSBuffer.fromString(A);M.write(n.String),M.write(s(x.byteLength)),M.write(x)}else if(r&&Buffer.isBuffer(A)){const x=w.VSBuffer.wrap(A);M.write(n.Buffer),M.write(s(x.byteLength)),M.write(x)}else if(A instanceof w.VSBuffer)M.write(n.VSBuffer),M.write(s(A.byteLength)),M.write(A);else if(Array.isArray(A)){M.write(n.Array),M.write(s(A.length));for(const x of A)a(M,x)}else{const x=w.VSBuffer.fromString(JSON.stringify(A));M.write(n.Object),M.write(s(x.byteLength)),M.write(x)}}function y(M){switch(M.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return M.read(e(M)).toString();case o.Buffer:return M.read(e(M)).buffer;case o.VSBuffer:return M.read(e(M));case o.Array:{const x=e(M),G=[];for(let H=0;H<x;H++)G.push(y(M));return G}case o.Object:return JSON.parse(M.read(e(M)).toString())}}class P{constructor(A,x,G=null,H=1e3){this.protocol=A,this.ctx=x,this.logger=G,this.timeoutDelay=H,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(A,x){this.channels.set(A,x),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const x=this.send([A.type]);this.logger&&this.logger.logOutgoing(x,0,1,m(A.type));return}case 201:case 202:case 204:case 203:{const x=this.send([A.type,A.id],A.data);this.logger&&this.logger.logOutgoing(x,A.id,1,m(A.type),A.data);return}}}send(A,x=void 0){const G=new f;return a(G,A),a(G,x),this.sendBuffer(G.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(x){return 0}}onRawMessage(A){const x=new h(A),G=y(x),H=y(x),B=G[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(A.byteLength,G[1],1,`${c(B)}: ${G[2]}.${G[3]}`,H),this.onPromise({type:B,id:G[1],channelName:G[2],name:G[3],arg:H});case 102:return this.logger&&this.logger.logIncoming(A.byteLength,G[1],1,`${c(B)}: ${G[2]}.${G[3]}`,H),this.onEventListen({type:B,id:G[1],channelName:G[2],name:G[3],arg:H});case 101:return this.logger&&this.logger.logIncoming(A.byteLength,G[1],1,`${c(B)}`),this.disposeActiveRequest({type:B,id:G[1]});case 103:return this.logger&&this.logger.logIncoming(A.byteLength,G[1],1,`${c(B)}`),this.disposeActiveRequest({type:B,id:G[1]})}}onPromise(A){const x=this.channels.get(A.channelName);if(!x){this.collectPendingRequest(A);return}const G=new D.CancellationTokenSource;let H;try{H=x.call(this.ctx,A.name,A.arg,G.token)}catch(J){H=Promise.reject(J)}const B=A.id;H.then(J=>{this.sendResponse({id:B,data:J,type:201}),this.activeRequests.delete(A.id)},J=>{J instanceof Error?this.sendResponse({id:B,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.sendResponse({id:B,data:J,type:203}),this.activeRequests.delete(A.id)});const ne=(0,d.toDisposable)(()=>G.cancel());this.activeRequests.set(A.id,ne)}onEventListen(A){const x=this.channels.get(A.channelName);if(!x){this.collectPendingRequest(A);return}const G=A.id,B=x.listen(this.ctx,A.name,A.arg)(ne=>this.sendResponse({id:G,data:ne,type:204}));this.activeRequests.set(A.id,B)}disposeActiveRequest(A){const x=this.activeRequests.get(A.id);x&&(x.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let x=this.pendingRequests.get(A.channelName);x||(x=[],this.pendingRequests.set(A.channelName,x));const G=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:A,timeoutTimer:G})}flushPendingRequests(A){const x=this.pendingRequests.get(A);if(x){for(const G of x)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}t.ChannelServer=P;var O;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(O=t.RequestInitiator||(t.RequestInitiator={}));class v{constructor(A,x=null){this.protocol=A,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=x}getChannel(A){const x=this;return{call(G,H,B){return x.isDisposed?Promise.reject(L.canceled()):x.requestPromise(A,G,H,B)},listen(G,H){return x.isDisposed?Promise.reject(L.canceled()):x.requestEvent(A,G,H)}}}requestPromise(A,x,G,H=D.CancellationToken.None){const B=this.lastRequestId++,J={id:B,type:100,channelName:A,name:x,arg:G};if(H.isCancellationRequested)return Promise.reject(L.canceled());let z;return new Promise((_,j)=>{if(H.isCancellationRequested)return j(L.canceled());const X=()=>{const me=pe=>{switch(pe.type){case 201:this.handlers.delete(B),_(pe.data);break;case 202:this.handlers.delete(B);const fe=new Error(pe.data.message);fe.stack=pe.data.stack,fe.name=pe.data.name,j(fe);break;case 203:this.handlers.delete(B),j(pe.data);break}};this.handlers.set(B,me),this.sendRequest(J)};let Z=null;this.state===p.Idle?X():(Z=(0,b.createCancelablePromise)(me=>this.whenInitialized()),Z.then(()=>{Z=null,X()}));const se=()=>{Z?(Z.cancel(),Z=null):this.sendRequest({id:B,type:101}),j(L.canceled())},re=H.onCancellationRequested(se);z=(0,d.combinedDisposable)((0,d.toDisposable)(se),re),this.activeRequests.add(z)}).finally(()=>{this.activeRequests.delete(z)})}requestEvent(A,x,G){const H=this.lastRequestId++,ne={id:H,type:102,channelName:A,name:x,arg:G};let J=null;const z=new l.Emitter({onFirstListenerAdd:()=>{J=(0,b.createCancelablePromise)(_=>this.whenInitialized()),J.then(()=>{J=null,this.activeRequests.add(z),this.sendRequest(ne)})},onLastListenerRemove:()=>{J?(J.cancel(),J=null):(this.activeRequests.delete(z),this.sendRequest({id:H,type:103}))}}),N=_=>z.fire(_.data);return this.handlers.set(H,N),z.event}sendRequest(A){switch(A.type){case 100:case 102:{const x=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger&&this.logger.logOutgoing(x,A.id,0,`${c(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const x=this.send([A.type,A.id]);this.logger&&this.logger.logOutgoing(x,A.id,0,c(A.type));return}}}send(A,x=void 0){const G=new f;return a(G,A),a(G,x),this.sendBuffer(G.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(x){return 0}}onBuffer(A){const x=new h(A),G=y(x),H=y(x),B=G[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(A.byteLength,0,0,m(B)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(A.byteLength,G[1],0,m(B),H),this.onResponse({type:G[0],id:G[1],data:H})}}onResponse(A){if(A.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const x=this.handlers.get(A.id);x&&x(A)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}de([R.memoize],v.prototype,"onDidInitializePromise",null),t.ChannelClient=v;class T{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:x,onDidClientDisconnect:G})=>{l.Event.once(x.onMessage)(B=>{const ne=new h(B),J=y(ne),z=new P(x,J),N=new v(x);this.channels.forEach((j,X)=>z.registerChannel(X,j));const _={channelServer:z,channelClient:N,ctx:J};this._connections.add(_),this._onDidAddConnection.fire(_),G(()=>{z.dispose(),N.dispose(),this._connections.delete(_),this._onDidRemoveConnection.fire(_)})})})}get connections(){const A=[];return this._connections.forEach(x=>A.push(x)),A}getChannel(A,x){const G=this;return{call(H,B,ne){let J;if((0,g.isFunction)(x)){let N=(0,C.getRandomElement)(G.connections.filter(x));J=N?Promise.resolve(N):l.Event.toPromise(l.Event.filter(G.onDidAddConnection,x))}else J=x.routeCall(G,H,B);const z=J.then(N=>N.channelClient.getChannel(A));return U(z).call(H,B,ne)},listen(H,B){if((0,g.isFunction)(x))return G.getMulticastEvent(A,x,H,B);const ne=x.routeEvent(G,H,B).then(J=>J.channelClient.getChannel(A));return U(ne).listen(H,B)}}}getMulticastEvent(A,x,G,H){const B=this;let ne=new d.DisposableStore;const J=new l.Emitter({onFirstListenerAdd:()=>{ne=new d.DisposableStore;const z=new l.EventMultiplexer,N=new Map,_=X=>{const se=X.channelClient.getChannel(A).listen(G,H),re=z.add(se);N.set(X,re)},j=X=>{const Z=N.get(X);!Z||(Z.dispose(),N.delete(X))};B.connections.filter(x).forEach(_),l.Event.filter(B.onDidAddConnection,x)(_,void 0,ne),B.onDidRemoveConnection(j,void 0,ne),z.event(J.fire,J,ne),ne.add(z)},onLastListenerRemove:()=>{ne.dispose()}});return J.event}registerChannel(A,x){this.channels.set(A,x),this._connections.forEach(G=>{G.channelServer.registerChannel(A,x)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=T;class F{constructor(A,x,G=null){const H=new f;a(H,x),A.send(H.buffer),this.channelClient=new v(A,G),this.channelServer=new P(A,x,G)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,x){this.channelServer.registerChannel(A,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=F;function U(M){return{call(A,x,G){return M.then(H=>H.call(A,x,G))},listen(A,x){const G=new l.Relay;return M.then(H=>G.input=H.listen(A,x)),G.event}}}t.getDelayedChannel=U;function K(M){let A=!1;return{call(x,G,H){return A?M.call(x,G,H):(0,b.timeout)(0).then(()=>A=!0).then(()=>M.call(x,G,H))},listen(x,G){if(A)return M.listen(x,G);const H=new l.Relay;return(0,b.timeout)(0).then(()=>A=!0).then(()=>H.input=M.listen(x,G)),H.event}}}t.getNextTickChannel=K;class ee{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const x of A.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await l.Event.toPromise(A.onDidAddConnection),await this.route(A)}}t.StaticRouter=ee;var oe;(function(M){function A(B,ne){const J=B,z=ne&&ne.disableMarshalling,N=new Map;for(const _ in J)G(_)&&N.set(_,l.Event.buffer(J[_],!0));return new class{listen(_,j,X){const Z=N.get(j);if(Z)return Z;if(H(j)){const se=J[j];if(typeof se=="function")return se.call(J,X)}throw new Error(`Event not found: ${j}`)}call(_,j,X){const Z=J[j];if(typeof Z=="function"){if(!z&&Array.isArray(X))for(let se=0;se<X.length;se++)X[se]=(0,E.revive)(X[se]);return Z.apply(J,X)}throw new Error(`Method not found: ${j}`)}}}M.fromService=A;function x(B,ne){const J=ne&&ne.disableMarshalling;return new Proxy({},{get(z,N){if(typeof N=="string")return ne?.properties?.has(N)?ne.properties.get(N):H(N)?function(_){return B.listen(N,_)}:G(N)?B.listen(N):async function(..._){let j;ne&&!(0,g.isUndefinedOrNull)(ne.context)?j=[ne.context,..._]:j=_;const X=await B.call(N,j);return J?X:(0,E.revive)(X)};throw new Error(`Property not found: ${String(N)}`)}})}M.toService=x;function G(B){return B[0]==="o"&&B[1]==="n"&&I.isUpperAsciiLetter(B.charCodeAt(2))}function H(B){return/^onDynamic/.test(B)&&I.isUpperAsciiLetter(B.charCodeAt(9))}})(oe=t.ProxyChannel||(t.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let A=M.toString();if(A!=="[object Object]")return A}return M}function ae(M){return Array.isArray(M)?M.map(ue):ue(M)}function $(M,A,x,G,H,B,ne){ne=ae(ne);const J=te[H],z=J[G%J.length];let N=[`%c[${M}]%c[${String(A).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${z}`];/\($/.test(B)?(N=N.concat(ne),N.push(")")):N.push(ne),console.log.apply(console,N)}t.logWithColors=$;class ie{constructor(A,x){this._outgoingPrefix=A,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,x,G,H,B){this._totalOutgoing+=A,$(this._outgoingPrefix,this._totalOutgoing,A,x,G,H,B)}logIncoming(A,x,G,H,B){this._totalIncoming+=A,$(this._incomingPrefix,this._totalIncoming,A,x,G,H,B)}}t.IPCLogger=ie}),define(Y[65],Q([0,1,3,10,2,11]),function(V,t,C,b,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var R;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(R=t.StorageHint||(t.StorageHint={}));function L(I){const g=I;return g?.changed instanceof Map||g?.deleted instanceof Set}t.isStorageItemsChangeEvent=L;var l;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(l||(l={}));class d extends w.Disposable{constructor(g,S=Object.create(null)){super();this.database=g,this.options=S,this._onDidChangeStorage=this._register(new b.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((S,c)=>this.accept(c,S)),g.deleted?.forEach(S=>this.accept(S,void 0))}accept(g,S){if(this.state===l.Closed)return;let c=!1;(0,D.isUndefinedOrNull)(S)?c=this.cache.delete(g):this.cache.get(g)!==S&&(this.cache.set(g,S),c=!0),c&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,S){const c=this.cache.get(g);return(0,D.isUndefinedOrNull)(c)?S:c}getBoolean(g,S){const c=this.get(g);return(0,D.isUndefinedOrNull)(c)?S:c==="true"}getNumber(g,S){const c=this.get(g);return(0,D.isUndefinedOrNull)(c)?S:parseInt(c,10)}async set(g,S){if(this.state===l.Closed)return;if((0,D.isUndefinedOrNull)(S))return this.delete(g);const c=String(S);if(this.cache.get(g)!==c)return this.cache.set(g,c),this.pendingInserts.set(g,c),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async delete(g){if(!(this.state===l.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=b.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((S,c)=>this.items.set(c,S)),g.delete&&g.delete.forEach(S=>this.items.delete(S))}async close(){}}t.InMemoryStorageDatabase=E}),define(Y[66],Q([4,5]),function(V,t){return V.create("vs/base/common/date",t)}),define(Y[67],Q([0,1,66]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const b=60,w=b*60,D=w*24,R=D*7,L=D*30,l=D*365;function d(I,g){typeof I!="number"&&(I=I.getTime());const S=Math.round((new Date().getTime()-I)/1e3);if(S<-30)return(0,C.localize)(0,null,d(new Date().getTime()+S*1e3,!1));if(S<30)return(0,C.localize)(1,null);let c;return S<b?(c=S,g?c===1?(0,C.localize)(2,null,c):(0,C.localize)(3,null,c):c===1?(0,C.localize)(4,null,c):(0,C.localize)(5,null,c)):S<w?(c=Math.floor(S/b),g?c===1?(0,C.localize)(6,null,c):(0,C.localize)(7,null,c):c===1?(0,C.localize)(8,null,c):(0,C.localize)(9,null,c)):S<D?(c=Math.floor(S/w),g?c===1?(0,C.localize)(10,null,c):(0,C.localize)(11,null,c):c===1?(0,C.localize)(12,null,c):(0,C.localize)(13,null,c)):S<R?(c=Math.floor(S/D),g?c===1?(0,C.localize)(14,null,c):(0,C.localize)(15,null,c):c===1?(0,C.localize)(16,null,c):(0,C.localize)(17,null,c)):S<L?(c=Math.floor(S/R),g?c===1?(0,C.localize)(18,null,c):(0,C.localize)(19,null,c):c===1?(0,C.localize)(20,null,c):(0,C.localize)(21,null,c)):S<l?(c=Math.floor(S/L),g?c===1?(0,C.localize)(22,null,c):(0,C.localize)(23,null,c):c===1?(0,C.localize)(24,null,c):(0,C.localize)(25,null,c)):(c=Math.floor(S/l),g?c===1?(0,C.localize)(26,null,c):(0,C.localize)(27,null,c):c===1?(0,C.localize)(28,null,c):(0,C.localize)(29,null,c))}t.fromNow=d;function E(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=E}),define(Y[68],Q([4,5]),function(V,t){return V.create("vs/base/common/errorMessage",t)}),define(Y[28],Q([0,1,20,11,68]),function(V,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function D(d,E){return E&&(d.stack||d.stacktrace)?w.localize(0,null,L(d),R(d.stack)||R(d.stacktrace)):L(d)}function R(d){return Array.isArray(d)?d.join(`
`):d}function L(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?w.localize(1,null,d.message):d.message||w.localize(2,null)}function l(d=null,E=!1){if(!d)return w.localize(3,null);if(Array.isArray(d)){const I=C.coalesce(d),g=l(I[0],E);return I.length>1?w.localize(4,null,g,I.length):g}if(b.isString(d))return d;if(d.detail){const I=d.detail;if(I.error)return D(I.error,E);if(I.exception)return D(I.exception,E)}return d.stack?D(d,E):d.message?d.message:w.localize(5,null)}t.toErrorMessage=l}),define(Y[69],Q([4,5]),function(V,t){return V.create("vs/base/node/processes",t)}),define(Y[49],Q([0,1,39,47,6,18,7,12,29,58,11,62,13,69]),function(V,t,C,b,w,D,R,L,l,d,E,I,g,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.removeDangerousEnvVariables=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return d.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return d.TerminateResponseCode}});function c(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(e,i){if(L.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};i&&(n.cwd=i);const r=C.execFile("taskkill",["/T","/F","/PID",e.pid.toString()],n);return new Promise(a=>{r.once("error",y=>{a({success:!1,error:y})}),r.once("exit",(y,P)=>{a(y===0?{success:!0}:{success:!1,code:y!==null?y:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?c(n.status):1})}else if(L.isLinux||L.isMacintosh)try{const n=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(r=>{C.execFile(n,[e.pid.toString()],{encoding:"utf8",shell:!0},(a,y,P)=>{r(a?{success:!1,error:a}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else e.kill("SIGKILL");return Promise.resolve({success:!0})}function m(e){!e||(delete e.DEBUG,L.isMacintosh&&delete e.DYLD_LIBRARY_PATH,L.isLinux&&delete e.LD_PRELOAD)}t.removeDangerousEnvVariables=m;function p(e=l.env){return e.comspec||"cmd.exe"}t.getWindowsShell=p;class h{constructor(i,n,r,a){if(n!==void 0&&r!==void 0&&a!==void 0)this.cmd=i,this.args=n,this.shell=r,this.options=a;else{const y=i;this.cmd=y.command,this.shell=y.isShellCommand,this.args=y.args.slice(0),this.options=y.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const y=Object.create(null);Object.keys(l.env).forEach(P=>{y[P]=l.env[P]}),Object.keys(this.options.env).forEach(P=>{y[P]=this.options.env[P]}),this.options.env=y}}getSanitizedCommand(){let i=this.cmd.toLowerCase();const n=i.lastIndexOf(R.sep);return n!==-1&&(i=i.substring(n+1)),h.WellKnowCommands[i]?i:"other"}start(i){return L.isWindows&&(this.options&&this.options.cwd&&b.isUNC(this.options.cwd)||!this.options&&b.isUNC(l.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(n=>{let r,a;const y=new Promise((P,O)=>{r=P,a=O});if(n){let P=this.cmd;this.args&&(P=P+" "+this.args.join(" ")),this.childProcess=C.exec(P,this.options,(O,v,T)=>{this.childProcess=null;const F=O;F&&F.killed?a({killed:this.terminateRequested,stdout:v.toString(),stderr:T.toString()}):this.handleExec(r,i,O,v,T)})}else{let P=null;const O=v=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(v,r,i,a);const T={terminated:this.terminateRequested};E.isNumber(v)&&(T.cmdCode=v),r(T)};if(this.shell&&L.isWindows){const v=D.deepClone(this.options);v.windowsVerbatimArguments=!0,v.detached=!1;let T=!1,F=!1;const U=[];let K=this.ensureQuotes(this.cmd);U.push(K.value),T=K.quoted,this.args&&this.args.forEach(oe=>{K=this.ensureQuotes(oe),U.push(K.value),F=F&&K.quoted});const ee=["/s","/c"];T?F?ee.push('"'+U.join(" ")+'"'):U.length>1?ee.push('"'+U[0]+'" '+U.slice(1).join(" ")):ee.push('"'+U[0]+'"'):ee.push(U.join(" ")),P=C.spawn(p(),ee,v)}else this.cmd&&(P=C.spawn(this.cmd,this.args,this.options));P&&(this.childProcess=P,this.childProcessPromise=Promise.resolve(P),this.pidResolve&&(this.pidResolve(E.isNumber(P.pid)?P.pid:-1),this.pidResolve=void 0),P.on("error",v=>{this.childProcess=null,a({terminated:this.terminateRequested,error:v})}),P.pid&&(this.childProcess.on("close",O),this.handleSpawn(P,r,i,a,!0)))}return y})}handleClose(i,n,r,a){}ensureQuotes(i){return h.regexp.test(i)?{value:'"'+i+'"',quoted:!0}:{value:i,quoted:i.length>0&&i[0]==='"'&&i[i.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(i=>i.pid,i=>-1):new Promise(i=>{this.pidResolve=i})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(i=>(this.terminateRequested=!0,u(i,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),i=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(i=>{if(!this.shell||!L.isWindows)return i(!1);const n=C.spawn(p(),["/s","/c"]);n.on("error",r=>i(!0)),n.on("exit",r=>i(!1))})}}t.AbstractProcess=h,h.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},h.regexp=/^[^"].* .*[^"]/;class f extends h{constructor(i,n,r,a){super(i,n,r,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(i,n,r,a,y){[a,y].forEach((P,O)=>{const v=new I.LineDecoder;v.write(P).forEach(U=>{n({line:U,source:O===0?0:1})});const F=v.end();F&&n({line:F,source:O===0?0:1})}),i({terminated:this.terminateRequested,error:r})}handleSpawn(i,n,r,a,y){const P=new I.LineDecoder,O=new I.LineDecoder;i.stdout.on("data",v=>{P.write(v).forEach(F=>r({line:F,source:0}))}),i.stderr.on("data",v=>{O.write(v).forEach(F=>r({line:F,source:1}))}),this.stdoutLineDecoder=P,this.stderrLineDecoder=O}handleClose(i,n,r,a){const y=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;y&&r({line:y,source:0});const P=this.stderrLineDecoder?this.stderrLineDecoder.end():null;P&&r({line:P,source:1})}}t.LineProcess=f;function o(e){let i=[],n=!1;const r=function(a){if(n){i.push(a);return}(!e.send(a,P=>{if(P&&console.error(P),n=!1,i.length>0){const O=i.slice(0);i=[],O.forEach(v=>r(v))}})||L.isWindows)&&(n=!0)};return{send:r}}t.createQueuedSender=o;var s;(function(e){async function i(n,r,a){if(R.isAbsolute(n))return n;if(r===void 0&&(r=l.cwd()),R.dirname(n)!=="."||(a===void 0&&E.isString(l.env.PATH)&&(a=l.env.PATH.split(R.delimiter)),a===void 0||a.length===0))return R.join(r,n);async function P(O){if(await g.Promises.exists(O)){let v;try{v=await g.Promises.stat(O)}catch(T){T.message.startsWith("EACCES")&&(v=await g.Promises.lstat(O))}return v?!v.isDirectory():!1}return!1}for(let O of a){let v;if(R.isAbsolute(O)?v=R.join(O,n):v=R.join(r,O,n),await P(v))return v;let T=v+".com";if(await P(T)||(T=v+".exe",await P(T)))return T}return R.join(r,n)}e.findExecutable=i})(s=t.win32||(t.win32={}))}),define(Y[70],Q([0,1,35,12,64,49]),function(V,t,C,b,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function R(S,c){return S===1?b.isWindows?I():D.getWindowsShell(c):d(S,c)}t.getSystemShell=R;function L(S,c){return S===1?b.isWindows?g(c):D.getWindowsShell(c):d(S,c)}t.getSystemShellSync=L;let l=null;function d(S,c){if(b.isLinux&&S===2||b.isMacintosh&&S===3)return"/bin/bash";if(!l){let u;if(b.isWindows)u="/bin/bash";else{if(u=c.SHELL,!u)try{u=(0,C.userInfo)().shell}catch(m){}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}l=u}return l}let E=null;async function I(){return E||(E=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),E}function g(S){if(E)return E;const c=b.isWindows&&parseFloat((0,C.release)())>=10,u=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),m=`${S.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?m:D.getWindowsShell(S)}}),define(Y[40],Q([0,1,39,3,17,24,59,9,10,2,18,49,36]),function(V,t,C,b,w,D,R,L,l,d,E,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class S extends g.ChannelServer{constructor(m){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch(h){}},onMessage:l.Event.fromNodeEventEmitter(process,"message",p=>w.VSBuffer.wrap(Buffer.from(p,"base64")))},m);process.once("disconnect",()=>this.dispose())}}t.Server=S;class c{constructor(m,p){this.modulePath=m,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new b.Delayer(h),this.child=null,this._client=null}getChannel(m){const p=this;return{call(h,f,o){return p.requestPromise(m,h,f,o)},listen(h,f){return p.requestEvent(m,h,f)}}}requestPromise(m,p,h,f=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(L.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(m),s=(0,b.createCancelablePromise)(n=>o.call(p,h,n)),e=f.onCancellationRequested(()=>s.cancel()),i=(0,d.toDisposable)(()=>s.cancel());return this.activeRequests.add(i),s.finally(()=>{e.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(m,p,h){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let f;const o=new l.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(m).listen(p,h)(o.fire,o),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,I.removeDangerousEnvVariables)(p.env),this.child=(0,C.fork)(this.modulePath,m,p);const h=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,R.isRemoteConsoleLog)(r)){(0,R.log)(r,`IPC Library: ${this.options.serverName}`);return}h.fire(w.VSBuffer.wrap(Buffer.from(r,"base64")))});const o=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,s=r=>this.child&&this.child.connected&&o.send(r.buffer.toString("base64")),e=h.event,i={send:s,onMessage:e};this._client=new g.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,a)=>{process.removeListener("exit",n),this.activeRequests.forEach(y=>(0,d.dispose)(y)),this.activeRequests.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:a})})}return this._client}getCachedChannel(m){let p=this.channels.get(m);return p||(p=this.client.getChannel(m),this.channels.set(m,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=c}),define(Y[71],Q([4,5]),function(V,t){return V.create("vs/base/node/zip",t)}),define(Y[72],Q([4,5]),function(V,t){return V.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Y[73],Q([4,5]),function(V,t){return V.create("vs/platform/environment/node/shellEnv",t)}),define(Y[74],Q([4,5]),function(V,t){return V.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Y[75],Q([4,5]),function(V,t){return V.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Y[76],Q([4,5]),function(V,t){return V.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Y[77],Q([4,5]),function(V,t){return V.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Y[78],Q([4,5]),function(V,t){return V.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Y[79],Q([4,5]),function(V,t){return V.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Y[80],Q([4,5]),function(V,t){return V.create("vs/platform/extensions/common/extensionValidator",t)}),define(Y[81],Q([4,5]),function(V,t){return V.create("vs/platform/files/common/fileService",t)}),define(Y[82],Q([4,5]),function(V,t){return V.create("vs/platform/files/common/io",t)}),define(Y[83],Q([4,5]),function(V,t){return V.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Y[84],Q([4,5]),function(V,t){return V.create("vs/platform/request/common/request",t)}),define(Y[85],Q([4,5]),function(V,t){return V.create("vs/platform/telemetry/common/telemetryService",t)}),define(Y[86],Q([0,1,67,46,6,7,29,19,8]),function(V,t,C,b,w,D,R,L,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(u,m,p){this._args=u,this.paths=m,this.productService=p}get appRoot(){return(0,D.dirname)(w.FileAccess.asFileUri("",V).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,L.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(l.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=R.env.VSCODE_PORTABLE;return u?l.URI.file((0,D.join)(u,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,L.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,D.resolve)(u):(0,D.normalize)((0,D.join)(w.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=this.args["extensions-download-dir"];return u?(0,D.resolve)(u):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,D.resolve)(u);const m=R.env.VSCODE_EXTENSIONS;if(m)return m;const p=R.env.VSCODE_PORTABLE;return p?(0,D.join)(p,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(m=>/^[^:/?#]+?:\/\//.test(m)?l.URI.parse(m):l.URI.file((0,D.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?l.URI.parse(u):l.URI.file((0,D.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,L.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([b.memoize],d.prototype,"appRoot",null),de([b.memoize],d.prototype,"userHome",null),de([b.memoize],d.prototype,"userDataPath",null),de([b.memoize],d.prototype,"appSettingsHome",null),de([b.memoize],d.prototype,"tmpDir",null),de([b.memoize],d.prototype,"userRoamingDataHome",null),de([b.memoize],d.prototype,"settingsResource",null),de([b.memoize],d.prototype,"userDataSyncHome",null),de([b.memoize],d.prototype,"userDataSyncLogResource",null),de([b.memoize],d.prototype,"sync",null),de([b.memoize],d.prototype,"machineSettingsResource",null),de([b.memoize],d.prototype,"globalStorageHome",null),de([b.memoize],d.prototype,"workspaceStorageHome",null),de([b.memoize],d.prototype,"keybindingsResource",null),de([b.memoize],d.prototype,"keyboardLayoutResource",null),de([b.memoize],d.prototype,"argvResource",null),de([b.memoize],d.prototype,"snippetsHome",null),de([b.memoize],d.prototype,"isExtensionDevelopment",null),de([b.memoize],d.prototype,"untitledWorkspacesHome",null),de([b.memoize],d.prototype,"installSourcePath",null),de([b.memoize],d.prototype,"builtinExtensionsPath",null),de([b.memoize],d.prototype,"extensionsPath",null),de([b.memoize],d.prototype,"extensionDevelopmentLocationURI",null),de([b.memoize],d.prototype,"extensionDevelopmentKind",null),de([b.memoize],d.prototype,"extensionTestsLocationURI",null),de([b.memoize],d.prototype,"debugExtensionHost",null),de([b.memoize],d.prototype,"serviceMachineIdResource",null),de([b.memoize],d.prototype,"telemetryLogResource",null),de([b.memoize],d.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=d;function E(c,u){return S(c["inspect-extensions"],c["inspect-brk-extensions"],5870,u,c.debugId,c.extensionEnvironment)}t.parseExtensionHostPort=E;function I(c,u){return S(c["inspect-search"],c["inspect-brk-search"],5876,u,c.extensionEnvironment)}t.parseSearchPort=I;function g(c,u){return S(c["inspect-ptyhost"],c["inspect-brk-ptyhost"],5877,u,c.extensionEnvironment)}t.parsePtyHostPort=g;function S(c,u,m,p,h,f){const s=Number(u||c)||(p?null:m),e=s?Boolean(!!u):!1;let i;if(f)try{i=JSON.parse(f)}catch{}return{port:s,break:e,debugId:h,env:i}}}),function(){"use strict";function V(t,C,b,w){function D(L){const l=R(L),d=[l];return t.isAbsolute(l)||d.unshift(w),t.resolve(...d)}function R(L){const l=process.env.VSCODE_PORTABLE;if(l)return t.join(l,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,b);const E=L["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(I,"AppData","Roaming")}break;case"darwin":d=t.join(C.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,b)}return{getUserDataPath:D}}if(typeof define=="function")define(Y[87],Q([0,128,35,6,19,29]),function(t,C,b,w,D,R){const L=D.dirname(w.FileAccess.asFileUri("",t)),l=t.__$__nodeRequire(D.joinPath(L,"package.json").fsPath);return V(C,b,l.name,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),C=require("path"),b=require("os");module.exports=V(C,b,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[88],Q([0,1,35,86,87]),function(V,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class D extends b.AbstractNativeEnvironmentService{constructor(L,l){super(L,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,w.getUserDataPath)(L)},l)}}t.NativeEnvironmentService=D}),define(Y[89],Q([0,1,18]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const b=/^%([\w\d.-]+)%$/i;function w(D,R){const L=l=>{if(typeof l!="string")return;const d=b.exec(l);if(!d)return;const E=R[d[1]]??l;return typeof E=="string"?E:typeof E.message=="string"?E.message:l};return(0,C.cloneAndChange)(D,L)}t.localizeManifest=w}),define(Y[50],Q([0,1,80]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function D(g){return g=g.trim(),g==="*"||b.test(g)}t.isValidVersionStr=D;function R(g){if(!D(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=g.match(b);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}t.parseVersion=R;function L(g){if(!g)return null;let S=g.majorBase,c=g.majorMustEqual,u=g.minorBase,m=g.minorMustEqual,p=g.patchBase,h=g.patchMustEqual;g.hasCaret&&(S===0||(m=!1),h=!1);let f=0;if(g.preRelease){const o=w.exec(g.preRelease);if(o){const[,s,e,i]=o;f=Date.UTC(Number(s),Number(e)-1,Number(i))}}return{majorBase:S,majorMustEqual:c,minorBase:u,minorMustEqual:m,patchBase:p,patchMustEqual:h,isMinimum:g.hasGreaterEquals,notBefore:f}}t.normalizeVersion=L;function l(g,S,c){let u;typeof g=="string"?u=L(R(g)):u=g;let m;S instanceof Date?m=S.getTime():typeof S=="string"&&(m=new Date(S).getTime());let p;if(typeof c=="string"?p=L(R(c)):p=c,!u||!p)return!1;let h=u.majorBase,f=u.minorBase,o=u.patchBase,s=p.majorBase,e=p.minorBase,i=p.patchBase,n=p.notBefore,r=p.majorMustEqual,a=p.minorMustEqual,y=p.patchMustEqual;return p.isMinimum?h>s?!0:h<s?!1:f>e?!0:f<e||m&&m<n?!1:o>=i:(h===1&&s===0&&(!r||!a||!y)&&(s=1,e=0,i=0,r=!0,a=!1,y=!1),h<s?!1:h>s?!r:f<e?!1:f>e?!a:o<i?!1:o>i?!y:!(m&&m<n))}t.isValidVersion=l;function d(g,S,c,u){return c.isBuiltin||typeof c.main=="undefined"?!0:I(g,S,c.engines.vscode,u)}t.isValidExtensionVersion=d;function E(g,S,c){return g==="*"||I(S,c,g)}t.isEngineValid=E;function I(g,S,c,u=[]){let m=L(R(c));if(!m)return u.push(C.localize(0,null,c)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return u.push(C.localize(1,null,c)),!1}else if(!m.majorMustEqual)return u.push(C.localize(2,null,c)),!1;return l(g,S,m)?!0:(u.push(C.localize(3,null,g,c)),!1)}}),define(Y[51],Q([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class C{constructor(w,D=[],R=!1){this.ctor=w,this.staticArguments=D,this.supportsDelayedInstantiation=R}}t.SyncDescriptor=C}),define(Y[90],Q([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class C{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}t.Node=C;class b{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let R of this._nodes.values())R.outgoing.size===0&&D.push(R);return D}insertEdge(D,R){const L=this.lookupOrInsertNode(D),l=this.lookupOrInsertNode(R);L.outgoing.set(this._hashFn(R),l),l.incoming.set(this._hashFn(D),L)}removeNode(D){const R=this._hashFn(D);this._nodes.delete(R);for(let L of this._nodes.values())L.outgoing.delete(R),L.incoming.delete(R)}lookupOrInsertNode(D){const R=this._hashFn(D);let L=this._nodes.get(R);return L||(L=new C(D),this._nodes.set(R,L)),L}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[R,L]of this._nodes)D.push(`${R}, (incoming)[${[...L.incoming.keys()].join(", ")}], (outgoing)[${[...L.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,R]of this._nodes){const L=new Set([D]),l=this._findCycle(R,L);if(l)return l}}_findCycle(D,R){for(let[L,l]of D.outgoing){if(R.has(L))return[...R,L].join(" -> ");R.add(L);const d=this._findCycle(l,R);if(d)return d;R.delete(L)}}}t.Graph=b}),define(Y[52],Q([0,1,15]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,C.createDecorator)("downloadService")}),define(Y[21],Q([0,1,15]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,C.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,C.refineServiceDecorator)(t.IEnvironmentService)}),define(Y[22],Q([0,1,6,75,15]),function(V,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var D;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(D=t.TargetPlatform||(t.TargetPlatform={}));function R(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=R;function L(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=L;function l(h,f){switch(h){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=l;function d(h,f){return f==="web"&&!h.includes("web")}t.isNotWebExtensionInWebTargetPlatform=d;function E(h,f,o){return d(f,o)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===o?!0:I(o).includes(h)}t.isTargetPlatformCompatible=E;function I(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=I;function g(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}t.isIExtensionIdentifier=g;var S;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(S=t.SortBy||(t.SortBy={}));var c;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(c=t.SortOrder||(t.SortOrder={}));var u;(function(h){h.Install="install",h.Uninstall="uninstall"})(u=t.StatisticType||(t.StatisticType={}));var m;(function(h){h[h.None=0]="None",h[h.Install=1]="Install",h[h.Update=2]="Update"})(m=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,w.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class p extends Error{constructor(f,o){super(f);this.code=o,this.name=o}}t.ExtensionManagementError=p,t.IExtensionManagementService=(0,w.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,w.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,w.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",V).toString(!0),t.ExtensionsLabel=(0,b.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,b.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,w.createDecorator)("IExtensionManagementCLIService")}),define(Y[91],Q([0,1,39,7,73,24,28,9,12,31,70,129,3]),function(V,t,C,b,w,D,R,L,l,d,E,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;const S=1e4;let c;async function u(p,h,f){return h["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(f)&&!h["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(f)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),c||(c=g.Promises.withAsyncBody(async(o,s)=>{const e=new D.CancellationTokenSource,i=setTimeout(()=>{e.dispose(!0),s(new Error((0,w.localize)(0,null)))},S);try{o(await m(p,e.token))}catch(n){!(0,L.isPromiseCanceledError)(n)&&!e.token.isCancellationRequested?s(new Error((0,w.localize)(1,null,(0,R.toErrorMessage)(n)))):o({})}finally{clearTimeout(i),e.dispose()}})),c)}t.resolveShellEnv=u;async function m(p,h){const f=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",f);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",o);const s=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",i);const n=await(0,E.getSystemShell)(l.OS,i);return p.trace("getUnixShellEnvironment#shell",n),new Promise((r,a)=>{if(h.isCancellationRequested)return a((0,L.canceled)());const y=(0,b.basename)(n);let P,O;/^pwsh(-preview)?$/.test(y)?(P=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,O=["-Login","-Command"]):(P=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,O=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(O),P);const v=(0,C.spawn)(n,[...O,P],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});h.onCancellationRequested(()=>(v.kill(),a((0,L.canceled)()))),v.on("error",U=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(U)),a(U)});const T=[];v.stdout.on("data",U=>T.push(U));const F=[];v.stderr.on("data",U=>F.push(U)),v.on("close",(U,K)=>{const ee=Buffer.concat(T).toString("utf8");p.trace("getUnixShellEnvironment#raw",ee);const oe=Buffer.concat(F).toString("utf8");if(oe.trim()&&p.trace("getUnixShellEnvironment#stderr",oe),U||K)return a(new Error((0,w.localize)(2,null,U,K)));const te=e.exec(ee),ue=te?te[1]:"{}";try{const ae=JSON.parse(ue);f?ae.ELECTRON_RUN_AS_NODE=f:delete ae.ELECTRON_RUN_AS_NODE,o?ae.ELECTRON_NO_ATTACH_CONSOLE=o:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",ae),r(ae)}catch(ae){p.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(ae)),a(ae)}})})}}),define(Y[32],Q([0,1,2,12,8,16]),function(V,t,C,b,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=t.WatcherService=void 0;class R extends C.Disposable{}t.WatcherService=R;function L(E){return E.map(I=>({type:I.type,resource:w.URI.file(I.path)}))}t.toFileChanges=L;function l(E){const I=new d;for(const g of E)I.processEvent(g);return I.normalize()}t.normalizeFileChanges=l;class d{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(I){return b.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const g=this.mapPathToChange.get(this.toKey(I));let S=!1;if(g){const c=g.type,u=I.type;g.path!==I.path&&I.type===2?S=!0:c===1&&u===2?(this.mapPathToChange.delete(this.toKey(I)),this.normalized.delete(g)):c===2&&u===1?g.type=0:c===1&&u===0||(g.type=u)}else S=!0;S&&(this.normalized.add(I),this.mapPathToChange.set(this.toKey(I),I))}normalize(){const I=[],g=[];return Array.from(this.normalized).filter(S=>S.type!==2?(I.push(S),!1):!0).sort((S,c)=>S.path.length-c.path.length).filter(S=>g.some(c=>(0,D.isParent)(S.path,c,!b.isLinux))?!1:(g.push(S.path),!0)).concat(I)}}}),define(Y[92],Q([0,1,3,2,7,63,13,130,32]),function(V,t,C,b,w,D,R,L,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends b.Disposable{constructor(I,g,S,c){super();this.path=I,this.onDidFilesChange=g,this.onLogMessage=S,this.verboseLogging=c,this.fileChangesDelayer=this._register(new C.ThrottledDelayer(L.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:g}=await R.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let S=this.path;if(g)try{S=await(0,D.realpath)(S)}catch(c){if(this.onError(c),g.dangling)return}I.isDirectory()?this._register((0,L.watchFolder)(S,(c,u)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:(0,w.join)(this.path,(0,w.basename)(u))})},c=>this.onError(c))):this._register((0,L.watchFile)(S,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,l.normalizeFileChanges)(g);if(this.verboseLogging)for(const c of S)this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);S.length>0&&this.onDidFilesChange(S)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(Y[93],Q([0,1,6,36,40,32]),function(V,t,C,b,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R extends D.WatcherService{constructor(l,d,E){super();this.onDidFilesChange=l,this.onLogMessage=d,this.verboseLogging=E,this.isDisposed=!1,this.startWatching()}startWatching(){const l=this._register(new w.Client(C.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=b.ProxyChannel.toService((0,b.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d)))}async setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||await this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${l}`})}async watch(l){this.isDisposed||await this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=R}),define(Y[94],Q([0,1,2,6,36,40,32]),function(V,t,C,b,w,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class L extends R.WatcherService{constructor(d,E,I){super();this.onDidFilesChange=d,this.onLogMessage=E,this.verboseLogging=I,this.serviceDisposables=this._register(new C.MutableDisposable),this.requests=void 0,this.restartCounter=0,this.init()}init(){const d=new C.DisposableStore;this.serviceDisposables.value=d;const E=d.add(new D.Client(b.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));d.add(E.onDidProcessExit(()=>{this.restartCounter<=L.MAX_RESTARTS&&this.requests?(this.error("terminated unexpectedly and is restarted again..."),this.restart(this.requests)):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!")})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(E.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),d.add(this.service.onDidChangeFile(I=>this.onDidFilesChange(I))),d.add(this.service.onDidLogMessage(I=>this.onLogMessage(I)))}restart(d){this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.service?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${d}`})}dispose(){return this.service=void 0,super.dispose()}}t.FileWatcher=L,L.MAX_RESTARTS=5}),define(Y[95],Q([0,1,6,36,40,32]),function(V,t,C,b,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R extends D.WatcherService{constructor(l,d,E,I={}){super();this.onDidFilesChange=l,this.onLogMessage=d,this.verboseLogging=E,this.watcherOptions=I,this.isDisposed=!1,this.restartCounter=0,this.requests=void 0,this.startWatching()}startWatching(){const l=this._register(new w.Client(C.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherServiceChokidar"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=R.MAX_RESTARTS&&this.requests?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching(),this.service?.watch(this.requests)):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=b.ProxyChannel.toService((0,b.getNextTickChannel)(l.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d)))}async setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||await this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${l}`})}async watch(l){this.requests=l,await this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=R,R.MAX_RESTARTS=5}),define(Y[53],Q([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class C{constructor(...w){this._entries=new Map;for(let[D,R]of w)this.set(D,R)}set(w,D){const R=this._entries.get(w);return this._entries.set(w,D),R}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}t.ServiceCollection=C}),define(Y[96],Q([0,1,3,9,51,90,15,53]),function(V,t,C,b,w,D,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const l=!1;class d extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class E{constructor(c=new L.ServiceCollection,u=!1,m){this._activeInstantiations=new Set,this._services=c,this._strict=u,this._parent=m,this._services.set(R.IInstantiationService,this)}createChild(c){return new E(c,this._strict,this)}invokeFunction(c,...u){let m=g.traceInvocation(c),p=!1;try{return c({get:(f,o)=>{if(p)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(f,m);if(!s&&o!==R.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return s}},...u)}finally{p=!0,m.stop()}}createInstance(c,...u){let m,p;return c instanceof w.SyncDescriptor?(m=g.traceCreation(c.ctor),p=this._createInstance(c.ctor,c.staticArguments.concat(u),m)):(m=g.traceCreation(c),p=this._createInstance(c,u,m)),m.stop(),p}_createInstance(c,u=[],m){let p=R._util.getServiceDependencies(c).sort((o,s)=>o.index-s.index),h=[];for(const o of p){let s=this._getOrCreateServiceInstance(o.id,m);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${o.id}.`);h.push(s)}let f=p.length>0?p[0].index:u.length;if(u.length!==f){console.warn(`[createInstance] First service dependency of ${c.name} at position ${f+1} conflicts with ${u.length} static arguments`);let o=f-u.length;o>0?u=u.concat(new Array(o)):u=u.slice(0,f)}return new c(...[...u,...h])}_setServiceInstance(c,u){if(this._services.get(c)instanceof w.SyncDescriptor)this._services.set(c,u);else if(this._parent)this._parent._setServiceInstance(c,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let u=this._services.get(c);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):u}_getOrCreateServiceInstance(c,u){let m=this._getServiceInstanceOrDescriptor(c);return m instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,m,u.branch(c,!0)):(u.branch(c,!1),m)}_safeCreateAndCacheServiceInstance(c,u,m){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,u,m)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,u,m){const p=new D.Graph(o=>o.id.toString());let h=0;const f=[{id:c,desc:u,_trace:m}];for(;f.length;){const o=f.pop();if(p.lookupOrInsertNode(o),h++>1e3)throw new d(p);for(let s of R._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${c} depends on ${s.id} which is NOT registered.`),e instanceof w.SyncDescriptor){const i={id:s.id,desc:e,_trace:o._trace.branch(s.id,!0)};p.insertEdge(o,i),f.push(i)}}}for(;;){const o=p.roots();if(o.length===0){if(!p.isEmpty())throw new d(p);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof w.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}p.removeNode(s)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,u,m=[],p,h){if(this._services.get(c)instanceof w.SyncDescriptor)return this._createServiceInstance(u,m,p,h);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,u,m,p,h);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(c,u=[],m,p){if(m){const h=new C.IdleValue(()=>this._createInstance(c,u,p));return new Proxy(Object.create(null),{get(f,o){if(o in f)return f[o];let s=h.value,e=s[o];return typeof e!="function"||(e=e.bind(s),f[o]=e),e},set(f,o,s){return h.value[o]=s,!0}})}else return this._createInstance(c,u,p)}}t.InstantiationService=E;var I;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(I||(I={}));class g{constructor(c,u){this.type=c,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return l?new g(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(c){return l?new g(0,c.name):g._None}branch(c,u){let m=new g(2,c.toString());return this._dep.push([c,u,m]),m}stop(){let c=Date.now()-this._start;g._totals+=c;let u=!1;function m(h,f){let o=[],s=new Array(h+1).join("	");for(const[e,i,n]of f._dep)if(i&&n){u=!0,o.push(`${s}CREATES -> ${e}`);let r=m(h+1,n);r&&o.push(r)}else o.push(`${s}uses -> ${e}`);return o.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(c>2||u)&&console.log(p.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(Y[54],Q([0,1,15]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,C.createDecorator)("localizationsService");function b(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const D of w.translations)if(typeof D.id!="string"||typeof D.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}t.isValidLocalization=b}),define(Y[14],Q([0,1,28,10,2,12,15]),function(V,t,C,b,w,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,R.createDecorator)("logService"),t.ILoggerService=(0,R.createDecorator)("loggerService");function L(){return new Date().toISOString()}var l;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(l=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=l.Info;class d extends w.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=d;class E extends d{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(l.Trace)&&this.log(l.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(l.Debug)&&this.log(l.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(l.Info)&&this.log(l.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(l.Warning)&&this.log(l.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(l.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(l.Error,this.format(n))}else this.log(l.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(l.Critical)&&this.log(l.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let r=e[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}i+=(n>0?" ":"")+r}return i}}t.AbstractMessageLogger=E;class I extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!D.isWindows}trace(e,...i){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}debug(e,...i){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}info(e,...i){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}warn(e,...i){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${L()}][0m`,e,...i):console.warn(`[main ${L()}]`,e,...i))}error(e,...i){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}critical(e,...i){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=I;class g extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=g;class S extends d{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,C.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}t.AdapterLogger=S;class c extends d{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=c;class u extends w.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=u;class m extends w.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?l.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=m;class p{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=p;function h(s){if(s.verbose)return l.Trace;if(typeof s.logLevel=="string"){const e=f(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=h;function f(s){switch(s){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}t.parseLogLevel=f;function o(s){switch(s){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}t.LogLevelToString=o});var ce=this&&this.__param||function(V,t){return function(C,b){t(C,b,V)}};define(Y[97],Q([0,1,39,3,28,10,2,6,7,13,21,14]),function(V,t,C,b,w,D,R,L,l,d,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let g=class extends R.Disposable{constructor(c,u){super();this.environmentService=c,this.logService=u,this.processesLimiter=new b.Limiter(5)}async postUninstall(c){const u=this.parseScript(c,"uninstall");return u&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(u.script,"uninstall",u.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),m=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${m}`)))),d.Promises.rm(this.getExtensionStoragePath(c)).then(void 0,m=>this.logService.error("Error while removing extension storage path",m))}parseScript(c,u){const m=`vscode:${u}`;if(c.location.scheme===L.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[m]=="string"){const p=c.manifest.scripts[m].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${m} should be a node script`),null):{script:(0,l.join)(c.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(c,u,m,p,h){return new Promise((f,o)=>{const s=this.start(c,u,m,h);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?o(n):f(void 0)};s.on("error",n=>{i((0,w.toErrorMessage)(n)||"Unknown")}),s.on("exit",(n,r)=>{i(n?`post-${u} process exited with code ${n}`:void 0)}),p&&(e=setTimeout(()=>{e=null,s.kill(),o("timed out")},5e3))})}start(c,u,m,p){const h={silent:!0,execArgv:void 0},f=(0,C.fork)(c,[`--type=extension-post-${u}`,...m],h);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const o=D.Event.fromNodeEventEmitter(f.stdout,"data"),s=D.Event.fromNodeEventEmitter(f.stderr,"data");o(n=>this.logService.info(p.identifier.id,p.manifest.version,`post-${u}`,n)),s(n=>this.logService.error(p.identifier.id,p.manifest.version,`post-${u}`,n));const e=D.Event.any(D.Event.map(o,n=>({data:`%c${n}`,format:[""]})),D.Event.map(s,n=>({data:`%c${n}`,format:["color: red"]})));return D.Event.debounce(e,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(p.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(c){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};g=de([ce(0,E.IEnvironmentService),ce(1,I.ILogService)],g),t.ExtensionsLifecycle=g}),define(Y[98],Q([0,1,20,3,10,2,7,32,14]),function(V,t,C,b,w,D,R,L,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class d extends D.Disposable{constructor(I){super();this.logService=I,this._onDidErrorOccur=this._register(new w.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new w.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new b.ThrottledDelayer(0))}watch(I,g){return g.recursive?this.watchRecursive(I,g):this.watchNonRecursive(I)}watchRecursive(I,g){const S={path:this.toFilePath(I),excludes:g.excludes},c=(0,C.insert)(this.recursiveFoldersToWatch,S);return this.refreshRecursiveWatchers(),(0,D.toDisposable)(()=>{c(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(I=>this.logService.error(I))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(this.recursiveFoldersToWatch.length,I=>this._onDidChangeFile.fire((0,L.toFileChanges)(I)),I=>this.onWatcherLogMessage(I),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)}))),this.recursiveWatcher.watch(this.recursiveFoldersToWatch)}watchNonRecursive(I){const g=this.createNonRecursiveWatcher(this.toFilePath(I),c=>this._onDidChangeFile.fire((0,L.toFileChanges)(c)),c=>this.onWatcherLogMessage(c),this.logService.getLevel()===l.LogLevel.Trace),S=this.logService.onDidChangeLogLevel(()=>{g.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)});return(0,D.combinedDisposable)(g,S)}onWatcherLogMessage(I){I.type==="error"&&this._onDidErrorOccur.fire(I.message),this.logService[I.type](I.message)}toFilePath(I){return(0,R.normalize)(I.fsPath)}}t.AbstractDiskFileSystemProvider=d}),define(Y[99],Q([0,1,16,14]),function(V,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function w(l,d,E,I){try{const g=await new Promise((S,c)=>{V(["spdlog"],S,c)});return g.setFlushOn(b.LogLevel.Trace),g.createAsyncRotatingLogger(l,d,E,I)}catch(g){console.error(g)}return null}function D(l,d,E,I){const g=V.__$__nodeRequire("spdlog");return g.setFlushOn(b.LogLevel.Trace),g.createRotatingLogger(l,d,E,I)}t.createRotatingLogger=D;function R(l,d,E){switch(d){case b.LogLevel.Trace:l.trace(E);break;case b.LogLevel.Debug:l.debug(E);break;case b.LogLevel.Info:l.info(E);break;case b.LogLevel.Warning:l.warn(E);break;case b.LogLevel.Error:l.error(E);break;case b.LogLevel.Critical:l.critical(E);break;default:throw new Error("Invalid log level")}}class L extends b.AbstractMessageLogger{constructor(d,E,I,g){super();this.name=d,this.filepath=E,this.rotating=I,this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}_createSpdLogLogger(){const d=this.rotating?6:1,E=30/d*C.ByteSize.MB;return w(this.name,this.filepath,E,d).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:g,message:S}of this.buffer)R(this._logger,g,S);this.buffer=[]}})}log(d,E){this._logger?R(this._logger,d,E):this.getLevel()<=d&&this.buffer.push({level:d,message:E})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=L}),define(Y[55],Q([0,1,17,9,82,16,33]),function(V,t,C,b,w,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function L(I,g,S,c,u,m){let p;try{await l(I,g,S,c,u,m)}catch(h){p=h}finally{p&&u.errorTransformer&&(p=u.errorTransformer(p)),typeof p!="undefined"&&S.error(p),S.end()}}t.readFileIntoStream=L;async function l(I,g,S,c,u,m){d(m);const p=await I.open(g,{create:!1});try{d(m);let h=0,f=0,o=u&&typeof u.length=="number"?u.length:void 0,s=C.VSBuffer.alloc(Math.min(u.bufferSize,typeof o=="number"?o:u.bufferSize)),e=u&&typeof u.position=="number"?u.position:0,i=0;do f=await I.read(p,e,s.buffer,i,s.byteLength-i),e+=f,i+=f,h+=f,typeof o=="number"&&(o-=f),i===s.byteLength&&(await S.write(c(s)),s=C.VSBuffer.alloc(Math.min(u.bufferSize,typeof o=="number"?o:u.bufferSize)),i=0);while(f>0&&(typeof o!="number"||o>0)&&d(m)&&E(h,u));if(i>0){let n=i;typeof o=="number"&&(n=Math.min(i,o)),S.write(c(s.slice(0,n)))}}catch(h){throw(0,D.ensureFileSystemProviderError)(h)}finally{await I.close(p)}}function d(I){if(I.isCancellationRequested)throw(0,b.canceled)();return!0}function E(I,g){if(g?.limits){if(typeof g.limits.memory=="number"&&I>g.limits.memory)throw(0,D.createFileSystemProviderError)((0,w.localize)(0,null,R.default.nameShort),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&I>g.limits.size)throw(0,D.createFileSystemProviderError)((0,w.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[100],Q([0,1,20,3,17,24,10,131,2,101,6,132,19,38,81,16,55,14]),function(V,t,C,b,w,D,R,L,l,d,E,I,g,S,c,u,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let h=class Ue extends l.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new R.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new R.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new R.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new R.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new b.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new u.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new b.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new u.FileChangesEvent(s,!0)))),this.watchedResources=d.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const e=new l.DisposableStore;return e.add(s.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,l.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){s.push(e)}}),!this.provider.has(o)&&await b.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,s){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return L.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,g.isAbsolutePath)(o))throw new u.FileOperationError((0,c.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,c.localize)(1,null,o.toString()),e}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s)||(0,u.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(e){throw(0,u.toFileSystemProviderErrorCode)(e)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,c.localize)(2,null,this.resourceForError(o)),1):(0,u.ensureFileSystemProviderError)(e)}}async doResolveFile(o,s){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),n=s?.resolveTo,r=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,y=await e.stat(o);let P;return this.toFileStat(e,o,y,void 0,!!a,(O,v)=>(P||(P=d.TernarySearchTree.forUris(()=>!i),P.set(o,!0),n&&P.fill(!0,n)),P.get(O.resource)||P.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&r?v===1:!1))}async toFileStat(o,s,e,i,n,r){const{providerExtUri:a}=this.getExtUri(o),y={resource:s,name:a.basename(s),isFile:(e.type&u.FileType.File)!=0,isDirectory:(e.type&u.FileType.Directory)!=0,isSymbolicLink:(e.type&u.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&u.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,u.etag)({mtime:e.mtime,size:e.size})};if(y.isDirectory&&r(y,i)){try{const P=await o.readdir(s),O=await b.Promises.settled(P.map(async([v,T])=>{try{const F=a.joinPath(s,v),U=n?await o.stat(F):{type:T};return await this.toFileStat(o,F,U,P.length,n,r)}catch(F){return this.logService.trace(F),null}}));y.children=(0,C.coalesce)(O)}catch(P){this.logService.trace(P),y.children=[]}return y}return y}async resolveAll(o){return b.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(e){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(e){return e}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new u.FileOperationError((0,c.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=w.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,s);return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,i)),i}async writeFile(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,n.dirname(o));let a;if((0,u.hasReadWriteCapability)(i)&&!(s instanceof w.VSBuffer))if((0,S.isReadableStream)(s)){const y=await(0,S.peekStream)(s,3);y.ended?a=w.VSBuffer.concat(y.buffer):a=y}else a=(0,S.peekReadable)(s,y=>w.VSBuffer.concat(y),3);else a=s;!(0,u.hasOpenReadWriteCloseCapability)(i)||(0,u.hasReadWriteCapability)(i)&&a instanceof w.VSBuffer?await this.doWriteUnbuffered(i,o,e,a):await this.doWriteBuffered(i,o,e,a instanceof w.VSBuffer?(0,w.bufferToReadable)(a):a)}catch(r){throw new u.FileOperationError((0,c.localize)(4,null,this.resourceForError(o),(0,u.ensureFileSystemProviderError)(r).toString()),(0,u.toFileOperationResult)(r),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,c.localize)(5,null,this.resourceForError(s)));let n;try{n=await o.stat(s)}catch(r){return}if((n.type&u.FileType.Directory)!=0)throw new u.FileOperationError((0,c.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,n),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==u.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,u.etag)({mtime:e.mtime,size:n.size}))throw new u.FileOperationError((0,c.localize)(7,null),3,e);return n}async readFile(o,s){const e=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(e,o,s):this.doReadFile(e,o,s)}async doReadFileAtomic(o,s,e){return new Promise((i,n)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,s,e);i(r)}catch(r){n(r)}})})}async doReadFile(o,s,e){const i=await this.doReadFileStream(o,s,{...e,preferUnbuffered:!0});return{...i,value:await(0,w.streamToBuffer)(i.value)}}async readFileStream(o,s){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,s)}async doReadFileStream(o,s,e){const i=new D.CancellationTokenSource,n=this.validateReadFile(s,e).then(a=>a,a=>{throw i.cancel(),a});let r;try{return typeof e?.etag=="string"&&e.etag!==u.ETAG_DISABLED&&await n,!((0,u.hasOpenReadWriteCloseCapability)(o)||(0,u.hasFileReadStreamCapability)(o))||(0,u.hasReadWriteCapability)(o)&&e?.preferUnbuffered?r=this.readFileUnbuffered(o,s,e):(0,u.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,s,i.token,e):r=this.readFileBuffered(o,s,i.token,e),{...await n,value:r}}catch(a){r&&await(0,S.consumeStream)(r);const y=(0,c.localize)(8,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(a).toString());throw a instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(y,a.stat,e):new u.FileOperationError(y,(0,u.toFileOperationResult)(a),e)}}readFileStreamed(o,s,e,i=Object.create(null)){const n=o.readFileStream(s,i,e);return(0,S.transform)(n,{data:r=>r instanceof w.VSBuffer?r:w.VSBuffer.wrap(r),error:r=>new u.FileOperationError((0,c.localize)(9,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(r).toString()),(0,u.toFileOperationResult)(r),i)},r=>w.VSBuffer.concat(r))}readFileBuffered(o,s,e,i=Object.create(null)){const n=(0,w.newWriteableBufferStream)();return(0,m.readFileIntoStream)(o,s,n,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new u.FileOperationError((0,c.localize)(10,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(r).toString()),(0,u.toFileOperationResult)(r),i)},e),n}readFileUnbuffered(o,s,e){const i=(0,S.newWriteableStream)(n=>w.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(s);typeof e?.position=="number"&&(n=n.slice(e.position)),typeof e?.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(s,n.byteLength,e),i.end(w.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new u.FileOperationError((0,c.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==u.ETAG_DISABLED&&s.etag===e.etag)throw new u.NotModifiedSinceFileOperationError((0,c.localize)(12,null),e,s);return this.validateReadFileLimits(o,e.size,s),e}validateReadFileLimits(o,s,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&s>e.limits.size&&(i=7),typeof i=="number")throw new u.FileOperationError((0,c.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,s,e){return this.doCanMoveCopy(o,s,"move",e)}async canCopy(o,s,e){return this.doCanMoveCopy(o,s,"copy",e)}async doCanMoveCopy(o,s,e,i){if(o.toString()!==s.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,o,r,s,e,i)}catch(n){return n}return!0}async move(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,r==="move"?2:3,a)),a}async copy(o,s,e){const i=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,r==="copy"?3:2,a)),a}async doMoveCopy(o,s,e,i,n,r){if(s.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:y}=await this.doValidateMoveCopy(o,s,e,i,n,r);if(a&&!y&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(o===e&&(0,u.hasFileFolderCopyCapability)(o))await o.copy(s,i,{overwrite:r});else{const P=await this.resolve(s);P.isDirectory?await this.doCopyFolder(o,P,e,i):await this.doCopyFile(o,s,e,i)}return n}else return o===e?(await o.rename(s,i,{overwrite:r}),n):(await this.doMoveCopy(o,s,e,i,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,e,i){if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,s,e,i);if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,s,e,i);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,s,e,i);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,s,e,i)}async doCopyFolder(o,s,e,i){await e.mkdir(i),Array.isArray(s.children)&&await b.Promises.settled(s.children.map(async n=>{const r=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),e,r):this.doCopyFile(o,n.resource,e,r)}))}async doValidateMoveCopy(o,s,e,i,n,r){let a=!1;if(o===e){const{providerExtUri:P,isPathCaseSensitive:O}=this.getExtUri(o);if(O||(a=P.isEqual(s,i)),a&&n==="copy")throw new Error((0,c.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&P.isEqualOrParent(i,s))throw new Error((0,c.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const y=await this.exists(i);if(y&&!a){if(!r)throw new u.FileOperationError((0,c.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(o===e){const{providerExtUri:P}=this.getExtUri(o);if(P.isEqualOrParent(s,i))throw new Error((0,c.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:y,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,e)),e}async mkdirp(o,s){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(s,i.dirname(s));)try{if(((await o.stat(s)).type&u.FileType.Directory)==0)throw new Error((0,c.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,u.toFileSystemProviderErrorCode)(n)!==u.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(s)),s=i.dirname(s)}for(let n=e.length-1;n>=0;n--){s=i.joinPath(s,e[n]);try{await o.mkdir(s)}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(e){return e}return!0}async doValidateDelete(o,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,c.localize)(19,null,this.resourceForError(o)));let n;try{n=await e.stat(o)}catch(a){}if(n)this.throwIfFileIsReadonly(o,n);else throw new u.FileOperationError((0,c.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,c.localize)(21,null,this.resourceForError(o)))}return e}async del(o,s){const e=await this.doValidateDelete(o,s),i=!!s?.useTrash,n=!!s?.recursive;await e.delete(o,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new u.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let e,i;{for(const n of o)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new u.FileChangesEvent(e,!s))}if(i){const n=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Ue.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const e=new l.DisposableStore;let i=!1,n=()=>{i=!0};return e.add((0,l.toDisposable)(()=>n())),this.doWatch(o,s).then(r=>{i?(0,l.dispose)(r):n=()=>(0,l.dispose)(r)},r=>this.logService.error(r)),s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,l.toDisposable)(()=>{const r=this.watchedResources.get(o);typeof r=="number"&&(r<=1?this.watchedResources.delete(o):this.watchedResources.set(o,r-1))}))),e}async doWatch(o,s){const e=await this.withProvider(o),i=this.toWatchKey(e,o,s);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:e.watch(o,s)},this.activeWatchers.set(i,n)),n.count+=1,(0,l.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,l.dispose)(n.disposable),this.activeWatchers.delete(i)))})}toWatchKey(o,s,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,l.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,S.isReadableStream)(i)||(0,S.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,n,i):await this.doWriteReadableBufferedQueued(o,n,i)}catch(r){throw(0,u.ensureFileSystemProviderError)(r)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,s,e){let i=0,n;if((0,S.isReadableBufferedStream)(e)){if(e.buffer.length>0){const r=w.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,s,r,r.byteLength,i,0),i+=r.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise((r,a)=>{(0,S.listenStream)(n,{onData:async y=>{n.pause();try{await this.doWriteBuffer(o,s,y,y.byteLength,i,0)}catch(P){return a(P)}i+=y.byteLength,setTimeout(()=>n.resume())},onError:y=>a(y),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,s,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(o,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(o,s,e,i,n,r){let a=0;for(;a<i;)a+=await o.write(s,n+a,e.buffer,r+a,i-a)}async doWriteUnbuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,e,i))}async doWriteUnbufferedQueued(o,s,e,i){let n;i instanceof w.VSBuffer?n=i:(0,S.isReadableStream)(i)?n=await(0,w.streamToBuffer)(i):(0,S.isReadableBufferedStream)(i)?n=await(0,w.bufferedStreamToBuffer)(i):n=(0,w.readableToBuffer)(i),await o.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,e,i))}async doPipeBufferedQueued(o,s,e,i){let n,r;try{n=await o.open(s,{create:!1}),r=await e.open(i,{create:!0,unlock:!1});const a=w.VSBuffer.alloc(this.BUFFER_SIZE);let y=0,P=0,O=0;do O=await o.read(n,y,a.buffer,P,a.byteLength-P),await this.doWriteBuffer(e,r,a,O,y,P),y+=O,P+=O,P===a.byteLength&&(P=0);while(O>0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await b.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof r=="number"?e.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,e,i))}async doPipeUnbufferedQueued(o,s,e,i){return e.writeFile(i,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,e,i))}async doPipeUnbufferedToBufferedQueued(o,s,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const r=await o.readFile(s);await this.doWriteBuffer(e,n,w.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,u.ensureFileSystemProviderError)(r)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(o,s,e,i){const n=await(0,w.streamToBuffer)(this.readFileBuffered(o,s,D.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new u.FileOperationError((0,c.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,c.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===E.Schemas.file?o.fsPath:o.toString(!0)}};h.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},h=de([ce(0,p.ILogService)],h),t.FileService=h}),define(Y[102],Q([0,1,48,133,3,17,10,47,7,12,19,38,13,83,16,55,92,93,94,95,33,98,28]),function(V,t,C,b,w,D,R,L,l,d,E,I,g,S,c,u,m,p,h,f,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,b.gracefulify)(C)}catch(n){console.error(`Error enabling graceful-fs: ${(0,e.toErrorMessage)(n)}`)}})();class i extends s.AbstractDiskFileSystemProvider{constructor(r,a){super(r);this.options=a,this.onDidChangeCapabilities=R.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,d.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:y}=await g.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,y),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await g.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),y=[];return await Promise.all(a.map(async P=>{try{let O;P.isSymbolicLink()?O=(await this.stat((0,E.joinPath)(r,P.name))).type:O=this.toType(P),y.push([P.name,O])}catch(O){this.logService.trace(O)}})),y}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let y;return a?.dangling?y=c.FileType.Unknown:r.isFile()?y=c.FileType.File:r.isDirectory()?y=c.FileType.Directory:y=c.FileType.Unknown,a&&(y|=c.FileType.SymbolicLink),y}async readFile(r){try{const a=this.toFilePath(r);return await g.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,y){const P=(0,I.newWriteableStream)(O=>D.VSBuffer.concat(O.map(v=>D.VSBuffer.wrap(v))).buffer);return(0,u.readFileIntoStream)(this,r,P,O=>O.buffer,{...a,bufferSize:256*1024},y),P}async writeFile(r,a,y){let P;try{const O=this.toFilePath(r);if(!y.create||!y.overwrite){if(await g.Promises.exists(O)){if(!y.overwrite)throw(0,c.createFileSystemProviderError)((0,S.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!y.create)throw(0,c.createFileSystemProviderError)((0,S.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}P=await this.open(r,{create:!0,unlock:y.unlock}),await this.write(P,0,a,0,a.byteLength)}catch(O){throw await this.toFileSystemProviderWriteError(r,O)}finally{typeof P=="number"&&await this.close(P)}}async open(r,a){try{const y=this.toFilePath(r);if((0,c.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:v}=await g.SymlinkSupport.stat(y);v.mode&128||await g.Promises.chmod(y,v.mode|128)}catch(v){this.logService.trace(v)}let P;if((0,c.isFileOpenForWriteOptions)(a)){if(d.isWindows)try{await g.Promises.truncate(y,0),P="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}P||(P="w")}else P="r";const O=await g.Promises.open(y,P);return this.mapHandleToPos.set(O,0),(0,c.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(O,r),O}catch(y){throw(0,c.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,y):this.toFileSystemProviderError(y)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await g.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await g.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,y,P,O){const v=this.normalizePos(r,a);let T=null;try{const F=await g.Promises.read(r,y,P,O,v);return typeof F=="number"?T=F:T=F.bytesRead,T}catch(F){throw this.toFileSystemProviderError(F)}finally{this.updatePos(r,v,T)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,y){const P=this.mapHandleToPos.get(r);typeof P=="number"&&(typeof a=="number"||(typeof y=="number"?this.mapHandleToPos.set(r,P+y):this.mapHandleToPos.delete(r)))}async write(r,a,y,P,O){return(0,w.retry)(()=>this.doWrite(r,a,y,P,O),100,3)}async doWrite(r,a,y,P,O){const v=this.normalizePos(r,a);let T=null;try{const F=await g.Promises.write(r,y,P,O,v);return typeof F=="number"?T=F:T=F.bytesWritten,T}catch(F){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),F)}finally{this.updatePos(r,v,T)}}async mkdir(r){try{await g.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const y=this.toFilePath(r);await this.doDelete(y,a)}catch(y){throw this.toFileSystemProviderError(y)}}async doDelete(r,a){a.recursive?await g.Promises.rm(r,g.RimRafMode.MOVE):await g.Promises.unlink(r)}async rename(r,a,y){const P=this.toFilePath(r),O=this.toFilePath(a);if(P!==O)try{await this.validateTargetDeleted(r,a,"move",y.overwrite),await g.Promises.move(P,O)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,S.localize)(2,null,(0,l.basename)(P),(0,l.basename)((0,l.dirname)(O)),v.toString()))),this.toFileSystemProviderError(v)}}async copy(r,a,y){const P=this.toFilePath(r),O=this.toFilePath(a);if(P!==O)try{await this.validateTargetDeleted(r,a,"copy",y.overwrite),await g.Promises.copy(P,O,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,S.localize)(3,null,(0,l.basename)(P),(0,l.basename)((0,l.dirname)(O)),v.toString()))),this.toFileSystemProviderError(v)}}async validateTargetDeleted(r,a,y,P){const O=this.toFilePath(r),v=this.toFilePath(a);let T=!1;if(!!(this.capabilities&1024)||(T=(0,L.isEqual)(O,v,!0)),T&&y==="copy")throw(0,c.createFileSystemProviderError)((0,S.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!T&&await g.Promises.exists(v)){if(!P)throw(0,c.createFileSystemProviderError)((0,S.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(r,a,y,P){let O,v;if(this.options?.watcher?.usePolling)O=f.FileWatcher,v=this.options?.watcher;else{let T=!1;this.options?.legacyWatcher==="on"||this.options?.legacyWatcher==="off"?T=this.options.legacyWatcher==="on":o.default.quality==="stable"&&(T=r===1),T?d.isLinux?O=f.FileWatcher:O=p.FileWatcher:O=h.FileWatcher}return new O(T=>a(T),T=>y(T),P,v)}createNonRecursiveWatcher(r,a,y,P){return new m.FileWatcher(r,O=>a(O),O=>y(O),P)}toFileSystemProviderError(r){if(r instanceof c.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=c.FileSystemProviderErrorCode.NoPermissions;break;default:a=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let y=this.toFileSystemProviderError(a);if(r&&y.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:P}=await g.SymlinkSupport.stat(this.toFilePath(r));P.mode&128||(y=(0,c.createFileSystemProviderError)(a,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(P){this.logService.trace(P)}return y}}t.DiskFileSystemProvider=i}),define(Y[41],Q([0,1,15]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,C.createDecorator)("productService")}),define(Y[25],Q([0,1,56,11]),function(V,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class w{constructor(){this.data=new Map}add(R,L){C.ok(b.isString(R)),C.ok(b.isObject(L)),C.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,L)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}t.Registry=new w}),define(Y[103],Q([0,1,10,25]),function(V,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function w(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class D{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,d){this.schemasById[w(l)]=d,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new D;b.Registry.add(t.Extensions.JSONContribution,R)}),define(Y[34],Q([0,1,20,10,11,72,103,25]),function(V,t,C,b,w,D,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var l;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(l=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var d;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=L.Registry.as(R.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new b.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new b.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(f,o=!0){this.registerConfigurations([f],o)}registerConfigurations(f,o=!0){const s=this.doRegisterConfigurations(f,o);E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(f){const o=this.doDeregisterConfigurations(f);E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:f,remove:o}){const s=[];s.push(...this.doDeregisterConfigurations(o)),s.push(...this.doRegisterConfigurations(f,!1)),E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,C.distinct)(s))}registerDefaultConfigurations(f){const o=[],s=[];for(const e of f)for(const i in e)if(o.push(i),t.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...e[i]};const n={type:"object",default:this.defaultValues[i],description:D.localize(1,null,i),$ref:t.resourceLanguageSettingsSchemaId};s.push(S(i)),this.configurationProperties[i]=n,this.defaultLanguageConfigurationOverridesNode.properties[i]=n}else{this.defaultValues[i]=e[i];const n=this.configurationProperties[i];n&&(this.updatePropertyDefaultValue(i,n),this.updateSchema(i,n))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(f){const o=[];for(const s of f)for(const e in s)if(o.push(e),delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...f){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(f){for(const o of f)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(f,o){const s=[];return f.forEach(e=>{s.push(...this.validateAndRegisterProperties(e,o,e.extensionInfo)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),s}doDeregisterConfigurations(f){const o=[],s=e=>{if(e.properties)for(const i in e.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,e.properties[i]);e.allOf&&e.allOf.forEach(i=>s(i))};for(const e of f){s(e);const i=this.configurationContributors.indexOf(e);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(f,o=!0,s,e=3){e=w.isUndefinedOrNull(f.scope)?e:f.scope;let i=[],n=f.properties;if(n)for(let a in n){if(o&&m(a)){delete n[a];continue}const y=n[a];if(this.updatePropertyDefaultValue(a,y),t.OVERRIDE_PROPERTY_PATTERN.test(a)?y.scope=void 0:(y.scope=w.isUndefinedOrNull(y.scope)?e:y.scope,y.restricted=w.isUndefinedOrNull(y.restricted)?!!s?.restrictedConfigurations?.includes(a):y.restricted),n[a].hasOwnProperty("included")&&!n[a].included){this.excludedConfigurationProperties[a]=n[a],delete n[a];continue}else this.configurationProperties[a]=n[a];!n[a].deprecationMessage&&n[a].markdownDeprecationMessage&&(n[a].deprecationMessage=n[a].markdownDeprecationMessage),i.push(a)}let r=f.allOf;if(r)for(let a of r)i.push(...this.validateAndRegisterProperties(a,o,s,e));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(f){const o=s=>{let e=s.properties;if(e)for(const n in e)this.updateSchema(n,e[n]);let i=s.allOf;i&&i.forEach(o)};o(f)}updateSchema(f,o){switch(t.allSettings.properties[f]=o,o.scope){case 1:t.applicationSettings.properties[f]=o;break;case 2:t.machineSettings.properties[f]=o;break;case 6:t.machineOverridableSettings.properties[f]=o;break;case 3:t.windowSettings.properties[f]=o;break;case 4:t.resourceSettings.properties[f]=o;break;case 5:t.resourceSettings.properties[f]=o,this.resourceLanguageSettingsSchema.properties[f]=o;break}}removeFromSchema(f,o){switch(delete t.allSettings.properties[f],o.scope){case 1:delete t.applicationSettings.properties[f];break;case 2:delete t.machineSettings.properties[f];break;case 6:delete t.machineOverridableSettings.properties[f];break;case 3:delete t.windowSettings.properties[f];break;case 4:case 5:delete t.resourceSettings.properties[f];break}}updateOverridePropertyPatternKey(){for(const f of this.overrideIdentifiers.values()){const o=`[${f}]`,s={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),t.allSettings.properties[o]=s,t.applicationSettings.properties[o]=s,t.machineSettings.properties[o]=s,t.machineOverridableSettings.properties[o]=s,t.windowSettings.properties[o]=s,t.resourceSettings.properties[o]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(f,o){let s=this.defaultValues[f];w.isUndefined(s)&&(s=o.default),w.isUndefined(s)&&(s=c(o.type)),o.default=s}}const g="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(g);function S(h){return h.substring(1,h.length-1)}t.overrideIdentifierFromKey=S;function c(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=c;const u=new I;L.Registry.add(t.Extensions.Configuration,u);function m(h){return h.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(h)?D.localize(5,null,h):u.getConfigurationProperties()[h]!==void 0?D.localize(6,null,h):null:D.localize(4,null)}t.validateProperty=m;function p(){const h=[],f=u.getConfigurationProperties();for(const o of Object.keys(f))h.push([o,f[o].scope]);return h.push(["launch",4]),h.push(["task",4]),h}t.getScopes=p}),define(Y[26],Q([0,1,18,11,8,34,15,25]),function(V,t,C,b,w,D,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,R.createDecorator)("configurationService");function l(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof w.URI)}t.isConfigurationOverrides=l;var d;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function E(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=E;function I(i,n){const r=n?i?n.keys.filter(F=>i.keys.indexOf(F)===-1):[...n.keys]:[],a=i?n?i.keys.filter(F=>n.keys.indexOf(F)===-1):[...i.keys]:[],y=[];if(n&&i){for(const F of i.keys)if(n.keys.indexOf(F)!==-1){const U=p(i.contents,F),K=p(n.contents,F);C.equals(U,K)||y.push(F)}}const P=[],O=F=>{const U={};for(const K of F)for(const ee of K.identifiers)U[s(ee)]=K;return U},v=n?O(n.overrides):{},T=i?O(i.overrides):{};if(Object.keys(v).length)for(const F of r){const U=v[F];U&&P.push([(0,D.overrideIdentifierFromKey)(F),U.keys])}if(Object.keys(T).length)for(const F of a){const U=T[F];U&&P.push([(0,D.overrideIdentifierFromKey)(F),U.keys])}if(Object.keys(v).length&&Object.keys(T).length)for(const F of y){const U=T[F],K=v[F];if(U&&K){const ee=I({contents:U.contents,keys:U.keys,overrides:[]},{contents:K.contents,keys:K.keys,overrides:[]});P.push([(0,D.overrideIdentifierFromKey)(F),[...ee.added,...ee.removed,...ee.updated]])}}return{added:r,removed:a,updated:y,overrides:P}}t.compare=I;function g(i,n){const r=[];for(const a of Object.keys(i))if(D.OVERRIDE_PROPERTY_PATTERN.test(a)){const y={};for(const P in i[a])y[P]=i[a][P];r.push({identifiers:[(0,D.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(y),contents:S(y,n)})}return r}t.toOverrides=g;function S(i,n){const r=Object.create(null);for(let a in i)c(r,a,i[a],n);return r}t.toValuesTree=S;function c(i,n,r,a){const y=n.split("."),P=y.pop();let O=i;for(let v=0;v<y.length;v++){let T=y[v],F=O[T];switch(typeof F){case"undefined":F=O[T]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${y.slice(0,v+1).join(".")} is ${JSON.stringify(F)}`);return}O=F}if(typeof O=="object"&&O!==null)try{O[P]=r}catch(v){a(`Ignoring ${n} as ${y.join(".")} is ${JSON.stringify(O)}`)}else a(`Ignoring ${n} as ${y.join(".")} is ${JSON.stringify(O)}`)}t.addToValueTree=c;function u(i,n){const r=n.split(".");m(i,r)}t.removeFromValueTree=u;function m(i,n){const r=n.shift();if(n.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const a=i[r];typeof a=="object"&&!Array.isArray(a)&&(m(a,n),Object.keys(a).length===0&&delete i[r])}}function p(i,n,r){function a(O,v){let T=O;for(const F of v){if(typeof T!="object"||T===null)return;T=T[F]}return T}const y=n.split("."),P=a(i,y);return typeof P=="undefined"?r:P}t.getConfigurationValue=p;function h(i,n,r){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?b.isObject(i[a])&&b.isObject(n[a])?h(i[a],n[a],r):r&&(i[a]=n[a]):i[a]=n[a])})}t.merge=h;function f(){const i=L.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=f;function o(){const i=Object.create(null),n=L.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let r in n){let a=n[r].default;c(i,r,a,y=>console.error(`Conflict in default settings: ${y}`))}return i}t.getDefaultValues=o;function s(i){return`[${i}]`}t.keyFromOverrideIdentifier=s;function e(i,n,r){const a=i.inspect(n),y=i.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:a.defaultValue}t.getMigratedSettingValue=e}),define(Y[104],Q([0,1,20,10,57,2,101,18,11,8,26,34,25]),function(V,t,C,b,w,D,R,L,l,d,E,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class S{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,E.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,E.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){let i=this.overrideConfigurations.get(e);return i||(i=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,i)),i}merge(...e){const i=L.deepClone(this.contents),n=L.deepClone(this.overrides),r=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const y of a.overrides){const[P]=n.filter(O=>C.equals(O.identifiers,y.identifiers));P?this.mergeContents(P.contents,y.contents):n.push(L.deepClone(y))}for(const y of a.keys)r.indexOf(y)===-1&&r.push(y)}return new S(i,r,n)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const r of C.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r],y=i[r];y&&(typeof a=="object"&&typeof y=="object"?(a=L.deepClone(a),this.mergeContents(a,y)):a=y),n[r]=a}return new S(n,this.keys,this.overrides)}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&l.isObject(e[n])&&l.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=L.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?L.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,E.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,E.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=S;class c extends S{constructor(){const e=(0,E.getDefaultValues)(),i=(0,E.getConfigurationKeys)(),n=[];for(const r of Object.keys(e))I.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,I.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(e[r]),contents:(0,E.toValuesTree)(e[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,n)}}t.DefaultConfigurationModel=c;class u{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!l.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:r,overrides:a,restricted:y}=this.doParseRaw(e,i);this._configurationModel=new S(n,r,a),this._restrictedConfigurations=y||[]}doParseContent(e){let i={},n=null,r=[],a=[],y=[];function P(v){Array.isArray(r)?r.push(v):n!==null&&(r[n]=v)}let O={onObjectBegin:()=>{let v={};P(v),a.push(r),r=v,n=null},onObjectProperty:v=>{n=v},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let v=[];P(v),a.push(r),r=v,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:P,onError:(v,T,F)=>{y.push({error:v,offset:T,length:F})}};if(e)try{w.visit(e,O),i=r[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return i}doParseRaw(e,i){const n=g.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,n,!0,i);e=r.raw;const a=(0,E.toValuesTree)(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`)),y=Object.keys(e),P=(0,E.toOverrides)(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`));return{contents:a,keys:y,overrides:P,restricted:r.restricted}}filter(e,i,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const a={},y=[];for(let P in e)if(I.OVERRIDE_PROPERTY_PATTERN.test(P)&&n){const O=this.filter(e[P],i,!1,r);a[P]=O.raw,y.push(...O.restricted)}else{const O=i[P],v=O?typeof O.scope!="undefined"?O.scope:3:void 0;O?.restricted&&y.push(P),(v===void 0||r.scopes===void 0||r.scopes.includes(v))&&(r.skipRestricted&&O?.restricted||(a[P]=e[P]))}return{raw:a,restricted:y}}}t.ConfigurationModelParser=u;class m extends D.Disposable{constructor(e,i,n,r){super();this.userSettingsResource=e,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=m;class p{constructor(e,i,n=new S,r=new S,a=new R.ResourceMap,y=new S,P=new R.ResourceMap,O=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=y,this._memoryConfigurationByResource=P,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new S,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(e):r.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const r=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),y=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,P=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),O=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),v=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),T=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),F=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,U=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,K=i.overrideIdentifier?y.override(i.overrideIdentifier).getValue(e):y.getValue(e),ee=r.getValue(e),oe=C.distinct(C.flatten(r.overrides.map(te=>te.identifiers))).filter(te=>r.getOverrideValue(e,te)!==void 0);return{defaultValue:P,userValue:O,userLocalValue:v,userRemoteValue:T,workspaceValue:F,workspaceFolderValue:U,memoryValue:K,value:ee,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:v!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:U!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:K!==void 0?{value:y.getValue(e),override:i.overrideIdentifier?y.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(r=>I.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,I.overrideIdentifierFromKey)(r),y=this._defaultConfiguration.getKeysForOverrideIdentifier(a),P=e.getKeysForOverrideIdentifier(a),O=[...P.filter(v=>y.indexOf(v)===-1),...y.filter(v=>P.indexOf(v)===-1),...y.filter(v=>!L.equals(this._defaultConfiguration.override(a).getValue(v),e.override(a).getValue(v)))];return[a,O]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,E.compare)(this.localUserConfiguration,e),y=[...i,...n,...r];return y.length&&this.updateLocalUserConfiguration(e),{keys:y,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,E.compare)(this.remoteUserConfiguration,e);let y=[...i,...n,...r];return y.length&&this.updateRemoteUserConfiguration(e),{keys:y,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,E.compare)(this.workspaceConfiguration,e);let y=[...i,...n,...r];return y.length&&this.updateWorkspaceConfiguration(e),{keys:y,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:r,updated:a,removed:y,overrides:P}=(0,E.compare)(n,i);let O=[...r,...a,...y];return(O.length||!n)&&this.updateFolderConfiguration(e,i),{keys:O,overrides:P}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:r,removed:a,overrides:y}=(0,E.compare)(i,void 0);return{keys:[...n,...r,...a],overrides:y}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const r=i.getFolder(e);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const a=this._memoryConfigurationByResource.get(e);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(i=n.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:r,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:r,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((y,P)=>(y.set(d.URI.revive(P[0]),this.parseConfigurationModel(P[1])),y),new R.ResourceMap);return new p(i,n,new S,r,a,new S,new R.ResourceMap,!1)}static parseConfigurationModel(e){return new S(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=p;function h(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,i=new Map;for(const r of s)r.keys.forEach(a=>e.add(a)),r.overrides.forEach(([a,y])=>{const P=(0,R.getOrSet)(i,a,new Set);y.forEach(O=>P.add(O))});const n=[];return i.forEach((r,a)=>n.push([a,[...r.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=h;class f{constructor(e,i,n,r){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(P=>a.add(P)),e.overrides.forEach(([,P])=>P.forEach(O=>a.add(O))),this.affectedKeys=[...a.values()];const y=new S;this.affectedKeys.forEach(P=>y.setValue(P,{})),this.affectedKeysTree=y.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!L.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,E.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(e=e[r],!e)return!1;n=n[r]}return!0}}t.ConfigurationChangeEvent=f;class o extends f{constructor(e,i,n,r){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=r}}t.AllKeysConfigurationChangeEvent=o}),define(Y[105],Q([0,1,3,10,2,19,26,104,34,25]),function(V,t,C,b,w,D,R,L,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class E extends w.Disposable{constructor(g,S){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new b.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new L.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,S)),this.configuration=new L.Configuration(new L.DefaultConfigurationModel,new L.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new L.Configuration(new L.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,S){const c=typeof g=="string"?g:void 0,u=(0,R.isConfigurationOverrides)(g)?g:(0,R.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(c,u,void 0)}updateValue(g,S,c,u){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const S=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(c,S,1)}onDidDefaultConfigurationChange(g){const S=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new L.DefaultConfigurationModel,g);this.trigger(c,S,6)}trigger(g,S,c){const u=new L.ConfigurationChangeEvent(g,{data:S},this.configuration);u.source=c,u.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(u)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=E}),define(Y[106],Q([0,1,6]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVirtualWorkspace=t.getVirtualWorkspaceScheme=t.getVirtualWorkspaceLocation=t.isVirtualResource=t.getRemoteName=t.getRemoteAuthority=void 0;function b(d){return d.scheme===C.Schemas.vscodeRemote?d.authority:void 0}t.getRemoteAuthority=b;function w(d){if(!d)return;const E=d.indexOf("+");return E<0?d:d.substr(0,E)}t.getRemoteName=w;function D(d){return d.scheme!==C.Schemas.file&&d.scheme!==C.Schemas.vscodeRemote}t.isVirtualResource=D;function R(d){if(d.folders.length)return d.folders.every(E=>D(E.uri))?d.folders[0].uri:void 0;if(d.configuration&&D(d.configuration))return d.configuration}t.getVirtualWorkspaceLocation=R;function L(d){return R(d)?.scheme}t.getVirtualWorkspaceScheme=L;function l(d){return R(d)!==void 0}t.isVirtualWorkspace=l}),define(Y[42],Q([0,1,27,15,106]),function(V,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}t.getWorkspaceSupportTypeMessage=D;function R(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}t.isIExtensionIdentifier=R,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(L=t.ExtensionType||(t.ExtensionType={}));class l{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,c){if(typeof S=="undefined"||S===null)return typeof c=="undefined"||c===null;if(typeof c=="undefined"||c===null)return!1;if(typeof S=="string"||typeof c=="string"){let u=typeof S=="string"?S:S.value,m=typeof c=="string"?c:c.value;return C.equalsIgnoreCase(u,m)}return S._lower===c._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}t.ExtensionIdentifier=l;function d(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}t.isLanguagePackExtension=d;function E(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=E;function I(g,S){if(S&&g.enableProposedApi){const c=`onResolveRemoteAuthority:${(0,w.getRemoteName)(S)}`;return g.activationEvents?.indexOf(c)!==-1}return!1}t.isResolverExtension=I,t.IBuiltinExtensionsScannerService=(0,b.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[23],Q([0,1,27,42]),function(V,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function w(c,u){return c.uuid&&u.uuid?c.uuid===u.uuid:c.id===u.id?!0:(0,C.compareIgnoreCase)(c.id,u.id)===0}t.areSameExtensions=w;class D{constructor(u,m){this.version=m,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof D?w(this,u)&&this.version===u.version:!1}}t.ExtensionIdentifierWithVersion=D;function R(c,u){return`${c}.${u}`}t.getExtensionId=R;function L(c){return c.toLocaleLowerCase()}t.adoptToGalleryExtensionId=L;function l(c,u){return L(R(c,u))}t.getGalleryExtensionId=l;function d(c,u){const m=[],p=h=>{for(const f of m)if(f.some(o=>w(u(o),u(h))))return f;return null};for(const h of c){const f=p(h);f?f.push(h):m.push([h])}return m}t.groupByExtension=d;function E(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=E;function I(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}t.getGalleryExtensionTelemetryData=I,t.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function g(c){const u=new Set;for(const m of c)m.malicious&&u.add(m.id.id);return u}t.getMaliciousExtensionsSet=g;function S(c,u){const m=[],p=u.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const h=p.shift();if(h&&m.every(f=>!w(f.identifier,{id:h}))){const f=c.filter(o=>w(o.identifier,{id:h}));f.length===1&&(m.push(f[0]),p.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}t.getExtensionDependencies=S}),define(Y[107],Q([0,1,24,9,61,6,43,8,76,22,23,42]),function(V,t,C,b,w,D,R,L,l,d,E,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const g=h=>(0,l.localize)(0,null,h),S=(0,l.localize)(1,null,"ms-dotnettools.csharp");function c(h,f){return f?`${h.publisher}.${h.name}@${h.version}`:`${h.publisher}.${h.name}`}const u=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function m(h){const f=u.exec(h);return f&&f[1]?[(0,E.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,E.adoptToGalleryExtensionId)(h),void 0]}t.getIdAndVersion=m;let p=class{constructor(f,o){this.extensionManagementService=f,this.extensionGalleryService=o}get location(){}async listExtensions(f,o,s=console){let e=await this.extensionManagementService.getInstalled(1);const i=I.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(r=>r.manifest.categories?r.manifest.categories.map(y=>y.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){s.log("Possible Categories: "),i.forEach(r=>{s.log(r)});return}this.location&&s.log((0,l.localize)(2,null,this.location)),e=e.sort((r,a)=>r.identifier.id.localeCompare(a.identifier.id));let n;for(let r of e)n!==r.identifier.id&&(n=r.identifier.id,s.log(c(r.manifest,f)))}async installExtensions(f,o,s,e,i=console){const n=[],r=[];f.length&&i.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),y=(v,T)=>{const F=a.find(U=>(0,E.areSameExtensions)(U.identifier,{id:v}));if(F){if(!T&&!e)return i.log((0,l.localize)(5,null,v,F.manifest.version,v)),!1;if(T&&F.manifest.version===T)return i.log((0,l.localize)(6,null,`${v}@${T}`)),!1}return!0},P=[],O=[];for(const v of f)if(v instanceof L.URI)P.push(v);else{const[T,F]=m(v);y(T,F)&&O.push({id:T,version:F,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const v of o){const[T,F]=m(v);y(T,F)&&O.push({id:T,version:F,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(P.length&&await Promise.all(P.map(async v=>{try{const T=await this.installVSIX(v,{isBuiltin:!1,isMachineScoped:s},e,i);T&&r.push(T)}catch(T){i.error(T.message||T.stack||T),n.push(v.toString())}})),O.length){const v=await this.getGalleryExtensions(O);await Promise.all(O.map(async T=>{const F=v.get(T.id.toLowerCase());if(F)try{const U=await this.installFromGallery(T,F,a,e,i);U&&r.push(U)}catch(U){i.error(U.message||U.stack||U),n.push(T.id)}else i.error(`${g(T.version?`${T.id}@${T.version}`:T.id)}
${S}`),n.push(T.id)}))}if(n.length)throw new Error((0,l.localize)(7,null,n.join(", ")))}async installVSIX(f,o,s,e){const i=await this.extensionManagementService.getManifest(f);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,e))try{return await this.extensionManagementService.install(f,o),e.log((0,l.localize)(8,null,(0,w.getBaseLabel)(f))),i}catch(r){if((0,b.isPromiseCanceledError)(r))return e.log((0,l.localize)(9,null,(0,w.getBaseLabel)(f))),null;throw r}return null}async getGalleryExtensions(f){const o=new Map,s=await this.extensionGalleryService.getExtensions(f,C.CancellationToken.None);for(const e of s)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:f,version:o,installOptions:s},e,i,n,r){const a=await this.extensionGalleryService.getManifest(e,C.CancellationToken.None);if(a&&!this.validateExtensionKind(a,r))return null;const y=i.find(P=>(0,E.areSameExtensions)(P.identifier,e.identifier));if(y){if(e.version===y.manifest.version)return r.log((0,l.localize)(10,null,o?`${f}@${o}`:f)),null;r.log((0,l.localize)(11,null,f,e.version))}try{return s.isBuiltin?r.log(o?(0,l.localize)(12,null,f,o):(0,l.localize)(13,null,f)):r.log(o?(0,l.localize)(14,null,f,o):(0,l.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(e,{...s,installGivenVersion:!!o}),r.log((0,l.localize)(16,null,f,e.version)),a}catch(P){if((0,b.isPromiseCanceledError)(P))return r.log((0,l.localize)(17,null,f)),null;throw P}}validateExtensionKind(f,o){return!0}async validateVSIX(f,o,s){const e={id:(0,E.getGalleryExtensionId)(f.publisher,f.name)},n=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,E.areSameExtensions)(e,r.identifier)&&(0,R.gt)(r.manifest.version,f.version));return n&&!o?(s.log((0,l.localize)(18,null,n.identifier.id,n.manifest.version,f.version)),!1):this.validateExtensionKind(f,s)}async uninstallExtensions(f,o,s=console){const e=async n=>{if(n instanceof L.URI){const r=await this.extensionManagementService.getManifest(n);return c(r)}return n},i=[];for(const n of f){const r=await e(n),y=(await this.extensionManagementService.getInstalled()).filter(P=>(0,E.areSameExtensions)(P.identifier,{id:r}));if(!y.length)throw new Error(`${this.notInstalled(r)}
${S}`);if(y.some(P=>P.type===0)){s.log((0,l.localize)(19,null,r));return}if(!o&&y.some(P=>P.isBuiltin)){s.log((0,l.localize)(20,null,r));return}s.log((0,l.localize)(21,null,r));for(const P of y)await this.extensionManagementService.uninstall(P),i.push(P);this.location?s.log((0,l.localize)(22,null,r,this.location)):s.log((0,l.localize)(23,null,r))}}async locateExtension(f,o=console){const s=await this.extensionManagementService.getInstalled();f.forEach(e=>{s.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===D.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(f){return this.location?(0,l.localize)(24,null,f,this.location):(0,l.localize)(25,null,f)}};p=de([ce(0,d.IExtensionManagementService),ce(1,d.IExtensionGalleryService)],p),t.ExtensionManagementCLIService=p}),define(Y[108],Q([0,1,3,9,2,12,19,43,8,31,13,21,22,23,16,14]),function(V,t,C,b,w,D,R,L,l,d,E,I,g,S,c,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let p=class extends w.Disposable{constructor(f,o,s,e){super();this.fileService=o,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=l.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,o){await this.cleanUpPromise;const s=this.getName(f),e=(0,R.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const i=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(f,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,o,s){try{await E.Promises.rename(f.fsPath,o.fsPath)}catch(e){if(D.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${f} to ${o} with 'EPERM' error. Trying again...`),this.rename(f,o,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const o=[],s=[];for(const n of f.children){const r=this.parse(n.name);r&&s.push([r,n])}const e=(0,S.groupByExtension)(s,([n])=>n),i=[];for(const n of e)n.sort((r,a)=>L.rcompare(r[0].version,a[0].version)),o.push(...n.slice(1).map(r=>r[1].resource)),i.push(n[0][1]);i.sort((n,r)=>n.mtime-r.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await C.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new S.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,d.generateUuid)()}parse(f){const o=m.exec(f);return o&&o[1]&&o[2]?new S.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};p=de([ce(0,I.INativeEnvironmentService),ce(1,c.IFileService),ce(2,g.IExtensionGalleryService),ce(3,u.ILogService)],p),t.ExtensionsDownloader=p}),define(Y[109],Q([0,1,2,7,13,42]),function(V,t,C,b,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class R extends C.Disposable{constructor(l,d){super();this.environmentService=l,this.extensionsManifestCache=(0,b.join)(this.environmentService.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(d.onDidUninstallExtension(E=>this.onDidUnInstallExtension(E)))}onDidInstallExtensions(l){l.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=R}),define(Y[110],Q([0,1,10,2,19,8,21,23,16,14]),function(V,t,C,b,w,D,R,L,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let E=class extends b.Disposable{constructor(g,S,c,u){super();this.extensionsManagementService=g,this.logService=u,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(h=>{this.installedExtensions=h.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(h=>this.onInstallExtension(h))),this._register(g.onDidInstallExtensions(h=>this.onDidInstallExtensions(h))),this._register(g.onDidUninstallExtension(h=>this.onDidUninstallExtension(h)));const m=D.URI.file(c.extensionsPath),p=new w.ExtUri(h=>!S.hasCapability(h,1024));this._register(S.watch(m)),this._register(C.Event.filter(S.onDidChangeFilesRaw,h=>h.changes.some(f=>this.doesChangeAffects(f,m,p)))(()=>this.onDidChange()))}doesChangeAffects(g,S,c){return c.isEqual(c.dirname(g.resource),S)?c.isEqual(g.resource,c.joinPath(S,".obsolete"))?!0:!(g.type!==1&&g.type!==2||c.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const S of g)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(S=>!(0,L.areSameExtensions)(S,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,L.areSameExtensions)(S,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),S=g.filter(u=>[...this.installingExtensions,...this.installedExtensions].some(m=>(0,L.areSameExtensions)(m,u.identifier))?!1:u.installedTimestamp&&u.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",u.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",u.identifier.id),!1)),c=this.installedExtensions.filter(u=>this.installingExtensions.some(m=>(0,L.areSameExtensions)(m,u))?!1:g.every(m=>!(0,L.areSameExtensions)(m.identifier,u))?(this.logService.info("Detected extension removed from another source",u.id),!0):!1);this.installedExtensions=g.map(u=>u.identifier),(S.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:c})}}};E=de([ce(1,l.IFileService),ce(2,R.INativeEnvironmentService),ce(3,d.ILogService)],E),t.ExtensionsWatcher=E}),define(Y[111],Q([0,1,134,20,3,2,6,7,13,21,22,23,54,14]),function(V,t,C,b,w,D,R,L,l,d,E,I,g,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let c=class extends D.Disposable{constructor(p,h,f){super();this.extensionManagementService=p,this.logService=f,this.cache=this._register(new u(h,f)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const p=await this.cache.getLanguagePacks(),h=["en",...Object.keys(p)];return(0,b.distinct)(h)}async postInstallExtension(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",p.identifier.id),await this.update())}async postUninstallExtension(p){const h=await this.cache.getLanguagePacks();Object.keys(h).some(f=>h[f]&&h[f].extensions.some(o=>(0,I.areSameExtensions)(o.extensionIdentifier,p.identifier)))&&(this.logService.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,h]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(h);return!(0,b.equals)(Object.keys(p),Object.keys(f))}};c=de([ce(0,E.IExtensionManagementService),ce(1,d.INativeEnvironmentService),ce(2,S.ILogService)],c),t.LocalizationsService=c;let u=class extends D.Disposable{constructor(p,h){super();this.logService=h,this.languagePacks={},this.languagePacksFilePath=(0,L.join)(p.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(p){return this.withLanguagePacks(h=>{Object.keys(h).forEach(f=>delete h[f]),this.createLanguagePacksFromExtensions(h,...p)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(p,...h){for(const f of h)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(p,f);Object.keys(p).forEach(f=>this.updateHash(p[f]))}createLanguagePacksFromExtension(p,h){const f=h.identifier,o=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const s of o)if(h.location.scheme===R.Schemas.file&&(0,g.isValidLocalization)(s)){let e=p[s.languageId];e||(e={hash:"",extensions:[],translations:{}},p[s.languageId]=e);let i=e.extensions.filter(n=>(0,I.areSameExtensions)(n.extensionIdentifier,f))[0];i?i.version=h.manifest.version:e.extensions.push({extensionIdentifier:f,version:h.manifest.version});for(const n of s.translations)e.translations[n.id]=(0,L.join)(h.location.fsPath,n.path)}}updateHash(p){if(p){const h=(0,C.createHash)("md5");for(const f of p.extensions)h.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);p.hash=h.digest("hex")}}withLanguagePacks(p=()=>null){return this.languagePacksFileLimiter.queue(()=>{let h=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(o){return{}}}).then(f=>(h=p(f),f)).then(f=>{for(const s of Object.keys(f))f[s]||delete f[s];this.languagePacks=f,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),l.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>h,f=>this.logService.error(f))})}};u=de([ce(0,d.INativeEnvironmentService),ce(1,S.ILogService)],u)}),define(Y[44],Q([0,1,17,84,34,15,25]),function(V,t,C,b,w,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,D.createDecorator)("requestService");function L(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}t.isSuccess=L;function l(c){return c.res.statusCode===204}async function d(c){if(!L(c))throw new Error("Server returned "+c.res.statusCode);return l(c)?null:(await(0,C.streamToBuffer)(c.stream)).toString()}t.asText=d;async function E(c){if(!L(c))throw new Error("Server returned "+c.res.statusCode);if(l(c))return null;const m=(await(0,C.streamToBuffer)(c.stream)).toString();try{return JSON.parse(m)}catch(p){throw p.message+=`:
`+m,p}}t.asJson=E;function I(c){S(c)}t.updateProxyConfigurationsScope=I;let g;function S(c){const u=R.Registry.as(w.Extensions.Configuration),m=g;g={id:"http",order:15,title:(0,b.localize)(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,b.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,b.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,b.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,b.localize)(4,null),(0,b.localize)(5,null),(0,b.localize)(6,null),(0,b.localize)(7,null)],default:"override",description:(0,b.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,b.localize)(9,null),restricted:!0}}},u.updateConfigurations({add:[g],remove:m?[m]:[]})}S(2)}),define(Y[112],Q([0,1,24,6,16,44]),function(V,t,C,b,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let R=class{constructor(l,d){this.requestService=l,this.fileService=d}async download(l,d,E=C.CancellationToken.None){if(l.scheme===b.Schemas.file||l.scheme===b.Schemas.vscodeRemote){await this.fileService.copy(l,d);return}const I={type:"GET",url:l.toString()},g=await this.requestService.request(I,E);if(g.res.statusCode===200)await this.fileService.writeFile(d,g.stream);else{const S=await(0,D.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${S}`)}}};R=de([ce(0,D.IRequestService),ce(1,w.IFileService)],R),t.DownloadService=R}),define(Y[113],Q([0,1,114,11]),function(V,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function w(R,L){return R.protocol==="http:"?L.HTTP_PROXY||L.http_proxy||null:R.protocol==="https:"&&(L.HTTPS_PROXY||L.https_proxy||L.HTTP_PROXY||L.http_proxy)||null}async function D(R,L,l={}){const d=(0,C.parse)(R),E=l.proxyUrl||w(d,L);if(!E)return null;const I=(0,C.parse)(E);if(!/^https?:$/.test(I.protocol||""))return null;const g={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,b.isBoolean)(l.strictSSL)?l.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((S,c)=>{V(["http-proxy-agent"],S,c)}))(g):new(await new Promise((S,c)=>{V(["https-proxy-agent"],S,c)}))(g)}t.getProxyAgent=D}),define(Y[115],Q([0,1,17,31]),function(V,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function w(D,R,L){let l=L&&L.get("storage.serviceMachineId",0)||null;if(l)return l;try{const E=(await R.readFile(D.serviceMachineIdResource)).value.toString();l=(0,b.isUUID)(E)?E:null}catch(d){l=null}if(!l){l=(0,b.generateUuid)();try{await R.writeFile(D.serviceMachineIdResource,C.VSBuffer.fromString(l))}catch(d){}}return L&&L.store("storage.serviceMachineId",l,0,1),l}t.getServiceMachineId=w}),define(Y[116],Q([0,1,3,10,2,11,65,15]),function(V,t,C,b,w,D,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const l="__$__targetStorageMarker";t.IStorageService=(0,L.createDecorator)("storageService");var d;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(d=t.WillSaveStateReason||(t.WillSaveStateReason={}));var E;(function(u){u[u.GLOBAL=0]="GLOBAL",u[u.WORKSPACE=1]="WORKSPACE"})(E=t.StorageScope||(t.StorageScope={}));var I;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(I=t.StorageTarget||(t.StorageTarget={}));class g extends w.Disposable{constructor(m={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new b.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new b.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new b.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,p){p===l?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:p,target:this.getKeyTargets(m)[p]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,p,h){return this.getStorage(p)?.get(m,h)}getBoolean(m,p,h){return this.getStorage(p)?.getBoolean(m,h)}getNumber(m,p,h){return this.getStorage(p)?.getNumber(m,h)}store(m,p,h,f){if((0,D.isUndefinedOrNull)(p)){this.remove(m,h);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,h,f),this.getStorage(h)?.set(m,p)})}remove(m,p){this.withPausedEmitters(()=>{this.updateKeyTarget(m,p,void 0),this.getStorage(p)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,p){const h=[],f=this.getKeyTargets(m);for(const o of Object.keys(f))f[o]===p&&h.push(o);return h}updateKeyTarget(m,p,h){const f=this.getKeyTargets(p);typeof h=="number"?f[m]!==h&&(f[m]=h,this.getStorage(p)?.set(l,JSON.stringify(f))):typeof f[m]=="number"&&(delete f[m],this.getStorage(p)?.set(l,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const p=this.get(l,m);if(p)try{return JSON.parse(p)}catch(h){}return Object.create(null)}isNew(m){return this.getBoolean(t.IS_NEW_KEY,m)===!0}async flush(m=d.NONE){this._onWillSaveState.fire({reason:m}),await C.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const m=this.getStorage(0)?.items??new Map,p=this.getStorage(1)?.items??new Map;return c(m,p,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;class S extends g{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}t.InMemoryStorageService=S;async function c(u,m,p,h){const f=a=>{try{return JSON.parse(a)}catch(y){return a}},o=new Map,s=new Map;u.forEach((a,y)=>{o.set(y,a),s.set(y,f(a))});const e=new Map,i=new Map;m.forEach((a,y)=>{e.set(y,a),i.set(y,f(a))}),console.group(`Storage: Global (path: ${p})`);let n=[];o.forEach((a,y)=>{n.push({key:y,value:a})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${h})`);let r=[];e.forEach((a,y)=>{r.push({key:y,value:a})}),console.table(r),console.groupEnd(),console.log(i)}t.logStorage=c}),define(Y[117],Q([0,1,12,29,8,31]),function(V,t,C,b,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function R(d){if(C.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function L(d,E,I,g,S,c,u,m,p,h){const f=Object.create(null);f["common.machineId"]=u,f.sessionID=(0,D.generateUuid)()+Date.now(),f.commitHash=S,f.version=c,f["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,C.PlatformToString)(C.platform),f["common.nodePlatform"]=b.platform,f["common.nodeArch"]=g,f["common.product"]=h||"desktop";const o=l(m||[]);o&&(f["common.msftInternal"]=o);let s=0;const e=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),C.isLinuxSnap&&(f["common.snap"]="true");const i=R(I);i&&(f["common.platformDetail"]=i);try{const n=await d.readFile(w.URI.file(p));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}t.resolveCommonProperties=L;function l(d){const E=b.env.USERDNSDOMAIN;if(!E)return!1;const I=E.toLowerCase();return d.some(g=>I===g)}t.verifyMicrosoftInternalDomain=l}),define(Y[30],Q([0,1,15]),function(V,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,C.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var b;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(b=t.TelemetryLevel||(t.TelemetryLevel={}));var w;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(w=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Y[118],Q([0,1,20,3,24,9,10,2,12,8,74,22,23,14,33,30]),function(V,t,C,b,w,D,R,L,l,d,E,I,g,S,c,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let m=class extends L.Disposable{constructor(s,e,i){super();this.galleryService=s,this.telemetryService=e,this.logService=i,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,L.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const e=await this.getTargetPlatform();return s.allTargetPlatforms.some(i=>(0,I.isTargetPlatformCompatible)(i,s.allTargetPlatforms,e))}async installFromGallery(s,e={}){if(!this.galleryService.isEnabled())throw new Error(E.localize(0,null));if(!await this.canInstall(s)){const n=await this.getTargetPlatform(),r=new I.ExtensionManagementError(E.localize(1,null,s.identifier.id,c.default.nameLong,(0,I.TargetPlatformToString)(n)),t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",s.identifier.id,r.message),h(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,r),r}try{s=await this.checkAndGetCompatibleVersion(s,!e.installGivenVersion)}catch(n){throw this.logService.error((0,D.getErrorMessage)(n)),h(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,n),n}const i=await this.galleryService.getManifest(s,w.CancellationToken.None);if(i===null){const n=new I.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,n.message),h(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,n),n}if(i.version!==s.version){const n=new I.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),h(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,n),n}return this.installExtension(i,s,e)}async uninstall(s,e={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,e)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(2,null));const e=await this.findGalleryExtension(s);if(!e)throw new Error(E.localize(3,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,e,i){if(!d.URI.isUri(e)){let P=this.installingExtensions.get(new g.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(P)return this.logService.info("Extensions is already requested to install",e.identifier.id),P.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],r=[],a=this.createInstallExtensionTask(s,e,i);d.URI.isUri(e)||this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(a.identifier,s.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),n.push({task:a,manifest:s});let y=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const O=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,s,!!i.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:v,manifest:T}of O)if(y=y||!!T.extensionDependencies?.some(F=>(0,g.areSameExtensions)({id:F},a.identifier)),this.installingExtensions.has(new g.ExtensionIdentifierWithVersion(v.identifier,v.version).key()))this.logService.info("Extension is already requested to install",v.identifier.id);else{const F=this.createInstallExtensionTask(T,v,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(F.identifier,T.version).key(),F),this._onInstallExtension.fire({identifier:F.identifier,source:v}),this.logService.info("Installing extension:",F.identifier.id),n.push({task:F,manifest:T})}}catch(O){if(d.URI.isUri(a.source))(0,C.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,O.message),(0,C.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(O),O}const P=n.reduce((O,{task:v,manifest:T})=>(O.set(v.identifier.id.toLowerCase(),{task:v,manifest:T}),O),new Map);for(;P.size;){let O;const v=[...P.values()].filter(({manifest:T})=>!T.extensionDependencies?.some(F=>P.has(F.toLowerCase())));v.length?O=P.size===1?v:v.filter(({task:T})=>!(T===a&&!y)):(this.logService.info("Found extensions with circular dependencies",v.map(({task:T})=>T.identifier.id)),O=[...P.values()]),await this.joinAllSettled(O.map(async({task:T})=>{const F=new Date().getTime();try{const U=await T.run();if(await this.joinAllSettled(this.participants.map(K=>K.postInstall(U,T.source,i,w.CancellationToken.None))),!d.URI.isUri(T.source)&&(h(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-F,void 0),l.isWeb&&T.operation===1))try{await this.galleryService.reportStatistic(U.manifest.publisher,U.manifest.name,U.manifest.version,"install")}catch(K){}r.push({local:U,identifier:T.identifier,operation:T.operation,source:T.source})}catch(U){throw d.URI.isUri(T.source)||h(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-F,U),this.logService.error("Error while installing the extension:",T.identifier.id),this.logService.error(U),U}finally{P.delete(T.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:O})=>(0,g.areSameExtensions)(O,a.identifier))[0].local}catch(P){if(n.forEach(({task:O})=>O.cancel()),r.length)try{const O=await Promise.allSettled(r.map(({local:v})=>this.createUninstallExtensionTask(v,{versionOnly:!0}).run()));for(let v=0;v<O.length;v++){const T=O[v],{identifier:F}=r[v];T.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",F.id):this.logService.warn("Rollback: Error while uninstalling extension",F.id,(0,D.getErrorMessage)(T.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,D.getErrorMessage)(O),r.map(({identifier:v})=>v.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,D.getErrorMessage)(P)),this._onDidInstallExtensions.fire(n.map(({task:O})=>({identifier:O.identifier,operation:1,source:O.source}))),P instanceof Error&&(P.name=P&&P.code?P.code:t.ERROR_UNKNOWN),P}finally{for(const{task:P,manifest:O}of n)if(!d.URI.isUri(P.source)){const v=new g.ExtensionIdentifierWithVersion(P.identifier,O.version).key();this.installingExtensions.delete(v)||this.logService.warn("Installation task is not found in the cache",v)}}}async joinAllSettled(s){const e=[],i=[],n=await Promise.allSettled(s);for(const r of n)r.status==="fulfilled"?e.push(r.value):i.push(r.reason);if(i.length)throw p(i);return e}async getAllDepsAndPackExtensionsToInstall(s,e,i){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const r=[s,...n.map(P=>P.identifier)],a=[],y=async(P,O)=>{const v=O.extensionDependencies||[],T=[...v];if(O.extensionPack){const F=i?n.find(U=>(0,g.areSameExtensions)(U.identifier,P)):void 0;for(const U of O.extensionPack)F&&F.manifest.extensionPack&&F.manifest.extensionPack.some(K=>(0,g.areSameExtensions)({id:K},{id:U}))||T.every(K=>!(0,g.areSameExtensions)({id:K},{id:U}))&&T.push(U)}if(T.length){const F=[...r,...a.map(K=>K.gallery.identifier)],U=T.filter(K=>F.every(ee=>!(0,g.areSameExtensions)(ee,{id:K})));if(U.length){const K=await this.galleryService.query({names:U,pageSize:T.length},w.CancellationToken.None);for(const ee of K.firstPage){if(F.find(ae=>(0,g.areSameExtensions)(ae,ee.identifier)))continue;if(!v.some(ae=>(0,g.areSameExtensions)({id:ae},ee.identifier))&&!await this.canInstall(ee)){this.logService.info("Skipping the packed extension as it cannot be installed",ee.identifier.id);continue}const te=await this.checkAndGetCompatibleVersion(ee,!0),ue=await this.galleryService.getManifest(te,w.CancellationToken.None);if(ue===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${te.identifier.id}`,t.INSTALL_ERROR_VALIDATING);a.push({gallery:te,manifest:ue}),await y(te.identifier,ue)}}}};return await y(s,e),n=await this.getInstalled(),a.filter(P=>!n.some(O=>(0,g.areSameExtensions)(O.identifier,P.gallery.identifier)))}async checkAndGetCompatibleVersion(s,e){if(await this.isMalicious(s))throw new I.ExtensionManagementError(E.localize(4,null,s.identifier.id),I.INSTALL_ERROR_MALICIOUS);const i=await this.getCompatibleVersion(s,e);if(!i)throw new I.ExtensionManagementError(E.localize(5,null,s.identifier.id,c.default.version),I.INSTALL_ERROR_INCOMPATIBLE);return i}async getCompatibleVersion(s,e){const i=await this.getTargetPlatform();let n=null;return await this.galleryService.isExtensionCompatible(s,i)&&(n=s),!n&&e&&(n=await this.galleryService.getCompatibleExtension(s,i)),n}async isMalicious(s){const e=await this.getExtensionsReport();return(0,g.getMaliciousExtensionsSet)(e).has(s.identifier.id)}async unininstallExtension(s,e){const i=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),i.waitUntilTaskIsFinished();const n=(P,O)=>{const v=this.createUninstallExtensionTask(P,O);return this.uninstallingExtensions.set(v.extension.identifier.id.toLowerCase(),v),this.logService.info("Uninstalling extension:",P.identifier.id),this._onUninstallExtension.fire(P.identifier),v},r=(P,O)=>{O?this.logService.error("Failed to uninstall extension:",P.identifier.id,O.message):this.logService.info("Successfully uninstalled extension:",P.identifier.id),h(this.telemetryService,"extensionGallery:uninstall",(0,g.getLocalExtensionTelemetryData)(P),void 0,O),this._onDidUninstallExtension.fire({identifier:P.identifier,error:O?.code})},a=[],y=[];try{a.push(n(s,{}));const P=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const O=this.getAllPackExtensionsToUninstall(s,P);for(const v of O)this.uninstallingExtensions.has(v.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",v.identifier.id):a.push(n(v,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(a.map(O=>O.extension),P,s),await this.joinAllSettled(a.map(async O=>{try{if(await O.run(),await this.joinAllSettled(this.participants.map(v=>v.postUninstall(O.extension,e,w.CancellationToken.None))),O.extension.identifier.uuid)try{await this.galleryService.reportStatistic(O.extension.manifest.publisher,O.extension.manifest.name,O.extension.manifest.version,"uninstall")}catch(v){}r(O.extension)}catch(v){const T=v instanceof I.ExtensionManagementError?v:new I.ExtensionManagementError((0,D.getErrorMessage)(v),t.ERROR_UNKNOWN);throw r(O.extension,T),T}finally{y.push(O)}}))}catch(P){const O=P instanceof I.ExtensionManagementError?P:new I.ExtensionManagementError((0,D.getErrorMessage)(P),t.ERROR_UNKNOWN);for(const v of a){try{v.cancel()}catch(T){}y.includes(v)||r(v.extension,O)}throw O}finally{for(const P of a)this.uninstallingExtensions.delete(P.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",P.extension.identifier.id)}}checkForDependents(s,e,i){for(const n of s){const r=this.getDependents(n,e);if(r.length){const a=r.filter(y=>!s.some(P=>(0,g.areSameExtensions)(P.identifier,y.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(n,a,i))}}}getDependentsErrorMessage(s,e,i){return i===s?e.length===1?E.localize(6,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?E.localize(7,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):E.localize(8,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?E.localize(9,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?E.localize(10,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):E.localize(11,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(s,e,i=[]){if(i.indexOf(s)!==-1)return[];i.push(s);const n=s.manifest.extensionPack?s.manifest.extensionPack:[];if(n.length){const r=e.filter(y=>!y.isBuiltin&&n.some(P=>(0,g.areSameExtensions)({id:P},y.identifier))),a=[];for(const y of r)a.push(...this.getAllPackExtensionsToUninstall(y,e,i));return[...r,...a]}return[]}getDependents(s,e){return e.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(n=>(0,g.areSameExtensions)({id:n},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const e=await this.findGalleryExtensionById(s.identifier.uuid);return e||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},w.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},w.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};m=de([ce(0,I.IExtensionGalleryService),ce(1,u.ITelemetryService),ce(2,S.ILogService)],m),t.AbstractExtensionManagementService=m;function p(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((e,i)=>new Error(`${e.message}${e.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=p;function h(o,s,e,i,n){const r=n?n instanceof I.ExtensionManagementError?n.code:t.ERROR_UNKNOWN:void 0;o.publicLogError(s,{...e,success:!n,duration:i,errorcode:r})}t.reportTelemetry=h;class f{constructor(){this.barrier=new b.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(s=>new Promise((e,i)=>{const n=s.onCancellationRequested(()=>{n.dispose(),i((0,D.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=f}),define(Y[37],Q([0,1,18,11,26,30]),function(V,t,C,b,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class R{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(p,h){return Promise.resolve(void 0)}publicLog2(p,h){return this.publicLog(p,h)}publicLogError(p,h){return Promise.resolve(void 0)}publicLogError2(p,h){return this.publicLogError(p,h)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=R,t.NullTelemetryService=new R;class L{async publicLog(p,h,f){}async publicLogError(p,h,f){}}t.NullEndpointTelemetryService=L,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(m,p){return p.onDidChangeConfiguration(h=>{h.source!==6&&m.publicLog2("updateConfiguration",{configurationSource:(0,w.ConfigurationTargetToString)(h.source),configurationKeys:c(h.sourceConfig)})})}t.configurationTelemetry=l;function d(m,p){return!(p.disableTelemetry||!m.enableTelemetry)}t.supportsTelemetry=d;function E(m){const p=m.getValue(D.TELEMETRY_SETTING_ID),h=m.getValue("telemetry.enableCrashReporter");if(m.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=E;function I(m){const p=Object.create(null),h=Object.create(null),f=Object.create(null);S(m,f);for(let o in f){o=o.length>150?o.substr(o.length-149):o;const s=f[o];typeof s=="number"?h[o]=s:typeof s=="boolean"?h[o]=s?1:0:typeof s=="string"?p[o]=s.substring(0,1023):typeof s!="undefined"&&s!==null&&(p[o]=s)}return{properties:p,measurements:h}}t.validateTelemetryData=I;function g(m){if(!m)return"none";let p="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{m.indexOf(`${f}+`)===0&&(p=f)}),p}t.cleanRemoteAuthority=g;function S(m,p,h=0,f){if(!!m)for(let o of Object.getOwnPropertyNames(m)){const s=m[o],e=f?f+o:o;Array.isArray(s)?p[e]=(0,C.safeStringify)(s):s instanceof Date?p[e]=s.toISOString():(0,b.isObject)(s)?h<2?S(s,p,h+1,e+"."):p[e]=(0,C.safeStringify)(s):p[e]=s}}function c(m){if(!m)return[];const p=[];return u(p,"",m),p}function u(m,p,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(f=>u(m,p?`${p}.${f}`:f,h[f])):m.push(p)}}),define(Y[119],Q([0,1,20,24,9,18,12,29,8,26,21,22,23,50,16,14,41,44,115,116,30,37]),function(V,t,C,b,w,D,R,L,l,d,E,I,g,S,c,u,m,p,h,f,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const e=R.isWeb?"web":(0,I.getTargetPlatform)(R.platform,L.arch);var i;(function(z){z[z.None=0]="None",z[z.IncludeVersions=1]="IncludeVersions",z[z.IncludeFiles=2]="IncludeFiles",z[z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",z[z.IncludeSharedAccounts=8]="IncludeSharedAccounts",z[z.IncludeVersionProperties=16]="IncludeVersionProperties",z[z.ExcludeNonValidated=32]="ExcludeNonValidated",z[z.IncludeInstallationTargets=64]="IncludeInstallationTargets",z[z.IncludeAssetUri=128]="IncludeAssetUri",z[z.IncludeStatistics=256]="IncludeStatistics",z[z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",z[z.Unpublished=4096]="Unpublished"})(i||(i={}));function n(...z){return String(z.reduce((N,_)=>N|_,0))}var r;(function(z){z[z.Tag=1]="Tag",z[z.ExtensionId=4]="ExtensionId",z[z.Category=5]="Category",z[z.ExtensionName=7]="ExtensionName",z[z.Target=8]="Target",z[z.Featured=9]="Featured",z[z.SearchText=10]="SearchText",z[z.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},y={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},O={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class v{constructor(N=O){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,_=this.state.pageSize){return new v({...this.state,pageNumber:N,pageSize:_})}withFilter(N,..._){const j=[...this.state.criteria,..._.length?_.map(X=>({filterType:N,value:X})):[{filterType:N}]];return new v({...this.state,criteria:j})}withSortBy(N){return new v({...this.state,sortBy:N})}withSortOrder(N){return new v({...this.state,sortOrder:N})}withFlags(...N){return new v({...this.state,flags:N.reduce((_,j)=>_|j,0)})}withAssetTypes(...N){return new v({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:_,pageSize:j,sortBy:X,sortOrder:Z,flags:se,assetTypes:re}=this.state;return{filters:[{criteria:N,pageNumber:_,pageSize:j,sortBy:X,sortOrder:Z}],assetTypes:re,flags:se}}get searchText(){const N=this.state.criteria.filter(_=>_.filterType===r.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(z,N){const _=(z||[]).filter(j=>j.statisticName===N)[0];return _?_.value:0}function F(z){const N="Microsoft.VisualStudio.Code.Translation.";return z.files.filter(j=>j.assetType.indexOf(N)===0).reduce((j,X)=>{const Z=oe(z,X.assetType);return Z&&j.push([X.assetType.substring(N.length),Z]),j},[])}function U(z){if(z.properties){const N=z.properties.filter(X=>X.key===a.Repository),_=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=N.filter(X=>_.test(X.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return oe(z,a.Repository)}function K(z){return{uri:`${z.fallbackAssetUri}/${a.VSIX}?redirect=true${z.targetPlatform?`&targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${a.VSIX}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}}function ee(z){const N=oe(z,a.Icon);if(N)return N;const _=I.DefaultIconPath;return{uri:_,fallbackUri:_}}function oe(z,N){return z.files.filter(j=>j.assetType===N)[0]?{uri:`${z.assetUri}/${N}`,fallbackUri:`${z.fallbackAssetUri}/${N}`}:null}function te(z,N){const _=z.properties?z.properties.filter(X=>X.key===N):[],j=_.length>0&&_[0].value;return j?j.split(",").map(X=>(0,g.adoptToGalleryExtensionId)(X)):[]}function ue(z){const N=z.properties?z.properties.filter(_=>_.key===y.Engine):[];return N.length>0&&N[0].value||""}function ae(z){const N=z.properties?z.properties.filter(j=>j.key===y.LocalizedLanguages):[],_=N.length>0&&N[0].value||"";return _?_.split(","):[]}function $(z){return z.indexOf("preview")!==-1}function ie(z){return z.targetPlatform?(0,I.toTargetPlatform)(z.targetPlatform):"undefined"}function M(z){const N=(0,C.distinct)(z.versions.map(ie)),_=!!z.tags?.includes(I.WEB_EXTENSION_TAG),j=N.indexOf("web");return _?j===-1&&N.push("web"):j!==-1&&N.splice(j,1),N}function A(z,N){const _=(0,I.getFallbackTargetPlarforms)(N);for(let j=0;j<z.length;j++){const X=z[j];if(X.version===z[j-1]?.version){let Z=j;const se=ie(X);if(se===N)for(;Z>0&&z[Z-1].version===X.version;)Z--;else if(_.includes(se))for(;Z>0&&z[Z-1].version===X.version&&ie(z[Z-1])!==N;)Z--;Z!==j&&(z.splice(j,1),z.splice(Z,0,X))}}return z}t.sortExtensionVersions=A;function x(z,N,_,j,X){const Z=M(z);let se=z.versions[0];return se=z.versions.find(re=>re.version===se.version&&(0,I.isTargetPlatformCompatible)(ie(re),Z,X))||se,G(z,se,Z,N,_,j)}function G(z,N,_,j,X,Z){const se={manifest:oe(N,a.Manifest),readme:oe(N,a.Details),changelog:oe(N,a.Changelog),license:oe(N,a.License),repository:U(N),download:K(N),icon:ee(N),coreTranslations:F(N)};return{identifier:{id:(0,g.getGalleryExtensionId)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},name:z.extensionName,version:N.version,displayName:z.displayName,publisherId:z.publisher.publisherId,publisher:z.publisher.publisherName,publisherDisplayName:z.publisher.displayName,description:z.shortDescription||"",installCount:T(z.statistics,"install"),rating:T(z.statistics,"averagerating"),ratingCount:T(z.statistics,"ratingcount"),categories:z.categories||[],tags:z.tags||[],releaseDate:Date.parse(z.releaseDate),lastUpdated:Date.parse(z.lastUpdated),allTargetPlatforms:_,assets:se,properties:{dependencies:te(N,y.Dependency),extensionPack:te(N,y.ExtensionPack),engine:ue(N),localizedLanguages:ae(N),targetPlatform:ie(N)},preview:$(z.flags),telemetryData:{index:(X.pageNumber-1)*X.pageSize+j,querySource:Z}}}let H=class{constructor(N,_,j,X,Z,se,re,me){this.requestService=_,this.logService=j,this.environmentService=X,this.telemetryService=Z,this.fileService=se,this.productService=re,this.configurationService=me;const pe=re.extensionsGallery;this.extensionsGalleryUrl=pe&&pe.serviceUrl,this.extensionsControlUrl=pe&&pe.controlUrl,this.commonHeadersPromise=J(re.version,re,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,_){const j=[];let X=new v().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,N.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...N.map(({id:se})=>se.toLowerCase()));N.every(se=>!se.version)&&(X=X.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:Z}=await this.queryGallery(X,e,b.CancellationToken.None);for(let se=0;se<Z.length;se++){const re=Z[se];if(!re.versions.length)continue;const me=(0,g.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName),pe=N.find(fe=>(0,g.areSameExtensions)(fe,{id:me}))?.version;if(pe){const fe=re.versions.find(be=>be.version===pe);fe&&j.push(G(re,fe,M(re),se,X))}else j.push(x(re,se,X,void 0,e))}return j}async getCompatibleExtension(N,_){const j=(0,I.isIExtensionIdentifier)(N)?null:N;if(j){if((0,I.isNotWebExtensionInWebTargetPlatform)(j.allTargetPlatforms,_))return null;if(await this.isExtensionCompatible(j,_))return j}const{id:X,uuid:Z}=j?j.identifier:N;let se=new v().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");Z?se=se.withFilter(r.ExtensionId,Z):se=se.withFilter(r.ExtensionName,X);const{galleryExtensions:re}=await this.queryGallery(se,_,b.CancellationToken.None),[me]=re;if(!me||!me.versions.length)return null;const pe=M(me);if((0,I.isNotWebExtensionInWebTargetPlatform)(pe,_))return null;for(let fe of me.versions){if(!ue(fe)){const be=await this.getEngine(fe);fe={...fe,properties:[...fe.properties||[],{key:y.Engine,value:be}]}}if(await this.isRawExtensionVersionCompatible(fe,pe,_))return G(me,fe,pe,0,se)}return null}async isExtensionCompatible(N,_){if(!(0,I.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,_))return!1;let j=N.properties.engine;if(!j){const X=await this.getManifest(N,b.CancellationToken.None);if(!X)throw new Error("Manifest was not found");j=X.engines.vscode}return(0,S.isEngineValid)(j,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(N,_,j){if(!(0,I.isTargetPlatformCompatible)(ie(N),_,j))return!1;const X=await this.getEngine(N);return(0,S.isEngineValid)(X,this.productService.version,this.productService.date)}async query(N,_){const j=b.CancellationToken.isCancellationToken(N)?{}:N,X=b.CancellationToken.isCancellationToken(N)?N:_;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Z=j.text||"";const se=(0,D.getOrDefault)(j,ye=>ye.pageSize,50);let re=new v().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,se).withFilter(r.Target,"Microsoft.VisualStudio.Code");Z?(Z=Z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,we,Fe)=>(re=re.withFilter(r.Category,Fe||we),"")),Z=Z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,we,Fe)=>(re=re.withFilter(r.Tag,Fe||we),"")),Z=Z.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(r.Featured),"")),Z=Z.trim(),Z&&(Z=Z.length<200?Z:Z.substring(0,200),re=re.withFilter(r.SearchText,Z)),re=re.withSortBy(0)):j.ids?re=re.withFilter(r.ExtensionId,...j.ids):j.names?re=re.withFilter(r.ExtensionName,...j.names):re=re.withSortBy(4),typeof j.sortBy=="number"&&(re=re.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(re=re.withSortOrder(j.sortOrder));const{galleryExtensions:me,total:pe}=await this.queryGallery(re,e,X),fe=me.map((ye,we)=>x(ye,we,re,j.source,e)),be=async(ye,we)=>{if(we.isCancellationRequested)throw(0,w.canceled)();const Fe=re.withPage(ye+1),{galleryExtensions:Me}=await this.queryGallery(Fe,e,we);return Me.map((ze,xe)=>x(ze,xe,Fe,j.source,e))};return{firstPage:fe,total:pe,pageSize:re.pageSize,getPage:be}}async queryGallery(N,_,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,i.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,n(i.Unpublished));const X=await this.commonHeadersPromise,Z=JSON.stringify(N.raw),se={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},re=new Date().getTime();let me,pe,fe=0;try{if(me=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:se},j),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:fe};const be=await(0,p.asJson)(me);if(be){const ye=be.results[0],we=ye.extensions;we.forEach(Me=>A(Me.versions,_));const Fe=ye.resultMetadata&&ye.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return fe=Fe&&Fe.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:fe}}return{galleryExtensions:[],total:fe}}catch(be){throw pe=be,be}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-re,success:!!me&&(0,p.isSuccess)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:pe?(0,w.isPromiseCanceledError)(pe)?"canceled":(0,w.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(N,_,j,X){if(!this.isEnabled())return;const Z=R.isWeb?this.api(`/itemName/${N}.${_}/version/${j}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${_}/${j}/stats?statType=${X}`),se=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:Z,headers:me},b.CancellationToken.None)}catch(pe){}}async download(N,_,j){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const X=(0,g.getGalleryExtensionTelemetryData)(N),Z=new Date().getTime(),se=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:fe}),re=j===1?"install":j===2?"update":"",me=re?{uri:`${N.assets.download.uri}${l.URI.parse(N.assets.download.uri).query?"&":"?"}${re}=true`,fallbackUri:`${N.assets.download.fallbackUri}${l.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${re}=true`}:N.assets.download,pe=await this.getAsset(me);await this.fileService.writeFile(_,pe.stream),se(new Date().getTime()-Z)}async getReadme(N,_){if(N.assets.readme){const j=await this.getAsset(N.assets.readme,{},_);return await(0,p.asText)(j)||""}return""}async getManifest(N,_){if(N.assets.manifest){const j=await this.getAsset(N.assets.manifest,{},_),X=await(0,p.asText)(j);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(N,_){const j=oe(N,a.Manifest);if(!j)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},Z=await this.getAsset(j,{headers:X});return await(0,p.asJson)(Z)}async getCoreTranslation(N,_){const j=N.assets.coreTranslations.filter(X=>X[0]===_.toUpperCase())[0];if(j){const X=await this.getAsset(j[1]),Z=await(0,p.asText)(X);return Z?JSON.parse(Z):null}return null}async getChangelog(N,_){if(N.assets.changelog){const j=await this.getAsset(N.assets.changelog,{},_);return await(0,p.asText)(j)||""}return""}async getAllCompatibleVersions(N,_){let j=new v().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?j=j.withFilter(r.ExtensionId,N.identifier.uuid):j=j.withFilter(r.ExtensionName,N.identifier.id);const{galleryExtensions:X}=await this.queryGallery(j,_,b.CancellationToken.None);if(!X.length)return[];const Z=M(X[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(Z,_))return[];const se=[];for(const re of X[0].versions)try{se[se.length-1]?.version!==re.version&&await this.isRawExtensionVersionCompatible(re,Z,_)&&se.push({version:re.version,date:re.lastUpdated})}catch(me){}return se}async getAsset(N,_={},j=b.CancellationToken.None){const X=await this.commonHeadersPromise,Z={type:"GET"},se={...X,..._.headers||{}};_={..._,...Z,headers:se};const re=N.uri,me=N.fallbackUri,pe={..._,url:re};try{const fe=await this.requestService.request(pe,j);if(fe.res.statusCode===200)return fe;const be=await(0,p.asText)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${be}`)}catch(fe){if((0,w.isPromiseCanceledError)(fe))throw fe;const be=(0,w.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:re,message:be});const ye={..._,url:me};return this.requestService.request(ye,j)}}async getEngine(N){let _=ue(N);if(!_){const j=await this.getManifestFromRawExtensionVersion(N,b.CancellationToken.None);if(!j)throw new Error("Manifest was not found");_=j.engines.vscode}return _}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},b.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const _=await(0,p.asJson)(N),j=new Map;if(_)for(const X of _.malicious){const Z=j.get(X)||{id:{id:X},malicious:!0,slow:!1};Z.malicious=!0,j.set(X,Z)}return[...j.values()]}};H=de([ce(1,p.IRequestService),ce(2,u.ILogService),ce(3,E.IEnvironmentService),ce(4,o.ITelemetryService),ce(5,c.IFileService),ce(6,m.IProductService),ce(7,d.IConfigurationService)],H);let B=class extends H{constructor(N,_,j,X,Z,se,re,me){super(N,_,j,X,Z,se,re,me)}};B=de([ce(0,f.IStorageService),ce(1,p.IRequestService),ce(2,u.ILogService),ce(3,E.IEnvironmentService),ce(4,o.ITelemetryService),ce(5,c.IFileService),ce(6,m.IProductService),ce(7,d.IConfigurationService)],B),t.ExtensionGalleryService=B;let ne=class extends H{constructor(N,_,j,X,Z,se,re){super(void 0,N,_,j,X,Z,se,re)}};ne=de([ce(0,p.IRequestService),ce(1,u.ILogService),ce(2,E.IEnvironmentService),ce(3,o.ITelemetryService),ce(4,c.IFileService),ce(5,m.IProductService),ce(6,d.IConfigurationService)],ne),t.ExtensionGalleryServiceWithNoStorageService=ne;async function J(z,N,_,j,X,Z){const se={"X-Market-Client-Id":`VSCode ${z}`,"User-Agent":`VSCode ${z}`},re=await(0,h.getServiceMachineId)(_,X,Z);return(0,s.supportsTelemetry)(N,_)&&(0,s.getTelemetryLevel)(j)===3&&(se["X-Market-User-Id"]=re),se}t.resolveMarketplaceHeaders=J}),define(Y[120],Q([0,1,2,18,12,27,85,26,34,33,25,30,37]),function(V,t,C,b,w,D,R,L,l,d,E,I,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let S=class{constructor(m,p){this._configurationService=p,this._experimentProperties={},this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let h of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(h),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(h=>{const f=/^[a-f0-9]+$/i.test(h["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})})}setExperimentProperty(m,p){this._experimentProperties[m]=p}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const m=await this._commonProperties;let p=m.sessionID,h=m["common.instanceId"],f=m["common.machineId"],o=m["common.firstSessionDate"],s=m["common.msftInternal"];return{sessionId:p,instanceId:h,machineId:f,firstSessionDate:o,msftInternal:s}}dispose(){this._disposables.dispose()}_log(m,p,h,f){return this.telemetryLevel<p?Promise.resolve(void 0):this._commonProperties.then(o=>{h=(0,b.mixin)(h,o),h=(0,b.mixin)(h,this._experimentProperties),h=(0,b.cloneAndChange)(h,s=>{if(typeof s=="string")return this._cleanupInfo(s,f)}),this._appenders.forEach(s=>s.log(m,h))},o=>{console.error(o)})}publicLog(m,p,h){return this._log(m,3,p,h)}publicLog2(m,p,h){return this.publicLog(m,p,h)}publicLogError(m,p){return this.sendErrorTelemetry?this._log(m,2,p,!0):Promise.resolve(void 0)}publicLogError2(m,p){return this.publicLogError(m,p)}_anonymizeFilePaths(m){let p=m;const h=[];for(let e of this._cleanupPatterns)for(;;){const i=e.exec(m);if(!i)break;h.push([i.index,e.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(p="";;){const e=o.exec(m);if(!e)break;!f.test(e[0])&&h.every(([i,n])=>e.index<i||e.index>=n)&&(p+=m.substring(s,e.index)+"<REDACTED: user-file-path>",s=o.lastIndex)}return s<m.length&&(p+=m.substr(s)),p}_removePropertiesWithPossibleUserInfo(m){if(!m)return m;const p=m.toLowerCase(),h=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(p)?"<REDACTED: secret>":h.test(p)?"<REDACTED: email>":m}_cleanupInfo(m,p){let h=m;p&&(h=this._anonymizeFilePaths(h));for(let f of this._cleanupPatterns)h=h.replace(f,"");return h=this._removePropertiesWithPossibleUserInfo(h),h}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=de([ce(1,L.IConfigurationService)],S),t.TelemetryService=S;function c(){const u=(0,R.localize)(0,null,d.default.nameLong),m=d.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=w.isWeb?"":(0,R.localize)(3,null),h=(0,R.localize)(4,null),f=(0,R.localize)(5,null),o=(0,R.localize)(6,null),s=(0,R.localize)(7,null),e=`
|       | ${h} | ${f} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,R.localize)(8,null);return`
${u} ${m} ${p}

&nbsp;

${s}
${e}

&nbsp;

${i}
`}E.Registry.as(l.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:c(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(l.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,R.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,R.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[121],Q([0,1,9,18,37]),function(V,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function D(L){const l=await new Promise((E,I)=>{V(["applicationinsights"],E,I)});let d;return l.defaultClient?(d=new l.TelemetryClient(L),d.channel.setUseDiskRetryCaching(!0)):(l.setup(L).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),d=l.defaultClient),L.indexOf("AIF-")===0&&(d.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),d}class R{constructor(l,d,E){this._eventPrefix=l,this._defaultData=d,this._defaultData||(this._defaultData=Object.create(null)),typeof E=="function"?this._aiClient=E():this._aiClient=E,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=D(this._aiClient)),this._asyncAIClient.then(d=>{l(d)},d=>{(0,C.onUnexpectedError)(d),console.error(d)})}}log(l,d){!this._aiClient||(d=(0,b.mixin)(d,this._defaultData),d=(0,w.validateTelemetryData)(d),this._withAIClient(E=>E.trackEvent({name:this._eventPrefix+"/"+l,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=R}),define(Y[122],Q([0,1,7,13]),function(V,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function w(D,R){const L=Object.create(null),l=(E,I)=>{const g=JSON.parse(E);L[I]=g};if(R){const E=[],I=await b.Promises.readdir(R);for(const S of I)try{(await b.Promises.stat((0,C.join)(R,S))).isDirectory()&&E.push(S)}catch{}const g=[];for(const S of E)(await b.Promises.readdir((0,C.join)(R,S))).filter(u=>u==="telemetry.json").length===1&&g.push(S);for(const S of g){const c=(await b.Promises.readFile((0,C.join)(R,S,"telemetry.json"))).toString();l(c,S)}}let d=(await b.Promises.readFile((0,C.join)(D,"telemetry-core.json"))).toString();return l(d,"vscode-core"),d=(await b.Promises.readFile((0,C.join)(D,"telemetry-extensions.json"))).toString(),l(d,"vscode-extensions"),JSON.stringify(L,null,4)}t.buildTelemetryMessage=w}),define(Y[45],Q([0,1,48,3,7,11,13,71,135,136]),function(V,t,C,b,w,D,R,L,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class E extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=E;function I(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function g(s){if(s instanceof E)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new E(e,s)}function S(s,e,i,n,r,a){const y=w.dirname(e),P=w.join(n,y);if(!P.startsWith(n))return Promise.reject(new Error(L.localize(0,null,e)));const O=w.join(n,e);let v;return a.onCancellationRequested(()=>{v&&v.destroy()}),Promise.resolve(R.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((T,F)=>{if(!a.isCancellationRequested)try{v=(0,C.createWriteStream)(O,{mode:i}),v.once("close",()=>T()),v.once("error",F),s.once("error",F),s.pipe(v)}catch(U){F(U)}}))}function c(s,e,i,n){let r=(0,b.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((y,P)=>{const O=new b.Sequencer,v=T=>{T.isCancellationRequested||(a++,s.readEntry())};s.once("error",P),s.once("close",()=>r.then(()=>{n.isCancellationRequested||s.entryCount===a?y():P(new E("Incomplete",new Error(L.localize(1,null,a,s.entryCount))))},P)),s.readEntry(),s.on("entry",T=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(T.fileName)){v(n);return}const F=T.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(F)){const ee=w.join(e,F);r=(0,b.createCancelablePromise)(oe=>R.Promises.mkdir(ee,{recursive:!0}).then(()=>v(oe)).then(void 0,P));return}const U=m(s,T),K=I(T);r=(0,b.createCancelablePromise)(ee=>O.queue(()=>U.then(oe=>S(oe,F,K,e,i,ee).then(()=>v(ee)))).then(null,P))})})}function u(s,e=!1){return new Promise((i,n)=>{(0,l.open)(s,e?{lazyEntries:!0}:void 0,(r,a)=>{r?n(g(r)):i((0,D.assertIsDefined)(a))})})}function m(s,e){return new Promise((i,n)=>{s.openReadStream(e,(r,a)=>{r?n(g(r)):i((0,D.assertIsDefined)(a))})})}function p(s,e){return new Promise((i,n)=>{const r=new d.ZipFile;e.forEach(y=>{y.contents?r.addBuffer(typeof y.contents=="string"?Buffer.from(y.contents,"utf8"):y.contents,y.path):y.localPath&&r.addFile(y.localPath,y.path)}),r.end();const a=(0,C.createWriteStream)(s);r.outputStream.pipe(a),r.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(s))})}t.zip=p;function h(s,e,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=u(s,!0);return i.overwrite&&(a=a.then(y=>R.Promises.rm(e).then(()=>y))),a.then(y=>c(y,e,{sourcePathRegex:r},n))}t.extract=h;function f(s,e){return u(s).then(i=>new Promise((n,r)=>{i.on("entry",a=>{a.fileName===e&&m(i,a).then(y=>n(y),y=>r(y))}),i.once("close",()=>r(new Error(L.localize(2,null,e))))}))}function o(s,e){return f(s,e).then(i=>new Promise((n,r)=>{const a=[];i.once("error",r),i.on("data",y=>a.push(y)),i.on("end",()=>n(Buffer.concat(a)))}))}t.buffer=o}),define(Y[123],Q([0,1,45,78]),function(V,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function w(D){return(0,C.buffer)(D,"extension/package.json").then(R=>{try{return JSON.parse(R.toString("utf8"))}catch(L){throw new Error((0,b.localize)(0,null))}})}t.getManifest=w}),define(Y[124],Q([0,1,20,3,9,2,6,7,12,19,43,8,31,13,45,79,21,22,23,89,16,14,41]),function(V,t,C,b,w,D,R,L,l,d,E,I,g,S,c,u,m,p,h,f,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",r="extracting",a="deleting",y="renaming";let P=class extends D.Disposable{constructor(v,T,F,U,K){super();this.beforeRemovingExtension=v,this.fileService=T,this.logService=F,this.environmentService=U,this.productService=K,this._devSystemExtensionsPath=null,this.systemExtensionsPath=U.builtinExtensionsPath,this.extensionsPath=U.extensionsPath,this.uninstalledPath=L.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new b.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(v){const T=[];(v===null||v===0)&&T.push(this.scanSystemExtensions().then(null,F=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(F).message,i)))),(v===null||v===1)&&T.push(this.scanUserExtensions(!0).then(null,F=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(F).message,n))));try{const F=await Promise.all(T);return(0,C.flatten)(F)}catch(F){throw this.joinErrors(F)}}async scanUserExtensions(v){this.logService.trace("Started scanning user extensions");let[T,F]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return F=F.filter(U=>!T[new h.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version).key()]),v&&(F=(0,h.groupByExtension)(F,K=>K.identifier).map(K=>K.sort((ee,oe)=>E.rcompare(ee.manifest.version,oe.manifest.version))[0])),this.logService.trace("Scanned user extensions:",F.length),F}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(v,T,F,U){const K=v.key(),ee=L.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),oe=L.join(this.extensionsPath,K);try{await S.Promises.rm(oe)}catch(ue){try{await S.Promises.rm(oe)}catch(ae){}throw new p.ExtensionManagementError((0,u.localize)(0,null,oe,v.id),a)}await this.extractAtLocation(v,T,ee,U);let te=await this.scanExtension(I.URI.file(ee),1);if(!te)throw new Error((0,u.localize)(1,null,ee));await this.storeMetadata(te,{...F,installedTimestamp:Date.now()});try{await this.rename(v,ee,oe,Date.now()+2*60*1e3),this.logService.info("Renamed to",oe)}catch(ue){try{await S.Promises.rm(ee)}catch(ae){}if(ue.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",v.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(ue)}. Deleted from extracted location`,ee),ue}try{te=await this.scanExtension(I.URI.file(oe),1)}catch(ue){}if(te)return te;throw new Error((0,u.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(v,T){return this.setMetadata(v,T),await this.storeMetadata(v,{...T,installedTimestamp:v.installedTimestamp}),v}async storeMetadata(v,T){T.isMachineScoped=T.isMachineScoped||void 0,T.isBuiltin=T.isBuiltin||void 0,T.installedTimestamp=T.installedTimestamp||void 0;const F=L.join(v.location.fsPath,"package.json"),U=await S.Promises.readFile(F,"utf8"),{manifest:K}=await this.parseManifest(U);return K.__metadata=T,await S.Promises.writeFile(F,JSON.stringify(K,null,"	")),v}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...v){const T=v.map(F=>new h.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version));await this.withUninstalledExtensions(F=>{T.forEach(U=>F[U.key()]=!0)})}async setInstalled(v){await this.withUninstalledExtensions(U=>delete U[v.key()]);const F=(await this.scanExtensions(1)).find(U=>new h.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version).equals(v))||null;return F?(await this.storeMetadata(F,{installedTimestamp:Date.now()}),this.scanExtension(F.location,1)):null}async withUninstalledExtensions(v){return this.uninstalledFileLimiter.queue(async()=>{let T;try{T=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(U){if(U.code!=="ENOENT")throw U}let F={};if(T)try{F=JSON.parse(T)}catch(U){}return v&&(v(F),Object.keys(F).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(F)):await S.Promises.rm(this.uninstalledPath)),F})}async removeExtension(v,T){this.logService.trace(`Deleting ${T} extension from disk`,v.identifier.id,v.location.fsPath),await S.Promises.rm(v.location.fsPath),this.logService.info("Deleted from disk",v.identifier.id,v.location.fsPath)}async removeUninstalledExtension(v){await this.removeExtension(v,"uninstalled"),await this.withUninstalledExtensions(T=>delete T[new h.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()])}async extractAtLocation(v,T,F,U){this.logService.trace(`Started extracting the extension from ${T} to ${F}`);try{await S.Promises.rm(F)}catch(K){throw new p.ExtensionManagementError(this.joinErrors(K).message,a)}try{await(0,c.extract)(T,F,{sourcePath:"extension",overwrite:!0},U),this.logService.info(`Extracted extension to ${F}:`,v.id)}catch(K){try{await S.Promises.rm(F)}catch(ee){}throw new p.ExtensionManagementError(K.message,K instanceof c.ExtractError&&K.type?K.type:r)}}async rename(v,T,F,U){try{await S.Promises.rename(T,F)}catch(K){if(l.isWindows&&K&&K.code==="EPERM"&&Date.now()<U)return this.logService.info(`Failed renaming ${T} to ${F} with 'EPERM' error. Trying again...`,v.id),this.rename(v,T,F,U);throw new p.ExtensionManagementError(K.message||(0,u.localize)(3,null,T,F),K.code||y)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const v=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return v;const T=this.scanDevSystemExtensions(),[F,U]=await Promise.all([v,T]);return[...F,...U]}async scanExtensionsInDir(v,T){const F=new b.Limiter(10),U=await this.fileService.resolve(I.URI.file(v));return U.children?(await Promise.all(U.children.filter(ee=>ee.isDirectory).map(ee=>F.queue(async()=>T===1&&(0,d.basename)(ee.resource).indexOf(".")===0?null:this.scanExtension(ee.resource,T))))).filter(ee=>ee&&ee.identifier):[]}async scanExtension(v,T){try{const F=await this.fileService.resolve(v);if(F.children){const{manifest:U,metadata:K}=await this.readManifest(v.fsPath),ee=F.children.find(({name:ae})=>/^readme(\.txt|\.md|)$/i.test(ae))?.resource,oe=F.children.find(({name:ae})=>/^changelog(\.txt|\.md|)$/i.test(ae))?.resource,te={id:(0,h.getGalleryExtensionId)(U.publisher,U.name)},ue={type:T,identifier:te,manifest:U,location:v,readmeUrl:ee,changelogUrl:oe,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:T===0};return K&&(this.setMetadata(ue,K),ue.installedTimestamp=K.installedTimestamp),ue}}catch(F){T!==0&&this.logService.trace(F)}return null}async scanDefaultSystemExtensions(){const v=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",v.length),v}async scanDevSystemExtensions(){const v=this.getDevSystemExtensionsList();if(v.length){const T=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",T.length),T.filter(F=>v.some(U=>(0,h.areSameExtensions)(F.identifier,{id:U})))}else return[]}setMetadata(v,T){v.publisherDisplayName=T.publisherDisplayName||null,v.publisherId=T.publisherId||null,v.identifier.uuid=T.id,v.isMachineScoped=!!T.isMachineScoped,v.isBuiltin=v.type===0||!!T.isBuiltin}async removeUninstalledExtensions(){const v=await this.getUninstalledExtensions(),T=await this.scanAllUserExtensions(),F=new Set;for(const ee of T)v[new h.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]||F.add(ee.identifier.id.toLowerCase());const U=(0,h.groupByExtension)(T,ee=>ee.identifier);await b.Promises.settled(U.map(async ee=>{const oe=ee.sort((te,ue)=>E.rcompare(te.manifest.version,ue.manifest.version))[0];F.has(oe.identifier.id.toLowerCase())||await this.beforeRemovingExtension(oe)}));const K=T.filter(ee=>v[new h.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]);await b.Promises.settled(K.map(ee=>this.removeUninstalledExtension(ee)))}async removeOutdatedExtensions(){const v=await this.scanAllUserExtensions(),T=[],F=(0,h.groupByExtension)(v,U=>U.identifier);T.push(...(0,C.flatten)(F.map(U=>U.sort((K,ee)=>E.rcompare(K.manifest.version,ee.manifest.version)).slice(1)))),await b.Promises.settled(T.map(U=>this.removeExtension(U,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(v=>v.name)}joinErrors(v){const T=Array.isArray(v)?v:[v];return T.length===1?T[0]instanceof Error?T[0]:new Error(T[0]):T.reduce((F,U)=>new Error(`${F.message}${F.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=L.normalize(L.join(R.FileAccess.asFileUri("",V).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(v){const T=[S.Promises.readFile(L.join(v,"package.json"),"utf8").then(ee=>this.parseManifest(ee)),S.Promises.readFile(L.join(v,"package.nls.json"),"utf8").then(void 0,ee=>ee.code!=="ENOENT"?Promise.reject(ee):"{}").then(ee=>JSON.parse(ee))],[{manifest:F,metadata:U},K]=await Promise.all(T);return{manifest:(0,f.localizeManifest)(F,K),metadata:U}}parseManifest(v){return new Promise((T,F)=>{try{const U=JSON.parse(v),K=U.__metadata||null;T({manifest:U,metadata:K})}catch(U){F(new Error((0,u.localize)(4,null)))}})}};P=de([ce(1,o.IFileService),ce(2,s.ILogService),ce(3,m.INativeEnvironmentService),ce(4,e.IProductService)],P),t.ExtensionsScanner=P}),define(Y[125],Q([0,1,28,9,6,7,12,29,19,43,8,31,13,45,77,52,21,118,22,23,108,97,123,109,124,110,50,16,15,14,33,30]),function(V,t,C,b,w,D,R,L,l,d,E,I,g,S,c,u,m,p,h,f,o,s,e,i,n,r,a,y,P,O,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const F="unsetUninstalled",U="downloading";let K=class extends p.AbstractExtensionManagementService{constructor($,ie,M,A,x,G,H){super($,ie,M);this.environmentService=A,this.downloadService=x,this.fileService=H;const B=this._register(G.createInstance(s.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(n.ExtensionsScanner,J=>B.postUninstall(J))),this.manifestCache=this._register(new i.ExtensionsManifestCache(A,this)),this.extensionsDownloader=this._register(G.createInstance(o.ExtensionsDownloader));const ne=this._register(new r.ExtensionsWatcher(this,H,A,M));this._register(ne.onDidChangeExtensionsByAnotherSource(({added:J,removed:z})=>{J.length&&this._onDidInstallExtensions.fire(J.map(N=>({identifier:N.identifier,operation:0,local:N}))),z.forEach(N=>this._onDidUninstallExtension.fire({identifier:N}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const $=await this.isAlpineLinux(),ie=(0,h.getTargetPlatform)($?"alpine":R.platform,L.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",ie),ie})()),this._targetPlatformPromise}async isAlpineLinux(){if(!R.isLinux)return!1;let $;try{$=(await this.fileService.readFile(E.URI.file("/etc/os-release"))).value.toString()}catch(ie){try{$=(await this.fileService.readFile(E.URI.file("/usr/lib/os-release"))).value.toString()}catch(M){this.logService.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(M))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip($){this.logService.trace("ExtensionManagementService#zip",$.identifier.id);const ie=await this.collectFiles($),M=await(0,S.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)()).fsPath,ie);return E.URI.file(M)}async unzip($){return this.logService.trace("ExtensionManagementService#unzip",$.toString()),(await this.install($)).identifier}async getManifest($){const ie=await this.downloadVsix($),M=D.resolve(ie.fsPath);return(0,e.getManifest)(M)}getInstalled($=null){return this.extensionsScanner.scanExtensions($)}async install($,ie={}){this.logService.trace("ExtensionManagementService#install",$.toString());const M=await this.downloadVsix($),A=await(0,e.getManifest)(D.resolve(M.fsPath));if(A.engines&&A.engines.vscode&&!(0,a.isEngineValid)(A.engines.vscode,v.default.version,v.default.date))throw new Error(c.localize(0,null,(0,f.getGalleryExtensionId)(A.publisher,A.name),v.default.version));return this.installExtension(A,M,ie)}async updateMetadata($,ie){return this.logService.trace("ExtensionManagementService#updateMetadata",$.identifier.id),$=await this.extensionsScanner.saveMetadataForLocalExtension($,{...$.manifest.__metadata||{},...ie}),this.manifestCache.invalidate(),$}async updateExtensionScope($,ie){return this.logService.trace("ExtensionManagementService#updateExtensionScope",$.identifier.id),$=await this.extensionsScanner.saveMetadataForLocalExtension($,{...$.manifest.__metadata||{},isMachineScoped:ie}),this.manifestCache.invalidate(),$}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix($){if($.scheme===w.Schemas.file)return $;const ie=(0,l.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)());return await this.downloadService.download($,ie),ie}createInstallExtensionTask($,ie,M){return E.URI.isUri(ie)?new te($,ie,M,this.galleryService,this.extensionsScanner,this.logService):new oe(ie,M,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask($,ie){return new ue($,ie,this.extensionsScanner)}async collectFiles($){const ie=async A=>{let x=await g.Promises.readdir(A);x=x.map(B=>D.join(A,B));const G=await Promise.all(x.map(B=>g.Promises.stat(B)));let H=Promise.resolve([]);return G.forEach((B,ne)=>{const J=x[ne];B.isFile()&&(H=H.then(z=>[...z,J])),B.isDirectory()&&(H=H.then(z=>ie(J).then(N=>[...z,...N])))}),H};return(await ie($.location.fsPath)).map(A=>({path:`extension/${D.relative($.location.fsPath,A)}`,localPath:A}))}};K=de([ce(0,h.IExtensionGalleryService),ce(1,T.ITelemetryService),ce(2,O.ILogService),ce(3,m.INativeEnvironmentService),ce(4,u.IDownloadService),ce(5,P.IInstantiationService),ce(6,y.IFileService)],K),t.ExtensionManagementService=K;class ee extends p.AbstractExtensionTask{constructor($,ie,M,A){super();this.identifier=$,this.source=ie,this.extensionsScanner=M,this.logService=A,this._operation=1}get operation(){return this._operation}async installExtension($,ie){try{const M=await this.unsetUninstalledAndGetLocal($.identifierWithVersion);if(M)return $.metadata?this.extensionsScanner.saveMetadataForLocalExtension(M,$.metadata):M}catch(M){throw R.isMacintosh?new h.ExtensionManagementError(c.localize(1,null),F):new h.ExtensionManagementError(c.localize(2,null),F)}return this.extract($,ie)}async unsetUninstalledAndGetLocal($){if(!await this.isUninstalled($))return null;this.logService.trace("Removing the extension from uninstalled list:",$.id);const M=await this.extensionsScanner.setInstalled($);return this.logService.info("Removed the extension from uninstalled list:",$.id),M}async isUninstalled($){return!!(await this.extensionsScanner.getUninstalledExtensions())[$.key()]}async extract({zipPath:$,identifierWithVersion:ie,metadata:M},A){let x=await this.extensionsScanner.extractUserExtension(ie,$,M,A);return this.logService.info("Extracting completed.",ie.id),x}}class oe extends ee{constructor($,ie,M,A,x){super($.identifier,$,A,x);this.gallery=$,this.options=ie,this.extensionsDownloader=M}async doRun($){const M=(await this.extensionsScanner.scanExtensions(null)).find(x=>(0,f.areSameExtensions)(x.identifier,this.gallery.identifier));M&&(this._operation=2);const A=await this.downloadInstallableExtension(this.gallery,this._operation);A.metadata.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,A.metadata.isBuiltin=this.options.isBuiltin||M?.isBuiltin;try{const x=await this.installExtension(A,$);return M&&d.neq(M.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(M),x}catch(x){throw await this.deleteDownloadedVSIX(A.zipPath),x}}async deleteDownloadedVSIX($){try{await this.extensionsDownloader.delete(E.URI.file($))}catch(ie){this.logService.warn("Error while deleting the downloaded vsix",$.toString(),(0,b.getErrorMessage)(ie))}}async downloadInstallableExtension($,ie){const M={id:$.identifier.uuid,publisherId:$.publisherId,publisherDisplayName:$.publisherDisplayName};let A;try{this.logService.trace("Started downloading extension:",$.identifier.id),A=(await this.extensionsDownloader.downloadExtension($,ie)).fsPath,this.logService.info("Downloaded extension:",$.identifier.id,A)}catch(x){throw new h.ExtensionManagementError((0,p.joinErrors)(x).message,U)}try{const x=await(0,e.getManifest)(A);return{zipPath:A,identifierWithVersion:new f.ExtensionIdentifierWithVersion($.identifier,x.version),metadata:M}}catch(x){throw await this.deleteDownloadedVSIX(A),new h.ExtensionManagementError((0,p.joinErrors)(x).message,p.INSTALL_ERROR_VALIDATING)}}}class te extends ee{constructor($,ie,M,A,x,G){super({id:(0,f.getGalleryExtensionId)($.publisher,$.name)},ie,x,G);this.manifest=$,this.location=ie,this.options=M,this.galleryService=A}async doRun($){const ie=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),A=(await this.extensionsScanner.scanExtensions(1)).find(G=>(0,f.areSameExtensions)(this.identifier,G.identifier)),x=await this.getMetadata(this.identifier.id,$);if(x.isMachineScoped=this.options.isMachineScoped||A?.isMachineScoped,x.isBuiltin=this.options.isBuiltin||A?.isBuiltin,A)if(this._operation=2,ie.equals(new f.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version)))try{await this.extensionsScanner.removeExtension(A,"existing")}catch(G){throw new Error(c.localize(3,null,this.manifest.displayName||this.manifest.name))}else d.gt(A.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(A);else{const G=await this.unsetUninstalledAndGetLocal(ie);if(G)try{await this.extensionsScanner.removeExtension(G,"existing")}catch(H){throw new Error(c.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:D.resolve(this.location.fsPath),identifierWithVersion:ie,metadata:x},$)}async getMetadata($,ie){try{const M=(await this.galleryService.query({names:[$],pageSize:1},ie)).firstPage[0];if(M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId}}catch(M){}return{}}}class ue extends p.AbstractExtensionTask{constructor($,ie,M){super();this.extension=$,this.options=ie,this.extensionsScanner=M}async doRun($){const ie=[],M=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const A=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);ie.push(...M.filter(x=>A.equals(new f.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version))))}else ie.push(...M.filter(A=>(0,f.areSameExtensions)(A.identifier,this.extension.identifier)));if(!ie.length)throw new Error(c.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...ie),this.options.remove)for(const A of ie)try{$.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(A)}catch(x){throw new Error(c.localize(6,null,(0,C.toErrorMessage)(x)))}}}}),define(Y[126],Q([0,1,114,3,17,9,2,11,26,21,91,14,113,137]),function(V,t,C,b,w,D,R,L,l,d,E,I,g,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let c=class extends R.Disposable{constructor(m,p,h){super();this.environmentService=p,this.logService=h,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,p){this.logService.trace("RequestService#request",m.url);const{proxyUrl:h,strictSSL:f}=this;let o;try{o=await(0,E.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(i){this.logService.error("RequestService#request resolving shell environment failed",i)}const s={...process.env,...o},e=m.agent?m.agent:await(0,g.getProxyAgent)(m.url||"",s,{proxyUrl:h,strictSSL:f});return m.agent=e,m.strictSSL=f,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization}),this._request(m,p)}async getNodeRequest(m){return((0,C.parse)(m.url).protocol==="https:"?await new Promise((f,o)=>{V(["https"],f,o)}):await new Promise((f,o)=>{V(["http"],f,o)})).request}_request(m,p){return b.Promises.withAsyncBody(async(h,f)=>{let o;const s=(0,C.parse)(m.url),e=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),i={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,L.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(i.auth=m.user+":"+m.password),o=e(i,n=>{const r=(0,L.isNumber)(m.followRedirects)?m.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&r>0&&n.headers.location)this._request({...m,url:n.headers.location,followRedirects:r-1},p).then(h,f);else{let a=n;n.headers["content-encoding"]==="gzip"&&(a=n.pipe((0,S.createGunzip)())),h({res:n,stream:(0,w.streamToBufferReadableStream)(a)})}}),o.on("error",f),m.timeout&&o.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&o.write(m.data),o.end(),p.onCancellationRequested(()=>{o.abort(),f((0,D.canceled)())})})}async resolveProxy(m){}};c=de([ce(0,l.IConfigurationService),ce(1,d.INativeEnvironmentService),ce(2,I.ILogService)],c),t.RequestService=c}),define(Y[138],Q([0,1,35,3,17,28,9,2,6,7,29,8,13,26,105,52,112,21,88,119,22,107,125,16,100,102,51,96,53,54,111,14,99,33,41,44,126,117,30,120,37,121,122]),function(V,t,C,b,w,D,R,L,l,d,E,I,g,S,c,u,m,p,h,f,o,s,e,i,n,r,a,y,P,O,v,T,F,U,K,ee,oe,te,ue,ae,$,ie,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class A extends L.Disposable{constructor(H){super();this.argv=H,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[H,B]=await this.initServices();return H.invokeFunction(async ne=>{const J=ne.get(T.ILogService),z=ne.get(i.IFileService),N=ne.get(p.INativeEnvironmentService),_=ne.get(o.IExtensionManagementCLIService);J.info("CLI main",this.argv),this.registerErrorHandler(J),await this.doRun(N,_,z),await Promise.all(B.map(j=>{(0,b.raceTimeout)(j.flush(),1e3)}))})}async initServices(){const H=new P.ServiceCollection,B={_serviceBrand:void 0,...U.default};H.set(K.IProductService,B);const ne=new h.NativeEnvironmentService(this.argv,B);H.set(p.INativeEnvironmentService,ne),await Promise.all([ne.appSettingsHome.fsPath,ne.extensionsPath].map(se=>se?g.Promises.mkdir(se,{recursive:!0}):void 0));const J=(0,T.getLogLevel)(ne),z=[];z.push(new F.SpdLogLogger("cli",(0,d.join)(ne.logsPath,"cli.log"),!0,J)),J===T.LogLevel.Trace&&z.push(new T.ConsoleLogger(J));const N=this._register(new T.MultiplexLogService(z));H.set(T.ILogService,N);const _=this._register(new n.FileService(N));H.set(i.IFileService,_);const j=this._register(new r.DiskFileSystemProvider(N));_.registerProvider(l.Schemas.file,j);const X=this._register(new c.ConfigurationService(ne.settingsResource,_));H.set(S.IConfigurationService,X),await X.initialize(),H.set(ee.IRequestService,new a.SyncDescriptor(oe.RequestService)),H.set(u.IDownloadService,new a.SyncDescriptor(m.DownloadService)),H.set(o.IExtensionManagementService,new a.SyncDescriptor(e.ExtensionManagementService)),H.set(o.IExtensionGalleryService,new a.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService)),H.set(o.IExtensionManagementCLIService,new a.SyncDescriptor(s.ExtensionManagementCLIService)),H.set(O.ILocalizationsService,new a.SyncDescriptor(v.LocalizationsService));const Z=[];if((0,$.supportsTelemetry)(B,ne)){B.aiConfig&&B.aiConfig.asimovKey&&Z.push(new ie.AppInsightsAppender("monacoworkbench",null,B.aiConfig.asimovKey));const{appRoot:se,extensionsPath:re,installSourcePath:me}=ne,pe={appenders:Z,sendErrorTelemetry:!1,commonProperties:(async()=>{let fe;try{const be=await g.Promises.readFile((0,d.join)(ne.userDataPath,"storage.json"));fe=JSON.parse(be.toString())[ue.machineIdKey]}catch(be){be.code!=="ENOENT"&&N.error(be)}return(0,te.resolveCommonProperties)(_,(0,C.release)(),(0,C.hostname)(),process.arch,B.commit,B.version,fe,B.msftInternalDomains,me)})(),piiPaths:[se,re]};H.set(ue.ITelemetryService,new a.SyncDescriptor(ae.TelemetryService,[pe]))}else H.set(ue.ITelemetryService,$.NullTelemetryService);return[new y.InstantiationService(H),Z]}registerErrorHandler(H){(0,R.setUnexpectedErrorHandler)(B=>{const ne=(0,D.toErrorMessage)(B,!0);!ne||H.error(`[uncaught exception in CLI]: ${ne}`)}),process.on("uncaughtException",B=>(0,R.onUnexpectedError)(B)),process.on("unhandledRejection",B=>(0,R.onUnexpectedError)(B))}async doRun(H,B,ne){if(this.argv["install-source"])return this.setInstallSource(H,ne,this.argv["install-source"]);if(this.argv["list-extensions"])return B.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return B.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return B.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return B.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(H.appRoot,H.extensionsPath))}asExtensionIdOrVSIX(H){return H.map(B=>/\.vsix$/i.test(B)?I.URI.file((0,d.isAbsolute)(B)?B:(0,d.join)((0,E.cwd)(),B)):B)}async setInstallSource(H,B,ne){await B.writeFile(I.URI.file(H.installSourcePath),w.VSBuffer.fromString(ne.slice(0,30)))}}async function x(G){const H=new A(G);try{await H.run()}finally{H.dispose()}}t.main=x})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/97018d742e4ce3dfbcdb0a02c42c16c6c152e4e1/core/vs/code/node/cliProcessMain.js.map
