/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/base/node/pfs","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","fs","vs/editor/common/core/position","vs/base/common/errorMessage","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],me=function(Y){for(var e=[],g=0,F=Y.length;g<F;g++)e[g]=fe[Y[g]];return e};define(fe[58],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(F,C){if(!F)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=g}),define(fe[59],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function F(i){const I=[];for(let a in i)g.call(i,a)&&I.push(i[a]);return I}e.values=F;function C(i,I){for(let a in i)if(g.call(i,a)&&I({key:a,value:i[a]},function(){delete i[a]})===!1)return}e.forEach=C;function S(i,I){const a=Object.create(null);for(const p of i){const h=I(p);let w=a[h];w||(w=a[h]=[]),w.push(p)}return a}e.groupBy=S;function P(i){const I=Object.create(null);return i&&i.forEach((a,p)=>{I[p]=a}),I}e.fromMap=P;function _(i,I){const a=[],p=[];for(let h of i)I.has(h)||a.push(h);for(let h of I)i.has(h)||p.push(h);return{removed:a,added:p}}e.diffSets=_;function y(i,I){const a=[],p=[];for(let[h,w]of i)I.has(h)||a.push(w);for(let[h,w]of I)i.has(h)||p.push(w);return{removed:a,added:p}}e.diffMaps=y;class k{constructor(){this.map=new Map}add(I,a){let p=this.map.get(I);p||(p=new Set,this.map.set(I,p)),p.add(a)}delete(I,a){const p=this.map.get(I);!p||(p.delete(a),p.size===0&&this.map.delete(I))}forEach(I,a){const p=this.map.get(I);!p||p.forEach(a)}}e.SetMap=k}),define(fe[60],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(P){return(_,y,k)=>{let i=null,I=null;if(typeof k.value=="function"?(i="value",I=k.value):typeof k.get=="function"&&(i="get",I=k.get),!I)throw new Error("not supported");k[i]=P(I,y)}}e.createDecorator=g;function F(P,_,y){let k=null,i=null;if(typeof y.value=="function"?(k="value",i=y.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(k="get",i=y.get),!i)throw new Error("not supported");const I=`$memoize$${_}`;y[k]=function(...a){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,a)}),this[I]}}e.memoize=F;function C(P,_,y){return g((k,i)=>{const I=`$debounce$${i}`,a=`$debounce$result$${i}`;return function(...p){this[a]||(this[a]=y?y():void 0),clearTimeout(this[I]),_&&(this[a]=_(this[a],...p),p=[this[a]]),this[I]=setTimeout(()=>{k.apply(this,p),this[a]=y?y():void 0},P)}})}e.debounce=C;function S(P,_,y){return g((k,i)=>{const I=`$throttle$timer$${i}`,a=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,h=`$throttle$pending$${i}`;return function(...w){if(this[a]||(this[a]=y?y():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),_&&(this[a]=_(this[a],...w)),this[h])return;const D=this[p]+P;D<=Date.now()?(this[p]=Date.now(),k.apply(this,[this[a]]),this[a]=y?y():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),k.apply(this,[this[a]]),this[a]=y?y():void 0},D-Date.now()))}})}e.throttle=S}),define(fe[17],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(f=>{f(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=g,e.errorHandler=new g;function F(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=F;function C(v){y(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=C;function S(v){y(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=S;function P(v){if(v instanceof Error){let{name:n,message:f}=v;const r=v.stacktrace||v.stack;return{$isError:!0,name:n,message:f,stack:r}}return v}e.transformErrorForSerialization=P;const _="Canceled";function y(v){return v instanceof Error&&v.name===_&&v.message===_}e.isPromiseCanceledError=y;class k extends Error{constructor(){super(_);this.name=this.message}}e.CancellationError=k;function i(){const v=new Error(_);return v.name=v.message,v}e.canceled=i;function I(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=I;function a(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=a;function p(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(v){const n=new Error(`${v} has been disposed`);return n.name="DISPOSED",n}e.disposed=h;function w(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=w;class D extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=D;class T extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=T;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function l(v){const n=v;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=l;function o(v,n=Object.create(null)){const f=new Error(v);return n.actions&&(f.actions=n.actions),f}e.createErrorWithActions=o}),define(fe[18],me([0,1,17]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function F($,X=0){return $[$.length-(1+X)]}e.tail=F;function C($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=C;function S($,X,K=(de,_e)=>de===_e){if($===X)return!0;if(!$||!X||$.length!==X.length)return!1;for(let de=0,_e=$.length;de<_e;de++)if(!K($[de],X[de]))return!1;return!0}e.equals=S;function P($,X,K){let de=0,_e=$.length-1;for(;de<=_e;){const Ce=(de+_e)/2|0,Pe=K($[Ce],X);if(Pe<0)de=Ce+1;else if(Pe>0)_e=Ce-1;else return Ce}return-(de+1)}e.binarySearch=P;function _($,X){let K=0,de=$.length;if(de===0)return 0;for(;K<de;){const _e=Math.floor((K+de)/2);X($[_e])?de=_e:K=_e+1}return K}e.findFirstInSorted=_;function y($,X,K){if($=$|0,$>=X.length)throw new TypeError("invalid index");let de=X[Math.floor(X.length*Math.random())],_e=[],Ce=[],Pe=[];for(let Be of X){const $e=K(Be,de);$e<0?_e.push(Be):$e>0?Ce.push(Be):Pe.push(Be)}return $<_e.length?y($,_e,K):$<_e.length+Pe.length?Pe[0]:y($-(_e.length+Pe.length),Ce,K)}e.quickSelect=y;function k($,X){const K=[];let de;for(const _e of $.slice(0).sort(X))!de||X(de[0],_e)!==0?(de=[_e],K.push(de)):de.push(_e);return K}e.groupBy=k;function i($,X,K){const de=[];function _e(Be,$e,He){if($e===0&&He.length===0)return;const G=de[de.length-1];G&&G.start+G.deleteCount===Be?(G.deleteCount+=$e,G.toInsert.push(...He)):de.push({start:Be,deleteCount:$e,toInsert:He})}let Ce=0,Pe=0;for(;;){if(Ce===$.length){_e(Ce,0,X.slice(Pe));break}if(Pe===X.length){_e(Ce,$.length-Ce,[]);break}const Be=$[Ce],$e=X[Pe],He=K(Be,$e);He===0?(Ce+=1,Pe+=1):He<0?(_e(Ce,1,[]),Ce+=1):He>0&&(_e(Ce,0,[$e]),Pe+=1)}return de}e.sortedDiff=i;function I($,X,K){const de=i($,X,K),_e=[],Ce=[];for(const Pe of de)_e.push(...$.slice(Pe.start,Pe.start+Pe.deleteCount)),Ce.push(...Pe.toInsert);return{removed:_e,added:Ce}}e.delta=I;function a($,X,K){if(K===0)return[];const de=$.slice(0,K).sort(X);return h($,X,de,K,$.length),de}e.top=a;function p($,X,K,de,_e){return K===0?Promise.resolve([]):new Promise((Ce,Pe)=>{(async()=>{const Be=$.length,$e=$.slice(0,K).sort(X);for(let He=K,G=Math.min(K+de,Be);He<Be;He=G,G=Math.min(G+de,Be)){if(He>K&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,g.canceled)();h($,X,$e,He,G)}return $e})().then(Ce,Pe)})}e.topAsync=p;function h($,X,K,de,_e){for(const Ce=K.length;de<_e;de++){const Pe=$[de];if(X(Pe,K[Ce-1])<0){K.pop();const Be=_(K,$e=>X(Pe,$e)<0);K.splice(Be,0,Pe)}}}function w($){return $.filter(X=>!!X)}e.coalesce=w;function D($){let X=0;for(let K=0;K<$.length;K++)$[K]&&($[X]=$[K],X+=1);$.length=X}e.coalesceInPlace=D;function T($,X,K){$.splice(K,0,$.splice(X,1)[0])}e.move=T;function b($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=b;function l($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=l;function o($,X=K=>K){const K=new Set;return $.filter(de=>{const _e=X(de);return K.has(_e)?!1:(K.add(_e),!0)})}e.distinct=o;function v($){const X=Object.create(null);return K=>{const de=$(K);return X[de]?!1:(X[de]=!0,!0)}}e.uniqueFilter=v;function n($,X){const K=f($,X);if(K!==-1)return $[K]}e.findLast=n;function f($,X){for(let K=$.length-1;K>=0;K--){const de=$[K];if(X(de))return K}return-1}e.lastIndex=f;function r($,X){return $.length>0?$[0]:X}e.firstOrDefault=r;function t($,X,K=(de,_e)=>de===_e){let de=0;for(let _e=0,Ce=Math.min($.length,X.length);_e<Ce&&K($[_e],X[_e]);_e++)de++;return de}e.commonPrefixLength=t;function d($){return[].concat(...$)}e.flatten=d;function s($,X){let K=typeof X=="number"?$:0;typeof X=="number"?K=$:(K=0,X=$);const de=[];if(K<=X)for(let _e=K;_e<X;_e++)de.push(_e);else for(let _e=K;_e>X;_e--)de.push(_e);return de}e.range=s;function c($,X,K){return $.reduce((de,_e)=>(de[X(_e)]=K?K(_e):_e,de),Object.create(null))}e.index=c;function m($,X){return $.push(X),()=>u($,X)}e.insert=m;function u($,X){const K=$.indexOf(X);if(K>-1)return $.splice(K,1),X}e.remove=u;function E($,X,K){const de=$.slice(0,X),_e=$.slice(X);return de.concat(K,_e)}e.arrayInsert=E;function R($,X){let K;if(typeof X=="number"){let de=X;K=()=>{const _e=Math.sin(de++)*179426549;return _e-Math.floor(_e)}}else K=Math.random;for(let de=$.length-1;de>0;de-=1){const _e=Math.floor(K()*(de+1)),Ce=$[de];$[de]=$[_e],$[_e]=Ce}}e.shuffle=R;function L($,X){const K=$.indexOf(X);K>-1&&($.splice(K,1),$.unshift(X))}e.pushToStart=L;function M($,X){const K=$.indexOf(X);K>-1&&($.splice(K,1),$.push(X))}e.pushToEnd=M;function A($,X){return Array.isArray($)?$.map(X):X($)}e.mapArrayOrNot=A;function B($){return Array.isArray($)?$:[$]}e.asArray=B;function V($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=V;function N($,X){for(const K of $){const de=X(K);if(de!==void 0)return de}}e.mapFind=N;function j($,X,K){const de=x($,X),_e=$.length,Ce=K.length;$.length=_e+Ce;for(let Pe=_e-1;Pe>=de;Pe--)$[Pe+Ce]=$[Pe];for(let Pe=0;Pe<Ce;Pe++)$[Pe+de]=K[Pe]}e.insertInto=j;function U($,X,K,de){const _e=x($,X),Ce=$.splice(_e,K);return j($,_e,de),Ce}e.splice=U;function x($,X){return X<0?Math.max(X+$.length,0):Math.min(X,$.length)}function z($,X){let K=Number.MAX_SAFE_INTEGER,de=0;return $.forEach((_e,Ce)=>{const Pe=X(_e);Pe<K&&(K=Pe,de=Ce)}),de}e.minIndex=z;function O($,X){let K=Number.MIN_SAFE_INTEGER,de=0;return $.forEach((_e,Ce)=>{const Pe=X(_e);Pe>K&&(K=Pe,de=Ce)}),de}e.maxIndex=O;class W{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let K=this.firstIdx;for(;K<this.items.length&&X(this.items[K]);)K++;const de=K===this.firstIdx?null:this.items.slice(this.firstIdx,K);return this.firstIdx=K,de}takeFromEndWhile(X){let K=this.lastIdx;for(;K>=0&&X(this.items[K]);)K--;const de=K===this.lastIdx?null:this.items.slice(K+1,this.lastIdx+1);return this.lastIdx=K,de}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=W}),define(fe[76],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(F){const C=this;let S=!1,P;return function(){return S||(S=!0,P=F.apply(C,arguments)),P}}e.once=g}),define(fe[77],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(fe[94],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(F){function C(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}F.is=C;const S=Object.freeze([]);function P(){return S}F.empty=P;function*_(v){yield v}F.single=_;function y(v){return v||S}F.from=y;function k(v){return!v||v[Symbol.iterator]().next().done===!0}F.isEmpty=k;function i(v){return v[Symbol.iterator]().next().value}F.first=i;function I(v,n){for(const f of v)if(n(f))return!0;return!1}F.some=I;function a(v,n){for(const f of v)if(n(f))return f}F.find=a;function*p(v,n){for(const f of v)n(f)&&(yield f)}F.filter=p;function*h(v,n){let f=0;for(const r of v)yield n(r,f++)}F.map=h;function*w(...v){for(const n of v)for(const f of n)yield f}F.concat=w;function*D(v){for(const n of v)for(const f of n)yield f}F.concatNested=D;function T(v,n,f){let r=f;for(const t of v)r=n(r,t);return r}F.reduce=T;function*b(v,n,f=v.length){for(n<0&&(n+=v.length),f<0?f+=v.length:f>v.length&&(f=v.length);n<f;n++)yield v[n]}F.slice=b;function l(v,n=Number.POSITIVE_INFINITY){const f=[];if(n===0)return[f,v];const r=v[Symbol.iterator]();for(let t=0;t<n;t++){const d=r.next();if(d.done)return[f,F.empty()];f.push(d.value)}return[f,{[Symbol.iterator](){return r}}]}F.consume=l;function o(v,n,f=(r,t)=>r===t){const r=v[Symbol.iterator](),t=n[Symbol.iterator]();for(;;){const d=r.next(),s=t.next();if(d.done!==s.done)return!1;if(d.done)return!0;if(!f(d.value,s.value))return!1}}F.equals=o})(g=e.Iterable||(e.Iterable={}))}),define(fe[61],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var F;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(n){n.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function P(n,f=!1){let r=0,t=n.length,d="",s=0,c=16,m=0;function u(V){let N=0,j=0;for(;N<V;){const U=n.charCodeAt(r);if(U>=48&&U<=57)j=j*16+U-48;else if(U>=65&&U<=70)j=j*16+U-65+10;else if(U>=97&&U<=102)j=j*16+U-97+10;else break;r++,N++}return N<V&&(j=-1),j}function E(V){r=V,d="",s=0,c=16,m=0}function R(){const V=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&k(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&k(n.charCodeAt(r)))for(r++;r<n.length&&k(n.charCodeAt(r));)r++;else return m=3,n.substring(V,r);let N=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&k(n.charCodeAt(r))){for(r++;r<n.length&&k(n.charCodeAt(r));)r++;N=r}else m=3;return n.substring(V,N)}function L(){let V="",N=r;for(;;){if(r>=t){V+=n.substring(N,r),m=2;break}const j=n.charCodeAt(r);if(j===34){V+=n.substring(N,r),r++;break}if(j===92){if(V+=n.substring(N,r),r++,r>=t){m=2;break}switch(n.charCodeAt(r++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:const x=u(4);x>=0?V+=String.fromCharCode(x):m=4;break;default:m=5}N=r;continue}if(j>=0&&j<=31)if(y(j)){V+=n.substring(N,r),m=2;break}else m=6;r++}return V}function M(){if(d="",m=0,s=r,r>=t)return s=t,c=17;let V=n.charCodeAt(r);if(_(V)){do r++,d+=String.fromCharCode(V),V=n.charCodeAt(r);while(_(V));return c=15}if(y(V))return r++,d+=String.fromCharCode(V),V===13&&n.charCodeAt(r)===10&&(r++,d+=`
`),c=14;switch(V){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,d=L(),c=10;case 47:const N=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<t&&!y(n.charCodeAt(r));)r++;return d=n.substring(N,r),c=12}if(n.charCodeAt(r+1)===42){r+=2;const j=t-1;let U=!1;for(;r<j;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,U=!0;break}r++}return U||(r++,m=1),d=n.substring(N,r),c=13}return d+=String.fromCharCode(V),r++,c=16;case 45:if(d+=String.fromCharCode(V),r++,r===t||!k(n.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return d+=R(),c=11;default:for(;r<t&&A(V);)r++,V=n.charCodeAt(r);if(s!==r){switch(d=n.substring(s,r),d){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return d+=String.fromCharCode(V),r++,c=16}}function A(V){if(_(V)||y(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let V;do V=M();while(V>=12&&V<=15);return V}return{setPosition:E,getPosition:()=>r,scan:f?B:M,getToken:()=>c,getTokenValue:()=>d,getTokenOffset:()=>s,getTokenLength:()=>r-s,getTokenError:()=>m}}e.createScanner=P;function _(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function y(n){return n===10||n===13||n===8232||n===8233}function k(n){return n>=48&&n<=57}var i;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(i||(i={}));function I(n,f){const r=[],t=new Object;let d;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function m(u,E,R,L){s.value=u,s.offset=E,s.length=R,s.type=L,s.colonOffset=void 0,d=s}try{l(n,{onObjectBegin:(u,E)=>{if(f<=u)throw t;d=void 0,c=f>u,r.push("")},onObjectProperty:(u,E,R)=>{if(f<E||(m(u,E,R,"property"),r[r.length-1]=u,f<=E+R))throw t},onObjectEnd:(u,E)=>{if(f<=u)throw t;d=void 0,r.pop()},onArrayBegin:(u,E)=>{if(f<=u)throw t;d=void 0,r.push(0)},onArrayEnd:(u,E)=>{if(f<=u)throw t;d=void 0,r.pop()},onLiteralValue:(u,E,R)=>{if(f<E||(m(u,E,R,v(u)),f<=E+R))throw t},onSeparator:(u,E,R)=>{if(f<=E)throw t;if(u===":"&&d&&d.type==="property")d.colonOffset=E,c=!1,d=void 0;else if(u===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(c=!0,r[r.length-1]=""),d=void 0}}})}catch(u){if(u!==t)throw u}return{path:r,previousNode:d,isAtPropertyKey:c,matches:u=>{let E=0;for(let R=0;E<u.length&&R<r.length;R++)if(u[E]===r[R]||u[E]==="*")E++;else if(u[E]!=="**")return!1;return E===u.length}}}e.getLocation=I;function a(n,f=[],r=S.DEFAULT){let t=null,d=[];const s=[];function c(u){Array.isArray(d)?d.push(u):t!==null&&(d[t]=u)}return l(n,{onObjectBegin:()=>{const u={};c(u),s.push(d),d=u,t=null},onObjectProperty:u=>{t=u},onObjectEnd:()=>{d=s.pop()},onArrayBegin:()=>{const u=[];c(u),s.push(d),d=u,t=null},onArrayEnd:()=>{d=s.pop()},onLiteralValue:c,onError:(u,E,R)=>{f.push({error:u,offset:E,length:R})}},r),d[0]}e.parse=a;function p(n,f=[],r=S.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function d(u){t.type==="property"&&(t.length=u-t.offset,t=t.parent)}function s(u){return t.children.push(u),u}l(n,{onObjectBegin:u=>{t=s({type:"object",offset:u,length:-1,parent:t,children:[]})},onObjectProperty:(u,E,R)=>{t=s({type:"property",offset:E,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:u,offset:E,length:R,parent:t})},onObjectEnd:(u,E)=>{t.length=u+E-t.offset,t=t.parent,d(u+E)},onArrayBegin:(u,E)=>{t=s({type:"array",offset:u,length:-1,parent:t,children:[]})},onArrayEnd:(u,E)=>{t.length=u+E-t.offset,t=t.parent,d(u+E)},onLiteralValue:(u,E,R)=>{s({type:v(u),offset:E,length:R,parent:t,value:u}),d(E+R)},onSeparator:(u,E,R)=>{t.type==="property"&&(u===":"?t.colonOffset=E:u===","&&d(E))},onError:(u,E,R)=>{f.push({error:u,offset:E,length:R})}},r);const m=t.children[0];return m&&delete m.parent,m}e.parseTree=p;function h(n,f){if(!n)return;let r=n;for(let t of f)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let d=!1;for(const s of r.children)if(Array.isArray(s.children)&&s.children[0].value===t){r=s.children[1],d=!0;break}if(!d)return}else{const d=t;if(r.type!=="array"||d<0||!Array.isArray(r.children)||d>=r.children.length)return;r=r.children[d]}return r}e.findNodeAtLocation=h;function w(n){if(!n.parent||!n.parent.children)return[];const f=w(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;f.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&f.push(r)}return f}e.getNodePath=w;function D(n){switch(n.type){case"array":return n.children.map(D);case"object":const f=Object.create(null);for(let r of n.children){const t=r.children[1];t&&(f[r.children[0].value]=D(t))}return f;case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=D;function T(n,f,r=!1){return f>=n.offset&&f<n.offset+n.length||r&&f===n.offset+n.length}e.contains=T;function b(n,f,r=!1){if(T(n,f,r)){const t=n.children;if(Array.isArray(t))for(let d=0;d<t.length&&t[d].offset<=f;d++){const s=b(t[d],f,r);if(s)return s}return n}}e.findNodeAtOffset=b;function l(n,f,r=S.DEFAULT){const t=P(n,!1);function d(K){return K?()=>K(t.getTokenOffset(),t.getTokenLength()):()=>!0}function s(K){return K?de=>K(de,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=d(f.onObjectBegin),m=s(f.onObjectProperty),u=d(f.onObjectEnd),E=d(f.onArrayBegin),R=d(f.onArrayEnd),L=s(f.onLiteralValue),M=s(f.onSeparator),A=d(f.onComment),B=s(f.onError),V=r&&r.disallowComments,N=r&&r.allowTrailingComma;function j(){for(;;){const K=t.scan();switch(t.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:V||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(K){case 12:case 13:V?U(10):A();break;case 16:U(1);break;case 15:case 14:break;default:return K}}}function U(K,de=[],_e=[]){if(B(K),de.length+_e.length>0){let Ce=t.getToken();for(;Ce!==17;){if(de.indexOf(Ce)!==-1){j();break}else if(_e.indexOf(Ce)!==-1)break;Ce=j()}}}function x(K){const de=t.getTokenValue();return K?L(de):m(de),j(),!0}function z(){switch(t.getToken()){case 11:let K=0;try{K=JSON.parse(t.getTokenValue()),typeof K!="number"&&(U(2),K=0)}catch(de){U(2)}L(K);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return j(),!0}function O(){return t.getToken()!==10?(U(3,[],[2,5]),!1):(x(!1),t.getToken()===6?(M(":"),j(),X()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function W(){c(),j();let K=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(K||U(4,[],[]),M(","),j(),t.getToken()===2&&N)break}else K&&U(6,[],[]);O()||U(4,[],[2,5]),K=!0}return u(),t.getToken()!==2?U(7,[2],[]):j(),!0}function $(){E(),j();let K=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(K||U(4,[],[]),M(","),j(),t.getToken()===4&&N)break}else K&&U(6,[],[]);X()||U(4,[],[4,5]),K=!0}return R(),t.getToken()!==4?U(8,[4],[]):j(),!0}function X(){switch(t.getToken()){case 3:return $();case 1:return W();case 10:return x(!0);default:return z()}}return j(),t.getToken()===17?r.allowEmptyContent?!0:(U(4,[],[]),!1):X()?(t.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=l;function o(n,f){let r=P(n),t=[],d,s=0,c;do switch(c=r.getPosition(),d=r.scan(),d){case 12:case 13:case 17:s!==c&&t.push(n.substring(s,c)),f!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,f)),s=r.getPosition();break}while(d!==17);return t.join("")}e.stripComments=o;function v(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(fe[139],me([0,1,61]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function F(y,k,i){let I,a,p,h,w;if(k){for(h=k.offset,w=h+k.length,p=h;p>0&&!_(y,p-1);)p--;let s=w;for(;s<y.length&&!_(y,s);)s++;a=y.substring(p,s),I=S(a,i)}else a=y,I=0,p=0,h=0,w=y.length;const D=P(i,y);let T=!1,b=0,l;i.insertSpaces?l=C(" ",i.tabSize||4):l="	";const o=(0,g.createScanner)(a,!1);let v=!1;function n(){return D+C(l,I+b)}function f(){let s=o.scan();for(T=!1;s===15||s===14;)T=T||s===14,s=o.scan();return v=s===16||o.getTokenError()!==0,s}const r=[];function t(s,c,m){!v&&c<w&&m>h&&y.substring(c,m)!==s&&r.push({offset:c,length:m-c,content:s})}let d=f();if(d!==17){const s=o.getTokenOffset()+p,c=C(l,I);t(c,p,s)}for(;d!==17;){let s=o.getTokenOffset()+o.getTokenLength()+p,c=f(),m="";for(;!T&&(c===12||c===13);){const E=o.getTokenOffset()+p;t(" ",s,E),s=o.getTokenOffset()+o.getTokenLength()+p,m=c===12?n():"",c=f()}if(c===2)d!==1&&(b--,m=n());else if(c===4)d!==3&&(b--,m=n());else{switch(d){case 3:case 1:b++,m=n();break;case 5:case 12:m=n();break;case 13:T?m=n():m=" ";break;case 6:m=" ";break;case 10:if(c===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:c===12||c===13?m=" ":c!==5&&c!==17&&(v=!0);break;case 16:v=!0;break}T&&(c===12||c===13)&&(m=n())}const u=o.getTokenOffset()+p;t(m,s,u),d=c}return r}e.format=F;function C(y,k){let i="";for(let I=0;I<k;I++)i+=y;return i}function S(y,k){let i=0,I=0;const a=k.tabSize||4;for(;i<y.length;){const p=y.charAt(i);if(p===" ")I++;else if(p==="	")I+=a;else break;i++}return Math.floor(I/a)}function P(y,k){for(let i=0;i<k.length;i++){const I=k.charAt(i);if(I==="\r")return i+1<k.length&&k.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=P;function _(y,k){return`\r
`.indexOf(y.charAt(k))!==-1}e.isEOL=_}),define(fe[140],me([0,1,61,139]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(k,i,I){return S(k,i,void 0,I)}e.removeProperty=C;function S(k,i,I,a,p){const h=i.slice(),w=[],D=(0,g.parseTree)(k,w);let T,b;for(;h.length>0&&(b=h.pop(),T=(0,g.findNodeAtLocation)(D,h),T===void 0&&I!==void 0);)typeof b=="string"?I={[b]:I}:I=[I];if(T)if(T.type==="object"&&typeof b=="string"&&Array.isArray(T.children)){const l=(0,g.findNodeAtLocation)(T,[b]);if(l!==void 0)if(I===void 0){if(!l.parent)throw new Error("Malformed AST");const o=T.children.indexOf(l.parent);let v,n=l.parent.offset+l.parent.length;if(o>0){const f=T.children[o-1];v=f.offset+f.length}else v=T.offset+1,T.children.length>1&&(n=T.children[1].offset);return P(k,{offset:v,length:n-v,content:""},a)}else return P(k,{offset:l.offset,length:l.length,content:JSON.stringify(I)},a);else{if(I===void 0)return[];const o=`${JSON.stringify(b)}: ${JSON.stringify(I)}`,v=p?p(T.children.map(f=>f.children[0].value)):T.children.length;let n;if(v>0){const f=T.children[v-1];n={offset:f.offset+f.length,length:0,content:","+o}}else T.children.length===0?n={offset:T.offset+1,length:0,content:o}:n={offset:T.offset+1,length:0,content:o+","};return P(k,n,a)}}else if(T.type==="array"&&typeof b=="number"&&Array.isArray(T.children))if(I!==void 0){const l=`${JSON.stringify(I)}`;let o;if(T.children.length===0||b===0)o={offset:T.offset+1,length:0,content:T.children.length===0?l:l+","};else{const v=b===-1||b>T.children.length?T.children.length:b,n=T.children[v-1];o={offset:n.offset+n.length,length:0,content:","+l}}return P(k,o,a)}else{const l=b,o=T.children[l];let v;if(T.children.length===1)v={offset:T.offset+1,length:T.length-2,content:""};else if(T.children.length-1===l){const n=T.children[l-1],f=n.offset+n.length,r=T.offset+T.length;v={offset:f,length:r-2-f,content:""}}else v={offset:o.offset,length:T.children[l+1].offset-o.offset,content:""};return P(k,v,a)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${T.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return P(k,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(I)},a)}}e.setProperty=S;function P(k,i,I){let a=_(k,i),p=i.offset,h=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!(0,F.isEOL)(a,p-1);)p--;for(;h<a.length&&!(0,F.isEOL)(a,h);)h++}const w=(0,F.format)(a,{offset:p,length:h-p},I);for(let T=w.length-1;T>=0;T--){const b=w[T];a=_(a,b),p=Math.min(p,b.offset),h=Math.max(h,b.offset+b.length),h+=b.content.length-b.length}const D=k.length-(a.length-h)-p;return[{offset:p,length:D,content:a.substring(p,h)}]}e.withFormatting=P;function _(k,i){return k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)}e.applyEdit=_;function y(k,i){let I=i.slice(0).sort((p,h)=>{const w=p.offset-h.offset;return w===0?p.length-h.length:w}),a=k.length;for(let p=I.length-1;p>=0;p--){let h=I[p];if(h.offset+h.length<=a)k=_(k,h);else throw new Error("Overlapping edit");a=h.offset}return k}e.applyEdits=y}),define(fe[141],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new g(()=>C(this.getValue()))}}e.Lazy=g}),define(fe[6],me([0,1,76,94]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let S=null;function P(t){S=t}if(e.setDisposableTracker=P,C){const t="__is_disposable_tracked__";P(new class{trackDisposable(d){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[t]||console.log(s)},3e3)}setParent(d,s){if(d&&d!==b.None)try{d[t]=!0}catch{}}markAsDisposed(d){if(d&&d!==b.None)try{d[t]=!0}catch{}}markAsSingleton(d){}})}function _(t){return S?.trackDisposable(t),t}function y(t){S?.markAsDisposed(t)}function k(t,d){S?.setParent(t,d)}function i(t,d){if(!!S)for(const s of t)S.setParent(s,d)}function I(t){return S?.markAsSingleton(t),t}e.markAsSingleton=I;class a extends Error{constructor(d){super(`Encountered errors while disposing of store. Errors: [${d.join(", ")}]`);this.errors=d}}e.MultiDisposeError=a;function p(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=p;function h(t){if(F.Iterable.is(t)){let d=[];for(const s of t)if(s)try{s.dispose()}catch(c){d.push(c)}if(d.length===1)throw d[0];if(d.length>1)throw new a(d);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function w(...t){const d=D(()=>h(t));return i(t,d),d}e.combinedDisposable=w;function D(t){const d=_({dispose:(0,g.once)(()=>{y(d),t()})});return d}e.toDisposable=D;class T{constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return k(d,this),this._isDisposed?T.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(d),d}}e.DisposableStore=T,T.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new T,_(this),k(this._store,this)}dispose(){y(this),this._store.dispose()}_register(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(d)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(d){this._isDisposed||d===this._value||(this._value?.dispose(),d&&k(d,this),this._value=d)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const d=this._value;return this._value=void 0,d&&k(d,null),d}}e.MutableDisposable=l;class o{constructor(d){this._disposable=d,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class v{constructor(){this.references=new Map}acquire(d,...s){let c=this.references.get(d);c||(c={counter:0,object:this.createReferencedObject(d,...s)},this.references.set(d,c));const{object:m}=c,u=(0,g.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(d,c.object),this.references.delete(d))});return c.counter++,{object:m,dispose:u}}}e.ReferenceCollection=v;class n{constructor(d){this.referenceCollection=d}async acquire(d,...s){const c=this.referenceCollection.acquire(d,...s);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(m){throw c.dispose(),m}}}e.AsyncReferenceCollection=n;class f{constructor(d){this.object=d}dispose(){}}e.ImmortalReference=f;function r(t){const d=new T;try{t(d)}finally{d.dispose()}}e.disposeOnReturn=r}),define(fe[95],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(S){this.element=S,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class F{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let S=this._first;for(;S!==g.Undefined;){const P=S.next;S.prev=g.Undefined,S.next=g.Undefined,S=P}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,P){const _=new g(S);if(this._first===g.Undefined)this._first=_,this._last=_;else if(P){const k=this._last;this._last=_,_.prev=k,k.next=_}else{const k=this._first;this._first=_,_.next=k,k.prev=_}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(_))}}shift(){if(this._first!==g.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==g.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==g.Undefined&&S.next!==g.Undefined){const P=S.prev;P.next=S.next,S.next.prev=P}else S.prev===g.Undefined&&S.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):S.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):S.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==g.Undefined;)yield S.element,S=S.next}}e.LinkedList=F}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Re,De){for(var Te=0;Te<De.length;Te++){var oe=De[Te];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Re,oe.key,oe)}}function e(Re,De,Te){return De&&Y(Re.prototype,De),Te&&Y(Re,Te),Re}function g(Re,De){if(!!Re){if(typeof Re=="string")return F(Re,De);var Te=Object.prototype.toString.call(Re).slice(8,-1);if(Te==="Object"&&Re.constructor&&(Te=Re.constructor.name),Te==="Map"||Te==="Set")return Array.from(Re);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return F(Re,De)}}function F(Re,De){(De==null||De>Re.length)&&(De=Re.length);for(var Te=0,oe=new Array(De);Te<De;Te++)oe[Te]=Re[Te];return oe}function C(Re,De){var Te=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(Te)return(Te=Te.call(Re)).next.bind(Te);if(Array.isArray(Re)||(Te=g(Re))||De&&Re&&typeof Re.length=="number"){Te&&(Re=Te);var oe=0;return function(){return oe>=Re.length?{done:!0}:{done:!1,value:Re[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var S={exports:{}};function P(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function _(Re){S.exports.defaults=Re}S.exports={defaults:P(),getDefaults:P,changeDefaults:_};var y=/[&<>"']/,k=/[&<>"']/g,i=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(De){return a[De]};function h(Re,De){if(De){if(y.test(Re))return Re.replace(k,p)}else if(i.test(Re))return Re.replace(I,p);return Re}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function D(Re){return Re.replace(w,function(De,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var T=/(^|[^\[])\^/g;function b(Re,De){Re=Re.source||Re,De=De||"";var Te={replace:function(ue,we){return we=we.source||we,we=we.replace(T,"$1"),Re=Re.replace(ue,we),Te},getRegex:function(){return new RegExp(Re,De)}};return Te}var l=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Re,De,Te){if(Re){var oe;try{oe=decodeURIComponent(D(Te)).replace(l,"").toLowerCase()}catch(ue){return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}De&&!o.test(Te)&&(Te=d(De,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch(ue){return null}return Te}var n={},f=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d(Re,De){n[" "+Re]||(f.test(Re)?n[" "+Re]=Re+"/":n[" "+Re]=u(Re,"/",!0)),Re=n[" "+Re];var Te=Re.indexOf(":")===-1;return De.substring(0,2)==="//"?Te?De:Re.replace(r,"$1")+De:De.charAt(0)==="/"?Te?De:Re.replace(t,"$1")+De:Re+De}var s={exec:function(){}};function c(Re){for(var De=1,Te,oe;De<arguments.length;De++){Te=arguments[De];for(oe in Te)Object.prototype.hasOwnProperty.call(Te,oe)&&(Re[oe]=Te[oe])}return Re}function m(Re,De){var Te=Re.replace(/\|/g,function(we,ve,Fe){for(var Ge=!1,ze=ve;--ze>=0&&Fe[ze]==="\\";)Ge=!Ge;return Ge?"|":" |"}),oe=Te.split(/ \|/),ue=0;if(oe[0].trim()||oe.shift(),oe[oe.length-1].trim()||oe.pop(),oe.length>De)oe.splice(De);else for(;oe.length<De;)oe.push("");for(;ue<oe.length;ue++)oe[ue]=oe[ue].trim().replace(/\\\|/g,"|");return oe}function u(Re,De,Te){var oe=Re.length;if(oe===0)return"";for(var ue=0;ue<oe;){var we=Re.charAt(oe-ue-1);if(we===De&&!Te)ue++;else if(we!==De&&Te)ue++;else break}return Re.substr(0,oe-ue)}function E(Re,De){if(Re.indexOf(De[1])===-1)return-1;for(var Te=Re.length,oe=0,ue=0;ue<Te;ue++)if(Re[ue]==="\\")ue++;else if(Re[ue]===De[0])oe++;else if(Re[ue]===De[1]&&(oe--,oe<0))return ue;return-1}function R(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(Re,De){if(De<1)return"";for(var Te="";De>1;)De&1&&(Te+=Re),De>>=1,Re+=Re;return Te+Re}var M={escape:h,unescape:D,edit:b,cleanUrl:v,resolveUrl:d,noopTest:s,merge:c,splitCells:m,rtrim:u,findClosingBracket:E,checkSanitizeDeprecation:R,repeatString:L},A=S.exports.defaults,B=M.rtrim,V=M.splitCells,N=M.escape,j=M.findClosingBracket;function U(Re,De,Te,oe){var ue=De.href,we=De.title?N(De.title):null,ve=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){oe.state.inLink=!0;var Fe={type:"link",raw:Te,href:ue,title:we,text:ve,tokens:oe.inlineTokens(ve,[])};return oe.state.inLink=!1,Fe}else return{type:"image",raw:Te,href:ue,title:we,text:N(ve)}}function x(Re,De){var Te=Re.match(/^(\s+)(?:```)/);if(Te===null)return De;var oe=Te[1];return De.split(`
`).map(function(ue){var we=ue.match(/^\s+/);if(we===null)return ue;var ve=we[0];return ve.length>=oe.length?ue.slice(oe.length):ue}).join(`
`)}var z=function(){function Re(Te){this.options=Te||A}var De=Re.prototype;return De.space=function(oe){var ue=this.rules.block.newline.exec(oe);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},De.code=function(oe){var ue=this.rules.block.code.exec(oe);if(ue){var we=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?we:B(we,`
`)}}},De.fences=function(oe){var ue=this.rules.block.fences.exec(oe);if(ue){var we=ue[0],ve=x(we,ue[3]||"");return{type:"code",raw:we,lang:ue[2]?ue[2].trim():ue[2],text:ve}}},De.heading=function(oe){var ue=this.rules.block.heading.exec(oe);if(ue){var we=ue[2].trim();if(/#$/.test(we)){var ve=B(we,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(we=ve.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:we,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},De.hr=function(oe){var ue=this.rules.block.hr.exec(oe);if(ue)return{type:"hr",raw:ue[0]}},De.blockquote=function(oe){var ue=this.rules.block.blockquote.exec(oe);if(ue){var we=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(we,[]),text:we}}},De.list=function(oe){var ue=this.rules.block.list.exec(oe);if(ue){var we,ve,Fe,Ge,ze,Ye,lt,xe,ge,be,ie=ue[1].trim(),Q=ie.length>1,Se={type:"list",raw:"",ordered:Q,start:Q?+ie.slice(0,-1):"",loose:!1,items:[]};ie=Q?"\\d{1,9}\\"+ie.slice(-1):"\\"+ie,this.options.pedantic&&(ie=Q?ie:"[*+-]");for(var Le=new RegExp("^( {0,3}"+ie+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");oe&&!(this.rules.block.hr.test(oe)||!(ue=Le.exec(oe)));){ge=ue[2].split(`
`),this.options.pedantic?(Ge=2,be=ge[0].trimLeft()):(Ge=ue[2].search(/[^ ]/),Ge=ue[1].length+(Ge>4?1:Ge),be=ge[0].slice(Ge-ue[1].length)),Ye=!1,we=ue[0],!ge[0]&&/^ *$/.test(ge[1])&&(we=ue[1]+ge.slice(0,2).join(`
`)+`
`,Se.loose=!0,ge=[]);var nt=new RegExp("^ {0,"+Math.min(3,Ge-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(ze=1;ze<ge.length;ze++){if(xe=ge[ze],this.options.pedantic&&(xe=xe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),nt.test(xe)){we=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}if(!Ye){xe.trim()||(Ye=!0),xe.search(/[^ ]/)>=Ge?be+=`
`+xe.slice(Ge):be+=`
`+xe;continue}if(xe.search(/[^ ]/)>=Ge||!xe.trim()){be+=`
`+xe.slice(Ge);continue}else{we=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}}Se.loose||(lt?Se.loose=!0:/\n *\n *$/.test(we)&&(lt=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(be),ve&&(Fe=ve[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:we,task:!!ve,checked:Fe,loose:!1,text:be}),Se.raw+=we,oe=oe.slice(we.length)}Se.items[Se.items.length-1].raw=we.trimRight(),Se.items[Se.items.length-1].text=be.trimRight(),Se.raw=Se.raw.trimRight();var qe=Se.items.length;for(ze=0;ze<qe;ze++)this.lexer.state.top=!1,Se.items[ze].tokens=this.lexer.blockTokens(Se.items[ze].text,[]),Se.items[ze].tokens.some(function(gt){return gt.type==="space"})&&(Se.loose=!0,Se.items[ze].loose=!0);return Se}},De.html=function(oe){var ue=this.rules.block.html.exec(oe);if(ue){var we={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(we.type="paragraph",we.text=this.options.sanitizer?this.options.sanitizer(ue[0]):N(ue[0]),we.tokens=[],this.lexer.inline(we.text,we.tokens)),we}},De.def=function(oe){var ue=this.rules.block.def.exec(oe);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var we=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:we,raw:ue[0],href:ue[2],title:ue[3]}}},De.table=function(oe){var ue=this.rules.block.table.exec(oe);if(ue){var we={type:"table",header:V(ue[1]).map(function(lt){return{text:lt}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(we.header.length===we.align.length){we.raw=ue[0];var ve=we.align.length,Fe,Ge,ze,Ye;for(Fe=0;Fe<ve;Fe++)/^ *-+: *$/.test(we.align[Fe])?we.align[Fe]="right":/^ *:-+: *$/.test(we.align[Fe])?we.align[Fe]="center":/^ *:-+ *$/.test(we.align[Fe])?we.align[Fe]="left":we.align[Fe]=null;for(ve=we.rows.length,Fe=0;Fe<ve;Fe++)we.rows[Fe]=V(we.rows[Fe],we.header.length).map(function(lt){return{text:lt}});for(ve=we.header.length,Ge=0;Ge<ve;Ge++)we.header[Ge].tokens=[],this.lexer.inlineTokens(we.header[Ge].text,we.header[Ge].tokens);for(ve=we.rows.length,Ge=0;Ge<ve;Ge++)for(Ye=we.rows[Ge],ze=0;ze<Ye.length;ze++)Ye[ze].tokens=[],this.lexer.inlineTokens(Ye[ze].text,Ye[ze].tokens);return we}}},De.lheading=function(oe){var ue=this.rules.block.lheading.exec(oe);if(ue){var we={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.paragraph=function(oe){var ue=this.rules.block.paragraph.exec(oe);if(ue){var we={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.text=function(oe){var ue=this.rules.block.text.exec(oe);if(ue){var we={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.escape=function(oe){var ue=this.rules.inline.escape.exec(oe);if(ue)return{type:"escape",raw:ue[0],text:N(ue[1])}},De.tag=function(oe){var ue=this.rules.inline.tag.exec(oe);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):N(ue[0]):ue[0]}},De.link=function(oe){var ue=this.rules.inline.link.exec(oe);if(ue){var we=ue[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;var ve=B(we.slice(0,-1),"\\");if((we.length-ve.length)%2==0)return}else{var Fe=j(ue[2],"()");if(Fe>-1){var Ge=ue[0].indexOf("!")===0?5:4,ze=Ge+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,ze).trim(),ue[3]=""}}var Ye=ue[2],lt="";if(this.options.pedantic){var xe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ye);xe&&(Ye=xe[1],lt=xe[3])}else lt=ue[3]?ue[3].slice(1,-1):"";return Ye=Ye.trim(),/^</.test(Ye)&&(this.options.pedantic&&!/>$/.test(we)?Ye=Ye.slice(1):Ye=Ye.slice(1,-1)),U(ue,{href:Ye&&Ye.replace(this.rules.inline._escapes,"$1"),title:lt&&lt.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},De.reflink=function(oe,ue){var we;if((we=this.rules.inline.reflink.exec(oe))||(we=this.rules.inline.nolink.exec(oe))){var ve=(we[2]||we[1]).replace(/\s+/g," ");if(ve=ue[ve.toLowerCase()],!ve||!ve.href){var Fe=we[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return U(we,ve,we[0],this.lexer)}},De.emStrong=function(oe,ue,we){we===void 0&&(we="");var ve=this.rules.inline.emStrong.lDelim.exec(oe);if(!!ve&&!(ve[3]&&we.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=ve[1]||ve[2]||"";if(!Fe||Fe&&(we===""||this.rules.inline.punctuation.exec(we))){var Ge=ve[0].length-1,ze,Ye,lt=Ge,xe=0,ge=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,ue=ue.slice(-1*oe.length+Ge);(ve=ge.exec(ue))!=null;)if(ze=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!ze){if(Ye=ze.length,ve[3]||ve[4]){lt+=Ye;continue}else if((ve[5]||ve[6])&&Ge%3&&!((Ge+Ye)%3)){xe+=Ye;continue}if(lt-=Ye,!(lt>0)){if(Ye=Math.min(Ye,Ye+lt+xe),Math.min(Ge,Ye)%2){var be=oe.slice(1,Ge+ve.index+Ye);return{type:"em",raw:oe.slice(0,Ge+ve.index+Ye+1),text:be,tokens:this.lexer.inlineTokens(be,[])}}var ie=oe.slice(2,Ge+ve.index+Ye-1);return{type:"strong",raw:oe.slice(0,Ge+ve.index+Ye+1),text:ie,tokens:this.lexer.inlineTokens(ie,[])}}}}}},De.codespan=function(oe){var ue=this.rules.inline.code.exec(oe);if(ue){var we=ue[2].replace(/\n/g," "),ve=/[^ ]/.test(we),Fe=/^ /.test(we)&&/ $/.test(we);return ve&&Fe&&(we=we.substring(1,we.length-1)),we=N(we,!0),{type:"codespan",raw:ue[0],text:we}}},De.br=function(oe){var ue=this.rules.inline.br.exec(oe);if(ue)return{type:"br",raw:ue[0]}},De.del=function(oe){var ue=this.rules.inline.del.exec(oe);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},De.autolink=function(oe,ue){var we=this.rules.inline.autolink.exec(oe);if(we){var ve,Fe;return we[2]==="@"?(ve=N(this.options.mangle?ue(we[1]):we[1]),Fe="mailto:"+ve):(ve=N(we[1]),Fe=ve),{type:"link",raw:we[0],text:ve,href:Fe,tokens:[{type:"text",raw:ve,text:ve}]}}},De.url=function(oe,ue){var we;if(we=this.rules.inline.url.exec(oe)){var ve,Fe;if(we[2]==="@")ve=N(this.options.mangle?ue(we[0]):we[0]),Fe="mailto:"+ve;else{var Ge;do Ge=we[0],we[0]=this.rules.inline._backpedal.exec(we[0])[0];while(Ge!==we[0]);ve=N(we[0]),we[1]==="www."?Fe="http://"+ve:Fe=ve}return{type:"link",raw:we[0],text:ve,href:Fe,tokens:[{type:"text",raw:ve,text:ve}]}}},De.inlineText=function(oe,ue){var we=this.rules.inline.text.exec(oe);if(we){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):N(we[0]):we[0]:ve=N(this.options.smartypants?ue(we[0]):we[0]),{type:"text",raw:we[0],text:ve}}},Re}(),O=M.noopTest,W=M.edit,$=M.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=W(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.listItemStart=W(/^( *)(bull) */).replace("bull",X.bullet).getRegex(),X.list=W(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=W(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=W(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.blockquote=W(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=$({},X),X.gfm=$({},X.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.table=W(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.pedantic=$({},X.normal,{html:W(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:W(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=W(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=W(X._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=W(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=W(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=W(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=W(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=W(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=W(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=W(K.reflink).replace("label",K._label).getRegex(),K.reflinkSearch=W(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=$({},K),K.pedantic=$({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:W(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:W(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=$({},K.normal,{escape:W(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),K.gfm.url=W(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=$({},K.gfm,{br:W(K.br).replace("{2,}","*").getRegex(),text:W(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:X,inline:K},_e=z,Ce=S.exports.defaults,Pe=de.block,Be=de.inline,$e=M.repeatString;function He(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(Re){var De="",Te,oe,ue=Re.length;for(Te=0;Te<ue;Te++)oe=Re.charCodeAt(Te),Math.random()>.5&&(oe="x"+oe.toString(16)),De+="&#"+oe+";";return De}var ee=function(){function Re(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||Ce,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:Pe.normal,inline:Be.normal};this.options.pedantic?(oe.block=Pe.pedantic,oe.inline=Be.pedantic):this.options.gfm&&(oe.block=Pe.gfm,this.options.breaks?oe.inline=Be.breaks:oe.inline=Be.gfm),this.tokenizer.rules=oe}Re.lex=function(oe,ue){var we=new Re(ue);return we.lex(oe)},Re.lexInline=function(oe,ue){var we=new Re(ue);return we.inlineTokens(oe)};var De=Re.prototype;return De.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},De.blockTokens=function(oe,ue){var we=this;ue===void 0&&(ue=[]),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var ve,Fe,Ge,ze;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(lt){return(ve=lt.call({lexer:we},oe,ue))?(oe=oe.substring(ve.raw.length),ue.push(ve),!0):!1}))){if(ve=this.tokenizer.space(oe)){oe=oe.substring(ve.raw.length),ve.type&&ue.push(ve);continue}if(ve=this.tokenizer.code(oe)){oe=oe.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(ve);continue}if(ve=this.tokenizer.fences(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.heading(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.hr(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.blockquote(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.list(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.html(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.def(oe)){oe=oe.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.lheading(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(Ge=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var lt=Infinity,xe=oe.slice(1),ge=void 0;we.options.extensions.startBlock.forEach(function(be){ge=be.call({lexer:this},xe),typeof ge=="number"&&ge>=0&&(lt=Math.min(lt,ge))}),lt<Infinity&&lt>=0&&(Ge=oe.substring(0,lt+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(Ge))){Fe=ue[ue.length-1],ze&&Fe.type==="paragraph"?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(ve),ze=Ge.length!==oe.length,oe=oe.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(oe)){oe=oe.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(ve);continue}if(oe){var Ye="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Ye);break}else throw new Error(Ye)}}return this.state.top=!0,ue},De.inline=function(oe,ue){this.inlineQueue.push({src:oe,tokens:ue})},De.inlineTokens=function(oe,ue){var we=this;ue===void 0&&(ue=[]);var ve,Fe,Ge,ze=oe,Ye,lt,xe;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(Ye=this.tokenizer.rules.inline.reflinkSearch.exec(ze))!=null;)ge.includes(Ye[0].slice(Ye[0].lastIndexOf("[")+1,-1))&&(ze=ze.slice(0,Ye.index)+"["+$e("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ye=this.tokenizer.rules.inline.blockSkip.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"["+$e("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ye=this.tokenizer.rules.inline.escapedEmSt.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"++"+ze.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(lt||(xe=""),lt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ie){return(ve=ie.call({lexer:we},oe,ue))?(oe=oe.substring(ve.raw.length),ue.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.tag(oe)){oe=oe.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&ve.type==="text"&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ue.push(ve);continue}if(ve=this.tokenizer.link(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&ve.type==="text"&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ue.push(ve);continue}if(ve=this.tokenizer.emStrong(oe,ze,xe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.codespan(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.br(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.del(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.autolink(oe,G)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(oe,G))){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(Ge=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ie=Infinity,Q=oe.slice(1),Se=void 0;we.options.extensions.startInline.forEach(function(Le){Se=Le.call({lexer:this},Q),typeof Se=="number"&&Se>=0&&(ie=Math.min(ie,Se))}),ie<Infinity&&ie>=0&&(Ge=oe.substring(0,ie+1))}(),ve=this.tokenizer.inlineText(Ge,He)){oe=oe.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(xe=ve.raw.slice(-1)),lt=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ue.push(ve);continue}if(oe){var be="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return ue},e(Re,null,[{key:"rules",get:function(){return{block:Pe,inline:Be}}}]),Re}(),te=S.exports.defaults,ce=M.cleanUrl,Z=M.escape,re=function(){function Re(Te){this.options=Te||te}var De=Re.prototype;return De.code=function(oe,ue,we){var ve=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(oe,ve);Fe!=null&&Fe!==oe&&(we=!0,oe=Fe)}return oe=oe.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+Z(ve,!0)+'">'+(we?oe:Z(oe,!0))+`</code></pre>
`:"<pre><code>"+(we?oe:Z(oe,!0))+`</code></pre>
`},De.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},De.html=function(oe){return oe},De.heading=function(oe,ue,we,ve){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+ve.slug(we)+'">'+oe+"</h"+ue+`>
`:"<h"+ue+">"+oe+"</h"+ue+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(oe,ue,we){var ve=ue?"ol":"ul",Fe=ue&&we!==1?' start="'+we+'"':"";return"<"+ve+Fe+`>
`+oe+"</"+ve+`>
`},De.listitem=function(oe){return"<li>"+oe+`</li>
`},De.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(oe){return"<p>"+oe+`</p>
`},De.table=function(oe,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ue+`</table>
`},De.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},De.tablecell=function(oe,ue){var we=ue.header?"th":"td",ve=ue.align?"<"+we+' align="'+ue.align+'">':"<"+we+">";return ve+oe+"</"+we+`>
`},De.strong=function(oe){return"<strong>"+oe+"</strong>"},De.em=function(oe){return"<em>"+oe+"</em>"},De.codespan=function(oe){return"<code>"+oe+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(oe){return"<del>"+oe+"</del>"},De.link=function(oe,ue,we){if(oe=ce(this.options.sanitize,this.options.baseUrl,oe),oe===null)return we;var ve='<a href="'+Z(oe)+'"';return ue&&(ve+=' title="'+ue+'"'),ve+=">"+we+"</a>",ve},De.image=function(oe,ue,we){if(oe=ce(this.options.sanitize,this.options.baseUrl,oe),oe===null)return we;var ve='<img src="'+oe+'" alt="'+we+'"';return ue&&(ve+=' title="'+ue+'"'),ve+=this.options.xhtml?"/>":">",ve},De.text=function(oe){return oe},Re}(),pe=function(){function Re(){}var De=Re.prototype;return De.strong=function(oe){return oe},De.em=function(oe){return oe},De.codespan=function(oe){return oe},De.del=function(oe){return oe},De.html=function(oe){return oe},De.text=function(oe){return oe},De.link=function(oe,ue,we){return""+we},De.image=function(oe,ue,we){return""+we},De.br=function(){return""},Re}(),Me=function(){function Re(){this.seen={}}var De=Re.prototype;return De.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(oe,ue){var we=oe,ve=0;if(this.seen.hasOwnProperty(we)){ve=this.seen[oe];do ve++,we=oe+"-"+ve;while(this.seen.hasOwnProperty(we))}return ue||(this.seen[oe]=ve,this.seen[we]=0),we},De.slug=function(oe,ue){ue===void 0&&(ue={});var we=this.serialize(oe);return this.getNextSafeSlug(we,ue.dryrun)},Re}(),je=re,Ke=pe,Ze=Me,rt=S.exports.defaults,ct=M.unescape,ye=function(){function Re(Te){this.options=Te||rt,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Ze}Re.parse=function(oe,ue){var we=new Re(ue);return we.parse(oe)},Re.parseInline=function(oe,ue){var we=new Re(ue);return we.parseInline(oe)};var De=Re.prototype;return De.parse=function(oe,ue){ue===void 0&&(ue=!0);var we="",ve,Fe,Ge,ze,Ye,lt,xe,ge,be,ie,Q,Se,Le,nt,qe,gt,Et,pt,vt,wt=oe.length;for(ve=0;ve<wt;ve++){if(ie=oe[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ie.type]&&(vt=this.options.extensions.renderers[ie.type].call({parser:this},ie),vt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ie.type))){we+=vt||"";continue}switch(ie.type){case"space":continue;case"hr":{we+=this.renderer.hr();continue}case"heading":{we+=this.renderer.heading(this.parseInline(ie.tokens),ie.depth,ct(this.parseInline(ie.tokens,this.textRenderer)),this.slugger);continue}case"code":{we+=this.renderer.code(ie.text,ie.lang,ie.escaped);continue}case"table":{for(ge="",xe="",ze=ie.header.length,Fe=0;Fe<ze;Fe++)xe+=this.renderer.tablecell(this.parseInline(ie.header[Fe].tokens),{header:!0,align:ie.align[Fe]});for(ge+=this.renderer.tablerow(xe),be="",ze=ie.rows.length,Fe=0;Fe<ze;Fe++){for(lt=ie.rows[Fe],xe="",Ye=lt.length,Ge=0;Ge<Ye;Ge++)xe+=this.renderer.tablecell(this.parseInline(lt[Ge].tokens),{header:!1,align:ie.align[Ge]});be+=this.renderer.tablerow(xe)}we+=this.renderer.table(ge,be);continue}case"blockquote":{be=this.parse(ie.tokens),we+=this.renderer.blockquote(be);continue}case"list":{for(Q=ie.ordered,Se=ie.start,Le=ie.loose,ze=ie.items.length,be="",Fe=0;Fe<ze;Fe++)qe=ie.items[Fe],gt=qe.checked,Et=qe.task,nt="",qe.task&&(pt=this.renderer.checkbox(gt),Le?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=pt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=pt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:pt}):nt+=pt),nt+=this.parse(qe.tokens,Le),be+=this.renderer.listitem(nt,Et,gt);we+=this.renderer.list(be,Q,Se);continue}case"html":{we+=this.renderer.html(ie.text);continue}case"paragraph":{we+=this.renderer.paragraph(this.parseInline(ie.tokens));continue}case"text":{for(be=ie.tokens?this.parseInline(ie.tokens):ie.text;ve+1<wt&&oe[ve+1].type==="text";)ie=oe[++ve],be+=`
`+(ie.tokens?this.parseInline(ie.tokens):ie.text);we+=ue?this.renderer.paragraph(be):be;continue}default:{var Dt='Token with "'+ie.type+'" type was not found.';if(this.options.silent){console.error(Dt);return}else throw new Error(Dt)}}}return we},De.parseInline=function(oe,ue){ue=ue||this.renderer;var we="",ve,Fe,Ge,ze=oe.length;for(ve=0;ve<ze;ve++){if(Fe=oe[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ge=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){we+=Ge||"";continue}switch(Fe.type){case"escape":{we+=ue.text(Fe.text);break}case"html":{we+=ue.html(Fe.text);break}case"link":{we+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{we+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{we+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{we+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{we+=ue.codespan(Fe.text);break}case"br":{we+=ue.br();break}case"del":{we+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{we+=ue.text(Fe.text);break}default:{var Ye='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return we},Re}(),at=ee,J=ye,se=z,Ee=re,Qe=pe,et=Me,le=M.merge,Ie=M.checkSanitizeDeprecation,Ue=M.escape,Xe=S.exports.getDefaults,it=S.exports.changeDefaults,ft=S.exports.defaults;function tt(Re,De,Te){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof De=="function"&&(Te=De,De=null),De=le({},tt.defaults,De||{}),Ie(De),Te){var oe=De.highlight,ue;try{ue=at.lex(Re,De)}catch(Ge){return Te(Ge)}var we=function(ze){var Ye;if(!ze)try{De.walkTokens&&tt.walkTokens(ue,De.walkTokens),Ye=J.parse(ue,De)}catch(lt){ze=lt}return De.highlight=oe,ze?Te(ze):Te(null,Ye)};if(!oe||oe.length<3||(delete De.highlight,!ue.length))return we();var ve=0;tt.walkTokens(ue,function(Ge){Ge.type==="code"&&(ve++,setTimeout(function(){oe(Ge.text,Ge.lang,function(ze,Ye){if(ze)return we(ze);Ye!=null&&Ye!==Ge.text&&(Ge.text=Ye,Ge.escaped=!0),ve--,ve===0&&we()})},0))}),ve===0&&we();return}try{var Fe=at.lex(Re,De);return De.walkTokens&&tt.walkTokens(Fe,De.walkTokens),J.parse(Fe,De)}catch(Ge){if(Ge.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ue(Ge.message+"",!0)+"</pre>";throw Ge}}tt.options=tt.setOptions=function(Re){return le(tt.defaults,Re),it(tt.defaults),tt},tt.getDefaults=Xe,tt.defaults=ft,tt.use=function(){for(var Re=this,De=arguments.length,Te=new Array(De),oe=0;oe<De;oe++)Te[oe]=arguments[oe];var ue=le.apply(void 0,[{}].concat(Te)),we=tt.defaults.extensions||{renderers:{},childTokens:{}},ve;Te.forEach(function(Fe){if(Fe.extensions&&(ve=!0,Fe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var Ye=we.renderers?we.renderers[ze.name]:null;Ye?we.renderers[ze.name]=function(){for(var lt=arguments.length,xe=new Array(lt),ge=0;ge<lt;ge++)xe[ge]=arguments[ge];var be=ze.renderer.apply(this,xe);return be===!1&&(be=Ye.apply(this,xe)),be}:we.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");we[ze.level]?we[ze.level].unshift(ze.tokenizer):we[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?we.startBlock?we.startBlock.push(ze.start):we.startBlock=[ze.start]:ze.level==="inline"&&(we.startInline?we.startInline.push(ze.start):we.startInline=[ze.start]))}ze.childTokens&&(we.childTokens[ze.name]=ze.childTokens)})),Fe.renderer&&function(){var ze=tt.defaults.renderer||new Ee,Ye=function(ge){var be=ze[ge];ze[ge]=function(){for(var ie=arguments.length,Q=new Array(ie),Se=0;Se<ie;Se++)Q[Se]=arguments[Se];var Le=Fe.renderer[ge].apply(ze,Q);return Le===!1&&(Le=be.apply(ze,Q)),Le}};for(var lt in Fe.renderer)Ye(lt);ue.renderer=ze}(),Fe.tokenizer&&function(){var ze=tt.defaults.tokenizer||new se,Ye=function(ge){var be=ze[ge];ze[ge]=function(){for(var ie=arguments.length,Q=new Array(ie),Se=0;Se<ie;Se++)Q[Se]=arguments[Se];var Le=Fe.tokenizer[ge].apply(ze,Q);return Le===!1&&(Le=be.apply(ze,Q)),Le}};for(var lt in Fe.tokenizer)Ye(lt);ue.tokenizer=ze}(),Fe.walkTokens){var Ge=tt.defaults.walkTokens;ue.walkTokens=function(ze){Fe.walkTokens.call(Re,ze),Ge&&Ge(ze)}}ve&&(ue.extensions=we),tt.setOptions(ue)})},tt.walkTokens=function(Re,De){for(var Te=function(){var ve=ue.value;switch(De(ve),ve.type){case"table":{for(var Fe=C(ve.header),Ge;!(Ge=Fe()).done;){var ze=Ge.value;tt.walkTokens(ze.tokens,De)}for(var Ye=C(ve.rows),lt;!(lt=Ye()).done;)for(var xe=lt.value,ge=C(xe),be;!(be=ge()).done;){var ie=be.value;tt.walkTokens(ie.tokens,De)}break}case"list":{tt.walkTokens(ve.items,De);break}default:tt.defaults.extensions&&tt.defaults.extensions.childTokens&&tt.defaults.extensions.childTokens[ve.type]?tt.defaults.extensions.childTokens[ve.type].forEach(function(Q){tt.walkTokens(ve[Q],De)}):ve.tokens&&tt.walkTokens(ve.tokens,De)}},oe=C(Re),ue;!(ue=oe()).done;)Te()},tt.parseInline=function(Re,De){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");De=le({},tt.defaults,De||{}),Ie(De);try{var Te=at.lexInline(Re,De);return De.walkTokens&&tt.walkTokens(Te,De.walkTokens),J.parseInline(Te,De)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ue(oe.message+"",!0)+"</pre>";throw oe}},tt.Parser=J,tt.parser=J.parse,tt.Renderer=Ee,tt.TextRenderer=Qe,tt.Lexer=at,tt.lexer=at.lex,tt.Tokenizer=se,tt.Slugger=et,tt.parse=tt;var ut=tt;return ut}),define(fe[78],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(P,_,y){return Math.min(Math.max(P,_),y)}e.clamp=g;function F(P,_){return(_+P%_)%_}e.rot=F;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class S{constructor(){this._n=1,this._val=0}update(_){return this._val=this._val+(_-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=S}),function(){function Y(C){const S=[];typeof C=="number"&&S.push("code/timeOrigin",C);function P(y){S.push(y,Date.now())}function _(){const y=[];for(let k=0;k<S.length;k+=2)y.push({name:S[k],startTime:S[k+1]});return y}return{mark:P,getMarks:_}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const P of performance.getEntriesByType("mark"))S.push({name:P.name,startTime:Math.round(C+P.startTime)});return S}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function g(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=g(F))}(),define(fe[11],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let F=!1,C=!1,S=!1,P=!1,_=!1,y=!1,k=!1,i,I=g,a,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const w=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=w&&h?.sandboxed,typeof navigator=="object"&&!w)p=navigator.userAgent,F=p.indexOf("Windows")>=0,C=p.indexOf("Macintosh")>=0,k=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=p.indexOf("Linux")>=0,y=!0,i=navigator.language,I=i;else if(typeof h=="object"){F=h.platform==="win32",C=h.platform==="darwin",S=h.platform==="linux",P=S&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,i=g,I=g;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const t=JSON.parse(r),d=t.availableLanguages["*"];i=t.locale,I=d||g,a=t._translationsConfigFile}catch(t){}_=!0}else console.error("Unable to resolve platform.");var D;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function T(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=T;let b=0;C?b=1:F?b=3:S&&(b=2),e.isWindows=F,e.isMacintosh=C,e.isLinux=S,e.isLinuxSnap=P,e.isNative=_,e.isWeb=y,e.isIOS=k,e.platform=b,e.userAgent=p,e.language=I;var l;(function(r){function t(){return e.language}r.value=t;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=d;function s(){return e.language==="en"}r.isDefault=s})(l=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=a,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let d=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeSetImmediateId)for(let m=0,u=d.length;m<u;m++){const E=d[m];if(E.id===c.data.vscodeSetImmediateId){d.splice(m,1),E.callback();return}}});let s=0;return c=>{const m=++s;d.push({id:m,callback:c}),e.globals.postMessage({vscodeSetImmediateId:m},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const t=Promise.resolve();return d=>t.then(d)}();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||k?2:F?1:3;let v=!0,n=!1;function f(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,v=new Uint16Array(r.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=f}),define(fe[38],me([0,1,11]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let F;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const C=g.globals.vscode.process;F={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()},nextTick(S){return(0,g.setImmediate)(S)}}}else typeof process!="undefined"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:F={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},get arch(){},nextTick(C){return(0,g.setImmediate)(C)},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.platform=F.platform,e.nextTick=F.nextTick,e.arch=F.arch}),define(fe[8],me([0,1,38]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const F=65,C=97,S=90,P=122,_=46,y=47,k=92,i=58,I=63;class a extends Error{constructor(o,v,n){let f;typeof v=="string"&&v.indexOf("not ")===0?(f="must not be",v=v.replace(/^not /,"")):f="must be";const r=o.indexOf(".")!==-1?"property":"argument";let t=`The "${o}" ${r} ${f} of type ${v}`;t+=`. Received type ${typeof n}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function p(l,o){if(typeof l!="string")throw new a(o,"string",l)}function h(l){return l===y||l===k}function w(l){return l===y}function D(l){return l>=F&&l<=S||l>=C&&l<=P}function T(l,o,v,n){let f="",r=0,t=-1,d=0,s=0;for(let c=0;c<=l.length;++c){if(c<l.length)s=l.charCodeAt(c);else{if(n(s))break;s=y}if(n(s)){if(!(t===c-1||d===1))if(d===2){if(f.length<2||r!==2||f.charCodeAt(f.length-1)!==_||f.charCodeAt(f.length-2)!==_){if(f.length>2){const m=f.lastIndexOf(v);m===-1?(f="",r=0):(f=f.slice(0,m),r=f.length-1-f.lastIndexOf(v)),t=c,d=0;continue}else if(f.length!==0){f="",r=0,t=c,d=0;continue}}o&&(f+=f.length>0?`${v}..`:"..",r=2)}else f.length>0?f+=`${v}${l.slice(t+1,c)}`:f=l.slice(t+1,c),r=c-t-1;t=c,d=0}else s===_&&d!==-1?++d:d=-1}return f}function b(l,o){if(o===null||typeof o!="object")throw new a("pathObject","Object",o);const v=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return v?v===o.root?`${v}${n}`:`${v}${l}${n}`:n}e.win32={resolve(...l){let o="",v="",n=!1;for(let f=l.length-1;f>=-1;f--){let r;if(f>=0){if(r=l[f],p(r,"path"),r.length===0)continue}else o.length===0?r=g.cwd():(r=g.env[`=${o}`]||g.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===k)&&(r=`${o}\\`));const t=r.length;let d=0,s="",c=!1;const m=r.charCodeAt(0);if(t===1)h(m)&&(d=1,c=!0);else if(h(m))if(c=!0,h(r.charCodeAt(1))){let u=2,E=u;for(;u<t&&!h(r.charCodeAt(u));)u++;if(u<t&&u!==E){const R=r.slice(E,u);for(E=u;u<t&&h(r.charCodeAt(u));)u++;if(u<t&&u!==E){for(E=u;u<t&&!h(r.charCodeAt(u));)u++;(u===t||u!==E)&&(s=`\\\\${R}\\${r.slice(E,u)}`,d=u)}}}else d=1;else D(m)&&r.charCodeAt(1)===i&&(s=r.slice(0,2),d=2,t>2&&h(r.charCodeAt(2))&&(c=!0,d=3));if(s.length>0)if(o.length>0){if(s.toLowerCase()!==o.toLowerCase())continue}else o=s;if(n){if(o.length>0)break}else if(v=`${r.slice(d)}\\${v}`,n=c,c&&o.length>0)break}return v=T(v,!n,"\\",h),n?`${o}\\${v}`:`${o}${v}`||"."},normalize(l){p(l,"path");const o=l.length;if(o===0)return".";let v=0,n,f=!1;const r=l.charCodeAt(0);if(o===1)return w(r)?"\\":l;if(h(r))if(f=!0,h(l.charCodeAt(1))){let d=2,s=d;for(;d<o&&!h(l.charCodeAt(d));)d++;if(d<o&&d!==s){const c=l.slice(s,d);for(s=d;d<o&&h(l.charCodeAt(d));)d++;if(d<o&&d!==s){for(s=d;d<o&&!h(l.charCodeAt(d));)d++;if(d===o)return`\\\\${c}\\${l.slice(s)}\\`;d!==s&&(n=`\\\\${c}\\${l.slice(s,d)}`,v=d)}}}else v=1;else D(r)&&l.charCodeAt(1)===i&&(n=l.slice(0,2),v=2,o>2&&h(l.charCodeAt(2))&&(f=!0,v=3));let t=v<o?T(l.slice(v),!f,"\\",h):"";return t.length===0&&!f&&(t="."),t.length>0&&h(l.charCodeAt(o-1))&&(t+="\\"),n===void 0?f?`\\${t}`:t:f?`${n}\\${t}`:`${n}${t}`},isAbsolute(l){p(l,"path");const o=l.length;if(o===0)return!1;const v=l.charCodeAt(0);return h(v)||o>2&&D(v)&&l.charCodeAt(1)===i&&h(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let o,v;for(let r=0;r<l.length;++r){const t=l[r];p(t,"path"),t.length>0&&(o===void 0?o=v=t:o+=`\\${t}`)}if(o===void 0)return".";let n=!0,f=0;if(typeof v=="string"&&h(v.charCodeAt(0))){++f;const r=v.length;r>1&&h(v.charCodeAt(1))&&(++f,r>2&&(h(v.charCodeAt(2))?++f:n=!1))}if(n){for(;f<o.length&&h(o.charCodeAt(f));)f++;f>=2&&(o=`\\${o.slice(f)}`)}return e.win32.normalize(o)},relative(l,o){if(p(l,"from"),p(o,"to"),l===o)return"";const v=e.win32.resolve(l),n=e.win32.resolve(o);if(v===n||(l=v.toLowerCase(),o=n.toLowerCase(),l===o))return"";let f=0;for(;f<l.length&&l.charCodeAt(f)===k;)f++;let r=l.length;for(;r-1>f&&l.charCodeAt(r-1)===k;)r--;const t=r-f;let d=0;for(;d<o.length&&o.charCodeAt(d)===k;)d++;let s=o.length;for(;s-1>d&&o.charCodeAt(s-1)===k;)s--;const c=s-d,m=t<c?t:c;let u=-1,E=0;for(;E<m;E++){const L=l.charCodeAt(f+E);if(L!==o.charCodeAt(d+E))break;L===k&&(u=E)}if(E!==m){if(u===-1)return n}else{if(c>m){if(o.charCodeAt(d+E)===k)return n.slice(d+E+1);if(E===2)return n.slice(d+E)}t>m&&(l.charCodeAt(f+E)===k?u=E:E===2&&(u=3)),u===-1&&(u=0)}let R="";for(E=f+u+1;E<=r;++E)(E===r||l.charCodeAt(E)===k)&&(R+=R.length===0?"..":"\\..");return d+=u,R.length>0?`${R}${n.slice(d,s)}`:(n.charCodeAt(d)===k&&++d,n.slice(d,s))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const o=e.win32.resolve(l);if(o.length<=2)return l;if(o.charCodeAt(0)===k){if(o.charCodeAt(1)===k){const v=o.charCodeAt(2);if(v!==I&&v!==_)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(D(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===k)return`\\\\?\\${o}`;return l},dirname(l){p(l,"path");const o=l.length;if(o===0)return".";let v=-1,n=0;const f=l.charCodeAt(0);if(o===1)return h(f)?l:".";if(h(f)){if(v=n=1,h(l.charCodeAt(1))){let d=2,s=d;for(;d<o&&!h(l.charCodeAt(d));)d++;if(d<o&&d!==s){for(s=d;d<o&&h(l.charCodeAt(d));)d++;if(d<o&&d!==s){for(s=d;d<o&&!h(l.charCodeAt(d));)d++;if(d===o)return l;d!==s&&(v=n=d+1)}}}}else D(f)&&l.charCodeAt(1)===i&&(v=o>2&&h(l.charCodeAt(2))?3:2,n=v);let r=-1,t=!0;for(let d=o-1;d>=n;--d)if(h(l.charCodeAt(d))){if(!t){r=d;break}}else t=!1;if(r===-1){if(v===-1)return".";r=v}return l.slice(0,r)},basename(l,o){o!==void 0&&p(o,"ext"),p(l,"path");let v=0,n=-1,f=!0,r;if(l.length>=2&&D(l.charCodeAt(0))&&l.charCodeAt(1)===i&&(v=2),o!==void 0&&o.length>0&&o.length<=l.length){if(o===l)return"";let t=o.length-1,d=-1;for(r=l.length-1;r>=v;--r){const s=l.charCodeAt(r);if(h(s)){if(!f){v=r+1;break}}else d===-1&&(f=!1,d=r+1),t>=0&&(s===o.charCodeAt(t)?--t==-1&&(n=r):(t=-1,n=d))}return v===n?n=d:n===-1&&(n=l.length),l.slice(v,n)}for(r=l.length-1;r>=v;--r)if(h(l.charCodeAt(r))){if(!f){v=r+1;break}}else n===-1&&(f=!1,n=r+1);return n===-1?"":l.slice(v,n)},extname(l){p(l,"path");let o=0,v=-1,n=0,f=-1,r=!0,t=0;l.length>=2&&l.charCodeAt(1)===i&&D(l.charCodeAt(0))&&(o=n=2);for(let d=l.length-1;d>=o;--d){const s=l.charCodeAt(d);if(h(s)){if(!r){n=d+1;break}continue}f===-1&&(r=!1,f=d+1),s===_?v===-1?v=d:t!==1&&(t=1):v!==-1&&(t=-1)}return v===-1||f===-1||t===0||t===1&&v===f-1&&v===n+1?"":l.slice(v,f)},format:b.bind(null,"\\"),parse(l){p(l,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return o;const v=l.length;let n=0,f=l.charCodeAt(0);if(v===1)return h(f)?(o.root=o.dir=l,o):(o.base=o.name=l,o);if(h(f)){if(n=1,h(l.charCodeAt(1))){let u=2,E=u;for(;u<v&&!h(l.charCodeAt(u));)u++;if(u<v&&u!==E){for(E=u;u<v&&h(l.charCodeAt(u));)u++;if(u<v&&u!==E){for(E=u;u<v&&!h(l.charCodeAt(u));)u++;u===v?n=u:u!==E&&(n=u+1)}}}}else if(D(f)&&l.charCodeAt(1)===i){if(v<=2)return o.root=o.dir=l,o;if(n=2,h(l.charCodeAt(2))){if(v===3)return o.root=o.dir=l,o;n=3}}n>0&&(o.root=l.slice(0,n));let r=-1,t=n,d=-1,s=!0,c=l.length-1,m=0;for(;c>=n;--c){if(f=l.charCodeAt(c),h(f)){if(!s){t=c+1;break}continue}d===-1&&(s=!1,d=c+1),f===_?r===-1?r=c:m!==1&&(m=1):r!==-1&&(m=-1)}return d!==-1&&(r===-1||m===0||m===1&&r===d-1&&r===t+1?o.base=o.name=l.slice(t,d):(o.name=l.slice(t,r),o.base=l.slice(t,d),o.ext=l.slice(r,d))),t>0&&t!==n?o.dir=l.slice(0,t-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let o="",v=!1;for(let n=l.length-1;n>=-1&&!v;n--){const f=n>=0?l[n]:g.cwd();p(f,"path"),f.length!==0&&(o=`${f}/${o}`,v=f.charCodeAt(0)===y)}return o=T(o,!v,"/",w),v?`/${o}`:o.length>0?o:"."},normalize(l){if(p(l,"path"),l.length===0)return".";const o=l.charCodeAt(0)===y,v=l.charCodeAt(l.length-1)===y;return l=T(l,!o,"/",w),l.length===0?o?"/":v?"./":".":(v&&(l+="/"),o?`/${l}`:l)},isAbsolute(l){return p(l,"path"),l.length>0&&l.charCodeAt(0)===y},join(...l){if(l.length===0)return".";let o;for(let v=0;v<l.length;++v){const n=l[v];p(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.posix.normalize(o)},relative(l,o){if(p(l,"from"),p(o,"to"),l===o||(l=e.posix.resolve(l),o=e.posix.resolve(o),l===o))return"";const v=1,n=l.length,f=n-v,r=1,t=o.length-r,d=f<t?f:t;let s=-1,c=0;for(;c<d;c++){const u=l.charCodeAt(v+c);if(u!==o.charCodeAt(r+c))break;u===y&&(s=c)}if(c===d)if(t>d){if(o.charCodeAt(r+c)===y)return o.slice(r+c+1);if(c===0)return o.slice(r+c)}else f>d&&(l.charCodeAt(v+c)===y?s=c:c===0&&(s=0));let m="";for(c=v+s+1;c<=n;++c)(c===n||l.charCodeAt(c)===y)&&(m+=m.length===0?"..":"/..");return`${m}${o.slice(r+s)}`},toNamespacedPath(l){return l},dirname(l){if(p(l,"path"),l.length===0)return".";const o=l.charCodeAt(0)===y;let v=-1,n=!0;for(let f=l.length-1;f>=1;--f)if(l.charCodeAt(f)===y){if(!n){v=f;break}}else n=!1;return v===-1?o?"/":".":o&&v===1?"//":l.slice(0,v)},basename(l,o){o!==void 0&&p(o,"ext"),p(l,"path");let v=0,n=-1,f=!0,r;if(o!==void 0&&o.length>0&&o.length<=l.length){if(o===l)return"";let t=o.length-1,d=-1;for(r=l.length-1;r>=0;--r){const s=l.charCodeAt(r);if(s===y){if(!f){v=r+1;break}}else d===-1&&(f=!1,d=r+1),t>=0&&(s===o.charCodeAt(t)?--t==-1&&(n=r):(t=-1,n=d))}return v===n?n=d:n===-1&&(n=l.length),l.slice(v,n)}for(r=l.length-1;r>=0;--r)if(l.charCodeAt(r)===y){if(!f){v=r+1;break}}else n===-1&&(f=!1,n=r+1);return n===-1?"":l.slice(v,n)},extname(l){p(l,"path");let o=-1,v=0,n=-1,f=!0,r=0;for(let t=l.length-1;t>=0;--t){const d=l.charCodeAt(t);if(d===y){if(!f){v=t+1;break}continue}n===-1&&(f=!1,n=t+1),d===_?o===-1?o=t:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||n===-1||r===0||r===1&&o===n-1&&o===v+1?"":l.slice(o,n)},format:b.bind(null,"/"),parse(l){p(l,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return o;const v=l.charCodeAt(0)===y;let n;v?(o.root="/",n=1):n=0;let f=-1,r=0,t=-1,d=!0,s=l.length-1,c=0;for(;s>=n;--s){const m=l.charCodeAt(s);if(m===y){if(!d){r=s+1;break}continue}t===-1&&(d=!1,t=s+1),m===_?f===-1?f=s:c!==1&&(c=1):f!==-1&&(c=-1)}if(t!==-1){const m=r===0&&v?1:r;f===-1||c===0||c===1&&f===t-1&&f===r+1?o.base=o.name=l.slice(m,t):(o.name=l.slice(m,f),o.base=l.slice(m,t),o.ext=l.slice(f,t))}return r>0?o.dir=l.slice(0,r-1):v&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(fe[96],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var F;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(F=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(S,...P){const _=P.reduce((i,I)=>(i[I]=!0,i),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(i=>!_[i]).forEach(i=>{for(let I=0;I<y.length;I++)if(i.search(y[I])!==-1){delete S[i];break}})}e.sanitizeProcessEnvironment=C}),define(fe[142],me([0,1]),function(Y,e){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class F{constructor(_,y,k){this.level=_,this.key=y,this.value=k,this.forward=[]}}const C=void 0;class S{constructor(_,y=2**16){this.comparator=_,this[g]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(y)|0),this._header=new F(this._maxLevel,C,C)}get size(){return this._size}clear(){this._header=new F(this._maxLevel,C,C)}has(_){return Boolean(S._search(this,_,this.comparator))}get(_){return S._search(this,_,this.comparator)?.value}set(_,y){return S._insert(this,_,y,this.comparator)&&(this._size+=1),this}delete(_){const y=S._delete(this,_,this.comparator);return y&&(this._size-=1),y}forEach(_,y){let k=this._header.forward[0];for(;k;)_.call(y,k.value,k.key,this),k=k.forward[0]}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let _=this._header.forward[0];for(;_;)yield[_.key,_.value],_=_.forward[0]}*keys(){let _=this._header.forward[0];for(;_;)yield _.key,_=_.forward[0]}*values(){let _=this._header.forward[0];for(;_;)yield _.value,_=_.forward[0]}toString(){let _="[SkipList]:",y=this._header.forward[0];for(;y;)_+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return _}static _search(_,y,k){let i=_._header;for(let I=_._level-1;I>=0;I--)for(;i.forward[I]&&k(i.forward[I].key,y)<0;)i=i.forward[I];if(i=i.forward[0],i&&k(i.key,y)===0)return i}static _insert(_,y,k,i){let I=[],a=_._header;for(let p=_._level-1;p>=0;p--){for(;a.forward[p]&&i(a.forward[p].key,y)<0;)a=a.forward[p];I[p]=a}if(a=a.forward[0],a&&i(a.key,y)===0)return a.value=k,!1;{let p=S._randomLevel(_);if(p>_._level){for(let h=_._level;h<p;h++)I[h]=_._header;_._level=p}a=new F(p,y,k);for(let h=0;h<p;h++)a.forward[h]=I[h].forward[h],I[h].forward[h]=a;return!0}}static _randomLevel(_,y=.5){let k=1;for(;Math.random()<y&&k<_._maxLevel;)k+=1;return k}static _delete(_,y,k){let i=[],I=_._header;for(let a=_._level-1;a>=0;a--){for(;I.forward[a]&&k(I.forward[a].key,y)<0;)I=I.forward[a];i[a]=I}if(I=I.forward[0],!I||k(I.key,y)!==0)return!1;for(let a=0;a<_._level&&i[a].forward[a]===I;a++)i[a].forward[a]=I.forward[a];for(;_._level>0&&_._header.forward[_._level-1]===C;)_._level-=1;return!0}}e.SkipList=S}),define(fe[46],me([0,1,11]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const F=g.globals.performance&&typeof g.globals.performance.now=="function";class C{constructor(P){this._highResolution=F&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new C(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=C}),define(fe[3],me([0,1,17,76,6,95,46]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var _;(function(o){o.None=()=>C.Disposable.None;function v(N){return(j,U=null,x)=>{let z=!1,O;return O=N(W=>{if(!z)return O?O.dispose():z=!0,j.call(U,W)},null,x),z&&O.dispose(),O}}o.once=v;function n(N,j){return c((U,x=null,z)=>N(O=>U.call(x,j(O)),null,z))}o.map=n;function f(N,j){return c((U,x=null,z)=>N(O=>{j(O),U.call(x,O)},null,z))}o.forEach=f;function r(N,j){return c((U,x=null,z)=>N(O=>j(O)&&U.call(x,O),null,z))}o.filter=r;function t(N){return N}o.signal=t;function d(...N){return(j,U=null,x)=>(0,C.combinedDisposable)(...N.map(z=>z(O=>j.call(U,O),null,x)))}o.any=d;function s(N,j,U){let x=U;return n(N,z=>(x=j(x,z),x))}o.reduce=s;function c(N){let j;const U=new a({onFirstListenerAdd(){j=N(U.fire,U)},onLastListenerRemove(){j.dispose()}});return U.event}function m(N,j,U=100,x=!1,z){let O,W,$,X=0;const K=new a({leakWarningThreshold:z,onFirstListenerAdd(){O=N(de=>{X++,W=j(W,de),x&&!$&&(K.fire(W),W=void 0),clearTimeout($),$=setTimeout(()=>{const _e=W;W=void 0,$=void 0,(!x||X>1)&&K.fire(_e),X=0},U)})},onLastListenerRemove(){O.dispose()}});return K.event}o.debounce=m;function u(N,j=(U,x)=>U===x){let U=!0,x;return r(N,z=>{const O=U||!j(z,x);return U=!1,x=z,O})}o.latch=u;function E(N,j){return[o.filter(N,j),o.filter(N,U=>!j(U))]}o.split=E;function R(N,j=!1,U=[]){let x=U.slice(),z=N($=>{x?x.push($):W.fire($)});const O=()=>{x&&x.forEach($=>W.fire($)),x=null},W=new a({onFirstListenerAdd(){z||(z=N($=>W.fire($)))},onFirstListenerDidAdd(){x&&(j?setTimeout(O):O())},onLastListenerRemove(){z&&z.dispose(),z=null}});return W.event}o.buffer=R;class L{constructor(j){this.event=j}map(j){return new L(n(this.event,j))}forEach(j){return new L(f(this.event,j))}filter(j){return new L(r(this.event,j))}reduce(j,U){return new L(s(this.event,j,U))}latch(){return new L(u(this.event))}debounce(j,U=100,x=!1,z){return new L(m(this.event,j,U,x,z))}on(j,U,x){return this.event(j,U,x)}once(j,U,x){return v(this.event)(j,U,x)}}function M(N){return new L(N)}o.chain=M;function A(N,j,U=x=>x){const x=(...$)=>W.fire(U(...$)),z=()=>N.on(j,x),O=()=>N.removeListener(j,x),W=new a({onFirstListenerAdd:z,onLastListenerRemove:O});return W.event}o.fromNodeEventEmitter=A;function B(N,j,U=x=>x){const x=(...$)=>W.fire(U(...$)),z=()=>N.addEventListener(j,x),O=()=>N.removeEventListener(j,x),W=new a({onFirstListenerAdd:z,onLastListenerRemove:O});return W.event}o.fromDOMEventEmitter=B;function V(N){return new Promise(j=>v(N)(j))}o.toPromise=V})(_=e.Event||(e.Event={}));class y{constructor(v){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${v}_${y._idPool++}`}start(v){this._stopWatch=new P.StopWatch(!0),this._listenerCount=v}stop(){if(this._stopWatch){const v=this._stopWatch.elapsed();this._elapsedOverall+=v,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${v.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let k=-1;function i(o){const v=k;return k=o,{dispose(){k=v}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(v,n=Math.random().toString(18).slice(2,5)){this.customThreshold=v,this.name=n,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(v){let n=k;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||v<n)return;this._stacks||(this._stacks=new Map);const f=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(f)||0;if(this._stacks.set(f,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let t,d=0;for(const[s,c]of this._stacks)(!t||d<c)&&(t=s,d=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${d}):`),console.warn(t)}return()=>{const t=this._stacks.get(f)||0;this._stacks.set(f,t-1)}}}class a{constructor(v){this._disposed=!1,this._options=v,this._leakageMon=k>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(v,n,f)=>{this._listeners||(this._listeners=new S.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(n?[v,n]:v);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,v,n);const d=this._leakageMon?.check(this._listeners.size),s=(0,C.toDisposable)(()=>{d&&d(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return f instanceof C.DisposableStore?f.add(s):Array.isArray(f)&&f.push(s),s}),this._event}fire(v){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,v]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,f]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,f):n[0].call(n[1],f)}catch(r){(0,g.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=a;class p extends a{async fireAsync(v,n,f){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,v]);for(;this._asyncDeliveryQueue.size>0&&!n.isCancellationRequested;){const[r,t]=this._asyncDeliveryQueue.shift(),d=[],s={...t,waitUntil:c=>{if(Object.isFrozen(d))throw new Error("waitUntil can NOT be called asynchronous");f&&(c=f(c,typeof r=="function"?r:r[0])),d.push(c)}};try{typeof r=="function"?r.call(void 0,s):r[0].call(r[1],s)}catch(c){(0,g.onUnexpectedError)(c);continue}Object.freeze(d),await Promise.allSettled(d).then(c=>{for(const m of c)m.status==="rejected"&&(0,g.onUnexpectedError)(m.reason)})}}}}e.AsyncEmitter=p;class h extends a{constructor(v){super(v);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=v?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const v=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(v))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(v){this._listeners&&(this._isPaused!==0?this._eventQueue.push(v):super.fire(v))}}e.PauseableEmitter=h;class w extends h{constructor(v){super(v);this._delay=v.delay??100}fire(v){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(v)}}e.DebounceEmitter=w;class D extends a{constructor(v){super(v);this._queuedEvents=[],this._mergeFn=v?.merge}fire(v){this._queuedEvents.push(v),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(n=>super.fire(n)),this._queuedEvents=[]})}}e.MicrotaskEmitter=D;class T{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(v){const n={event:v,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);const f=()=>{this.hasListeners&&this.unhook(n);const r=this.events.indexOf(n);this.events.splice(r,1)};return(0,C.toDisposable)((0,F.once)(f))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(v=>this.hook(v))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(v=>this.unhook(v))}hook(v){v.listener=v.event(n=>this.emitter.fire(n))}unhook(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=T;class b{constructor(){this.buffers=[]}wrapEvent(v){return(n,f,r)=>v(t=>{const d=this.buffers[this.buffers.length-1];d?d.push(()=>n.call(f,t)):n.call(f,t)},void 0,r)}bufferEvents(v){const n=[];this.buffers.push(n);const f=v();return this.buffers.pop(),n.forEach(r=>r()),f}}e.EventBufferer=b;class l{constructor(){this.listening=!1,this.inputEvent=_.None,this.inputEventListener=C.Disposable.None,this.emitter=new a({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(v){this.inputEvent=v,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=v(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=l}),define(fe[21],me([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const F=Object.freeze(function(_,y){const k=setTimeout(_.bind(y),0);return{dispose(){clearTimeout(k)}}});var C;(function(_){function y(k){return k===_.None||k===_.Cancelled||k instanceof S?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}_.isCancellationToken=y,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(C=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=C.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=P}),define(fe[47],me([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const a=this._icons.get(I.id);a?I.description?a.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new F;e.iconRegistry=C;function S(i,I){return new _(i,I)}e.registerCodicon=S;function P(i){return i?i.replace(/\$\((.*?)\)/g,(I,a)=>` ${a} `).trim():""}e.getCodiconAriaLabel=P;class _{constructor(I,a,p){this.id=I,this.definition=a,this.description=p,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=_;function y(i,I){const a=["codicon","codicon-"+i];return I&&a.push("codicon-modifier-"+I),a}e.getClassNamesArray=y;var k;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function a(w){if(w instanceof _)return["codicon","codicon-"+w.id];const D=I.exec(w.id);if(!D)return a(_.error);let[,T,b]=D;const l=["codicon","codicon-"+T];return b&&l.push("codicon-modifier-"+b.substr(1)),l}i.asClassNameArray=a;function p(w){return a(w).join(" ")}i.asClassName=p;function h(w){return"."+a(w).join(".")}i.asCSSSelector=h})(k=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"})}(_=e.Codicon||(e.Codicon={}))}),define(fe[97],me([0,1,17,6]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(l){const o=l;return o?[o.on,o.pause,o.resume,o.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=C;function S(l){const o=l;return o?C(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=S;function P(l,o){return new _(l,o)}e.newWriteableStream=P;class _{constructor(o,v){this.reducer=o,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(v=>v(o))}emitError(o){this.listeners.error.length===0?(0,g.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(v=>v(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,v){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(o,v){if(this.state.destroyed)return;let n;switch(o){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const f=n.indexOf(v);f>=0&&n.splice(f,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(l,o){const v=[];let n;for(;(n=l.read())!==null;)v.push(n);return o(v)}e.consumeReadable=y;function k(l,o,v){const n=[];let f;for(;(f=l.read())!==null&&n.length<v;)n.push(f);return f===null&&n.length>0?o(n):{read:()=>{if(n.length>0)return n.shift();if(typeof f!="undefined"){const r=f;return f=void 0,r}return l.read()}}}e.peekReadable=k;function i(l,o){return new Promise((v,n)=>{const f=[];I(l,{onData:r=>{o&&f.push(r)},onError:r=>{o?n(r):v(void 0)},onEnd:()=>{v(o?o(f):void 0)}})})}e.consumeStream=i;function I(l,o){l.on("error",v=>o.onError(v)),l.on("end",()=>o.onEnd()),l.on("data",v=>o.onData(v))}e.listenStream=I;function a(l,o){return new Promise((v,n)=>{const f=new F.DisposableStore,r=[],t=c=>{if(r.push(c),r.length>o)return f.dispose(),l.pause(),v({stream:l,buffer:r,ended:!1})},d=c=>n(c),s=()=>v({stream:l,buffer:r,ended:!0});f.add((0,F.toDisposable)(()=>l.removeListener("error",d))),l.on("error",d),f.add((0,F.toDisposable)(()=>l.removeListener("end",s))),l.on("end",s),f.add((0,F.toDisposable)(()=>l.removeListener("data",t))),l.on("data",t)})}e.peekStream=a;function p(l,o){const v=P(o);return v.end(l),v}e.toStream=p;function h(){const l=P(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=h;function w(l){let o=!1;return{read:()=>o?null:(o=!0,l)}}e.toReadable=w;function D(l,o,v){const n=P(v);return I(l,{onData:f=>n.write(o.data(f)),onError:f=>n.error(o.error?o.error(f):f),onEnd:()=>n.end()}),n}e.transform=D;function T(l,o,v){let n=!1;return{read:()=>{const f=o.read();return n?f:(n=!0,f!==null?v([l,f]):l)}}}e.prefixedReadable=T;function b(l,o,v){let n=!1;const f=P(v);return I(o,{onData:r=>n?f.write(r):(n=!0,f.write(v([l,r]))),onError:r=>f.error(r),onEnd:()=>{n||(n=!0,f.write(l)),f.end()}}),f}e.prefixedStream=b}),define(fe[22],me([0,1,97]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const F=typeof Buffer!="undefined";let C,S;class P{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return F?new P(Buffer.allocUnsafe(t)):new P(new Uint8Array(t))}static wrap(t){return F&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new P(t)}static fromString(t,d){return!(d?.dontUseNodeBuffer||!1)&&F?new P(Buffer.from(t)):(C||(C=new TextEncoder),new P(C.encode(t)))}static concat(t,d){if(typeof d=="undefined"){d=0;for(let m=0,u=t.length;m<u;m++)d+=t[m].byteLength}const s=P.alloc(d);let c=0;for(let m=0,u=t.length;m<u;m++){const E=t[m];s.set(E,c),c+=E.byteLength}return s}toString(){return F?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(t,d){return new P(this.buffer.subarray(t,d))}set(t,d){t instanceof P?this.buffer.set(t.buffer,d):this.buffer.set(t,d)}readUInt32BE(t){return k(this.buffer,t)}writeUInt32BE(t,d){i(this.buffer,t,d)}readUInt32LE(t){return I(this.buffer,t)}writeUInt32LE(t,d){a(this.buffer,t,d)}readUInt8(t){return p(this.buffer,t)}writeUInt8(t,d){h(this.buffer,t,d)}}e.VSBuffer=P;function _(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0}e.readUInt16LE=_;function y(r,t,d){r[d+0]=t&255,t=t>>>8,r[d+1]=t&255}e.writeUInt16LE=y;function k(r,t){return r[t]*2**24+r[t+1]*2**16+r[t+2]*2**8+r[t+3]}e.readUInt32BE=k;function i(r,t,d){r[d+3]=t,t=t>>>8,r[d+2]=t,t=t>>>8,r[d+1]=t,t=t>>>8,r[d]=t}e.writeUInt32BE=i;function I(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0|r[t+2]<<16>>>0|r[t+3]<<24>>>0}e.readUInt32LE=I;function a(r,t,d){r[d+0]=t&255,t=t>>>8,r[d+1]=t&255,t=t>>>8,r[d+2]=t&255,t=t>>>8,r[d+3]=t&255}e.writeUInt32LE=a;function p(r,t){return r[t]}e.readUInt8=p;function h(r,t,d){r[d]=t}e.writeUInt8=h;function w(r){return g.consumeReadable(r,t=>P.concat(t))}e.readableToBuffer=w;function D(r){return g.toReadable(r)}e.bufferToReadable=D;function T(r){return g.consumeStream(r,t=>P.concat(t))}e.streamToBuffer=T;async function b(r){return r.ended?P.concat(r.buffer):P.concat([...r.buffer,await T(r.stream)])}e.bufferedStreamToBuffer=b;function l(r){return g.toStream(r,t=>P.concat(t))}e.bufferToStream=l;function o(r){return g.transform(r,{data:t=>typeof t=="string"?P.fromString(t):P.wrap(t)},t=>P.concat(t))}e.streamToBufferReadableStream=o;function v(r){return g.newWriteableStream(t=>P.concat(t),r)}e.newWriteableBufferStream=v;function n(r,t){return g.prefixedReadable(r,t,d=>P.concat(d))}e.prefixedBufferReadable=n;function f(r,t){return g.prefixedStream(r,t,d=>P.concat(d))}e.prefixedBufferStream=f}),define(fe[9],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(le){return!le||typeof le!="string"?!0:le.trim().length===0}e.isFalsyOrWhitespace=g;const F=/{(\d+)}/g;function C(le,...Ie){return Ie.length===0?le:le.replace(F,function(Ue,Xe){const it=parseInt(Xe,10);return isNaN(it)||it<0||it>=Ie.length?Ue:Ie[it]})}e.format=C;const S=/{([^}]+)}/g;function P(le,Ie){return le.replace(S,(Ue,Xe)=>Ie[Xe]??Ue)}e.format2=P;function _(le){return le.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=_;function y(le){return le.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function k(le,Ie){let Ue=0;const Xe=Ie.charCodeAt(0);for(let it=le.length-1;it>=0;it--)le.charCodeAt(it)===Xe&&Ue++;return Ue}e.count=k;function i(le,Ie,Ue="\u2026"){return le.length<=Ie?le:`${le.substr(0,Ie)}${Ue}`}e.truncate=i;function I(le,Ie=" "){const Ue=a(le,Ie);return p(Ue,Ie)}e.trim=I;function a(le,Ie){if(!le||!Ie)return le;const Ue=Ie.length;if(Ue===0||le.length===0)return le;let Xe=0;for(;le.indexOf(Ie,Xe)===Xe;)Xe=Xe+Ue;return le.substring(Xe)}e.ltrim=a;function p(le,Ie){if(!le||!Ie)return le;const Ue=Ie.length,Xe=le.length;if(Ue===0||Xe===0)return le;let it=Xe,ft=-1;for(;ft=le.lastIndexOf(Ie,it-1),!(ft===-1||ft+Ue!==it);){if(ft===0)return"";it=ft}return le.substring(0,it)}e.rtrim=p;function h(le){return le.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function w(le){return le.replace(/\*/g,"")}e.stripWildcards=w;function D(le,Ie,Ue={}){if(!le)throw new Error("Cannot create regex from empty string");Ie||(le=y(le)),Ue.wholeWord&&(/\B/.test(le.charAt(0))||(le="\\b"+le),/\B/.test(le.charAt(le.length-1))||(le=le+"\\b"));let Xe="";return Ue.global&&(Xe+="g"),Ue.matchCase||(Xe+="i"),Ue.multiline&&(Xe+="m"),Ue.unicode&&(Xe+="u"),new RegExp(le,Xe)}e.createRegExp=D;function T(le){return le.source==="^"||le.source==="^$"||le.source==="$"||le.source==="^\\s*$"?!1:!!(le.exec("")&&le.lastIndex===0)}e.regExpLeadsToEndlessLoop=T;function b(le){return!!le.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function l(le){return(le.global?"g":"")+(le.ignoreCase?"i":"")+(le.multiline?"m":"")+(le.unicode?"u":"")}e.regExpFlags=l;function o(le){return le.split(/\r\n|\r|\n/)}e.splitLines=o;function v(le){for(let Ie=0,Ue=le.length;Ie<Ue;Ie++){const Xe=le.charCodeAt(Ie);if(Xe!==32&&Xe!==9)return Ie}return-1}e.firstNonWhitespaceIndex=v;function n(le,Ie=0,Ue=le.length){for(let Xe=Ie;Xe<Ue;Xe++){const it=le.charCodeAt(Xe);if(it!==32&&it!==9)return le.substring(Ie,Xe)}return le.substring(Ie,Ue)}e.getLeadingWhitespace=n;function f(le,Ie=le.length-1){for(let Ue=Ie;Ue>=0;Ue--){const Xe=le.charCodeAt(Ue);if(Xe!==32&&Xe!==9)return Ue}return-1}e.lastNonWhitespaceIndex=f;function r(le,Ie){return le<Ie?-1:le>Ie?1:0}e.compare=r;function t(le,Ie,Ue=0,Xe=le.length,it=0,ft=Ie.length){for(;Ue<Xe&&it<ft;Ue++,it++){let Re=le.charCodeAt(Ue),De=Ie.charCodeAt(it);if(Re<De)return-1;if(Re>De)return 1}const tt=Xe-Ue,ut=ft-it;return tt<ut?-1:tt>ut?1:0}e.compareSubstring=t;function d(le,Ie){return s(le,Ie,0,le.length,0,Ie.length)}e.compareIgnoreCase=d;function s(le,Ie,Ue=0,Xe=le.length,it=0,ft=Ie.length){for(;Ue<Xe&&it<ft;Ue++,it++){let Re=le.charCodeAt(Ue),De=Ie.charCodeAt(it);if(Re===De)continue;if(Re>=128||De>=128)return t(le.toLowerCase(),Ie.toLowerCase(),Ue,Xe,it,ft);c(Re)&&(Re-=32),c(De)&&(De-=32);const Te=Re-De;if(Te!==0)return Te}const tt=Xe-Ue,ut=ft-it;return tt<ut?-1:tt>ut?1:0}e.compareSubstringIgnoreCase=s;function c(le){return le>=97&&le<=122}e.isLowerAsciiLetter=c;function m(le){return le>=65&&le<=90}e.isUpperAsciiLetter=m;function u(le,Ie){return le.length===Ie.length&&s(le,Ie)===0}e.equalsIgnoreCase=u;function E(le,Ie){const Ue=Ie.length;return Ie.length>le.length?!1:s(le,Ie,0,Ue)===0}e.startsWithIgnoreCase=E;function R(le,Ie){let Ue,Xe=Math.min(le.length,Ie.length);for(Ue=0;Ue<Xe;Ue++)if(le.charCodeAt(Ue)!==Ie.charCodeAt(Ue))return Ue;return Xe}e.commonPrefixLength=R;function L(le,Ie){let Ue,Xe=Math.min(le.length,Ie.length);const it=le.length-1,ft=Ie.length-1;for(Ue=0;Ue<Xe;Ue++)if(le.charCodeAt(it-Ue)!==Ie.charCodeAt(ft-Ue))return Ue;return Xe}e.commonSuffixLength=L;function M(le){return 55296<=le&&le<=56319}e.isHighSurrogate=M;function A(le){return 56320<=le&&le<=57343}e.isLowSurrogate=A;function B(le,Ie){return(le-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=B;function V(le,Ie,Ue){const Xe=le.charCodeAt(Ue);if(M(Xe)&&Ue+1<Ie){const it=le.charCodeAt(Ue+1);if(A(it))return B(Xe,it)}return Xe}e.getNextCodePoint=V;function N(le,Ie){const Ue=le.charCodeAt(Ie-1);if(A(Ue)&&Ie>1){const Xe=le.charCodeAt(Ie-2);if(M(Xe))return B(Xe,Ue)}return Ue}function j(le,Ie){const Ue=ye.getInstance(),Xe=Ie,it=le.length,ft=V(le,it,Ie);Ie+=ft>=65536?2:1;let tt=Ue.getGraphemeBreakType(ft);for(;Ie<it;){const ut=V(le,it,Ie),Re=Ue.getGraphemeBreakType(ut);if(rt(tt,Re))break;Ie+=ut>=65536?2:1,tt=Re}return Ie-Xe}e.nextCharLength=j;function U(le,Ie){const Ue=ye.getInstance(),Xe=Ie,it=N(le,Ie);Ie-=it>=65536?2:1;let ft=Ue.getGraphemeBreakType(it);for(;Ie>0;){const tt=N(le,Ie),ut=Ue.getGraphemeBreakType(tt);if(rt(ut,ft))break;Ie-=tt>=65536?2:1,ft=ut}return Xe-Ie}e.prevCharLength=U;function x(le,Ie){const Ue=ye.getInstance(),Xe=le.length,it=Ie,ft=V(le,Xe,Ie),tt=Ue.getGraphemeBreakType(ft);Ie+=ft>=65536?2:1;let ut=tt;for(;Ie<Xe;){const De=V(le,Xe,Ie),Te=Ue.getGraphemeBreakType(De);if(rt(ut,Te))break;Ie+=De>=65536?2:1,ut=Te}const Re=Ie;for(Ie=it,ut=tt;Ie>0;){const De=N(le,Ie),Te=Ue.getGraphemeBreakType(De);if(rt(Te,ut))break;Ie-=De>=65536?2:1,ut=Te}return[Ie,Re]}function z(le,Ie){return Ie>0&&A(le.charCodeAt(Ie))?x(le,Ie-1):x(le,Ie)}e.getCharContainingOffset=z;const O=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(le){return O.test(le)}e.containsRTL=W;const $=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(le){return $.test(le)}e.containsEmoji=X;const K=/^[\t\n\r\x20-\x7E]*$/;function de(le){return K.test(le)}e.isBasicASCII=de,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _e(le){return e.UNUSUAL_LINE_TERMINATORS.test(le)}e.containsUnusualLineTerminators=_e;function Ce(le){for(let Ie=0,Ue=le.length;Ie<Ue;Ie++)if(Pe(le.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=Ce;function Pe(le){return le=+le,le>=11904&&le<=55215||le>=63744&&le<=64255||le>=65281&&le<=65374}e.isFullWidthCharacter=Pe;function Be(le){return le>=127462&&le<=127487||le===8986||le===8987||le===9200||le===9203||le>=9728&&le<=10175||le===11088||le===11093||le>=127744&&le<=128591||le>=128640&&le<=128764||le>=128992&&le<=129003||le>=129280&&le<=129535||le>=129648&&le<=129750}e.isEmojiImprecise=Be;function $e(le,Ie){if(le.length<Ie)return le;const Ue=/\b/g;let Xe=0;for(;Ue.test(le)&&!(le.length-Ue.lastIndex<Ie);)Xe=Ue.lastIndex,Ue.lastIndex+=1;return le.substring(Xe).replace(/^\s/,"")}e.lcut=$e;const He=/\x1B\x5B[12]?K/g,G=/\x1b\[\d+m/g,ee=/\x1b\[0?m/g;function te(le){return le&&(le=le.replace(He,""),le=le.replace(G,""),le=le.replace(ee,"")),le}e.removeAnsiEscapeCodes=te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(le){return!!(le&&le.length>0&&le.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function Z(le){return ce(le)?le.substr(1):le}e.stripUTF8BOM=Z;function re(le,Ie){if(!le||!Ie||le.length<Ie.length)return!1;const Ue=Ie.length,Xe=le.toLowerCase();let it=0,ft=-1;for(;it<Ue;){const tt=Xe.indexOf(Ie[it],ft+1);if(tt<0)return!1;ft=tt,it++}return!0}e.fuzzyContains=re;function pe(le,Ie=!1){return le?(Ie&&(le=le.replace(/\\./g,"")),le.toLowerCase()!==le):!1}e.containsUppercaseCharacter=pe;function Me(le){return le.charAt(0).toUpperCase()+le.slice(1)}e.uppercaseFirstLetter=Me;function je(le,Ie=1){if(Ie===0)return"";let Ue=-1;do Ue=le.indexOf(`
`,Ue+1),Ie--;while(Ie>0&&Ue>=0);return Ue===-1?le:(le[Ue-1]==="\r"&&Ue--,le.substr(0,Ue))}e.getNLines=je;function Ke(le){const Ie=90-65+1;return le=le%(2*Ie),le<Ie?String.fromCharCode(97+le):String.fromCharCode(65+le-Ie)}e.singleLetterHash=Ke;function Ze(le){return ye.getInstance().getGraphemeBreakType(le)}e.getGraphemeBreakType=Ze;function rt(le,Ie){return le===0?Ie!==5&&Ie!==7:le===2&&Ie===3?!1:le===4||le===2||le===3||Ie===4||Ie===2||Ie===3?!0:!(le===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(le===11||le===9)&&(Ie===9||Ie===10)||(le===12||le===10)&&Ie===10||Ie===5||Ie===13||Ie===7||le===1||le===13&&Ie===14||le===6&&Ie===6)}e.breakBetweenGraphemeBreakType=rt;var ct;(function(le){le[le.Other=0]="Other",le[le.Prepend=1]="Prepend",le[le.CR=2]="CR",le[le.LF=3]="LF",le[le.Control=4]="Control",le[le.Extend=5]="Extend",le[le.Regional_Indicator=6]="Regional_Indicator",le[le.SpacingMark=7]="SpacingMark",le[le.L=8]="L",le[le.V=9]="V",le[le.T=10]="T",le[le.LV=11]="LV",le[le.LVT=12]="LVT",le[le.ZWJ=13]="ZWJ",le[le.Extended_Pictographic=14]="Extended_Pictographic"})(ct=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ye{constructor(){this._data=at()}static getInstance(){return ye._INSTANCE||(ye._INSTANCE=new ye),ye._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ue=this._data,Xe=Ue.length/3;let it=1;for(;it<=Xe;)if(Ie<Ue[3*it])it=2*it;else if(Ie>Ue[3*it+1])it=2*it+1;else return Ue[3*it+2];return 0}}ye._INSTANCE=null;function at(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function J(le,Ie){if(le===0)return 0;const Ue=se(le,Ie);if(Ue!==void 0)return Ue;const Xe=N(Ie,le);return le-=Ee(Xe),le}e.getLeftDeleteOffset=J;function se(le,Ie){let Ue=N(Ie,le);for(le-=Ee(Ue);Qe(Ue)||Ue===65039||Ue===8419;){if(le===0)return;Ue=N(Ie,le),le-=Ee(Ue)}if(!!Be(Ue)){if(le>=0){const Xe=N(Ie,le);Xe===8205&&(le-=Ee(Xe))}return le}}function Ee(le){return le>=65536?2:1}function Qe(le){return 127995<=le&&le<=127999}var et;(function(le){le[le.zwj=8205]="zwj",le[le.emojiVariantSelector=65039]="emojiVariantSelector",le[le.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={}))}),define(fe[48],me([0,1,9]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function F(T){return C(T,0)}e.hash=F;function C(T,b){switch(typeof T){case"object":return T===null?S(349,b):Array.isArray(T)?y(T,b):k(T,b);case"string":return _(T,b);case"boolean":return P(T,b);case"number":return S(T,b);case"undefined":return S(937,b);default:return S(617,b)}}e.doHash=C;function S(T,b){return(b<<5)-b+T|0}e.numberHash=S;function P(T,b){return S(T?433:863,b)}function _(T,b){b=S(149417,b);for(let l=0,o=T.length;l<o;l++)b=S(T.charCodeAt(l),b);return b}e.stringHash=_;function y(T,b){return b=S(104579,b),T.reduce((l,o)=>C(o,l),b)}function k(T,b){return b=S(181387,b),Object.keys(T).sort().reduce((l,o)=>(l=_(o,l),C(T[o],l)),b)}class i{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=C(b,this._value),this._value}}e.Hasher=i;var I;(function(T){T[T.BLOCK_SIZE=64]="BLOCK_SIZE",T[T.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function a(T,b,l=32){const o=l-b,v=~((1<<o)-1);return(T<<b|(v&T)>>>o)>>>0}function p(T,b=0,l=T.byteLength,o=0){for(let v=0;v<l;v++)T[b+v]=o}function h(T,b,l="0"){for(;T.length<b;)T=l+T;return T}function w(T,b=32){return T instanceof ArrayBuffer?Array.from(new Uint8Array(T)).map(l=>l.toString(16).padStart(2,"0")).join(""):h((T>>>0).toString(16),b/4)}e.toHexString=w;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const l=b.length;if(l===0)return;const o=this._buff;let v=this._buffLen,n=this._leftoverHighSurrogate,f,r;for(n!==0?(f=n,r=-1,n=0):(f=b.charCodeAt(0),r=0);;){let t=f;if(g.isHighSurrogate(f))if(r+1<l){const d=b.charCodeAt(r+1);g.isLowSurrogate(d)?(r++,t=g.computeCodePoint(f,d)):t=65533}else{n=f;break}else g.isLowSurrogate(f)&&(t=65533);if(v=this._push(o,v,t),r++,r<l)f=b.charCodeAt(r);else break}this._buffLen=v,this._leftoverHighSurrogate=n}_push(b,l,o){return o<128?b[l++]=o:o<2048?(b[l++]=192|(o&1984)>>>6,b[l++]=128|(o&63)>>>0):o<65536?(b[l++]=224|(o&61440)>>>12,b[l++]=128|(o&4032)>>>6,b[l++]=128|(o&63)>>>0):(b[l++]=240|(o&1835008)>>>18,b[l++]=128|(o&258048)>>>12,b[l++]=128|(o&4032)>>>6,b[l++]=128|(o&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=D._bigBlock32,l=this._buffDV;for(let c=0;c<64;c+=4)b.setUint32(c,l.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)b.setUint32(c,a(b.getUint32(c-12,!1)^b.getUint32(c-32,!1)^b.getUint32(c-56,!1)^b.getUint32(c-64,!1),1),!1);let o=this._h0,v=this._h1,n=this._h2,f=this._h3,r=this._h4,t,d,s;for(let c=0;c<80;c++)c<20?(t=v&n|~v&f,d=1518500249):c<40?(t=v^n^f,d=1859775393):c<60?(t=v&n|v&f|n&f,d=2400959708):(t=v^n^f,d=3395469782),s=a(o,5)+t+r+d+b.getUint32(c*4,!1)&4294967295,r=f,f=n,n=a(v,30),v=o,o=s;this._h0=this._h0+o&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+f&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(fe[49],me([0,1,9]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(F||(F={})),function(C){const S="error",P="warning",_="warn",y="info",k="ignore";function i(a){return a?g.equalsIgnoreCase(S,a)?C.Error:g.equalsIgnoreCase(P,a)||g.equalsIgnoreCase(_,a)?C.Warning:g.equalsIgnoreCase(y,a)?C.Info:C.Ignore:C.Ignore}C.fromValue=i;function I(a){switch(a){case C.Error:return S;case C.Warning:return P;case C.Info:return y;default:return k}}C.toString=I}(F||(F={})),e.default=F}),define(fe[12],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(m){return Array.isArray(m)}e.isArray=g;function F(m){return typeof m=="string"}e.isString=F;function C(m){return Array.isArray(m)&&m.every(u=>F(u))}e.isStringArray=C;function S(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=S;function P(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=P;function _(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=_;function y(m){return m===!0||m===!1}e.isBoolean=y;function k(m){return typeof m=="undefined"}e.isUndefined=k;function i(m){return!I(m)}e.isDefined=i;function I(m){return k(m)||m===null}e.isUndefinedOrNull=I;function a(m,u){if(!m)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=a;function p(m){if(I(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=p;function h(...m){const u=[];for(let E=0;E<m.length;E++){const R=m[E];if(I(R))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);u.push(R)}return u}e.assertAllDefined=h;const w=Object.prototype.hasOwnProperty;function D(m){if(!S(m))return!1;for(let u in m)if(w.call(m,u))return!1;return!0}e.isEmptyObject=D;function T(m){return typeof m=="function"}e.isFunction=T;function b(...m){return m.length>0&&m.every(T)}e.areFunctions=b;function l(m,u){const E=Math.min(m.length,u.length);for(let R=0;R<E;R++)o(m[R],u[R])}e.validateConstraints=l;function o(m,u){if(F(u)){if(typeof m!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(T(u)){try{if(m instanceof u)return}catch{}if(!I(m)&&m.constructor===u||u.length===1&&u.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function v(m){let u=[],E=Object.getPrototypeOf(m);for(;Object.prototype!==E;)u=u.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return u}e.getAllPropertyNames=v;function n(m){const u=[];for(const E of v(m))typeof m[E]=="function"&&u.push(E);return u}e.getAllMethodNames=n;function f(m,u){const E=L=>function(){const M=Array.prototype.slice.call(arguments,0);return u(L,M)};let R={};for(const L of m)R[L]=E(L);return R}e.createProxyObject=f;function r(m){return m===null?void 0:m}e.withNullAsUndefined=r;function t(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=t;function d(m){return class{constructor(){return new Proxy({},{get(u,E){if(u[E])return u[E];throw new Error(`Not Implemented: ${m}->${String(E)}`)}})}}}e.NotImplementedProxy=d;function s(m,u="Unreachable"){throw new Error(u)}e.assertNever=s;function c(m){return!!m&&typeof m.then=="function"&&typeof m.catch=="function"}e.isPromise=c}),define(fe[29],me([0,1,8,11,9,12]),function(Y,e,g,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(r){return r===47||r===92}e.isPathSeparator=P;function _(r){return r.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=_;function y(r){return r.indexOf("/")===-1&&(r=_(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=y;function k(r,t=g.posix.sep){if(!r)return"";const d=r.length,s=r.charCodeAt(0);if(P(s)){if(P(r.charCodeAt(1))&&!P(r.charCodeAt(2))){let m=3;const u=m;for(;m<d&&!P(r.charCodeAt(m));m++);if(u!==m&&!P(r.charCodeAt(m+1))){for(m+=1;m<d;m++)if(P(r.charCodeAt(m)))return r.slice(0,m+1).replace(/[\\/]/g,t)}}return t}else if(T(s)&&r.charCodeAt(1)===58)return P(r.charCodeAt(2))?r.slice(0,2)+t:r.slice(0,2);let c=r.indexOf("://");if(c!==-1){for(c+=3;c<d;c++)if(P(r.charCodeAt(c)))return r.slice(0,c+1)}return""}e.getRoot=k;function i(r){if(!F.isWindows||!r||r.length<5)return!1;let t=r.charCodeAt(0);if(t!==92||(t=r.charCodeAt(1),t!==92))return!1;let d=2;const s=d;for(;d<r.length&&(t=r.charCodeAt(d),t!==92);d++);return!(s===d||(t=r.charCodeAt(d+1),isNaN(t)||t===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,t=F.isWindows){const d=t?I:a;return!(!r||r.length===0||/^\s+$/.test(r)||(d.lastIndex=0,d.test(r))||t&&p.test(r)||r==="."||r===".."||t&&r[r.length-1]==="."||t&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function w(r,t,d){const s=r===t;return!d||s?s:!r||!t?!1:(0,C.equalsIgnoreCase)(r,t)}e.isEqual=w;function D(r,t,d,s=g.sep){if(r===t)return!0;if(!r||!t||t.length>r.length)return!1;if(d){if(!(0,C.startsWithIgnoreCase)(r,t))return!1;if(t.length===r.length)return!0;let m=t.length;return t.charAt(t.length-1)===s&&m--,r.charAt(m)===s}return t.charAt(t.length-1)!==s&&(t+=s),r.indexOf(t)===0}e.isEqualOrParent=D;function T(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=T;function b(r,t){return F.isWindows&&r.endsWith(":")&&(r+=g.sep),(0,g.isAbsolute)(r)||(r=(0,g.join)(t,r)),r=(0,g.normalize)(r),F.isWindows?(r=(0,C.rtrim)(r,g.sep),r.endsWith(":")&&(r+=g.sep)):(r=(0,C.rtrim)(r,g.sep),r||(r=g.sep)),r}e.sanitizeFilePath=b;function l(r){const t=(0,g.normalize)(r);return F.isWindows?r.length>3?!1:o(t)&&(r.length===2||t.charCodeAt(2)===92):t===g.posix.sep}e.isRootOrDriveLetter=l;function o(r){return F.isWindows?T(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function v(r){return o(r)?r[0]:void 0}e.getDriveLetter=v;function n(r,t,d){return t.length>r.length?-1:r===t?0:(d&&(r=r.toLowerCase(),t=t.toLowerCase()),r.indexOf(t))}e.indexOfPath=n;function f(r){const t=r.split(":");let d,s,c;if(t.forEach(m=>{const u=Number(m);(0,S.isNumber)(u)?s===void 0?s=u:c===void 0&&(c=u):d=d?[d,m].join(":"):m}),!d)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:d,line:s!==void 0?s:void 0,column:c!==void 0?c:s!==void 0?1:void 0}}e.parseLineAndColumnAware=f}),define(fe[25],me([0,1,12]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const D=Array.isArray(w)?[]:{};return Object.keys(w).forEach(T=>{w[T]&&typeof w[T]=="object"?D[T]=F(w[T]):D[T]=w[T]}),D}e.deepClone=F;function C(w){if(!w||typeof w!="object")return w;const D=[w];for(;D.length>0;){const T=D.shift();Object.freeze(T);for(const b in T)if(S.call(T,b)){const l=T[b];typeof l=="object"&&!Object.isFrozen(l)&&D.push(l)}}return w}e.deepFreeze=C;const S=Object.prototype.hasOwnProperty;function P(w,D){return _(w,D,new Set)}e.cloneAndChange=P;function _(w,D,T){if((0,g.isUndefinedOrNull)(w))return w;const b=D(w);if(typeof b!="undefined")return b;if((0,g.isArray)(w)){const l=[];for(const o of w)l.push(_(o,D,T));return l}if((0,g.isObject)(w)){if(T.has(w))throw new Error("Cannot clone recursive data-structure");T.add(w);const l={};for(let o in w)S.call(w,o)&&(l[o]=_(w[o],D,T));return T.delete(w),l}return w}function y(w,D,T=!0){return(0,g.isObject)(w)?((0,g.isObject)(D)&&Object.keys(D).forEach(b=>{b in w?T&&((0,g.isObject)(w[b])&&(0,g.isObject)(D[b])?y(w[b],D[b],T):w[b]=D[b]):w[b]=D[b]}),w):D}e.mixin=y;function k(w,D){if(w===D)return!0;if(w==null||D===null||D===void 0||typeof w!=typeof D||typeof w!="object"||Array.isArray(w)!==Array.isArray(D))return!1;let T,b;if(Array.isArray(w)){if(w.length!==D.length)return!1;for(T=0;T<w.length;T++)if(!k(w[T],D[T]))return!1}else{const l=[];for(b in w)l.push(b);l.sort();const o=[];for(b in D)o.push(b);if(o.sort(),!k(l,o))return!1;for(T=0;T<l.length;T++)if(!k(w[l[T]],D[l[T]]))return!1}return!0}e.equals=k;function i(w){const D=new Set;return JSON.stringify(w,(T,b)=>{if((0,g.isObject)(b)||Array.isArray(b)){if(D.has(b))return"[Circular]";D.add(b)}return b})}e.safeStringify=i;function I(w,D,T){const b=D(w);return typeof b=="undefined"?T:b}e.getOrDefault=I;function a(w,D){const T=Object.create(null);return!w||!D||Object.keys(D).forEach(l=>{const o=w[l],v=D[l];k(o,v)||(T[l]=v)}),T}e.distinct=a;function p(w,D){const T=D.toLowerCase(),b=Object.keys(w).find(l=>l.toLowerCase()===T);return b?w[b]:w[D]}e.getCaseInsensitive=p;function h(w,D){const T=Object.create(null);for(const b of Object.keys(w))D(b,w[b])&&(T[b]=w[b]);return T}e.filter=h}),define(fe[98],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(S){S[S.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",S[S.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",S[S.MAX_UINT_8=255]="MAX_UINT_8",S[S.MAX_UINT_16=65535]="MAX_UINT_16",S[S.MAX_UINT_32=4294967295]="MAX_UINT_32",S[S.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function F(S){return S<0?0:S>255?255:S|0}e.toUint8=F;function C(S){return S<0?0:S>4294967295?4294967295:S|0}e.toUint32=C}),define(fe[2],me([0,1,8,11]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,S=/^\//,P=/^\/\//;function _(r,t){if(!r.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!C.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!S.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(r,t){return!r&&!t?"file":r}function k(r,t){switch(r){case"https":case"http":case"file":t?t[0]!==I&&(t=I+t):t=I;break}return t}const i="",I="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(t,d,s,c,m,u=!1){typeof t=="object"?(this.scheme=t.scheme||i,this.authority=t.authority||i,this.path=t.path||i,this.query=t.query||i,this.fragment=t.fragment||i):(this.scheme=y(t,u),this.authority=d||i,this.path=k(this.scheme,s||i),this.query=c||i,this.fragment=m||i,_(this,u))}static isUri(t){return t instanceof p?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return l(this,!1)}with(t){if(!t)return this;let{scheme:d,authority:s,path:c,query:m,fragment:u}=t;return d===void 0?d=this.scheme:d===null&&(d=i),s===void 0?s=this.authority:s===null&&(s=i),c===void 0?c=this.path:c===null&&(c=i),m===void 0?m=this.query:m===null&&(m=i),u===void 0?u=this.fragment:u===null&&(u=i),d===this.scheme&&s===this.authority&&c===this.path&&m===this.query&&u===this.fragment?this:new w(d,s,c,m,u)}static parse(t,d=!1){const s=a.exec(t);return s?new w(s[2]||i,f(s[4]||i),f(s[5]||i),f(s[7]||i),f(s[9]||i),d):new w(i,i,i,i,i)}static file(t){let d=i;if(F.isWindows&&(t=t.replace(/\\/g,I)),t[0]===I&&t[1]===I){const s=t.indexOf(I,2);s===-1?(d=t.substring(2),t=I):(d=t.substring(2,s),t=t.substring(s)||I)}return new w("file",d,t,i,i)}static from(t){const d=new w(t.scheme,t.authority,t.path,t.query,t.fragment);return _(d,!0),d}static joinPath(t,...d){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return F.isWindows&&t.scheme==="file"?s=p.file(g.win32.join(l(t,!0),...d)).path:s=g.posix.join(t.path,...d),t.with({path:s})}toString(t=!1){return o(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof p)return t;{const d=new w(t);return d._formatted=t.external,d._fsPath=t._sep===h?t.fsPath:null,d}}else return t}}e.URI=p;const h=F.isWindows?1:void 0;class w extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(t=!1){return t?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function T(r,t){let d,s=-1;for(let c=0;c<r.length;c++){const m=r.charCodeAt(c);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||t&&m===47)s!==-1&&(d+=encodeURIComponent(r.substring(s,c)),s=-1),d!==void 0&&(d+=r.charAt(c));else{d===void 0&&(d=r.substr(0,c));const u=D[m];u!==void 0?(s!==-1&&(d+=encodeURIComponent(r.substring(s,c)),s=-1),d+=u):s===-1&&(s=c)}}return s!==-1&&(d+=encodeURIComponent(r.substring(s))),d!==void 0?d:r}function b(r){let t;for(let d=0;d<r.length;d++){const s=r.charCodeAt(d);s===35||s===63?(t===void 0&&(t=r.substr(0,d)),t+=D[s]):t!==void 0&&(t+=r[d])}return t!==void 0?t:r}function l(r,t){let d;return r.authority&&r.path.length>1&&r.scheme==="file"?d=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?t?d=r.path.substr(1):d=r.path[1].toLowerCase()+r.path.substr(2):d=r.path,F.isWindows&&(d=d.replace(/\//g,"\\")),d}e.uriToFsPath=l;function o(r,t){const d=t?b:T;let s="",{scheme:c,authority:m,path:u,query:E,fragment:R}=r;if(c&&(s+=c,s+=":"),(m||c==="file")&&(s+=I,s+=I),m){let L=m.indexOf("@");if(L!==-1){const M=m.substr(0,L);m=m.substr(L+1),L=M.indexOf(":"),L===-1?s+=d(M,!1):(s+=d(M.substr(0,L),!1),s+=":",s+=d(M.substr(L+1),!1)),s+="@"}m=m.toLowerCase(),L=m.indexOf(":"),L===-1?s+=d(m,!1):(s+=d(m.substr(0,L),!1),s+=m.substr(L))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const L=u.charCodeAt(1);L>=65&&L<=90&&(u=`/${String.fromCharCode(L+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const L=u.charCodeAt(0);L>=65&&L<=90&&(u=`${String.fromCharCode(L+32)}:${u.substr(2)}`)}s+=d(u,!0)}return E&&(s+="?",s+=d(E,!1)),R&&(s+="#",s+=t?R:T(R,!1)),s}function v(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+v(r.substr(3)):r}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function f(r){return r.match(n)?r.replace(n,t=>v(t)):r}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,g):C?C.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[24],me([0,1,18,9,2]),function(Y,e,g,F,C){"use strict";var S,P,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(r,t,d){let s=r.get(t);return s===void 0&&(s=d,r.set(t,s)),s}e.getOrSet=y;function k(r){const t=[];return r.forEach((d,s)=>{t.push(`${s} => ${d}`)}),`Map(${r.size}) {${t.join(", ")}}`}e.mapToString=k;function i(r){const t=[];return r.forEach(d=>{t.push(d)}),`Set(${r.size}) {${t.join(", ")}}`}e.setToString=i;class I{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const d=t.charCodeAt(0),s=this._value.charCodeAt(this._pos);return d-s}value(){return this._value[this._pos]}}e.StringIterator=I;class a{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,F.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=a;class p{constructor(t=!0,d=!0){this._splitOnBackslash=t,this._caseSensitive=d}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const d=this._value.charCodeAt(this._to);if(d===47||this._splitOnBackslash&&d===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,F.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var h;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(h||(h={}));class w{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,F.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=w;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(T||(T={}));class b{constructor(t){this._iter=t}static forUris(t=()=>!1){return new b(new w(t))}static forPaths(){return new b(new p)}static forStrings(){return new b(new I)}static forConfigKeys(){return new b(new a)}clear(){this._root=void 0}fill(t,d){if(d){const s=d.slice(0);(0,g.shuffle)(s);for(let c of s)this.set(c,t)}else{const s=t.slice(0);(0,g.shuffle)(s);for(let c of s)this.set(c[0],c[1])}}set(t,d){const s=this._iter.reset(t);let c;this._root||(this._root=new D,this._root.segment=s.value());const m=[];for(c=this._root;;){const E=s.cmp(c.segment);if(E>0)c.left||(c.left=new D,c.left.segment=s.value()),m.push([-1,c]),c=c.left;else if(E<0)c.right||(c.right=new D,c.right.segment=s.value()),m.push([1,c]),c=c.right;else if(s.hasNext())s.next(),c.mid||(c.mid=new D,c.mid.segment=s.value()),m.push([0,c]),c=c.mid;else break}const u=c.value;c.value=d,c.key=t;for(let E=m.length-1;E>=0;E--){const R=m[E][1];R.updateHeight();const L=R.balanceFactor();if(L<-1||L>1){const M=m[E][0],A=m[E+1][0];if(M===1&&A===1)m[E][1]=R.rotateLeft();else if(M===-1&&A===-1)m[E][1]=R.rotateRight();else if(M===1&&A===-1)R.right=m[E+1][1]=m[E+1][1].rotateRight(),m[E][1]=R.rotateLeft();else if(M===-1&&A===1)R.left=m[E+1][1]=m[E+1][1].rotateLeft(),m[E][1]=R.rotateRight();else throw new Error;if(E>0)switch(m[E-1][0]){case-1:m[E-1][1].left=m[E][1];break;case 1:m[E-1][1].right=m[E][1];break;case 0:m[E-1][1].mid=m[E][1];break}else this._root=m[0][1]}}return u}get(t){return this._getNode(t)?.value}_getNode(t){const d=this._iter.reset(t);let s=this._root;for(;s;){const c=d.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(d.hasNext())d.next(),s=s.mid;else break}return s}has(t){const d=this._getNode(t);return!(d?.value===void 0&&d?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,d){const s=this._iter.reset(t),c=[];let m=this._root;for(;m;){const u=s.cmp(m.segment);if(u>0)c.push([-1,m]),m=m.left;else if(u<0)c.push([1,m]),m=m.right;else if(s.hasNext())s.next(),c.push([0,m]),m=m.mid;else break}if(!!m){if(d?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const u=this._min(m.right),{key:E,value:R,segment:L}=u;this._delete(u.key,!1),m.key=E,m.value=R,m.segment=L}else{const u=m.left??m.right;if(c.length>0){const[E,R]=c[c.length-1];switch(E){case-1:R.left=u;break;case 0:R.mid=u;break;case 1:R.right=u;break}}else this._root=u}for(let u=c.length-1;u>=0;u--){const E=c[u][1];E.updateHeight();const R=E.balanceFactor();if(R>1?(E.right.balanceFactor()>=0||(E.right=c[u+1][1]=c[u+1][1].rotateRight()),c[u][1]=E.rotateLeft()):R<-1&&(E.left.balanceFactor()<=0||(E.left=c[u+1][1]=c[u+1][1].rotateLeft()),c[u][1]=E.rotateRight()),u>0)switch(c[u-1][0]){case-1:c[u-1][1].left=c[u][1];break;case 1:c[u-1][1].right=c[u][1];break;case 0:c[u-1][1].mid=c[u][1];break}else this._root=c[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const d=this._iter.reset(t);let s=this._root,c;for(;s;){const m=d.cmp(s.segment);if(m>0)s=s.left;else if(m<0)s=s.right;else if(d.hasNext())d.next(),c=s.value||c,s=s.mid;else break}return s&&s.value||c}findSuperstr(t){const d=this._iter.reset(t);let s=this._root;for(;s;){const c=d.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(d.hasNext())d.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(t){for(const[d,s]of this)t(s,d)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=d=>{if(!d)return!0;const s=d.balanceFactor();return s<-1||s>1?!1:t(d.left)&&t(d.right)};return t(this._root)}}e.TernarySearchTree=b;class l{constructor(t,d){this[S]="ResourceMap",t instanceof l?(this.map=new Map(t.map),this.toKey=d??l.defaultToKey):(this.map=new Map,this.toKey=t??l.defaultToKey)}set(t,d){return this.map.set(this.toKey(t),d),this}get(t){return this.map.get(this.toKey(t))}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,d){typeof d!="undefined"&&(t=t.bind(d));for(let[s,c]of this.map)t(c,C.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let t of this.map.keys())yield C.URI.parse(t)}*entries(){for(let t of this.map.entries())yield[C.URI.parse(t[0]),t[1]]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(let t of this.map)yield[C.URI.parse(t[0]),t[1]]}}e.ResourceMap=l,l.defaultToKey=r=>r.toString();var o;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class v{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,d=0){const s=this._map.get(t);if(!!s)return d!==0&&this.touch(s,d),s.value}set(t,d,s=0){let c=this._map.get(t);if(c)c.value=d,s!==0&&this.touch(c,s);else{switch(c={key:t,value:d,next:void 0,previous:void 0},s){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const d=this._map.get(t);if(!!d)return this._map.delete(t),this.removeItem(d),this._size--,d.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,d){const s=this._state;let c=this._head;for(;c;){if(d?t.bind(d)(c.value,c.key,this):t(c.value,c.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,d=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==d)throw new Error("LinkedMap got modified during iteration.");if(s){const m={value:s.key,done:!1};return s=s.next,m}else return{value:void 0,done:!0}}};return c}values(){const t=this,d=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==d)throw new Error("LinkedMap got modified during iteration.");if(s){const m={value:s.value,done:!1};return s=s.next,m}else return{value:void 0,done:!0}}};return c}entries(){const t=this,d=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==d)throw new Error("LinkedMap got modified during iteration.");if(s){const m={value:[s.key,s.value],done:!1};return s=s.next,m}else return{value:void 0,done:!0}}};return c}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let d=this._head,s=this.size;for(;d&&s>t;)this._map.delete(d.key),d=d.next,s--;this._head=d,this._size=s,d&&(d.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const d=t.next,s=t.previous;if(!d||!s)throw new Error("Invalid list");d.previous=s,s.next=d}t.next=void 0,t.previous=void 0,this._state++}touch(t,d){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(t===this._head)return;const s=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(s.previous=c,c.next=s),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(d===2){if(t===this._tail)return;const s=t.next,c=t.previous;t===this._head?(s.previous=void 0,this._head=s):(s.previous=c,c.next=s),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((d,s)=>{t.push([s,d])}),t}fromJSON(t){this.clear();for(const[d,s]of t)this.set(d,s)}}e.LinkedMap=v;class n extends v{constructor(t,d=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,d),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,d=2){return super.get(t,d)}peek(t){return super.get(t,0)}set(t,d){return super.set(t,d,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class f{constructor(t){_.set(this,void 0),st(this,_,t,"f")}get size(){return Ne(this,_,"f").size}forEach(t,d){Ne(this,_,"f").forEach(t,d)}get(t){return Ne(this,_,"f").get(t)}has(t){return Ne(this,_,"f").has(t)}entries(){return Ne(this,_,"f").entries()}keys(){return Ne(this,_,"f").keys()}values(){return Ne(this,_,"f").values()}[(_=new WeakMap,Symbol.iterator)](){return Ne(this,_,"f").entries()}}e.ReadonlyMapView=f}),define(fe[99],me([0,1,24,9]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...Z){return function(re,pe){for(let Me=0,je=Z.length;Me<je;Me++){const Ke=Z[Me](re,pe);if(Ke)return Ke}return null}}e.or=C,e.matchesStrictPrefix=S.bind(void 0,!1),e.matchesPrefix=S.bind(void 0,!0);function S(Z,re,pe){if(!pe||pe.length<re.length)return null;let Me;return Z?Me=F.startsWithIgnoreCase(pe,re):Me=pe.indexOf(re)===0,Me?re.length>0?[{start:0,end:re.length}]:[]:null}function P(Z,re){const pe=re.toLowerCase().indexOf(Z.toLowerCase());return pe===-1?null:[{start:pe,end:pe+Z.length}]}e.matchesContiguousSubString=P;function _(Z,re){return y(Z.toLowerCase(),re.toLowerCase(),0,0)}e.matchesSubString=_;function y(Z,re,pe,Me){if(pe===Z.length)return[];if(Me===re.length)return null;if(Z[pe]===re[Me]){let je=null;return(je=y(Z,re,pe+1,Me+1))?T({start:Me,end:Me+1},je):null}return y(Z,re,pe,Me+1)}function k(Z){return 97<=Z&&Z<=122}function i(Z){return 65<=Z&&Z<=90}e.isUpper=i;function I(Z){return 48<=Z&&Z<=57}function a(Z){return Z===32||Z===9||Z===10||Z===13}const p=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Z=>p.add(Z.charCodeAt(0)));function h(Z){return a(Z)||p.has(Z)}function w(Z,re){return Z===re||h(Z)&&h(re)}function D(Z){return k(Z)||i(Z)||I(Z)}function T(Z,re){return re.length===0?re=[Z]:Z.end===re[0].start?re[0].start=Z.start:re.unshift(Z),re}function b(Z,re){for(let pe=re;pe<Z.length;pe++){const Me=Z.charCodeAt(pe);if(i(Me)||I(Me)||pe>0&&!D(Z.charCodeAt(pe-1)))return pe}return Z.length}function l(Z,re,pe,Me){if(pe===Z.length)return[];if(Me===re.length)return null;if(Z[pe]!==re[Me].toLowerCase())return null;{let je=null,Ke=Me+1;for(je=l(Z,re,pe+1,Me+1);!je&&(Ke=b(re,Ke))<re.length;)je=l(Z,re,pe+1,Ke),Ke++;return je===null?null:T({start:Me,end:Me+1},je)}}function o(Z){let re=0,pe=0,Me=0,je=0,Ke=0;for(let at=0;at<Z.length;at++)Ke=Z.charCodeAt(at),i(Ke)&&re++,k(Ke)&&pe++,D(Ke)&&Me++,I(Ke)&&je++;const Ze=re/Z.length,rt=pe/Z.length,ct=Me/Z.length,ye=je/Z.length;return{upperPercent:Ze,lowerPercent:rt,alphaPercent:ct,numericPercent:ye}}function v(Z){const{upperPercent:re,lowerPercent:pe}=Z;return pe===0&&re>.6}function n(Z){const{upperPercent:re,lowerPercent:pe,alphaPercent:Me,numericPercent:je}=Z;return pe>.2&&re<.8&&Me>.6&&je<.2}function f(Z){let re=0,pe=0,Me=0,je=0;for(let Ke=0;Ke<Z.length;Ke++)Me=Z.charCodeAt(Ke),i(Me)&&re++,k(Me)&&pe++,a(Me)&&je++;return(re===0||pe===0)&&je===0?Z.length<=30:re<=5}function r(Z,re){if(!re||(re=re.trim(),re.length===0)||!f(Z)||re.length>60)return null;const pe=o(re);if(!n(pe)){if(!v(pe))return null;re=re.toLowerCase()}let Me=null,je=0;for(Z=Z.toLowerCase();je<re.length&&(Me=l(Z,re,0,je))===null;)je=b(re,je+1);return Me}e.matchesCamelCase=r;function t(Z,re,pe=!1){if(!re||re.length===0)return null;let Me=null,je=0;for(Z=Z.toLowerCase(),re=re.toLowerCase();je<re.length&&(Me=d(Z,re,0,je,pe))===null;)je=s(re,je+1);return Me}e.matchesWords=t;function d(Z,re,pe,Me,je){if(pe===Z.length)return[];if(Me===re.length)return null;if(w(Z.charCodeAt(pe),re.charCodeAt(Me))){let Ke=null,Ze=Me+1;if(Ke=d(Z,re,pe+1,Me+1,je),!je)for(;!Ke&&(Ze=s(re,Ze))<re.length;)Ke=d(Z,re,pe+1,Ze,je),Ze++;return Ke===null?null:T({start:Me,end:Me+1},Ke)}else return null}function s(Z,re){for(let pe=re;pe<Z.length;pe++)if(h(Z.charCodeAt(pe))||pe>0&&h(Z.charCodeAt(pe-1)))return pe;return Z.length}const c=C(e.matchesPrefix,r,P),m=C(e.matchesPrefix,r,_),u=new g.LRUCache(1e4);function E(Z,re,pe=!1){if(typeof Z!="string"||typeof re!="string")return null;let Me=u.get(Z);Me||(Me=new RegExp(F.convertSimple2RegExpPattern(Z),"i"),u.set(Z,Me));const je=Me.exec(re);return je?[{start:je.index,end:je.index+je[0].length}]:pe?m(Z,re):c(Z,re)}e.matchesFuzzy=E;function R(Z,re){const pe=Be(Z,Z.toLowerCase(),0,re,re.toLowerCase(),0,!0);return pe?M(pe):null}e.matchesFuzzy2=R;function L(Z,re,pe,Me,je,Ke){const Ze=Math.min(13,Z.length);for(;pe<Ze;pe++){const rt=Be(Z,re,pe,Me,je,Ke,!1);if(rt)return rt}return[0,Ke]}e.anyScore=L;function M(Z){if(typeof Z=="undefined")return[];const re=[],pe=Z[1];for(let Me=Z.length-1;Me>1;Me--){const je=Z[Me]+pe,Ke=re[re.length-1];Ke&&Ke.end===je?Ke.end=je+1:re.push({start:je,end:je+1})}return re}e.createMatches=M;const A=128;function B(){const Z=[],re=[];for(let pe=0;pe<=A;pe++)re[pe]=0;for(let pe=0;pe<=A;pe++)Z.push(re.slice(0));return Z}function V(Z){const re=[];for(let pe=0;pe<=Z;pe++)re[pe]=0;return re}const N=V(2*A),j=V(2*A),U=B(),x=B(),z=B(),O=!1;function W(Z,re,pe,Me,je){function Ke(rt,ct,ye=" "){for(;rt.length<ct;)rt=ye+rt;return rt}let Ze=` |   |${Me.split("").map(rt=>Ke(rt,3)).join("|")}
`;for(let rt=0;rt<=pe;rt++)rt===0?Ze+=" |":Ze+=`${re[rt-1]}|`,Ze+=Z[rt].slice(0,je+1).map(ct=>Ke(ct.toString(),3)).join("|")+`
`;return Ze}function $(Z,re,pe,Me){Z=Z.substr(re),pe=pe.substr(Me),console.log(W(x,Z,Z.length,pe,pe.length)),console.log(W(z,Z,Z.length,pe,pe.length)),console.log(W(U,Z,Z.length,pe,pe.length))}function X(Z,re){if(re<0||re>=Z.length)return!1;const pe=Z.codePointAt(re);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(pe)}}function K(Z,re){if(re<0||re>=Z.length)return!1;switch(Z.charCodeAt(re)){case 32:case 9:return!0;default:return!1}}function de(Z,re,pe){return re[Z]!==pe[Z]}function _e(Z,re,pe,Me,je,Ke,Ze=!1){for(;re<pe&&je<Ke;)Z[re]===Me[je]&&(Ze&&(N[re]=je),re+=1),je+=1;return re===pe}e.isPatternInWord=_e;var Ce;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Pe;(function(Z){Z.Default=[-100,0];function re(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}Z.isDefault=re})(Pe=e.FuzzyScore||(e.FuzzyScore={}));function Be(Z,re,pe,Me,je,Ke,Ze){const rt=Z.length>A?A:Z.length,ct=Me.length>A?A:Me.length;if(pe>=rt||Ke>=ct||rt-pe>ct-Ke||!_e(re,pe,rt,je,Ke,ct,!0))return;$e(rt,ct,pe,Ke,re,je);let ye=1,at=1,J=pe,se=Ke;const Ee=[!1];for(ye=1,J=pe;J<rt;ye++,J++){const Ue=N[J],Xe=j[J],it=J+1<rt?j[J+1]:ct;for(at=Ue-Ke+1,se=Ue;se<it;at++,se++){let ft=Number.MIN_SAFE_INTEGER,tt=!1;se<=Xe&&(ft=He(Z,re,J,pe,Me,je,se,ct,Ke,U[ye-1][at-1]===0,Ee));let ut=0;ft!==Number.MAX_SAFE_INTEGER&&(tt=!0,ut=ft+x[ye-1][at-1]);const Re=se>Ue,De=Re?x[ye][at-1]+(U[ye][at-1]>0?-5:0):0,Te=se>Ue+1&&U[ye][at-1]>0,oe=Te?x[ye][at-2]+(U[ye][at-2]>0?-5:0):0;if(Te&&(!Re||oe>=De)&&(!tt||oe>=ut))x[ye][at]=oe,z[ye][at]=3,U[ye][at]=0;else if(Re&&(!tt||De>=ut))x[ye][at]=De,z[ye][at]=2,U[ye][at]=0;else if(tt)x[ye][at]=ut,z[ye][at]=1,U[ye][at]=U[ye-1][at-1]+1;else throw new Error("not possible")}}if(O&&$(Z,pe,Me,Ke),!Ee[0]&&!Ze)return;ye--,at--;const Qe=[x[ye][at],Ke];let et=0,le=0;for(;ye>=1;){let Ue=at;do{const Xe=z[ye][Ue];if(Xe===3)Ue=Ue-2;else if(Xe===2)Ue=Ue-1;else break}while(Ue>=1);et>1&&re[pe+ye-1]===je[Ke+at-1]&&!de(Ue+Ke-1,Me,je)&&et+1>U[ye][Ue]&&(Ue=at),Ue===at?et++:et=1,le||(le=Ue),ye--,at=Ue-1,Qe.push(at)}ct===rt&&(Qe[0]+=2);const Ie=le-rt;return Qe[0]-=Ie,Qe}e.fuzzyScore=Be;function $e(Z,re,pe,Me,je,Ke){let Ze=Z-1,rt=re-1;for(;Ze>=pe&&rt>=Me;)je[Ze]===Ke[rt]&&(j[Ze]=rt,Ze--),rt--}function He(Z,re,pe,Me,je,Ke,Ze,rt,ct,ye,at){if(re[pe]!==Ke[Ze])return Number.MIN_SAFE_INTEGER;let J=1,se=!1;return Ze===pe-Me?J=Z[pe]===je[Ze]?7:5:de(Ze,je,Ke)&&(Ze===0||!de(Ze-1,je,Ke))?(J=Z[pe]===je[Ze]?7:5,se=!0):X(Ke,Ze)&&(Ze===0||!X(Ke,Ze-1))?J=5:(X(Ke,Ze-1)||K(Ke,Ze-1))&&(J=5,se=!0),J>1&&pe===Me&&(at[0]=!0),se||(se=de(Ze,je,Ke)||X(Ke,Ze-1)||K(Ke,Ze-1)),pe===Me?Ze>ct&&(J-=se?3:5):ye?J+=se?2:0:J+=se?0:1,Ze+1===rt&&(J-=se?3:5),J}function G(Z,re,pe,Me,je,Ke,Ze){return te(Z,re,pe,Me,je,Ke,!0,Ze)}e.fuzzyScoreGracefulAggressive=G;function ee(Z,re,pe,Me,je,Ke,Ze){return te(Z,re,pe,Me,je,Ke,!1,Ze)}e.fuzzyScoreGraceful=ee;function te(Z,re,pe,Me,je,Ke,Ze,rt){let ct=Be(Z,re,pe,Me,je,Ke,rt);if(ct&&!Ze)return ct;if(Z.length>=3){const ye=Math.min(7,Z.length-1);for(let at=pe+1;at<ye;at++){const J=ce(Z,at);if(J){const se=Be(J,J.toLowerCase(),pe,Me,je,Ke,rt);se&&(se[0]-=3,(!ct||se[0]>ct[0])&&(ct=se))}}}return ct}function ce(Z,re){if(re+1>=Z.length)return;const pe=Z[re],Me=Z[re+1];if(pe!==Me)return Z.slice(0,re)+Me+pe+Z.slice(re+2)}}),define(fe[143],me([0,1,47,99,9]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const S=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${S.source}`,"g");function _(w){return w.replace(P,(D,T)=>T?D:`\\${D}`)}e.escapeIcons=_;const y=new RegExp(`\\\\${S.source}`,"g");function k(w){return w.replace(y,D=>`\\${D}`)}e.markdownEscapeEscapedIcons=k;const i=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function I(w){return w.indexOf(e.iconStartMarker)===-1?w:w.replace(i,(D,T,b,l)=>b?D:T||l||"")}e.stripIcons=I;function a(w){const D=w.indexOf(e.iconStartMarker);return D===-1?{text:w}:p(w,D)}e.parseLabelWithIcons=a;function p(w,D){const T=[];let b="";function l(s){if(s){b+=s;for(const c of s)T.push(n)}}let o=-1,v="",n=0,f,r,t=D;const d=w.length;for(l(w.substr(0,D));t<d;)f=w[t],r=w[t+1],f===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(o=t,l(v),v=e.iconStartMarker,t++):f===")"&&o!==-1?(n+=t-o+1,o=-1,v=""):o!==-1?/^[a-z0-9\-]$/i.test(f)?v+=f:(l(v),o=-1,v=""):l(f),t++;return l(v),{text:b,iconOffsets:T}}function h(w,D,T=!1){const{text:b,iconOffsets:l}=D;if(!l||l.length===0)return(0,F.matchesFuzzy)(w,b,T);const o=(0,C.ltrim)(b," "),v=b.length-o.length,n=(0,F.matchesFuzzy)(w,o,T);if(n)for(const f of n){const r=l[f.start+v]+v;f.start+=r,f.end+=r}return n}e.matchesFuzzyIconAware=h}),define(fe[100],me([0,1,17,143]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(p="",h=!1){if(this.value=p,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(p,h=0){return this.value+=k(this.supportThemeIcons?(0,F.escapeIcons)(p):p).replace(/([ \t]+)/g,(w,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,h){return this.value+="\n```",this.value+=p,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}}e.MarkdownString=S;function P(a){return _(a)?!a.value:Array.isArray(a)?a.every(P):!0}e.isEmptyMarkdownString=P;function _(a){return a instanceof S?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=_;function y(a,p){return a===p?!0:!a||!p?!1:a.value===p.value&&a.isTrusted===p.isTrusted&&a.supportThemeIcons===p.supportThemeIcons}e.markdownStringEqual=y;function k(a){return a.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function i(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function I(a){const p=[],h=a.split("|").map(D=>D.trim());a=h[0];const w=h[1];if(w){const D=/height=(\d+)/.exec(w),T=/width=(\d+)/.exec(w),b=D?D[1]:"",l=T?T[1]:"",o=isFinite(parseInt(l)),v=isFinite(parseInt(b));o&&p.push(`width="${l}"`),v&&p.push(`height="${b}"`)}return{href:a,dimensions:p}}e.parseHrefAndDimensions=I}),define(fe[62],me([0,1,22,9,2]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function S(i){return JSON.stringify(i,y)}e.stringify=S;function P(i){let I=JSON.parse(i);return I=k(I),I}e.parse=P;var _;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(_=e.MarshalledId||(e.MarshalledId={}));function y(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,F.regExpFlags)(I)}:I}function k(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return C.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof g.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let a=0;a<i.length;++a)i[a]=k(i[a],I+1);else for(const a in i)Object.hasOwnProperty.call(i,a)&&(i[a]=k(i[a],I+1))}return i}e.revive=k}),define(fe[10],me([0,1,11,2]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(_){_.inMemory="inmemory",_.vscode="vscode",_.internal="private",_.walkThrough="walkThrough",_.walkThroughSnippet="walkThroughSnippet",_.http="http",_.https="https",_.file="file",_.mailto="mailto",_.untitled="untitled",_.data="data",_.command="command",_.vscodeRemote="vscode-remote",_.vscodeRemoteResource="vscode-remote-resource",_.userData="vscode-userdata",_.vscodeCustomEditor="vscode-custom-editor",_.vscodeNotebook="vscode-notebook",_.vscodeNotebookCell="vscode-notebook-cell",_.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",_.vscodeNotebookCellOutput="vscode-notebook-cell-output",_.vscodeInteractive="vscode-interactive",_.vscodeInteractiveInput="vscode-interactive-input",_.vscodeSettings="vscode-settings",_.vscodeWorkspaceTrust="vscode-workspace-trust",_.vscodeTerminal="vscode-terminal",_.webviewPanel="webview-panel",_.vscodeWebview="vscode-webview",_.extension="extension",_.vscodeFileResource="vscode-file",_.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,k,i){this._hosts[y]=k,this._ports[y]=i}setConnectionToken(y,k){this._connectionTokens[y]=k}rewrite(y){if(this._delegate)return this._delegate(y);const k=y.authority;let i=this._hosts[k];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[k],a=this._connectionTokens[k];let p=`path=${encodeURIComponent(y.path)}`;return typeof a=="string"&&(p+=`&tkn=${encodeURIComponent(a)}`),F.URI.from({scheme:g.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new S;class P{asBrowserUri(y,k){const i=this.toUri(y,k);return i.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===C.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${C.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?i.with({scheme:C.vscodeFileResource,authority:i.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(y,k){const i=this.toUri(y,k);return i.scheme===C.vscodeFileResource?i.with({scheme:C.file,authority:i.authority!==P.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(y,k){return F.URI.isUri(y)?y:F.URI.parse(k.toUrl(y))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P}),define(fe[79],me([0,1,24]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const F=new g.LRUCache(1e4);function C(k){return y(k,"NFC",F)}e.normalizeNFC=C;const S=new g.LRUCache(1e4);function P(k){return y(k,"NFD",S)}e.normalizeNFD=P;const _=/[^\u0000-\u0080]/;function y(k,i,I){if(!k)return k;const a=I.get(k);if(a)return a;let p;return _.test(k)?p=k.normalize(i):p=k,I.set(k,p),p}e.removeAccents=function(){const k=/[\u0300-\u036f]/g;return function(i){return P(i).replace(k,"")}}()}),define(fe[23],me([0,1,29,10,8,11,9,2]),function(Y,e,g,F,C,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(p){return(0,_.uriToFsPath)(p,!0)}e.originalFSPath=y;class k{constructor(h){this._ignorePathCasing=h}compare(h,w,D=!1){return h===w?0:(0,P.compare)(this.getComparisonKey(h,D),this.getComparisonKey(w,D))}isEqual(h,w,D=!1){return h===w?!0:!h||!w?!1:this.getComparisonKey(h,D)===this.getComparisonKey(w,D)}getComparisonKey(h,w=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,w,D=!1){if(h.scheme===w.scheme){if(h.scheme===F.Schemas.file)return g.isEqualOrParent(y(h),y(w),this._ignorePathCasing(h))&&h.query===w.query&&(D||h.fragment===w.fragment);if((0,e.isEqualAuthority)(h.authority,w.authority))return g.isEqualOrParent(h.path,w.path,this._ignorePathCasing(h),"/")&&h.query===w.query&&(D||h.fragment===w.fragment)}return!1}joinPath(h,...w){return _.URI.joinPath(h,...w)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return C.posix.basename(h.path)}extname(h){return C.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let w;return h.scheme===F.Schemas.file?w=_.URI.file(C.dirname(y(h))).path:(w=C.posix.dirname(h.path),h.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),w="/")),h.with({path:w})}normalizePath(h){if(!h.path.length)return h;let w;return h.scheme===F.Schemas.file?w=_.URI.file(C.normalize(y(h))).path:w=C.posix.normalize(h.path),h.with({path:w})}relativePath(h,w){if(h.scheme!==w.scheme||!(0,e.isEqualAuthority)(h.authority,w.authority))return;if(h.scheme===F.Schemas.file){const b=C.relative(y(h),y(w));return S.isWindows?g.toSlashes(b):b}let D=h.path||"/",T=w.path||"/";if(this._ignorePathCasing(h)){let b=0;for(const l=Math.min(D.length,T.length);b<l&&!(D.charCodeAt(b)!==T.charCodeAt(b)&&D.charAt(b).toLowerCase()!==T.charAt(b).toLowerCase());b++);D=T.substr(0,b)+D.substr(b)}return C.posix.relative(D,T)}resolvePath(h,w){if(h.scheme===F.Schemas.file){const D=_.URI.file(C.resolve(y(h),w));return h.with({authority:D.authority,path:D.path})}return w=g.toPosixPath(w),h.with({path:C.posix.resolve(h.path,w)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,w){return h===w||(0,P.equalsIgnoreCase)(h,w)}hasTrailingPathSeparator(h,w=C.sep){if(h.scheme===F.Schemas.file){const D=y(h);return D.length>g.getRoot(D).length&&D[D.length-1]===w}else{const D=h.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,w=C.sep){return(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,w=C.sep){let D=!1;if(h.scheme===F.Schemas.file){const T=y(h);D=T!==void 0&&T.length===g.getRoot(T).length&&T[T.length-1]===w}else{w="/";const T=h.path;D=T.length===1&&T.charCodeAt(T.length-1)===47}return!D&&!(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path+"/"}):h}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(p=>p.scheme===F.Schemas.file?!S.isLinux:!0),e.extUriIgnorePathCase=new k(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,h){const w=[];for(let D=0;D<p.length;D++){const T=h(p[D]);p.some((b,l)=>l===D?!1:(0,e.isEqualOrParent)(T,h(b)))||w.push(p[D])}return w}e.distinctParents=i;var I;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(w){const D=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(l=>{const[o,v]=l.split(":");o&&v&&D.set(o,v)});const b=w.path.substring(0,w.path.indexOf(";"));return b&&D.set(p.META_DATA_MIME,b),D}p.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function a(p,h,w){if(h){let D=p.path;return D&&D[0]!==C.posix.sep&&(D=C.posix.sep+D),p.with({scheme:w,authority:h,path:D})}return p.with({scheme:w})}e.toLocalResource=a}),define(fe[15],me([0,1,21,17,3,6,23]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(U){return!!U&&typeof U.then=="function"}e.isThenable=_;function y(U){const x=new g.CancellationTokenSource,z=U(x.token),O=new Promise((W,$)=>{const X=x.token.onCancellationRequested(()=>{X.dispose(),x.dispose(),$((0,F.canceled)())});Promise.resolve(z).then(K=>{X.dispose(),x.dispose(),W(K)},K=>{X.dispose(),x.dispose(),$(K)})});return new class{cancel(){x.cancel()}then(W,$){return O.then(W,$)}catch(W){return this.then(void 0,W)}finally(W){return O.finally(W)}}}e.createCancelablePromise=y;function k(U,x,z){return Promise.race([U,new Promise(O=>x.onCancellationRequested(()=>O(z)))])}e.raceCancellation=k;async function i(U){let x=-1;const z=U.map((W,$)=>W.then(X=>(x=$,X))),O=await Promise.race(z);return U.forEach((W,$)=>{$!==x&&W.cancel()}),O}e.raceCancellablePromises=i;function I(U,x,z){let O;const W=setTimeout(()=>{O?.(void 0),z?.()},x);return Promise.race([U.finally(()=>clearTimeout(W)),new Promise($=>O=$)])}e.raceTimeout=I;function a(U){return new Promise((x,z)=>{const O=U();_(O)?O.then(x,z):x(O)})}e.asPromise=a;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const z=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(z,z).then(O)})}return new Promise((z,O)=>{this.queuedPromise.then(z,O)})}return this.activePromise=x(),new Promise((z,O)=>{this.activePromise.then(W=>{this.activePromise=null,z(W)},W=>{this.activePromise=null,O(W)})})}}e.Throttler=p;class h{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=h;class w{constructor(){this.promiseMap=new Map}queue(x,z){const W=(this.promiseMap.get(x)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.promiseMap.get(x)===W&&this.promiseMap.delete(x)});return this.promiseMap.set(x,W),W}}e.SequencerByKey=w;class D{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,z=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,W)=>{this.doResolve=O,this.doReject=W}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=D;class T{constructor(x){this.delayer=new D(x),this.throttler=new p}trigger(x,z){return this.delayer.trigger(()=>this.throttler.queue(x),z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=T;class b{constructor(){this._isOpen=!1,this._promise=new Promise((x,z)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class l extends b{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function o(U,x){return x?new Promise((z,O)=>{const W=setTimeout(()=>{$.dispose(),z()},U),$=x.onCancellationRequested(()=>{clearTimeout(W),$.dispose(),O((0,F.canceled)())})}):y(z=>o(U,z))}e.timeout=o;function v(U,x=0){const z=setTimeout(U,x);return(0,S.toDisposable)(()=>clearTimeout(z))}e.disposableTimeout=v;function n(U){const x=[];let z=0;const O=U.length;function W(){return z<O?U[z++]():null}function $(X){X!=null&&x.push(X);const K=W();return K?K.then($):Promise.resolve(x)}return Promise.resolve(null).then($)}e.sequence=n;function f(U,x=O=>!!O,z=null){let O=0;const W=U.length,$=()=>{if(O>=W)return Promise.resolve(z);const X=U[O++];return Promise.resolve(X()).then(de=>x(de)?Promise.resolve(de):$())};return $()}e.first=f;function r(U,x=O=>!!O,z=null){if(U.length===0)return Promise.resolve(z);let O=U.length;const W=()=>{O=-1;for(const $ of U)$.cancel?.()};return new Promise(($,X)=>{for(const K of U)K.then(de=>{--O>=0&&x(de)?(W(),$(de)):O===0&&$(z)}).catch(de=>{--O>=0&&(W(),X(de))})})}e.firstParallel=r;class t{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise((z,O)=>{this.outstandingPromises.push({factory:x,c:z,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const z=x.factory();z.then(x.c,x.e),z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=t;class d extends t{constructor(){super(1)}}e.Queue=d;class s{constructor(){this.queues=new Map}queueFor(x,z=P.extUri){const O=z.getComparisonKey(x);let W=this.queues.get(O);return W||(W=new d,C.Event.once(W.onFinished)(()=>{W?.dispose(),this.queues.delete(O)}),this.queues.set(O,W)),W}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=s;class c{constructor(x,z){this._token=-1,typeof x=="function"&&typeof z=="number"&&this.setIfNotSet(x,z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},z)}setIfNotSet(x,z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},z))}}e.TimeoutTimer=c;class m{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,z){this.cancel(),this._token=setInterval(()=>{x()},z)}}e.IntervalTimer=m;class u{constructor(x,z){this.timeoutToken=-1,this.runner=x,this.timeout=z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=u;class E{constructor(x,z){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.runner=x,this.timeout=z,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(x=this.timeout){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(x/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=E;class R extends u{constructor(x,z){super(x,z);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=R;class L extends S.Disposable{constructor(x,z,O,W){super();this.maxWorkChunkSize=x,this.maxPendingWork=z,this.throttleDelay=O,this.handler=W,this.pendingWork=[],this.throttler=this._register(new S.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(x){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+x.length>this.maxPendingWork)return!1}else if(this.pending+x.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...x),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new u(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=L,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{const x=setTimeout(()=>{const O=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let z=!1;return{dispose(){z||(z=!0,clearTimeout(x))}}}:e.runWhenIdle=(U,x)=>{const z=requestIdleCallback(U,typeof x=="number"?{timeout:x}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(z))}}}}();class M{constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch(z){this._error=z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=M;async function A(U,x,z){let O;for(let W=0;W<z;W++)try{return await U()}catch($){O=$,await o(x)}throw O}e.retry=A;class B{hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(x,z,O){return this._pending={taskId:x,cancel:()=>O?.(),promise:z},z.then(()=>this.donePending(x),()=>this.donePending(x)),z}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let z,O;const W=new Promise(($,X)=>{z=$,O=X});this._next={run:x,promise:W,promiseResolve:z,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=B;class V{constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,z)=>{this.completeCallback=x,this.errorCallback=z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise(z=>{this.completeCallback(x),this.resolved=!0,z()})}error(x){return new Promise(z=>{this.errorCallback(x),this.rejected=!0,z()})}cancel(){new Promise(x=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,x()})}}e.DeferredPromise=N;var j;(function(U){async function x(O){let W;const $=await Promise.all(O.map(X=>X.then(K=>K,K=>{W||(W=K)})));if(typeof W!="undefined")throw W;return $}U.settled=x;function z(O){return new Promise(async(W,$)=>{try{await O(W,$)}catch(X){$(X)}})}U.withAsyncBody=z})(j=e.Promises||(e.Promises={}))}),define(fe[101],me([0,1,15,8]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new g.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),S=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function _(u,E,R=!1){const L=u||"",M=E||"",A=C.value.collator.compare(L,M);return C.value.collatorIsNumeric&&A===0&&L!==M?L<M?-1:1:A}e.compareFileNames=_;function y(u,E){const R=S.value.collator;return u=u||"",E=E||"",v(R,u,E)}e.compareFileNamesDefault=y;function k(u,E){const R=S.value.collator;return u=u||"",E=E||"",t(u,E)||v(R,u,E)}e.compareFileNamesUpper=k;function i(u,E){const R=S.value.collator;return u=u||"",E=E||"",r(u,E)||v(R,u,E)}e.compareFileNamesLower=i;function I(u,E){return u=u||"",E=E||"",u===E?0:u<E?-1:1}e.compareFileNamesUnicode=I;function a(u,E,R=!1){R||(u=u&&u.toLowerCase(),E=E&&E.toLowerCase());const[L,M]=l(u),[A,B]=l(E);return L!==A?L<A?-1:1:M===B?0:M<B?-1:1}e.noIntlCompareFileNames=a;function p(u,E){const[R,L]=l(u),[M,A]=l(E);let B=C.value.collator.compare(L,A);if(B===0){if(C.value.collatorIsNumeric&&L!==A)return L<A?-1:1;if(B=C.value.collator.compare(R,M),C.value.collatorIsNumeric&&B===0&&R!==M)return R<M?-1:1}return B}e.compareFileExtensions=p;function h(u,E){u=u||"",E=E||"";const R=o(u),L=o(E),M=S.value.collator,A=P.value.collator;return v(A,R,L)||v(M,u,E)}e.compareFileExtensionsDefault=h;function w(u,E){u=u||"",E=E||"";const R=o(u),L=o(E),M=S.value.collator,A=P.value.collator;return v(A,R,L)||t(u,E)||v(M,u,E)}e.compareFileExtensionsUpper=w;function D(u,E){u=u||"",E=E||"";const R=o(u),L=o(E),M=S.value.collator,A=P.value.collator;return v(A,R,L)||r(u,E)||v(M,u,E)}e.compareFileExtensionsLower=D;function T(u,E){u=u||"",E=E||"";const R=o(u).toLowerCase(),L=o(E).toLowerCase();return R!==L?R<L?-1:1:u!==E?u<E?-1:1:0}e.compareFileExtensionsUnicode=T;const b=/^(.*?)(\.([^.]*))?$/;function l(u,E=!1){const R=u?b.exec(u):[];let L=[R&&R[1]||"",R&&R[3]||""];return E&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function o(u){const E=u?b.exec(u):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function v(u,E,R){let L=u.compare(E,R);return L!==0?L:E.length!==R.length?E.length<R.length?-1:1:0}function n(u){const E=u.charAt(0);return E.toLocaleUpperCase()!==E}function f(u){const E=u.charAt(0);return E.toLocaleLowerCase()!==E}function r(u,E){return n(u)&&f(E)?-1:f(u)&&n(E)?1:0}function t(u,E){return f(u)&&n(E)?-1:n(u)&&f(E)?1:0}function d(u,E,R=!1){return R||(u=u&&u.toLowerCase(),E=E&&E.toLowerCase()),u===E?0:u<E?-1:1}function s(u,E,R=!1){const L=u.split(F.sep),M=E.split(F.sep),A=L.length-1,B=M.length-1;let V,N;for(let j=0;;j++){if(V=A===j,N=B===j,V&&N)return _(L[j],M[j],R);if(V)return-1;if(N)return 1;const U=d(L[j],M[j],R);if(U!==0)return U}}e.comparePaths=s;function c(u,E,R){const L=u.toLowerCase(),M=E.toLowerCase(),A=m(u,E,R);if(A)return A;const B=L.endsWith(R),V=M.endsWith(R);if(B!==V)return B?-1:1;const N=_(L,M);return N!==0?N:L.localeCompare(M)}e.compareAnything=c;function m(u,E,R){const L=u.toLowerCase(),M=E.toLowerCase(),A=L.startsWith(R),B=M.startsWith(R);if(A!==B)return A?-1:1;if(A&&B){if(L.length<M.length)return-1;if(L.length>M.length)return 1}return 0}e.compareByPrefix=m}),define(fe[102],me([0,1,101,99,48,8,11,9]),function(Y,e,g,F,C,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,k=[y,[]];function i(U,x,z,O){if(!U||!x)return k;const W=U.length,$=x.length;if(W<$)return k;const X=U.toLowerCase();return I(x,z,$,U,X,W,O)}e.scoreFuzzy=i;function I(U,x,z,O,W,$,X){const K=[],de=[];for(let Be=0;Be<z;Be++){const $e=Be*$,He=$e-$,G=Be>0,ee=U[Be],te=x[Be];for(let ce=0;ce<$;ce++){const Z=ce>0,re=$e+ce,pe=re-1,Me=He+ce-1,je=Z?K[pe]:0,Ke=G&&Z?K[Me]:0,Ze=G&&Z?de[Me]:0;let rt;!Ke&&G?rt=0:rt=a(ee,te,O,W,ce,Ze),rt&&Ke+rt>=je&&(X||G||W.startsWith(x,ce))?(de[re]=Ze+1,K[re]=Ke+rt):(de[re]=y,K[re]=je)}}const _e=[];let Ce=z-1,Pe=$-1;for(;Ce>=0&&Pe>=0;){const Be=Ce*$+Pe;de[Be]===y||(_e.push(Pe),Ce--),Pe--}return[K[z*$-1],_e.reverse()]}function a(U,x,z,O,W,$){let X=0;if(!p(x,O[W]))return X;if(X+=1,$>0&&(X+=$*5),U===z[W]&&(X+=1),W===0)X+=8;else{const K=h(z.charCodeAt(W-1));K?X+=K:(0,F.isUpper)(z.charCodeAt(W))&&(X+=2)}return X}function p(U,x){return U===x?!0:U==="/"||U==="\\"?x==="/"||x==="\\":!1}function h(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function D(U,x,z=0,O=0){const W=x;return W.values&&W.values.length>1?T(U,W.values,z,O):b(U,x,z,O)}e.scoreFuzzy2=D;function T(U,x,z,O){let W=0;const $=[];for(const X of x){const[K,de]=b(U,X,z,O);if(typeof K!="number")return w;W+=K,$.push(...de)}return[W,m($)]}function b(U,x,z,O){const W=(0,F.fuzzyScore)(x.original,x.originalLowercase,z,U,U.toLowerCase(),O,!0);return W?[W[0],(0,F.createMatches)(W)]:w}const l=Object.freeze({score:0}),o=1<<18,v=1<<17,n=1<<16;function f(U,x,z,O){const W=O.values?O.values:[O];return(0,C.hash)({[O.normalized]:{values:W.map(X=>({value:X.normalized,expectContiguousMatch:X.expectContiguousMatch})),label:U,description:x,allowNonContiguousMatches:z}})}function r(U,x,z,O,W){if(!U||!x.normalized)return l;const $=O.getItemLabel(U);if(!$)return l;const X=O.getItemDescription(U),K=f($,X,z,x),de=W[K];if(de)return de;const _e=t($,X,O.getItemPath(U),x,z);return W[K]=_e,_e}e.scoreItemFuzzy=r;function t(U,x,z,O,W){const $=!z||!O.containsPathSeparator;return z&&(P.isLinux?O.pathNormalized===z:(0,_.equalsIgnoreCase)(O.pathNormalized,z))?{score:o,labelMatch:[{start:0,end:U.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:O.values&&O.values.length>1?d(U,x,z,O.values,$,W):s(U,x,z,O,$,W)}function d(U,x,z,O,W,$){let X=0;const K=[],de=[];for(const _e of O){const{score:Ce,labelMatch:Pe,descriptionMatch:Be}=s(U,x,z,_e,W,$);if(Ce===y)return l;X+=Ce,Pe&&K.push(...Pe),Be&&de.push(...Be)}return{score:X,labelMatch:m(K),descriptionMatch:m(de)}}function s(U,x,z,O,W,$){if(W||!x){const[X,K]=i(U,O.normalized,O.normalizedLowercase,$&&!O.expectContiguousMatch);if(X){const de=(0,F.matchesPrefix)(O.normalized,U);let _e;return de?(_e=v,_e+=Math.round(O.normalized.length/U.length*100)):_e=n,{score:_e+X,labelMatch:de||c(K)}}}if(x){let X=x;z&&(X=`${x}${S.sep}`);const K=X.length,de=`${X}${U}`,[_e,Ce]=i(de,O.normalized,O.normalizedLowercase,$&&!O.expectContiguousMatch);if(_e){const Pe=c(Ce),Be=[],$e=[];return Pe.forEach(He=>{He.start<K&&He.end>K?(Be.push({start:0,end:He.end-K}),$e.push({start:He.start,end:K})):He.start>=K?Be.push({start:He.start-K,end:He.end-K}):$e.push(He)}),{score:_e,labelMatch:Be,descriptionMatch:$e}}}return l}function c(U){const x=[];if(!U)return x;let z;for(const O of U)z&&z.end===O?z.end+=1:(z={start:O,end:O+1},x.push(z));return x}function m(U){const x=U.sort((W,$)=>W.start-$.start),z=[];let O;for(const W of x)!O||!u(O,W)?(O=W,z.push(W)):(O.start=Math.min(O.start,W.start),O.end=Math.max(O.end,W.end));return z}function u(U,x){return!(U.end<x.start||x.end<U.start)}function E(U,x,z,O,W,$){const X=r(U,z,O,W,$),K=r(x,z,O,W,$),de=X.score,_e=K.score;if((de===o||_e===o)&&de!==_e)return de===o?-1:1;if(de>n||_e>n){if(de!==_e)return de>_e?-1:1;if(de<v&&_e<v){const ee=L(X.labelMatch,K.labelMatch);if(ee!==0)return ee}const He=W.getItemLabel(U)||"",G=W.getItemLabel(x)||"";if(He.length!==G.length)return He.length-G.length}if(de!==_e)return de>_e?-1:1;const Ce=Array.isArray(X.labelMatch)&&X.labelMatch.length>0,Pe=Array.isArray(K.labelMatch)&&K.labelMatch.length>0;if(Ce&&!Pe)return-1;if(Pe&&!Ce)return 1;const Be=R(U,X,W),$e=R(x,K,W);return Be&&$e&&Be!==$e?$e>Be?-1:1:M(U,x,z,W)}e.compareItemsByFuzzyScore=E;function R(U,x,z){let O=-1,W=-1;if(x.descriptionMatch&&x.descriptionMatch.length?O=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(O=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(W=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const $=z.getItemDescription(U);$&&(W+=$.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(W=x.descriptionMatch[x.descriptionMatch.length-1].end);return W-O}function L(U,x){if(!U&&!x||(!U||!U.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!U||!U.length)return 1;const z=U[0].start,W=U[U.length-1].end-z,$=x[0].start,K=x[x.length-1].end-$;return W===K?0:K<W?1:-1}function M(U,x,z,O){const W=O.getItemLabel(U)||"",$=O.getItemLabel(x)||"",X=O.getItemDescription(U),K=O.getItemDescription(x),de=W.length+(X?X.length:0),_e=$.length+(K?K.length:0);if(de!==_e)return de-_e;const Ce=O.getItemPath(U),Pe=O.getItemPath(x);return Ce&&Pe&&Ce.length!==Pe.length?Ce.length-Pe.length:W!==$?(0,g.compareAnything)(W,$,z.normalized):X&&K&&X!==K?(0,g.compareAnything)(X,K,z.normalized):Ce&&Pe&&Ce!==Pe?(0,g.compareAnything)(Ce,Pe,z.normalized):0}function A(U){return U.startsWith('"')&&U.endsWith('"')}const B=" ";function V(U){typeof U!="string"&&(U="");const x=U.toLowerCase(),{pathNormalized:z,normalized:O,normalizedLowercase:W}=N(U),$=z.indexOf(S.sep)>=0,X=A(U);let K;const de=U.split(B);if(de.length>1)for(const _e of de){const Ce=A(_e),{pathNormalized:Pe,normalized:Be,normalizedLowercase:$e}=N(_e);Be&&(K||(K=[]),K.push({original:_e,originalLowercase:_e.toLowerCase(),pathNormalized:Pe,normalized:Be,normalizedLowercase:$e,expectContiguousMatch:Ce}))}return{original:U,originalLowercase:x,pathNormalized:z,normalized:O,normalizedLowercase:W,values:K,containsPathSeparator:$,expectContiguousMatch:X}}e.prepareQuery=V;function N(U){let x;P.isWindows?x=U.replace(/\//g,S.sep):x=U.replace(/\\/g,S.sep);const z=(0,_.stripWildcards)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:z,normalizedLowercase:z.toLowerCase()}}function j(U){return Array.isArray(U)?V(U.map(x=>x.original).join(B)):V(U.original)}e.pieceToQuery=j}),define(fe[30],me([0,1,15,29,24,8,9]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function _(){return Object.create(null)}e.getEmptyExpression=_;const y="**",k="/",i="[/\\\\]",I="[^/\\\\]",a=/\//g;function p(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function h(O,W){if(!O)return[];const $=[];let X=!1,K=!1,de="";for(const _e of O){switch(_e){case W:if(!X&&!K){$.push(de),de="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":K=!0;break;case"]":K=!1;break}de+=_e}return de&&$.push(de),$}e.splitGlobAware=h;function w(O){if(!O)return"";let W="";const $=h(O,k);if($.every(X=>X===y))W=".*";else{let X=!1;$.forEach((K,de)=>{if(K===y){X||(W+=p(2),X=!0);return}let _e=!1,Ce="",Pe=!1,Be="";for(const $e of K){if($e!=="}"&&_e){Ce+=$e;continue}if(Pe&&($e!=="]"||!Be)){let He;$e==="-"?He=$e:($e==="^"||$e==="!")&&!Be?He="^":$e===k?He="":He=P.escapeRegExpCharacters($e),Be+=He;continue}switch($e){case"{":_e=!0;continue;case"[":Pe=!0;continue;case"}":W+=`(?:${h(Ce,",").map(ee=>w(ee)).join("|")})`,_e=!1,Ce="";break;case"]":W+="["+Be+"]",Pe=!1,Be="";break;case"?":W+=I;continue;case"*":W+=p(1);continue;default:W+=P.escapeRegExpCharacters($e)}}de<$.length-1&&($[de+1]!==y||de+2<$.length)&&(W+=i),X=!1})}return W}const D=/^\*\*\/\*\.[\w\.-]+$/,T=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new C.LRUCache(1e4),f=function(){return!1},r=function(){return null};function t(O,W){if(!O)return r;let $;typeof O!="string"?$=O.pattern:$=O,$=$.trim();const X=`${$}_${!!W.trimForExclusions}`;let K=n.get(X);if(K)return d(K,O);let de;if(D.test($)){const _e=$.substr(4);K=function(Ce,Pe){return typeof Ce=="string"&&Ce.endsWith(_e)?$:null}}else(de=T.exec(s($,W)))?K=c(de[1],$):(W.trimForExclusions?l:b).test($)?K=m($,W):(de=o.exec(s($,W)))?K=u(de[1].substr(1),$,!0):(de=v.exec(s($,W)))?K=u(de[1],$,!1):K=E($);return n.set(X,K),d(K,O)}function d(O,W){return typeof W=="string"?O:function($,X){return F.isEqualOrParent($,W.base)?O(S.relative(W.base,$),X):null}}function s(O,W){return W.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function c(O,W){const $=`/${O}`,X=`\\${O}`,K=function(_e,Ce){return typeof _e!="string"?null:Ce?Ce===O?W:null:_e===O||_e.endsWith($)||_e.endsWith(X)?W:null},de=[O];return K.basenames=de,K.patterns=[W],K.allBasenames=de,K}function m(O,W){const $=z(O.slice(1,-1).split(",").map(Ce=>t(Ce,W)).filter(Ce=>Ce!==r),O),X=$.length;if(!X)return r;if(X===1)return $[0];const K=function(Ce,Pe){for(let Be=0,$e=$.length;Be<$e;Be++)if($[Be](Ce,Pe))return O;return null},de=$.find(Ce=>!!Ce.allBasenames);de&&(K.allBasenames=de.allBasenames);const _e=$.reduce((Ce,Pe)=>Pe.allPaths?Ce.concat(Pe.allPaths):Ce,[]);return _e.length&&(K.allPaths=_e),K}function u(O,W,$){const X=S.sep===S.posix.sep,K=X?O:O.replace(a,S.sep),de=S.sep+K,_e=S.posix.sep+O,Ce=$?function(Pe,Be){return typeof Pe=="string"&&(Pe===K||Pe.endsWith(de)||!X&&(Pe===O||Pe.endsWith(_e)))?W:null}:function(Pe,Be){return typeof Pe=="string"&&(Pe===K||!X&&Pe===O)?W:null};return Ce.allPaths=[($?"*/":"./")+O],Ce}function E(O){try{const W=new RegExp(`^${w(O)}$`);return function($){return W.lastIndex=0,typeof $=="string"&&W.test($)?O:null}}catch(W){return r}}function R(O,W,$){return!O||typeof W!="string"?!1:L(O)(W,void 0,$)}e.match=R;function L(O,W={}){if(!O)return f;if(typeof O=="string"||V(O)){const $=t(O,W);if($===r)return f;const X=function(K,de){return!!$(K,de)};return $.allBasenames&&(X.allBasenames=$.allBasenames),$.allPaths&&(X.allPaths=$.allPaths),X}return U(O,W)}e.parse=L;function M(O){if(!O)return;let W;return $=>(W||(W=(O()||Promise.resolve([])).then(X=>X?B(X):{})),W.then(X=>!!X[$]))}e.hasSiblingPromiseFn=M;function A(O){if(!O)return;let W;return $=>{if(!W){const X=O();W=X?B(X):{}}return!!W[$]}}e.hasSiblingFn=A;function B(O){const W={};for(const $ of O)W[$]=!0;return W}function V(O){const W=O;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=V;function N(O){return O.allBasenames||[]}e.getBasenameTerms=N;function j(O){return O.allPaths||[]}e.getPathTerms=j;function U(O,W){const $=z(Object.getOwnPropertyNames(O).map(Ce=>x(Ce,O[Ce],W)).filter(Ce=>Ce!==r)),X=$.length;if(!X)return r;if(!$.some(Ce=>!!Ce.requiresSiblings)){if(X===1)return $[0];const Ce=function($e,He){for(let G=0,ee=$.length;G<ee;G++){const te=$[G]($e,He);if(te)return te}return null},Pe=$.find($e=>!!$e.allBasenames);Pe&&(Ce.allBasenames=Pe.allBasenames);const Be=$.reduce(($e,He)=>He.allPaths?$e.concat(He.allPaths):$e,[]);return Be.length&&(Ce.allPaths=Be),Ce}const K=function(Ce,Pe,Be){let $e;for(let He=0,G=$.length;He<G;He++){const ee=$[He];ee.requiresSiblings&&Be&&(Pe||(Pe=S.basename(Ce)),$e||($e=Pe.substr(0,Pe.length-S.extname(Ce).length)));const te=ee(Ce,Pe,$e,Be);if(te)return te}return null},de=$.find(Ce=>!!Ce.allBasenames);de&&(K.allBasenames=de.allBasenames);const _e=$.reduce((Ce,Pe)=>Pe.allPaths?Ce.concat(Pe.allPaths):Ce,[]);return _e.length&&(K.allPaths=_e),K}function x(O,W,$){if(W===!1)return r;const X=t(O,$);if(X===r)return r;if(typeof W=="boolean")return X;if(W){const K=W.when;if(typeof K=="string"){const de=(_e,Ce,Pe,Be)=>{if(!Be||!X(_e,Ce))return null;const $e=K.replace("$(basename)",Pe),He=Be($e);return(0,g.isThenable)(He)?He.then(G=>G?O:null):He?O:null};return de.requiresSiblings=!0,de}}return X}function z(O,W){const $=O.filter(Ce=>!!Ce.basenames);if($.length<2)return O;const X=$.reduce((Ce,Pe)=>{const Be=Pe.basenames;return Be?Ce.concat(Be):Ce},[]);let K;if(W){K=[];for(let Ce=0,Pe=X.length;Ce<Pe;Ce++)K.push(W)}else K=$.reduce((Ce,Pe)=>{const Be=Pe.patterns;return Be?Ce.concat(Be):Ce},[]);const de=function(Ce,Pe){if(typeof Ce!="string")return null;if(!Pe){let $e;for($e=Ce.length;$e>0;$e--){const He=Ce.charCodeAt($e-1);if(He===47||He===92)break}Pe=Ce.substr($e)}const Be=X.indexOf(Pe);return Be!==-1?K[Be]:null};de.basenames=X,de.patterns=K,de.allBasenames=X;const _e=O.filter(Ce=>!Ce.basenames);return _e.push(de),_e}}),define(fe[80],me([0,1,29,10,8,11,23,9,2]),function(Y,e,g,F,C,S,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(t,d,s){if(typeof t=="string"&&(t=y.URI.file(t)),s){const m=s.getWorkspaceFolder(t);if(m){const u=s.getWorkspace().folders.length>1;let E;if((0,P.isEqual)(m.uri,t)?E="":E=(0,P.relativePath)(m.uri,t),u){const R=m.name?m.name:(0,P.basename)(m.uri);E=E?R+" \u2022 "+E:R}return E}}if(t.scheme!==F.Schemas.file&&t.scheme!==F.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(t.fsPath))return(0,C.normalize)(I(t.fsPath));let c=(0,C.normalize)(t.fsPath);return!S.isWindows&&d?.userHome&&(c=p(c,d.userHome.fsPath)),c}e.getPathLabel=k;function i(t){if(!t)return;typeof t=="string"&&(t=y.URI.file(t));const d=(0,P.basename)(t)||(t.scheme===F.Schemas.file?t.fsPath:t.path);return S.isWindows&&(0,g.isRootOrDriveLetter)(d)?I(d):d}e.getBaseLabel=i;function I(t){return(0,g.hasDriveLetter)(t)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=I;let a=Object.create(null);function p(t,d){if(S.isWindows||!t||!d)return t;let s=a.original===d?a.normalized:void 0;return s||(s=`${(0,_.rtrim)(d,C.posix.sep)}${C.posix.sep}`,a={original:d,normalized:s}),(S.isLinux?t.startsWith(s):(0,_.startsWithIgnoreCase)(t,s))&&(t=`~/${t.substr(s.length)}`),t}e.tildify=p;function h(t,d){return t.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=h;const w="\u2026",D="\\\\",T="~";function b(t,d=C.sep){const s=new Array(t.length);let c=!1;for(let m=0;m<t.length;m++){let u=t[m];if(u===""){s[m]=`.${d}`;continue}if(!u){s[m]=u;continue}c=!0;let E="";u.indexOf(D)===0?(E=u.substr(0,u.indexOf(D)+D.length),u=u.substr(u.indexOf(D)+D.length)):u.indexOf(d)===0?(E=u.substr(0,u.indexOf(d)+d.length),u=u.substr(u.indexOf(d)+d.length)):u.indexOf(T)===0&&(E=u.substr(0,u.indexOf(T)+T.length),u=u.substr(u.indexOf(T)+T.length));const R=u.split(d);for(let L=1;c&&L<=R.length;L++)for(let M=R.length-L;c&&M>=0;M--){c=!1;let A=R.slice(M,M+L).join(d);for(let B=0;!c&&B<t.length;B++)if(B!==m&&t[B]&&t[B].indexOf(A)>-1){const V=M+L===R.length,N=M>0&&t[B].indexOf(d)>-1?d+A:A,j=t[B].endsWith(N);c=!V||j}if(!c){let B="";(R[0].endsWith(":")||E!=="")&&(M===1&&(M=0,L++,A=R[0]+d+A),M>0&&(B=R[0]+d),B=E+B),M>0&&(B=B+w+d),B=B+A,M+L<R.length&&(B=B+d+w),s[m]=B}}c&&(s[m]=u)}return s}e.shorten=b;var l;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function o(t,d=Object.create(null)){const s=[];let c=!1,m="";for(const u of t)if(u==="$"||c&&u==="{")m&&s.push({value:m,type:l.TEXT}),m="",c=!0;else if(u==="}"&&c){const E=d[m];if(typeof E=="string")E.length&&s.push({value:E,type:l.VARIABLE});else if(E){const R=s[s.length-1];(!R||R.type!==l.SEPARATOR)&&s.push({value:E.label,type:l.SEPARATOR})}m="",c=!1}else m+=u;return m&&!c&&s.push({value:m,type:l.TEXT}),s.filter((u,E)=>{if(u.type===l.SEPARATOR){const R=s[E-1],L=s[E+1];return[R,L].every(M=>M&&(M.type===l.VARIABLE||M.type===l.TEXT)&&M.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=o;function v(t,d){return S.isMacintosh||d?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):t.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function n(t,d){return S.isMacintosh||d?t.replace(/\(&&\w\)|&&/g,""):S.isWindows?t.replace(/&&|&/g,s=>s==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=n;function f(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=f;function r(t){const d=t.indexOf("/")!==-1?C.posix:C.win32,s=d.basename(t),c=d.dirname(t);return s.length?{name:s,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(fe[103],me([0,1,30,10,8,23,9]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var _;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(_=e.Mimes||(e.Mimes={}));let y=[],k=[],i=[];function I(t,d=!1){const s=a(t);y.push(s),s.userConfigured?i.push(s):k.push(s),d&&!s.userConfigured&&y.forEach(c=>{c.mime===s.mime||c.userConfigured||(s.extension&&c.extension===s.extension&&console.warn(`Overwriting extension <<${s.extension}>> to now point to mime <<${s.mime}>>`),s.filename&&c.filename===s.filename&&console.warn(`Overwriting filename <<${s.filename}>> to now point to mime <<${s.mime}>>`),s.filepattern&&c.filepattern===s.filepattern&&console.warn(`Overwriting filepattern <<${s.filepattern}>> to now point to mime <<${s.mime}>>`),s.firstline&&c.firstline===s.firstline&&console.warn(`Overwriting firstline <<${s.firstline}>> to now point to mime <<${s.mime}>>`))})}e.registerTextMime=I;function a(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,g.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(C.posix.sep)>=0:!1}}function p(t){t?(y=y.filter(d=>!d.userConfigured),i=[]):(y=[],k=[],i=[])}e.clearTextMimes=p;function h(t,d){let s;if(t)switch(t.scheme){case F.Schemas.file:s=t.fsPath;break;case F.Schemas.data:s=S.DataUri.parseMetaData(t).get(S.DataUri.META_DATA_LABEL);break;default:s=t.path}if(!s)return[_.unknown];s=s.toLowerCase();const c=(0,C.basename)(s),m=w(s,c,i);if(m)return[m,_.text];const u=w(s,c,k);if(u)return[u,_.text];if(d){const E=D(d);if(E)return[E,_.text]}return[_.unknown]}e.guessMimeTypes=h;function w(t,d,s){let c=null,m=null,u=null;for(let E=s.length-1;E>=0;E--){const R=s[E];if(d===R.filenameLowercase){c=R;break}if(R.filepattern&&(!m||R.filepattern.length>m.filepattern.length)){const L=R.filepatternOnPath?t:d;R.filepatternLowercase?.(L)&&(m=R)}R.extension&&(!u||R.extension.length>u.extension.length)&&d.endsWith(R.extensionLowercase)&&(u=R)}return c?c.mime:m?m.mime:u?u.mime:null}function D(t){if((0,P.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let d=y.length-1;d>=0;d--){const s=y[d];if(!s.firstline)continue;const c=t.match(s.firstline);if(c&&c.length>0)return s.mime}return null}function T(t){return t?typeof t=="string"?t===_.binary||t===_.text||t===_.unknown:t.length===1&&T(t[0]):!0}e.isUnspecific=T;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(t){const d=(0,C.extname)(t),s=b[d.toLowerCase()];return s!==void 0?s:v(t)}e.getMediaOrTextMime=o;function v(t){const d=(0,C.extname)(t);return l[d.toLowerCase()]}e.getMediaMime=v;function n(t){for(const d in l)if(l[d]===t)return d}e.getExtensionForMimeType=n;const f=/^(.+)\/(.+?)(;.+)?$/;function r(t,d){const s=f.exec(t);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:d?void 0:t}e.normalizeMimeType=r}),define(fe[104],me([0,1,2]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(i){return i.toJSON()}class C{constructor(I){this._uriTransformer=I}transformIncoming(I){const a=this._uriTransformer.transformIncoming(I);return a===I?I:F(g.URI.from(a))}transformOutgoing(I){const a=this._uriTransformer.transformOutgoing(I);return a===I?I:F(g.URI.from(a))}transformOutgoingURI(I){const a=this._uriTransformer.transformOutgoing(I);return a===I?I:g.URI.from(a)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function S(i,I,a){if(!i||a>200)return null;if(typeof i=="object"){if(i instanceof g.URI)return I.transformOutgoing(i);for(let p in i)if(Object.hasOwnProperty.call(i,p)){const h=S(i[p],I,a+1);h!==null&&(i[p]=h)}}return null}function P(i,I){const a=S(i,I,0);return a===null?i:a}e.transformOutgoingURIs=P;function _(i,I,a,p){if(!i||p>200)return null;if(typeof i=="object"){if(i.$mid===1)return a?g.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let h in i)if(Object.hasOwnProperty.call(i,h)){const w=_(i[h],I,a,p+1);w!==null&&(i[h]=w)}}return null}function y(i,I){const a=_(i,I,!1,0);return a===null?i:a}e.transformIncomingURIs=y;function k(i,I){const a=_(i,I,!0,0);return a===null?i:a}e.transformAndReviveIncomingURIs=k}),define(fe[32],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(y){return g.test(y)}e.isUUID=F;const C=new Uint8Array(16),S=[];for(let y=0;y<256;y++)S.push(y.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(y){for(let k=0;k<y.length;k++)y[k]=Math.floor(Math.random()*256);return y};function _(){P(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let y=0,k="";return k+=S[C[y++]],k+=S[C[y++]],k+=S[C[y++]],k+=S[C[y++]],k+="-",k+=S[C[y++]],k+=S[C[y++]],k+="-",k+=S[C[y++]],k+=S[C[y++]],k+="-",k+=S[C[y++]],k+=S[C[y++]],k+="-",k+=S[C[y++]],k+=S[C[y++]],k+=S[C[y++]],k+=S[C[y++]],k+=S[C[y++]],k+=S[C[y++]],k}e.generateUuid=_}),define(fe[144],me([0,1,105]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class F{constructor(S="utf8"){this.stringDecoder=new g.StringDecoder(S),this.remaining=null}write(S){const P=[],_=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(_.length<1)return P;let y=0,k,i=y;for(;i<_.length;)if(k=_.charCodeAt(i),k===13||k===10){if(P.push(_.substring(y,i)),i++,i<_.length){const I=k;k=_.charCodeAt(i),(I===13&&k===10||I===10&&k===13)&&i++}y=i}else i++;return this.remaining=y<_.length?_.substr(y):null,P}end(){return this.remaining}}e.LineDecoder=F}),define(fe[26],me([0,1,50,81,292,15,29,79,8,11,23,2,32]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function h(N,j=p.UNLINK){if((0,P.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return j===p.UNLINK?D(N):w(N)}async function w(N){try{const j=(0,y.join)((0,F.tmpdir)(),(0,a.generateUuid)());try{await e.Promises.rename(N,j)}catch(U){return D(N)}D(j).catch(U=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function D(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function T(N){if((0,P.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(N,{recursive:!0})}e.rimrafSync=T;async function b(N,j){return v(await(j?l(N):(0,C.promisify)(g.readdir)(N)))}async function l(N){try{return await(0,C.promisify)(g.readdir)(N,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const j=[],U=await b(N);for(const x of U){let z=!1,O=!1,W=!1;try{const $=await e.Promises.lstat((0,y.join)(N,x));z=$.isFile(),O=$.isDirectory(),W=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}j.push({name:x,isFile:()=>z,isDirectory:()=>O,isSymbolicLink:()=>W})}return j}function o(N){return v(g.readdirSync(N))}e.readdirSync=o;function v(N){return N.map(j=>typeof j=="string"?k.isMacintosh?(0,_.normalizeNFC)(j):j:(j.name=k.isMacintosh?(0,_.normalizeNFC)(j.name):j.name,j))}async function n(N){const j=await b(N),U=[];for(const x of j)await r.existsDirectory((0,y.join)(N,x))&&U.push(x);return U}function f(N,j=1e3){return new Promise(U=>{let x=!1;const z=setInterval(()=>{x||(x=!0,g.access(N,O=>{x=!1,O&&(clearInterval(z),U(void 0))}))},j)})}e.whenDeleted=f;var r;(function(N){async function j(z){let O;try{if(O=await e.Promises.lstat(z),!O.isSymbolicLink())return{stat:O}}catch(W){}try{return{stat:await e.Promises.stat(z),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(k.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw $}throw W}}N.stat=j;async function U(z){try{const{stat:O,symbolicLink:W}=await N.stat(z);return O.isFile()&&W?.dangling!==!0}catch(O){}return!1}N.existsFile=U;async function x(z){try{const{stat:O,symbolicLink:W}=await N.stat(z);return O.isDirectory()&&W?.dangling!==!0}catch(O){}return!1}N.existsDirectory=x})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new S.ResourceQueue;function d(N,j,U){return t.queueFor(I.URI.file(N),i.extUriBiasedIgnorePathCase).queue(()=>{const x=u(U);return new Promise((z,O)=>c(N,j,x,W=>W?O(W):z()))})}let s=!0;function c(N,j,U,x){if(!s)return g.writeFile(N,j,{mode:U.mode,flag:U.flag},x);g.open(N,U.flag,U.mode,(z,O)=>{if(z)return x(z);g.writeFile(O,j,W=>{if(W)return g.close(O,()=>x(W));g.fdatasync(O,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),s=!1),g.close(O,X=>x(X))))})})}function m(N,j,U){const x=u(U);if(!s)return g.writeFileSync(N,j,{mode:x.mode,flag:x.flag});const z=g.openSync(N,x.flag,x.mode);try{g.writeFileSync(z,j);try{g.fdatasyncSync(z)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),s=!1}}finally{g.closeSync(z)}}e.writeFileSync=m;function u(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function E(N,j){if(N===j)return;async function U(x){try{const z=await e.Promises.lstat(x);if(z.isDirectory()||z.isSymbolicLink())return;await e.Promises.utimes(x,z.atime,new Date)}catch(z){}}try{await e.Promises.rename(N,j),await U(j)}catch(x){if(N.toLowerCase()!==j.toLowerCase()&&x.code==="EXDEV"||N.endsWith("."))await R(N,j,{preserveSymlinks:!1}),await h(N,p.MOVE),await U(j);else throw x}}async function R(N,j,U){return M(N,j,{root:{source:N,target:j},options:U,handledSourcePaths:new Set})}const L=511;async function M(N,j,U){if(U.handledSourcePaths.has(N))return;U.handledSourcePaths.add(N);const{stat:x,symbolicLink:z}=await r.stat(N);if(z){if(U.options.preserveSymlinks)try{return await V(N,j,U)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(z.dangling)return}return x.isDirectory()?A(N,j,x.mode&L,U):B(N,j,x.mode&L)}async function A(N,j,U,x){await e.Promises.mkdir(j,{recursive:!0,mode:U});const z=await b(N);for(const O of z)await M((0,y.join)(N,O),(0,y.join)(j,O),x)}async function B(N,j,U){await e.Promises.copyFile(N,j),await e.Promises.chmod(j,U)}async function V(N,j,U){let x=await e.Promises.readlink(N);(0,P.isEqualOrParent)(x,U.root.source,!k.isLinux)&&(x=(0,y.join)(U.root.target,x.substr(U.root.source.length+1))),await e.Promises.symlink(x,j)}e.Promises=new class{get access(){return(0,C.promisify)(g.access)}get stat(){return(0,C.promisify)(g.stat)}get lstat(){return(0,C.promisify)(g.lstat)}get utimes(){return(0,C.promisify)(g.utimes)}get read(){return(0,C.promisify)(g.read)}get readFile(){return(0,C.promisify)(g.readFile)}get write(){return(0,C.promisify)(g.write)}get appendFile(){return(0,C.promisify)(g.appendFile)}get fdatasync(){return(0,C.promisify)(g.fdatasync)}get truncate(){return(0,C.promisify)(g.truncate)}get rename(){return(0,C.promisify)(g.rename)}get copyFile(){return(0,C.promisify)(g.copyFile)}get open(){return(0,C.promisify)(g.open)}get close(){return(0,C.promisify)(g.close)}get symlink(){return(0,C.promisify)(g.symlink)}get readlink(){return(0,C.promisify)(g.readlink)}get chmod(){return(0,C.promisify)(g.chmod)}get mkdir(){return(0,C.promisify)(g.mkdir)}get unlink(){return(0,C.promisify)(g.unlink)}get rmdir(){return(0,C.promisify)(g.rmdir)}get realpath(){return(0,C.promisify)(g.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return n}get writeFile(){return d}get rm(){return h}get move(){return E}get copy(){return R}}}),define(fe[106],me([0,1,50,8,9,26]),function(Y,e,g,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(i){const I=(0,F.dirname)(i);if(i===I)return i;const a=((0,F.basename)(i)||i).toLowerCase();try{const h=(0,S.readdirSync)(I).filter(w=>w.toLowerCase()===a);if(h.length===1){const w=P(I);if(w)return(0,F.join)(w,h[0])}else if(h.length>1){const w=h.indexOf(a);if(w>=0){const D=P(I);if(D)return(0,F.join)(D,h[w])}}}catch(p){}return null}e.realcaseSync=P;async function _(i){try{return await S.Promises.realpath(i)}catch(I){const a=k(i);return await S.Promises.access(a,g.constants.R_OK),a}}e.realpath=_;function y(i){try{return g.realpathSync(i)}catch(I){const a=k(i);return g.accessSync(a,g.constants.R_OK),a}}e.realpathSync=y;function k(i){return(0,C.rtrim)((0,F.normalize)(i),F.sep)}});var Ve=this&&this.__decorate||function(Y,e,g,F){var C=arguments.length,S=C<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,g):F,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(Y,e,g,F);else for(var _=Y.length-1;_>=0;_--)(P=Y[_])&&(S=(C<3?P(S):C>3?P(e,g,S):P(e,g))||S);return C>3&&S&&Object.defineProperty(e,g,S),S};define(fe[107],me([0,1,18,15,22,21,60,17,3,6,62,9,12]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function h(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function D(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var T;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(T||(T={}));class b{constructor(O){this.buffer=O,this.pos=0}read(O){const W=this.buffer.slice(this.pos,this.pos+O);return this.pos+=W.byteLength,W}}class l{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var o;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(o||(o={}));function v(z){const O=C.VSBuffer.alloc(4);return O.writeUInt32BE(z,0),O}function n(z){return z.read(4).readUInt32BE(0)}function f(z){const O=C.VSBuffer.alloc(1);return O.writeUInt8(z,0),O}const r={Undefined:f(o.Undefined),String:f(o.String),Buffer:f(o.Buffer),VSBuffer:f(o.VSBuffer),Array:f(o.Array),Object:f(o.Object)},t=typeof Buffer!="undefined";function d(z,O){if(typeof O=="undefined")z.write(r.Undefined);else if(typeof O=="string"){const W=C.VSBuffer.fromString(O);z.write(r.String),z.write(v(W.byteLength)),z.write(W)}else if(t&&Buffer.isBuffer(O)){const W=C.VSBuffer.wrap(O);z.write(r.Buffer),z.write(v(W.byteLength)),z.write(W)}else if(O instanceof C.VSBuffer)z.write(r.VSBuffer),z.write(v(O.byteLength)),z.write(O);else if(Array.isArray(O)){z.write(r.Array),z.write(v(O.length));for(const W of O)d(z,W)}else{const W=C.VSBuffer.fromString(JSON.stringify(O));z.write(r.Object),z.write(v(W.byteLength)),z.write(W)}}function s(z){switch(z.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return z.read(n(z)).toString();case o.Buffer:return z.read(n(z)).buffer;case o.VSBuffer:return z.read(n(z));case o.Array:{const W=n(z),$=[];for(let X=0;X<W;X++)$.push(s(z));return $}case o.Object:return JSON.parse(z.read(n(z)).toString())}}class c{constructor(O,W,$=null,X=1e3){this.protocol=O,this.ctx=W,this.logger=$,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(O,W){this.channels.set(O,W),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const W=this.send([O.type]);this.logger&&this.logger.logOutgoing(W,0,1,D(O.type));return}case 201:case 202:case 204:case 203:{const W=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(W,O.id,1,D(O.type),O.data);return}}}send(O,W=void 0){const $=new l;return d($,O),d($,W),this.sendBuffer($.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(W){return 0}}onRawMessage(O){const W=new b(O),$=s(W),X=s(W),K=$[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,$[1],1,`${h(K)}: ${$[2]}.${$[3]}`,X),this.onPromise({type:K,id:$[1],channelName:$[2],name:$[3],arg:X});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,$[1],1,`${h(K)}: ${$[2]}.${$[3]}`,X),this.onEventListen({type:K,id:$[1],channelName:$[2],name:$[3],arg:X});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,$[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:$[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,$[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:$[1]})}}onPromise(O){const W=this.channels.get(O.channelName);if(!W){this.collectPendingRequest(O);return}const $=new S.CancellationTokenSource;let X;try{X=W.call(this.ctx,O.name,O.arg,$.token)}catch(_e){X=Promise.reject(_e)}const K=O.id;X.then(_e=>{this.sendResponse({id:K,data:_e,type:201}),this.activeRequests.delete(O.id)},_e=>{_e instanceof Error?this.sendResponse({id:K,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:K,data:_e,type:203}),this.activeRequests.delete(O.id)});const de=(0,k.toDisposable)(()=>$.cancel());this.activeRequests.set(O.id,de)}onEventListen(O){const W=this.channels.get(O.channelName);if(!W){this.collectPendingRequest(O);return}const $=O.id,K=W.listen(this.ctx,O.name,O.arg)(de=>this.sendResponse({id:$,data:de,type:204}));this.activeRequests.set(O.id,K)}disposeActiveRequest(O){const W=this.activeRequests.get(O.id);W&&(W.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let W=this.pendingRequests.get(O.channelName);W||(W=[],this.pendingRequests.set(O.channelName,W));const $=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:O,timeoutTimer:$})}flushPendingRequests(O){const W=this.pendingRequests.get(O);if(W){for(const $ of W)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var m;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class u{constructor(O,W=null){this.protocol=O,this.isDisposed=!1,this.state=T.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=W}getChannel(O){const W=this;return{call($,X,K){return W.isDisposed?Promise.reject(_.canceled()):W.requestPromise(O,$,X,K)},listen($,X){return W.isDisposed?Promise.reject(_.canceled()):W.requestEvent(O,$,X)}}}requestPromise(O,W,$,X=S.CancellationToken.None){const K=this.lastRequestId++,_e={id:K,type:100,channelName:O,name:W,arg:$};if(X.isCancellationRequested)return Promise.reject(_.canceled());let Ce;return new Promise((Be,$e)=>{if(X.isCancellationRequested)return $e(_.canceled());const He=()=>{const ce=Z=>{switch(Z.type){case 201:this.handlers.delete(K),Be(Z.data);break;case 202:this.handlers.delete(K);const re=new Error(Z.data.message);re.stack=Z.data.stack,re.name=Z.data.name,$e(re);break;case 203:this.handlers.delete(K),$e(Z.data);break}};this.handlers.set(K,ce),this.sendRequest(_e)};let G=null;this.state===T.Idle?He():(G=(0,F.createCancelablePromise)(ce=>this.whenInitialized()),G.then(()=>{G=null,He()}));const ee=()=>{G?(G.cancel(),G=null):this.sendRequest({id:K,type:101}),$e(_.canceled())},te=X.onCancellationRequested(ee);Ce=(0,k.combinedDisposable)((0,k.toDisposable)(ee),te),this.activeRequests.add(Ce)}).finally(()=>{this.activeRequests.delete(Ce)})}requestEvent(O,W,$){const X=this.lastRequestId++,de={id:X,type:102,channelName:O,name:W,arg:$};let _e=null;const Ce=new y.Emitter({onFirstListenerAdd:()=>{_e=(0,F.createCancelablePromise)(Be=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(Ce),this.sendRequest(de)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(Ce),this.sendRequest({id:X,type:103}))}}),Pe=Be=>Ce.fire(Be.data);return this.handlers.set(X,Pe),Ce.event}sendRequest(O){switch(O.type){case 100:case 102:{const W=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(W,O.id,0,`${h(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const W=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(W,O.id,0,h(O.type));return}}}send(O,W=void 0){const $=new l;return d($,O),d($,W),this.sendBuffer($.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(W){return 0}}onBuffer(O){const W=new b(O),$=s(W),X=s(W),K=$[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,D(K)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,$[1],0,D(K),X),this.onResponse({type:$[0],id:$[1],data:X})}}onResponse(O){if(O.type===200){this.state=T.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(O.id);W&&W(O)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===T.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}Ve([P.memoize],u.prototype,"onDidInitializePromise",null),e.ChannelClient=u;class E{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:W,onDidClientDisconnect:$})=>{y.Event.once(W.onMessage)(K=>{const de=new b(K),_e=s(de),Ce=new c(W,_e),Pe=new u(W);this.channels.forEach(($e,He)=>Ce.registerChannel(He,$e));const Be={channelServer:Ce,channelClient:Pe,ctx:_e};this._connections.add(Be),this._onDidAddConnection.fire(Be),$(()=>{Ce.dispose(),Pe.dispose(),this._connections.delete(Be),this._onDidRemoveConnection.fire(Be)})})})}get connections(){const O=[];return this._connections.forEach(W=>O.push(W)),O}getChannel(O,W){const $=this;return{call(X,K,de){let _e;if((0,a.isFunction)(W)){let Pe=(0,g.getRandomElement)($.connections.filter(W));_e=Pe?Promise.resolve(Pe):y.Event.toPromise(y.Event.filter($.onDidAddConnection,W))}else _e=W.routeCall($,X,K);const Ce=_e.then(Pe=>Pe.channelClient.getChannel(O));return L(Ce).call(X,K,de)},listen(X,K){if((0,a.isFunction)(W))return $.getMulticastEvent(O,W,X,K);const de=W.routeEvent($,X,K).then(_e=>_e.channelClient.getChannel(O));return L(de).listen(X,K)}}}getMulticastEvent(O,W,$,X){const K=this;let de=new k.DisposableStore;const _e=new y.Emitter({onFirstListenerAdd:()=>{de=new k.DisposableStore;const Ce=new y.EventMultiplexer,Pe=new Map,Be=He=>{const ee=He.channelClient.getChannel(O).listen($,X),te=Ce.add(ee);Pe.set(He,te)},$e=He=>{const G=Pe.get(He);!G||(G.dispose(),Pe.delete(He))};K.connections.filter(W).forEach(Be),y.Event.filter(K.onDidAddConnection,W)(Be,void 0,de),K.onDidRemoveConnection($e,void 0,de),Ce.event(_e.fire,_e,de),de.add(Ce)},onLastListenerRemove:()=>{de.dispose()}});return _e.event}registerChannel(O,W){this.channels.set(O,W),this._connections.forEach($=>{$.channelServer.registerChannel(O,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class R{constructor(O,W,$=null){const X=new l;d(X,W),O.send(X.buffer),this.channelClient=new u(O,$),this.channelServer=new c(O,W,$)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,W){this.channelServer.registerChannel(O,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function L(z){return{call(O,W,$){return z.then(X=>X.call(O,W,$))},listen(O,W){const $=new y.Relay;return z.then(X=>$.input=X.listen(O,W)),$.event}}}e.getDelayedChannel=L;function M(z){let O=!1;return{call(W,$,X){return O?z.call(W,$,X):(0,F.timeout)(0).then(()=>O=!0).then(()=>z.call(W,$,X))},listen(W,$){if(O)return z.listen(W,$);const X=new y.Relay;return(0,F.timeout)(0).then(()=>O=!0).then(()=>X.input=z.listen(W,$)),X.event}}}e.getNextTickChannel=M;class A{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const W of O.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await y.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=A;var B;(function(z){function O(K,de){const _e=K,Ce=de&&de.disableMarshalling,Pe=new Map;for(const Be in _e)$(Be)&&Pe.set(Be,y.Event.buffer(_e[Be],!0));return new class{listen(Be,$e,He){const G=Pe.get($e);if(G)return G;if(X($e)){const ee=_e[$e];if(typeof ee=="function")return ee.call(_e,He)}throw new Error(`Event not found: ${$e}`)}call(Be,$e,He){const G=_e[$e];if(typeof G=="function"){if(!Ce&&Array.isArray(He))for(let ee=0;ee<He.length;ee++)He[ee]=(0,i.revive)(He[ee]);return G.apply(_e,He)}throw new Error(`Method not found: ${$e}`)}}}z.fromService=O;function W(K,de){const _e=de&&de.disableMarshalling;return new Proxy({},{get(Ce,Pe){if(typeof Pe=="string")return de?.properties?.has(Pe)?de.properties.get(Pe):X(Pe)?function(Be){return K.listen(Pe,Be)}:$(Pe)?K.listen(Pe):async function(...Be){let $e;de&&!(0,a.isUndefinedOrNull)(de.context)?$e=[de.context,...Be]:$e=Be;const He=await K.call(Pe,$e);return _e?He:(0,i.revive)(He)};throw new Error(`Property not found: ${String(Pe)}`)}})}z.toService=W;function $(K){return K[0]==="o"&&K[1]==="n"&&I.isUpperAsciiLetter(K.charCodeAt(2))}function X(K){return/^onDynamic/.test(K)&&I.isUpperAsciiLetter(K.charCodeAt(9))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let O=z.toString();if(O!=="[object Object]")return O}return z}function j(z){return Array.isArray(z)?z.map(N):N(z)}function U(z,O,W,$,X,K,de){de=j(de);const _e=V[X],Ce=_e[$%_e.length];let Pe=[`%c[${z}]%c[${String(O).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String($).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${Ce}`];/\($/.test(K)?(Pe=Pe.concat(de),Pe.push(")")):Pe.push(de),console.log.apply(console,Pe)}e.logWithColors=U;class x{constructor(O,W){this._outgoingPrefix=O,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,W,$,X,K){this._totalOutgoing+=O,U(this._outgoingPrefix,this._totalOutgoing,O,W,$,X,K)}logIncoming(O,W,$,X,K){this._totalIncoming+=O,U(this._incomingPrefix,this._totalIncoming,O,W,$,X,K)}}e.IPCLogger=x}),define(fe[108],me([0,1,22,3,6,11,38,107]),function(Y,e,g,F,C,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var y;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let k=null;function i(){return k||(k=g.VSBuffer.alloc(0)),k}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,d){if(t===0)return i();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const u=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=t),u}if(this._chunks[0].byteLength>t){const u=this._chunks[0].slice(0,t);return d&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),u}let s=g.VSBuffer.alloc(t),c=0,m=0;for(;t>0;){const u=this._chunks[m];if(u.byteLength>t){const E=u.slice(0,t);s.set(E,c),c+=t,d&&(this._chunks[m]=u.slice(t),this._totalLength-=t),t-=t}else s.set(u,c),c+=u.byteLength,d?(this._chunks.shift(),this._totalLength-=u.byteLength):m++,t-=u.byteLength}return s}}e.ChunkStream=I;var a;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(a||(a={}));var p;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(t,d,s,c){this.type=t,this.id=d,this.ack=s,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends C.Disposable{constructor(t){super();this._onMessage=this._register(new F.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5);else{const s=this._state.messageType,c=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(s,c,m,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class D{constructor(t){this._isDisposed=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(t){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=g.VSBuffer.alloc(13);d.writeUInt8(t.type,0),d.writeUInt32BE(t.id,1),d.writeUInt32BE(t.ack,5),d.writeUInt32BE(t.data.byteLength,9),this._writeSoon(d,t.data)}_bufferAdd(t,d){const s=this._totalLength===0;return this._data.push(t,d),this._totalLength+=t.byteLength+d.byteLength,s}_bufferTake(){const t=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,d){this._bufferAdd(t,d)&&S.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class T extends C.Disposable{constructor(t){super();this._onMessage=new F.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new D(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===1&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new h(1,0,0,t))}}e.Protocol=T;class b extends _.IPCClient{constructor(t,d,s=null){super(t,d,s);this.protocol=t}static fromSocket(t,d){return new b(new T(t),d)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=b;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new F.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class o{constructor(t){this.data=t,this.next=null}}class v{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let t=[],d=0,s=this._first;for(;s;)t[d++]=s.data,s=s.next;return t}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const d=new o(t);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class n{constructor(){this.lastRuns=[];const t=Date.now();for(let d=0;d<n._HISTORY_LENGTH;d++)this.lastRuns[d]=t-1e3*d;setInterval(()=>{for(let d=n._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const t=Date.now(),d=(1+n._HISTORY_LENGTH)*1e3;let s=0;for(let c=0;c<n._HISTORY_LENGTH;c++)t-this.lastRuns[c]<=d&&s++;return 1-s/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class f{constructor(t,d=null,s=n.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=s,this._isReconnecting=!1,this._outgoingUnackMsg=new v,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=t,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),d&&this._socketReader.acceptChunk(d),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new h(5,0,0,i());this._socketWriter.write(t),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const t=Date.now()-this._socketWriter.lastWriteTime;if(t>=5e3){const d=new h(4,0,0,i());this._socketWriter.write(d),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-t+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const t=Date.now()-this._socketReader.lastReadTime;if(t>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-t,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,d){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=t,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(s=>this._onSocketClose.fire(s))),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1;const t=this._outgoingUnackMsg.toArray();for(let d=0,s=t.length;d<s;d++)this._socketWriter.write(t[d]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(t.type===1){if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new h(6,0,0,i())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data)}else if(t.type===2)this._onControlMessage.fire(t.data);else if(t.type===5)this._onDidDispose.fire();else if(t.type===6){const d=this._outgoingUnackMsg.toArray();for(let s=0,c=d.length;s<c;s++)this._socketWriter.write(d[s]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const s=new h(1,d,this._incomingAckId,t);this._outgoingUnackMsg.push(s),this._isReconnecting||(this._socketWriter.write(s),this._recvAckCheck())}sendControl(t){const d=new h(2,0,0,t);this._socketWriter.write(d)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),d=Date.now()-t.writtenTime;if(d>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-d,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new h(3,0,this._incomingAckId,i());this._socketWriter.write(t)}}e.PersistentProtocol=f}),define(fe[109],me([0,1,98]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class F{constructor(_){let y=(0,g.toUint8)(_);this._defaultValue=y,this._asciiMap=F._createAsciiMap(y),this._map=new Map}static _createAsciiMap(_){let y=new Uint8Array(256);for(let k=0;k<256;k++)y[k]=_;return y}set(_,y){let k=(0,g.toUint8)(y);_>=0&&_<256?this._asciiMap[_]=k:this._map.set(_,k)}get(_){return _>=0&&_<256?this._asciiMap[_]:this._map.get(_)||this._defaultValue}}e.CharacterClassifier=F;var C;(function(P){P[P.False=0]="False",P[P.True=1]="True"})(C||(C={}));class S{constructor(){this._actual=new F(0)}add(_){this._actual.set(_,1)}has(_){return this._actual.get(_)===1}}e.CharacterSet=S}),define(fe[145],me([0,1,109]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(P){P[P.Regular=0]="Regular",P[P.Whitespace=1]="Whitespace",P[P.WordSeparator=2]="WordSeparator"})(F=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends g.CharacterClassifier{constructor(_){super(0);for(let y=0,k=_.length;y<k;y++)this.set(_.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function S(P){let _={};return y=>(_.hasOwnProperty(y)||(_[y]=P(y)),_[y])}e.getMapForWordSeparators=S(P=>new C(P))}),define(fe[51],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(C,S){this.lineNumber=C,this.column=S}with(C=this.lineNumber,S=this.column){return C===this.lineNumber&&S===this.column?this:new g(C,S)}delta(C=0,S=0){return this.with(this.lineNumber+C,this.column+S)}equals(C){return g.equals(this,C)}static equals(C,S){return!C&&!S?!0:!!C&&!!S&&C.lineNumber===S.lineNumber&&C.column===S.column}isBefore(C){return g.isBefore(this,C)}static isBefore(C,S){return C.lineNumber<S.lineNumber?!0:S.lineNumber<C.lineNumber?!1:C.column<S.column}isBeforeOrEqual(C){return g.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,S){return C.lineNumber<S.lineNumber?!0:S.lineNumber<C.lineNumber?!1:C.column<=S.column}static compare(C,S){let P=C.lineNumber|0,_=S.lineNumber|0;if(P===_){let y=C.column|0,k=S.column|0;return y-k}return P-_}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new g(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=g}),define(fe[42],me([0,1,51]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class F{constructor(S,P,_,y){S>_||S===_&&P>y?(this.startLineNumber=_,this.startColumn=y,this.endLineNumber=S,this.endColumn=P):(this.startLineNumber=S,this.startColumn=P,this.endLineNumber=_,this.endColumn=y)}isEmpty(){return F.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return F.containsPosition(this,S)}static containsPosition(S,P){return!(P.lineNumber<S.startLineNumber||P.lineNumber>S.endLineNumber||P.lineNumber===S.startLineNumber&&P.column<S.startColumn||P.lineNumber===S.endLineNumber&&P.column>S.endColumn)}containsRange(S){return F.containsRange(this,S)}static containsRange(S,P){return!(P.startLineNumber<S.startLineNumber||P.endLineNumber<S.startLineNumber||P.startLineNumber>S.endLineNumber||P.endLineNumber>S.endLineNumber||P.startLineNumber===S.startLineNumber&&P.startColumn<S.startColumn||P.endLineNumber===S.endLineNumber&&P.endColumn>S.endColumn)}strictContainsRange(S){return F.strictContainsRange(this,S)}static strictContainsRange(S,P){return!(P.startLineNumber<S.startLineNumber||P.endLineNumber<S.startLineNumber||P.startLineNumber>S.endLineNumber||P.endLineNumber>S.endLineNumber||P.startLineNumber===S.startLineNumber&&P.startColumn<=S.startColumn||P.endLineNumber===S.endLineNumber&&P.endColumn>=S.endColumn)}plusRange(S){return F.plusRange(this,S)}static plusRange(S,P){let _,y,k,i;return P.startLineNumber<S.startLineNumber?(_=P.startLineNumber,y=P.startColumn):P.startLineNumber===S.startLineNumber?(_=P.startLineNumber,y=Math.min(P.startColumn,S.startColumn)):(_=S.startLineNumber,y=S.startColumn),P.endLineNumber>S.endLineNumber?(k=P.endLineNumber,i=P.endColumn):P.endLineNumber===S.endLineNumber?(k=P.endLineNumber,i=Math.max(P.endColumn,S.endColumn)):(k=S.endLineNumber,i=S.endColumn),new F(_,y,k,i)}intersectRanges(S){return F.intersectRanges(this,S)}static intersectRanges(S,P){let _=S.startLineNumber,y=S.startColumn,k=S.endLineNumber,i=S.endColumn,I=P.startLineNumber,a=P.startColumn,p=P.endLineNumber,h=P.endColumn;return _<I?(_=I,y=a):_===I&&(y=Math.max(y,a)),k>p?(k=p,i=h):k===p&&(i=Math.min(i,h)),_>k||_===k&&y>i?null:new F(_,y,k,i)}equalsRange(S){return F.equalsRange(this,S)}static equalsRange(S,P){return!!S&&!!P&&S.startLineNumber===P.startLineNumber&&S.startColumn===P.startColumn&&S.endLineNumber===P.endLineNumber&&S.endColumn===P.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(S){return new g.Position(S.endLineNumber,S.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(S){return new g.Position(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,P){return new F(this.startLineNumber,this.startColumn,S,P)}setStartPosition(S,P){return new F(S,P,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(S){return new F(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}static fromPositions(S,P=S){return new F(S.lineNumber,S.column,P.lineNumber,P.column)}static lift(S){return S?new F(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,P){return!(S.endLineNumber<P.startLineNumber||S.endLineNumber===P.startLineNumber&&S.endColumn<P.startColumn||P.endLineNumber<S.startLineNumber||P.endLineNumber===S.startLineNumber&&P.endColumn<S.startColumn)}static areIntersecting(S,P){return!(S.endLineNumber<P.startLineNumber||S.endLineNumber===P.startLineNumber&&S.endColumn<=P.startColumn||P.endLineNumber<S.startLineNumber||P.endLineNumber===S.startLineNumber&&P.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,P){if(S&&P){const k=S.startLineNumber|0,i=P.startLineNumber|0;if(k===i){const I=S.startColumn|0,a=P.startColumn|0;if(I===a){const p=S.endLineNumber|0,h=P.endLineNumber|0;if(p===h){const w=S.endColumn|0,D=P.endColumn|0;return w-D}return p-h}return I-a}return k-i}return(S?1:0)-(P?1:0)}static compareRangesUsingEnds(S,P){return S.endLineNumber===P.endLineNumber?S.endColumn===P.endColumn?S.startLineNumber===P.startLineNumber?S.startColumn-P.startColumn:S.startLineNumber-P.startLineNumber:S.endColumn-P.endColumn:S.endLineNumber-P.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}}e.Range=F}),define(fe[146],me([0,1,51,42]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(P){P[P.LTR=0]="LTR",P[P.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class S extends F.Range{constructor(_,y,k,i){super(_,y,k,i);this.selectionStartLineNumber=_,this.selectionStartColumn=y,this.positionLineNumber=k,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(_){return S.selectionsEqual(this,_)}static selectionsEqual(_,y){return _.selectionStartLineNumber===y.selectionStartLineNumber&&_.selectionStartColumn===y.selectionStartColumn&&_.positionLineNumber===y.positionLineNumber&&_.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(_,y){return this.getDirection()===0?new S(this.startLineNumber,this.startColumn,_,y):new S(_,y,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(_,y){return this.getDirection()===0?new S(_,y,this.endLineNumber,this.endColumn):new S(this.endLineNumber,this.endColumn,_,y)}static fromPositions(_,y=_){return new S(_.lineNumber,_.column,y.lineNumber,y.column)}static liftSelection(_){return new S(_.selectionStartLineNumber,_.selectionStartColumn,_.positionLineNumber,_.positionColumn)}static selectionsArrEqual(_,y){if(_&&!y||!_&&y)return!1;if(!_&&!y)return!0;if(_.length!==y.length)return!1;for(let k=0,i=_.length;k<i;k++)if(!this.selectionsEqual(_[k],y[k]))return!1;return!0}static isISelection(_){return _&&typeof _.selectionStartLineNumber=="number"&&typeof _.selectionStartColumn=="number"&&typeof _.positionLineNumber=="number"&&typeof _.positionColumn=="number"}static createWithDirection(_,y,k,i,I){return I===0?new S(_,y,k,i):new S(k,i,_,y)}}e.Selection=S}),define(fe[110],me([0,1,25]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var F;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(F=e.OverviewRulerLane||(e.OverviewRulerLane={}));var C;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(C=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var _;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(_=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),this.indentSize=l.tabSize|0,this.insertSpaces=Boolean(l.insertSpaces),this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=Boolean(l.trimAutoWhitespace),this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,g.equals)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class k{constructor(l,o){this._findMatchBrand=void 0,this.range=l,this.matches=o}}e.FindMatch=k;var i;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(i=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var I;(function(b){b[b.Disabled=0]="Disabled",b[b.EnabledForActive=1]="EnabledForActive",b[b.Enabled=2]="Enabled"})(I=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class a{constructor(l,o,v){this.visibleColumn=l,this.className=o,this.horizontalLine=v}}e.IndentGuide=a;class p{constructor(l,o){this.top=l,this.endColumn=o}}e.IndentGuideHorizontalLine=p;var h;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None"})(h=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class D{constructor(l,o,v,n,f,r){this.identifier=l,this.range=o,this.text=v,this.forceMoveMarkers=n,this.isAutoWhitespaceEdit=f,this._isTracked=r}}e.ValidAnnotatedEditOperation=D;class T{constructor(l,o,v){this.reverseEdits=l,this.changes=o,this.trimAutoWhitespaceLineNumbers=v}}e.ApplyEditsResult=T}),define(fe[147],me([0,1,9,145,51,42,110]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const _=999;class y{constructor(l,o,v,n){this.searchString=l,this.isRegex=o,this.matchCase=v,this.wordSeparators=n}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=k(this.searchString):l=this.searchString.indexOf(`
`)>=0;let o=null;try{o=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(n){return null}if(!o)return null;let v=!this.isRegex&&!l;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new i(o,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=y;function k(b){if(!b||b.length===0)return!1;for(let l=0,o=b.length;l<o;l++)if(b.charCodeAt(l)===92){if(l++,l>=o)break;const n=b.charCodeAt(l);if(n===110||n===114||n===87)return!0}return!1}e.isMultilineRegexSource=k;class i{constructor(l,o,v){this.regex=l,this.wordSeparators=o,this.simpleSearch=v}}e.SearchData=i;function I(b,l,o){if(!o)return new P.FindMatch(b,null);let v=[];for(let n=0,f=l.length;n<f;n++)v[n]=l[n];return new P.FindMatch(b,v)}e.createFindMatch=I;class a{constructor(l){let o=[],v=0;for(let n=0,f=l.length;n<f;n++)l.charCodeAt(n)===10&&(o[v++]=n);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(l){const o=this._lineFeedsOffsets;let v=0,n=o.length-1;if(n===-1||l<=o[0])return 0;for(;v<n;){const f=v+((n-v)/2>>0);o[f]>=l?n=f-1:o[f+1]>=l?(v=f,n=f):v=f+1}return v+1}}class p{static findMatches(l,o,v,n,f){const r=o.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(l,v,new T(r.wordSeparators,r.regex),n,f):this._doFindMatchesLineByLine(l,v,r,n,f):[]}static _getMultilineMatchRange(l,o,v,n,f,r){let t,d=0;n?(d=n.findLineFeedCountBeforeOffset(f),t=o+f+d):t=o+f;let s;if(n){let E=n.findLineFeedCountBeforeOffset(f+r.length)-d;s=t+r.length+E}else s=t+r.length;const c=l.getPositionAt(t),m=l.getPositionAt(s);return new S.Range(c.lineNumber,c.column,m.lineNumber,m.column)}static _doFindMatchesMultiline(l,o,v,n,f){const r=l.getOffsetAt(o.getStartPosition()),t=l.getValueInRange(o,1),d=l.getEOL()===`\r
`?new a(t):null,s=[];let c=0,m;for(v.reset(0);m=v.next(t);)if(s[c++]=I(this._getMultilineMatchRange(l,r,t,d,m.index,m[0]),m,n),c>=f)return s;return s}static _doFindMatchesLineByLine(l,o,v,n,f){const r=[];let t=0;if(o.startLineNumber===o.endLineNumber){const s=l.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return t=this._findMatchesInLine(v,s,o.startLineNumber,o.startColumn-1,t,r,n,f),r}const d=l.getLineContent(o.startLineNumber).substring(o.startColumn-1);t=this._findMatchesInLine(v,d,o.startLineNumber,o.startColumn-1,t,r,n,f);for(let s=o.startLineNumber+1;s<o.endLineNumber&&t<f;s++)t=this._findMatchesInLine(v,l.getLineContent(s),s,0,t,r,n,f);if(t<f){const s=l.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);t=this._findMatchesInLine(v,s,o.endLineNumber,0,t,r,n,f)}return r}static _findMatchesInLine(l,o,v,n,f,r,t,d){const s=l.wordSeparators;if(!t&&l.simpleSearch){const u=l.simpleSearch,E=u.length,R=o.length;let L=-E;for(;(L=o.indexOf(u,L+E))!==-1;)if((!s||D(s,o,R,L,E))&&(r[f++]=new P.FindMatch(new S.Range(v,L+1+n,v,L+1+E+n),null),f>=d))return f;return f}const c=new T(l.wordSeparators,l.regex);let m;c.reset(0);do if(m=c.next(o),m&&(r[f++]=I(new S.Range(v,m.index+1+n,v,m.index+1+m[0].length+n),m,t),f>=d))return f;while(m);return f}static findNextMatch(l,o,v,n){const f=o.parseSearchRequest();if(!f)return null;const r=new T(f.wordSeparators,f.regex);return f.regex.multiline?this._doFindNextMatchMultiline(l,v,r,n):this._doFindNextMatchLineByLine(l,v,r,n)}static _doFindNextMatchMultiline(l,o,v,n){const f=new C.Position(o.lineNumber,1),r=l.getOffsetAt(f),t=l.getLineCount(),d=l.getValueInRange(new S.Range(f.lineNumber,f.column,t,l.getLineMaxColumn(t)),1),s=l.getEOL()===`\r
`?new a(d):null;v.reset(o.column-1);let c=v.next(d);return c?I(this._getMultilineMatchRange(l,r,d,s,c.index,c[0]),c,n):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(l,new C.Position(1,1),v,n):null}static _doFindNextMatchLineByLine(l,o,v,n){const f=l.getLineCount(),r=o.lineNumber,t=l.getLineContent(r),d=this._findFirstMatchInLine(v,t,r,o.column,n);if(d)return d;for(let s=1;s<=f;s++){const c=(r+s-1)%f,m=l.getLineContent(c+1),u=this._findFirstMatchInLine(v,m,c+1,1,n);if(u)return u}return null}static _findFirstMatchInLine(l,o,v,n,f){l.reset(n-1);const r=l.next(o);return r?I(new S.Range(v,r.index+1,v,r.index+1+r[0].length),r,f):null}static findPreviousMatch(l,o,v,n){const f=o.parseSearchRequest();if(!f)return null;const r=new T(f.wordSeparators,f.regex);return f.regex.multiline?this._doFindPreviousMatchMultiline(l,v,r,n):this._doFindPreviousMatchLineByLine(l,v,r,n)}static _doFindPreviousMatchMultiline(l,o,v,n){const f=this._doFindMatchesMultiline(l,new S.Range(1,1,o.lineNumber,o.column),v,n,10*_);if(f.length>0)return f[f.length-1];const r=l.getLineCount();return o.lineNumber!==r||o.column!==l.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(l,new C.Position(r,l.getLineMaxColumn(r)),v,n):null}static _doFindPreviousMatchLineByLine(l,o,v,n){const f=l.getLineCount(),r=o.lineNumber,t=l.getLineContent(r).substring(0,o.column-1),d=this._findLastMatchInLine(v,t,r,n);if(d)return d;for(let s=1;s<=f;s++){const c=(f+r-s-1)%f,m=l.getLineContent(c+1),u=this._findLastMatchInLine(v,m,c+1,n);if(u)return u}return null}static _findLastMatchInLine(l,o,v,n){let f=null,r;for(l.reset(0);r=l.next(o);)f=I(new S.Range(v,r.index+1,v,r.index+1+r[0].length),r,n);return f}}e.TextModelSearch=p;function h(b,l,o,v,n){if(v===0)return!0;const f=l.charCodeAt(v-1);if(b.get(f)!==0||f===13||f===10)return!0;if(n>0){const r=l.charCodeAt(v);if(b.get(r)!==0)return!0}return!1}function w(b,l,o,v,n){if(v+n===o)return!0;const f=l.charCodeAt(v+n);if(b.get(f)!==0||f===13||f===10)return!0;if(n>0){const r=l.charCodeAt(v+n-1);if(b.get(r)!==0)return!0}return!1}function D(b,l,o,v,n){return h(b,l,o,v,n)&&w(b,l,o,v,n)}e.isValidMatch=D;class T{constructor(l,o){this._wordSeparators=l,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const o=l.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(v=this._searchRegex.exec(l),!v))return null;const n=v.index,f=v[0].length;if(n===this._prevMatchStartIndex&&f===this._prevMatchLength){if(f===0){g.getNextCodePoint(l,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=n,this._prevMatchLength=f,!this._wordSeparators||D(this._wordSeparators,l,o,n,f))return v}while(v);return null}}e.Searcher=T}),define(fe[111],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(_=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)_.indexOf(k)>=0||(y+="\\"+k);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=g();function F(_){let y=e.DEFAULT_WORD_REGEXP;if(_&&_ instanceof RegExp)if(_.global)y=_;else{let k="g";_.ignoreCase&&(k+="i"),_.multiline&&(k+="m"),_.unicode&&(k+="u"),y=new RegExp(_.source,k)}return y.lastIndex=0,y}e.ensureValidWordDefinition=F;const C={maxLen:1e3,windowSize:15,timeBudget:150};function S(_,y,k,i,I=C){if(k.length>I.maxLen){let D=_-I.maxLen/2;return D<0?D=0:i+=D,k=k.substring(D,_+I.maxLen/2),S(_,y,k,i,I)}const a=Date.now(),p=_-1-i;let h=-1,w=null;for(let D=1;!(Date.now()-a>=I.timeBudget);D++){const T=p-I.windowSize*D;y.lastIndex=Math.max(0,T);const b=P(y,k,p,h);if(!b&&w||(w=b,T<=0))break;h=T}if(w){let D={word:w[0],startColumn:i+1+w.index,endColumn:i+1+w.index+w[0].length};return y.lastIndex=0,D}return null}e.getWordAtText=S;function P(_,y,k,i){let I;for(;I=_.exec(y);){const a=I.index||0;if(a<=k&&_.lastIndex>=k)return I;if(i>0&&a>i)return null}return null}}),define(fe[148],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class F{constructor(_){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=_.open,this.close=_.close,this._standardTokenMask=0,Array.isArray(_.notIn))for(let y=0,k=_.notIn.length;y<k;y++)switch(_.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(_){return(this._standardTokenMask&_)==0}}e.StandardAutoClosingPairConditional=F;class C{constructor(_){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of _)S(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),S(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),S(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),S(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&S(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=C;function S(P,_,y){P.has(_)?P.get(_).push(y):P.set(_,[y])}}),define(fe[82],me([0,1,30,8]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(S,P,_,y){if(Array.isArray(S)){let k=0;for(const i of S){const I=C(i,P,_,y);if(I===10)return I;I>k&&(k=I)}return k}else{if(typeof S=="string")return y?S==="*"?5:S===_?10:0:0;if(S){const{language:k,pattern:i,scheme:I,hasAccessToAllModels:a}=S;if(!y&&!a)return 0;let p=0;if(I)if(I===P.scheme)p=10;else if(I==="*")p=5;else return 0;if(k)if(k===_)p=10;else if(k==="*")p=Math.max(p,5);else return 0;if(i){let h;if(typeof i=="string"?h=i:h={...i,base:(0,F.normalize)(i.base)},h===P.fsPath||(0,g.match)(h,P.fsPath))p=10;else return 0}return p}else return 0}}e.score=C}),define(fe[149],me([0,1,109]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var F;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(F=e.State||(e.State={}));class C{constructor(h,w,D){const T=new Uint8Array(h*w);for(let b=0,l=h*w;b<l;b++)T[b]=D;this._data=T,this.rows=h,this.cols=w}get(h,w){return this._data[h*this.cols+w]}set(h,w,D){this._data[h*this.cols+w]=D}}e.Uint8Matrix=C;class S{constructor(h){let w=0,D=0;for(let b=0,l=h.length;b<l;b++){let[o,v,n]=h[b];v>w&&(w=v),o>D&&(D=o),n>D&&(D=n)}w++,D++;let T=new C(D,w,0);for(let b=0,l=h.length;b<l;b++){let[o,v,n]=h[b];T.set(o,v,n)}this._states=T,this._maxCharCode=w}nextState(h,w){return w<0||w>=this._maxCharCode?0:this._states.get(h,w)}}e.StateMachine=S;let P=null;function _(){return P===null&&(P=new S([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),P}var y;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let k=null;function i(){if(k===null){k=new g.CharacterClassifier(0);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<p.length;w++)k.set(p.charCodeAt(w),1);const h=".,;";for(let w=0;w<h.length;w++)k.set(h.charCodeAt(w),2)}return k}class I{static _createLink(h,w,D,T,b){let l=b-1;do{const o=w.charCodeAt(l);if(h.get(o)!==2)break;l--}while(l>T);if(T>0){const o=w.charCodeAt(T-1),v=w.charCodeAt(l);(o===40&&v===41||o===91&&v===93||o===123&&v===125)&&l--}return{range:{startLineNumber:D,startColumn:T+1,endLineNumber:D,endColumn:l+2},url:w.substring(T,l+1)}}static computeLinks(h,w=_()){const D=i();let T=[];for(let b=1,l=h.getLineCount();b<=l;b++){const o=h.getLineContent(b),v=o.length;let n=0,f=0,r=0,t=1,d=!1,s=!1,c=!1,m=!1;for(;n<v;){let u=!1;const E=o.charCodeAt(n);if(t===13){let R;switch(E){case 40:d=!0,R=0;break;case 41:R=d?0:1;break;case 91:c=!0,s=!0,R=0;break;case 93:c=!1,R=s?0:1;break;case 123:m=!0,R=0;break;case 125:R=m?0:1;break;case 39:R=r===34||r===96?0:1;break;case 34:R=r===39||r===96?0:1;break;case 96:R=r===39||r===34?0:1;break;case 42:R=r===42?1:0;break;case 124:R=r===124?1:0;break;case 32:R=c?0:1;break;default:R=D.get(E)}R===1&&(T.push(I._createLink(D,o,b,f,n)),u=!0)}else if(t===12){let R;E===91?(s=!0,R=0):R=D.get(E),R===1?u=!0:t=13}else t=w.nextState(t,E),t===0&&(u=!0);u&&(t=1,d=!1,s=!1,m=!1,f=n+1,r=E),n++}t===13&&T.push(I._createLink(D,o,b,f,v))}return T}}e.LinkComputer=I;function a(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:I.computeLinks(p)}e.computeLinks=a}),define(fe[150],me([0,1,3,6]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,_){return this._map.set(P,_),this.fire([P]),(0,F.toDisposable)(()=>{this._map.get(P)===_&&(this._map.delete(P),this.fire([P]))})}registerPromise(P,_){let y=null,k=!1;return this._promises.set(P,_.then(i=>{this._promises.delete(P),!(k||!i)&&(y=this.register(P,i))})),(0,F.toDisposable)(()=>{k=!0,y&&y.dispose()})}getPromise(P){const _=this.get(P);if(_)return Promise.resolve(_);const y=this._promises.get(P);return y?y.then(k=>this.get(P)):null}get(P){return this._map.get(P)||null}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(fe[112],me([0,1,22,11]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(C||(C={}));function S(I){for(let a=0,p=I.length;a<p;a+=4){const h=I[a+0],w=I[a+1],D=I[a+2],T=I[a+3];I[a+0]=T,I[a+1]=D,I[a+2]=w,I[a+3]=h}}function P(I){const a=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return F.isLittleEndian()||S(a),g.VSBuffer.wrap(a)}function _(I){const a=I.buffer;if(F.isLittleEndian()||S(a),a.byteOffset%4==0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const p=new Uint8Array(a.byteLength);return p.set(a),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function y(I){const a=new Uint32Array(k(I));let p=0;if(a[p++]=I.id,I.type==="full")a[p++]=1,a[p++]=I.data.length,a.set(I.data,p),p+=I.data.length;else{a[p++]=2,a[p++]=I.deltas.length;for(const h of I.deltas)a[p++]=h.start,a[p++]=h.deleteCount,h.data?(a[p++]=h.data.length,a.set(h.data,p),p+=h.data.length):a[p++]=0}return P(a)}e.encodeSemanticTokensDto=y;function k(I){let a=0;if(a+=1+1,I.type==="full")a+=1+I.data.length;else{a+=1,a+=(1+1+1)*I.deltas.length;for(const p of I.deltas)p.data&&(a+=p.data.length)}return a}function i(I){const a=_(I);let p=0;const h=a[p++];if(a[p++]===1){const b=a[p++],l=a.subarray(p,p+b);return p+=b,{id:h,type:"full",data:l}}const D=a[p++];let T=[];for(let b=0;b<D;b++){const l=a[p++],o=a[p++],v=a[p++];let n;v>0&&(n=a.subarray(p,p+v),p+=v),T[b]={start:l,deleteCount:o,data:n}}return{id:h,type:"delta",deltas:T}}e.decodeSemanticTokensDto=i}),define(fe[113],me([0,1,98]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class F{constructor(P,_){this._prefixSumIndexOfResultBrand=void 0,this.index=P,this.remainder=_}}e.PrefixSumIndexOfResult=F;class C{constructor(P){this.values=P,this.prefixSum=new Uint32Array(P.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(P,_){P=(0,g.toUint32)(P);const y=this.values,k=this.prefixSum,i=_.length;return i===0?!1:(this.values=new Uint32Array(y.length+i),this.values.set(y.subarray(0,P),0),this.values.set(y.subarray(P),P+i),this.values.set(_,P),P-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=P-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(P,_){return P=(0,g.toUint32)(P),_=(0,g.toUint32)(_),this.values[P]===_?!1:(this.values[P]=_,P-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=P-1),!0)}removeValues(P,_){P=(0,g.toUint32)(P),_=(0,g.toUint32)(_);const y=this.values,k=this.prefixSum;if(P>=y.length)return!1;let i=y.length-P;return _>=i&&(_=i),_===0?!1:(this.values=new Uint32Array(y.length-_),this.values.set(y.subarray(0,P),0),this.values.set(y.subarray(P+_),P),this.prefixSum=new Uint32Array(this.values.length),P-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=P-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(P){return P<0?0:(P=(0,g.toUint32)(P),this._getPrefixSum(P))}_getPrefixSum(P){if(P<=this.prefixSumValidIndex[0])return this.prefixSum[P];let _=this.prefixSumValidIndex[0]+1;_===0&&(this.prefixSum[0]=this.values[0],_++),P>=this.values.length&&(P=this.values.length-1);for(let y=_;y<=P;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],P),this.prefixSum[P]}getIndexOf(P){P=Math.floor(P),this.getTotalSum();let _=0,y=this.values.length-1,k=0,i=0,I=0;for(;_<=y;)if(k=_+(y-_)/2|0,i=this.prefixSum[k],I=i-this.values[k],P<I)y=k-1;else if(P>=i)_=k+1;else break;return new F(k,P-I)}}e.PrefixSumComputer=C}),define(fe[151],me([0,1,9,51,113]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class S{constructor(_,y,k,i){this._uri=_,this._lines=y,this._eol=k,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(_){_.eol&&_.eol!==this._eol&&(this._eol=_.eol,this._lineStarts=null);const y=_.changes;for(const k of y)this._acceptDeleteRange(k.range),this._acceptInsertText(new F.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=_.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const _=this._eol.length,y=this._lines.length,k=new Uint32Array(y);for(let i=0;i<y;i++)k[i]=this._lines[i].length+_;this._lineStarts=new C.PrefixSumComputer(k)}}_setLineText(_,y){this._lines[_]=y,this._lineStarts&&this._lineStarts.changeValue(_,this._lines[_].length+this._eol.length)}_acceptDeleteRange(_){if(_.startLineNumber===_.endLineNumber){if(_.startColumn===_.endColumn)return;this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.startLineNumber-1].substring(_.endColumn-1));return}this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.endLineNumber-1].substring(_.endColumn-1)),this._lines.splice(_.startLineNumber,_.endLineNumber-_.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(_.startLineNumber,_.endLineNumber-_.startLineNumber)}_acceptInsertText(_,y){if(y.length===0)return;let k=(0,g.splitLines)(y);if(k.length===1){this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+k[0]+this._lines[_.lineNumber-1].substring(_.column-1));return}k[k.length-1]+=this._lines[_.lineNumber-1].substring(_.column-1),this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+k[0]);let i=new Uint32Array(k.length-1);for(let I=1;I<k.length;I++)this._lines.splice(_.lineNumber+I-1,0,k[I]),i[I-1]=k[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(_.lineNumber,i)}}e.MirrorTextModel=S}),define(fe[152],me([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(fe[153],me([0,1,152]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const F=60,C=F*60,S=C*24,P=S*7,_=S*30,y=S*365;function k(I,a){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,g.localize)(0,null,k(new Date().getTime()+p*1e3,!1));if(p<30)return(0,g.localize)(1,null);let h;return p<F?(h=p,a?h===1?(0,g.localize)(2,null,h):(0,g.localize)(3,null,h):h===1?(0,g.localize)(4,null,h):(0,g.localize)(5,null,h)):p<C?(h=Math.floor(p/F),a?h===1?(0,g.localize)(6,null,h):(0,g.localize)(7,null,h):h===1?(0,g.localize)(8,null,h):(0,g.localize)(9,null,h)):p<S?(h=Math.floor(p/C),a?h===1?(0,g.localize)(10,null,h):(0,g.localize)(11,null,h):h===1?(0,g.localize)(12,null,h):(0,g.localize)(13,null,h)):p<P?(h=Math.floor(p/S),a?h===1?(0,g.localize)(14,null,h):(0,g.localize)(15,null,h):h===1?(0,g.localize)(16,null,h):(0,g.localize)(17,null,h)):p<_?(h=Math.floor(p/P),a?h===1?(0,g.localize)(18,null,h):(0,g.localize)(19,null,h):h===1?(0,g.localize)(20,null,h):(0,g.localize)(21,null,h)):p<y?(h=Math.floor(p/_),a?h===1?(0,g.localize)(22,null,h):(0,g.localize)(23,null,h):h===1?(0,g.localize)(24,null,h):(0,g.localize)(25,null,h)):(h=Math.floor(p/y),a?h===1?(0,g.localize)(26,null,h):(0,g.localize)(27,null,h):h===1?(0,g.localize)(28,null,h):(0,g.localize)(29,null,h))}e.fromNow=k;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(fe[154],me([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(fe[52],me([0,1,18,12,154]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(k,i){return i&&(k.stack||k.stacktrace)?C.localize(0,null,_(k),P(k.stack)||P(k.stacktrace)):_(k)}function P(k){return Array.isArray(k)?k.join(`
`):k}function _(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function y(k=null,i=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const I=g.coalesce(k),a=y(I[0],i);return I.length>1?C.localize(4,null,a,I.length):a}if(F.isString(k))return k;if(k.detail){const I=k.detail;if(I.error)return S(I.error,i);if(I.exception)return S(I.exception,i)}return k.stack?S(k,i):k.message?k.message:C.localize(5,null)}e.toErrorMessage=y}),define(fe[155],me([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(fe[114],me([0,1,39,29,10,25,8,11,38,96,12,144,26,155]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function h(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(n,f){if(_.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};f&&(r.cwd=f);const t=g.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],r);return new Promise(d=>{t.once("error",s=>{d({success:!1,error:s})}),t.once("exit",(s,c)=>{d(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?h(r.status):1})}else if(_.isLinux||_.isMacintosh)try{const r=C.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{g.execFile(r,[n.pid.toString()],{encoding:"utf8",shell:!0},(d,s,c)=>{t(d?{success:!1,error:d}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function D(n){!n||(delete n.DEBUG,_.isMacintosh&&delete n.DYLD_LIBRARY_PATH,_.isLinux&&delete n.LD_PRELOAD)}e.removeDangerousEnvVariables=D;function T(n=y.env){return n.comspec||"cmd.exe"}e.getWindowsShell=T;class b{constructor(f,r,t,d){if(r!==void 0&&t!==void 0&&d!==void 0)this.cmd=f,this.args=r,this.shell=t,this.options=d;else{const s=f;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(y.env).forEach(c=>{s[c]=y.env[c]}),Object.keys(this.options.env).forEach(c=>{s[c]=this.options.env[c]}),this.options.env=s}}getSanitizedCommand(){let f=this.cmd.toLowerCase();const r=f.lastIndexOf(P.sep);return r!==-1&&(f=f.substring(r+1)),b.WellKnowCommands[f]?f:"other"}start(f){return _.isWindows&&(this.options&&this.options.cwd&&F.isUNC(this.options.cwd)||!this.options&&F.isUNC(y.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(r=>{let t,d;const s=new Promise((c,m)=>{t=c,d=m});if(r){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=g.exec(c,this.options,(m,u,E)=>{this.childProcess=null;const R=m;R&&R.killed?d({killed:this.terminateRequested,stdout:u.toString(),stderr:E.toString()}):this.handleExec(t,f,m,u,E)})}else{let c=null;const m=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,t,f,d);const E={terminated:this.terminateRequested};i.isNumber(u)&&(E.cmdCode=u),t(E)};if(this.shell&&_.isWindows){const u=S.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let E=!1,R=!1;const L=[];let M=this.ensureQuotes(this.cmd);L.push(M.value),E=M.quoted,this.args&&this.args.forEach(B=>{M=this.ensureQuotes(B),L.push(M.value),R=R&&M.quoted});const A=["/s","/c"];E?R?A.push('"'+L.join(" ")+'"'):L.length>1?A.push('"'+L[0]+'" '+L.slice(1).join(" ")):A.push('"'+L[0]+'"'):A.push(L.join(" ")),c=g.spawn(T(),A,u)}else this.cmd&&(c=g.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(i.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",u=>{this.childProcess=null,d({terminated:this.terminateRequested,error:u})}),c.pid&&(this.childProcess.on("close",m),this.handleSpawn(c,t,f,d,!0)))}return s})}handleClose(f,r,t,d){}ensureQuotes(f){return b.regexp.test(f)?{value:'"'+f+'"',quoted:!0}:{value:f,quoted:f.length>0&&f[0]==='"'&&f[f.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(f=>f.pid,f=>-1):new Promise(f=>{this.pidResolve=f})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(f=>(this.terminateRequested=!0,w(f,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),f=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(f=>{if(!this.shell||!_.isWindows)return f(!1);const r=g.spawn(T(),["/s","/c"]);r.on("error",t=>f(!0)),r.on("exit",t=>f(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class l extends b{constructor(f,r,t,d){super(f,r,t,d);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(f,r,t,d,s){[d,s].forEach((c,m)=>{const u=new I.LineDecoder;u.write(c).forEach(L=>{r({line:L,source:m===0?0:1})});const R=u.end();R&&r({line:R,source:m===0?0:1})}),f({terminated:this.terminateRequested,error:t})}handleSpawn(f,r,t,d,s){const c=new I.LineDecoder,m=new I.LineDecoder;f.stdout.on("data",u=>{c.write(u).forEach(R=>t({line:R,source:0}))}),f.stderr.on("data",u=>{m.write(u).forEach(R=>t({line:R,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=m}handleClose(f,r,t,d){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&t({line:s,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=l;function o(n){let f=[],r=!1;const t=function(d){if(r){f.push(d);return}(!n.send(d,c=>{if(c&&console.error(c),r=!1,f.length>0){const m=f.slice(0);f=[],m.forEach(u=>t(u))}})||_.isWindows)&&(r=!0)};return{send:t}}e.createQueuedSender=o;var v;(function(n){async function f(r,t,d){if(P.isAbsolute(r))return r;if(t===void 0&&(t=y.cwd()),P.dirname(r)!=="."||(d===void 0&&i.isString(y.env.PATH)&&(d=y.env.PATH.split(P.delimiter)),d===void 0||d.length===0))return P.join(t,r);async function c(m){if(await a.Promises.exists(m)){let u;try{u=await a.Promises.stat(m)}catch(E){E.message.startsWith("EACCES")&&(u=await a.Promises.lstat(m))}return u?!u.isDirectory():!1}return!1}for(let m of d){let u;if(P.isAbsolute(m)?u=P.join(m,r):u=P.join(t,m,r),await c(u))return u;let E=u+".com";if(await c(E)||(E=u+".exe",await c(E)))return E}return P.join(t,r)}n.findExecutable=f})(v=e.win32||(e.win32={}))}),define(fe[156],me([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(fe[115],me([0,1,156,11,111]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=P;class _{constructor(){this._values=[]}_read(se){return this._values[se]}get(se){return this._values[se]}_write(se,Ee){this._values[se]=Ee}}e.ValidatedEditorOptions=_;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class k{constructor(se,Ee,Qe,et){this.id=se,this.name=Ee,this.defaultValue=Qe,this.schema=et}compute(se,Ee,Qe){return Qe}}class i{constructor(se,Ee=null){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0,this.deps=Ee}validate(se){return this.defaultValue}}class I{constructor(se,Ee,Qe,et){this.id=se,this.name=Ee,this.defaultValue=Qe,this.schema=et}validate(se){return typeof se=="undefined"?this.defaultValue:se}compute(se,Ee,Qe){return Qe}}function a(J,se){return typeof J=="undefined"?se:J==="false"?!1:Boolean(J)}e.boolean=a;class p extends I{constructor(se,Ee,Qe,et=void 0){typeof et!="undefined"&&(et.type="boolean",et.default=Qe),super(se,Ee,Qe,et)}validate(se){return a(se,this.defaultValue)}}function h(J,se,Ee,Qe){if(typeof J=="undefined")return se;let et=parseInt(J,10);return isNaN(et)?se:(et=Math.max(Ee,et),et=Math.min(Qe,et),et|0)}e.clampedInt=h;class w extends I{constructor(se,Ee,Qe,et,le,Ie=void 0){typeof Ie!="undefined"&&(Ie.type="integer",Ie.default=Qe,Ie.minimum=et,Ie.maximum=le),super(se,Ee,Qe,Ie),this.minimum=et,this.maximum=le}static clampedInt(se,Ee,Qe,et){return h(se,Ee,Qe,et)}validate(se){return w.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class D extends I{constructor(se,Ee,Qe,et,le){typeof le!="undefined"&&(le.type="number",le.default=Qe),super(se,Ee,Qe,le),this.validationFn=et}static clamp(se,Ee,Qe){return se<Ee?Ee:se>Qe?Qe:se}static float(se,Ee){if(typeof se=="number")return se;if(typeof se=="undefined")return Ee;const Qe=parseFloat(se);return isNaN(Qe)?Ee:Qe}validate(se){return this.validationFn(D.float(se,this.defaultValue))}}class T extends I{static string(se,Ee){return typeof se!="string"?Ee:se}constructor(se,Ee,Qe,et=void 0){typeof et!="undefined"&&(et.type="string",et.default=Qe),super(se,Ee,Qe,et)}validate(se){return T.string(se,this.defaultValue)}}function b(J,se,Ee){return typeof J!="string"||Ee.indexOf(J)===-1?se:J}e.stringSet=b;class l extends I{constructor(se,Ee,Qe,et,le=void 0){typeof le!="undefined"&&(le.type="string",le.enum=et,le.default=Qe),super(se,Ee,Qe,le),this._allowedValues=et}validate(se){return b(se,this.defaultValue,this._allowedValues)}}class o extends k{constructor(se,Ee,Qe,et,le,Ie,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.enum=le,Ue.default=et),super(se,Ee,Qe,Ue),this._allowedValues=le,this._convert=Ie}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function v(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ee,Qe){return Qe===0?se.accessibilitySupport:Qe}}class f extends k{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:g.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertSpace:a(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function s(J){switch(J){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=s;function c(J){switch(J){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class m extends i{constructor(){super(126,[65,33])}compute(se,Ee,Qe){const et=["monaco-editor"];return Ee.get(33)&&et.push(Ee.get(33)),se.extraEditorClassName&&et.push(se.extraEditorClassName),Ee.get(65)==="default"?et.push("mouse-default"):Ee.get(65)==="copy"&&et.push("mouse-copy"),Ee.get(99)&&et.push("showUnused"),Ee.get(124)&&et.push("showDeprecated"),et.join(" ")}}class u extends p{constructor(){super(32,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(se,Ee,Qe){return Qe&&se.emptySelectionClipboard}}class E extends k{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:g.localize(16,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:g.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{cursorMoveOnType:a(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":b(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":b(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(Ee.loop,this.defaultValue.loop)}}}class R extends k{constructor(){super(44,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(se){return typeof se=="undefined"?this.defaultValue:typeof se=="string"?se==="false"?R.OFF:se==="true"?R.ON:se:Boolean(se)?R.ON:R.OFF}}e.EditorFontLigatures=R,R.OFF='"liga" off, "calt" off',R.ON='"liga" on, "calt" on';class L extends i{constructor(){super(43)}compute(se,Ee,Qe){return se.fontInfo}}class M extends I{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(se){let Ee=D.float(se,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:D.clamp(Ee,6,100)}compute(se,Ee,Qe){return se.fontInfo.fontSize}}class A extends k{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:A.MINIMUM_VALUE,maximum:A.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:A.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(w.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,A.MINIMUM_VALUE,A.MAXIMUM_VALUE))}}A.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],A.MINIMUM_VALUE=1,A.MAXIMUM_VALUE=1e3;class B extends k{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},Qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),...Ee},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:Qe,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:Qe,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:Qe,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:Qe,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:Qe,description:g.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{multiple:b(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??b(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??b(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??b(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??b(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??b(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:T.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:T.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:T.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:T.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:T.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class V extends k{constructor(){const se={enabled:!0,delay:300,sticky:!0};super(52,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:g.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:a(Ee.enabled,this.defaultValue.enabled),delay:w.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:a(Ee.sticky,this.defaultValue.sticky)}}}var N;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class j extends i{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(se,Ee,Qe){return j.computeLayout(Ee,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const Ee=se.height/se.lineHeight,Qe=se.scrollBeyondLastLine?Ee-1:0,et=(se.viewLineCount+Qe)/(se.pixelRatio*se.height),le=Math.floor(se.viewLineCount/et);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:Qe,desiredRatio:et,minimapLineCount:le}}static _computeMinimapLayout(se,Ee){const Qe=se.outerWidth,et=se.outerHeight,le=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(le*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const Ie=Ee.stableMinimapLayoutInput,Ue=Ie&&se.outerHeight===Ie.outerHeight&&se.lineHeight===Ie.lineHeight&&se.typicalHalfwidthCharacterWidth===Ie.typicalHalfwidthCharacterWidth&&se.pixelRatio===Ie.pixelRatio&&se.scrollBeyondLastLine===Ie.scrollBeyondLastLine&&se.minimap.enabled===Ie.minimap.enabled&&se.minimap.side===Ie.minimap.side&&se.minimap.size===Ie.minimap.size&&se.minimap.showSlider===Ie.minimap.showSlider&&se.minimap.renderCharacters===Ie.minimap.renderCharacters&&se.minimap.maxColumn===Ie.minimap.maxColumn&&se.minimap.scale===Ie.minimap.scale&&se.verticalScrollbarWidth===Ie.verticalScrollbarWidth&&se.isViewportWrapping===Ie.isViewportWrapping,Xe=se.lineHeight,it=se.typicalHalfwidthCharacterWidth,ft=se.scrollBeyondLastLine,tt=se.minimap.renderCharacters;let ut=le>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const Re=se.minimap.maxColumn,De=se.minimap.size,Te=se.minimap.side,oe=se.verticalScrollbarWidth,ue=se.viewLineCount,we=se.remainingWidth,ve=se.isViewportWrapping,Fe=tt?2:3;let Ge=Math.floor(le*et);const ze=Ge/le;let Ye=!1,lt=!1,xe=Fe*ut,ge=ut/le,be=1;if(De==="fill"||De==="fit"){const{typicalViewportLineCount:gt,extraLinesBeyondLastLine:Et,desiredRatio:pt,minimapLineCount:vt}=j.computeContainedMinimapLineCount({viewLineCount:ue,scrollBeyondLastLine:ft,height:et,lineHeight:Xe,pixelRatio:le});if(ue/vt>1)Ye=!0,lt=!0,ut=1,xe=1,ge=ut/le;else{let Dt=!1,Ct=ut+1;if(De==="fit"){const Tt=Math.ceil((ue+Et)*xe);ve&&Ue&&we<=Ee.stableFitRemainingWidth?(Dt=!0,Ct=Ee.stableFitMaxMinimapScale):Dt=Tt>Ge}if(De==="fill"||Dt){Ye=!0;const Tt=ut;xe=Math.min(Xe*le,Math.max(1,Math.floor(1/pt))),ve&&Ue&&we<=Ee.stableFitRemainingWidth&&(Ct=Ee.stableFitMaxMinimapScale),ut=Math.min(Ct,Math.max(1,Math.floor(xe/Fe))),ut>Tt&&(be=Math.min(2,ut/Tt)),ge=ut/le/be,Ge=Math.ceil(Math.max(gt,ue+Et)*xe),ve?(Ee.stableMinimapLayoutInput=se,Ee.stableFitRemainingWidth=we,Ee.stableFitMaxMinimapScale=ut):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const ie=Math.floor(Re*ge),Q=Math.min(ie,Math.max(0,Math.floor((we-oe-2)*ge/(it+ge)))+e.MINIMAP_GUTTER_WIDTH);let Se=Math.floor(le*Q);const Le=Se/le;Se=Math.floor(Se*be);const nt=tt?1:2,qe=Te==="left"?0:Qe-Q-oe;return{renderMinimap:nt,minimapLeft:qe,minimapWidth:Q,minimapHeightIsEditorHeight:Ye,minimapIsSampling:lt,minimapScale:ut,minimapLineHeight:xe,minimapCanvasInnerWidth:Se,minimapCanvasInnerHeight:Ge,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:ze}}static computeLayout(se,Ee){const Qe=Ee.outerWidth|0,et=Ee.outerHeight|0,le=Ee.lineHeight|0,Ie=Ee.lineNumbersDigitCount|0,Ue=Ee.typicalHalfwidthCharacterWidth,Xe=Ee.maxDigitWidth,it=Ee.pixelRatio,ft=Ee.viewLineCount,tt=se.get(121),ut=tt==="inherit"?se.get(120):tt,Re=ut==="inherit"?se.get(116):ut,De=se.get(119),Te=se.get(2),oe=Ee.isDominatedByLongLines,ue=se.get(49),we=se.get(59).renderType!==0,ve=se.get(60),Fe=se.get(93),Ge=se.get(64),ze=se.get(91),Ye=ze.verticalScrollbarSize,lt=ze.verticalHasArrows,xe=ze.arrowSize,ge=ze.horizontalScrollbarSize,be=se.get(57),ie=se.get(37);let Q;if(typeof be=="string"&&/^\d+(\.\d+)?ch$/.test(be)){const Ut=parseFloat(be.substr(0,be.length-2));Q=w.clampedInt(Ut*Ue,0,0,1e3)}else Q=w.clampedInt(be,0,0,1e3);ie&&(Q+=16);let Se=0;if(we){const Ut=Math.max(Ie,ve);Se=Math.round(Ut*Xe)}let Le=0;ue&&(Le=le);let nt=0,qe=nt+Le,gt=qe+Se,Et=gt+Q;const pt=Qe-Le-Se-Q;let vt=!1,wt=!1,Dt=-1;Te!==2&&(ut==="inherit"&&oe?(vt=!0,wt=!0):Re==="on"||Re==="bounded"?wt=!0:Re==="wordWrapColumn"&&(Dt=De));const Ct=j._computeMinimapLayout({outerWidth:Qe,outerHeight:et,lineHeight:le,typicalHalfwidthCharacterWidth:Ue,pixelRatio:it,scrollBeyondLastLine:Fe,minimap:Ge,verticalScrollbarWidth:Ye,viewLineCount:ft,remainingWidth:pt,isViewportWrapping:wt},Ee.memory||new y);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(nt+=Ct.minimapWidth,qe+=Ct.minimapWidth,gt+=Ct.minimapWidth,Et+=Ct.minimapWidth);const Tt=pt-Ct.minimapWidth,Nt=Math.max(1,Math.floor((Tt-Ye-2)/Ue)),It=lt?xe:0;return wt&&(Dt=Math.max(1,Nt),Re==="bounded"&&(Dt=Math.min(Dt,De))),{width:Qe,height:et,glyphMarginLeft:nt,glyphMarginWidth:Le,lineNumbersLeft:qe,lineNumbersWidth:Se,decorationsLeft:gt,decorationsWidth:Q,contentLeft:Et,contentWidth:Tt,minimap:Ct,viewportColumn:Nt,isWordWrapMinified:vt,isViewportWrapping:wt,wrappingColumn:Dt,verticalScrollbarWidth:Ye,horizontalScrollbarHeight:ge,overviewRuler:{top:It,width:Ye,height:et-2*It,right:0}}}}e.EditorLayoutInfoComputer=j;class U extends k{constructor(){const se={enabled:!0};super(56,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:g.localize(42,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:a(se.enabled,this.defaultValue.enabled)}}}class x extends k{constructor(){const se={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",se,{"editor.inlayHints.enabled":{type:"boolean",default:se.enabled,description:g.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:g.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:g.localize(45,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:a(Ee.enabled,this.defaultValue.enabled),fontSize:w.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:T.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class z extends D{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>D.clamp(se,0,150),{markdownDescription:g.localize(46,null)})}compute(se,Ee,Qe){return se.fontInfo.lineHeight}}class O extends k{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:g.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(48,null),g.localize(49,null),g.localize(50,null)],default:se.size,description:g.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:g.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:g.localize(53,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:g.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:g.localize(56,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:a(Ee.enabled,this.defaultValue.enabled),size:b(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(Ee.side,this.defaultValue.side,["right","left"]),showSlider:b(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(Ee.scale,1,1,3),maxColumn:w.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function W(J){return J==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class $ extends k{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{top:w.clampedInt(Ee.top,0,0,1e3),bottom:w.clampedInt(Ee.bottom,0,0,1e3)}}}class X extends k{constructor(){const se={enabled:!0,cycle:!1};super(75,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:g.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:g.localize(60,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:a(Ee.enabled,this.defaultValue.enabled),cycle:a(Ee.cycle,this.defaultValue.cycle)}}}class K extends i{constructor(){super(127)}compute(se,Ee,Qe){return se.pixelRatio}}class de extends k{constructor(){const se={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",se,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:se.strings,description:g.localize(61,null)},comments:{type:"boolean",default:se.comments,description:g.localize(62,null)},other:{type:"boolean",default:se.other,description:g.localize(63,null)}}}],default:se,description:g.localize(64,null)});this.defaultValue=se}validate(se){if(typeof se=="boolean")return se;if(se&&typeof se=="object"){const Ee=se,Qe={other:a(Ee.other,this.defaultValue.other),comments:a(Ee.comments,this.defaultValue.comments),strings:a(Ee.strings,this.defaultValue.strings)};return Qe.other&&Qe.comments&&Qe.strings?!0:!Qe.other&&!Qe.comments&&!Qe.strings?!1:Qe}return this.defaultValue}}var _e;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ce extends k{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(65,null),g.localize(66,null),g.localize(67,null),g.localize(68,null)],default:"on",description:g.localize(69,null)})}validate(se){let Ee=this.defaultValue.renderType,Qe=this.defaultValue.renderFn;return typeof se!="undefined"&&(typeof se=="function"?(Ee=4,Qe=se):se==="interval"?Ee=3:se==="relative"?Ee=2:se==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Qe}}}function Pe(J){const se=J.get(86);return se==="editable"?J.get(80):se!=="on"}e.filterValidationDecorations=Pe;class Be extends k{constructor(){const se=[],Ee={type:"number",description:g.localize(70,null)};super(90,"rulers",se,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:g.localize(71,null),format:"color-hex"}}}]},default:se,description:g.localize(72,null)})}validate(se){if(Array.isArray(se)){let Ee=[];for(let Qe of se)if(typeof Qe=="number")Ee.push({column:w.clampedInt(Qe,0,0,1e4),color:null});else if(Qe&&typeof Qe=="object"){const et=Qe;Ee.push({column:w.clampedInt(et.column,0,0,1e4),color:et.color})}return Ee.sort((Qe,et)=>Qe.column-et.column),Ee}return this.defaultValue}}function $e(J,se){if(typeof J!="string")return se;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class He extends k{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(73,null),g.localize(74,null),g.localize(75,null)],default:"auto",description:g.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(77,null),g.localize(78,null),g.localize(79,null)],default:"auto",description:g.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:g.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:g.localize(83,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se,Qe=w.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=w.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:$e(Ee.vertical,this.defaultValue.vertical),horizontal:$e(Ee.horizontal,this.defaultValue.horizontal),useShadows:a(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Qe,horizontalSliderSize:w.clampedInt(Ee.horizontalSliderSize,Qe,0,1e3),verticalScrollbarSize:et,verticalSliderSize:w.clampedInt(Ee.verticalSliderSize,et,0,1e3),scrollByPage:a(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}class G extends k{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:g.localize(84,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:a(Ee.enabled,this.defaultValue.enabled),mode:b(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends k{constructor(){const se={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,description:g.localize(85,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:a(se.enabled,this.defaultValue.enabled)}}}class te extends k{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],default:se.bracketPairs,description:g.localize(86,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],default:se.bracketPairsHorizontal,description:g.localize(87,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:g.localize(88,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:g.localize(89,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:se.highlightActiveIndentation,description:g.localize(90,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{bracketPairs:ce(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ce(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:a(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ce(J,se,Ee){const Qe=Ee.indexOf(J);return Qe===-1?se:Ee[Qe]}class Z extends k{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(91,null),g.localize(92,null)],default:se.insertMode,description:g.localize(93,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:g.localize(94,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:g.localize(95,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:g.localize(96,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:g.localize(97,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:g.localize(98,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:g.localize(99,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:g.localize(100,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:g.localize(101,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(102,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(103,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(104,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(105,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(106,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertMode:b(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:a(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:a(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:a(Ee.preview,this.defaultValue.preview),previewMode:b(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(Ee.showMethods,this.defaultValue.showMethods),showFunctions:a(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:a(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(Ee.showDeprecated,this.defaultValue.showDeprecated),showFields:a(Ee.showFields,this.defaultValue.showFields),showVariables:a(Ee.showVariables,this.defaultValue.showVariables),showClasses:a(Ee.showClasses,this.defaultValue.showClasses),showStructs:a(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:a(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:a(Ee.showModules,this.defaultValue.showModules),showProperties:a(Ee.showProperties,this.defaultValue.showProperties),showEvents:a(Ee.showEvents,this.defaultValue.showEvents),showOperators:a(Ee.showOperators,this.defaultValue.showOperators),showUnits:a(Ee.showUnits,this.defaultValue.showUnits),showValues:a(Ee.showValues,this.defaultValue.showValues),showConstants:a(Ee.showConstants,this.defaultValue.showConstants),showEnums:a(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:a(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(Ee.showKeywords,this.defaultValue.showKeywords),showWords:a(Ee.showWords,this.defaultValue.showWords),showColors:a(Ee.showColors,this.defaultValue.showColors),showFiles:a(Ee.showFiles,this.defaultValue.showFiles),showReferences:a(Ee.showReferences,this.defaultValue.showReferences),showFolders:a(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:a(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:a(Ee.showUsers,this.defaultValue.showUsers),showIssues:a(Ee.showIssues,this.defaultValue.showIssues)}}}class re extends k{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(133,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class pe extends i{constructor(){super(128,[80])}compute(se,Ee,Qe){return Ee.get(80)?!0:se.tabFocusMode}}var Me;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(Me=e.WrappingIndent||(e.WrappingIndent={}));function je(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Ke extends i{constructor(){super(130,[129])}compute(se,Ee,Qe){const et=Ee.get(129);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}const Ze="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?rt:F.isLinux?ct:Ze,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(J){return e.editorOptionsRegistry[J.id]=J,J}var at;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.emptySelectionClipboard=32]="emptySelectionClipboard",J[J.extraEditorClassName=33]="extraEditorClassName",J[J.fastScrollSensitivity=34]="fastScrollSensitivity",J[J.find=35]="find",J[J.fixedOverflowWidgets=36]="fixedOverflowWidgets",J[J.folding=37]="folding",J[J.foldingStrategy=38]="foldingStrategy",J[J.foldingHighlight=39]="foldingHighlight",J[J.foldingImportsByDefault=40]="foldingImportsByDefault",J[J.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=42]="fontFamily",J[J.fontInfo=43]="fontInfo",J[J.fontLigatures=44]="fontLigatures",J[J.fontSize=45]="fontSize",J[J.fontWeight=46]="fontWeight",J[J.formatOnPaste=47]="formatOnPaste",J[J.formatOnType=48]="formatOnType",J[J.glyphMargin=49]="glyphMargin",J[J.gotoLocation=50]="gotoLocation",J[J.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",J[J.hover=52]="hover",J[J.inDiffEditor=53]="inDiffEditor",J[J.inlineSuggest=54]="inlineSuggest",J[J.letterSpacing=55]="letterSpacing",J[J.lightbulb=56]="lightbulb",J[J.lineDecorationsWidth=57]="lineDecorationsWidth",J[J.lineHeight=58]="lineHeight",J[J.lineNumbers=59]="lineNumbers",J[J.lineNumbersMinChars=60]="lineNumbersMinChars",J[J.linkedEditing=61]="linkedEditing",J[J.links=62]="links",J[J.matchBrackets=63]="matchBrackets",J[J.minimap=64]="minimap",J[J.mouseStyle=65]="mouseStyle",J[J.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=67]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",J[J.multiCursorModifier=69]="multiCursorModifier",J[J.multiCursorPaste=70]="multiCursorPaste",J[J.occurrencesHighlight=71]="occurrencesHighlight",J[J.overviewRulerBorder=72]="overviewRulerBorder",J[J.overviewRulerLanes=73]="overviewRulerLanes",J[J.padding=74]="padding",J[J.parameterHints=75]="parameterHints",J[J.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",J[J.quickSuggestions=78]="quickSuggestions",J[J.quickSuggestionsDelay=79]="quickSuggestionsDelay",J[J.readOnly=80]="readOnly",J[J.renameOnType=81]="renameOnType",J[J.renderControlCharacters=82]="renderControlCharacters",J[J.renderFinalNewline=83]="renderFinalNewline",J[J.renderLineHighlight=84]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=86]="renderValidationDecorations",J[J.renderWhitespace=87]="renderWhitespace",J[J.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",J[J.roundedSelection=89]="roundedSelection",J[J.rulers=90]="rulers",J[J.scrollbar=91]="scrollbar",J[J.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=93]="scrollBeyondLastLine",J[J.scrollPredominantAxis=94]="scrollPredominantAxis",J[J.selectionClipboard=95]="selectionClipboard",J[J.selectionHighlight=96]="selectionHighlight",J[J.selectOnLineNumbers=97]="selectOnLineNumbers",J[J.showFoldingControls=98]="showFoldingControls",J[J.showUnused=99]="showUnused",J[J.snippetSuggestions=100]="snippetSuggestions",J[J.smartSelect=101]="smartSelect",J[J.smoothScrolling=102]="smoothScrolling",J[J.stickyTabStops=103]="stickyTabStops",J[J.stopRenderingLineAfter=104]="stopRenderingLineAfter",J[J.suggest=105]="suggest",J[J.suggestFontSize=106]="suggestFontSize",J[J.suggestLineHeight=107]="suggestLineHeight",J[J.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",J[J.suggestSelection=109]="suggestSelection",J[J.tabCompletion=110]="tabCompletion",J[J.tabIndex=111]="tabIndex",J[J.unusualLineTerminators=112]="unusualLineTerminators",J[J.useShadowDOM=113]="useShadowDOM",J[J.useTabStops=114]="useTabStops",J[J.wordSeparators=115]="wordSeparators",J[J.wordWrap=116]="wordWrap",J[J.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=119]="wordWrapColumn",J[J.wordWrapOverride1=120]="wordWrapOverride1",J[J.wordWrapOverride2=121]="wordWrapOverride2",J[J.wrappingIndent=122]="wrappingIndent",J[J.wrappingStrategy=123]="wrappingStrategy",J[J.showDeprecated=124]="showDeprecated",J[J.inlayHints=125]="inlayHints",J[J.editorClassName=126]="editorClassName",J[J.pixelRatio=127]="pixelRatio",J[J.tabFocusMode=128]="tabFocusMode",J[J.layoutInfo=129]="layoutInfo",J[J.wrappingInfo=130]="wrappingInfo"})(at=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new p(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(134,null)})),acceptSuggestionOnEnter:ye(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(135,null),""],markdownDescription:g.localize(136,null)})),accessibilitySupport:ye(new n),accessibilityPageSize:ye(new w(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(137,null)})),ariaLabel:ye(new T(4,"ariaLabel",g.localize(138,null))),autoClosingBrackets:ye(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(139,null),g.localize(140,null),""],description:g.localize(141,null)})),autoClosingDelete:ye(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(142,null),""],description:g.localize(143,null)})),autoClosingOvertype:ye(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(144,null),""],description:g.localize(145,null)})),autoClosingQuotes:ye(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(146,null),g.localize(147,null),""],description:g.localize(148,null)})),autoIndent:ye(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[g.localize(149,null),g.localize(150,null),g.localize(151,null),g.localize(152,null),g.localize(153,null)],description:g.localize(154,null)})),automaticLayout:ye(new p(10,"automaticLayout",!1)),autoSurround:ye(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(155,null),g.localize(156,null),g.localize(157,null),""],description:g.localize(158,null)})),bracketPairColorization:ye(new ee),bracketPairGuides:ye(new te),stickyTabStops:ye(new p(103,"stickyTabStops",!1,{description:g.localize(159,null)})),codeLens:ye(new p(14,"codeLens",!0,{description:g.localize(160,null)})),codeLensFontFamily:ye(new T(15,"codeLensFontFamily","",{description:g.localize(161,null)})),codeLensFontSize:ye(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(162,null)})),colorDecorators:ye(new p(17,"colorDecorators",!0,{description:g.localize(163,null)})),columnSelection:ye(new p(18,"columnSelection",!1,{description:g.localize(164,null)})),comments:ye(new f),contextmenu:ye(new p(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new p(21,"copyWithSyntaxHighlighting",!0,{description:g.localize(165,null)})),cursorBlinking:ye(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:g.localize(166,null)})),cursorSmoothCaretAnimation:ye(new p(23,"cursorSmoothCaretAnimation",!1,{description:g.localize(167,null)})),cursorStyle:ye(new o(24,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:g.localize(168,null)})),cursorSurroundingLines:ye(new w(25,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(169,null)})),cursorSurroundingLinesStyle:ye(new l(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(170,null),g.localize(171,null)],description:g.localize(172,null)})),cursorWidth:ye(new w(27,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(173,null)})),disableLayerHinting:ye(new p(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new p(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new p(30,"domReadOnly",!1)),dragAndDrop:ye(new p(31,"dragAndDrop",!0,{description:g.localize(174,null)})),emptySelectionClipboard:ye(new u),extraEditorClassName:ye(new T(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new D(34,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:g.localize(175,null)})),find:ye(new E),fixedOverflowWidgets:ye(new p(36,"fixedOverflowWidgets",!1)),folding:ye(new p(37,"folding",!0,{description:g.localize(176,null)})),foldingStrategy:ye(new l(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(177,null),g.localize(178,null)],description:g.localize(179,null)})),foldingHighlight:ye(new p(39,"foldingHighlight",!0,{description:g.localize(180,null)})),foldingImportsByDefault:ye(new p(40,"foldingImportsByDefault",!1,{description:g.localize(181,null)})),unfoldOnClickAfterEndOfLine:ye(new p(41,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(182,null)})),fontFamily:ye(new T(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(183,null)})),fontInfo:ye(new L),fontLigatures2:ye(new R),fontSize:ye(new M),fontWeight:ye(new A),formatOnPaste:ye(new p(47,"formatOnPaste",!1,{description:g.localize(184,null)})),formatOnType:ye(new p(48,"formatOnType",!1,{description:g.localize(185,null)})),glyphMargin:ye(new p(49,"glyphMargin",!0,{description:g.localize(186,null)})),gotoLocation:ye(new B),hideCursorInOverviewRuler:ye(new p(51,"hideCursorInOverviewRuler",!1,{description:g.localize(187,null)})),hover:ye(new V),inDiffEditor:ye(new p(53,"inDiffEditor",!1)),letterSpacing:ye(new D(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>D.clamp(J,-5,20),{description:g.localize(188,null)})),lightbulb:ye(new U),lineDecorationsWidth:ye(new I(57,"lineDecorationsWidth",10)),lineHeight:ye(new z),lineNumbers:ye(new Ce),lineNumbersMinChars:ye(new w(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new p(61,"linkedEditing",!1,{description:g.localize(189,null)})),links:ye(new p(62,"links",!0,{description:g.localize(190,null)})),matchBrackets:ye(new l(63,"matchBrackets","always",["always","near","never"],{description:g.localize(191,null)})),minimap:ye(new O),mouseStyle:ye(new l(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new D(66,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:g.localize(192,null)})),mouseWheelZoom:ye(new p(67,"mouseWheelZoom",!1,{markdownDescription:g.localize(193,null)})),multiCursorMergeOverlapping:ye(new p(68,"multiCursorMergeOverlapping",!0,{description:g.localize(194,null)})),multiCursorModifier:ye(new o(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],W,{markdownEnumDescriptions:[g.localize(195,null),g.localize(196,null)],markdownDescription:g.localize(197,null)})),multiCursorPaste:ye(new l(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(198,null),g.localize(199,null)],markdownDescription:g.localize(200,null)})),occurrencesHighlight:ye(new p(71,"occurrencesHighlight",!0,{description:g.localize(201,null)})),overviewRulerBorder:ye(new p(72,"overviewRulerBorder",!0,{description:g.localize(202,null)})),overviewRulerLanes:ye(new w(73,"overviewRulerLanes",3,0,3)),padding:ye(new $),parameterHints:ye(new X),peekWidgetDefaultFocus:ye(new l(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(203,null),g.localize(204,null)],description:g.localize(205,null)})),definitionLinkOpensInPeek:ye(new p(77,"definitionLinkOpensInPeek",!1,{description:g.localize(206,null)})),quickSuggestions:ye(new de),quickSuggestionsDelay:ye(new w(79,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(207,null)})),readOnly:ye(new p(80,"readOnly",!1)),renameOnType:ye(new p(81,"renameOnType",!1,{description:g.localize(208,null),markdownDeprecationMessage:g.localize(209,null)})),renderControlCharacters:ye(new p(82,"renderControlCharacters",!1,{description:g.localize(210,null)})),renderFinalNewline:ye(new p(83,"renderFinalNewline",!0,{description:g.localize(211,null)})),renderLineHighlight:ye(new l(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(212,null)],description:g.localize(213,null)})),renderLineHighlightOnlyWhenFocus:ye(new p(85,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(214,null)})),renderValidationDecorations:ye(new l(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new l(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(215,null),g.localize(216,null),g.localize(217,null),""],description:g.localize(218,null)})),revealHorizontalRightPadding:ye(new w(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new p(89,"roundedSelection",!0,{description:g.localize(219,null)})),rulers:ye(new Be),scrollbar:ye(new He),scrollBeyondLastColumn:ye(new w(92,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(220,null)})),scrollBeyondLastLine:ye(new p(93,"scrollBeyondLastLine",!0,{description:g.localize(221,null)})),scrollPredominantAxis:ye(new p(94,"scrollPredominantAxis",!0,{description:g.localize(222,null)})),selectionClipboard:ye(new p(95,"selectionClipboard",!0,{description:g.localize(223,null),included:F.isLinux})),selectionHighlight:ye(new p(96,"selectionHighlight",!0,{description:g.localize(224,null)})),selectOnLineNumbers:ye(new p(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new l(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(225,null),g.localize(226,null)],description:g.localize(227,null)})),showUnused:ye(new p(99,"showUnused",!0,{description:g.localize(228,null)})),showDeprecated:ye(new p(124,"showDeprecated",!0,{description:g.localize(229,null)})),inlayHints:ye(new x),snippetSuggestions:ye(new l(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(230,null),g.localize(231,null),g.localize(232,null),g.localize(233,null)],description:g.localize(234,null)})),smartSelect:ye(new re),smoothScrolling:ye(new p(102,"smoothScrolling",!1,{description:g.localize(235,null)})),stopRenderingLineAfter:ye(new w(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new Z),inlineSuggest:ye(new G),suggestFontSize:ye(new w(106,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(236,null)})),suggestLineHeight:ye(new w(107,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(237,null)})),suggestOnTriggerCharacters:ye(new p(108,"suggestOnTriggerCharacters",!0,{description:g.localize(238,null)})),suggestSelection:ye(new l(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(239,null),g.localize(240,null),g.localize(241,null)],description:g.localize(242,null)})),tabCompletion:ye(new l(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(243,null),g.localize(244,null),g.localize(245,null)],description:g.localize(246,null)})),tabIndex:ye(new w(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new l(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(247,null),g.localize(248,null),g.localize(249,null)],description:g.localize(250,null)})),useShadowDOM:ye(new p(113,"useShadowDOM",!0)),useTabStops:ye(new p(114,"useTabStops",!0,{description:g.localize(251,null)})),wordSeparators:ye(new T(115,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:g.localize(252,null)})),wordWrap:ye(new l(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(253,null),g.localize(254,null),g.localize(255,null),g.localize(256,null)],description:g.localize(257,null)})),wordWrapBreakAfterCharacters:ye(new T(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new T(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new w(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(258,null)})),wordWrapOverride1:ye(new l(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new l(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new o(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],je,{enumDescriptions:[g.localize(259,null),g.localize(260,null),g.localize(261,null),g.localize(262,null)],description:g.localize(263,null)})),wrappingStrategy:ye(new l(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(264,null),g.localize(265,null)],description:g.localize(266,null)})),editorClassName:ye(new m),pixelRatio:ye(new K),tabFocusMode:ye(new pe),layoutInfo:ye(new j),wrappingInfo:ye(new Ke)}}),define(fe[157],me([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(fe[158],me([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(fe[159],me([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(fe[160],me([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(fe[161],me([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(fe[162],me([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(fe[163],me([19,20]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(fe[164],me([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(fe[165],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(fe[166],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(fe[167],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(fe[168],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(fe[169],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(fe[170],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(fe[171],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(fe[172],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(fe[173],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(fe[174],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(fe[175],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(fe[176],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(fe[177],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(fe[178],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(fe[179],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(fe[180],me([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(fe[181],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(P){P[P.ACTIVATE=1]="ACTIVATE",P[P.RESTORE=2]="RESTORE",P[P.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var F;(function(P){P[P.PICK=0]="PICK",P[P.DISABLED=1]="DISABLED",P[P.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var C;(function(P){P[P.API=0]="API",P[P.USER=1]="USER"})(C=e.EditorOpenContext||(e.EditorOpenContext={}));var S;(function(P){P[P.Center=0]="Center",P[P.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",P[P.NearTop=2]="NearTop",P[P.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(S=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(fe[182],me([0,1,159]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function S(a){return a=a.trim(),a==="*"||F.test(a)}e.isValidVersionStr=S;function P(a){if(!S(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=a.match(F);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=P;function _(a){if(!a)return null;let p=a.majorBase,h=a.majorMustEqual,w=a.minorBase,D=a.minorMustEqual,T=a.patchBase,b=a.patchMustEqual;a.hasCaret&&(p===0||(D=!1),b=!1);let l=0;if(a.preRelease){const o=C.exec(a.preRelease);if(o){const[,v,n,f]=o;l=Date.UTC(Number(v),Number(n)-1,Number(f))}}return{majorBase:p,majorMustEqual:h,minorBase:w,minorMustEqual:D,patchBase:T,patchMustEqual:b,isMinimum:a.hasGreaterEquals,notBefore:l}}e.normalizeVersion=_;function y(a,p,h){let w;typeof a=="string"?w=_(P(a)):w=a;let D;p instanceof Date?D=p.getTime():typeof p=="string"&&(D=new Date(p).getTime());let T;if(typeof h=="string"?T=_(P(h)):T=h,!w||!T)return!1;let b=w.majorBase,l=w.minorBase,o=w.patchBase,v=T.majorBase,n=T.minorBase,f=T.patchBase,r=T.notBefore,t=T.majorMustEqual,d=T.minorMustEqual,s=T.patchMustEqual;return T.isMinimum?b>v?!0:b<v?!1:l>n?!0:l<n||D&&D<r?!1:o>=f:(b===1&&v===0&&(!t||!d||!s)&&(v=1,n=0,f=0,t=!0,d=!1,s=!1),b<v?!1:b>v?!t:l<n?!1:l>n?!d:o<f?!1:o>f?!s:!(D&&D<r))}e.isValidVersion=y;function k(a,p,h,w){return h.isBuiltin||typeof h.main=="undefined"?!0:I(a,p,h.engines.vscode,w)}e.isValidExtensionVersion=k;function i(a,p,h){return a==="*"||I(p,h,a)}e.isEngineValid=i;function I(a,p,h,w=[]){let D=_(P(h));if(!D)return w.push(g.localize(0,null,h)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return w.push(g.localize(1,null,h)),!1}else if(!D.majorMustEqual)return w.push(g.localize(2,null,h)),!1;return y(a,p,D)?!0:(w.push(g.localize(3,null,a,h)),!1)}}),define(fe[116],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(C,S=[],P=!1){this.ctor=C,this.staticArguments=S,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=g}),define(fe[83],me([0,1,116]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function C(P,_,y){_ instanceof g.SyncDescriptor||(_=new g.SyncDescriptor(_,[],y)),F.push([P,_])}e.registerSingleton=C;function S(){return F}e.getSingletonServiceDescriptors=S}),define(fe[183],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=g;class F{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let P of this._nodes.values())P.outgoing.size===0&&S.push(P);return S}insertEdge(S,P){const _=this.lookupOrInsertNode(S),y=this.lookupOrInsertNode(P);_.outgoing.set(this._hashFn(P),y),y.incoming.set(this._hashFn(S),_)}removeNode(S){const P=this._hashFn(S);this._nodes.delete(P);for(let _ of this._nodes.values())_.outgoing.delete(P),_.incoming.delete(P)}lookupOrInsertNode(S){const P=this._hashFn(S);let _=this._nodes.get(P);return _||(_=new g(S),this._nodes.set(P,_)),_}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[P,_]of this._nodes)S.push(`${P}, (incoming)[${[..._.incoming.keys()].join(", ")}], (outgoing)[${[..._.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,P]of this._nodes){const _=new Set([S]),y=this._findCycle(P,_);if(y)return y}}_findCycle(S,P){for(let[_,y]of S.outgoing){if(P.has(_))return[...P,_].join(" -> ");P.add(_);const k=this._findCycle(y,P);if(k)return k;P.delete(_)}}}e.Graph=F}),define(fe[4],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function y(k){return k[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=y})(g=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function F(_,y,k,i){y[g.DI_TARGET]===y?y[g.DI_DEPENDENCIES].push({id:_,index:k,optional:i}):(y[g.DI_DEPENDENCIES]=[{id:_,index:k,optional:i}],y[g.DI_TARGET]=y)}function C(_){if(g.serviceIds.has(_))return g.serviceIds.get(_);const y=function(k,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(y,k,I,!1)};return y.toString=()=>_,g.serviceIds.set(_,y),y}e.createDecorator=C;function S(_){return _}e.refineServiceDecorator=S;function P(_){return function(y,k,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");F(_,y,i,!0)}}e.optional=P}),define(fe[184],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function F(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(fe[185],me([0,1,3,48,6,24,78,82,184]),function(Y,e,g,F,C,S,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(w){return typeof w=="string"?!1:Array.isArray(w)?w.every(k):!!w.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(D,T){let b={selector:D,provider:T,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,C.toDisposable)(()=>{if(b){let l=this._entries.indexOf(b);l>=0&&(this._entries.splice(l,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(D){return this.all(D).length>0}all(D){if(!D)return[];this._updateScores(D);const T=[];for(let b of this._entries)b._score>0&&T.push(b.provider);return T}ordered(D){const T=[];return this._orderedForEach(D,b=>T.push(b.provider)),T}orderedGroups(D){const T=[];let b,l;return this._orderedForEach(D,o=>{b&&l===o._score?b.push(o.provider):(l=o._score,b=[o.provider],T.push(b))}),T}_orderedForEach(D,T){if(!!D){this._updateScores(D);for(const b of this._entries)b._score>0&&T(b)}}_updateScores(D){let T={uri:D.uri.toString(),language:D.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===T.language&&this._lastCandidate.uri===T.uri)){this._lastCandidate=T;for(let b of this._entries)if(b._score=(0,_.score)(b.selector,D.uri,D.getLanguageId(),(0,y.shouldSynchronizeModel)(D)),k(b.selector)&&b._score>0){for(let l of this._entries)l._score=0;b._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(D,T){return D._score<T._score?1:D._score>T._score?-1:D._time<T._time?1:D._time>T._time?-1:0}}e.LanguageFeatureRegistry=i;const I=new WeakMap;let a=0;function p(w){let D=I.get(w);return D===void 0&&(D=++a,I.set(w,D)),D}class h{constructor(D,T,b=Number.MAX_SAFE_INTEGER){this._registry=D,this.min=T,this.max=b,this._cache=new S.LRUCache(50,.7)}_key(D){return D.id+this._registry.all(D).reduce((T,b)=>(0,F.doHash)(p(b),T),0)}_clamp(D){return D===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(D*1.3)))}get(D){const T=this._key(D),b=this._cache.get(T);return this._clamp(b?.value)}update(D,T){const b=this._key(D);let l=this._cache.get(b);return l||(l=new P.MovingAverage,this._cache.set(b,l)),l.update(T),this.get(D)}}e.LanguageFeatureRequestDelays=h}),define(fe[84],me([0,1,2,42,185,150,47]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var _;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(_=e.LanguageId||(e.LanguageId={}));var y;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(y=e.FontStyle||(e.FontStyle={}));var k;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(k=e.ColorId||(e.ColorId={}));var i;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(i=e.StandardTokenType||(e.StandardTokenType={}));var I;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(I=e.MetadataConsts||(e.MetadataConsts={}));class a{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let R=this.getForeground(E),L="mtk"+R,M=this.getFontStyle(E);return M&1&&(L+=" mtki"),M&2&&(L+=" mtkb"),M&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(E,R){const L=this.getForeground(E),M=this.getFontStyle(E);let A=`color: ${R[L]};`;return M&1&&(A+="font-style: italic;"),M&2&&(A+="font-weight: bold;"),M&4&&(A+="text-decoration: underline;"),A}}e.TokenMetadata=a;var p;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(p=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(E){const R=u[E];let L=R&&P.iconRegistry.get(R);return L||(console.info("No codicon found for CompletionItemKind "+E),L=P.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(E,R){let L=u[E];return typeof L=="undefined"&&!R&&(L=9),L}}();var h;(function(u){u[u.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var D;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var T;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(T=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var l;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(l=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var o;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(o=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(u){return u&&g.URI.isUri(u.uri)&&F.Range.isIRange(u.range)&&(F.Range.isIRange(u.originSelectionRange)||F.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=v;var n;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var f;(function(u){u[u.Deprecated=1]="Deprecated"})(f=e.SymbolTag||(e.SymbolTag={}));var r;(function(u){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function L(B){return E.get(B)}u.fromString=L;function M(B){return R.get(B)}u.toString=M;function A(B,V){const N=R.get(B);let j=N&&P.iconRegistry.get("symbol-"+N);return j||(console.info("No codicon found for SymbolKind "+B),j=P.Codicon.symbolProperty),`${V?"inline":"block"} ${j.classNames}`}u.toCssClassName=A})(r=e.SymbolKinds||(e.SymbolKinds={}));class t{constructor(E){this.value=E}}e.FoldingRangeKind=t,t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region");var d;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(d=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var s;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(s=e.CommentMode||(e.CommentMode={}));var c;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new S.TokenizationRegistryImpl;var m;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(m=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(fe[63],me([0,1,11,9,4]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let S=g.userAgent||"";const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",g.isMacintosh),P.set("isLinux",g.isLinux),P.set("isWindows",g.isWindows),P.set("isWeb",g.isWeb),P.set("isMacNative",g.isMacintosh&&!g.isWeb),P.set("isEdge",S.indexOf("Edg/")>=0),P.set("isFirefox",S.indexOf("Firefox")>=0),P.set("isChrome",S.indexOf("Chrome")>=0),P.set("isSafari",S.indexOf("Safari")>=0);const _=Object.prototype.hasOwnProperty;var y;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return a.INSTANCE}static true(){return p.INSTANCE}static has(A){return h.create(A)}static equals(A,B){return w.create(A,B)}static notEquals(A,B){return b.create(A,B)}static regex(A,B){return r.create(A,B)}static in(A,B){return D.create(A,B)}static not(A){return l.create(A)}static and(...A){return s.create(A,null)}static or(...A){return c.create(A,null,!0)}static greater(A,B){return o.create(A,B)}static less(A,B){return n.create(A,B)}static deserialize(A,B=!1){if(!!A)return this._deserializeOrExpression(A,B)}static _deserializeOrExpression(A,B){let V=A.split("||");return c.create(V.map(N=>this._deserializeAndExpression(N,B)),null,!0)}static _deserializeAndExpression(A,B){let V=A.split("&&");return s.create(V.map(N=>this._deserializeOne(N,B)),null)}static _deserializeOne(A,B){if(A=A.trim(),A.indexOf("!=")>=0){let V=A.split("!=");return b.create(V[0].trim(),this._deserializeValue(V[1],B))}if(A.indexOf("==")>=0){let V=A.split("==");return w.create(V[0].trim(),this._deserializeValue(V[1],B))}if(A.indexOf("=~")>=0){let V=A.split("=~");return r.create(V[0].trim(),this._deserializeRegexValue(V[1],B))}if(A.indexOf(" in ")>=0){let V=A.split(" in ");return D.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const V=A.split(">=");return v.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const V=A.split(">");return o.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const V=A.split("<=");return f.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const V=A.split("<");return n.create(V[0].trim(),V[1].trim())}return/^\!\s*/.test(A)?l.create(A.substr(1).trim()):h.create(A)}static _deserializeValue(A,B){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;let V=/^'([^']*)'$/.exec(A);return V?V[1].trim():A}static _deserializeRegexValue(A,B){if((0,F.isFalsyOrWhitespace)(A)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let V=A.indexOf("/"),N=A.lastIndexOf("/");if(V===N||V<0){if(B)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}let j=A.slice(V+1,N),U=A[N+1]==="i"?"i":"";try{return new RegExp(j,U)}catch(x){if(B)throw new Error(`bad regexp-value '${A}', parse error: ${x}`);return console.warn(`bad regexp-value '${A}', parse error: ${x}`),null}}}e.ContextKeyExpr=k;function i(M,A){const B=M?M.substituteConstants():void 0,V=A?A.substituteConstants():void 0;return!B&&!V?!0:!B||!V?!1:B.equals(V)}e.expressionsAreEqualWithConstantSubstitution=i;function I(M,A){return M.cmp(A)}class a{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=a,a.INSTANCE=new a;class p{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return a.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class h{constructor(A,B){this.key=A,this.negated=B,this.type=2}static create(A,B=null){const V=P.get(A);return typeof V=="boolean"?V?p.INSTANCE:a.INSTANCE:new h(A,B)}cmp(A){return A.type!==this.type?this.type-A.type:u(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?p.INSTANCE:a.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class w{constructor(A,B,V){this.key=A,this.value=B,this.negated=V,this.type=4}static create(A,B,V=null){if(typeof B=="boolean")return B?h.create(A,V):l.create(A,V);const N=P.get(A);return typeof N=="boolean"?B===(N?"true":"false")?p.INSTANCE:a.INSTANCE:new w(A,B,V)}cmp(A){return A.type!==this.type?this.type-A.type:E(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const B=A?"true":"false";return this.value===B?p.INSTANCE:a.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class D{constructor(A,B){this.key=A,this.valueKey=B,this.type=10,this.negated=null}static create(A,B){return new D(A,B)}cmp(A){return A.type!==this.type?this.type-A.type:E(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const B=A.getValue(this.valueKey),V=A.getValue(this.key);return Array.isArray(B)?B.indexOf(V)>=0:typeof V=="string"&&typeof B=="object"&&B!==null?_.call(B,V):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=T.create(this)),this.negated}}e.ContextKeyInExpr=D;class T{constructor(A){this._actual=A,this.type=11}static create(A){return new T(A)}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(A){return new T(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotInExpr=T;class b{constructor(A,B,V){this.key=A,this.value=B,this.negated=V,this.type=5}static create(A,B,V=null){if(typeof B=="boolean")return B?l.create(A,V):h.create(A,V);const N=P.get(A);return typeof N=="boolean"?B===(N?"true":"false")?a.INSTANCE:p.INSTANCE:new b(A,B,V)}cmp(A){return A.type!==this.type?this.type-A.type:E(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const B=A?"true":"false";return this.value===B?a.INSTANCE:p.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class l{constructor(A,B){this.key=A,this.negated=B,this.type=3}static create(A,B=null){const V=P.get(A);return typeof V=="boolean"?V?a.INSTANCE:p.INSTANCE:new l(A,B)}cmp(A){return A.type!==this.type?this.type-A.type:u(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?a.INSTANCE:p.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=l;class o{constructor(A,B,V){this.key=A,this.value=B,this.negated=V,this.type=12}static create(A,B,V=null){return new o(A,B,V)}cmp(A){return A.type!==this.type?this.type-A.type:E(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return parseFloat(A.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=o;class v{constructor(A,B,V){this.key=A,this.value=B,this.negated=V,this.type=13}static create(A,B,V=null){return new v(A,B,V)}cmp(A){return A.type!==this.type?this.type-A.type:E(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return parseFloat(A.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=v;class n{constructor(A,B,V){this.key=A,this.value=B,this.negated=V,this.type=14}static create(A,B,V=null){return new n(A,B,V)}cmp(A){return A.type!==this.type?this.type-A.type:E(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return parseFloat(A.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class f{constructor(A,B,V){this.key=A,this.value=B,this.negated=V,this.type=15}static create(A,B,V=null){return new f(A,B,V)}cmp(A){return A.type!==this.type?this.type-A.type:E(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return parseFloat(A.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=f;class r{constructor(A,B){this.key=A,this.regexp=B,this.type=7,this.negated=null}static create(A,B){return new r(A,B)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const B=this.regexp?this.regexp.source:"",V=A.regexp?A.regexp.source:"";return B<V?-1:B>V?1:0}equals(A){if(A.type===this.type){const B=this.regexp?this.regexp.source:"",V=A.regexp?A.regexp.source:"";return this.key===A.key&&B===V}return!1}substituteConstants(){return this}evaluate(A){let B=A.getValue(this.key);return this.regexp?this.regexp.test(B):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=t.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class t{constructor(A){this._actual=A,this.type=8}static create(A){return new t(A)}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(A){return new t(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=t;function d(M){let A=null;for(let B=0,V=M.length;B<V;B++){const N=M[B].substituteConstants();if(M[B]!==N&&A===null){A=[];for(let j=0;j<B;j++)A[j]=M[j]}A!==null&&(A[B]=N)}return A===null?M:A}class s{constructor(A,B){this.expr=A,this.negated=B,this.type=6}static create(A,B){return s._normalizeArr(A,B)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let B=0,V=this.expr.length;B<V;B++){const N=I(this.expr[B],A.expr[B]);if(N!==0)return N}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let B=0,V=this.expr.length;B<V;B++)if(!this.expr[B].equals(A.expr[B]))return!1;return!0}return!1}substituteConstants(){const A=d(this.expr);return A===this.expr?this:s.create(A,this.negated)}evaluate(A){for(let B=0,V=this.expr.length;B<V;B++)if(!this.expr[B].evaluate(A))return!1;return!0}static _normalizeArr(A,B){const V=[];let N=!1;for(const j of A)if(!!j){if(j.type===1){N=!0;continue}if(j.type===0)return a.INSTANCE;if(j.type===6){V.push(...j.expr);continue}V.push(j)}if(V.length===0&&N)return p.INSTANCE;if(V.length!==0){if(V.length===1)return V[0];V.sort(I);for(let j=1;j<V.length;j++)V[j-1].equals(V[j])&&(V.splice(j,1),j--);if(V.length===1)return V[0];for(;V.length>1;){const j=V[V.length-1];if(j.type!==9)break;V.pop();const U=V.pop(),x=V.length===0,z=c.create(j.expr.map(O=>s.create([O,U],null)),null,x);z&&(V.push(z),V.sort(I))}return V.length===1?V[0]:new s(V,B)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(let B of this.expr)A.push(...B.keys());return A}map(A){return new s(this.expr.map(B=>B.map(A)),null)}negate(){if(!this.negated){const A=[];for(let B of this.expr)A.push(B.negate());this.negated=c.create(A,this,!0)}return this.negated}}class c{constructor(A,B){this.expr=A,this.negated=B,this.type=9}static create(A,B,V){return c._normalizeArr(A,B,V)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let B=0,V=this.expr.length;B<V;B++){const N=I(this.expr[B],A.expr[B]);if(N!==0)return N}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let B=0,V=this.expr.length;B<V;B++)if(!this.expr[B].equals(A.expr[B]))return!1;return!0}return!1}substituteConstants(){const A=d(this.expr);return A===this.expr?this:c.create(A,this.negated,!1)}evaluate(A){for(let B=0,V=this.expr.length;B<V;B++)if(this.expr[B].evaluate(A))return!0;return!1}static _normalizeArr(A,B,V){let N=[],j=!1;if(A){for(let U=0,x=A.length;U<x;U++){const z=A[U];if(!!z){if(z.type===0){j=!0;continue}if(z.type===1)return p.INSTANCE;if(z.type===9){N=N.concat(z.expr);continue}N.push(z)}}if(N.length===0&&j)return a.INSTANCE;N.sort(I)}if(N.length!==0){if(N.length===1)return N[0];for(let U=1;U<N.length;U++)N[U-1].equals(N[U])&&(N.splice(U,1),U--);if(N.length===1)return N[0];if(V){for(let U=0;U<N.length;U++)for(let x=U+1;x<N.length;x++)R(N[U],N[x])&&(N.splice(x,1),x--);if(N.length===1)return N[0]}return new c(N,B)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(let B of this.expr)A.push(...B.keys());return A}map(A){return new c(this.expr.map(B=>B.map(A)),null)}negate(){if(!this.negated){let A=[];for(let B of this.expr)A.push(B.negate());for(;A.length>1;){const B=A.shift(),V=A.shift(),N=[];for(const U of L(B))for(const x of L(V))N.push(s.create([U,x],null));const j=A.length===0;A.unshift(c.create(N,null,j))}this.negated=A[0]}return this.negated}}class m extends h{constructor(A,B,V){super(A,null);this._defaultValue=B,typeof V=="object"?m._info.push({...V,key:A}):V!==!0&&m._info.push({key:A,description:V,type:B!=null?typeof B:void 0})}static all(){return m._info.values()}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return w.create(this.key,A)}notEqualsTo(A){return b.create(this.key,A)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,C.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(M,A){return M<A?-1:M>A?1:0}function E(M,A,B,V){return M<B?-1:M>B?1:A<V?-1:A>V?1:0}function R(M,A){if(A.type===6&&M.type!==9&&M.type!==6){for(const N of A.expr)if(M.equals(N))return!0}const B=M.negate(),V=L(B).concat(L(A));V.sort(I);for(let N=0;N<V.length;N++){const U=V[N].negate();for(let x=N+1;x<V.length;x++){const z=V[x];if(U.equals(z))return!0}}return!1}e.implies=R;function L(M){return M.type===9?M.expr:[M]}}),define(fe[186],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(fe[187],me([0,1,10,158,4]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var S;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));function P(b){switch(b){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function _(b){switch(b){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=_;function y(b,l){switch(b){case 3:return l==="x64"?"win32-x64":l==="ia32"?"win32-ia32":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function k(b,l){return l==="web"&&!b.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function i(b,l,o){return k(l,o)?!1:b==="undefined"||b==="universal"?!0:b==="unknown"?!1:b===o?!0:I(o).includes(b)}e.isTargetPlatformCompatible=i;function I(b){switch(b){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function a(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(!b.uuid||typeof b.uuid=="string")}e.isIExtensionIdentifier=a;var p;(function(b){b[b.NoneOrRelevance=0]="NoneOrRelevance",b[b.LastUpdatedDate=1]="LastUpdatedDate",b[b.Title=2]="Title",b[b.PublisherName=3]="PublisherName",b[b.InstallCount=4]="InstallCount",b[b.PublishedDate=10]="PublishedDate",b[b.AverageRating=6]="AverageRating",b[b.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var h;(function(b){b[b.Default=0]="Default",b[b.Ascending=1]="Ascending",b[b.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var w;(function(b){b.Install="install",b.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var D;(function(b){b[b.None=0]="None",b[b.Install=1]="Install",b[b.Update=2]="Update"})(D=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class T extends Error{constructor(l,o){super(l);this.code=o,this.name=o}}e.ExtensionManagementError=T,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,F.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,F.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(fe[188],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(fe[189],me([0,1,39,10,8,11,96,26,114,160,188]),function(Y,e,g,F,C,S,P,_,y,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=k.localize(0,null);class a{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends a{openTerminal(o,v){return this.spawnTerminal(g,o,y.getWindowsShell(),v)}spawnTerminal(o,v,n,f){const r=v.windowsExec||p.getDefaultTerminalWindows();f&&f[1]===":"&&(f=f[0].toUpperCase()+f.substr(1));const t=C.basename(r).toLowerCase();if(t==="cmder"||t==="cmder.exe")return o.spawn(r,f?[f]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return r.indexOf(" ")>=0&&d.push('""'),d.push(r),(t==="wt"||t==="wt.exe")&&d.push("-d ."),new Promise((s,c)=>{const m=D(process),u=o.spawn(n,d,{cwd:f,env:m});u.on("error",c),u.on("exit",()=>s())})}runInTerminal(o,v,n,f,r){const t="windowsExec"in r&&r.windowsExec?r.windowsExec:p.getDefaultTerminalWindows();return new Promise((d,s)=>{const c=`"${v} - ${I}"`,m=`""${n.join('" "')}" & pause"`,u=["/c","start",c,"/wait",t,"/c",m],E=Object.assign({},D(process),f);Object.keys(E).filter(M=>E[M]===null).forEach(M=>delete E[M]);const R={cwd:v,env:E,windowsVerbatimArguments:!0};g.spawn(p.CMD,u,R).on("error",M=>{s(T(M))}),d(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class h extends a{openTerminal(o,v){return this.spawnTerminal(g,o,v)}runInTerminal(o,v,n,f,r){const t=r.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((d,s)=>{if(t===i.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const c=t===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",u=[F.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,Y).fsPath,"-t",o||I,"-w",v];for(let L of n)u.push("-a"),u.push(L);if(f){const L=Object.assign({},D(process),f);for(let M in L){const A=L[M];A===null?(u.push("-u"),u.push(M)):(u.push("-e"),u.push(`${M}=${A}`))}}let E="";const R=g.spawn(h.OSASCRIPT,u);R.on("error",L=>{s(T(L))}),R.stderr.on("data",L=>{E+=L.toString()}),R.on("exit",L=>{if(L===0)d(void 0);else if(E){const M=E.split(`
`,1);s(new Error(M[0]))}else s(new Error(k.localize(1,null,c,L)))})}else s(new Error(k.localize(2,null,t)))})}spawnTerminal(o,v,n){const f=v.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((r,t)=>{const d=["-a",f];n&&d.push(n);const s=D(process),c=o.spawn("/usr/bin/open",d,{cwd:n,env:s});c.on("error",t),c.on("exit",()=>r())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class w extends a{openTerminal(o,v){return this.spawnTerminal(g,o,v)}runInTerminal(o,v,n,f,r){const t=r.linuxExec?Promise.resolve(r.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((d,s)=>{let c=[];t.then(m=>{m.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const u=`${b(n)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;c.push(`''${u}''`);const E=Object.assign({},D(process),f);Object.keys(E).filter(A=>E[A]===null).forEach(A=>delete E[A]);const R={cwd:v,env:E};let L="";const M=g.spawn(m,c,R);M.on("error",A=>{s(T(A))}),M.stderr.on("data",A=>{L+=A.toString()}),M.on("exit",A=>{if(A===0)d(void 0);else if(L){const B=L.split(`
`,1);s(new Error(B[0]))}else s(new Error(k.localize(4,null,m,A)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!S.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await _.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(v=>{o?v("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?v("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?v("konsole"):process.env.COLORTERM?v(process.env.COLORTERM):process.env.TERM?v(process.env.TERM):v("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,v,n){const f=v.linuxExec?Promise.resolve(v.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,t)=>{f.then(d=>{const s=D(process),c=o.spawn(d,[],{cwd:n,env:s});c.on("error",t),c.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=k.localize(3,null);function D(l){const o={...l.env};return(0,P.sanitizeProcessEnvironment)(o),o}function T(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(k.localize(5,null,l.path)):l}function b(l){let o="";for(let v of l)v.indexOf(" ")>=0?o+='"'+v+'"':o+=v,o+=" ";return o}}),define(fe[43],me([0,1,24,8,9,12,2,161,4]),function(Y,e,g,F,C,S,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function k(N){return N.create===!0}e.isFileOpenForWriteOptions=k;var i;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(N){N[N.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var a;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(a=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=p;function h(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=h;function w(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function D(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=D;var T;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(T=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(j,U){super(j);this.code=U}}e.FileSystemProviderError=b;function l(N,j){const U=new b(N.toString(),j);return v(U,j),U}e.createFileSystemProviderError=l;function o(N){return N||l((0,_.localize)(0,null),T.Unknown)}e.ensureFileSystemProviderError=o;function v(N,j){return N.name=j?`${j} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=v;function n(N){if(!N)return T.Unknown;if(N instanceof b)return N.code;const j=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!j)return T.Unknown;switch(j[1]){case T.FileExists:return T.FileExists;case T.FileIsADirectory:return T.FileIsADirectory;case T.FileNotADirectory:return T.FileNotADirectory;case T.FileNotFound:return T.FileNotFound;case T.FileExceedsMemoryLimit:return T.FileExceedsMemoryLimit;case T.FileTooLarge:return T.FileTooLarge;case T.FileWriteLocked:return T.FileWriteLocked;case T.NoPermissions:return T.NoPermissions;case T.Unavailable:return T.Unavailable}return T.Unknown}e.toFileSystemProviderErrorCode=n;function f(N){if(N instanceof m)return N.fileOperationResult;switch(n(N)){case T.FileNotFound:return 1;case T.FileIsADirectory:return 0;case T.FileNotADirectory:return 10;case T.FileWriteLocked:return 5;case T.NoPermissions:return 6;case T.FileExists:return 4;case T.FileExceedsMemoryLimit:return 9;case T.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=f;var r;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class t{constructor(j,U,x){this.resource=j,this.operation=U,this.target=x}isOperation(j){return this.operation===j}}e.FileOperationEvent=t;var d;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(d=e.FileChangeType||(e.FileChangeType={}));class s{constructor(j,U){this.added=void 0,this.updated=void 0,this.deleted=void 0;const x=new Map;for(const z of j){const O=x.get(z.type);O?O.push([z.resource,z]):x.set(z.type,[[z.resource,z]])}for(const[z,O]of x)switch(z){case 1:this.added=g.TernarySearchTree.forUris(()=>U),this.added.fill(O);break;case 0:this.updated=g.TernarySearchTree.forUris(()=>U),this.updated.fill(O);break;case 2:this.deleted=g.TernarySearchTree.forUris(()=>U),this.deleted.fill(O);break}}contains(j,...U){return this.doContains(j,{includeChildren:!1},...U)}affects(j,...U){return this.doContains(j,{includeChildren:!0},...U)}doContains(j,U,...x){if(!j)return!1;const z=x.length>0;return!!((!z||x.includes(1))&&(this.added?.get(j)||U.includeChildren&&this.added?.findSuperstr(j))||(!z||x.includes(0))&&(this.updated?.get(j)||U.includeChildren&&this.updated?.findSuperstr(j))||(!z||x.includes(2))&&(this.deleted?.findSubstr(j)||U.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=s;function c(N,j,U){return!N||!j||N===j||j.length>N.length?!1:(j.charAt(j.length-1)!==F.sep&&(j+=F.sep),U?(0,C.startsWithIgnoreCase)(N,j):N.indexOf(j)===0)}e.isParent=c;class m extends Error{constructor(j,U,x){super(j);this.fileOperationResult=U,this.options=x}}e.FileOperationError=m;class u extends m{constructor(j,U,x){super(j,2,x);this.stat=U}}e.NotModifiedSinceFileOperationError=u;var E;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=L;async function M(N,j){if(!j.hasProvider(P.URI.from({scheme:N.scheme})))return new Promise(U=>{const x=j.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===N.scheme&&z.added&&(x.dispose(),U())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class A{static formatSize(j){return(0,S.isNumber)(j)||(j=0),j<A.KB?(0,_.localize)(1,null,j.toFixed(0)):j<A.MB?(0,_.localize)(2,null,(j/A.KB).toFixed(2)):j<A.GB?(0,_.localize)(3,null,(j/A.MB).toFixed(2)):j<A.TB?(0,_.localize)(4,null,(j/A.GB).toFixed(2)):(0,_.localize)(5,null,(j/A.TB).toFixed(2))}}e.ByteSize=A,A.KB=1024,A.MB=A.KB*A.KB,A.GB=A.MB*A.KB,A.TB=A.GB*A.KB;var B;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function V(N){return{maxFileSize:N===0?300*A.MB:16*A.GB,maxHeapSize:N===0?700*A.MB:2*700*A.MB}}e.getPlatformLimits=V}),define(fe[85],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...C){this._entries=new Map;for(let[S,P]of C)this.set(S,P)}set(C,S){const P=this._entries.get(C);return this._entries.set(C,S),P}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=g}),define(fe[190],me([0,1,15,17,116,183,4,85]),function(Y,e,g,F,C,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class k extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class i{constructor(h=new _.ServiceCollection,w=!1,D){this._activeInstantiations=new Set,this._services=h,this._strict=w,this._parent=D,this._services.set(P.IInstantiationService,this)}createChild(h){return new i(h,this._strict,this)}invokeFunction(h,...w){let D=a.traceInvocation(h),T=!1;try{return h({get:(l,o)=>{if(T)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(l,D);if(!v&&o!==P.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return v}},...w)}finally{T=!0,D.stop()}}createInstance(h,...w){let D,T;return h instanceof C.SyncDescriptor?(D=a.traceCreation(h.ctor),T=this._createInstance(h.ctor,h.staticArguments.concat(w),D)):(D=a.traceCreation(h),T=this._createInstance(h,w,D)),D.stop(),T}_createInstance(h,w=[],D){let T=P._util.getServiceDependencies(h).sort((o,v)=>o.index-v.index),b=[];for(const o of T){let v=this._getOrCreateServiceInstance(o.id,D);if(!v&&this._strict&&!o.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${o.id}.`);b.push(v)}let l=T.length>0?T[0].index:w.length;if(w.length!==l){console.warn(`[createInstance] First service dependency of ${h.name} at position ${l+1} conflicts with ${w.length} static arguments`);let o=l-w.length;o>0?w=w.concat(new Array(o)):w=w.slice(0,l)}return new h(...[...w,...b])}_setServiceInstance(h,w){if(this._services.get(h)instanceof C.SyncDescriptor)this._services.set(h,w);else if(this._parent)this._parent._setServiceInstance(h,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let w=this._services.get(h);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):w}_getOrCreateServiceInstance(h,w){let D=this._getServiceInstanceOrDescriptor(h);return D instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,D,w.branch(h,!0)):(w.branch(h,!1),D)}_safeCreateAndCacheServiceInstance(h,w,D){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,w,D)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,w,D){const T=new S.Graph(o=>o.id.toString());let b=0;const l=[{id:h,desc:w,_trace:D}];for(;l.length;){const o=l.pop();if(T.lookupOrInsertNode(o),b++>1e3)throw new k(T);for(let v of P._util.getServiceDependencies(o.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(v.id);if(!n&&!v.optional&&console.warn(`[createInstance] ${h} depends on ${v.id} which is NOT registered.`),n instanceof C.SyncDescriptor){const f={id:v.id,desc:n,_trace:o._trace.branch(v.id,!0)};T.insertEdge(o,f),l.push(f)}}}for(;;){const o=T.roots();if(o.length===0){if(!T.isEmpty())throw new k(T);break}for(const{data:v}of o){if(this._getServiceInstanceOrDescriptor(v.id)instanceof C.SyncDescriptor){const f=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,f)}T.removeNode(v)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,w,D=[],T,b){if(this._services.get(h)instanceof C.SyncDescriptor)return this._createServiceInstance(w,D,T,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,w,D,T,b);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(h,w=[],D,T){if(D){const b=new g.IdleValue(()=>this._createInstance(h,w,T));return new Proxy(Object.create(null),{get(l,o){if(o in l)return l[o];let v=b.value,n=v[o];return typeof n!="function"||(n=n.bind(v),l[o]=n),n},set(l,o,v){return b.value[o]=v,!0}})}else return this._createInstance(h,w,T)}}e.InstantiationService=i;var I;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(I||(I={}));class a{constructor(h,w){this.type=h,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return y?new a(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):a._None}static traceCreation(h){return y?new a(0,h.name):a._None}branch(h,w){let D=new a(2,h.toString());return this._dep.push([h,w,D]),D}stop(){let h=Date.now()-this._start;a._totals+=h;let w=!1;function D(b,l){let o=[],v=new Array(b+1).join("	");for(const[n,f,r]of l._dep)if(f&&r){w=!0,o.push(`${v}CREATES -> ${n}`);let t=D(b+1,r);t&&o.push(t)}else o.push(`${v}uses -> ${n}`);return o.join(`
`)}let T=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${a._totals.toFixed(2)}ms)`];(h>2||w)&&console.log(T.join(`
`))}}a._None=new class extends a{constructor(){super(-1,null)}stop(){}branch(){return this}},a._totals=0}),define(fe[13],me([0,1,52,3,6,11,4]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function _(){return new Date().toISOString()}var y;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class k extends C.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class i extends k{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...f){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([n,...f]))}debug(n,...f){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([n,...f]))}info(n,...f){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([n,...f]))}warn(n,...f){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([n,...f]))}error(n,...f){if(this.checkLogLevel(y.Error))if(n instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=n.stack,this.log(y.Error,this.format(r))}else this.log(y.Error,this.format([n,...f]))}critical(n,...f){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([n,...f]))}flush(){}format(n){let f="";for(let r=0;r<n.length;r++){let t=n[r];if(typeof t=="object")try{t=JSON.stringify(t)}catch(d){}f+=(r>0?" ":"")+t}return f}}e.AbstractMessageLogger=i;class I extends k{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!S.isWindows}trace(n,...f){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${_()}][0m`,n,...f):console.log(`[main ${_()}]`,n,...f))}debug(n,...f){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${_()}][0m`,n,...f):console.log(`[main ${_()}]`,n,...f))}info(n,...f){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${_()}][0m`,n,...f):console.log(`[main ${_()}]`,n,...f))}warn(n,...f){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${_()}][0m`,n,...f):console.warn(`[main ${_()}]`,n,...f))}error(n,...f){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${_()}][0m`,n,...f):console.error(`[main ${_()}]`,n,...f))}critical(n,...f){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${_()}][0m`,n,...f):console.error(`[main ${_()}]`,n,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class a extends k{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...f){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",n,...f)}debug(n,...f){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...f)}info(n,...f){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",n,...f)}warn(n,...f){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",n,...f)}error(n,...f){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",n,...f)}critical(n,...f){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...f)}dispose(){}flush(){}}e.ConsoleLogger=a;class p extends k{constructor(n,f=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(f)}trace(n,...f){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(n),...f])}debug(n,...f){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(n),...f])}info(n,...f){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(n),...f])}warn(n,...f){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(n),...f])}error(n,...f){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(n),...f])}critical(n,...f){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(n),...f])}extractMessage(n){return typeof n=="string"?n:(0,g.toErrorMessage)(n,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class h extends k{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const f of this.logServices)f.setLevel(n);super.setLevel(n)}trace(n,...f){for(const r of this.logServices)r.trace(n,...f)}debug(n,...f){for(const r of this.logServices)r.debug(n,...f)}info(n,...f){for(const r of this.logServices)r.info(n,...f)}warn(n,...f){for(const r of this.logServices)r.warn(n,...f)}error(n,...f){for(const r of this.logServices)r.error(n,...f)}critical(n,...f){for(const r of this.logServices)r.critical(n,...f)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=h;class w extends C.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...f){this.logger.trace(n,...f)}debug(n,...f){this.logger.debug(n,...f)}info(n,...f){this.logger.info(n,...f)}warn(n,...f){this.logger.warn(n,...f)}error(n,...f){this.logger.error(n,...f)}critical(n,...f){this.logger.critical(n,...f)}flush(){this.logger.flush()}}e.LogService=w;class D extends C.Disposable{constructor(n,f){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(f(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(r))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,f){let r=this.loggers.get(n.toString());return r||(r=this.doCreateLogger(n,f?.always?y.Trace:this.logLevel,f),this.loggers.set(n.toString(),r),f?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class T{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(n){}getLevel(){return y.Info}trace(n,...f){}debug(n,...f){}info(n,...f){}warn(n,...f){}error(n,...f){}critical(n,...f){}dispose(){}flush(){}}e.NullLogService=T;function b(v){if(v.verbose)return y.Trace;if(typeof v.logLevel=="string"){const n=l(v.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function l(v){switch(v){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=l;function o(v){switch(v){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=o}),define(fe[117],me([0,1,43,13]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(y,k,i,I){try{const a=await new Promise((p,h)=>{Y(["spdlog"],p,h)});return a.setFlushOn(F.LogLevel.Trace),a.createAsyncRotatingLogger(y,k,i,I)}catch(a){console.error(a)}return null}function S(y,k,i,I){const a=Y.__$__nodeRequire("spdlog");return a.setFlushOn(F.LogLevel.Trace),a.createRotatingLogger(y,k,i,I)}e.createRotatingLogger=S;function P(y,k,i){switch(k){case F.LogLevel.Trace:y.trace(i);break;case F.LogLevel.Debug:y.debug(i);break;case F.LogLevel.Info:y.info(i);break;case F.LogLevel.Warning:y.warn(i);break;case F.LogLevel.Error:y.error(i);break;case F.LogLevel.Critical:y.critical(i);break;default:throw new Error("Invalid log level")}}class _ extends F.AbstractMessageLogger{constructor(k,i,I,a){super();this.name=k,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(a),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const k=this.rotating?6:1,i=30/k*g.ByteSize.MB;return C(this.name,this.filepath,i,k).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:a,message:p}of this.buffer)P(this._logger,a,p);this.buffer=[]}})}log(k,i){this._logger?P(this._logger,k,i):this.getLevel()<=k&&this.buffer.push({level:k,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=_}),define(fe[118],me([0,1,49,162,4]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(S=e.MarkerTag||(e.MarkerTag={}));var P;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(P=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function k(h,w){return w-h}y.compare=k;const i=Object.create(null);i[y.Error]=(0,F.localize)(0,null),i[y.Warning]=(0,F.localize)(1,null),i[y.Info]=(0,F.localize)(2,null);function I(h){return i[h]||""}y.toString=I;function a(h){switch(h){case g.default.Error:return y.Error;case g.default.Warning:return y.Warning;case g.default.Info:return y.Info;case g.default.Ignore:return y.Hint}}y.fromSeverity=a;function p(h){switch(h){case y.Error:return g.default.Error;case y.Warning:return g.default.Warning;case y.Info:return g.default.Info;case y.Hint:return g.default.Ignore}}y.toSeverity=p}(P=e.MarkerSeverity||(e.MarkerSeverity={}));var _;(function(y){const k="";function i(a){return I(a,!0)}y.makeKey=i;function I(a,p){let h=[k];return a.source?h.push(a.source.replace("\xA6","\\\xA6")):h.push(k),a.code?typeof a.code=="string"?h.push(a.code.replace("\xA6","\\\xA6")):h.push(a.code.value.replace("\xA6","\\\xA6")):h.push(k),a.severity!==void 0&&a.severity!==null?h.push(P.toString(a.severity)):h.push(k),a.message&&p?h.push(a.message.replace("\xA6","\\\xA6")):h.push(k),a.startLineNumber!==void 0&&a.startLineNumber!==null?h.push(a.startLineNumber.toString()):h.push(k),a.startColumn!==void 0&&a.startColumn!==null?h.push(a.startColumn.toString()):h.push(k),a.endLineNumber!==void 0&&a.endLineNumber!==null?h.push(a.endLineNumber.toString()):h.push(k),a.endColumn!==void 0&&a.endColumn!==null?h.push(a.endColumn.toString()):h.push(k),h.push(k),h.join("\xA6")}y.makeKeyOptionalMessage=I})(_=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,C.createDecorator)("markerService")}),define(fe[191],me([0,1,3,49,4]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,C.createDecorator)("notificationService");var S;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(S=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var P;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(P=e.NotificationsFilter||(e.NotificationsFilter={}));class _{constructor(){this.progress=new y,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=_;class y{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=y}),define(fe[192],me([0,1,6,9,2,4]),function(Y,e,g,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,S.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(_){return{resolved:_,dispose(){}}}});function P(_,y){return C.URI.isUri(_)?(0,F.equalsIgnoreCase)(_.scheme,y):(0,F.startsWithIgnoreCase)(_,y+":")}e.matchesScheme=P}),define(fe[193],me([0,1,10,11,38,23]),function(Y,e,g,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof F.globals.vscode!="undefined"&&typeof F.globals.vscode.context!="undefined"){const _=F.globals.vscode.context.configuration();if(_)P=_.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const _=(0,S.dirname)(g.FileAccess.asFileUri("",Y));P=Y.__$__nodeRequire((0,S.joinPath)(_,"product.json").fsPath);const y=Y.__$__nodeRequire((0,S.joinPath)(_,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:y.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=P});var We=this&&this.__param||function(Y,e){return function(g,F){e(g,F,Y)}};define(fe[119],me([0,1,15,21,6,4]),function(Y,e,g,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,S.createDecorator)("progressService");var P;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(P=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class _{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=_,_.None=Object.freeze({report(){}});let y=class extends C.Disposable{constructor(I,a){super();this.deferred=new g.DeferredPromise,a.withProgress(I,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};y=Ve([We(1,e.IProgressService)],y),e.UnmanagedProgress=y;class k extends C.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(I){this.stop();const a=++this.currentOperationId,p=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{a===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:a,token:p.token,stop:()=>this.doStop(a),isCurrent:()=>this.currentOperationId===a}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,S.createDecorator)("editorProgressService")}),define(fe[34],me([0,1,58,12]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(P,_){g.ok(F.isString(P)),g.ok(F.isObject(_)),g.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,_)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new C}),define(fe[120],me([0,1,3,34]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(_){return _.length>0&&_.charAt(_.length-1)==="#"?_.substring(0,_.length-1):_}class S{constructor(){this._onDidChangeSchema=new g.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,k){this.schemasById[C(y)]=k,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new S;F.Registry.add(e.Extensions.JSONContribution,P)}),define(fe[86],me([0,1,18,3,12,157,120,34]),function(Y,e,g,F,C,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=_.Registry.as(P.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(l,o=!0){this.registerConfigurations([l],o)}registerConfigurations(l,o=!0){const v=this.doRegisterConfigurations(l,o);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(l){const o=this.doDeregisterConfigurations(l);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:l,remove:o}){const v=[];v.push(...this.doDeregisterConfigurations(o)),v.push(...this.doRegisterConfigurations(l,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,g.distinct)(v))}registerDefaultConfigurations(l){const o=[],v=[];for(const n of l)for(const f in n)if(o.push(f),e.OVERRIDE_PROPERTY_PATTERN.test(f)){this.defaultValues[f]={...this.defaultValues[f]||{},...n[f]};const r={type:"object",default:this.defaultValues[f],description:S.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId};v.push(p(f)),this.configurationProperties[f]=r,this.defaultLanguageConfigurationOverridesNode.properties[f]=r}else{this.defaultValues[f]=n[f];const r=this.configurationProperties[f];r&&(this.updatePropertyDefaultValue(f,r),this.updateSchema(f,r))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(l){const o=[];for(const v of l)for(const n in v)if(o.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_PATTERN.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const f=this.configurationProperties[n];f&&(this.updatePropertyDefaultValue(n,f),this.updateSchema(n,f))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const o of l)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,o){const v=[];return l.forEach(n=>{v.push(...this.validateAndRegisterProperties(n,o,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),v}doDeregisterConfigurations(l){const o=[],v=n=>{if(n.properties)for(const f in n.properties)o.push(f),delete this.configurationProperties[f],this.removeFromSchema(f,n.properties[f]);n.allOf&&n.allOf.forEach(f=>v(f))};for(const n of l){v(n);const f=this.configurationContributors.indexOf(n);f!==-1&&this.configurationContributors.splice(f,1)}return o}validateAndRegisterProperties(l,o=!0,v,n=3){n=C.isUndefinedOrNull(l.scope)?n:l.scope;let f=[],r=l.properties;if(r)for(let d in r){if(o&&D(d)){delete r[d];continue}const s=r[d];if(this.updatePropertyDefaultValue(d,s),e.OVERRIDE_PROPERTY_PATTERN.test(d)?s.scope=void 0:(s.scope=C.isUndefinedOrNull(s.scope)?n:s.scope,s.restricted=C.isUndefinedOrNull(s.restricted)?!!v?.restrictedConfigurations?.includes(d):s.restricted),r[d].hasOwnProperty("included")&&!r[d].included){this.excludedConfigurationProperties[d]=r[d],delete r[d];continue}else this.configurationProperties[d]=r[d];!r[d].deprecationMessage&&r[d].markdownDeprecationMessage&&(r[d].deprecationMessage=r[d].markdownDeprecationMessage),f.push(d)}let t=l.allOf;if(t)for(let d of t)f.push(...this.validateAndRegisterProperties(d,o,v,n));return f}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(l){const o=v=>{let n=v.properties;if(n)for(const r in n)this.updateSchema(r,n[r]);let f=v.allOf;f&&f.forEach(o)};o(l)}updateSchema(l,o){switch(e.allSettings.properties[l]=o,o.scope){case 1:e.applicationSettings.properties[l]=o;break;case 2:e.machineSettings.properties[l]=o;break;case 6:e.machineOverridableSettings.properties[l]=o;break;case 3:e.windowSettings.properties[l]=o;break;case 4:e.resourceSettings.properties[l]=o;break;case 5:e.resourceSettings.properties[l]=o,this.resourceLanguageSettingsSchema.properties[l]=o;break}}removeFromSchema(l,o){switch(delete e.allSettings.properties[l],o.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const o=`[${l}]`,v={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,v),e.allSettings.properties[o]=v,e.applicationSettings.properties[o]=v,e.machineSettings.properties[o]=v,e.machineOverridableSettings.properties[o]=v,e.windowSettings.properties[o]=v,e.resourceSettings.properties[o]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,o){let v=this.defaultValues[l];C.isUndefined(v)&&(v=o.default),C.isUndefined(v)&&(v=h(o.type)),o.default=v}}const a="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(a);function p(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=p;function h(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const w=new I;_.Registry.add(e.Extensions.Configuration,w);function D(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?S.localize(5,null,b):w.getConfigurationProperties()[b]!==void 0?S.localize(6,null,b):null:S.localize(4,null)}e.validateProperty=D;function T(){const b=[],l=w.getConfigurationProperties();for(const o of Object.keys(l))b.push([o,l[o].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=T}),define(fe[121],me([0,1,25,12,2,86,4,34]),function(Y,e,g,F,C,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function y(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof C.URI)}e.isConfigurationOverrides=y;var k;(function(f){f[f.USER=1]="USER",f[f.USER_LOCAL=2]="USER_LOCAL",f[f.USER_REMOTE=3]="USER_REMOTE",f[f.WORKSPACE=4]="WORKSPACE",f[f.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",f[f.DEFAULT=6]="DEFAULT",f[f.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(f){switch(f){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(f,r){const t=r?f?r.keys.filter(R=>f.keys.indexOf(R)===-1):[...r.keys]:[],d=f?r?f.keys.filter(R=>r.keys.indexOf(R)===-1):[...f.keys]:[],s=[];if(r&&f){for(const R of f.keys)if(r.keys.indexOf(R)!==-1){const L=T(f.contents,R),M=T(r.contents,R);g.equals(L,M)||s.push(R)}}const c=[],m=R=>{const L={};for(const M of R)for(const A of M.identifiers)L[v(A)]=M;return L},u=r?m(r.overrides):{},E=f?m(f.overrides):{};if(Object.keys(u).length)for(const R of t){const L=u[R];L&&c.push([(0,S.overrideIdentifierFromKey)(R),L.keys])}if(Object.keys(E).length)for(const R of d){const L=E[R];L&&c.push([(0,S.overrideIdentifierFromKey)(R),L.keys])}if(Object.keys(u).length&&Object.keys(E).length)for(const R of s){const L=E[R],M=u[R];if(L&&M){const A=I({contents:L.contents,keys:L.keys,overrides:[]},{contents:M.contents,keys:M.keys,overrides:[]});c.push([(0,S.overrideIdentifierFromKey)(R),[...A.added,...A.removed,...A.updated]])}}return{added:t,removed:d,updated:s,overrides:c}}e.compare=I;function a(f,r){const t=[];for(const d of Object.keys(f))if(S.OVERRIDE_PROPERTY_PATTERN.test(d)){const s={};for(const c in f[d])s[c]=f[d][c];t.push({identifiers:[(0,S.overrideIdentifierFromKey)(d).trim()],keys:Object.keys(s),contents:p(s,r)})}return t}e.toOverrides=a;function p(f,r){const t=Object.create(null);for(let d in f)h(t,d,f[d],r);return t}e.toValuesTree=p;function h(f,r,t,d){const s=r.split("."),c=s.pop();let m=f;for(let u=0;u<s.length;u++){let E=s[u],R=m[E];switch(typeof R){case"undefined":R=m[E]=Object.create(null);break;case"object":break;default:d(`Ignoring ${r} as ${s.slice(0,u+1).join(".")} is ${JSON.stringify(R)}`);return}m=R}if(typeof m=="object"&&m!==null)try{m[c]=t}catch(u){d(`Ignoring ${r} as ${s.join(".")} is ${JSON.stringify(m)}`)}else d(`Ignoring ${r} as ${s.join(".")} is ${JSON.stringify(m)}`)}e.addToValueTree=h;function w(f,r){const t=r.split(".");D(f,t)}e.removeFromValueTree=w;function D(f,r){const t=r.shift();if(r.length===0){delete f[t];return}if(Object.keys(f).indexOf(t)!==-1){const d=f[t];typeof d=="object"&&!Array.isArray(d)&&(D(d,r),Object.keys(d).length===0&&delete f[t])}}function T(f,r,t){function d(m,u){let E=m;for(const R of u){if(typeof E!="object"||E===null)return;E=E[R]}return E}const s=r.split("."),c=d(f,s);return typeof c=="undefined"?t:c}e.getConfigurationValue=T;function b(f,r,t){Object.keys(r).forEach(d=>{d!=="__proto__"&&(d in f?F.isObject(f[d])&&F.isObject(r[d])?b(f[d],r[d],t):t&&(f[d]=r[d]):f[d]=r[d])})}e.merge=b;function l(){const f=_.Registry.as(S.Extensions.Configuration).getConfigurationProperties();return Object.keys(f)}e.getConfigurationKeys=l;function o(){const f=Object.create(null),r=_.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(let t in r){let d=r[t].default;h(f,t,d,s=>console.error(`Conflict in default settings: ${s}`))}return f}e.getDefaultValues=o;function v(f){return`[${f}]`}e.keyFromOverrideIdentifier=v;function n(f,r,t){const d=f.inspect(r),s=f.inspect(t);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:d.defaultValue}e.getMigratedSettingValue=n}),define(fe[194],me([0,1,18,3,61,6,24,25,12,2,121,86,34]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(n={},f=[],r=[]){this._contents=n,this._keys=f,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,i.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,f){const r=this.getContentsForOverrideIdentifer(f);return r?n?(0,i.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){for(const f of this.overrides)if(f.identifiers.indexOf(n)!==-1)return f.keys;return[]}override(n){let f=this.overrideConfigurations.get(n);return f||(f=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,f)),f}merge(...n){const f=_.deepClone(this.contents),r=_.deepClone(this.overrides),t=[...this.keys];for(const d of n){this.mergeContents(f,d.contents);for(const s of d.overrides){const[c]=r.filter(m=>g.equals(m.identifiers,s.identifiers));c?this.mergeContents(c.contents,s.contents):r.push(_.deepClone(s))}for(const s of d.keys)t.indexOf(s)===-1&&t.push(s)}return new p(f,t,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const f=this.getContentsForOverrideIdentifer(n);if(!f||typeof f!="object"||!Object.keys(f).length)return this;let r={};for(const t of g.distinct([...Object.keys(this.contents),...Object.keys(f)])){let d=this.contents[t],s=f[t];s&&(typeof d=="object"&&typeof s=="object"?(d=_.deepClone(d),this.mergeContents(d,s)):d=s),r[t]=d}return new p(r,this.keys,this.overrides)}mergeContents(n,f){for(const r of Object.keys(f)){if(r in n&&y.isObject(n[r])&&y.isObject(f[r])){this.mergeContents(n[r],f[r]);continue}n[r]=_.deepClone(f[r])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?_.deepFreeze(n):n}getContentsForOverrideIdentifer(n){for(const f of this.overrides)if(f.identifiers.indexOf(n)!==-1)return f.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,f){this.addKey(n),(0,i.addToValueTree)(this.contents,n,f,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,i.removeFromValueTree)(this.contents,n)}addKey(n){let f=this.keys.length;for(let r=0;r<f;r++)n.indexOf(this.keys[r])===0&&(f=r);this.keys.splice(f,1,n)}removeKey(n){let f=this.keys.indexOf(n);return f!==-1?(this.keys.splice(f,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(){const n=(0,i.getDefaultValues)(),f=(0,i.getConfigurationKeys)(),r=[];for(const t of Object.keys(n))I.OVERRIDE_PROPERTY_PATTERN.test(t)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(t).trim()],keys:Object.keys(n[t]),contents:(0,i.toValuesTree)(n[t],d=>console.error(`Conflict in default settings file: ${d}`))});super(n,f,r)}}e.DefaultConfigurationModel=h;class w{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,f){if(!y.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,f)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,f){this._raw=n;const{contents:r,keys:t,overrides:d,restricted:s}=this.doParseRaw(n,f);this._configurationModel=new p(r,t,d),this._restrictedConfigurations=s||[]}doParseContent(n){let f={},r=null,t=[],d=[],s=[];function c(u){Array.isArray(t)?t.push(u):r!==null&&(t[r]=u)}let m={onObjectBegin:()=>{let u={};c(u),d.push(t),t=u,r=null},onObjectProperty:u=>{r=u},onObjectEnd:()=>{t=d.pop()},onArrayBegin:()=>{let u=[];c(u),d.push(t),t=u,r=null},onArrayEnd:()=>{t=d.pop()},onLiteralValue:c,onError:(u,E,R)=>{s.push({error:u,offset:E,length:R})}};if(n)try{C.visit(n,m),f=t[0]||{}}catch(u){console.error(`Error while parsing settings file ${this._name}: ${u}`),this._parseErrors=[u]}return f}doParseRaw(n,f){const r=a.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),t=this.filter(n,r,!0,f);n=t.raw;const d=(0,i.toValuesTree)(n,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),s=Object.keys(n),c=(0,i.toOverrides)(n,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:d,keys:s,overrides:c,restricted:t.restricted}}filter(n,f,r,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:n,restricted:[]};const d={},s=[];for(let c in n)if(I.OVERRIDE_PROPERTY_PATTERN.test(c)&&r){const m=this.filter(n[c],f,!1,t);d[c]=m.raw,s.push(...m.restricted)}else{const m=f[c],u=m?typeof m.scope!="undefined"?m.scope:3:void 0;m?.restricted&&s.push(c),(u===void 0||t.scopes===void 0||t.scopes.includes(u))&&(t.skipRestricted&&m?.restricted||(d[c]=n[c]))}return{raw:d,restricted:s}}}e.ConfigurationModelParser=w;class D extends S.Disposable{constructor(n,f,r,t){super();this.userSettingsResource=n,this.scopes=f,this.fileService=t,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class T{constructor(n,f,r=new p,t=new p,d=new P.ResourceMap,s=new p,c=new P.ResourceMap,m=!0){this._defaultConfiguration=n,this._localUserConfiguration=f,this._remoteUserConfiguration=r,this._workspaceConfiguration=t,this._folderConfigurations=d,this._memoryConfiguration=s,this._memoryConfigurationByResource=c,this._freeze=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(n,f,r){return this.getConsolidateConfigurationModel(f,r).getValue(n)}updateValue(n,f,r={}){let t;r.resource?(t=this._memoryConfigurationByResource.get(r.resource),t||(t=new p,this._memoryConfigurationByResource.set(r.resource,t))):t=this._memoryConfiguration,f===void 0?t.removeValue(n):t.setValue(n,f),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,f,r){const t=this.getConsolidateConfigurationModel(f,r),d=this.getFolderConfigurationModelForResource(f.resource,r),s=f.resource?this._memoryConfigurationByResource.get(f.resource)||this._memoryConfiguration:this._memoryConfiguration,c=f.overrideIdentifier?this._defaultConfiguration.freeze().override(f.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),m=f.overrideIdentifier?this.userConfiguration.freeze().override(f.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),u=f.overrideIdentifier?this.localUserConfiguration.freeze().override(f.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),E=f.overrideIdentifier?this.remoteUserConfiguration.freeze().override(f.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),R=r?f.overrideIdentifier?this._workspaceConfiguration.freeze().override(f.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,L=d?f.overrideIdentifier?d.freeze().override(f.overrideIdentifier).getValue(n):d.freeze().getValue(n):void 0,M=f.overrideIdentifier?s.override(f.overrideIdentifier).getValue(n):s.getValue(n),A=t.getValue(n),B=g.distinct(g.flatten(t.overrides.map(V=>V.identifiers))).filter(V=>t.getOverrideValue(n,V)!==void 0);return{defaultValue:c,userValue:m,userLocalValue:u,userRemoteValue:E,workspaceValue:R,workspaceFolderValue:L,memoryValue:M,value:A,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:f.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,user:m!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:f.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,userLocal:u!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:f.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,userRemote:E!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:f.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:f.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:d?.freeze().getValue(n),override:f.overrideIdentifier?d?.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:s.getValue(n),override:f.overrideIdentifier?s.getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,overrideIdentifiers:B.length?B:void 0}}keys(n){const f=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:f?f.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,f){this._folderConfigurations.set(n,f),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,f){const r=f.filter(t=>I.OVERRIDE_PROPERTY_PATTERN.test(t)).map(t=>{const d=(0,I.overrideIdentifierFromKey)(t),s=this._defaultConfiguration.getKeysForOverrideIdentifier(d),c=n.getKeysForOverrideIdentifier(d),m=[...c.filter(u=>s.indexOf(u)===-1),...s.filter(u=>c.indexOf(u)===-1),...s.filter(u=>!_.equals(this._defaultConfiguration.override(d).getValue(u),n.override(d).getValue(u)))];return[d,m]});return this.updateDefaultConfiguration(n),{keys:f,overrides:r}}compareAndUpdateLocalUserConfiguration(n){const{added:f,updated:r,removed:t,overrides:d}=(0,i.compare)(this.localUserConfiguration,n),s=[...f,...r,...t];return s.length&&this.updateLocalUserConfiguration(n),{keys:s,overrides:d}}compareAndUpdateRemoteUserConfiguration(n){const{added:f,updated:r,removed:t,overrides:d}=(0,i.compare)(this.remoteUserConfiguration,n);let s=[...f,...r,...t];return s.length&&this.updateRemoteUserConfiguration(n),{keys:s,overrides:d}}compareAndUpdateWorkspaceConfiguration(n){const{added:f,updated:r,removed:t,overrides:d}=(0,i.compare)(this.workspaceConfiguration,n);let s=[...f,...r,...t];return s.length&&this.updateWorkspaceConfiguration(n),{keys:s,overrides:d}}compareAndUpdateFolderConfiguration(n,f){const r=this.folderConfigurations.get(n),{added:t,updated:d,removed:s,overrides:c}=(0,i.compare)(r,f);let m=[...t,...d,...s];return(m.length||!r)&&this.updateFolderConfiguration(n,f),{keys:m,overrides:c}}compareAndDeleteFolderConfiguration(n){const f=this.folderConfigurations.get(n);if(!f)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:t,removed:d,overrides:s}=(0,i.compare)(f,void 0);return{keys:[...r,...t,...d],overrides:s}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,f){let r=this.getConsolidatedConfigurationModelForResource(n,f);return n.overrideIdentifier?r.override(n.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:n},f){let r=this.getWorkspaceConsolidatedConfiguration();if(f&&n){const t=f.getFolder(n);t&&(r=this.getFolderConsolidatedConfiguration(t.uri)||r);const d=this._memoryConfigurationByResource.get(n);d&&(r=r.merge(d))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let f=this._foldersConsolidatedConfigurations.get(n);if(!f){const r=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(n);t?(f=r.merge(t),this._freeze&&(f=f.freeze()),this._foldersConsolidatedConfigurations.set(n,f)):f=r}return f}getFolderConfigurationModelForResource(n,f){if(f&&n){const r=f.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,f)=>{const{contents:r,overrides:t,keys:d}=this._folderConfigurations.get(f);return n.push([f,{contents:r,overrides:t,keys:d}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(f=>n.add(f)),this.userConfiguration.freeze().keys.forEach(f=>n.add(f)),this._workspaceConfiguration.freeze().keys.forEach(f=>n.add(f)),this._folderConfigurations.forEach(f=>f.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const f=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>f.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>f.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>f.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(t=>f.add(t))),[...f.values()]}static parse(n){const f=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.user),t=this.parseConfigurationModel(n.workspace),d=n.folders.reduce((s,c)=>(s.set(k.URI.revive(c[0]),this.parseConfigurationModel(c[1])),s),new P.ResourceMap);return new T(f,r,new p,t,d,new p,new P.ResourceMap,!1)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=T;function b(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const n=new Set,f=new Map;for(const t of v)t.keys.forEach(d=>n.add(d)),t.overrides.forEach(([d,s])=>{const c=(0,P.getOrSet)(f,d,new Set);s.forEach(m=>c.add(m))});const r=[];return f.forEach((t,d)=>r.push([d,[...t.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=b;class l{constructor(n,f,r,t){this.change=n,this.previous=f,this.currentConfiguraiton=r,this.currentWorkspace=t,this._previousConfiguration=void 0;const d=new Set;n.keys.forEach(c=>d.add(c)),n.overrides.forEach(([,c])=>c.forEach(m=>d.add(m))),this.affectedKeys=[...d.values()];const s=new p;this.affectedKeys.forEach(c=>s.setValue(c,{})),this.affectedKeysTree=s.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=T.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,f){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(f){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,f,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(n,f,this.currentWorkspace);return!_.equals(r,t)}return!0}return!1}doesAffectedKeysTreeContains(n,f){let r=(0,i.toValuesTree)({[f]:!0},()=>{}),t;for(;typeof r=="object"&&(t=Object.keys(r)[0]);){if(n=n[t],!n)return!1;r=r[t]}return!0}}e.ConfigurationChangeEvent=l;class o extends l{constructor(n,f,r,t){super({keys:n.allKeys(),overrides:[]},void 0,n,f);this.source=r,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=o}),define(fe[122],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var F;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(P,_=F.Unknown,y){super(P);this._message=P,this._code=_,this._detail=y,this.isHandled=_===F.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(P){return P instanceof C&&P._code===F.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof C&&P._code===F.NoResolverFound}static isHandled(P){return P instanceof C&&P.isHandled}}e.RemoteAuthorityResolverError=C}),define(fe[64],me([0,1,10]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(k){return k.scheme===g.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=F;function C(k){if(!k)return;const i=k.indexOf("+");return i<0?k:k.substr(0,i)}e.getRemoteName=C;function S(k){return k.scheme!==g.Schemas.file&&k.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=S;function P(k){if(k.folders.length)return k.folders.every(i=>S(i.uri))?k.folders[0].uri:void 0;if(k.configuration&&S(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=P;function _(k){return P(k)?.scheme}e.getVirtualWorkspaceScheme=_;function y(k){return P(k)!==void 0}e.isVirtualWorkspace=y}),define(fe[27],me([0,1,9,4,64]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.getWorkspaceSupportTypeMessage=S;function P(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var _;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(_=e.ExtensionType||(e.ExtensionType={}));class y{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p=="undefined"||p===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){let w=typeof p=="string"?p:p.value,D=typeof h=="string"?h:h.value;return g.equalsIgnoreCase(w,D)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=y;function k(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function i(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function I(a,p){if(p&&a.enableProposedApi){const h=`onResolveRemoteAuthority:${(0,C.getRemoteName)(p)}`;return a.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(fe[195],me([0,1,9,27]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(h,w){return h.uuid&&w.uuid?h.uuid===w.uuid:h.id===w.id?!0:(0,g.compareIgnoreCase)(h.id,w.id)===0}e.areSameExtensions=C;class S{constructor(w,D){this.version=D,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof S?C(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=S;function P(h,w){return`${h}.${w}`}e.getExtensionId=P;function _(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=_;function y(h,w){return _(P(h,w))}e.getGalleryExtensionId=y;function k(h,w){const D=[],T=b=>{for(const l of D)if(l.some(o=>C(w(o),w(b))))return l;return null};for(const b of h){const l=T(b);l?l.push(b):D.push([b])}return D}e.groupByExtension=k;function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function a(h){const w=new Set;for(const D of h)D.malicious&&w.add(D.id.id);return w}e.getMaliciousExtensionsSet=a;function p(h,w){const D=[],T=w.manifest.extensionDependencies?.slice(0)??[];for(;T.length;){const b=T.shift();if(b&&D.every(l=>!C(l.identifier,{id:b}))){const l=h.filter(o=>C(o.identifier,{id:b}));l.length===1&&(D.push(l[0]),T.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return D}e.getExtensionDependencies=p}),define(fe[123],me([0,1,3,11,4,13]),function(Y,e,g,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService");var P;(function(h){h.Http="http",h.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var _;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(_=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=I;function a(h,w){return w?w!==1&&h<1024:!F.isWindows&&h<1024}e.isPortPrivileged=a;let p=class{constructor(w){this.logService=w,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,D){return this._tunnelProvider=w,w?(this._canElevate=D.elevation,this._privacyOptions=D.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],D=Array.from(this._tunnels.values());for(let T of D){const b=Array.from(T.values());for(let l of b){const o=await l.value;o&&w.push(o)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:D}of w.values())await D.then(T=>T?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,D,T,b,l=!1,o=_.Private,v){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${D}:${T} on local port ${b}.`),!w)return;D||(D="localhost");const n=this.retainOrCreateTunnel(w,D,T,b,l,o,v);return n?n.then(f=>{if(!f){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(D,T);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(f);return(f.tunnelRemoteHost!==D||f.tunnelRemotePort!==T)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const D=this._tunnels.get(w.tunnelRemoteHost);if(D){const T=D.get(w.tunnelRemotePort);T&&(T.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,T))}}}}async tryDisposeTunnel(w,D,T){if(T.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${D}.`);const b=T.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(D),b}}async closeTunnel(w,D){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${D} `);const T=this._tunnels.get(w);if(T&&T.has(D)){const b=T.get(D);b.refcount=0,await this.tryDisposeTunnel(w,D,b)}}addTunnelToMap(w,D,T){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(D,{refcount:1,value:T})}async removeEmptyTunnelFromMap(w,D){const T=this._tunnels.get(w);T&&(await T.get(D)||T.delete(D),T.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,D){let T=[w];i(w)?(T.push(...e.LOCALHOST_ADDRESSES),T.push(...e.ALL_INTERFACES_ADDRESSES)):I(w)&&T.push(...e.ALL_INTERFACES_ADDRESSES);const b=T.map(l=>this._tunnels.get(l));for(const l of b){const o=l?.get(D);if(o)return o}}canTunnel(w){return!!k(w)}createWithProvider(w,D,T,b,l,o,v){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${D}:${T} on local port ${b}.`);const f={elevationRequired:l?a(b===void 0?T:b):!1},r={remoteAddress:{host:D,port:T},localAddressPort:b,privacy:o,public:o!==_.Private,protocol:v},t=w.forwardPort(r,f);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(D,T,t),t}};p=Ve([We(0,S.ILogService)],p),e.AbstractTunnelService=p}),define(fe[196],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{constructor(){this.validators=new Map}vsda(){return new Promise((C,S)=>Y(["vsda"],C,S))}async createNewMessage(C){try{const S=await this.vsda(),P=new S.validator;if(P){const _=String(g._nextId++);return this.validators.set(_,P),{id:_,data:P.createNewMessage(C)}}}catch(S){}return{id:"",data:C}}async validate(C,S){if(!C.id)return!0;const P=this.validators.get(C.id);if(!P)return!1;this.validators.delete(C.id);try{return P.validate(S)==="ok"}catch(_){return!1}}async sign(C){try{const S=await this.vsda(),P=new S.signer;if(P)return P.sign(C)}catch(S){}return C}}e.SignService=g,g._nextId=1}),define(fe[197],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,S,P=5){let _;return _=S(y=>{const k=typeof y=="string"?y:y.data;let i=this._terminalBufferMap.get(C);if(i){i.data.push(k);return}const I=setTimeout(()=>this.flushBuffer(C),P);i={data:[k],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(C),_.dispose()}},this._terminalBufferMap.set(C,i)}),_}stopBuffering(C){const S=this._terminalBufferMap.get(C);S&&S.dispose()}flushBuffer(C){const S=this._terminalBufferMap.get(C);S&&(this._terminalBufferMap.delete(C),this._callback(C,S.data.join("")))}}e.TerminalDataBufferer=g}),define(fe[198],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(fe[65],me([0,1,47,3,6,4,34,198]),function(Y,e,g,F,C,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,S.createDecorator)("themeService");var y;(function(D){function T(b){return b&&typeof b=="object"&&typeof b.id=="string"}D.isThemeColor=T})(y=e.ThemeColor||(e.ThemeColor={}));function k(D){return{id:D}}e.themeColorFromId=k;var i;(function(D){function T(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color=="undefined"||y.isThemeColor(f.color))}D.isThemeIcon=T;const b=new RegExp(`^\\$\\((${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?)\\)$`);function l(f){const r=b.exec(f);if(!r)return;let[,t]=r;return{id:t}}D.fromString=l;function o(f,r){let t=f.id;const d=t.lastIndexOf("~");return d!==-1&&(t=t.substring(0,d)),r&&(t=`${t}~${r}`),{id:t}}D.modify=o;function v(f,r){return f.id===r.id&&f.color?.id===r.color?.id}D.isEqual=v;function n(f,r){return{id:f.id,color:r?k(r):void 0}}D.asThemeIcon=n,D.asClassNameArray=g.CSSIcon.asClassNameArray,D.asClassName=g.CSSIcon.asClassName,D.asCSSSelector=g.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=g.Codicon.file,e.FolderThemeIcon=g.Codicon.folder;function I(D){switch(D){case _.ColorScheme.DARK:return"vs-dark";case _.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class a{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new F.Emitter}onColorThemeChange(T){return this.themingParticipants.push(T),this.onThemingParticipantAddedEmitter.fire(T),(0,C.toDisposable)(()=>{const b=this.themingParticipants.indexOf(T);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new a;P.Registry.add(e.Extensions.ThemingContribution,p);function h(D){return p.onColorThemeChange(D)}e.registerThemingParticipant=h;class w extends C.Disposable{constructor(T){super();this.themeService=T,this.theme=T.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(T){this.theme=T,this.updateStyles()}updateStyles(){}getColor(T,b){let l=this.theme.getColor(T);return l&&b&&(l=b(l,this.theme)),l?l.toString():null}}e.Themable=w}),define(fe[199],me([0,1,15,47,3,163,120,34,65]),function(Y,e,g,F,C,S,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${F.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(T,b,l,o){const v=this.iconsById[T];if(v){if(l&&!v.description){v.description=l,this.iconSchema.properties[T].markdownDescription=`${l} $(${T})`;const r=this.iconReferenceSchema.enum.indexOf(T);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=l),this._onDidChange.fire()}return v}let n={id:T,description:l,defaults:b,deprecationMessage:o};this.iconsById[T]=n;let f={$ref:"#/definitions/icons"};return o&&(f.deprecationMessage=o),l&&(f.markdownDescription=`${l}: $(${T})`),this.iconSchema.properties[T]=f,this.iconReferenceSchema.enum.push(T),this.iconReferenceSchema.enumDescriptions.push(l||""),this._onDidChange.fire(),{id:T}}deregisterIcon(T){delete this.iconsById[T],delete this.iconSchema.properties[T];const b=this.iconReferenceSchema.enum.indexOf(T);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(T=>this.iconsById[T])}getIcon(T){return this.iconsById[T]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(T,b){const l=this.iconFontsById[T];if(l)return l;let o={id:T,definition:b};return this.iconFontsById[T]=o,this._onDidChange.fire(),o}deregisterIconFont(T){delete this.iconFontsById[T]}getIconFonts(){return Object.keys(this.iconFontsById).map(T=>this.iconFontsById[T])}getIconFont(T){return this.iconFontsById[T]}toString(){const T=(v,n)=>v.id.localeCompare(n.id),b=v=>{for(;y.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of o.filter(n=>!!n.description).sort(T))l.push(`|<i class="${b(v)}"></i>|${v.id}|${y.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const v of o.filter(n=>!y.ThemeIcon.isThemeIcon(n.defaults)).sort(T))l.push(`|<i class="${b(v)}"></i>|${v.id}|`);return l.join(`
`)}}const i=new k;_.Registry.add(e.Extensions.IconContribution,i);function I(D,T,b,l){return i.registerIcon(D,T,b,l)}e.registerIcon=I;function a(){return i}e.getIconRegistry=a;function p(){for(const D of F.iconRegistry.all)i.registerIcon(D.id,D.definition,D.description);F.iconRegistry.onDidRegister(D=>i.registerIcon(D.id,D.definition,D.description))}p(),e.iconsSchemaId="vscode://schemas/icons";let h=_.Registry.as(P.Extensions.JSONContribution);h.registerSchema(e.iconsSchemaId,i.getIconSchema());const w=new g.RunOnceScheduler(()=>h.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=I("widget-close",F.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",F.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",F.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=y.ThemeIcon.modify(F.Codicon.sync,"spin")}),define(fe[44],me([0,1,24,23,2,4]),function(Y,e,g,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");var P;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function _(a){const p=a;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=_;function y(a){const p=a;return!!(p&&typeof p=="object"&&C.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=y;class k{constructor(p,h,w,D,T){this._id=p,this._transient=w,this._configuration=D,this._ignorePathCasing=T,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=k;class i{constructor(p,h){this.raw=h,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,F.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(a){return new i({uri:a,index:0,name:(0,F.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=I}),define(fe[200],me([0,1,29,61,140,80,10,8,11,23,2,164,4,64,44]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(N){return(typeof N=="string"?(0,_.extname)(N):(0,k.extname)(N))===w}e.hasWorkspaceFileExtension=D,e.IWorkspacesService=(0,a.createDecorator)("workspacesService");function T(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=T;function b(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=b;function l(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=l;function o(N){const j=N;return typeof j?.id=="string"&&i.URI.isUri(j.uri)}e.isSingleFolderWorkspaceIdentifier=o;function v(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=v;function n(N){const j=N;return typeof j?.id=="string"&&i.URI.isUri(j.configPath)}e.isWorkspaceIdentifier=n;function f(N){const j=N;if(j?.uri)return{id:j.id,uri:i.URI.revive(j.uri)};const U=N;if(U?.configPath)return{id:U.id,configPath:i.URI.revive(U.configPath)};if(N?.id)return{id:N.id}}e.reviveIdentifier=f;function r(N,j){return k.extUriBiasedIgnorePathCase.isEqualOrParent(N,j.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function t(N){return d(N)||s(N)}e.isStoredWorkspaceFolder=t;function d(N){const j=N;return typeof j?.path=="string"&&(!j.name||typeof j.name=="string")}e.isRawFileWorkspaceFolder=d;function s(N){const j=N;return typeof j?.uri=="string"&&(!j.name||typeof j.name=="string")}e.isRawUriWorkspaceFolder=s;function c(N,j,U,x,z=!y.isWindows,O){if(N.scheme!==x.scheme)return{name:U,uri:N.toString(!0)};let W=j?void 0:O.relativePath(x,N);if(W!==void 0)W.length===0?W=".":y.isWindows&&N.scheme===P.Schemas.file&&!z&&(W=W.replace(/\//g,"\\"));else if(N.scheme===P.Schemas.file)W=N.fsPath,y.isWindows&&(W=(0,S.normalizeDriveLetter)(W),z&&(W=(0,g.toSlashes)(W)));else{if(!O.isEqualAuthority(N.authority,x.authority))return{name:U,uri:N.toString(!0)};W=N.path}return{name:U,path:W}}e.getStoredWorkspaceFolder=c;function m(N,j,U){let x=[],z=new Set;const O=U.dirname(j);for(let W of N){let $;if(d(W))W.path&&($=U.resolvePath(O,W.path));else if(s(W))try{$=i.URI.parse(W.uri),$.path[0]!=="/"&&($=$.with({path:"/"+$.path}))}catch(X){console.warn(X)}if($){let X=U.getComparisonKey($);if(!z.has(X)){z.add(X);const K=W.name||U.basenameOrAuthority($);x.push(new h.WorkspaceFolder({uri:$,name:K,index:x.length},W))}}}return x}e.toWorkspaceFolders=m;function u(N,j,U,x,z){let O=E(j,N);const W=z.dirname(j),$=z.dirname(x),X=[],K=R(O.folders);for(const Pe of O.folders){const Be=d(Pe)?z.resolvePath(W,Pe.path):i.URI.parse(Pe.uri);let $e;U?$e=!1:$e=!d(Pe)||(0,_.isAbsolute)(Pe.path),X.push(c(Be,$e,Pe.name,$,K,z))}const de={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},_e=C.setProperty(N,["folders"],X,de);let Ce=C.applyEdits(N,_e);return O.remoteAuthority===(0,p.getRemoteAuthority)(x)&&(Ce=C.applyEdits(Ce,C.removeProperty(Ce,["remoteAuthority"],de))),Ce}e.rewriteWorkspaceFileForNewLocation=u;function E(N,j){let U=F.parse(j);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(x=>t(x));else throw new Error(`${N} looks like an invalid workspace file.`);return U}function R(N){return y.isWindows?N.some(j=>d(j)&&j.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function L(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function M(N){return typeof N.folderUri=="string"}function A(N){return typeof N.fileUri=="string"}function B(N,j){const U={workspaces:[],files:[]};if(N){const x=function(O,W){for(let $=0;$<O.length;$++)try{W(O[$],$)}catch(X){j.warn(`Error restoring recent entry ${JSON.stringify(O[$])}: ${X.toString()}. Skip entry.`)}},z=N;if(Array.isArray(z.entries))x(z.entries,O=>{const W=O.label,$=O.remoteAuthority;L(O)?U.workspaces.push({label:W,remoteAuthority:$,workspace:{id:O.workspace.id,configPath:i.URI.parse(O.workspace.configPath)}}):M(O)?U.workspaces.push({label:W,remoteAuthority:$,folderUri:i.URI.parse(O.folderUri)}):A(O)&&U.files.push({label:W,remoteAuthority:$,fileUri:i.URI.parse(O.fileUri)})});else{const O=N;Array.isArray(O.workspaces3)&&x(O.workspaces3,(W,$)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[$]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?U.workspaces.push({label:X,workspace:{id:W.id,configPath:i.URI.parse(W.configURIPath)}}):typeof W=="string"&&U.workspaces.push({label:X,folderUri:i.URI.parse(W)})}),Array.isArray(O.files2)&&x(O.files2,(W,$)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[$]||void 0;typeof W=="string"&&U.files.push({label:X,fileUri:i.URI.parse(W)})})}}return U}e.restoreRecentlyOpened=B;function V(N){const j={entries:[]};for(const U of N.workspaces)b(U)?j.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):j.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of N.files)j.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return j}e.toStoreData=V}),define(fe[87],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const S=this._idPool++;return this._data.set(S,C),this.logDebugInfo(),S}get(C,S){return this._data.has(C)?this._data.get(C)[S]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(fe[53],me([0,1,10,23,4]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map,this.extUri=new F.ExtUri(_=>{const y=this._providerInfo.get(_.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(_,y){y===null?this._providerInfo.delete(_):this._providerInfo.set(_,y)}isFreeScheme(_){return!this._providerInfo.has(_)&&!this._systemSchemes.has(_)}getCapabilities(_){return this._providerInfo.get(_)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(fe[28],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(fe[201],me([0,1,15]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(P,_,y){this._deferredPromises=new Map,this._id=P,this._shared=_,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of k.values())i.complete()}catch(i){for(const I of k.values())I.error(i)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this._init}get(P,_){let y=this._value[P];return typeof y=="undefined"&&(y=_),y}update(P,_){this._value[P]=_;let y=this._deferredPromises.get(P);if(y!==void 0)return y.p;const k=new g.DeferredPromise;return this._deferredPromises.set(P,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class C extends F{constructor(P,_){super(P.identifier.value,!0,_);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=C}),define(fe[202],me([0,1,3,2,13]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let S=class{constructor(_,y){this._logService=_,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(_,y,k){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_)).acceptModelChanged(y.value,k)}$acceptDirtyStateChanged(_,y){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_)).acceptDirty(y)}$acceptModelSaved(_){const y=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(_,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",_.path,y);const k=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_));k.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:k.apiNotebook})}};S=Ve([We(0,C.ILogService)],S),e.ExtHostNotebookDocuments=S}),define(fe[14],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class F{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.ExtHostRpcService=F});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,g):C?C.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[203],me([0,1,27,3]),function(Y,e,g,F){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class S{constructor(_,y){C.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(_.identifier),st(this,C,y,"f"),Ne(this,C,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(_){return Ne(this,C,"f").get(this._id,_)}store(_,y){return Ne(this,C,"f").store(this._id,_,y)}delete(_){return Ne(this,C,"f").delete(this._id,_)}}e.ExtensionSecrets=S,C=new WeakMap}),define(fe[124],me([0,1,4,3]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(P){this._enabled=P}$onDidChangeTelemetryEnabled(P){this._enabled=P,this._onDidChangeTelemetryEnabled.fire(P)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(fe[66],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,C=(b,l)=>{const o={controllerId:l};return F.set(b,o),o};e.createPrivateApiFor=C;const S=b=>F.get(b);e.getPrivateApiFor=S;const P=(b,l,o,v)=>{let n=o;return{enumerable:!0,configurable:!1,get(){return n},set(f){if(!v(n,f)){const r=n;n=f,b.listener?.({op:3,key:l,value:f,previous:r})}}}},_=(b,l)=>b===l,y={range:(b,l)=>b===l?!0:!b||!l?!1:b.isEqual(l),label:_,description:_,busy:_,error:_,canResolveChildren:_,tags:(b,l)=>!(b.length!==l.length||b.some(o=>!l.find(v=>o.id===v.id)))},k=Object.keys(y),i=(b,l)=>({range:P(b,"range",void 0,y.range),label:P(b,"label",l,y.label),description:P(b,"description",void 0,y.description),canResolveChildren:P(b,"canResolveChildren",!1,y.canResolveChildren),busy:P(b,"busy",!1,y.busy),error:P(b,"error",void 0,y.error),tags:P(b,"tags",[],y.tags)}),I=(b,l)=>{const o=new Map;for(const v of k)y[v](b[v],l[v])||o.set(v,l[v]);return o};e.diffTestItems=I;class a extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.DuplicateTestItemError=a;class p extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class h extends Error{constructor(l,o,v){super(`TestItem with ID "${l}" is from controller "${o}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=h;const w=b=>{const l=(0,e.getPrivateApiFor)(b);let o=new Map;return{get size(){return o.size},forEach(v,n){for(const f of o.values())v.call(n,f,this)},replace(v){const n=new Map,f=new Set(o.keys()),r={op:4,ops:[]};for(const t of v){if(!(t instanceof D))throw new p(t.id);const d=(0,e.getPrivateApiFor)(t).controllerId;if(d!==l.controllerId)throw new h(t.id,d,l.controllerId);if(n.has(t.id))throw new a(t.id);n.set(t.id,t),f.delete(t.id),r.ops.push({op:0,item:t})}for(const t of f.keys())r.ops.push({op:1,id:t});l.listener?.(r),o=n},add(v){if(!(v instanceof D))throw new p(v.id);o.set(v.id,v),l.listener?.({op:0,item:v})},delete(v){o.delete(v)&&l.listener?.({op:1,id:v})},get(v){return o.get(v)},toJSON(){return Array.from(o.values())},[Symbol.iterator](){return o.values()}}};class D{constructor(l,o,v,n){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const f=(0,e.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof T?void 0:f.parent}},children:{value:w(this),enumerable:!0,writable:!1},...i(f,v)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=D;class T extends D{constructor(l,o){super(l,l,o,void 0)}}e.TestItemRootImpl=T}),define(fe[54],me([0,1,4,123,3,14]),function(Y,e,g,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(y){function k(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?F.TunnelPrivacyId.Public:F.TunnelPrivacyId.Private),protocol:I.protocol}}y.fromApiTunnel=k;function i(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==F.TunnelPrivacyId.ConstantPrivate&&I.privacy!==F.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}y.fromServiceTunnel=i})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let _=class{constructor(k){this.onDidChangeTunnels=new C.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,i){}async getTunnels(){return[]}async setTunnelExtensionFunctions(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,i){return{dispose:()=>{}}}async $providePortAttributes(k,i,I,a,p){return[]}async $forwardPort(k,i){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};_=Ve([We(0,S.IExtHostRpcService)],_),e.ExtHostTunnelService=_});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,g):C?C.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[7],me([0,1,18,17,100,24,103,9,12,2,32,43,122]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a){"use strict";var p,h,w,D,T,b,l,o,v,n,f,r,t,d,s,c,m,u,E,R;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function L(q){function H(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty(H,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf(H,q),Object.setPrototypeOf(H.prototype,q.prototype),H}let M=T=class{constructor(H){p.set(this,void 0),st(this,p,H,"f")}static from(...H){let ae=H;return new T(function(){if(ae){for(const ke of ae)ke&&typeof ke.dispose=="function"&&ke.dispose();ae=void 0}})}dispose(){typeof Ne(this,p,"f")=="function"&&(Ne(this,p,"f").call(this),st(this,p,void 0,"f"))}};p=new WeakMap,M=T=Ve([L],M),e.Disposable=M;let A=b=class{constructor(H,ae){if(H<0)throw(0,F.illegalArgument)("line must be non-negative");if(ae<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=H,this._character=ae}static Min(...H){if(H.length===0)throw new TypeError;let ae=H[0];for(let ke=1;ke<H.length;ke++){const Je=H[ke];Je.isBefore(ae)&&(ae=Je)}return ae}static Max(...H){if(H.length===0)throw new TypeError;let ae=H[0];for(let ke=1;ke<H.length;ke++){const Je=H[ke];Je.isAfter(ae)&&(ae=Je)}return ae}static isPosition(H){if(!H)return!1;if(H instanceof b)return!0;let{line:ae,character:ke}=H;return typeof ae=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<H._character}isBeforeOrEqual(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<=H._character}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this._line===H._line&&this._character===H._character}compareTo(H){return this._line<H._line?-1:this._line>H.line?1:this._character<H._character?-1:this._character>H._character?1:0}translate(H,ae=0){if(H===null||ae===null)throw(0,F.illegalArgument)();let ke;return typeof H=="undefined"?ke=0:typeof H=="number"?ke=H:(ke=typeof H.lineDelta=="number"?H.lineDelta:0,ae=typeof H.characterDelta=="number"?H.characterDelta:0),ke===0&&ae===0?this:new b(this.line+ke,this.character+ae)}with(H,ae=this.character){if(H===null||ae===null)throw(0,F.illegalArgument)();let ke;return typeof H=="undefined"?ke=this.line:typeof H=="number"?ke=H:(ke=typeof H.line=="number"?H.line:this.line,ae=typeof H.character=="number"?H.character:this.character),ke===this.line&&ae===this.character?this:new b(ke,ae)}toJSON(){return{line:this.line,character:this.character}}};A=b=Ve([L],A),e.Position=A;let B=l=class{constructor(H,ae,ke,Je){let ot,dt;if(typeof H=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof Je=="number"?(ot=new A(H,ae),dt=new A(ke,Je)):H instanceof A&&ae instanceof A&&(ot=H,dt=ae),!ot||!dt)throw new Error("Invalid arguments");ot.isBefore(dt)?(this._start=ot,this._end=dt):(this._start=dt,this._end=ot)}static isRange(H){return H instanceof l?!0:H?A.isPosition(H.start)&&A.isPosition(H.end):!1}get start(){return this._start}get end(){return this._end}contains(H){return H instanceof l?this.contains(H._start)&&this.contains(H._end):H instanceof A?!(H.isBefore(this._start)||this._end.isBefore(H)):!1}isEqual(H){return this._start.isEqual(H._start)&&this._end.isEqual(H._end)}intersection(H){const ae=A.Max(H.start,this._start),ke=A.Min(H.end,this._end);if(!ae.isAfter(ke))return new l(ae,ke)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const ae=A.Min(H.start,this._start),ke=A.Max(H.end,this.end);return new l(ae,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(H,ae=this.end){if(H===null||ae===null)throw(0,F.illegalArgument)();let ke;return H?A.isPosition(H)?ke=H:(ke=H.start||this.start,ae=H.end||this.end):ke=this.start,ke.isEqual(this._start)&&ae.isEqual(this.end)?this:new l(ke,ae)}toJSON(){return[this.start,this.end]}};B=l=Ve([L],B),e.Range=B;let V=o=class extends B{constructor(H,ae,ke,Je){let ot,dt;if(typeof H=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof Je=="number"?(ot=new A(H,ae),dt=new A(ke,Je)):H instanceof A&&ae instanceof A&&(ot=H,dt=ae),!ot||!dt)throw new Error("Invalid arguments");super(ot,dt);this._anchor=ot,this._active=dt}static isSelection(H){return H instanceof o?!0:H?B.isRange(H)&&A.isPosition(H.anchor)&&A.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};V=o=Ve([L],V),e.Selection=V;class N{constructor(H,ae,ke){if(typeof H!="string"||H.length===0)throw(0,F.illegalArgument)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,F.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,F.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(ae),this.connectionToken=ke}}e.ResolvedAuthority=N;class j extends Error{constructor(H,ae=a.RemoteAuthorityResolverErrorCode.Unknown,ke){super(H);this._message=H,this._code=ae,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,j.prototype)}static NotAvailable(H,ae){return new j(H,a.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(H){return new j(H,a.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=j;var U;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(U=e.EndOfLine||(e.EndOfLine={}));var x;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let z=v=class{constructor(H,ae){this._range=H,this._newText=ae}static isTextEdit(H){return H instanceof v?!0:H?B.isRange(H)&&typeof H.newText=="string":!1}static replace(H,ae){return new v(H,ae)}static insert(H,ae){return v.replace(new B(H,H),ae)}static delete(H){return v.replace(H,"")}static setEndOfLine(H){const ae=new v(new B(new A(0,0),new A(0,0)),"");return ae.newEol=H,ae}get range(){return this._range}set range(H){if(H&&!B.isRange(H))throw(0,F.illegalArgument)("range");this._range=H}get newText(){return this._newText||""}set newText(H){if(H&&typeof H!="string")throw(0,F.illegalArgument)("newText");this._newText=H}get newEol(){return this._newEol}set newEol(H){if(H&&typeof H!="number")throw(0,F.illegalArgument)("newEol");this._newEol=H}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};z=v=Ve([L],z),e.TextEdit=z;var O;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace"})(O=e.FileEditType||(e.FileEditType={}));let W=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(H,ae,ke,Je){this._edits.push({_type:1,from:H,to:ae,options:ke,metadata:Je})}createFile(H,ae,ke){this._edits.push({_type:1,from:void 0,to:H,options:ae,metadata:ke})}deleteFile(H,ae,ke){this._edits.push({_type:1,from:H,to:void 0,options:ae,metadata:ke})}replaceNotebookMetadata(H,ae,ke){this._edits.push({_type:3,metadata:ke,uri:H,edit:{editType:5,metadata:ae},notebookMetadata:ae})}replaceNotebookCells(H,ae,ke,Je,ot){let dt,mt,kt=[],Rt;if(Ht.isNotebookRange(ae)&&Oe.isNotebookCellDataArray(ke)&&!Oe.isNotebookCellDataArray(Je)?(dt=ae.start,mt=ae.end,kt=ke,Rt=Je):typeof ae=="number"&&typeof ke=="number"&&Oe.isNotebookCellDataArray(Je)&&(dt=ae,mt=ke,kt=Je,Rt=ot),dt===void 0||mt===void 0)throw new Error("Invalid arguments");(dt!==mt||kt.length>0)&&this._edits.push({_type:5,uri:H,index:dt,count:mt-dt,cells:kt,metadata:Rt})}replaceNotebookCellMetadata(H,ae,ke,Je){this._edits.push({_type:3,metadata:Je,uri:H,edit:{editType:8,index:ae,metadata:ke}})}replace(H,ae,ke,Je){this._edits.push({_type:2,uri:H,edit:new z(ae,ke),metadata:Je})}insert(H,ae,ke,Je){this.replace(H,new B(ae,ae),ke,Je)}delete(H,ae,ke){this.replace(H,ae,"",ke)}has(H){return this._edits.some(ae=>ae._type===2&&ae.uri.toString()===H.toString())}set(H,ae){if(ae)for(const ke of ae)ke&&this._edits.push({_type:2,uri:H,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Je=this._edits[ke];Je._type===2&&Je.uri.toString()===H.toString()&&(this._edits[ke]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(H){const ae=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===H.toString()&&ae.push(ke.edit);return ae}entries(){const H=new S.ResourceMap;for(let ae of this._edits)if(ae._type===2){let ke=H.get(ae.uri);ke||(ke=[ae.uri,[]],H.set(ae.uri,ke)),ke[1].push(ae.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};W=Ve([L],W),e.WorkspaceEdit=W;let $=n=class{constructor(H){this._tabstop=1,this.value=H||""}static isSnippetString(H){return H instanceof n?!0:H?typeof H.value=="string":!1}static _escape(H){return H.replace(/\$|}|\\/g,"\\$&")}appendText(H){return this.value+=n._escape(H),this}appendTabstop(H=this._tabstop++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,ae=this._tabstop++){if(typeof H=="function"){const ke=new n;ke._tabstop=this._tabstop,H(ke),this._tabstop=ke._tabstop,H=ke.value}else H=n._escape(H);return this.value+="${",this.value+=ae,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,ae=this._tabstop++){const ke=H.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(H,ae){if(typeof ae=="function"){const ke=new n;ke._tabstop=this._tabstop,ae(ke),this._tabstop=ke._tabstop,ae=ke.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};$=n=Ve([L],$),e.SnippetString=$;var X;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(X=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let de=f=class{constructor(H,ae){if(this.uri=H,ae)if(ae instanceof B)this.range=ae;else if(ae instanceof A)this.range=new B(ae,ae);else throw new Error("Illegal argument")}static isLocation(H){return H instanceof f?!0:H?B.isRange(H.range)&&k.URI.isUri(H.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};de=f=Ve([L],de),e.Location=de;let _e=class{constructor(H,ae){this.location=H,this.message=ae}static is(H){return H?typeof H.message=="string"&&H.location&&B.isRange(H.location.range)&&k.URI.isUri(H.location.uri):!1}static isEqual(H,ae){return H===ae?!0:!H||!ae?!1:H.message===ae.message&&H.location.range.isEqual(ae.location.range)&&H.location.uri.toString()===ae.location.uri.toString()}};_e=Ve([L],_e),e.DiagnosticRelatedInformation=_e;let Ce=class{constructor(H,ae,ke=K.Error){if(!B.isRange(H))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=H,this.message=ae,this.severity=ke}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,ae){return H===ae?!0:!H||!ae?!1:H.message===ae.message&&H.severity===ae.severity&&H.code===ae.code&&H.severity===ae.severity&&H.source===ae.source&&H.range.isEqual(ae.range)&&(0,g.equals)(H.tags,ae.tags)&&(0,g.equals)(H.relatedInformation,ae.relatedInformation,_e.isEqual)}};Ce=Ve([L],Ce),e.Diagnostic=Ce;let Pe=class{constructor(H,ae){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=ae}};Pe=Ve([L],Pe),e.Hover=Pe;var Be;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(Be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $e=class{constructor(H,ae=Be.Text){this.range=H,this.kind=ae}toJSON(){return{range:this.range,kind:Be[this.kind]}}};$e=Ve([L],$e),e.DocumentHighlight=$e;var He;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(He=e.SymbolKind||(e.SymbolKind={}));var G;(function(q){q[q.Deprecated=1]="Deprecated"})(G=e.SymbolTag||(e.SymbolTag={}));let ee=r=class{constructor(H,ae,ke,Je,ot){this.name=H,this.kind=ae,this.containerName=ot,typeof ke=="string"&&(this.containerName=ke),Je instanceof de?this.location=Je:ke instanceof B&&(this.location=new de(Je,ke)),r.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:He[this.kind],location:this.location,containerName:this.containerName}}};ee=r=Ve([L],ee),e.SymbolInformation=ee;let te=t=class{constructor(H,ae,ke,Je,ot){this.name=H,this.detail=ae,this.kind=ke,this.range=Je,this.selectionRange=ot,this.children=[],t.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children&&H.children.forEach(t.validate)}};te=t=Ve([L],te),e.DocumentSymbol=te;var ce;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(ce=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Z=class{constructor(H,ae){this.title=H,this.kind=ae}};Z=Ve([L],Z),e.CodeAction=Z;let re=d=class{constructor(H){this.value=H}append(H){return new d(this.value?this.value+d.sep+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+d.sep)}};re.sep=".",re=d=Ve([L],re),e.CodeActionKind=re,re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll");let pe=class{constructor(H,ae){if(this.range=H,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};pe=Ve([L],pe),e.SelectionRange=pe;class Me{constructor(H,ae,ke,Je,ot,dt){this.kind=H,this.name=ae,this.detail=ke,this.uri=Je,this.range=ot,this.selectionRange=dt}}e.CallHierarchyItem=Me;class je{constructor(H,ae){this.fromRanges=ae,this.from=H}}e.CallHierarchyIncomingCall=je;class Ke{constructor(H,ae){this.fromRanges=ae,this.to=H}}e.CallHierarchyOutgoingCall=Ke;var Ze;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let rt=class{constructor(H,ae){this.range=H,this.command=ae}get isResolved(){return!!this.command}};rt=Ve([L],rt),e.CodeLens=rt;let ct=s=class{constructor(H,ae=!1){h.set(this,void 0),st(this,h,new C.MarkdownString(H,{supportThemeIcons:ae}),"f")}static isMarkdownString(H){return H instanceof s?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}get value(){return Ne(this,h,"f").value}set value(H){Ne(this,h,"f").value=H}get isTrusted(){return Ne(this,h,"f").isTrusted}set isTrusted(H){Ne(this,h,"f").isTrusted=H}get supportThemeIcons(){return Ne(this,h,"f").supportThemeIcons}set supportThemeIcons(H){Ne(this,h,"f").supportThemeIcons=H}get supportHtml(){return Ne(this,h,"f").supportHtml}set supportHtml(H){Ne(this,h,"f").supportHtml=H}appendText(H){return Ne(this,h,"f").appendText(H),this}appendMarkdown(H){return Ne(this,h,"f").appendMarkdown(H),this}appendCodeblock(H,ae){return Ne(this,h,"f").appendCodeblock(ae??"",H),this}};h=new WeakMap,ct=s=Ve([L],ct),e.MarkdownString=ct;let ye=class{constructor(H,ae){this.label=H,this.documentation=ae}};ye=Ve([L],ye),e.ParameterInformation=ye;let at=class{constructor(H,ae){this.label=H,this.documentation=ae,this.parameters=[]}};at=Ve([L],at),e.SignatureInformation=at;let J=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};J=Ve([L],J),e.SignatureHelp=J;var se;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(se=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ee;(function(q){q[q.Other=0]="Other",q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Ee=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(H,ae,ke){this.text=H,this.position=ae,this.kind=ke}};Qe=Ve([L],Qe),e.InlayHint=Qe;var et;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(et=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var le;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(le=e.CompletionItemKind||(e.CompletionItemKind={}));var Ie;(function(q){q[q.Deprecated=1]="Deprecated"})(Ie=e.CompletionItemTag||(e.CompletionItemTag={}));let Ue=class{constructor(H,ae){this.label=H,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ue=Ve([L],Ue),e.CompletionItem=Ue;let Xe=class{constructor(H=[],ae=!1){this.items=H,this.isIncomplete=ae}};Xe=Ve([L],Xe),e.CompletionList=Xe;let it=class{constructor(H,ae,ke){this.text=H,this.range=ae,this.command=ke}};it=Ve([L],it),e.InlineSuggestion=it;let ft=class{constructor(H){this.items=H}};ft=Ve([L],ft),e.InlineSuggestions=ft;var tt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(tt=e.ViewColumn||(e.ViewColumn={}));var ut;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ut=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Re;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Re=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(De=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Te;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Te=e.TextEditorRevealType||(e.TextEditorRevealType={}));var oe;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var we;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(we=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function H(ae){switch(ae){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=H}(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ve=class{constructor(H,ae){if(ae&&!k.URI.isUri(ae))throw(0,F.illegalArgument)("target");if(!B.isRange(H)||H.isEmpty)throw(0,F.illegalArgument)("range");this.range=H,this.target=ae}};ve=Ve([L],ve),e.DocumentLink=ve;let Fe=class{constructor(H,ae,ke,Je){this.red=H,this.green=ae,this.blue=ke,this.alpha=Je}};Fe=Ve([L],Fe),e.Color=Fe;let Ge=class{constructor(H,ae){if(ae&&!(ae instanceof Fe))throw(0,F.illegalArgument)("color");if(!B.isRange(H)||H.isEmpty)throw(0,F.illegalArgument)("range");this.range=H,this.color=ae}};Ge=Ve([L],Ge),e.ColorInformation=Ge;let ze=class{constructor(H){if(!H||typeof H!="string")throw(0,F.illegalArgument)("label");this.label=H}};ze=Ve([L],ze),e.ColorPresentation=ze;var Ye;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Ye=e.ColorFormat||(e.ColorFormat={}));var lt;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class xe{constructor(H,ae,ke){if(this.startIndex=H,this.length=ae,this.tooltip=ke,typeof H!="number"||H<0)throw(0,F.illegalArgument)("startIndex");if(typeof ae!="number"||ae<1)throw(0,F.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=xe;var ge;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(ge=e.TerminalLocation||(e.TerminalLocation={}));class be{constructor(H){this.options=H,typeof H!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=be;var ie;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(ie=e.TaskRevealKind||(e.TaskRevealKind={}));var Q;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(Q=e.TaskPanelKind||(e.TaskPanelKind={}));let Se=c=class{constructor(H,ae){if(this.label=ae,typeof H!="string"||typeof ae!="string")throw(0,F.illegalArgument)("name");this._id=H}static from(H){switch(H){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};Se.Clean=new c("clean","Clean"),Se.Build=new c("build","Build"),Se.Rebuild=new c("rebuild","Rebuild"),Se.Test=new c("test","Test"),Se=c=Ve([L],Se),e.TaskGroup=Se;function Le(q){let H="";for(let ae=0;ae<q.length;ae++)H+=q[ae].replace(/,/g,",,")+",";return H}let nt=class{constructor(H,ae,ke){if(typeof H!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=H,ae!==void 0&&(Array.isArray(ae)?(this._args=ae,this._options=ke):this._options=ae)}get process(){return this._process}set process(H){if(typeof H!="string")throw(0,F.illegalArgument)("process");this._process=H}get args(){return this._args}set args(H){Array.isArray(H)||(H=[]),this._args=H}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("process"),this._process!==void 0&&H.push(this._process),this._args&&this._args.length>0)for(let ae of this._args)H.push(ae);return Le(H)}};nt=Ve([L],nt),e.ProcessExecution=nt;let qe=class{constructor(H,ae,ke){if(this._args=[],Array.isArray(ae)){if(!H)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,F.illegalArgument)("command");this._command=H,this._args=ae,this._options=ke}else{if(typeof H!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=H,this._options=ae}}get commandLine(){return this._commandLine}set commandLine(H){if(typeof H!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=H}get command(){return this._command?this._command:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,F.illegalArgument)("command");this._command=H}get args(){return this._args}set args(H){this._args=H||[]}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("shell"),this._commandLine!==void 0&&H.push(this._commandLine),this._command!==void 0&&H.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ae of this._args)H.push(typeof ae=="string"?ae:ae.value);return Le(H)}};qe=Ve([L],qe),e.ShellExecution=qe;var gt;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(gt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class pt{constructor(H){this._callback=H}computeId(){return"customExecution"+(0,i.generateUuid)()}set callback(H){this._callback=H}get callback(){return this._callback}}e.CustomExecution=pt;let vt=m=class{constructor(H,ae,ke,Je,ot,dt){this.__deprecated=!1,this._definition=this.definition=H;let mt;typeof ae=="string"?(this._name=this.name=ae,this._source=this.source=ke,this.execution=Je,mt=ot,this.__deprecated=!0):ae===Et.Global||ae===Et.Workspace?(this.target=ae,this._name=this.name=ke,this._source=this.source=Je,this.execution=ot,mt=dt):(this.target=ae,this._name=this.name=ke,this._source=this.source=Je,this.execution=ot,mt=dt),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(H){this.__id=H}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof nt?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof pt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,i.generateUuid)()}}get definition(){return this._definition}set definition(H){if(H==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=H}get scope(){return this._scope}set target(H){this.clear(),this._scope=H}get name(){return this._name}set name(H){if(typeof H!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=H}get execution(){return this._execution}set execution(H){H===null&&(H=void 0),this.clear(),this._execution=H;const ae=this._definition.type;(m.EmptyType===ae||m.ProcessType===ae||m.ShellType===ae||m.ExtensionCallbackType===ae)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(H){if(Array.isArray(H))this.clear(),this._problemMatchers=H,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.clear(),this._isBackground=H}get source(){return this._source}set source(H){if(typeof H!="string"||H.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=H}get group(){return this._group}set group(H){H===null&&(H=void 0),this.clear(),this._group=H}get detail(){return this._detail}set detail(H){H===null&&(H=void 0),this._detail=H}get presentationOptions(){return this._presentationOptions}set presentationOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._presentationOptions=H}get runOptions(){return this._runOptions}set runOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._runOptions=H}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=m=Ve([L],vt),e.Task=vt;var wt;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(wt=e.ProgressLocation||(e.ProgressLocation={}));let Dt=class{constructor(H,ae=Ct.None){this.collapsibleState=ae,k.URI.isUri(H)?this.resourceUri=H:this.label=H}};Dt=Ve([L],Dt),e.TreeItem=Dt;var Ct;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Tt=class{constructor(H,ae){this.id=H,this.color=ae}};Tt=Ve([L],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let Nt=class{constructor(H){this.id=H}};Nt=Ve([L],Nt),e.ThemeColor=Nt;var It;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(It=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ut=class{constructor(H,ae){if(typeof H!="string"&&(!H||!k.URI.isUri(H)&&!k.URI.isUri(H.uri)))throw(0,F.illegalArgument)("base");if(typeof ae!="string")throw(0,F.illegalArgument)("pattern");typeof H=="string"?(this.baseFolder=k.URI.file(H),this.base=H):k.URI.isUri(H)?(this.baseFolder=H,this.base=H.fsPath):(this.baseFolder=H.uri,this.base=H.uri.fsPath),this.pattern=ae}};Ut=Ve([L],Ut),e.RelativePattern=Ut;let $t=class{constructor(H,ae,ke,Je){this.enabled=typeof H=="boolean"?H:!0,typeof ae=="string"&&(this.condition=ae),typeof ke=="string"&&(this.hitCondition=ke),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,i.generateUuid)()),this._id}};$t=Ve([L],$t),e.Breakpoint=$t;let St=class extends $t{constructor(H,ae,ke,Je,ot){super(ae,ke,Je,ot);if(H===null)throw(0,F.illegalArgument)("location");this.location=H}};St=Ve([L],St),e.SourceBreakpoint=St;let Qt=class extends $t{constructor(H,ae,ke,Je,ot){super(ae,ke,Je,ot);this.functionName=H}};Qt=Ve([L],Qt),e.FunctionBreakpoint=Qt;let zt=class extends $t{constructor(H,ae,ke,Je,ot,dt,mt){super(Je,ot,dt,mt);if(!ae)throw(0,F.illegalArgument)("dataId");this.label=H,this.dataId=ae,this.canPersist=ke}};zt=Ve([L],zt),e.DataBreakpoint=zt;let nn=class{constructor(H,ae,ke){this.command=H,this.args=ae||[],this.options=ke}};nn=Ve([L],nn),e.DebugAdapterExecutable=nn;let rn=class{constructor(H,ae){this.port=H,this.host=ae}};rn=Ve([L],rn),e.DebugAdapterServer=rn;let At=class{constructor(H){this.path=H}};At=Ve([L],At),e.DebugAdapterNamedPipeServer=At;let Xt=class{constructor(H){this.implementation=H}};Xt=Ve([L],Xt),e.DebugAdapterInlineImplementation=Xt;let sn=class{constructor(H,ae){this.range=H,this.expression=ae}};sn=Ve([L],sn),e.EvaluatableExpression=sn;var Yt;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(Yt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(H,ae){this.range=H,this.text=ae}};Wt=Ve([L],Wt),e.InlineValueText=Wt;let bt=class{constructor(H,ae,ke=!0){this.range=H,this.variableName=ae,this.caseSensitiveLookup=ke}};bt=Ve([L],bt),e.InlineValueVariableLookup=bt;let on=class{constructor(H,ae){this.range=H,this.expression=ae}};on=Ve([L],on),e.InlineValueEvaluatableExpression=on;let Ft=class{constructor(H,ae){this.frameId=H,this.stoppedLocation=ae}};Ft=Ve([L],Ft),e.InlineValueContext=Ft;var Vt;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let Jt=u=class extends Error{constructor(H,ae=I.FileSystemProviderErrorCode.Unknown,ke){super(k.URI.isUri(H)?H.toString(!0):H);this.code=ke?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,ae),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(H){return new u(H,I.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(H){return new u(H,I.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(H){return new u(H,I.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(H){return new u(H,I.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(H){return new u(H,I.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(H){return new u(H,I.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}};Jt=u=Ve([L],Jt),e.FileSystemError=Jt;let an=class{constructor(H,ae,ke){this.start=H,this.end=ae,this.kind=ke}};an=Ve([L],an),e.FoldingRange=an;var hn;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(hn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var bn;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(bn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var fn;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(fn=e.CommentMode||(e.CommentMode={}));class Zt{constructor(H,ae=[]){this.tokenTypes=H,this.tokenModifiers=ae}}e.SemanticTokensLegend=Zt;function En(q){return typeof q=="undefined"||(0,y.isStringArray)(q)}class jt{constructor(H){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,H){this._hasLegend=!0;for(let ae=0,ke=H.tokenTypes.length;ae<ke;ae++)this._tokenTypeStrToInt.set(H.tokenTypes[ae],ae);for(let ae=0,ke=H.tokenModifiers.length;ae<ke;ae++)this._tokenModifierStrToInt.set(H.tokenModifiers[ae],ae)}}push(H,ae,ke,Je,ot){if(typeof H=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof Je=="number"&&(typeof ot=="number"||typeof ot=="undefined"))return typeof ot=="undefined"&&(ot=0),this._pushEncoded(H,ae,ke,Je,ot);if(B.isRange(H)&&typeof ae=="string"&&En(ke))return this._push(H,ae,ke);throw(0,F.illegalArgument)()}_push(H,ae,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ae))throw new Error("`tokenType` is not in the provided legend");const Je=H.start.line,ot=H.start.character,dt=H.end.character-H.start.character,mt=this._tokenTypeStrToInt.get(ae);let kt=0;if(ke)for(const Rt of ke){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Mt=this._tokenModifierStrToInt.get(Rt);kt|=1<<Mt>>>0}this._pushEncoded(Je,ot,dt,mt,kt)}_pushEncoded(H,ae,ke,Je,ot){if(this._dataIsSortedAndDeltaEncoded&&(H<this._prevLine||H===this._prevLine&&ae<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Rt=0,Mt=0;for(let Ot=0;Ot<kt;Ot++){let xt=this._data[5*Ot],un=this._data[5*Ot+1];xt===0?(xt=Rt,un+=Mt):xt+=Rt,this._data[5*Ot]=xt,this._data[5*Ot+1]=un,Rt=xt,Mt=un}}let dt=H,mt=ae;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=ot,this._prevLine=H,this._prevChar=ae}static _sortAndDeltaEncode(H){let ae=[];const ke=H.length/5|0;for(let mt=0;mt<ke;mt++)ae[mt]=mt;ae.sort((mt,kt)=>{const Rt=H[5*mt],Mt=H[5*kt];if(Rt===Mt){const Ot=H[5*mt+1],xt=H[5*kt+1];return Ot-xt}return Rt-Mt});const Je=new Uint32Array(H.length);let ot=0,dt=0;for(let mt=0;mt<ke;mt++){const kt=5*ae[mt],Rt=H[kt+0],Mt=H[kt+1],Ot=H[kt+2],xt=H[kt+3],un=H[kt+4],Bn=Rt-ot,Kn=Bn===0?Mt-dt:Mt,dn=5*mt;Je[dn+0]=Bn,Je[dn+1]=Kn,Je[dn+2]=Ot,Je[dn+3]=xt,Je[dn+4]=un,ot=Rt,dt=Mt}return Je}build(H){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),H):new qt(jt._sortAndDeltaEncode(this._data),H)}}e.SemanticTokensBuilder=jt;class qt{constructor(H,ae){this.resultId=ae,this.data=H}}e.SemanticTokens=qt;class _n{constructor(H,ae,ke){this.start=H,this.deleteCount=ae,this.data=ke}}e.SemanticTokensEdit=_n;class Sn{constructor(H,ae){this.resultId=ae,this.edits=H}}e.SemanticTokensEdits=Sn;var Gt;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yn;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(yn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let en=class{constructor(){}};en.Back={iconPath:new Tt("arrow-left")},en=Ve([L],en),e.QuickInputButtons=en;var Dn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(H,ae,ke){this.badge=H,this.tooltip=ae,this.color=ke}static validate(H){if(H.badge){let ae=(0,_.nextCharLength)(H.badge,0);if(ae<H.badge.length&&(ae+=(0,_.nextCharLength)(H.badge,ae)),H.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Cn;let Kt=class{constructor(H){this.kind=H}};Kt=Ve([L],Kt),e.ColorTheme=Kt;var mn;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(mn=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(H,ae){if(H<0)throw(0,F.illegalArgument)("start must be positive");if(ae<0)throw(0,F.illegalArgument)("end must be positive");H<=ae?(this._start=H,this._end=ae):(this._start=ae,this._end=H)}static isNotebookRange(H){return H instanceof Ht?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(H){let ae=this._start,ke=this._end;return H.start!==void 0&&(ae=H.start),H.end!==void 0&&(ke=H.end),ae===this._start&&ke===this._end?this:new Ht(ae,ke)}}e.NotebookRange=Ht;class Oe{constructor(H,ae,ke,Je,ot,dt,mt){this.kind=H,this.value=ae,this.languageId=ke,this.mime=Je,this.outputs=ot??[],this.metadata=dt,this.executionSummary=mt,Oe.validate(this)}static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(ae=>Oe.isNotebookCellData(ae))}static isNotebookCellData(H){return!0}}e.NotebookCellData=Oe;class ln{constructor(H){this.cells=H}}e.NotebookData=ln;class Lt{constructor(H,ae){this.data=H,this.mime=ae;const ke=(0,P.normalizeMimeType)(ae,!0);if(!ke)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}static isNotebookCellOutputItem(H){return H instanceof Lt?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const ae={name:H.name,message:H.message,stack:H.stack};return Lt.json(ae,"application/vnd.code.notebook.error")}static stdout(H){return Lt.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return Lt.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,ae="application/octet-stream"){return new Lt(H,ae)}static text(H,ae=P.Mimes.text){const ke=Ne(Lt,w,"f",D).encode(String(H));return new Lt(ke,ae)}static json(H,ae="application/json"){const ke=JSON.stringify(H,void 0,"	");return Lt.text(ke,ae)}}e.NotebookCellOutputItem=Lt,w=Lt,D={value:new TextEncoder};class _t{constructor(H,ae,ke){this.items=_t.ensureUniqueMimeTypes(H,!0),typeof ae=="string"?(this.id=ae,this.metadata=ke):(this.id=(0,i.generateUuid)(),this.metadata=ae??ke)}static isNotebookCellOutput(H){return H instanceof _t?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&(0,y.isArray)(H.items)}static ensureUniqueMimeTypes(H,ae=!1){const ke=new Set,Je=new Set;for(let ot=0;ot<H.length;ot++){const dt=H[ot],mt=(0,P.normalizeMimeType)(dt.mime);if(!ke.has(mt)){ke.add(mt);continue}Je.add(ot),ae&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Je.size===0?H:H.filter((ot,dt)=>!Je.has(dt))}}e.NotebookCellOutput=_t;var kn;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(kn=e.NotebookCellKind||(e.NotebookCellKind={}));var In;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(In=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var gn;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var pn;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Pn{constructor(H,ae){this.text=H,this.alignment=ae}}e.NotebookCellStatusBarItem=Pn;var Tn;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(Tn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class An{constructor(H,ae=[]){this.uri=H,this.provides=(0,g.asArray)(ae)}}e.NotebookRendererScript=An;let cn=class{constructor(H,ae){this.label=H,this.timestamp=ae}};cn=Ve([L],cn),e.TimelineItem=cn;var vn;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(vn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ln;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(Ln=e.StandardTokenType||(e.StandardTokenType={}));class Fn{constructor(H,ae){this.ranges=H,this.wordPattern=ae}}e.LinkedEditingRanges=Fn;class Mn{constructor(H,ae){this._port=H,this._autoForwardAction=ae}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mn;var On;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(On=e.TestResultState||(e.TestResultState={}));var ne;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(ne=e.TestRunProfileKind||(e.TestRunProfileKind={}));let he=class{constructor(H,ae,ke){this.include=H,this.exclude=ae,this.profile=ke}};he=Ve([L],he),e.TestRunRequest=he;let Ae=E=class{constructor(H){this.message=H}static diff(H,ae,ke){const Je=new E(H);return Je.expectedOutput=ae,Je.actualOutput=ke,Je}};Ae=E=Ve([L],Ae),e.TestMessage=Ae;let ht=class{constructor(H){this.id=H}};ht=Ve([L],ht),e.TestTag=ht;let yt=class{constructor(H,ae){this.covered=H,this.total=ae}};yt=Ve([L],yt),e.CoveredCount=yt;let Pt=R=class{constructor(H,ae,ke,Je){this.uri=H,this.statementCoverage=ae,this.branchCoverage=ke,this.functionCoverage=Je}static fromDetails(H,ae){const ke=new yt(0,0),Je=new yt(0,0),ot=new yt(0,0);for(const mt of ae)if("branches"in mt){ke.total+=1,ke.covered+=mt.executionCount>0?1:0;for(const kt of mt.branches)Je.total+=1,Je.covered+=kt.executionCount>0?1:0}else ot.total+=1,ot.covered+=mt.executionCount>0?1:0;const dt=new R(H,ke,Je.total>0?Je:void 0,ot.total>0?ot:void 0);return dt.detailedCoverage=ae,dt}};Pt=R=Ve([L],Pt),e.FileCoverage=Pt;let Nn=class{constructor(H,ae,ke=[]){this.executionCount=H,this.location=ae,this.branches=ke}};Nn=Ve([L],Nn),e.StatementCoverage=Nn;let Un=class{constructor(H,ae){this.executionCount=H,this.location=ae}};Un=Ve([L],Un),e.BranchCoverage=Un;let xn=class{constructor(H,ae){this.executionCount=H,this.location=ae}};xn=Ve([L],xn),e.FunctionCoverage=xn;var Vn;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(Vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var jn;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(jn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var qn;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(qn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Gn{constructor(H,ae,ke,Je,ot,dt){this.kind=H,this.name=ae,this.detail=ke,this.uri=Je,this.range=ot,this.selectionRange=dt}}e.TypeHierarchyItem=Gn}),define(fe[125],me([0,1,58,10,9,151,111,7,18]),function(Y,e,g,F,C,S,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function i(h,w){w?k.set(h,w):k.delete(h)}e.setWordDefinitionFor=i;function I(h){return k.get(h)}e.getWordDefinitionFor=I;class a extends S.MirrorTextModel{constructor(w,D,T,b,l,o,v,n){super(D,T,b,l);this._proxy=w,this._languageId=o,this._isDirty=v,this._notebook=n,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,y.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===F.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},get notebook(){return w._notebook},save(){return w._save()},getText(D){return D?w._getTextInRange(D):w.getText()},get eol(){return w._eol===`
`?_.EndOfLine.LF:_.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(D){return w._lineAt(D)},offsetAt(D){return w._offsetAt(D)},positionAt(D){return w._positionAt(D)},validateRange(D){return w._validateRange(D)},validatePosition(D){return w._validatePosition(D)},getWordRangeAtPosition(D,T){return w._getWordRangeAtPosition(D,T)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,g.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,g.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const D=this._validateRange(w);if(D.isEmpty)return"";if(D.isSingleLine)return this._lines[D.start.line].substring(D.start.character,D.end.character);const T=this._eol,b=D.start.line,l=D.end.line,o=[];o.push(this._lines[b].substring(D.start.character));for(let v=b+1;v<l;v++)o.push(this._lines[v]);return o.push(this._lines[l].substring(0,D.end.character)),o.join(T)}_lineAt(w){let D;if(w instanceof _.Position?D=w.line:typeof w=="number"&&(D=w),typeof D!="number"||D<0||D>=this._lines.length||Math.floor(D)!==D)throw new Error("Illegal value for `line`");return new p(D,this._lines[D],D===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const D=this._lineStarts.getIndexOf(w),T=this._lines[D.index].length;return new _.Position(D.index,Math.min(D.remainder,T))}_validateRange(w){if(!(w instanceof _.Range))throw new Error("Invalid argument");const D=this._validatePosition(w.start),T=this._validatePosition(w.end);return D===w.start&&T===w.end?w:new _.Range(D.line,D.character,T.line,T.character)}_validatePosition(w){if(!(w instanceof _.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:D,character:T}=w,b=!1;if(D<0)D=0,T=0,b=!0;else if(D>=this._lines.length)D=this._lines.length-1,T=this._lines[D].length,b=!0;else{const l=this._lines[D].length;T<0?(T=0,b=!0):T>l&&(T=l,b=!0)}return b?new _.Position(D,T):w}_getWordRangeAtPosition(w,D){const T=this._validatePosition(w);if(!D)D=I(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(D))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${D.source}' because it matches the empty string.`);const b=(0,P.getWordAtText)(T.character+1,(0,P.ensureValidWordDefinition)(D),this._lines[T.line],0);if(b)return new _.Range(T.line,b.startColumn-1,T.line,b.endColumn-1)}}e.ExtHostDocumentData=a;class p{constructor(w,D,T){this._line=w,this._text=D,this._isLastLine=T}get lineNumber(){return this._line}get text(){return this._text}get range(){return new _.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new _.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(fe[204],me([0,1,7,3,113,6,82,24,2,32]),function(Y,e,g,F,C,S,P,_,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(a,p,h,w){this._notebook=h,this._selector=w,this._disposables=new S.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(T=>{const b=this._cellUris.get(T.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const D=T=>{T===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(a.onDidChangeNotebookCells(T=>D(T.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new _.ResourceMap;const a=[],p=[];for(const h of this._notebook.getCells())h.kind===g.NotebookCellKind.Code&&(!this._selector||(0,P.score)(this._selector,h.document.uri,h.document.languageId,!0))&&(this._cellUris.set(h.document.uri,this._cells.length),this._cells.push(h),a.push(h.document.getText().length+1),p.push(h.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(a)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(a){if(!a){let b="";for(const l of this._cells)b+=l.document.getText()+`
`;return b=b.slice(0,-1),b}if(a.isEmpty)return"";const p=this.locationAt(a.start),h=this.locationAt(a.end),w=this._cellUris.get(p.uri),D=this._cellUris.get(h.uri);if(w===void 0||D===void 0)return"";if(w===D)return this._cells[w].document.getText(new g.Range(p.range.start,h.range.end));const T=[this._cells[w].document.getText(new g.Range(p.range.start,new g.Position(this._cells[w].document.lineCount,0)))];for(let b=w+1;b<D;b++)T.push(this._cells[b].document.getText());return T.push(this._cells[D].document.getText(new g.Range(new g.Position(0,0),h.range.end))),T.join(`
`)}offsetAt(a){const p=this._cellLines.getIndexOf(a.line),h=this._cellLengths.getPrefixSum(p.index-1),w=this._cells[p.index].document.offsetAt(a.with(p.remainder));return h+w}positionAt(a){if(typeof a=="number"){const h=this._cellLengths.getIndexOf(a),w=this._cellLines.getPrefixSum(h.index-1);return this._cells[h.index].document.positionAt(h.remainder).translate(w)}const p=this._cellUris.get(a.uri);if(p!==void 0){const h=this._cellLines.getPrefixSum(p-1);return new g.Position(h+a.range.start.line,a.range.start.character)}return new g.Position(0,0)}locationAt(a){g.Range.isRange(a)||(a=new g.Range(a,a));const p=this._cellLines.getIndexOf(a.start.line);let h=p;a.isEmpty||(h=this._cellLines.getIndexOf(a.end.line));const w=new g.Position(p.remainder,a.start.character),D=new g.Position(h.remainder,a.end.character),T=new g.Range(w,D),b=this._cells[p.index];return new g.Location(b.document.uri,b.document.validateRange(T))}contains(a){return this._cellUris.has(a)}validateRange(a){const p=this.validatePosition(a.start),h=this.validatePosition(a.end);return a.with(p,h)}validatePosition(a){const p=this._cellLines.getIndexOf(a.line),h=new g.Position(p.remainder,a.character),w=this._cells[p.index].document.validatePosition(h),D=this._cellLines.getPrefixSum(p.index-1);return new g.Position(D+w.line,w.character)}}e.ExtHostNotebookConcatDocument=i}),define(fe[205],me([0,1,7,14,3]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let S=class{constructor(_){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(_){let y=_==="light"?g.ColorThemeKind.Light:_==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};S=Ve([We(0,F.IExtHostRpcService)],S),e.ExtHostTheming=S}),define(fe[67],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class F{constructor(S){S?(this.transformIncoming=S.transformIncoming.bind(S),this.transformOutgoing=S.transformOutgoing.bind(S),this.transformOutgoingURI=S.transformOutgoingURI.bind(S),this.transformOutgoingScheme=S.transformOutgoingScheme.bind(S)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.URITransformerService=F}),define(fe[206],me([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(y){let k=this.buffers.indexOf(y);return k<0&&(k=this.buffers.length,this.buffers.push(y)),k}}function C(_,y){if(y.serializeBuffersForPostMessage){const k=new F,i=(p,h)=>{if(h instanceof ArrayBuffer){const w=k.add(h);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(h)){const w=S(h);if(w){const D=k.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:D,view:{type:w,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},I=JSON.stringify(_,i),a=k.buffers.map(p=>{const h=new Uint8Array(p);return g.VSBuffer.wrap(h)});return{message:I,buffers:a}}else return{message:JSON.stringify(_),buffers:[]}}e.serializeWebviewMessage=C;function S(_){switch(_.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(_,y){const k=y.map(a=>{const p=new ArrayBuffer(a.byteLength);return new Uint8Array(p).set(a.buffer),p}),i=y.length?(a,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const h=p,{index:w}=h,D=k[w];if(h.view)switch(h.view.type){case 1:return new Int8Array(D,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(D,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(D,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(D,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(D,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(D,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(D,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(D,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(D,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(D,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(D,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return D}return p}:void 0;return{message:JSON.parse(_,i),arrayBuffers:k}}e.deserializeWebviewMessage=P}),define(fe[207],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(F){function C(P){const _={items:new Map};return P.types.forEach((y,k)=>{_.items.set(y,{asString:async()=>P.items[k].asString})}),_}F.toITreeDataTransfer=C;async function S(P){const _={types:[],items:[]},y=Array.from(P.items.entries());for(const k of y)_.types.push(k[0]),_.items.push({asString:await k[1].asString()});return _}F.toTreeDataTransferDTO=S})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(fe[88],me([0,1,10,2]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function C(_,y){return _.scheme===g.Schemas.http||_.scheme===g.Schemas.https?_:(y&&y.authority&&y.isRemote&&_.scheme===g.Schemas.file&&(_=F.URI.from({scheme:g.Schemas.vscodeRemote,authority:y.authority,path:_.path})),F.URI.from({scheme:g.Schemas.https,authority:`${_.scheme}+${S(_.authority)}.${e.webviewRootResourceAuthority}`,path:_.path,fragment:_.fragment,query:_.query}))}e.asWebviewUri=C;function S(_){return _.replace(/./g,y=>{const k=y.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?y:"-"+k.toString(16).padStart(4,"0")})}function P(_){return _.replace(/-([0-9a-f]{4})/g,(y,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=P}),define(fe[208],me([0,1,3,6,88]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(_,y,k){this._proxy=_,this._editors=y,this._initData=k,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const i=y.getVisibleTextEditors();for(const I of this._insets.values())i.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(_=>_.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(_,y,k,i,I){let a;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===_){a=l;break}if(!a)throw new Error("not a visible editor");const p=this,h=this._handlePool++,w=new g.Emitter,D=new g.Emitter,T=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,C.asWebviewUri)(l,p._initData.remote)}get cspSource(){return C.webviewGenericCspSource}set options(l){this._options=l,p._proxy.$setOptions(h,l)}get options(){return this._options}set html(l){this._html=l,p._proxy.$setHtml(h,l)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(l){return p._proxy.$postMessage(h,l)}},b=new class{constructor(){this.editor=_,this.line=y,this.height=k,this.webview=T,this.onDidDispose=D.event}dispose(){p._insets.has(h)&&(p._insets.delete(h),p._proxy.$disposeEditorInset(h),D.fire(),D.dispose(),w.dispose())}};return this._proxy.$createEditorInset(h,a.id,a.value.document.uri,y+1,k,i||{},I.identifier,I.extensionLocation),this._insets.set(h,{editor:_,inset:b,onDidReceiveMessage:w}),b}$onDidDispose(_){const y=this._insets.get(_);y&&y.inset.dispose()}$onDidReceiveMessage(_,y){const k=this._insets.get(_);k&&k.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=S}),define(fe[209],me([0,1,174,12,2,6,4,63,34,18,10]),function(Y,e,g,F,C,S,P,_,y,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new _.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new _.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new _.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new _.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new _.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new _.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new _.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new _.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new _.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new _.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.SideBySideEditorActiveContext=new _.RawContextKey("sideBySideEditorActive",!1,(0,g.localize)(11,null)),e.EditorGroupEditorsCountContext=new _.RawContextKey("groupEditorsCount",0,(0,g.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new _.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(13,null)),e.ActiveEditorGroupIndexContext=new _.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(14,null)),e.ActiveEditorGroupLastContext=new _.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(15,null)),e.ActiveEditorGroupLockedContext=new _.RawContextKey("activeEditorGroupLocked",!1,(0,g.localize)(16,null)),e.MultipleEditorGroupsContext=new _.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new _.RawContextKey("editorIsOpen",!1,(0,g.localize)(18,null)),e.InEditorZenModeContext=new _.RawContextKey("inZenMode",!1,(0,g.localize)(19,null)),e.IsCenteredLayoutContext=new _.RawContextKey("isCenteredLayout",!1,(0,g.localize)(20,null)),e.SplitEditorsVertically=new _.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(21,null)),e.EditorAreaVisibleContext=new _.RawContextKey("editorAreaVisible",!0,(0,g.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function I(M,A,B){for(const V of B.visibleEditorPanes)if(V.group.id===A&&M.matches(V.input))return V.getViewState()}e.findViewStateForEditor=I;function a(M){if(o(M))return!1;const A=M;return C.URI.isUri(A?.resource)}e.isResourceEditorInput=a;function p(M){if(o(M))return!1;const A=M;return A?.original!==void 0&&A.modified!==void 0}e.isResourceDiffEditorInput=p;function h(M){if(o(M)||p(M))return!1;const A=M;return A?.primary!==void 0&&A.secondary!==void 0}e.isResourceSideBySideEditorInput=h;function w(M){if(o(M))return!1;const A=M;return A?A.resource===void 0||A.resource.scheme===i.Schemas.untitled||A.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=w;var D;(function(M){M[M.SHORT=0]="SHORT",M[M.MEDIUM=1]="MEDIUM",M[M.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var T;(function(M){M[M.EXPLICIT=1]="EXPLICIT",M[M.AUTO=2]="AUTO",M[M.FOCUS_CHANGE=3]="FOCUS_CHANGE",M[M.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(T=e.SaveReason||(e.SaveReason={}));var b;(function(M){M[M.None=0]="None",M[M.Readonly=2]="Readonly",M[M.Untitled=4]="Untitled",M[M.Singleton=8]="Singleton",M[M.RequiresTrust=16]="RequiresTrust",M[M.CanSplitInGroup=32]="CanSplitInGroup",M[M.ForceDescription=64]="ForceDescription"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class l extends S.Disposable{}e.AbstractEditorInput=l;function o(M){return M instanceof l}e.isEditorInput=o;function v(M){const A=M;return C.URI.isUri(A?.preferredResource)}function n(M){const A=M;return o(A?.primary)&&o(A?.secondary)}e.isSideBySideEditorInput=n;function f(M){const A=M;return o(A?.modified)&&o(A?.original)}e.isDiffEditorInput=f;function r(M){return o(M?.editor)}e.isEditorInputWithOptions=r;function t(M){const A=M;return r(M)&&A?.group!==void 0}e.isEditorInputWithOptionsAndGroup=t;function d(M){const A=M;return typeof A?.groupId=="number"&&o(A.editor)}e.isEditorIdentifier=d;var s;(function(M){M[M.UNKNOWN=0]="UNKNOWN",M[M.REPLACE=1]="REPLACE",M[M.MOVE=2]="MOVE",M[M.UNPIN=3]="UNPIN"})(s=e.EditorCloseContext||(e.EditorCloseContext={}));var c;(function(M){M[M.PRIMARY=1]="PRIMARY",M[M.SECONDARY=2]="SECONDARY",M[M.BOTH=3]="BOTH",M[M.ANY=4]="ANY"})(c=e.SideBySideEditor||(e.SideBySideEditor={}));class m{getOriginalUri(A,B){if(!A)return;if(B?.supportSideBySide){const{primary:N,secondary:j}=this.getSideEditors(A);if(N&&j){if(B?.supportSideBySide===c.BOTH)return{primary:this.getOriginalUri(N,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===c.ANY)return this.getOriginalUri(N,{filterByScheme:B.filterByScheme})??this.getOriginalUri(j,{filterByScheme:B.filterByScheme});A=B.supportSideBySide===c.PRIMARY?N:j}}if(p(A)||h(A))return;const V=v(A)?A.preferredResource:A.resource;return!V||!B||!B.filterByScheme?V:this.filterUri(V,B.filterByScheme)}getSideEditors(A){return n(A)||h(A)?{primary:A.primary,secondary:A.secondary}:f(A)||p(A)?{primary:A.modified,secondary:A.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(A,B){if(!A)return;if(B?.supportSideBySide){const{primary:N,secondary:j}=this.getSideEditors(A);if(N&&j){if(B?.supportSideBySide===c.BOTH)return{primary:this.getCanonicalUri(N,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===c.ANY)return this.getCanonicalUri(N,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(j,{filterByScheme:B.filterByScheme});A=B.supportSideBySide===c.PRIMARY?N:j}}if(p(A)||h(A))return;const V=A.resource;return!V||!B||!B.filterByScheme?V:this.filterUri(V,B.filterByScheme)}filterUri(A,B){if(Array.isArray(B)){if(B.some(V=>A.scheme===V))return A}else if(B===A.scheme)return A}}e.EditorResourceAccessor=new m;var u;(function(M){M[M.LEFT=0]="LEFT",M[M.RIGHT=1]="RIGHT"})(u=e.CloseDirection||(e.CloseDirection={}));class E{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(A){const B=this.instantiationService=A.get(P.IInstantiationService);for(const[V,N]of this.editorSerializerConstructors)this.createEditorSerializer(V,N,B);this.editorSerializerConstructors.clear()}createEditorSerializer(A,B,V){const N=V.createInstance(B);this.editorSerializerInstances.set(A,N)}registerFileEditorFactory(A){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=A}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(A,B){if(this.editorSerializerConstructors.has(A)||this.editorSerializerInstances.has(A))throw new Error(`A editor serializer with type ID '${A}' was already registered.`);return this.instantiationService?this.createEditorSerializer(A,B,this.instantiationService):this.editorSerializerConstructors.set(A,B),(0,S.toDisposable)(()=>{this.editorSerializerConstructors.delete(A),this.editorSerializerInstances.delete(A)})}getEditorSerializer(A){return this.editorSerializerInstances.get(typeof A=="string"?A:A.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new E);async function R(M,A){if(!M||!M.length)return[];const B=await Promise.all(M.map(async V=>{const N=C.URI.revive(V.fileUri);if(!N||!await A.canHandleResource(N))return;const U=typeof V.exists=="boolean"?V.exists:await A.exists(N);if(!U&&V.openOnlyIfExists)return;const x={selection:U?V.selection:void 0,pinned:!0,override:V.editorOverrideId};let z;return U?z={resource:N,options:x}:z={resource:N,options:x,forceUntitled:!0},z}));return(0,k.coalesce)(B)}e.pathsToEditors=R;var L;(function(M){M[M.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",M[M.SEQUENTIAL=1]="SEQUENTIAL"})(L=e.EditorsOrder||(e.EditorsOrder={}))}),define(fe[210],me([0,1,3,63,175,4,6,24,34,18,59,25,47,199]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,p.registerIcon)("default-view-icon",a.Codicon.window,(0,C.localize)(0,null));var h;(function(d){d.ViewContainersRegistry="workbench.registry.view.containers",d.ViewsRegistry="workbench.registry.view"})(h=e.Extensions||(e.Extensions={}));var w;(function(d){d[d.Sidebar=0]="Sidebar",d[d.Panel=1]="Panel",d[d.AuxiliaryBar=2]="AuxiliaryBar"})(w=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function D(d){switch(d){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=D;function T(d){return`viewContainer.${d}.enabled`}e.getEnabledViewContainerContextKey=T;class b extends P.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(s,c,m){const u=this.get(s.id);if(u)return u;const E=s;return E.openCommandActionDescriptor=m?.donotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,_.getOrSet)(this.viewContainers,c,[]).push(E),m?.isDefault&&this.defaultViewContainers.push(E),this._onDidRegister.fire({viewContainer:E,viewContainerLocation:c}),E}deregisterViewContainer(s){for(const c of this.viewContainers.keys()){const m=this.viewContainers.get(c),u=m?.indexOf(s);if(u!==-1){m?.splice(u,1),m.length===0&&this.viewContainers.delete(c),this._onDidDeregister.fire({viewContainer:s,viewContainerLocation:c});return}}}get(s){return this.all.filter(c=>c.id===s)[0]}getViewContainers(s){return[...this.viewContainers.get(s)||[]]}getViewContainerLocation(s){return[...this.viewContainers.keys()].filter(c=>this.getViewContainers(c).filter(m=>m?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.defaultViewContainers.find(c=>this.getViewContainerLocation(c)===s)}}y.Registry.add(h.ViewContainersRegistry,new b);var l;(function(d){d.Open="2_open",d.Debug="4_debug",d.SCM="5_scm",d.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function o(d,s){const c=d.group??l.More,m=s.group??l.More;return c!==m?c.localeCompare(m):(d.order??5)-(s.order??5)}class v extends P.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(s,c){this.registerViews2([{views:s,viewContainer:c}])}registerViews2(s){s.forEach(({views:c,viewContainer:m})=>this.addViews(c,m)),this._onViewsRegistered.fire(s)}deregisterViews(s,c){const m=this.removeViews(s,c);m.length&&this._onViewsDeregistered.fire({views:m,viewContainer:c})}moveViews(s,c){for(const m of this._views.keys())if(m!==c){const u=this.removeViews(s,m);u.length&&(this.addViews(u,c),this._onDidChangeContainer.fire({views:u,from:m,to:c}))}}getViews(s){return this._views.get(s)||[]}getView(s){for(const c of this._viewContainers){const m=(this._views.get(c)||[]).filter(u=>u.id===s)[0];if(m)return m}return null}getViewContainer(s){for(const c of this._viewContainers)if((this._views.get(c)||[]).filter(u=>u.id===s)[0])return c;return null}registerViewWelcomeContent(s,c){return this._viewWelcomeContents.add(s,c),this._onDidChangeViewWelcomeContent.fire(s),(0,P.toDisposable)(()=>{this._viewWelcomeContents.delete(s,c),this._onDidChangeViewWelcomeContent.fire(s)})}registerViewWelcomeContent2(s,c){const m=new Map;for(const[u,E]of c)this._viewWelcomeContents.add(s,E),m.set(u,(0,P.toDisposable)(()=>{this._viewWelcomeContents.delete(s,E),this._onDidChangeViewWelcomeContent.fire(s)}));return this._onDidChangeViewWelcomeContent.fire(s),m}getViewWelcomeContent(s){const c=[];return this._viewWelcomeContents.forEach(s,m=>c.push(m)),c.sort(o)}addViews(s,c){let m=this._views.get(c);m||(m=[],this._views.set(c,m),this._viewContainers.push(c));for(const u of s){if(this.getView(u.id)!==null)throw new Error((0,C.localize)(1,null,u.id));m.push(u)}}removeViews(s,c){const m=this._views.get(c);if(!m)return[];const u=[],E=[];for(const R of m)s.includes(R)?u.push(R):E.push(R);return u.length&&(E.length?this._views.set(c,E):(this._views.delete(c),this._viewContainers.splice(this._viewContainers.indexOf(c),1))),u}}y.Registry.add(h.ViewsRegistry,new v),e.IViewsService=(0,S.createDecorator)("viewsService"),e.FocusedViewContext=new F.RawContextKey("focusedView","",(0,C.localize)(2,null));function n(d){return`view.${d}.visible`}e.getVisbileViewContextKey=n,e.IViewDescriptorService=(0,S.createDecorator)("viewDescriptorService");var f;(function(d){d[d.Default=0]="Default",d[d.Expand=1]="Expand"})(f=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(s,c){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,s),this._hasResolve=!!c,this.resolve=async m=>{if(c&&!this.resolved){const u=await c(m);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}m.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(fe[126],me([0,1,3,15,176]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class S{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(_){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=_}onEvent(_){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=_}onRequest(_){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=_}sendResponse(_){_.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${_.command}`)):this.internalSend("response",_)}sendRequest(_,y,k,i){const I={command:_};if(y&&Object.keys(y).length>0&&(I.arguments=y),this.internalSend("request",I),typeof i=="number"){const a=setTimeout(()=>{clearTimeout(a);const p=this.pendingRequests.get(I.seq);if(p){this.pendingRequests.delete(I.seq);const h={type:"response",seq:0,request_seq:I.seq,success:!1,command:_,message:(0,C.localize)(0,null,i,_)};p(h)}},i)}return k&&this.pendingRequests.set(I.seq,k),I.seq}acceptMessage(_){this.messageCallback?this.messageCallback(_):(this.queue.push(_),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(_,y){return _.type!=="event"||y.type!=="event"}async processQueue(){let _;for(;this.queue.length;){if((!_||this.needsTaskBoundaryBetween(this.queue[0],_))&&await(0,F.timeout)(0),_=this.queue.shift(),!_)return;switch(_.type){case"event":this.eventCallback&&this.eventCallback(_);break;case"request":this.requestCallback&&this.requestCallback(_);break;case"response":const y=_,k=this.pendingRequests.get(y.request_seq);k&&(this.pendingRequests.delete(y.request_seq),k(y));break}}}internalSend(_,y){y.type=_,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const _=new Map;this.pendingRequests.forEach((y,k)=>_.set(k,y)),await(0,F.timeout)(500),_.forEach((y,k)=>{y({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=S}),define(fe[211],me([0,1,9,2,8,25,10]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const _=/{([^}]+)}/g;function y(r,t,d){return r.replace(_,function(s,c){return t&&c.length>0&&c[0]!=="_"?s:d&&d.hasOwnProperty(c)?d[c]:s})}e.formatPII=y;function k(r){const t={};for(const d of Object.keys(r))d.startsWith("!")||(t[d]=r[d]);return t}e.filterExceptionsFromTelemetry=k;function i(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||i(r.parentSession))}e.isSessionAttach=i;function I(r){let t=r.configuration.type;if(!!t)return t==="vslsShare"&&(t=r.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(t,"extensionhost")||(0,g.equalsIgnoreCase)(t,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function a(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=a;function p(r,t,d){let s,c=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,u=null;for(;u=m.exec(r);){let E=u.index+1,R=E+u[0].length;if(E<=t&&R>=d){s=u[0],c=E;break}}if(s){let E=/\w+/g,R=null;for(;(R=E.exec(s))&&!(R.index+1+c+R[0].length>=d););R&&(s=s.substring(0,E.lastIndex))}return s?{start:c,end:c+s.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(r){return!!(r&&r.match(h))}e.isUri=w;function D(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(w(r.path))return F.URI.parse(r.path);if((0,C.isAbsolute)(r.path))return F.URI.file(r.path)}return r.path}function T(r){if(typeof r.path=="object"){const t=F.URI.revive(r.path);if(t)return t.scheme===P.Schemas.file?t.fsPath:t.toString()}return r.path}function b(r,t){const d=t?D:T,s=(0,S.deepClone)(r);return o(s,(c,m)=>{c&&m&&(m.path=d(m))}),s}e.convertToDAPaths=b;function l(r,t){const d=t?D:T,s=(0,S.deepClone)(r);return o(s,(c,m)=>{!c&&m&&(m.path=d(m))}),s}e.convertToVSCPaths=l;function o(r,t){switch(r.type){case"event":const d=r;switch(d.event){case"output":t(!1,d.body.source);break;case"loadedSource":t(!1,d.body.source);break;case"breakpoint":t(!1,d.body.breakpoint.source);break;default:break}break;case"request":const s=r;switch(s.command){case"setBreakpoints":t(!0,s.arguments.source);break;case"breakpointLocations":t(!0,s.arguments.source);break;case"source":t(!0,s.arguments.source);break;case"gotoTargets":t(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(m=>t(!1,m));break;default:break}break;case"response":const c=r;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(m=>t(!1,m.source));break;case"loadedSources":c.body.sources.forEach(m=>t(!1,m));break;case"scopes":c.body.scopes.forEach(m=>t(!1,m.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(m=>t(!1,m.source));break;case"setBreakpoints":c.body.breakpoints.forEach(m=>t(!1,m.source));break;default:break}break}}function v(r){return r.filter(t=>!t.presentation?.hidden).sort((t,d)=>t.presentation?d.presentation?t.presentation.group?d.presentation.group?t.presentation.group!==d.presentation.group?t.presentation.group.localeCompare(d.presentation.group):n(t.presentation.order,d.presentation.order):-1:d.presentation.group?1:n(t.presentation.order,d.presentation.order):-1:d.presentation?1:0)}e.getVisibleAndSorted=v;function n(r,t){return typeof r!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:r-t}async function f(r,t){const d=r.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(d!=="none"&&(await t.saveAll(),d==="allEditorsInActiveGroup")){const s=t.activeEditorPane;s&&await t.save({editor:s.input,groupId:s.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=f}),define(fe[212],me([0,1,26,39,177,127,8,9,25,11,187,126]),function(Y,e,g,F,C,S,P,_,y,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class a extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,l){this.outputStream=l,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",o=>this.handleData(o))}sendMessage(b){if(this.outputStream){const l=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(l,"utf8")}${a.TWO_CRLF}${l}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const l=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,l.length>0)try{this.acceptMessage(JSON.parse(l))}catch(o){this._onError.fire(new Error((o.message||o)+`
`+l))}continue}}else{const l=this.rawData.indexOf(a.TWO_CRLF);if(l!==-1){const v=this.rawData.toString("utf8",0,l).split(a.HEADER_LINESEPARATOR);for(const n of v){const f=n.split(a.HEADER_FIELDSEPARATOR);f[0]==="Content-Length"&&(this.contentLength=Number(f[1]))}this.rawData=this.rawData.slice(l+a.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=a,a.TWO_CRLF=`\r
\r
`,a.HEADER_LINESEPARATOR=/\r?\n/,a.HEADER_FIELDSEPARATOR=/: */;class p extends a{startSession(){return new Promise((b,l)=>{let o=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),o=!0}),this.socket.on("close",()=>{o?this._onError.fire(new Error("connection closed")):l(new Error("connection closed"))}),this.socket.on("error",v=>{o?this._onError.fire(v):l(v)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class h extends p{constructor(b){super();this.adapterServer=b}createConnection(b){return S.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=h;class w extends p{constructor(b){super();this.adapterServer=b}createConnection(b){return S.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=w;class D extends a{constructor(b,l,o){super();this.adapterExecutable=b,this.debugType=l,this.outputService=o}async startSession(){const b=this.adapterExecutable.command,l=this.adapterExecutable.args,o=this.adapterExecutable.options||{};try{if(b)if(P.isAbsolute(b)){if(!await g.Promises.exists(b))throw new Error(C.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let v=process.env;if(o.env&&Object.keys(o.env).length>0&&(v=y.mixin(y.deepClone(process.env),o.env)),b==="node")if(Array.isArray(l)&&l.length>0){const f=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:v,execArgv:f?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(r.cwd=o.cwd);const t=F.fork(l[0],l.slice(1),r);if(!t.pid)throw new Error(C.localize(2,null,l[0]));this.serverProcess=t}else throw new Error(C.localize(3,null));else{const f={env:v};o.cwd&&(f.cwd=o.cwd),this.serverProcess=F.spawn(b,l,f)}this.serverProcess.on("error",f=>{this._onError.fire(f)}),this.serverProcess.on("exit",(f,r)=>{this._onExit.fire(f)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",f=>{this._onError.fire(f)}),this.serverProcess.stdin.on("error",f=>{this._onError.fire(f)});const n=this.outputService;if(n){const f=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const t=n.getChannel(i.ExtensionsChannelId);t&&t.append(f(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(v){this._onError.fire(v)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),k.isWindows?new Promise((b,l)=>{const o=F.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(v,n,f){if(v)return l(v)});o.on("exit",b),o.on("error",l)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,l){if(!b)return;const o=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?o.runtime=P.join(l,b.runtime):o.runtime=b.runtime),b.runtimeArgs&&(o.runtimeArgs=b.runtimeArgs),b.program&&(P.isAbsolute(b.program)?o.program=b.program:o.program=P.join(l,b.program)),b.args&&(o.args=b.args);const v=b;return v.win&&(o.win=D.extract(v.win,l)),v.winx86&&(o.winx86=D.extract(v.winx86,l)),v.windows&&(o.windows=D.extract(v.windows,l)),v.osx&&(o.osx=D.extract(v.osx,l)),v.linux&&(o.linux=D.extract(v.linux,l)),o}static platformAdapterExecutable(b,l){let o=Object.create(null);l=l.toLowerCase();for(const d of b)if(d.contributes){const s=d.contributes.debuggers;s&&s.length>0&&s.filter(c=>typeof c.type=="string"&&_.equalsIgnoreCase(c.type,l)).forEach(c=>{const m=D.extract(c,d.extensionLocation.fsPath);o=y.mixin(o,m,d.isBuiltin)})}let v;k.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=o.winx86||o.win||o.windows:k.isWindows?v=o.win||o.windows:k.isMacintosh?v=o.osx:k.isLinux&&(v=o.linux),v=v||o;let n=v.program||o.program;const f=v.args||o.args;let r=v.runtime||o.runtime;const t=v.runtimeArgs||o.runtimeArgs;if(r)return{type:"executable",command:r,args:(t||[]).concat(typeof n=="string"?[n]:[]).concat(f||[])};if(n)return{type:"executable",command:n,args:f||[]}}}e.ExecutableDebugAdapter=D}),define(fe[213],me([0,1,39,11,29,189]),function(Y,e,g,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function P(a,p){return new Promise((h,w)=>{let D="";const T=g.spawn(a,p);T.pid&&T.stdout.on("data",b=>{D+=b.toString()}),T.on("error",b=>{w(b)}),T.on("close",b=>{h(D)})})}let _;function y(a,p){if(!_)if(F.isWindows)_=new S.WindowsExternalTerminalService;else if(F.isMacintosh)_=new S.MacExternalTerminalService;else if(F.isLinux)_=new S.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const h=p.getConfiguration("terminal");return _.runInTerminal(a.title,a.cwd,a.args,a.env||{},h.external||{})}e.runInExternalTerminal=y;async function k(a){if(a)if(F.isWindows){const p=await new Promise((h,w)=>{Y(["windows-process-tree"],h,w)});return new Promise(h=>{p.getProcessTree(a,w=>{h(w.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(a)]).then(p=>{const h=p.trim();return!(h.length===0||h.indexOf(" tmux")>=0)},p=>!0);return Promise.resolve(!0)}e.hasChildProcesses=k;var i;(function(a){a[a.cmd=0]="cmd",a[a.powershell=1]="powershell",a[a.bash=2]="bash"})(i||(i={}));function I(a,p,h,w){a=a.trim().toLowerCase();let D;a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0?D=1:a.indexOf("cmd.exe")>=0?D=0:a.indexOf("bash")>=0?D=2:F.isWindows?D=0:D=2;let T,b=" ";switch(D){case 1:if(T=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),h){const o=(0,C.getDriveLetter)(h);o&&(b+=`${o}:; `),b+=`cd ${T(h)}; `}if(w)for(let o in w){const v=w[o];v===null?b+=`Remove-Item env:${o}; `:b+=`\${env:${o}}='${v}'; `}if(p.length>0){const o=T(p.shift());b+=o[0]==="'"?`& ${o} `:`${o} `;for(let v of p)b+=`${T(v)} `}break;case 0:if(T=o=>(o=o.replace(/\"/g,'""'),o.indexOf(" ")>=0||o.indexOf('"')>=0||o.length===0?`"${o}"`:o),h){const o=(0,C.getDriveLetter)(h);o&&(b+=`${o}: && `),b+=`cd ${T(h)} && `}if(w){b+='cmd /C "';for(let o in w){let v=w[o];v===null?b+=`set "${o}=" && `:(v=v.replace(/[\^\&\|\<\>]/g,n=>`^${n}`),b+=`set "${o}=${v}" && `)}}for(let o of p)b+=`${T(o)} `;w&&(b+='"');break;case 2:T=o=>(o=o.replace(/(["'\\\$])/g,"\\$1"),o.indexOf(" ")>=0||o.indexOf(";")>=0||o.length===0?`"${o}"`:o);const l=o=>/[^\w@%\/+=,.:^-]/.test(o)?`'${o.replace(/'/g,"'\\''")}'`:o;if(h&&(b+=`cd ${T(h)} ; `),w){b+="/usr/bin/env";for(let o in w){const v=w[o];v===null?b+=` -u ${l(o)}`:b+=` ${l(`${o}=${v}`)}`}b+=" "}for(let o of p)b+=`${T(o)} `;break}return b}e.prepareCommand=I}),define(fe[128],me([0,1,30,103,10,8,11,63]),function(Y,e,g,F,C,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.latex,F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.latex,F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var i;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var a;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(a=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var w;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(w=e.CellEditType||(e.CellEditType={}));var D;(function(E){E.scheme=C.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function L(N,j){return N.with({scheme:E.scheme,fragment:`ch${j.toString().padStart(7,"0")}${N.scheme!==C.Schemas.file?N.scheme:""}`})}E.generate=L;function M(N){if(N.scheme!==E.scheme)return;const j=R.exec(N.fragment);return j?{handle:Number(j[1]),notebook:N.with({scheme:N.fragment.substr(j[0].length)||C.Schemas.file,fragment:null})}:void 0}E.parse=M;function A(N){if(N.scheme!==C.Schemas.vscodeNotebookCellMetadata)return;const j=R.exec(N.fragment);return j?{handle:Number(j[1]),notebook:N.with({scheme:N.fragment.substr(j[0].length)||C.Schemas.file,fragment:null})}:void 0}E.parseCellMetadataUri=A;function B(N,j,U){return N.with({scheme:U,fragment:`ch${j.toString().padStart(7,"0")}${N.scheme!==C.Schemas.file?N.scheme:""}`})}E.generateCellUri=B;function V(N,j){if(N.scheme!==j)return;const U=R.exec(N.fragment);return U?{handle:Number(U[1]),notebook:N.with({scheme:N.fragment.substr(U[0].length)||C.Schemas.file,fragment:null})}:void 0}E.parseCellUri=V})(D=e.CellUri||(e.CellUri={}));const T=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(E){return T.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=b;function l(E){return T.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=l;function o(E){return T.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=o;function v(E,R){return P.isWindows&&(E=E.replace(/\//g,"\\"),R=R.replace(/\//g,"\\")),g.match(E,R)}function n(E,R,L){let M=0;for(let A=0;A<R.length;A++){if(v(R[A],E))return M;M++}for(let A=0;A<L.length;A++){if(v(L[A],E))return M;M++}return M}function f(E,R,L){return E.sort((M,A)=>n(M,R,L)-n(A,R,L))}e.sortMimeTypes=f;function r(E,R,L,M=(A,B)=>A===B){const A=[];function B(j,U,x){if(U===0&&x.length===0)return;const z=A[A.length-1];z&&z.start+z.deleteCount===j?(z.deleteCount+=U,z.toInsert.push(...x)):A.push({start:j,deleteCount:U,toInsert:x})}let V=0,N=0;for(;;){if(V===E.length){B(V,0,R.slice(N));break}if(N===R.length){B(V,E.length-V,[]);break}const j=E[V],U=R[N];if(M(j,U)){V+=1,N+=1;continue}L(U)?(B(V,1,[]),V+=1):(B(V,0,[U]),N+=1)}return A}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(E){E.default="default",E.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(E){const R=E;return!!((typeof R.include=="string"||g.isRelativePattern(R.include))&&(typeof R.exclude=="string"||g.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=d;function s(E,R,L){if(Array.isArray(E.viewType)&&E.viewType.indexOf(R)>=0||E.viewType===R)return!0;if(E.filenamePattern){let M=d(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,A=d(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(g.match(M,(0,S.basename)(L.fsPath).toLowerCase()))return!(A&&g.match(A,(0,S.basename)(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s;class c{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)R[L]=this.textModel.cells[L].getHashValue();return R}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var m;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(m=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class u{static create(R){return`${u._prefix}${R}`}static parse(R){if(R.startsWith(u._prefix))return R.substr(u._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=u,u._prefix="notebook/"}),define(fe[214],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState",C[C.Complete=4]="Complete"})(F=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,g.createDecorator)("INotebookExecutionService")}),define(fe[215],me([0,1,179,4,63]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(fe[216],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=g;function F(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=F}),define(fe[129],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var F;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(F=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var C;(function(I){I[I.Error=0]="Error",I[I.Info=1]="Info"})(C=e.TestMessageType||(e.TestMessageType={}));var S;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(S=e.TestItemExpandState||(e.TestItemExpandState={}));const P=(I,a)=>{a.expand!==void 0&&(I.expand=a.expand),a.item!==void 0&&(I.item=I.item?Object.assign(I.item,a.item):a.item)};e.applyTestItemUpdate=P;var _;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(_=e.DetailType||(e.DetailType={}));var y;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire",I[I.AddTag=5]="AddTag",I[I.RemoveTag=6]="RemoveTag"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class k{add(a){}update(a){}remove(a,p){}complete(){}}e.IncrementalChangeCollector=k;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const p=this.createChangeCollector();for(const h of a)switch(h[0]){case 0:{const w=h[1];if(w.parent){if(this.items.has(w.parent)){const D=this.items.get(w.parent);D.children.add(w.item.extId);const T=this.createItem(w,D);this.items.set(w.item.extId,T),p.add(T)}}else{const D=this.createItem(w);this.roots.add(D),this.items.set(w.item.extId,D),p.add(D)}w.expand===2&&this.busyControllerCount++;break}case 1:{const w=h[1],D=this.items.get(w.extId);if(!D)break;w.expand!==void 0&&(D.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(D,w),p.update(D);break}case 2:{const w=this.items.get(h[1]);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w);const D=[[h[1]]];for(;D.length;)for(const T of D.pop()){const b=this.items.get(T);b&&(D.push(b.children),this.items.delete(T),p.remove(b,b!==w),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h[1]);break;case 3:this.updatePendingRoots(h[1]);break;case 5:this._tags.set(h[1].id,h[1]);break;case 6:this._tags.delete(h[1]);break}p.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=i}),define(fe[89],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(S){S.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(S){S[S.IsSame=0]="IsSame",S[S.Disconnected=1]="Disconnected",S[S.IsChild=2]="IsChild",S[S.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class C{constructor(P,_=P.length){if(this.path=P,this.viewEnd=_,P.length===0||_<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(P,_,y=P.parent){if(P.id===_)return new C([_]);let k=[P.id];for(let i=y;i&&i.id!==_;i=i.parent)k.push(i.id);return k.push(_),new C(k.reverse())}static isRoot(P){return!P.includes("\0")}static fromString(P){return new C(P.split("\0"))}static join(P,_){return new C([...P.path,_])}static joinToString(P,_){return P.toString()+"\0"+_}static compare(P,_){return P===_?0:_.startsWith(P+"\0")?2:P.startsWith(_+"\0")?3:1}get parentId(){return this.viewEnd>1?new C(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let P=1;P<=this.viewEnd;P++)yield new C(this.path,P)}compare(P){if(typeof P=="string")return C.compare(this.toString(),P);for(let _=0;_<P.viewEnd&&_<this.viewEnd;_++)if(P.path[_]!==this.path[_])return 1;return P.viewEnd>this.viewEnd?2:P.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let P=1;P<this.viewEnd;P++)this.stringifed+="\0",this.stringifed+=this.path[P]}return this.stringifed}}e.TestId=C}),define(fe[217],me([0,1,8,38,12,25,11,80,180]),function(Y,e,g,F,C,S,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(I,a,p){this._contributedVariables=new Map,this._context=I,this._labelService=a,p&&(this._envVariablesPromise=p.then(h=>this.prepareEnv(h)))}prepareEnv(I){if(P.isWindows){const a=Object.create(null);return Object.keys(I).forEach(p=>{a[p.toLowerCase()]=I[p]}),a}return I}resolveWithEnvironment(I,a,p){return this.recursiveResolve(this.prepareEnv(I),a?a.uri:void 0,p)}async resolveAsync(I,a){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,a)}async resolveAnyBase(I,a,p,h){const w=S.deepClone(a);return P.isWindows&&w.windows?Object.keys(w.windows).forEach(D=>w[D]=w.windows[D]):P.isMacintosh&&w.osx?Object.keys(w.osx).forEach(D=>w[D]=w.osx[D]):P.isLinux&&w.linux&&Object.keys(w.linux).forEach(D=>w[D]=w.linux[D]),delete w.windows,delete w.osx,delete w.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,w,p,h)}async resolveAnyAsync(I,a,p){return this.resolveAnyBase(I,a,p)}async resolveAnyMap(I,a,p){const h=new Map;return{newConfig:await this.resolveAnyBase(I,a,p,h),resolvedVariables:h}}resolveWithInteractionReplace(I,a,p,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,a,p,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,a){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,a)}recursiveResolve(I,a,p,h,w){if(C.isString(p))return this.resolveString(I,a,p,h,w);if(C.isArray(p))return p.map(D=>this.recursiveResolve(I,a,D,h,w));if(C.isObject(p)){let D=Object.create(null);return Object.keys(p).forEach(T=>{const b=this.resolveString(I,a,T,h,w);D[b]=this.recursiveResolve(I,a,p[T],h,w)}),D}return p}resolveString(I,a,p,h,w){return p.replace(k.VARIABLE_REGEXP,(T,b)=>{if(b.includes(k.VARIABLE_LHS))return T;let l=this.evaluateSingleVariable(I,T,b,a,h);return w&&w.set(b,l),l!==T&&C.isString(l)&&l.match(k.VARIABLE_REGEXP)&&(l=this.resolveString(I,a,l,h,w)),l})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,a,p,h,w){let D;const T=p.split(":");T.length>1&&(p=T[0],D=T[1]);const b=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,y.localize)(0,null,a))},l=()=>{const v=b();if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new Error((0,y.localize)(1,null,a,g.basename(v)))},o=()=>{if(D){const v=this._context.getFolderUri(D);if(v)return v;throw new Error((0,y.localize)(2,null,a,D))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,a)):new Error((0,y.localize)(4,null,a))};switch(p){case"env":if(D){if(I){const v=I[P.isWindows?D.toLowerCase():D];if(C.isString(v))return v}return""}throw new Error((0,y.localize)(5,null,a));case"config":if(D){const v=this._context.getConfigurationValue(h,D);if(C.isUndefinedOrNull(v))throw new Error((0,y.localize)(6,null,a,D));if(C.isObject(v))throw new Error((0,y.localize)(7,null,a,D));return v}throw new Error((0,y.localize)(8,null,a));case"command":return this.resolveFromMap(a,D,w,"command");case"input":return this.resolveFromMap(a,D,w,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,_.normalizeDriveLetter)(this.fsPath(o()));case"cwd":return h||D?(0,_.normalizeDriveLetter)(this.fsPath(o())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(o()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,y.localize)(9,null,a));case"selectedText":const n=this._context.getSelectedText();if(n)return n;throw new Error((0,y.localize)(10,null,a));case"file":return b();case"fileWorkspaceFolder":return l();case"relativeFile":return h||D?g.relative(this.fsPath(o()),b()):b();case"relativeFileDirname":const f=g.dirname(b());if(h||D){const s=g.relative(this.fsPath(o()),f);return s.length===0?".":s}return f;case"fileDirname":return g.dirname(b());case"fileExtname":return g.extname(b());case"fileBasename":return g.basename(b());case"fileBasenameNoExtension":const r=g.basename(b());return r.slice(0,r.length-g.extname(r).length);case"fileDirnameBasename":return g.basename(g.dirname(b()));case"execPath":const t=this._context.getExecPath();return t||a;case"execInstallFolder":const d=this._context.getAppRoot();return d||a;case"pathSeparator":return g.sep;default:try{const s=D?`${p}:${D}`:p;return this.resolveFromMap(a,s,w,void 0)}catch(s){return a}}}}resolveFromMap(I,a,p,h){if(a&&p){const w=h===void 0?p[a]:p[h+":"+a];if(typeof w=="string")return w;throw new Error((0,y.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(fe[130],me([0,1,4,209]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var C;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var S;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var _;(function(w){w[w.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(_=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function k(w){const D=w;return(0,F.isEditorInput)(D?.editor)&&(0,F.isEditorInput)(D?.replacement)}e.isEditorReplacement=k;var i;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(w){w[w.GROUP_ACTIVE=0]="GROUP_ACTIVE",w[w.GROUP_INDEX=1]="GROUP_INDEX",w[w.GROUP_LOCKED=2]="GROUP_LOCKED",w[w.EDITOR_OPEN=3]="EDITOR_OPEN",w[w.EDITOR_CLOSE=4]="EDITOR_CLOSE",w[w.EDITOR_MOVE=5]="EDITOR_MOVE",w[w.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",w[w.EDITOR_LABEL=7]="EDITOR_LABEL",w[w.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",w[w.EDITOR_PIN=9]="EDITOR_PIN",w[w.EDITOR_STICKY=10]="EDITOR_STICKY",w[w.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var a;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(a=e.OpenEditorContext||(e.OpenEditorContext={}));function p(w){const D=w;return!!D&&typeof D.id=="number"&&Array.isArray(D.editors)}e.isEditorGroup=p;function h(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=h}),define(fe[218],me([0,1,4,130]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(S){const P=S;return typeof S=="number"||(0,F.isEditorGroup)(P)}e.isPreferredGroup=C}),define(fe[16],me([0,1,18,22,100,293,62,25,12,2,42,84,181,118,66,128,89,218,7]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(ge){function be(Q){const{selectionStartLineNumber:Se,selectionStartColumn:Le,positionLineNumber:nt,positionColumn:qe}=Q,gt=new b.Position(Se-1,Le-1),Et=new b.Position(nt-1,qe-1);return new b.Selection(gt,Et)}ge.to=be;function ie(Q){const{anchor:Se,active:Le}=Q;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ge.from=ie})(l=e.Selection||(e.Selection={}));var o;(function(ge){function be(Q){if(!Q)return;const{start:Se,end:Le}=Q;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ge.from=be;function ie(Q){if(!Q)return;const{startLineNumber:Se,startColumn:Le,endLineNumber:nt,endColumn:qe}=Q;return new b.Range(Se-1,Le-1,nt-1,qe-1)}ge.to=ie})(o=e.Range||(e.Range={}));var v;(function(ge){function be(ie){switch(ie){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}ge.to=be})(v=e.TokenType||(e.TokenType={}));var n;(function(ge){function be(Q){return new b.Position(Q.lineNumber-1,Q.column-1)}ge.to=be;function ie(Q){return{lineNumber:Q.line+1,column:Q.character+1}}ge.from=ie})(n=e.Position||(e.Position={}));var f;(function(ge){function be(Se,Le){return(0,g.coalesce)((0,g.asArray)(Se).map(nt=>ie(nt,Le)))}ge.from=be;function ie(Se,Le){if(typeof Se=="string")return{$serialized:!0,language:Se};if(Se)return{$serialized:!0,language:Se.language,scheme:Q(Se.scheme,Le),pattern:typeof Se.pattern=="undefined"?void 0:le.from(Se.pattern),exclusive:Se.exclusive}}function Q(Se,Le){return Le&&typeof Se=="string"?Le.transformOutgoingScheme(Se):Se}})(f=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ge){function be(Q){switch(Q){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}ge.from=be;function ie(Q){switch(Q){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}ge.to=ie})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(ge){function be(Q){let Se;return Q.code&&((0,y.isString)(Q.code)||(0,y.isNumber)(Q.code)?Se=String(Q.code):Se={value:String(Q.code.value),target:Q.code.target}),{...o.from(Q.range),message:Q.message,source:Q.source,code:Se,severity:s.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(d.from),tags:Array.isArray(Q.tags)?(0,g.coalesce)(Q.tags.map(r.from)):void 0}}ge.from=be;function ie(Q){const Se=new b.Diagnostic(o.to(Q),Q.message,s.to(Q.severity));return Se.source=Q.source,Se.code=(0,y.isString)(Q.code)?Q.code:Q.code?.value,Se.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(d.to),Se.tags=Q.tags&&(0,g.coalesce)(Q.tags.map(r.to)),Se}ge.to=ie})(t=e.Diagnostic||(e.Diagnostic={}));var d;(function(ge){function be(Q){return{...o.from(Q.location.range),message:Q.message,resource:Q.location.uri}}ge.from=be;function ie(Q){return new b.DiagnosticRelatedInformation(new b.Location(Q.resource,o.to(Q)),Q.message)}ge.to=ie})(d=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var s;(function(ge){function be(Q){switch(Q){case b.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}ge.from=be;function ie(Q){switch(Q){case p.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ge.to=ie})(s=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(ge){function be(Q){return typeof Q=="number"&&Q>=b.ViewColumn.One?Q-1:Q===b.ViewColumn.Beside?T.SIDE_GROUP:T.ACTIVE_GROUP}ge.from=be;function ie(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}ge.to=ie})(c=e.ViewColumn||(e.ViewColumn={}));function m(ge){return typeof ge.range!="undefined"}function u(ge){return ge.length===0?!0:!!m(ge[0])}e.isDecorationOptionsArr=u;var E;(function(ge){function be(qe){return qe.map(ge.from)}ge.fromMany=be;function ie(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function Q(qe){let gt;if(ie(qe)){const{language:wt,value:Dt}=qe;gt={value:"```"+wt+`
`+Dt+"\n```\n"}}else b.MarkdownString.isMarkdownString(qe)?gt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml}:typeof qe=="string"?gt={value:qe}:gt={value:""};const Et=Object.create(null);gt.uris=Et;const pt=wt=>{try{let Dt=k.URI.parse(wt,!0);Dt=Dt.with({query:Se(Dt.query,Et)}),Et[wt]=Dt}catch(Dt){}return""},vt=new S.Renderer;return vt.link=pt,vt.image=wt=>pt(C.parseHrefAndDimensions(wt).href),S(gt.value,{renderer:vt}),gt}ge.from=Q;function Se(qe,gt){if(!qe)return qe;let Et;try{Et=(0,P.parse)(qe)}catch(vt){}if(!Et)return qe;let pt=!1;return Et=(0,_.cloneAndChange)(Et,vt=>{if(k.URI.isUri(vt)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return gt[wt]=vt,pt=!0,wt}else return}),pt?JSON.stringify(Et):qe}function Le(qe){const gt=new b.MarkdownString(qe.value,qe.supportThemeIcons);return gt.isTrusted=qe.isTrusted,gt.supportHtml=qe.supportHtml,gt}ge.to=Le;function nt(qe){if(!!qe)return typeof qe=="string"?qe:ge.from(qe)}ge.fromStrict=nt})(E=e.MarkdownString||(e.MarkdownString={}));function R(ge){return u(ge)?ge.map(be=>({range:o.from(be.range),hoverMessage:Array.isArray(be.hoverMessage)?E.fromMany(be.hoverMessage):be.hoverMessage?E.from(be.hoverMessage):void 0,renderOptions:be.renderOptions})):ge.map(be=>({range:o.from(be)}))}e.fromRangeOrRangeWithMessage=R;function L(ge){return typeof ge=="undefined"?ge:typeof ge=="string"?k.URI.file(ge):ge}e.pathOrURIToURI=L;var M;(function(ge){function be(ie){return typeof ie=="undefined"?ie:{contentText:ie.contentText,contentIconPath:ie.contentIconPath?L(ie.contentIconPath):void 0,border:ie.border,borderColor:ie.borderColor,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,color:ie.color,backgroundColor:ie.backgroundColor,margin:ie.margin,width:ie.width,height:ie.height}}ge.from=be})(M=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var A;(function(ge){function be(ie){return typeof ie=="undefined"?ie:{backgroundColor:ie.backgroundColor,outline:ie.outline,outlineColor:ie.outlineColor,outlineStyle:ie.outlineStyle,outlineWidth:ie.outlineWidth,border:ie.border,borderColor:ie.borderColor,borderRadius:ie.borderRadius,borderSpacing:ie.borderSpacing,borderStyle:ie.borderStyle,borderWidth:ie.borderWidth,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,cursor:ie.cursor,color:ie.color,opacity:ie.opacity,letterSpacing:ie.letterSpacing,gutterIconPath:ie.gutterIconPath?L(ie.gutterIconPath):void 0,gutterIconSize:ie.gutterIconSize,overviewRulerColor:ie.overviewRulerColor,before:ie.before?M.from(ie.before):void 0,after:ie.after?M.from(ie.after):void 0}}ge.from=be})(A=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var B;(function(ge){function be(ie){if(typeof ie=="undefined")return ie;switch(ie){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}ge.from=be})(B=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var V;(function(ge){function be(ie){return{isWholeLine:ie.isWholeLine,rangeBehavior:ie.rangeBehavior?B.from(ie.rangeBehavior):void 0,overviewRulerLane:ie.overviewRulerLane,light:ie.light?A.from(ie.light):void 0,dark:ie.dark?A.from(ie.dark):void 0,backgroundColor:ie.backgroundColor,outline:ie.outline,outlineColor:ie.outlineColor,outlineStyle:ie.outlineStyle,outlineWidth:ie.outlineWidth,border:ie.border,borderColor:ie.borderColor,borderRadius:ie.borderRadius,borderSpacing:ie.borderSpacing,borderStyle:ie.borderStyle,borderWidth:ie.borderWidth,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,cursor:ie.cursor,color:ie.color,opacity:ie.opacity,letterSpacing:ie.letterSpacing,gutterIconPath:ie.gutterIconPath?L(ie.gutterIconPath):void 0,gutterIconSize:ie.gutterIconSize,overviewRulerColor:ie.overviewRulerColor,before:ie.before?M.from(ie.before):void 0,after:ie.after?M.from(ie.after):void 0}}ge.from=be})(V=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(ge){function be(Q){return{text:Q.newText,eol:Q.newEol&&J.from(Q.newEol),range:o.from(Q.range)}}ge.from=be;function ie(Q){const Se=new b.TextEdit(o.to(Q.range),Q.text);return Se.newEol=typeof Q.eol=="undefined"?void 0:J.to(Q.eol),Se}ge.to=ie})(N=e.TextEdit||(e.TextEdit={}));var j;(function(ge){function be(Q,Se,Le){const nt={edits:[]};if(Q instanceof b.WorkspaceEdit)for(let qe of Q._allEntries())if(qe._type===1)nt.edits.push({_type:1,oldUri:qe.from,newUri:qe.to,options:qe.options,metadata:qe.metadata});else if(qe._type===2){const gt=Se?.getDocument(qe.uri);nt.edits.push({_type:2,resource:qe.uri,edit:N.from(qe.edit),modelVersionId:gt?.version,metadata:qe.metadata})}else qe._type===3?nt.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,edit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version}):qe._type===5&&nt.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(tt.from)}});return nt}ge.from=be;function ie(Q){const Se=new b.WorkspaceEdit;for(const Le of Q.edits)Le.edit?Se.replace(k.URI.revive(Le.resource),o.to(Le.edit.range),Le.edit.text):Se.renameFile(k.URI.revive(Le.oldUri),k.URI.revive(Le.newUri),Le.options);return Se}ge.to=ie})(j=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(ge){const be=Object.create(null);be[b.SymbolKind.File]=0,be[b.SymbolKind.Module]=1,be[b.SymbolKind.Namespace]=2,be[b.SymbolKind.Package]=3,be[b.SymbolKind.Class]=4,be[b.SymbolKind.Method]=5,be[b.SymbolKind.Property]=6,be[b.SymbolKind.Field]=7,be[b.SymbolKind.Constructor]=8,be[b.SymbolKind.Enum]=9,be[b.SymbolKind.Interface]=10,be[b.SymbolKind.Function]=11,be[b.SymbolKind.Variable]=12,be[b.SymbolKind.Constant]=13,be[b.SymbolKind.String]=14,be[b.SymbolKind.Number]=15,be[b.SymbolKind.Boolean]=16,be[b.SymbolKind.Array]=17,be[b.SymbolKind.Object]=18,be[b.SymbolKind.Key]=19,be[b.SymbolKind.Null]=20,be[b.SymbolKind.EnumMember]=21,be[b.SymbolKind.Struct]=22,be[b.SymbolKind.Event]=23,be[b.SymbolKind.Operator]=24,be[b.SymbolKind.TypeParameter]=25;function ie(Se){return typeof be[Se]=="number"?be[Se]:6}ge.from=ie;function Q(Se){for(const Le in be)if(be[Le]===Se)return Number(Le);return b.SymbolKind.Property}ge.to=Q})(U=e.SymbolKind||(e.SymbolKind={}));var x;(function(ge){function be(Q){switch(Q){case b.SymbolTag.Deprecated:return 1}}ge.from=be;function ie(Q){switch(Q){case 1:return b.SymbolTag.Deprecated}}ge.to=ie})(x=e.SymbolTag||(e.SymbolTag={}));var z;(function(ge){function be(Q){return{name:Q.name,kind:U.from(Q.kind),tags:Q.tags&&Q.tags.map(x.from),containerName:Q.containerName,location:K.from(Q.location)}}ge.from=be;function ie(Q){const Se=new b.SymbolInformation(Q.name,U.to(Q.kind),Q.containerName,K.to(Q.location));return Se.tags=Q.tags&&Q.tags.map(x.to),Se}ge.to=ie})(z=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(ge){function be(Q){const Se={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),kind:U.from(Q.kind),tags:Q.tags?.map(x.from)??[]};return Q.children&&(Se.children=Q.children.map(be)),Se}ge.from=be;function ie(Q){const Se=new b.DocumentSymbol(Q.name,Q.detail,U.to(Q.kind),o.to(Q.range),o.to(Q.selectionRange));return(0,g.isNonEmptyArray)(Q.tags)&&(Se.tags=Q.tags.map(x.to)),Q.children&&(Se.children=Q.children.map(ie)),Se}ge.to=ie})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var W;(function(ge){function be(Q){const Se=new b.CallHierarchyItem(U.to(Q.kind),Q.name,Q.detail||"",k.URI.revive(Q.uri),o.to(Q.range),o.to(Q.selectionRange));return Se._sessionId=Q._sessionId,Se._itemId=Q._itemId,Se}ge.to=be;function ie(Q,Se,Le){if(Se=Se??Q._sessionId,Le=Le??Q._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,name:Q.name,detail:Q.detail,kind:U.from(Q.kind),uri:Q.uri,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}ge.from=ie})(W=e.CallHierarchyItem||(e.CallHierarchyItem={}));var $;(function(ge){function be(ie){return new b.CallHierarchyIncomingCall(W.to(ie.from),ie.fromRanges.map(Q=>o.to(Q)))}ge.to=be})($=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var X;(function(ge){function be(ie){return new b.CallHierarchyOutgoingCall(W.to(ie.to),ie.fromRanges.map(Q=>o.to(Q)))}ge.to=be})(X=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var K;(function(ge){function be(Q){return{range:Q.range&&o.from(Q.range),uri:Q.uri}}ge.from=be;function ie(Q){return new b.Location(k.URI.revive(Q.uri),o.to(Q.range))}ge.to=ie})(K=e.location||(e.location={}));var de;(function(ge){function be(Q){const Se=Q,Le=Q;return{originSelectionRange:Se.originSelectionRange?o.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:Le.uri,range:o.from(Se.targetRange?Se.targetRange:Le.range),targetSelectionRange:Se.targetSelectionRange?o.from(Se.targetSelectionRange):void 0}}ge.from=be;function ie(Q){return{targetUri:k.URI.revive(Q.uri),targetRange:o.to(Q.range),targetSelectionRange:Q.targetSelectionRange?o.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?o.to(Q.originSelectionRange):void 0}}ge.to=ie})(de=e.DefinitionLink||(e.DefinitionLink={}));var _e;(function(ge){function be(Q){return{range:o.from(Q.range),contents:E.fromMany(Q.contents)}}ge.from=be;function ie(Q){return new b.Hover(Q.contents.map(E.to),o.to(Q.range))}ge.to=ie})(_e=e.Hover||(e.Hover={}));var Ce;(function(ge){function be(Q){return{range:o.from(Q.range),expression:Q.expression}}ge.from=be;function ie(Q){return new b.EvaluatableExpression(o.to(Q.range),Q.expression)}ge.to=ie})(Ce=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Pe;(function(ge){function be(Q){if(Q instanceof b.InlineValueText)return{type:"text",range:o.from(Q.range),text:Q.text};if(Q instanceof b.InlineValueVariableLookup)return{type:"variable",range:o.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}ge.from=be;function ie(Q){switch(Q.type){case"text":return{range:o.to(Q.range),text:Q.text};case"variable":return{range:o.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:o.to(Q.range),expression:Q.expression}}}ge.to=ie})(Pe=e.InlineValue||(e.InlineValue={}));var Be;(function(ge){function be(Q){return{frameId:Q.frameId,stoppedLocation:o.from(Q.stoppedLocation)}}ge.from=be;function ie(Q){return new b.InlineValueContext(Q.frameId,o.to(Q.stoppedLocation))}ge.to=ie})(Be=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(ge){function be(Q){return{range:o.from(Q.range),kind:Q.kind}}ge.from=be;function ie(Q){return new b.DocumentHighlight(o.to(Q.range),Q.kind)}ge.to=ie})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var He;(function(ge){function be(ie){switch(ie){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}ge.to=be})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var G;(function(ge){function be(ie){return{triggerKind:He.to(ie.triggerKind),triggerCharacter:ie.triggerCharacter}}ge.to=be})(G=e.CompletionContext||(e.CompletionContext={}));var ee;(function(ge){function be(Q){switch(Q){case b.CompletionItemTag.Deprecated:return 1}}ge.from=be;function ie(Q){switch(Q){case 1:return b.CompletionItemTag.Deprecated}}ge.to=ie})(ee=e.CompletionItemTag||(e.CompletionItemTag={}));var te;(function(ge){const be=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function ie(Le){return be.get(Le)??9}ge.from=ie;const Q=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Se(Le){return Q.get(Le)??b.CompletionItemKind.Property}ge.to=Se})(te=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(ge){function be(ie,Q){const Se=new b.CompletionItem(ie.label);return Se.insertText=ie.insertText,Se.kind=te.to(ie.kind),Se.tags=ie.tags?.map(ee.to),Se.detail=ie.detail,Se.documentation=C.isMarkdownString(ie.documentation)?E.to(ie.documentation):ie.documentation,Se.sortText=ie.sortText,Se.filterText=ie.filterText,Se.preselect=ie.preselect,Se.commitCharacters=ie.commitCharacters,i.Range.isIRange(ie.range)?Se.range=o.to(ie.range):typeof ie.range=="object"&&(Se.range={inserting:o.to(ie.range.insert),replacing:o.to(ie.range.replace)}),Se.keepWhitespace=typeof ie.insertTextRules=="undefined"?!1:Boolean(ie.insertTextRules&1),typeof ie.insertTextRules!="undefined"&&ie.insertTextRules&4?Se.insertText=new b.SnippetString(ie.insertText):(Se.insertText=ie.insertText,Se.textEdit=Se.range instanceof b.Range?new b.TextEdit(Se.range,Se.insertText):void 0),ie.additionalTextEdits&&ie.additionalTextEdits.length>0&&(Se.additionalTextEdits=ie.additionalTextEdits.map(Le=>N.to(Le))),Se.command=Q&&ie.command?Q.fromInternal(ie.command):void 0,Se}ge.to=be})(ce=e.CompletionItem||(e.CompletionItem={}));var Z;(function(ge){function be(Q){return{label:Q.label,documentation:Q.documentation?E.fromStrict(Q.documentation):void 0}}ge.from=be;function ie(Q){return{label:Q.label,documentation:C.isMarkdownString(Q.documentation)?E.to(Q.documentation):Q.documentation}}ge.to=ie})(Z=e.ParameterInformation||(e.ParameterInformation={}));var re;(function(ge){function be(Q){return{label:Q.label,documentation:Q.documentation?E.fromStrict(Q.documentation):void 0,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Z.from):[],activeParameter:Q.activeParameter}}ge.from=be;function ie(Q){return{label:Q.label,documentation:C.isMarkdownString(Q.documentation)?E.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Z.to):[],activeParameter:Q.activeParameter}}ge.to=ie})(re=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(ge){function be(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(re.from):[]}}ge.from=be;function ie(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(re.to):[]}}ge.to=ie})(pe=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ge){function be(Q){return{text:Q.text,position:n.from(Q.position),kind:je.from(Q.kind??b.InlayHintKind.Other),whitespaceBefore:Q.whitespaceBefore,whitespaceAfter:Q.whitespaceAfter}}ge.from=be;function ie(Q){const Se=new b.InlayHint(Q.text,n.to(Q.position),je.to(Q.kind));return Se.whitespaceAfter=Q.whitespaceAfter,Se.whitespaceBefore=Q.whitespaceBefore,Se}ge.to=ie})(Me=e.InlayHint||(e.InlayHint={}));var je;(function(ge){function be(Q){return Q}ge.from=be;function ie(Q){return Q}ge.to=ie})(je=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(ge){function be(Q){return{range:o.from(Q.range),url:Q.target,tooltip:Q.tooltip}}ge.from=be;function ie(Q){let Se;if(Q.url)try{Se=typeof Q.url=="string"?k.URI.parse(Q.url,!0):k.URI.revive(Q.url)}catch(Le){}return new b.DocumentLink(o.to(Q.range),Se)}ge.to=ie})(Ke=e.DocumentLink||(e.DocumentLink={}));var Ze;(function(ge){function be(Q){const Se=new b.ColorPresentation(Q.label);return Q.textEdit&&(Se.textEdit=N.to(Q.textEdit)),Q.additionalTextEdits&&(Se.additionalTextEdits=Q.additionalTextEdits.map(Le=>N.to(Le))),Se}ge.to=be;function ie(Q){return{label:Q.label,textEdit:Q.textEdit?N.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Se=>N.from(Se)):void 0}}ge.from=ie})(Ze=e.ColorPresentation||(e.ColorPresentation={}));var rt;(function(ge){function be(Q){return new b.Color(Q[0],Q[1],Q[2],Q[3])}ge.to=be;function ie(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}ge.from=ie})(rt=e.Color||(e.Color={}));var ct;(function(ge){function be(Q){return{range:o.from(Q.range)}}ge.from=be;function ie(Q){return new b.SelectionRange(o.to(Q.range))}ge.to=ie})(ct=e.SelectionRange||(e.SelectionRange={}));var ye;(function(ge){function be(ie){switch(ie){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}ge.to=be})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var at;(function(ge){function be(Q){switch(Q){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}ge.from=be;function ie(Q){switch(Q){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}ge.to=ie})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(ge){function be(Q){if(Q===b.EndOfLine.CRLF)return 1;if(Q===b.EndOfLine.LF)return 0}ge.from=be;function ie(Q){if(Q===1)return b.EndOfLine.CRLF;if(Q===0)return b.EndOfLine.LF}ge.to=ie})(J=e.EndOfLine||(e.EndOfLine={}));var se;(function(ge){function be(ie){if(typeof ie=="object")return ie.viewId;switch(ie){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ge.from=be})(se=e.ProgressLocation||(e.ProgressLocation={}));var Ee;(function(ge){function be(ie){const Q={start:ie.start+1,end:ie.end+1};return ie.kind&&(Q.kind=Qe.from(ie.kind)),Q}ge.from=be})(Ee=e.FoldingRange||(e.FoldingRange={}));var Qe;(function(ge){function be(ie){if(ie)switch(ie){case b.FoldingRangeKind.Comment:return I.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return I.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return I.FoldingRangeKind.Region}}ge.from=be})(Qe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var et;(function(ge){function be(ie){if(ie)return{pinned:typeof ie.preview=="boolean"?!ie.preview:void 0,inactive:ie.background,preserveFocus:ie.preserveFocus,selection:typeof ie.selection=="object"?o.from(ie.selection):void 0,override:typeof ie.override=="boolean"?a.EditorResolution.DISABLED:void 0}}ge.from=be})(et=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var le;(function(ge){function be(Q){return Q instanceof b.RelativePattern||typeof Q=="string"?Q:ie(Q)?new b.RelativePattern(Q.base,Q.pattern):Q}ge.from=be;function ie(Q){const Se=Q;return Se&&typeof Se.base=="string"&&typeof Se.pattern=="string"}})(le=e.GlobPattern||(e.GlobPattern={}));var Ie;(function(ge){function be(ie){if(ie){if(Array.isArray(ie))return ie.map(be);if(typeof ie=="string")return ie;{const Q=ie;return{language:Q.language,scheme:Q.scheme,pattern:typeof Q.pattern=="undefined"?void 0:le.from(Q.pattern),exclusive:Q.exclusive}}}else return}ge.from=be})(Ie=e.LanguageSelector||(e.LanguageSelector={}));var Ue;(function(ge){function be(Q){return{start:Q.start,end:Q.end}}ge.from=be;function ie(Q){return new b.NotebookRange(Q.start,Q.end)}ge.to=ie})(Ue=e.NotebookRange||(e.NotebookRange={}));var Xe;(function(ge){function be(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}ge.to=be;function ie(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}ge.from=ie})(Xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var it;(function(ge){function be(Q){switch(Q){case b.NotebookCellKind.Markup:return w.CellKind.Markup;case b.NotebookCellKind.Code:default:return w.CellKind.Code}}ge.from=be;function ie(Q){switch(Q){case w.CellKind.Markup:return b.NotebookCellKind.Markup;case w.CellKind.Code:default:return b.NotebookCellKind.Code}}ge.to=ie})(it=e.NotebookCellKind||(e.NotebookCellKind={}));var ft;(function(ge){function be(Q){const Se={metadata:Q.metadata??Object.create(null),cells:[]};for(let Le of Q.cells)b.NotebookCellData.validate(Le),Se.cells.push(tt.from(Le));return Se}ge.from=be;function ie(Q){const Se=new b.NotebookData(Q.cells.map(tt.to));return(0,y.isEmptyObject)(Q.metadata)||(Se.metadata=Q.metadata),Se}ge.to=ie})(ft=e.NotebookData||(e.NotebookData={}));var tt;(function(ge){function be(Q){return{cellKind:it.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:Xe.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Re.from):[]}}ge.from=be;function ie(Q){return new b.NotebookCellData(it.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Re.to):void 0,Q.metadata,Q.internalMetadata?Xe.to(Q.internalMetadata):void 0)}ge.to=ie})(tt=e.NotebookCellData||(e.NotebookCellData={}));var ut;(function(ge){function be(Q){return{mime:Q.mime,valueBytes:F.VSBuffer.wrap(Q.data)}}ge.from=be;function ie(Q){return new b.NotebookCellOutputItem(Q.valueBytes.buffer,Q.mime)}ge.to=ie})(ut=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Re;(function(ge){function be(Q){return{outputId:Q.id,items:Q.items.map(ut.from),metadata:Q.metadata}}ge.from=be;function ie(Q){const Se=Q.items.map(ut.to);return new b.NotebookCellOutput(Se,Q.outputId,Q.metadata)}ge.to=ie})(Re=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(ge){function be(Le){if(Le!=null){if(Le instanceof b.RelativePattern||typeof Le=="string")return Le;if(Se(Le))return new b.RelativePattern(Le.base,Le.pattern);if(Q(Le))return{include:le.from(Le.include)||void 0,exclude:le.from(Le.exclude)||void 0}}}ge.from=be;function ie(Le){return typeof Le=="string"?Le:Se(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}ge.to=ie;function Q(Le){const nt=Le,qe=le.from(nt.include);if(!(qe&&qe instanceof b.RelativePattern||typeof qe=="string"))return!1;const gt=le.from(nt.exclude);return!!(gt&&gt instanceof b.RelativePattern||typeof gt=="string")}function Se(Le){const nt=Le;return nt&&typeof nt.base=="string"&&typeof nt.pattern=="string"}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Te;(function(ge){function be(ie){return{backgroundColor:ie.backgroundColor,borderColor:ie.borderColor,top:ie.top?M.from(ie.top):void 0}}ge.from=be})(Te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var oe;(function(ge){function be(ie,Q,Se){const Le=typeof ie.command=="string"?{title:"",command:ie.command}:ie.command;return{alignment:ie.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Le,Se),text:ie.text,tooltip:ie.tooltip,accessibilityInformation:ie.accessibilityInformation,priority:ie.priority}}ge.from=be})(oe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(ge){function be(ie){return{transientOutputs:ie?.transientOutputs??!1,transientCellMetadata:ie?.transientCellMetadata??{},transientDocumentMetadata:ie?.transientDocumentMetadata??{}}}ge.from=be})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var we;(function(ge){function be(Q){return{uri:Q.uri,provides:Q.provides}}ge.from=be;function ie(Q){return new b.NotebookRendererScript(k.URI.revive(Q.uri),Q.provides)}ge.to=ie})(we=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ve;(function(ge){function be(Q){return{message:E.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,location:Q.location?K.from(Q.location):void 0}}ge.from=be;function ie(Q){const Se=new b.TestMessage(typeof Q.message=="string"?Q.message:E.to(Q.message));return Se.actualOutput=Q.actual,Se.expectedOutput=Q.expected,Se.location=Q.location?K.to(Q.location):void 0,Se}ge.to=ie})(ve=e.TestMessage||(e.TestMessage={}));var Fe;(function(ge){let be;(function(ie){ie.Delimiter="\0"})(be||(be={})),ge.namespace=(ie,Q)=>ie+"\0"+Q,ge.denamespace=ie=>{const Q=ie.indexOf("\0");return{ctrlId:ie.slice(0,Q),tagId:ie.slice(Q+1)}}})(Fe=e.TestTag||(e.TestTag={}));var Ge;(function(ge){function be(Le){const nt=(0,h.getPrivateApiFor)(Le).controllerId;return{extId:D.TestId.fromExtHostTestItem(Le,nt).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(qe=>Fe.namespace(nt,qe.id)),range:o.from(Le.range)||null,description:Le.description||null,error:Le.error&&E.fromStrict(Le.error)||null}}ge.from=be;function ie(Le){return{id:D.TestId.fromString(Le.extId).localId,label:Le.label,uri:k.URI.revive(Le.uri),tags:(Le.tags||[]).map(nt=>{const{tagId:qe}=Fe.denamespace(nt);return new b.TestTag(qe)}),range:o.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}ge.toPlain=ie;function Q(Le){const nt=D.TestId.fromString(Le.extId),qe=new h.TestItemImpl(nt.controllerId,nt.localId,Le.label,k.URI.revive(Le.uri));return qe.range=o.to(Le.range||void 0),qe.description=Le.description||void 0,qe}function Se(Le){let nt;for(const qe of Le.tests){const gt=Q(qe.item);(0,h.getPrivateApiFor)(gt).parent=nt,nt=gt}return nt}ge.toItemFromContext=Se})(Ge=e.TestItem||(e.TestItem={})),function(ge){function be(Q){return{id:Q.id}}ge.from=be;function ie(Q){return new b.TestTag(Q.id)}ge.to=ie}(Fe=e.TestTag||(e.TestTag={}));var ze;(function(ge){const be=(Q,Se)=>{const Le={...Ge.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(nt=>({state:nt.state,duration:nt.duration,messages:nt.messages.filter(qe=>qe.type===0).map(ve.to)})),children:Q.children.map(nt=>Se.get(nt)).filter(y.isDefined).map(nt=>be(nt,Se))};for(const nt of Le.children)nt.parent=Le;return Le};function ie(Q){const Se=[],Le=new Map;for(const nt of Q.items)Le.set(nt.item.extId,nt),Q.request.targets.some(qe=>qe.controllerId===nt.controllerId&&qe.testIds.includes(nt.item.extId))&&Se.push(nt);return{completedAt:Q.completedAt,results:Se.map(nt=>be(nt,Le))}}ge.to=ie})(ze=e.TestResults||(e.TestResults={}));var Ye;(function(ge){function be(Le){return{covered:Le.covered,total:Le.covered}}function ie(Le){return"line"in Le?n.from(Le):o.from(Le)}function Q(Le){return"branches"in Le?{count:Le.executionCount,location:ie(Le.location),type:1,branches:Le.branches.length?Le.branches.map(nt=>({count:nt.executionCount,location:nt.location&&ie(nt.location)})):void 0}:{type:0,count:Le.executionCount,location:ie(Le.location)}}ge.fromDetailed=Q;function Se(Le){return{uri:Le.uri,statement:be(Le.statementCoverage),branch:Le.branchCoverage&&be(Le.branchCoverage),function:Le.functionCoverage&&be(Le.functionCoverage),details:Le.detailedCoverage?.map(Q)}}ge.fromFile=Se})(Ye=e.TestCoverage||(e.TestCoverage={}));var lt;(function(ge){function be(ie){switch(ie){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}ge.to=be})(lt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xe;(function(ge){function be(Q){const Se=new b.TypeHierarchyItem(U.to(Q.kind),Q.name,Q.detail||"",k.URI.revive(Q.uri),o.to(Q.range),o.to(Q.selectionRange));return Se._sessionId=Q._sessionId,Se._itemId=Q._itemId,Se}ge.to=be;function ie(Q,Se,Le){if(Se=Se??Q._sessionId,Le=Le??Q._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,kind:U.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}ge.from=ie})(xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(fe[219],me([0,1,2,17,7,16,95]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class _{constructor(k,i,I,a={timeout:1500,errors:3}){this._logService=k,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=a,this._callbacks=new P.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(i,I,a)=>{const h={dispose:this._callbacks.push([i,I,k])};return Array.isArray(a)&&a.push(h),h}}async $participateInSave(k,i){const I=g.URI.revive(k);let a=!1;const p=setTimeout(()=>a=!0,this._thresholds.timeout),h=[];try{for(let w of[...this._callbacks]){if(a)break;const D=this._documents.getDocument(I),T=await this._deliverEventAsyncAndBlameBadListeners(w,{document:D,reason:S.TextDocumentSaveReason.to(i)});h.push(T)}}finally{clearTimeout(p)}return h}_deliverEventAsyncAndBlameBadListeners([k,i,I],a){const p=this._badListeners.get(k);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,k,i,a).then(()=>!0,h=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const w=this._badListeners.get(k);this._badListeners.set(k,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,i,I,a){const p=[],h=Date.now(),{document:w,reason:D}=a,{version:T}=w,b=Object.freeze({document:w,reason:D,waitUntil(l){if(Object.isFrozen(p))throw(0,F.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(l))}});try{i.apply(I,[b])}catch(l){return Promise.reject(l)}return Object.freeze(p),new Promise((l,o)=>{const v=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(v),l(n)}).catch(n=>{clearTimeout(v),o(n)})}).then(l=>{const o={edits:[]};for(const v of l)if(Array.isArray(v)&&v.every(n=>n instanceof C.TextEdit))for(const{newText:n,newEol:f,range:r}of v)o.edits.push({_type:2,resource:w.uri,edit:{range:r&&S.Range.from(r),text:n,eol:f&&S.EndOfLine.from(f)}});if(o.edits.length!==0)return T===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=_}),define(fe[220],me([0,1,3,30,2,16,7]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{constructor(i,I,a,p,h){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,a&&(this._config+=1),p&&(this._config+=2),h&&(this._config+=4);const w=(0,F.parse)(I),D=i(T=>{if(!a)for(let b of T.created){const l=C.URI.revive(b);w(l.fsPath)&&this._onDidCreate.fire(l)}if(!p)for(let b of T.changed){const l=C.URI.revive(b);w(l.fsPath)&&this._onDidChange.fire(l)}if(!h)for(let b of T.deleted){const l=C.URI.revive(b);w(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,D)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(i,I,a){this._logService=I,this._extHostDocumentsAndEditors=a,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(i,I,a,p){return new _(this._onFileSystemEvent.event,i,I,a,p)}$onFileEvent(i){this._onFileSystemEvent.fire(i)}$onDidRunFileOperation(i,I){switch(i){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(a=>({oldUri:C.URI.revive(a.source),newUri:C.URI.revive(a.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(a=>C.URI.revive(a.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(a=>C.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(i){return this._createWillExecuteEvent(i,this._onWillRenameFile)}getOnWillCreateFileEvent(i){return this._createWillExecuteEvent(i,this._onWillCreateFile)}getOnWillDeleteFileEvent(i){return this._createWillExecuteEvent(i,this._onWillDeleteFile)}_createWillExecuteEvent(i,I){return(a,p,h)=>{const w=function(T){a.call(p,T)};return w.extension=i,I.event(w,void 0,h)}}async $onWillRunFileOperation(i,I,a,p){switch(i){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(h=>({oldUri:C.URI.revive(h.source),newUri:C.URI.revive(h.target)}))},a,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(h=>C.URI.revive(h.target))},a,p);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(h=>C.URI.revive(h.target))},a,p)}}async _fireWillEvent(i,I,a,p){const h=new Set,w=[];if(await i.fireAsync(I,p,async(T,b)=>{const l=Date.now(),o=await Promise.resolve(T);o instanceof P.WorkspaceEdit&&(w.push(o),h.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-l>a&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),p.isCancellationRequested||w.length===0)return;const D={edits:[]};for(let T of w){let{edits:b}=S.WorkspaceEdit.from(T,this._extHostDocumentsAndEditors);D.edits=D.edits.concat(b)}return{edit:D,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=y}),define(fe[221],me([0,1,10,25,2,16,7,128]),function(Y,e,g,F,C,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(a,p,h,w){this.start=a,this.deletedCount=p,this.deletedItems=h,this.items=w}static asApiEvents(a){return a.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(h=>h.apiCell)}))}}class k{constructor(a,p,h){this.notebook=a,this._extHostDocument=p,this._cellData=h,this.handle=h.handle,this.uri=C.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=h.internalMetadata??{},this._metadata=Object.freeze(h.metadata??{}),this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(h.internalMetadata??{}))}static asModelAddData(a,p){return{EOL:p.eol,lines:p.source,modeId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:a}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const a=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return a.notebook.getCellIndex(a)},notebook:a.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return a._mime},set mime(h){a._mime=h},get outputs(){return a._outputs.slice(0)},get metadata(){return a._metadata},get executionSummary(){return a._previousResult}})}return this._apiCell}setOutputs(a){this._outputs=a.map(S.NotebookCellOutput.to)}setOutputItems(a,p,h){const w=h.map(S.NotebookCellOutputItem.to),D=this._outputs.find(T=>T.id===a);D&&(p||(D.items.length=0),D.items.push(...w))}setMetadata(a){this._metadata=Object.freeze(a)}setInternalMetadata(a){this._internalMetadata=a,this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(a))}setMime(a){}}e.ExtHostCell=k;class i{constructor(a,p,h,w,D,T){this._proxy=a,this._textDocumentsAndEditors=p,this._textDocuments=h,this._emitter=w,this.uri=D,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=T.viewType,this._metadata=Object.freeze(T.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,T.cells]],!0),this._versionId=T.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const a=this;this._notebook={get uri(){return a.uri},get version(){return a._versionId},get notebookType(){return a._notebookType},get isDirty(){return a._isDirty},get isUntitled(){return a.uri.scheme===g.Schemas.untitled},get isClosed(){return a._disposed},get metadata(){return a._metadata},get cellCount(){return a._cells.length},cellAt(p){return p=a._validateIndex(p),a._cells[p].apiCell},getCells(p){return(p?a._getCells(p):a._cells).map(w=>w.apiCell)},save(){return a._save()}}}return this._notebook}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(a){a.metadata&&(this._metadata=Object.freeze({...this._metadata,...a.metadata}))}acceptDirty(a){this._isDirty=a}acceptModelChanged(a,p){this._versionId=a.versionId,this._isDirty=p;for(const h of a.rawEvents)h.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===_.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===_.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===_.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===_.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===_.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(h.index,h.metadata):h.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(h.index,h.internalMetadata)}_validateIndex(a){return a=a|0,a<0?0:a>=this._cells.length?this._cells.length-1:a}_validateRange(a){let p=a.start|0,h=a.end|0;return p<0&&(p=0),h>this._cells.length&&(h=this._cells.length),a.with({start:p,end:h})}_getCells(a){a=this._validateRange(a);const p=[];for(let h=a.start;h<a.end;h++)p.push(this._cells[h]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(a,p){if(this._disposed)return;const h=[],w=[],D=[];a.reverse().forEach(T=>{const l=T[2].map(n=>{const f=new k(this,this._textDocumentsAndEditors,n);return p||w.push(k.asModelAddData(this.apiNotebook,n)),f}),o=new y(T[0],T[1],[],l),v=this._cells.splice(T[0],T[1],...l);for(const n of v)D.push(n.uri),o.deletedItems.push(n.apiCell);h.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:D}),p||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(h)}))}_moveCell(a,p){const h=this._cells.splice(a,1);this._cells.splice(p,0,...h);const w=[new y(a,1,h.map(D=>D.apiCell),[]),new y(p,0,[],h)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(w)}))}_setCellOutputs(a,p){const h=this._cells[a];h.setOutputs(p),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_setCellOutputItems(a,p,h,w){const D=this._cells[a];D.setOutputItems(p,h,w),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[D.apiCell]}))}_changeCellLanguage(a,p){const h=this._cells[a];h.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelModeChanged(h.uri,p)}_changeCellMime(a,p){const h=this._cells[a];h.apiCell.mime=p}_changeCellMetadata(a,p){const h=this._cells[a],w=h.apiCell.metadata;h.setMetadata(p);const D=h.apiCell.metadata;(0,F.equals)(w,D)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:h.apiCell}))}_changeCellInternalMetadata(a,p){const h=this._cells[a],w=h.internalMetadata;if(h.setInternalMetadata(p),w.runState!==p.runState){const D=p.runState??P.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:h.apiCell,state:D}))}}getCellFromApiCell(a){return this._cells.find(p=>p.apiCell===a)}getCellFromIndex(a){return this._cells[a]}getCell(a){return this._cells.find(p=>p.handle===a)}getCellIndex(a){return this._cells.indexOf(a)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(fe[131],me([0,1,7,16,17]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class S{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,k){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:k})}replaceCells(y,k,i){this._throwIfFinalized(),!(y===k&&i.length===0)&&this._collectedEdits.push({editType:1,index:y,count:k-y,cells:i.map(F.NotebookCellData.from)})}}class P{constructor(y,k,i,I,a,p){this.id=y,this._proxy=k,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=a,this._visibleRanges=I,this._viewColumn=p}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(k){if(!Array.isArray(k)||!k.every(g.NotebookRange.isNotebookRange))throw(0,C.illegalArgument)("selections");y._selections=k,y._trySetSelections(k)},get visibleRanges(){return y._visibleRanges},revealRange(k,i){y._proxy.$tryRevealRange(y.id,F.NotebookRange.from(k),i??g.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(k){const i=new S(this.document.version);return k(i),y._applyEdit(i.finalize())},setDecorations(k,i){return y.setDecorations(k,i)}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(F.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const k=[];let i=-1;for(let I=0;I<y.cellEdits.length;I++){if(i<0){k.push(y.cellEdits[I]),i++;continue}const p=k[i],h=y.cellEdits[I];if(p.editType===1&&h.editType===1&&p.index===h.index){p.cells.push(...y.cellEdits[I].cells),p.count+=y.cellEdits[I].count;continue}k.push(y.cellEdits[I]),i++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,k)}setDecorations(y,k){if(!(k.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return k.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(k),y.key)}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(fe[222],me([0,1,16,119,167,21,60,17]),function(Y,e,g,F,C,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(a){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=a}async withProgress(a,p,h){const w=this._handles++,{title:D,location:T,cancellable:b}=p,l={label:(0,C.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this._proxy.$startProgress(w,{location:g.ProgressLocation.from(T),title:D,source:l,cancellable:b},a).catch(_.onUnexpectedExternalError),this._withProgress(w,h,!!b)}_withProgress(a,p,h){let w;h&&(w=new S.CancellationTokenSource,this._mapHandleToCancellationSource.set(a,w));const D=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),w&&w.dispose()};let T;try{T=p(new i(this._proxy,a),h&&w?w.token:S.CancellationToken.None)}catch(b){throw D(a),b}return T.then(b=>D(a),b=>D(a)),T}$acceptProgressCanceled(a){const p=this._mapHandleToCancellationSource.get(a);p&&(p.cancel(),this._mapHandleToCancellationSource.delete(a))}}e.ExtHostProgress=y;function k(I,a){return I.message=a.message,typeof a.increment=="number"&&(typeof I.increment=="number"?I.increment+=a.increment:I.increment=a.increment),I}class i extends F.Progress{constructor(a,p){super(h=>this.throttledReport(h));this._proxy=a,this._handle=p}throttledReport(a){this._proxy.$progressReport(this._handle,a)}}Ve([(0,P.throttle)(100,(I,a)=>k(I,a),()=>Object.create(null))],i.prototype,"throttledReport",null)}),define(fe[132],me([0,1,58,17,77,16,7]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class _{constructor(a,p,h){const w=_._Keys.nextId();a.$registerTextEditorDecorationType(p.identifier,w,S.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:w,dispose(){a.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=_,_._Keys=new C.IdGenerator("TextEditorDecorationType");class y{constructor(a,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=a,this._documentVersionId=a.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(a,p){this._throwIfFinalized();let h=null;if(a instanceof P.Position)h=new P.Range(a,a);else if(a instanceof P.Range)h=a;else throw new Error("Unrecognized location");this._pushEdit(h,p,!1)}insert(a,p){this._throwIfFinalized(),this._pushEdit(new P.Range(a,a),p,!0)}delete(a){this._throwIfFinalized();let p=null;if(a instanceof P.Range)p=a;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(a,p,h){const w=this._document.validateRange(a);this._collectedEdits.push({range:w,text:p,forceMoveMarkers:h})}setEndOfLine(a){if(this._throwIfFinalized(),a!==P.EndOfLine.LF&&a!==P.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=a}}e.TextEditorEdit=y;class k{constructor(a,p,h,w){this._proxy=a,this._id=p,this._accept(h),this._logService=w;const D=this;this.value={get tabSize(){return D._tabSize},set tabSize(T){D._setTabSize(T)},get insertSpaces(){return D._insertSpaces},set insertSpaces(T){D._setInsertSpaces(T)},get cursorStyle(){return D._cursorStyle},set cursorStyle(T){D._setCursorStyle(T)},get lineNumbers(){return D._lineNumbers},set lineNumbers(T){D._setLineNumbers(T)}}}_accept(a){this._tabSize=a.tabSize,this._insertSpaces=a.insertSpaces,this._cursorStyle=a.cursorStyle,this._lineNumbers=S.TextEditorLineNumbersStyle.to(a.lineNumbers)}_validateTabSize(a){if(a==="auto")return"auto";if(typeof a=="number"){const p=Math.floor(a);return p>0?p:null}if(typeof a=="string"){const p=parseInt(a,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(a){const p=this._validateTabSize(a);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(a){return a==="auto"?"auto":a==="false"?!1:Boolean(a)}_setInsertSpaces(a){const p=this._validateInsertSpaces(a);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(a){this._cursorStyle!==a&&(this._cursorStyle=a,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:a})))}_setLineNumbers(a){this._lineNumbers!==a&&(this._lineNumbers=a,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:S.TextEditorLineNumbersStyle.from(a)})))}assign(a){const p={};let h=!1;if(typeof a.tabSize!="undefined"){const w=this._validateTabSize(a.tabSize);w==="auto"?(h=!0,p.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,h=!0,p.tabSize=w)}if(typeof a.insertSpaces!="undefined"){const w=this._validateInsertSpaces(a.insertSpaces);w==="auto"?(h=!0,p.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,h=!0,p.insertSpaces=w)}typeof a.cursorStyle!="undefined"&&this._cursorStyle!==a.cursorStyle&&(this._cursorStyle=a.cursorStyle,h=!0,p.cursorStyle=a.cursorStyle),typeof a.lineNumbers!="undefined"&&this._lineNumbers!==a.lineNumbers&&(this._lineNumbers=a.lineNumbers,h=!0,p.lineNumbers=S.TextEditorLineNumbersStyle.from(a.lineNumbers)),h&&this._warnOnError(this._proxy.$trySetOptions(this._id,p))}_warnOnError(a){a.catch(p=>this._logService.warn(p))}}e.ExtHostTextEditorOptions=k;class i{constructor(a,p,h,w,D,T,b,l){this.id=a,this._proxy=p,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=D,this._options=new k(this._proxy,this.id,T,h),this._visibleRanges=b,this._viewColumn=l;const o=this;this.value=Object.freeze({get document(){return w.getValue()},set document(v){throw(0,F.readonly)("document")},get selection(){return o._selections&&o._selections[0]},set selection(v){if(!(v instanceof P.Selection))throw(0,F.illegalArgument)("selection");o._selections=[v],o._trySetSelection()},get selections(){return o._selections},set selections(v){if(!Array.isArray(v)||v.some(n=>!(n instanceof P.Selection)))throw(0,F.illegalArgument)("selections");o._selections=v,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(v){throw(0,F.readonly)("visibleRanges")},get options(){return o._options.value},set options(v){o._disposed||o._options.assign(v)},get viewColumn(){return o._viewColumn},set viewColumn(v){throw(0,F.readonly)("viewColumn")},edit(v,n={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new y(w.getValue(),n);return v(f),o._applyEdit(f)},insertSnippet(v,n,f={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!n||Array.isArray(n)&&n.length===0)r=o._selections.map(t=>S.Range.from(t));else if(n instanceof P.Position){const{lineNumber:t,column:d}=S.Position.from(n);r=[{startLineNumber:t,startColumn:d,endLineNumber:t,endColumn:d}]}else if(n instanceof P.Range)r=[S.Range.from(n)];else{r=[];for(const t of n)if(t instanceof P.Range)r.push(S.Range.from(t));else{const{lineNumber:d,column:s}=S.Position.from(t);r.push({startLineNumber:d,startColumn:s,endLineNumber:d,endColumn:s})}}return p.$tryInsertSnippet(a,v.value,r,f)},setDecorations(v,n){const f=n.length===0;f&&!o._hasDecorationsForKey.has(v.key)||(f?o._hasDecorationsForKey.delete(v.key):o._hasDecorationsForKey.add(v.key),o._runOnProxy(()=>{if(S.isDecorationOptionsArr(n))return p.$trySetDecorations(a,v.key,S.fromRangeOrRangeWithMessage(n));{const r=new Array(4*n.length);for(let t=0,d=n.length;t<d;t++){const s=n[t];r[4*t]=s.start.line+1,r[4*t+1]=s.start.character+1,r[4*t+2]=s.end.line+1,r[4*t+3]=s.end.character+1}return p.$trySetDecorationsFast(a,v.key,r)}}))},revealRange(v,n){o._runOnProxy(()=>p.$tryRevealRange(a,S.Range.from(v),n||P.TextEditorRevealType.Default))},show(v){p.$tryShowEditor(a,S.ViewColumn.from(v))},hide(){p.$tryHideEditor(a)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(a){(0,g.ok)(!this._disposed),this._options._accept(a)}_acceptVisibleRanges(a){(0,g.ok)(!this._disposed),this._visibleRanges=a}_acceptViewColumn(a){(0,g.ok)(!this._disposed),this._viewColumn=a}_acceptSelections(a){(0,g.ok)(!this._disposed),this._selections=a}async _trySetSelection(){const a=this._selections.map(S.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,a)),this.value}_applyEdit(a){const p=a.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const h=p.edits.map(D=>D.range);h.sort((D,T)=>D.end.line===T.end.line?D.end.character===T.end.character?D.start.line===T.start.line?D.start.character-T.start.character:D.start.line-T.start.line:D.end.character-T.end.character:D.end.line-T.end.line);for(let D=0,T=h.length-1;D<T;D++){const b=h[D].end;if(h[D+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=p.edits.map(D=>({range:S.Range.from(D.range),text:D.text,forceMoveMarkers:D.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,w,{setEndOfLine:typeof p.setEndOfLine=="number"?S.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(a){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=i}),define(fe[223],me([0,1,170,23,2,3,6,210,15,7,12,18,16,21,207]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function w(b,l){if((0,i.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let o;return Array.isArray(b.highlights)&&(o=b.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),o=o.length?o:void 0),{label:b.label,highlights:o}}}class D{constructor(l,o,v){this._proxy=l,this.commands=o,this.logService=v,this.treeViews=new Map;function n(f){return f&&f.$treeViewId&&f.$treeItemHandle}o.registerArgumentProcessor({processArgument:f=>n(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(r=>n(r)?this.convertArgument(r):r):f})}registerTreeDataProvider(l,o,v){const n=this.createTreeView(l,{treeDataProvider:o},v);return{dispose:()=>n.dispose()}}createTreeView(l,o,v){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=o.dragAndDropController!==void 0,f=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,canDragAndDrop:n}),r=this.createExtHostTreeView(l,o,v);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(t){r.message=t},get title(){return r.title},set title(t){r.title=t},get description(){return r.description},set description(t){r.description=t},reveal:(t,d)=>r.reveal(t,d),dispose:async()=>{await f,this.treeViews.delete(l),r.dispose()}}}$getChildren(l,o){const v=this.treeViews.get(l);return v?v.getChildren(o):Promise.reject(new Error((0,g.localize)(0,null,l)))}async $onDrop(l,o,v){const n=this.treeViews.get(l);if(!n)return Promise.reject(new Error((0,g.localize)(1,null,l)));const f=h.TreeDataTransferConverter.toITreeDataTransfer(o);if(f.items.has(_.TREE_ITEM_DATA_TRANSFER_TYPE)){const t=JSON.parse(await f.items.get(_.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(d=>n.getExtensionElement(d)).filter(d=>!!d);t.length>0?f.items.set(_.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(t)}):f.items.delete(_.TREE_ITEM_DATA_TRANSFER_TYPE)}return n.onDrop(f,v)}async $hasResolve(l){const o=this.treeViews.get(l);if(!o)throw new Error((0,g.localize)(2,null,l));return o.hasResolve}$resolve(l,o,v){const n=this.treeViews.get(l);if(!n)throw new Error((0,g.localize)(3,null,l));return n.resolveTreeItem(o,v)}$setExpanded(l,o,v){const n=this.treeViews.get(l);if(!n)throw new Error((0,g.localize)(4,null,l));n.setExpanded(o,v)}$setSelection(l,o){const v=this.treeViews.get(l);if(!v)throw new Error((0,g.localize)(5,null,l));v.setSelection(o)}$setVisible(l,o){const v=this.treeViews.get(l);if(!v)throw new Error((0,g.localize)(6,null,l));v.setVisible(o)}createExtHostTreeView(l,o,v){const n=new T(l,o,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(l,n),n}convertArgument(l){const o=this.treeViews.get(l.$treeViewId);return o?o.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=D;class T extends P.Disposable{constructor(l,o,v,n,f,r){super();if(this.viewId=l,this.proxy=v,this.commands=n,this.logService=f,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new S.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new S.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new S.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new S.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new S.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,r.contributes&&r.contributes.views)for(const s in r.contributes.views)for(const c of r.contributes.views[s])c.id===l&&(this._title=c.name);this.dataProvider=o.treeDataProvider,this.dndController=o.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(s=>this._onDidChangeData.fire({message:!1,element:s}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let t,d;this._register(S.Event.debounce(this._onDidChangeData.event,(s,c)=>(s||(s={message:!1,elements:[]}),c.element!==!1&&(t||(t=new Promise(m=>d=m),this.refreshPromise=this.refreshPromise.then(()=>t)),Array.isArray(c.element)?s.elements.push(...c.element):s.elements.push(c.element)),c.message&&(s.message=!0),s),200,!0)(({message:s,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=d;return t=null,this.refresh(c).then(()=>m())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,i.isUndefinedOrNull)(l))}async getChildren(l){const o=l?this.getExtensionElement(l):void 0;if(l&&!o)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let v=this.getChildrenNodes(l);return v||(v=await this.fetchChildrenNodes(o)),v?v.map(n=>n.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,o){o=o||{select:!0,focus:!1};const v=(0,i.isUndefinedOrNull)(o.select)?!0:o.select,n=(0,i.isUndefinedOrNull)(o.focus)?!1:o.focus,f=(0,i.isUndefinedOrNull)(o.expand)?!1:o.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(r=>this.resolveTreeNode(l,r[r.length-1]).then(t=>this.proxy.$reveal(this.viewId,{item:t.item,parentChain:r.map(d=>d.item)},{select:v,focus:n,expand:f})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:n,expand:f})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}setExpanded(l,o){const v=this.getExtensionElement(l);v&&(o?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(l){(0,I.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(l,o){const v=this.getExtensionElement(o);if(!!v)return(0,y.asPromise)(()=>this.dndController?.onDrop(l,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,o){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(l);if(v){const n=this.nodes.get(v);if(n){const f=await this.dataProvider.resolveTreeItem(n.extensionItem,v,o)??n.extensionItem;return n.item.tooltip=this.getTooltip(f.tooltip),n.item.command=this.getCommand(n.disposableStore,f.command),n.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(o=>o?this.resolveUnknownParentChain(o).then(v=>this.resolveTreeNode(o,v[v.length-1]).then(n=>(v.push(n),v))):Promise.resolve([]))}resolveParent(l){const o=this.nodes.get(l);return o?Promise.resolve(o.parent?this.elements.get(o.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,o){const v=this.nodes.get(l);return v?Promise.resolve(v):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(n=>this.createHandle(l,n,o,!0)).then(n=>this.getChildren(o?o.item.handle:void 0).then(()=>{const f=this.getExtensionElement(n);if(f){const r=this.nodes.get(f);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${n}`)}))}getChildrenNodes(l){if(l){let o;if(typeof l=="string"){const v=this.getExtensionElement(l);o=v?this.nodes.get(v):void 0}else o=l;return o&&o.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const o=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=l?this.nodes.get(l):void 0,n=await this.dataProvider.getChildren(l);if(o.token.isCancellationRequested)return;const f=await Promise.all((0,I.coalesce)(n||[]).map(async r=>{const t=await this.dataProvider.getTreeItem(r);return t&&!o.token.isCancellationRequested?this.createAndRegisterTreeNode(r,t,v):null}));return o.token.isCancellationRequested?void 0:(0,I.coalesce)(f)}finally{o.dispose()}}refresh(l){if(l.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(l);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const o=new Set,v=l.map(f=>this.nodes.get(f));for(const f of v)if(f&&!o.has(f.item.handle)){let r=f;for(;r&&r.parent&&v.findIndex(t=>r&&r.parent&&t&&t.item.handle===r.parent.item.handle)===-1;){const t=this.elements.get(r.parent.item.handle);r=t?this.nodes.get(t):void 0}r&&!r.parent&&o.add(f.item.handle)}const n=[];return o.forEach(f=>{const r=this.elements.get(f);if(r){const t=this.nodes.get(r);t&&(!t.parent||!o.has(t.parent.item.handle))&&n.push(f)}}),n}refreshHandles(l){const o={};return Promise.all(l.map(v=>this.refreshNode(v).then(n=>{n&&(o[v]=n.item)}))).then(()=>Object.keys(o).length?this.proxy.$refresh(this.viewId,o):void 0)}refreshNode(l){const o=this.getExtensionElement(l);if(o){const v=this.nodes.get(o);if(v)return this.clearChildren(o),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(n=>{if(n){const f=this.createTreeNode(o,n,v.parent);return this.updateNodeCache(o,f,v,v.parent),v.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,o,v){const n=this.createTreeNode(l,o,v);if(o.id&&this.elements.has(n.item.handle))throw new Error((0,g.localize)(7,null,o.id));return this.addNodeToCache(l,n),this.addNodeToParentCache(n,v),n}getTooltip(l){return k.MarkdownString.isMarkdownString(l)?a.MarkdownString.from(l):l}getCommand(l,o){return o?this.commands.toInternal(o,l):void 0}createTreeNode(l,o,v){const n=new P.DisposableStore,f=this.createHandle(l,o,v),r=this.getLightIconPath(o);return{item:{handle:f,parentHandle:v?v.item.handle:void 0,label:w(o.label,this.extension),description:o.description,resourceUri:o.resourceUri,tooltip:this.getTooltip(o.tooltip),command:this.getCommand(n,o.command),contextValue:o.contextValue,icon:r,iconDark:this.getDarkIconPath(o)||r,themeIcon:this.getThemeIcon(o),collapsibleState:(0,i.isUndefinedOrNull)(o.collapsibleState)?k.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation},extensionItem:o,parent:v,children:void 0,disposableStore:n,dispose(){n.dispose()}}}getThemeIcon(l){return l.iconPath instanceof k.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:o,label:v,resourceUri:n},f,r){if(o)return`${T.ID_HANDLE_PREFIX}/${o}`;const t=w(v,this.extension),d=f?f.item.handle:T.LABEL_HANDLE_PREFIX;let s=t?t.label:n?(0,F.basename)(n):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const c=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,m=this.getChildrenNodes(f)||[];let u,E=0;do{if(u=`${d}/${E}:${s}`,r||!this.elements.has(u)||c===u)break;E++}while(E<=m.length);return u}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof k.ThemeIcon))return typeof l.iconPath=="string"||C.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof k.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return C.URI.isUri(l)?l:C.URI.file(l)}addNodeToCache(l,o){this.elements.set(o.item.handle,l),this.nodes.set(l,o)}updateNodeCache(l,o,v,n){this.elements.delete(o.item.handle),this.nodes.delete(l),o.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(l,o);const f=this.getChildrenNodes(n)||[],r=f.filter(t=>t.item.handle===v.item.handle)[0];r&&f.splice(f.indexOf(r),1,o)}addNodeToParentCache(l,o){o?(o.children||(o.children=[]),o.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const o=this.nodes.get(l);if(o){if(o.children)for(const v of o.children){const n=this.elements.get(v.item.handle);n&&this.clear(n)}o.children=void 0}}else this.clearAll()}clear(l){const o=this.nodes.get(l);if(o){if(o.children)for(const v of o.children){const n=this.elements.get(v.item.handle);n&&this.clear(n)}this.nodes.delete(l),this.elements.delete(o.item.handle),o.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}T.LABEL_HANDLE_PREFIX="0",T.ID_HANDLE_PREFIX="1"}),define(fe[224],me([0,1,15,3,6,12,66,16,129,89]),function(Y,e,g,F,C,S,P,_,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class i extends C.Disposable{constructor(a){super();this.controllerId=a,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new P.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(a){this._resolveHandler=a;for(const p of this.tree.values())this.updateExpandability(p)}collectDiff(){const a=this.diff;return this.diff=[],a}pushDiff(a){const p=this.diff[this.diff.length-1];if(p&&a[0]===1){if(p[0]===1&&p[1].extId===a[1].extId){(0,y.applyTestItemUpdate)(p[1],a[1]);return}if(p[0]===0&&p[1].item.extId===a[1].extId){(0,y.applyTestItemUpdate)(p[1],a[1]);return}}this.diff.push(a),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(a,p){const h=this.tree.get(a);if(!!h){if((h.expandLevels===void 0||p>h.expandLevels)&&(h.expandLevels=p),h.expand===1){const w=this.resolveChildren(h);return w.isOpen()?this.expandChildren(h,p-1):w.wait().then(()=>this.expandChildren(h,p-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.expandChildren(h,p-1)):this.expandChildren(h,p-1)}}dispose(){for(const a of this.tree.values())(0,P.getPrivateApiFor)(a.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(a,p){switch(p.op){case 2:this.pushDiff([4,a.fullId.toString()]);break;case 1:this.removeItem(k.TestId.joinToString(a.fullId,p.id));break;case 0:this.upsertItem(p.item,a);break;case 4:for(const b of p.ops)this.onTestItemEvent(a,b);break;case 3:const{key:h,value:w,previous:D}=p,T=a.fullId.toString();switch(h){case"canResolveChildren":this.updateExpandability(a);break;case"tags":this.diffTagRefs(w,D,T);break;case"range":this.pushDiff([1,{extId:T,item:{range:_.Range.from(w)}}]);break;case"error":this.pushDiff([1,{extId:T,item:{error:_.MarkdownString.fromStrict(w)||null}}]);break;default:this.pushDiff([1,{extId:T,item:{[h]:w??null}}]);break}break;default:(0,S.assertNever)(p)}}upsertItem(a,p){if(!(a instanceof P.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${a.id} did not`);const h=k.TestId.fromExtHostTestItem(a,this.root.id,p?.actual),w=(0,P.getPrivateApiFor)(a);w.parent&&w.parent!==p?.actual&&w.parent.children.delete(a.id);let D=this.tree.get(h.toString());if(!D){D={fullId:h,actual:a,parent:p?h.parentId:null,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},a.tags.forEach(this.incrementTagRefs,this),this.tree.set(D.fullId.toString(),D),this.setItemParent(a,p),this.pushDiff([0,{parent:D.parent&&D.parent.toString(),controllerId:this.controllerId,expand:D.expand,item:_.TestItem.from(a)}]),this.connectItemAndChildren(a,D,p);return}if(D.actual===a){this.connectItem(a,D,p);return}const T=D.actual.children,b=D.actual,l=(0,P.diffTestItems)(b,a);(0,P.getPrivateApiFor)(b).listener=void 0,D.actual=a,D.expand=0;for(const[o,v]of l)this.onTestItemEvent(D,{op:3,key:o,value:v,previous:b[o]});this.connectItemAndChildren(a,D,p);for(const o of T)a.children.get(o.id)||this.removeItem(k.TestId.joinToString(h,o.id))}diffTagRefs(a,p,h){const w=new Set(p.map(D=>D.id));for(const D of a)w.delete(D.id)||this.incrementTagRefs(D);this.pushDiff([1,{extId:h,item:{tags:a.map(D=>_.TestTag.namespace(this.controllerId,D.id))}}]),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(a){const p=this.tags.get(a.id);p?p.refCount++:(this.tags.set(a.id,{refCount:1}),this.pushDiff([5,{id:_.TestTag.namespace(this.controllerId,a.id),ctrlLabel:this.root.label}]))}decrementTagRefs(a){const p=this.tags.get(a);p&&!--p.refCount&&(this.tags.delete(a),this.pushDiff([6,_.TestTag.namespace(this.controllerId,a)]))}setItemParent(a,p){(0,P.getPrivateApiFor)(a).parent=p&&p.actual!==this.root?p.actual:void 0}connectItem(a,p,h){this.setItemParent(a,h);const w=(0,P.getPrivateApiFor)(a);w.parent=h?.actual,w.listener=D=>this.onTestItemEvent(p,D),this.updateExpandability(p)}connectItemAndChildren(a,p,h){this.connectItem(a,p,h);for(const w of a.children)this.upsertItem(w,p)}updateExpandability(a){let p;this._resolveHandler?a.resolveBarrier?p=a.resolveBarrier.isOpen()?3:2:p=a.actual.canResolveChildren?1:0:p=0,p!==a.expand&&(a.expand=p,this.pushDiff([1,{extId:a.fullId.toString(),expand:p}]),p===1&&a.expandLevels!==void 0&&this.resolveChildren(a))}expandChildren(a,p){if(p<0)return;const h=[];for(const w of a.actual.children){const D=this.expand(k.TestId.joinToString(a.fullId,w.id),p);(0,g.isThenable)(D)&&h.push(D)}if(h.length)return Promise.all(h).then(()=>{})}resolveChildren(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this._resolveHandler){const D=new g.Barrier;return D.open(),D}a.expand=2,this.pushExpandStateUpdate(a);const p=a.resolveBarrier=new g.Barrier,h=D=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),a.actual!==this.root&&(a.actual.error=D.stack||D.message||String(D))};let w;try{w=this._resolveHandler(a.actual===this.root?void 0:a.actual)}catch(D){h(D)}return(0,g.isThenable)(w)?w.catch(h).then(()=>{p.open(),this.updateExpandability(a)}):(p.open(),this.updateExpandability(a)),a.resolveBarrier}pushExpandStateUpdate(a){this.pushDiff([1,{extId:a.fullId.toString(),expand:a.expand}])}removeItem(a){const p=this.tree.get(a);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff([2,a]);const h=[p];for(;h.length;){const w=h.pop();if(!!w){(0,P.getPrivateApiFor)(w.actual).listener=void 0;for(const D of w.actual.tags)this.decrementTagRefs(D.id);this.tree.delete(w.fullId.toString());for(const D of w.actual.children)h.push(this.tree.get(k.TestId.joinToString(w.fullId,D.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.diffOpEmitter.fire(a)}}e.SingleUseTestCollection=i}),define(fe[225],me([0,1,4,186]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(F.IEnvironmentService)}),define(fe[226],me([0,1,27,3,8]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class S{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=S;class P{constructor(i){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(a=>I.add(g.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>I.has(g.ExtensionIdentifier.toKey(a.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const a=P._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(a.map(p=>p.identifier)),I.length>0){const p=new Set;I.forEach(h=>p.add(g.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>!p.has(g.ExtensionIdentifier.toKey(h.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new S(a)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(D){this._nodesSet.has(D)||(this._nodesSet.add(D),this._nodesArr.push(D))}addArc(D,T){this.addNode(D),this.addNode(T),this._arcs.has(D)?this._arcs.get(D).push(T):this._arcs.set(D,[T])}getArcs(D){return this._arcs.has(D)?this._arcs.get(D):[]}hasOnlyGoodArcs(D,T){const b=I.getArcs(D);for(let l=0;l<b.length;l++)if(!T.has(b[l]))return!1;return!0}getNodes(){return this._nodesArr}};let a=new Map;for(let D of i){const T=g.ExtensionIdentifier.toKey(D.identifier);if(a.set(T,D),D.extensionDependencies)for(let b of D.extensionDependencies){const l=g.ExtensionIdentifier.toKey(b);I.addArc(T,l)}}let p=new Set;I.getNodes().filter(D=>I.getArcs(D).length===0).forEach(D=>p.add(D));let h=I.getNodes().filter(D=>!p.has(D)),w;do{w=!1;for(let D=0;D<h.length;D++){const T=h[D];I.hasOnlyGoodArcs(T,p)&&(h.splice(D,1),D--,p.add(T),w=!0)}}while(w);return h.map(D=>a.get(D))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=P;var _;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(_||(_={}));function y(k,i){const I=k.isBuiltin?0:k.isUnderDevelopment?2:1,a=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==a)return I-a;const p=C.posix.basename(k.extensionLocation.path),h=C.posix.basename(i.extensionLocation.path);return p<h?-1:p>h?1:0}}),define(fe[227],me([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(_){_[_.VersionMismatch=55]="VersionMismatch",_[_.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(_){_[_.Initialized=0]="Initialized",_[_.Ready=1]="Ready",_[_.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function S(_){const y=g.VSBuffer.alloc(1);switch(_){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=S;function P(_,y){if(_.byteLength!==1)return!1;switch(_.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=P}),define(fe[35],me([0,1,3,2,4,27,195]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new S.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");var _;(function(o){o[o.None=0]="None",o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(_=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function y(o){switch(o){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=y;class k{constructor(v){this.dependency=v}}e.MissingExtensionDependency=k;var i;(function(o){o[o.LocalProcess=0]="LocalProcess",o[o.LocalWebWorker=1]="LocalWebWorker",o[o.Remote=2]="Remote"})(i=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(o){switch(o){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=I;class a{constructor(v,n,f,r){this.codeLoadingTime=v,this.activateCallTime=n,this.activateResolvedTime=f,this.activationReason=r}}e.ActivationTimes=a;class p{constructor(v,n){this.description=v,this.value=n}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var h;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(h=e.ActivationKind||(e.ActivationKind={}));function w(o){o.enableProposedApi||D(o)}e.checkProposedApiEnabled=w;function D(o){throw new Error(`[${o.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.throwProposedApiError=D;function T(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,P.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation}}e.toExtension=T;function b(o,v){return{identifier:new S.ExtensionIdentifier(o.identifier.id),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!v,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid}}e.toExtensionDescription=b;class l{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(v){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(v){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(v,n){return Promise.resolve()}_onWillActivateExtension(v){}_onDidActivateExtension(v,n,f,r,t){}_onDidActivateExtensionError(v,n){}_onExtensionRuntimeError(v,n){}_onExtensionHostExit(v){}}e.NullExtensionService=l}),define(fe[228],me([0,1,27,35,13]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class P{constructor(h,w,D,T){this.startup=h,this.codeLoadingTime=w,this.activateCallTime=D,this.activateResolvedTime=T}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class _{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,w){return h===-1||w===-1?-1:w-h}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=_;class y{constructor(h,w,D,T,b,l){this.activationFailed=h,this.activationFailedError=w,this.activationTimes=D,this.module=T,this.exports=b,this.subscriptions=l}}e.ActivatedExtension=y;class k extends y{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class i extends y{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class I extends y{constructor(h){super(!0,h,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let a=class{constructor(h,w,D,T,b){this._logService=b,this._registry=h,this._resolvedExtensionsSet=new Set,w.forEach(l=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,D.forEach(l=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(l),l)),this._host=T,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(h){const w=g.ExtensionIdentifier.toKey(h);return this._activatedExtensions.has(w)}getActivatedExtension(h){const w=g.ExtensionIdentifier.toKey(h),D=this._activatedExtensions.get(w);if(!D)throw new Error("Extension `"+h.value+"` is not known or not activated");return D}activateByEvent(h,w){if(this._alreadyActivatedEvents[h])return S;const D=this._registry.getExtensionDescriptionsForActivationEvent(h);return this._activateExtensions(D.map(T=>({id:T.identifier,reason:{startup:w,extensionId:T.identifier,activationEvent:h}}))).then(()=>{this._alreadyActivatedEvents[h]=!0})}activateById(h,w){const D=this._registry.getExtensionDescription(h);if(!D)throw new Error("Extension `"+h+"` is not known");return this._activateExtensions([{id:D.identifier,reason:w}])}_handleActivateRequest(h,w,D){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(h.id))){w[g.ExtensionIdentifier.toKey(h.id)]=h;return}const T=this._registry.getExtensionDescription(h.id);if(!T){const o=new Error(`Cannot activate unknown extension '${h.id.value}'`);this._host.onExtensionActivationError(h.id,o,new F.MissingExtensionDependency(h.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(h.id),new I(o));return}const b=typeof T.extensionDependencies=="undefined"?[]:T.extensionDependencies;let l=!0;for(let o=0,v=b.length;o<v;o++){const n=b[o];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(n)))continue;const f=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(n));if(f&&!f.activationFailed)continue;if(f&&f.activationFailed){const s=T.displayName||T.identifier.value,c=this._registry.getExtensionDescription(n),m=c&&c.displayName||n,u=new Error(`Cannot activate the '${s}' extension because its dependency '${m}' failed to activate`);u.detail=f.activationFailedError,this._host.onExtensionActivationError(T.identifier,u,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(T.identifier),new I(u));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(n))){l=!1,w[g.ExtensionIdentifier.toKey(n)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(n)),reason:h.reason};continue}const r=this._registry.getExtensionDescription(n);if(r){if(!r.main&&!r.browser)continue;l=!1,w[g.ExtensionIdentifier.toKey(n)]={id:r.identifier,reason:h.reason};continue}const t=T.displayName||T.identifier.value,d=new Error(`Cannot activate the '${t}' extension because it depends on unknown extension '${n}'`);this._host.onExtensionActivationError(T.identifier,d,new F.MissingExtensionDependency(n)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(T.identifier),new I(d));return}l?w[g.ExtensionIdentifier.toKey(T.identifier)]=h:D.push(h)}_activateExtensions(h){if(h.length===0||(h=h.filter(b=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(b.id))),h.length===0))return Promise.resolve(void 0);const w=Object.create(null),D=[];for(let b=0,l=h.length;b<l;b++)this._handleActivateRequest(h[b],w,D);for(let b=0,l=D.length;b<l;b++){const o=g.ExtensionIdentifier.toKey(D[b].id);w[o]&&delete w[o]}const T=Object.keys(w).map(b=>w[b]);return D.length===0?Promise.all(T.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(T).then(b=>this._activateExtensions(D))}_activateExtension(h,w){const D=g.ExtensionIdentifier.toKey(h);if(this._activatedExtensions.has(D))return Promise.resolve(void 0);const T=this._activatingExtensions.get(D);if(T)return T;const b=this._host.actualActivateExtension(h,w).then(void 0,l=>{const o=new Error;return l&&l.name&&(o.name=l.name),l&&l.message?o.message=`Activating extension '${h.value}' failed: ${l.message}.`:o.message=`Activating extension '${h.value}' failed: ${l}.`,l&&l.stack&&(o.stack=l.stack),this._host.onExtensionActivationError(h,o,null),this._logService.error(`Activating extension ${h.value} failed due to an error:`),this._logService.error(l),new I(l)}).then(l=>{this._activatedExtensions.set(D,l),this._activatingExtensions.delete(D)});return this._activatingExtensions.set(D,b),b}};a=Ve([We(4,C.ILogService)],a),e.ExtensionsActivator=a}),define(fe[229],me([0,1,13,35,28,10,117]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let _=class extends g.LogService{constructor(k){if(k.logFile.scheme!==S.Schemas.file)throw new Error("Only file-logging supported");super(new P.SpdLogLogger(F.ExtensionHostLogFileName,k.logFile.fsPath,!0,k.logLevel))}$setLevel(k){this.setLevel(k)}};_=Ve([We(0,C.IExtHostInitDataService)],_),e.ExtHostLogService=_}),define(fe[230],me([0,1,17]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((S,P)=>{this._actualOk=S,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(S){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=S,this._actual&&this._actualOk(S))}resolveErr(S){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=S,this._actual?this._actualErr(S):(0,g.onUnexpectedError)(S))}then(S,P){return this._ensureActual().then(S,P)}catch(S){return this._ensureActual().then(void 0,S)}finally(S){return this._ensureActual().finally(S)}}e.LazyPromise=F}),define(fe[55],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(k,i){this._proxyIdentifierBrand=void 0,this.isMain=k,this.sid=i,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const F=[];function C(y){const k=new g(!0,y);return F[k.nid]=k,k}e.createMainContextProxyIdentifier=C;function S(y){const k=new g(!1,y);return F[k.nid]=k,k}e.createExtHostContextProxyIdentifier=S;function P(y){return F[y].sid}e.getStringIdentifierForProxy=P;class _{constructor(k){this.value=k}}e.SerializableObjectWithBuffers=_}),define(fe[5],me([0,1,62,2,55]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var S;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(S=e.UIKind||(e.UIKind={}));var P;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var _;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var a;(function(l){l.name="$ident";function o(n,f){return Object.defineProperty(n,l.name,{value:f,enumerable:!0}),n}l.mixin=o;function v(n){return n[l.name]}l.of=v})(a=e.ObjectIdentifier||(e.ObjectIdentifier={}));class p{static mixin(o){return o._id=p._n++,o}}e.IdObject=p,p._n=0;var h;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var D;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(D=e.WorkspaceEditType||(e.WorkspaceEditType={}));function T(l){if(l&&l.edits)for(const o of l.edits)typeof o.resource=="object"?o.resource=F.URI.revive(o.resource):(o.newUri=F.URI.revive(o.newUri),o.oldUri=F.URI.revive(o.oldUri)),o.metadata&&o.metadata.iconPath&&(o.metadata=(0,g.revive)(o.metadata));return l}e.reviveWorkspaceEditDto=T;var b;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,C.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,C.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,C.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,C.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,C.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,C.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,C.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,C.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,C.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,C.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,C.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,C.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,C.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,C.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,C.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,C.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,C.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(fe[90],me([0,1,5,3,4]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class S{constructor(_){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=_.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(_){this._onDidChangePassword.fire(_)}get(_,y){return this._proxy.$getPassword(_,y)}store(_,y,k){return this._proxy.$setPassword(_,y,k)}delete(_,y){return this._proxy.$deletePassword(_,y)}}e.ExtHostSecretState=S,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")}),define(fe[68],me([0,1,4,13,5,14]),function(Y,e,g,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let P=class{constructor(y,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(C.MainContext.MainThreadTelemetry)}report(y,k,i){const I=this.getUsageKey(y,k);this._reportedUsages.has(I)||(this._reportedUsages.add(I),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:y}))}getUsageKey(y,k){return`${y}-${k.identifier.value}`}};P=Ve([We(0,S.IExtHostRpcService),We(1,F.ILogService)],P),e.ExtHostApiDeprecationService=P,e.NullApiDeprecationService=Object.freeze(new class{report(_,y,k){}})}),define(fe[231],me([0,1,3,5,7,27]),function(Y,e,g,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class P{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,k,i,I={}){const a=S.ExtensionIdentifier.toKey(y.identifier),p=this._inFlightRequests.get(a)||[],h=[...i].sort().join(" ");let w=p.find(D=>D.scopes===h);if(w)return w.result;{const D=this._getSession(y,a,k,i,I);w={scopes:h,result:D},p.push(w),this._inFlightRequests.set(a,p);try{await D}finally{const T=p.findIndex(b=>b.scopes===h);T>-1&&(p.splice(T),this._inFlightRequests.set(a,p))}return D}}async _getSession(y,k,i,I,a={}){await this._proxy.$ensureProvider(i);const p=y.displayName||y.name;return this._proxy.$getSession(i,I,k,p,a)}async removeSession(y,k){const i=this._authenticationProviders.get(y);return i?i.provider.removeSession(k):this._proxy.$removeSession(y,k)}registerAuthenticationProvider(y,k,i,I){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:k,provider:i,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(p=>p.id===y)||this._providers.push({id:y,label:k});const a=i.onDidChangeSessions(p=>{this._proxy.$sendDidChangeSessions(y,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,k,I?.supportsMultipleAccounts??!1),new C.Disposable(()=>{a.dispose(),this._authenticationProviders.delete(y);const p=this._providers.findIndex(h=>h.id===y);p>-1&&this._providers.splice(p),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,k){const i=this._authenticationProviders.get(y);if(i)return Promise.resolve(i.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,k){const i=this._authenticationProviders.get(y);if(i)return Promise.resolve(i.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,k){const i=this._authenticationProviders.get(y);if(i)return Promise.resolve(i.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,k){return this._onDidChangeSessions.fire({provider:{id:y,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=P}),define(fe[232],me([0,1,5,14,16]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let S=class{constructor(_,y){this._extHostDocumentsAndEditors=y,this._proxy=_.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(_){const y=C.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};S=Ve([We(0,F.IExtHostRpcService)],S),e.ExtHostBulkEdits=S}),define(fe[233],me([0,1,5]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(S){const P=S.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(_){return P.$writeText(_)}})}}e.ExtHostClipboard=F}),define(fe[40],me([0,1,12,7,16,25,5,18,13,62,42,51,2,6,4,14,66,22,55,52]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(d,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=d.getProxy(P.MainContext.MainThreadCommands),this._logService=s,this.converter=new v(this,c=>{const m=this._apiCommands.get(c);return m?.result===f.Void?m:void 0},s),this._argumentProcessors=[{processArgument(c){return(0,k.revive)(c)}},{processArgument(c){return(0,S.cloneAndChange)(c,function(m){if(i.Range.isIRange(m))return C.Range.to(m);if(I.Position.isIPosition(m))return C.Position.to(m);if(i.Range.isIRange(m.range)&&a.URI.isUri(m.uri))return C.location.to(m);if(m instanceof T.VSBuffer)return m.buffer.buffer;if(!Array.isArray(m))return m})}}]}registerArgumentProcessor(d){this._argumentProcessors.push(d)}registerApiCommand(d){const s=this.registerCommand(!1,d.id,async(...c)=>{const m=d.args.map((E,R)=>{if(!E.validate(c[R]))throw new Error(`Invalid argument '${E.name}' when running '${d.id}', received: ${c[R]}`);return E.convert(c[R])}),u=await this.executeCommand(d.internalId,...m);return d.result.convert(u,c,this.converter)},void 0,{description:d.description,args:d.args,returns:d.result.description});return this._apiCommands.set(d.id,d),new F.Disposable(()=>{s.dispose(),this._apiCommands.delete(d.id)})}registerCommand(d,s,c,m,u,E){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:c,thisArg:m,description:u,extension:E}),d&&this._proxy.$registerCommand(s),new F.Disposable(()=>{this._commands.delete(s)&&d&&this._proxy.$unregisterCommand(s)})}executeCommand(d,...s){return this._logService.trace("ExtHostCommands#executeCommand",d),this._doExecuteCommand(d,s,!0)}async _doExecuteCommand(d,s,c){if(this._commands.has(d))return this._executeContributedCommand(d,s,!1);{let m=!1;const u=(0,S.cloneAndChange)(s,function(E){if(E instanceof F.Position)return C.Position.from(E);if(E instanceof F.Range)return C.Range.from(E);if(E instanceof F.Location)return C.location.from(E);if(F.NotebookRange.isNotebookRange(E))return C.NotebookRange.from(E);if(E instanceof ArrayBuffer)return m=!0,T.VSBuffer.wrap(new Uint8Array(E));if(E instanceof Uint8Array)return m=!0,T.VSBuffer.wrap(E);if(!Array.isArray(E))return E});try{const E=await this._proxy.$executeCommand(d,m?new b.SerializableObjectWithBuffers(u):u,c);return(0,k.revive)(E)}catch(E){if(E instanceof Error&&E.message==="$executeCommand:retry")return this._doExecuteCommand(d,s,!1);throw E}}}async _executeContributedCommand(d,s,c){const m=this._commands.get(d);if(!m)throw new Error("Unknown command");let{callback:u,thisArg:E,description:R}=m;if(R)for(let L=0;L<R.args.length;L++)try{(0,g.validateConstraint)(s[L],R.args[L].constraint)}catch(M){throw new Error(`Running the contributed command: '${d}' failed. Illegal argument '${R.args[L].name}' - ${R.args[L].description}`)}try{return await u.apply(E,s)}catch(L){if(d===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...s);M&&(d=M.command)}throw this._logService.error(L,d,m.extension?.identifier),c?new class extends Error{constructor(){super((0,l.toErrorMessage)(L));this.id=d,this.source=m.extension?.displayName??m.extension?.name}}:L}}$executeContributedCommand(d,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",d),this._commands.has(d)?(s=s.map(c=>this._argumentProcessors.reduce((m,u)=>u.processArgument(m),c)),this._executeContributedCommand(d,s,!0)):Promise.reject(new Error(`Contributed command '${d}' does not exist.`))}getCommands(d=!1){return this._logService.trace("ExtHostCommands#getCommands",d),this._proxy.$getCommands().then(s=>(d&&(s=s.filter(c=>c[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const d=Object.create(null);for(let[s,c]of this._commands){let{description:m}=c;m&&(d[s]=m)}return Promise.resolve(d)}};o=Ve([We(0,w.IExtHostRpcService),We(1,y.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class v{constructor(d,s,c){this._commands=d,this._lookupApiCommand=s,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(d,s){if(!d)return;const c={$ident:void 0,id:d.command,title:d.title,tooltip:d.tooltip};if(!d.command)return c;const m=this._lookupApiCommand(d.command);if(m)c.id=m.internalId,c.arguments=m.args.map((u,E)=>u.convert(d.arguments&&d.arguments[E]));else if((0,_.isNonEmptyArray)(d.arguments)){const u=++this._cachIdPool;this._cache.set(u,d),s.add((0,p.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),c.$ident=u,c.id=this.delegatingCommandId,c.arguments=[u],this._logService.trace("CommandsConverter#CREATE",d.command,u)}return c}fromInternal(d){const s=P.ObjectIdentifier.of(d);return typeof s=="number"?this._cache.get(s):{command:d.id,title:d.title,arguments:d.arguments}}getActualCommand(...d){return this._cache.get(d[0])}_executeConvertedCommand(...d){const s=this.getActualCommand(...d);return this._logService.trace("CommandsConverter#EXECUTE",d[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class n{constructor(d,s,c,m){this.name=d,this.description=s,this.validate=c,this.convert=m}optional(){return new n(this.name,`(optional) ${this.description}`,d=>d==null||this.validate(d),d=>d===void 0?void 0:d===null?null:this.convert(d))}with(d,s){return new n(d??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",t=>a.URI.isUri(t),t=>t),n.Position=new n("position","A position in a text document",t=>F.Position.isPosition(t),C.Position.from),n.Range=new n("range","A range in a text document",t=>F.Range.isRange(t),C.Range.from),n.Selection=new n("selection","A selection in a text document",t=>F.Selection.isSelection(t),C.Selection.from),n.Number=new n("number","",t=>typeof t=="number",t=>t),n.String=new n("string","",t=>typeof t=="string",t=>t),n.CallHierarchyItem=new n("item","A call hierarchy item",t=>t instanceof F.CallHierarchyItem,C.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",t=>t instanceof F.TypeHierarchyItem,C.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",t=>t instanceof D.TestItemImpl,C.TestItem.from);class f{constructor(d,s){this.description=d,this.convert=s}}e.ApiCommandResult=f,f.Void=new f("no result",t=>t);class r{constructor(d,s,c,m,u){this.id=d,this.internalId=s,this.description=c,this.args=m,this.result=u}}e.ApiCommand=r}),define(fe[234],me([0,1,16,7,84,40,18,112]),function(Y,e,g,F,C,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(g.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,p)=>{if((0,P.isFalsyOrEmpty)(a))return;class h extends F.SymbolInformation{static to(D){const T=new h(D.name,g.SymbolKind.to(D.kind),D.containerName||"",new F.Location(p[0],g.Range.to(D.range)));return T.detail=D.detail,T.range=T.location.range,T.selectionRange=g.Range.to(D.selectionRange),T.children=D.children?D.children.map(h.to):[],T}}return a.map(h.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(g.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(g.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(p=>F.Position.isPosition(p)),a=>a.map(g.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(p=>{let h;for(const w of p.reverse())h=new F.SelectionRange(g.Range.to(w),h);return h}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const p=[];if(Array.isArray(a))for(let h of a)p.push(...h[1].map(g.WorkspaceSymbol.to));return p})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(g.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(g.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(g.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:g.Range.to(a.range),placeholder:a.text}})),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return g.WorkspaceEdit.to(a)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(g.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new F.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const p=(0,_.decodeSemanticTokensDto)(a);if(p.type==="full")return new F.SemanticTokens(p.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new F.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const p=(0,_.decodeSemanticTokensDto)(a);if(p.type==="full")return new F.SemanticTokens(p.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,p,h)=>{if(!a)return new F.CompletionList([]);const w=a.suggestions.map(D=>g.CompletionItem.to(D,h));return new F.CompletionList(w,a.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return g.SignatureHelp.to(a)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,p,h)=>i(w=>new F.CodeLens(g.Range.to(w.range),w.command&&h.fromInternal(w.command)))(a))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>F.Range.isRange(a),a=>F.Selection.isSelection(a)?g.Selection.from(a):g.Range.from(a)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,p,h)=>i(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(w.command)}else{const D=new F.CodeAction(w.title,w.kind?new F.CodeActionKind(w.kind):void 0);return w.edit&&(D.edit=g.WorkspaceEdit.to(w.edit)),w.command&&(D.command=h.fromInternal(w.command)),D.isPreferred=w.isPreferred,D}})(a))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(p=>new F.ColorInformation(g.Range.to(p.range),g.Color.to(p.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",a=>a instanceof F.Color,g.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:g.Range.from(a.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(g.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",a=>a.map(g.InlayHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(p=>g.NotebookExclusiveDocumentPattern.to(p))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(g.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[g.ViewColumn.from(a.viewColumn),g.TextEditorOpenOptions.from(a)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[g.ViewColumn.from(a.viewColumn),g.TextEditorOpenOptions.from(a)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[g.ViewColumn.from(a.viewColumn),g.TextEditorOpenOptions.from(a)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(g.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(g.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(g.TypeHierarchyItem.to))),new S.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[S.ApiCommandArgument.TestItem],S.ApiCommandResult.Void)];class k{static register(p){y.forEach(p.registerApiCommand,p)}}e.ExtHostApiCommands=k;function i(a){return p=>{if(Array.isArray(p))return p.map(a)}}function I(a){if(!Array.isArray(a))return;const p=[];for(const h of a)C.isLocationLink(h)?p.push(g.DefinitionLink.to(h)):p.push(g.location.to(h));return p}}),define(fe[235],me([0,1,15,60,3,6,2,84,27,16,7,5]),function(Y,e,g,F,C,S,P,_,y,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function a(p,h,w){const D=p.getProxy(I.MainContext.MainThreadComments);class T{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const d=this._commentControllers.get(t.handle);return d||t}else if(t&&t.$mid===7){const d=this._commentControllers.get(t.commentControlHandle);if(!d)return t;const s=d.getCommentThread(t.commentThreadHandle);return s||t}else if(t&&t.$mid===8){const d=this._commentControllers.get(t.thread.commentControlHandle);if(!d)return t;const s=d.getCommentThread(t.thread.commentThreadHandle);return s?{thread:s,text:t.text}:t}else if(t&&t.$mid===9){const d=this._commentControllers.get(t.thread.commentControlHandle);if(!d)return t;const s=d.getCommentThread(t.thread.commentThreadHandle);if(!s)return t;let c=t.commentUniqueId,m=s.getCommentByUniqueId(c);return m||t}else if(t&&t.$mid===10){const d=this._commentControllers.get(t.thread.commentControlHandle);if(!d)return t;const s=d.getCommentThread(t.thread.commentThreadHandle);if(!s)return t;let c=t.text,m=t.commentUniqueId,u=s.getCommentByUniqueId(m);return u?(u.body=c,u):t}return t}})}createCommentController(t,d,s){const c=T.handlePool++,m=new l(t,c,d,s);this._commentControllers.set(m.handle,m);const u=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(t.identifier))||[];return u.push(m),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(t.identifier),u),m.value}$createCommentThreadTemplate(t,d,s){const c=this._commentControllers.get(t);!c||c.$createCommentThreadTemplate(d,s)}async $updateCommentThreadTemplate(t,d,s){const c=this._commentControllers.get(t);!c||c.$updateCommentThreadTemplate(d,s)}$deleteCommentThread(t,d){const s=this._commentControllers.get(t);s&&s.$deleteCommentThread(d)}$provideCommentingRanges(t,d,s){const c=this._commentControllers.get(t);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const m=w.getDocument(P.URI.revive(d));return(0,g.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(m,s)).then(u=>u?u.map(E=>k.Range.from(E)):void 0)}$toggleReaction(t,d,s,c,m){const u=this._commentControllers.get(t);return!u||!u.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const E=u.getCommentThread(d);if(E){const R=E.getCommentByUniqueId(c.uniqueIdInThread);if(u!==void 0&&R&&u.reactionHandler)return u.reactionHandler(R,n(m))}return Promise.resolve(void 0)})}dispose(){}}T.handlePool=0;class b{constructor(t,d,s,c,m,u,E){this._commentControllerHandle=d,this._id=s,this._uri=c,this._range=m,this._comments=u,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputDisposables.value=new S.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),D.$createCommentThread(d,this.handle,this._id,this._uri,k.Range.from(this._range),E),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=u,this._localDisposables.push({dispose:()=>{D.$deleteCommentThread(d,this.handle)}});const R=this;this.value={get uri(){return R.uri},get range(){return R.range},set range(L){R.range=L},get comments(){return R.comments},set comments(L){R.comments=L},get collapsibleState(){return R.collapsibleState},set collapsibleState(L){R.collapsibleState=L},get canReply(){return R.canReply},set canReply(L){R.canReply=L},get contextValue(){return R.contextValue},set contextValue(L){R.contextValue=L},get label(){return R.label},set label(L){R.label=L},dispose:()=>{R.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new S.DisposableStore);const t=s=>Object.prototype.hasOwnProperty.call(this.modifications,s),d={};t("range")&&(d.range=k.Range.from(this._range)),t("label")&&(d.label=this.label),t("contextValue")&&(d.contextValue=this.contextValue),t("comments")&&(d.comments=this._comments.map(s=>o(this,s,this._commentsMap))),t("collapsibleState")&&(d.collapseState=f(this._collapseState)),t("canReply")&&(d.canReply=this.canReply),this.modifications={},D.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,d)}getCommentByUniqueId(t){for(let d of this._commentsMap){let s=d[0],c=d[1];if(t===c)return s}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}b._handlePool=0,Ve([(0,F.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(t,d,s,c){this._extension=t,this._handle=d,this._id=s,this._label=c,this._threads=new Map,D.$registerCommentController(this.handle,s,c);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(u){m.options=u},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(u){m.commentingRangeProvider=u},get reactionHandler(){return m.reactionHandler},set reactionHandler(u){m.reactionHandler=u},createCommentThread(u,E,R){return m.createCommentThread(u,E,R).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{D.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,D.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,D.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,D.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,d,s,c){if(typeof t=="string"){const m=new b(this.id,this.handle,t,d,s,c,this._extension.identifier);return this._threads.set(m.handle,m),m}else{const m=new b(this.id,this.handle,void 0,t,d,s,this._extension.identifier);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(t,d){const s=new b(this.id,this.handle,void 0,P.URI.revive(t),k.Range.to(d),[],this._extension.identifier);return s.collapsibleState=_.CommentThreadCollapsibleState.Expanded,this._threads.set(s.handle,s),s}$updateCommentThreadTemplate(t,d){let s=this._threads.get(t);s&&(s.range=k.Range.to(d))}$deleteCommentThread(t){let d=this._threads.get(t);d&&d.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function o(r,t,d){let s=d.get(t);s||(s=++r.commentHandle,d.set(t,s));const c=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:s,body:k.MarkdownString.from(t.body),userName:t.author.name,userIconPath:c,label:t.label,commentReactions:t.reactions?t.reactions.map(m=>v(m)):void 0}}function v(r){return{label:r.label,iconPath:r.iconPath?k.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function n(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?P.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function f(r){if(r!==void 0)switch(r){case i.CommentThreadCollapsibleState.Expanded:return _.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return _.CommentThreadCollapsibleState.Collapsed}return _.CommentThreadCollapsibleState.Collapsed}return new T}e.createExtHostComments=a}),define(fe[133],me([0,1,2,5,7,4,14,13,18,9,8]),function(Y,e,g,F,C,S,P,_,y,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wn{constructor(p,h){this._logService=h,this._provider=new Map,this._proxy=p.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,h){const w=wn._handlePool++;this._provider.set(w,{provider:p,extensionId:h}),this._proxy.$registerDecorationProvider(w,h.value);const D=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(T=>{if(!T){this._proxy.$onDidChange(w,null);return}let b=(0,y.asArray)(T);if(b.length<=wn._maxEventSize){this._proxy.$onDidChange(w,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",h.value,b.length);const l=b.map(n=>({uri:n,rank:(0,k.count)(n.path,"/")})),o=(0,y.groupBy)(l,(n,f)=>n.rank-f.rank||(0,k.compare)(n.uri.path,f.uri.path));let v=[];e:for(let n of o){let f;for(let r of n){let t=(0,i.dirname)(r.uri.path);if(f!==t&&(f=t,v.push(r.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(w,v)});return new C.Disposable(()=>{D?.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(p,h,w){if(!this._provider.has(p))return Object.create(null);const D=Object.create(null),{provider:T,extensionId:b}=this._provider.get(p);return await Promise.all(h.map(async l=>{try{const{uri:o,id:v}=l,n=await Promise.resolve(T.provideFileDecoration(g.URI.revive(o),w));if(!n)return;try{C.FileDecoration.validate(n),D[v]=[n.propagate,n.tooltip,n.badge,n.color]}catch(f){this._logService.warn(`INVALID decoration from extension '${b.value}': ${f}`)}}catch(o){this._logService.error(o)}})),D}};I._handlePool=0,I._maxEventSize=250,I=Ve([We(0,P.IExtHostRpcService),We(1,_.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,S.createDecorator)("IExtHostDecorations")});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,g):C?C.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[236],me([0,1,165,118,2,5,7,16,3,13,24,53,142]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a){"use strict";var p,h,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class D{constructor(l,o,v,n,f,r){this._name=l,this._owner=o,this._maxDiagnosticsPerFile=v,p.set(this,void 0),h.set(this,void 0),w.set(this,void 0),this._isDisposed=!1,st(this,w,new a.SkipList((t,d)=>n.compare(t,d)),"f"),st(this,p,f,"f"),st(this,h,r,"f")}dispose(){this._isDisposed||(Ne(this,h,"f").fire([...Ne(this,w,"f").keys()]),Ne(this,p,"f")&&Ne(this,p,"f").$clear(this._owner),Ne(this,w,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(l,o){if(!l){this.clear();return}this._checkDisposed();let v=[];if(C.URI.isUri(l)){if(!o){this.delete(l);return}Ne(this,w,"f").set(l,o.slice()),v=[l]}else if(Array.isArray(l)){v=[];let f;l=[...l].sort(D._compareIndexedTuplesByUri);for(const r of l){const[t,d]=r;if((!f||t.toString()!==f.toString())&&(f&&Ne(this,w,"f").get(f).length===0&&Ne(this,w,"f").delete(f),f=t,v.push(t),Ne(this,w,"f").set(t,[])),d){const s=Ne(this,w,"f").get(t);s&&s.push(...d)}else{const s=Ne(this,w,"f").get(t);s&&(s.length=0)}}}if(Ne(this,h,"f").fire(v),!Ne(this,p,"f"))return;const n=[];for(let f of v){let r=[];const t=Ne(this,w,"f").get(f);if(t)if(t.length>this._maxDiagnosticsPerFile){r=[];const d=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(let c of t)if(c.severity===d[s]&&r.push(_.Diagnostic.from(c))===this._maxDiagnosticsPerFile)break e;r.push({severity:F.MarkerSeverity.Info,message:(0,g.localize)(0,null,t.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=t.map(d=>_.Diagnostic.from(d));n.push([f,r])}Ne(this,p,"f").$changeMany(this._owner,n)}delete(l){this._checkDisposed(),Ne(this,h,"f").fire([l]),Ne(this,w,"f").delete(l),Ne(this,p,"f")&&Ne(this,p,"f").$changeMany(this._owner,[[l,void 0]])}clear(){this._checkDisposed(),Ne(this,h,"f").fire([...Ne(this,w,"f").keys()]),Ne(this,w,"f").clear(),Ne(this,p,"f")&&Ne(this,p,"f").$clear(this._owner)}forEach(l,o){this._checkDisposed();for(let v of Ne(this,w,"f").keys())l.apply(o,[v,this.get(v),this])}get(l){this._checkDisposed();const o=Ne(this,w,"f").get(l);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(l){return this._checkDisposed(),Array.isArray(Ne(this,w,"f").get(l))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(l,o){return l[0].toString()<o[0].toString()?-1:l[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=D,p=new WeakMap,h=new WeakMap,w=new WeakMap;let T=class tn{constructor(l,o,v){this._logService=o,this._fileSystemInfoService=v,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,tn._mapper),this._proxy=l.getProxy(S.MainContext.MainThreadDiagnostics)}static _mapper(l){const o=new i.ResourceMap;for(const v of l)o.set(v,v);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(l,o){const{_collections:v,_proxy:n,_onDidChangeDiagnostics:f,_logService:r,_fileSystemInfoService:t}=this,d=new class{$changeMany(m,u){n.$changeMany(m,u),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,m,u.length===0?"CLEARING":u)}$clear(m){n.$clear(m),r.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,m)}dispose(){n.dispose()}};let s;if(!o)o="_generated_diagnostic_collection_name_#"+tn._idPool++,s=o;else if(!v.has(o))s=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do s=o+tn._idPool++;while(v.has(s))}return new class extends D{constructor(){super(o,s,tn._maxDiagnosticsPerFile,t.extUri,d,f);v.set(s,this)}dispose(){super.dispose(),v.delete(s)}}}getDiagnostics(l){if(l)return this._getDiagnostics(l);{const o=new Map,v=[];for(const n of this._collections.values())n.forEach((f,r)=>{let t=o.get(f.toString());typeof t=="undefined"&&(t=v.length,o.set(f.toString(),t),v.push([f,[]])),v[t][1]=v[t][1].concat(...r)});return v}}_getDiagnostics(l){let o=[];for(let v of this._collections.values())v.has(l)&&(o=o.concat(v.get(l)));return o}$acceptMarkersChange(l){if(!this._mirrorCollection){const o="_generated_mirror",v=new D(o,o,tn._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,v),this._mirrorCollection=v}for(const[o,v]of l)this._mirrorCollection.set(C.URI.revive(o),v.map(_.Diagnostic.to))}};T._idPool=0,T._maxDiagnosticsPerFile=1e3,T=Ve([We(1,k.ILogService),We(2,I.IExtHostFileSystemInfo)],T),e.ExtHostDiagnostics=T}),define(fe[237],me([0,1,2,5]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(P){this._proxy=P.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(P){return this._proxy.$showOpenDialog(P).then(_=>_?_.map(y=>g.URI.revive(y)):void 0)}showSaveDialog(P){return this._proxy.$showSaveDialog(P).then(_=>_?g.URI.revive(_):void 0)}}e.ExtHostDialogs=C}),define(fe[238],me([0,1,17,2,7,5,10,21,9]),function(Y,e,g,F,C,S,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(I,a,p){this._documentsAndEditors=a,this._logService=p,this._documentContentProviders=new Map,this._proxy=I.getProxy(S.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,a){if(Object.keys(P.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const p=k._handlePool++;this._documentContentProviders.set(p,a),this._proxy.$registerTextContentProvider(p,I);let h;return typeof a.onDidChange=="function"&&(h=a.onDidChange(w=>{if(w.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(p,w).then(D=>{if(!D&&typeof D!="string")return;const T=this._documentsAndEditors.getDocument(w);if(!T)return;const b=(0,y.splitLines)(D);if(!T.equalLines(b))return this._proxy.$onVirtualDocumentChange(w,D)},g.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(I,a){const p=this._documentContentProviders.get(I);return p?Promise.resolve(p.provideTextDocumentContent(F.URI.revive(a),_.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(fe[239],me([0,1,3,6,2,5,125,16,12,25,7]),function(Y,e,g,F,C,S,P,_,y,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(p,h){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(S.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(w=>{for(const D of w)this._onDidRemoveDocument.fire(D.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(w=>{for(const D of w)this._onDidAddDocument.fire(D.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const h=this._documentsAndEditors.getDocument(p);if(h)return h}getDocument(p){const h=this.getDocumentData(p);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return h.document}ensureDocumentData(p){const h=this._documentsAndEditors.getDocument(p);if(h)return Promise.resolve(h);let w=this._documentLoader.get(p.toString());return w||(w=this._proxy.$tryOpenDocument(p).then(D=>{this._documentLoader.delete(p.toString());const T=C.URI.revive(D);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(T))},D=>(this._documentLoader.delete(p.toString()),Promise.reject(D))),this._documentLoader.set(p.toString(),w)),w}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(h=>C.URI.revive(h))}$acceptModelModeChanged(p,h){const w=C.URI.revive(p),D=this._documentsAndEditors.getDocument(w);if(!D)throw new Error("unknown document");this._onDidRemoveDocument.fire(D.document),D._acceptLanguageId(h),this._onDidAddDocument.fire(D.document)}$acceptModelSaved(p){const h=C.URI.revive(p),w=this._documentsAndEditors.getDocument(h);if(!w)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(w.document)}$acceptDirtyStateChanged(p,h){const w=C.URI.revive(p),D=this._documentsAndEditors.getDocument(w);if(!D)throw new Error("unknown document");D._acceptIsDirty(h),this._onDidChangeDocument.fire({document:D.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,h,w){const D=C.URI.revive(p),T=this._documentsAndEditors.getDocument(D);if(!T)throw new Error("unknown document");T._acceptIsDirty(w),T.onEvents(h);let b;h.isUndoing?b=i.TextDocumentChangeReason.Undo:h.isRedoing&&(b=i.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:T.document,contentChanges:h.changes.map(l=>({range:_.Range.to(l.range),rangeOffset:l.rangeOffset,rangeLength:l.rangeLength,text:l.text})),reason:b}))}setWordDefinitionFor(p,h){(0,P.setWordDefinitionFor)(p,h)}}e.ExtHostDocuments=I}),define(fe[45],me([0,1,58,3,6,2,4,5,125,14,132,16,13,24,10,94,141]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class T{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(o,v){this._extHostRpc=o,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const v=[],n=[],f=[];if(o.removedDocuments)for(const r of o.removedDocuments){const t=S.URI.revive(r),d=this._documents.get(t);d?.unref()&&(this._documents.delete(t),v.push(d.value))}if(o.addedDocuments)for(const r of o.addedDocuments){const t=S.URI.revive(r.uri);let d=this._documents.get(t);if(d&&t.scheme!==h.Schemas.vscodeNotebookCell&&t.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);d||(d=new T(new y.ExtHostDocumentData(this._extHostRpc.getProxy(_.MainContext.MainThreadDocuments),t,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(t,d),n.push(d.value)),d.ref()}if(o.removedEditors)for(const r of o.removedEditors){const t=this._editors.get(r);this._editors.delete(r),t&&f.push(t)}if(o.addedEditors)for(const r of o.addedEditors){const t=S.URI.revive(r.documentUri);g.ok(this._documents.has(t),`document '${t}' does not exist`),g.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const d=this._documents.get(t).value,s=new i.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(_.MainContext.MainThreadTextEditors),this._logService,new D.Lazy(()=>d.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(c=>I.Range.to(c)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,s)}o.newActiveEditor!==void 0&&(g.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,C.dispose)(v),(0,C.dispose)(f),o.removedDocuments&&this._onDidRemoveDocuments.fire(v),o.addedDocuments&&this._onDidAddDocuments.fire(n),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){return this._documents.get(o)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return o?v:v?.value}allEditors(){return[...this._editors.values()]}};b=Ve([We(0,k.IExtHostRpcService),We(1,a.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,P.createDecorator)("IExtHostDocumentsAndEditors")}),define(fe[56],me([0,1,16,5,2,3,4,14,15]),function(Y,e,g,F,C,S,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,P.createDecorator)("IExtHostEditorTabs");let k=class{constructor(I){this._onDidChangeTabs=new S.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new S.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=I.getProxy(F.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(I){let a=-1;this._tabs=I.map((h,w)=>(h.isActive&&(a=w),Object.freeze({label:h.label,viewColumn:g.ViewColumn.to(h.viewColumn),index:w,resource:C.URI.revive(h.resource),additionalResourcesAndViewIds:h.additionalResourcesAndViewIds.map(({resource:D,viewId:T})=>({resource:C.URI.revive(D),viewId:T})),viewId:h.editorId,isActive:h.isActive,move:async(D,T)=>{this._proxy.$moveTab(h,D,g.ViewColumn.from(T)),await(0,y.raceTimeout)(S.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(h),await(0,y.raceTimeout)(S.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((h,w)=>h.viewColumn===w.viewColumn?h.index-w.index:h.viewColumn-w.viewColumn);const p=this._activeTab;this._activeTab=a===-1?void 0:this._tabs[a],this._activeTab!==p&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};k=Ve([We(0,_.IExtHostRpcService)],k),e.ExtHostEditorTabs=k}),define(fe[240],me([0,1,2,5,6,7,16,149,9,22]),function(Y,e,g,F,C,S,P,_,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const h=this._schemes.indexOf(p);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),h=[];let w,D,T=14,b=14;for(const l of p){let o=w?(0,y.commonPrefixLength)(w,l):0;for(o===0?D=1:D=b;o<l.length;o++)o+1===l.length?(T=b,b=9):b+=1,h.push([D,l.toUpperCase().charCodeAt(o),b]),h.push([D,l.toLowerCase().charCodeAt(o),b]),D=b;w=l,b=T}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new _.StateMachine(h)}}provideDocumentLinks(p){this._initStateMachine();const h=[],w=_.LinkComputer.computeLinks({getLineContent(D){return p.lineAt(D-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const D of w){const T=P.DocumentLink.to(D);T.target&&h.push(T)}return h}}class I{constructor(p,h){this._extHostLanguageFeatures=h,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(p,h,w,D={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const T=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(T,w);let b=2;D.isCaseSensitive&&(b+=1024),D.isReadonly&&(b+=2048),typeof w.copy=="function"&&(b+=8),typeof w.open=="function"&&typeof w.close=="function"&&typeof w.read=="function"&&typeof w.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(T,h,b).catch(o=>{console.error(`FAILED to register filesystem provider of ${p.value}-extension for the scheme ${h}`),console.error(o)});const l=w.onDidChangeFile(o=>{const v=[];for(const n of o){let{uri:f,type:r}=n;if(f.scheme!==h)continue;let t;switch(r){case S.FileChangeType.Changed:t=0;break;case S.FileChangeType.Created:t=1;break;case S.FileChangeType.Deleted:t=2;break;default:throw new Error("Unknown FileChangeType")}v.push({resource:f,type:t})}this._proxy.$onFileSystemChange(T,v)});return(0,C.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(T),this._proxy.$unregisterProvider(T)})}static _asIStat(p){const{type:h,ctime:w,mtime:D,size:T,permissions:b}=p;return{type:h,ctime:w,mtime:D,size:T,permissions:b}}$stat(p,h){return Promise.resolve(this._getFsProvider(p).stat(g.URI.revive(h))).then(w=>I._asIStat(w))}$readdir(p,h){return Promise.resolve(this._getFsProvider(p).readDirectory(g.URI.revive(h)))}$readFile(p,h){return Promise.resolve(this._getFsProvider(p).readFile(g.URI.revive(h))).then(w=>k.VSBuffer.wrap(w))}$writeFile(p,h,w,D){return Promise.resolve(this._getFsProvider(p).writeFile(g.URI.revive(h),w.buffer,D))}$delete(p,h,w){return Promise.resolve(this._getFsProvider(p).delete(g.URI.revive(h),w))}$rename(p,h,w,D){return Promise.resolve(this._getFsProvider(p).rename(g.URI.revive(h),g.URI.revive(w),D))}$copy(p,h,w,D){const T=this._getFsProvider(p);if(!T.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(T.copy(g.URI.revive(h),g.URI.revive(w),D))}$mkdir(p,h){return Promise.resolve(this._getFsProvider(p).createDirectory(g.URI.revive(h)))}$watch(p,h,w,D){const T=this._getFsProvider(p).watch(g.URI.revive(w),D);this._watches.set(h,T)}$unwatch(p,h){const w=this._watches.get(h);w&&(w.dispose(),this._watches.delete(h))}$open(p,h,w){const D=this._getFsProvider(p);if(!D.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(D.open(g.URI.revive(h),w))}$close(p,h){const w=this._getFsProvider(p);if(!w.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(w.close(h))}$read(p,h,w,D){const T=this._getFsProvider(p);if(!T.read)throw new Error('FileSystemProvider does not implement "read"');const b=k.VSBuffer.alloc(D);return Promise.resolve(T.read(h,w,b.buffer,0,D)).then(l=>b.slice(0,l))}$write(p,h,w,D){const T=this._getFsProvider(p);if(!T.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(T.write(h,w,D.buffer,0,D.byteLength))}_getFsProvider(p){const h=this._fsProvider.get(p);if(!h){const w=new Error;throw w.name="ENOPRO",w.message="no provider",w}return h}}e.ExtHostFileSystem=I}),define(fe[91],me([0,1,5,43,7,22,4,14,53]),function(Y,e,g,F,C,S,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Bt{constructor(I,a){const p=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(h){return p.$stat(h).catch(Bt._handleError)},readDirectory(h){return p.$readdir(h).catch(Bt._handleError)},createDirectory(h){return p.$mkdir(h).catch(Bt._handleError)},async readFile(h){return p.$readFile(h).then(w=>w.buffer).catch(Bt._handleError)},writeFile(h,w){return p.$writeFile(h,S.VSBuffer.wrap(w)).catch(Bt._handleError)},delete(h,w){return p.$delete(h,{recursive:!1,useTrash:!1,...w}).catch(Bt._handleError)},rename(h,w,D){return p.$rename(h,w,{overwrite:!1,...D}).catch(Bt._handleError)},copy(h,w,D){return p.$copy(h,w,{overwrite:!1,...D}).catch(Bt._handleError)},isWritableFileSystem(h){const w=a.getCapabilities(h);if(typeof w=="number")return!(w&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new C.FileSystemError(String(I));if(I.name==="ENOPRO")throw C.FileSystemError.Unavailable(I.message);switch(I.name){case F.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(I.message);case F.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(I.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(I.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(I.message);case F.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(I.message);case F.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(I.message);default:throw new C.FileSystemError(I.message,I.name)}}};k=Ve([We(0,_.IExtHostRpcService),We(1,y.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,P.createDecorator)("IExtHostConsumerFileSystem")}),define(fe[241],me([0,1,2,40]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class C{constructor(P,_,y,k){this._extHostNotebooks=_,this._textDocumentsAndEditors=y,this._commands=k;const i=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new F.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new F.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new F.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new F.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const a=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri),notebookEditor:a.apiEditor}}return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(i)}$willAddInteractiveDocument(P,_,y,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:_,lines:[""],modeId:y,uri:P,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,_){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.ExtHostInteractive=C}),define(fe[242],me([0,1,6,5]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(P){this._handlePool=0,this._proxy=P.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(P){const _=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(_,P),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(_)})}}e.ExtHostLabelService=C}),define(fe[243],me([0,1,2,25,16,7,5,9,42,18,12,146,6,112,77,87,46,17,3]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class l{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentSymbols(G,ee){const te=this._documents.getDocument(G),ce=await this._provider.provideDocumentSymbols(te,ee);if(!(0,k.isFalsyOrEmpty)(ce))return ce[0]instanceof S.DocumentSymbol?ce.map(C.DocumentSymbol.from):l._asDocumentSymbolTree(ce)}static _asDocumentSymbolTree(G){G=G.slice(0).sort((ce,Z)=>{let re=ce.location.range.start.compareTo(Z.location.range.start);return re===0&&(re=Z.location.range.end.compareTo(ce.location.range.end)),re});const ee=[],te=[];for(const ce of G){const Z={name:ce.name||"!!MISSING: name!!",kind:C.SymbolKind.from(ce.kind),tags:ce.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:ce.containerName,range:C.Range.from(ce.location.range),selectionRange:C.Range.from(ce.location.range),children:[]};for(;;){if(te.length===0){te.push(Z),ee.push(Z);break}const re=te[te.length-1];if(y.Range.containsRange(re.range,Z.range)&&!y.Range.equalsRange(re.range,Z.range)){re.children&&re.children.push(Z),te.push(Z);break}te.pop()}}return ee}}class o{constructor(G,ee,te){this._documents=G,this._commands=ee,this._provider=te,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(G,ee){const te=this._documents.getDocument(G),ce=await this._provider.provideCodeLenses(te,ee);if(!ce||ee.isCancellationRequested)return;const Z=this._cache.add(ce),re=new a.DisposableStore;this._disposables.set(Z,re);const pe={cacheId:Z,lenses:[]};for(let Me=0;Me<ce.length;Me++)pe.lenses.push({cacheId:[Z,Me],range:C.Range.from(ce[Me].range),command:this._commands.toInternal(ce[Me].command,re)});return pe}async resolveCodeLens(G,ee){const te=G.cacheId&&this._cache.get(...G.cacheId);if(!te)return;let ce;if(typeof this._provider.resolveCodeLens!="function"||te.isResolved?ce=te:ce=await this._provider.resolveCodeLens(te,ee),ce||(ce=te),ee.isCancellationRequested)return;const Z=G.cacheId&&this._disposables.get(G.cacheId[0]);if(!!Z)return G.command=this._commands.toInternal(ce.command??o._badCmd,Z),G}releaseCodeLenses(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(He){return Array.isArray(He)?He.map(C.DefinitionLink.from):He?[C.DefinitionLink.from(He)]:[]}class n{constructor(G,ee){this._documents=G,this._provider=ee}async provideDefinition(G,ee,te){const ce=this._documents.getDocument(G),Z=C.Position.to(ee),re=await this._provider.provideDefinition(ce,Z,te);return v(re)}}class f{constructor(G,ee){this._documents=G,this._provider=ee}async provideDeclaration(G,ee,te){const ce=this._documents.getDocument(G),Z=C.Position.to(ee),re=await this._provider.provideDeclaration(ce,Z,te);return v(re)}}class r{constructor(G,ee){this._documents=G,this._provider=ee}async provideImplementation(G,ee,te){const ce=this._documents.getDocument(G),Z=C.Position.to(ee),re=await this._provider.provideImplementation(ce,Z,te);return v(re)}}class t{constructor(G,ee){this._documents=G,this._provider=ee}async provideTypeDefinition(G,ee,te){const ce=this._documents.getDocument(G),Z=C.Position.to(ee),re=await this._provider.provideTypeDefinition(ce,Z,te);return v(re)}}class d{constructor(G,ee){this._documents=G,this._provider=ee}async provideHover(G,ee,te){const ce=this._documents.getDocument(G),Z=C.Position.to(ee),re=await this._provider.provideHover(ce,Z,te);if(!(!re||(0,k.isFalsyOrEmpty)(re.contents)))return re.range||(re.range=ce.getWordRangeAtPosition(Z)),re.range||(re.range=new S.Range(Z,Z)),C.Hover.from(re)}}class s{constructor(G,ee){this._documents=G,this._provider=ee}async provideEvaluatableExpression(G,ee,te){const ce=this._documents.getDocument(G),Z=C.Position.to(ee),re=await this._provider.provideEvaluatableExpression(ce,Z,te);if(re)return C.EvaluatableExpression.from(re)}}class c{constructor(G,ee){this._documents=G,this._provider=ee}async provideInlineValues(G,ee,te,ce){const Z=this._documents.getDocument(G),re=await this._provider.provideInlineValues(Z,C.Range.to(ee),C.InlineValueContext.to(te),ce);if(Array.isArray(re))return re.map(pe=>C.InlineValue.from(pe))}}class m{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentHighlights(G,ee,te){const ce=this._documents.getDocument(G),Z=C.Position.to(ee),re=await this._provider.provideDocumentHighlights(ce,Z,te);if(Array.isArray(re))return re.map(C.DocumentHighlight.from)}}class u{constructor(G,ee){this._documents=G,this._provider=ee}async provideLinkedEditingRanges(G,ee,te){const ce=this._documents.getDocument(G),Z=C.Position.to(ee),re=await this._provider.provideLinkedEditingRanges(ce,Z,te);if(re&&Array.isArray(re.ranges))return{ranges:(0,k.coalesce)(re.ranges.map(C.Range.from)),wordPattern:re.wordPattern}}}class E{constructor(G,ee){this._documents=G,this._provider=ee}async provideReferences(G,ee,te,ce){const Z=this._documents.getDocument(G),re=C.Position.to(ee),pe=await this._provider.provideReferences(Z,re,te,ce);if(Array.isArray(pe))return pe.map(C.location.from)}}class R{constructor(G,ee,te,ce,Z,re,pe){this._documents=G,this._commands=ee,this._diagnostics=te,this._provider=ce,this._logService=Z,this._extension=re,this._apiDeprecation=pe,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(G,ee,te,ce){const Z=this._documents.getDocument(G),re=I.Selection.isISelection(ee)?C.Selection.to(ee):C.Range.to(ee),pe=[];for(const ct of this._diagnostics.getDiagnostics(G))if(re.intersection(ct.range)&&pe.push(ct)>R._maxCodeActionsPerFile)break;const Me={diagnostics:pe,only:te.only?new S.CodeActionKind(te.only):void 0,triggerKind:C.CodeActionTriggerKind.to(te.trigger)},je=await this._provider.provideCodeActions(Z,re,Me,ce);if(!(0,k.isNonEmptyArray)(je)||ce.isCancellationRequested)return;const Ke=this._cache.add(je),Ze=new a.DisposableStore;this._disposables.set(Ke,Ze);const rt=[];for(let ct=0;ct<je.length;ct++){const ye=je[ct];!ye||(R._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,Ze)})):(Me.only&&(ye.kind?Me.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[Ke,ct],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,Ze),diagnostics:ye.diagnostics&&ye.diagnostics.map(C.Diagnostic.from),edit:ye.edit&&C.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:Ke,actions:rt}}async resolveCodeAction(G,ee){const[te,ce]=G,Z=this._cache.get(te,ce);if(!Z||R._isCommand(Z)||!this._provider.resolveCodeAction)return;const re=await this._provider.resolveCodeAction(Z,ee)??Z;return re?.edit?C.WorkspaceEdit.from(re.edit):void 0}releaseCodeActions(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}static _isCommand(G){return typeof G.command=="string"&&typeof G.title=="string"}}R._maxCodeActionsPerFile=1e3;class L{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentFormattingEdits(G,ee,te){const ce=this._documents.getDocument(G),Z=await this._provider.provideDocumentFormattingEdits(ce,ee,te);if(Array.isArray(Z))return Z.map(C.TextEdit.from)}}class M{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeFormattingEdits(G,ee,te,ce){const Z=this._documents.getDocument(G),re=C.Range.to(ee),pe=await this._provider.provideDocumentRangeFormattingEdits(Z,re,te,ce);if(Array.isArray(pe))return pe.map(C.TextEdit.from)}}class A{constructor(G,ee){this._documents=G,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(G,ee,te,ce,Z){const re=this._documents.getDocument(G),pe=C.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(re,pe,te,ce,Z);if(Array.isArray(Me))return Me.map(C.TextEdit.from)}}class B{constructor(G,ee){this._provider=G,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(G,ee){const te=P.IdObject.mixin({symbols:[]}),ce=await this._provider.provideWorkspaceSymbols(G,ee);if((0,k.isNonEmptyArray)(ce))for(const Z of ce){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const re=P.IdObject.mixin(C.WorkspaceSymbol.from(Z));this._symbolCache.set(re._id,Z),te.symbols.push(re)}return te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te}async resolveWorkspaceSymbol(G,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return G;const te=this._symbolCache.get(G._id);if(te){const ce=await this._provider.resolveWorkspaceSymbol(te,ee);return ce&&(0,F.mixin)(G,C.WorkspaceSymbol.from(ce),!0)}}releaseWorkspaceSymbols(G){const ee=this._resultCache.get(G);if(ee){for(let[te,ce]=ee;te<=ce;te++)this._symbolCache.delete(te);this._resultCache.delete(G)}}}class V{constructor(G,ee,te){this._documents=G,this._provider=ee,this._logService=te}static supportsResolving(G){return typeof G.prepareRename=="function"}async provideRenameEdits(G,ee,te,ce){const Z=this._documents.getDocument(G),re=C.Position.to(ee);try{const pe=await this._provider.provideRenameEdits(Z,re,te,ce);return pe?C.WorkspaceEdit.from(pe):void 0}catch(pe){const Me=V._asMessage(pe);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(pe)}}async resolveRenameLocation(G,ee,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ce=this._documents.getDocument(G),Z=C.Position.to(ee);try{const re=await this._provider.prepareRename(ce,Z,te);let pe,Me;if(S.Range.isRange(re)?(pe=re,Me=ce.getText(re)):(0,i.isObject)(re)&&(pe=re.range,Me=re.placeholder),!pe||!Me)return;if(pe.start.line>Z.line||pe.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(pe),text:Me}}catch(re){const pe=V._asMessage(re);return pe?{rejectReason:pe,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage(G){return typeof G=="string"?G:G instanceof Error&&typeof G.message=="string"?G.message:void 0}}class N{constructor(G,ee){this.resultId=G,this.tokens=ee}}class j{constructor(G,ee){this._documents=G,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(G,ee,te){const ce=this._documents.getDocument(G),Z=ee!==0?this._previousResults.get(ee):null;let re=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ce,Z.resultId,te):await this._provider.provideDocumentSemanticTokens(ce,te);return Z&&this._previousResults.delete(ee),re?(re=j._fixProvidedSemanticTokens(re),this._send(j._convertToEdits(Z,re),re)):null}async releaseDocumentSemanticColoring(G){this._previousResults.delete(G)}static _fixProvidedSemanticTokens(G){return j._isSemanticTokens(G)?j._isCorrectSemanticTokens(G)?G:new S.SemanticTokens(new Uint32Array(G.data),G.resultId):j._isSemanticTokensEdits(G)?j._isCorrectSemanticTokensEdits(G)?G:new S.SemanticTokensEdits(G.edits.map(ee=>new S.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),G.resultId):G}static _isSemanticTokens(G){return G&&!!G.data}static _isCorrectSemanticTokens(G){return G.data instanceof Uint32Array}static _isSemanticTokensEdits(G){return G&&Array.isArray(G.edits)}static _isCorrectSemanticTokensEdits(G){for(const ee of G.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(G,ee){if(!j._isSemanticTokens(ee)||!G||!G.tokens)return ee;const te=G.tokens,ce=te.length,Z=ee.data,re=Z.length;let pe=0;const Me=Math.min(ce,re);for(;pe<Me&&te[pe]===Z[pe];)pe++;if(pe===ce&&pe===re)return new S.SemanticTokensEdits([],ee.resultId);let je=0;const Ke=Me-pe;for(;je<Ke&&te[ce-je-1]===Z[re-je-1];)je++;return new S.SemanticTokensEdits([{start:pe,deleteCount:ce-pe-je,data:Z.subarray(pe,re-je)}],ee.resultId)}_send(G,ee){if(j._isSemanticTokens(G)){const te=this._nextResultId++;return this._previousResults.set(te,new N(G.resultId,G.data)),(0,p.encodeSemanticTokensDto)({id:te,type:"full",data:G.data})}if(j._isSemanticTokensEdits(G)){const te=this._nextResultId++;return j._isSemanticTokens(ee)?this._previousResults.set(te,new N(ee.resultId,ee.data)):this._previousResults.set(te,new N(G.resultId)),(0,p.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(G.edits||[]).map(ce=>({start:ce.start,deleteCount:ce.deleteCount,data:ce.data}))})}return null}}e.DocumentSemanticTokensAdapter=j;class U{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeSemanticTokens(G,ee,te){const ce=this._documents.getDocument(G),Z=await this._provider.provideDocumentRangeSemanticTokens(ce,C.Range.to(ee),te);return Z?this._send(Z):null}_send(G){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:G.data})}}e.DocumentRangeSemanticTokensAdapter=U;class x{constructor(G,ee,te,ce,Z){this._documents=G,this._commands=ee,this._provider=te,this._apiDeprecation=ce,this._extension=Z,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(G){return typeof G.resolveCompletionItem=="function"}async provideCompletionItems(G,ee,te,ce){const Z=this._documents.getDocument(G),re=C.Position.to(ee),pe=Z.getWordRangeAtPosition(re)||new S.Range(re,re),Me=pe.with({end:re}),je=new D.StopWatch(!0),Ke=await this._provider.provideCompletionItems(Z,re,ce,C.CompletionContext.to(te));if(!Ke||ce.isCancellationRequested)return;const Ze=Array.isArray(Ke)?new S.CompletionList(Ke):Ke,rt=x.supportsResolving(this._provider)?this._cache.add(Ze.items):this._cache.add([]),ct=new a.DisposableStore;this._disposables.set(rt,ct);const ye=[],at={x:rt,b:ye,a:{replace:C.Range.from(pe),insert:C.Range.from(Me)},c:Ze.isIncomplete||void 0,d:je.elapsed()};for(let J=0;J<Ze.items.length;J++){const se=Ze.items[J],Ee=this._convertCompletionItem(se,[rt,J],Me,pe);ye.push(Ee)}return at}async resolveCompletionItem(G,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...G);if(!te)return;const ce=await this._provider.resolveCompletionItem(te,ee);if(!!ce)return this._convertCompletionItem(ce,G)}releaseCompletionItems(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}_convertCompletionItem(G,ee,te,ce){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const re={x:ee,a:G.label,b:G.kind!==void 0?C.CompletionItemKind.from(G.kind):void 0,n:G.tags&&G.tags.map(C.CompletionItemTag.from),c:G.detail,d:typeof G.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(G.documentation),e:G.sortText!==G.label?G.sortText:void 0,f:G.filterText!==G.label?G.filterText:void 0,g:G.preselect||void 0,i:G.keepWhitespace?1:0,k:G.commitCharacters,l:G.additionalTextEdits&&G.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(G.command,Z)};G.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),re.h=G.textEdit.newText):typeof G.insertText=="string"?re.h=G.insertText:G.insertText instanceof S.SnippetString&&(re.h=G.insertText.value,re.i|=4);let pe;return G.textEdit?pe=G.textEdit.range:G.range&&(pe=G.range),S.Range.isRange(pe)?re.j=C.Range.from(pe):pe&&(!te?.isEqual(pe.inserting)||!ce?.isEqual(pe.replacing))&&(re.j={insert:C.Range.from(pe.inserting),replace:C.Range.from(pe.replacing)}),re}}class z{constructor(G,ee,te){this._documents=G,this._provider=ee,this._commands=te,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(G,ee,te,ce){const Z=this._documents.getDocument(G),re=C.Position.to(ee),pe=await this._provider.provideInlineCompletionItems(Z,re,{selectedCompletionInfo:te.selectedSuggestionInfo?{range:C.Range.to(te.selectedSuggestionInfo.range),text:te.selectedSuggestionInfo.text}:void 0,triggerKind:te.triggerKind},ce);if(!pe||ce.isCancellationRequested)return;const Me=(0,i.isArray)(pe)?{items:pe}:pe,je=this._cache.add(Me.items);let Ke;return{pid:je,items:Me.items.map((Ze,rt)=>{let ct;return Ze.command&&(Ke||(Ke=new a.DisposableStore,this._disposables.set(je,Ke)),ct=this._commands.toInternal(Ze.command,Ke)),{text:Ze.text,range:Ze.range?C.Range.from(Ze.range):void 0,command:ct,idx:rt}})}}disposeCompletions(G){this._cache.delete(G);const ee=this._disposables.get(G);ee&&ee.clear(),this._disposables.delete(G)}handleDidShowCompletionItem(G,ee){const te=this._cache.get(G,ee);te&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:te})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(G){let ee=O.map.get(G);return ee||(ee=new O,O.map.set(G,ee)),ee}fireOnDidShowCompletionItem(G){this._onDidShowCompletionItemEmitter.fire(G)}}e.InlineCompletionController=O,O.map=new WeakMap;class W{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new w.Cache("SignatureHelp")}async provideSignatureHelp(G,ee,te,ce){const Z=this._documents.getDocument(G),re=C.Position.to(ee),pe=this.reviveContext(te),Me=await this._provider.provideSignatureHelp(Z,re,ce,pe);if(Me){const je=this._cache.add([Me]);return{...C.SignatureHelp.from(Me),id:je}}}reviveContext(G){let ee;if(G.activeSignatureHelp){const te=C.SignatureHelp.to(G.activeSignatureHelp),ce=this._cache.get(G.activeSignatureHelp.id,0);ce?(ee=ce,ee.activeSignature=te.activeSignature,ee.activeParameter=te.activeParameter):ee=te}return{...G,activeSignatureHelp:ee}}releaseSignatureHelp(G){this._cache.delete(G)}}class ${constructor(G,ee){this._documents=G,this._provider=ee}async provideInlayHints(G,ee,te){const ce=this._documents.getDocument(G),Z=await this._provider.provideInlayHints(ce,C.Range.to(ee),te);return Z?{hints:Z.map(C.InlayHint.from)}:void 0}}class X{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new w.Cache("DocumentLink")}async provideLinks(G,ee){const te=this._documents.getDocument(G),ce=await this._provider.provideDocumentLinks(te,ee);if(!(!Array.isArray(ce)||ce.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ce.filter(X._validateLink).map(C.DocumentLink.from)};{const Z=this._cache.add(ce),re={links:[],id:Z};for(let pe=0;pe<ce.length;pe++){if(!X._validateLink(ce[pe]))continue;const Me=C.DocumentLink.from(ce[pe]);Me.cacheId=[Z,pe],re.links.push(Me)}return re}}}static _validateLink(G){return G.target&&G.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(G,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const te=this._cache.get(...G);if(!te)return;const ce=await this._provider.resolveDocumentLink(te,ee);if(!(!ce||!X._validateLink(ce)))return C.DocumentLink.from(ce)}releaseLinks(G){this._cache.delete(G)}}class K{constructor(G,ee){this._documents=G,this._provider=ee}async provideColors(G,ee){const te=this._documents.getDocument(G),ce=await this._provider.provideDocumentColors(te,ee);return Array.isArray(ce)?ce.map(re=>({color:C.Color.from(re.color),range:C.Range.from(re.range)})):[]}async provideColorPresentations(G,ee,te){const ce=this._documents.getDocument(G),Z=C.Range.to(ee.range),re=C.Color.to(ee.color),pe=await this._provider.provideColorPresentations(re,{document:ce,range:Z},te);if(!!Array.isArray(pe))return pe.map(C.ColorPresentation.from)}}class de{constructor(G,ee){this._documents=G,this._provider=ee}async provideFoldingRanges(G,ee,te){const ce=this._documents.getDocument(G),Z=await this._provider.provideFoldingRanges(ce,ee,te);if(!!Array.isArray(Z))return Z.map(C.FoldingRange.from)}}class _e{constructor(G,ee,te){this._documents=G,this._provider=ee,this._logService=te}async provideSelectionRanges(G,ee,te){const ce=this._documents.getDocument(G),Z=ee.map(C.Position.to),re=await this._provider.provideSelectionRanges(ce,Z,te);if(!(0,k.isNonEmptyArray)(re))return[];if(re.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const pe=[];for(let Me=0;Me<Z.length;Me++){const je=[];pe.push(je);let Ke=Z[Me],Ze=re[Me];for(;;){if(!Ze.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(je.push(C.SelectionRange.from(Ze)),!Ze.parent)break;Ke=Ze.range,Ze=Ze.parent}}return pe}}class Ce{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,te){const ce=this._documents.getDocument(G),Z=C.Position.to(ee),re=await this._provider.prepareCallHierarchy(ce,Z,te);if(!re)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(re)?re.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,re)]}async provideCallsTo(G,ee,te){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(ce,te);if(!!Z)return Z.map(re=>({from:this._cacheAndConvertItem(G,re.from),fromRanges:re.fromRanges.map(pe=>C.Range.from(pe))}))}async provideCallsFrom(G,ee,te){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(ce,te);if(!!Z)return Z.map(re=>({to:this._cacheAndConvertItem(G,re.to),fromRanges:re.fromRanges.map(pe=>C.Range.from(pe))}))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const te=this._cache.get(G),ce=C.CallHierarchyItem.from(ee,G,te.size.toString(36));return te.set(ce._itemId,ee),ce}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class Pe{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,te){const ce=this._documents.getDocument(G),Z=C.Position.to(ee),re=await this._provider.prepareTypeHierarchy(ce,Z,te);if(!re)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(re)?re.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,re)]}async provideSupertypes(G,ee,te){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(ce,te);if(!!Z)return Z.map(re=>this._cacheAndConvertItem(G,re))}async provideSubtypes(G,ee,te){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(ce,te);if(!!Z)return Z.map(re=>this._cacheAndConvertItem(G,re))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const te=this._cache.get(G),ce=C.TypeHierarchyItem.from(ee,G,te.size.toString(36));return te.set(ce._itemId,ee),ce}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class Be{constructor(G,ee){this.adapter=G,this.extension=ee}}class $e{constructor(G,ee,te,ce,Z,re,pe){this._adapter=new Map,this._uriTransformer=ee,this._proxy=G.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ce,this._diagnostics=Z,this._logService=re,this._apiDeprecation=pe}_transformDocumentSelector(G){return C.DocumentSelector.from(G,this._uriTransformer)}_createDisposable(G){return new S.Disposable(()=>{this._adapter.delete(G),this._proxy.$unregister(G)})}_nextHandle(){return $e._handlePool++}_withAdapter(G,ee,te,ce,Z=!1){const re=this._adapter.get(G);if(!re)return Promise.resolve(ce);if(re.adapter instanceof ee){let pe;re.extension&&(pe=Date.now(),this._logService.trace(`[${re.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=te(re.adapter,re.extension),je=re.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-pe}ms`),Ke=>{Z&&Ke instanceof T.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(G,ee){const te=this._nextHandle();return this._adapter.set(te,new Be(G,ee)),te}static _extLabel(G){return G.displayName||G.name}registerDocumentSymbolProvider(G,ee,te,ce){const Z=this._addNewAdapter(new l(this._documents,te),G),re=ce&&ce.label||$e._extLabel(G);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),re),this._createDisposable(Z)}$provideDocumentSymbols(G,ee,te){return this._withAdapter(G,l,ce=>ce.provideDocumentSymbols(g.URI.revive(ee),te),void 0)}registerCodeLensProvider(G,ee,te){const ce=this._nextHandle(),Z=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ce,new Be(new o(this._documents,this._commands.converter,te),G)),this._proxy.$registerCodeLensSupport(ce,this._transformDocumentSelector(ee),Z);let re=this._createDisposable(ce);if(Z!==void 0){const pe=te.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));re=S.Disposable.from(re,pe)}return re}$provideCodeLenses(G,ee,te){return this._withAdapter(G,o,ce=>ce.provideCodeLenses(g.URI.revive(ee),te),void 0)}$resolveCodeLens(G,ee,te){return this._withAdapter(G,o,ce=>ce.resolveCodeLens(ee,te),void 0)}$releaseCodeLenses(G,ee){this._withAdapter(G,o,te=>Promise.resolve(te.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(G,ee,te){const ce=this._addNewAdapter(new n(this._documents,te),G);return this._proxy.$registerDefinitionSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDefinition(G,ee,te,ce){return this._withAdapter(G,n,Z=>Z.provideDefinition(g.URI.revive(ee),te,ce),[])}registerDeclarationProvider(G,ee,te){const ce=this._addNewAdapter(new f(this._documents,te),G);return this._proxy.$registerDeclarationSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDeclaration(G,ee,te,ce){return this._withAdapter(G,f,Z=>Z.provideDeclaration(g.URI.revive(ee),te,ce),[])}registerImplementationProvider(G,ee,te){const ce=this._addNewAdapter(new r(this._documents,te),G);return this._proxy.$registerImplementationSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideImplementation(G,ee,te,ce){return this._withAdapter(G,r,Z=>Z.provideImplementation(g.URI.revive(ee),te,ce),[])}registerTypeDefinitionProvider(G,ee,te){const ce=this._addNewAdapter(new t(this._documents,te),G);return this._proxy.$registerTypeDefinitionSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideTypeDefinition(G,ee,te,ce){return this._withAdapter(G,t,Z=>Z.provideTypeDefinition(g.URI.revive(ee),te,ce),[])}registerHoverProvider(G,ee,te,ce){const Z=this._addNewAdapter(new d(this._documents,te),G);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(G,ee,te,ce){return this._withAdapter(G,d,Z=>Z.provideHover(g.URI.revive(ee),te,ce),void 0)}registerEvaluatableExpressionProvider(G,ee,te,ce){const Z=this._addNewAdapter(new s(this._documents,te),G);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(G,ee,te,ce){return this._withAdapter(G,s,Z=>Z.provideEvaluatableExpression(g.URI.revive(ee),te,ce),void 0)}registerInlineValuesProvider(G,ee,te,ce){const Z=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new c(this._documents,te),G);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(ee),Z);let pe=this._createDisposable(re);if(Z!==void 0){const Me=te.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(Z));pe=S.Disposable.from(pe,Me)}return pe}$provideInlineValues(G,ee,te,ce,Z){return this._withAdapter(G,c,re=>re.provideInlineValues(g.URI.revive(ee),te,ce,Z),void 0)}registerDocumentHighlightProvider(G,ee,te){const ce=this._addNewAdapter(new m(this._documents,te),G);return this._proxy.$registerDocumentHighlightProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDocumentHighlights(G,ee,te,ce){return this._withAdapter(G,m,Z=>Z.provideDocumentHighlights(g.URI.revive(ee),te,ce),void 0)}registerLinkedEditingRangeProvider(G,ee,te){const ce=this._addNewAdapter(new u(this._documents,te),G);return this._proxy.$registerLinkedEditingRangeProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideLinkedEditingRanges(G,ee,te,ce){return this._withAdapter(G,u,async Z=>{const re=await Z.provideLinkedEditingRanges(g.URI.revive(ee),te,ce);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?$e._serializeRegExp(re.wordPattern):void 0}},void 0)}registerReferenceProvider(G,ee,te){const ce=this._addNewAdapter(new E(this._documents,te),G);return this._proxy.$registerReferenceSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideReferences(G,ee,te,ce,Z){return this._withAdapter(G,E,re=>re.provideReferences(g.URI.revive(ee),te,ce,Z),void 0)}registerCodeActionProvider(G,ee,te,ce){const Z=new a.DisposableStore,re=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,te,this._logService,G,this._apiDeprecation),G);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(ee),{providedKinds:ce?.providedCodeActionKinds?.map(pe=>pe.value),documentation:ce?.documentation?.map(pe=>({kind:pe.kind.value,command:this._commands.converter.toInternal(pe.command,Z)}))},$e._extLabel(G),Boolean(te.resolveCodeAction)),Z.add(this._createDisposable(re)),Z}$provideCodeActions(G,ee,te,ce,Z){return this._withAdapter(G,R,re=>re.provideCodeActions(g.URI.revive(ee),te,ce,Z),void 0)}$resolveCodeAction(G,ee,te){return this._withAdapter(G,R,ce=>ce.resolveCodeAction(ee,te),void 0)}$releaseCodeActions(G,ee){this._withAdapter(G,R,te=>Promise.resolve(te.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(G,ee,te){const ce=this._addNewAdapter(new L(this._documents,te),G);return this._proxy.$registerDocumentFormattingSupport(ce,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(ce)}$provideDocumentFormattingEdits(G,ee,te,ce){return this._withAdapter(G,L,Z=>Z.provideDocumentFormattingEdits(g.URI.revive(ee),te,ce),void 0)}registerDocumentRangeFormattingEditProvider(G,ee,te){const ce=this._addNewAdapter(new M(this._documents,te),G);return this._proxy.$registerRangeFormattingSupport(ce,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(ce)}$provideDocumentRangeFormattingEdits(G,ee,te,ce,Z){return this._withAdapter(G,M,re=>re.provideDocumentRangeFormattingEdits(g.URI.revive(ee),te,ce,Z),void 0)}registerOnTypeFormattingEditProvider(G,ee,te,ce){const Z=this._addNewAdapter(new A(this._documents,te),G);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),ce,G.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(G,ee,te,ce,Z,re){return this._withAdapter(G,A,pe=>pe.provideOnTypeFormattingEdits(g.URI.revive(ee),te,ce,Z,re),void 0)}registerWorkspaceSymbolProvider(G,ee){const te=this._addNewAdapter(new B(ee,this._logService),G);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(G,ee,te){return this._withAdapter(G,B,ce=>ce.provideWorkspaceSymbols(ee,te),{symbols:[]})}$resolveWorkspaceSymbol(G,ee,te){return this._withAdapter(G,B,ce=>ce.resolveWorkspaceSymbol(ee,te),void 0)}$releaseWorkspaceSymbols(G,ee){this._withAdapter(G,B,te=>te.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(G,ee,te){const ce=this._addNewAdapter(new V(this._documents,te,this._logService),G);return this._proxy.$registerRenameSupport(ce,this._transformDocumentSelector(ee),V.supportsResolving(te)),this._createDisposable(ce)}$provideRenameEdits(G,ee,te,ce,Z){return this._withAdapter(G,V,re=>re.provideRenameEdits(g.URI.revive(ee),te,ce,Z),void 0)}$resolveRenameLocation(G,ee,te,ce){return this._withAdapter(G,V,Z=>Z.resolveRenameLocation(g.URI.revive(ee),te,ce),void 0)}registerDocumentSemanticTokensProvider(G,ee,te,ce){const Z=this._nextHandle(),re=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new Be(new j(this._documents,te),G)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),ce,re);let pe=this._createDisposable(Z);if(re){const Me=te.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(re));pe=S.Disposable.from(pe,Me)}return pe}$provideDocumentSemanticTokens(G,ee,te,ce){return this._withAdapter(G,j,Z=>Z.provideDocumentSemanticTokens(g.URI.revive(ee),te,ce),null,!0)}$releaseDocumentSemanticTokens(G,ee){this._withAdapter(G,j,te=>te.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(G,ee,te,ce){const Z=this._addNewAdapter(new U(this._documents,te),G);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),ce),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(G,ee,te,ce){return this._withAdapter(G,U,Z=>Z.provideDocumentRangeSemanticTokens(g.URI.revive(ee),te,ce),null,!0)}registerCompletionItemProvider(G,ee,te,ce){const Z=this._addNewAdapter(new x(this._documents,this._commands.converter,te,this._apiDeprecation,G),G);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),ce,x.supportsResolving(te),`${G.identifier.value}(${ce.join("")})`),this._createDisposable(Z)}$provideCompletionItems(G,ee,te,ce,Z){return this._withAdapter(G,x,re=>re.provideCompletionItems(g.URI.revive(ee),te,ce,Z),void 0)}$resolveCompletionItem(G,ee,te){return this._withAdapter(G,x,ce=>ce.resolveCompletionItem(ee,te),void 0)}$releaseCompletionItems(G,ee){this._withAdapter(G,x,te=>te.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(G,ee,te){const ce=this._addNewAdapter(new z(this._documents,te,this._commands.converter),G);return this._proxy.$registerInlineCompletionsSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideInlineCompletions(G,ee,te,ce,Z){return this._withAdapter(G,z,re=>re.provideInlineCompletions(g.URI.revive(ee),te,ce,Z),void 0)}$handleInlineCompletionDidShow(G,ee,te){this._withAdapter(G,z,async ce=>{ce.handleDidShowCompletionItem(ee,te)},void 0)}$freeInlineCompletionsList(G,ee){this._withAdapter(G,z,async te=>{te.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(G,ee,te,ce){const Z=Array.isArray(ce)?{triggerCharacters:ce,retriggerCharacters:[]}:ce,re=this._addNewAdapter(new W(this._documents,te),G);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(ee),Z),this._createDisposable(re)}$provideSignatureHelp(G,ee,te,ce,Z){return this._withAdapter(G,W,re=>re.provideSignatureHelp(g.URI.revive(ee),te,ce,Z),void 0)}$releaseSignatureHelp(G,ee){this._withAdapter(G,W,te=>te.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(G,ee,te){const ce=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new $(this._documents,te),G);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),ce);let re=this._createDisposable(Z);if(ce!==void 0){const pe=te.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(ce));re=S.Disposable.from(re,pe)}return re}$provideInlayHints(G,ee,te,ce){return this._withAdapter(G,$,Z=>Z.provideInlayHints(g.URI.revive(ee),te,ce),void 0)}registerDocumentLinkProvider(G,ee,te){const ce=this._addNewAdapter(new X(this._documents,te),G);return this._proxy.$registerDocumentLinkProvider(ce,this._transformDocumentSelector(ee),typeof te.resolveDocumentLink=="function"),this._createDisposable(ce)}$provideDocumentLinks(G,ee,te){return this._withAdapter(G,X,ce=>ce.provideLinks(g.URI.revive(ee),te),void 0)}$resolveDocumentLink(G,ee,te){return this._withAdapter(G,X,ce=>ce.resolveLink(ee,te),void 0)}$releaseDocumentLinks(G,ee){this._withAdapter(G,X,te=>te.releaseLinks(ee),void 0)}registerColorProvider(G,ee,te){const ce=this._addNewAdapter(new K(this._documents,te),G);return this._proxy.$registerDocumentColorProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDocumentColors(G,ee,te){return this._withAdapter(G,K,ce=>ce.provideColors(g.URI.revive(ee),te),[])}$provideColorPresentations(G,ee,te,ce){return this._withAdapter(G,K,Z=>Z.provideColorPresentations(g.URI.revive(ee),te,ce),void 0)}registerFoldingRangeProvider(G,ee,te){const ce=this._nextHandle(),Z=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ce,new Be(new de(this._documents,te),G)),this._proxy.$registerFoldingRangeProvider(ce,this._transformDocumentSelector(ee),Z);let re=this._createDisposable(ce);if(Z!==void 0){const pe=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));re=S.Disposable.from(re,pe)}return re}$provideFoldingRanges(G,ee,te,ce){return this._withAdapter(G,de,Z=>Z.provideFoldingRanges(g.URI.revive(ee),te,ce),void 0)}registerSelectionRangeProvider(G,ee,te){const ce=this._addNewAdapter(new _e(this._documents,te,this._logService),G);return this._proxy.$registerSelectionRangeProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideSelectionRanges(G,ee,te,ce){return this._withAdapter(G,_e,Z=>Z.provideSelectionRanges(g.URI.revive(ee),te,ce),[])}registerCallHierarchyProvider(G,ee,te){const ce=this._addNewAdapter(new Ce(this._documents,te),G);return this._proxy.$registerCallHierarchyProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$prepareCallHierarchy(G,ee,te,ce){return this._withAdapter(G,Ce,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),te,ce)),void 0)}$provideCallHierarchyIncomingCalls(G,ee,te,ce){return this._withAdapter(G,Ce,Z=>Z.provideCallsTo(ee,te,ce),void 0)}$provideCallHierarchyOutgoingCalls(G,ee,te,ce){return this._withAdapter(G,Ce,Z=>Z.provideCallsFrom(ee,te,ce),void 0)}$releaseCallHierarchy(G,ee){this._withAdapter(G,Ce,te=>Promise.resolve(te.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(G,ee,te){const ce=this._addNewAdapter(new Pe(this._documents,te),G);return this._proxy.$registerTypeHierarchyProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$prepareTypeHierarchy(G,ee,te,ce){return this._withAdapter(G,Pe,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),te,ce)),void 0)}$provideTypeHierarchySupertypes(G,ee,te,ce){return this._withAdapter(G,Pe,Z=>Z.provideSupertypes(ee,te,ce),void 0)}$provideTypeHierarchySubtypes(G,ee,te,ce){return this._withAdapter(G,Pe,Z=>Z.provideSubtypes(ee,te,ce),void 0)}$releaseTypeHierarchy(G,ee){this._withAdapter(G,Pe,te=>Promise.resolve(te.releaseSession(ee)),void 0)}static _serializeRegExp(G){return{pattern:G.source,flags:(0,_.regExpFlags)(G)}}static _serializeIndentationRule(G){return{decreaseIndentPattern:$e._serializeRegExp(G.decreaseIndentPattern),increaseIndentPattern:$e._serializeRegExp(G.increaseIndentPattern),indentNextLinePattern:G.indentNextLinePattern?$e._serializeRegExp(G.indentNextLinePattern):void 0,unIndentedLinePattern:G.unIndentedLinePattern?$e._serializeRegExp(G.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(G){return{beforeText:$e._serializeRegExp(G.beforeText),afterText:G.afterText?$e._serializeRegExp(G.afterText):void 0,previousLineText:G.previousLineText?$e._serializeRegExp(G.previousLineText):void 0,action:G.action}}static _serializeOnEnterRules(G){return G.map($e._serializeOnEnterRule)}setLanguageConfiguration(G,ee,te){let{wordPattern:ce}=te;if(ce&&(0,_.regExpLeadsToEndlessLoop)(ce))throw new Error(`Invalid language configuration: wordPattern '${ce}' is not allowed to match the empty string.`);ce?this._documents.setWordDefinitionFor(ee,ce):this._documents.setWordDefinitionFor(ee,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",G,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",G,"Do not use.");const Z=this._nextHandle(),re={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?$e._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?$e._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?$e._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,re),this._createDisposable(Z)}$setWordDefinitions(G){for(const ee of G)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=$e,$e._handlePool=0}),define(fe[244],me([0,1,5,16,7,49,15,6]),function(Y,e,g,F,C,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(i,I,a,p){this._documents=I,this._commands=a,this._uriTransformer=p,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=i.getProxy(g.MainContext.MainThreadLanguages)}$acceptLanguageIds(i){this._languageIds=i}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(i,I){await this._proxy.$changeLanguage(i,I);const a=this._documents.getDocumentData(i);if(!a)throw new Error(`document '${i.toString}' NOT found`);return a.document}async tokenAtPosition(i,I){const a=i.version,p=F.Position.from(I),h=await this._proxy.$tokensAtPosition(i.uri,p),w={type:C.StandardTokenType.Other,range:i.getWordRangeAtPosition(I)??new C.Range(I.line,I.character,I.line,I.character)};if(!h)return w;const D={range:F.Range.to(h.range),type:F.TokenType.to(h.type)};return!D.range.contains(I)||a!==i.version?w:D}createLanguageStatusItem(i,I,a){const p=this._handlePool++,h=this._proxy,w=this._ids,D=`${i.identifier.value}/${I}`;if(w.has(D))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);w.add(D);const T={selector:a,id:I,name:i.displayName??i.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let b,l=new _.DisposableStore;const o=()=>{b?.dispose(),b=(0,P.disposableTimeout)(()=>{l.clear(),this._proxy.$setLanguageStatus(p,{id:D,name:T.name??i.displayName??i.name,source:i.displayName??i.name,selector:F.DocumentSelector.from(T.selector,this._uriTransformer),label:T.text,detail:T.detail??"",severity:T.severity===C.LanguageStatusSeverity.Error?S.default.Error:T.severity===C.LanguageStatusSeverity.Warning?S.default.Warning:S.default.Info,command:T.command&&this._commands.toInternal(T.command,l),accessibilityInfo:T.accessibilityInformation})},0)},v={dispose(){l.dispose(),b?.dispose(),h.$removeLanguageStatus(p),w.delete(D)},get id(){return T.id},get name(){return T.name},set name(n){T.name=n,o()},get selector(){return T.selector},set selector(n){T.selector=n,o()},get text(){return T.text},set text(n){T.text=n,o()},get detail(){return T.detail},set detail(n){T.detail=n,o()},get severity(){return T.severity},set severity(n){T.severity=n,o()},get accessibilityInformation(){return T.accessibilityInformation},set accessibilityInformation(n){T.accessibilityInformation=n,o()},get command(){return T.command},set command(n){T.command=n,o()}};return o(),v}}e.ExtHostLanguages=y}),define(fe[245],me([0,1,5,13,35]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function S(_){return _&&_.title}let P=class{constructor(y,k){this._logService=k,this._proxy=y.getProxy(g.MainContext.MainThreadMessageService)}showMessage(y,k,i,I,a){const p={extension:y};let h;typeof I=="string"||S(I)?h=[I,...a]:(p.modal=I?.modal,p.useCustom=I?.useCustom,p.detail=I?.detail,h=a),p.useCustom&&(0,C.checkProposedApiEnabled)(y);const w=[];for(let D=0;D<h.length;D++){const T=h[D];if(typeof T=="string")w.push({title:T,handle:D,isCloseAffordance:!1});else if(typeof T=="object"){let{title:b,isCloseAffordance:l}=T;w.push({title:b,isCloseAffordance:!!l,handle:D})}else this._logService.warn("Invalid message item:",T)}return this._proxy.$showMessage(k,i,p,w).then(D=>{if(typeof D=="number")return h[D]})}};P=Ve([We(1,F.ILogService)],P),e.ExtHostMessageService=P}),define(fe[246],me([0,1,22,3,48,6,24,9,12,2,87,5,16,7,55,221,131]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class T{constructor(l,o,v,n,f){this._textDocumentsAndEditors=v,this._textDocuments=n,this._extensionStoragePaths=f,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const t=r.notebookEditor?.notebookUri,d=r.cell.handle,c=this._documents.get(t)?.getCell(d);if(c)return c.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const o=this._editors.get(l);if(!o)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(l){for(const[o,v]of this._editors)if(v.apiEditor===l)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,o){const v=this._documents.get(l);if(!v&&!o)throw new Error(`NO notebook document for '${l}'`);return v}_getProviderData(l){const o=this._notebookContentProviders.get(l);if(!o)throw new Error(`NO provider for '${l}'`);return o}registerNotebookContentProvider(l,o,v,n,f){if((0,_.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(o))throw new Error(`Notebook provider for '${o}' already registered`);this._notebookContentProviders.set(o,{extension:l,provider:v});let r;return v.onDidChangeNotebookContentOptions&&(r=v.onDidChangeNotebookContentOptions(()=>{const t=a.NotebookDocumentContentOptions.from(v.options);this._notebookProxy.$updateNotebookProviderOptions(o,t)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},o,a.NotebookDocumentContentOptions.from(n),T._convertNotebookRegistrationData(l,f)),new p.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(o),this._notebookProxy.$unregisterNotebookProvider(o)})}static _convertNotebookRegistrationData(l,o){if(!o)return;const v=o.filenamePattern.map(n=>a.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(o.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:o.displayName,filenamePattern:v,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,o,v){const n=T._notebookStatusBarItemProviderHandlePool++,f=typeof v.onDidChangeCellStatusBarItems=="function"?T._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(n,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(n,f,o);let r;return f!==void 0&&(r=v.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(f))),new p.Disposable(()=>{this._notebookStatusBarItemProviders.delete(n),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(n,f),r&&r.dispose()})}async createNotebookDocument(l){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&a.NotebookData.from(l.content)});return k.URI.revive(o)}async openNotebookDocument(l){const o=this._documents.get(l);if(o)return o.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenNotebook(l),n=this._documents.get(k.URI.revive(v));return(0,y.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(l,o){k.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let v;typeof o=="object"?v={position:a.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(a.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:v={preserveFocus:!1};const n=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,v),f=n&&this._editors.get(n)?.apiEditor;if(f)return f;throw n?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,o,v,n){const f=this._notebookStatusBarItemProviders.get(l),r=k.URI.revive(o),t=this._documents.get(r);if(!t||!f)return;const d=t.getCellFromIndex(v);if(!d)return;const s=await f.provideCellStatusBarItems(d.apiCell,n);if(!s)return;const c=new S.DisposableStore,m=this._statusBarCache.add([c]),E=(Array.isArray(s)?s:[s]).map(R=>a.NotebookStatusBarItem.from(R,this._commandsConverter,c));return{cacheId:m,items:E}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,o,v,n,f){if((0,_.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,v),this._notebookProxy.$registerNotebookSerializer(r,{id:l.identifier,location:l.extensionLocation},o,a.NotebookDocumentContentOptions.from(n),T._convertNotebookRegistrationData(l,f)),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(l,o,v){const n=this._notebookSerializer.get(l);if(!n)throw new Error("NO serializer found");const f=await n.deserializeNotebook(o.buffer,v);return new h.SerializableObjectWithBuffers(a.NotebookData.from(f))}async $notebookToData(l,o,v){const n=this._notebookSerializer.get(l);if(!n)throw new Error("NO serializer found");const f=await n.serializeNotebook(a.NotebookData.to(o.value),v);return g.VSBuffer.wrap(f)}async $openNotebook(l,o,v,n,f){const{provider:r}=this._getProviderData(l),t=await r.openNotebook(k.URI.revive(o),{backupId:v,untitledDocumentData:n?.buffer},f);return new h.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(a.NotebookCellData.from)})}async $saveNotebook(l,o,v){const n=this.getNotebookDocument(k.URI.revive(o)),{provider:f}=this._getProviderData(l);return await f.saveNotebook(n.apiNotebook,v),!0}async $saveNotebookAs(l,o,v,n){const f=this.getNotebookDocument(k.URI.revive(o)),{provider:r}=this._getProviderData(l);return await r.saveNotebookAs(k.URI.revive(v),f.apiNotebook,n),!0}async $backupNotebook(l,o,v){const n=this.getNotebookDocument(k.URI.revive(o)),f=this._getProviderData(l),r=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension),t=String((0,C.hash)([n.uri.toString(),this._backupIdPool++])),d=k.URI.joinPath(r,t),s=await f.provider.backupNotebook(n.apiNotebook,{destination:d},v);return n.updateBackup(s),s.id}_createExtHostEditor(l,o,v){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const n=new D.ExtHostNotebookEditor(o,this._notebookEditorsProxy,l,v.visibleRanges.map(a.NotebookRange.to),v.selections.map(a.NotebookRange.to),typeof v.viewColumn=="number"?a.ViewColumn.to(v.viewColumn):void 0);this._editors.set(o,n)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const v of l.value.removedDocuments){const n=k.URI.revive(v),f=this._documents.get(n);f&&(f.dispose(),this._documents.delete(n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(f.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===n.toString()&&this._editors.delete(r.id)}if(l.value.addedDocuments){const v=[];for(const n of l.value.addedDocuments){const f=k.URI.revive(n.uri);if(this._documents.has(f))throw new Error(`adding EXISTING notebook ${f} `);const r=this,t=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(d){r._onDidChangeNotebookCells.fire(d)},emitCellOutputsChange(d){r._onDidChangeCellOutputs.fire(d)},emitCellMetadataChange(d){r._onDidChangeCellMetadata.fire(d)},emitCellExecutionStateChange(d){r._onDidChangeCellExecutionState.fire(d)}},f,n);v.push(...n.cells.map(d=>w.ExtHostCell.asModelAddData(t.apiNotebook,d))),this._documents.get(f)?.dispose(),this._documents.set(f,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(l.value.addedEditors)for(const v of l.value.addedEditors){if(this._editors.has(v.id))return;const n=k.URI.revive(v.documentUri),f=this._documents.get(n);f&&this._createExtHostEditor(f,v.id,v)}const o=[];if(l.value.removedEditors)for(const v of l.value.removedEditors){const n=this._editors.get(v);n&&(this._editors.delete(v),this._activeNotebookEditor?.id===n.id&&(this._activeNotebookEditor=void 0),o.push(n))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(n=>this._editors.get(n)).filter(n=>!!n);const v=new Set;this._visibleNotebookEditors.forEach(n=>v.add(n.id));for(const n of this._editors.values()){const f=v.has(n.id);n._acceptVisibility(f)}this._visibleNotebookEditors=[...this._editors.values()].map(n=>n).filter(n=>n.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=T,T._notebookStatusBarItemProviderHandlePool=0}),define(fe[247],me([0,1,3,77,13,5,14,16]),function(Y,e,g,F,C,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(I,a){const p=y._Keys.nextId();I.$registerNotebookEditorDecorationType(p,_.NotebookDecorationRenderOptions.from(a)),this.value={key:p,dispose(){I.$removeNotebookEditorDecorationType(p)}}}}y._Keys=new F.IdGenerator("NotebookEditorDecorationType");let k=class{constructor(I,a,p){this._logService=I,this._extHostRpc=a,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new y(this._extHostRpc.getProxy(S.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,a){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,a);const p=this._notebooksAndEditors.getEditorById(I);a.visibleRanges&&p._acceptVisibleRanges(a.visibleRanges.ranges.map(_.NotebookRange.to)),a.selections&&p._acceptSelections(a.selections.selections.map(_.NotebookRange.to)),a.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.apiEditor,visibleRanges:p.apiEditor.visibleRanges}),a.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.apiEditor,selections:p.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const a in I)this._notebooksAndEditors.getEditorById(a)._acceptViewColumn(_.ViewColumn.to(I[a]))}};k=Ve([We(0,C.ILogService),We(1,P.IExtHostRpcService)],k),e.ExtHostNotebookEditors=k}),define(fe[248],me([0,1,18,15,21,3,6,24,2,27,13,5,40,16,7,88,214,35,55]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let l=class{constructor(r,t,d,s,c){this._initData=t,this._extHostNotebook=d,this._commands=s,this._logService=c,this._activeExecutions=new _.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(I.MainContext.MainThreadNotebookKernels);const m=new a.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.ApiCommandArgument("options","Select kernel options",u=>!0,u=>{if(u&&"notebookEditor"in u&&"id"in u){const E=this._extHostNotebook.getIdByEditor(u.notebookEditor);return{id:u.id,extension:u.extension,notebookEditorId:E}}else if(u&&"notebookEditor"in u){const E=this._extHostNotebook.getIdByEditor(u.notebookEditor);if(E===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${u.notebookEditor.document.uri.toString()}`);return{notebookEditorId:E}}return u})],a.ApiCommandResult.Void);this._commands.registerApiCommand(m)}createNotebookController(r,t,d,s,c,m){for(let W of this._kernelData.values())if(W.controller.id===t&&k.ExtensionIdentifier.equals(r.identifier,W.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const u=this._handlePool++,E=this;this._logService.trace(`NotebookController[${u}], CREATED by ${r.identifier.value}, ${t}`);const R=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${r.identifier}'`);let L=!1;const M=new P.DisposableStore,A=new S.Emitter,B=new S.Emitter,V={id:`${r.identifier.value}/${t}`,notebookType:d,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:s||r.identifier.value,preloads:m?m.map(p.NotebookRendererScript.from):[]};let N=c??R,j;this._proxy.$addKernel(u,V).catch(W=>{console.log(W),L=!0});let U=0;const x=()=>{if(L)return;const W=++U;Promise.resolve().then(()=>{W===U&&this._proxy.$updateKernel(u,V)})},z=new _.ResourceMap,O={get id(){return t},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return V.label},set label(W){V.label=W??r.displayName??r.name,x()},get detail(){return V.detail??""},set detail(W){V.detail=W,x()},get description(){return V.description??""},set description(W){V.description=W,x()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(W){V.supportedLanguages=W,x()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(W){V.supportsExecutionOrder=W,x()},get rendererScripts(){return V.preloads?V.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return N},set executeHandler(W){N=W??R},get interruptHandler(){return j},set interruptHandler(W){j=W,V.supportsInterrupt=Boolean(W),x()},createNotebookCellExecution(W){if(L)throw new Error("notebook controller is DISPOSED");if(!z.has(W.notebook.uri))throw E._logService.trace(`NotebookController[${u}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(z.keys()).map($=>$.toString())),new Error(`notebook controller is NOT associated to notebook: ${W.notebook.uri.toString()}`);return E._createNotebookCellExecution(W)},dispose:()=>{L||(this._logService.trace(`NotebookController[${u}], DISPOSED`),L=!0,this._kernelData.delete(u),M.dispose(),A.dispose(),B.dispose(),this._proxy.$removeKernel(u))},updateNotebookAffinity(W,$){E._proxy.$updateNotebookPriority(u,W.uri,$)},onDidReceiveMessage:B.event,postMessage(W,$){return(0,T.checkProposedApiEnabled)(r),E._proxy.$postMessage(u,$&&E._extHostNotebook.getIdByEditor($),W)},asWebviewUri(W){return(0,T.checkProposedApiEnabled)(r),(0,w.asWebviewUri)(W,E._initData.remote)}};return this._kernelData.set(u,{extensionId:r.identifier,controller:O,onDidReceiveMessage:B,onDidChangeSelection:A,associatedNotebooks:z}),O}$acceptNotebookAssociation(r,t,d){const s=this._kernelData.get(r);if(s){const c=this._extHostNotebook.getNotebookDocument(y.URI.revive(t));d?s.associatedNotebooks.set(c.uri,!0):s.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,c.uri.toString(),d),s.onDidChangeSelection.fire({selected:d,notebook:c.apiNotebook})}}async $executeCells(r,t,d){const s=this._kernelData.get(r);if(!s)return;const c=this._extHostNotebook.getNotebookDocument(y.URI.revive(t)),m=[];for(let u of d){const E=c.getCell(u);E&&m.push(E.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,c.uri.toString(),m.length),await s.controller.executeHandler.call(s.controller,m,c.apiNotebook,s.controller)}catch(u){this._logService.error(`NotebookController[${r}] execute cells FAILED`,u),console.error(u)}}async $cancelCells(r,t,d){const s=this._kernelData.get(r);if(!s)return;const c=this._extHostNotebook.getNotebookDocument(y.URI.revive(t));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,c.apiNotebook);else for(let m of d){const u=c.getCell(m);u&&this._activeExecutions.get(u.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,t,d){const s=this._kernelData.get(r);if(!s)return;const c=this._extHostNotebook.getEditorById(t);s.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:d}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!d)throw new Error("invalid cell");if(this._activeExecutions.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const s=new v(d.notebook,d,this._proxy);this._activeExecutions.set(d.uri,s);const c=s.onDidChangeState(()=>{s.state===o.Resolved&&(s.dispose(),c.dispose(),this._activeExecutions.delete(d.uri))});return s.asApiObject()}};l=Ve([We(4,i.ILogService)],l),e.ExtHostNotebookKernels=l;var o;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(o||(o={}));class v extends P.Disposable{constructor(r,t,d){super();this._document=r,this._cell=t,this._proxy=d,this._handle=v.HANDLE++,this._onDidChangeState=new S.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._collector=new n(10,s=>this.update(s)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const t=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new b.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let t=this._cell;if(r&&(t=this._document.getCellFromApiCell(r)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(r){return r.map(t=>{const d=h.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return d===t.items?p.NotebookCellOutput.from(t):p.NotebookCellOutput.from({items:d,id:t.id,metadata:t.metadata})})}async updateOutputs(r,t,d){const s=this.cellIndexToHandle(t),c=this.validateAndConvertOutputs((0,g.asArray)(r));return this.updateSoon({editType:D.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:s,append:d,outputs:c})}async updateOutputItems(r,t,d){return r=h.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(r),!0),this.updateSoon({editType:D.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(p.NotebookCellOutputItem.from),outputId:t.id,append:d})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(d){r._executionOrder=d,r.update([{editType:D.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(d){if(r._state===o.Resolved||r._state===o.Started)throw new Error("Cannot call start again");r._state=o.Started,r._onDidChangeState.fire(),r.update({editType:D.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:d})},end(d,s){if(r._state===o.Resolved)throw new Error("Cannot call resolve twice");r._state=o.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:D.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:s,lastRunSuccess:d}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(d){return r.verifyStateForOutput(),r.updateOutputs([],d,!1)},appendOutput(d,s){return r.verifyStateForOutput(),r.updateOutputs(d,s,!0)},replaceOutput(d,s){return r.verifyStateForOutput(),r.updateOutputs(d,s,!1)},appendOutputItems(d,s){return r.verifyStateForOutput(),r.updateOutputItems(d,s,!0)},replaceOutputItems(d,s){return r.verifyStateForOutput(),r.updateOutputItems(d,s,!1)}})}}v.HANDLE=0;class n{constructor(r,t){this.delay=r,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>r.complete())}}}),define(fe[249],me([0,1,3,5,131]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class S{constructor(_,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=_.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(_,y,k){const i=this._extHostNotebook.getEditorById(_);this._rendererMessageEmitters.get(y)?.fire({editor:i.apiEditor,message:k})}createRendererMessaging(_,y){if(!_.contributes?.notebookRenderer?.some(a=>a.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const k=!!_.enableProposedApi,i=new WeakMap;return{onDidReceiveMessage:(a,p,h)=>{const w=k?a:D=>{const T={};i.set(T,D.editor),a({editor:T,message:D.message})};return this.getOrCreateEmitterFor(y).event(w,p,h)},postMessage:(a,p)=>{C.ExtHostNotebookEditor.apiEditorsToExtHost.has(a)&&([a,p]=[p,a]);const h=k?p:i.get(p),w=h&&C.ExtHostNotebookEditor.apiEditorsToExtHost.get(h);return this.proxy.$postMessage(w?.id,y,a)}}}getOrCreateEmitterFor(_){let y=this._rendererMessageEmitters.get(_);return y||(y=new g.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(_)}}),this._rendererMessageEmitters.set(_,y),y)}}e.ExtHostNotebookRenderers=S}),define(fe[69],me([0,1,5,3,6,22,4,14]),function(Y,e,g,F,C,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends C.Disposable{constructor(h,w,D,T,b){super();this._onDidAppend=this._register(new F.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=h,this._proxy=b,this._id=b.$register(this.name,w,D,T),this._disposed=!1,this._offset=0}get name(){return this._name}append(h){this.validate(),this._offset+=h?S.VSBuffer.fromString(h).byteLength:0}update(){this._id.then(h=>this._proxy.$update(h))}appendLine(h){this.validate(),this.append(h+`
`)}clear(){this.validate();const h=this._offset;this._id.then(w=>this._proxy.$clear(w,h))}show(h,w){this.validate(),this._id.then(D=>this._proxy.$reveal(D,!!(typeof h=="boolean"?h:w)))}hide(){this.validate(),this._id.then(h=>this._proxy.$close(h))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(h=>this._proxy.$dispose(h)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class k extends y{constructor(h,w,D){super(h,!1,void 0,w,D)}append(h){super.append(h),this._id.then(w=>this._proxy.$append(w,h)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class i extends y{constructor(h,w,D){super(h,!0,w,void 0,D)}append(h){throw new Error("Not supported")}}class I{constructor(h,w){this.name=h,this._channel=w}append(h){this._channel.then(w=>w.append(h))}appendLine(h){this._channel.then(w=>w.appendLine(h))}clear(){this._channel.then(h=>h.clear())}show(h,w){this._channel.then(D=>D.show(h,w))}hide(){this._channel.then(h=>h.hide())}dispose(){this._channel.then(h=>h.dispose())}}e.LazyOutputChannel=I;let a=class{constructor(h){this._proxy=h.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(h){}createOutputChannel(h,w){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");return new k(h,w.identifier.value,this._proxy)}createOutputChannelFromLogFile(h,w){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");if(!w)throw new Error("illegal argument `file`. must not be falsy");return new i(h,w,this._proxy)}};a=Ve([We(0,_.IExtHostRpcService)],a),e.ExtHostOutputService=a,e.IExtHostOutputService=(0,P.createDecorator)("IExtHostOutputService")}),define(fe[250],me([0,1,15,21,3,6,5,2,7,17,18,49,65]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(h,w,D){const T=h.getProxy(P.MainContext.MainThreadQuickOpen);class b{constructor(s,c){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=c}showQuickPick(s,c,m,u=F.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(s),R=++this._instances,L=T.$show(R,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},u),M={},A=L.then(()=>M);return Promise.race([A,E]).then(B=>{if(B!==M)return E.then(V=>{const N=[];for(let j=0;j<V.length;j++){const U=V[j];let x,z,O,W,$;typeof U=="string"?x=U:(x=U.label,z=U.description,O=U.detail,W=U.picked,$=U.alwaysShow),N.push({label:x,description:z,handle:j,detail:O,picked:W,alwaysShow:$})}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{m.onDidSelectItem(V[j])}),T.$setItems(R,N),L.then(j=>{if(typeof j=="number")return V[j];if(Array.isArray(j))return j.map(U=>V[U])})})}).then(void 0,B=>{if(!(0,k.isPromiseCanceledError)(B))return T.$setError(R,B),Promise.reject(B)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,c=F.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,T.$input(s,typeof this._validateInput=="function",c).then(void 0,m=>{if(!(0,k.isPromiseCanceledError)(m))return Promise.reject(m)})}$validateInput(s){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,c=F.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!m)return;const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(E=>E.uri.toString()===m.uri.toString())}createQuickPick(s,c){const m=new r(s,c,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(s){const c=new t(s,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(s,c){const m=this._sessions.get(s);m&&m._fireDidChangeValue(c)}$onDidAccept(s){const c=this._sessions.get(s);c&&c._fireDidAccept()}$onDidChangeActive(s,c){const m=this._sessions.get(s);m instanceof r&&m._fireDidChangeActive(c)}$onDidChangeSelection(s,c){const m=this._sessions.get(s);m instanceof r&&m._fireDidChangeSelection(c)}$onDidTriggerButton(s,c){const m=this._sessions.get(s);m&&m._fireDidTriggerButton(c)}$onDidTriggerItemButton(s,c,m){const u=this._sessions.get(s);u instanceof r&&u._fireDidTriggerItemButton(c,m)}$onDidHide(s){const c=this._sessions.get(s);c&&c._fireDidHide()}}class l{constructor(s,c){this._extensionId=s,this._onDidDispose=c,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((c,m)=>{const u=c===y.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(u,c)}),this.update({buttons:s.map((c,m)=>({...f(c),tooltip:c.tooltip,handle:c===y.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const c=this._handlesToButtons.get(s);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,S.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),T.$dispose(this._id))}update(s){if(!this._disposed){for(const c of Object.keys(s)){const m=s[c];this._pendingUpdate[c]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){T.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}l._nextId=1;function o(d){if(d instanceof y.ThemeIcon)return{id:d.id};const s=n(d),c=v(d);return{dark:typeof s=="string"?_.URI.file(s):s,light:typeof c=="string"?_.URI.file(c):c}}function v(d){return typeof d=="object"&&"light"in d?d.light:d}function n(d){return typeof d=="object"&&"dark"in d?d.dark:d}function f(d){const s=o(d.iconPath);let c,m;return"id"in s?m=a.ThemeIcon.asClassName(s):c=s,{iconPath:c,iconClass:m}}class r extends l{constructor(s,c,m){super(s,m);this.enableProposedApi=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this._onDidTriggerItemButtonEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((c,m)=>{this._handlesToItems.set(m,c),this._itemsToHandles.set(c,m)}),this.update({items:s.map((c,m)=>({label:c.label,description:c.description,handle:m,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow,buttons:c.buttons&&this.enableProposedApi?c.buttons.map((u,E)=>({...f(u),tooltip:u.tooltip,handle:E})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(s){const c=(0,i.coalesce)(s.map(m=>this._handlesToItems.get(m)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(s){const c=(0,i.coalesce)(s.map(m=>this._handlesToItems.get(m)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}_fireDidTriggerItemButton(s,c){const m=this._handlesToItems.get(s);if(!m||!m.buttons||!m.buttons.length)return;const u=m.buttons[c];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:m})}}class t extends l{constructor(s,c){super(s,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?I.default.Error:I.default.Ignore})}}return new b(w,D)}e.createExtHostQuickOpen=p}),define(fe[251],me([0,1,2,3,60,6,15,5,18,101,13,27,35,65,16]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function w(s){if(s)return typeof s.iconPath=="string"?g.URI.file(s.iconPath):g.URI.isUri(s.iconPath)||p.ThemeIcon.isThemeIcon(s.iconPath)?s.iconPath:void 0}function D(s,c){if(!s.iconPath&&!c.iconPath)return 0;if(s.iconPath){if(!c.iconPath)return 1}else return-1;const m=typeof s.iconPath=="string"?s.iconPath:g.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id,u=typeof c.iconPath=="string"?c.iconPath:g.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,k.comparePaths)(m,u)}function T(s,c){let m=0;if(s.strikeThrough!==c.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==c.faded)return s.faded?1:-1;if(s.tooltip!==c.tooltip)return(s.tooltip||"").localeCompare(c.tooltip||"");if(m=D(s,c),m!==0)return m;if(s.light&&c.light)m=D(s.light,c.light);else{if(s.light)return 1;if(c.light)return-1}if(m!==0)return m;if(s.dark&&c.dark)m=D(s.dark,c.dark);else{if(s.dark)return 1;if(c.dark)return-1}return m}function b(s,c){if(s.command!==c.command)return s.command<c.command?-1:1;if(s.title!==c.title)return s.title<c.title?-1:1;if(s.tooltip!==c.tooltip){if(s.tooltip!==void 0&&c.tooltip!==void 0)return s.tooltip<c.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(s.arguments===c.arguments)return 0;if(s.arguments)if(c.arguments){if(s.arguments.length!==c.arguments.length)return s.arguments.length-c.arguments.length}else return 1;else return-1;for(let m=0;m<s.arguments.length;m++){const u=s.arguments[m],E=c.arguments[m];if(u!==E)return u<E?-1:1}return 0}function l(s,c){let m=(0,k.comparePaths)(s.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(m!==0)return m;if(s.command&&c.command)m=b(s.command,c.command);else{if(s.command)return 1;if(c.command)return-1}if(m!==0)return m;if(s.decorations&&c.decorations)m=T(s.decorations,c.decorations);else{if(s.decorations)return 1;if(c.decorations)return-1}return m}function o(s,c){for(let m=0;m<s.length;m++)if(s[m]!==c[m])return!1;return!0}function v(s,c){return s.command===c.command&&s.title===c.title&&s.tooltip===c.tooltip&&(s.arguments&&c.arguments?o(s.arguments,c.arguments):s.arguments===c.arguments)}function n(s,c){return(0,y.equals)(s,c,v)}class f{constructor(c,m,u){this._extension=c,this._proxy=m,this._sourceControlHandle=u,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,a.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(c){if((0,a.checkProposedApiEnabled)(this._extension),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}focus(){(0,a.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(c,m){(0,a.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,c,m)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=f;class r{constructor(c,m,u,E,R){this._proxy=c,this._commands=m,this._sourceControlHandle=u,this._id=E,this._label=R,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,m){const u=this._resourceStatesCommandsMap.get(c);return u?(0,P.asPromise)(()=>this._commands.executeCommand(u.command,...u.arguments||[],m)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this._resourceStates].sort(l),u=(0,y.sortedDiff)(this._resourceSnapshot,c,l).map(L=>{const M=L.toInsert.map(A=>{const B=this._resourceHandlePool++;this._resourceStatesMap.set(B,A);const V=A.resourceUri;let N;if(A.command)if(A.command.command==="vscode.open"||A.command.command==="vscode.diff"){const de=new S.DisposableStore;N=this._commands.converter.toInternal(A.command,de),this._resourceStatesDisposablesMap.set(B,de)}else this._resourceStatesCommandsMap.set(B,A.command);const j=w(A.decorations),U=A.decorations&&w(A.decorations.light)||j,x=A.decorations&&w(A.decorations.dark)||j,z=[U,x],O=A.decorations&&A.decorations.tooltip||"",W=A.decorations&&!!A.decorations.strikeThrough,$=A.decorations&&!!A.decorations.faded,X=A.contextValue||"";return{rawResource:[B,V,z,O,W,$,X,N],handle:B}});return{start:L.start,deleteCount:L.deleteCount,toInsert:M}}),E=u.map(({start:L,deleteCount:M,toInsert:A})=>[L,M,A.map(B=>B.rawResource)]),R=u.reverse();for(const{start:L,deleteCount:M,toInsert:A}of R){const B=A.map(N=>N.handle),V=this._handlesSnapshot.splice(L,M,...B);for(const N of V)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=c,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class t{constructor(c,m,u,E,R,L){this._extension=c,this._proxy=m,this._commands=u,this._id=E,this._label=R,this._rootUri=L,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new S.MutableDisposable,this._statusBarDisposables=new S.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new f(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,R,L)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new S.DisposableStore,this._acceptInputCommand=c;const m=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:m})}get actionButton(){return(0,a.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(c){(0,a.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new S.DisposableStore,this._actionButton=c;const m=c!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:m??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&n(this._statusBarCommands,c))return;this._statusBarDisposables.value=new S.DisposableStore,this._statusBarCommands=c;const m=(c||[]).map(u=>this._commands.converter.toInternal(u,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:m})}get selected(){return this._selected}createResourceGroup(c,m){const u=new r(this._proxy,this._commands,this.handle,c,m),E=F.Event.once(u.onDidDispose)(()=>this.createdResourceGroups.delete(u));return this.createdResourceGroups.set(u,E),this.eventuallyAddResourceGroups(),u}eventuallyAddResourceGroups(){const c=[],m=[];for(const[u,E]of this.createdResourceGroups){E.dispose();const R=u.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(u),this.eventuallyUpdateResourceStates()});F.Event.once(u.onDidDispose)(()=>{this.updatedResourceGroups.delete(u),R.dispose(),this._groups.delete(u.handle),this._proxy.$unregisterGroup(this.handle,u.handle)}),c.push([u.handle,u.id,u.label,u.features]);const L=u._takeResourceStateSnapshot();L.length>0&&m.push([u.handle,L]),this._groups.set(u.handle,u)}this._proxy.$registerGroups(this.handle,c,m),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(m=>{const u=m._takeResourceStateSnapshot();u.length!==0&&c.push([m.handle,u])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}t._handlePool=0,Ve([(0,C.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Ve([(0,C.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let d=class $n{constructor(c,m,u){this._commands=m,this.logService=u,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=c.getProxy(_.MainContext.MainThreadSCM),this._telemetry=c.getProxy(_.MainContext.MainThreadTelemetry),m.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const R=this._sourceControls.get(E.sourceControlHandle);if(!R)return E;const L=R.getResourceGroup(E.groupHandle);return L?L.getResourceState(E.handle):E}else if(E&&E.$mid===4){const R=this._sourceControls.get(E.sourceControlHandle);return R?R.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const R=this._sourceControls.get(E.handle);return R||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,m,u,E){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,m,u,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const R=$n._handlePool++,L=new t(c,this._proxy,this._commands,m,u,E);this._sourceControls.set(R,L);const M=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(c.identifier))||[];return M.push(L),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(c.identifier),M),L}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const m=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(c.identifier)),u=m&&m[m.length-1];return u&&u.inputBox}$provideOriginalResource(c,m,u){const E=g.URI.revive(m);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,E.toString());const R=this._sourceControls.get(c);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.asPromise)(()=>R.quickDiffProvider.provideOriginalResource(E,u)).then(L=>L||null)}$onInputBoxValueChange(c,m){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const u=this._sourceControls.get(c);return u&&u.inputBox.$onInputBoxValueChange(m),Promise.resolve(void 0)}$executeResourceCommand(c,m,u,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,m,u);const R=this._sourceControls.get(c);if(!R)return Promise.resolve(void 0);const L=R.getResourceGroup(m);return L?L.$executeResourceCommand(u,E):Promise.resolve(void 0)}$validateInput(c,m,u){this.logService.trace("ExtHostSCM#$validateInput",c);const E=this._sourceControls.get(c);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,P.asPromise)(()=>E.inputBox.validateInput(m,u)).then(R=>{if(!R)return Promise.resolve(void 0);const L=h.MarkdownString.fromStrict(R.message);return L?Promise.resolve([L,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this._sourceControls.get(c)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};d._handlePool=0,d=Ve([We(2,i.ILogService)],d),e.ExtHostSCM=d});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,g):C?C.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[252],me([0,1,7,5,168,6,16,12]),function(Y,e,g,F,C,S,P,_){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class i{constructor(h,w,D,T,b=g.StatusBarAlignment.Left,l){y.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new S.DisposableStore,st(this,y,h,"f"),st(this,k,w,"f"),this._entryId=i.ID_GEN++,this._extension=D,this._id=T,this._alignment=b,this._priority=this.validatePriority(l)}validatePriority(h){if(!!(0,_.isNumber)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!i.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Ne(this,k,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Ne(this,k,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ne(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let w;this._name?w=this._name:w=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let D=this._color;this._backgroundColor&&(D=i.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const T=this._tooltip?P.MarkdownString.fromStrict(this._tooltip):void 0;Ne(this,y,"f").$setEntry(this._entryId,h,w,this._text,T,this._command?.internal,D,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=i,y=new WeakMap,k=new WeakMap,i.ID_GEN=0,i.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const w={message:h};return this._messages.unshift(w),this._update(),new g.Disposable(()=>{const D=this._messages.indexOf(w);D>=0&&(this._messages.splice(D,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class a{constructor(h,w){this._proxy=h.getProxy(F.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new I(this)}createStatusBarEntry(h,w,D,T){return new i(this._proxy,this._commands,h,w,D,T)}setStatusBarMessage(h,w){const D=this._statusMessage.setMessage(h);let T;return typeof w=="number"?T=setTimeout(()=>D.dispose(),w):typeof w!="undefined"&&w.then(()=>D.dispose(),()=>D.dispose()),new g.Disposable(()=>{D.dispose(),clearTimeout(T)})}}e.ExtHostStatusBar=a}),define(fe[92],me([0,1,5,3,4]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class S{constructor(_){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=_.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(_,y){this._proxy.$registerExtensionStorageKeysToSync(_,y)}getValue(_,y,k){return this._proxy.$getValue(_,y).then(i=>i||k)}setValue(_,y,k){return this._proxy.$setValue(_,y,k)}$acceptValue(_,y,k){this._onDidChangeStorage.fire({shared:_,key:y,value:k})}}e.ExtHostStorage=S,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(fe[70],me([0,1,4,28,13,91,2]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let _=class{constructor(k,i,I){this._logService=i,this._extHostFileSystem=I,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(a=>this._value=a)}async _getWorkspaceStorageURI(k){return P.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,i=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(i),this._logService.trace("[ExtHostStorage] storage dir already exists",i),i}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",i),await this._extHostFileSystem.value.createDirectory(i),await this._extHostFileSystem.value.writeFile(P.URI.joinPath(i,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:P.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),i}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(k){if(this._value)return P.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return P.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};_=Ve([We(0,F.IExtHostInitDataService),We(1,C.ILogService),We(2,S.IExtHostConsumerFileSystem)],_),e.ExtensionStoragePaths=_}),define(fe[33],me([0,1,3,5,4,2,14,6,7,169,17,216,21,32,197,65,12,15]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class b{constructor(s,c,m,u){this._proxy=s,this._id=c,this._creationOptions=m,this._name=u,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(R,L=!0){E._checkDisposed(),E._proxy.$sendText(E._id,R,L)},show(R){E._checkDisposed(),E._proxy.$show(E._id,R)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(s,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:(0,D.withNullAsUndefined)(s.shellPath),shellArgs:(0,D.withNullAsUndefined)(s.shellArgs),cwd:(0,D.withNullAsUndefined)(s.cwd),env:(0,D.withNullAsUndefined)(s.env),icon:(0,D.withNullAsUndefined)(r(s.iconPath)),color:w.ThemeColor.isThemeColor(s.color)?s.color.id:void 0,initialText:(0,D.withNullAsUndefined)(s.message),strictEnv:(0,D.withNullAsUndefined)(s.strictEnv),hideFromUser:(0,D.withNullAsUndefined)(s.hideFromUser),isFeatureTerminal:(0,D.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,D.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(s.location,c?.resolvedExtHostIdentifier)})}async createExtensionTerminal(s,c,m,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:w.ThemeColor.isThemeColor(u)?u.id:void 0,location:this._serializeParentTerminal(s,c)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(s,c){return typeof s=="object"?"parentTerminal"in s&&s.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in s?{viewColumn:s.viewColumn,preserveFocus:s.preserveFocus}:void 0:s}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitCode(s){this._exitStatus=Object.freeze({code:s})}setDimensions(s,c){return s===this._cols&&c===this._rows||s===0||c===0?!1:(this._cols=s,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=b;class l{constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new g.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(s){return Promise.resolve("")}async updateProperty(s,c){Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput&&this._pty.handleInput(s)}resize(s,c){this._pty.setDimensions&&this._pty.setDimensions({columns:s,rows:c})}async processBinary(s){}acknowledgeDataEvent(s){}async setUnicodeVersion(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose&&this._pty.onDidClose((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(c=>this._onProcessOverrideDimensions.fire(c&&{cols:c.columns,rows:c.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(c=>this._onProcessTitleChanged.fire(c)),this._pty.open(s||void 0),this._pty.setDimensions&&s&&this._pty.setDimensions(s),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=l;let o=1,v=class extends _.Disposable{constructor(s,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new g.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new g.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new g.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new g.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new h.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[m,u]of this._terminalProcesses)u.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(s,c){const m=new b(this._proxy,(0,p.generateUuid)(),s,s.name),u=new l(s.pty);return m.createExtensionTerminal(s.location,this._serializeParentTerminal(s,c).resolvedExtHostIdentifier,r(s.iconPath),t(s.color)).then(E=>{const R=this._setupExtHostProcessListeners(E,u);this._terminalProcessDisposables[E]=R}),this._terminals.push(m),m.value}_serializeParentTerminal(s,c){if(c=c||{},s.location&&typeof s.location=="object"&&"parentTerminal"in s.location){const m=s.location.parentTerminal;if(m){const u=this._terminals.find(E=>E.value===m);u&&(c.resolvedExtHostIdentifier=u._id)}}else s.location&&typeof s.location!="object"?c.location=s.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(s,c){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const u=new l(c),E=this._setupExtHostProcessListeners(s,u);this._terminalProcessDisposables[s]=E}async $acceptActiveTerminalChanged(s){const c=this._activeTerminal;if(s===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(s);m&&(this._activeTerminal=m,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,c){const m=this._getTerminalById(s);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:c})}async $acceptTerminalDimensions(s,c,m){const u=this._getTerminalById(s);u&&u.setDimensions(c,m)&&this._onDidChangeTerminalDimensions.fire({terminal:u.value,dimensions:u.value.dimensions})}async $acceptTerminalMaximumDimensions(s,c,m){this._terminalProcesses.get(s)?.resize(c,m)}async $acceptTerminalTitleChange(s,c){const m=this._getTerminalById(s);m&&(m.name=c)}async $acceptTerminalClosed(s,c){const m=this._getTerminalObjectIndexById(this._terminals,s);if(m!==null){const u=this._terminals.splice(m,1)[0];u.setExitCode(c),this._onDidCloseTerminal.fire(u.value)}}$acceptTerminalOpened(s,c,m,u){if(c){const L=this._getTerminalObjectIndexById(this._terminals,c);if(L!==null){this._terminals[L]._id=s,this._onDidOpenTerminal.fire(this.terminals[L]),this._terminals[L].isOpen=!0;return}}const E={name:u.name,shellPath:u.executable,shellArgs:u.args,cwd:typeof u.cwd=="string"?u.cwd:S.URI.revive(u.cwd),env:u.env,hideFromUser:u.hideFromUser},R=new b(this._proxy,s,E,m);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(s,c){const m=this._getTerminalById(s);m&&m._setProcessId(c)}async $startExtensionTerminal(s,c){const m=this._getTerminalById(s);if(!m)return{message:(0,k.localize)(0,null,s)};m.isOpen||await new Promise(E=>{const R=this.onDidOpenTerminal(async L=>{L===m.value&&(R.dispose(),E())})});const u=this._terminalProcesses.get(s);u?u.startSendingEvents(c):this._extensionTerminalAwaitingStart[s]={initialDimensions:c}}_setupExtHostProcessListeners(s,c){const m=new _.DisposableStore;m.add(c.onProcessReady(E=>this._proxy.$sendProcessReady(s,E.pid,E.cwd))),m.add(c.onProcessTitleChanged(E=>this._proxy.$sendProcessTitle(s,E))),this._bufferer.startBuffering(s,c.onProcessData),m.add(c.onProcessExit(E=>this._onProcessExit(s,E))),c.onProcessOverrideDimensions&&m.add(c.onProcessOverrideDimensions(E=>this._proxy.$sendOverrideDimensions(s,E))),this._terminalProcesses.set(s,c);const u=this._extensionTerminalAwaitingStart[s];return u&&c instanceof l&&(c.startSendingEvents(u.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),m}$acceptProcessAckDataEvent(s,c){this._terminalProcesses.get(s)?.acknowledgeDataEvent(c)}$acceptProcessInput(s,c){this._terminalProcesses.get(s)?.input(c)}$acceptTerminalInteraction(s){const c=this._getTerminalById(s);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(s,c,m){try{this._terminalProcesses.get(s)?.resize(c,m)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(s,c){this._terminalProcesses.get(s)?.shutdown(c)}$acceptProcessRequestInitialCwd(s){this._terminalProcesses.get(s)?.getInitialCwd().then(c=>this._proxy.$sendProcessInitialCwd(s,c))}$acceptProcessRequestCwd(s){this._terminalProcesses.get(s)?.getCwd().then(c=>this._proxy.$sendProcessCwd(s,c))}$acceptProcessRequestLatency(s){return s}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,c,m){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,m),this._proxy.$registerProfileProvider(c,s.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(s,c){const m=new a.CancellationTokenSource().token,u=await this._profileProviders.get(s)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(!u||!("options"in u))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in u.options){this.createExtensionTerminal(u.options,c);return}this.createTerminalFromOptions(u.options,c)}}async $provideLinks(s,c){const m=this._getTerminalById(s);if(!m)return[];this._terminalLinkCache.delete(s);const u=this._terminalLinkCancellationSource.get(s);u&&u.dispose(!0);const E=new a.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,E);const R=[],L={terminal:m.value,line:c},M=[];for(const V of this._linkProviders)M.push(T.Promises.withAsyncBody(async N=>{E.token.onCancellationRequested(()=>N({provider:V,links:[]}));const j=await V.provideTerminalLinks(L,E.token)||[];E.token.isCancellationRequested||N({provider:V,links:j})}));const A=await Promise.all(M);if(E.token.isCancellationRequested)return[];const B=new Map;for(const V of A)V&&V.links.length>0&&R.push(...V.links.map(N=>{const j={id:o++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return B.set(j.id,{provider:V.provider,link:N}),j}));return this._terminalLinkCache.set(s,B),R}$activateLink(s,c){const m=this._terminalLinkCache.get(s)?.get(c);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(s,c){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const m=this._terminalProcessDisposables[s];m&&(m.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,c)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,c){const m=this._getTerminalObjectIndexById(s,c);return m!==null?s[m]:null}_getTerminalObjectIndexById(s,c){let m=null;return s.some((u,E)=>u._id===c?(m=E,!0):!1),m}getEnvironmentVariableCollection(s){let c=this._environmentVariableCollections.get(s.identifier.value);return c||(c=new n,this._setEnvironmentVariableCollection(s.identifier.value,c)),c}_syncEnvironmentVariableCollection(s,c){const m=(0,I.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(s,c.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(s){s.forEach(c=>{const m=c[0],u=new n(c[1]);this._setEnvironmentVariableCollection(m,u)})}$acceptDefaultProfile(s,c){this._defaultProfile=s,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(s,c){this._environmentVariableCollections.set(s,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,c)})}};v=Ve([We(1,P.IExtHostRpcService)],v),e.BaseExtHostTerminalService=v;class n{constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(s)}get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(s,c){this._setIfDiffers(s,{value:c,type:y.EnvironmentVariableMutatorType.Replace})}append(s,c){this._setIfDiffers(s,{value:c,type:y.EnvironmentVariableMutatorType.Append})}prepend(s,c){this._setIfDiffers(s,{value:c,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,c){const m=this.map.get(s);(!m||m.value!==c.value||m.type!==c.type)&&(this.map.set(s,c),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,c){this.map.forEach((m,u)=>s.call(c,u,m,this))}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=n;let f=class extends v{constructor(s){super(!1,s)}createTerminal(s,c,m){throw new i.NotSupportedError}createTerminalFromOptions(s,c){throw new i.NotSupportedError}};f=Ve([We(0,P.IExtHostRpcService)],f),e.WorkerExtHostTerminalService=f;function r(d){if(!(!d||typeof d=="string"))return"id"in d?{id:d.id,color:d.color}:d}function t(d){return w.ThemeColor.isThemeColor(d)?d:void 0}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,g):C?C.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[253],me([0,1,18,22,21,3,76,48,6,25,12,32,5,14,66,16,7,224,129,89]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T,b,l){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let v=class{constructor(L,M){this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(a.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new f(this.proxy),M.registerArgumentProcessor({processArgument:A=>A?.$mid===13?w.TestItem.toItemFromContext(A):A})}createTestController(L,M){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const A=new y.DisposableStore,B=A.add(new T.SingleUseTestCollection(L));B.root.label=M;const V=new Map,N=this.proxy,j={items:B.root.children,get label(){return M},set label(x){M=x,B.root.label=x,N.$updateControllerLabel(L,M)},get id(){return L},createRunProfile:(x,z,O,W,$)=>{let X=(0,_.hash)(x);for(;V.has(X);)X++;const K=new u(this.proxy,L,X,x,z,O,W,$);return V.set(X,K),K},createTestItem(x,z,O){return new h.TestItemImpl(L,x,z,O)},createTestRun:(x,z,O=!0)=>this.runTracker.createTestRun(L,B,x,z,O),set resolveHandler(x){B.resolveHandler=x},get resolveHandler(){return B.resolveHandler},dispose:()=>{A.dispose()}};j.createRunConfiguration=j.createRunProfile,N.$registerTestController(L,M),A.add((0,y.toDisposable)(()=>N.$unregisterTestController(L)));const U={controller:j,collection:B,profiles:V};return this.controllers.set(L,U),A.add((0,y.toDisposable)(()=>this.controllers.delete(L))),A.add(B.onDidGenerateDiff(x=>N.$publishDiff(L,x))),j}createTestObserver(){return this.observer.checkout()}async runTests(L,M=C.CancellationToken.None){const A=r(L);if(!A)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.controllers.get(A.controllerId);if(!B)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:L.include?.map(V=>V.id)??[B.collection.root.id],profileGroup:E[A.kind],profileId:A.profileId,controllerId:A.controllerId}],exclude:L.exclude?.map(V=>V.id)},M)}$provideFileCoverage(L,M,A){return(0,g.mapFind)(this.runTracker.trackers,V=>V.id===L?V.getCoverage(M):void 0)?.provideFileCoverage(A)??Promise.resolve([])}$resolveFileCoverage(L,M,A,B){return(0,g.mapFind)(this.runTracker.trackers,N=>N.id===L?N.getCoverage(M):void 0)?.resolveFileCoverage(A,B)??Promise.resolve([])}$configureRunProfile(L,M){this.controllers.get(L)?.profiles.get(M)?.configureHandler?.()}$publishTestResults(L){this.results=Object.freeze(L.map(M=>(0,k.deepFreeze)(w.TestResults.to(M))).concat(this.results).sort((M,A)=>A.completedAt-M.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,M){const A=this.controllers.get(l.TestId.fromString(L).controllerId)?.collection;A&&(await A.expand(L,M<0?Infinity:M),A.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L)}async $runControllerTests(L,M){const A=this.controllers.get(L.controllerId);if(!A)return;const{collection:B,profiles:V}=A,N=V.get(L.profileId);if(!N)return;const j=L.testIds.map(O=>B.tree.get(O)).filter(i.isDefined),U=L.excludeExtIds.map(O=>A.collection.tree.get(O)).filter(i.isDefined).filter(O=>j.some(W=>W.fullId.compare(O.fullId)===2));if(!j.length)return;const x=new D.TestRunRequest(j.some(O=>O.actual instanceof h.TestItemRootImpl)?void 0:j.map(O=>O.actual),U.map(O=>O.actual),N),z=this.runTracker.prepareForMainThreadTestRun(x,t.fromInternal(L,A.collection),M);try{await N.runHandler(x,M)}finally{z.isRunning&&!M.isCancellationRequested&&await S.Event.toPromise(z.onEnd),z.dispose()}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};v=Ve([We(0,p.IExtHostRpcService)],v),e.ExtHostTesting=v;class n extends y.Disposable{constructor(L,M,A){super();this.dto=L,this.proxy=M,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new S.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new C.CancellationTokenSource(A)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:B}of this.tasks.values())B.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const M=this.dto.id,A=this.dto.controllerId,B=(0,I.generateUuid)(),V=new d(this.proxy,M,B),N=z=>(O,...W)=>{if(U){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),z(O,...W))},j=(z,O)=>{const W=O instanceof Array?O.map(w.TestMessage.from):[w.TestMessage.from(O)];if(z.uri&&z.range){const $={range:w.Range.from(z.range),uri:z.uri};for(const X of W)X.location=X.location||$}this.proxy.$appendTestMessagesInRun(M,B,l.TestId.fromExtHostTestItem(z,A).toString(),W)};let U=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return V.coverageProvider},set coverageProvider(z){V.coverageProvider=z},enqueued:N(z=>{this.proxy.$updateTestStateInRun(M,B,l.TestId.fromExtHostTestItem(z,A).toString(),1)}),skipped:N(z=>{this.proxy.$updateTestStateInRun(M,B,l.TestId.fromExtHostTestItem(z,A).toString(),5)}),started:N(z=>{this.proxy.$updateTestStateInRun(M,B,l.TestId.fromExtHostTestItem(z,A).toString(),2)}),errored:N((z,O,W)=>{j(z,O),this.proxy.$updateTestStateInRun(M,B,l.TestId.fromExtHostTestItem(z,A).toString(),6,W)}),failed:N((z,O,W)=>{j(z,O),this.proxy.$updateTestStateInRun(M,B,l.TestId.fromExtHostTestItem(z,A).toString(),4,W)}),passed:N((z,O)=>{this.proxy.$updateTestStateInRun(M,B,l.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,O)}),appendOutput:(z,O,W)=>{U||(W&&(this.dto.isIncluded(W)?this.ensureTestIsKnown(W):W=void 0),this.proxy.$appendOutputToRun(M,B,F.VSBuffer.fromString(z),O&&w.location.from(O),W&&l.TestId.fromExtHostTestItem(W,A).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(M,B),this.tasks.delete(B),this.isRunning||this.dispose())}};return this.tasks.set(B,{run:x,coverage:V}),this.proxy.$startedTestRunTask(M,{id:B,name:L,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(L){if(!(L instanceof h.TestItemImpl))throw new h.InvalidTestItemError(L.id);if(this.sharedTestIds.has(l.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const M=[],A=this.dto.colllection.root;for(;;){const B=w.TestItem.from(L);if(M.unshift(B),this.sharedTestIds.has(B.extId)||(this.sharedTestIds.add(B.extId),L===A))break;L=L.parent||A}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,M)}}class f{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,M,A){return this.getTracker(L,M,A)}cancelRunById(L){for(const M of this.tracked.values())if(M.id===L){M.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,M,A,B,V){const N=this.tracked.get(A);if(N)return N.createRun(B);const j=t.fromPublic(L,M,A,V),U=r(A);this.proxy.$startedExtensionTestRun({controllerId:L,profile:U&&{group:E[U.kind],id:U.profileId},exclude:A.exclude?.map(z=>z.id)??[],id:j.id,include:A.include?.map(z=>z.id)??[M.root.id],persist:V});const x=this.getTracker(A,j);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(j.id)),x.createRun(B)}getTracker(L,M,A){const B=new n(M,this.proxy,A);return this.tracked.set(L,B),B.onEnd(()=>this.tracked.delete(L)),B}}e.TestRunCoordinator=f;const r=R=>{if(!!R.profile){if(!(R.profile instanceof u))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class t{constructor(L,M,A,B,V,N){this.controllerId=L,this.id=M,this.isPersisted=V,this.colllection=N,this.includePrefix=A.map(j=>j+"\0"),this.excludePrefix=B.map(j=>j+"\0")}static fromPublic(L,M,A,B){return new t(L,(0,I.generateUuid)(),A.include?.map(V=>l.TestId.fromExtHostTestItem(V,L).toString())??[L],A.exclude?.map(V=>l.TestId.fromExtHostTestItem(V,L).toString())??[],B,M)}static fromInternal(L,M){return new t(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,M)}isIncluded(L){const M=l.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const A of this.excludePrefix)if(M===A||M.startsWith(A))return!1;for(const A of this.includePrefix)if(M===A||M.startsWith(A))return!0;return!1}}e.TestRunDto=t;class d{constructor(L,M,A){this.proxy=L,this.runId=M,this.taskId=A}set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch(M){throw this.fileCoverage=void 0,M}}async resolveFileCoverage(L,M){const A=await this.fileCoverage;let B=A?.[L];return!this._coverageProvider||!A||!B?[]:(B.detailedCoverage||(B=A[L]=await this._coverageProvider.resolveFileCoverage?.(B,M)??B),B.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class s extends b.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,w.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:M,removed:A}=this;return{get added(){return[...L].map(B=>B.revived)},get updated(){return[...M].map(B=>B.revived)},get removed(){return[...A].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,M){return{...L,revived:w.TestItem.toPlain(L.item),depth:M?M.depth+1:0,children:new Set}}createChangeCollector(){return new s(this.changeEmitter)}}e.MirroredTestCollection=c;class m{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(M=>M.revived)},dispose:(0,P.once)(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class u{constructor(L,M,A,B,V,N,j=!1,U=void 0){this.controllerId=M,this.profileId=A,this._label=B,this.kind=V,this.runHandler=N,this._isDefault=j,this._tag=U,o.set(this,void 0),st(this,o,L,"f");const x=E[V];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${V}`);Ne(this,o,"f").$publishTestRunProfile({profileId:A,controllerId:M,tag:U?w.TestTag.namespace(this.controllerId,U.id):null,label:B,group:x,isDefault:j,hasConfigurationHandler:!1})}get label(){return this._label}set label(L){L!==this._label&&(this._label=L,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?w.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}dispose(){Ne(this,o,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=u,o=new WeakMap;const E={[D.TestRunProfileKind.Coverage]:8,[D.TestRunProfileKind.Debug]:4,[D.TestRunProfileKind.Run]:2}}),define(fe[254],me([0,1,3,18,5,132,16,7]),function(Y,e,g,F,C,S,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(a=>this._onDidChangeVisibleTextEditors.fire(a)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(a=>this._onDidChangeActiveTextEditor.fire(a))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(a=>a.value)}async showTextDocument(i,I,a){let p;typeof I=="number"?p={position:P.ViewColumn.from(I),preserveFocus:a}:typeof I=="object"?p={position:P.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?P.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:p={preserveFocus:!1};const h=await this._proxy.$tryShowTextDocument(i.uri,p),w=h&&this._extHostDocumentsAndEditors.getEditor(h);if(w)return w.value;throw h?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,I){return new S.TextEditorDecorationType(this._proxy,i,I).value}$acceptEditorPropertiesChanged(i,I){const a=this._extHostDocumentsAndEditors.getEditor(i);if(!a)throw new Error("unknown text editor");if(I.options&&a._acceptOptions(I.options),I.selections){const p=I.selections.selections.map(P.Selection.to);a._acceptSelections(p)}if(I.visibleRanges){const p=F.coalesce(I.visibleRanges.map(P.Range.to));a._acceptVisibleRanges(p)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:a.value,options:{...I.options,lineNumbers:P.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const p=_.TextEditorSelectionChangeKind.fromValue(I.selections.source),h=I.selections.selections.map(P.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:a.value,selections:h,kind:p})}if(I.visibleRanges){const p=F.coalesce(I.visibleRanges.map(P.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:a.value,visibleRanges:p})}}$acceptEditorPositionData(i){for(const I in i){const a=this._extHostDocumentsAndEditors.getEditor(I);if(!a)throw new Error("Unknown text editor");const p=P.ViewColumn.to(i[I]);a.value.viewColumn!==p&&(a._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:a.value,viewColumn:p}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=y}),define(fe[255],me([0,1,2,4,5,6,7]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class _{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(C.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===11){const p=a.uri===void 0?void 0:g.URI.revive(a.uri);return this._itemsBySourceAndUriMap.get(a.source)?.get(y(p))?.get(a.handle)}return a}})}async $getTimeline(i,I,a,p,h){return this._providers.get(i)?.provideTimeline(g.URI.revive(I),a,p,h)}registerTimelineProvider(i,I,a,p){const h=new S.DisposableStore,w=this.convertTimelineItem(I.id,p,h).bind(this);let D;I.onDidChange&&(D=I.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:I.id}),this));const T=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:i,onDidChange:void 0,async provideTimeline(b,l,o,v){v?.resetCache&&(h.clear(),T.get(I.id)?.clear());const n=await I.provideTimeline(b,l,o);if(n==null)return;const f=w(b,v);return{...n,source:I.id,items:n.items.map(f)}},dispose(){for(const b of T.values())b.get(I.id)?.clear();D?.dispose(),h.dispose()}})}convertTimelineItem(i,I,a){return(p,h)=>{let w;if(h?.cacheResults){let D=this._itemsBySourceAndUriMap.get(i);D===void 0&&(D=new Map,this._itemsBySourceAndUriMap.set(i,D));const T=y(p);w=D.get(T),w===void 0&&(w=new Map,D.set(T,w))}return D=>{const{iconPath:T,...b}=D,l=`${i}|${D.id??D.timestamp}`;w?.set(l,D);let o,v,n;return D.iconPath&&(T instanceof P.ThemeIcon?n={id:T.id,color:T.color}:g.URI.isUri(T)?(o=T,v=T):{light:o,dark:v}=T),{...b,id:b.id??void 0,handle:l,source:i,command:D.command?I.toInternal(D.command,a):void 0,icon:o,iconDark:v,themeIcon:n,accessibilityInformation:D.accessibilityInformation}}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,S.toDisposable)(()=>{for(const a of this._itemsBySourceAndUriMap.values())a.get(i.id)?.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=_;function y(k){return k?.toString()}}),define(fe[256],me([0,1,6,10,2,5]),function(Y,e,g,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class P{constructor(y){this._openers=new Map,this._proxy=y.getProxy(S.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,k,i,I){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const a=I.schemes.find(p=>!P.supportedSchemes.has(p));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,i),this._proxy.$registerUriOpener(k,I.schemes,y,I.label),(0,g.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(y,k,i){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener with id: ${y}`);const a=C.URI.revive(k);return I.canOpenExternalUri(a,i)}async $openUri(y,k,i){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener id: '${y}'`);return I.openExternalUri(C.URI.revive(k.resolvedUri),{sourceUri:C.URI.revive(k.sourceUri)},i)}}e.ExtHostUriOpeners=P,P.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(fe[257],me([0,1,5,2,6,17,27]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class _{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(k,i){if(this.handles.has(P.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const I=_.HandlePool++;return this.handles.add(P.ExtensionIdentifier.toKey(k)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,k),(0,C.toDisposable)(()=>{this.handles.delete(P.ExtensionIdentifier.toKey(k)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(k,i){const I=this.handlers.get(k);if(!I)return Promise.resolve(void 0);try{I.handleUri(F.URI.revive(i))}catch(a){(0,S.onUnexpectedError)(a)}return Promise.resolve(void 0)}async createAppUri(k){return F.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=_,_.HandlePool=0});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,g):C?C.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[71],me([0,1,3,10,2,182,206,88,5]),function(Y,e,g,F,C,S,P,_,y){"use strict";var k,i,I,a,p,h,w,D,T,b,l,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class v{constructor(m,u,E,R,L,M,A){k.set(this,void 0),i.set(this,void 0),I.set(this,void 0),a.set(this,void 0),p.set(this,void 0),h.set(this,void 0),w.set(this,""),D.set(this,void 0),T.set(this,!1),b.set(this,!1),l.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new g.Emitter),this._onDidDispose=Ne(this,o,"f").event,st(this,k,m,"f"),st(this,i,u,"f"),st(this,D,E,"f"),st(this,a,R,"f"),st(this,p,L,"f"),st(this,h,M,"f"),st(this,l,n(M),"f"),st(this,I,A,"f")}dispose(){st(this,T,!0,"f"),Ne(this,o,"f").fire(),Ne(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return st(this,b,!0,"f"),(0,_.asWebviewUri)(m,Ne(this,a,"f").remote)}get cspSource(){const m=Ne(this,h,"f").extensionLocation;if(m.scheme===F.Schemas.https||m.scheme===F.Schemas.http){let u=m.toString();return u.endsWith("/")||(u+="/"),u+" "+_.webviewGenericCspSource}return _.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ne(this,w,"f")}set html(m){this.assertNotDisposed(),Ne(this,w,"f")!==m&&(st(this,w,m,"f"),!Ne(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(st(this,b,!0,"f"),Ne(this,I,"f").report("Webview vscode-resource: uris",Ne(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,i,"f").$setHtml(Ne(this,k,"f"),m))}get options(){return this.assertNotDisposed(),Ne(this,D,"f")}set options(m){this.assertNotDisposed(),Ne(this,i,"f").$setOptions(Ne(this,k,"f"),t(Ne(this,h,"f"),Ne(this,p,"f"),m)),st(this,D,m,"f")}async postMessage(m){if(Ne(this,T,"f"))return!1;const u=(0,P.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Ne(this,l,"f")});return Ne(this,i,"f").$postMessage(Ne(this,k,"f"),u.message,...u.buffers)}assertNotDisposed(){if(Ne(this,T,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=v,k=new WeakMap,i=new WeakMap,I=new WeakMap,a=new WeakMap,p=new WeakMap,h=new WeakMap,w=new WeakMap,D=new WeakMap,T=new WeakMap,b=new WeakMap,l=new WeakMap,o=new WeakMap;function n(c){try{const m=(0,S.normalizeVersion)((0,S.parseVersion)(c.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;class f{constructor(m,u,E,R,L){this.initData=u,this.workspace=E,this._logService=R,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=m.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(m,u,...E){const R=this.getWebview(m);if(R){const{message:L}=(0,P.deserializeWebviewMessage)(u,E);R._onMessageEmitter.fire(L)}}$onMissingCsp(m,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,u,E){const R=new v(m,this._webviewProxy,d(u),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(m,R),R._onDidDispose(()=>{this._webviews.delete(m)}),R}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=f;function r(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=r;function t(c,m,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||s(c,m)}}e.serializeWebviewOptions=t;function d(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(m=>C.URI.from(m))}}e.reviveOptions=d;function s(c,m){return[...(m?.getWorkspaceFolders()||[]).map(u=>u.uri),c.extensionLocation]}}),define(fe[258],me([0,1,21,48,6,10,23,2,16,71,87,5,7]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(n,f){this.document=n,this._storagePath=f,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,f){await this.getEdit(n).undo(),f||this.disposeBackup()}async redo(n,f){await this.getEdit(n).redo(),f||this.disposeBackup()}disposeEdits(n){for(const f of n)this._edits.delete(f)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=o(this.document.uri)+this._backupCounter++;return(0,P.joinPath)(this._storagePath,n)}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(n){const f=this._edits.get(n,0);if(!f)throw new Error("No edit found");return f}}class h{constructor(){this._documents=new Map}get(n,f){return this._documents.get(this.key(n,f))}add(n,f,r){const t=this.key(n,f.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${n} resource:${f.uri}`);const d=new p(f,r);return this._documents.set(t,d),d}delete(n,f){const r=this.key(n,f.uri);this._documents.delete(r)}key(n,f){return`${n}@@@${f}`}}var w;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(w||(w={}));class D{constructor(){this._providers=new Map}addTextProvider(n,f,r){return this.add(0,n,f,r)}addCustomProvider(n,f,r){return this.add(1,n,f,r)}get(n){return this._providers.get(n)}add(n,f,r,t){if(this._providers.has(f))throw new Error(`Provider for viewType:${f} already registered`);return this._providers.set(f,{type:n,extension:r,provider:t}),new a.Disposable(()=>this._providers.delete(f))}}class T{constructor(n,f,r,t,d){this._extHostDocuments=f,this._extensionStoragePaths=r,this._extHostWebview=t,this._extHostWebviewPanels=d,this._editorProviders=new D,this._documents=new h,this._proxy=n.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,f,r,t){const d=new C.DisposableStore;return b(r)?(d.add(this._editorProviders.addTextProvider(f,n,r)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(n),f,t.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(n))):(d.add(this._editorProviders.addCustomProvider(f,n,r)),this.supportEditing(r)&&d.add(r.onDidChangeCustomDocument(s=>{const c=this.getCustomDocumentEntry(f,s.document.uri);if(l(s)){const m=c.addEdit(s);this._proxy.$onDidEdit(s.document.uri,f,m,s.label)}else this._proxy.$onContentChange(s.document.uri,f)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(n),f,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(n))),a.Disposable.from(d,new a.Disposable(()=>{this._proxy.$unregisterEditorProvider(f)}))}async $createCustomDocument(n,f,r,t,d){const s=this._editorProviders.get(f);if(!s)throw new Error(`No provider found for '${f}'`);if(s.type!==1)throw new Error(`Invalid provide type for '${f}'`);const c=_.URI.revive(n),m=await s.provider.openCustomDocument(c,{backupId:r,untitledDocumentData:t?.buffer},d);let u;return this.supportEditing(s.provider)&&this._extensionStoragePaths&&(u=this._extensionStoragePaths.workspaceValue(s.extension)??this._extensionStoragePaths.globalValue(s.extension)),this._documents.add(f,m,u),{editable:this.supportEditing(s.provider)}}async $disposeCustomDocument(n,f){const r=this._editorProviders.get(f);if(!r)throw new Error(`No provider found for '${f}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${f}'`);const t=_.URI.revive(n),{document:d}=this.getCustomDocumentEntry(f,t);this._documents.delete(f,d),d.dispose()}async $resolveWebviewEditor(n,f,r,t,d,s){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);const m=y.ViewColumn.to(d),u=this._extHostWebview.createNewWebview(f,t.webviewOptions,c.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(f,r,t.title,m,t.panelOptions,u),R=_.URI.revive(n);switch(c.type){case 1:{const{document:L}=this.getCustomDocumentEntry(r,R);return c.provider.resolveCustomEditor(L,E,s)}case 0:{const L=this._extHostDocuments.getDocument(R);return c.provider.resolveCustomTextEditor(L,E,s)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,f,r){this.getCustomDocumentEntry(f,n).disposeEdits(r)}async $onMoveCustomEditor(n,f,r){const t=this._editorProviders.get(r);if(!t)throw new Error(`No provider found for '${r}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const d=this._extHostWebviewPanels.getWebviewPanel(n);if(!d)throw new Error("No webview found");const s=_.URI.revive(f),c=this._extHostDocuments.getDocument(s);await t.provider.moveCustomTextEditor(c,d,g.CancellationToken.None)}async $undo(n,f,r,t){return this.getCustomDocumentEntry(f,n).undo(r,t)}async $redo(n,f,r,t){return this.getCustomDocumentEntry(f,n).redo(r,t)}async $revert(n,f,r){const t=this.getCustomDocumentEntry(f,n);await this.getCustomEditorProvider(f).revertCustomDocument(t.document,r),t.disposeBackup()}async $onSave(n,f,r){const t=this.getCustomDocumentEntry(f,n);await this.getCustomEditorProvider(f).saveCustomDocument(t.document,r),t.disposeBackup()}async $onSaveAs(n,f,r,t){const d=this.getCustomDocumentEntry(f,n);return this.getCustomEditorProvider(f).saveCustomDocumentAs(d.document,_.URI.revive(r),t)}async $backup(n,f,r){const t=this.getCustomDocumentEntry(f,n),s=await this.getCustomEditorProvider(f).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},r);return t.updateBackup(s),s.id}getCustomDocumentEntry(n,f){const r=this._documents.get(n,_.URI.revive(f));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(n){const r=this._editorProviders.get(n)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(n){return!!n.onDidChangeCustomDocument}}e.ExtHostCustomEditors=T;function b(v){return typeof v.resolveCustomTextEditor=="function"}function l(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function o(v){const n=v.scheme===S.Schemas.file||v.scheme===S.Schemas.untitled?v.fsPath:v.toString();return(0,F.hash)(n)+""}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,g):C?C.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[259],me([0,1,3,6,2,32,16,71,5,7]),function(Y,e,g,F,C,S,P,_,y,k){"use strict";var i,I,a,p,h,w,D,T,b,l,o,v,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class f extends F.Disposable{constructor(s,c,m,u,E,R,L){super();i.set(this,void 0),I.set(this,void 0),a.set(this,void 0),p.set(this,void 0),h.set(this,void 0),w.set(this,void 0),D.set(this,void 0),T.set(this,void 0),b.set(this,!0),l.set(this,!0),o.set(this,!1),v.set(this,this._register(new g.Emitter)),this.onDidDispose=Ne(this,v,"f").event,n.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Ne(this,n,"f").event,st(this,i,s,"f"),st(this,I,c,"f"),st(this,a,m,"f"),st(this,h,R,"f"),st(this,T,E,"f"),st(this,w,u,"f"),st(this,p,L,"f")}dispose(){Ne(this,o,"f")||(st(this,o,!0,"f"),Ne(this,v,"f").fire(),Ne(this,I,"f").$disposeWebview(Ne(this,i,"f")),Ne(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ne(this,p,"f")}get viewType(){return this.assertNotDisposed(),Ne(this,a,"f")}get title(){return this.assertNotDisposed(),Ne(this,w,"f")}set title(s){this.assertNotDisposed(),Ne(this,w,"f")!==s&&(st(this,w,s,"f"),Ne(this,I,"f").$setTitle(Ne(this,i,"f"),s))}get iconPath(){return this.assertNotDisposed(),Ne(this,D,"f")}set iconPath(s){this.assertNotDisposed(),Ne(this,D,"f")!==s&&(st(this,D,s,"f"),Ne(this,I,"f").$setIconPath(Ne(this,i,"f"),C.URI.isUri(s)?{light:s,dark:s}:s))}get options(){return Ne(this,h,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ne(this,T,"f")=="number"&&Ne(this,T,"f")<0))return Ne(this,T,"f")}get active(){return this.assertNotDisposed(),Ne(this,l,"f")}get visible(){return this.assertNotDisposed(),Ne(this,b,"f")}_updateViewState(s){Ne(this,o,"f")||(this.active!==s.active||this.visible!==s.visible||this.viewColumn!==s.viewColumn)&&(st(this,l,s.active,"f"),st(this,b,s.visible,"f"),st(this,T,s.viewColumn,"f"),Ne(this,n,"f").fire({webviewPanel:this}))}reveal(s,c){this.assertNotDisposed(),Ne(this,I,"f").$reveal(Ne(this,i,"f"),{viewColumn:s?P.ViewColumn.from(s):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Ne(this,o,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,a=new WeakMap,p=new WeakMap,h=new WeakMap,w=new WeakMap,D=new WeakMap,T=new WeakMap,b=new WeakMap,l=new WeakMap,o=new WeakMap,v=new WeakMap,n=new WeakMap;class r{constructor(s,c,m){this.webviews=c,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=s.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,S.generateUuid)()}createWebviewPanel(s,c,m,u,E={}){const R=typeof u=="object"?u.viewColumn:u,L={viewColumn:P.ViewColumn.from(R),preserveFocus:typeof u=="object"&&!!u.preserveFocus},M=(0,_.shouldSerializeBuffersForPostMessage)(s),A=r.newHandle();this._proxy.$createWebviewPanel((0,_.toExtensionData)(s),A,c,{title:m,panelOptions:t(E),webviewOptions:(0,_.serializeWebviewOptions)(s,this.workspace,E),serializeBuffersForPostMessage:M},L);const B=this.webviews.createNewWebview(A,E,s);return this.createNewWebviewPanel(A,c,m,R,E,B)}$onDidChangeWebviewPanelViewStates(s){const c=Object.keys(s);c.sort((m,u)=>{const E=s[m],R=s[u];return E.active?1:R.active?-1:+E.visible-+R.visible});for(const m of c){const u=this.getWebviewPanel(m);if(!u)continue;const E=s[m];u._updateViewState({active:E.active,visible:E.visible,viewColumn:P.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(s){this.getWebviewPanel(s)?.dispose(),this._webviewPanels.delete(s),this.webviews.deleteWebview(s)}registerWebviewPanelSerializer(s,c,m){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:m,extension:s}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,_.shouldSerializeBuffersForPostMessage)(s)}),new k.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(s,c,m,u){const E=this._serializers.get(c);if(!E)throw new Error(`No serializer found for '${c}'`);const{serializer:R,extension:L}=E,M=this.webviews.createNewWebview(s,m.webviewOptions,L),A=this.createNewWebviewPanel(s,c,m.title,u,m.panelOptions,M);await R.deserializeWebviewPanel(A,m.state)}createNewWebviewPanel(s,c,m,u,E,R){const L=new f(s,this._proxy,c,m,u,E,R);return this._webviewPanels.set(s,L),L}getWebviewPanel(s){return this._webviewPanels.get(s)}}e.ExtHostWebviewPanels=r;function t(d){return{enableFindWidget:d.enableFindWidget,retainContextWhenHidden:d.retainContextWhenHidden}}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,g):C?C.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[260],me([0,1,3,6,71,5,7]),function(Y,e,g,F,C,S,P){"use strict";var _,y,k,i,I,a,p,h,w,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class T extends F.Disposable{constructor(o,v,n,f,r,t){super();_.set(this,void 0),y.set(this,void 0),k.set(this,void 0),i.set(this,void 0),I.set(this,!1),a.set(this,void 0),p.set(this,void 0),h.set(this,void 0),w.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Ne(this,w,"f").event,D.set(this,this._register(new g.Emitter)),this.onDidDispose=Ne(this,D,"f").event,st(this,k,n,"f"),st(this,p,f,"f"),st(this,_,o,"f"),st(this,y,v,"f"),st(this,i,r,"f"),st(this,a,t,"f")}dispose(){Ne(this,I,"f")||(st(this,I,!0,"f"),Ne(this,D,"f").fire(),Ne(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ne(this,p,"f")}set title(o){this.assertNotDisposed(),Ne(this,p,"f")!==o&&(st(this,p,o,"f"),Ne(this,y,"f").$setWebviewViewTitle(Ne(this,_,"f"),o))}get description(){return this.assertNotDisposed(),Ne(this,h,"f")}set description(o){this.assertNotDisposed(),Ne(this,h,"f")!==o&&(st(this,h,o,"f"),Ne(this,y,"f").$setWebviewViewDescription(Ne(this,_,"f"),o))}get visible(){return Ne(this,a,"f")}get webview(){return Ne(this,i,"f")}get viewType(){return Ne(this,k,"f")}_setVisible(o){o===Ne(this,a,"f")||Ne(this,I,"f")||(st(this,a,o,"f"),Ne(this,w,"f").fire())}show(o){this.assertNotDisposed(),Ne(this,y,"f").$show(Ne(this,_,"f"),!!o)}assertNotDisposed(){if(Ne(this,I,"f"))throw new Error("Webview is disposed")}}_=new WeakMap,y=new WeakMap,k=new WeakMap,i=new WeakMap,I=new WeakMap,a=new WeakMap,p=new WeakMap,h=new WeakMap,w=new WeakMap,D=new WeakMap;class b{constructor(o,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=o.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,v,n,f){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:n,extension:o}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(o),v,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new P.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(o,v,n,f,r){const t=this._viewProviders.get(v);if(!t)throw new Error(`No view provider found for '${v}'`);const{provider:d,extension:s}=t,c=this._extHostWebview.createNewWebview(o,{},s),m=new T(o,this._proxy,v,n,c,!0);this._webviewViews.set(o,m),await d.resolveWebviewView(m,{state:f},r)}async $onDidChangeWebviewViewVisibility(o,v){this.getWebviewView(o)._setVisible(v)}async $disposeWebviewView(o){const v=this.getWebviewView(o);this._webviewViews.delete(o),v.dispose(),this._extHostWebview.deleteWebview(o)}getWebviewView(o){const v=this._webviewViews.get(o);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=b}),define(fe[134],me([0,1,3,5,2,10,9,4,14]),function(Y,e,g,F,C,S,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Wn{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wn.InitialState,this._proxy=I.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(a=>this.$onDidChangeWindowFocus(a))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,a){let p;if(typeof I=="string"){p=I;try{I=C.URI.parse(I)}catch(h){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,P.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===S.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,p,a)}async asExternalUri(I,a){if((0,P.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(I,a);return C.URI.from(p)}};k.InitialState={focused:!0},k=Ve([We(0,y.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,_.createDecorator)("IExtHostWindow")}),define(fe[261],me([0,1,8,81,32,40,6,5,2,14]),function(Y,e,g,F,C,S,P,_,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends P.Disposable{constructor(a,p){super();const h=a.getProxy(_.MainContext.MainThreadDownloadService);p.registerCommand(!1,"_workbench.downloadResource",async w=>{const D=y.URI.file((0,g.join)((0,F.tmpdir)(),(0,C.generateUuid)()));return await h.$download(w,D),D})}};i=Ve([We(0,k.IExtHostRpcService),We(1,S.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(fe[262],me([0,1,2,8,153,26,69,28,14,6,13,117,43]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class p{constructor(T,b,l){this.name=T,this.file=b,this.appender=l}static async create(T,b){const l=await(0,I.createRotatingLogger)(T,b,30*a.ByteSize.MB,1);return l.clearFormatters(),new p(T,b,l)}append(T){this.appender.critical(T)}flush(){this.appender.flush()}}class h extends P.AbstractExtHostOutputChannel{constructor(T,b,l,o){super(T,!1,g.URI.file(b.file),l,o);this._appender=b}append(T){super.append(T),this._appender.append(T),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(T,b){this._appender.flush(),super.show(T,b)}clear(){this._appender.flush(),super.clear()}}let w=class extends P.ExtHostOutputService{constructor(T,b,l){super(T);this.logService=b,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new k.MutableDisposable,this._logsLocation=l.logsLocation}$setVisibleChannel(T){if(T){const b=this._channels.get(T);b&&(this._visibleChannelDisposable.value=b.onDidAppend(()=>b.update()))}}createOutputChannel(T,b){if(T=T.trim(),!T)throw new Error("illegal argument `name`. must not be falsy");const l=this._doCreateOutChannel(T,b);return l.then(o=>o._id.then(v=>this._channels.set(v,o))),new P.LazyOutputChannel(T,l)}async _doCreateOutChannel(T,b){try{const l=(0,F.join)(this._logsLocation.fsPath,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await S.SymlinkSupport.existsDirectory(l)||await S.Promises.mkdir(l,{recursive:!0});const v=`${this._namePool++}-${T.replace(/[\\/:\*\?"<>\|]/g,"")}`,n=g.URI.file((0,F.join)(l,`${v}.log`)),f=await p.create(v,n.fsPath);return new h(T,f,b.identifier.value,this._proxy)}catch(l){return this.logService.error(l),new P.ExtHostPushOutputChannel(T,b.identifier.value,this._proxy)}}};w=Ve([We(0,y.IExtHostRpcService),We(1,i.ILogService),We(2,_.IExtHostInitDataService)],w),e.ExtHostOutputService2=w}),define(fe[263],me([0,1,50,8,2,70,6,10,15,26]),function(Y,e,g,F,C,S,P,_,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class i extends S.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(n){const f=await super._getWorkspaceStorageURI(n);if(f.scheme!==_.Schemas.file)return f;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const r=f.fsPath;let t=0;do{let d;t===0?d=r:d=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${t}`:`${r}-${t}`,await I(d);const s=F.join(d,"vscode.lock"),c=await w(this._logService,s,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),C.URI.file(d);t++}while(t<10);return f}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=i;async function I(v){try{await k.Promises.stat(v);return}catch{}try{await k.Promises.mkdir(v,{recursive:!0})}catch{}}const a=1e3,p=10*60*1e3;class h extends P.Disposable{constructor(n,f){super();this.logService=n,this.filename=f,this._timer=this._register(new y.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await D(n,f);(!r||r.pid!==process.pid)&&(n.info(`Lock '${f}': The lock was lost unexpectedly.`),this._timer.cancel());try{await k.Promises.utimes(f,new Date,new Date)}catch(t){n.error(t),n.info(`Lock '${f}': Could not update mtime.`)}},a)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(n){}}async setWillRelease(n){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+n};await k.Promises.writeFile(this.filename,JSON.stringify(f),{flag:"w"})}catch(f){this.logService.error(f)}}}async function w(v,n,f){try{const t={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(n,JSON.stringify(t),{flag:"wx"})}catch(t){v.error(t)}const r=await D(v,n);return!r||r.pid!==process.pid?f?(v.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(v.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),l(v,n)):(v.info(`Lock '${n}': Lock acquired.`),new h(v,n))}async function D(v,n){let f;try{f=await k.Promises.readFile(n)}catch(r){return v.error(r),null}try{return JSON.parse(String(f))}catch(r){return v.error(r),null}}async function T(v,n){let f;try{f=await k.Promises.stat(n)}catch(r){return v.error(r),0}return f.mtime.getTime()}function b(v){try{return process.kill(v,0),!0}catch(n){return!1}}async function l(v,n){const f=await D(v,n);if(!f)return v.info(`Lock '${n}': Could not read pid of lock holder.`),o(v,n);if(f.willReleaseAt){let c=f.willReleaseAt-Date.now();if(c<5e3){for(c>0?v.info(`Lock '${n}': The lockfile is scheduled to be released in ${c} ms.`):v.info(`Lock '${n}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,y.timeout)(Math.min(100,c)),await T(v,n)===0)return o(v,n);c=f.willReleaseAt-Date.now()}return o(v,n)}}if(!b(f.pid))return v.info(`Lock '${n}': The pid ${f.pid} appears to be gone.`),o(v,n);const r=await T(v,n),t=Date.now()-r;if(t<=p)return v.info(`Lock '${n}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;v.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const d=await T(v,n),s=Date.now()-d;return s<=p?(v.info(`Lock '${n}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null):(v.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),o(v,n))}async function o(v,n){v.info(`Lock '${n}': Deleting a stale lock.`);try{await k.Promises.unlink(n)}catch(f){}return w(v,n,!0)}}),define(fe[264],me([0,1,32,14,33]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let S=class extends C.BaseExtHostTerminalService{constructor(_){super(!0,_)}createTerminal(_,y,k){return this.createTerminalFromOptions({name:_,shellPath:y,shellArgs:k})}createTerminalFromOptions(_,y){const k=new C.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),_,_.name);return this._terminals.push(k),k.create(_,this._serializeParentTerminal(_,y)),k.value}};S=Ve([We(0,F.IExtHostRpcService)],S),e.ExtHostTerminalService=S}),define(fe[265],me([0,1,5,14,173,6,28,2,39,23,26,7,11,54,3,123,78,13]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(m,u,E){this.remoteAddress=m,this.localAddress=u,this._dispose=E,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function l(c){const m=c.trim().split(`
`),u=[];return m.forEach(R=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);L&&L.length>=3&&u.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),u.reduce((R,L)=>(R[L.socket]=L,R),{})}e.getSockets=l;function o(...c){const m=[].concat(...c.map(n));return[...new Map(m.filter(u=>u.st==="0A").map(u=>{const E=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:v(E[0]),port:parseInt(E[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=o;function v(c){let m="";if(c.length===8)for(let u=c.length-2;u>=0;u-=2)m+=parseInt(c.substr(u,2),16),u!==0&&(m+=".");else for(let u=c.length-4;u>=0;u-=4)m+=parseInt(c.substr(u,4),16).toString(16),u!==0&&(m+=":");return m}e.parseIpAddress=v;function n(c){const m=c.trim().split(`
`),u=m.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return m.map(R=>R.trim().split(/\s+/).reduce((L,M,A)=>(L[u[A]||A]=M,L),{}))}e.loadConnectionTable=n;function f(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function r(c){const m=c.trim().split(`
`),u=[];return m.forEach(E=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);R&&R.length>=4&&u.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),u}e.getRootProcesses=r;async function t(c,m,u){const E=u.reduce((L,M)=>(L[M.pid]=M,L),{}),R=[];return c.forEach(({socket:L,ip:M,port:A})=>{const B=m[L]?m[L].pid:void 0,V=B?E[B]?.cmd:void 0;B&&V&&!f(V)&&R.push({host:M,port:A,detail:V,pid:B})}),R}e.findPorts=t;function d(c,m,u){const E=new Map,R=r(m);for(const L of c){const M=u.get(L.port);if(M){E.set(L.port,M);continue}const A=R.find(B=>B.cmd.includes(`${L.port}`));if(A){let B=A,V;do V=R.find(N=>N.ppid===B.pid),V&&(B=V);while(V);E.set(L.port,{host:L.ip,port:L.port,pid:B.pid,detail:B.cmd,ppid:B.ppid})}else E.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=d;let s=class extends S.Disposable{constructor(m,u,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(g.MainContext.MainThreadTunnelService),a.isLinux&&u.remote.isRemote&&u.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(u,m.displayName);if(E){const R=new b(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,u){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:m,provider:u}),this._proxy.$registerPortsAttributesProvider(m,E),new I.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(m,u,E,R,L){const M=[];for(const B of m){const V=this._portAttributesProviders.get(B);if(!V)return[];M.push(...await Promise.all(u.map(async N=>V.provider.providePortAttributes(N,E,R,L))))}const A=M.filter(B=>!!B);return A.length>0?A.map(B=>({autoForwardAction:B.autoForwardAction,port:B.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let u=new D.MovingAverage,E;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),L=(await this.findCandidatePorts()).filter(A=>(0,w.isLocalhost)(A.host)||(0,w.isAllInterfaces)(A.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${L.map(A=>A.port).join(", ")}`);const M=new Date().getTime()-R;u.update(M),(!E||JSON.stringify(E)!==JSON.stringify(L))&&(E=L,await this._proxy.$onFoundNewCandidates(E)),await new Promise(A=>setTimeout(()=>A(),this.calculateDelay(u.value)))}}async setTunnelExtensionFunctions(m){if(m){if(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory){this._forwardPortProvider=m.tunnelFactory;let u=m.tunnelFeatures?.privacyOptions??[];m.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:C.localize(0,null),themeIcon:"lock"},{id:"public",label:C.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!m.tunnelFeatures?.elevation,public:!!m.tunnelFeatures?.public,privacyOptions:u})}}else this._forwardPortProvider=void 0;return(0,S.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,u){if(this._extensionTunnels.has(m.host)){const E=this._extensionTunnels.get(m.host);E.has(m.port)&&(u&&E.get(m.port).disposeListener.dispose(),await E.get(m.port).tunnel.dispose(),E.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(m,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const R=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const L=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:R,disposeListener:L}),p.TunnelDto.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const u=await Promise.all(m.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),E=m.filter((R,L)=>u[L]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(R=>R.port).join(", ")} to ${E.map(R=>R.port).join(", ")}`),E}async findCandidatePorts(){let m="",u="";try{m=await i.Promises.readFile("/proc/net/tcp","utf8"),u=await i.Promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const E=o(m,u),R=await new Promise(U=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,z,O)=>{U(z)})}),L=l(R),M=await i.Promises.readdir("/proc"),A=[];for(let U of M)try{const x=Number(U),z=k.joinPath(_.URI.file("/proc"),U);if((await i.Promises.stat(z.fsPath)).isDirectory()&&!isNaN(x)){const W=await i.Promises.readlink(k.joinPath(z,"cwd").fsPath),$=await i.Promises.readFile(k.joinPath(z,"cmdline").fsPath,"utf8");A.push({pid:x,cwd:W,cmd:$})}}catch(x){}const B=[],V=E.filter(U=>{const x=L[U.socket];return x||B.push(U),x}),N=t(V,L,A);let j;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${B.length}`),B.length>0){const U=await new Promise(x=>{(0,y.exec)("ps -F -A -l | grep root",(z,O,W)=>{x(O)})});this._foundRootPorts=d(B,U,this._foundRootPorts),j=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${j.join(", ")}`)}return N.then(U=>j?U.concat(j):U)}};s=Ve([We(0,F.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,T.ILogService)],s),e.ExtHostTunnelService=s}),define(fe[266],me([0,1,15,22,21,17,3,6,104,230,55]),function(Y,e,g,F,C,S,P,_,y,k,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function a(E,R){try{return JSON.stringify(E,R)}catch(L){return"null"}}const p="$$ref$$",h={[p]:-1};class w{constructor(R,L){this.jsonString=R,this.referencedBuffers=L}}function D(E,R=null,L=!1){const M=[];return{jsonString:(L?a:JSON.stringify)(E,(B,V)=>{if(typeof V=="undefined")return h;if(typeof V=="object"){if(V instanceof F.VSBuffer){const N=M.push(V)-1;return{[p]:N}}if(R)return R(B,V)}return V}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=D;function T(E,R,L){return JSON.parse(E,(M,A)=>{if(A){const B=A[p];if(typeof B=="number")return R[B];if(L&&A.$mid===1)return L.transformIncoming(A)}return A})}e.parseJsonAndRestoreBufferRefs=T;function b(E,R){return JSON.stringify(E,R)}function l(E){return E?(R,L)=>L&&L.$mid===1?E.transformOutgoing(L):L:null}var o;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},f=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class t extends _.Disposable{constructor(R,L=null,M=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=L,this._uriTransformer=M,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,B=i.ProxyIdentifier.count;A<B;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,y.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:L,sid:M}=R;return this._proxies[L]||(this._proxies[L]=this._createProxy(L,M)),this._proxies[L]}_createProxy(R,L){let M={get:(A,B)=>(typeof B=="string"&&!A[B]&&B.charCodeAt(0)===36&&(A[B]=(...V)=>this._remoteCall(R,B,V)),B===r?L:A[B])};return new Proxy(Object.create(null),M)}set(R,L){return this._locals[R.nid]=L,L}assertRegistered(R){for(let L=0,M=R.length;L<M;L++){const A=R[L];if(!this._locals[A.nid])throw new Error(`Missing actor ${A.sid} (isMain: ${A.isMain})`)}}_receiveOneMessage(R){if(this._isDisposed)return;const L=R.byteLength,M=d.read(R,0),A=M.readUInt8(),B=M.readUInt32();switch(A){case 1:case 2:{let{rpcId:V,method:N,args:j}=c.deserializeRequestJSONArgs(M);this._uriTransformer&&(j=(0,y.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(L,B,V,N,j,A===2);break}case 3:case 4:{let{rpcId:V,method:N,args:j}=c.deserializeRequestMixedArgs(M);this._uriTransformer&&(j=(0,y.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(L,B,V,N,j,A===4);break}case 5:{this._logger&&this._logger.logIncoming(L,B,0,"ack"),this._onDidReceiveAcknowledge(B);break}case 6:{this._receiveCancel(L,B);break}case 7:{this._receiveReply(L,B,void 0);break}case 9:{let V=c.deserializeReplyOKJSON(M);this._uriTransformer&&(V=(0,y.transformIncomingURIs)(V,this._uriTransformer)),this._receiveReply(L,B,V);break}case 10:{const V=c.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(L,B,V);break}case 8:{let V=c.deserializeReplyOKVSBuffer(M);this._receiveReply(L,B,V);break}case 11:{let V=c.deserializeReplyErrError(M);this._uriTransformer&&(V=(0,y.transformIncomingURIs)(V,this._uriTransformer)),this._receiveReplyErr(L,B,V);break}case 12:{this._receiveReplyErr(L,B,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,L,M,A,B,V){this._logger&&this._logger.logIncoming(R,L,1,`receiveRequest ${(0,i.getStringIdentifierForProxy)(M)}.${A}(`,B);const N=String(L);let j,U;if(V){const z=new C.CancellationTokenSource;B.push(z.token),j=this._invokeHandler(M,A,B),U=()=>z.cancel()}else j=this._invokeHandler(M,A,B),U=n;this._cancelInvokedHandlers[N]=U;const x=c.serializeAcknowledged(L);this._logger&&this._logger.logOutgoing(x.byteLength,L,1,"ack"),this._protocol.send(x),j.then(z=>{delete this._cancelInvokedHandlers[N];const O=c.serializeReplyOK(L,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(O.byteLength,L,1,"reply:",z),this._protocol.send(O)},z=>{delete this._cancelInvokedHandlers[N];const O=c.serializeReplyErr(L,z);this._logger&&this._logger.logOutgoing(O.byteLength,L,1,"replyErr:",z),this._protocol.send(O)})}_receiveCancel(R,L){this._logger&&this._logger.logIncoming(R,L,1,"receiveCancel");const M=String(L);this._cancelInvokedHandlers[M]&&this._cancelInvokedHandlers[M]()}_receiveReply(R,L,M){this._logger&&this._logger.logIncoming(R,L,0,"receiveReply:",M);const A=String(L);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const B=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],B.resolveOk(M)}_receiveReplyErr(R,L,M){this._logger&&this._logger.logIncoming(R,L,0,"receiveReplyErr:",M);const A=String(L);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const B=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let V;M&&(M.$isError?(V=new Error,V.name=M.name,V.message=M.message,V.stack=M.stack):V=M),B.resolveErr(V)}_invokeHandler(R,L,M){try{return Promise.resolve(this._doInvokeHandler(R,L,M))}catch(A){return Promise.reject(A)}}_doInvokeHandler(R,L,M){const A=this._locals[R];if(!A)throw new Error("Unknown actor "+(0,i.getStringIdentifierForProxy)(R));let B=A[L];if(typeof B!="function")throw new Error("Unknown method "+L+" on actor "+(0,i.getStringIdentifierForProxy)(R));return B.apply(A,M)}_remoteCall(R,L,M){if(this._isDisposed)return Promise.reject(S.canceled());let A=null;if(M.length>0&&C.CancellationToken.isCancellationToken(M[M.length-1])&&(A=M.pop()),A&&A.isCancellationRequested)return Promise.reject(S.canceled());const B=c.serializeRequestArguments(M,this._uriReplacer),V=++this._lastMessageId,N=String(V),j=new k.LazyPromise;A&&A.onCancellationRequested(()=>{const x=c.serializeCancel(V);this._logger&&this._logger.logOutgoing(x.byteLength,V,0,"cancel"),this._protocol.send(c.serializeCancel(V))}),this._pendingRPCReplies[N]=j,this._onWillSendRequest(V);const U=c.serializeRequest(V,R,L,B,!!A);return this._logger&&this._logger.logOutgoing(U.byteLength,V,0,`request: ${(0,i.getStringIdentifierForProxy)(R)}.${L}(`,M),this._protocol.send(U),j}}e.RPCProtocol=t,I=f,t.UNRESPONSIVE_TIME=3*1e3;class d{constructor(R,L){this._buff=R,this._offset=L}static alloc(R,L,M){let A=new d(F.VSBuffer.alloc(M+1+4),0);return A.writeUInt8(R),A.writeUInt32(L),A}static read(R,L){return new d(R,L)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,M}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,M}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,L}static sizeMixedArray(R){let L=0;L+=1;for(let M=0,A=R.length;M<A;M++){const B=R[M];switch(L+=1,B.type){case 1:L+=this.sizeLongString(B.value);break;case 2:L+=this.sizeVSBuffer(B.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(B.value);for(let V=0;V<B.buffers.length;++V)L+=this.sizeVSBuffer(B.buffers[V]);break;case 4:break}}return L}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let L=0,M=R.length;L<M;L++){const A=R[L];switch(A.type){case 1:this.writeUInt8(1),this.writeLongString(A.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A.value);break;case 3:this.writeUInt8(3),this.writeUInt32(A.buffers.length),this.writeLongString(A.value);for(let B=0;B<A.buffers.length;++B)this.writeBuffer(A.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;let L=new Array(R);for(let M=0;M<R;M++)switch(this.readUInt8()){case 1:L[M]=this.readLongString();break;case 2:L[M]=this.readVSBuffer();break;case 3:const B=this.readUInt32(),V=this.readLongString(),N=[];for(let j=0;j<B;++j)N.push(this.readVSBuffer());L[M]=new i.SerializableObjectWithBuffers(T(V,N,null));break;case 4:L[M]=void 0;break}return L}}d.sizeUInt32=4;var s;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(s||(s={}));class c{static _useMixedArgSerialization(R){for(let L=0,M=R.length;L<M;L++)if(R[L]instanceof F.VSBuffer||R[L]instanceof i.SerializableObjectWithBuffers||typeof R[L]=="undefined")return!0;return!1}static serializeRequestArguments(R,L){if(this._useMixedArgSerialization(R)){const M=[];for(let A=0,B=R.length;A<B;A++){const V=R[A];if(V instanceof F.VSBuffer)M[A]={type:2,value:V};else if(typeof V=="undefined")M[A]={type:4};else if(V instanceof i.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:j}=D(V.value,L);M[A]={type:3,value:F.VSBuffer.fromString(N),buffers:j}}else M[A]={type:1,value:F.VSBuffer.fromString(b(V,L))}}return{type:1,args:M}}return{type:0,args:b(R,L)}}static serializeRequest(R,L,M,A,B){switch(A.type){case 0:return this._requestJSONArgs(R,L,M,A.args,B);case 1:return this._requestMixedArgs(R,L,M,A.args,B)}}static _requestJSONArgs(R,L,M,A,B){const V=F.VSBuffer.fromString(M),N=F.VSBuffer.fromString(A);let j=0;j+=d.sizeUInt8(),j+=d.sizeShortString(V),j+=d.sizeLongString(N);let U=d.alloc(B?2:1,R,j);return U.writeUInt8(L),U.writeShortString(V),U.writeLongString(N),U.buffer}static deserializeRequestJSONArgs(R){const L=R.readUInt8(),M=R.readShortString(),A=R.readLongString();return{rpcId:L,method:M,args:JSON.parse(A)}}static _requestMixedArgs(R,L,M,A,B){const V=F.VSBuffer.fromString(M);let N=0;N+=d.sizeUInt8(),N+=d.sizeShortString(V),N+=d.sizeMixedArray(A);let j=d.alloc(B?4:3,R,N);return j.writeUInt8(L),j.writeShortString(V),j.writeMixedArray(A),j.buffer}static deserializeRequestMixedArgs(R){const L=R.readUInt8(),M=R.readShortString(),A=R.readMixedArray(),B=new Array(A.length);for(let V=0,N=A.length;V<N;V++){const j=A[V];typeof j=="string"?B[V]=JSON.parse(j):B[V]=j}return{rpcId:L,method:M,args:B}}static serializeAcknowledged(R){return d.alloc(5,R,0).buffer}static serializeCancel(R){return d.alloc(6,R,0).buffer}static serializeReplyOK(R,L,M){if(typeof L=="undefined")return this._serializeReplyOKEmpty(R);if(L instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(R,L);if(L instanceof i.SerializableObjectWithBuffers){const{jsonString:A,referencedBuffers:B}=D(L.value,M,!0);return this._serializeReplyOKJSONWithBuffers(R,A,B)}else return this._serializeReplyOKJSON(R,a(L,M))}static _serializeReplyOKEmpty(R){return d.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,L){let M=0;M+=d.sizeVSBuffer(L);let A=d.alloc(8,R,M);return A.writeVSBuffer(L),A.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,L){const M=F.VSBuffer.fromString(L);let A=0;A+=d.sizeLongString(M);let B=d.alloc(9,R,A);return B.writeLongString(M),B.buffer}static _serializeReplyOKJSONWithBuffers(R,L,M){const A=F.VSBuffer.fromString(L);let B=0;B+=d.sizeUInt32,B+=d.sizeLongString(A);for(const N of M)B+=d.sizeVSBuffer(N);let V=d.alloc(10,R,B);V.writeUInt32(M.length),V.writeLongString(A);for(const N of M)V.writeBuffer(N);return V.buffer}static deserializeReplyOKJSON(R){const L=R.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(R,L){const M=R.readUInt32(),A=R.readLongString(),B=[];for(let V=0;V<M;++V)B.push(R.readVSBuffer());return new i.SerializableObjectWithBuffers(T(A,B,L))}static serializeReplyErr(R,L){return L?this._serializeReplyErrEror(R,L):this._serializeReplyErrEmpty(R)}static _serializeReplyErrEror(R,L){const M=F.VSBuffer.fromString(a(S.transformErrorForSerialization(L),null));let A=0;A+=d.sizeLongString(M);let B=d.alloc(11,R,A);return B.writeLongString(M),B.buffer}static deserializeReplyErrError(R){const L=R.readLongString();return JSON.parse(L)}static _serializeReplyErrEmpty(R){return d.alloc(12,R,0).buffer}}var m;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var u;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(u||(u={}))}),define(fe[267],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(fe[268],me([0,1,10,8,11,2,4,64,44,225,267]),function(Y,e,g,F,C,S,P,_,y,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,P.createDecorator)("pathService");let I=class Hn{constructor(p,h,w,D){this.localUserHome=p,this.remoteAgentService=h,this.environmentService=w,this.contextService=D,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||C.OS)(),this.resolveUserHome=(async()=>{const T=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=T?.userHome||p})()}get defaultUriScheme(){return Hn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(p,h){if(p.remoteAuthority)return g.Schemas.vscodeRemote;const w=(0,_.getVirtualWorkspaceScheme)(h.getWorkspace());if(w)return w;const D=h.getWorkspace().folders[0];if(D)return D.uri.scheme;const T=h.getWorkspace().configuration;return T?T.scheme:g.Schemas.file}async userHome(p){return p?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(p=>p===1?F.win32:F.posix)}async fileURI(p){let h="";if(await this.resolveOS===1&&(p=p.replace(/\\/g,"/")),p[0]==="/"&&p[1]==="/"){const D=p.indexOf("/",2);D===-1?(h=p.substring(2),p="/"):(h=p.substring(2,D),p=p.substring(D)||"/")}return S.URI.from({scheme:g.Schemas.file,authority:h,path:p,query:"",fragment:""})}};I=Ve([We(1,i.IRemoteAgentService),We(2,k.IWorkbenchEnvironmentService),We(3,y.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(fe[72],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(P,_){this.line=P,this.character=_}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,_){return new g(0,0)}with(P){return new g(0,0)}}e.Position=g;class F{constructor(P,_,y,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(P,_),this.end=new g(y,k)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new F(0,0,0,0)}with(P){return new F(0,0,0,0)}}e.Range=F;var C;(function(S){S[S.Information=1]="Information",S[S.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(fe[31],me([0,1,18,30,25,29,9,4,8,17,72,12]),function(Y,e,g,F,C,S,P,_,y,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const a="\u27EA ",p=" characters skipped \u27EB",h=(a.length+p.length+5)*2;e.ISearchService=(0,_.createDecorator)("searchService");var w;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(w=e.SearchProviderType||(e.SearchProviderType={}));var D;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(D=e.QueryType||(e.QueryType={}));function T(x){return!!x.preview}e.resultIsMatch=T;function b(x){return!!x.resource}e.isFileMatch=b;function l(x){return!!x.message}e.isProgressMessage=l;var o;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=v;class n{constructor(z,O,W){this.ranges=O;const $=Array.isArray(O)?O:[O];if(W&&W.matchLines===1&&f($)){z=(0,P.getNLines)(z,W.matchLines);let X="",K=0,de=0;const _e=Math.floor(W.charsPerLine/5),Ce=[];for(const Pe of $){const Be=Math.max(Pe.startColumn-_e,0),$e=Pe.startColumn+W.charsPerLine;if(Be>de+_e+h){const He=a+(Be-de)+p;X+=He+z.slice(Be,$e),K+=Be-(de+He.length)}else X+=z.slice(de,$e);Ce.push(new t(0,Pe.startColumn-K,Pe.endColumn-K)),de=$e}this.preview={text:X,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const X=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:z,matches:(0,g.mapArrayOrNot)(O,K=>new r(K.startLineNumber-X,K.startColumn,K.endLineNumber-X,K.endColumn))}}}}e.TextSearchMatch=n;function f(x){const z=x[0].startLineNumber;for(const O of x)if(O.startLineNumber!==z||O.endLineNumber!==z)return!1;return!0}class r{constructor(z,O,W,$){this.startLineNumber=z,this.startColumn=O,this.endLineNumber=W,this.endColumn=$}}e.SearchRange=r;class t extends r{constructor(z,O,W){super(z,O,z,W)}}e.OneLineRange=t;var d;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(d=e.SearchSortOrder||(e.SearchSortOrder={}));function s(x,z=!0){const O=x&&x.files&&x.files.exclude,W=z&&x&&x.search&&x.search.exclude;if(!O&&!W)return;if(!O||!W)return O||W;let $=Object.create(null);return $=C.mixin($,C.deepClone(O)),$=C.mixin($,C.deepClone(W),!0),$}e.getExcludes=s;function c(x,z){return x.excludePattern&&F.match(x.excludePattern,z)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&F.match(x.includePattern,z)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(O=>{const W=O.folder.fsPath;if(S.isEqualOrParent(z,W)){const $=y.relative(W,z);return!O.includePattern||!!F.match(O.includePattern,$)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var m;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class u extends Error{constructor(z,O){super(z);this.code=O}}e.SearchError=u;function E(x){const z=x.message;if((0,k.isPromiseCanceledError)(x))return new u(z,m.canceled);try{const O=JSON.parse(z);return new u(O.message,O.code)}catch(O){return new u(z,m.other)}}e.deserializeSearchError=E;function R(x){const z={message:x.message,code:x.code};return new Error(JSON.stringify(z))}e.serializeSearchError=R;function L(x){return x.type==="error"?!0:x.type==="success"}e.isSerializedSearchComplete=L;function M(x){return x.type==="success"}e.isSerializedSearchSuccess=M;function A(x){return!!x.path}e.isSerializedFileMatch=A;function B(x,z){const O=x.searchPath?x.searchPath:x.relativePath;return(0,P.fuzzyContains)(O,z)}e.isFilePatternMatch=B;class V{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=V;function N(x,z){const O={...x||{},...z||{}};return Object.keys(O).filter(W=>{const $=O[W];return typeof $=="boolean"&&$})}e.resolvePatternsForProvider=N;class j{constructor(z,O){this._parsedIncludeExpression=null,this._excludeExpression={...z.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let W=z.includePattern;O.includePattern&&(W?W={...W,...O.includePattern}:W=O.includePattern),W&&(this._parsedIncludeExpression=F.parse(W))}matchesExcludesSync(z,O,W){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,O,W))}includedInQuerySync(z,O,W){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,O,W)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,O,W))}includedInQuery(z,O,W){const $=this._parsedExcludeExpression(z,O,W),X=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(z,O,W):!0;return(0,I.isPromise)($)?$.then(K=>K?!1:X()):X()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=j;function U(x){for(const z in x)if(typeof x[z]!="boolean")return!0;return!1}}),define(fe[36],me([0,1,18,15,21,3,24,10,78,23,9,12,2,171,4,13,191,44,53,28,14,7,31,5]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T,b,l,o,v,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(R,L,M){return new k.ExtUri(A=>c(A,M)).isEqual(R,L)}function t(R,L,M){return r(R.uri,L.uri,M)?0:(0,i.compare)(R.uri.toString(),L.uri.toString())}function d(R,L,M){return R.index!==L.index?R.index<L.index?-1:1:r(R.uri,L.uri,M)?(0,i.compare)(R.name,L.name):(0,i.compare)(R.uri.toString(),L.uri.toString())}function s(R,L,M,A){const B=R.slice(0).sort((N,j)=>M(N,j,A)),V=L.slice(0).sort((N,j)=>M(N,j,A));return(0,g.delta)(B,V,(N,j)=>M(N,j,A))}function c(R,L){const M=L.getCapabilities(R.scheme);return!(M&&M&1024)}class m extends T.Workspace{constructor(L,M,A,B,V,N,j){super(L,A.map(U=>new T.WorkspaceFolder(U)),B,V,j);this._name=M,this._isUntitled=N,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris(j),A.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(L,M,A,B){if(!L)return{workspace:null,added:[],removed:[]};const{id:V,name:N,folders:j,configuration:U,transient:x,isUntitled:z}=L,O=[],W=M;M?j.forEach((de,_e)=>{const Ce=a.URI.revive(de.uri),Pe=m._findFolder(A||M,Ce,B);Pe?(Pe.name=de.name,Pe.index=de.index,O.push(Pe)):O.push({uri:Ce,name:de.name,index:_e})}):O.push(...j.map(({uri:de,name:_e,index:Ce})=>({uri:a.URI.revive(de),name:_e,index:Ce}))),O.sort((de,_e)=>de.index<_e.index?-1:1);const $=new m(V,N,O,!!x,U?a.URI.revive(U):null,!!z,de=>c(de,B)),{added:X,removed:K}=s(W?W.workspaceFolders:[],$.workspaceFolders,t,B);return{workspace:$,added:X,removed:K}}static _findFolder(L,M,A){for(let B=0;B<L.folders.length;B++){const V=L.workspaceFolders[B];if(r(V.uri,M,A))return V}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,M){return M&&this._structure.get(L)&&(L=(0,k.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let u=class{constructor(L,M,A,B){this._onDidChangeWorkspace=new S.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new S.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=B,this._extHostFileSystemInfo=A,this._requestIdProvider=new y.Counter,this._barrier=new F.Barrier,this._proxy=L.getProxy(f.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(f.MainContext.MainThreadMessageService);const V=M.workspace;this._confirmedWorkspace=V?new m(V.id,V.name,[],!!V.transient,V.configuration?a.URI.revive(V.configuration):null,!!V.isUntitled,N=>c(N,A)):void 0}$initializeWorkspace(L,M){this._trusted=M,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?a.URI.from({scheme:_.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,M,A,...B){const V=[];if(Array.isArray(B)&&B.forEach(z=>{a.URI.isUri(z.uri)&&!V.some(O=>r(O.uri,z.uri,this._extHostFileSystemInfo))&&V.push({uri:z.uri,name:z.name||(0,k.basenameOrAuthority)(z.uri)})}),this._unconfirmedWorkspace||[M,A].some(z=>typeof z!="number"||z<0)||A===0&&V.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(M+A>N.length)return!1;const j=N.slice(0);j.splice(M,A,...V.map(z=>({uri:z.uri,name:z.name||(0,k.basenameOrAuthority)(z.uri),index:void 0})));for(let z=0;z<j.length;z++){const O=j[z];if(j.some((W,$)=>$!==z&&r(O.uri,W.uri,this._extHostFileSystemInfo)))return!1}j.forEach((z,O)=>z.index=O);const{added:U,removed:x}=s(N,j,d,this._extHostFileSystemInfo);if(U.length===0&&x.length===0)return!1;if(this._proxy){const z=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(z,M,A,V).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(D.Severity.Error,(0,p.localize)(0,null,z,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(j),!0}getWorkspaceFolder(L,M){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,M)}async getWorkspaceFolder2(L,M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,M)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,M){let A,B="";if(typeof L=="string"?(A=a.URI.file(L),B=L):typeof L!="undefined"&&(A=L,B=L.fsPath),!A)return B;const V=this.getWorkspaceFolder(A,!0);if(!V)return B;typeof M=="undefined"&&this._actualWorkspace&&(M=this._actualWorkspace.folders.length>1);let N=(0,k.relativePath)(V.uri,A);return M&&V.name&&(N=`${V.name}/${N}`),N}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=m.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:M,added:A,removed:B}=m.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=M||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:A,removed:B}))}findFiles(L,M,A,B,V=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let N;if(M===null?N=!1:M&&(typeof M=="string"?N=M:N=M.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:j,folder:U}=E(L);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(j),(0,I.withUndefinedAsNull)(U),(0,I.withUndefinedAsNull)(N),(0,I.withUndefinedAsNull)(A),V).then(x=>Array.isArray(x)?x.map(z=>a.URI.revive(z)):[])}async findTextInFiles(L,M,A,B,V=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),j=typeof M.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:U,folder:x}=E(M.include),z=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,O={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:j,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:U,excludePattern:z},W=!1;if(this._activeSearchCallbacks[N]=$=>{if(W)return;const X=a.URI.revive($.resource);$.results.forEach(K=>{(0,n.resultIsMatch)(K)?A({uri:X,preview:{text:K.preview.text,matches:(0,g.mapArrayOrNot)(K.preview.matches,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,g.mapArrayOrNot)(K.ranges,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):A({uri:X,text:K.text,lineNumber:K.lineNumber})})},V.isCancellationRequested)return{};try{const $=await this._proxy.$startTextSearch(L,(0,I.withUndefinedAsNull)(x),O,N,V);return delete this._activeSearchCallbacks[N],$||{}}catch($){throw delete this._activeSearchCallbacks[N],$}}$handleTextSearchResult(L,M){this._activeSearchCallbacks[M]&&this._activeSearchCallbacks[M](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};u=Ve([We(0,o.IExtHostRpcService),We(1,l.IExtHostInitDataService),We(2,b.IExtHostFileSystemInfo),We(3,w.ILogService)],u),e.ExtHostWorkspace=u,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function E(R){let L,M;return R&&(typeof R=="string"?L=R:(L=R.pattern,M=R.baseFolder||a.URI.file(R.base))),{includePattern:L,folder:M}}}),define(fe[37],me([0,1,25,3,36,5,7,194,86,12,15,4,14,13,2]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(f,r){if(r){const t=r.split(".");let d=f;for(let s=0;d&&s<t.length;s++)d=d[t[s]];return d}}function D(f){return f instanceof h.URI}function T(f){return f&&f.uri instanceof h.URI&&f.languageId&&typeof f.languageId=="string"}function b(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function l(f){return f&&f.uri instanceof h.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function o(f){if(D(f))return{resource:f};if(T(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(b(f))return{overrideIdentifier:f.languageId};if(l(f))return{resource:f.uri};if(f===null)return{resource:null}}let v=class{constructor(r,t,d){this._proxy=r.getProxy(S.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=d,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new n(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,t){this.getConfigProvider().then(d=>d.$acceptConfigurationChanged(r,t))}};v=Ve([We(0,a.IExtHostRpcService),We(1,C.IExtHostWorkspace),We(2,p.ILogService)],v),e.ExtHostConfiguration=v;class n{constructor(r,t,d,s){this._onDidChangeConfiguration=new F.Emitter,this._proxy=r,this._logService=s,this._extHostWorkspace=t,this._configuration=_.Configuration.parse(d),this._configurationScopes=this._toMap(d.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,t){const d={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=_.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,d))}getConfiguration(r,t,d){const s=o(t)||{},c=this._toReadonlyValue(r?w(this._configuration.getValue(void 0,s,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,s,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,s,d?.identifier);function m(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case P.ConfigurationTarget.Global:return 1;case P.ConfigurationTarget.Workspace:return 4;case P.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(E){return typeof w(c,E)!="undefined"},get:(E,R)=>{this._validateConfigurationAccess(r?`${r}.${E}`:E,s,d?.identifier);let L=w(c,E);if(typeof L=="undefined")L=R;else{let M;const A=(B,V)=>{let N;const j=()=>{M=M||(0,g.deepClone)(c),N=N||w(M,V)};return(0,k.isObject)(B)?new Proxy(B,{get:(U,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return j(),()=>N;if(M)return N=N||w(M,V),N[x];const z=U[x];return typeof x=="string"?A(z,`${V}.${x}`):z},set:(U,x,z)=>(j(),N&&(N[x]=z),!0),deleteProperty:(U,x)=>(j(),N&&delete N[x],!0),defineProperty:(U,x,z)=>(j(),N&&Object.defineProperty(N,x,z),!0)}):B};L=A(L,E)}return L},update:(E,R,L,M)=>{E=r?`${r}.${E}`:E;const A=m(L);return R!==void 0?this._proxy.$updateConfigurationOption(A,E,R,s,M):this._proxy.$removeConfigurationOption(A,E,s,M)},inspect:E=>{E=r?`${r}.${E}`:E;const R=(0,g.deepClone)(this._configuration.inspect(E,s,this._extHostWorkspace.workspace));if(R)return{key:E,defaultValue:R.default?.value,globalValue:R.user?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof c=="object"&&(0,g.mixin)(u,c,!1),Object.freeze(u)}_toReadonlyValue(r){const t=d=>(0,k.isObject)(d)?new Proxy(d,{get:(s,c)=>t(s[c]),set:(s,c,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(s,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(s,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:s=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):d;return t(r)}_validateConfigurationAccess(r,t,d){const s=y.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),c=d?`[${d.value}] `:"";if(s===4){typeof t?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(s===3){t?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,t){const d=new _.ConfigurationChangeEvent(r,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(s,c)=>d.affectsConfiguration(s,o(c))})}_toMap(r){return r.reduce((t,d)=>(t.set(d[0],d[1]),t),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,g):C?C.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[73],me([0,1,2,15,3,5,7,36,45,37,21,33,14,28,4,10,11,13,68,215,17]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T,b,l,o){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var n;(function(V){function N(U){if(U!=null)return U}V.from=N;function j(U){if(U!=null)return U}V.to=j})(n=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var f;(function(V){function N(U){if(U!=null)return U}V.from=N;function j(U){if(U!=null)return U}V.to=j})(f=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(V){function N(U){if(U!=null)return U}V.from=N;function j(U){if(U!=null)return U}V.to=j})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(V){function N(x){if(x){const z=x;return z&&!!z.process}else return!1}V.is=N;function j(x){if(x==null)return;const z={process:x.process,args:x.args};return x.options&&(z.options=r.from(x.options)),z}V.from=j;function U(x){if(x!=null)return new P.ProcessExecution(x.process,x.args,x.options)}V.to=U})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var d;(function(V){function N(U){if(U!=null)return U}V.from=N;function j(U){if(U!=null)return U}V.to=j})(d=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var s;(function(V){function N(x){if(x){const z=x;return z&&(!!z.commandLine||!!z.command)}else return!1}V.is=N;function j(x){if(x==null)return;const z={};return x.commandLine!==void 0?z.commandLine=x.commandLine:(z.command=x.command,z.args=x.args),x.options&&(z.options=d.from(x.options)),z}V.from=j;function U(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new P.ShellExecution(x.commandLine,x.options):new P.ShellExecution(x.command,x.args?x.args:[],x.options)}V.to=U})(s=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(V){function N(x){if(x){let z=x;return z&&z.customExecution==="customExecution"}else return!1}V.is=N;function j(x){return{customExecution:"customExecution"}}V.from=j;function U(x,z){return z.get(x)}V.to=U})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function(V){function N(j,U){let x;return j.scope!==void 0&&typeof j.scope!="number"?x=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===P.TaskScope.Workspace&&U&&U.workspaceFile?x=U.workspaceFile:x=l.USER_TASKS_GROUP_KEY),{id:j._id,workspaceFolder:x}}V.from=N})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(V){function N(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}V.from=N})(u=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(V){function N(x,z){if(x==null)return[];const O=[];for(let W of x){const $=j(W,z);$&&O.push($)}return O}V.fromMany=N;function j(x,z){if(x==null)return;let O;x.execution instanceof P.ProcessExecution?O=t.from(x.execution):x.execution instanceof P.ShellExecution?O=s.from(x.execution):x.execution&&x.execution instanceof P.CustomExecution&&(O=c.from(x.execution));const W=n.from(x.definition);let $;return x.scope?typeof x.scope=="number"?$=x.scope:$=x.scope.uri:$=P.TaskScope.Workspace,!W||!$?void 0:{_id:x._id,definition:W,name:x.name,source:{extensionId:z.identifier.value,label:x.source,scope:$},execution:O,isBackground:x.isBackground,group:u.from(x.group),presentationOptions:f.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}V.from=j;async function U(x,z,O){if(x==null)return;let W;t.is(x.execution)?W=t.to(x.execution):s.is(x.execution)?W=s.to(x.execution):c.is(x.execution)&&(W=c.to(x._id,O));const $=n.to(x.definition);let X;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?X=x.source.scope:X=await z.resolveWorkspaceFolder(g.URI.revive(x.source.scope)):X=P.TaskScope.Workspace),!$||!X)return;const K=new P.Task($,X,x.name,x.source.label,W,x.problemMatchers);return x.isBackground!==void 0&&(K.isBackground=x.isBackground),x.group!==void 0&&(K.group=P.TaskGroup.from(x.group._id),K.group&&x.group.isDefault&&(K.group=new P.TaskGroup(K.group.id,K.group.label),x.group.isDefault&&(K.group.isDefault=x.group.isDefault))),x.presentationOptions&&(K.presentationOptions=f.to(x.presentationOptions)),x._id&&(K._id=x._id),x.detail&&(K.detail=x.detail),K}V.to=U})(E=e.TaskDTO||(e.TaskDTO={}));var R;(function(V){function N(U){return U}V.from=N;function j(U){if(!!U)return Object.assign(Object.create(null),U)}V.to=j})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(N,j,U){this._id=j,this._task=U,v.set(this,void 0),st(this,v,N,"f")}get task(){return this._task}terminate(){Ne(this,v,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}v=new WeakMap;var M;(function(V){function N(j){return{id:j._id,task:void 0}}V.from=N})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let A=class{constructor(N,j,U,x,z,O,W,$){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=N.getProxy(S.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=x,this._configurationService=z,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=W,this._deprecationService=$,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,j,U){if(!U)return new P.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:j,provider:U,extension:N}),this._proxy.$registerTaskProvider(x,j),new P.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(N,j){this._proxy.$registerTaskSystem(N,j)}fetchTasks(N){return this._proxy.$fetchTasks(R.from(N)).then(async j=>{const U=[];for(let x of j){const z=await E.to(x,this._workspaceProvider,this._providedCustomExecutions2);z&&U.push(z)}return U})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(j=>N.push(j)),N}terminateTask(N){if(!(N instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,j,U){const x=this._providedCustomExecutions2.get(N.id);if(x){if(this._activeCustomExecutions2.get(N.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(N.id,x),this._terminalService.attachPtyToTerminal(j,await x.callback(U))}this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const j=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:j})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const j=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:j,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const j=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:j,exitCode:N.exitCode})}$provideTasks(N,j){const U=this._handlers.get(N);if(!U)return Promise.reject(new Error("no handler found"));const x=[],z=(0,F.asPromise)(()=>U.provider.provideTasks(i.CancellationToken.None)).then(O=>this.provideTasksInternal(j,x,U,O));return new Promise(O=>{z.then(W=>{Promise.all(x).then(()=>{O(W)})})})}async $resolveTask(N,j){const U=this._handlers.get(N);if(!U)return Promise.reject(new Error("no handler found"));if(j.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${U.type}].`);const x=await E.to(j,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const z=await U.provider.resolveTask(x,i.CancellationToken.None);if(!z)return;this.checkDeprecation(z,U);const O=E.from(z,U.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(O.execution)&&await this.addCustomExecution(O,z,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,j,U){const x=await this._proxy.$createTaskId(N);!U&&!this._providedCustomExecutions2.has(x)&&this._notProvidedCustomExecutions.add(x),this._providedCustomExecutions2.set(x,j.execution)}async getTaskExecution(N,j){if(typeof N=="string"){const z=this._taskExecutionPromises.get(N);if(!z)throw new Error("Unexpected: The specified task is missing an execution");return z}let U=this._taskExecutionPromises.get(N.id);if(U)return U;const x=new Promise(async(z,O)=>{const W=j||await E.to(N.task,this._workspaceProvider,this._providedCustomExecutions2);W?z(new L(this,N.id,W)):O("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(N.id,x),x.then(z=>(this._taskExecutions.set(N.id,z),z),z=>Promise.reject(z))}checkDeprecation(N,j){N._deprecated&&this._deprecationService.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let U=this._notProvidedCustomExecutions.values(),x=U.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=U.next()}};A=Ve([We(0,a.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,_.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,T.ILogService),We(7,b.IExtHostApiDeprecationService)],A),e.ExtHostTaskBase=A;let B=class extends A{constructor(N,j,U,x,z,O,W,$){super(N,j,U,x,z,O,W,$);this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:D.PlatformToString(0)})}async executeTask(N,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const U=E.from(j,N);if(U===void 0)throw new Error("Task is not valid");if(c.is(U.execution))await this.addCustomExecution(U,j,!1);else throw new o.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),j);return this._proxy.$executeTask(U).catch(z=>{throw new Error(z)}),x}provideTasksInternal(N,j,U,x){const z=[];if(x)for(let O of x){this.checkDeprecation(O,U),(!O.definition||!N[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const W=E.from(O,U.extension);W&&c.is(W.execution)?(z.push(W),j.push(this.addCustomExecution(W,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:U.extension}}async resolveTaskInternal(N){if(c.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,j,U){}};B=Ve([We(0,a.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,_.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,T.ILogService),We(7,b.IExtHostApiDeprecationService)],B),e.WorkerExtHostTask=B,e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(fe[269],me([0,1,18,59,30,80,24,10,8,23,9,12,2,147,178,121,44,130,268,31]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let o=class{constructor(m,u,E,R){this.configurationService=m,this.workspaceContextService=u,this.editorGroupsService=E,this.pathService=R}text(m,u,E={}){m=this.getContentPattern(m,E);const R=this.configurationService.getValue(),L=u&&u.some(A=>!this.configurationService.getValue({resource:A}).search.useRipgrep);return{...this.commonQuery(u?.map(D.toWorkspaceFolder),E),type:2,contentPattern:m,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:R.search.usePCRE2||L||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(m,u){const E=this.configurationService.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const R={...m,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(m,u)&&(R.isCaseSensitive=!0),this.isMultiline(m)&&(R.isMultiline=!0),R}file(m,u={}){return{...this.commonQuery(m,u),type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey}}handleIncludeExclude(m,u){return m?(m=Array.isArray(m)?m.map(t):t(m),u?this.parseSearchPaths(m):{pattern:n(...Array.isArray(m)?m:[m])}):{}}commonQuery(m=[],u={}){const E=this.handleIncludeExclude(u.includePattern,u.expandPatterns),R=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),L=m.length>1,M=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(V=>this.getFolderQueryForSearchPath(V,u,R)):m.map(V=>this.getFolderQueryForRoot(V,u,R,L))).filter(V=>!!V),A={_reason:u._reason,folderQueries:M,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:R.pattern,includePattern:E.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const N=g.coalesce(g.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(x=>x.resource)))).filter(U=>(0,l.pathIncludedInQuery)(A,U.fsPath)),j=this.commonQueryFromFileList(N);return{...A,...j}}const B=u.extraFileResources&&u.extraFileResources.filter(V=>(0,l.pathIncludedInQuery)(A,V.fsPath));return A.extraFileResources=B&&B.length?B:void 0,A}commonQueryFromFileList(m){const u=[],E=new P.ResourceMap,R={};let L=!1;return m.forEach(M=>{if(M.scheme===_.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(M)){const B=this.workspaceContextService.getWorkspaceFolder(M)?.uri??M.with({path:y.dirname(M.fsPath)});let V=E.get(B);V||(L=!0,V={folder:B,includePattern:{}},u.push(V),E.set(B,V));const N=y.relative(B.fsPath,M.fsPath);(0,I.assertIsDefined)(V.includePattern)[N.replace(/\\/g,"/")]=!0}else M.fsPath&&(L=!0,R[M.fsPath]=!0)}),{folderQueries:u,includePattern:R,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(m,u){if(u.isSmartCase){if(m.isRegExp){if(i.containsUppercaseCharacter(m.pattern,!0))return!0}else if(i.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}isMultiline(m){return m.isMultiline||m.isRegExp&&(0,p.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const u=j=>y.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),R=(Array.isArray(m)?m:f(m)).map(j=>{const U=this.pathService.resolvedUserHome;return U?(0,S.untildify)(j,U.scheme===_.Schemas.file?U.fsPath:U.path):j}),L=F.groupBy(R,j=>u(j)?"searchPaths":"exprSegments"),M=(L.exprSegments||[]).map(j=>i.rtrim(j,"/")).map(j=>i.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),r(j))),A={},B=this.expandSearchPathPatterns(L.searchPaths||[]);B&&B.length&&(A.searchPaths=B);const V=g.flatten(M),N=n(...V);return N&&(A.pattern=N),A}getExcludesForFolder(m,u){return u.disregardExcludeSettings?void 0:(0,l.getExcludes)(m,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(m){if(!m||!m.length)return[];const u=g.flatten(m.map(R=>{let{pathPortion:L,globPortion:M}=v(R);M&&(M=d(M));const A=this.expandOneSearchPath(L);return g.flatten(A.map(B=>this.resolveOneSearchPathPattern(B,M)))})),E=new Map;return u.forEach(R=>{const L=R.searchPath.toString(),M=E.get(L);M?R.pattern&&(M.pattern=M.pattern||{},M.pattern[R.pattern]=!0):E.set(L,{searchPath:R.searchPath,pattern:R.pattern?n(R.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(m){if(y.isAbsolute(m)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==_.Schemas.file?[{searchPath:u[0].uri.with({path:m})}]:[{searchPath:a.URI.file(y.normalize(m))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(m=t(m),m.startsWith("../")||m===".."){const R=y.posix.resolve(u.path,m);return[{searchPath:u.with({path:R})}]}const E=d(m);return[{searchPath:u,pattern:E}]}else{if(m==="./"||m===".\\")return[];{const u=m.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(L=>{const M=u.match(new RegExp(`^${i.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return M?{match:M,folder:L}:null}).filter(I.isDefined);if(R.length)return R.map(L=>{const M=L.match[1];return{searchPath:L.folder.uri,pattern:M&&d(M)}});{const L=m.match(/\.[\/\\](.+)[\/\\]?/),M=L?L[1]:m,A=h.localize(0,null,M);throw new Error(A)}}}}resolveOneSearchPathPattern(m,u){const E=m.pattern&&u?`${m.pattern}/${u}`:m.pattern||u,R=[{searchPath:m.searchPath,pattern:E}];return E&&!E.endsWith("**")&&R.push({searchPath:m.searchPath,pattern:E+"/**"}),R}getFolderQueryForSearchPath(m,u,E){const R=this.getFolderQueryForRoot((0,D.toWorkspaceFolder)(m.searchPath),u,E,!1);return R?{...R,includePattern:m.pattern}:null}getFolderQueryForRoot(m,u,E,R){let L;const M=a.URI.isUri(m)?m:m.uri;if(E.searchPaths){const j=E.searchPaths.filter(U=>(0,k.isEqual)(U.searchPath,M))[0];if(j&&!j.pattern)return null;j&&(L=j.pattern)}const A=this.configurationService.getValue({resource:M}),V={...this.getExcludesForFolder(A,u)||{},...L||{}},N=a.URI.isUri(m)?(0,k.basename)(m):m.name;return{folder:M,folderName:R?N:void 0,excludePattern:Object.keys(V).length>0?V:void 0,fileEncoding:A.files&&A.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!A.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!A.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!A.search.followSymlinks}}};o=Ve([We(0,w.IConfigurationService),We(1,D.IWorkspaceContextService),We(2,T.IEditorGroupsService),We(3,b.IPathService)],o),e.QueryBuilder=o;function v(c){const m=c.match(/[\*\{\}\(\)\[\]\?]/);if(m){const u=m.index,E=c.substr(0,u).match(/[/|\\][^/\\]*$/);if(E){let R=c.substr(0,E.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:c.substr((E.index||0)+1)}}}return{pathPortion:c}}function n(...c){return c.length?c.reduce((m,u)=>(m[u]=!0,m),Object.create(null)):void 0}function f(c){return C.splitGlobAware(c,",").map(m=>m.trim()).filter(m=>!!m.length)}function r(c){return[`**/${c}/**`,`**/${c}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function t(c){return c.replace(/\\/g,"/")}function d(c){return t(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function s(c,m){c=g.distinct(c,R=>R.toString());const u=[],E=m.getWorkspace();return c&&c.forEach(R=>{let L;if(m.getWorkbenchState()===2)L=(0,k.relativePath)(E.folders[0].uri,R),L&&L!=="."&&(L="./"+L);else{const M=m.getWorkspaceFolder(R);if(M){const A=M.name;if(E.folders.filter(V=>V.name===A).length===1){const V=(0,k.relativePath)(M.uri,R);V===""?L=`./${M.name}`:L=`./${M.name}/${V}`}else L=R.fsPath}}L&&u.push(L)}),u}e.resolveResourcesForSearchIncludes=s}),define(fe[270],me([0,1,23,2,21,17,4,269,31,44]),function(Y,e,g,F,C,S,P,_,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(w,D){const T=D.activationEvents;if(!T)return Promise.resolve(void 0);const b=[],l=[];for(const t of T)if(/^workspaceContains:/.test(t)){const d=t.substr("workspaceContains:".length);d.indexOf("*")>=0||d.indexOf("?")>=0||w.forceUsingSearch?l.push(d):b.push(d)}if(b.length===0&&l.length===0)return Promise.resolve(void 0);let o;const v=new Promise((t,d)=>{o=t}),n=t=>o({activationEvent:t}),f=Promise.all(b.map(t=>a(w,t,n))).then(()=>{}),r=p(w,D.identifier,l,n);return Promise.all([f,r]).then(()=>{o(void 0)}),v}e.checkActivateWorkspaceContainsExtension=I;async function a(w,D,T){for(const b of w.folders)if(await w.exists(g.joinPath(F.URI.revive(b),D))){T(`workspaceContains:${D}`);return}}async function p(w,D,T,b){if(T.length===0)return Promise.resolve(void 0);const l=new C.CancellationTokenSource,o=w.checkExists(w.folders,T,l.token),v=setTimeout(async()=>{l.cancel(),b(`workspaceContainsTimeout:${T.join(",")}`)},i);let n=!1;try{n=await o}catch(f){S.isPromiseCanceledError(f)||S.onUnexpectedError(f)}l.dispose(),clearTimeout(v),n&&b(`workspaceContains:${T.join(",")}`)}function h(w,D,T,b){const l=w.get(P.IInstantiationService),o=w.get(y.ISearchService),n=l.createInstance(_.QueryBuilder).file(D.map(f=>(0,k.toWorkspaceFolder)(F.URI.revive(f))),{_reason:"checkExists",includePattern:T,exists:!0});return o.fileSearch(n,b).then(f=>!!f.limitHit,f=>S.isPromiseCanceledError(f)?!1:Promise.reject(f))}e.checkGlobFileExists=h});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,g):C?C.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[41],me([0,1,166,8,74,23,15,6,24,2,13,5,37,228,92,36,35,226,17,27,22,201,7,122,4,28,70,14,85,54,33,3,270,90,203,10]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T,b,l,o,v,n,f,r,t,d,s,c,m,u,E,R,L,M,A){"use strict";var B,V,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let j=class zn extends _.Disposable{constructor(O,W,$,X,K,de,_e,Ce,Pe,Be){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=W,this._extHostContext=$,this._initData=_e,this._extHostWorkspace=X,this._extHostConfiguration=K,this._logService=de,this._extHostTunnelService=Pe,this._extHostTerminalService=Be,this._disposables=new _.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new P.Barrier,this._readyToStartExtensionHost=new P.Barrier,this._readyToRunExtensions=new P.Barrier,this._eagerExtensionsActivated=new P.Barrier,this._registry=new T.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new h.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=Ce,this._instaService=O.createChild(new c.ServiceCollection([h.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const $e=new Set;this._initData.hostExtensions.forEach(He=>$e.add(l.ExtensionIdentifier.toKey(He))),this._activator=new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(He,G,ee)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(He,b.transformErrorForSerialization(G),ee)},actualActivateExtension:async(He,G)=>{if($e.has(l.ExtensionIdentifier.toKey(He)))return await this._mainThreadExtensionsProxy.$activateExtension(He,G),new p.HostExtension;const ee=this._registry.getExtensionDescription(He);return this._activateExtension(ee,G)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){b.onUnexpectedError(O)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let O=[];try{O=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch(W){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,W){return this._activator.activateByEvent(O,W)}_activateById(O,W){return this._activator.activateById(O,W)}activateByIdWithErrors(O,W){return this._activateById(O,W).then(()=>{const $=this._activator.getActivatedExtension(O);if($.activationFailed)return Promise.reject($.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}async _realPathExtensionUri(O){if(O.scheme!==A.Schemas.file)return O;const W=await this._hostUtils.realpath(O.fsPath);return k.URI.file(W)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const O=y.TernarySearchTree.forUris(W=>S.extUriBiasedIgnorePathCase.ignorePathCasing(W));for(const W of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(W)){const $=await this._realPathExtensionUri(W.extensionLocation);O.set($,W)}return O})()),this._extensionPathIndex}_deactivate(O){let W=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return W;const $=this._activator.getActivatedExtension(O);if(!$)return W;try{typeof $.module.deactivate=="function"&&(W=Promise.resolve($.module.deactivate()).then(void 0,X=>(this._logService.error(X),Promise.resolve(void 0))))}catch(X){this._logService.error(X)}try{(0,_.dispose)($.subscriptions)}catch(X){this._logService.error(X)}return W}async _activateExtension(O,W){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,W).then($=>{const X=$.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,W),this._logExtensionActivationTimes(O,W,"success",X),$},$=>{throw this._logExtensionActivationTimes(O,W,"failure"),$})}_logExtensionActivationTimes(O,W,$,X){const K=U(O,W);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...X||{},outcome:$})}_doActivateExtension(O,W){const $=U(O,W);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",$);const X=this._getEntryPoint(O);if(!X)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${O.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this._logService.flush();const K=new p.ExtensionActivationTimesBuilder(W.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,S.joinPath)(O.extensionLocation,X),K),this._loadExtensionContext(O)]).then(de=>(C.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),zn._callActivate(this._logService,O.identifier,de[0],de[1],K))).then(de=>(C.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),de))}_loadExtensionContext(O){const W=new v.ExtensionGlobalMemento(O,this._storage),$=new v.ExtensionMemento(O.identifier.value,!1,this._storage),X=new M.ExtensionSecrets(O,this._secretState),K=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,de=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([W.whenReady,$.whenReady,this._storagePath.whenReady]).then(()=>{const _e=this;let Ce;return Object.freeze({globalState:W,workspaceState:$,secrets:X,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Pe){return F.join(O.extensionLocation.fsPath,Pe)},get storagePath(){return _e._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return _e._storagePath.globalValue(O).fsPath},get logPath(){return F.join(_e._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return k.URI.joinPath(_e._initData.logsLocation,O.identifier.value)},get storageUri(){return _e._storagePath.workspaceValue(O)},get globalStorageUri(){return _e._storagePath.globalValue(O)},get extensionMode(){return K},get extension(){return Ce===void 0&&(Ce=new x(_e,O.identifier,O,de)),Ce},get extensionRuntime(){return(0,D.checkProposedApiEnabled)(O),_e.extensionRuntime},get environmentVariableCollection(){return _e._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,W,$,X,K){return $=$||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,W,$,X,K).then(de=>new p.ActivatedExtension(!1,null,K.build(),$,de,X.subscriptions))}static _callActivateOptional(O,W,$,X,K){if(typeof $.activate=="function")try{K.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${W.value}`);const de=typeof global=="object"?global:self,_e=$.activate.apply(de,[X]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(_e).then(Ce=>(K.activateResolveStop(),Ce))}catch(de){return Promise.reject(de)}else return Promise.resolve($)}_activateOneStartupFinished(O,W){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:W}).then(void 0,$=>{this._logService.error($)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const W of O.activationEvents)W==="onStartupFinished"&&this._activateOneStartupFinished(O,W)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const W=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],$=this._handleWorkspaceContainsEagerExtensions(W),X=Promise.all([O,$]).then(()=>{});return Promise.race([X,(0,P.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(W=>this._handleWorkspaceContainsEagerExtension(O,W))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,W){if(this.isActivated(W.identifier))return;const $=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:O.map(de=>de.uri),forceUsingSearch:$,exists:de=>this._hostUtils.exists(de.fsPath),checkExists:(de,_e,Ce)=>this._mainThreadWorkspaceProxy.$checkExists(de,_e,Ce)},K=await(0,R.checkActivateWorkspaceContainsExtension)(X,W);if(!!K)return this._activateById(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:K.activationEvent}).then(void 0,de=>this._logService.error(de))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:W}=this._initData.environment;if(!O||!W)throw new Error(g.localize(0,null));const $=await this._loadCommonJSModule(null,W,new p.ExtensionActivationTimesBuilder(!1));if(!$||typeof $.run!="function")throw new Error(g.localize(1,null,W.toString()));return new Promise((X,K)=>{const de=(Pe,Be)=>{Pe?K(Pe):X(typeof Be=="number"&&Be>0?1:0)},_e=(0,S.originalFSPath)(W),Ce=$.run(_e,de);Ce&&Ce.then&&Ce.then(()=>{X(0)}).catch(Pe=>{K(Pe.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,W){return this._resolvers[O]=W,(0,_.toDisposable)(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const W=O.indexOf("+");if(W===-1)throw new Error("Not an authority that can be resolved!");const $=O.substr(0,W);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${$}`,!1),{authorityPrefix:$,resolver:this._resolvers[$]}}async $resolveAuthority(O,W){const{authorityPrefix:$,resolver:X}=await this._activateAndGetResolver(O);if(!X)return{type:"error",error:{code:f.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${$}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(X)),C.mark(`code/extHost/willResolveAuthority/${$}`);const K=await X.resolve(O,{resolveAttempt:W});C.mark(`code/extHost/didResolveAuthorityOK/${$}`);const de={authority:O,host:K.host,port:K.port,connectionToken:K.connectionToken},_e={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted};return{type:"ok",value:{authority:de,options:_e,tunnelInformation:{environmentTunnels:K.environmentTunnels}}}}catch(K){if(C.mark(`code/extHost/didResolveAuthorityError/${$}`),K instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(O,W){const{authorityPrefix:$,resolver:X}=await this._activateAndGetResolver(O);if(!X)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${$}`);const K=k.URI.revive(W);if(typeof X.getCanonicalURI=="undefined")return K;const de=await(0,P.asPromise)(()=>X.getCanonicalURI(K));return de||K}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,W){return W===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then($=>this._activateByEvent(O,!1))}async $activate(O,W){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,W),!0):!1}async $deltaExtensions(O,W){O.forEach(X=>X.extensionLocation=k.URI.revive(X.extensionLocation));const $=await this.getExtensionPathIndex();return await Promise.all(W.map(async X=>{const K=this._registry.getExtensionDescription(X);K&&$.delete(await this._realPathExtensionUri(K.extensionLocation))})),await Promise.all(O.map(async X=>{const K=await this._realPathExtensionUri(X.extensionLocation);$.set(K,X)})),this._registry.deltaExtensions(O,W),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let W=o.VSBuffer.alloc(O),$=Math.random()%256;for(let X=0;X<O;X++)W.writeUInt8($,X);return W}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};j=Ve([We(0,r.IInstantiationService),We(1,e.IHostUtils),We(2,s.IExtHostRpcService),We(3,w.IExtHostWorkspace),We(4,a.IExtHostConfiguration),We(5,i.ILogService),We(6,t.IExtHostInitDataService),We(7,d.IExtensionStoragePaths),We(8,m.IExtHostTunnelService),We(9,u.IExtHostTerminalService)],j),e.AbstractExtHostExtensionService=j;function U(z,O){return{id:z.identifier.value,name:z.name,extensionVersion:z.version,publisherDisplayName:z.publisher,activationEvents:z.activationEvents?z.activationEvents.join(","):null,isBuiltin:z.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class x{constructor(O,W,$,X){B.set(this,void 0),V.set(this,void 0),N.set(this,void 0),st(this,B,O,"f"),st(this,V,W,"f"),st(this,N,$.identifier,"f"),this.id=$.identifier.value,this.extensionUri=$.extensionLocation,this.extensionPath=F.normalize((0,S.originalFSPath)($.extensionLocation)),this.packageJSON=$,this.extensionKind=X}get isActive(){return Ne(this,B,"f").isActivated(Ne(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ne(this,B,"f").getExtensionExports(Ne(this,N,"f"))}activate(){return Ne(this,B,"f").activateByIdWithErrors(Ne(this,N,"f"),{startup:!1,extensionId:Ne(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=x,B=new WeakMap,V=new WeakMap,N=new WeakMap}),define(fe[57],me([0,1,8,2,3,15,5,7,126,36,41,45,217,37,211,14,4,12,38,56]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let o=class{constructor(c,m,u,E,R,L){this._workspaceService=m,this._extensionService=u,this._editorsService=E,this._configurationService=R,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=c.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new n(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(M=>{M.onDidChange(A=>{this.registerAllDebugTypes(M)}),this.registerAllDebugTypes(M)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,m){const u=c;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let E=`debug:${encodeURIComponent(u.path||"")}`,R="?";return m&&(E+=`${R}session=${encodeURIComponent(m.id)}`,R="&"),E+=`${R}ref=${u.sourceReference}`,F.URI.parse(E)}else{if(u.path)return F.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const m=[];for(const u of c.getAllExtensionDescriptions())if(u.contributes){const E=u.contributes.debuggers;if(E&&E.length>0)for(const R of E)(0,h.isDebuggerMainContribution)(R)&&m.push(R.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(m=>c.push(m)),c}addBreakpoints(c){this.startBreakpoints();const m=c.filter(R=>{const L=R.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,R),!0)});this.fireBreakpointChanges(m,[],[]);const u=[],E=new Map;for(const R of m)if(R instanceof _.SourceBreakpoint){let L=E.get(R.location.uri.toString());L||(L={type:"sourceMulti",uri:R.location.uri,lines:[]},E.set(R.location.uri.toString(),L),u.push(L)),L.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof _.FunctionBreakpoint&&u.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(c){this.startBreakpoints();const m=c.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],m,[]);const u=m.filter(L=>L instanceof _.SourceBreakpoint).map(L=>L.id),E=m.filter(L=>L instanceof _.FunctionBreakpoint).map(L=>L.id),R=m.filter(L=>L instanceof _.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(u,E,R)}startDebugging(c,m,u){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,m,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===_.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,debugUI:u.debugUI,suppressSaveBeforeStart:u.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,m,u){if(!m)return new _.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:E,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,u,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,E),new _.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(c,m,u){if(!u)return new _.Disposable(()=>{});if(!this.definesDebugType(c,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:E,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,E),new _.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(c,m){if(!m)return new _.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:u,factory:m}),new _.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==m)})}async $runInTerminal(c,m){return Promise.resolve(void 0)}async $substituteVariables(c,m){if(!this._variableResolver){const[R,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,L)}let u;const E=await this.getFolder(c);return E&&(u={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(u,m)}createDebugAdapter(c,m){if(c.type==="implementation")return new t(c.implementation)}createSignService(){}async $startDASession(c,m){const u=this,E=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const L=this.convertToDto(R),M=this.createDebugAdapter(L,E);if(!M)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const A=M;return this._debugAdapters.set(c,A),this.getDebugAdapterTrackers(E).then(B=>(B&&this._debugAdaptersTrackers.set(c,B),A.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const N=V,j={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(N.arguments.value);j.body={signature:U},A.sendResponse(j)}else throw new Error("no signer")}catch(U){j.success=!1,j.message=U.message,A.sendResponse(j)}}else B&&B.onDidSendMessage&&B.onDidSendMessage(V),V=(0,h.convertToVSCPaths)(V,!0),u._debugServiceProxy.$acceptDAMessage(c,V)}),A.onError(V=>{B&&B.onError&&B.onError(V),this._debugServiceProxy.$acceptDAError(c,V.name,V.message,V.stack)}),A.onExit(V=>{B&&B.onExit&&B.onExit((0,T.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,T.withNullAsUndefined)(V),void 0)}),B&&B.onWillStartSession&&B.onWillStartSession(),A.startSession()))})}$sendDAMessage(c,m){m=(0,h.convertToDAPaths)(m,!1);const u=this._debugAdaptersTrackers.get(c);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(m);const E=this._debugAdapters.get(c);E&&E.sendMessage(m)}$stopDASession(c){const m=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),m&&m.onWillStopSession&&m.onWillStopSession();const u=this._debugAdapters.get(c);return this._debugAdapters.delete(c),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const m=[],u=[],E=[];if(c.added)for(const R of c.added){const L=R.id;if(L&&!this._breakpoints.has(L)){let M;if(R.type==="function")M=new _.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")M=new _.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const A=F.URI.revive(R.uri);M=new _.SourceBreakpoint(new _.Location(A,new _.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}M._id=L,this._breakpoints.set(L,M),m.push(M)}}if(c.removed)for(const R of c.removed){const L=this._breakpoints.get(R);L&&(this._breakpoints.delete(R),u.push(L))}if(c.changed){for(const R of c.changed)if(R.id){const L=this._breakpoints.get(R.id);if(L){if(L instanceof _.FunctionBreakpoint&&R.type==="function"){const M=L;M.enabled=R.enabled,M.condition=R.condition,M.hitCondition=R.hitCondition,M.logMessage=R.logMessage,M.functionName=R.functionName}else if(L instanceof _.SourceBreakpoint&&R.type==="source"){const M=L;M.enabled=R.enabled,M.condition=R.condition,M.hitCondition=R.hitCondition,M.logMessage=R.logMessage,M.location=new _.Location(F.URI.revive(R.uri),new _.Position(R.line,R.character))}E.push(L)}}}this.fireBreakpointChanges(m,u,E)}$provideDebugConfigurations(c,m,u){return(0,S.asPromise)(async()=>{const E=this.getConfigProviderByHandle(c);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(m);return E.provideDebugConfigurations(R,u)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(c,m,u,E){return(0,S.asPromise)(async()=>{const R=this.getConfigProviderByHandle(c);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(m);return R.resolveDebugConfiguration(L,u,E)})}$resolveDebugConfigurationWithSubstitutedVariables(c,m,u,E){return(0,S.asPromise)(async()=>{const R=this.getConfigProviderByHandle(c);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(m);return R.resolveDebugConfigurationWithSubstitutedVariables(L,u,E)})}async $provideDebugAdapter(c,m){const u=this.getAdapterDescriptorFactoryByHandle(c);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(m);return this.getAdapterDescriptor(u,E).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(c){const m=await this.getSession(c);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(c){const m=await this.getSession(c);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,m){const u=await this.getSession(c);u&&u._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(c,m){const E={session:await this.getSession(c),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(c){if(c instanceof _.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof _.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof _.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof _.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const m=this._adapterFactories.filter(u=>u.type===c);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(c){const m=this._adapterFactories.filter(u=>u.handle===c);if(m.length>0)return m[0].factory}getConfigProviderByHandle(c){const m=this._configProviders.filter(u=>u.handle===c);if(m.length>0)return m[0].provider}definesDebugType(c,m){if(c.contributes){const u=c.contributes.debuggers;if(u&&u.length>0){for(const E of u)if(E.label&&E.type&&E.type===m)return!0}}return!1}getDebugAdapterTrackers(c){const u=c.configuration.type,E=this._trackerFactories.filter(R=>R.type===u||R.type==="*").map(R=>(0,S.asPromise)(()=>R.factory.createDebugAdapterTracker(c)).then(L=>L,L=>null));return Promise.race([Promise.all(E).then(R=>{const L=R.filter(M=>!!M);if(L.length>0)return new r(L)}),new Promise((R,L)=>{const M=setTimeout(()=>{clearTimeout(M),L(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(c,m){const u=m.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new _.DebugAdapterServer(u));if(c){const R=await this._extensionService.getExtensionRegistry();return(0,S.asPromise)(()=>c.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,R))).then(L=>{if(L)return L})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,E))}daExecutableFromPackage(c,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,m,u){(c.length>0||m.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:m,changed:u}))}async getSession(c){if(c)if(typeof c=="string"){const m=this._debugSessions.get(c);if(m)return m}else{let m=this._debugSessions.get(c.id);if(!m){const u=await this.getFolder(c.folderUri),E=c.parent?this._debugSessions.get(c.parent):void 0;m=new v(this._debugServiceProxy,c.id,c.type,c.name,u,c.configuration,E),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(c){if(c){const m=F.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};o=Ve([We(0,w.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,i.IExtHostExtensionService),We(3,I.IExtHostDocumentsAndEditors),We(4,p.IExtHostConfiguration),We(5,l.IExtHostEditorTabs)],o),e.ExtHostDebugServiceBase=o;class v{constructor(c,m,u,E,R,L,M){this._debugServiceProxy=c,this._id=m,this._type=u,this._name=E,this._workspaceFolder=R,this._configuration=L,this._parentSession=M}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,m)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=v;class n{constructor(c){this.value=Object.freeze({append(m){c.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=n;class f extends a.AbstractVariableResolverService{constructor(c,m,u,E,R){function L(){if(m){const M=m.activeEditor();if(M)return M.document.uri;const A=E.tabs.filter(B=>B.isActive);if(A.length>0){const B=A[0].resource;return B&&(B.primary||B.secondary)?B.primary??B.secondary:A[0].resource}}}super({getFolderUri:M=>{const A=c.filter(B=>B.name===M);if(A&&A.length>0)return A[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(M,A)=>u.getConfiguration(void 0,M).get(A),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const M=L();if(M)return g.normalize(M.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const M=L();if(M){const A=R.getWorkspaceFolder(M);if(A)return g.normalize(A.uri.fsPath)}}},getSelectedText:()=>{if(m){const M=m.activeEditor();if(M&&!M.selection.isEmpty)return M.document.getText(M.selection)}},getLineNumber:()=>{if(m){const M=m.activeEditor();if(M)return String(M.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=f;class r{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(m=>m.onError?m.onError(c):void 0)}onExit(c,m){this.trackers.forEach(u=>u.onExit?u.onExit(c,m):void 0)}}class t extends y.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let d=class extends o{constructor(c,m,u,E,R,L){super(c,m,u,E,R,L)}createVariableResolver(c,m,u){return new f(c,m,u,this._editorTabs)}};d=Ve([We(0,w.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,i.IExtHostExtensionService),We(3,I.IExtHostDocumentsAndEditors),We(4,p.IExtHostConfiguration),We(5,l.IExtHostEditorTabs)],d),e.WorkerExtHostDebugService=d}),define(fe[271],me([0,1,74,2,5,37,35,27,14,28,4,41,38,13]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(l,o,v,n,f,r,t){this._apiFactory=l,this._extensionRegistry=o,this._instaService=v,this._extHostConfiguration=n,this._extHostExtensionService=f,this._initData=r,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new w(this._apiFactory,o,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(D,o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(T,o,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let o of l.nodeModuleName)this._factories.set(o,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(o=>l.alternativeModuleName(o))}};h=Ve([We(2,i.IInstantiationService),We(3,S.IExtHostConfiguration),We(4,I.IExtHostExtensionService),We(5,k.IExtHostInitDataService),We(6,p.ILogService)],h),e.RequireInterceptor=h;class w{constructor(l,o,v,n,f){this._apiFactory=l,this._extensionPaths=o,this._extensionRegistry=v,this._configProvider=n,this._logService=f,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,o){const v=this._extensionPaths.findSubstr(o);if(v){let n=this._extApiImpl.get(_.ExtensionIdentifier.toKey(v.identifier));return n||(n=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(_.ExtensionIdentifier.toKey(v.identifier),n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((f,r)=>n+=`	${r} -> ${f.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(P.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let D=class{constructor(l,o,v){this._extensionPaths=l,this.nodeModuleName="keytar",this._mainThreadTelemetry=o.getProxy(C.MainContext.MainThreadTelemetry);const{environment:n}=v,f=o.getProxy(C.MainContext.MainThreadKeytar);if(n.appRoot){let r=n.appRoot.fsPath;a.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,t)=>f.$getPassword(r,t),setPassword:(r,t,d)=>f.$setPassword(r,t,d),deletePassword:(r,t)=>f.$deletePassword(r,t),findPassword:r=>f.$findPassword(r),findCredentials(r){return f.$findCredentials(r)}}}load(l,o){const v=this._extensionPaths.findSubstr(o);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:v?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(l){const o=l.length;if(o<=7||!this.alternativeNames)return;const v=o-7;if((l.charAt(v)==="/"||l.charAt(v)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}};D=Ve([We(1,y.IExtHostRpcService),We(2,k.IExtHostInitDataService)],D);let T=class{constructor(l,o,v){this._extensionPaths=l,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(C.MainContext.MainThreadTelemetry);const n=v.getProxy(C.MainContext.MainThreadWindow);this._impl=(f,r)=>{const t=F.URI.parse(f);return r?this.callOriginal(f,r):t.scheme==="http"||t.scheme==="https"?n.$openUri(t,f,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?n.$openUri(t,f,{}):this.callOriginal(f,r)}}load(l,o,v){const n=this._extensionPaths.findSubstr(o);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=v(l),this._impl}callOriginal(l,o){return this.sendNoForwardTelemetry(),this._original(l,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};T=Ve([We(2,y.IExtHostRpcService)],T)}),define(fe[272],me([0,1,172,11,7,212,36,41,45,37,33,14,57,196,15,213,56]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let T=class extends a.ExtHostDebugServiceBase{constructor(o,v,n,f,r,t,d){super(o,v,n,f,r,d);this._terminalService=t,this._integratedTerminalInstances=new b}createDebugAdapter(o,v){switch(o.type){case"server":return new S.SocketDebugAdapter(o);case"pipeServer":return new S.NamedPipeDebugAdapter(o);case"executable":return new S.ExecutableDebugAdapter(o,v.type)}return super.createDebugAdapter(o,v)}daExecutableFromPackage(o,v){const n=S.ExecutableDebugAdapter.platformAdapterExecutable(v.getAllExtensionDescriptions(),o.type);if(n)return new C.DebugAdapterExecutable(n.command,n.args,n.options)}createSignService(){return new p.SignService}async $runInTerminal(o,v){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const n=await this._configurationService.getConfigProvider(),f=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),t=o.title||g.localize(0,null),d=JSON.stringify({shell:f,shellArgs:r});let s=await this._integratedTerminalInstances.checkout(d,t),c,m=!1;if(s)c=o.cwd;else{const L={shellPath:f,shellArgs:r,cwd:o.cwd,name:t,iconPath:new C.ThemeIcon("debug")};m=!0,s=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(s,d)}s.show(!0);const u=await s.processId;m?await new Promise(L=>setTimeout(L,1e3)):n.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(f.indexOf("powershell")>=0||f.indexOf("pwsh")>=0||f.indexOf("cmd.exe")>=0?s.sendText("cls"):f.indexOf("bash")>=0?s.sendText("clear"):F.isWindows?s.sendText("cls"):s.sendText("clear"));const E=(0,w.prepareCommand)(f,o.args,c,o.env);s.sendText(E);const R=this.onDidTerminateDebugSession(L=>{L.id===v&&(this._integratedTerminalInstances.free(s),R.dispose())});return u}else if(o.kind==="external")return(0,w.runInExternalTerminal)(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,v)}createVariableResolver(o,v,n){return new a.ExtHostVariableResolverService(o,v,n,this._editorTabs,this._workspaceService)}};T=Ve([We(0,I.IExtHostRpcService),We(1,P.IExtHostWorkspace),We(2,_.IExtHostExtensionService),We(3,y.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,i.IExtHostTerminalService),We(6,D.IExtHostEditorTabs)],T),e.ExtHostDebugService=T;class b{constructor(){this._terminalInstances=new Map}async checkout(o,v){const f=[...this._terminalInstances.entries()].map(([r,t])=>(0,h.createCancelablePromise)(async d=>{if(r.name!==v||t.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await r.processId))return null;const s=Date.now();return t.lastUsedAt+b.minUseDelay>s||d.isCancellationRequested||t.config!==o?null:(t.lastUsedAt=s,r)}));return await(0,h.firstParallel)(f,r=>!!r)}insert(o,v){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:v})}free(o){const v=this._terminalInstances.get(o);v&&(v.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}b.minUseDelay=1e3}),define(fe[273],me([0,1,8,2,114,36,57,45,37,44,33,14,28,73,10,13,68,56,23,81]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let o=class extends p.ExtHostTaskBase{constructor(n,f,r,t,d,s,c,m,u){super(n,f,r,t,d,s,c,m);this.workspaceService=r,this.editorTabs=u,f.remote.isRemote&&f.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:f.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(n,f){const r=f;if(!f.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const t=p.TaskHandleDTO.from(r,this.workspaceService),d=await this._proxy.$getTaskExecution(t);if(d.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(d,f);return this._proxy.$executeTask(t).catch(()=>{}),s}else{const t=p.TaskDTO.from(f,n);if(t===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,f,!1);const d=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),f);return this._proxy.$executeTask(t).catch(()=>{}),d}}provideTasksInternal(n,f,r,t){const d=[];if(t)for(let s of t){this.checkDeprecation(s,r),(!s.definition||!n[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const c=p.TaskDTO.from(s,r.extension);c&&(d.push(c),p.CustomExecutionDTO.is(c.execution)&&f.push(this.addCustomExecution(c,s,!0)))}return{tasks:d,extension:r.extension}}async resolveTaskInternal(n){return n}async getVariableResolver(n){if(this._variableResolver===void 0){const f=await this._configurationService.getConfigProvider();this._variableResolver=new P.ExtHostVariableResolverService(n,this._editorService,f,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(n){let f=n&&n.length>0?n[0]:void 0;if(!f){const r=F.URI.file((0,l.homedir)());f=new k.WorkspaceFolder({uri:r,name:b.basename(r),index:0})}return{uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(n,f){const r=F.URI.revive(n),t={process:void 0,variables:Object.create(null)},d=await this._workspaceProvider.resolveWorkspaceFolder(r),s=await this._workspaceProvider.getWorkspaceFolders2()??[],c=await this.getVariableResolver(s),m=d?{uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(s);for(let u of f.variables)t.variables[u]=await c.resolveAsync(m,u);if(f.process!==void 0){let u;if(f.process.path!==void 0){u=f.process.path.split(g.delimiter);for(let E=0;E<u.length;E++)u[E]=await c.resolveAsync(m,u[E])}t.process=await C.win32.findExecutable(await c.resolveAsync(m,f.process.name),f.process.cwd!==void 0?await c.resolveAsync(m,f.process.cwd):void 0,u)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(n,f,r){return C.win32.findExecutable(n,f,r)}};o=Ve([We(0,I.IExtHostRpcService),We(1,a.IExtHostInitDataService),We(2,S.IExtHostWorkspace),We(3,_.IExtHostDocumentsAndEditors),We(4,y.IExtHostConfiguration),We(5,i.IExtHostTerminalService),We(6,w.ILogService),We(7,D.IExtHostApiDeprecationService),We(8,T.IExtHostEditorTabs)],o),e.ExtHostTask=o}),define(fe[274],me([0,1,15,17,74,6,2,5,266,13,83,85,28,190,14,67,41,33]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(o,v,n,f){this._disposables=new S.DisposableStore,this._isTerminating=!1,this._hostUtils=n,this._rpcProtocol=new y.RPCProtocol(o,null,f),v=b._transform(v,this._rpcProtocol);const r=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());r.set(a.IExtHostInitDataService,{_serviceBrand:void 0,...v}),r.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),r.set(w.IURITransformerService,new w.URITransformerService(f)),r.set(D.IHostUtils,n);const t=new p.InstantiationService(r,!0),d=t.invokeFunction(u=>u.get(T.IExtHostTerminalService));this._disposables.add(d),this._logService=t.invokeFunction(u=>u.get(k.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=t.invokeFunction(u=>u.get(D.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const s=new WeakMap;this._extensionService.getExtensionPathIndex().then(u=>{Error.prepareStackTrace=(E,R)=>{let L="",M,A;for(const B of R)L+=`
	at ${B.toString()}`,A=B.getFileName(),!M&&A&&(M=u.findSubstr(P.URI.file(A)));return s.set(E,M),`${E.name||"Error"}: ${E.message||""}${L}`}});const c=this._rpcProtocol.getProxy(_.MainContext.MainThreadExtensionService),m=this._rpcProtocol.getProxy(_.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(u=>{const E=F.transformErrorForSerialization(u),R=s.get(u);R?c.$onExtensionRuntimeError(R.identifier,E):m.$onUnexpectedError(E)})}terminate(o){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${o}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(n=>{this._logService.error(n)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(o,v){o.extensions.forEach(f=>f.extensionLocation=P.URI.revive(v.transformIncomingURIs(f.extensionLocation))),o.environment.appRoot=P.URI.revive(v.transformIncomingURIs(o.environment.appRoot));const n=o.environment.extensionDevelopmentLocationURI;return n&&(o.environment.extensionDevelopmentLocationURI=n.map(f=>P.URI.revive(v.transformIncomingURIs(f)))),o.environment.extensionTestsLocationURI=P.URI.revive(v.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=P.URI.revive(v.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=P.URI.revive(v.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=P.URI.revive(v.transformIncomingURIs(o.logsLocation)),o.logFile=P.URI.revive(v.transformIncomingURIs(o.logFile)),o.workspace=v.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=b}),define(fe[275],me([0,1,8,21,52,30,23,46,31]),function(Y,e,g,F,C,S,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(a,p,h){this.config=a,this.provider=p,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=a.filePattern,this.includePattern=a.includePattern&&S.parse(a.includePattern),this.maxResults=a.maxResults||void 0,this.exists=a.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=a.excludePattern&&S.parse(a.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(a=>a.cancel()),this.activeCancellationTokens=new Set}search(a){const p=this.config.folderQueries||[];return new Promise((h,w)=>{const D=T=>{this.resultCount++,a(T)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(T=>{const b=T.toString(),l=g.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,l)||this.matchFile(D,{base:T,basename:l})}),Promise.all(p.map(T=>this.searchInFolder(T,D))).then(T=>{h({limitHit:this.isLimitHit,stats:T[0]||void 0})},T=>{w(new Error((0,C.toErrorMessage)(T)))})})}async searchInFolder(a,p){const h=new F.CancellationTokenSource,w=this.getSearchOptionsForFolder(a),D=this.initDirectoryTree(),T=new y.QueryGlobTester(this.config,a),b=!T.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(h),l=_.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,h.token),v=l.elapsed(),n=_.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(f=>{const r=g.posix.relative(a.folder.path,f.path);if(b){const t=g.basename(f.path);this.matchFile(p,{base:a.folder,relativePath:r,basename:t});return}this.addDirectoryEntries(D,a.folder,r,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(D,T,p),{providerTime:v,postProcessTime:n.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(a){const p=(0,y.resolvePatternsForProvider)(this.config.includePattern,a.includePattern),h=(0,y.resolvePatternsForProvider)(this.config.excludePattern,a.excludePattern);return{folder:a.folder,excludes:h,includes:p,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries({pathToEntries:a},p,h,w){if(h===this.filePattern){const T=g.basename(this.filePattern);this.matchFile(w,{base:p,relativePath:this.filePattern,basename:T})}function D(T){const b=g.basename(T),l=g.dirname(T);let o=a[l];o||(o=a[l]=[],D(l)),o.push({base:p,relativePath:T,basename:b})}D(h)}matchDirectoryTree({rootEntries:a,pathToEntries:p},h,w){const D=this,T=this.filePattern;function b(l){const o=S.hasSiblingFn(()=>l.map(v=>v.basename));for(let v=0,n=l.length;v<n;v++){const f=l[v],{relativePath:r,basename:t}=f;if(h.matchesExcludesSync(r,t,T!==t?o:void 0))continue;const d=p[r];if(d)b(d);else{if(r===T)continue;D.matchFile(w,f)}if(D.isLimitHit)break}}b(a)}matchFile(a,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||a(p))}}class i{constructor(){this.sessions=new Map}fileSearch(a,p,h,w){const D=this.getSessionTokenSource(a.cacheKey),T=new k(a,p,D&&D.token);let b=0;const l=o=>{b+=o.length,h(o.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(T,i.BATCH_SIZE,l,w).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:o.stats}}))}clearCache(a){const p=this.getSessionTokenSource(a);p&&p.cancel()}getSessionTokenSource(a){if(!!a)return this.sessions.has(a)||this.sessions.set(a,new F.CancellationTokenSource),this.sessions.get(a)}rawMatchToSearchItem(a){return a.relativePath?{resource:P.joinPath(a.base,a.relativePath)}:{resource:a.base}}doSearch(a,p,h,w){w.onCancellationRequested(()=>{a.cancel()});const D=b=>{b&&(T.push(b),p>0&&T.length>=p&&(h(T),T=[]))};let T=[];return a.search(D).then(b=>(T.length&&h(T),b),b=>(T.length&&h(T),Promise.reject(b)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(fe[135],me([0,1,18,21,52,30,10,8,23,12,2,31]),function(Y,e,g,F,C,S,P,_,y,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class a{constructor(l,o,v,n){this.query=l,this.provider=o,this.fileUtils=v,this.processType=n,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,o){const v=this.query.folderQueries||[],n=new F.CancellationTokenSource;return o.onCancellationRequested(()=>n.cancel()),new Promise((f,r)=>{this.collector=new h(l);let t=!1;const d=(s,c)=>{if(!t&&!this.isLimitHit){const m=this.resultSize(s);D(s)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,t=!0,n.cancel(),s=this.trimResultToSize(s,this.query.maxResults-this.resultCount));const u=this.resultSize(s);this.resultCount+=u,(u>0||!D(s))&&this.collector.add(s,c)}};Promise.all(v.map((s,c)=>this.searchInFolder(s,m=>d(m,c),n.token))).then(s=>{n.dispose(),this.collector.flush();const c=s.some(m=>!!m&&!!m.limitHit);f({limitHit:this.isLimitHit||c,messages:(0,g.flatten)(s.map(m=>m?.message?(0,k.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},s=>{n.dispose();const c=(0,C.toErrorMessage)(s);r(new Error(c))})})}resultSize(l){return D(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,o){const v=Array.isArray(l.ranges)?l.ranges:[l.ranges],n=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:v.slice(0,o),preview:{matches:n.slice(0,o),text:l.preview.text},uri:l.uri}}async searchInFolder(l,o,v){const n=new I.QueryGlobTester(this.query,l),f=[],r={report:s=>{if(!this.validateProviderResult(s))return;const c=l.folder.scheme===P.Schemas.file?S.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(s.uri))):void 0,m=y.relativePath(l.folder,s.uri);if(m){const u=n.includedInQuery(m,_.basename(m),c);(0,k.isPromise)(u)?f.push(u.then(E=>{E&&o(s)})):u&&o(s)}}},t=this.getSearchOptionsForFolder(l),d=await this.provider.provideTextSearchResults(p(this.query.contentPattern),t,r,v);return f.length&&await Promise.all(f),d}validateProviderResult(l){if(D(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const o=(0,I.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),v=(0,I.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),n={folder:i.URI.from(l.folder),excludes:v,includes:o,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return n.usePCRE2=this.query.usePCRE2,n}}e.TextSearchManager=a;function p(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class h{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new T(512,o=>this.sendItems(o))}add(l,o){this._currentFileMatch&&(this._currentFolderIdx!==o||!y.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=o,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(w(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=h;function w(b){return D(b)?{preview:{matches:(0,g.mapArrayOrNot)(b.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:b.preview.text},ranges:(0,g.mapArrayOrNot)(b.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function D(b){return!!b.preview}e.extensionResultIsMatch=D;class T{constructor(l,o){this.maxBatchSize=l,this.cb=o,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,o){!l||this.addItemToBatch(l,o)}addItems(l,o){!l||this.addItemsToBatch(l,o)}addItemToBatch(l,o){this.batch.push(l),this.batchSize+=o,this.onUpdate()}addItemsToBatch(l,o){this.batch=this.batch.concat(l),this.batchSize+=o,this.onUpdate()}onUpdate(){this.totalNumberCompleted<T.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},T.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=T,T.TIMEOUT=4e3,T.START_BATCH_AFTER_COUNT=50}),define(fe[75],me([0,1,6,5,4,275,14,67,13,2,135]),function(Y,e,g,F,C,S,P,_,y,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let I=class{constructor(w,D,T){this.extHostRpc=w,this._uriTransformer=D,this._logService=T,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new S.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,D){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const T=this._handlePool++;return this._textSearchProvider.set(T,D),this._proxy.$registerTextSearchProvider(T,this._transformScheme(w)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}registerFileSearchProvider(w,D){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const T=this._handlePool++;return this._fileSearchProvider.set(T,D),this._proxy.$registerFileSearchProvider(T,this._transformScheme(w)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}$provideFileSearchResults(w,D,T,b){const l=a(T),o=this._fileSearchProvider.get(w);if(o)return this._fileSearchManager.fileSearch(l,o,v=>{this._proxy.$handleFileMatch(w,D,v.map(n=>n.resource))},b);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,D,T,b){const l=this._textSearchProvider.get(w);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const o=a(T);return this.createTextSearchManager(o,l).search(n=>this._proxy.$handleTextMatch(w,D,n),b)}$enableExtensionHostSearch(){}createTextSearchManager(w,D){return new i.TextSearchManager(w,D,{readdir:T=>Promise.resolve([]),toCanonicalName:T=>T},"textSearchProvider")}};I=Ve([We(0,P.IExtHostRpcService),We(1,_.IURITransformerService),We(2,y.ILogService)],I),e.ExtHostSearch=I;function a(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(p),extraFileResources:h.extraFileResources&&h.extraFileResources.map(w=>k.URI.revive(w))}}e.reviveQuery=a;function p(h){return{...h,folder:k.URI.revive(h.folder)}}}),define(fe[276],me([0,1,21,17,3,49,2,115,110,148,82,43,5,234,233,40,235,37,236,237,238,219,239,45,41,240,220,243,244,245,69,222,250,251,252,92,33,254,223,16,7,257,71,134,36,35,59,208,242,64,133,73,57,75,13,67,14,28,246,205,54,68,231,255,204,70,91,260,258,259,232,53,253,256,90,56,124,248,72,249,10,192,247,202,241]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T,b,l,o,v,n,f,r,t,d,s,c,m,u,E,R,L,M,A,B,V,N,j,U,x,z,O,W,$,X,K,de,_e,Ce,Pe,Be,$e,He,G,ee,te,ce,Z,re,pe,Me,je,Ke,Ze,rt,ct,ye,at,J,se,Ee,Qe,et,le,Ie,Ue,Xe,it,ft,tt,ut,Re,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Te(oe){const ue=oe.get(te.IExtHostInitDataService),we=oe.get(se.IExtHostFileSystemInfo),ve=oe.get(rt.IExtHostConsumerFileSystem),Fe=oe.get(r.IExtHostExtensionService),Ge=oe.get(W.IExtHostWorkspace),ze=oe.get(Ie.IExtHostTelemetry),Ye=oe.get(T.IExtHostConfiguration),lt=oe.get(G.IURITransformerService),xe=oe.get(ee.IExtHostRpcService),ge=oe.get(A.IExtHostStorage),be=oe.get(Ze.IExtensionStoragePaths),ie=oe.get(He.ILogService),Q=oe.get(re.IExtHostTunnelService),Se=oe.get(pe.IExtHostApiDeprecationService),Le=oe.get(O.IExtHostWindow),nt=oe.get(et.IExtHostSecretState),qe=oe.get(le.IExtHostEditorTabs);xe.set(a.ExtHostContext.ExtHostFileSystemInfo,we),xe.set(a.ExtHostContext.ExtHostLogService,ie),xe.set(a.ExtHostContext.ExtHostWorkspace,Ge),xe.set(a.ExtHostContext.ExtHostConfiguration,Ye),xe.set(a.ExtHostContext.ExtHostExtensionService,Fe),xe.set(a.ExtHostContext.ExtHostStorage,ge),xe.set(a.ExtHostContext.ExtHostTunnelService,Q),xe.set(a.ExtHostContext.ExtHostWindow,Le),xe.set(a.ExtHostContext.ExtHostSecretState,nt),xe.set(a.ExtHostContext.ExtHostTelemetry,ze),xe.set(a.ExtHostContext.ExtHostEditorTabs,qe);const gt=xe.set(a.ExtHostContext.ExtHostDecorations,oe.get(Ce.IExtHostDecorations)),Et=xe.set(a.ExtHostContext.ExtHostDocumentsAndEditors,oe.get(f.IExtHostDocumentsAndEditors)),pt=xe.set(a.ExtHostContext.ExtHostCommands,oe.get(w.IExtHostCommands)),vt=xe.set(a.ExtHostContext.ExtHostTerminalService,oe.get(B.IExtHostTerminalService)),wt=xe.set(a.ExtHostContext.ExtHostDebugService,oe.get(Be.IExtHostDebugService)),Dt=xe.set(a.ExtHostContext.ExtHostSearch,oe.get($e.IExtHostSearch)),Ct=xe.set(a.ExtHostContext.ExtHostTask,oe.get(Pe.IExtHostTask)),Tt=xe.set(a.ExtHostContext.ExtHostOutputService,oe.get(u.IExtHostOutputService)),Nt=xe.set(a.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(xe)),It=xe.set(a.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(xe,Et)),Ut=xe.set(a.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(xe,Et,ie)),$t=xe.set(a.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(ie,It,xe.getProxy(a.MainContext.MainThreadBulkEdits))),St=xe.set(a.ExtHostContext.ExtHostNotebook,new ce.ExtHostNotebookController(xe,pt,Et,It,be)),Qt=xe.set(a.ExtHostContext.ExtHostNotebookDocuments,new Re.ExtHostNotebookDocuments(ie,St)),zt=xe.set(a.ExtHostContext.ExtHostNotebookEditors,new ut.ExtHostNotebookEditors(ie,xe,St)),nn=xe.set(a.ExtHostContext.ExtHostNotebookKernels,new Ue.ExtHostNotebookKernels(xe,ue,St,pt,ie)),rn=xe.set(a.ExtHostContext.ExtHostNotebookRenderers,new it.ExtHostNotebookRenderers(xe,St)),At=xe.set(a.ExtHostContext.ExtHostEditors,new V.ExtHostEditors(xe,Et)),Xt=xe.set(a.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(xe.getProxy(a.MainContext.MainThreadTreeViews),pt,ie)),sn=xe.set(a.ExtHostContext.ExtHostEditorInsets,new K.ExtHostEditorInsets(xe.getProxy(a.MainContext.MainThreadEditorInsets),At,ue)),Yt=xe.set(a.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(xe,ie,we)),Wt=xe.set(a.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(xe,It,pt.converter,lt)),bt=xe.set(a.ExtHostContext.ExtHostLanguageFeatures,new s.ExtHostLanguageFeatures(xe,lt,It,pt,Yt,ie,Se)),on=xe.set(a.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(xe,bt)),Ft=xe.set(a.ExtHostContext.ExtHostFileSystemEventService,new d.ExtHostFileSystemEventService(xe,ie,Et)),Vt=xe.set(a.ExtHostContext.ExtHostQuickOpen,(0,R.createExtHostQuickOpen)(xe,Ge,pt)),Jt=xe.set(a.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(xe,pt,ie)),an=xe.set(a.ExtHostContext.ExtHostComments,(0,D.createExtHostComments)(xe,pt,It)),hn=xe.set(a.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(xe.getProxy(a.MainContext.MainThreadProgress))),bn=xe.set(a.ExtHostContext.ExtHosLabelService,new de.ExtHostLabelService(xe)),fn=xe.set(a.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(xe)),Zt=xe.set(a.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(xe)),En=xe.set(a.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(xe,pt)),jt=xe.set(a.ExtHostContext.ExtHostWebviews,new z.ExtHostWebviews(xe,{remote:ue.remote},Ge,ie,Se)),qt=xe.set(a.ExtHostContext.ExtHostWebviewPanels,new at.ExtHostWebviewPanels(xe,jt,Ge)),_n=xe.set(a.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(xe,It,be,jt,qt)),Sn=xe.set(a.ExtHostContext.ExtHostWebviewViews,new ct.ExtHostWebviewViews(xe,jt)),Gt=xe.set(a.ExtHostContext.ExtHostTesting,new Ee.ExtHostTesting(xe,pt)),yn=xe.set(a.ExtHostContext.ExtHostUriOpeners,new Qe.ExtHostUriOpeners(xe));xe.set(a.ExtHostContext.ExtHostInteractive,new De.ExtHostInteractive(xe,St,Et,pt));const en=(0,X.values)(a.ExtHostContext);xe.assertRegistered(en);const Dn=new J.ExtHostBulkEdits(xe,Et),Cn=new h.ExtHostClipboard(xe),Kt=new m.ExtHostMessageService(xe,ie),mn=new l.ExtHostDialogs(xe),Ht=new M.ExtHostStatusBar(xe,pt.converter);return p.ExtHostApiCommands.register(pt),function(Oe,ln,Lt){const _t=function(){let ne=!Oe.isUnderDevelopment;function he(Ae){ne||(ie.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Ae(ht){if(Array.isArray(ht))ht.forEach(Ae);else if(typeof ht=="string")he(ht);else{const yt=ht;typeof yt.scheme=="undefined"&&he(ht),!Oe.enableProposedApi&&typeof yt.exclusive=="boolean"&&(0,$.throwProposedApiError)(Oe)}return ht}}(),kn={getSession(ne,he,Ae){return(Ae?.forceNewSession||Ae?.silent)&&(0,$.checkProposedApiEnabled)(Oe),Zt.getSession(Oe,ne,he,Ae)},async hasSession(ne,he){return(0,$.checkProposedApiEnabled)(Oe),!!await Zt.getSession(Oe,ne,he,{solelyCheckExistence:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(ne,he,Ae,ht){return Zt.registerAuthenticationProvider(ne,he,Ae,ht)}},In={registerCommand(ne,he,Ae){return pt.registerCommand(!0,ne,he,Ae,void 0,Oe)},registerTextEditorCommand(ne,he,Ae){return pt.registerCommand(!0,ne,(...ht)=>{const yt=At.getActiveTextEditor();if(!yt){ie.warn("Cannot execute "+ne+" because there is no active text editor.");return}return yt.edit(Pt=>{he.apply(Ae,[yt,Pt,...ht])}).then(Pt=>{Pt||ie.warn("Edits from command "+ne+" were not applied.")},Pt=>{ie.warn("An error occurred while running command "+ne,Pt)})},void 0,void 0,Oe)},registerDiffInformationCommand:(ne,he,Ae)=>((0,$.checkProposedApiEnabled)(Oe),pt.registerCommand(!0,ne,async(...ht)=>{const yt=Et.activeEditor(!0);if(!yt){ie.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Pt=await At.getDiffInformation(yt.id);he.apply(Ae,[Pt,...ht])},void 0,void 0,Oe)),executeCommand(ne,...he){return pt.executeCommand(ne,...he)},getCommands(ne=!1){return pt.getCommands(ne)}},gn={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return Cn.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ne=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,he){return Le.openUri(ne,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===ue.environment.appUriScheme)return Nt.createAppUri(ne);try{return await Le.asExternalUri(ne,{allowTunneling:!!ue.remote.authority})}catch(he){if((0,tt.matchesScheme)(ne,ft.Schemas.http)||(0,tt.matchesScheme)(ne,ft.Schemas.https))return ne;throw he}},get remoteName(){return(0,_e.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,$.checkProposedApiEnabled)(Oe),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=ue.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Pn={createTestController(ne,he){return Gt.createTestController(ne,he)},createTestObserver(){return(0,$.checkProposedApiEnabled)(Oe),Gt.createTestObserver()},runTests(ne){return(0,$.checkProposedApiEnabled)(Oe),Gt.runTests(ne)},get onDidChangeTestResults(){return(0,$.checkProposedApiEnabled)(Oe),Gt.onResultsChanged},get testResults(){return(0,$.checkProposedApiEnabled)(Oe),Gt.results}},Tn={getExtension(ne){const he=ln.getExtensionDescription(ne);if(he)return new r.Extension(Fe,Oe.identifier,he,pn)},get all(){return ln.getAllExtensionDescriptions().map(ne=>new r.Extension(Fe,Oe.identifier,ne,pn))},get onDidChange(){return ln.onDidChange}},An={createDiagnosticCollection(ne){return Yt.createDiagnosticCollection(Oe.identifier,ne)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:ne=>Yt.getDiagnostics(ne),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(ne,he){return Wt.changeLanguage(ne.uri,he)},match(ne,he){return(0,i.score)(j.LanguageSelector.from(ne),he.uri,he.languageId,!0)},registerCodeActionsProvider(ne,he,Ae){return bt.registerCodeActionProvider(Oe,_t(ne),he,Ae)},registerCodeLensProvider(ne,he){return bt.registerCodeLensProvider(Oe,_t(ne),he)},registerDefinitionProvider(ne,he){return bt.registerDefinitionProvider(Oe,_t(ne),he)},registerDeclarationProvider(ne,he){return bt.registerDeclarationProvider(Oe,_t(ne),he)},registerImplementationProvider(ne,he){return bt.registerImplementationProvider(Oe,_t(ne),he)},registerTypeDefinitionProvider(ne,he){return bt.registerTypeDefinitionProvider(Oe,_t(ne),he)},registerHoverProvider(ne,he){return bt.registerHoverProvider(Oe,_t(ne),he,Oe.identifier)},registerEvaluatableExpressionProvider(ne,he){return bt.registerEvaluatableExpressionProvider(Oe,_t(ne),he,Oe.identifier)},registerInlineValuesProvider(ne,he){return bt.registerInlineValuesProvider(Oe,_t(ne),he,Oe.identifier)},registerDocumentHighlightProvider(ne,he){return bt.registerDocumentHighlightProvider(Oe,_t(ne),he)},registerLinkedEditingRangeProvider(ne,he){return bt.registerLinkedEditingRangeProvider(Oe,_t(ne),he)},registerReferenceProvider(ne,he){return bt.registerReferenceProvider(Oe,_t(ne),he)},registerRenameProvider(ne,he){return bt.registerRenameProvider(Oe,_t(ne),he)},registerDocumentSymbolProvider(ne,he,Ae){return bt.registerDocumentSymbolProvider(Oe,_t(ne),he,Ae)},registerWorkspaceSymbolProvider(ne){return bt.registerWorkspaceSymbolProvider(Oe,ne)},registerDocumentFormattingEditProvider(ne,he){return bt.registerDocumentFormattingEditProvider(Oe,_t(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return bt.registerDocumentRangeFormattingEditProvider(Oe,_t(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Ae,...ht){return bt.registerOnTypeFormattingEditProvider(Oe,_t(ne),he,[Ae].concat(ht))},registerDocumentSemanticTokensProvider(ne,he,Ae){return bt.registerDocumentSemanticTokensProvider(Oe,_t(ne),he,Ae)},registerDocumentRangeSemanticTokensProvider(ne,he,Ae){return bt.registerDocumentRangeSemanticTokensProvider(Oe,_t(ne),he,Ae)},registerSignatureHelpProvider(ne,he,Ae,...ht){return typeof Ae=="object"?bt.registerSignatureHelpProvider(Oe,_t(ne),he,Ae):bt.registerSignatureHelpProvider(Oe,_t(ne),he,typeof Ae=="undefined"?[]:[Ae,...ht])},registerCompletionItemProvider(ne,he,...Ae){return bt.registerCompletionItemProvider(Oe,_t(ne),he,Ae)},registerInlineCompletionItemProvider(ne,he){return(0,$.checkProposedApiEnabled)(Oe),bt.registerInlineCompletionsProvider(Oe,_t(ne),he)},registerDocumentLinkProvider(ne,he){return bt.registerDocumentLinkProvider(Oe,_t(ne),he)},registerColorProvider(ne,he){return bt.registerColorProvider(Oe,_t(ne),he)},registerFoldingRangeProvider(ne,he){return bt.registerFoldingRangeProvider(Oe,_t(ne),he)},registerSelectionRangeProvider(ne,he){return bt.registerSelectionRangeProvider(Oe,ne,he)},registerCallHierarchyProvider(ne,he){return bt.registerCallHierarchyProvider(Oe,ne,he)},registerTypeHierarchyProvider(ne,he){return bt.registerTypeHierarchyProvider(Oe,ne,he)},setLanguageConfiguration:(ne,he)=>bt.setLanguageConfiguration(Oe,ne,he),getTokenInformationAtPosition(ne,he){return(0,$.checkProposedApiEnabled)(Oe),Wt.tokenAtPosition(ne,he)},registerInlayHintsProvider(ne,he){return(0,$.checkProposedApiEnabled)(Oe),bt.registerInlayHintsProvider(Oe,ne,he)},createLanguageStatusItem(ne,he){return(0,$.checkProposedApiEnabled)(Oe),Wt.createLanguageStatusItem(Oe,ne,he)}},cn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(ne,he,Ae){const ht=await(P.URI.isUri(ne)?Promise.resolve(vn.openTextDocument(ne)):Promise.resolve(ne));return At.showTextDocument(ht,he,Ae)},createTextEditorDecorationType(ne){return At.createTextEditorDecorationType(Oe,ne)},onDidChangeActiveTextEditor(ne,he,Ae){return At.onDidChangeActiveTextEditor(ne,he,Ae)},onDidChangeVisibleTextEditors(ne,he,Ae){return At.onDidChangeVisibleTextEditors(ne,he,Ae)},onDidChangeTextEditorSelection(ne,he,Ae){return At.onDidChangeTextEditorSelection(ne,he,Ae)},onDidChangeTextEditorOptions(ne,he,Ae){return At.onDidChangeTextEditorOptions(ne,he,Ae)},onDidChangeTextEditorVisibleRanges(ne,he,Ae){return At.onDidChangeTextEditorVisibleRanges(ne,he,Ae)},onDidChangeTextEditorViewColumn(ne,he,Ae){return At.onDidChangeTextEditorViewColumn(ne,he,Ae)},onDidCloseTerminal(ne,he,Ae){return vt.onDidCloseTerminal(ne,he,Ae)},onDidOpenTerminal(ne,he,Ae){return vt.onDidOpenTerminal(ne,he,Ae)},onDidChangeActiveTerminal(ne,he,Ae){return vt.onDidChangeActiveTerminal(ne,he,Ae)},onDidChangeTerminalDimensions(ne,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),vt.onDidChangeTerminalDimensions(ne,he,Ae)},onDidChangeTerminalState(ne,he,Ae){return vt.onDidChangeTerminalState(ne,he,Ae)},onDidWriteTerminalData(ne,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),vt.onDidWriteTerminalData(ne,he,Ae)},get state(){return Le.state},onDidChangeWindowState(ne,he,Ae){return Le.onDidChangeWindowState(ne,he,Ae)},showInformationMessage(ne,...he){return Kt.showMessage(Oe,S.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return Kt.showMessage(Oe,S.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return Kt.showMessage(Oe,S.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Ae){return Vt.showQuickPick(ne,!!Oe.enableProposedApi,he,Ae)},showWorkspaceFolderPick(ne){return Vt.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return Vt.showInput(ne,he)},showOpenDialog(ne){return mn.showOpenDialog(ne)},showSaveDialog(ne){return mn.showSaveDialog(ne)},createStatusBarItem(ne,he,Ae){let ht,yt,Pt;return typeof ne=="string"?(ht=ne,yt=he,Pt=Ae):(yt=ne,Pt=he),Ht.createStatusBarEntry(Oe,ht,yt,Pt)},setStatusBarMessage(ne,he){return Ht.setStatusBarMessage(ne,he)},withScmProgress(ne){return Se.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),hn.withProgress(Oe,{location:U.ProgressLocation.SourceControl},(he,Ae)=>ne({report(ht){}}))},withProgress(ne,he){return hn.withProgress(Oe,ne,he)},createOutputChannel(ne){return Tt.createOutputChannel(ne,Oe)},createWebviewPanel(ne,he,Ae,ht){return qt.createWebviewPanel(Oe,ne,he,Ae,ht)},createWebviewTextEditorInset(ne,he,Ae,ht){return(0,$.checkProposedApiEnabled)(Oe),sn.createWebviewEditorInset(ne,he,Ae,ht,Oe)},createTerminal(ne,he,Ae){return typeof ne=="object"?("location"in ne&&(0,$.checkProposedApiEnabled)(Oe),"pty"in ne?vt.createExtensionTerminal(ne):vt.createTerminalFromOptions(ne)):vt.createTerminal(ne,he,Ae)},registerTerminalLinkProvider(ne){return vt.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,he){return vt.registerProfileProvider(Oe,ne,he)},registerTreeDataProvider(ne,he){return Xt.registerTreeDataProvider(ne,he,Oe)},createTreeView(ne,he){return Xt.createTreeView(ne,he,Oe)},registerWebviewPanelSerializer:(ne,he)=>qt.registerWebviewPanelSerializer(Oe,ne,he),registerCustomEditorProvider:(ne,he,Ae={})=>_n.registerCustomEditorProvider(Oe,ne,he,Ae),registerFileDecorationProvider(ne){return gt.registerFileDecorationProvider(ne,Oe.identifier)},registerUriHandler(ne){return Nt.registerUriHandler(Oe.identifier,ne)},createQuickPick(){return Vt.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return Vt.createInputBox(Oe.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Ae){return fn.onDidChangeActiveColorTheme(ne,he,Ae)},registerWebviewViewProvider(ne,he,Ae){return Sn.registerWebviewViewProvider(Oe,ne,he,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,$.checkProposedApiEnabled)(Oe),St.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),St.onDidChangeActiveNotebookEditor(ne,he,Ae)},get visibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Oe),St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,$.checkProposedApiEnabled)(Oe),St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),zt.onDidChangeNotebookEditorSelection(ne,he,Ae)},onDidChangeNotebookEditorVisibleRanges(ne,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),zt.onDidChangeNotebookEditorVisibleRanges(ne,he,Ae)},showNotebookDocument(ne,he){return(0,$.checkProposedApiEnabled)(Oe),St.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),yn.registerExternalUriOpener(Oe.identifier,ne,he,Ae)},get tabs(){return(0,$.checkProposedApiEnabled)(Oe),qe.tabs},get activeTab(){return(0,$.checkProposedApiEnabled)(Oe),qe.activeTab},get onDidChangeTabs(){return(0,$.checkProposedApiEnabled)(Oe),qe.onDidChangeTabs},get onDidChangeActiveTab(){return(0,$.checkProposedApiEnabled)(Oe),qe.onDidChangeActiveTab},getInlineCompletionItemController(ne){return(0,$.checkProposedApiEnabled)(Oe),s.InlineCompletionController.get(ne)}},vn={get rootPath(){return Se.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ge.getPath()},set rootPath(ne){throw F.readonly()},getWorkspaceFolder(ne){return Ge.getWorkspaceFolder(ne)},get workspaceFolders(){return Ge.getWorkspaceFolders()},get name(){return Ge.name},set name(ne){throw F.readonly()},get workspaceFile(){return Ge.workspaceFile},set workspaceFile(ne){throw F.readonly()},updateWorkspaceFolders:(ne,he,...Ae)=>Ge.updateWorkspaceFolders(Oe,ne,he||0,...Ae),onDidChangeWorkspaceFolders:function(ne,he,Ae){return Ge.onDidChangeWorkspace(ne,he,Ae)},asRelativePath:(ne,he)=>Ge.getRelativePath(ne,he),findFiles:(ne,he,Ae,ht)=>Ge.findFiles(j.GlobPattern.from(ne),j.GlobPattern.from(he),Ae,Oe.identifier,ht),findTextInFiles:(ne,he,Ae,ht)=>{let yt,Pt;return typeof he=="object"?(yt=he,Pt=Ae):(yt={},Pt=he,ht=Ae),Ge.findTextInFiles(ne,yt||{},Pt,Oe.identifier,ht)},saveAll:ne=>Ge.saveAll(ne),applyEdit(ne){return Dn.applyWorkspaceEdit(ne)},createFileSystemWatcher:(ne,he,Ae,ht)=>Ft.createFileSystemWatcher(j.GlobPattern.from(ne),he,Ae,ht),get textDocuments(){return It.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw F.readonly()},openTextDocument(ne){let he;const Ae=ne;if(typeof ne=="string")he=Promise.resolve(P.URI.file(ne));else if(P.URI.isUri(ne))he=Promise.resolve(ne);else if(!Ae||typeof Ae=="object")he=It.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ht=>It.ensureDocumentData(ht).then(yt=>yt.document))},onDidOpenTextDocument:(ne,he,Ae)=>It.onDidAddDocument(ne,he,Ae),onDidCloseTextDocument:(ne,he,Ae)=>It.onDidRemoveDocument(ne,he,Ae),onDidChangeTextDocument:(ne,he,Ae)=>It.onDidChangeDocument(ne,he,Ae),onDidSaveTextDocument:(ne,he,Ae)=>It.onDidSaveDocument(ne,he,Ae),onWillSaveTextDocument:(ne,he,Ae)=>$t.getOnWillSaveTextDocumentEvent(Oe)(ne,he,Ae),get notebookDocuments(){return St.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,he){let Ae;if(P.URI.isUri(ne))Ae=ne,await St.openNotebookDocument(ne);else if(typeof ne=="string")Ae=P.URI.revive(await St.createNotebookDocument({viewType:ne,content:he}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(ne,he,Ae,ht){return St.registerNotebookSerializer(Oe,ne,he,Ae,Oe.enableProposedApi?ht:void 0)},registerNotebookContentProvider:(ne,he,Ae,ht)=>((0,$.checkProposedApiEnabled)(Oe),St.registerNotebookContentProvider(Oe,ne,he,Ae,Oe.enableProposedApi?ht:void 0)),onDidChangeConfiguration:(ne,he,Ae)=>Lt.onDidChangeConfiguration(ne,he,Ae),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,Lt.getConfiguration(ne,he,Oe)},registerTextDocumentContentProvider(ne,he){return Ut.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(Se.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Oe,ne,he)),registerFileSystemProvider(ne,he,Ae){return on.registerFileSystemProvider(Oe.identifier,ne,he,Ae)},get fs(){return ve.value},registerFileSearchProvider:(ne,he)=>((0,$.checkProposedApiEnabled)(Oe),Dt.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>((0,$.checkProposedApiEnabled)(Oe),Dt.registerTextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>((0,$.checkProposedApiEnabled)(Oe),Fe.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>((0,$.checkProposedApiEnabled)(Oe),bn.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,he,Ae)=>Ft.onDidCreateFile(ne,he,Ae),onDidDeleteFiles:(ne,he,Ae)=>Ft.onDidDeleteFile(ne,he,Ae),onDidRenameFiles:(ne,he,Ae)=>Ft.onDidRenameFile(ne,he,Ae),onWillCreateFiles:(ne,he,Ae)=>Ft.getOnWillCreateFileEvent(Oe)(ne,he,Ae),onWillDeleteFiles:(ne,he,Ae)=>Ft.getOnWillDeleteFileEvent(Oe)(ne,he,Ae),onWillRenameFiles:(ne,he,Ae)=>Ft.getOnWillRenameFileEvent(Oe)(ne,he,Ae),openTunnel:ne=>((0,$.checkProposedApiEnabled)(Oe),Q.openTunnel(Oe,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,$.checkProposedApiEnabled)(Oe),Q.getTunnels()},onDidChangeTunnels:(ne,he,Ae)=>((0,$.checkProposedApiEnabled)(Oe),Q.onDidChangeTunnels(ne,he,Ae)),registerPortAttributesProvider:(ne,he)=>((0,$.checkProposedApiEnabled)(Oe),Q.registerPortsAttributesProvider(ne,he)),registerTimelineProvider:(ne,he)=>((0,$.checkProposedApiEnabled)(Oe),En.registerTimelineProvider(ne,he,Oe.identifier,pt.converter)),get isTrusted(){return Ge.trusted},requestWorkspaceTrust:ne=>((0,$.checkProposedApiEnabled)(Oe),Ge.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,he,Ae)=>Ge.onDidGrantWorkspaceTrust(ne,he,Ae)},Rn={get inputBox(){return Se.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Oe)},createSourceControl(ne,he,Ae){return Jt.createSourceControl(Oe,ne,he,Ae)}},Ln={createCommentController(ne,he){return an.createCommentController(Oe,ne,he)}},Fn={get activeDebugSession(){return wt.activeDebugSession},get activeDebugConsole(){return wt.activeDebugConsole},get breakpoints(){return wt.breakpoints},onDidStartDebugSession(ne,he,Ae){return wt.onDidStartDebugSession(ne,he,Ae)},onDidTerminateDebugSession(ne,he,Ae){return wt.onDidTerminateDebugSession(ne,he,Ae)},onDidChangeActiveDebugSession(ne,he,Ae){return wt.onDidChangeActiveDebugSession(ne,he,Ae)},onDidReceiveDebugSessionCustomEvent(ne,he,Ae){return wt.onDidReceiveDebugSessionCustomEvent(ne,he,Ae)},onDidChangeBreakpoints(ne,he,Ae){return wt.onDidChangeBreakpoints(ne,he,Ae)},registerDebugConfigurationProvider(ne,he,Ae){return wt.registerDebugConfigurationProvider(ne,he,Ae||U.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return wt.registerDebugAdapterDescriptorFactory(Oe,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return wt.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?wt.startDebugging(ne,he,{parentSession:Ae}):wt.startDebugging(ne,he,Ae||{})},stopDebugging(ne){return wt.stopDebugging(ne)},addBreakpoints(ne){return wt.addBreakpoints(ne)},removeBreakpoints(ne){return wt.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return wt.asDebugSourceUri(ne,he)}},Mn={registerTaskProvider:(ne,he)=>Ct.registerTaskProvider(Oe,ne,he),fetchTasks:ne=>Ct.fetchTasks(ne),executeTask:ne=>Ct.executeTask(Oe,ne),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(ne,he,Ae)=>Ct.onDidStartTask(ne,he,Ae),onDidEndTask:(ne,he,Ae)=>Ct.onDidEndTask(ne,he,Ae),onDidStartTaskProcess:(ne,he,Ae)=>Ct.onDidStartTaskProcess(ne,he,Ae),onDidEndTaskProcess:(ne,he,Ae)=>Ct.onDidEndTaskProcess(ne,he,Ae)},On={createNotebookController(ne,he,Ae,ht,yt){return nn.createNotebookController(Oe,ne,he,Ae,ht,Oe.enableProposedApi?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,he)=>St.registerNotebookCellStatusBarItemProvider(Oe,ne,he),get onDidSaveNotebookDocument(){return(0,$.checkProposedApiEnabled)(Oe),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ne){return(0,$.checkProposedApiEnabled)(Oe),zt.createNotebookEditorDecorationType(ne)},createRendererMessaging(ne){return rn.createRendererMessaging(Oe,ne)},onDidChangeNotebookDocumentMetadata(ne,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),Qt.onDidChangeNotebookDocumentMetadata(ne,he,Ae)},onDidChangeNotebookCells(ne,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),St.onDidChangeNotebookCells(ne,he,Ae)},onDidChangeNotebookCellExecutionState(ne,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),St.onDidChangeNotebookCellExecutionState(ne,he,Ae)},onDidChangeCellOutputs(ne,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),St.onDidChangeCellOutputs(ne,he,Ae)},onDidChangeCellMetadata(ne,he,Ae){return(0,$.checkProposedApiEnabled)(Oe),St.onDidChangeCellMetadata(ne,he,Ae)},createConcatTextDocument(ne,he){return(0,$.checkProposedApiEnabled)(Oe),new Ke.ExtHostNotebookConcatDocument(St,It,ne,he)}};return{version:ue.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:Tn,languages:An,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:cn,workspace:vn,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:a.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:U.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestions,Hover:U.Hover,IndentAction:k.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:_.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:a.UIKind,Uri:P.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,InlayHint:U.InlayHint,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:Xe.TextSearchCompleteMessageType,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Te}),define(fe[277],me([0,1,83,69,36,133,37,40,45,33,73,57,75,92,54,68,134,91,53,90,124,56]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T,b,l,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),(0,g.registerSingleton)(_.IExtHostCommands,_.ExtHostCommands),(0,g.registerSingleton)(P.IExtHostConfiguration,P.ExtHostConfiguration),(0,g.registerSingleton)(T.IExtHostConsumerFileSystem,T.ExtHostConsumerFileSystem),(0,g.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,g.registerSingleton)(S.IExtHostDecorations,S.ExtHostDecorations),(0,g.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,g.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,g.registerSingleton)(a.IExtHostSearch,a.ExtHostSearch),(0,g.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage),(0,g.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,g.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,g.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,g.registerSingleton)(D.IExtHostWindow,D.ExtHostWindow),(0,g.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace),(0,g.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,g.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry),(0,g.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(fe[93],me([0,1,18,13,31,72]),function(Y,e,g,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function P(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=P;function _(I,a,p,h){const w=(0,g.mapArrayOrNot)(p,y),D=new C.TextSearchMatch(a,w,h),T=D.preview.matches;return{ranges:(0,g.mapArrayOrNot)(w,k),uri:I,preview:{text:D.preview.text,matches:(0,g.mapArrayOrNot)(T,k)}}}e.createTextSearchResult=_;function y(I){return new C.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function k(I){return new S.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let i=class{constructor(a,p){this.prefix=a,this.logService=p}appendLine(a){this.logService.debug(`${this.prefix}#search`,a)}};i=Ve([We(1,F.ILogService)],i),e.OutputChannel=i}),define(fe[278],me([0,1,97,22]),function(Y,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(n){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(f=>f===n)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const S=512,P=512,_=512*8,y=512*128;class k{constructor(f){this.iconvLiteDecoder=f}static async create(f){let r;if(f!==e.UTF8)r=(await new Promise((d,s)=>{Y(["iconv-lite-umd"],d,s)})).getDecoder(p(f));else{const t=new TextDecoder;r={write(d){return t.decode(d,{stream:!0})},end(){return t.decode()}}}return new k(r)}write(f){return this.iconvLiteDecoder.write(f)}end(){return this.iconvLiteDecoder.end()}}function i(n,f){const r=f.minBytesRequiredForDetection??f.guessEncoding?_:P;return new Promise((t,d)=>{const s=(0,g.newWriteableStream)(R=>R.join("")),c=[];let m=0,u;const E=async()=>{try{const R=await v({buffer:F.VSBuffer.concat(c),bytesRead:m},f.guessEncoding);R.encoding=await f.overwriteEncoding(R.encoding),u=await k.create(R.encoding);const L=u.write(F.VSBuffer.concat(c).buffer);s.write(L),c.length=0,m=0,t({stream:s,detected:R})}catch(R){d(R)}};(0,g.listenStream)(n,{onData:async R=>{u?s.write(u.write(R.buffer)):(c.push(R),m+=R.byteLength,m>=r&&(n.pause(),await E(),setTimeout(()=>n.resume())))},onError:R=>s.error(R),onEnd:async()=>{u||await E(),s.end(u?.end())}})})}e.toDecodeStream=i;async function I(n,f,r){const d=(await new Promise((m,u)=>{Y(["iconv-lite-umd"],m,u)})).getEncoder(p(f),r);let s=!1,c=!1;return{read(){if(c)return null;const m=n.read();if(typeof m!="string"){if(c=!0,!s&&r?.addBOM)switch(f){case e.UTF8:case e.UTF8_with_bom:return F.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const u=d.end();return u&&u.length>0?(s=!0,F.VSBuffer.wrap(u)):null}return s=!0,F.VSBuffer.wrap(d.write(m))}}}e.toEncodeReadable=I;async function a(n){return(await new Promise((r,t)=>{Y(["iconv-lite-umd"],r,t)})).encodingExists(p(n))}e.encodingExists=a;function p(n){return n===e.UTF8_with_bom||n===null?e.UTF8:n}e.toNodeEncoding=p;function h(n,f){if(!n||f<e.UTF16be_BOM.length)return null;const r=n.readUInt8(0),t=n.readUInt8(1);if(r===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(f<e.UTF8_BOM.length)return null;const d=n.readUInt8(2);return r===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&d===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=h;const w=["ascii","utf-16","utf-32"];async function D(n){const f=await new Promise((c,m)=>{Y(["jschardet"],c,m)}),r=n.slice(0,y),t=l(r.buffer),d=f.detect(t);if(!d||!d.encoding)return null;const s=d.encoding.toLowerCase();return 0<=w.indexOf(s)?null:b(d.encoding)}const T={ibm866:"cp866",big5:"cp950"};function b(n){const f=n.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return T[f]||f}function l(n){let f="";for(let r=0;r<n.length;r++)f+=String.fromCharCode(n[r]);return f}function o(n){switch(n){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const f=n.match(/windows(\d+)/);return f?"windows-"+f[1]:n}}e.toCanonicalName=o;function v({buffer:n,bytesRead:f},r){let t=h(n,f),d=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&n){let s=!0,c=!0,m=!1;for(let u=0;u<f&&u<S;u++){const E=u%2==1,R=n.readUInt8(u)===0;if(R&&(m=!0),s&&(E&&!R||!E&&R)&&(s=!1),c&&(E&&R||!E&&!R)&&(c=!1),R&&!s&&!c)break}m&&(s?t=e.UTF16le:c?t=e.UTF16be:d=!0)}return r&&!d&&!t&&n?D(n.slice(0,f)).then(s=>({seemsBinary:!1,encoding:s})):{seemsBinary:d,encoding:t}}e.detectEncodingFromBuffer=v,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(fe[136],me([0,1,278,26,135]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class S extends C.TextSearchManager{constructor(_,y,k=F,i="searchProcess"){super(_,y,{readdir:I=>k.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,g.toCanonicalName)(I)},i)}}e.NativeTextSearchManager=S}),define(fe[279],me([0,1,280,294,295,2,296]),function(Y,e,g,F,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function _(I,a,p,h,w,D){const T=D.environment.useHostProxy,b=typeof T=="boolean"?T:!D.remote.isRemote,l=(0,P.createProxyResolver)({resolveProxy:v=>I.resolveProxy(v),getHttpProxySetting:()=>a.getConfiguration("http").get("proxy"),log:(v,n,...f)=>{switch(v){case P.LogLevel.Trace:h.trace(n,...f);break;case P.LogLevel.Debug:h.debug(n,...f);break;case P.LogLevel.Info:h.info(n,...f);break;case P.LogLevel.Warning:h.warn(n,...f);break;case P.LogLevel.Error:h.error(n,...f);break;case P.LogLevel.Critical:h.critical(n,...f);break;case P.LogLevel.Off:break;default:r(v,n,f);break}function r(t,d,...s){h.error("Unknown log level",t),h.error(d,...s)}},getLogLevel:()=>h.getLevel(),proxyResolveTelemetry:v=>{w.$publicLog2("resolveProxy",v)},useHostProxy:b,env:process.env}),o=y(a,l);return i(p,o)}e.connectProxyResolver=_;function y(I,a){const p={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(w=>{p.config=I.getConfiguration("http").get("proxySupport")||"off"});const h={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(w=>{h.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,P.createHttpPatch)(g,a,{config:"off"},h,!0)),on:Object.assign({},g,(0,P.createHttpPatch)(g,a,{config:"on"},h,!0)),override:Object.assign({},g,(0,P.createHttpPatch)(g,a,{config:"override"},h,!0)),onRequest:Object.assign({},g,(0,P.createHttpPatch)(g,a,p,h,!0)),default:Object.assign(g,(0,P.createHttpPatch)(g,a,p,h,!1))},https:{off:Object.assign({},F,(0,P.createHttpPatch)(F,a,{config:"off"},h,!0)),on:Object.assign({},F,(0,P.createHttpPatch)(F,a,{config:"on"},h,!0)),override:Object.assign({},F,(0,P.createHttpPatch)(F,a,{config:"override"},h,!0)),onRequest:Object.assign({},F,(0,P.createHttpPatch)(F,a,p,h,!0)),default:Object.assign(F,(0,P.createHttpPatch)(F,a,p,h,!1))},tls:Object.assign(C,(0,P.createTlsPatch)(C))}}const k=new Map;function i(I,a){return I.getExtensionPathIndex().then(p=>{const h=Y.__$__nodeRequire("module"),w=h._load;h._load=function(T,b,l){if(T==="tls")return a.tls;if(T!=="http"&&T!=="https")return w.apply(this,arguments);const o=a[T],v=p.findSubstr(S.URI.file(b.filename));let n=k.get(v);if(n||k.set(v,n={}),!n[T]){let f=o.default;v&&v.enableProposedApi&&(f=o[v.proxySupport]||o.onRequest),n[T]={...f}}return n[T]}})}}),define(fe[281],me([0,1,39,8,79,29,11,9,93,282]),function(Y,e,g,F,C,S,P,_,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(l,o,v,n){const f=a(l,o,v,n),r=o.folder.fsPath;return{cmd:g.spawn(i,f.args,{cwd:r}),rgDiskPath:i,siblingClauses:f.siblingClauses,rgArgs:f,cwd:r}}e.spawnRipgrepCmd=I;function a(l,o,v,n){const f=["--files","--hidden","--case-sensitive"];h([o],v,!1).forEach(t=>{const d=(0,y.anchorGlob)(t);if(f.push("-g",d),P.isMacintosh){const s=(0,C.normalizeNFD)(d);s!==d&&f.push("-g",s)}});const r=p([o],n,void 0,!1);return r.globArgs.forEach(t=>{const d=`!${(0,y.anchorGlob)(t)}`;if(f.push("-g",d),P.isMacintosh){const s=(0,C.normalizeNFD)(d);s!==d&&f.push("-g",s)}}),o.disregardIgnoreFiles!==!1?f.push("--no-ignore"):f.push("--no-ignore-parent"),o.ignoreSymlinks||f.push("--follow"),l.exists&&f.push("--quiet"),f.push("--no-config"),o.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:r.siblingClauses}}function p(l,o,v,n=!0){const f=[];let r={};return l.forEach(t=>{const d=Object.assign({},t.excludePattern||{},o||{}),s=w(d,n?t.folder.fsPath:void 0,v);f.push(...s.globArgs),s.siblingClauses&&(r=Object.assign(r,s.siblingClauses))}),{globArgs:f,siblingClauses:r}}e.foldersToRgExcludeGlobs=p;function h(l,o,v=!0){const n=[];return l.forEach(f=>{const r=Object.assign({},o||{},f.includePattern||{}),t=w(r,v?f.folder.fsPath:void 0);n.push(...t.globArgs)}),n}e.foldersToIncludeGlobs=h;function w(l,o,v){const n=[],f={};return Object.keys(l).forEach(r=>{if(v&&v.has(r)||!r)return;const t=l[r];r=T(o?D(o,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof t=="boolean"&&t?(r.startsWith("\\\\")&&(r+="**"),n.push(b(r))):t&&t.when&&(f[r]=t)}),{globArgs:n,siblingClauses:f}}function D(l,o){return F.isAbsolute(o)?o:F.join(l,o)}e.getAbsoluteGlob=D;function T(l){return l=_.rtrim(l,"\\"),_.rtrim(l,"/")}function b(l){return S.getRoot(l).toLowerCase()==="c:/"?l.replace(/^c:[/\\]/i,"/"):l}e.fixDriveC=b}),define(fe[283],me([0,1,39,50,8,105,18,52,30,79,29,11,46,9,12,26,31,281,102]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const l=new Set;process.on("exit",()=>{l.forEach(r=>r())});class o{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&y.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&y.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(d=>{const s=Object.assign({},d.excludePattern||{},this.config.excludePattern||{}),c=d.folder.fsPath;t.folderQueries.map(m=>m.folder.fsPath).filter(m=>m!==c).forEach(m=>{(0,i.isEqualOrParent)(m,c)&&(s[C.relative(c,m)]=!0)}),this.folderExcludePatterns.set(c,new n(s,c))})}cancel(){this.isCanceled=!0}walk(t,d,s,c,m){if(this.fileWalkSW=a.StopWatch.create(!1),this.isCanceled)return m(null,this.isLimitHit);d.forEach(u=>{const E=C.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,E)||this.matchFile(s,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=a.StopWatch.create(!1),this.parallel(t,(u,E)=>{this.call(this.cmdTraversal,this,u,s,c,R=>{if(R){const L=(0,_.toErrorMessage)(R);console.error(L),this.errors.push(L),E(R,void 0)}else E(null,void 0)})},(u,E)=>{this.fileWalkSW.stop();const R=u?P.coalesce(u)[0]:null;m(R,this.isLimitHit)})}parallel(t,d,s){const c=new Array(t.length),m=new Array(t.length);let u=!1,E=0;if(t.length===0)return s(null,[]);t.forEach((R,L)=>{d(R,(M,A)=>{if(M?(u=!0,c[L]=null,m[L]=M):(c[L]=A,m[L]=null),++E===t.length)return s(u?m:null,c)})})}call(t,d,...s){try{t.apply(d,s)}catch(c){s[s.length-1](c)}}cmdTraversal(t,d,s,c){const m=t.folder.fsPath,u=I.isMacintosh;let E;const R=()=>E&&E.kill();l.add(R);let L=U=>{l.delete(R),L=()=>{},c(U)},M="";const A=this.initDirectoryTree();let B;const V=(0,T.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);E=V.cmd,B=!Object.keys(V.siblingClauses).length;const N=V.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let j=`${V.rgDiskPath} ${N}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(j+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),s({message:j}),this.cmdResultCount=0,this.collectStdout(E,"utf8",s,(U,x,z)=>{if(U){L(U);return}if(this.isLimitHit){L();return}const W=(M+(u?k.normalizeNFC(x||""):x)).split(`
`);if(z){const $=W.length;W[$-1]=W[$-1].trim(),W[$-1]||W.pop()}else M=W.pop()||"";if(W.length&&W[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=W.length,B){for(const $ of W)if(this.matchFile(d,{base:m,relativePath:$,searchPath:this.getSearchPath(t,$)}),this.isLimitHit){R();break}(z||this.isLimitHit)&&L();return}this.addDirectoryEntries(t,A,m,W,d),z&&(this.matchDirectoryTree(A,m,d),L())})}spawnFindCmd(t){const d=this.folderExcludePatterns.get(t.folder.fsPath),s=d.getBasenameTerms(),c=d.getPathTerms(),m=["-L","."];if(s.length||c.length){m.push("-not","(","(");for(const u of s)m.push("-name",u),m.push("-o");for(const u of c)m.push("-path",u),m.push("-o");m.pop(),m.push(")","-prune",")")}return m.push("-type","f"),g.spawn("find",m,{cwd:t.folder.fsPath})}readStdout(t,d,s){let c="";this.collectStdout(t,d,()=>{},(m,u,E)=>{if(m){s(m);return}c+=u,E&&s(null,c)})}collectStdout(t,d,s,c){let m=(R,L,M)=>{(R||M)&&(m=()=>{},this.cmdSW&&this.cmdSW.stop()),c(R,L,M)},u=!1;t.stdout?(this.forwardData(t.stdout,d,m),t.stdout.once("data",()=>u=!0)):s({message:"stdout is null"});let E;t.stderr?E=this.collectData(t.stderr):s({message:"stderr is null"}),t.on("error",R=>{m(R)}),t.on("close",R=>{let L;!u&&(L=this.decodeData(E,d))&&f(L)?m(new Error(`command failed with error code ${R}: ${this.decodeData(E,d)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),m(null,"",!0))})}forwardData(t,d,s){const c=new S.StringDecoder(d);return t.on("data",m=>{s(null,c.write(m))}),c}collectData(t){const d=[];return t.on("data",s=>{d.push(s)}),d}decodeData(t,d){const s=new S.StringDecoder(d);return t.map(c=>s.write(c)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:d},s,c,m){c.indexOf(this.filePattern)!==-1&&this.matchFile(m,{base:s,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const u=E=>{const R=C.basename(E),L=C.dirname(E);let M=d[L];M||(M=d[L]=[],u(L)),M.push({base:s,relativePath:E,basename:R,searchPath:this.getSearchPath(t,E)})};c.forEach(u)}matchDirectoryTree({rootEntries:t,pathToEntries:d},s,c){const m=this,u=this.folderExcludePatterns.get(s),E=this.filePattern;function R(L){m.directoriesWalked++;const M=y.hasSiblingFn(()=>L.map(A=>A.basename));for(let A=0,B=L.length;A<B;A++){const V=L[A],{relativePath:N,basename:j}=V;if(u.test(N,j,E!==j?M:void 0))continue;const U=d[N];if(U)R(U);else{if(m.filesWalked++,N===E)continue;m.matchFile(c,V)}if(m.isLimitHit)break}}R(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,d,s,c,m){const u=t.folder,E=y.hasSiblingFn(()=>s);this.parallel(s,(R,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const M=d?[d,R].join(C.sep):R;if(this.folderExcludePatterns.get(t.folder.fsPath).test(M,R,this.config.filePattern!==R?E:void 0))return L(null);const A=[u.fsPath,M].join(C.sep);F.lstat(A,(B,V)=>{if(B||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(A,V,(N,j)=>N||this.isCanceled||this.isLimitHit?L(null):j.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(A,V,(U,x)=>U||this.isCanceled||this.isLimitHit||(x=x||"",this.walkedPaths[x])?L(null):(this.walkedPaths[x]=!0,w.Promises.readdir(A).then(z=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(t,M,z,c,O=>L(O||null))},z=>{L(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&h.isNumber(j.size)&&j.size>this.maxFilesize||this.matchFile(c,{base:u.fsPath,relativePath:M,searchPath:this.getSearchPath(t,M)}),L(null,void 0)))})},R=>{const L=R&&P.coalesce(R);return m(L&&L.length>0?L[0]:void 0)})}matchFile(t,d){this.isFileMatch(d)&&(!this.includePattern||this.includePattern(d.relativePath,C.basename(d.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(d))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,D.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,d,s){return d.isSymbolicLink()?F.stat(t,s):s(null,d)}realPathIfNeeded(t,d,s){return d.isSymbolicLink()?F.realpath(t,(c,m)=>c?s(c):s(null,m)):s(null,t)}getSearchPath(t,d){return t.folderName?C.join(t.folderName,d):d}}e.FileWalker=o;class v{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new o(t)}search(t,d,s){this.walker.walk(this.folderQueries,this.extraFiles,t,d,(c,m)=>{s(c,{limitHit:m,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class n{constructor(t,d){this.expression=t,this.root=d,this.init(t)}init(t){let d,s;Object.keys(t).filter(c=>t[c]).forEach(c=>{C.isAbsolute(c)?(d=d||y.getEmptyExpression(),d[c]=t[c]):(s=s||y.getEmptyExpression(),s[c]=t[c])}),this.absoluteParsedExpr=d&&y.parse(d,{trimForExclusions:!0}),this.relativeParsedExpr=s&&y.parse(s,{trimForExclusions:!0})}test(t,d,s){return this.relativeParsedExpr&&this.relativeParsedExpr(t,d,s)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,t),d,s)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...y.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...y.getPathTerms(this.relativeParsedExpr)),t}}function f(r){const t=r.trim().split(`
`),d=t[0].trim();if(d.startsWith("Error parsing regex"))return d;if(d.startsWith("regex parse error"))return p.uppercaseFirstLetter(t[t.length-1].trim());if(d.startsWith("error parsing glob")||d.startsWith("unsupported encoding"))return d.charAt(0).toUpperCase()+d.substr(1);if(d==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(d.startsWith("Literal "))return d}e.rgErrorMsgForDisplay=f}),define(fe[137],me([0,1,39,297,105,18,59,30,8,9,2,31,72,298,282,93]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const D=h.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class T{constructor(u){this.outputChannel=u}provideTextSearchResults(u,E,R,L){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((M,A)=>{L.onCancellationRequested(()=>O());const B=f(u,E),V=E.folder.fsPath,N=B.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.outputChannel.appendLine(`${D} ${N}
 - cwd: ${V}`);let j=g.spawn(D,B,{cwd:V});j.on("error",de=>{console.error(de),this.outputChannel.appendLine("Error: "+(de&&de.message)),A((0,I.serializeSearchError)(new I.SearchError(de&&de.message,I.SearchErrorCode.rgProcessError)))});let U=!1;const x=new o(E.maxResults,V,E.previewOptions);x.on("result",de=>{U=!0,$="",R.report(de)});let z=!1;const O=()=>{z=!0,j&&j.kill(),x&&x.cancel()};let W=!1;x.on("hitLimit",()=>{W=!0,O()});let $="";j.stdout.on("data",de=>{x.handleData(de),U||($+=de)});let X=!1;j.stdout.once("data",()=>X=!0);let K="";j.stderr.on("data",de=>{const _e=de.toString();this.outputChannel.appendLine(_e),K+=_e}),j.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),$&&this.outputChannel.appendLine(`Got data without result: ${$}`),this.outputChannel.appendLine(""),z)M({limitHit:W});else{x.flush(),j=null;let de;K&&!X&&(de=b(K))?A((0,I.serializeSearchError)(new I.SearchError(de.message,de.code))):M({limitHit:W})}})})}}e.RipgrepTextSearchEngine=T;function b(m){const u=m.split(`
`),E=u[0].trim();if(u.some(L=>L.startsWith("regex parse error")))return new I.SearchError(l(u),I.SearchErrorCode.regexParseError);const R=E.match(/grep config error: unknown encoding: (.*)/);if(R)return new I.SearchError(`Unknown encoding: ${R[1]}`,I.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(E,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function l(m){const u=["Regex parse error"],E=m.filter(R=>R.startsWith("PCRE2:"));if(E.length>=1){const R=E[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const L=R.split(":")[1];u.push(":"+L)}}return u.join("")}e.buildRegexParseError=l;class o extends F.EventEmitter{constructor(u,E,R){super();this.maxResults=u,this.rootFolder=E,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,E){return super.on(u,E),this}handleData(u){if(this.isDone)return;const E=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(E)}handleDecodedData(u){let E=u.indexOf(`
`);const R=this.remainder+u;if(E>=0)E+=this.remainder.length;else{this.remainder=R;return}let L=0;for(;E>=0;)this.handleLine(R.substring(L,E).trim()),L=E+1,E=R.indexOf(`
`,L);this.remainder=R.substring(L)}handleLine(u){if(this.isDone||!u)return;let E;try{E=JSON.parse(u)}catch(R){throw new Error(`malformed line from rg: ${u}`)}if(E.type==="match"){const R=v(E.data.path),L=i.URI.file(y.join(this.rootFolder,R)),M=this.createTextSearchMatch(E.data,L);this.onResult(M),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const R=v(E.data.path),L=i.URI.file(y.join(this.rootFolder,R));this.createTextSearchContext(E.data,L).forEach(A=>this.onResult(A))}}createTextSearchMatch(u,E){const R=u.line_number-1,L=v(u.lines),M=Buffer.from(L);let A=0,B=0,V=R;u.submatches.length===0&&u.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const N=(0,S.coalesce)(u.submatches.map((j,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const x=v(j.match),z=M.slice(A,j.start).toString().length,O=B+z,W=n(x),$=V,X=W.numLines+$,K=W.numLines>0?W.lastLineLength:W.lastLineLength+O;return A=j.end,B=K,V=X,new a.Range($,O,X,K)}));return(0,w.createTextSearchResult)(E,L,N,this.previewOptions)}createTextSearchContext(u,E){const R=v(u.lines),L=u.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((M,A)=>({text:M,uri:E,lineNumber:L+A}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=o;function v(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function n(m){const u=/\n/g;let E=0,R=-1,L;for(;L=u.exec(m);)E++,R=L.index;const M=R>=0?m.length-R-1:m.length;return{numLines:E,lastLineLength:M}}function f(m,u){const E=["--hidden"];E.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:L}=(0,P.groupBy)(u.includes,A=>A.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const A=new Set;L.forEach(B=>{A.add(B)}),E.push("-g","!*"),A.forEach(B=>{r(B).map(w.anchorGlob).forEach(V=>{E.push("-g",V)})})}R&&R.length&&R.forEach(A=>{E.push("-g",A)}),u.excludes.map(w.anchorGlob).forEach(A=>E.push("-g",`!${A}`)),u.maxFileSize&&E.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?E.push("--no-ignore-parent"):E.push("--no-ignore"),u.followSymlinks&&E.push("--follow"),u.encoding&&u.encoding!=="utf8"&&E.push("--encoding",u.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,k.escapeRegExpCharacters)(m.pattern),m.isRegExp=!0),u.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),m.isRegExp&&(m.pattern=t(m.pattern),E.push("--auto-hybrid-regex"));let M;if(m.isWordMatch){const B=(0,k.createRegExp)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",B)}else if(m.isRegExp){let A=s(m.pattern);A=c(A),E.push("--regexp",A)}else M=m.pattern,E.push("--fixed-strings");return E.push("--no-config"),u.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),m.isMultiline&&E.push("--multiline"),u.beforeContext&&E.push("--before-context",u.beforeContext+""),u.afterContext&&E.push("--after-context",u.afterContext+""),E.push("--"),M&&E.push(M),E.push("."),E}function r(m){const u=(0,_.splitGlobAware)(m,"/");return u.map((E,R)=>u.slice(0,R+1).join("/"))}e.spreadGlobComponents=r;function t(m){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(u);)m=m.replace(u,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(E);)m=m.replace(E,"$1\\x{$2}");return m}e.unicodeEscapesToPCRE2=t;const d=m=>m.type==="Assertion"&&m.kind==="lookbehind";function s(m){let u;try{u=new p.RegExpParser().parsePattern(m)}catch{return m}let E="",R=0;const L=(B,V,N)=>{E+=m.slice(R,B)+N,R=V},M=[];return new p.RegExpVisitor({onCharacterEnter(B){if(B.raw!=="\\n")return;const V=M[0];if(!V)L(B.start,B.end,"\\r?\\n");else if(!M.some(d))if(V.type==="CharacterClass")if(V.negate){const N=m.slice(V.start+2,B.start)+m.slice(B.end,V.end-1);if(V.parent?.type==="Quantifier"){const j=V.parent;L(j.start,j.end,(N?`[^${N}]`:".")+(j.greedy?"+":"*"))}else L(V.start,V.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=m.slice(V.start+1,B.start)+m.slice(B.end,V.end-1);L(V.start,V.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else V.type==="Quantifier"&&L(B.start,B.end,"(?:\\r?\\n)")},onQuantifierEnter(B){M.unshift(B)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(B){M.unshift(B)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(B){M.unshift(B)},onCharacterClassLeave(){M.shift()},onAssertionEnter(B){d(B)&&M.push(B)},onAssertionLeave(B){M[0]===B&&M.shift()}}).visit(u),E+=m.slice(R),E}e.fixRegexNewline=s;function c(m){return m.replace(/\n/g,"\\r?\\n")}e.fixNewline=c}),define(fe[284],me([0,1,21,137,119,10]),function(Y,e,g,F,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class P{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,i,I,a){const p=new F.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===S.Schemas.userData){const h={...i,folder:i.folder.with({scheme:S.Schemas.file})},w=new C.Progress(D=>I.report({...D,uri:D.uri.with({scheme:i.folder.scheme})}));return this.withToken(a,D=>p.provideTextSearchResults(k,h,w,D))}else return this.withToken(a,h=>p.provideTextSearchResults(k,i,I,h))}async withToken(k,i){const I=_(k);this.inProgress.add(I);const a=await i(I.token);return this.inProgress.delete(I),a}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=P;function _(y){const k=new g.CancellationTokenSource;return y.onCancellationRequested(()=>k.cancel()),k}}),define(fe[285],me([0,1,26,137,136]),function(Y,e,g,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class S{constructor(y){this.query=y}search(y,k,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(p){i({message:p})}},a=new C.NativeTextSearchManager(this.query,new F.RipgrepTextSearchEngine(I),g);return new Promise((p,h)=>a.search(w=>{k(w.map(P))},y).then(w=>p({limitHit:w.limitHit,type:"success",stats:w.stats}),h))}}e.TextSearchEngineAdapter=S;function P(_){return{path:_.resource&&_.resource.fsPath,results:_.results,numMatches:(_.results||[]).reduce((y,k)=>{if(k.ranges){const i=k;return y+(Array.isArray(i.ranges)?i.ranges.length:1)}else return y+1},0)}}}),define(fe[286],me([0,1,50,299,18,15,17,3,102,8,46,2,43,31,283,285]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,F.gracefulify(g);class D{constructor(n="searchProcess"){this.processType=n,this.caches=Object.create(null)}fileSearch(n){let f;const r=l(n),t=new _.Emitter({onFirstListenerDidAdd:()=>{f=(0,S.createCancelablePromise)(d=>this.doFileSearchWithEngine(h.Engine,r,s=>t.fire(s),d)),f.then(d=>t.fire(d),d=>t.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onLastListenerRemove:()=>{f.cancel()}});return t.event}textSearch(n){let f;const r=l(n),t=new _.Emitter({onFirstListenerDidAdd:()=>{f=(0,S.createCancelablePromise)(d=>this.ripgrepTextSearch(r,s=>t.fire(s),d)),f.then(d=>t.fire(d),d=>t.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onLastListenerRemove:()=>{f.cancel()}});return t.event}ripgrepTextSearch(n,f,r){return n.maxFileSize=(0,a.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new w.TextSearchEngineAdapter(n).search(r,f,f)}doFileSearch(n,f,r){return this.doFileSearchWithEngine(h.Engine,n,f,r)}doFileSearchWithEngine(n,f,r,t,d=D.BATCH_SIZE){let s=0;const c=u=>{Array.isArray(u)?(s+=u.length,r(u.map(E=>this.rawMatchToSearchItem(E)))):u.relativePath?(s++,r(this.rawMatchToSearchItem(u))):r(u)};if(f.sortByScore){let u=this.trySortedSearchFromCache(f,c,t);if(!u){const E=f.maxResults?Object.assign({},f,{maxResults:null}):f,R=new n(E);u=this.doSortedSearch(R,f,r,c,t)}return new Promise((E,R)=>{u.then(([L,M])=>{const A=M.map(B=>this.rawMatchToSearchItem(B));this.sendProgress(A,r,d),E(L)},R)})}const m=new n(f);return this.doSearch(m,c,d,t).then(u=>({limitHit:u.limitHit,type:"success",stats:{detailStats:u.stats,type:this.processType,fromCache:!1,resultCount:s,sortingTime:void 0}}))}rawMatchToSearchItem(n){return{path:n.base?(0,k.join)(n.base,n.relativePath):n.relativePath}}doSortedSearch(n,f,r,t,d){const s=new _.Emitter;let c=(0,S.createCancelablePromise)(u=>{let E=[];const R=L=>{Array.isArray(L)?E=L:(t(L),s.fire(L))};return this.doSearch(n,R,-1,u).then(L=>[L,E])}),m;if(f.cacheKey){m=this.getOrCreateCache(f.cacheKey);const u={promise:c,event:s.event,resolved:!1};m.resultsToSearchCache[f.filePattern||""]=u,c.then(()=>{u.resolved=!0},E=>{delete m.resultsToSearchCache[f.filePattern||""]}),c=this.preventCancellation(c)}return c.then(([u,E])=>{const R=m?m.scorerCache:Object.create(null),L=(typeof f.maxResults!="number"||f.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(f,E,R,d).then(M=>{const A=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:u.stats,sortingTime:A,fromCache:!1,type:this.processType,workspaceFolderCount:f.folderQueries.length,resultCount:M.length},messages:u.messages,limitHit:u.limitHit||typeof f.maxResults=="number"&&E.length>f.maxResults},M]})})}getOrCreateCache(n){const f=this.caches[n];return f||(this.caches[n]=new T)}trySortedSearchFromCache(n,f,r){const t=n.cacheKey&&this.caches[n.cacheKey];if(!t)return;const d=this.getResultsFromCache(t,n.filePattern||"",f,r);if(d)return d.then(([s,c,m])=>{const u=i.StopWatch.create(!1);return this.sortResults(n,c,t.scorerCache,r).then(E=>{const R=u.elapsed(),L={fromCache:!0,detailStats:m,type:this.processType,resultCount:c.length,sortingTime:R};return[{type:"success",limitHit:s.limitHit||typeof n.maxResults=="number"&&c.length>n.maxResults,stats:L},E]})})}sortResults(n,f,r,t){const d=(0,y.prepareQuery)(n.filePattern||""),s=(m,u)=>(0,y.compareItemsByFuzzyScore)(m,u,d,!0,b,r),c=typeof n.maxResults=="number"?n.maxResults:Number.MAX_VALUE;return C.topAsync(f,s,c,1e4,t)}sendProgress(n,f,r){if(r&&r>0)for(let t=0;t<n.length;t+=r)f(n.slice(t,t+r));else f(n)}getResultsFromCache(n,f,r,t){const d=i.StopWatch.create(!1),s=f.indexOf(k.sep)>=0;let c;for(const R in n.resultsToSearchCache)if(f.startsWith(R)){if(s&&R.indexOf(k.sep)<0&&R!=="")continue;const L=n.resultsToSearchCache[R];c={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!c)return null;const m=d.elapsed(),u=i.StopWatch.create(!1),E=c.event(r);return t&&t.onCancellationRequested(()=>{E.dispose()}),c.promise.then(([R,L])=>{if(t&&t.isCancellationRequested)throw(0,P.canceled)();const M=[],A=(0,y.prepareQuery)(f).normalizedLowercase;for(const B of L)!(0,p.isFilePatternMatch)(B,A)||M.push(B);return[R,M,{cacheWasResolved:c.resolved,cacheLookupTime:m,cacheFilterTime:u.elapsed(),cacheEntryCount:L.length}]})}doSearch(n,f,r,t){return new Promise((d,s)=>{let c=[];t&&t.onCancellationRequested(()=>n.cancel()),n.search(m=>{m&&(r?(c.push(m),r>0&&c.length>=r&&(f(c),c=[])):f(m))},m=>{f(m)},(m,u)=>{c.length&&f(c),m?s(m):d(u)})})}clearCache(n){return delete this.caches[n],Promise.resolve(void 0)}preventCancellation(n){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(f,r){return n.then(f,r)}catch(f){return this.then(void 0,f)}finally(f){return n.finally(f)}}}}e.SearchService=D,D.BATCH_SIZE=512;class T{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(v){return(0,k.basename)(v.relativePath)}getItemDescription(v){return(0,k.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function l(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(o),extraFileResources:v.extraFileResources&&v.extraFileResources.map(n=>I.URI.revive(n))}}function o(v){return{...v,folder:I.URI.revive(v.folder)}}}),define(fe[287],me([0,1,6,10,2,26,13,28,14,75,67,31,286,284,93,136]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let D=class extends k.ExtHostSearch{constructor(b,l,o,v){super(b,o,v);this._pfs=S,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const n=new h.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(F.Schemas.userData,new p.RipgrepSearchProvider(n)),l.remote.isRemote&&l.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new h.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(F.Schemas.file,new p.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(F.Schemas.file,new a.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,l){const o=this._handlePool++;return this._internalFileSearchProvider=l,this._internalFileSearchHandle=o,this._proxy.$registerFileSearchProvider(o,this._transformScheme(b)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(b,l,o,v){const n=(0,k.reviveQuery)(o);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,l,n,v):super.$provideFileSearchResults(b,l,o,v)}doInternalFileSearch(b,l,o,v){const n=f=>{if((0,I.isSerializedFileMatch)(f)&&(f=[f]),Array.isArray(f)){this._proxy.$handleFileMatch(b,l,f.map(r=>C.URI.file(r.path)));return}f.message&&this._logService.debug("ExtHostSearch",f.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(o,n,v)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,l){return new w.NativeTextSearchManager(b,l,void 0,"textSearchProvider")}};D=Ve([We(0,y.IExtHostRpcService),We(1,_.IExtHostInitDataService),We(2,i.IURITransformerService),We(3,P.ILogService)],D),e.NativeExtHostSearch=D}),define(fe[138],me([0,1,300,127,81,22,17,3,6,8,11,32,107,108,301]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(c){this.socket=c,this._errorListener=m=>{if(m){if(m.code==="EPIPE")return;(0,P.onUnexpectedError)(m)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(c){const m=u=>c(S.VSBuffer.wrap(u));return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(c){const m=u=>{c({type:0,hadError:u,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(c){return this.socket.on("end",c),{dispose:()=>this.socket.off("end",c)}}write(c){if(!this.socket.destroyed)try{this.socket.write(c.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,P.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,P.onUnexpectedError)(m)}}end(){this.socket.end()}drain(){return new Promise((c,m)=>{if(this.socket.bufferSize===0){c();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),c()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=w;var D;(function(s){s[s.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var T;(function(s){s[s.PeekHeader=1]="PeekHeader",s[s.ReadHeader=2]="ReadHeader",s[s.ReadBody=3]="ReadBody",s[s.Fin=4]="Fin"})(T||(T={}));class b extends y.Disposable{constructor(c,m,u,E){super();this._onDidZlibFlush=this._register(new _.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new _.Emitter),this._onClose=this._register(new _.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=c,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=m,this._recordInflateBytes=E,m?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",R=>{console.error(R),(0,P.onUnexpectedError)(R),this._onClose.fire({type:0,hadError:!0,error:R})}),this._zlibInflate.on("data",R=>{this._pendingInflateData.push(R)}),u&&(this._zlibInflate.write(u.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{console.error(R),(0,P.onUnexpectedError)(R),this._onClose.fire({type:0,hadError:!0,error:R})}),this._zlibDeflate.on("data",R=>{this._pendingDeflateData.push(R)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(R=>this._onClose.fire(R)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?S.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):S.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(c){return this._onData.event(c)}onClose(c){return this._onClose.event(c)}onEnd(c){return this.socket.onEnd(c)}write(c){this._totalOutgoingDataBytes+=c.byteLength,this._zlibDeflate?(this._zlibDeflate.write(c.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let m=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,m=m.slice(0,m.length-4),this._isEnded||this._write(S.VSBuffer.wrap(m),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(c,!1)}_write(c,m){let u=2;c.byteLength<126?u+=0:c.byteLength<2**16?u+=2:u+=8;const E=S.VSBuffer.alloc(u);if(m?E.writeUInt8(194,0):E.writeUInt8(130,0),c.byteLength<126)E.writeUInt8(c.byteLength,1);else if(c.byteLength<2**16){E.writeUInt8(126,1);let R=1;E.writeUInt8(c.byteLength>>>8&255,++R),E.writeUInt8(c.byteLength>>>0&255,++R)}else{E.writeUInt8(127,1);let R=1;E.writeUInt8(0,++R),E.writeUInt8(0,++R),E.writeUInt8(0,++R),E.writeUInt8(0,++R),E.writeUInt8(c.byteLength>>>24&255,++R),E.writeUInt8(c.byteLength>>>16&255,++R),E.writeUInt8(c.byteLength>>>8&255,++R),E.writeUInt8(c.byteLength>>>0&255,++R)}this._totalOutgoingWireBytes+=E.byteLength+c.byteLength,this.socket.write(S.VSBuffer.concat([E,c]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(c){if(c.byteLength!==0){for(this._totalIncomingWireBytes+=c.byteLength,this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const m=this._incomingData.peek(this._state.readLen),u=m.readUInt8(0),E=(u&128)>>>7,R=(u&64)>>>6,L=m.readUInt8(1),M=(L&128)>>>7,A=L&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(A===126?2:0)+(A===127?8:0),this._state.fin=E,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(R)),this._state.firstFrameOfMessage=Boolean(E),this._state.mask=0}else if(this._state.state===2){const m=this._incomingData.read(this._state.readLen),u=m.readUInt8(1),E=(u&128)>>>7;let R=u&127,L=1;R===126?R=m.readUInt8(++L)*2**8+m.readUInt8(++L):R===127&&(R=m.readUInt8(++L)*0+m.readUInt8(++L)*0+m.readUInt8(++L)*0+m.readUInt8(++L)*0+m.readUInt8(++L)*2**24+m.readUInt8(++L)*2**16+m.readUInt8(++L)*2**8+m.readUInt8(++L));let M=0;E&&(M=m.readUInt8(++L)*2**24+m.readUInt8(++L)*2**16+m.readUInt8(++L)*2**8+m.readUInt8(++L)),this._state.state=3,this._state.readLen=R,this._state.mask=M}else if(this._state.state===3){const m=this._incomingData.read(this._state.readLen);l(m,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(m.buffer)),this._zlibInflate.write(m.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const u=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=u.length,this._onData.fire(S.VSBuffer.wrap(u))})):(this._totalIncomingDataBytes+=m.byteLength,this._onData.fire(m))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await _.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function l(s,c){if(c===0)return;let m=s.byteLength>>>2;for(let A=0;A<m;A++){const B=s.readUInt32BE(A*4);s.writeUInt32BE(B^c,A*4)}let u=m*4,E=s.byteLength-u;const R=c>>>24&255,L=c>>>16&255,M=c>>>8&255;E>=1&&s.writeUInt8(s.readUInt8(u)^R,u),E>=2&&s.writeUInt8(s.readUInt8(u+1)^L,u+1),E>=3&&s.writeUInt8(s.readUInt8(u+2)^M,u+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function v(){const s=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${s}-sock`;let c;return e.XDG_RUNTIME_DIR?c=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${s}.sock`):c=(0,k.join)((0,C.tmpdir)(),`vscode-ipc-${s}.sock`),f(c),c}e.createRandomIPCHandle=v;function n(s,c,m){const u=(0,g.createHash)("md5").update(s).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${m}-${c}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${u.substr(0,8)}-${m}-${c}.sock`):E=(0,k.join)(s,`${m}-${c}.sock`),f(E),E}e.createStaticIPCHandle=n;function f(s){const c=o[i.platform];typeof c=="number"&&s.length>=c&&console.warn(`WARNING: IPC handle "${s}" is longer than ${c} chars, try a shorter --user-data-dir`)}class r extends a.IPCServer{constructor(c){super(r.toClientConnectionEvent(c));this.server=c}static toClientConnectionEvent(c){const m=_.Event.fromNodeEventEmitter(c,"connection");return _.Event.map(m,u=>({protocol:new p.Protocol(new w(u)),onDidClientDisconnect:_.Event.once(_.Event.fromNodeEventEmitter(u,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function t(s){return new Promise((c,m)=>{const u=(0,F.createServer)();u.on("error",m),u.listen(s,()=>{u.removeListener("error",m),c(new r(u))})})}e.serve=t;function d(s,c){return new Promise((m,u)=>{const E=(0,F.createConnection)(s,()=>{E.removeListener("error",u),m(p.Client.fromSocket(new w(E),c))});E.once("error",u)})}e.connect=d}),define(fe[288],me([0,1,138,280,50,40,2,200,13]),function(Y,e,g,F,C,S,P,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(a,p,h){this._commands=a,this.logService=p,this._ipcHandlePath=h,this._server=F.createServer((w,D)=>this.onRequest(w,D)),this.setup().catch(w=>(p.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",a=>this.logService.error(a))}catch(a){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(a,p){const h=[];a.setEncoding("utf8"),a.on("data",w=>h.push(w)),a.on("end",()=>{const w=JSON.parse(h.join(""));switch(w.type){case"open":this.open(w,p);break;case"openExternal":this.openExternal(w,p);break;case"status":this.getStatus(w,p);break;case"extensionManagement":this.manageExtensions(w,p).catch(this.logService.error);break;default:p.writeHead(404),p.write(`Unknown message type: ${w.type}`,D=>{D&&this.logService.error(D)}),p.end();break}})}open(a,p){let{fileURIs:h,folderURIs:w,forceNewWindow:D,diffMode:T,addMode:b,forceReuseWindow:l,gotoLineMode:o,waitMarkerFilePath:v}=a;const n=[];if(Array.isArray(w))for(const f of w)try{n.push({folderUri:P.URI.parse(f)})}catch(r){}if(Array.isArray(h))for(const f of h)try{(0,_.hasWorkspaceFileExtension)(f)?n.push({workspaceUri:P.URI.parse(f)}):n.push({fileUri:P.URI.parse(f)})}catch(r){}if(n.length){const f=v?P.URI.file(v):void 0,t={forceNewWindow:D,diffMode:T,addMode:b,gotoLineMode:o,forceReuseWindow:l,preferNewWindow:!l&&!f&&!b,waitMarkerFileURI:f};this._commands.executeCommand("_remoteCLI.windowOpen",n,t)}p.writeHead(200),p.end()}async openExternal(a,p){for(const h of a.uris){const w=P.URI.parse(h),D=w.scheme==="file"?w:h;await this._commands.executeCommand("_remoteCLI.openExternal",D)}p.writeHead(200),p.end()}async manageExtensions(a,p){try{const h=T=>T?.map(b=>/\.vsix$/i.test(b)?P.URI.parse(b):b),w={list:a.list,install:h(a.install),uninstall:h(a.uninstall),force:a.force},D=await this._commands.executeCommand("_remoteCLI.manageExtensions",w);p.writeHead(200),p.write(D)}catch(h){p.writeHead(500),p.write(String(h),w=>{w&&this.logService.error(w)})}p.end()}async getStatus(a,p){try{const h=await this._commands.executeCommand("_remoteCLI.getSystemStatus");p.writeHead(200),p.write(h),p.end()}catch(h){p.writeHead(500),p.write(String(h),w=>{w&&this.logService.error(w)}),p.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=k;let i=class extends k{constructor(a,p){super(a,p,(0,g.createRandomIPCHandle)())}};i=Ve([We(0,S.IExtHostCommands),We(1,y.ILogService)],i),e.CLIServer=i}),define(fe[289],me([0,1,74,276,271,5,279,41,261,2,10,7,288,106]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends C.RequireInterceptor{_installInterceptor(){const T=this,b=Y.__$__nodeRequire("module"),l=b._load;b._load=function(v,n,f){for(let r of T._alternatives){let t=r(v);if(t){v=t;break}}return T._factories.has(v)?T._factories.get(v).load(v,k.URI.file((0,p.realpathSync)(n.filename)),r=>l.apply(this,[r,n,f])):l.apply(this,arguments)}}}class w extends _.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const T=this._instaService.invokeFunction(F.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const n=this._instaService.createInstance(a.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=n.ipcHandlePath}await this._instaService.createInstance(h,T,this._registry).install(),g.mark("code/extHost/didInitAPI");const l=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,l,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const o=process.send,v=this._extHostContext.getProxy(S.MainContext.MainThreadConsole);process.send=(...n)=>n.length===0||!n[0]||n[0].type!=="__$console"?o.apply(process,n):(v.$logExtensionHostMessage(n[0]),!1)}_getEntryPoint(T){return T.main}_loadCommonJSModule(T,b,l){if(b.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let o=null;l.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{T&&g.mark(`code/extHost/willLoadExtensionCode/${T.value}`),o=Y.__$__nodeRequire(b.fsPath)}catch(v){return Promise.reject(v)}finally{T&&g.mark(`code/extHost/didLoadExtensionCode/${T.value}`),l.codeLoadingStop()}return Promise.resolve(o)}async $setRemoteEnvironment(T){if(!!this._initData.remote.isRemote)for(const b in T){const l=T[b];l===null?delete process.env[b]:process.env[b]=l}}}e.ExtHostExtensionService=w}),define(fe[290],me([0,1,83,262,264,273,272,287,289,229,265,57,41,69,75,73,33,54,13,70,263]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D,T,b,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(a.IExtHostExtensionService,y.ExtHostExtensionService),(0,g.registerSingleton)(b.ILogService,k.ExtHostLogService),(0,g.registerSingleton)(l.IExtensionStoragePaths,o.ExtensionStoragePaths),(0,g.registerSingleton)(I.IExtHostDebugService,P.ExtHostDebugService),(0,g.registerSingleton)(p.IExtHostOutputService,F.ExtHostOutputService2),(0,g.registerSingleton)(h.IExtHostSearch,_.NativeExtHostSearch),(0,g.registerSingleton)(w.IExtHostTask,S.ExtHostTask),(0,g.registerSingleton)(D.IExtHostTerminalService,C.ExtHostTerminalService),(0,g.registerSingleton)(T.IExtHostTunnelService,i.ExtHostTunnelService)}),define(fe[291],me([0,1,127,302,74,17,108,138,193,227,274,22,104,26,106,15,115,277,290]),function(Y,e,g,F,C,S,P,_,y,k,i,I,a,p,h,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let d=0;d<process.execArgv.length;d++)process.execArgv[d]==="--inspect-port=0"&&(process.execArgv.splice(d,1),d--)}();const T=F(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=Y.__$__nodeRequire("module"),d=t._load;t._load=function(s){if(s==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return d.apply(this,arguments)}})();const b=process.exit.bind(process);function l(t){process.exit=function(d){if(t)b(d);else{const s=new Error("An extension called process.exit() and this was prevented.");console.warn(s.stack)}},process.crash=function(){const d=new Error("An extension called process.crash() and this was prevented.");console.warn(d.stack)}}let o=function(t){b()};function v(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,d)=>{let s=null,c=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,u=3e5,E=new w.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (1)"),m),R=new w.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (2)"),u);process.on("message",(M,A)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){const B=I.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let V;if(M.skipWebSocketFrames)V=new _.NodeSocket(A);else{const N=I.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));V=new _.WebSocketNodeSocket(new _.NodeSocket(A),M.permessageDeflate,N,!1)}s?(E.cancel(),R.cancel(),s.beginAcceptReconnection(V,B),s.endAcceptReconnection()):(clearTimeout(c),s=new P.PersistentProtocol(V,B),s.onDidDispose(()=>o("renderer disconnected")),t(s),s.onSocketClose(()=>{E.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(R.isScheduled())return;E.isScheduled()&&R.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((d,s)=>{const c=g.createConnection(t,()=>{c.removeListener("error",s),d(new P.PersistentProtocol(new _.NodeSocket(c)))});c.once("error",s),c.on("close",()=>{o("renderer closed the socket")})})}}async function n(){const t=await v();return new class{constructor(){this._onMessage=new P.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(d=>{(0,k.isMessageOfType)(d,2)?(this._terminating=!0,o("received terminate message from renderer")):this._onMessage.fire(d)})}send(d){this._terminating||t.send(d)}drain(){return t.drain()}}}function f(t){return new Promise(d=>{const s=t.onMessage(c=>{s.dispose();const m=JSON.parse(c.toString()),u=m.commit,E=y.default.commit;u&&E&&u!==E&&b(55);const R=[];process.on("unhandledRejection",(A,B)=>{R.push(B),setTimeout(()=>{const V=R.indexOf(B);V>=0&&B.catch(N=>{R.splice(V,1),(0,S.isPromiseCanceledError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),(0,S.onUnexpectedError)(A))})},1e3)}),process.on("rejectionHandled",A=>{const B=R.indexOf(A);B>=0&&R.splice(B,1)}),process.on("uncaughtException",function(A){(0,S.onUnexpectedError)(A)});let L=0;setInterval(function(){try{process.kill(m.parentPid,0),L=0}catch(A){A&&A.code==="EPERM"?(L++,L>=3&&o(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${A.message} (code: ${A.code}) (errno: ${A.errno})`)):o(`parent process ${m.parentPid} does not exist anymore: ${A.message} (code: ${A.code}) (errno: ${A.errno})`)}},1e3);let M;try{M=Y.__$__nodeRequire("native-watchdog"),M.start(m.parentPid)}catch(A){(0,S.onUnexpectedError)(A)}t.send((0,k.createMessageOfType)(0)),d({protocol:t,initData:m})});t.send((0,k.createMessageOfType)(1))})}async function r(){C.mark("code/extHost/willConnectToRenderer");const t=await n();C.mark("code/extHost/didConnectToRenderer");const d=await f(t);C.mark("code/extHost/didWaitForInitData");const{initData:s}=d;l(!!s.environment.extensionTestsLocationURI),s.environment.useHostProxy=T.useHostProxy!==void 0?T.useHostProxy!=="false":void 0,s.environment.skipWorkspaceStorageLock=(0,D.boolean)(T.skipWorkspaceStorageLock,!1);const c=new class{exit(R){b(R)}exists(R){return p.Promises.exists(R)}realpath(R){return(0,h.realpath)(R)}};let m=null;if(s.remote.authority&&T.uriTransformerPath)try{const R=Y.__$__nodeRequire(T.uriTransformerPath)(s.remote.authority);m=new a.URITransformer(R)}catch(E){console.error(E)}const u=new i.ExtensionHostMain(d.protocol,s,c,m);o=E=>u.terminate(E)}e.startExtensionHostProcess=r}),define(fe[303],me([0,1,291]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(F=>console.log(F))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/97018d742e4ce3dfbcdb0a02c42c16c6c152e4e1/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
