/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/base/common/iterator","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(oe){for(var e=[],d=0,M=oe.length;d<M;d++)e[d]=be[oe[d]];return e};define(be[42],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(M,_){if(!M)throw new Error(_?`Assertion failed (${_})`:"Assertion Failed")}e.ok=d}),define(be[52],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function M(t){const y=[];for(let n in t)d.call(t,n)&&y.push(t[n]);return y}e.values=M;function _(t,y){for(let n in t)if(d.call(t,n)&&y({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=_;function A(t,y){const n=Object.create(null);for(const m of t){const s=y(m);let u=n[s];u||(u=n[s]=[]),u.push(m)}return n}e.groupBy=A;function F(t){const y=Object.create(null);return t&&t.forEach((n,m)=>{y[m]=n}),y}e.fromMap=F;function k(t,y){const n=[],m=[];for(let s of t)y.has(s)||n.push(s);for(let s of y)t.has(s)||m.push(s);return{removed:n,added:m}}e.diffSets=k;function D(t,y){const n=[],m=[];for(let[s,u]of t)y.has(s)||n.push(u);for(let[s,u]of y)t.has(s)||m.push(u);return{removed:n,added:m}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(y,n){let m=this.map.get(y);m||(m=new Set,this.map.set(y,m)),m.add(n)}delete(y,n){const m=this.map.get(y);!m||(m.delete(n),m.size===0&&this.map.delete(y))}forEach(y,n){const m=this.map.get(y);!m||m.forEach(n)}}e.SetMap=P}),define(be[53],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(F){return(k,D,P)=>{let t=null,y=null;if(typeof P.value=="function"?(t="value",y=P.value):typeof P.get=="function"&&(t="get",y=P.get),!y)throw new Error("not supported");P[t]=F(y,D)}}e.createDecorator=d;function M(F,k,D){let P=null,t=null;if(typeof D.value=="function"?(P="value",t=D.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(P="get",t=D.get),!t)throw new Error("not supported");const y=`$memoize$${k}`;D[P]=function(...n){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[y]}}e.memoize=M;function _(F,k,D){return d((P,t)=>{const y=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...m){this[n]||(this[n]=D?D():void 0),clearTimeout(this[y]),k&&(this[n]=k(this[n],...m),m=[this[n]]),this[y]=setTimeout(()=>{P.apply(this,m),this[n]=D?D():void 0},F)}})}e.debounce=_;function A(F,k,D){return d((P,t)=>{const y=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,m=`$throttle$lastRun$${t}`,s=`$throttle$pending$${t}`;return function(...u){if(this[n]||(this[n]=D?D():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),k&&(this[n]=k(this[n],...u)),this[s])return;const g=this[m]+F;g<=Date.now()?(this[m]=Date.now(),P.apply(this,[this[n]]),this[n]=D?D():void 0):(this[s]=!0,this[y]=setTimeout(()=>{this[s]=!1,this[m]=Date.now(),P.apply(this,[this[n]]),this[n]=D?D():void 0},g-Date.now()))}})}e.throttle=A}),define(be[14],Ee([0,1,16]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(j,le=0){return j[j.length-(1+le)]}e.tail=M;function _(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=_;function A(j,le,re=(ve,Fe)=>ve===Fe){if(j===le)return!0;if(!j||!le||j.length!==le.length)return!1;for(let ve=0,Fe=j.length;ve<Fe;ve++)if(!re(j[ve],le[ve]))return!1;return!0}e.equals=A;function F(j,le,re){let ve=0,Fe=j.length-1;for(;ve<=Fe;){const Me=(ve+Fe)/2|0,Oe=re(j[Me],le);if(Oe<0)ve=Me+1;else if(Oe>0)Fe=Me-1;else return Me}return-(ve+1)}e.binarySearch=F;function k(j,le){let re=0,ve=j.length;if(ve===0)return 0;for(;re<ve;){const Fe=Math.floor((re+ve)/2);le(j[Fe])?ve=Fe:re=Fe+1}return re}e.findFirstInSorted=k;function D(j,le,re){if(j=j|0,j>=le.length)throw new TypeError("invalid index");let ve=le[Math.floor(le.length*Math.random())],Fe=[],Me=[],Oe=[];for(let Ke of le){const je=re(Ke,ve);je<0?Fe.push(Ke):je>0?Me.push(Ke):Oe.push(Ke)}return j<Fe.length?D(j,Fe,re):j<Fe.length+Oe.length?Oe[0]:D(j-(Fe.length+Oe.length),Me,re)}e.quickSelect=D;function P(j,le){const re=[];let ve;for(const Fe of j.slice(0).sort(le))!ve||le(ve[0],Fe)!==0?(ve=[Fe],re.push(ve)):ve.push(Fe);return re}e.groupBy=P;function t(j,le,re){const ve=[];function Fe(Ke,je,Ve){if(je===0&&Ve.length===0)return;const U=ve[ve.length-1];U&&U.start+U.deleteCount===Ke?(U.deleteCount+=je,U.toInsert.push(...Ve)):ve.push({start:Ke,deleteCount:je,toInsert:Ve})}let Me=0,Oe=0;for(;;){if(Me===j.length){Fe(Me,0,le.slice(Oe));break}if(Oe===le.length){Fe(Me,j.length-Me,[]);break}const Ke=j[Me],je=le[Oe],Ve=re(Ke,je);Ve===0?(Me+=1,Oe+=1):Ve<0?(Fe(Me,1,[]),Me+=1):Ve>0&&(Fe(Me,0,[je]),Oe+=1)}return ve}e.sortedDiff=t;function y(j,le,re){const ve=t(j,le,re),Fe=[],Me=[];for(const Oe of ve)Fe.push(...j.slice(Oe.start,Oe.start+Oe.deleteCount)),Me.push(...Oe.toInsert);return{removed:Fe,added:Me}}e.delta=y;function n(j,le,re){if(re===0)return[];const ve=j.slice(0,re).sort(le);return s(j,le,ve,re,j.length),ve}e.top=n;function m(j,le,re,ve,Fe){return re===0?Promise.resolve([]):new Promise((Me,Oe)=>{(async()=>{const Ke=j.length,je=j.slice(0,re).sort(le);for(let Ve=re,U=Math.min(re+ve,Ke);Ve<Ke;Ve=U,U=Math.min(U+ve,Ke)){if(Ve>re&&await new Promise(Q=>setTimeout(Q)),Fe&&Fe.isCancellationRequested)throw(0,d.canceled)();s(j,le,je,Ve,U)}return je})().then(Me,Oe)})}e.topAsync=m;function s(j,le,re,ve,Fe){for(const Me=re.length;ve<Fe;ve++){const Oe=j[ve];if(le(Oe,re[Me-1])<0){re.pop();const Ke=k(re,je=>le(Oe,je)<0);re.splice(Ke,0,Oe)}}}function u(j){return j.filter(le=>!!le)}e.coalesce=u;function g(j){let le=0;for(let re=0;re<j.length;re++)j[re]&&(j[le]=j[re],le+=1);j.length=le}e.coalesceInPlace=g;function I(j,le,re){j.splice(re,0,j.splice(le,1)[0])}e.move=I;function E(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=E;function o(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=o;function h(j,le=re=>re){const re=new Set;return j.filter(ve=>{const Fe=le(ve);return re.has(Fe)?!1:(re.add(Fe),!0)})}e.distinct=h;function C(j){const le=Object.create(null);return re=>{const ve=j(re);return le[ve]?!1:(le[ve]=!0,!0)}}e.uniqueFilter=C;function i(j,le){const re=p(j,le);if(re!==-1)return j[re]}e.findLast=i;function p(j,le){for(let re=j.length-1;re>=0;re--){const ve=j[re];if(le(ve))return re}return-1}e.lastIndex=p;function a(j,le){return j.length>0?j[0]:le}e.firstOrDefault=a;function r(j,le,re=(ve,Fe)=>ve===Fe){let ve=0;for(let Fe=0,Me=Math.min(j.length,le.length);Fe<Me&&re(j[Fe],le[Fe]);Fe++)ve++;return ve}e.commonPrefixLength=r;function v(j){return[].concat(...j)}e.flatten=v;function l(j,le){let re=typeof le=="number"?j:0;typeof le=="number"?re=j:(re=0,le=j);const ve=[];if(re<=le)for(let Fe=re;Fe<le;Fe++)ve.push(Fe);else for(let Fe=re;Fe>le;Fe--)ve.push(Fe);return ve}e.range=l;function c(j,le,re){return j.reduce((ve,Fe)=>(ve[le(Fe)]=re?re(Fe):Fe,ve),Object.create(null))}e.index=c;function w(j,le){return j.push(le),()=>f(j,le)}e.insert=w;function f(j,le){const re=j.indexOf(le);if(re>-1)return j.splice(re,1),le}e.remove=f;function S(j,le,re){const ve=j.slice(0,le),Fe=j.slice(le);return ve.concat(re,Fe)}e.arrayInsert=S;function R(j,le){let re;if(typeof le=="number"){let ve=le;re=()=>{const Fe=Math.sin(ve++)*179426549;return Fe-Math.floor(Fe)}}else re=Math.random;for(let ve=j.length-1;ve>0;ve-=1){const Fe=Math.floor(re()*(ve+1)),Me=j[ve];j[ve]=j[Fe],j[Fe]=Me}}e.shuffle=R;function T(j,le){const re=j.indexOf(le);re>-1&&(j.splice(re,1),j.unshift(le))}e.pushToStart=T;function L(j,le){const re=j.indexOf(le);re>-1&&(j.splice(re,1),j.push(le))}e.pushToEnd=L;function b(j,le){return Array.isArray(j)?j.map(le):le(j)}e.mapArrayOrNot=b;function x(j){return Array.isArray(j)?j:[j]}e.asArray=x;function $(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=$;function B(j,le){for(const re of j){const ve=le(re);if(ve!==void 0)return ve}}e.mapFind=B;function G(j,le,re){const ve=W(j,le),Fe=j.length,Me=re.length;j.length=Fe+Me;for(let Oe=Fe-1;Oe>=ve;Oe--)j[Oe+Me]=j[Oe];for(let Oe=0;Oe<Me;Oe++)j[Oe+ve]=re[Oe]}e.insertInto=G;function H(j,le,re,ve){const Fe=W(j,le),Me=j.splice(Fe,re);return G(j,Fe,ve),Me}e.splice=H;function W(j,le){return le<0?Math.max(le+j.length,0):Math.min(le,j.length)}function ne(j,le){let re=Number.MAX_SAFE_INTEGER,ve=0;return j.forEach((Fe,Me)=>{const Oe=le(Fe);Oe<re&&(re=Oe,ve=Me)}),ve}e.minIndex=ne;function V(j,le){let re=Number.MIN_SAFE_INTEGER,ve=0;return j.forEach((Fe,Me)=>{const Oe=le(Fe);Oe>re&&(re=Oe,ve=Me)}),ve}e.maxIndex=V;class Y{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let re=this.firstIdx;for(;re<this.items.length&&le(this.items[re]);)re++;const ve=re===this.firstIdx?null:this.items.slice(this.firstIdx,re);return this.firstIdx=re,ve}takeFromEndWhile(le){let re=this.lastIdx;for(;re>=0&&le(this.items[re]);)re--;const ve=re===this.lastIdx?null:this.items.slice(re+1,this.lastIdx+1);return this.lastIdx=re,ve}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=Y}),define(be[54],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(_){this._prefix=_,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(be[102],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var _;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(_=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function F(i,p=!1){let a=0,r=i.length,v="",l=0,c=16,w=0;function f($){let B=0,G=0;for(;B<$;){const H=i.charCodeAt(a);if(H>=48&&H<=57)G=G*16+H-48;else if(H>=65&&H<=70)G=G*16+H-65+10;else if(H>=97&&H<=102)G=G*16+H-97+10;else break;a++,B++}return B<$&&(G=-1),G}function S($){a=$,v="",l=0,c=16,w=0}function R(){const $=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&P(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&P(i.charCodeAt(a)))for(a++;a<i.length&&P(i.charCodeAt(a));)a++;else return w=3,i.substring($,a);let B=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&P(i.charCodeAt(a))){for(a++;a<i.length&&P(i.charCodeAt(a));)a++;B=a}else w=3;return i.substring($,B)}function T(){let $="",B=a;for(;;){if(a>=r){$+=i.substring(B,a),w=2;break}const G=i.charCodeAt(a);if(G===34){$+=i.substring(B,a),a++;break}if(G===92){if($+=i.substring(B,a),a++,a>=r){w=2;break}switch(i.charCodeAt(a++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const W=f(4);W>=0?$+=String.fromCharCode(W):w=4;break;default:w=5}B=a;continue}if(G>=0&&G<=31)if(D(G)){$+=i.substring(B,a),w=2;break}else w=6;a++}return $}function L(){if(v="",w=0,l=a,a>=r)return l=r,c=17;let $=i.charCodeAt(a);if(k($)){do a++,v+=String.fromCharCode($),$=i.charCodeAt(a);while(k($));return c=15}if(D($))return a++,v+=String.fromCharCode($),$===13&&i.charCodeAt(a)===10&&(a++,v+=`
`),c=14;switch($){case 123:return a++,c=1;case 125:return a++,c=2;case 91:return a++,c=3;case 93:return a++,c=4;case 58:return a++,c=6;case 44:return a++,c=5;case 34:return a++,v=T(),c=10;case 47:const B=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<r&&!D(i.charCodeAt(a));)a++;return v=i.substring(B,a),c=12}if(i.charCodeAt(a+1)===42){a+=2;const G=r-1;let H=!1;for(;a<G;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,H=!0;break}a++}return H||(a++,w=1),v=i.substring(B,a),c=13}return v+=String.fromCharCode($),a++,c=16;case 45:if(v+=String.fromCharCode($),a++,a===r||!P(i.charCodeAt(a)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=R(),c=11;default:for(;a<r&&b($);)a++,$=i.charCodeAt(a);if(l!==a){switch(v=i.substring(l,a),v){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return v+=String.fromCharCode($),a++,c=16}}function b($){if(k($)||D($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let $;do $=L();while($>=12&&$<=15);return $}return{setPosition:S,getPosition:()=>a,scan:p?x:L,getToken:()=>c,getTokenValue:()=>v,getTokenOffset:()=>l,getTokenLength:()=>a-l,getTokenError:()=>w}}e.createScanner=F;function k(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function D(i){return i===10||i===13||i===8232||i===8233}function P(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function y(i,p){const a=[],r=new Object;let v;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function w(f,S,R,T){l.value=f,l.offset=S,l.length=R,l.type=T,l.colonOffset=void 0,v=l}try{o(i,{onObjectBegin:(f,S)=>{if(p<=f)throw r;v=void 0,c=p>f,a.push("")},onObjectProperty:(f,S,R)=>{if(p<S||(w(f,S,R,"property"),a[a.length-1]=f,p<=S+R))throw r},onObjectEnd:(f,S)=>{if(p<=f)throw r;v=void 0,a.pop()},onArrayBegin:(f,S)=>{if(p<=f)throw r;v=void 0,a.push(0)},onArrayEnd:(f,S)=>{if(p<=f)throw r;v=void 0,a.pop()},onLiteralValue:(f,S,R)=>{if(p<S||(w(f,S,R,C(f)),p<=S+R))throw r},onSeparator:(f,S,R)=>{if(p<=S)throw r;if(f===":"&&v&&v.type==="property")v.colonOffset=S,c=!1,v=void 0;else if(f===","){const T=a[a.length-1];typeof T=="number"?a[a.length-1]=T+1:(c=!0,a[a.length-1]=""),v=void 0}}})}catch(f){if(f!==r)throw f}return{path:a,previousNode:v,isAtPropertyKey:c,matches:f=>{let S=0;for(let R=0;S<f.length&&R<a.length;R++)if(f[S]===a[R]||f[S]==="*")S++;else if(f[S]!=="**")return!1;return S===f.length}}}e.getLocation=y;function n(i,p=[],a=A.DEFAULT){let r=null,v=[];const l=[];function c(f){Array.isArray(v)?v.push(f):r!==null&&(v[r]=f)}return o(i,{onObjectBegin:()=>{const f={};c(f),l.push(v),v=f,r=null},onObjectProperty:f=>{r=f},onObjectEnd:()=>{v=l.pop()},onArrayBegin:()=>{const f=[];c(f),l.push(v),v=f,r=null},onArrayEnd:()=>{v=l.pop()},onLiteralValue:c,onError:(f,S,R)=>{p.push({error:f,offset:S,length:R})}},a),v[0]}e.parse=n;function m(i,p=[],a=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(f){r.type==="property"&&(r.length=f-r.offset,r=r.parent)}function l(f){return r.children.push(f),f}o(i,{onObjectBegin:f=>{r=l({type:"object",offset:f,length:-1,parent:r,children:[]})},onObjectProperty:(f,S,R)=>{r=l({type:"property",offset:S,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:f,offset:S,length:R,parent:r})},onObjectEnd:(f,S)=>{r.length=f+S-r.offset,r=r.parent,v(f+S)},onArrayBegin:(f,S)=>{r=l({type:"array",offset:f,length:-1,parent:r,children:[]})},onArrayEnd:(f,S)=>{r.length=f+S-r.offset,r=r.parent,v(f+S)},onLiteralValue:(f,S,R)=>{l({type:C(f),offset:S,length:R,parent:r,value:f}),v(S+R)},onSeparator:(f,S,R)=>{r.type==="property"&&(f===":"?r.colonOffset=S:f===","&&v(S))},onError:(f,S,R)=>{p.push({error:f,offset:S,length:R})}},a);const w=r.children[0];return w&&delete w.parent,w}e.parseTree=m;function s(i,p){if(!i)return;let a=i;for(let r of p)if(typeof r=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let v=!1;for(const l of a.children)if(Array.isArray(l.children)&&l.children[0].value===r){a=l.children[1],v=!0;break}if(!v)return}else{const v=r;if(a.type!=="array"||v<0||!Array.isArray(a.children)||v>=a.children.length)return;a=a.children[v]}return a}e.findNodeAtLocation=s;function u(i){if(!i.parent||!i.parent.children)return[];const p=u(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;p.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&p.push(a)}return p}e.getNodePath=u;function g(i){switch(i.type){case"array":return i.children.map(g);case"object":const p=Object.create(null);for(let a of i.children){const r=a.children[1];r&&(p[a.children[0].value]=g(r))}return p;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=g;function I(i,p,a=!1){return p>=i.offset&&p<i.offset+i.length||a&&p===i.offset+i.length}e.contains=I;function E(i,p,a=!1){if(I(i,p,a)){const r=i.children;if(Array.isArray(r))for(let v=0;v<r.length&&r[v].offset<=p;v++){const l=E(r[v],p,a);if(l)return l}return i}}e.findNodeAtOffset=E;function o(i,p,a=A.DEFAULT){const r=F(i,!1);function v(re){return re?()=>re(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(re){return re?ve=>re(ve,r.getTokenOffset(),r.getTokenLength()):()=>!0}const c=v(p.onObjectBegin),w=l(p.onObjectProperty),f=v(p.onObjectEnd),S=v(p.onArrayBegin),R=v(p.onArrayEnd),T=l(p.onLiteralValue),L=l(p.onSeparator),b=v(p.onComment),x=l(p.onError),$=a&&a.disallowComments,B=a&&a.allowTrailingComma;function G(){for(;;){const re=r.scan();switch(r.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:$||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(re){case 12:case 13:$?H(10):b();break;case 16:H(1);break;case 15:case 14:break;default:return re}}}function H(re,ve=[],Fe=[]){if(x(re),ve.length+Fe.length>0){let Me=r.getToken();for(;Me!==17;){if(ve.indexOf(Me)!==-1){G();break}else if(Fe.indexOf(Me)!==-1)break;Me=G()}}}function W(re){const ve=r.getTokenValue();return re?T(ve):w(ve),G(),!0}function ne(){switch(r.getToken()){case 11:let re=0;try{re=JSON.parse(r.getTokenValue()),typeof re!="number"&&(H(2),re=0)}catch(ve){H(2)}T(re);break;case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return G(),!0}function V(){return r.getToken()!==10?(H(3,[],[2,5]),!1):(W(!1),r.getToken()===6?(L(":"),G(),le()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function Y(){c(),G();let re=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(re||H(4,[],[]),L(","),G(),r.getToken()===2&&B)break}else re&&H(6,[],[]);V()||H(4,[],[2,5]),re=!0}return f(),r.getToken()!==2?H(7,[2],[]):G(),!0}function j(){S(),G();let re=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(re||H(4,[],[]),L(","),G(),r.getToken()===4&&B)break}else re&&H(6,[],[]);le()||H(4,[],[4,5]),re=!0}return R(),r.getToken()!==4?H(8,[4],[]):G(),!0}function le(){switch(r.getToken()){case 3:return j();case 1:return Y();case 10:return W(!0);default:return ne()}}return G(),r.getToken()===17?a.allowEmptyContent?!0:(H(4,[],[]),!1):le()?(r.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=o;function h(i,p){let a=F(i),r=[],v,l=0,c;do switch(c=a.getPosition(),v=a.scan(),v){case 12:case 13:case 17:l!==c&&r.push(i.substring(l,c)),p!==void 0&&r.push(a.getTokenValue().replace(/[^\r\n]/g,p)),l=a.getPosition();break}while(v!==17);return r.join("")}e.stripComments=h;function C(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),define(be[103],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(_){this.executor=_,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(_){this._error=_}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(_){return new d(()=>_(this.getValue()))}}e.Lazy=d}),function(oe,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(oe=typeof globalThis!="undefined"?globalThis:oe||self,oe.marked=e())}(this,function(){"use strict";function oe(Pe,Se){for(var Ce=0;Ce<Se.length;Ce++){var te=Se[Ce];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(Pe,te.key,te)}}function e(Pe,Se,Ce){return Se&&oe(Pe.prototype,Se),Ce&&oe(Pe,Ce),Pe}function d(Pe,Se){if(!!Pe){if(typeof Pe=="string")return M(Pe,Se);var Ce=Object.prototype.toString.call(Pe).slice(8,-1);if(Ce==="Object"&&Pe.constructor&&(Ce=Pe.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Pe);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return M(Pe,Se)}}function M(Pe,Se){(Se==null||Se>Pe.length)&&(Se=Pe.length);for(var Ce=0,te=new Array(Se);Ce<Se;Ce++)te[Ce]=Pe[Ce];return te}function _(Pe,Se){var Ce=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(Ce)return(Ce=Ce.call(Pe)).next.bind(Ce);if(Array.isArray(Pe)||(Ce=d(Pe))||Se&&Pe&&typeof Pe.length=="number"){Ce&&(Pe=Ce);var te=0;return function(){return te>=Pe.length?{done:!0}:{done:!1,value:Pe[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function F(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Pe){A.exports.defaults=Pe}A.exports={defaults:F(),getDefaults:F,changeDefaults:k};var D=/[&<>"']/,P=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(Se){return n[Se]};function s(Pe,Se){if(Se){if(D.test(Pe))return Pe.replace(P,m)}else if(t.test(Pe))return Pe.replace(y,m);return Pe}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(Pe){return Pe.replace(u,function(Se,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var I=/(^|[^\[])\^/g;function E(Pe,Se){Pe=Pe.source||Pe,Se=Se||"";var Ce={replace:function(ue,me){return me=me.source||me,me=me.replace(I,"$1"),Pe=Pe.replace(ue,me),Ce},getRegex:function(){return new RegExp(Pe,Se)}};return Ce}var o=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function C(Pe,Se,Ce){if(Pe){var te;try{te=decodeURIComponent(g(Ce)).replace(o,"").toLowerCase()}catch(ue){return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}Se&&!h.test(Ce)&&(Ce=v(Se,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(ue){return null}return Ce}var i={},p=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(Pe,Se){i[" "+Pe]||(p.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=f(Pe,"/",!0)),Pe=i[" "+Pe];var Ce=Pe.indexOf(":")===-1;return Se.substring(0,2)==="//"?Ce?Se:Pe.replace(a,"$1")+Se:Se.charAt(0)==="/"?Ce?Se:Pe.replace(r,"$1")+Se:Pe+Se}var l={exec:function(){}};function c(Pe){for(var Se=1,Ce,te;Se<arguments.length;Se++){Ce=arguments[Se];for(te in Ce)Object.prototype.hasOwnProperty.call(Ce,te)&&(Pe[te]=Ce[te])}return Pe}function w(Pe,Se){var Ce=Pe.replace(/\|/g,function(me,fe,Ie){for(var Be=!1,Ne=fe;--Ne>=0&&Ie[Ne]==="\\";)Be=!Be;return Be?"|":" |"}),te=Ce.split(/ \|/),ue=0;if(te[0].trim()||te.shift(),te[te.length-1].trim()||te.pop(),te.length>Se)te.splice(Se);else for(;te.length<Se;)te.push("");for(;ue<te.length;ue++)te[ue]=te[ue].trim().replace(/\\\|/g,"|");return te}function f(Pe,Se,Ce){var te=Pe.length;if(te===0)return"";for(var ue=0;ue<te;){var me=Pe.charAt(te-ue-1);if(me===Se&&!Ce)ue++;else if(me!==Se&&Ce)ue++;else break}return Pe.substr(0,te-ue)}function S(Pe,Se){if(Pe.indexOf(Se[1])===-1)return-1;for(var Ce=Pe.length,te=0,ue=0;ue<Ce;ue++)if(Pe[ue]==="\\")ue++;else if(Pe[ue]===Se[0])te++;else if(Pe[ue]===Se[1]&&(te--,te<0))return ue;return-1}function R(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(Pe,Se){if(Se<1)return"";for(var Ce="";Se>1;)Se&1&&(Ce+=Pe),Se>>=1,Pe+=Pe;return Ce+Pe}var L={escape:s,unescape:g,edit:E,cleanUrl:C,resolveUrl:v,noopTest:l,merge:c,splitCells:w,rtrim:f,findClosingBracket:S,checkSanitizeDeprecation:R,repeatString:T},b=A.exports.defaults,x=L.rtrim,$=L.splitCells,B=L.escape,G=L.findClosingBracket;function H(Pe,Se,Ce,te){var ue=Se.href,me=Se.title?B(Se.title):null,fe=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){te.state.inLink=!0;var Ie={type:"link",raw:Ce,href:ue,title:me,text:fe,tokens:te.inlineTokens(fe,[])};return te.state.inLink=!1,Ie}else return{type:"image",raw:Ce,href:ue,title:me,text:B(fe)}}function W(Pe,Se){var Ce=Pe.match(/^(\s+)(?:```)/);if(Ce===null)return Se;var te=Ce[1];return Se.split(`
`).map(function(ue){var me=ue.match(/^\s+/);if(me===null)return ue;var fe=me[0];return fe.length>=te.length?ue.slice(te.length):ue}).join(`
`)}var ne=function(){function Pe(Ce){this.options=Ce||b}var Se=Pe.prototype;return Se.space=function(te){var ue=this.rules.block.newline.exec(te);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},Se.code=function(te){var ue=this.rules.block.code.exec(te);if(ue){var me=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?me:x(me,`
`)}}},Se.fences=function(te){var ue=this.rules.block.fences.exec(te);if(ue){var me=ue[0],fe=W(me,ue[3]||"");return{type:"code",raw:me,lang:ue[2]?ue[2].trim():ue[2],text:fe}}},Se.heading=function(te){var ue=this.rules.block.heading.exec(te);if(ue){var me=ue[2].trim();if(/#$/.test(me)){var fe=x(me,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(me=fe.trim())}var Ie={type:"heading",raw:ue[0],depth:ue[1].length,text:me,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},Se.hr=function(te){var ue=this.rules.block.hr.exec(te);if(ue)return{type:"hr",raw:ue[0]}},Se.blockquote=function(te){var ue=this.rules.block.blockquote.exec(te);if(ue){var me=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},Se.list=function(te){var ue=this.rules.block.list.exec(te);if(ue){var me,fe,Ie,Be,Ne,qe,it,Le,de,ge,X=ue[1].trim(),z=X.length>1,we={type:"list",raw:"",ordered:z,start:z?+X.slice(0,-1):"",loose:!1,items:[]};X=z?"\\d{1,9}\\"+X.slice(-1):"\\"+X,this.options.pedantic&&(X=z?X:"[*+-]");for(var ke=new RegExp("^( {0,3}"+X+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");te&&!(this.rules.block.hr.test(te)||!(ue=ke.exec(te)));){de=ue[2].split(`
`),this.options.pedantic?(Be=2,ge=de[0].trimLeft()):(Be=ue[2].search(/[^ ]/),Be=ue[1].length+(Be>4?1:Be),ge=de[0].slice(Be-ue[1].length)),qe=!1,me=ue[0],!de[0]&&/^ *$/.test(de[1])&&(me=ue[1]+de.slice(0,2).join(`
`)+`
`,we.loose=!0,de=[]);var Je=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Ne=1;Ne<de.length;Ne++){if(Le=de[Ne],this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Je.test(Le)){me=ue[1]+de.slice(0,Ne).join(`
`)+`
`;break}if(!qe){Le.trim()||(qe=!0),Le.search(/[^ ]/)>=Be?ge+=`
`+Le.slice(Be):ge+=`
`+Le;continue}if(Le.search(/[^ ]/)>=Be||!Le.trim()){ge+=`
`+Le.slice(Be);continue}else{me=ue[1]+de.slice(0,Ne).join(`
`)+`
`;break}}we.loose||(it?we.loose=!0:/\n *\n *$/.test(me)&&(it=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(ge),fe&&(Ie=fe[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:me,task:!!fe,checked:Ie,loose:!1,text:ge}),we.raw+=me,te=te.slice(me.length)}we.items[we.items.length-1].raw=me.trimRight(),we.items[we.items.length-1].text=ge.trimRight(),we.raw=we.raw.trimRight();var xe=we.items.length;for(Ne=0;Ne<xe;Ne++)this.lexer.state.top=!1,we.items[Ne].tokens=this.lexer.blockTokens(we.items[Ne].text,[]),we.items[Ne].tokens.some(function(ct){return ct.type==="space"})&&(we.loose=!0,we.items[Ne].loose=!0);return we}},Se.html=function(te){var ue=this.rules.block.html.exec(te);if(ue){var me={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(me.type="paragraph",me.text=this.options.sanitizer?this.options.sanitizer(ue[0]):B(ue[0]),me.tokens=[],this.lexer.inline(me.text,me.tokens)),me}},Se.def=function(te){var ue=this.rules.block.def.exec(te);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var me=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:ue[0],href:ue[2],title:ue[3]}}},Se.table=function(te){var ue=this.rules.block.table.exec(te);if(ue){var me={type:"table",header:$(ue[1]).map(function(it){return{text:it}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=ue[0];var fe=me.align.length,Ie,Be,Ne,qe;for(Ie=0;Ie<fe;Ie++)/^ *-+: *$/.test(me.align[Ie])?me.align[Ie]="right":/^ *:-+: *$/.test(me.align[Ie])?me.align[Ie]="center":/^ *:-+ *$/.test(me.align[Ie])?me.align[Ie]="left":me.align[Ie]=null;for(fe=me.rows.length,Ie=0;Ie<fe;Ie++)me.rows[Ie]=$(me.rows[Ie],me.header.length).map(function(it){return{text:it}});for(fe=me.header.length,Be=0;Be<fe;Be++)me.header[Be].tokens=[],this.lexer.inlineTokens(me.header[Be].text,me.header[Be].tokens);for(fe=me.rows.length,Be=0;Be<fe;Be++)for(qe=me.rows[Be],Ne=0;Ne<qe.length;Ne++)qe[Ne].tokens=[],this.lexer.inlineTokens(qe[Ne].text,qe[Ne].tokens);return me}}},Se.lheading=function(te){var ue=this.rules.block.lheading.exec(te);if(ue){var me={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(me.text,me.tokens),me}},Se.paragraph=function(te){var ue=this.rules.block.paragraph.exec(te);if(ue){var me={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(me.text,me.tokens),me}},Se.text=function(te){var ue=this.rules.block.text.exec(te);if(ue){var me={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(me.text,me.tokens),me}},Se.escape=function(te){var ue=this.rules.inline.escape.exec(te);if(ue)return{type:"escape",raw:ue[0],text:B(ue[1])}},Se.tag=function(te){var ue=this.rules.inline.tag.exec(te);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):B(ue[0]):ue[0]}},Se.link=function(te){var ue=this.rules.inline.link.exec(te);if(ue){var me=ue[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var fe=x(me.slice(0,-1),"\\");if((me.length-fe.length)%2==0)return}else{var Ie=G(ue[2],"()");if(Ie>-1){var Be=ue[0].indexOf("!")===0?5:4,Ne=Be+ue[1].length+Ie;ue[2]=ue[2].substring(0,Ie),ue[0]=ue[0].substring(0,Ne).trim(),ue[3]=""}}var qe=ue[2],it="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(qe);Le&&(qe=Le[1],it=Le[3])}else it=ue[3]?ue[3].slice(1,-1):"";return qe=qe.trim(),/^</.test(qe)&&(this.options.pedantic&&!/>$/.test(me)?qe=qe.slice(1):qe=qe.slice(1,-1)),H(ue,{href:qe&&qe.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},Se.reflink=function(te,ue){var me;if((me=this.rules.inline.reflink.exec(te))||(me=this.rules.inline.nolink.exec(te))){var fe=(me[2]||me[1]).replace(/\s+/g," ");if(fe=ue[fe.toLowerCase()],!fe||!fe.href){var Ie=me[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return H(me,fe,me[0],this.lexer)}},Se.emStrong=function(te,ue,me){me===void 0&&(me="");var fe=this.rules.inline.emStrong.lDelim.exec(te);if(!!fe&&!(fe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=fe[1]||fe[2]||"";if(!Ie||Ie&&(me===""||this.rules.inline.punctuation.exec(me))){var Be=fe[0].length-1,Ne,qe,it=Be,Le=0,de=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,ue=ue.slice(-1*te.length+Be);(fe=de.exec(ue))!=null;)if(Ne=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ne){if(qe=Ne.length,fe[3]||fe[4]){it+=qe;continue}else if((fe[5]||fe[6])&&Be%3&&!((Be+qe)%3)){Le+=qe;continue}if(it-=qe,!(it>0)){if(qe=Math.min(qe,qe+it+Le),Math.min(Be,qe)%2){var ge=te.slice(1,Be+fe.index+qe);return{type:"em",raw:te.slice(0,Be+fe.index+qe+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var X=te.slice(2,Be+fe.index+qe-1);return{type:"strong",raw:te.slice(0,Be+fe.index+qe+1),text:X,tokens:this.lexer.inlineTokens(X,[])}}}}}},Se.codespan=function(te){var ue=this.rules.inline.code.exec(te);if(ue){var me=ue[2].replace(/\n/g," "),fe=/[^ ]/.test(me),Ie=/^ /.test(me)&&/ $/.test(me);return fe&&Ie&&(me=me.substring(1,me.length-1)),me=B(me,!0),{type:"codespan",raw:ue[0],text:me}}},Se.br=function(te){var ue=this.rules.inline.br.exec(te);if(ue)return{type:"br",raw:ue[0]}},Se.del=function(te){var ue=this.rules.inline.del.exec(te);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},Se.autolink=function(te,ue){var me=this.rules.inline.autolink.exec(te);if(me){var fe,Ie;return me[2]==="@"?(fe=B(this.options.mangle?ue(me[1]):me[1]),Ie="mailto:"+fe):(fe=B(me[1]),Ie=fe),{type:"link",raw:me[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},Se.url=function(te,ue){var me;if(me=this.rules.inline.url.exec(te)){var fe,Ie;if(me[2]==="@")fe=B(this.options.mangle?ue(me[0]):me[0]),Ie="mailto:"+fe;else{var Be;do Be=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(Be!==me[0]);fe=B(me[0]),me[1]==="www."?Ie="http://"+fe:Ie=fe}return{type:"link",raw:me[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},Se.inlineText=function(te,ue){var me=this.rules.inline.text.exec(te);if(me){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):B(me[0]):me[0]:fe=B(this.options.smartypants?ue(me[0]):me[0]),{type:"text",raw:me[0],text:fe}}},Pe}(),V=L.noopTest,Y=L.edit,j=L.merge,le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:V,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=Y(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=Y(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=Y(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=Y(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=Y(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=Y(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=j({},le),le.gfm=j({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=Y(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=j({},le.normal,{html:Y(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:V,paragraph:Y(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:V,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:V,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=Y(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=Y(le._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=Y(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=Y(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=Y(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=Y(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=Y(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=Y(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=Y(re.reflink).replace("label",re._label).getRegex(),re.reflinkSearch=Y(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=j({},re),re.pedantic=j({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:Y(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:Y(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=j({},re.normal,{escape:Y(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),re.gfm.url=Y(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=j({},re.gfm,{br:Y(re.br).replace("{2,}","*").getRegex(),text:Y(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:le,inline:re},Fe=ne,Me=A.exports.defaults,Oe=ve.block,Ke=ve.inline,je=L.repeatString;function Ve(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(Pe){var Se="",Ce,te,ue=Pe.length;for(Ce=0;Ce<ue;Ce++)te=Pe.charCodeAt(Ce),Math.random()>.5&&(te="x"+te.toString(16)),Se+="&#"+te+";";return Se}var Q=function(){function Pe(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Me,this.options.tokenizer=this.options.tokenizer||new Fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:Oe.normal,inline:Ke.normal};this.options.pedantic?(te.block=Oe.pedantic,te.inline=Ke.pedantic):this.options.gfm&&(te.block=Oe.gfm,this.options.breaks?te.inline=Ke.breaks:te.inline=Ke.gfm),this.tokenizer.rules=te}Pe.lex=function(te,ue){var me=new Pe(ue);return me.lex(te)},Pe.lexInline=function(te,ue){var me=new Pe(ue);return me.inlineTokens(te)};var Se=Pe.prototype;return Se.lex=function(te){te=te.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(te,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},Se.blockTokens=function(te,ue){var me=this;ue===void 0&&(ue=[]),this.options.pedantic&&(te=te.replace(/^ +$/gm,""));for(var fe,Ie,Be,Ne;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(fe=it.call({lexer:me},te,ue))?(te=te.substring(fe.raw.length),ue.push(fe),!0):!1}))){if(fe=this.tokenizer.space(te)){te=te.substring(fe.raw.length),fe.type&&ue.push(fe);continue}if(fe=this.tokenizer.code(te)){te=te.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe);continue}if(fe=this.tokenizer.fences(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.heading(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.hr(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.blockquote(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.list(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.html(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.def(te)){te=te.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.lheading(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(Be=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,Le=te.slice(1),de=void 0;me.options.extensions.startBlock.forEach(function(ge){de=ge.call({lexer:this},Le),typeof de=="number"&&de>=0&&(it=Math.min(it,de))}),it<Infinity&&it>=0&&(Be=te.substring(0,it+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(Be))){Ie=ue[ue.length-1],Ne&&Ie.type==="paragraph"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe),Ne=Be.length!==te.length,te=te.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(te)){te=te.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(fe);continue}if(te){var qe="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(qe);break}else throw new Error(qe)}}return this.state.top=!0,ue},Se.inline=function(te,ue){this.inlineQueue.push({src:te,tokens:ue})},Se.inlineTokens=function(te,ue){var me=this;ue===void 0&&(ue=[]);var fe,Ie,Be,Ne=te,qe,it,Le;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(qe=this.tokenizer.rules.inline.reflinkSearch.exec(Ne))!=null;)de.includes(qe[0].slice(qe[0].lastIndexOf("[")+1,-1))&&(Ne=Ne.slice(0,qe.index)+"["+je("a",qe[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(qe=this.tokenizer.rules.inline.blockSkip.exec(Ne))!=null;)Ne=Ne.slice(0,qe.index)+"["+je("a",qe[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(qe=this.tokenizer.rules.inline.escapedEmSt.exec(Ne))!=null;)Ne=Ne.slice(0,qe.index)+"++"+Ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(it||(Le=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(X){return(fe=X.call({lexer:me},te,ue))?(te=te.substring(fe.raw.length),ue.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.tag(te)){te=te.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(fe=this.tokenizer.link(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(fe.raw.length),Ie=ue[ue.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(fe=this.tokenizer.emStrong(te,Ne,Le)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.codespan(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.br(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.del(te)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(fe=this.tokenizer.autolink(te,U)){te=te.substring(fe.raw.length),ue.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(te,U))){te=te.substring(fe.raw.length),ue.push(fe);continue}if(Be=te,this.options.extensions&&this.options.extensions.startInline&&function(){var X=Infinity,z=te.slice(1),we=void 0;me.options.extensions.startInline.forEach(function(ke){we=ke.call({lexer:this},z),typeof we=="number"&&we>=0&&(X=Math.min(X,we))}),X<Infinity&&X>=0&&(Be=te.substring(0,X+1))}(),fe=this.tokenizer.inlineText(Be,Ve)){te=te.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(Le=fe.raw.slice(-1)),it=!0,Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ue.push(fe);continue}if(te){var ge="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return ue},e(Pe,null,[{key:"rules",get:function(){return{block:Oe,inline:Ke}}}]),Pe}(),ee=A.exports.defaults,ae=L.cleanUrl,K=L.escape,se=function(){function Pe(Ce){this.options=Ce||ee}var Se=Pe.prototype;return Se.code=function(te,ue,me){var fe=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(te,fe);Ie!=null&&Ie!==te&&(me=!0,te=Ie)}return te=te.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+K(fe,!0)+'">'+(me?te:K(te,!0))+`</code></pre>
`:"<pre><code>"+(me?te:K(te,!0))+`</code></pre>
`},Se.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},Se.html=function(te){return te},Se.heading=function(te,ue,me,fe){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+fe.slug(me)+'">'+te+"</h"+ue+`>
`:"<h"+ue+">"+te+"</h"+ue+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(te,ue,me){var fe=ue?"ol":"ul",Ie=ue&&me!==1?' start="'+me+'"':"";return"<"+fe+Ie+`>
`+te+"</"+fe+`>
`},Se.listitem=function(te){return"<li>"+te+`</li>
`},Se.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(te){return"<p>"+te+`</p>
`},Se.table=function(te,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+ue+`</table>
`},Se.tablerow=function(te){return`<tr>
`+te+`</tr>
`},Se.tablecell=function(te,ue){var me=ue.header?"th":"td",fe=ue.align?"<"+me+' align="'+ue.align+'">':"<"+me+">";return fe+te+"</"+me+`>
`},Se.strong=function(te){return"<strong>"+te+"</strong>"},Se.em=function(te){return"<em>"+te+"</em>"},Se.codespan=function(te){return"<code>"+te+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(te){return"<del>"+te+"</del>"},Se.link=function(te,ue,me){if(te=ae(this.options.sanitize,this.options.baseUrl,te),te===null)return me;var fe='<a href="'+K(te)+'"';return ue&&(fe+=' title="'+ue+'"'),fe+=">"+me+"</a>",fe},Se.image=function(te,ue,me){if(te=ae(this.options.sanitize,this.options.baseUrl,te),te===null)return me;var fe='<img src="'+te+'" alt="'+me+'"';return ue&&(fe+=' title="'+ue+'"'),fe+=this.options.xhtml?"/>":">",fe},Se.text=function(te){return te},Pe}(),he=function(){function Pe(){}var Se=Pe.prototype;return Se.strong=function(te){return te},Se.em=function(te){return te},Se.codespan=function(te){return te},Se.del=function(te){return te},Se.html=function(te){return te},Se.text=function(te){return te},Se.link=function(te,ue,me){return""+me},Se.image=function(te,ue,me){return""+me},Se.br=function(){return""},Pe}(),Ae=function(){function Pe(){this.seen={}}var Se=Pe.prototype;return Se.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(te,ue){var me=te,fe=0;if(this.seen.hasOwnProperty(me)){fe=this.seen[te];do fe++,me=te+"-"+fe;while(this.seen.hasOwnProperty(me))}return ue||(this.seen[te]=fe,this.seen[me]=0),me},Se.slug=function(te,ue){ue===void 0&&(ue={});var me=this.serialize(te);return this.getNextSafeSlug(me,ue.dryrun)},Pe}(),Ue=se,He=he,Qe=Ae,et=A.exports.defaults,st=L.unescape,ye=function(){function Pe(Ce){this.options=Ce||et,this.options.renderer=this.options.renderer||new Ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new Qe}Pe.parse=function(te,ue){var me=new Pe(ue);return me.parse(te)},Pe.parseInline=function(te,ue){var me=new Pe(ue);return me.parseInline(te)};var Se=Pe.prototype;return Se.parse=function(te,ue){ue===void 0&&(ue=!0);var me="",fe,Ie,Be,Ne,qe,it,Le,de,ge,X,z,we,ke,Je,xe,ct,pt,dt,ht,ft=te.length;for(fe=0;fe<ft;fe++){if(X=te[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(ht=this.options.extensions.renderers[X.type].call({parser:this},X),ht!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type))){me+=ht||"";continue}switch(X.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(X.tokens),X.depth,st(this.parseInline(X.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(X.text,X.lang,X.escaped);continue}case"table":{for(de="",Le="",Ne=X.header.length,Ie=0;Ie<Ne;Ie++)Le+=this.renderer.tablecell(this.parseInline(X.header[Ie].tokens),{header:!0,align:X.align[Ie]});for(de+=this.renderer.tablerow(Le),ge="",Ne=X.rows.length,Ie=0;Ie<Ne;Ie++){for(it=X.rows[Ie],Le="",qe=it.length,Be=0;Be<qe;Be++)Le+=this.renderer.tablecell(this.parseInline(it[Be].tokens),{header:!1,align:X.align[Be]});ge+=this.renderer.tablerow(Le)}me+=this.renderer.table(de,ge);continue}case"blockquote":{ge=this.parse(X.tokens),me+=this.renderer.blockquote(ge);continue}case"list":{for(z=X.ordered,we=X.start,ke=X.loose,Ne=X.items.length,ge="",Ie=0;Ie<Ne;Ie++)xe=X.items[Ie],ct=xe.checked,pt=xe.task,Je="",xe.task&&(dt=this.renderer.checkbox(ct),ke?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=dt+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=dt+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:dt}):Je+=dt),Je+=this.parse(xe.tokens,ke),ge+=this.renderer.listitem(Je,pt,ct);me+=this.renderer.list(ge,z,we);continue}case"html":{me+=this.renderer.html(X.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(X.tokens));continue}case"text":{for(ge=X.tokens?this.parseInline(X.tokens):X.text;fe+1<ft&&te[fe+1].type==="text";)X=te[++fe],ge+=`
`+(X.tokens?this.parseInline(X.tokens):X.text);me+=ue?this.renderer.paragraph(ge):ge;continue}default:{var _t='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(_t);return}else throw new Error(_t)}}}return me},Se.parseInline=function(te,ue){ue=ue||this.renderer;var me="",fe,Ie,Be,Ne=te.length;for(fe=0;fe<Ne;fe++){if(Ie=te[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(Be=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){me+=Be||"";continue}switch(Ie.type){case"escape":{me+=ue.text(Ie.text);break}case"html":{me+=ue.html(Ie.text);break}case"link":{me+=ue.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ue));break}case"image":{me+=ue.image(Ie.href,Ie.title,Ie.text);break}case"strong":{me+=ue.strong(this.parseInline(Ie.tokens,ue));break}case"em":{me+=ue.em(this.parseInline(Ie.tokens,ue));break}case"codespan":{me+=ue.codespan(Ie.text);break}case"br":{me+=ue.br();break}case"del":{me+=ue.del(this.parseInline(Ie.tokens,ue));break}case"text":{me+=ue.text(Ie.text);break}default:{var qe='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(qe);return}else throw new Error(qe)}}}return me},Pe}(),nt=Q,q=ye,Z=ne,pe=se,We=he,Ye=Ae,rt=L.merge,mt=L.checkSanitizeDeprecation,ut=L.escape,St=A.exports.getDefaults,Tt=A.exports.changeDefaults,It=A.exports.defaults;function Xe(Pe,Se,Ce){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Se=="function"&&(Ce=Se,Se=null),Se=rt({},Xe.defaults,Se||{}),mt(Se),Ce){var te=Se.highlight,ue;try{ue=nt.lex(Pe,Se)}catch(Be){return Ce(Be)}var me=function(Ne){var qe;if(!Ne)try{Se.walkTokens&&Xe.walkTokens(ue,Se.walkTokens),qe=q.parse(ue,Se)}catch(it){Ne=it}return Se.highlight=te,Ne?Ce(Ne):Ce(null,qe)};if(!te||te.length<3||(delete Se.highlight,!ue.length))return me();var fe=0;Xe.walkTokens(ue,function(Be){Be.type==="code"&&(fe++,setTimeout(function(){te(Be.text,Be.lang,function(Ne,qe){if(Ne)return me(Ne);qe!=null&&qe!==Be.text&&(Be.text=qe,Be.escaped=!0),fe--,fe===0&&me()})},0))}),fe===0&&me();return}try{var Ie=nt.lex(Pe,Se);return Se.walkTokens&&Xe.walkTokens(Ie,Se.walkTokens),q.parse(Ie,Se)}catch(Be){if(Be.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+ut(Be.message+"",!0)+"</pre>";throw Be}}Xe.options=Xe.setOptions=function(Pe){return rt(Xe.defaults,Pe),Tt(Xe.defaults),Xe},Xe.getDefaults=St,Xe.defaults=It,Xe.use=function(){for(var Pe=this,Se=arguments.length,Ce=new Array(Se),te=0;te<Se;te++)Ce[te]=arguments[te];var ue=rt.apply(void 0,[{}].concat(Ce)),me=Xe.defaults.extensions||{renderers:{},childTokens:{}},fe;Ce.forEach(function(Ie){if(Ie.extensions&&(fe=!0,Ie.extensions.forEach(function(Ne){if(!Ne.name)throw new Error("extension name required");if(Ne.renderer){var qe=me.renderers?me.renderers[Ne.name]:null;qe?me.renderers[Ne.name]=function(){for(var it=arguments.length,Le=new Array(it),de=0;de<it;de++)Le[de]=arguments[de];var ge=Ne.renderer.apply(this,Le);return ge===!1&&(ge=qe.apply(this,Le)),ge}:me.renderers[Ne.name]=Ne.renderer}if(Ne.tokenizer){if(!Ne.level||Ne.level!=="block"&&Ne.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");me[Ne.level]?me[Ne.level].unshift(Ne.tokenizer):me[Ne.level]=[Ne.tokenizer],Ne.start&&(Ne.level==="block"?me.startBlock?me.startBlock.push(Ne.start):me.startBlock=[Ne.start]:Ne.level==="inline"&&(me.startInline?me.startInline.push(Ne.start):me.startInline=[Ne.start]))}Ne.childTokens&&(me.childTokens[Ne.name]=Ne.childTokens)})),Ie.renderer&&function(){var Ne=Xe.defaults.renderer||new pe,qe=function(de){var ge=Ne[de];Ne[de]=function(){for(var X=arguments.length,z=new Array(X),we=0;we<X;we++)z[we]=arguments[we];var ke=Ie.renderer[de].apply(Ne,z);return ke===!1&&(ke=ge.apply(Ne,z)),ke}};for(var it in Ie.renderer)qe(it);ue.renderer=Ne}(),Ie.tokenizer&&function(){var Ne=Xe.defaults.tokenizer||new Z,qe=function(de){var ge=Ne[de];Ne[de]=function(){for(var X=arguments.length,z=new Array(X),we=0;we<X;we++)z[we]=arguments[we];var ke=Ie.tokenizer[de].apply(Ne,z);return ke===!1&&(ke=ge.apply(Ne,z)),ke}};for(var it in Ie.tokenizer)qe(it);ue.tokenizer=Ne}(),Ie.walkTokens){var Be=Xe.defaults.walkTokens;ue.walkTokens=function(Ne){Ie.walkTokens.call(Pe,Ne),Be&&Be(Ne)}}fe&&(ue.extensions=me),Xe.setOptions(ue)})},Xe.walkTokens=function(Pe,Se){for(var Ce=function(){var fe=ue.value;switch(Se(fe),fe.type){case"table":{for(var Ie=_(fe.header),Be;!(Be=Ie()).done;){var Ne=Be.value;Xe.walkTokens(Ne.tokens,Se)}for(var qe=_(fe.rows),it;!(it=qe()).done;)for(var Le=it.value,de=_(Le),ge;!(ge=de()).done;){var X=ge.value;Xe.walkTokens(X.tokens,Se)}break}case"list":{Xe.walkTokens(fe.items,Se);break}default:Xe.defaults.extensions&&Xe.defaults.extensions.childTokens&&Xe.defaults.extensions.childTokens[fe.type]?Xe.defaults.extensions.childTokens[fe.type].forEach(function(z){Xe.walkTokens(fe[z],Se)}):fe.tokens&&Xe.walkTokens(fe.tokens,Se)}},te=_(Pe),ue;!(ue=te()).done;)Ce()},Xe.parseInline=function(Pe,Se){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Se=rt({},Xe.defaults,Se||{}),mt(Se);try{var Ce=nt.lexInline(Pe,Se);return Se.walkTokens&&Xe.walkTokens(Ce,Se.walkTokens),q.parseInline(Ce,Se)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+ut(te.message+"",!0)+"</pre>";throw te}},Xe.Parser=q,Xe.parser=q.parse,Xe.Renderer=pe,Xe.TextRenderer=We,Xe.Lexer=nt,Xe.lexer=nt.lex,Xe.Tokenizer=Z,Xe.Slugger=Ye,Xe.parse=Xe;var vt=Xe;return vt}),define(be[76],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(F,k,D){return Math.min(Math.max(F,k),D)}e.clamp=d;function M(F,k){return(k+F%k)%k}e.rot=M;class _{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=_;class A{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function oe(_){const A=[];typeof _=="number"&&A.push("code/timeOrigin",_);function F(D){A.push(D,Date.now())}function k(){const D=[];for(let P=0;P<A.length;P+=2)D.push({name:A[P],startTime:A[P+1]});return D}return{mark:F,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const F of performance.getEntriesByType("mark"))A.push({name:F.name,startTime:Math.round(_+F.startTime)});return A}};if(typeof process=="object"){const _=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function d(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=d(M))}(),define(be[104],Ee([0,1]),function(oe,e){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(k,D,P){this.level=k,this.key=D,this.value=P,this.forward=[]}}const _=void 0;class A{constructor(k,D=2**16){this.comparator=k,this[d]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(D)|0),this._header=new M(this._maxLevel,_,_)}get size(){return this._size}clear(){this._header=new M(this._maxLevel,_,_)}has(k){return Boolean(A._search(this,k,this.comparator))}get(k){return A._search(this,k,this.comparator)?.value}set(k,D){return A._insert(this,k,D,this.comparator)&&(this._size+=1),this}delete(k){const D=A._delete(this,k,this.comparator);return D&&(this._size-=1),D}forEach(k,D){let P=this._header.forward[0];for(;P;)k.call(D,P.value,P.key,this),P=P.forward[0]}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this._header.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this._header.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this._header.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",D=this._header.forward[0];for(;D;)k+=`node(${D.key}, ${D.value}, lvl:${D.level})`,D=D.forward[0];return k}static _search(k,D,P){let t=k._header;for(let y=k._level-1;y>=0;y--)for(;t.forward[y]&&P(t.forward[y].key,D)<0;)t=t.forward[y];if(t=t.forward[0],t&&P(t.key,D)===0)return t}static _insert(k,D,P,t){let y=[],n=k._header;for(let m=k._level-1;m>=0;m--){for(;n.forward[m]&&t(n.forward[m].key,D)<0;)n=n.forward[m];y[m]=n}if(n=n.forward[0],n&&t(n.key,D)===0)return n.value=P,!1;{let m=A._randomLevel(k);if(m>k._level){for(let s=k._level;s<m;s++)y[s]=k._header;k._level=m}n=new M(m,D,P);for(let s=0;s<m;s++)n.forward[s]=y[s].forward[s],y[s].forward[s]=n;return!0}}static _randomLevel(k,D=.5){let P=1;for(;Math.random()<D&&P<k._maxLevel;)P+=1;return P}static _delete(k,D,P){let t=[],y=k._header;for(let n=k._level-1;n>=0;n--){for(;y.forward[n]&&P(y.forward[n].key,D)<0;)y=y.forward[n];t[n]=y}if(y=y.forward[0],!y||P(y.key,D)!==0)return!1;for(let n=0;n<k._level&&t[n].forward[n]===y;n++)t[n].forward[n]=y.forward[n];for(;k._level>0&&k._header.forward[k._level-1]===_;)k._level-=1;return!0}}e.SkipList=A}),define(be[34],Ee([0,1,3]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new d.Emitter}add(y){const n=this._icons.get(y.id);n?y.description?n.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const _=new M;e.iconRegistry=_;function A(t,y){return new k(t,y)}e.registerCodicon=A;function F(t){return t?t.replace(/\$\((.*?)\)/g,(y,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=F;class k{constructor(y,n,m){this.id=y,this.definition=n,this.description=m,_.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function D(t,y){const n=["codicon","codicon-"+t];return y&&n.push("codicon-modifier-"+y),n}e.getClassNamesArray=D;var P;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const y=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(u){if(u instanceof k)return["codicon","codicon-"+u.id];const g=y.exec(u.id);if(!g)return n(k.error);let[,I,E]=g;const o=["codicon","codicon-"+I];return E&&o.push("codicon-modifier-"+E.substr(1)),o}t.asClassNameArray=n;function m(u){return n(u).join(" ")}t.asClassName=m;function s(u){return"."+n(u).join(".")}t.asCSSSelector=s})(P=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"})}(k=e.Codicon||(e.Codicon={}))}),define(be[105],Ee([0,1,16,6]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function _(o){const h=o;return h?[h.on,h.pause,h.resume,h.destroy].every(C=>typeof C=="function"):!1}e.isReadableStream=_;function A(o){const h=o;return h?_(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=A;function F(o,h){return new k(o,h)}e.newWriteableStream=F;class k{constructor(h,C){this.reducer=h,this.options=C,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(C=>this.pendingWritePromises.push(C))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(C=>C(h))}emitError(h){this.listeners.error.length===0?(0,d.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(C=>C(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,C){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(C),this.resume();break;case"end":this.listeners.end.push(C),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(C),this.state.flowing&&this.flowErrors();break}}removeListener(h,C){if(this.state.destroyed)return;let i;switch(h){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const p=i.indexOf(C);p>=0&&i.splice(p,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const C=[...this.pendingWritePromises];this.pendingWritePromises.length=0,C.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(o,h){const C=[];let i;for(;(i=o.read())!==null;)C.push(i);return h(C)}e.consumeReadable=D;function P(o,h,C){const i=[];let p;for(;(p=o.read())!==null&&i.length<C;)i.push(p);return p===null&&i.length>0?h(i):{read:()=>{if(i.length>0)return i.shift();if(typeof p!="undefined"){const a=p;return p=void 0,a}return o.read()}}}e.peekReadable=P;function t(o,h){return new Promise((C,i)=>{const p=[];y(o,{onData:a=>{h&&p.push(a)},onError:a=>{h?i(a):C(void 0)},onEnd:()=>{C(h?h(p):void 0)}})})}e.consumeStream=t;function y(o,h){o.on("error",C=>h.onError(C)),o.on("end",()=>h.onEnd()),o.on("data",C=>h.onData(C))}e.listenStream=y;function n(o,h){return new Promise((C,i)=>{const p=new M.DisposableStore,a=[],r=c=>{if(a.push(c),a.length>h)return p.dispose(),o.pause(),C({stream:o,buffer:a,ended:!1})},v=c=>i(c),l=()=>C({stream:o,buffer:a,ended:!0});p.add((0,M.toDisposable)(()=>o.removeListener("error",v))),o.on("error",v),p.add((0,M.toDisposable)(()=>o.removeListener("end",l))),o.on("end",l),p.add((0,M.toDisposable)(()=>o.removeListener("data",r))),o.on("data",r)})}e.peekStream=n;function m(o,h){const C=F(h);return C.end(o),C}e.toStream=m;function s(){const o=F(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=s;function u(o){let h=!1;return{read:()=>h?null:(h=!0,o)}}e.toReadable=u;function g(o,h,C){const i=F(C);return y(o,{onData:p=>i.write(h.data(p)),onError:p=>i.error(h.error?h.error(p):p),onEnd:()=>i.end()}),i}e.transform=g;function I(o,h,C){let i=!1;return{read:()=>{const p=h.read();return i?p:(i=!0,p!==null?C([o,p]):o)}}}e.prefixedReadable=I;function E(o,h,C){let i=!1;const p=F(C);return y(h,{onData:a=>i?p.write(a):(i=!0,p.write(C([o,a]))),onError:a=>p.error(a),onEnd:()=>{i||(i=!0,p.write(o)),p.end()}}),p}e.prefixedStream=E}),define(be[22],Ee([0,1,105]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let _,A;class F{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return M?new F(Buffer.allocUnsafe(r)):new F(new Uint8Array(r))}static wrap(r){return M&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new F(r)}static fromString(r,v){return!(v?.dontUseNodeBuffer||!1)&&M?new F(Buffer.from(r)):(_||(_=new TextEncoder),new F(_.encode(r)))}static concat(r,v){if(typeof v=="undefined"){v=0;for(let w=0,f=r.length;w<f;w++)v+=r[w].byteLength}const l=F.alloc(v);let c=0;for(let w=0,f=r.length;w<f;w++){const S=r[w];l.set(S,c),c+=S.byteLength}return l}toString(){return M?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(r,v){return new F(this.buffer.subarray(r,v))}set(r,v){r instanceof F?this.buffer.set(r.buffer,v):this.buffer.set(r,v)}readUInt32BE(r){return P(this.buffer,r)}writeUInt32BE(r,v){t(this.buffer,r,v)}readUInt32LE(r){return y(this.buffer,r)}writeUInt32LE(r,v){n(this.buffer,r,v)}readUInt8(r){return m(this.buffer,r)}writeUInt8(r,v){s(this.buffer,r,v)}}e.VSBuffer=F;function k(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0}e.readUInt16LE=k;function D(a,r,v){a[v+0]=r&255,r=r>>>8,a[v+1]=r&255}e.writeUInt16LE=D;function P(a,r){return a[r]*2**24+a[r+1]*2**16+a[r+2]*2**8+a[r+3]}e.readUInt32BE=P;function t(a,r,v){a[v+3]=r,r=r>>>8,a[v+2]=r,r=r>>>8,a[v+1]=r,r=r>>>8,a[v]=r}e.writeUInt32BE=t;function y(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0|a[r+2]<<16>>>0|a[r+3]<<24>>>0}e.readUInt32LE=y;function n(a,r,v){a[v+0]=r&255,r=r>>>8,a[v+1]=r&255,r=r>>>8,a[v+2]=r&255,r=r>>>8,a[v+3]=r&255}e.writeUInt32LE=n;function m(a,r){return a[r]}e.readUInt8=m;function s(a,r,v){a[v]=r}e.writeUInt8=s;function u(a){return d.consumeReadable(a,r=>F.concat(r))}e.readableToBuffer=u;function g(a){return d.toReadable(a)}e.bufferToReadable=g;function I(a){return d.consumeStream(a,r=>F.concat(r))}e.streamToBuffer=I;async function E(a){return a.ended?F.concat(a.buffer):F.concat([...a.buffer,await I(a.stream)])}e.bufferedStreamToBuffer=E;function o(a){return d.toStream(a,r=>F.concat(r))}e.bufferToStream=o;function h(a){return d.transform(a,{data:r=>typeof r=="string"?F.fromString(r):F.wrap(r)},r=>F.concat(r))}e.streamToBufferReadableStream=h;function C(a){return d.newWriteableStream(r=>F.concat(r),a)}e.newWriteableBufferStream=C;function i(a,r){return d.prefixedReadable(a,r,v=>F.concat(v))}e.prefixedBufferReadable=i;function p(a,r){return d.prefixedStream(a,r,v=>F.concat(v))}e.prefixedBufferStream=p}),define(be[35],Ee([0,1,9]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(_){_[_.Ignore=0]="Ignore",_[_.Info=1]="Info",_[_.Warning=2]="Warning",_[_.Error=3]="Error"})(M||(M={})),function(_){const A="error",F="warning",k="warn",D="info",P="ignore";function t(n){return n?d.equalsIgnoreCase(A,n)?_.Error:d.equalsIgnoreCase(F,n)||d.equalsIgnoreCase(k,n)?_.Warning:d.equalsIgnoreCase(D,n)?_.Info:_.Ignore:_.Ignore}_.fromValue=t;function y(n){switch(n){case _.Error:return A;case _.Warning:return F;case _.Info:return D;default:return P}}_.toString=y}(M||(M={})),e.default=M}),define(be[43],Ee([0,1,17,25,9,10]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(a){return a===47||a===92}e.isPathSeparator=F;function k(a){return a.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=k;function D(a){return a.indexOf("/")===-1&&(a=k(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=D;function P(a,r=d.posix.sep){if(!a)return"";const v=a.length,l=a.charCodeAt(0);if(F(l)){if(F(a.charCodeAt(1))&&!F(a.charCodeAt(2))){let w=3;const f=w;for(;w<v&&!F(a.charCodeAt(w));w++);if(f!==w&&!F(a.charCodeAt(w+1))){for(w+=1;w<v;w++)if(F(a.charCodeAt(w)))return a.slice(0,w+1).replace(/[\\/]/g,r)}}return r}else if(I(l)&&a.charCodeAt(1)===58)return F(a.charCodeAt(2))?a.slice(0,2)+r:a.slice(0,2);let c=a.indexOf("://");if(c!==-1){for(c+=3;c<v;c++)if(F(a.charCodeAt(c)))return a.slice(0,c+1)}return""}e.getRoot=P;function t(a){if(!M.isWindows||!a||a.length<5)return!1;let r=a.charCodeAt(0);if(r!==92||(r=a.charCodeAt(1),r!==92))return!1;let v=2;const l=v;for(;v<a.length&&(r=a.charCodeAt(v),r!==92);v++);return!(l===v||(r=a.charCodeAt(v+1),isNaN(r)||r===92))}e.isUNC=t;const y=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(a,r=M.isWindows){const v=r?y:n;return!(!a||a.length===0||/^\s+$/.test(a)||(v.lastIndex=0,v.test(a))||r&&m.test(a)||a==="."||a===".."||r&&a[a.length-1]==="."||r&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=s;function u(a,r,v){const l=a===r;return!v||l?l:!a||!r?!1:(0,_.equalsIgnoreCase)(a,r)}e.isEqual=u;function g(a,r,v,l=d.sep){if(a===r)return!0;if(!a||!r||r.length>a.length)return!1;if(v){if(!(0,_.startsWithIgnoreCase)(a,r))return!1;if(r.length===a.length)return!0;let w=r.length;return r.charAt(r.length-1)===l&&w--,a.charAt(w)===l}return r.charAt(r.length-1)!==l&&(r+=l),a.indexOf(r)===0}e.isEqualOrParent=g;function I(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=I;function E(a,r){return M.isWindows&&a.endsWith(":")&&(a+=d.sep),(0,d.isAbsolute)(a)||(a=(0,d.join)(r,a)),a=(0,d.normalize)(a),M.isWindows?(a=(0,_.rtrim)(a,d.sep),a.endsWith(":")&&(a+=d.sep)):(a=(0,_.rtrim)(a,d.sep),a||(a=d.sep)),a}e.sanitizeFilePath=E;function o(a){const r=(0,d.normalize)(a);return M.isWindows?a.length>3?!1:h(r)&&(a.length===2||r.charCodeAt(2)===92):r===d.posix.sep}e.isRootOrDriveLetter=o;function h(a){return M.isWindows?I(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function C(a){return h(a)?a[0]:void 0}e.getDriveLetter=C;function i(a,r,v){return r.length>a.length?-1:a===r?0:(v&&(a=a.toLowerCase(),r=r.toLowerCase()),a.indexOf(r))}e.indexOfPath=i;function p(a){const r=a.split(":");let v,l,c;if(r.forEach(w=>{const f=Number(w);(0,A.isNumber)(f)?l===void 0?l=f:c===void 0&&(c=f):v=v?[v,w].join(":"):w}),!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:l!==void 0?l:void 0,column:c!==void 0?c:l!==void 0?1:void 0}}e.parseLineAndColumnAware=p}),define(be[23],Ee([0,1,10]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const g=Array.isArray(u)?[]:{};return Object.keys(u).forEach(I=>{u[I]&&typeof u[I]=="object"?g[I]=M(u[I]):g[I]=u[I]}),g}e.deepClone=M;function _(u){if(!u||typeof u!="object")return u;const g=[u];for(;g.length>0;){const I=g.shift();Object.freeze(I);for(const E in I)if(A.call(I,E)){const o=I[E];typeof o=="object"&&!Object.isFrozen(o)&&g.push(o)}}return u}e.deepFreeze=_;const A=Object.prototype.hasOwnProperty;function F(u,g){return k(u,g,new Set)}e.cloneAndChange=F;function k(u,g,I){if((0,d.isUndefinedOrNull)(u))return u;const E=g(u);if(typeof E!="undefined")return E;if((0,d.isArray)(u)){const o=[];for(const h of u)o.push(k(h,g,I));return o}if((0,d.isObject)(u)){if(I.has(u))throw new Error("Cannot clone recursive data-structure");I.add(u);const o={};for(let h in u)A.call(u,h)&&(o[h]=k(u[h],g,I));return I.delete(u),o}return u}function D(u,g,I=!0){return(0,d.isObject)(u)?((0,d.isObject)(g)&&Object.keys(g).forEach(E=>{E in u?I&&((0,d.isObject)(u[E])&&(0,d.isObject)(g[E])?D(u[E],g[E],I):u[E]=g[E]):u[E]=g[E]}),u):g}e.mixin=D;function P(u,g){if(u===g)return!0;if(u==null||g===null||g===void 0||typeof u!=typeof g||typeof u!="object"||Array.isArray(u)!==Array.isArray(g))return!1;let I,E;if(Array.isArray(u)){if(u.length!==g.length)return!1;for(I=0;I<u.length;I++)if(!P(u[I],g[I]))return!1}else{const o=[];for(E in u)o.push(E);o.sort();const h=[];for(E in g)h.push(E);if(h.sort(),!P(o,h))return!1;for(I=0;I<o.length;I++)if(!P(u[o[I]],g[o[I]]))return!1}return!0}e.equals=P;function t(u){const g=new Set;return JSON.stringify(u,(I,E)=>{if((0,d.isObject)(E)||Array.isArray(E)){if(g.has(E))return"[Circular]";g.add(E)}return E})}e.safeStringify=t;function y(u,g,I){const E=g(u);return typeof E=="undefined"?I:E}e.getOrDefault=y;function n(u,g){const I=Object.create(null);return!u||!g||Object.keys(g).forEach(o=>{const h=u[o],C=g[o];P(h,C)||(I[o]=C)}),I}e.distinct=n;function m(u,g){const I=g.toLowerCase(),E=Object.keys(u).find(o=>o.toLowerCase()===I);return E?u[E]:u[g]}e.getCaseInsensitive=m;function s(u,g){const I=Object.create(null);for(const E of Object.keys(u))g(E,u[E])&&(I[E]=u[E]);return I}e.filter=s});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[20],Ee([0,1,14,9,2]),function(oe,e,d,M,_){"use strict";var A,F,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(a,r,v){let l=a.get(r);return l===void 0&&(l=v,a.set(r,l)),l}e.getOrSet=D;function P(a){const r=[];return a.forEach((v,l)=>{r.push(`${l} => ${v}`)}),`Map(${a.size}) {${r.join(", ")}}`}e.mapToString=P;function t(a){const r=[];return a.forEach(v=>{r.push(v)}),`Set(${a.size}) {${r.join(", ")}}`}e.setToString=t;class y{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const v=r.charCodeAt(0),l=this._value.charCodeAt(this._pos);return v-l}value(){return this._value[this._pos]}}e.StringIterator=y;class n{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=n;class m{constructor(r=!0,v=!0){this._splitOnBackslash=r,this._caseSensitive=v}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const v=this._value.charCodeAt(this._to);if(v===47||this._splitOnBackslash&&v===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var s;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(s||(s={}));class u{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(I||(I={}));class E{constructor(r){this._iter=r}static forUris(r=()=>!1){return new E(new u(r))}static forPaths(){return new E(new m)}static forStrings(){return new E(new y)}static forConfigKeys(){return new E(new n)}clear(){this._root=void 0}fill(r,v){if(v){const l=v.slice(0);(0,d.shuffle)(l);for(let c of l)this.set(c,r)}else{const l=r.slice(0);(0,d.shuffle)(l);for(let c of l)this.set(c[0],c[1])}}set(r,v){const l=this._iter.reset(r);let c;this._root||(this._root=new g,this._root.segment=l.value());const w=[];for(c=this._root;;){const S=l.cmp(c.segment);if(S>0)c.left||(c.left=new g,c.left.segment=l.value()),w.push([-1,c]),c=c.left;else if(S<0)c.right||(c.right=new g,c.right.segment=l.value()),w.push([1,c]),c=c.right;else if(l.hasNext())l.next(),c.mid||(c.mid=new g,c.mid.segment=l.value()),w.push([0,c]),c=c.mid;else break}const f=c.value;c.value=v,c.key=r;for(let S=w.length-1;S>=0;S--){const R=w[S][1];R.updateHeight();const T=R.balanceFactor();if(T<-1||T>1){const L=w[S][0],b=w[S+1][0];if(L===1&&b===1)w[S][1]=R.rotateLeft();else if(L===-1&&b===-1)w[S][1]=R.rotateRight();else if(L===1&&b===-1)R.right=w[S+1][1]=w[S+1][1].rotateRight(),w[S][1]=R.rotateLeft();else if(L===-1&&b===1)R.left=w[S+1][1]=w[S+1][1].rotateLeft(),w[S][1]=R.rotateRight();else throw new Error;if(S>0)switch(w[S-1][0]){case-1:w[S-1][1].left=w[S][1];break;case 1:w[S-1][1].right=w[S][1];break;case 0:w[S-1][1].mid=w[S][1];break}else this._root=w[0][1]}}return f}get(r){return this._getNode(r)?.value}_getNode(r){const v=this._iter.reset(r);let l=this._root;for(;l;){const c=v.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(v.hasNext())v.next(),l=l.mid;else break}return l}has(r){const v=this._getNode(r);return!(v?.value===void 0&&v?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,v){const l=this._iter.reset(r),c=[];let w=this._root;for(;w;){const f=l.cmp(w.segment);if(f>0)c.push([-1,w]),w=w.left;else if(f<0)c.push([1,w]),w=w.right;else if(l.hasNext())l.next(),c.push([0,w]),w=w.mid;else break}if(!!w){if(v?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const f=this._min(w.right),{key:S,value:R,segment:T}=f;this._delete(f.key,!1),w.key=S,w.value=R,w.segment=T}else{const f=w.left??w.right;if(c.length>0){const[S,R]=c[c.length-1];switch(S){case-1:R.left=f;break;case 0:R.mid=f;break;case 1:R.right=f;break}}else this._root=f}for(let f=c.length-1;f>=0;f--){const S=c[f][1];S.updateHeight();const R=S.balanceFactor();if(R>1?(S.right.balanceFactor()>=0||(S.right=c[f+1][1]=c[f+1][1].rotateRight()),c[f][1]=S.rotateLeft()):R<-1&&(S.left.balanceFactor()<=0||(S.left=c[f+1][1]=c[f+1][1].rotateLeft()),c[f][1]=S.rotateRight()),f>0)switch(c[f-1][0]){case-1:c[f-1][1].left=c[f][1];break;case 1:c[f-1][1].right=c[f][1];break;case 0:c[f-1][1].mid=c[f][1];break}else this._root=c[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const v=this._iter.reset(r);let l=this._root,c;for(;l;){const w=v.cmp(l.segment);if(w>0)l=l.left;else if(w<0)l=l.right;else if(v.hasNext())v.next(),c=l.value||c,l=l.mid;else break}return l&&l.value||c}findSuperstr(r){const v=this._iter.reset(r);let l=this._root;for(;l;){const c=v.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(v.hasNext())v.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(r){for(const[v,l]of this)r(l,v)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=v=>{if(!v)return!0;const l=v.balanceFactor();return l<-1||l>1?!1:r(v.left)&&r(v.right)};return r(this._root)}}e.TernarySearchTree=E;class o{constructor(r,v){this[A]="ResourceMap",r instanceof o?(this.map=new Map(r.map),this.toKey=v??o.defaultToKey):(this.map=new Map,this.toKey=r??o.defaultToKey)}set(r,v){return this.map.set(this.toKey(r),v),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,v){typeof v!="undefined"&&(r=r.bind(v));for(let[l,c]of this.map)r(c,_.URI.parse(l),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield _.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[_.URI.parse(r[0]),r[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[_.URI.parse(r[0]),r[1]]}}e.ResourceMap=o,o.defaultToKey=a=>a.toString();var h;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class C{constructor(){this[F]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,v=0){const l=this._map.get(r);if(!!l)return v!==0&&this.touch(l,v),l.value}set(r,v,l=0){let c=this._map.get(r);if(c)c.value=v,l!==0&&this.touch(c,l);else{switch(c={key:r,value:v,next:void 0,previous:void 0},l){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const v=this._map.get(r);if(!!v)return this._map.delete(r),this.removeItem(v),this._size--,v.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,v){const l=this._state;let c=this._head;for(;c;){if(v?r.bind(v)(c.value,c.key,this):r(c.value,c.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,v=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const w={value:l.key,done:!1};return l=l.next,w}else return{value:void 0,done:!0}}};return c}values(){const r=this,v=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const w={value:l.value,done:!1};return l=l.next,w}else return{value:void 0,done:!0}}};return c}entries(){const r=this,v=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const w={value:[l.key,l.value],done:!1};return l=l.next,w}else return{value:void 0,done:!0}}};return c}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let v=this._head,l=this.size;for(;v&&l>r;)this._map.delete(v.key),v=v.next,l--;this._head=v,this._size=l,v&&(v.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const v=r.next,l=r.previous;if(!v||!l)throw new Error("Invalid list");v.previous=l,l.next=v}r.next=void 0,r.previous=void 0,this._state++}touch(r,v){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(r===this._head)return;const l=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(l.previous=c,c.next=l),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(v===2){if(r===this._tail)return;const l=r.next,c=r.previous;r===this._head?(l.previous=void 0,this._head=l):(l.previous=c,c.next=l),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((v,l)=>{r.push([l,v])}),r}fromJSON(r){this.clear();for(const[v,l]of r)this.set(v,l)}}e.LinkedMap=C;class i extends C{constructor(r,v=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,v),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,v=2){return super.get(r,v)}peek(r){return super.get(r,0)}set(r,v){return super.set(r,v,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class p{constructor(r){k.set(this,void 0),Ze(this,k,r,"f")}get size(){return Re(this,k,"f").size}forEach(r,v){Re(this,k,"f").forEach(r,v)}get(r){return Re(this,k,"f").get(r)}has(r){return Re(this,k,"f").has(r)}entries(){return Re(this,k,"f").entries()}keys(){return Re(this,k,"f").keys()}values(){return Re(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Re(this,k,"f").entries()}}e.ReadonlyMapView=p}),define(be[106],Ee([0,1,20,9]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function _(...K){return function(se,he){for(let Ae=0,Ue=K.length;Ae<Ue;Ae++){const He=K[Ae](se,he);if(He)return He}return null}}e.or=_,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(K,se,he){if(!he||he.length<se.length)return null;let Ae;return K?Ae=M.startsWithIgnoreCase(he,se):Ae=he.indexOf(se)===0,Ae?se.length>0?[{start:0,end:se.length}]:[]:null}function F(K,se){const he=se.toLowerCase().indexOf(K.toLowerCase());return he===-1?null:[{start:he,end:he+K.length}]}e.matchesContiguousSubString=F;function k(K,se){return D(K.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=k;function D(K,se,he,Ae){if(he===K.length)return[];if(Ae===se.length)return null;if(K[he]===se[Ae]){let Ue=null;return(Ue=D(K,se,he+1,Ae+1))?I({start:Ae,end:Ae+1},Ue):null}return D(K,se,he,Ae+1)}function P(K){return 97<=K&&K<=122}function t(K){return 65<=K&&K<=90}e.isUpper=t;function y(K){return 48<=K&&K<=57}function n(K){return K===32||K===9||K===10||K===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(K=>m.add(K.charCodeAt(0)));function s(K){return n(K)||m.has(K)}function u(K,se){return K===se||s(K)&&s(se)}function g(K){return P(K)||t(K)||y(K)}function I(K,se){return se.length===0?se=[K]:K.end===se[0].start?se[0].start=K.start:se.unshift(K),se}function E(K,se){for(let he=se;he<K.length;he++){const Ae=K.charCodeAt(he);if(t(Ae)||y(Ae)||he>0&&!g(K.charCodeAt(he-1)))return he}return K.length}function o(K,se,he,Ae){if(he===K.length)return[];if(Ae===se.length)return null;if(K[he]!==se[Ae].toLowerCase())return null;{let Ue=null,He=Ae+1;for(Ue=o(K,se,he+1,Ae+1);!Ue&&(He=E(se,He))<se.length;)Ue=o(K,se,he+1,He),He++;return Ue===null?null:I({start:Ae,end:Ae+1},Ue)}}function h(K){let se=0,he=0,Ae=0,Ue=0,He=0;for(let nt=0;nt<K.length;nt++)He=K.charCodeAt(nt),t(He)&&se++,P(He)&&he++,g(He)&&Ae++,y(He)&&Ue++;const Qe=se/K.length,et=he/K.length,st=Ae/K.length,ye=Ue/K.length;return{upperPercent:Qe,lowerPercent:et,alphaPercent:st,numericPercent:ye}}function C(K){const{upperPercent:se,lowerPercent:he}=K;return he===0&&se>.6}function i(K){const{upperPercent:se,lowerPercent:he,alphaPercent:Ae,numericPercent:Ue}=K;return he>.2&&se<.8&&Ae>.6&&Ue<.2}function p(K){let se=0,he=0,Ae=0,Ue=0;for(let He=0;He<K.length;He++)Ae=K.charCodeAt(He),t(Ae)&&se++,P(Ae)&&he++,n(Ae)&&Ue++;return(se===0||he===0)&&Ue===0?K.length<=30:se<=5}function a(K,se){if(!se||(se=se.trim(),se.length===0)||!p(K)||se.length>60)return null;const he=h(se);if(!i(he)){if(!C(he))return null;se=se.toLowerCase()}let Ae=null,Ue=0;for(K=K.toLowerCase();Ue<se.length&&(Ae=o(K,se,0,Ue))===null;)Ue=E(se,Ue+1);return Ae}e.matchesCamelCase=a;function r(K,se,he=!1){if(!se||se.length===0)return null;let Ae=null,Ue=0;for(K=K.toLowerCase(),se=se.toLowerCase();Ue<se.length&&(Ae=v(K,se,0,Ue,he))===null;)Ue=l(se,Ue+1);return Ae}e.matchesWords=r;function v(K,se,he,Ae,Ue){if(he===K.length)return[];if(Ae===se.length)return null;if(u(K.charCodeAt(he),se.charCodeAt(Ae))){let He=null,Qe=Ae+1;if(He=v(K,se,he+1,Ae+1,Ue),!Ue)for(;!He&&(Qe=l(se,Qe))<se.length;)He=v(K,se,he+1,Qe,Ue),Qe++;return He===null?null:I({start:Ae,end:Ae+1},He)}else return null}function l(K,se){for(let he=se;he<K.length;he++)if(s(K.charCodeAt(he))||he>0&&s(K.charCodeAt(he-1)))return he;return K.length}const c=_(e.matchesPrefix,a,F),w=_(e.matchesPrefix,a,k),f=new d.LRUCache(1e4);function S(K,se,he=!1){if(typeof K!="string"||typeof se!="string")return null;let Ae=f.get(K);Ae||(Ae=new RegExp(M.convertSimple2RegExpPattern(K),"i"),f.set(K,Ae));const Ue=Ae.exec(se);return Ue?[{start:Ue.index,end:Ue.index+Ue[0].length}]:he?w(K,se):c(K,se)}e.matchesFuzzy=S;function R(K,se){const he=Ke(K,K.toLowerCase(),0,se,se.toLowerCase(),0,!0);return he?L(he):null}e.matchesFuzzy2=R;function T(K,se,he,Ae,Ue,He){const Qe=Math.min(13,K.length);for(;he<Qe;he++){const et=Ke(K,se,he,Ae,Ue,He,!1);if(et)return et}return[0,He]}e.anyScore=T;function L(K){if(typeof K=="undefined")return[];const se=[],he=K[1];for(let Ae=K.length-1;Ae>1;Ae--){const Ue=K[Ae]+he,He=se[se.length-1];He&&He.end===Ue?He.end=Ue+1:se.push({start:Ue,end:Ue+1})}return se}e.createMatches=L;const b=128;function x(){const K=[],se=[];for(let he=0;he<=b;he++)se[he]=0;for(let he=0;he<=b;he++)K.push(se.slice(0));return K}function $(K){const se=[];for(let he=0;he<=K;he++)se[he]=0;return se}const B=$(2*b),G=$(2*b),H=x(),W=x(),ne=x(),V=!1;function Y(K,se,he,Ae,Ue){function He(et,st,ye=" "){for(;et.length<st;)et=ye+et;return et}let Qe=` |   |${Ae.split("").map(et=>He(et,3)).join("|")}
`;for(let et=0;et<=he;et++)et===0?Qe+=" |":Qe+=`${se[et-1]}|`,Qe+=K[et].slice(0,Ue+1).map(st=>He(st.toString(),3)).join("|")+`
`;return Qe}function j(K,se,he,Ae){K=K.substr(se),he=he.substr(Ae),console.log(Y(W,K,K.length,he,he.length)),console.log(Y(ne,K,K.length,he,he.length)),console.log(Y(H,K,K.length,he,he.length))}function le(K,se){if(se<0||se>=K.length)return!1;const he=K.codePointAt(se);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(he)}}function re(K,se){if(se<0||se>=K.length)return!1;switch(K.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function ve(K,se,he){return se[K]!==he[K]}function Fe(K,se,he,Ae,Ue,He,Qe=!1){for(;se<he&&Ue<He;)K[se]===Ae[Ue]&&(Qe&&(B[se]=Ue),se+=1),Ue+=1;return se===he}e.isPatternInWord=Fe;var Me;(function(K){K[K.Diag=1]="Diag",K[K.Left=2]="Left",K[K.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var Oe;(function(K){K.Default=[-100,0];function se(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}K.isDefault=se})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function Ke(K,se,he,Ae,Ue,He,Qe){const et=K.length>b?b:K.length,st=Ae.length>b?b:Ae.length;if(he>=et||He>=st||et-he>st-He||!Fe(se,he,et,Ue,He,st,!0))return;je(et,st,he,He,se,Ue);let ye=1,nt=1,q=he,Z=He;const pe=[!1];for(ye=1,q=he;q<et;ye++,q++){const ut=B[q],St=G[q],Tt=q+1<et?G[q+1]:st;for(nt=ut-He+1,Z=ut;Z<Tt;nt++,Z++){let It=Number.MIN_SAFE_INTEGER,Xe=!1;Z<=St&&(It=Ve(K,se,q,he,Ae,Ue,Z,st,He,H[ye-1][nt-1]===0,pe));let vt=0;It!==Number.MAX_SAFE_INTEGER&&(Xe=!0,vt=It+W[ye-1][nt-1]);const Pe=Z>ut,Se=Pe?W[ye][nt-1]+(H[ye][nt-1]>0?-5:0):0,Ce=Z>ut+1&&H[ye][nt-1]>0,te=Ce?W[ye][nt-2]+(H[ye][nt-2]>0?-5:0):0;if(Ce&&(!Pe||te>=Se)&&(!Xe||te>=vt))W[ye][nt]=te,ne[ye][nt]=3,H[ye][nt]=0;else if(Pe&&(!Xe||Se>=vt))W[ye][nt]=Se,ne[ye][nt]=2,H[ye][nt]=0;else if(Xe)W[ye][nt]=vt,ne[ye][nt]=1,H[ye][nt]=H[ye-1][nt-1]+1;else throw new Error("not possible")}}if(V&&j(K,he,Ae,He),!pe[0]&&!Qe)return;ye--,nt--;const We=[W[ye][nt],He];let Ye=0,rt=0;for(;ye>=1;){let ut=nt;do{const St=ne[ye][ut];if(St===3)ut=ut-2;else if(St===2)ut=ut-1;else break}while(ut>=1);Ye>1&&se[he+ye-1]===Ue[He+nt-1]&&!ve(ut+He-1,Ae,Ue)&&Ye+1>H[ye][ut]&&(ut=nt),ut===nt?Ye++:Ye=1,rt||(rt=ut),ye--,nt=ut-1,We.push(nt)}st===et&&(We[0]+=2);const mt=rt-et;return We[0]-=mt,We}e.fuzzyScore=Ke;function je(K,se,he,Ae,Ue,He){let Qe=K-1,et=se-1;for(;Qe>=he&&et>=Ae;)Ue[Qe]===He[et]&&(G[Qe]=et,Qe--),et--}function Ve(K,se,he,Ae,Ue,He,Qe,et,st,ye,nt){if(se[he]!==He[Qe])return Number.MIN_SAFE_INTEGER;let q=1,Z=!1;return Qe===he-Ae?q=K[he]===Ue[Qe]?7:5:ve(Qe,Ue,He)&&(Qe===0||!ve(Qe-1,Ue,He))?(q=K[he]===Ue[Qe]?7:5,Z=!0):le(He,Qe)&&(Qe===0||!le(He,Qe-1))?q=5:(le(He,Qe-1)||re(He,Qe-1))&&(q=5,Z=!0),q>1&&he===Ae&&(nt[0]=!0),Z||(Z=ve(Qe,Ue,He)||le(He,Qe-1)||re(He,Qe-1)),he===Ae?Qe>st&&(q-=Z?3:5):ye?q+=Z?2:0:q+=Z?0:1,Qe+1===et&&(q-=Z?3:5),q}function U(K,se,he,Ae,Ue,He,Qe){return ee(K,se,he,Ae,Ue,He,!0,Qe)}e.fuzzyScoreGracefulAggressive=U;function Q(K,se,he,Ae,Ue,He,Qe){return ee(K,se,he,Ae,Ue,He,!1,Qe)}e.fuzzyScoreGraceful=Q;function ee(K,se,he,Ae,Ue,He,Qe,et){let st=Ke(K,se,he,Ae,Ue,He,et);if(st&&!Qe)return st;if(K.length>=3){const ye=Math.min(7,K.length-1);for(let nt=he+1;nt<ye;nt++){const q=ae(K,nt);if(q){const Z=Ke(q,q.toLowerCase(),he,Ae,Ue,He,et);Z&&(Z[0]-=3,(!st||Z[0]>st[0])&&(st=Z))}}}return st}function ae(K,se){if(se+1>=K.length)return;const he=K[se],Ae=K[se+1];if(he!==Ae)return K.slice(0,se)+Ae+he+K.slice(se+2)}}),define(be[107],Ee([0,1,34,106,9]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),F=new RegExp(`(\\\\)?${A.source}`,"g");function k(u){return u.replace(F,(g,I)=>I?g:`\\${g}`)}e.escapeIcons=k;const D=new RegExp(`\\\\${A.source}`,"g");function P(u){return u.replace(D,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=P;const t=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function y(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(t,(g,I,E,o)=>E?g:I||o||"")}e.stripIcons=y;function n(u){const g=u.indexOf(e.iconStartMarker);return g===-1?{text:u}:m(u,g)}e.parseLabelWithIcons=n;function m(u,g){const I=[];let E="";function o(l){if(l){E+=l;for(const c of l)I.push(i)}}let h=-1,C="",i=0,p,a,r=g;const v=u.length;for(o(u.substr(0,g));r<v;)p=u[r],a=u[r+1],p===e.iconStartMarker[0]&&a===e.iconStartMarker[1]?(h=r,o(C),C=e.iconStartMarker,r++):p===")"&&h!==-1?(i+=r-h+1,h=-1,C=""):h!==-1?/^[a-z0-9\-]$/i.test(p)?C+=p:(o(C),h=-1,C=""):o(p),r++;return o(C),{text:E,iconOffsets:I}}function s(u,g,I=!1){const{text:E,iconOffsets:o}=g;if(!o||o.length===0)return(0,M.matchesFuzzy)(u,E,I);const h=(0,_.ltrim)(E," "),C=E.length-h.length,i=(0,M.matchesFuzzy)(u,h,I);if(i)for(const p of i){const a=o[p.start+C]+C;p.start+=a,p.end+=a}return i}e.matchesFuzzyIconAware=s}),define(be[77],Ee([0,1,16,107]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var _;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(_=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(m="",s=!1){if(this.value=m,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(m,s=0){return this.value+=P(this.supportThemeIcons?(0,M.escapeIcons)(m):m).replace(/([ \t]+)/g,(u,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,s){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}}e.MarkdownString=A;function F(n){return k(n)?!n.value:Array.isArray(n)?n.every(F):!0}e.isEmptyMarkdownString=F;function k(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function D(n,m){return n===m?!0:!n||!m?!1:n.value===m.value&&n.isTrusted===m.isTrusted&&n.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=D;function P(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function y(n){const m=[],s=n.split("|").map(g=>g.trim());n=s[0];const u=s[1];if(u){const g=/height=(\d+)/.exec(u),I=/width=(\d+)/.exec(u),E=g?g[1]:"",o=I?I[1]:"",h=isFinite(parseInt(o)),C=isFinite(parseInt(E));h&&m.push(`width="${o}"`),C&&m.push(`height="${E}"`)}return{href:n,dimensions:m}}e.parseHrefAndDimensions=y}),define(be[55],Ee([0,1,22,9,2]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(t){return JSON.stringify(t,D)}e.stringify=A;function F(t){let y=JSON.parse(t);return y=P(y),y}e.parse=F;var k;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function D(t,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,M.regExpFlags)(y)}:y}function P(t,y=0){if(!t||y>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return _.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof d.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=P(t[n],y+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=P(t[n],y+1))}return t}e.revive=P}),define(be[11],Ee([0,1,25,2]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var _;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp"})(_=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,P,t){this._hosts[D]=P,this._ports[D]=t}setConnectionToken(D,P){this._connectionTokens[D]=P}rewrite(D){if(this._delegate)return this._delegate(D);const P=D.authority;let t=this._hosts[P];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const y=this._ports[P],n=this._connectionTokens[P];let m=`path=${encodeURIComponent(D.path)}`;return typeof n=="string"&&(m+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:d.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${t}:${y}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new A;class F{asBrowserUri(D,P){const t=this.toUri(D,P);return t.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===_.file&&(d.isNative||typeof d.globals.importScripts=="function"&&d.globals.origin===`${_.vscodeFileResource}://${F.FALLBACK_AUTHORITY}`)?t.with({scheme:_.vscodeFileResource,authority:t.authority||F.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(D,P){const t=this.toUri(D,P);return t.scheme===_.vscodeFileResource?t.with({scheme:_.file,authority:t.authority!==F.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(D,P){return M.URI.isUri(D)?D:M.URI.parse(P.toUrl(D))}}F.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new F}),define(be[24],Ee([0,1,43,11,17,25,9,2]),function(oe,e,d,M,_,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(m){return(0,k.uriToFsPath)(m,!0)}e.originalFSPath=D;class P{constructor(s){this._ignorePathCasing=s}compare(s,u,g=!1){return s===u?0:(0,F.compare)(this.getComparisonKey(s,g),this.getComparisonKey(u,g))}isEqual(s,u,g=!1){return s===u?!0:!s||!u?!1:this.getComparisonKey(s,g)===this.getComparisonKey(u,g)}getComparisonKey(s,u=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,u,g=!1){if(s.scheme===u.scheme){if(s.scheme===M.Schemas.file)return d.isEqualOrParent(D(s),D(u),this._ignorePathCasing(s))&&s.query===u.query&&(g||s.fragment===u.fragment);if((0,e.isEqualAuthority)(s.authority,u.authority))return d.isEqualOrParent(s.path,u.path,this._ignorePathCasing(s),"/")&&s.query===u.query&&(g||s.fragment===u.fragment)}return!1}joinPath(s,...u){return k.URI.joinPath(s,...u)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return _.posix.basename(s.path)}extname(s){return _.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let u;return s.scheme===M.Schemas.file?u=k.URI.file(_.dirname(D(s))).path:(u=_.posix.dirname(s.path),s.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),u="/")),s.with({path:u})}normalizePath(s){if(!s.path.length)return s;let u;return s.scheme===M.Schemas.file?u=k.URI.file(_.normalize(D(s))).path:u=_.posix.normalize(s.path),s.with({path:u})}relativePath(s,u){if(s.scheme!==u.scheme||!(0,e.isEqualAuthority)(s.authority,u.authority))return;if(s.scheme===M.Schemas.file){const E=_.relative(D(s),D(u));return A.isWindows?d.toSlashes(E):E}let g=s.path||"/",I=u.path||"/";if(this._ignorePathCasing(s)){let E=0;for(const o=Math.min(g.length,I.length);E<o&&!(g.charCodeAt(E)!==I.charCodeAt(E)&&g.charAt(E).toLowerCase()!==I.charAt(E).toLowerCase());E++);g=I.substr(0,E)+g.substr(E)}return _.posix.relative(g,I)}resolvePath(s,u){if(s.scheme===M.Schemas.file){const g=k.URI.file(_.resolve(D(s),u));return s.with({authority:g.authority,path:g.path})}return u=d.toPosixPath(u),s.with({path:_.posix.resolve(s.path,u)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,u){return s===u||(0,F.equalsIgnoreCase)(s,u)}hasTrailingPathSeparator(s,u=_.sep){if(s.scheme===M.Schemas.file){const g=D(s);return g.length>d.getRoot(g).length&&g[g.length-1]===u}else{const g=s.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,u=_.sep){return(0,e.hasTrailingPathSeparator)(s,u)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,u=_.sep){let g=!1;if(s.scheme===M.Schemas.file){const I=D(s);g=I!==void 0&&I.length===d.getRoot(I).length&&I[I.length-1]===u}else{u="/";const I=s.path;g=I.length===1&&I.charCodeAt(I.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(s,u)?s.with({path:s.path+"/"}):s}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(m=>m.scheme===M.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new P(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(m,s){const u=[];for(let g=0;g<m.length;g++){const I=s(m[g]);m.some((E,o)=>o===g?!1:(0,e.isEqualOrParent)(I,s(E)))||u.push(m[g])}return u}e.distinctParents=t;var y;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function s(u){const g=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(o=>{const[h,C]=o.split(":");h&&C&&g.set(h,C)});const E=u.path.substring(0,u.path.indexOf(";"));return E&&g.set(m.META_DATA_MIME,E),g}m.parseMetaData=s})(y=e.DataUri||(e.DataUri={}));function n(m,s,u){if(s){let g=m.path;return g&&g[0]!==_.posix.sep&&(g=_.posix.sep+g),m.with({scheme:u,authority:s,path:g})}return m.with({scheme:u})}e.toLocalResource=n}),define(be[12],Ee([0,1,21,16,3,6,24]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(H){return!!H&&typeof H.then=="function"}e.isThenable=k;function D(H){const W=new d.CancellationTokenSource,ne=H(W.token),V=new Promise((Y,j)=>{const le=W.token.onCancellationRequested(()=>{le.dispose(),W.dispose(),j((0,M.canceled)())});Promise.resolve(ne).then(re=>{le.dispose(),W.dispose(),Y(re)},re=>{le.dispose(),W.dispose(),j(re)})});return new class{cancel(){W.cancel()}then(Y,j){return V.then(Y,j)}catch(Y){return this.then(void 0,Y)}finally(Y){return V.finally(Y)}}}e.createCancelablePromise=D;function P(H,W,ne){return Promise.race([H,new Promise(V=>W.onCancellationRequested(()=>V(ne)))])}e.raceCancellation=P;async function t(H){let W=-1;const ne=H.map((Y,j)=>Y.then(le=>(W=j,le))),V=await Promise.race(ne);return H.forEach((Y,j)=>{j!==W&&Y.cancel()}),V}e.raceCancellablePromises=t;function y(H,W,ne){let V;const Y=setTimeout(()=>{V?.(void 0),ne?.()},W);return Promise.race([H.finally(()=>clearTimeout(Y)),new Promise(j=>V=j)])}e.raceTimeout=y;function n(H){return new Promise((W,ne)=>{const V=H();k(V)?V.then(W,ne):W(V)})}e.asPromise=n;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const ne=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(ne,ne).then(V)})}return new Promise((ne,V)=>{this.queuedPromise.then(ne,V)})}return this.activePromise=W(),new Promise((ne,V)=>{this.activePromise.then(Y=>{this.activePromise=null,ne(Y)},Y=>{this.activePromise=null,V(Y)})})}}e.Throttler=m;class s{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=s;class u{constructor(){this.promiseMap=new Map}queue(W,ne){const Y=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.promiseMap.get(W)===Y&&this.promiseMap.delete(W)});return this.promiseMap.set(W,Y),Y}}e.SequencerByKey=u;class g{constructor(W){this.defaultDelay=W,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,ne=this.defaultDelay){return this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,Y)=>{this.doResolve=V,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},ne),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=g;class I{constructor(W){this.delayer=new g(W),this.throttler=new m}trigger(W,ne){return this.delayer.trigger(()=>this.throttler.queue(W),ne)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class E{constructor(){this._isOpen=!1,this._promise=new Promise((W,ne)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=E;class o extends E{constructor(W){super();this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function h(H,W){return W?new Promise((ne,V)=>{const Y=setTimeout(()=>{j.dispose(),ne()},H),j=W.onCancellationRequested(()=>{clearTimeout(Y),j.dispose(),V((0,M.canceled)())})}):D(ne=>h(H,ne))}e.timeout=h;function C(H,W=0){const ne=setTimeout(H,W);return(0,A.toDisposable)(()=>clearTimeout(ne))}e.disposableTimeout=C;function i(H){const W=[];let ne=0;const V=H.length;function Y(){return ne<V?H[ne++]():null}function j(le){le!=null&&W.push(le);const re=Y();return re?re.then(j):Promise.resolve(W)}return Promise.resolve(null).then(j)}e.sequence=i;function p(H,W=V=>!!V,ne=null){let V=0;const Y=H.length,j=()=>{if(V>=Y)return Promise.resolve(ne);const le=H[V++];return Promise.resolve(le()).then(ve=>W(ve)?Promise.resolve(ve):j())};return j()}e.first=p;function a(H,W=V=>!!V,ne=null){if(H.length===0)return Promise.resolve(ne);let V=H.length;const Y=()=>{V=-1;for(const j of H)j.cancel?.()};return new Promise((j,le)=>{for(const re of H)re.then(ve=>{--V>=0&&W(ve)?(Y(),j(ve)):V===0&&j(ne)}).catch(ve=>{--V>=0&&(Y(),le(ve))})})}e.firstParallel=a;class r{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new _.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(W){return this._size++,new Promise((ne,V)=>{this.outstandingPromises.push({factory:W,c:ne,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const ne=W.factory();ne.then(W.c,W.e),ne.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class v extends r{constructor(){super(1)}}e.Queue=v;class l{constructor(){this.queues=new Map}queueFor(W,ne=F.extUri){const V=ne.getComparisonKey(W);let Y=this.queues.get(V);return Y||(Y=new v,_.Event.once(Y.onFinished)(()=>{Y?.dispose(),this.queues.delete(V)}),this.queues.set(V,Y)),Y}dispose(){this.queues.forEach(W=>W.dispose()),this.queues.clear()}}e.ResourceQueue=l;class c{constructor(W,ne){this._token=-1,typeof W=="function"&&typeof ne=="number"&&this.setIfNotSet(W,ne)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,ne){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},ne)}setIfNotSet(W,ne){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},ne))}}e.TimeoutTimer=c;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,ne){this.cancel(),this._token=setInterval(()=>{W()},ne)}}e.IntervalTimer=w;class f{constructor(W,ne){this.timeoutToken=-1,this.runner=W,this.timeout=ne,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=f;class S{constructor(W,ne){ne%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.runner=W,this.timeout=ne,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(W=this.timeout){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(W/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=S;class R extends f{constructor(W,ne){super(W,ne);this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner&&this.runner(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=R;class T extends A.Disposable{constructor(W,ne,V,Y){super();this.maxWorkChunkSize=W,this.maxPendingWork=ne,this.throttleDelay=V,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.maxPendingWork)return!1}else if(this.pending+W.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...W),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new f(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=T,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{const W=setTimeout(()=>{const V=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0,clearTimeout(W))}}}:e.runWhenIdle=(H,W)=>{const ne=requestIdleCallback(H,typeof W=="number"?{timeout:W}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(ne))}}}}();class L{constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(ne){this._error=ne}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=L;async function b(H,W,ne){let V;for(let Y=0;Y<ne;Y++)try{return await H()}catch(j){V=j,await h(W)}throw V}e.retry=b;class x{hasPending(W){return this._pending?typeof W=="number"?this._pending.taskId===W:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(W,ne,V){return this._pending={taskId:W,cancel:()=>V?.(),promise:ne},ne.then(()=>this.donePending(W),()=>this.donePending(W)),ne}donePending(W){this._pending&&W===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const W=this._next;this._next=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}setNext(W){if(this._next)this._next.run=W;else{let ne,V;const Y=new Promise((j,le)=>{ne=j,V=le});this._next={run:W,promise:Y,promiseResolve:ne,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=x;class ${constructor(W){this.interval=W,this.lastIncrementTime=0,this.value=0}increment(){const W=Date.now();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((W,ne)=>{this.completeCallback=W,this.errorCallback=ne})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(W){return new Promise(ne=>{this.completeCallback(W),this.resolved=!0,ne()})}error(W){return new Promise(ne=>{this.errorCallback(W),this.rejected=!0,ne()})}cancel(){new Promise(W=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,W()})}}e.DeferredPromise=B;var G;(function(H){async function W(V){let Y;const j=await Promise.all(V.map(le=>le.then(re=>re,re=>{Y||(Y=re)})));if(typeof Y!="undefined")throw Y;return j}H.settled=W;function ne(V){return new Promise(async(Y,j)=>{try{await V(Y,j)}catch(le){j(le)}})}H.withAsyncBody=ne})(G=e.Promises||(e.Promises={}))}),define(be[108],Ee([0,1,12,17]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const _=new d.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),A=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(f,S,R=!1){const T=f||"",L=S||"",b=_.value.collator.compare(T,L);return _.value.collatorIsNumeric&&b===0&&T!==L?T<L?-1:1:b}e.compareFileNames=k;function D(f,S){const R=A.value.collator;return f=f||"",S=S||"",C(R,f,S)}e.compareFileNamesDefault=D;function P(f,S){const R=A.value.collator;return f=f||"",S=S||"",r(f,S)||C(R,f,S)}e.compareFileNamesUpper=P;function t(f,S){const R=A.value.collator;return f=f||"",S=S||"",a(f,S)||C(R,f,S)}e.compareFileNamesLower=t;function y(f,S){return f=f||"",S=S||"",f===S?0:f<S?-1:1}e.compareFileNamesUnicode=y;function n(f,S,R=!1){R||(f=f&&f.toLowerCase(),S=S&&S.toLowerCase());const[T,L]=o(f),[b,x]=o(S);return T!==b?T<b?-1:1:L===x?0:L<x?-1:1}e.noIntlCompareFileNames=n;function m(f,S){const[R,T]=o(f),[L,b]=o(S);let x=_.value.collator.compare(T,b);if(x===0){if(_.value.collatorIsNumeric&&T!==b)return T<b?-1:1;if(x=_.value.collator.compare(R,L),_.value.collatorIsNumeric&&x===0&&R!==L)return R<L?-1:1}return x}e.compareFileExtensions=m;function s(f,S){f=f||"",S=S||"";const R=h(f),T=h(S),L=A.value.collator,b=F.value.collator;return C(b,R,T)||C(L,f,S)}e.compareFileExtensionsDefault=s;function u(f,S){f=f||"",S=S||"";const R=h(f),T=h(S),L=A.value.collator,b=F.value.collator;return C(b,R,T)||r(f,S)||C(L,f,S)}e.compareFileExtensionsUpper=u;function g(f,S){f=f||"",S=S||"";const R=h(f),T=h(S),L=A.value.collator,b=F.value.collator;return C(b,R,T)||a(f,S)||C(L,f,S)}e.compareFileExtensionsLower=g;function I(f,S){f=f||"",S=S||"";const R=h(f).toLowerCase(),T=h(S).toLowerCase();return R!==T?R<T?-1:1:f!==S?f<S?-1:1:0}e.compareFileExtensionsUnicode=I;const E=/^(.*?)(\.([^.]*))?$/;function o(f,S=!1){const R=f?E.exec(f):[];let T=[R&&R[1]||"",R&&R[3]||""];return S&&(!T[0]&&T[1]||T[0]&&T[0].charAt(0)===".")&&(T=[T[0]+"."+T[1],""]),T}function h(f){const S=f?E.exec(f):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function C(f,S,R){let T=f.compare(S,R);return T!==0?T:S.length!==R.length?S.length<R.length?-1:1:0}function i(f){const S=f.charAt(0);return S.toLocaleUpperCase()!==S}function p(f){const S=f.charAt(0);return S.toLocaleLowerCase()!==S}function a(f,S){return i(f)&&p(S)?-1:p(f)&&i(S)?1:0}function r(f,S){return p(f)&&i(S)?-1:i(f)&&p(S)?1:0}function v(f,S,R=!1){return R||(f=f&&f.toLowerCase(),S=S&&S.toLowerCase()),f===S?0:f<S?-1:1}function l(f,S,R=!1){const T=f.split(M.sep),L=S.split(M.sep),b=T.length-1,x=L.length-1;let $,B;for(let G=0;;G++){if($=b===G,B=x===G,$&&B)return k(T[G],L[G],R);if($)return-1;if(B)return 1;const H=v(T[G],L[G],R);if(H!==0)return H}}e.comparePaths=l;function c(f,S,R){const T=f.toLowerCase(),L=S.toLowerCase(),b=w(f,S,R);if(b)return b;const x=T.endsWith(R),$=L.endsWith(R);if(x!==$)return x?-1:1;const B=k(T,L);return B!==0?B:T.localeCompare(L)}e.compareAnything=c;function w(f,S,R){const T=f.toLowerCase(),L=S.toLowerCase(),b=T.startsWith(R),x=L.startsWith(R);if(b!==x)return b?-1:1;if(b&&x){if(T.length<L.length)return-1;if(T.length>L.length)return 1}return 0}e.compareByPrefix=w}),define(be[27],Ee([0,1,12,43,20,17,9]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const D="**",P="/",t="[/\\\\]",y="[^/\\\\]",n=/\//g;function m(V){switch(V){case 0:return"";case 1:return`${y}*?`;default:return`(?:${t}|${y}+${t}|${t}${y}+)*?`}}function s(V,Y){if(!V)return[];const j=[];let le=!1,re=!1,ve="";for(const Fe of V){switch(Fe){case Y:if(!le&&!re){j.push(ve),ve="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":re=!0;break;case"]":re=!1;break}ve+=Fe}return ve&&j.push(ve),j}e.splitGlobAware=s;function u(V){if(!V)return"";let Y="";const j=s(V,P);if(j.every(le=>le===D))Y=".*";else{let le=!1;j.forEach((re,ve)=>{if(re===D){le||(Y+=m(2),le=!0);return}let Fe=!1,Me="",Oe=!1,Ke="";for(const je of re){if(je!=="}"&&Fe){Me+=je;continue}if(Oe&&(je!=="]"||!Ke)){let Ve;je==="-"?Ve=je:(je==="^"||je==="!")&&!Ke?Ve="^":je===P?Ve="":Ve=F.escapeRegExpCharacters(je),Ke+=Ve;continue}switch(je){case"{":Fe=!0;continue;case"[":Oe=!0;continue;case"}":Y+=`(?:${s(Me,",").map(Q=>u(Q)).join("|")})`,Fe=!1,Me="";break;case"]":Y+="["+Ke+"]",Oe=!1,Ke="";break;case"?":Y+=y;continue;case"*":Y+=m(1);continue;default:Y+=F.escapeRegExpCharacters(je)}}ve<j.length-1&&(j[ve+1]!==D||ve+2<j.length)&&(Y+=t),le=!1})}return Y}const g=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new _.LRUCache(1e4),p=function(){return!1},a=function(){return null};function r(V,Y){if(!V)return a;let j;typeof V!="string"?j=V.pattern:j=V,j=j.trim();const le=`${j}_${!!Y.trimForExclusions}`;let re=i.get(le);if(re)return v(re,V);let ve;if(g.test(j)){const Fe=j.substr(4);re=function(Me,Oe){return typeof Me=="string"&&Me.endsWith(Fe)?j:null}}else(ve=I.exec(l(j,Y)))?re=c(ve[1],j):(Y.trimForExclusions?o:E).test(j)?re=w(j,Y):(ve=h.exec(l(j,Y)))?re=f(ve[1].substr(1),j,!0):(ve=C.exec(l(j,Y)))?re=f(ve[1],j,!1):re=S(j);return i.set(le,re),v(re,V)}function v(V,Y){return typeof Y=="string"?V:function(j,le){return M.isEqualOrParent(j,Y.base)?V(A.relative(Y.base,j),le):null}}function l(V,Y){return Y.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function c(V,Y){const j=`/${V}`,le=`\\${V}`,re=function(Fe,Me){return typeof Fe!="string"?null:Me?Me===V?Y:null:Fe===V||Fe.endsWith(j)||Fe.endsWith(le)?Y:null},ve=[V];return re.basenames=ve,re.patterns=[Y],re.allBasenames=ve,re}function w(V,Y){const j=ne(V.slice(1,-1).split(",").map(Me=>r(Me,Y)).filter(Me=>Me!==a),V),le=j.length;if(!le)return a;if(le===1)return j[0];const re=function(Me,Oe){for(let Ke=0,je=j.length;Ke<je;Ke++)if(j[Ke](Me,Oe))return V;return null},ve=j.find(Me=>!!Me.allBasenames);ve&&(re.allBasenames=ve.allBasenames);const Fe=j.reduce((Me,Oe)=>Oe.allPaths?Me.concat(Oe.allPaths):Me,[]);return Fe.length&&(re.allPaths=Fe),re}function f(V,Y,j){const le=A.sep===A.posix.sep,re=le?V:V.replace(n,A.sep),ve=A.sep+re,Fe=A.posix.sep+V,Me=j?function(Oe,Ke){return typeof Oe=="string"&&(Oe===re||Oe.endsWith(ve)||!le&&(Oe===V||Oe.endsWith(Fe)))?Y:null}:function(Oe,Ke){return typeof Oe=="string"&&(Oe===re||!le&&Oe===V)?Y:null};return Me.allPaths=[(j?"*/":"./")+V],Me}function S(V){try{const Y=new RegExp(`^${u(V)}$`);return function(j){return Y.lastIndex=0,typeof j=="string"&&Y.test(j)?V:null}}catch(Y){return a}}function R(V,Y,j){return!V||typeof Y!="string"?!1:T(V)(Y,void 0,j)}e.match=R;function T(V,Y={}){if(!V)return p;if(typeof V=="string"||$(V)){const j=r(V,Y);if(j===a)return p;const le=function(re,ve){return!!j(re,ve)};return j.allBasenames&&(le.allBasenames=j.allBasenames),j.allPaths&&(le.allPaths=j.allPaths),le}return H(V,Y)}e.parse=T;function L(V){if(!V)return;let Y;return j=>(Y||(Y=(V()||Promise.resolve([])).then(le=>le?x(le):{})),Y.then(le=>!!le[j]))}e.hasSiblingPromiseFn=L;function b(V){if(!V)return;let Y;return j=>{if(!Y){const le=V();Y=le?x(le):{}}return!!Y[j]}}e.hasSiblingFn=b;function x(V){const Y={};for(const j of V)Y[j]=!0;return Y}function $(V){const Y=V;return Y&&typeof Y.base=="string"&&typeof Y.pattern=="string"}e.isRelativePattern=$;function B(V){return V.allBasenames||[]}e.getBasenameTerms=B;function G(V){return V.allPaths||[]}e.getPathTerms=G;function H(V,Y){const j=ne(Object.getOwnPropertyNames(V).map(Me=>W(Me,V[Me],Y)).filter(Me=>Me!==a)),le=j.length;if(!le)return a;if(!j.some(Me=>!!Me.requiresSiblings)){if(le===1)return j[0];const Me=function(je,Ve){for(let U=0,Q=j.length;U<Q;U++){const ee=j[U](je,Ve);if(ee)return ee}return null},Oe=j.find(je=>!!je.allBasenames);Oe&&(Me.allBasenames=Oe.allBasenames);const Ke=j.reduce((je,Ve)=>Ve.allPaths?je.concat(Ve.allPaths):je,[]);return Ke.length&&(Me.allPaths=Ke),Me}const re=function(Me,Oe,Ke){let je;for(let Ve=0,U=j.length;Ve<U;Ve++){const Q=j[Ve];Q.requiresSiblings&&Ke&&(Oe||(Oe=A.basename(Me)),je||(je=Oe.substr(0,Oe.length-A.extname(Me).length)));const ee=Q(Me,Oe,je,Ke);if(ee)return ee}return null},ve=j.find(Me=>!!Me.allBasenames);ve&&(re.allBasenames=ve.allBasenames);const Fe=j.reduce((Me,Oe)=>Oe.allPaths?Me.concat(Oe.allPaths):Me,[]);return Fe.length&&(re.allPaths=Fe),re}function W(V,Y,j){if(Y===!1)return a;const le=r(V,j);if(le===a)return a;if(typeof Y=="boolean")return le;if(Y){const re=Y.when;if(typeof re=="string"){const ve=(Fe,Me,Oe,Ke)=>{if(!Ke||!le(Fe,Me))return null;const je=re.replace("$(basename)",Oe),Ve=Ke(je);return(0,d.isThenable)(Ve)?Ve.then(U=>U?V:null):Ve?V:null};return ve.requiresSiblings=!0,ve}}return le}function ne(V,Y){const j=V.filter(Me=>!!Me.basenames);if(j.length<2)return V;const le=j.reduce((Me,Oe)=>{const Ke=Oe.basenames;return Ke?Me.concat(Ke):Me},[]);let re;if(Y){re=[];for(let Me=0,Oe=le.length;Me<Oe;Me++)re.push(Y)}else re=j.reduce((Me,Oe)=>{const Ke=Oe.patterns;return Ke?Me.concat(Ke):Me},[]);const ve=function(Me,Oe){if(typeof Me!="string")return null;if(!Oe){let je;for(je=Me.length;je>0;je--){const Ve=Me.charCodeAt(je-1);if(Ve===47||Ve===92)break}Oe=Me.substr(je)}const Ke=le.indexOf(Oe);return Ke!==-1?re[Ke]:null};ve.basenames=le,ve.patterns=re,ve.allBasenames=le;const Fe=V.filter(Me=>!Me.basenames);return Fe.push(ve),Fe}}),define(be[78],Ee([0,1,43,11,17,25,24,9,2]),function(oe,e,d,M,_,A,F,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(r,v,l){if(typeof r=="string"&&(r=D.URI.file(r)),l){const w=l.getWorkspaceFolder(r);if(w){const f=l.getWorkspace().folders.length>1;let S;if((0,F.isEqual)(w.uri,r)?S="":S=(0,F.relativePath)(w.uri,r),f){const R=w.name?w.name:(0,F.basename)(w.uri);S=S?R+" \u2022 "+S:R}return S}}if(r.scheme!==M.Schemas.file&&r.scheme!==M.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(r.fsPath))return(0,_.normalize)(y(r.fsPath));let c=(0,_.normalize)(r.fsPath);return!A.isWindows&&v?.userHome&&(c=m(c,v.userHome.fsPath)),c}e.getPathLabel=P;function t(r){if(!r)return;typeof r=="string"&&(r=D.URI.file(r));const v=(0,F.basename)(r)||(r.scheme===M.Schemas.file?r.fsPath:r.path);return A.isWindows&&(0,d.isRootOrDriveLetter)(v)?y(v):v}e.getBaseLabel=t;function y(r){return(0,d.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=y;let n=Object.create(null);function m(r,v){if(A.isWindows||!r||!v)return r;let l=n.original===v?n.normalized:void 0;return l||(l=`${(0,k.rtrim)(v,_.posix.sep)}${_.posix.sep}`,n={original:v,normalized:l}),(A.isLinux?r.startsWith(l):(0,k.startsWithIgnoreCase)(r,l))&&(r=`~/${r.substr(l.length)}`),r}e.tildify=m;function s(r,v){return r.replace(/^~($|\/|\\)/,`${v}$1`)}e.untildify=s;const u="\u2026",g="\\\\",I="~";function E(r,v=_.sep){const l=new Array(r.length);let c=!1;for(let w=0;w<r.length;w++){let f=r[w];if(f===""){l[w]=`.${v}`;continue}if(!f){l[w]=f;continue}c=!0;let S="";f.indexOf(g)===0?(S=f.substr(0,f.indexOf(g)+g.length),f=f.substr(f.indexOf(g)+g.length)):f.indexOf(v)===0?(S=f.substr(0,f.indexOf(v)+v.length),f=f.substr(f.indexOf(v)+v.length)):f.indexOf(I)===0&&(S=f.substr(0,f.indexOf(I)+I.length),f=f.substr(f.indexOf(I)+I.length));const R=f.split(v);for(let T=1;c&&T<=R.length;T++)for(let L=R.length-T;c&&L>=0;L--){c=!1;let b=R.slice(L,L+T).join(v);for(let x=0;!c&&x<r.length;x++)if(x!==w&&r[x]&&r[x].indexOf(b)>-1){const $=L+T===R.length,B=L>0&&r[x].indexOf(v)>-1?v+b:b,G=r[x].endsWith(B);c=!$||G}if(!c){let x="";(R[0].endsWith(":")||S!=="")&&(L===1&&(L=0,T++,b=R[0]+v+b),L>0&&(x=R[0]+v),x=S+x),L>0&&(x=x+u+v),x=x+b,L+T<R.length&&(x=x+v+u),l[w]=x}}c&&(l[w]=f)}return l}e.shorten=E;var o;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function h(r,v=Object.create(null)){const l=[];let c=!1,w="";for(const f of r)if(f==="$"||c&&f==="{")w&&l.push({value:w,type:o.TEXT}),w="",c=!0;else if(f==="}"&&c){const S=v[w];if(typeof S=="string")S.length&&l.push({value:S,type:o.VARIABLE});else if(S){const R=l[l.length-1];(!R||R.type!==o.SEPARATOR)&&l.push({value:S.label,type:o.SEPARATOR})}w="",c=!1}else w+=f;return w&&!c&&l.push({value:w,type:o.TEXT}),l.filter((f,S)=>{if(f.type===o.SEPARATOR){const R=l[S-1],T=l[S+1];return[R,T].every(L=>L&&(L.type===o.VARIABLE||L.type===o.TEXT)&&L.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=h;function C(r,v){return A.isMacintosh||v?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):r.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=C;function i(r,v){return A.isMacintosh||v?r.replace(/\(&&\w\)|&&/g,""):A.isWindows?r.replace(/&&|&/g,l=>l==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function p(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=p;function a(r){const v=r.indexOf("/")!==-1?_.posix:_.win32,l=v.basename(r),c=v.dirname(r);return l.length?{name:l,parentPath:c}:{name:c,parentPath:""}}e.splitName=a}),define(be[79],Ee([0,1,27,11,17,24,9]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown",r.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let D=[],P=[],t=[];function y(r,v=!1){const l=n(r);D.push(l),l.userConfigured?t.push(l):P.push(l),v&&!l.userConfigured&&D.forEach(c=>{c.mime===l.mime||c.userConfigured||(l.extension&&c.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&c.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&c.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&c.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=y;function n(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?(0,d.parse)(r.filepattern.toLowerCase()):void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(_.posix.sep)>=0:!1}}function m(r){r?(D=D.filter(v=>!v.userConfigured),t=[]):(D=[],P=[],t=[])}e.clearTextMimes=m;function s(r,v){let l;if(r)switch(r.scheme){case M.Schemas.file:l=r.fsPath;break;case M.Schemas.data:l=A.DataUri.parseMetaData(r).get(A.DataUri.META_DATA_LABEL);break;default:l=r.path}if(!l)return[k.unknown];l=l.toLowerCase();const c=(0,_.basename)(l),w=u(l,c,t);if(w)return[w,k.text];const f=u(l,c,P);if(f)return[f,k.text];if(v){const S=g(v);if(S)return[S,k.text]}return[k.unknown]}e.guessMimeTypes=s;function u(r,v,l){let c=null,w=null,f=null;for(let S=l.length-1;S>=0;S--){const R=l[S];if(v===R.filenameLowercase){c=R;break}if(R.filepattern&&(!w||R.filepattern.length>w.filepattern.length)){const T=R.filepatternOnPath?r:v;R.filepatternLowercase?.(T)&&(w=R)}R.extension&&(!f||R.extension.length>f.extension.length)&&v.endsWith(R.extensionLowercase)&&(f=R)}return c?c.mime:w?w.mime:f?f.mime:null}function g(r){if((0,F.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let v=D.length-1;v>=0;v--){const l=D[v];if(!l.firstline)continue;const c=r.match(l.firstline);if(c&&c.length>0)return l.mime}return null}function I(r){return r?typeof r=="string"?r===k.binary||r===k.text||r===k.unknown:r.length===1&&I(r[0]):!0}e.isUnspecific=I;const E={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function h(r){const v=(0,_.extname)(r),l=E[v.toLowerCase()];return l!==void 0?l:C(r)}e.getMediaOrTextMime=h;function C(r){const v=(0,_.extname)(r);return o[v.toLowerCase()]}e.getMediaMime=C;function i(r){for(const v in o)if(o[v]===r)return v}e.getExtensionForMimeType=i;const p=/^(.+)\/(.+?)(;.+)?$/;function a(r,v){const l=p.exec(r);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:v?void 0:r}e.normalizeMimeType=a}),define(be[109],Ee([0,1,2]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class _{constructor(y){this._uriTransformer=y}transformIncoming(y){const n=this._uriTransformer.transformIncoming(y);return n===y?y:M(d.URI.from(n))}transformOutgoing(y){const n=this._uriTransformer.transformOutgoing(y);return n===y?y:M(d.URI.from(n))}transformOutgoingURI(y){const n=this._uriTransformer.transformOutgoing(y);return n===y?y:d.URI.from(n)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function A(t,y,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof d.URI)return y.transformOutgoing(t);for(let m in t)if(Object.hasOwnProperty.call(t,m)){const s=A(t[m],y,n+1);s!==null&&(t[m]=s)}}return null}function F(t,y){const n=A(t,y,0);return n===null?t:n}e.transformOutgoingURIs=F;function k(t,y,n,m){if(!t||m>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?d.URI.revive(y.transformIncoming(t)):y.transformIncoming(t);for(let s in t)if(Object.hasOwnProperty.call(t,s)){const u=k(t[s],y,n,m+1);u!==null&&(t[s]=u)}}return null}function D(t,y){const n=k(t,y,!1,0);return n===null?t:n}e.transformIncomingURIs=D;function P(t,y){const n=k(t,y,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=P}),define(be[36],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(D){return d.test(D)}e.isUUID=M;const _=new Uint8Array(16),A=[];for(let D=0;D<256;D++)A.push(D.toString(16).padStart(2,"0"));let F;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?F=crypto.getRandomValues.bind(crypto):F=function(D){for(let P=0;P<D.length;P++)D[P]=Math.floor(Math.random()*256);return D};function k(){F(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let D=0,P="";return P+=A[_[D++]],P+=A[_[D++]],P+=A[_[D++]],P+=A[_[D++]],P+="-",P+=A[_[D++]],P+=A[_[D++]],P+="-",P+=A[_[D++]],P+=A[_[D++]],P+="-",P+=A[_[D++]],P+=A[_[D++]],P+="-",P+=A[_[D++]],P+=A[_[D++]],P+=A[_[D++]],P+=A[_[D++]],P+=A[_[D++]],P+=A[_[D++]],P}e.generateUuid=k}),define(be[110],Ee([0,1,227]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(F){F[F.Regular=0]="Regular",F[F.Whitespace=1]="Whitespace",F[F.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class _ extends d.CharacterClassifier{constructor(k){super(0);for(let D=0,P=k.length;D<P;D++)this.set(k.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=_;function A(F){let k={};return D=>(k.hasOwnProperty(D)||(k[D]=F(D)),k[D])}e.getMapForWordSeparators=A(F=>new _(F))}),define(be[80],Ee([0,1,23]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(E){E[E.Left=1]="Left",E[E.Center=2]="Center",E[E.Right=4]="Right",E[E.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var _;(function(E){E[E.Inline=1]="Inline",E[E.Gutter=2]="Gutter"})(_=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(E){E[E.TextDefined=0]="TextDefined",E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var F;(function(E){E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(F=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(E){E[E.LF=0]="LF",E[E.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace),this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,d.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class P{constructor(o,h){this._findMatchBrand=void 0,this.range=o,this.matches=h}}e.FindMatch=P;var t;(function(E){E[E.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",E[E.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",E[E.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",E[E.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var y;(function(E){E[E.Disabled=0]="Disabled",E[E.EnabledForActive=1]="EnabledForActive",E[E.Enabled=2]="Enabled"})(y=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class n{constructor(o,h,C){this.visibleColumn=o,this.className=h,this.horizontalLine=C}}e.IndentGuide=n;class m{constructor(o,h){this.top=o,this.endColumn=h}}e.IndentGuideHorizontalLine=m;var s;(function(E){E[E.Left=0]="Left",E[E.Right=1]="Right",E[E.None=2]="None"})(s=e.PositionAffinity||(e.PositionAffinity={}));var u;(function(E){E[E.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u=e.ModelConstants||(e.ModelConstants={}));class g{constructor(o,h,C,i,p,a){this.identifier=o,this.range=h,this.text=C,this.forceMoveMarkers=i,this.isAutoWhitespaceEdit=p,this._isTracked=a}}e.ValidAnnotatedEditOperation=g;class I{constructor(o,h,C){this.reverseEdits=o,this.changes=h,this.trimAutoWhitespaceLineNumbers=C}}e.ApplyEditsResult=I}),define(be[111],Ee([0,1,9,110,112,44,80]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class D{constructor(o,h,C,i){this.searchString=o,this.isRegex=h,this.matchCase=C,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=P(this.searchString):o=this.searchString.indexOf(`
`)>=0;let h=null;try{h=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(i){return null}if(!h)return null;let C=!this.isRegex&&!o;return C&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(C=this.matchCase),new t(h,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,C?this.searchString:null)}}e.SearchParams=D;function P(E){if(!E||E.length===0)return!1;for(let o=0,h=E.length;o<h;o++)if(E.charCodeAt(o)===92){if(o++,o>=h)break;const i=E.charCodeAt(o);if(i===110||i===114||i===87)return!0}return!1}e.isMultilineRegexSource=P;class t{constructor(o,h,C){this.regex=o,this.wordSeparators=h,this.simpleSearch=C}}e.SearchData=t;function y(E,o,h){if(!h)return new F.FindMatch(E,null);let C=[];for(let i=0,p=o.length;i<p;i++)C[i]=o[i];return new F.FindMatch(E,C)}e.createFindMatch=y;class n{constructor(o){let h=[],C=0;for(let i=0,p=o.length;i<p;i++)o.charCodeAt(i)===10&&(h[C++]=i);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(o){const h=this._lineFeedsOffsets;let C=0,i=h.length-1;if(i===-1||o<=h[0])return 0;for(;C<i;){const p=C+((i-C)/2>>0);h[p]>=o?i=p-1:h[p+1]>=o?(C=p,i=p):C=p+1}return C+1}}class m{static findMatches(o,h,C,i,p){const a=h.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(o,C,new I(a.wordSeparators,a.regex),i,p):this._doFindMatchesLineByLine(o,C,a,i,p):[]}static _getMultilineMatchRange(o,h,C,i,p,a){let r,v=0;i?(v=i.findLineFeedCountBeforeOffset(p),r=h+p+v):r=h+p;let l;if(i){let S=i.findLineFeedCountBeforeOffset(p+a.length)-v;l=r+a.length+S}else l=r+a.length;const c=o.getPositionAt(r),w=o.getPositionAt(l);return new A.Range(c.lineNumber,c.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(o,h,C,i,p){const a=o.getOffsetAt(h.getStartPosition()),r=o.getValueInRange(h,1),v=o.getEOL()===`\r
`?new n(r):null,l=[];let c=0,w;for(C.reset(0);w=C.next(r);)if(l[c++]=y(this._getMultilineMatchRange(o,a,r,v,w.index,w[0]),w,i),c>=p)return l;return l}static _doFindMatchesLineByLine(o,h,C,i,p){const a=[];let r=0;if(h.startLineNumber===h.endLineNumber){const l=o.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return r=this._findMatchesInLine(C,l,h.startLineNumber,h.startColumn-1,r,a,i,p),a}const v=o.getLineContent(h.startLineNumber).substring(h.startColumn-1);r=this._findMatchesInLine(C,v,h.startLineNumber,h.startColumn-1,r,a,i,p);for(let l=h.startLineNumber+1;l<h.endLineNumber&&r<p;l++)r=this._findMatchesInLine(C,o.getLineContent(l),l,0,r,a,i,p);if(r<p){const l=o.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);r=this._findMatchesInLine(C,l,h.endLineNumber,0,r,a,i,p)}return a}static _findMatchesInLine(o,h,C,i,p,a,r,v){const l=o.wordSeparators;if(!r&&o.simpleSearch){const f=o.simpleSearch,S=f.length,R=h.length;let T=-S;for(;(T=h.indexOf(f,T+S))!==-1;)if((!l||g(l,h,R,T,S))&&(a[p++]=new F.FindMatch(new A.Range(C,T+1+i,C,T+1+S+i),null),p>=v))return p;return p}const c=new I(o.wordSeparators,o.regex);let w;c.reset(0);do if(w=c.next(h),w&&(a[p++]=y(new A.Range(C,w.index+1+i,C,w.index+1+w[0].length+i),w,r),p>=v))return p;while(w);return p}static findNextMatch(o,h,C,i){const p=h.parseSearchRequest();if(!p)return null;const a=new I(p.wordSeparators,p.regex);return p.regex.multiline?this._doFindNextMatchMultiline(o,C,a,i):this._doFindNextMatchLineByLine(o,C,a,i)}static _doFindNextMatchMultiline(o,h,C,i){const p=new _.Position(h.lineNumber,1),a=o.getOffsetAt(p),r=o.getLineCount(),v=o.getValueInRange(new A.Range(p.lineNumber,p.column,r,o.getLineMaxColumn(r)),1),l=o.getEOL()===`\r
`?new n(v):null;C.reset(h.column-1);let c=C.next(v);return c?y(this._getMultilineMatchRange(o,a,v,l,c.index,c[0]),c,i):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(o,new _.Position(1,1),C,i):null}static _doFindNextMatchLineByLine(o,h,C,i){const p=o.getLineCount(),a=h.lineNumber,r=o.getLineContent(a),v=this._findFirstMatchInLine(C,r,a,h.column,i);if(v)return v;for(let l=1;l<=p;l++){const c=(a+l-1)%p,w=o.getLineContent(c+1),f=this._findFirstMatchInLine(C,w,c+1,1,i);if(f)return f}return null}static _findFirstMatchInLine(o,h,C,i,p){o.reset(i-1);const a=o.next(h);return a?y(new A.Range(C,a.index+1,C,a.index+1+a[0].length),a,p):null}static findPreviousMatch(o,h,C,i){const p=h.parseSearchRequest();if(!p)return null;const a=new I(p.wordSeparators,p.regex);return p.regex.multiline?this._doFindPreviousMatchMultiline(o,C,a,i):this._doFindPreviousMatchLineByLine(o,C,a,i)}static _doFindPreviousMatchMultiline(o,h,C,i){const p=this._doFindMatchesMultiline(o,new A.Range(1,1,h.lineNumber,h.column),C,i,10*k);if(p.length>0)return p[p.length-1];const a=o.getLineCount();return h.lineNumber!==a||h.column!==o.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(o,new _.Position(a,o.getLineMaxColumn(a)),C,i):null}static _doFindPreviousMatchLineByLine(o,h,C,i){const p=o.getLineCount(),a=h.lineNumber,r=o.getLineContent(a).substring(0,h.column-1),v=this._findLastMatchInLine(C,r,a,i);if(v)return v;for(let l=1;l<=p;l++){const c=(p+a-l-1)%p,w=o.getLineContent(c+1),f=this._findLastMatchInLine(C,w,c+1,i);if(f)return f}return null}static _findLastMatchInLine(o,h,C,i){let p=null,a;for(o.reset(0);a=o.next(h);)p=y(new A.Range(C,a.index+1,C,a.index+1+a[0].length),a,i);return p}}e.TextModelSearch=m;function s(E,o,h,C,i){if(C===0)return!0;const p=o.charCodeAt(C-1);if(E.get(p)!==0||p===13||p===10)return!0;if(i>0){const a=o.charCodeAt(C);if(E.get(a)!==0)return!0}return!1}function u(E,o,h,C,i){if(C+i===h)return!0;const p=o.charCodeAt(C+i);if(E.get(p)!==0||p===13||p===10)return!0;if(i>0){const a=o.charCodeAt(C+i-1);if(E.get(a)!==0)return!0}return!1}function g(E,o,h,C,i){return s(E,o,h,C,i)&&u(E,o,h,C,i)}e.isValidMatch=g;class I{constructor(o,h){this._wordSeparators=o,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const h=o.length;let C;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(C=this._searchRegex.exec(o),!C))return null;const i=C.index,p=C[0].length;if(i===this._prevMatchStartIndex&&p===this._prevMatchLength){if(p===0){d.getNextCodePoint(o,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=p,!this._wordSeparators||g(this._wordSeparators,o,h,i,p))return C}while(C);return null}}e.Searcher=I}),define(be[113],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class M{constructor(k){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let D=0,P=k.notIn.length;D<P;D++)switch(k.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=M;class _{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of k)A(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),A(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),A(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),A(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&A(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=_;function A(F,k,D){F.has(k)?F.get(k).push(D):F.set(k,[D])}}),define(be[56],Ee([0,1,27,17]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function _(A,F,k,D){if(Array.isArray(A)){let P=0;for(const t of A){const y=_(t,F,k,D);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof A=="string")return D?A==="*"?5:A===k?10:0:0;if(A){const{language:P,pattern:t,scheme:y,hasAccessToAllModels:n}=A;if(!D&&!n)return 0;let m=0;if(y)if(y===F.scheme)m=10;else if(y==="*")m=5;else return 0;if(P)if(P===k)m=10;else if(P==="*")m=Math.max(m,5);else return 0;if(t){let s;if(typeof t=="string"?s=t:s={...t,base:(0,M.normalize)(t.base)},s===F.fsPath||(0,d.match)(s,F.fsPath))m=10;else return 0}return m}else return 0}}e.score=_}),define(be[114],Ee([0,1,3,6]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class _{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(F){this._onDidChange.fire({changedLanguages:F,changedColorMap:!1})}register(F,k){return this._map.set(F,k),this.fire([F]),(0,M.toDisposable)(()=>{this._map.get(F)===k&&(this._map.delete(F),this.fire([F]))})}registerPromise(F,k){let D=null,P=!1;return this._promises.set(F,k.then(t=>{this._promises.delete(F),!(P||!t)&&(D=this.register(F,t))})),(0,M.toDisposable)(()=>{P=!0,D&&D.dispose()})}getPromise(F){const k=this.get(F);if(k)return Promise.resolve(k);const D=this._promises.get(F);return D?D.then(P=>this.get(F)):null}get(F){return this._map.get(F)||null}setColorMap(F){this._colorMap=F,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=_}),define(be[81],Ee([0,1,22,25]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var _;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(_||(_={}));function A(y){for(let n=0,m=y.length;n<m;n+=4){const s=y[n+0],u=y[n+1],g=y[n+2],I=y[n+3];y[n+0]=I,y[n+1]=g,y[n+2]=u,y[n+3]=s}}function F(y){const n=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return M.isLittleEndian()||A(n),d.VSBuffer.wrap(n)}function k(y){const n=y.buffer;if(M.isLittleEndian()||A(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const m=new Uint8Array(n.byteLength);return m.set(n),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function D(y){const n=new Uint32Array(P(y));let m=0;if(n[m++]=y.id,y.type==="full")n[m++]=1,n[m++]=y.data.length,n.set(y.data,m),m+=y.data.length;else{n[m++]=2,n[m++]=y.deltas.length;for(const s of y.deltas)n[m++]=s.start,n[m++]=s.deleteCount,s.data?(n[m++]=s.data.length,n.set(s.data,m),m+=s.data.length):n[m++]=0}return F(n)}e.encodeSemanticTokensDto=D;function P(y){let n=0;if(n+=1+1,y.type==="full")n+=1+y.data.length;else{n+=1,n+=(1+1+1)*y.deltas.length;for(const m of y.deltas)m.data&&(n+=m.data.length)}return n}function t(y){const n=k(y);let m=0;const s=n[m++];if(n[m++]===1){const E=n[m++],o=n.subarray(m,m+E);return m+=E,{id:s,type:"full",data:o}}const g=n[m++];let I=[];for(let E=0;E<g;E++){const o=n[m++],h=n[m++],C=n[m++];let i;C>0&&(i=n.subarray(m,m+C),m+=C),I[E]={start:o,deleteCount:h,data:i}}return{id:s,type:"delta",deltas:I}}e.decodeSemanticTokensDto=t}),define(be[115],Ee([18,19]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(be[45],Ee([0,1,14,10,115]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(P,t){return t&&(P.stack||P.stacktrace)?_.localize(0,null,k(P),F(P.stack)||F(P.stacktrace)):k(P)}function F(P){return Array.isArray(P)?P.join(`
`):P}function k(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?_.localize(1,null,P.message):P.message||_.localize(2,null)}function D(P=null,t=!1){if(!P)return _.localize(3,null);if(Array.isArray(P)){const y=d.coalesce(P),n=D(y[0],t);return y.length>1?_.localize(4,null,n,y.length):n}if(M.isString(P))return P;if(P.detail){const y=P.detail;if(y.error)return A(y.error,t);if(y.exception)return A(y.exception,t)}return P.stack?A(P,t):P.message?P.message:_.localize(5,null)}e.toErrorMessage=D}),define(be[116],Ee([18,19]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(be[117],Ee([0,1,116,25,118]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(q){q[q.None=0]="None",q[q.Keep=1]="Keep",q[q.Brackets=2]="Brackets",q[q.Advanced=3]="Advanced",q[q.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=F;class k{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,pe){this._values[Z]=pe}}e.ValidatedEditorOptions=k;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class P{constructor(Z,pe,We,Ye){this.id=Z,this.name=pe,this.defaultValue=We,this.schema=Ye}compute(Z,pe,We){return We}}class t{constructor(Z,pe=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(Z){return this.defaultValue}}class y{constructor(Z,pe,We,Ye){this.id=Z,this.name=pe,this.defaultValue=We,this.schema=Ye}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,pe,We){return We}}function n(q,Z){return typeof q=="undefined"?Z:q==="false"?!1:Boolean(q)}e.boolean=n;class m extends y{constructor(Z,pe,We,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=We),super(Z,pe,We,Ye)}validate(Z){return n(Z,this.defaultValue)}}function s(q,Z,pe,We){if(typeof q=="undefined")return Z;let Ye=parseInt(q,10);return isNaN(Ye)?Z:(Ye=Math.max(pe,Ye),Ye=Math.min(We,Ye),Ye|0)}e.clampedInt=s;class u extends y{constructor(Z,pe,We,Ye,rt,mt=void 0){typeof mt!="undefined"&&(mt.type="integer",mt.default=We,mt.minimum=Ye,mt.maximum=rt),super(Z,pe,We,mt),this.minimum=Ye,this.maximum=rt}static clampedInt(Z,pe,We,Ye){return s(Z,pe,We,Ye)}validate(Z){return u.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class g extends y{constructor(Z,pe,We,Ye,rt){typeof rt!="undefined"&&(rt.type="number",rt.default=We),super(Z,pe,We,rt),this.validationFn=Ye}static clamp(Z,pe,We){return Z<pe?pe:Z>We?We:Z}static float(Z,pe){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return pe;const We=parseFloat(Z);return isNaN(We)?pe:We}validate(Z){return this.validationFn(g.float(Z,this.defaultValue))}}class I extends y{static string(Z,pe){return typeof Z!="string"?pe:Z}constructor(Z,pe,We,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=We),super(Z,pe,We,Ye)}validate(Z){return I.string(Z,this.defaultValue)}}function E(q,Z,pe){return typeof q!="string"||pe.indexOf(q)===-1?Z:q}e.stringSet=E;class o extends y{constructor(Z,pe,We,Ye,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=Ye,rt.default=We),super(Z,pe,We,rt),this._allowedValues=Ye}validate(Z){return E(Z,this.defaultValue,this._allowedValues)}}class h extends P{constructor(Z,pe,We,Ye,rt,mt,ut=void 0){typeof ut!="undefined"&&(ut.type="string",ut.enum=rt,ut.default=Ye),super(Z,pe,We,ut),this._allowedValues=rt,this._convert=mt}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function C(q){switch(q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,pe,We){return We===0?Z.accessibilitySupport:We}}class p extends P{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:d.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertSpace:n(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(q){q[q.Hidden=0]="Hidden",q[q.Blink=1]="Blink",q[q.Smooth=2]="Smooth",q[q.Phase=3]="Phase",q[q.Expand=4]="Expand",q[q.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(q){switch(q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(q){q[q.Line=1]="Line",q[q.Block=2]="Block",q[q.Underline=3]="Underline",q[q.LineThin=4]="LineThin",q[q.BlockOutline=5]="BlockOutline",q[q.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(q){switch(q){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function c(q){switch(q){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class w extends t{constructor(){super(126,[65,33])}compute(Z,pe,We){const Ye=["monaco-editor"];return pe.get(33)&&Ye.push(pe.get(33)),Z.extraEditorClassName&&Ye.push(Z.extraEditorClassName),pe.get(65)==="default"?Ye.push("mouse-default"):pe.get(65)==="copy"&&Ye.push("mouse-copy"),pe.get(99)&&Ye.push("showUnused"),pe.get(124)&&Ye.push("showDeprecated"),Ye.join(" ")}}class f extends m{constructor(){super(32,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(Z,pe,We){return We&&Z.emptySelectionClipboard}}class S extends P{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:d.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:d.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{cursorMoveOnType:n(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":E(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":E(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(pe.loop,this.defaultValue.loop)}}}class R extends P{constructor(){super(44,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?R.OFF:Z==="true"?R.ON:Z:Boolean(Z)?R.ON:R.OFF}}e.EditorFontLigatures=R,R.OFF='"liga" off, "calt" off',R.ON='"liga" on, "calt" on';class T extends t{constructor(){super(43)}compute(Z,pe,We){return Z.fontInfo}}class L extends y{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(Z){let pe=g.float(Z,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(pe,6,100)}compute(Z,pe,We){return Z.fontInfo.fontSize}}class b extends P{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:b.MINIMUM_VALUE,maximum:b.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:b.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(u.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,b.MINIMUM_VALUE,b.MAXIMUM_VALUE))}}b.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],b.MINIMUM_VALUE=1,b.MAXIMUM_VALUE=1e3;class x extends P{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:We,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:We,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:We,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:We,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:We,description:d.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{multiple:E(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??E(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??E(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??E(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??E(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??E(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:I.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:I.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:I.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:I.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:I.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends P{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(52,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:d.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),delay:u.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:n(pe.sticky,this.defaultValue.sticky)}}}var B;(function(q){q[q.None=0]="None",q[q.Text=1]="Text",q[q.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class G extends t{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(Z,pe,We){return G.computeLayout(pe,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const pe=Z.height/Z.lineHeight,We=Z.scrollBeyondLastLine?pe-1:0,Ye=(Z.viewLineCount+We)/(Z.pixelRatio*Z.height),rt=Math.floor(Z.viewLineCount/Ye);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:We,desiredRatio:Ye,minimapLineCount:rt}}static _computeMinimapLayout(Z,pe){const We=Z.outerWidth,Ye=Z.outerHeight,rt=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const mt=pe.stableMinimapLayoutInput,ut=mt&&Z.outerHeight===mt.outerHeight&&Z.lineHeight===mt.lineHeight&&Z.typicalHalfwidthCharacterWidth===mt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===mt.pixelRatio&&Z.scrollBeyondLastLine===mt.scrollBeyondLastLine&&Z.minimap.enabled===mt.minimap.enabled&&Z.minimap.side===mt.minimap.side&&Z.minimap.size===mt.minimap.size&&Z.minimap.showSlider===mt.minimap.showSlider&&Z.minimap.renderCharacters===mt.minimap.renderCharacters&&Z.minimap.maxColumn===mt.minimap.maxColumn&&Z.minimap.scale===mt.minimap.scale&&Z.verticalScrollbarWidth===mt.verticalScrollbarWidth&&Z.isViewportWrapping===mt.isViewportWrapping,St=Z.lineHeight,Tt=Z.typicalHalfwidthCharacterWidth,It=Z.scrollBeyondLastLine,Xe=Z.minimap.renderCharacters;let vt=rt>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Pe=Z.minimap.maxColumn,Se=Z.minimap.size,Ce=Z.minimap.side,te=Z.verticalScrollbarWidth,ue=Z.viewLineCount,me=Z.remainingWidth,fe=Z.isViewportWrapping,Ie=Xe?2:3;let Be=Math.floor(rt*Ye);const Ne=Be/rt;let qe=!1,it=!1,Le=Ie*vt,de=vt/rt,ge=1;if(Se==="fill"||Se==="fit"){const{typicalViewportLineCount:ct,extraLinesBeyondLastLine:pt,desiredRatio:dt,minimapLineCount:ht}=G.computeContainedMinimapLineCount({viewLineCount:ue,scrollBeyondLastLine:It,height:Ye,lineHeight:St,pixelRatio:rt});if(ue/ht>1)qe=!0,it=!0,vt=1,Le=1,de=vt/rt;else{let _t=!1,yt=vt+1;if(Se==="fit"){const Pt=Math.ceil((ue+pt)*Le);fe&&ut&&me<=pe.stableFitRemainingWidth?(_t=!0,yt=pe.stableFitMaxMinimapScale):_t=Pt>Be}if(Se==="fill"||_t){qe=!0;const Pt=vt;Le=Math.min(St*rt,Math.max(1,Math.floor(1/dt))),fe&&ut&&me<=pe.stableFitRemainingWidth&&(yt=pe.stableFitMaxMinimapScale),vt=Math.min(yt,Math.max(1,Math.floor(Le/Ie))),vt>Pt&&(ge=Math.min(2,vt/Pt)),de=vt/rt/ge,Be=Math.ceil(Math.max(ct,ue+pt)*Le),fe?(pe.stableMinimapLayoutInput=Z,pe.stableFitRemainingWidth=me,pe.stableFitMaxMinimapScale=vt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const X=Math.floor(Pe*de),z=Math.min(X,Math.max(0,Math.floor((me-te-2)*de/(Tt+de)))+e.MINIMAP_GUTTER_WIDTH);let we=Math.floor(rt*z);const ke=we/rt;we=Math.floor(we*ge);const Je=Xe?1:2,xe=Ce==="left"?0:We-z-te;return{renderMinimap:Je,minimapLeft:xe,minimapWidth:z,minimapHeightIsEditorHeight:qe,minimapIsSampling:it,minimapScale:vt,minimapLineHeight:Le,minimapCanvasInnerWidth:we,minimapCanvasInnerHeight:Be,minimapCanvasOuterWidth:ke,minimapCanvasOuterHeight:Ne}}static computeLayout(Z,pe){const We=pe.outerWidth|0,Ye=pe.outerHeight|0,rt=pe.lineHeight|0,mt=pe.lineNumbersDigitCount|0,ut=pe.typicalHalfwidthCharacterWidth,St=pe.maxDigitWidth,Tt=pe.pixelRatio,It=pe.viewLineCount,Xe=Z.get(121),vt=Xe==="inherit"?Z.get(120):Xe,Pe=vt==="inherit"?Z.get(116):vt,Se=Z.get(119),Ce=Z.get(2),te=pe.isDominatedByLongLines,ue=Z.get(49),me=Z.get(59).renderType!==0,fe=Z.get(60),Ie=Z.get(93),Be=Z.get(64),Ne=Z.get(91),qe=Ne.verticalScrollbarSize,it=Ne.verticalHasArrows,Le=Ne.arrowSize,de=Ne.horizontalScrollbarSize,ge=Z.get(57),X=Z.get(37);let z;if(typeof ge=="string"&&/^\d+(\.\d+)?ch$/.test(ge)){const xt=parseFloat(ge.substr(0,ge.length-2));z=u.clampedInt(xt*ut,0,0,1e3)}else z=u.clampedInt(ge,0,0,1e3);X&&(z+=16);let we=0;if(me){const xt=Math.max(mt,fe);we=Math.round(xt*St)}let ke=0;ue&&(ke=rt);let Je=0,xe=Je+ke,ct=xe+we,pt=ct+z;const dt=We-ke-we-z;let ht=!1,ft=!1,_t=-1;Ce!==2&&(vt==="inherit"&&te?(ht=!0,ft=!0):Pe==="on"||Pe==="bounded"?ft=!0:Pe==="wordWrapColumn"&&(_t=Se));const yt=G._computeMinimapLayout({outerWidth:We,outerHeight:Ye,lineHeight:rt,typicalHalfwidthCharacterWidth:ut,pixelRatio:Tt,scrollBeyondLastLine:Ie,minimap:Be,verticalScrollbarWidth:qe,viewLineCount:It,remainingWidth:dt,isViewportWrapping:ft},pe.memory||new D);yt.renderMinimap!==0&&yt.minimapLeft===0&&(Je+=yt.minimapWidth,xe+=yt.minimapWidth,ct+=yt.minimapWidth,pt+=yt.minimapWidth);const Pt=dt-yt.minimapWidth,Nt=Math.max(1,Math.floor((Pt-qe-2)/ut)),Ct=it?Le:0;return ft&&(_t=Math.max(1,Nt),Pe==="bounded"&&(_t=Math.min(_t,Se))),{width:We,height:Ye,glyphMarginLeft:Je,glyphMarginWidth:ke,lineNumbersLeft:xe,lineNumbersWidth:we,decorationsLeft:ct,decorationsWidth:z,contentLeft:pt,contentWidth:Pt,minimap:yt,viewportColumn:Nt,isWordWrapMinified:ht,isViewportWrapping:ft,wrappingColumn:_t,verticalScrollbarWidth:qe,horizontalScrollbarHeight:de,overviewRuler:{top:Ct,width:qe,height:Ye-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=G;class H extends P{constructor(){const Z={enabled:!0};super(56,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:d.localize(42,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:n(Z.enabled,this.defaultValue.enabled)}}}class W extends P{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"boolean",default:Z.enabled,description:d.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:d.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:d.localize(45,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:I.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class ne extends g{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>g.clamp(Z,0,150),{markdownDescription:d.localize(46,null)})}compute(Z,pe,We){return Z.fontInfo.lineHeight}}class V extends P{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:d.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(48,null),d.localize(49,null),d.localize(50,null)],default:Z.size,description:d.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:d.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:d.localize(53,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:d.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:d.localize(56,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),size:E(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:E(pe.side,this.defaultValue.side,["right","left"]),showSlider:E(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(pe.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(pe.scale,1,1,3),maxColumn:u.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(q){return q==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends P{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(58,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{top:u.clampedInt(pe.top,0,0,1e3),bottom:u.clampedInt(pe.bottom,0,0,1e3)}}}class le extends P{constructor(){const Z={enabled:!0,cycle:!1};super(75,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:d.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:d.localize(60,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),cycle:n(pe.cycle,this.defaultValue.cycle)}}}class re extends t{constructor(){super(127)}compute(Z,pe,We){return Z.pixelRatio}}class ve extends P{constructor(){const Z={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:d.localize(61,null)},comments:{type:"boolean",default:Z.comments,description:d.localize(62,null)},other:{type:"boolean",default:Z.other,description:d.localize(63,null)}}}],default:Z,description:d.localize(64,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const pe=Z,We={other:n(pe.other,this.defaultValue.other),comments:n(pe.comments,this.defaultValue.comments),strings:n(pe.strings,this.defaultValue.strings)};return We.other&&We.comments&&We.strings?!0:!We.other&&!We.comments&&!We.strings?!1:We}return this.defaultValue}}var Fe;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval",q[q.Custom=4]="Custom"})(Fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Me extends P{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(65,null),d.localize(66,null),d.localize(67,null),d.localize(68,null)],default:"on",description:d.localize(69,null)})}validate(Z){let pe=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(pe=4,We=Z):Z==="interval"?pe=3:Z==="relative"?pe=2:Z==="on"?pe=1:pe=0),{renderType:pe,renderFn:We}}}function Oe(q){const Z=q.get(86);return Z==="editable"?q.get(80):Z!=="on"}e.filterValidationDecorations=Oe;class Ke extends P{constructor(){const Z=[],pe={type:"number",description:d.localize(70,null)};super(90,"rulers",Z,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:d.localize(71,null),format:"color-hex"}}}]},default:Z,description:d.localize(72,null)})}validate(Z){if(Array.isArray(Z)){let pe=[];for(let We of Z)if(typeof We=="number")pe.push({column:u.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const Ye=We;pe.push({column:u.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return pe.sort((We,Ye)=>We.column-Ye.column),pe}return this.defaultValue}}function je(q,Z){if(typeof q!="string")return Z;switch(q){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ve extends P{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(73,null),d.localize(74,null),d.localize(75,null)],default:"auto",description:d.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(77,null),d.localize(78,null),d.localize(79,null)],default:"auto",description:d.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:d.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:d.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:d.localize(83,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z,We=u.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=u.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(pe.vertical,this.defaultValue.vertical),horizontal:je(pe.horizontal,this.defaultValue.horizontal),useShadows:n(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:u.clampedInt(pe.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:u.clampedInt(pe.verticalSliderSize,Ye,0,1e3),scrollByPage:n(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class U extends P{constructor(){const Z={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:d.localize(84,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:n(pe.enabled,this.defaultValue.enabled),mode:E(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Q extends P{constructor(){const Z={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,description:d.localize(85,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:n(Z.enabled,this.defaultValue.enabled)}}}class ee extends P{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],default:Z.bracketPairs,description:d.localize(86,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],default:Z.bracketPairsHorizontal,description:d.localize(87,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:d.localize(88,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:d.localize(89,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Z.highlightActiveIndentation,description:d.localize(90,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{bracketPairs:ae(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ae(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:n(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ae(q,Z,pe){const We=pe.indexOf(q);return We===-1?Z:pe[We]}class K extends P{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(91,null),d.localize(92,null)],default:Z.insertMode,description:d.localize(93,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:d.localize(94,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:d.localize(95,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:d.localize(96,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:d.localize(97,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:d.localize(98,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:d.localize(99,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:d.localize(100,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:d.localize(101,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(102,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(103,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(104,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(105,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(106,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(107,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(108,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(109,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(110,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(111,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(112,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(113,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(114,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(115,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(116,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(117,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(118,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(119,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(120,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(121,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(122,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(123,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(124,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(125,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(126,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(127,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(128,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(129,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(130,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(131,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertMode:E(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(pe.showIcons,this.defaultValue.showIcons),showStatusBar:n(pe.showStatusBar,this.defaultValue.showStatusBar),preview:n(pe.preview,this.defaultValue.preview),previewMode:E(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(pe.showMethods,this.defaultValue.showMethods),showFunctions:n(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:n(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:n(pe.showFields,this.defaultValue.showFields),showVariables:n(pe.showVariables,this.defaultValue.showVariables),showClasses:n(pe.showClasses,this.defaultValue.showClasses),showStructs:n(pe.showStructs,this.defaultValue.showStructs),showInterfaces:n(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:n(pe.showModules,this.defaultValue.showModules),showProperties:n(pe.showProperties,this.defaultValue.showProperties),showEvents:n(pe.showEvents,this.defaultValue.showEvents),showOperators:n(pe.showOperators,this.defaultValue.showOperators),showUnits:n(pe.showUnits,this.defaultValue.showUnits),showValues:n(pe.showValues,this.defaultValue.showValues),showConstants:n(pe.showConstants,this.defaultValue.showConstants),showEnums:n(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:n(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(pe.showKeywords,this.defaultValue.showKeywords),showWords:n(pe.showWords,this.defaultValue.showWords),showColors:n(pe.showColors,this.defaultValue.showColors),showFiles:n(pe.showFiles,this.defaultValue.showFiles),showReferences:n(pe.showReferences,this.defaultValue.showReferences),showFolders:n(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:n(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(pe.showSnippets,this.defaultValue.showSnippets),showUsers:n(pe.showUsers,this.defaultValue.showUsers),showIssues:n(pe.showIssues,this.defaultValue.showIssues)}}}class se extends P{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(133,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class he extends t{constructor(){super(128,[80])}compute(Z,pe,We){return pe.get(80)?!0:Z.tabFocusMode}}var Ae;(function(q){q[q.None=0]="None",q[q.Same=1]="Same",q[q.Indent=2]="Indent",q[q.DeepIndent=3]="DeepIndent"})(Ae=e.WrappingIndent||(e.WrappingIndent={}));function Ue(q){switch(q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class He extends t{constructor(){super(130,[129])}compute(Z,pe,We){const Ye=pe.get(129);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const Qe="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",st="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?et:M.isLinux?st:Qe,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(q){return e.editorOptionsRegistry[q.id]=q,q}var nt;(function(q){q[q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",q[q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",q[q.accessibilitySupport=2]="accessibilitySupport",q[q.accessibilityPageSize=3]="accessibilityPageSize",q[q.ariaLabel=4]="ariaLabel",q[q.autoClosingBrackets=5]="autoClosingBrackets",q[q.autoClosingDelete=6]="autoClosingDelete",q[q.autoClosingOvertype=7]="autoClosingOvertype",q[q.autoClosingQuotes=8]="autoClosingQuotes",q[q.autoIndent=9]="autoIndent",q[q.automaticLayout=10]="automaticLayout",q[q.autoSurround=11]="autoSurround",q[q.bracketPairColorization=12]="bracketPairColorization",q[q.guides=13]="guides",q[q.codeLens=14]="codeLens",q[q.codeLensFontFamily=15]="codeLensFontFamily",q[q.codeLensFontSize=16]="codeLensFontSize",q[q.colorDecorators=17]="colorDecorators",q[q.columnSelection=18]="columnSelection",q[q.comments=19]="comments",q[q.contextmenu=20]="contextmenu",q[q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",q[q.cursorBlinking=22]="cursorBlinking",q[q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",q[q.cursorStyle=24]="cursorStyle",q[q.cursorSurroundingLines=25]="cursorSurroundingLines",q[q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",q[q.cursorWidth=27]="cursorWidth",q[q.disableLayerHinting=28]="disableLayerHinting",q[q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",q[q.domReadOnly=30]="domReadOnly",q[q.dragAndDrop=31]="dragAndDrop",q[q.emptySelectionClipboard=32]="emptySelectionClipboard",q[q.extraEditorClassName=33]="extraEditorClassName",q[q.fastScrollSensitivity=34]="fastScrollSensitivity",q[q.find=35]="find",q[q.fixedOverflowWidgets=36]="fixedOverflowWidgets",q[q.folding=37]="folding",q[q.foldingStrategy=38]="foldingStrategy",q[q.foldingHighlight=39]="foldingHighlight",q[q.foldingImportsByDefault=40]="foldingImportsByDefault",q[q.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",q[q.fontFamily=42]="fontFamily",q[q.fontInfo=43]="fontInfo",q[q.fontLigatures=44]="fontLigatures",q[q.fontSize=45]="fontSize",q[q.fontWeight=46]="fontWeight",q[q.formatOnPaste=47]="formatOnPaste",q[q.formatOnType=48]="formatOnType",q[q.glyphMargin=49]="glyphMargin",q[q.gotoLocation=50]="gotoLocation",q[q.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",q[q.hover=52]="hover",q[q.inDiffEditor=53]="inDiffEditor",q[q.inlineSuggest=54]="inlineSuggest",q[q.letterSpacing=55]="letterSpacing",q[q.lightbulb=56]="lightbulb",q[q.lineDecorationsWidth=57]="lineDecorationsWidth",q[q.lineHeight=58]="lineHeight",q[q.lineNumbers=59]="lineNumbers",q[q.lineNumbersMinChars=60]="lineNumbersMinChars",q[q.linkedEditing=61]="linkedEditing",q[q.links=62]="links",q[q.matchBrackets=63]="matchBrackets",q[q.minimap=64]="minimap",q[q.mouseStyle=65]="mouseStyle",q[q.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",q[q.mouseWheelZoom=67]="mouseWheelZoom",q[q.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",q[q.multiCursorModifier=69]="multiCursorModifier",q[q.multiCursorPaste=70]="multiCursorPaste",q[q.occurrencesHighlight=71]="occurrencesHighlight",q[q.overviewRulerBorder=72]="overviewRulerBorder",q[q.overviewRulerLanes=73]="overviewRulerLanes",q[q.padding=74]="padding",q[q.parameterHints=75]="parameterHints",q[q.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",q[q.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",q[q.quickSuggestions=78]="quickSuggestions",q[q.quickSuggestionsDelay=79]="quickSuggestionsDelay",q[q.readOnly=80]="readOnly",q[q.renameOnType=81]="renameOnType",q[q.renderControlCharacters=82]="renderControlCharacters",q[q.renderFinalNewline=83]="renderFinalNewline",q[q.renderLineHighlight=84]="renderLineHighlight",q[q.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",q[q.renderValidationDecorations=86]="renderValidationDecorations",q[q.renderWhitespace=87]="renderWhitespace",q[q.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",q[q.roundedSelection=89]="roundedSelection",q[q.rulers=90]="rulers",q[q.scrollbar=91]="scrollbar",q[q.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",q[q.scrollBeyondLastLine=93]="scrollBeyondLastLine",q[q.scrollPredominantAxis=94]="scrollPredominantAxis",q[q.selectionClipboard=95]="selectionClipboard",q[q.selectionHighlight=96]="selectionHighlight",q[q.selectOnLineNumbers=97]="selectOnLineNumbers",q[q.showFoldingControls=98]="showFoldingControls",q[q.showUnused=99]="showUnused",q[q.snippetSuggestions=100]="snippetSuggestions",q[q.smartSelect=101]="smartSelect",q[q.smoothScrolling=102]="smoothScrolling",q[q.stickyTabStops=103]="stickyTabStops",q[q.stopRenderingLineAfter=104]="stopRenderingLineAfter",q[q.suggest=105]="suggest",q[q.suggestFontSize=106]="suggestFontSize",q[q.suggestLineHeight=107]="suggestLineHeight",q[q.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",q[q.suggestSelection=109]="suggestSelection",q[q.tabCompletion=110]="tabCompletion",q[q.tabIndex=111]="tabIndex",q[q.unusualLineTerminators=112]="unusualLineTerminators",q[q.useShadowDOM=113]="useShadowDOM",q[q.useTabStops=114]="useTabStops",q[q.wordSeparators=115]="wordSeparators",q[q.wordWrap=116]="wordWrap",q[q.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",q[q.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",q[q.wordWrapColumn=119]="wordWrapColumn",q[q.wordWrapOverride1=120]="wordWrapOverride1",q[q.wordWrapOverride2=121]="wordWrapOverride2",q[q.wrappingIndent=122]="wrappingIndent",q[q.wrappingStrategy=123]="wrappingStrategy",q[q.showDeprecated=124]="showDeprecated",q[q.inlayHints=125]="inlayHints",q[q.editorClassName=126]="editorClassName",q[q.pixelRatio=127]="pixelRatio",q[q.tabFocusMode=128]="tabFocusMode",q[q.layoutInfo=129]="layoutInfo",q[q.wrappingInfo=130]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(134,null)})),acceptSuggestionOnEnter:ye(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(135,null),""],markdownDescription:d.localize(136,null)})),accessibilitySupport:ye(new i),accessibilityPageSize:ye(new u(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(137,null)})),ariaLabel:ye(new I(4,"ariaLabel",d.localize(138,null))),autoClosingBrackets:ye(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(139,null),d.localize(140,null),""],description:d.localize(141,null)})),autoClosingDelete:ye(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(142,null),""],description:d.localize(143,null)})),autoClosingOvertype:ye(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(144,null),""],description:d.localize(145,null)})),autoClosingQuotes:ye(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(146,null),d.localize(147,null),""],description:d.localize(148,null)})),autoIndent:ye(new h(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],C,{enumDescriptions:[d.localize(149,null),d.localize(150,null),d.localize(151,null),d.localize(152,null),d.localize(153,null)],description:d.localize(154,null)})),automaticLayout:ye(new m(10,"automaticLayout",!1)),autoSurround:ye(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(155,null),d.localize(156,null),d.localize(157,null),""],description:d.localize(158,null)})),bracketPairColorization:ye(new Q),bracketPairGuides:ye(new ee),stickyTabStops:ye(new m(103,"stickyTabStops",!1,{description:d.localize(159,null)})),codeLens:ye(new m(14,"codeLens",!0,{description:d.localize(160,null)})),codeLensFontFamily:ye(new I(15,"codeLensFontFamily","",{description:d.localize(161,null)})),codeLensFontSize:ye(new u(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(162,null)})),colorDecorators:ye(new m(17,"colorDecorators",!0,{description:d.localize(163,null)})),columnSelection:ye(new m(18,"columnSelection",!1,{description:d.localize(164,null)})),comments:ye(new p),contextmenu:ye(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new m(21,"copyWithSyntaxHighlighting",!0,{description:d.localize(165,null)})),cursorBlinking:ye(new h(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:d.localize(166,null)})),cursorSmoothCaretAnimation:ye(new m(23,"cursorSmoothCaretAnimation",!1,{description:d.localize(167,null)})),cursorStyle:ye(new h(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:d.localize(168,null)})),cursorSurroundingLines:ye(new u(25,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(169,null)})),cursorSurroundingLinesStyle:ye(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(170,null),d.localize(171,null)],description:d.localize(172,null)})),cursorWidth:ye(new u(27,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(173,null)})),disableLayerHinting:ye(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new m(30,"domReadOnly",!1)),dragAndDrop:ye(new m(31,"dragAndDrop",!0,{description:d.localize(174,null)})),emptySelectionClipboard:ye(new f),extraEditorClassName:ye(new I(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new g(34,"fastScrollSensitivity",5,q=>q<=0?5:q,{markdownDescription:d.localize(175,null)})),find:ye(new S),fixedOverflowWidgets:ye(new m(36,"fixedOverflowWidgets",!1)),folding:ye(new m(37,"folding",!0,{description:d.localize(176,null)})),foldingStrategy:ye(new o(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(177,null),d.localize(178,null)],description:d.localize(179,null)})),foldingHighlight:ye(new m(39,"foldingHighlight",!0,{description:d.localize(180,null)})),foldingImportsByDefault:ye(new m(40,"foldingImportsByDefault",!1,{description:d.localize(181,null)})),unfoldOnClickAfterEndOfLine:ye(new m(41,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(182,null)})),fontFamily:ye(new I(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(183,null)})),fontInfo:ye(new T),fontLigatures2:ye(new R),fontSize:ye(new L),fontWeight:ye(new b),formatOnPaste:ye(new m(47,"formatOnPaste",!1,{description:d.localize(184,null)})),formatOnType:ye(new m(48,"formatOnType",!1,{description:d.localize(185,null)})),glyphMargin:ye(new m(49,"glyphMargin",!0,{description:d.localize(186,null)})),gotoLocation:ye(new x),hideCursorInOverviewRuler:ye(new m(51,"hideCursorInOverviewRuler",!1,{description:d.localize(187,null)})),hover:ye(new $),inDiffEditor:ye(new m(53,"inDiffEditor",!1)),letterSpacing:ye(new g(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,q=>g.clamp(q,-5,20),{description:d.localize(188,null)})),lightbulb:ye(new H),lineDecorationsWidth:ye(new y(57,"lineDecorationsWidth",10)),lineHeight:ye(new ne),lineNumbers:ye(new Me),lineNumbersMinChars:ye(new u(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new m(61,"linkedEditing",!1,{description:d.localize(189,null)})),links:ye(new m(62,"links",!0,{description:d.localize(190,null)})),matchBrackets:ye(new o(63,"matchBrackets","always",["always","near","never"],{description:d.localize(191,null)})),minimap:ye(new V),mouseStyle:ye(new o(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new g(66,"mouseWheelScrollSensitivity",1,q=>q===0?1:q,{markdownDescription:d.localize(192,null)})),mouseWheelZoom:ye(new m(67,"mouseWheelZoom",!1,{markdownDescription:d.localize(193,null)})),multiCursorMergeOverlapping:ye(new m(68,"multiCursorMergeOverlapping",!0,{description:d.localize(194,null)})),multiCursorModifier:ye(new h(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[d.localize(195,null),d.localize(196,null)],markdownDescription:d.localize(197,null)})),multiCursorPaste:ye(new o(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(198,null),d.localize(199,null)],markdownDescription:d.localize(200,null)})),occurrencesHighlight:ye(new m(71,"occurrencesHighlight",!0,{description:d.localize(201,null)})),overviewRulerBorder:ye(new m(72,"overviewRulerBorder",!0,{description:d.localize(202,null)})),overviewRulerLanes:ye(new u(73,"overviewRulerLanes",3,0,3)),padding:ye(new j),parameterHints:ye(new le),peekWidgetDefaultFocus:ye(new o(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(203,null),d.localize(204,null)],description:d.localize(205,null)})),definitionLinkOpensInPeek:ye(new m(77,"definitionLinkOpensInPeek",!1,{description:d.localize(206,null)})),quickSuggestions:ye(new ve),quickSuggestionsDelay:ye(new u(79,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(207,null)})),readOnly:ye(new m(80,"readOnly",!1)),renameOnType:ye(new m(81,"renameOnType",!1,{description:d.localize(208,null),markdownDeprecationMessage:d.localize(209,null)})),renderControlCharacters:ye(new m(82,"renderControlCharacters",!1,{description:d.localize(210,null)})),renderFinalNewline:ye(new m(83,"renderFinalNewline",!0,{description:d.localize(211,null)})),renderLineHighlight:ye(new o(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(212,null)],description:d.localize(213,null)})),renderLineHighlightOnlyWhenFocus:ye(new m(85,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(214,null)})),renderValidationDecorations:ye(new o(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new o(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(215,null),d.localize(216,null),d.localize(217,null),""],description:d.localize(218,null)})),revealHorizontalRightPadding:ye(new u(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new m(89,"roundedSelection",!0,{description:d.localize(219,null)})),rulers:ye(new Ke),scrollbar:ye(new Ve),scrollBeyondLastColumn:ye(new u(92,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(220,null)})),scrollBeyondLastLine:ye(new m(93,"scrollBeyondLastLine",!0,{description:d.localize(221,null)})),scrollPredominantAxis:ye(new m(94,"scrollPredominantAxis",!0,{description:d.localize(222,null)})),selectionClipboard:ye(new m(95,"selectionClipboard",!0,{description:d.localize(223,null),included:M.isLinux})),selectionHighlight:ye(new m(96,"selectionHighlight",!0,{description:d.localize(224,null)})),selectOnLineNumbers:ye(new m(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new o(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(225,null),d.localize(226,null)],description:d.localize(227,null)})),showUnused:ye(new m(99,"showUnused",!0,{description:d.localize(228,null)})),showDeprecated:ye(new m(124,"showDeprecated",!0,{description:d.localize(229,null)})),inlayHints:ye(new W),snippetSuggestions:ye(new o(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(230,null),d.localize(231,null),d.localize(232,null),d.localize(233,null)],description:d.localize(234,null)})),smartSelect:ye(new se),smoothScrolling:ye(new m(102,"smoothScrolling",!1,{description:d.localize(235,null)})),stopRenderingLineAfter:ye(new u(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new K),inlineSuggest:ye(new U),suggestFontSize:ye(new u(106,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(236,null)})),suggestLineHeight:ye(new u(107,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(237,null)})),suggestOnTriggerCharacters:ye(new m(108,"suggestOnTriggerCharacters",!0,{description:d.localize(238,null)})),suggestSelection:ye(new o(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(239,null),d.localize(240,null),d.localize(241,null)],description:d.localize(242,null)})),tabCompletion:ye(new o(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(243,null),d.localize(244,null),d.localize(245,null)],description:d.localize(246,null)})),tabIndex:ye(new u(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new o(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(247,null),d.localize(248,null),d.localize(249,null)],description:d.localize(250,null)})),useShadowDOM:ye(new m(113,"useShadowDOM",!0)),useTabStops:ye(new m(114,"useTabStops",!0,{description:d.localize(251,null)})),wordSeparators:ye(new I(115,"wordSeparators",_.USUAL_WORD_SEPARATORS,{description:d.localize(252,null)})),wordWrap:ye(new o(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(253,null),d.localize(254,null),d.localize(255,null),d.localize(256,null)],description:d.localize(257,null)})),wordWrapBreakAfterCharacters:ye(new I(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new I(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new u(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(258,null)})),wordWrapOverride1:ye(new o(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new o(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new h(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ue,{enumDescriptions:[d.localize(259,null),d.localize(260,null),d.localize(261,null),d.localize(262,null)],description:d.localize(263,null)})),wrappingStrategy:ye(new o(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(264,null),d.localize(265,null)],description:d.localize(266,null)})),editorClassName:ye(new w),pixelRatio:ye(new re),tabFocusMode:ye(new he),layoutInfo:ye(new G),wrappingInfo:ye(new He)}}),define(be[119],Ee([18,19]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[120],Ee([18,19]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[121],Ee([18,19]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(be[122],Ee([18,19]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(be[123],Ee([18,19]),function(oe,e){return oe.create("vs/platform/theme/common/iconRegistry",e)}),define(be[124],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[125],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[126],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostProgress",e)}),define(be[127],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[128],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[129],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[130],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[131],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(be[132],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/common/views",e)}),define(be[133],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[134],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[135],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[136],Ee([18,19]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[137],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var d;(function(F){F[F.ACTIVATE=1]="ACTIVATE",F[F.RESTORE=2]="RESTORE",F[F.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var M;(function(F){F[F.PICK=0]="PICK",F[F.DISABLED=1]="DISABLED",F[F.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var _;(function(F){F[F.API=0]="API",F[F.USER=1]="USER"})(_=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(F){F[F.Center=0]="Center",F[F.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",F[F.NearTop=2]="NearTop",F[F.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[138],Ee([0,1,120]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,_=/^-(\d{4})(\d{2})(\d{2})$/;function A(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=A;function F(n){if(!A(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=n.match(M);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=F;function k(n){if(!n)return null;let m=n.majorBase,s=n.majorMustEqual,u=n.minorBase,g=n.minorMustEqual,I=n.patchBase,E=n.patchMustEqual;n.hasCaret&&(m===0||(g=!1),E=!1);let o=0;if(n.preRelease){const h=_.exec(n.preRelease);if(h){const[,C,i,p]=h;o=Date.UTC(Number(C),Number(i)-1,Number(p))}}return{majorBase:m,majorMustEqual:s,minorBase:u,minorMustEqual:g,patchBase:I,patchMustEqual:E,isMinimum:n.hasGreaterEquals,notBefore:o}}e.normalizeVersion=k;function D(n,m,s){let u;typeof n=="string"?u=k(F(n)):u=n;let g;m instanceof Date?g=m.getTime():typeof m=="string"&&(g=new Date(m).getTime());let I;if(typeof s=="string"?I=k(F(s)):I=s,!u||!I)return!1;let E=u.majorBase,o=u.minorBase,h=u.patchBase,C=I.majorBase,i=I.minorBase,p=I.patchBase,a=I.notBefore,r=I.majorMustEqual,v=I.minorMustEqual,l=I.patchMustEqual;return I.isMinimum?E>C?!0:E<C?!1:o>i?!0:o<i||g&&g<a?!1:h>=p:(E===1&&C===0&&(!r||!v||!l)&&(C=1,i=0,p=0,r=!0,v=!1,l=!1),E<C?!1:E>C?!r:o<i?!1:o>i?!v:h<p?!1:h>p?!l:!(g&&g<a))}e.isValidVersion=D;function P(n,m,s,u){return s.isBuiltin||typeof s.main=="undefined"?!0:y(n,m,s.engines.vscode,u)}e.isValidExtensionVersion=P;function t(n,m,s){return n==="*"||y(m,s,n)}e.isEngineValid=t;function y(n,m,s,u=[]){let g=k(F(s));if(!g)return u.push(d.localize(0,null,s)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return u.push(d.localize(1,null,s)),!1}else if(!g.majorMustEqual)return u.push(d.localize(2,null,s)),!1;return D(n,m,g)?!0:(u.push(d.localize(3,null,n,s)),!1)}}),define(be[82],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(_,A=[],F=!1){this.ctor=_,this.staticArguments=A,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=d}),define(be[57],Ee([0,1,82]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function _(F,k,D){k instanceof d.SyncDescriptor||(k=new d.SyncDescriptor(k,[],D)),M.push([F,k])}e.registerSingleton=_;function A(){return M}e.getSingletonServiceDescriptors=A}),define(be[139],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=d;class M{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let F of this._nodes.values())F.outgoing.size===0&&A.push(F);return A}insertEdge(A,F){const k=this.lookupOrInsertNode(A),D=this.lookupOrInsertNode(F);k.outgoing.set(this._hashFn(F),D),D.incoming.set(this._hashFn(A),k)}removeNode(A){const F=this._hashFn(A);this._nodes.delete(F);for(let k of this._nodes.values())k.outgoing.delete(F),k.incoming.delete(F)}lookupOrInsertNode(A){const F=this._hashFn(A);let k=this._nodes.get(F);return k||(k=new d(A),this._nodes.set(F,k)),k}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[F,k]of this._nodes)A.push(`${F}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,F]of this._nodes){const k=new Set([A]),D=this._findCycle(F,k);if(D)return D}}_findCycle(A,F){for(let[k,D]of A.outgoing){if(F.has(k))return[...F,k].join(" -> ");F.add(k);const P=this._findCycle(D,F);if(P)return P;F.delete(k)}}}e.Graph=M}),define(be[4],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function D(P){return P[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=D})(d=e._util||(e._util={})),e.IInstantiationService=_("instantiationService");function M(k,D,P,t){D[d.DI_TARGET]===D?D[d.DI_DEPENDENCIES].push({id:k,index:P,optional:t}):(D[d.DI_DEPENDENCIES]=[{id:k,index:P,optional:t}],D[d.DI_TARGET]=D)}function _(k){if(d.serviceIds.has(k))return d.serviceIds.get(k);const D=function(P,t,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(D,P,y,!1)};return D.toString=()=>k,d.serviceIds.set(k,D),D}e.createDecorator=_;function A(k){return k}e.refineServiceDecorator=A;function F(k){return function(D,P,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(k,D,t,!0)}}e.optional=F}),define(be[140],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,d.createDecorator)("modelService");function M(_){return!_.isTooLargeForSyncing()&&!_.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(be[141],Ee([0,1,3,58,6,20,76,56,140]),function(oe,e,d,M,_,A,F,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(P):!!u.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new d.Emitter}get onDidChange(){return this._onDidChange.event}register(g,I){let E={selector:g,provider:I,_score:-1,_time:this._clock++};return this._entries.push(E),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,_.toDisposable)(()=>{if(E){let o=this._entries.indexOf(E);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),E=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const I=[];for(let E of this._entries)E._score>0&&I.push(E.provider);return I}ordered(g){const I=[];return this._orderedForEach(g,E=>I.push(E.provider)),I}orderedGroups(g){const I=[];let E,o;return this._orderedForEach(g,h=>{E&&o===h._score?E.push(h.provider):(o=h._score,E=[h.provider],I.push(E))}),I}_orderedForEach(g,I){if(!!g){this._updateScores(g);for(const E of this._entries)E._score>0&&I(E)}}_updateScores(g){let I={uri:g.uri.toString(),language:g.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===I.language&&this._lastCandidate.uri===I.uri)){this._lastCandidate=I;for(let E of this._entries)if(E._score=(0,k.score)(E.selector,g.uri,g.getLanguageId(),(0,D.shouldSynchronizeModel)(g)),P(E.selector)&&E._score>0){for(let o of this._entries)o._score=0;E._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(g,I){return g._score<I._score?1:g._score>I._score?-1:g._time<I._time?1:g._time>I._time?-1:0}}e.LanguageFeatureRegistry=t;const y=new WeakMap;let n=0;function m(u){let g=y.get(u);return g===void 0&&(g=++n,y.set(u,g)),g}class s{constructor(g,I,E=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=I,this.max=E,this._cache=new A.LRUCache(50,.7)}_key(g){return g.id+this._registry.all(g).reduce((I,E)=>(0,M.doHash)(m(E),I),0)}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const I=this._key(g),E=this._cache.get(I);return this._clamp(E?.value)}update(g,I){const E=this._key(g);let o=this._cache.get(E);return o||(o=new F.MovingAverage,this._cache.set(E,o)),o.update(I),this.get(g)}}e.LanguageFeatureRequestDelays=s}),define(be[59],Ee([0,1,2,44,141,114,34]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(f){f[f.Null=0]="Null",f[f.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var D;(function(f){f[f.NotSet=-1]="NotSet",f[f.None=0]="None",f[f.Italic=1]="Italic",f[f.Bold=2]="Bold",f[f.Underline=4]="Underline"})(D=e.FontStyle||(e.FontStyle={}));var P;(function(f){f[f.None=0]="None",f[f.DefaultForeground=1]="DefaultForeground",f[f.DefaultBackground=2]="DefaultBackground"})(P=e.ColorId||(e.ColorId={}));var t;(function(f){f[f.Other=0]="Other",f[f.Comment=1]="Comment",f[f.String=2]="String",f[f.RegEx=4]="RegEx"})(t=e.StandardTokenType||(e.StandardTokenType={}));var y;(function(f){f[f.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",f[f.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",f[f.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",f[f.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",f[f.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",f[f.ITALIC_MASK=2048]="ITALIC_MASK",f[f.BOLD_MASK=4096]="BOLD_MASK",f[f.UNDERLINE_MASK=8192]="UNDERLINE_MASK",f[f.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",f[f.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",f[f.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",f[f.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",f[f.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",f[f.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",f[f.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",f[f.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",f[f.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",f[f.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(y=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(S){return(S&255)>>>0}static getTokenType(S){return(S&1792)>>>8}static getFontStyle(S){return(S&14336)>>>11}static getForeground(S){return(S&8372224)>>>14}static getBackground(S){return(S&4286578688)>>>23}static getClassNameFromMetadata(S){let R=this.getForeground(S),T="mtk"+R,L=this.getFontStyle(S);return L&1&&(T+=" mtki"),L&2&&(T+=" mtkb"),L&4&&(T+=" mtku"),T}static getInlineStyleFromMetadata(S,R){const T=this.getForeground(S),L=this.getFontStyle(S);let b=`color: ${R[T]};`;return L&1&&(b+="font-style: italic;"),L&2&&(b+="font-weight: bold;"),L&4&&(b+="text-decoration: underline;"),b}}e.TokenMetadata=n;var m;(function(f){f[f.Method=0]="Method",f[f.Function=1]="Function",f[f.Constructor=2]="Constructor",f[f.Field=3]="Field",f[f.Variable=4]="Variable",f[f.Class=5]="Class",f[f.Struct=6]="Struct",f[f.Interface=7]="Interface",f[f.Module=8]="Module",f[f.Property=9]="Property",f[f.Event=10]="Event",f[f.Operator=11]="Operator",f[f.Unit=12]="Unit",f[f.Value=13]="Value",f[f.Constant=14]="Constant",f[f.Enum=15]="Enum",f[f.EnumMember=16]="EnumMember",f[f.Keyword=17]="Keyword",f[f.Text=18]="Text",f[f.Color=19]="Color",f[f.File=20]="File",f[f.Reference=21]="Reference",f[f.Customcolor=22]="Customcolor",f[f.Folder=23]="Folder",f[f.TypeParameter=24]="TypeParameter",f[f.User=25]="User",f[f.Issue=26]="Issue",f[f.Snippet=27]="Snippet"})(m=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let f=Object.create(null);return f[0]="symbol-method",f[1]="symbol-function",f[2]="symbol-constructor",f[3]="symbol-field",f[4]="symbol-variable",f[5]="symbol-class",f[6]="symbol-struct",f[7]="symbol-interface",f[8]="symbol-module",f[9]="symbol-property",f[10]="symbol-event",f[11]="symbol-operator",f[12]="symbol-unit",f[13]="symbol-value",f[14]="symbol-constant",f[15]="symbol-enum",f[16]="symbol-enum-member",f[17]="symbol-keyword",f[27]="symbol-snippet",f[18]="symbol-text",f[19]="symbol-color",f[20]="symbol-file",f[21]="symbol-reference",f[22]="symbol-customcolor",f[23]="symbol-folder",f[24]="symbol-type-parameter",f[25]="account",f[26]="issues",function(S){const R=f[S];let T=R&&F.iconRegistry.get(R);return T||(console.info("No codicon found for CompletionItemKind "+S),T=F.Codicon.symbolProperty),T.classNames}}(),e.completionKindFromString=function(){let f=Object.create(null);return f.method=0,f.function=1,f.constructor=2,f.field=3,f.variable=4,f.class=5,f.struct=6,f.interface=7,f.module=8,f.property=9,f.event=10,f.operator=11,f.unit=12,f.value=13,f.constant=14,f.enum=15,f["enum-member"]=16,f.enumMember=16,f.keyword=17,f.snippet=27,f.text=18,f.color=19,f.file=20,f.reference=21,f.customcolor=22,f.folder=23,f["type-parameter"]=24,f.typeParameter=24,f.account=25,f.issue=26,function(S,R){let T=f[S];return typeof T=="undefined"&&!R&&(T=9),T}}();var s;(function(f){f[f.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var u;(function(f){f[f.KeepWhitespace=1]="KeepWhitespace",f[f.InsertAsSnippet=4]="InsertAsSnippet"})(u=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var g;(function(f){f[f.Invoke=0]="Invoke",f[f.TriggerCharacter=1]="TriggerCharacter",f[f.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var I;(function(f){f[f.Automatic=0]="Automatic",f[f.Explicit=1]="Explicit"})(I=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var E;(function(f){f[f.Invoke=1]="Invoke",f[f.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(f){f[f.Invoke=1]="Invoke",f[f.TriggerCharacter=2]="TriggerCharacter",f[f.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(f){f[f.Text=0]="Text",f[f.Read=1]="Read",f[f.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function C(f){return f&&d.URI.isUri(f.uri)&&M.Range.isIRange(f.range)&&(M.Range.isIRange(f.originSelectionRange)||M.Range.isIRange(f.targetSelectionRange))}e.isLocationLink=C;var i;(function(f){f[f.File=0]="File",f[f.Module=1]="Module",f[f.Namespace=2]="Namespace",f[f.Package=3]="Package",f[f.Class=4]="Class",f[f.Method=5]="Method",f[f.Property=6]="Property",f[f.Field=7]="Field",f[f.Constructor=8]="Constructor",f[f.Enum=9]="Enum",f[f.Interface=10]="Interface",f[f.Function=11]="Function",f[f.Variable=12]="Variable",f[f.Constant=13]="Constant",f[f.String=14]="String",f[f.Number=15]="Number",f[f.Boolean=16]="Boolean",f[f.Array=17]="Array",f[f.Object=18]="Object",f[f.Key=19]="Key",f[f.Null=20]="Null",f[f.EnumMember=21]="EnumMember",f[f.Struct=22]="Struct",f[f.Event=23]="Event",f[f.Operator=24]="Operator",f[f.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var p;(function(f){f[f.Deprecated=1]="Deprecated"})(p=e.SymbolTag||(e.SymbolTag={}));var a;(function(f){const S=new Map;S.set("file",0),S.set("module",1),S.set("namespace",2),S.set("package",3),S.set("class",4),S.set("method",5),S.set("property",6),S.set("field",7),S.set("constructor",8),S.set("enum",9),S.set("interface",10),S.set("function",11),S.set("variable",12),S.set("constant",13),S.set("string",14),S.set("number",15),S.set("boolean",16),S.set("array",17),S.set("object",18),S.set("key",19),S.set("null",20),S.set("enum-member",21),S.set("struct",22),S.set("event",23),S.set("operator",24),S.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function T(x){return S.get(x)}f.fromString=T;function L(x){return R.get(x)}f.toString=L;function b(x,$){const B=R.get(x);let G=B&&F.iconRegistry.get("symbol-"+B);return G||(console.info("No codicon found for SymbolKind "+x),G=F.Codicon.symbolProperty),`${$?"inline":"block"} ${G.classNames}`}f.toCssClassName=b})(a=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(S){this.value=S}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var v;(function(f){f[f.Collapsed=0]="Collapsed",f[f.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(f){f[f.Editing=0]="Editing",f[f.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var c;(function(f){f[f.Other=0]="Other",f[f.Type=1]="Type",f[f.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new _.LanguageFeatureRegistry,e.RenameProviderRegistry=new _.LanguageFeatureRegistry,e.CompletionProviderRegistry=new _.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new _.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new _.LanguageFeatureRegistry,e.HoverProviderRegistry=new _.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new _.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new _.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new _.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new _.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new _.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new _.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new _.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new _.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new _.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.LinkProviderRegistry=new _.LanguageFeatureRegistry,e.ColorProviderRegistry=new _.LanguageFeatureRegistry,e.SelectionRangeRegistry=new _.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new _.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var w;(function(f){f[f.None=0]="None",f[f.Option=1]="Option",f[f.Default=2]="Default",f[f.Preferred=3]="Preferred"})(w=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[46],Ee([0,1,25,9,4]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=d.userAgent||"";const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",d.isMacintosh),F.set("isLinux",d.isLinux),F.set("isWindows",d.isWindows),F.set("isWeb",d.isWeb),F.set("isMacNative",d.isMacintosh&&!d.isWeb),F.set("isEdge",A.indexOf("Edg/")>=0),F.set("isFirefox",A.indexOf("Firefox")>=0),F.set("isChrome",A.indexOf("Chrome")>=0),F.set("isSafari",A.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var D;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return n.INSTANCE}static true(){return m.INSTANCE}static has(b){return s.create(b)}static equals(b,x){return u.create(b,x)}static notEquals(b,x){return E.create(b,x)}static regex(b,x){return a.create(b,x)}static in(b,x){return g.create(b,x)}static not(b){return o.create(b)}static and(...b){return l.create(b,null)}static or(...b){return c.create(b,null,!0)}static greater(b,x){return h.create(b,x)}static less(b,x){return i.create(b,x)}static deserialize(b,x=!1){if(!!b)return this._deserializeOrExpression(b,x)}static _deserializeOrExpression(b,x){let $=b.split("||");return c.create($.map(B=>this._deserializeAndExpression(B,x)),null,!0)}static _deserializeAndExpression(b,x){let $=b.split("&&");return l.create($.map(B=>this._deserializeOne(B,x)),null)}static _deserializeOne(b,x){if(b=b.trim(),b.indexOf("!=")>=0){let $=b.split("!=");return E.create($[0].trim(),this._deserializeValue($[1],x))}if(b.indexOf("==")>=0){let $=b.split("==");return u.create($[0].trim(),this._deserializeValue($[1],x))}if(b.indexOf("=~")>=0){let $=b.split("=~");return a.create($[0].trim(),this._deserializeRegexValue($[1],x))}if(b.indexOf(" in ")>=0){let $=b.split(" in ");return g.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(b)){const $=b.split(">=");return C.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(b)){const $=b.split(">");return h.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(b)){const $=b.split("<=");return p.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(b)){const $=b.split("<");return i.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(b)?o.create(b.substr(1).trim()):s.create(b)}static _deserializeValue(b,x){if(b=b.trim(),b==="true")return!0;if(b==="false")return!1;let $=/^'([^']*)'$/.exec(b);return $?$[1].trim():b}static _deserializeRegexValue(b,x){if((0,M.isFalsyOrWhitespace)(b)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let $=b.indexOf("/"),B=b.lastIndexOf("/");if($===B||$<0){if(x)throw new Error(`bad regexp-value '${b}', missing /-enclosure`);return console.warn(`bad regexp-value '${b}', missing /-enclosure`),null}let G=b.slice($+1,B),H=b[B+1]==="i"?"i":"";try{return new RegExp(G,H)}catch(W){if(x)throw new Error(`bad regexp-value '${b}', parse error: ${W}`);return console.warn(`bad regexp-value '${b}', parse error: ${W}`),null}}}e.ContextKeyExpr=P;function t(L,b){const x=L?L.substituteConstants():void 0,$=b?b.substituteConstants():void 0;return!x&&!$?!0:!x||!$?!1:x.equals($)}e.expressionsAreEqualWithConstantSubstitution=t;function y(L,b){return L.cmp(b)}class n{constructor(){this.type=0}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class m{constructor(){this.type=1}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class s{constructor(b,x){this.key=b,this.negated=x,this.type=2}static create(b,x=null){const $=F.get(b);return typeof $=="boolean"?$?m.INSTANCE:n.INSTANCE:new s(b,x)}cmp(b){return b.type!==this.type?this.type-b.type:f(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}substituteConstants(){const b=F.get(this.key);return typeof b=="boolean"?b?m.INSTANCE:n.INSTANCE:this}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=s;class u{constructor(b,x,$){this.key=b,this.value=x,this.negated=$,this.type=4}static create(b,x,$=null){if(typeof x=="boolean")return x?s.create(b,$):o.create(b,$);const B=F.get(b);return typeof B=="boolean"?x===(B?"true":"false")?m.INSTANCE:n.INSTANCE:new u(b,x,$)}cmp(b){return b.type!==this.type?this.type-b.type:S(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){const b=F.get(this.key);if(typeof b=="boolean"){const x=b?"true":"false";return this.value===x?m.INSTANCE:n.INSTANCE}return this}evaluate(b){return b.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(b){return b.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class g{constructor(b,x){this.key=b,this.valueKey=x,this.type=10,this.negated=null}static create(b,x){return new g(b,x)}cmp(b){return b.type!==this.type?this.type-b.type:S(this.key,this.valueKey,b.key,b.valueKey)}equals(b){return b.type===this.type?this.key===b.key&&this.valueKey===b.valueKey:!1}substituteConstants(){return this}evaluate(b){const x=b.getValue(this.valueKey),$=b.getValue(this.key);return Array.isArray(x)?x.indexOf($)>=0:typeof $=="string"&&typeof x=="object"&&x!==null?k.call(x,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(b){return b.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=I.create(this)),this.negated}}e.ContextKeyInExpr=g;class I{constructor(b){this._actual=b,this.type=11}static create(b){return new I(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}substituteConstants(){return this}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new I(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotInExpr=I;class E{constructor(b,x,$){this.key=b,this.value=x,this.negated=$,this.type=5}static create(b,x,$=null){if(typeof x=="boolean")return x?o.create(b,$):s.create(b,$);const B=F.get(b);return typeof B=="boolean"?x===(B?"true":"false")?n.INSTANCE:m.INSTANCE:new E(b,x,$)}cmp(b){return b.type!==this.type?this.type-b.type:S(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){const b=F.get(this.key);if(typeof b=="boolean"){const x=b?"true":"false";return this.value===x?n.INSTANCE:m.INSTANCE}return this}evaluate(b){return b.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(b){return b.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=E;class o{constructor(b,x){this.key=b,this.negated=x,this.type=3}static create(b,x=null){const $=F.get(b);return typeof $=="boolean"?$?n.INSTANCE:m.INSTANCE:new o(b,x)}cmp(b){return b.type!==this.type?this.type-b.type:f(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}substituteConstants(){const b=F.get(this.key);return typeof b=="boolean"?b?n.INSTANCE:m.INSTANCE:this}evaluate(b){return!b.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(b){return b.mapNot(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=o;class h{constructor(b,x,$){this.key=b,this.value=x,this.negated=$,this.type=12}static create(b,x,$=null){return new h(b,x,$)}cmp(b){return b.type!==this.type?this.type-b.type:S(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){return this}evaluate(b){return parseFloat(b.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=h;class C{constructor(b,x,$){this.key=b,this.value=x,this.negated=$,this.type=13}static create(b,x,$=null){return new C(b,x,$)}cmp(b){return b.type!==this.type?this.type-b.type:S(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){return this}evaluate(b){return parseFloat(b.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=C;class i{constructor(b,x,$){this.key=b,this.value=x,this.negated=$,this.type=14}static create(b,x,$=null){return new i(b,x,$)}cmp(b){return b.type!==this.type?this.type-b.type:S(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){return this}evaluate(b){return parseFloat(b.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class p{constructor(b,x,$){this.key=b,this.value=x,this.negated=$,this.type=15}static create(b,x,$=null){return new p(b,x,$)}cmp(b){return b.type!==this.type?this.type-b.type:S(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}substituteConstants(){return this}evaluate(b){return parseFloat(b.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=p;class a{constructor(b,x){this.key=b,this.regexp=x,this.type=7,this.negated=null}static create(b,x){return new a(b,x)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.key<b.key)return-1;if(this.key>b.key)return 1;const x=this.regexp?this.regexp.source:"",$=b.regexp?b.regexp.source:"";return x<$?-1:x>$?1:0}equals(b){if(b.type===this.type){const x=this.regexp?this.regexp.source:"",$=b.regexp?b.regexp.source:"";return this.key===b.key&&x===$}return!1}substituteConstants(){return this}evaluate(b){let x=b.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const b=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${b}`}keys(){return[this.key]}map(b){return b.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=a;class r{constructor(b){this._actual=b,this.type=8}static create(b){return new r(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}substituteConstants(){return this}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new r(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function v(L){let b=null;for(let x=0,$=L.length;x<$;x++){const B=L[x].substituteConstants();if(L[x]!==B&&b===null){b=[];for(let G=0;G<x;G++)b[G]=L[G]}b!==null&&(b[x]=B)}return b===null?L:b}class l{constructor(b,x){this.expr=b,this.negated=x,this.type=6}static create(b,x){return l._normalizeArr(b,x)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let x=0,$=this.expr.length;x<$;x++){const B=y(this.expr[x],b.expr[x]);if(B!==0)return B}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let x=0,$=this.expr.length;x<$;x++)if(!this.expr[x].equals(b.expr[x]))return!1;return!0}return!1}substituteConstants(){const b=v(this.expr);return b===this.expr?this:l.create(b,this.negated)}evaluate(b){for(let x=0,$=this.expr.length;x<$;x++)if(!this.expr[x].evaluate(b))return!1;return!0}static _normalizeArr(b,x){const $=[];let B=!1;for(const G of b)if(!!G){if(G.type===1){B=!0;continue}if(G.type===0)return n.INSTANCE;if(G.type===6){$.push(...G.expr);continue}$.push(G)}if($.length===0&&B)return m.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(y);for(let G=1;G<$.length;G++)$[G-1].equals($[G])&&($.splice(G,1),G--);if($.length===1)return $[0];for(;$.length>1;){const G=$[$.length-1];if(G.type!==9)break;$.pop();const H=$.pop(),W=$.length===0,ne=c.create(G.expr.map(V=>l.create([V,H],null)),null,W);ne&&($.push(ne),$.sort(y))}return $.length===1?$[0]:new l($,x)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(let x of this.expr)b.push(...x.keys());return b}map(b){return new l(this.expr.map(x=>x.map(b)),null)}negate(){if(!this.negated){const b=[];for(let x of this.expr)b.push(x.negate());this.negated=c.create(b,this,!0)}return this.negated}}class c{constructor(b,x){this.expr=b,this.negated=x,this.type=9}static create(b,x,$){return c._normalizeArr(b,x,$)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let x=0,$=this.expr.length;x<$;x++){const B=y(this.expr[x],b.expr[x]);if(B!==0)return B}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let x=0,$=this.expr.length;x<$;x++)if(!this.expr[x].equals(b.expr[x]))return!1;return!0}return!1}substituteConstants(){const b=v(this.expr);return b===this.expr?this:c.create(b,this.negated,!1)}evaluate(b){for(let x=0,$=this.expr.length;x<$;x++)if(this.expr[x].evaluate(b))return!0;return!1}static _normalizeArr(b,x,$){let B=[],G=!1;if(b){for(let H=0,W=b.length;H<W;H++){const ne=b[H];if(!!ne){if(ne.type===0){G=!0;continue}if(ne.type===1)return m.INSTANCE;if(ne.type===9){B=B.concat(ne.expr);continue}B.push(ne)}}if(B.length===0&&G)return n.INSTANCE;B.sort(y)}if(B.length!==0){if(B.length===1)return B[0];for(let H=1;H<B.length;H++)B[H-1].equals(B[H])&&(B.splice(H,1),H--);if(B.length===1)return B[0];if($){for(let H=0;H<B.length;H++)for(let W=H+1;W<B.length;W++)R(B[H],B[W])&&(B.splice(W,1),W--);if(B.length===1)return B[0]}return new c(B,x)}}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(let x of this.expr)b.push(...x.keys());return b}map(b){return new c(this.expr.map(x=>x.map(b)),null)}negate(){if(!this.negated){let b=[];for(let x of this.expr)b.push(x.negate());for(;b.length>1;){const x=b.shift(),$=b.shift(),B=[];for(const H of T(x))for(const W of T($))B.push(l.create([H,W],null));const G=b.length===0;b.unshift(c.create(B,null,G))}this.negated=b[0]}return this.negated}}class w extends s{constructor(b,x,$){super(b,null);this._defaultValue=x,typeof $=="object"?w._info.push({...$,key:b}):$!==!0&&w._info.push({key:b,description:$,type:x!=null?typeof x:void 0})}static all(){return w._info.values()}bindTo(b){return b.createKey(this.key,this._defaultValue)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(b){return u.create(this.key,b)}notEqualsTo(b){return E.create(this.key,b)}}e.RawContextKey=w,w._info=[],e.IContextKeyService=(0,_.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(L,b){return L<b?-1:L>b?1:0}function S(L,b,x,$){return L<x?-1:L>x?1:b<$?-1:b>$?1:0}function R(L,b){if(b.type===6&&L.type!==9&&L.type!==6){for(const B of b.expr)if(L.equals(B))return!0}const x=L.negate(),$=T(x).concat(T(b));$.sort(y);for(let B=0;B<$.length;B++){const H=$[B].negate();for(let W=B+1;W<$.length;W++){const ne=$[W];if(H.equals(ne))return!0}}return!1}e.implies=R;function T(L){return L.type===9?L.expr:[L]}}),define(be[142],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(be[60],Ee([0,1,20,17,9,10,2,121,4]),function(oe,e,d,M,_,A,F,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function P(B){return B.create===!0}e.isFileOpenForWriteOptions=P;var t;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var y;(function(B){B[B.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var n;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=m;function s(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=s;function u(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function g(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=g;var I;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(G,H){super(G);this.code=H}}e.FileSystemProviderError=E;function o(B,G){const H=new E(B.toString(),G);return C(H,G),H}e.createFileSystemProviderError=o;function h(B){return B||o((0,k.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=h;function C(B,G){return B.name=G?`${G} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=C;function i(B){if(!B)return I.Unknown;if(B instanceof E)return B.code;const G=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!G)return I.Unknown;switch(G[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=i;function p(B){if(B instanceof w)return B.fileOperationResult;switch(i(B)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=p;var a;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY"})(a=e.FileOperation||(e.FileOperation={}));class r{constructor(G,H,W){this.resource=G,this.operation=H,this.target=W}isOperation(G){return this.operation===G}}e.FileOperationEvent=r;var v;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(v=e.FileChangeType||(e.FileChangeType={}));class l{constructor(G,H){this.added=void 0,this.updated=void 0,this.deleted=void 0;const W=new Map;for(const ne of G){const V=W.get(ne.type);V?V.push([ne.resource,ne]):W.set(ne.type,[[ne.resource,ne]])}for(const[ne,V]of W)switch(ne){case 1:this.added=d.TernarySearchTree.forUris(()=>H),this.added.fill(V);break;case 0:this.updated=d.TernarySearchTree.forUris(()=>H),this.updated.fill(V);break;case 2:this.deleted=d.TernarySearchTree.forUris(()=>H),this.deleted.fill(V);break}}contains(G,...H){return this.doContains(G,{includeChildren:!1},...H)}affects(G,...H){return this.doContains(G,{includeChildren:!0},...H)}doContains(G,H,...W){if(!G)return!1;const ne=W.length>0;return!!((!ne||W.includes(1))&&(this.added?.get(G)||H.includeChildren&&this.added?.findSuperstr(G))||(!ne||W.includes(0))&&(this.updated?.get(G)||H.includeChildren&&this.updated?.findSuperstr(G))||(!ne||W.includes(2))&&(this.deleted?.findSubstr(G)||H.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function c(B,G,H){return!B||!G||B===G||G.length>B.length?!1:(G.charAt(G.length-1)!==M.sep&&(G+=M.sep),H?(0,_.startsWithIgnoreCase)(B,G):B.indexOf(G)===0)}e.isParent=c;class w extends Error{constructor(G,H,W){super(G);this.fileOperationResult=H,this.options=W}}e.FileOperationError=w;class f extends w{constructor(G,H,W){super(G,2,W);this.stat=H}}e.NotModifiedSinceFileOperationError=f;var S;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(S=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function T(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=T;async function L(B,G){if(!G.hasProvider(F.URI.from({scheme:B.scheme})))return new Promise(H=>{const W=G.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===B.scheme&&ne.added&&(W.dispose(),H())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class b{static formatSize(G){return(0,A.isNumber)(G)||(G=0),G<b.KB?(0,k.localize)(1,null,G.toFixed(0)):G<b.MB?(0,k.localize)(2,null,(G/b.KB).toFixed(2)):G<b.GB?(0,k.localize)(3,null,(G/b.MB).toFixed(2)):G<b.TB?(0,k.localize)(4,null,(G/b.GB).toFixed(2)):(0,k.localize)(5,null,(G/b.TB).toFixed(2))}}e.ByteSize=b,b.KB=1024,b.MB=b.KB*b.KB,b.GB=b.MB*b.KB,b.TB=b.GB*b.KB;var x;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function $(B){return{maxFileSize:B===0?300*b.MB:16*b.GB,maxHeapSize:B===0?700*b.MB:2*700*b.MB}}e.getPlatformLimits=$}),define(be[61],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(..._){this._entries=new Map;for(let[A,F]of _)this.set(A,F)}set(_,A){const F=this._entries.get(_);return this._entries.set(_,A),F}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=d}),define(be[143],Ee([0,1,12,16,82,139,4,61]),function(oe,e,d,M,_,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class P extends Error{constructor(s){super("cyclic dependency between services");this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class t{constructor(s=new k.ServiceCollection,u=!1,g){this._activeInstantiations=new Set,this._services=s,this._strict=u,this._parent=g,this._services.set(F.IInstantiationService,this)}createChild(s){return new t(s,this._strict,this)}invokeFunction(s,...u){let g=n.traceInvocation(s),I=!1;try{return s({get:(o,h)=>{if(I)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const C=this._getOrCreateServiceInstance(o,g);if(!C&&h!==F.optional)throw new Error(`[invokeFunction] unknown service '${o}'`);return C}},...u)}finally{I=!0,g.stop()}}createInstance(s,...u){let g,I;return s instanceof _.SyncDescriptor?(g=n.traceCreation(s.ctor),I=this._createInstance(s.ctor,s.staticArguments.concat(u),g)):(g=n.traceCreation(s),I=this._createInstance(s,u,g)),g.stop(),I}_createInstance(s,u=[],g){let I=F._util.getServiceDependencies(s).sort((h,C)=>h.index-C.index),E=[];for(const h of I){let C=this._getOrCreateServiceInstance(h.id,g);if(!C&&this._strict&&!h.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${h.id}.`);E.push(C)}let o=I.length>0?I[0].index:u.length;if(u.length!==o){console.warn(`[createInstance] First service dependency of ${s.name} at position ${o+1} conflicts with ${u.length} static arguments`);let h=o-u.length;h>0?u=u.concat(new Array(h)):u=u.slice(0,o)}return new s(...[...u,...E])}_setServiceInstance(s,u){if(this._services.get(s)instanceof _.SyncDescriptor)this._services.set(s,u);else if(this._parent)this._parent._setServiceInstance(s,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let u=this._services.get(s);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):u}_getOrCreateServiceInstance(s,u){let g=this._getServiceInstanceOrDescriptor(s);return g instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,g,u.branch(s,!0)):(u.branch(s,!1),g)}_safeCreateAndCacheServiceInstance(s,u,g){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,u,g)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,u,g){const I=new A.Graph(h=>h.id.toString());let E=0;const o=[{id:s,desc:u,_trace:g}];for(;o.length;){const h=o.pop();if(I.lookupOrInsertNode(h),E++>1e3)throw new P(I);for(let C of F._util.getServiceDependencies(h.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(C.id);if(!i&&!C.optional&&console.warn(`[createInstance] ${s} depends on ${C.id} which is NOT registered.`),i instanceof _.SyncDescriptor){const p={id:C.id,desc:i,_trace:h._trace.branch(C.id,!0)};I.insertEdge(h,p),o.push(p)}}}for(;;){const h=I.roots();if(h.length===0){if(!I.isEmpty())throw new P(I);break}for(const{data:C}of h){if(this._getServiceInstanceOrDescriptor(C.id)instanceof _.SyncDescriptor){const p=this._createServiceInstanceWithOwner(C.id,C.desc.ctor,C.desc.staticArguments,C.desc.supportsDelayedInstantiation,C._trace);this._setServiceInstance(C.id,p)}I.removeNode(C)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,u,g=[],I,E){if(this._services.get(s)instanceof _.SyncDescriptor)return this._createServiceInstance(u,g,I,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,u,g,I,E);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(s,u=[],g,I){if(g){const E=new d.IdleValue(()=>this._createInstance(s,u,I));return new Proxy(Object.create(null),{get(o,h){if(h in o)return o[h];let C=E.value,i=C[h];return typeof i!="function"||(i=i.bind(C),o[h]=i),i},set(o,h,C){return E.value[h]=C,!0}})}else return this._createInstance(s,u,I)}}e.InstantiationService=t;var y;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(y||(y={}));class n{constructor(s,u){this.type=s,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return D?new n(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(s){return D?new n(0,s.name):n._None}branch(s,u){let g=new n(2,s.toString());return this._dep.push([s,u,g]),g}stop(){let s=Date.now()-this._start;n._totals+=s;let u=!1;function g(E,o){let h=[],C=new Array(E+1).join("	");for(const[i,p,a]of o._dep)if(p&&a){u=!0,h.push(`${C}CREATES -> ${i}`);let r=g(E+1,a);r&&h.push(r)}else h.push(`${C}uses -> ${i}`);return h.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(s>2||u)&&console.log(I.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(be[15],Ee([0,1,45,3,6,25,4]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,F.createDecorator)("logService"),e.ILoggerService=(0,F.createDecorator)("loggerService");function k(){return new Date().toISOString()}var D;(function(C){C[C.Trace=0]="Trace",C[C.Debug=1]="Debug",C[C.Info=2]="Info",C[C.Warning=3]="Warning",C[C.Error=4]="Error",C[C.Critical=5]="Critical",C[C.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class P extends _.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class t extends P{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...p){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([i,...p]))}debug(i,...p){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([i,...p]))}info(i,...p){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([i,...p]))}warn(i,...p){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([i,...p]))}error(i,...p){if(this.checkLogLevel(D.Error))if(i instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=i.stack,this.log(D.Error,this.format(a))}else this.log(D.Error,this.format([i,...p]))}critical(i,...p){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([i,...p]))}flush(){}format(i){let p="";for(let a=0;a<i.length;a++){let r=i[a];if(typeof r=="object")try{r=JSON.stringify(r)}catch(v){}p+=(a>0?" ":"")+r}return p}}e.AbstractMessageLogger=t;class y extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...p){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...p):console.log(`[main ${k()}]`,i,...p))}debug(i,...p){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...p):console.log(`[main ${k()}]`,i,...p))}info(i,...p){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...p):console.log(`[main ${k()}]`,i,...p))}warn(i,...p){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,i,...p):console.warn(`[main ${k()}]`,i,...p))}error(i,...p){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,i,...p):console.error(`[main ${k()}]`,i,...p))}critical(i,...p){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,i,...p):console.error(`[main ${k()}]`,i,...p))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class n extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...p){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",i,...p)}debug(i,...p){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...p)}info(i,...p){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",i,...p)}warn(i,...p){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",i,...p)}error(i,...p){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",i,...p)}critical(i,...p){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...p)}dispose(){}flush(){}}e.ConsoleLogger=n;class m extends P{constructor(i,p=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(p)}trace(i,...p){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(i),...p])}debug(i,...p){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(i),...p])}info(i,...p){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(i),...p])}warn(i,...p){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(i),...p])}error(i,...p){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(i),...p])}critical(i,...p){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(i),...p])}extractMessage(i){return typeof i=="string"?i:(0,d.toErrorMessage)(i,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class s extends P{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const p of this.logServices)p.setLevel(i);super.setLevel(i)}trace(i,...p){for(const a of this.logServices)a.trace(i,...p)}debug(i,...p){for(const a of this.logServices)a.debug(i,...p)}info(i,...p){for(const a of this.logServices)a.info(i,...p)}warn(i,...p){for(const a of this.logServices)a.warn(i,...p)}error(i,...p){for(const a of this.logServices)a.error(i,...p)}critical(i,...p){for(const a of this.logServices)a.critical(i,...p)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=s;class u extends _.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...p){this.logger.trace(i,...p)}debug(i,...p){this.logger.debug(i,...p)}info(i,...p){this.logger.info(i,...p)}warn(i,...p){this.logger.warn(i,...p)}error(i,...p){this.logger.error(i,...p)}critical(i,...p){this.logger.critical(i,...p)}flush(){this.logger.flush()}}e.LogService=u;class g extends _.Disposable{constructor(i,p){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(p(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(a))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,p){let a=this.loggers.get(i.toString());return a||(a=this.doCreateLogger(i,p?.always?D.Trace:this.logLevel,p),this.loggers.set(i.toString(),a),p?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class I{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return D.Info}trace(i,...p){}debug(i,...p){}info(i,...p){}warn(i,...p){}error(i,...p){}critical(i,...p){}dispose(){}flush(){}}e.NullLogService=I;function E(C){if(C.verbose)return D.Trace;if(typeof C.logLevel=="string"){const i=o(C.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function o(C){switch(C){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=o;function h(C){switch(C){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=h}),define(be[83],Ee([0,1,35,122,4]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var F;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(F=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function P(s,u){return u-s}D.compare=P;const t=Object.create(null);t[D.Error]=(0,M.localize)(0,null),t[D.Warning]=(0,M.localize)(1,null),t[D.Info]=(0,M.localize)(2,null);function y(s){return t[s]||""}D.toString=y;function n(s){switch(s){case d.default.Error:return D.Error;case d.default.Warning:return D.Warning;case d.default.Info:return D.Info;case d.default.Ignore:return D.Hint}}D.fromSeverity=n;function m(s){switch(s){case D.Error:return d.default.Error;case D.Warning:return d.default.Warning;case D.Info:return d.default.Info;case D.Hint:return d.default.Ignore}}D.toSeverity=m}(F=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(D){const P="";function t(n){return y(n,!0)}D.makeKey=t;function y(n,m){let s=[P];return n.source?s.push(n.source.replace("\xA6","\\\xA6")):s.push(P),n.code?typeof n.code=="string"?s.push(n.code.replace("\xA6","\\\xA6")):s.push(n.code.value.replace("\xA6","\\\xA6")):s.push(P),n.severity!==void 0&&n.severity!==null?s.push(F.toString(n.severity)):s.push(P),n.message&&m?s.push(n.message.replace("\xA6","\\\xA6")):s.push(P),n.startLineNumber!==void 0&&n.startLineNumber!==null?s.push(n.startLineNumber.toString()):s.push(P),n.startColumn!==void 0&&n.startColumn!==null?s.push(n.startColumn.toString()):s.push(P),n.endLineNumber!==void 0&&n.endLineNumber!==null?s.push(n.endLineNumber.toString()):s.push(P),n.endColumn!==void 0&&n.endColumn!==null?s.push(n.endColumn.toString()):s.push(P),s.push(P),s.join("\xA6")}D.makeKeyOptionalMessage=y})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(be[144],Ee([0,1,3,35,4]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,_.createDecorator)("notificationService");var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var F;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(F=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new D,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=k;class D{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=D}),define(be[145],Ee([0,1,6,9,2,4]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(k){return{resolved:k,dispose(){}}}});function F(k,D){return _.URI.isUri(k)?(0,M.equalsIgnoreCase)(k.scheme,D):(0,M.startsWithIgnoreCase)(k,D+":")}e.matchesScheme=F});var $e=this&&this.__decorate||function(oe,e,d,M){var _=arguments.length,A=_<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,d):M,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(oe,e,d,M);else for(var k=oe.length-1;k>=0;k--)(F=oe[k])&&(A=(_<3?F(A):_>3?F(e,d,A):F(e,d))||A);return _>3&&A&&Object.defineProperty(e,d,A),A},ze=this&&this.__param||function(oe,e){return function(d,M){e(d,M,oe)}};define(be[146],Ee([0,1,12,21,6,4]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var F;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(F=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let D=class extends _.Disposable{constructor(y,n){super();this.deferred=new d.DeferredPromise,n.withProgress(y,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,_.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};D=$e([ze(1,e.IProgressService)],D),e.UnmanagedProgress=D;class P extends _.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new _.DisposableStore)}start(y){this.stop();const n=++this.currentOperationId,m=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,_.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,_.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,_.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:m.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,42,10]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class _{constructor(){this.data=new Map}add(F,k){d.ok(M.isString(F)),d.ok(M.isObject(k)),d.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,k)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}e.Registry=new _}),define(be[84],Ee([0,1,3,28]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function _(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,P){this.schemasById[_(D)]=P,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new A;M.Registry.add(e.Extensions.JSONContribution,F)}),define(be[62],Ee([0,1,14,3,10,119,84,28]),function(oe,e,d,M,_,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=k.Registry.as(F.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(o,h=!0){this.registerConfigurations([o],h)}registerConfigurations(o,h=!0){const C=this.doRegisterConfigurations(o,h);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(C)}deregisterConfigurations(o){const h=this.doDeregisterConfigurations(o);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}updateConfigurations({add:o,remove:h}){const C=[];C.push(...this.doDeregisterConfigurations(h)),C.push(...this.doRegisterConfigurations(o,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,d.distinct)(C))}registerDefaultConfigurations(o){const h=[],C=[];for(const i of o)for(const p in i)if(h.push(p),e.OVERRIDE_PROPERTY_PATTERN.test(p)){this.defaultValues[p]={...this.defaultValues[p]||{},...i[p]};const a={type:"object",default:this.defaultValues[p],description:A.localize(1,null,p),$ref:e.resourceLanguageSettingsSchemaId};C.push(m(p)),this.configurationProperties[p]=a,this.defaultLanguageConfigurationOverridesNode.properties[p]=a}else{this.defaultValues[p]=i[p];const a=this.configurationProperties[p];a&&(this.updatePropertyDefaultValue(p,a),this.updateSchema(p,a))}this.registerOverrideIdentifiers(C),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterDefaultConfigurations(o){const h=[];for(const C of o)for(const i in C)if(h.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const p=this.configurationProperties[i];p&&(this.updatePropertyDefaultValue(i,p),this.updateSchema(i,p))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const h of o)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,h){const C=[];return o.forEach(i=>{C.push(...this.validateAndRegisterProperties(i,h,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),C}doDeregisterConfigurations(o){const h=[],C=i=>{if(i.properties)for(const p in i.properties)h.push(p),delete this.configurationProperties[p],this.removeFromSchema(p,i.properties[p]);i.allOf&&i.allOf.forEach(p=>C(p))};for(const i of o){C(i);const p=this.configurationContributors.indexOf(i);p!==-1&&this.configurationContributors.splice(p,1)}return h}validateAndRegisterProperties(o,h=!0,C,i=3){i=_.isUndefinedOrNull(o.scope)?i:o.scope;let p=[],a=o.properties;if(a)for(let v in a){if(h&&g(v)){delete a[v];continue}const l=a[v];if(this.updatePropertyDefaultValue(v,l),e.OVERRIDE_PROPERTY_PATTERN.test(v)?l.scope=void 0:(l.scope=_.isUndefinedOrNull(l.scope)?i:l.scope,l.restricted=_.isUndefinedOrNull(l.restricted)?!!C?.restrictedConfigurations?.includes(v):l.restricted),a[v].hasOwnProperty("included")&&!a[v].included){this.excludedConfigurationProperties[v]=a[v],delete a[v];continue}else this.configurationProperties[v]=a[v];!a[v].deprecationMessage&&a[v].markdownDeprecationMessage&&(a[v].deprecationMessage=a[v].markdownDeprecationMessage),p.push(v)}let r=o.allOf;if(r)for(let v of r)p.push(...this.validateAndRegisterProperties(v,h,C,i));return p}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(o){const h=C=>{let i=C.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);let p=C.allOf;p&&p.forEach(h)};h(o)}updateSchema(o,h){switch(e.allSettings.properties[o]=h,h.scope){case 1:e.applicationSettings.properties[o]=h;break;case 2:e.machineSettings.properties[o]=h;break;case 6:e.machineOverridableSettings.properties[o]=h;break;case 3:e.windowSettings.properties[o]=h;break;case 4:e.resourceSettings.properties[o]=h;break;case 5:e.resourceSettings.properties[o]=h,this.resourceLanguageSettingsSchema.properties[o]=h;break}}removeFromSchema(o,h){switch(delete e.allSettings.properties[o],h.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const h=`[${o}]`,C={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,C),e.allSettings.properties[h]=C,e.applicationSettings.properties[h]=C,e.machineSettings.properties[h]=C,e.machineOverridableSettings.properties[h]=C,e.windowSettings.properties[h]=C,e.resourceSettings.properties[h]=C}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,h){let C=this.defaultValues[o];_.isUndefined(C)&&(C=h.default),_.isUndefined(C)&&(C=s(h.type)),h.default=C}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function m(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=m;function s(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=s;const u=new y;k.Registry.add(e.Extensions.Configuration,u);function g(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?A.localize(5,null,E):u.getConfigurationProperties()[E]!==void 0?A.localize(6,null,E):null:A.localize(4,null)}e.validateProperty=g;function I(){const E=[],o=u.getConfigurationProperties();for(const h of Object.keys(o))E.push([h,o[h].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=I}),define(be[85],Ee([0,1,23,10,2,62,4,28]),function(oe,e,d,M,_,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,F.createDecorator)("configurationService");function D(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof _.URI)}e.isConfigurationOverrides=D;var P;(function(p){p[p.USER=1]="USER",p[p.USER_LOCAL=2]="USER_LOCAL",p[p.USER_REMOTE=3]="USER_REMOTE",p[p.WORKSPACE=4]="WORKSPACE",p[p.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",p[p.DEFAULT=6]="DEFAULT",p[p.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(p){switch(p){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function y(p,a){const r=a?p?a.keys.filter(R=>p.keys.indexOf(R)===-1):[...a.keys]:[],v=p?a?p.keys.filter(R=>a.keys.indexOf(R)===-1):[...p.keys]:[],l=[];if(a&&p){for(const R of p.keys)if(a.keys.indexOf(R)!==-1){const T=I(p.contents,R),L=I(a.contents,R);d.equals(T,L)||l.push(R)}}const c=[],w=R=>{const T={};for(const L of R)for(const b of L.identifiers)T[C(b)]=L;return T},f=a?w(a.overrides):{},S=p?w(p.overrides):{};if(Object.keys(f).length)for(const R of r){const T=f[R];T&&c.push([(0,A.overrideIdentifierFromKey)(R),T.keys])}if(Object.keys(S).length)for(const R of v){const T=S[R];T&&c.push([(0,A.overrideIdentifierFromKey)(R),T.keys])}if(Object.keys(f).length&&Object.keys(S).length)for(const R of l){const T=S[R],L=f[R];if(T&&L){const b=y({contents:T.contents,keys:T.keys,overrides:[]},{contents:L.contents,keys:L.keys,overrides:[]});c.push([(0,A.overrideIdentifierFromKey)(R),[...b.added,...b.removed,...b.updated]])}}return{added:r,removed:v,updated:l,overrides:c}}e.compare=y;function n(p,a){const r=[];for(const v of Object.keys(p))if(A.OVERRIDE_PROPERTY_PATTERN.test(v)){const l={};for(const c in p[v])l[c]=p[v][c];r.push({identifiers:[(0,A.overrideIdentifierFromKey)(v).trim()],keys:Object.keys(l),contents:m(l,a)})}return r}e.toOverrides=n;function m(p,a){const r=Object.create(null);for(let v in p)s(r,v,p[v],a);return r}e.toValuesTree=m;function s(p,a,r,v){const l=a.split("."),c=l.pop();let w=p;for(let f=0;f<l.length;f++){let S=l[f],R=w[S];switch(typeof R){case"undefined":R=w[S]=Object.create(null);break;case"object":break;default:v(`Ignoring ${a} as ${l.slice(0,f+1).join(".")} is ${JSON.stringify(R)}`);return}w=R}if(typeof w=="object"&&w!==null)try{w[c]=r}catch(f){v(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(w)}`)}else v(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=s;function u(p,a){const r=a.split(".");g(p,r)}e.removeFromValueTree=u;function g(p,a){const r=a.shift();if(a.length===0){delete p[r];return}if(Object.keys(p).indexOf(r)!==-1){const v=p[r];typeof v=="object"&&!Array.isArray(v)&&(g(v,a),Object.keys(v).length===0&&delete p[r])}}function I(p,a,r){function v(w,f){let S=w;for(const R of f){if(typeof S!="object"||S===null)return;S=S[R]}return S}const l=a.split("."),c=v(p,l);return typeof c=="undefined"?r:c}e.getConfigurationValue=I;function E(p,a,r){Object.keys(a).forEach(v=>{v!=="__proto__"&&(v in p?M.isObject(p[v])&&M.isObject(a[v])?E(p[v],a[v],r):r&&(p[v]=a[v]):p[v]=a[v])})}e.merge=E;function o(){const p=k.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(p)}e.getConfigurationKeys=o;function h(){const p=Object.create(null),a=k.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let r in a){let v=a[r].default;s(p,r,v,l=>console.error(`Conflict in default settings: ${l}`))}return p}e.getDefaultValues=h;function C(p){return`[${p}]`}e.keyFromOverrideIdentifier=C;function i(p,a,r){const v=p.inspect(a),l=p.inspect(r);return typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:v.defaultValue}e.getMigratedSettingValue=i}),define(be[147],Ee([0,1,14,3,102,6,20,23,10,2,85,62,28]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(i={},p=[],a=[]){this._contents=i,this._keys=p,this._overrides=a,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,p){const a=this.getContentsForOverrideIdentifer(p);return a?i?(0,t.getConfigurationValue)(a,i):a:void 0}getKeysForOverrideIdentifier(i){for(const p of this.overrides)if(p.identifiers.indexOf(i)!==-1)return p.keys;return[]}override(i){let p=this.overrideConfigurations.get(i);return p||(p=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,p)),p}merge(...i){const p=k.deepClone(this.contents),a=k.deepClone(this.overrides),r=[...this.keys];for(const v of i){this.mergeContents(p,v.contents);for(const l of v.overrides){const[c]=a.filter(w=>d.equals(w.identifiers,l.identifiers));c?this.mergeContents(c.contents,l.contents):a.push(k.deepClone(l))}for(const l of v.keys)r.indexOf(l)===-1&&r.push(l)}return new m(p,r,a)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const p=this.getContentsForOverrideIdentifer(i);if(!p||typeof p!="object"||!Object.keys(p).length)return this;let a={};for(const r of d.distinct([...Object.keys(this.contents),...Object.keys(p)])){let v=this.contents[r],l=p[r];l&&(typeof v=="object"&&typeof l=="object"?(v=k.deepClone(v),this.mergeContents(v,l)):v=l),a[r]=v}return new m(a,this.keys,this.overrides)}mergeContents(i,p){for(const a of Object.keys(p)){if(a in i&&D.isObject(i[a])&&D.isObject(p[a])){this.mergeContents(i[a],p[a]);continue}i[a]=k.deepClone(p[a])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?k.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const p of this.overrides)if(p.identifiers.indexOf(i)!==-1)return p.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,p){this.addKey(i),(0,t.addToValueTree)(this.contents,i,p,a=>{throw new Error(a)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let p=this.keys.length;for(let a=0;a<p;a++)i.indexOf(this.keys[a])===0&&(p=a);this.keys.splice(p,1,i)}removeKey(i){let p=this.keys.indexOf(i);return p!==-1?(this.keys.splice(p,1),!0):!1}}e.ConfigurationModel=m;class s extends m{constructor(){const i=(0,t.getDefaultValues)(),p=(0,t.getConfigurationKeys)(),a=[];for(const r of Object.keys(i))y.OVERRIDE_PROPERTY_PATTERN.test(r)&&a.push({identifiers:[(0,y.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(i[r]),contents:(0,t.toValuesTree)(i[r],v=>console.error(`Conflict in default settings file: ${v}`))});super(i,p,a)}}e.DefaultConfigurationModel=s;class u{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,p){if(!D.isUndefinedOrNull(i)){const a=this.doParseContent(i);this.parseRaw(a,p)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,p){this._raw=i;const{contents:a,keys:r,overrides:v,restricted:l}=this.doParseRaw(i,p);this._configurationModel=new m(a,r,v),this._restrictedConfigurations=l||[]}doParseContent(i){let p={},a=null,r=[],v=[],l=[];function c(f){Array.isArray(r)?r.push(f):a!==null&&(r[a]=f)}let w={onObjectBegin:()=>{let f={};c(f),v.push(r),r=f,a=null},onObjectProperty:f=>{a=f},onObjectEnd:()=>{r=v.pop()},onArrayBegin:()=>{let f=[];c(f),v.push(r),r=f,a=null},onArrayEnd:()=>{r=v.pop()},onLiteralValue:c,onError:(f,S,R)=>{l.push({error:f,offset:S,length:R})}};if(i)try{_.visit(i,w),p=r[0]||{}}catch(f){console.error(`Error while parsing settings file ${this._name}: ${f}`),this._parseErrors=[f]}return p}doParseRaw(i,p){const a=n.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,a,!0,p);i=r.raw;const v=(0,t.toValuesTree)(i,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),l=Object.keys(i),c=(0,t.toOverrides)(i,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:v,keys:l,overrides:c,restricted:r.restricted}}filter(i,p,a,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const v={},l=[];for(let c in i)if(y.OVERRIDE_PROPERTY_PATTERN.test(c)&&a){const w=this.filter(i[c],p,!1,r);v[c]=w.raw,l.push(...w.restricted)}else{const w=p[c],f=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&l.push(c),(f===void 0||r.scopes===void 0||r.scopes.includes(f))&&(r.skipRestricted&&w?.restricted||(v[c]=i[c]))}return{raw:v,restricted:l}}}e.ConfigurationModelParser=u;class g extends A.Disposable{constructor(i,p,a,r){super();this.userSettingsResource=i,this.scopes=p,this.fileService=r,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,v=>v.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class I{constructor(i,p,a=new m,r=new m,v=new F.ResourceMap,l=new m,c=new F.ResourceMap,w=!0){this._defaultConfiguration=i,this._localUserConfiguration=p,this._remoteUserConfiguration=a,this._workspaceConfiguration=r,this._folderConfigurations=v,this._memoryConfiguration=l,this._memoryConfigurationByResource=c,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(i,p,a){return this.getConsolidateConfigurationModel(p,a).getValue(i)}updateValue(i,p,a={}){let r;a.resource?(r=this._memoryConfigurationByResource.get(a.resource),r||(r=new m,this._memoryConfigurationByResource.set(a.resource,r))):r=this._memoryConfiguration,p===void 0?r.removeValue(i):r.setValue(i,p),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,p,a){const r=this.getConsolidateConfigurationModel(p,a),v=this.getFolderConfigurationModelForResource(p.resource,a),l=p.resource?this._memoryConfigurationByResource.get(p.resource)||this._memoryConfiguration:this._memoryConfiguration,c=p.overrideIdentifier?this._defaultConfiguration.freeze().override(p.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),w=p.overrideIdentifier?this.userConfiguration.freeze().override(p.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),f=p.overrideIdentifier?this.localUserConfiguration.freeze().override(p.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),S=p.overrideIdentifier?this.remoteUserConfiguration.freeze().override(p.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),R=a?p.overrideIdentifier?this._workspaceConfiguration.freeze().override(p.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,T=v?p.overrideIdentifier?v.freeze().override(p.overrideIdentifier).getValue(i):v.freeze().getValue(i):void 0,L=p.overrideIdentifier?l.override(p.overrideIdentifier).getValue(i):l.getValue(i),b=r.getValue(i),x=d.distinct(d.flatten(r.overrides.map($=>$.identifiers))).filter($=>r.getOverrideValue(i,$)!==void 0);return{defaultValue:c,userValue:w,userLocalValue:f,userRemoteValue:S,workspaceValue:R,workspaceFolderValue:T,memoryValue:L,value:b,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:p.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:p.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,userLocal:f!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:p.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,userRemote:S!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:p.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:p.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,workspaceFolder:T!==void 0?{value:v?.freeze().getValue(i),override:p.overrideIdentifier?v?.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,memory:L!==void 0?{value:l.getValue(i),override:p.overrideIdentifier?l.getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,overrideIdentifiers:x.length?x:void 0}}keys(i){const p=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:p?p.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,p){this._folderConfigurations.set(i,p),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,p){const a=p.filter(r=>y.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const v=(0,y.overrideIdentifierFromKey)(r),l=this._defaultConfiguration.getKeysForOverrideIdentifier(v),c=i.getKeysForOverrideIdentifier(v),w=[...c.filter(f=>l.indexOf(f)===-1),...l.filter(f=>c.indexOf(f)===-1),...l.filter(f=>!k.equals(this._defaultConfiguration.override(v).getValue(f),i.override(v).getValue(f)))];return[v,w]});return this.updateDefaultConfiguration(i),{keys:p,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:p,updated:a,removed:r,overrides:v}=(0,t.compare)(this.localUserConfiguration,i),l=[...p,...a,...r];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:v}}compareAndUpdateRemoteUserConfiguration(i){const{added:p,updated:a,removed:r,overrides:v}=(0,t.compare)(this.remoteUserConfiguration,i);let l=[...p,...a,...r];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:v}}compareAndUpdateWorkspaceConfiguration(i){const{added:p,updated:a,removed:r,overrides:v}=(0,t.compare)(this.workspaceConfiguration,i);let l=[...p,...a,...r];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:v}}compareAndUpdateFolderConfiguration(i,p){const a=this.folderConfigurations.get(i),{added:r,updated:v,removed:l,overrides:c}=(0,t.compare)(a,p);let w=[...r,...v,...l];return(w.length||!a)&&this.updateFolderConfiguration(i,p),{keys:w,overrides:c}}compareAndDeleteFolderConfiguration(i){const p=this.folderConfigurations.get(i);if(!p)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:a,updated:r,removed:v,overrides:l}=(0,t.compare)(p,void 0);return{keys:[...a,...r,...v],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,p){let a=this.getConsolidatedConfigurationModelForResource(i,p);return i.overrideIdentifier?a.override(i.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:i},p){let a=this.getWorkspaceConsolidatedConfiguration();if(p&&i){const r=p.getFolder(i);r&&(a=this.getFolderConsolidatedConfiguration(r.uri)||a);const v=this._memoryConfigurationByResource.get(i);v&&(a=a.merge(v))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let p=this._foldersConsolidatedConfigurations.get(i);if(!p){const a=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(p=a.merge(r),this._freeze&&(p=p.freeze()),this._foldersConsolidatedConfigurations.set(i,p)):p=a}return p}getFolderConfigurationModelForResource(i,p){if(p&&i){const a=p.getFolder(i);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,p)=>{const{contents:a,overrides:r,keys:v}=this._folderConfigurations.get(p);return i.push([p,{contents:a,overrides:r,keys:v}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(p=>i.add(p)),this.userConfiguration.freeze().keys.forEach(p=>i.add(p)),this._workspaceConfiguration.freeze().keys.forEach(p=>i.add(p)),this._folderConfigurations.forEach(p=>p.freeze().keys.forEach(a=>i.add(a))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const p=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>p.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>p.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>p.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(i).forEach(r=>p.add(r))),[...p.values()]}static parse(i){const p=this.parseConfigurationModel(i.defaults),a=this.parseConfigurationModel(i.user),r=this.parseConfigurationModel(i.workspace),v=i.folders.reduce((l,c)=>(l.set(P.URI.revive(c[0]),this.parseConfigurationModel(c[1])),l),new F.ResourceMap);return new I(p,a,new m,r,v,new m,new F.ResourceMap,!1)}static parseConfigurationModel(i){return new m(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=I;function E(...C){if(C.length===0)return{keys:[],overrides:[]};if(C.length===1)return C[0];const i=new Set,p=new Map;for(const r of C)r.keys.forEach(v=>i.add(v)),r.overrides.forEach(([v,l])=>{const c=(0,F.getOrSet)(p,v,new Set);l.forEach(w=>c.add(w))});const a=[];return p.forEach((r,v)=>a.push([v,[...r.values()]])),{keys:[...i.values()],overrides:a}}e.mergeChanges=E;class o{constructor(i,p,a,r){this.change=i,this.previous=p,this.currentConfiguraiton=a,this.currentWorkspace=r,this._previousConfiguration=void 0;const v=new Set;i.keys.forEach(c=>v.add(c)),i.overrides.forEach(([,c])=>c.forEach(w=>v.add(w))),this.affectedKeys=[...v.values()];const l=new m;this.affectedKeys.forEach(c=>l.setValue(c,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,p){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(p){const a=this.previousConfiguration?this.previousConfiguration.getValue(i,p,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,p,this.currentWorkspace);return!k.equals(a,r)}return!0}return!1}doesAffectedKeysTreeContains(i,p){let a=(0,t.toValuesTree)({[p]:!0},()=>{}),r;for(;typeof a=="object"&&(r=Object.keys(a)[0]);){if(i=i[r],!i)return!1;a=a[r]}return!0}}e.ConfigurationChangeEvent=o;class h extends o{constructor(i,p,a,r){super({keys:i.allKeys(),overrides:[]},void 0,i,p);this.source=a,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=h}),define(be[86],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var M;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class _ extends Error{constructor(F,k=M.Unknown,D){super(F);this._message=F,this._code=k,this._detail=D,this.isHandled=k===M.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype)}static isTemporarilyNotAvailable(F){return F instanceof _&&F._code===M.TemporarilyNotAvailable}static isNoResolverFound(F){return F instanceof _&&F._code===M.NoResolverFound}static isHandled(F){return F instanceof _&&F.isHandled}}e.RemoteAuthorityResolverError=_}),define(be[63],Ee([0,1,11]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(P){return P.scheme===d.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=M;function _(P){if(!P)return;const t=P.indexOf("+");return t<0?P:P.substr(0,t)}e.getRemoteName=_;function A(P){return P.scheme!==d.Schemas.file&&P.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=A;function F(P){if(P.folders.length)return P.folders.every(t=>A(t.uri))?P.folders[0].uri:void 0;if(P.configuration&&A(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=F;function k(P){return F(P)?.scheme}e.getVirtualWorkspaceScheme=k;function D(P){return F(P)!==void 0}e.isVirtualWorkspace=D}),define(be[26],Ee([0,1,9,4,63]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=A;function F(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=F,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class D{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,s){if(typeof m=="undefined"||m===null)return typeof s=="undefined"||s===null;if(typeof s=="undefined"||s===null)return!1;if(typeof m=="string"||typeof s=="string"){let u=typeof m=="string"?m:m.value,g=typeof s=="string"?s:s.value;return d.equalsIgnoreCase(u,g)}return m._lower===s._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=D;function P(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function t(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=t;function y(n,m){if(m&&n.enableProposedApi){const s=`onResolveRemoteAuthority:${(0,_.getRemoteName)(m)}`;return n.activationEvents?.indexOf(s)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[148],Ee([0,1,9,26]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function _(s,u){return s.uuid&&u.uuid?s.uuid===u.uuid:s.id===u.id?!0:(0,d.compareIgnoreCase)(s.id,u.id)===0}e.areSameExtensions=_;class A{constructor(u,g){this.version=g,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof A?_(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=A;function F(s,u){return`${s}.${u}`}e.getExtensionId=F;function k(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function D(s,u){return k(F(s,u))}e.getGalleryExtensionId=D;function P(s,u){const g=[],I=E=>{for(const o of g)if(o.some(h=>_(u(h),u(E))))return o;return null};for(const E of s){const o=I(E);o?o.push(E):g.push([E])}return g}e.groupByExtension=P;function t(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function y(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(s){const u=new Set;for(const g of s)g.malicious&&u.add(g.id.id);return u}e.getMaliciousExtensionsSet=n;function m(s,u){const g=[],I=u.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const E=I.shift();if(E&&g.every(o=>!_(o.identifier,{id:E}))){const o=s.filter(h=>_(h.identifier,{id:E}));o.length===1&&(g.push(o[0]),I.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}e.getExtensionDependencies=m}),define(be[149],Ee([0,1,3,25,4,15]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,_.createDecorator)("tunnelService");var F;(function(s){s.Http="http",s.Https="https"})(F=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function t(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=t,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=y;function n(s,u){return u?u!==1&&s<1024:!M.isWindows&&s<1024}e.isPortPrivileged=n;let m=class{constructor(u){this.logService=u,this._onTunnelOpened=new d.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new d.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new d.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u,g){return this._tunnelProvider=u,u?(this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],g=Array.from(this._tunnels.values());for(let I of g){const E=Array.from(I.values());for(let o of E){const h=await o.value;h&&u.push(h)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:g}of u.values())await g.then(I=>I?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,g,I,E,o=!1,h=k.Private,C){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${I} on local port ${E}.`),!u)return;g||(g="localhost");const i=this.retainOrCreateTunnel(u,g,I,E,o,h,C);return i?i.then(p=>{if(!p){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,I);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(p);return(p.tunnelRemoteHost!==g||p.tunnelRemotePort!==I)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const g=this._tunnels.get(u.tunnelRemoteHost);if(g){const I=g.get(u.tunnelRemotePort);I&&(I.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,I))}}}}async tryDisposeTunnel(u,g,I){if(I.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${g}.`);const E=I.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(g),E}}async closeTunnel(u,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${g} `);const I=this._tunnels.get(u);if(I&&I.has(g)){const E=I.get(g);E.refcount=0,await this.tryDisposeTunnel(u,g,E)}}addTunnelToMap(u,g,I){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(g,{refcount:1,value:I})}async removeEmptyTunnelFromMap(u,g){const I=this._tunnels.get(u);I&&(await I.get(g)||I.delete(g),I.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,g){let I=[u];t(u)?(I.push(...e.LOCALHOST_ADDRESSES),I.push(...e.ALL_INTERFACES_ADDRESSES)):y(u)&&I.push(...e.ALL_INTERFACES_ADDRESSES);const E=I.map(o=>this._tunnels.get(o));for(const o of E){const h=o?.get(g);if(h)return h}}canTunnel(u){return!!P(u)}createWithProvider(u,g,I,E,o,h,C){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${I} on local port ${E}.`);const p={elevationRequired:o?n(E===void 0?I:E):!1},a={remoteAddress:{host:g,port:I},localAddressPort:E,privacy:h,public:h!==k.Private,protocol:C},r=u.forwardPort(a,p);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(g,I,r),r}};m=$e([ze(0,A.ILogService)],m),e.AbstractTunnelService=m}),define(be[150],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(_){this._callback=_,this._terminalBufferMap=new Map}dispose(){for(const _ of this._terminalBufferMap.values())_.dispose()}startBuffering(_,A,F=5){let k;return k=A(D=>{const P=typeof D=="string"?D:D.data;let t=this._terminalBufferMap.get(_);if(t){t.data.push(P);return}const y=setTimeout(()=>this.flushBuffer(_),F);t={data:[P],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(_),k.dispose()}},this._terminalBufferMap.set(_,t)}),k}stopBuffering(_){const A=this._terminalBufferMap.get(_);A&&A.dispose()}flushBuffer(_){const A=this._terminalBufferMap.get(_);A&&(this._terminalBufferMap.delete(_),this._callback(_,A.data.join("")))}}e.TerminalDataBufferer=d}),define(be[151],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var d;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(d=e.ColorScheme||(e.ColorScheme={}))}),define(be[47],Ee([0,1,34,3,6,4,28,151]),function(oe,e,d,M,_,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var D;(function(g){function I(E){return E&&typeof E=="object"&&typeof E.id=="string"}g.isThemeColor=I})(D=e.ThemeColor||(e.ThemeColor={}));function P(g){return{id:g}}e.themeColorFromId=P;var t;(function(g){function I(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color=="undefined"||D.isThemeColor(p.color))}g.isThemeIcon=I;const E=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function o(p){const a=E.exec(p);if(!a)return;let[,r]=a;return{id:r}}g.fromString=o;function h(p,a){let r=p.id;const v=r.lastIndexOf("~");return v!==-1&&(r=r.substring(0,v)),a&&(r=`${r}~${a}`),{id:r}}g.modify=h;function C(p,a){return p.id===a.id&&p.color?.id===a.color?.id}g.isEqual=C;function i(p,a){return{id:p.id,color:a?P(a):void 0}}g.asThemeIcon=i,g.asClassNameArray=d.CSSIcon.asClassNameArray,g.asClassName=d.CSSIcon.asClassName,g.asCSSSelector=d.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function y(g){switch(g){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,_.toDisposable)(()=>{const E=this.themingParticipants.indexOf(I);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new n;F.Registry.add(e.Extensions.ThemingContribution,m);function s(g){return m.onColorThemeChange(g)}e.registerThemingParticipant=s;class u extends _.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,E){let o=this.theme.getColor(I);return o&&E&&(o=E(o,this.theme)),o?o.toString():null}}e.Themable=u}),define(be[152],Ee([0,1,12,34,3,123,84,28,47]),function(oe,e,d,M,_,A,F,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(I,E,o,h){const C=this.iconsById[I];if(C){if(o&&!C.description){C.description=o,this.iconSchema.properties[I].markdownDescription=`${o} $(${I})`;const a=this.iconReferenceSchema.enum.indexOf(I);a!==-1&&(this.iconReferenceSchema.enumDescriptions[a]=o),this._onDidChange.fire()}return C}let i={id:I,description:o,defaults:E,deprecationMessage:h};this.iconsById[I]=i;let p={$ref:"#/definitions/icons"};return h&&(p.deprecationMessage=h),o&&(p.markdownDescription=`${o}: $(${I})`),this.iconSchema.properties[I]=p,this.iconReferenceSchema.enum.push(I),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:I}}deregisterIcon(I){delete this.iconsById[I],delete this.iconSchema.properties[I];const E=this.iconReferenceSchema.enum.indexOf(I);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(I=>this.iconsById[I])}getIcon(I){return this.iconsById[I]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(I,E){const o=this.iconFontsById[I];if(o)return o;let h={id:I,definition:E};return this.iconFontsById[I]=h,this._onDidChange.fire(),h}deregisterIconFont(I){delete this.iconFontsById[I]}getIconFonts(){return Object.keys(this.iconFontsById).map(I=>this.iconFontsById[I])}getIconFont(I){return this.iconFontsById[I]}toString(){const I=(C,i)=>C.id.localeCompare(i.id),E=C=>{for(;D.ThemeIcon.isThemeIcon(C.defaults);)C=this.iconsById[C.defaults.id];return`codicon codicon-${C?C.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.iconsById).map(C=>this.iconsById[C]);for(const C of h.filter(i=>!!i.description).sort(I))o.push(`|<i class="${E(C)}"></i>|${C.id}|${D.ThemeIcon.isThemeIcon(C.defaults)?C.defaults.id:C.id}|${C.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const C of h.filter(i=>!D.ThemeIcon.isThemeIcon(i.defaults)).sort(I))o.push(`|<i class="${E(C)}"></i>|${C.id}|`);return o.join(`
`)}}const t=new P;k.Registry.add(e.Extensions.IconContribution,t);function y(g,I,E,o){return t.registerIcon(g,I,E,o)}e.registerIcon=y;function n(){return t}e.getIconRegistry=n;function m(){for(const g of M.iconRegistry.all)t.registerIcon(g.id,g.definition,g.description);M.iconRegistry.onDidRegister(g=>t.registerIcon(g.id,g.definition,g.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let s=k.Registry.as(F.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,t.getIconSchema());const u=new d.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.widgetClose=y("widget-close",M.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=y("goto-previous-location",M.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=y("goto-next-location",M.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=D.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(be[48],Ee([0,1,20,24,2,4]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var F;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(F=e.WorkbenchState||(e.WorkbenchState={}));function k(n){const m=n;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=k;function D(n){const m=n;return!!(m&&typeof m=="object"&&_.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=D;class P{constructor(m,s,u,g,I){this._id=m,this._transient=u,this._configuration=g,this._ignorePathCasing=I,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class t{constructor(m,s){this.raw=s,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,M.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function y(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=y}),define(be[64],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(_){this.id=_,this._data=new Map,this._idPool=1}add(_){const A=this._idPool++;return this._data.set(A,_),this.logDebugInfo(),A}get(_,A){return this._data.has(_)?this._data.get(_)[A]:void 0}delete(_){this._data.delete(_),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(be[37],Ee([0,1,11,24,4]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(k=>{const D=this._providerInfo.get(k.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(k,D){D===null?this._providerInfo.delete(k):this._providerInfo.set(k,D)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,_.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(be[153],Ee([0,1,12]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(F,k,D){this._deferredPromises=new Map,this._id=F,this._shared=k,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of P.values())t.complete()}catch(t){for(const y of P.values())y.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this._init}get(F,k){let D=this._value[F];return typeof D=="undefined"&&(D=k),D}update(F,k){this._value[F]=k;let D=this._deferredPromises.get(F);if(D!==void 0)return D.p;const P=new d.DeferredPromise;return this._deferredPromises.set(F,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class _ extends M{constructor(F,k){super(F.identifier.value,!0,k);this._extension=F}setKeysForSync(F){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},F)}}e.ExtensionGlobalMemento=_}),define(be[154],Ee([0,1,3,2,15]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(k,D){this._logService=k,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new d.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,D,P){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k)).acceptModelChanged(D.value,P)}$acceptDirtyStateChanged(k,D){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k)).acceptDirty(D)}$acceptModelSaved(k){const D=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(k,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,D);const P=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(k));P.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};A=$e([ze(0,_.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(be[13],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=M});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[155],Ee([0,1,26,3]),function(oe,e,d,M){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(k,D){_.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(k.identifier),Ze(this,_,D,"f"),Re(this,_,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(k){return Re(this,_,"f").get(this._id,k)}store(k,D){return Re(this,_,"f").store(this._id,k,D)}delete(k){return Re(this,_,"f").delete(this._id,k)}}e.ExtensionSecrets=A,_=new WeakMap}),define(be[87],Ee([0,1,4,3]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class _{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(F){this._enabled=F}$onDidChangeTelemetryEnabled(F){this._enabled=F,this._onDidChangeTelemetryEnabled.fire(F)}}e.ExtHostTelemetry=_,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(be[49],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var d;(function(E){E[E.Upsert=0]="Upsert",E[E.RemoveChild=1]="RemoveChild",E[E.Invalidated=2]="Invalidated",E[E.SetProp=3]="SetProp",E[E.Bulk=4]="Bulk"})(d=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,_=(E,o)=>{const h={controllerId:o};return M.set(E,h),h};e.createPrivateApiFor=_;const A=E=>M.get(E);e.getPrivateApiFor=A;const F=(E,o,h,C)=>{let i=h;return{enumerable:!0,configurable:!1,get(){return i},set(p){if(!C(i,p)){const a=i;i=p,E.listener?.({op:3,key:o,value:p,previous:a})}}}},k=(E,o)=>E===o,D={range:(E,o)=>E===o?!0:!E||!o?!1:E.isEqual(o),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(E,o)=>!(E.length!==o.length||E.some(h=>!o.find(C=>h.id===C.id)))},P=Object.keys(D),t=(E,o)=>({range:F(E,"range",void 0,D.range),label:F(E,"label",o,D.label),description:F(E,"description",void 0,D.description),canResolveChildren:F(E,"canResolveChildren",!1,D.canResolveChildren),busy:F(E,"busy",!1,D.busy),error:F(E,"error",void 0,D.error),tags:F(E,"tags",[],D.tags)}),y=(E,o)=>{const h=new Map;for(const C of P)D[C](E[C],o[C])||h.set(C,o[C]);return h};e.diffTestItems=y;class n extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=n;class m extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class s extends Error{constructor(o,h,C){super(`TestItem with ID "${o}" is from controller "${h}" and cannot be added as a child of an item from controller "${C}".`)}}e.MixedTestItemController=s;const u=E=>{const o=(0,e.getPrivateApiFor)(E);let h=new Map;return{get size(){return h.size},forEach(C,i){for(const p of h.values())C.call(i,p,this)},replace(C){const i=new Map,p=new Set(h.keys()),a={op:4,ops:[]};for(const r of C){if(!(r instanceof g))throw new m(r.id);const v=(0,e.getPrivateApiFor)(r).controllerId;if(v!==o.controllerId)throw new s(r.id,v,o.controllerId);if(i.has(r.id))throw new n(r.id);i.set(r.id,r),p.delete(r.id),a.ops.push({op:0,item:r})}for(const r of p.keys())a.ops.push({op:1,id:r});o.listener?.(a),h=i},add(C){if(!(C instanceof g))throw new m(C.id);h.set(C.id,C),o.listener?.({op:0,item:C})},delete(C){h.delete(C)&&o.listener?.({op:1,id:C})},get(C){return h.get(C)},toJSON(){return Array.from(h.values())},[Symbol.iterator](){return h.values()}}};class g{constructor(o,h,C,i){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const p=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return p.parent instanceof I?void 0:p.parent}},children:{value:u(this),enumerable:!0,writable:!1},...t(p,C)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=g;class I extends g{constructor(o,h){super(o,o,h,void 0)}}e.TestItemRootImpl=I}),define(be[65],Ee([0,1,4,149,3,13]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var F;(function(D){function P(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?M.TunnelPrivacyId.Public:M.TunnelPrivacyId.Private),protocol:y.protocol}}D.fromApiTunnel=P;function t(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==M.TunnelPrivacyId.ConstantPrivate&&y.privacy!==M.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}D.fromServiceTunnel=t})(F=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let k=class{constructor(P){this.onDidChangeTunnels=new _.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,t){}async getTunnels(){return[]}async setTunnelExtensionFunctions(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,t){return{dispose:()=>{}}}async $providePortAttributes(P,t,y,n,m){return[]}async $forwardPort(P,t){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=$e([ze(0,A.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[7],Ee([0,1,14,16,77,20,79,9,10,2,36,60,86]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n){"use strict";var m,s,u,g,I,E,o,h,C,i,p,a,r,v,l,c,w,f,S,R;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function T(N){function O(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(O,N),Object.setPrototypeOf(O.prototype,N.prototype),O}let L=I=class{constructor(O){m.set(this,void 0),Ze(this,m,O,"f")}static from(...O){let ie=O;return new I(function(){if(ie){for(const _e of ie)_e&&typeof _e.dispose=="function"&&_e.dispose();ie=void 0}})}dispose(){typeof Re(this,m,"f")=="function"&&(Re(this,m,"f").call(this),Ze(this,m,void 0,"f"))}};m=new WeakMap,L=I=$e([T],L),e.Disposable=L;let b=E=class{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("line must be non-negative");if(ie<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=O,this._character=ie}static Min(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isBefore(ie)&&(ie=Ge)}return ie}static Max(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isAfter(ie)&&(ie=Ge)}return ie}static isPosition(O){if(!O)return!1;if(O instanceof E)return!0;let{line:ie,character:_e}=O;return typeof ie=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,ie=0){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=0:typeof O=="number"?_e=O:(_e=typeof O.lineDelta=="number"?O.lineDelta:0,ie=typeof O.characterDelta=="number"?O.characterDelta:0),_e===0&&ie===0?this:new E(this.line+_e,this.character+ie)}with(O,ie=this.character){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=this.line:typeof O=="number"?_e=O:(_e=typeof O.line=="number"?O.line:this.line,ie=typeof O.character=="number"?O.character:this.character),_e===this.line&&ie===this.character?this:new E(_e,ie)}toJSON(){return{line:this.line,character:this.character}}};b=E=$e([T],b),e.Position=b;let x=o=class{constructor(O,ie,_e,Ge){let tt,ot;if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new b(O,ie),ot=new b(_e,Ge)):O instanceof b&&ie instanceof b&&(tt=O,ot=ie),!tt||!ot)throw new Error("Invalid arguments");tt.isBefore(ot)?(this._start=tt,this._end=ot):(this._start=ot,this._end=tt)}static isRange(O){return O instanceof o?!0:O?b.isPosition(O.start)&&b.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof o?this.contains(O._start)&&this.contains(O._end):O instanceof b?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const ie=b.Max(O.start,this._start),_e=b.Min(O.end,this._end);if(!ie.isAfter(_e))return new o(ie,_e)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ie=b.Min(O.start,this._start),_e=b.Max(O.end,this.end);return new o(ie,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,ie=this.end){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return O?b.isPosition(O)?_e=O:(_e=O.start||this.start,ie=O.end||this.end):_e=this.start,_e.isEqual(this._start)&&ie.isEqual(this.end)?this:new o(_e,ie)}toJSON(){return[this.start,this.end]}};x=o=$e([T],x),e.Range=x;let $=h=class extends x{constructor(O,ie,_e,Ge){let tt,ot;if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new b(O,ie),ot=new b(_e,Ge)):O instanceof b&&ie instanceof b&&(tt=O,ot=ie),!tt||!ot)throw new Error("Invalid arguments");super(tt,ot);this._anchor=tt,this._active=ot}static isSelection(O){return O instanceof h?!0:O?x.isRange(O)&&b.isPosition(O.anchor)&&b.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};$=h=$e([T],$),e.Selection=$;class B{constructor(O,ie,_e){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(ie),this.connectionToken=_e}}e.ResolvedAuthority=B;class G extends Error{constructor(O,ie=n.RemoteAuthorityResolverErrorCode.Unknown,_e){super(O);this._message=O,this._code=ie,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,G.prototype)}static NotAvailable(O,ie){return new G(O,n.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(O){return new G(O,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=G;var H;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var W;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ne=C=class{constructor(O,ie){this._range=O,this._newText=ie}static isTextEdit(O){return O instanceof C?!0:O?x.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ie){return new C(O,ie)}static insert(O,ie){return C.replace(new x(O,O),ie)}static delete(O){return C.replace(O,"")}static setEndOfLine(O){const ie=new C(new x(new b(0,0),new b(0,0)),"");return ie.newEol=O,ie}get range(){return this._range}set range(O){if(O&&!x.isRange(O))throw(0,M.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,M.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,M.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ne=C=$e([T],ne),e.TextEdit=ne;var V;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(V=e.FileEditType||(e.FileEditType={}));let Y=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,ie,_e,Ge){this._edits.push({_type:1,from:O,to:ie,options:_e,metadata:Ge})}createFile(O,ie,_e){this._edits.push({_type:1,from:void 0,to:O,options:ie,metadata:_e})}deleteFile(O,ie,_e){this._edits.push({_type:1,from:O,to:void 0,options:ie,metadata:_e})}replaceNotebookMetadata(O,ie,_e){this._edits.push({_type:3,metadata:_e,uri:O,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(O,ie,_e,Ge,tt){let ot,lt,Dt=[],Rt;if(Ht.isNotebookRange(ie)&&Te.isNotebookCellDataArray(_e)&&!Te.isNotebookCellDataArray(Ge)?(ot=ie.start,lt=ie.end,Dt=_e,Rt=Ge):typeof ie=="number"&&typeof _e=="number"&&Te.isNotebookCellDataArray(Ge)&&(ot=ie,lt=_e,Dt=Ge,Rt=tt),ot===void 0||lt===void 0)throw new Error("Invalid arguments");(ot!==lt||Dt.length>0)&&this._edits.push({_type:5,uri:O,index:ot,count:lt-ot,cells:Dt,metadata:Rt})}replaceNotebookCellMetadata(O,ie,_e,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:ie,metadata:_e}})}replace(O,ie,_e,Ge){this._edits.push({_type:2,uri:O,edit:new ne(ie,_e),metadata:Ge})}insert(O,ie,_e,Ge){this.replace(O,new x(ie,ie),_e,Ge)}delete(O,ie,_e){this.replace(O,ie,"",_e)}has(O){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===O.toString())}set(O,ie){if(ie)for(const _e of ie)_e&&this._edits.push({_type:2,uri:O,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ge=this._edits[_e];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[_e]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(O){const ie=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===O.toString()&&ie.push(_e.edit);return ie}entries(){const O=new A.ResourceMap;for(let ie of this._edits)if(ie._type===2){let _e=O.get(ie.uri);_e||(_e=[ie.uri,[]],O.set(ie.uri,_e)),_e[1].push(ie.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Y=$e([T],Y),e.WorkspaceEdit=Y;let j=i=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof i?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=i._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ie=this._tabstop++){if(typeof O=="function"){const _e=new i;_e._tabstop=this._tabstop,O(_e),this._tabstop=_e._tabstop,O=_e.value}else O=i._escape(O);return this.value+="${",this.value+=ie,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ie=this._tabstop++){const _e=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(O,ie){if(typeof ie=="function"){const _e=new i;_e._tabstop=this._tabstop,ie(_e),this._tabstop=_e._tabstop,ie=_e.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};j=i=$e([T],j),e.SnippetString=j;var le;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(le=e.DiagnosticTag||(e.DiagnosticTag={}));var re;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(re=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ve=p=class{constructor(O,ie){if(this.uri=O,ie)if(ie instanceof x)this.range=ie;else if(ie instanceof b)this.range=new x(ie,ie);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof p?!0:O?x.isRange(O.range)&&P.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ve=p=$e([T],ve),e.Location=ve;let Fe=class{constructor(O,ie){this.location=O,this.message=ie}static is(O){return O?typeof O.message=="string"&&O.location&&x.isRange(O.location.range)&&P.URI.isUri(O.location.uri):!1}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.location.range.isEqual(ie.location.range)&&O.location.uri.toString()===ie.location.uri.toString()}};Fe=$e([T],Fe),e.DiagnosticRelatedInformation=Fe;let Me=class{constructor(O,ie,_e=re.Error){if(!x.isRange(O))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=O,this.message=ie,this.severity=_e}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.severity===ie.severity&&O.code===ie.code&&O.severity===ie.severity&&O.source===ie.source&&O.range.isEqual(ie.range)&&(0,d.equals)(O.tags,ie.tags)&&(0,d.equals)(O.relatedInformation,ie.relatedInformation,Fe.isEqual)}};Me=$e([T],Me),e.Diagnostic=Me;let Oe=class{constructor(O,ie){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=ie}};Oe=$e([T],Oe),e.Hover=Oe;var Ke;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Ke=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let je=class{constructor(O,ie=Ke.Text){this.range=O,this.kind=ie}toJSON(){return{range:this.range,kind:Ke[this.kind]}}};je=$e([T],je),e.DocumentHighlight=je;var Ve;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(Ve=e.SymbolKind||(e.SymbolKind={}));var U;(function(N){N[N.Deprecated=1]="Deprecated"})(U=e.SymbolTag||(e.SymbolTag={}));let Q=a=class{constructor(O,ie,_e,Ge,tt){this.name=O,this.kind=ie,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),Ge instanceof ve?this.location=Ge:_e instanceof x&&(this.location=new ve(Ge,_e)),a.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ve[this.kind],location:this.location,containerName:this.containerName}}};Q=a=$e([T],Q),e.SymbolInformation=Q;let ee=r=class{constructor(O,ie,_e,Ge,tt){this.name=O,this.detail=ie,this.kind=_e,this.range=Ge,this.selectionRange=tt,this.children=[],r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(r.validate)}};ee=r=$e([T],ee),e.DocumentSymbol=ee;var ae;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let K=class{constructor(O,ie){this.title=O,this.kind=ie}};K=$e([T],K),e.CodeAction=K;let se=v=class{constructor(O){this.value=O}append(O){return new v(this.value?this.value+v.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+v.sep)}};se.sep=".",se=v=$e([T],se),e.CodeActionKind=se,se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll");let he=class{constructor(O,ie){if(this.range=O,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};he=$e([T],he),e.SelectionRange=he;class Ae{constructor(O,ie,_e,Ge,tt,ot){this.kind=O,this.name=ie,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=ot}}e.CallHierarchyItem=Ae;class Ue{constructor(O,ie){this.fromRanges=ie,this.from=O}}e.CallHierarchyIncomingCall=Ue;class He{constructor(O,ie){this.fromRanges=ie,this.to=O}}e.CallHierarchyOutgoingCall=He;var Qe;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(O,ie){this.range=O,this.command=ie}get isResolved(){return!!this.command}};et=$e([T],et),e.CodeLens=et;let st=l=class{constructor(O,ie=!1){s.set(this,void 0),Ze(this,s,new _.MarkdownString(O,{supportThemeIcons:ie}),"f")}static isMarkdownString(O){return O instanceof l?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Re(this,s,"f").value}set value(O){Re(this,s,"f").value=O}get isTrusted(){return Re(this,s,"f").isTrusted}set isTrusted(O){Re(this,s,"f").isTrusted=O}get supportThemeIcons(){return Re(this,s,"f").supportThemeIcons}set supportThemeIcons(O){Re(this,s,"f").supportThemeIcons=O}get supportHtml(){return Re(this,s,"f").supportHtml}set supportHtml(O){Re(this,s,"f").supportHtml=O}appendText(O){return Re(this,s,"f").appendText(O),this}appendMarkdown(O){return Re(this,s,"f").appendMarkdown(O),this}appendCodeblock(O,ie){return Re(this,s,"f").appendCodeblock(ie??"",O),this}};s=new WeakMap,st=l=$e([T],st),e.MarkdownString=st;let ye=class{constructor(O,ie){this.label=O,this.documentation=ie}};ye=$e([T],ye),e.ParameterInformation=ye;let nt=class{constructor(O,ie){this.label=O,this.documentation=ie,this.parameters=[]}};nt=$e([T],nt),e.SignatureInformation=nt;let q=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};q=$e([T],q),e.SignatureHelp=q;var Z;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(Z=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var pe;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(pe=e.InlayHintKind||(e.InlayHintKind={}));let We=class{constructor(O,ie,_e){this.text=O,this.position=ie,this.kind=_e}};We=$e([T],We),e.InlayHint=We;var Ye;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var rt;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(rt=e.CompletionItemKind||(e.CompletionItemKind={}));var mt;(function(N){N[N.Deprecated=1]="Deprecated"})(mt=e.CompletionItemTag||(e.CompletionItemTag={}));let ut=class{constructor(O,ie){this.label=O,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&rt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ut=$e([T],ut),e.CompletionItem=ut;let St=class{constructor(O=[],ie=!1){this.items=O,this.isIncomplete=ie}};St=$e([T],St),e.CompletionList=St;let Tt=class{constructor(O,ie,_e){this.text=O,this.range=ie,this.command=_e}};Tt=$e([T],Tt),e.InlineSuggestion=Tt;let It=class{constructor(O){this.items=O}};It=$e([T],It),e.InlineSuggestions=It;var Xe;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(Xe=e.ViewColumn||(e.ViewColumn={}));var vt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(vt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Pe;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Pe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Se;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Se=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ce;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var te;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(te=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var me;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(me=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function O(ie){switch(ie){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=O}(te=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let fe=class{constructor(O,ie){if(ie&&!P.URI.isUri(ie))throw(0,M.illegalArgument)("target");if(!x.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.target=ie}};fe=$e([T],fe),e.DocumentLink=fe;let Ie=class{constructor(O,ie,_e,Ge){this.red=O,this.green=ie,this.blue=_e,this.alpha=Ge}};Ie=$e([T],Ie),e.Color=Ie;let Be=class{constructor(O,ie){if(ie&&!(ie instanceof Ie))throw(0,M.illegalArgument)("color");if(!x.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.color=ie}};Be=$e([T],Be),e.ColorInformation=Be;let Ne=class{constructor(O){if(!O||typeof O!="string")throw(0,M.illegalArgument)("label");this.label=O}};Ne=$e([T],Ne),e.ColorPresentation=Ne;var qe;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(qe=e.ColorFormat||(e.ColorFormat={}));var it;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Le{constructor(O,ie,_e){if(this.startIndex=O,this.length=ie,this.tooltip=_e,typeof O!="number"||O<0)throw(0,M.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=Le;var de;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(de=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(O){this.options=O,typeof O!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=ge;var X;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(X=e.TaskRevealKind||(e.TaskRevealKind={}));var z;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(z=e.TaskPanelKind||(e.TaskPanelKind={}));let we=c=class{constructor(O,ie){if(this.label=ie,typeof O!="string"||typeof ie!="string")throw(0,M.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};we.Clean=new c("clean","Clean"),we.Build=new c("build","Build"),we.Rebuild=new c("rebuild","Rebuild"),we.Test=new c("test","Test"),we=c=$e([T],we),e.TaskGroup=we;function ke(N){let O="";for(let ie=0;ie<N.length;ie++)O+=N[ie].replace(/,/g,",,")+",";return O}let Je=class{constructor(O,ie,_e){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=O,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=_e):this._options=ie)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let ie of this._args)O.push(ie);return ke(O)}};Je=$e([T],Je),e.ProcessExecution=Je;let xe=class{constructor(O,ie,_e){if(this._args=[],Array.isArray(ie)){if(!O)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O,this._args=ie,this._options=_e}else{if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ie of this._args)O.push(typeof ie=="string"?ie:ie.value);return ke(O)}};xe=$e([T],xe),e.ShellExecution=xe;var ct;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(ct=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class dt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,t.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=dt;let ht=w=class{constructor(O,ie,_e,Ge,tt,ot){this.__deprecated=!1,this._definition=this.definition=O;let lt;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=_e,this.execution=Ge,lt=tt,this.__deprecated=!0):ie===pt.Global||ie===pt.Workspace?(this.target=ie,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,lt=ot):(this.target=ie,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,lt=ot),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Je?this._definition={type:w.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:w.ShellType,id:this._execution.computeId()}:this._execution instanceof dt?this._definition={type:w.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:w.EmptyType,id:(0,t.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const ie=this._definition.type;(w.EmptyType===ie||w.ProcessType===ie||w.ShellType===ie||w.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};ht.ExtensionCallbackType="customExecution",ht.ProcessType="process",ht.ShellType="shell",ht.EmptyType="$empty",ht=w=$e([T],ht),e.Task=ht;var ft;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let _t=class{constructor(O,ie=yt.None){this.collapsibleState=ie,P.URI.isUri(O)?this.resourceUri=O:this.label=O}};_t=$e([T],_t),e.TreeItem=_t;var yt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(yt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Pt=class{constructor(O,ie){this.id=O,this.color=ie}};Pt=$e([T],Pt),e.ThemeIcon=Pt,Pt.File=new Pt("file"),Pt.Folder=new Pt("folder");let Nt=class{constructor(O){this.id=O}};Nt=$e([T],Nt),e.ThemeColor=Nt;var Ct;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Ct=e.ConfigurationTarget||(e.ConfigurationTarget={}));let xt=class{constructor(O,ie){if(typeof O!="string"&&(!O||!P.URI.isUri(O)&&!P.URI.isUri(O.uri)))throw(0,M.illegalArgument)("base");if(typeof ie!="string")throw(0,M.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=P.URI.file(O),this.base=O):P.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=ie}};xt=$e([T],xt),e.RelativePattern=xt;let $t=class{constructor(O,ie,_e,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof ie=="string"&&(this.condition=ie),typeof _e=="string"&&(this.hitCondition=_e),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,t.generateUuid)()),this._id}};$t=$e([T],$t),e.Breakpoint=$t;let bt=class extends $t{constructor(O,ie,_e,Ge,tt){super(ie,_e,Ge,tt);if(O===null)throw(0,M.illegalArgument)("location");this.location=O}};bt=$e([T],bt),e.SourceBreakpoint=bt;let Qt=class extends $t{constructor(O,ie,_e,Ge,tt){super(ie,_e,Ge,tt);this.functionName=O}};Qt=$e([T],Qt),e.FunctionBreakpoint=Qt;let zt=class extends $t{constructor(O,ie,_e,Ge,tt,ot,lt){super(Ge,tt,ot,lt);if(!ie)throw(0,M.illegalArgument)("dataId");this.label=O,this.dataId=ie,this.canPersist=_e}};zt=$e([T],zt),e.DataBreakpoint=zt;let ii=class{constructor(O,ie,_e){this.command=O,this.args=ie||[],this.options=_e}};ii=$e([T],ii),e.DebugAdapterExecutable=ii;let ni=class{constructor(O,ie){this.port=O,this.host=ie}};ni=$e([T],ni),e.DebugAdapterServer=ni;let At=class{constructor(O){this.path=O}};At=$e([T],At),e.DebugAdapterNamedPipeServer=At;let Yt=class{constructor(O){this.implementation=O}};Yt=$e([T],Yt),e.DebugAdapterInlineImplementation=Yt;let ri=class{constructor(O,ie){this.range=O,this.expression=ie}};ri=$e([T],ri),e.EvaluatableExpression=ri;var Jt;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(Jt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(O,ie){this.range=O,this.text=ie}};Wt=$e([T],Wt),e.InlineValueText=Wt;let gt=class{constructor(O,ie,_e=!0){this.range=O,this.variableName=ie,this.caseSensitiveLookup=_e}};gt=$e([T],gt),e.InlineValueVariableLookup=gt;let si=class{constructor(O,ie){this.range=O,this.expression=ie}};si=$e([T],si),e.InlineValueEvaluatableExpression=si;let Mt=class{constructor(O,ie){this.frameId=O,this.stoppedLocation=ie}};Mt=$e([T],Mt),e.InlineValueContext=Mt;var Vt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let Xt=f=class extends Error{constructor(O,ie=y.FileSystemProviderErrorCode.Unknown,_e){super(P.URI.isUri(O)?O.toString(!0):O);this.code=_e?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(O){return new f(O,y.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(O){return new f(O,y.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(O){return new f(O,y.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(O){return new f(O,y.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(O){return new f(O,y.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(O){return new f(O,y.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}};Xt=f=$e([T],Xt),e.FileSystemError=Xt;let oi=class{constructor(O,ie,_e){this.start=O,this.end=ie,this.kind=_e}};oi=$e([T],oi),e.FoldingRange=oi;var di;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(di=e.FoldingRangeKind||(e.FoldingRangeKind={}));var wi;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var hi;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(hi=e.CommentMode||(e.CommentMode={}));class Zt{constructor(O,ie=[]){this.tokenTypes=O,this.tokenModifiers=ie}}e.SemanticTokensLegend=Zt;function bi(N){return typeof N=="undefined"||(0,D.isStringArray)(N)}class jt{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let ie=0,_e=O.tokenTypes.length;ie<_e;ie++)this._tokenTypeStrToInt.set(O.tokenTypes[ie],ie);for(let ie=0,_e=O.tokenModifiers.length;ie<_e;ie++)this._tokenModifierStrToInt.set(O.tokenModifiers[ie],ie)}}push(O,ie,_e,Ge,tt){if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(O,ie,_e,Ge,tt);if(x.isRange(O)&&typeof ie=="string"&&bi(_e))return this._push(O,ie,_e);throw(0,M.illegalArgument)()}_push(O,ie,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,tt=O.start.character,ot=O.end.character-O.start.character,lt=this._tokenTypeStrToInt.get(ie);let Dt=0;if(_e)for(const Rt of _e){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(Rt);Dt|=1<<Lt>>>0}this._pushEncoded(Ge,tt,ot,lt,Dt)}_pushEncoded(O,ie,_e,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Rt=0,Lt=0;for(let Ot=0;Ot<Dt;Ot++){let Bt=this._data[5*Ot],ui=this._data[5*Ot+1];Bt===0?(Bt=Rt,ui+=Lt):Bt+=Rt,this._data[5*Ot]=Bt,this._data[5*Ot+1]=ui,Rt=Bt,Lt=ui}}let ot=O,lt=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=O,this._prevChar=ie}static _sortAndDeltaEncode(O){let ie=[];const _e=O.length/5|0;for(let lt=0;lt<_e;lt++)ie[lt]=lt;ie.sort((lt,Dt)=>{const Rt=O[5*lt],Lt=O[5*Dt];if(Rt===Lt){const Ot=O[5*lt+1],Bt=O[5*Dt+1];return Ot-Bt}return Rt-Lt});const Ge=new Uint32Array(O.length);let tt=0,ot=0;for(let lt=0;lt<_e;lt++){const Dt=5*ie[lt],Rt=O[Dt+0],Lt=O[Dt+1],Ot=O[Dt+2],Bt=O[Dt+3],ui=O[Dt+4],Bi=Rt-tt,Gi=Bi===0?Lt-ot:Lt,ci=5*lt;Ge[ci+0]=Bi,Ge[ci+1]=Gi,Ge[ci+2]=Ot,Ge[ci+3]=Bt,Ge[ci+4]=ui,tt=Rt,ot=Lt}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(jt._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=jt;class qt{constructor(O,ie){this.resultId=ie,this.data=O}}e.SemanticTokens=qt;class Ei{constructor(O,ie,_e){this.start=O,this.deleteCount=ie,this.data=_e}}e.SemanticTokensEdit=Ei;class _i{constructor(O,ie){this.resultId=ie,this.edits=O}}e.SemanticTokensEdits=_i;var Gt;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Pt("arrow-left")},ei=$e([T],ei),e.QuickInputButtons=ei;var Si;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(O,ie,_e){this.badge=O,this.tooltip=ie,this.color=_e}static validate(O){if(O.badge){let ie=(0,k.nextCharLength)(O.badge,0);if(ie<O.badge.length&&(ie+=(0,k.nextCharLength)(O.badge,ie)),O.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Di;let Kt=class{constructor(O){this.kind=O}};Kt=$e([T],Kt),e.ColorTheme=Kt;var fi;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(fi=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("start must be positive");if(ie<0)throw(0,M.illegalArgument)("end must be positive");O<=ie?(this._start=O,this._end=ie):(this._start=ie,this._end=O)}static isNotebookRange(O){return O instanceof Ht?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let ie=this._start,_e=this._end;return O.start!==void 0&&(ie=O.start),O.end!==void 0&&(_e=O.end),ie===this._start&&_e===this._end?this:new Ht(ie,_e)}}e.NotebookRange=Ht;class Te{constructor(O,ie,_e,Ge,tt,ot,lt){this.kind=O,this.value=ie,this.languageId=_e,this.mime=Ge,this.outputs=tt??[],this.metadata=ot,this.executionSummary=lt,Te.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ie=>Te.isNotebookCellData(ie))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Te;class ai{constructor(O){this.cells=O}}e.NotebookData=ai;class Ft{constructor(O,ie){this.data=O,this.mime=ie;const _e=(0,F.normalizeMimeType)(ie,!0);if(!_e)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(O){return O instanceof Ft?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const ie={name:O.name,message:O.message,stack:O.stack};return Ft.json(ie,"application/vnd.code.notebook.error")}static stdout(O){return Ft.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Ft.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,ie="application/octet-stream"){return new Ft(O,ie)}static text(O,ie=F.Mimes.text){const _e=Re(Ft,u,"f",g).encode(String(O));return new Ft(_e,ie)}static json(O,ie="application/json"){const _e=JSON.stringify(O,void 0,"	");return Ft.text(_e,ie)}}e.NotebookCellOutputItem=Ft,u=Ft,g={value:new TextEncoder};class wt{constructor(O,ie,_e){this.items=wt.ensureUniqueMimeTypes(O,!0),typeof ie=="string"?(this.id=ie,this.metadata=_e):(this.id=(0,t.generateUuid)(),this.metadata=ie??_e)}static isNotebookCellOutput(O){return O instanceof wt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,D.isArray)(O.items)}static ensureUniqueMimeTypes(O,ie=!1){const _e=new Set,Ge=new Set;for(let tt=0;tt<O.length;tt++){const ot=O[tt],lt=(0,F.normalizeMimeType)(ot.mime);if(!_e.has(lt)){_e.add(lt);continue}Ge.add(tt),ie&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ge.size===0?O:O.filter((tt,ot)=>!Ge.has(ot))}}e.NotebookCellOutput=wt;var Ci;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Ci=e.NotebookCellKind||(e.NotebookCellKind={}));var ki;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(ki=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var mi;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(mi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(gi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ii{constructor(O,ie){this.text=O,this.alignment=ie}}e.NotebookCellStatusBarItem=Ii;var Pi;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Pi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ti{constructor(O,ie=[]){this.uri=O,this.provides=(0,d.asArray)(ie)}}e.NotebookRendererScript=Ti;let li=class{constructor(O,ie){this.label=O,this.timestamp=ie}};li=$e([T],li),e.TimelineItem=li;var pi;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(pi=e.ExtensionMode||(e.ExtensionMode={}));var Ai;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Ai=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ri;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Ri=e.StandardTokenType||(e.StandardTokenType={}));class Fi{constructor(O,ie){this.ranges=O,this.wordPattern=ie}}e.LinkedEditingRanges=Fi;class Mi{constructor(O,ie){this._port=O,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mi;var Li;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Li=e.TestResultState||(e.TestResultState={}));var J;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(J=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ce=class{constructor(O,ie,_e){this.include=O,this.exclude=ie,this.profile=_e}};ce=$e([T],ce),e.TestRunRequest=ce;let De=S=class{constructor(O){this.message=O}static diff(O,ie,_e){const Ge=new S(O);return Ge.expectedOutput=ie,Ge.actualOutput=_e,Ge}};De=S=$e([T],De),e.TestMessage=De;let at=class{constructor(O){this.id=O}};at=$e([T],at),e.TestTag=at;let Et=class{constructor(O,ie){this.covered=O,this.total=ie}};Et=$e([T],Et),e.CoveredCount=Et;let kt=R=class{constructor(O,ie,_e,Ge){this.uri=O,this.statementCoverage=ie,this.branchCoverage=_e,this.functionCoverage=Ge}static fromDetails(O,ie){const _e=new Et(0,0),Ge=new Et(0,0),tt=new Et(0,0);for(const lt of ie)if("branches"in lt){_e.total+=1,_e.covered+=lt.executionCount>0?1:0;for(const Dt of lt.branches)Ge.total+=1,Ge.covered+=Dt.executionCount>0?1:0}else tt.total+=1,tt.covered+=lt.executionCount>0?1:0;const ot=new R(O,_e,Ge.total>0?Ge:void 0,tt.total>0?tt:void 0);return ot.detailedCoverage=ie,ot}};kt=R=$e([T],kt),e.FileCoverage=kt;let Oi=class{constructor(O,ie,_e=[]){this.executionCount=O,this.location=ie,this.branches=_e}};Oi=$e([T],Oi),e.StatementCoverage=Oi;let Ni=class{constructor(O,ie){this.executionCount=O,this.location=ie}};Ni=$e([T],Ni),e.BranchCoverage=Ni;let xi=class{constructor(O,ie){this.executionCount=O,this.location=ie}};xi=$e([T],xi),e.FunctionCoverage=xi;var zi;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(zi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(Vi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ji;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(ji=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qi{constructor(O,ie,_e,Ge,tt,ot){this.kind=O,this.name=ie,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=ot}}e.TypeHierarchyItem=qi}),define(be[88],Ee([0,1,42,11,9,228,118,7,14]),function(oe,e,d,M,_,A,F,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function t(s,u){u?P.set(s,u):P.delete(s)}e.setWordDefinitionFor=t;function y(s){return P.get(s)}e.getWordDefinitionFor=y;class n extends A.MirrorTextModel{constructor(u,g,I,E,o,h,C,i){super(g,I,E,o);this._proxy=u,this._languageId=h,this._isDirty=C,this._notebook=i,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,D.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===M.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(g){return g?u._getTextInRange(g):u.getText()},get eol(){return u._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(g){return u._lineAt(g)},offsetAt(g){return u._offsetAt(g)},positionAt(g){return u._positionAt(g)},validateRange(g){return u._validateRange(g)},validatePosition(g){return u._validatePosition(g)},getWordRangeAtPosition(g,I){return u._getWordRangeAtPosition(g,I)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,d.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,d.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const g=this._validateRange(u);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const I=this._eol,E=g.start.line,o=g.end.line,h=[];h.push(this._lines[E].substring(g.start.character));for(let C=E+1;C<o;C++)h.push(this._lines[C]);return h.push(this._lines[o].substring(0,g.end.character)),h.join(I)}_lineAt(u){let g;if(u instanceof k.Position?g=u.line:typeof u=="number"&&(g=u),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new m(g,this._lines[g],g===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(u),I=this._lines[g.index].length;return new k.Position(g.index,Math.min(g.remainder,I))}_validateRange(u){if(!(u instanceof k.Range))throw new Error("Invalid argument");const g=this._validatePosition(u.start),I=this._validatePosition(u.end);return g===u.start&&I===u.end?u:new k.Range(g.line,g.character,I.line,I.character)}_validatePosition(u){if(!(u instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:g,character:I}=u,E=!1;if(g<0)g=0,I=0,E=!0;else if(g>=this._lines.length)g=this._lines.length-1,I=this._lines[g].length,E=!0;else{const o=this._lines[g].length;I<0?(I=0,E=!0):I>o&&(I=o,E=!0)}return E?new k.Position(g,I):u}_getWordRangeAtPosition(u,g){const I=this._validatePosition(u);if(!g)g=y(this._languageId);else if((0,_.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const E=(0,F.getWordAtText)(I.character+1,(0,F.ensureValidWordDefinition)(g),this._lines[I.line],0);if(E)return new k.Range(I.line,E.startColumn-1,I.line,E.endColumn-1)}}e.ExtHostDocumentData=n;class m{constructor(u,g,I){this._line=u,this._text=g,this._isLastLine=I}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(be[156],Ee([0,1,7,3,229,6,56,20,2,36]),function(oe,e,d,M,_,A,F,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,m,s,u){this._notebook=s,this._selector=u,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(I=>{const E=this._cellUris.get(I.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const g=I=>{I===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(I=>g(I.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const n=[],m=[];for(const s of this._notebook.getCells())s.kind===d.NotebookCellKind.Code&&(!this._selector||(0,F.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),n.push(s.document.getText().length+1),m.push(s.document.lineCount));this._cellLengths=new _.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new _.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(n){if(!n){let E="";for(const o of this._cells)E+=o.document.getText()+`
`;return E=E.slice(0,-1),E}if(n.isEmpty)return"";const m=this.locationAt(n.start),s=this.locationAt(n.end),u=this._cellUris.get(m.uri),g=this._cellUris.get(s.uri);if(u===void 0||g===void 0)return"";if(u===g)return this._cells[u].document.getText(new d.Range(m.range.start,s.range.end));const I=[this._cells[u].document.getText(new d.Range(m.range.start,new d.Position(this._cells[u].document.lineCount,0)))];for(let E=u+1;E<g;E++)I.push(this._cells[E].document.getText());return I.push(this._cells[g].document.getText(new d.Range(new d.Position(0,0),s.range.end))),I.join(`
`)}offsetAt(n){const m=this._cellLines.getIndexOf(n.line),s=this._cellLengths.getPrefixSum(m.index-1),u=this._cells[m.index].document.offsetAt(n.with(m.remainder));return s+u}positionAt(n){if(typeof n=="number"){const s=this._cellLengths.getIndexOf(n),u=this._cellLines.getPrefixSum(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(u)}const m=this._cellUris.get(n.uri);if(m!==void 0){const s=this._cellLines.getPrefixSum(m-1);return new d.Position(s+n.range.start.line,n.range.start.character)}return new d.Position(0,0)}locationAt(n){d.Range.isRange(n)||(n=new d.Range(n,n));const m=this._cellLines.getIndexOf(n.start.line);let s=m;n.isEmpty||(s=this._cellLines.getIndexOf(n.end.line));const u=new d.Position(m.remainder,n.start.character),g=new d.Position(s.remainder,n.end.character),I=new d.Range(u,g),E=this._cells[m.index];return new d.Location(E.document.uri,E.document.validateRange(I))}contains(n){return this._cellUris.has(n)}validateRange(n){const m=this.validatePosition(n.start),s=this.validatePosition(n.end);return n.with(m,s)}validatePosition(n){const m=this._cellLines.getIndexOf(n.line),s=new d.Position(m.remainder,n.character),u=this._cells[m.index].document.validatePosition(s),g=this._cellLines.getPrefixSum(m.index-1);return new d.Position(g+u.line,u.character)}}e.ExtHostNotebookConcatDocument=t}),define(be[157],Ee([0,1,7,13,3]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(k){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new _.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let D=k==="light"?d.ColorThemeKind.Light:k==="dark"?d.ColorThemeKind.Dark:d.ColorThemeKind.HighContrast;this._actual=new d.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=$e([ze(0,M.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(be[66],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=M}),define(be[158],Ee([0,1,22]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(D){let P=this.buffers.indexOf(D);return P<0&&(P=this.buffers.length,this.buffers.push(D)),P}}function _(k,D){if(D.serializeBuffersForPostMessage){const P=new M,t=(m,s)=>{if(s instanceof ArrayBuffer){const u=P.add(s);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(s)){const u=A(s);if(u){const g=P.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:u,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},y=JSON.stringify(k,t),n=P.buffers.map(m=>{const s=new Uint8Array(m);return d.VSBuffer.wrap(s)});return{message:y,buffers:n}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=_;function A(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(k,D){const P=D.map(n=>{const m=new ArrayBuffer(n.byteLength);return new Uint8Array(m).set(n.buffer),m}),t=D.length?(n,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const s=m,{index:u}=s,g=P[u];if(s.view)switch(s.view.type){case 1:return new Int8Array(g,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return m}:void 0;return{message:JSON.parse(k,t),arrayBuffers:P}}e.deserializeWebviewMessage=F}),define(be[159],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var d;(function(M){function _(F){const k={items:new Map};return F.types.forEach((D,P)=>{k.items.set(D,{asString:async()=>F.items[P].asString})}),k}M.toITreeDataTransfer=_;async function A(F){const k={types:[],items:[]},D=Array.from(F.items.entries());for(const P of D)k.types.push(P[0]),k.items.push({asString:await P[1].asString()});return k}M.toTreeDataTransferDTO=A})(d=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[67],Ee([0,1,11,2]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function _(k,D){return k.scheme===d.Schemas.http||k.scheme===d.Schemas.https?k:(D&&D.authority&&D.isRemote&&k.scheme===d.Schemas.file&&(k=M.URI.from({scheme:d.Schemas.vscodeRemote,authority:D.authority,path:k.path})),M.URI.from({scheme:d.Schemas.https,authority:`${k.scheme}+${A(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=_;function A(k){return k.replace(/./g,D=>{const P=D.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?D:"-"+P.toString(16).padStart(4,"0")})}function F(k){return k.replace(/-([0-9a-f]{4})/g,(D,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=F}),define(be[160],Ee([0,1,3,6,67]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(k,D,P){this._proxy=k,this._editors=D,this._initData=P,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const t=D.getVisibleTextEditors();for(const y of this._insets.values())t.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,D,P,t,y){let n;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===k){n=o;break}if(!n)throw new Error("not a visible editor");const m=this,s=this._handlePool++,u=new d.Emitter,g=new d.Emitter,I=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,_.asWebviewUri)(o,m._initData.remote)}get cspSource(){return _.webviewGenericCspSource}set options(o){this._options=o,m._proxy.$setOptions(s,o)}get options(){return this._options}set html(o){this._html=o,m._proxy.$setHtml(s,o)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(o){return m._proxy.$postMessage(s,o)}},E=new class{constructor(){this.editor=k,this.line=D,this.height=P,this.webview=I,this.onDidDispose=g.event}dispose(){m._insets.has(s)&&(m._insets.delete(s),m._proxy.$disposeEditorInset(s),g.fire(),g.dispose(),u.dispose())}};return this._proxy.$createEditorInset(s,n.id,n.value.document.uri,D+1,P,t||{},y.identifier,y.extensionLocation),this._insets.set(s,{editor:k,inset:E,onDidReceiveMessage:u}),E}$onDidDispose(k){const D=this._insets.get(k);D&&D.inset.dispose()}$onDidReceiveMessage(k,D){const P=this._insets.get(k);P&&P.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=A}),define(be[161],Ee([0,1,131,10,2,6,4,46,28,14,11]),function(oe,e,d,M,_,A,F,k,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,d.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,d.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,d.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,d.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,d.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,d.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,d.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,d.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,d.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,d.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,d.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,d.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,d.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,d.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,d.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,d.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,d.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,d.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,d.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,d.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,d.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function y(L,b,x){for(const $ of x.visibleEditorPanes)if($.group.id===b&&L.matches($.input))return $.getViewState()}e.findViewStateForEditor=y;function n(L){if(h(L))return!1;const b=L;return _.URI.isUri(b?.resource)}e.isResourceEditorInput=n;function m(L){if(h(L))return!1;const b=L;return b?.original!==void 0&&b.modified!==void 0}e.isResourceDiffEditorInput=m;function s(L){if(h(L)||m(L))return!1;const b=L;return b?.primary!==void 0&&b.secondary!==void 0}e.isResourceSideBySideEditorInput=s;function u(L){if(h(L))return!1;const b=L;return b?b.resource===void 0||b.resource.scheme===t.Schemas.untitled||b.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var g;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(g=e.Verbosity||(e.Verbosity={}));var I;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(I=e.SaveReason||(e.SaveReason={}));var E;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription"})(E=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends A.Disposable{}e.AbstractEditorInput=o;function h(L){return L instanceof o}e.isEditorInput=h;function C(L){const b=L;return _.URI.isUri(b?.preferredResource)}function i(L){const b=L;return h(b?.primary)&&h(b?.secondary)}e.isSideBySideEditorInput=i;function p(L){const b=L;return h(b?.modified)&&h(b?.original)}e.isDiffEditorInput=p;function a(L){return h(L?.editor)}e.isEditorInputWithOptions=a;function r(L){const b=L;return a(L)&&b?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function v(L){const b=L;return typeof b?.groupId=="number"&&h(b.editor)}e.isEditorIdentifier=v;var l;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(l=e.EditorCloseContext||(e.EditorCloseContext={}));var c;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(c=e.SideBySideEditor||(e.SideBySideEditor={}));class w{getOriginalUri(b,x){if(!b)return;if(x?.supportSideBySide){const{primary:B,secondary:G}=this.getSideEditors(b);if(B&&G){if(x?.supportSideBySide===c.BOTH)return{primary:this.getOriginalUri(B,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===c.ANY)return this.getOriginalUri(B,{filterByScheme:x.filterByScheme})??this.getOriginalUri(G,{filterByScheme:x.filterByScheme});b=x.supportSideBySide===c.PRIMARY?B:G}}if(m(b)||s(b))return;const $=C(b)?b.preferredResource:b.resource;return!$||!x||!x.filterByScheme?$:this.filterUri($,x.filterByScheme)}getSideEditors(b){return i(b)||s(b)?{primary:b.primary,secondary:b.secondary}:p(b)||m(b)?{primary:b.modified,secondary:b.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(b,x){if(!b)return;if(x?.supportSideBySide){const{primary:B,secondary:G}=this.getSideEditors(b);if(B&&G){if(x?.supportSideBySide===c.BOTH)return{primary:this.getCanonicalUri(B,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===c.ANY)return this.getCanonicalUri(B,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(G,{filterByScheme:x.filterByScheme});b=x.supportSideBySide===c.PRIMARY?B:G}}if(m(b)||s(b))return;const $=b.resource;return!$||!x||!x.filterByScheme?$:this.filterUri($,x.filterByScheme)}filterUri(b,x){if(Array.isArray(x)){if(x.some($=>b.scheme===$))return b}else if(x===b.scheme)return b}}e.EditorResourceAccessor=new w;var f;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(f=e.CloseDirection||(e.CloseDirection={}));class S{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(b){const x=this.instantiationService=b.get(F.IInstantiationService);for(const[$,B]of this.editorSerializerConstructors)this.createEditorSerializer($,B,x);this.editorSerializerConstructors.clear()}createEditorSerializer(b,x,$){const B=$.createInstance(x);this.editorSerializerInstances.set(b,B)}registerFileEditorFactory(b){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=b}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(b,x){if(this.editorSerializerConstructors.has(b)||this.editorSerializerInstances.has(b))throw new Error(`A editor serializer with type ID '${b}' was already registered.`);return this.instantiationService?this.createEditorSerializer(b,x,this.instantiationService):this.editorSerializerConstructors.set(b,x),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(b),this.editorSerializerInstances.delete(b)})}getEditorSerializer(b){return this.editorSerializerInstances.get(typeof b=="string"?b:b.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new S);async function R(L,b){if(!L||!L.length)return[];const x=await Promise.all(L.map(async $=>{const B=_.URI.revive($.fileUri);if(!B||!await b.canHandleResource(B))return;const H=typeof $.exists=="boolean"?$.exists:await b.exists(B);if(!H&&$.openOnlyIfExists)return;const W={selection:H?$.selection:void 0,pinned:!0,override:$.editorOverrideId};let ne;return H?ne={resource:B,options:W}:ne={resource:B,options:W,forceUntitled:!0},ne}));return(0,P.coalesce)(x)}e.pathsToEditors=R;var T;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(T=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[162],Ee([0,1,3,46,132,4,6,20,28,14,52,23,34,152]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",n.Codicon.window,(0,_.localize)(0,null));var s;(function(v){v.ViewContainersRegistry="workbench.registry.view.containers",v.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var u;(function(v){v[v.Sidebar=0]="Sidebar",v[v.Panel=1]="Panel",v[v.AuxiliaryBar=2]="AuxiliaryBar"})(u=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function g(v){switch(v){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=g;function I(v){return`viewContainer.${v}.enabled`}e.getEnabledViewContainerContextKey=I;class E extends F.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new d.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new d.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(l,c,w){const f=this.get(l.id);if(f)return f;const S=l;return S.openCommandActionDescriptor=w?.donotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,k.getOrSet)(this.viewContainers,c,[]).push(S),w?.isDefault&&this.defaultViewContainers.push(S),this._onDidRegister.fire({viewContainer:S,viewContainerLocation:c}),S}deregisterViewContainer(l){for(const c of this.viewContainers.keys()){const w=this.viewContainers.get(c),f=w?.indexOf(l);if(f!==-1){w?.splice(f,1),w.length===0&&this.viewContainers.delete(c),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:c});return}}}get(l){return this.all.filter(c=>c.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(c=>this.getViewContainers(c).filter(w=>w?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(c=>this.getViewContainerLocation(c)===l)}}D.Registry.add(s.ViewContainersRegistry,new E);var o;(function(v){v.Open="2_open",v.Debug="4_debug",v.SCM="5_scm",v.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function h(v,l){const c=v.group??o.More,w=l.group??o.More;return c!==w?c.localeCompare(w):(v.order??5)-(l.order??5)}class C extends F.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new d.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new d.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new d.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new d.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(l,c){this.registerViews2([{views:l,viewContainer:c}])}registerViews2(l){l.forEach(({views:c,viewContainer:w})=>this.addViews(c,w)),this._onViewsRegistered.fire(l)}deregisterViews(l,c){const w=this.removeViews(l,c);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:c})}moveViews(l,c){for(const w of this._views.keys())if(w!==c){const f=this.removeViews(l,w);f.length&&(this.addViews(f,c),this._onDidChangeContainer.fire({views:f,from:w,to:c}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const c of this._viewContainers){const w=(this._views.get(c)||[]).filter(f=>f.id===l)[0];if(w)return w}return null}getViewContainer(l){for(const c of this._viewContainers)if((this._views.get(c)||[]).filter(f=>f.id===l)[0])return c;return null}registerViewWelcomeContent(l,c){return this._viewWelcomeContents.add(l,c),this._onDidChangeViewWelcomeContent.fire(l),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(l,c),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,c){const w=new Map;for(const[f,S]of c)this._viewWelcomeContents.add(l,S),w.set(f,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(l,S),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),w}getViewWelcomeContent(l){const c=[];return this._viewWelcomeContents.forEach(l,w=>c.push(w)),c.sort(h)}addViews(l,c){let w=this._views.get(c);w||(w=[],this._views.set(c,w),this._viewContainers.push(c));for(const f of l){if(this.getView(f.id)!==null)throw new Error((0,_.localize)(1,null,f.id));w.push(f)}}removeViews(l,c){const w=this._views.get(c);if(!w)return[];const f=[],S=[];for(const R of w)l.includes(R)?f.push(R):S.push(R);return f.length&&(S.length?this._views.set(c,S):(this._views.delete(c),this._viewContainers.splice(this._viewContainers.indexOf(c),1))),f}}D.Registry.add(s.ViewsRegistry,new C),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,_.localize)(2,null));function i(v){return`view.${v}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var p;(function(v){v[v.Default=0]="Default",v[v.Expand=1]="Expand"})(p=e.ViewVisibilityState||(e.ViewVisibilityState={}));var a;(function(v){v[v.None=0]="None",v[v.Collapsed=1]="Collapsed",v[v.Expanded=2]="Expanded"})(a=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(l,c){this.resolved=!1,this._hasResolve=!1,(0,y.mixin)(this,l),this._hasResolve=!!c,this.resolve=async w=>{if(c&&!this.resolved){const f=await c(w);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[163],Ee([0,1,3,12,133]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,D,P,t){const y={command:k};if(D&&Object.keys(D).length>0&&(y.arguments=D),this.internalSend("request",y),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const m=this.pendingRequests.get(y.seq);if(m){this.pendingRequests.delete(y.seq);const s={type:"response",seq:0,request_seq:y.seq,success:!1,command:k,message:(0,_.localize)(0,null,t,k)};m(s)}},t)}return P&&this.pendingRequests.set(y.seq,P),y.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,D){return k.type!=="event"||D.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,M.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const D=k,P=this.pendingRequests.get(D.request_seq);P&&(this.pendingRequests.delete(D.request_seq),P(D));break}}}internalSend(k,D){D.type=k,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((D,P)=>k.set(P,D)),await(0,M.timeout)(500),k.forEach((D,P)=>{D({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(be[164],Ee([0,1,9,2,17,23,11]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function D(a,r,v){return a.replace(k,function(l,c){return r&&c.length>0&&c[0]!=="_"?l:v&&v.hasOwnProperty(c)?v[c]:l})}e.formatPII=D;function P(a){const r={};for(const v of Object.keys(a))v.startsWith("!")||(r[v]=a[v]);return r}e.filterExceptionsFromTelemetry=P;function t(a){return a.configuration.request==="attach"&&!y(a)&&(!a.parentSession||t(a.parentSession))}e.isSessionAttach=t;function y(a){let r=a.configuration.type;if(!!r)return r==="vslsShare"&&(r=a.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(r,"extensionhost")||(0,d.equalsIgnoreCase)(r,"pwa-extensionhost")?a:a.parentSession?y(a.parentSession):void 0}e.getExtensionHostDebugSession=y;function n(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=n;function m(a,r,v){let l,c=0,w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,f=null;for(;f=w.exec(a);){let S=f.index+1,R=S+f[0].length;if(S<=r&&R>=v){l=f[0],c=S;break}}if(l){let S=/\w+/g,R=null;for(;(R=S.exec(l))&&!(R.index+1+c+R[0].length>=v););R&&(l=l.substring(0,S.lastIndex))}return l?{start:c,end:c+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(a){return!!(a&&a.match(s))}e.isUri=u;function g(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(u(a.path))return M.URI.parse(a.path);if((0,_.isAbsolute)(a.path))return M.URI.file(a.path)}return a.path}function I(a){if(typeof a.path=="object"){const r=M.URI.revive(a.path);if(r)return r.scheme===F.Schemas.file?r.fsPath:r.toString()}return a.path}function E(a,r){const v=r?g:I,l=(0,A.deepClone)(a);return h(l,(c,w)=>{c&&w&&(w.path=v(w))}),l}e.convertToDAPaths=E;function o(a,r){const v=r?g:I,l=(0,A.deepClone)(a);return h(l,(c,w)=>{!c&&w&&(w.path=v(w))}),l}e.convertToVSCPaths=o;function h(a,r){switch(a.type){case"event":const v=a;switch(v.event){case"output":r(!1,v.body.source);break;case"loadedSource":r(!1,v.body.source);break;case"breakpoint":r(!1,v.body.breakpoint.source);break;default:break}break;case"request":const l=a;switch(l.command){case"setBreakpoints":r(!0,l.arguments.source);break;case"breakpointLocations":r(!0,l.arguments.source);break;case"source":r(!0,l.arguments.source);break;case"gotoTargets":r(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(w=>r(!1,w));break;default:break}break;case"response":const c=a;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(w=>r(!1,w.source));break;case"loadedSources":c.body.sources.forEach(w=>r(!1,w));break;case"scopes":c.body.scopes.forEach(w=>r(!1,w.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(w=>r(!1,w.source));break;case"setBreakpoints":c.body.breakpoints.forEach(w=>r(!1,w.source));break;default:break}break}}function C(a){return a.filter(r=>!r.presentation?.hidden).sort((r,v)=>r.presentation?v.presentation?r.presentation.group?v.presentation.group?r.presentation.group!==v.presentation.group?r.presentation.group.localeCompare(v.presentation.group):i(r.presentation.order,v.presentation.order):-1:v.presentation.group?1:i(r.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.getVisibleAndSorted=C;function i(a,r){return typeof a!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:a-r}async function p(a,r){const v=a.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorMode});if(v!=="none"&&(await r.saveAll(),v==="allEditorsInActiveGroup")){const l=r.activeEditorPane;l&&await r.save({editor:l.input,groupId:l.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=p}),define(be[89],Ee([0,1,27,79,11,17,25,46]),function(oe,e,d,M,_,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(S){S[S.Markup=1]="Markup",S[S.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(S){S[S.Running=1]="Running",S[S.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(S){S[S.Pending=2]="Pending",S[S.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var y;(function(S){S[S.WithHardKernelDependency=0]="WithHardKernelDependency",S[S.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",S[S.Pure=2]="Pure",S[S.Never=3]="Never"})(y=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(S){S.Always="always",S.Never="never",S.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(S){S[S.ModelChange=1]="ModelChange",S[S.Move=2]="Move",S[S.ChangeLanguage=5]="ChangeLanguage",S[S.Initialize=6]="Initialize",S[S.ChangeCellMetadata=7]="ChangeCellMetadata",S[S.Output=8]="Output",S[S.OutputItem=9]="OutputItem",S[S.ChangeCellContent=10]="ChangeCellContent",S[S.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",S[S.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",S[S.ChangeCellMime=13]="ChangeCellMime",S[S.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var s;(function(S){S[S.Handle=0]="Handle",S[S.Index=1]="Index"})(s=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(S){S[S.Replace=1]="Replace",S[S.Output=2]="Output",S[S.Metadata=3]="Metadata",S[S.CellLanguage=4]="CellLanguage",S[S.DocumentMetadata=5]="DocumentMetadata",S[S.Move=6]="Move",S[S.OutputItems=7]="OutputItems",S[S.PartialMetadata=8]="PartialMetadata",S[S.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var g;(function(S){S.scheme=_.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function T(B,G){return B.with({scheme:S.scheme,fragment:`ch${G.toString().padStart(7,"0")}${B.scheme!==_.Schemas.file?B.scheme:""}`})}S.generate=T;function L(B){if(B.scheme!==S.scheme)return;const G=R.exec(B.fragment);return G?{handle:Number(G[1]),notebook:B.with({scheme:B.fragment.substr(G[0].length)||_.Schemas.file,fragment:null})}:void 0}S.parse=L;function b(B){if(B.scheme!==_.Schemas.vscodeNotebookCellMetadata)return;const G=R.exec(B.fragment);return G?{handle:Number(G[1]),notebook:B.with({scheme:B.fragment.substr(G[0].length)||_.Schemas.file,fragment:null})}:void 0}S.parseCellMetadataUri=b;function x(B,G,H){return B.with({scheme:H,fragment:`ch${G.toString().padStart(7,"0")}${B.scheme!==_.Schemas.file?B.scheme:""}`})}S.generateCellUri=x;function $(B,G){if(B.scheme!==G)return;const H=R.exec(B.fragment);return H?{handle:Number(H[1]),notebook:B.with({scheme:B.fragment.substr(H[0].length)||_.Schemas.file,fragment:null})}:void 0}S.parseCellUri=$})(g=e.CellUri||(e.CellUri={}));const I=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(S){return I.get(S)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=E;function o(S){return I.get(S)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function h(S){return I.get(S)?.mergeable??!1}e.mimeTypeIsMergeable=h;function C(S,R){return F.isWindows&&(S=S.replace(/\//g,"\\"),R=R.replace(/\//g,"\\")),d.match(S,R)}function i(S,R,T){let L=0;for(let b=0;b<R.length;b++){if(C(R[b],S))return L;L++}for(let b=0;b<T.length;b++){if(C(T[b],S))return L;L++}return L}function p(S,R,T){return S.sort((L,b)=>i(L,R,T)-i(b,R,T))}e.sortMimeTypes=p;function a(S,R,T,L=(b,x)=>b===x){const b=[];function x(G,H,W){if(H===0&&W.length===0)return;const ne=b[b.length-1];ne&&ne.start+ne.deleteCount===G?(ne.deleteCount+=H,ne.toInsert.push(...W)):b.push({start:G,deleteCount:H,toInsert:W})}let $=0,B=0;for(;;){if($===S.length){x($,0,R.slice(B));break}if(B===R.length){x($,S.length-$,[]);break}const G=S[$],H=R[B];if(L(G,H)){$+=1,B+=1;continue}T(H)?(x($,1,[]),$+=1):(x($,0,[H]),B+=1)}return b}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(S){S.default="default",S.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function v(S){const R=S;return!!((typeof R.include=="string"||d.isRelativePattern(R.include))&&(typeof R.exclude=="string"||d.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=v;function l(S,R,T){if(Array.isArray(S.viewType)&&S.viewType.indexOf(R)>=0||S.viewType===R)return!0;if(S.filenamePattern){let L=v(S.filenamePattern)?S.filenamePattern.include:S.filenamePattern,b=v(S.filenamePattern)?S.filenamePattern.exclude:void 0;if(d.match(L,(0,A.basename)(T.fsPath).toLowerCase()))return!(b&&d.match(b,(0,A.basename)(T.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class c{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let T=0;T<this.textModel.cells.length;T++)R[T]=this.textModel.cells[T].getHashValue();return R}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var w;(function(S){S[S.Left=1]="Left",S[S.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class f{static create(R){return`${f._prefix}${R}`}static parse(R){if(R.startsWith(f._prefix))return R.substr(f._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=f,f._prefix="notebook/"}),define(be[165],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(_){_[_.Output=1]="Output",_[_.OutputItems=2]="OutputItems",_[_.ExecutionState=3]="ExecutionState",_[_.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(be[166],Ee([0,1,135,4,46]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new _.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new _.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new _.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[167],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=d;function M(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=M}),define(be[90],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var d;(function(y){y[y.Unset=0]="Unset",y[y.Queued=1]="Queued",y[y.Running=2]="Running",y[y.Passed=3]="Passed",y[y.Failed=4]="Failed",y[y.Skipped=5]="Skipped",y[y.Errored=6]="Errored"})(d=e.TestResultState||(e.TestResultState={}));var M;(function(y){y[y.Run=2]="Run",y[y.Debug=4]="Debug",y[y.Coverage=8]="Coverage",y[y.HasNonDefaultProfile=16]="HasNonDefaultProfile",y[y.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(y){y[y.Error=0]="Error",y[y.Info=1]="Info"})(_=e.TestMessageType||(e.TestMessageType={}));var A;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const F=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&(y.item=y.item?Object.assign(y.item,n.item):n.item)};e.applyTestItemUpdate=F;var k;(function(y){y[y.Function=0]="Function",y[y.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var D;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",y[y.Retire=4]="Retire",y[y.AddTag=5]="AddTag",y[y.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(n){}update(n){}remove(n,m){}complete(){}}e.IncrementalChangeCollector=P;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const m=this.createChangeCollector();for(const s of n)switch(s[0]){case 0:{const u=s[1];if(u.parent){if(this.items.has(u.parent)){const g=this.items.get(u.parent);g.children.add(u.item.extId);const I=this.createItem(u,g);this.items.set(u.item.extId,I),m.add(I)}}else{const g=this.createItem(u);this.roots.add(g),this.items.set(u.item.extId,g),m.add(g)}u.expand===2&&this.busyControllerCount++;break}case 1:{const u=s[1],g=this.items.get(u.extId);if(!g)break;u.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,u.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,u),m.update(g);break}case 2:{const u=this.items.get(s[1]);if(!u)break;u.parent?this.items.get(u.parent).children.delete(u.item.extId):this.roots.delete(u);const g=[[s[1]]];for(;g.length;)for(const I of g.pop()){const E=this.items.get(I);E&&(g.push(E.children),this.items.delete(I),m.remove(E,E!==u),E.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(s[1]);break;case 3:this.updatePendingRoots(s[1]);break;case 5:this._tags.set(s[1].id,s[1]);break;case 6:this._tags.delete(s[1]);break}m.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=t}),define(be[68],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(A){A.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class _{constructor(F,k=F.length){if(this.path=F,this.viewEnd=k,F.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(F,k,D=F.parent){if(F.id===k)return new _([k]);let P=[F.id];for(let t=D;t&&t.id!==k;t=t.parent)P.push(t.id);return P.push(k),new _(P.reverse())}static isRoot(F){return!F.includes("\0")}static fromString(F){return new _(F.split("\0"))}static join(F,k){return new _([...F.path,k])}static joinToString(F,k){return F.toString()+"\0"+k}static compare(F,k){return F===k?0:k.startsWith(F+"\0")?2:F.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new _(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let F=1;F<=this.viewEnd;F++)yield new _(this.path,F)}compare(F){if(typeof F=="string")return _.compare(this.toString(),F);for(let k=0;k<F.viewEnd&&k<this.viewEnd;k++)if(F.path[k]!==this.path[k])return 1;return F.viewEnd>this.viewEnd?2:F.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let F=1;F<this.viewEnd;F++)this.stringifed+="\0",this.stringifed+=this.path[F]}return this.stringifed}}e.TestId=_}),define(be[168],Ee([0,1,17,91,10,23,25,78,136]),function(oe,e,d,M,_,A,F,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(y,n,m){this._contributedVariables=new Map,this._context=y,this._labelService=n,m&&(this._envVariablesPromise=m.then(s=>this.prepareEnv(s)))}prepareEnv(y){if(F.isWindows){const n=Object.create(null);return Object.keys(y).forEach(m=>{n[m.toLowerCase()]=y[m]}),n}return y}resolveWithEnvironment(y,n,m){return this.recursiveResolve(this.prepareEnv(y),n?n.uri:void 0,m)}async resolveAsync(y,n){return this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,n)}async resolveAnyBase(y,n,m,s){const u=A.deepClone(n);return F.isWindows&&u.windows?Object.keys(u.windows).forEach(g=>u[g]=u.windows[g]):F.isMacintosh&&u.osx?Object.keys(u.osx).forEach(g=>u[g]=u.osx[g]):F.isLinux&&u.linux&&Object.keys(u.linux).forEach(g=>u[g]=u.linux[g]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,u,m,s)}async resolveAnyAsync(y,n,m){return this.resolveAnyBase(y,n,m)}async resolveAnyMap(y,n,m){const s=new Map;return{newConfig:await this.resolveAnyBase(y,n,m,s),resolvedVariables:s}}resolveWithInteractionReplace(y,n,m,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,n,m,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,n){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,n)}recursiveResolve(y,n,m,s,u){if(_.isString(m))return this.resolveString(y,n,m,s,u);if(_.isArray(m))return m.map(g=>this.recursiveResolve(y,n,g,s,u));if(_.isObject(m)){let g=Object.create(null);return Object.keys(m).forEach(I=>{const E=this.resolveString(y,n,I,s,u);g[E]=this.recursiveResolve(y,n,m[I],s,u)}),g}return m}resolveString(y,n,m,s,u){return m.replace(P.VARIABLE_REGEXP,(I,E)=>{if(E.includes(P.VARIABLE_LHS))return I;let o=this.evaluateSingleVariable(y,I,E,n,s);return u&&u.set(E,o),o!==I&&_.isString(o)&&o.match(P.VARIABLE_REGEXP)&&(o=this.resolveString(y,n,o,s,u)),o})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}evaluateSingleVariable(y,n,m,s,u){let g;const I=m.split(":");I.length>1&&(m=I[0],g=I[1]);const E=()=>{const C=this._context.getFilePath();if(C)return C;throw new Error((0,D.localize)(0,null,n))},o=()=>{const C=E();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,D.localize)(1,null,n,d.basename(C)))},h=()=>{if(g){const C=this._context.getFolderUri(g);if(C)return C;throw new Error((0,D.localize)(2,null,n,g))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,n)):new Error((0,D.localize)(4,null,n))};switch(m){case"env":if(g){if(y){const C=y[F.isWindows?g.toLowerCase():g];if(_.isString(C))return C}return""}throw new Error((0,D.localize)(5,null,n));case"config":if(g){const C=this._context.getConfigurationValue(s,g);if(_.isUndefinedOrNull(C))throw new Error((0,D.localize)(6,null,n,g));if(_.isObject(C))throw new Error((0,D.localize)(7,null,n,g));return C}throw new Error((0,D.localize)(8,null,n));case"command":return this.resolveFromMap(n,g,u,"command");case"input":return this.resolveFromMap(n,g,u,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return s||g?(0,k.normalizeDriveLetter)(this.fsPath(h())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(h()));case"lineNumber":const C=this._context.getLineNumber();if(C)return C;throw new Error((0,D.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,D.localize)(10,null,n));case"file":return E();case"fileWorkspaceFolder":return o();case"relativeFile":return s||g?d.relative(this.fsPath(h()),E()):E();case"relativeFileDirname":const p=d.dirname(E());if(s||g){const l=d.relative(this.fsPath(h()),p);return l.length===0?".":l}return p;case"fileDirname":return d.dirname(E());case"fileExtname":return d.extname(E());case"fileBasename":return d.basename(E());case"fileBasenameNoExtension":const a=d.basename(E());return a.slice(0,a.length-d.extname(a).length);case"fileDirnameBasename":return d.basename(d.dirname(E()));case"execPath":const r=this._context.getExecPath();return r||n;case"execInstallFolder":const v=this._context.getAppRoot();return v||n;case"pathSeparator":return d.sep;default:try{const l=g?`${m}:${g}`:m;return this.resolveFromMap(n,l,u,void 0)}catch(l){return n}}}}resolveFromMap(y,n,m,s){if(n&&m){const u=s===void 0?m[n]:m[s+":"+n];if(typeof u=="string")return u;throw new Error((0,D.localize)(11,null,y))}return y}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[92],Ee([0,1,4,161]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var _;(function(u){u[u.UP=0]="UP",u[u.DOWN=1]="DOWN",u[u.LEFT=2]="LEFT",u[u.RIGHT=3]="RIGHT"})(_=e.GroupDirection||(e.GroupDirection={}));var A;(function(u){u[u.HORIZONTAL=0]="HORIZONTAL",u[u.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var F;(function(u){u[u.FIRST=0]="FIRST",u[u.LAST=1]="LAST",u[u.NEXT=2]="NEXT",u[u.PREVIOUS=3]="PREVIOUS"})(F=e.GroupLocation||(e.GroupLocation={}));var k;(function(u){u[u.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",u[u.EVEN=1]="EVEN",u[u.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(u){u[u.COPY_EDITORS=0]="COPY_EDITORS",u[u.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function P(u){const g=u;return(0,M.isEditorInput)(g?.editor)&&(0,M.isEditorInput)(g?.replacement)}e.isEditorReplacement=P;var t;(function(u){u[u.CREATION_TIME=0]="CREATION_TIME",u[u.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",u[u.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(u){u[u.GROUP_ACTIVE=0]="GROUP_ACTIVE",u[u.GROUP_INDEX=1]="GROUP_INDEX",u[u.GROUP_LOCKED=2]="GROUP_LOCKED",u[u.EDITOR_OPEN=3]="EDITOR_OPEN",u[u.EDITOR_CLOSE=4]="EDITOR_CLOSE",u[u.EDITOR_MOVE=5]="EDITOR_MOVE",u[u.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",u[u.EDITOR_LABEL=7]="EDITOR_LABEL",u[u.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",u[u.EDITOR_PIN=9]="EDITOR_PIN",u[u.EDITOR_STICKY=10]="EDITOR_STICKY",u[u.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(y=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(u){u[u.NEW_EDITOR=1]="NEW_EDITOR",u[u.MOVE_EDITOR=2]="MOVE_EDITOR",u[u.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function m(u){const g=u;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=m;function s(u){return u.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=s}),define(be[169],Ee([0,1,4,92]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function _(A){const F=A;return typeof A=="number"||(0,M.isEditorGroup)(F)}e.isPreferredGroup=_}),define(be[8],Ee([0,1,14,22,77,230,55,23,10,2,44,59,137,83,49,89,68,169,7]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(de){function ge(z){const{selectionStartLineNumber:we,selectionStartColumn:ke,positionLineNumber:Je,positionColumn:xe}=z,ct=new E.Position(we-1,ke-1),pt=new E.Position(Je-1,xe-1);return new E.Selection(ct,pt)}de.to=ge;function X(z){const{anchor:we,active:ke}=z;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:ke.line+1,positionColumn:ke.character+1}}de.from=X})(o=e.Selection||(e.Selection={}));var h;(function(de){function ge(z){if(!z)return;const{start:we,end:ke}=z;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:ke.line+1,endColumn:ke.character+1}}de.from=ge;function X(z){if(!z)return;const{startLineNumber:we,startColumn:ke,endLineNumber:Je,endColumn:xe}=z;return new E.Range(we-1,ke-1,Je-1,xe-1)}de.to=X})(h=e.Range||(e.Range={}));var C;(function(de){function ge(X){switch(X){case 1:return E.StandardTokenType.Comment;case 0:return E.StandardTokenType.Other;case 4:return E.StandardTokenType.RegEx;case 2:return E.StandardTokenType.String}}de.to=ge})(C=e.TokenType||(e.TokenType={}));var i;(function(de){function ge(z){return new E.Position(z.lineNumber-1,z.column-1)}de.to=ge;function X(z){return{lineNumber:z.line+1,column:z.character+1}}de.from=X})(i=e.Position||(e.Position={}));var p;(function(de){function ge(we,ke){return(0,d.coalesce)((0,d.asArray)(we).map(Je=>X(Je,ke)))}de.from=ge;function X(we,ke){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:z(we.scheme,ke),pattern:typeof we.pattern=="undefined"?void 0:rt.from(we.pattern),exclusive:we.exclusive}}function z(we,ke){return ke&&typeof we=="string"?ke.transformOutgoingScheme(we):we}})(p=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(de){function ge(z){switch(z){case E.DiagnosticTag.Unnecessary:return 1;case E.DiagnosticTag.Deprecated:return 2}}de.from=ge;function X(z){switch(z){case 1:return E.DiagnosticTag.Unnecessary;case 2:return E.DiagnosticTag.Deprecated;default:return}}de.to=X})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(de){function ge(z){let we;return z.code&&((0,D.isString)(z.code)||(0,D.isNumber)(z.code)?we=String(z.code):we={value:String(z.code.value),target:z.code.target}),{...h.from(z.range),message:z.message,source:z.source,code:we,severity:l.from(z.severity),relatedInformation:z.relatedInformation&&z.relatedInformation.map(v.from),tags:Array.isArray(z.tags)?(0,d.coalesce)(z.tags.map(a.from)):void 0}}de.from=ge;function X(z){const we=new E.Diagnostic(h.to(z),z.message,l.to(z.severity));return we.source=z.source,we.code=(0,D.isString)(z.code)?z.code:z.code?.value,we.relatedInformation=z.relatedInformation&&z.relatedInformation.map(v.to),we.tags=z.tags&&(0,d.coalesce)(z.tags.map(a.to)),we}de.to=X})(r=e.Diagnostic||(e.Diagnostic={}));var v;(function(de){function ge(z){return{...h.from(z.location.range),message:z.message,resource:z.location.uri}}de.from=ge;function X(z){return new E.DiagnosticRelatedInformation(new E.Location(z.resource,h.to(z)),z.message)}de.to=X})(v=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(de){function ge(z){switch(z){case E.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case E.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case E.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case E.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}de.from=ge;function X(z){switch(z){case m.MarkerSeverity.Info:return E.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return E.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return E.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return E.DiagnosticSeverity.Hint;default:return E.DiagnosticSeverity.Error}}de.to=X})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(de){function ge(z){return typeof z=="number"&&z>=E.ViewColumn.One?z-1:z===E.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}de.from=ge;function X(z){if(typeof z=="number"&&z>=0)return z+1;throw new Error("invalid 'EditorGroupColumn'")}de.to=X})(c=e.ViewColumn||(e.ViewColumn={}));function w(de){return typeof de.range!="undefined"}function f(de){return de.length===0?!0:!!w(de[0])}e.isDecorationOptionsArr=f;var S;(function(de){function ge(xe){return xe.map(de.from)}de.fromMany=ge;function X(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function z(xe){let ct;if(X(xe)){const{language:ft,value:_t}=xe;ct={value:"```"+ft+`
`+_t+"\n```\n"}}else E.MarkdownString.isMarkdownString(xe)?ct={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml}:typeof xe=="string"?ct={value:xe}:ct={value:""};const pt=Object.create(null);ct.uris=pt;const dt=ft=>{try{let _t=P.URI.parse(ft,!0);_t=_t.with({query:we(_t.query,pt)}),pt[ft]=_t}catch(_t){}return""},ht=new A.Renderer;return ht.link=dt,ht.image=ft=>dt(_.parseHrefAndDimensions(ft).href),A(ct.value,{renderer:ht}),ct}de.from=z;function we(xe,ct){if(!xe)return xe;let pt;try{pt=(0,F.parse)(xe)}catch(ht){}if(!pt)return xe;let dt=!1;return pt=(0,k.cloneAndChange)(pt,ht=>{if(P.URI.isUri(ht)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ft]=ht,dt=!0,ft}else return}),dt?JSON.stringify(pt):xe}function ke(xe){const ct=new E.MarkdownString(xe.value,xe.supportThemeIcons);return ct.isTrusted=xe.isTrusted,ct.supportHtml=xe.supportHtml,ct}de.to=ke;function Je(xe){if(!!xe)return typeof xe=="string"?xe:de.from(xe)}de.fromStrict=Je})(S=e.MarkdownString||(e.MarkdownString={}));function R(de){return f(de)?de.map(ge=>({range:h.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?S.fromMany(ge.hoverMessage):ge.hoverMessage?S.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):de.map(ge=>({range:h.from(ge)}))}e.fromRangeOrRangeWithMessage=R;function T(de){return typeof de=="undefined"?de:typeof de=="string"?P.URI.file(de):de}e.pathOrURIToURI=T;var L;(function(de){function ge(X){return typeof X=="undefined"?X:{contentText:X.contentText,contentIconPath:X.contentIconPath?T(X.contentIconPath):void 0,border:X.border,borderColor:X.borderColor,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,color:X.color,backgroundColor:X.backgroundColor,margin:X.margin,width:X.width,height:X.height}}de.from=ge})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var b;(function(de){function ge(X){return typeof X=="undefined"?X:{backgroundColor:X.backgroundColor,outline:X.outline,outlineColor:X.outlineColor,outlineStyle:X.outlineStyle,outlineWidth:X.outlineWidth,border:X.border,borderColor:X.borderColor,borderRadius:X.borderRadius,borderSpacing:X.borderSpacing,borderStyle:X.borderStyle,borderWidth:X.borderWidth,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,cursor:X.cursor,color:X.color,opacity:X.opacity,letterSpacing:X.letterSpacing,gutterIconPath:X.gutterIconPath?T(X.gutterIconPath):void 0,gutterIconSize:X.gutterIconSize,overviewRulerColor:X.overviewRulerColor,before:X.before?L.from(X.before):void 0,after:X.after?L.from(X.after):void 0}}de.from=ge})(b=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var x;(function(de){function ge(X){if(typeof X=="undefined")return X;switch(X){case E.DecorationRangeBehavior.OpenOpen:return 0;case E.DecorationRangeBehavior.ClosedClosed:return 1;case E.DecorationRangeBehavior.OpenClosed:return 2;case E.DecorationRangeBehavior.ClosedOpen:return 3}}de.from=ge})(x=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(de){function ge(X){return{isWholeLine:X.isWholeLine,rangeBehavior:X.rangeBehavior?x.from(X.rangeBehavior):void 0,overviewRulerLane:X.overviewRulerLane,light:X.light?b.from(X.light):void 0,dark:X.dark?b.from(X.dark):void 0,backgroundColor:X.backgroundColor,outline:X.outline,outlineColor:X.outlineColor,outlineStyle:X.outlineStyle,outlineWidth:X.outlineWidth,border:X.border,borderColor:X.borderColor,borderRadius:X.borderRadius,borderSpacing:X.borderSpacing,borderStyle:X.borderStyle,borderWidth:X.borderWidth,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,cursor:X.cursor,color:X.color,opacity:X.opacity,letterSpacing:X.letterSpacing,gutterIconPath:X.gutterIconPath?T(X.gutterIconPath):void 0,gutterIconSize:X.gutterIconSize,overviewRulerColor:X.overviewRulerColor,before:X.before?L.from(X.before):void 0,after:X.after?L.from(X.after):void 0}}de.from=ge})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var B;(function(de){function ge(z){return{text:z.newText,eol:z.newEol&&q.from(z.newEol),range:h.from(z.range)}}de.from=ge;function X(z){const we=new E.TextEdit(h.to(z.range),z.text);return we.newEol=typeof z.eol=="undefined"?void 0:q.to(z.eol),we}de.to=X})(B=e.TextEdit||(e.TextEdit={}));var G;(function(de){function ge(z,we,ke){const Je={edits:[]};if(z instanceof E.WorkspaceEdit)for(let xe of z._allEntries())if(xe._type===1)Je.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata});else if(xe._type===2){const ct=we?.getDocument(xe.uri);Je.edits.push({_type:2,resource:xe.uri,edit:B.from(xe.edit),modelVersionId:ct?.version,metadata:xe.metadata})}else xe._type===3?Je.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:ke?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version}):xe._type===5&&Je.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:ke?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Xe.from)}});return Je}de.from=ge;function X(z){const we=new E.WorkspaceEdit;for(const ke of z.edits)ke.edit?we.replace(P.URI.revive(ke.resource),h.to(ke.edit.range),ke.edit.text):we.renameFile(P.URI.revive(ke.oldUri),P.URI.revive(ke.newUri),ke.options);return we}de.to=X})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(de){const ge=Object.create(null);ge[E.SymbolKind.File]=0,ge[E.SymbolKind.Module]=1,ge[E.SymbolKind.Namespace]=2,ge[E.SymbolKind.Package]=3,ge[E.SymbolKind.Class]=4,ge[E.SymbolKind.Method]=5,ge[E.SymbolKind.Property]=6,ge[E.SymbolKind.Field]=7,ge[E.SymbolKind.Constructor]=8,ge[E.SymbolKind.Enum]=9,ge[E.SymbolKind.Interface]=10,ge[E.SymbolKind.Function]=11,ge[E.SymbolKind.Variable]=12,ge[E.SymbolKind.Constant]=13,ge[E.SymbolKind.String]=14,ge[E.SymbolKind.Number]=15,ge[E.SymbolKind.Boolean]=16,ge[E.SymbolKind.Array]=17,ge[E.SymbolKind.Object]=18,ge[E.SymbolKind.Key]=19,ge[E.SymbolKind.Null]=20,ge[E.SymbolKind.EnumMember]=21,ge[E.SymbolKind.Struct]=22,ge[E.SymbolKind.Event]=23,ge[E.SymbolKind.Operator]=24,ge[E.SymbolKind.TypeParameter]=25;function X(we){return typeof ge[we]=="number"?ge[we]:6}de.from=X;function z(we){for(const ke in ge)if(ge[ke]===we)return Number(ke);return E.SymbolKind.Property}de.to=z})(H=e.SymbolKind||(e.SymbolKind={}));var W;(function(de){function ge(z){switch(z){case E.SymbolTag.Deprecated:return 1}}de.from=ge;function X(z){switch(z){case 1:return E.SymbolTag.Deprecated}}de.to=X})(W=e.SymbolTag||(e.SymbolTag={}));var ne;(function(de){function ge(z){return{name:z.name,kind:H.from(z.kind),tags:z.tags&&z.tags.map(W.from),containerName:z.containerName,location:re.from(z.location)}}de.from=ge;function X(z){const we=new E.SymbolInformation(z.name,H.to(z.kind),z.containerName,re.to(z.location));return we.tags=z.tags&&z.tags.map(W.to),we}de.to=X})(ne=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var V;(function(de){function ge(z){const we={name:z.name||"!!MISSING: name!!",detail:z.detail,range:h.from(z.range),selectionRange:h.from(z.selectionRange),kind:H.from(z.kind),tags:z.tags?.map(W.from)??[]};return z.children&&(we.children=z.children.map(ge)),we}de.from=ge;function X(z){const we=new E.DocumentSymbol(z.name,z.detail,H.to(z.kind),h.to(z.range),h.to(z.selectionRange));return(0,d.isNonEmptyArray)(z.tags)&&(we.tags=z.tags.map(W.to)),z.children&&(we.children=z.children.map(X)),we}de.to=X})(V=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(de){function ge(z){const we=new E.CallHierarchyItem(H.to(z.kind),z.name,z.detail||"",P.URI.revive(z.uri),h.to(z.range),h.to(z.selectionRange));return we._sessionId=z._sessionId,we._itemId=z._itemId,we}de.to=ge;function X(z,we,ke){if(we=we??z._sessionId,ke=ke??z._itemId,we===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:ke,name:z.name,detail:z.detail,kind:H.from(z.kind),uri:z.uri,range:h.from(z.range),selectionRange:h.from(z.selectionRange),tags:z.tags?.map(W.from)}}de.from=X})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(de){function ge(X){return new E.CallHierarchyIncomingCall(Y.to(X.from),X.fromRanges.map(z=>h.to(z)))}de.to=ge})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var le;(function(de){function ge(X){return new E.CallHierarchyOutgoingCall(Y.to(X.to),X.fromRanges.map(z=>h.to(z)))}de.to=ge})(le=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var re;(function(de){function ge(z){return{range:z.range&&h.from(z.range),uri:z.uri}}de.from=ge;function X(z){return new E.Location(P.URI.revive(z.uri),h.to(z.range))}de.to=X})(re=e.location||(e.location={}));var ve;(function(de){function ge(z){const we=z,ke=z;return{originSelectionRange:we.originSelectionRange?h.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:ke.uri,range:h.from(we.targetRange?we.targetRange:ke.range),targetSelectionRange:we.targetSelectionRange?h.from(we.targetSelectionRange):void 0}}de.from=ge;function X(z){return{targetUri:P.URI.revive(z.uri),targetRange:h.to(z.range),targetSelectionRange:z.targetSelectionRange?h.to(z.targetSelectionRange):void 0,originSelectionRange:z.originSelectionRange?h.to(z.originSelectionRange):void 0}}de.to=X})(ve=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(de){function ge(z){return{range:h.from(z.range),contents:S.fromMany(z.contents)}}de.from=ge;function X(z){return new E.Hover(z.contents.map(S.to),h.to(z.range))}de.to=X})(Fe=e.Hover||(e.Hover={}));var Me;(function(de){function ge(z){return{range:h.from(z.range),expression:z.expression}}de.from=ge;function X(z){return new E.EvaluatableExpression(h.to(z.range),z.expression)}de.to=X})(Me=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Oe;(function(de){function ge(z){if(z instanceof E.InlineValueText)return{type:"text",range:h.from(z.range),text:z.text};if(z instanceof E.InlineValueVariableLookup)return{type:"variable",range:h.from(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};if(z instanceof E.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(z.range),expression:z.expression};throw new Error("Unknown 'InlineValue' type")}de.from=ge;function X(z){switch(z.type){case"text":return{range:h.to(z.range),text:z.text};case"variable":return{range:h.to(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};case"expression":return{range:h.to(z.range),expression:z.expression}}}de.to=X})(Oe=e.InlineValue||(e.InlineValue={}));var Ke;(function(de){function ge(z){return{frameId:z.frameId,stoppedLocation:h.from(z.stoppedLocation)}}de.from=ge;function X(z){return new E.InlineValueContext(z.frameId,h.to(z.stoppedLocation))}de.to=X})(Ke=e.InlineValueContext||(e.InlineValueContext={}));var je;(function(de){function ge(z){return{range:h.from(z.range),kind:z.kind}}de.from=ge;function X(z){return new E.DocumentHighlight(h.to(z.range),z.kind)}de.to=X})(je=e.DocumentHighlight||(e.DocumentHighlight={}));var Ve;(function(de){function ge(X){switch(X){case 1:return E.CompletionTriggerKind.TriggerCharacter;case 2:return E.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return E.CompletionTriggerKind.Invoke}}de.to=ge})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var U;(function(de){function ge(X){return{triggerKind:Ve.to(X.triggerKind),triggerCharacter:X.triggerCharacter}}de.to=ge})(U=e.CompletionContext||(e.CompletionContext={}));var Q;(function(de){function ge(z){switch(z){case E.CompletionItemTag.Deprecated:return 1}}de.from=ge;function X(z){switch(z){case 1:return E.CompletionItemTag.Deprecated}}de.to=X})(Q=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(de){const ge=new Map([[E.CompletionItemKind.Method,0],[E.CompletionItemKind.Function,1],[E.CompletionItemKind.Constructor,2],[E.CompletionItemKind.Field,3],[E.CompletionItemKind.Variable,4],[E.CompletionItemKind.Class,5],[E.CompletionItemKind.Interface,7],[E.CompletionItemKind.Struct,6],[E.CompletionItemKind.Module,8],[E.CompletionItemKind.Property,9],[E.CompletionItemKind.Unit,12],[E.CompletionItemKind.Value,13],[E.CompletionItemKind.Constant,14],[E.CompletionItemKind.Enum,15],[E.CompletionItemKind.EnumMember,16],[E.CompletionItemKind.Keyword,17],[E.CompletionItemKind.Snippet,27],[E.CompletionItemKind.Text,18],[E.CompletionItemKind.Color,19],[E.CompletionItemKind.File,20],[E.CompletionItemKind.Reference,21],[E.CompletionItemKind.Folder,23],[E.CompletionItemKind.Event,10],[E.CompletionItemKind.Operator,11],[E.CompletionItemKind.TypeParameter,24],[E.CompletionItemKind.Issue,26],[E.CompletionItemKind.User,25]]);function X(ke){return ge.get(ke)??9}de.from=X;const z=new Map([[0,E.CompletionItemKind.Method],[1,E.CompletionItemKind.Function],[2,E.CompletionItemKind.Constructor],[3,E.CompletionItemKind.Field],[4,E.CompletionItemKind.Variable],[5,E.CompletionItemKind.Class],[7,E.CompletionItemKind.Interface],[6,E.CompletionItemKind.Struct],[8,E.CompletionItemKind.Module],[9,E.CompletionItemKind.Property],[12,E.CompletionItemKind.Unit],[13,E.CompletionItemKind.Value],[14,E.CompletionItemKind.Constant],[15,E.CompletionItemKind.Enum],[16,E.CompletionItemKind.EnumMember],[17,E.CompletionItemKind.Keyword],[27,E.CompletionItemKind.Snippet],[18,E.CompletionItemKind.Text],[19,E.CompletionItemKind.Color],[20,E.CompletionItemKind.File],[21,E.CompletionItemKind.Reference],[23,E.CompletionItemKind.Folder],[10,E.CompletionItemKind.Event],[11,E.CompletionItemKind.Operator],[24,E.CompletionItemKind.TypeParameter],[25,E.CompletionItemKind.User],[26,E.CompletionItemKind.Issue]]);function we(ke){return z.get(ke)??E.CompletionItemKind.Property}de.to=we})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var ae;(function(de){function ge(X,z){const we=new E.CompletionItem(X.label);return we.insertText=X.insertText,we.kind=ee.to(X.kind),we.tags=X.tags?.map(Q.to),we.detail=X.detail,we.documentation=_.isMarkdownString(X.documentation)?S.to(X.documentation):X.documentation,we.sortText=X.sortText,we.filterText=X.filterText,we.preselect=X.preselect,we.commitCharacters=X.commitCharacters,t.Range.isIRange(X.range)?we.range=h.to(X.range):typeof X.range=="object"&&(we.range={inserting:h.to(X.range.insert),replacing:h.to(X.range.replace)}),we.keepWhitespace=typeof X.insertTextRules=="undefined"?!1:Boolean(X.insertTextRules&1),typeof X.insertTextRules!="undefined"&&X.insertTextRules&4?we.insertText=new E.SnippetString(X.insertText):(we.insertText=X.insertText,we.textEdit=we.range instanceof E.Range?new E.TextEdit(we.range,we.insertText):void 0),X.additionalTextEdits&&X.additionalTextEdits.length>0&&(we.additionalTextEdits=X.additionalTextEdits.map(ke=>B.to(ke))),we.command=z&&X.command?z.fromInternal(X.command):void 0,we}de.to=ge})(ae=e.CompletionItem||(e.CompletionItem={}));var K;(function(de){function ge(z){return{label:z.label,documentation:z.documentation?S.fromStrict(z.documentation):void 0}}de.from=ge;function X(z){return{label:z.label,documentation:_.isMarkdownString(z.documentation)?S.to(z.documentation):z.documentation}}de.to=X})(K=e.ParameterInformation||(e.ParameterInformation={}));var se;(function(de){function ge(z){return{label:z.label,documentation:z.documentation?S.fromStrict(z.documentation):void 0,parameters:Array.isArray(z.parameters)?z.parameters.map(K.from):[],activeParameter:z.activeParameter}}de.from=ge;function X(z){return{label:z.label,documentation:_.isMarkdownString(z.documentation)?S.to(z.documentation):z.documentation,parameters:Array.isArray(z.parameters)?z.parameters.map(K.to):[],activeParameter:z.activeParameter}}de.to=X})(se=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(de){function ge(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(se.from):[]}}de.from=ge;function X(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(se.to):[]}}de.to=X})(he=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(de){function ge(z){return{text:z.text,position:i.from(z.position),kind:Ue.from(z.kind??E.InlayHintKind.Other),whitespaceBefore:z.whitespaceBefore,whitespaceAfter:z.whitespaceAfter}}de.from=ge;function X(z){const we=new E.InlayHint(z.text,i.to(z.position),Ue.to(z.kind));return we.whitespaceAfter=z.whitespaceAfter,we.whitespaceBefore=z.whitespaceBefore,we}de.to=X})(Ae=e.InlayHint||(e.InlayHint={}));var Ue;(function(de){function ge(z){return z}de.from=ge;function X(z){return z}de.to=X})(Ue=e.InlayHintKind||(e.InlayHintKind={}));var He;(function(de){function ge(z){return{range:h.from(z.range),url:z.target,tooltip:z.tooltip}}de.from=ge;function X(z){let we;if(z.url)try{we=typeof z.url=="string"?P.URI.parse(z.url,!0):P.URI.revive(z.url)}catch(ke){}return new E.DocumentLink(h.to(z.range),we)}de.to=X})(He=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(de){function ge(z){const we=new E.ColorPresentation(z.label);return z.textEdit&&(we.textEdit=B.to(z.textEdit)),z.additionalTextEdits&&(we.additionalTextEdits=z.additionalTextEdits.map(ke=>B.to(ke))),we}de.to=ge;function X(z){return{label:z.label,textEdit:z.textEdit?B.from(z.textEdit):void 0,additionalTextEdits:z.additionalTextEdits?z.additionalTextEdits.map(we=>B.from(we)):void 0}}de.from=X})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(de){function ge(z){return new E.Color(z[0],z[1],z[2],z[3])}de.to=ge;function X(z){return[z.red,z.green,z.blue,z.alpha]}de.from=X})(et=e.Color||(e.Color={}));var st;(function(de){function ge(z){return{range:h.from(z.range)}}de.from=ge;function X(z){return new E.SelectionRange(h.to(z.range))}de.to=X})(st=e.SelectionRange||(e.SelectionRange={}));var ye;(function(de){function ge(X){switch(X){case 2:return E.TextDocumentSaveReason.AfterDelay;case 1:return E.TextDocumentSaveReason.Manual;case 3:case 4:return E.TextDocumentSaveReason.FocusOut}}de.to=ge})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(de){function ge(z){switch(z){case E.TextEditorLineNumbersStyle.Off:return 0;case E.TextEditorLineNumbersStyle.Relative:return 2;case E.TextEditorLineNumbersStyle.On:default:return 1}}de.from=ge;function X(z){switch(z){case 0:return E.TextEditorLineNumbersStyle.Off;case 2:return E.TextEditorLineNumbersStyle.Relative;case 1:default:return E.TextEditorLineNumbersStyle.On}}de.to=X})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var q;(function(de){function ge(z){if(z===E.EndOfLine.CRLF)return 1;if(z===E.EndOfLine.LF)return 0}de.from=ge;function X(z){if(z===1)return E.EndOfLine.CRLF;if(z===0)return E.EndOfLine.LF}de.to=X})(q=e.EndOfLine||(e.EndOfLine={}));var Z;(function(de){function ge(X){if(typeof X=="object")return X.viewId;switch(X){case E.ProgressLocation.SourceControl:return 3;case E.ProgressLocation.Window:return 10;case E.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}de.from=ge})(Z=e.ProgressLocation||(e.ProgressLocation={}));var pe;(function(de){function ge(X){const z={start:X.start+1,end:X.end+1};return X.kind&&(z.kind=We.from(X.kind)),z}de.from=ge})(pe=e.FoldingRange||(e.FoldingRange={}));var We;(function(de){function ge(X){if(X)switch(X){case E.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}de.from=ge})(We=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ye;(function(de){function ge(X){if(X)return{pinned:typeof X.preview=="boolean"?!X.preview:void 0,inactive:X.background,preserveFocus:X.preserveFocus,selection:typeof X.selection=="object"?h.from(X.selection):void 0,override:typeof X.override=="boolean"?n.EditorResolution.DISABLED:void 0}}de.from=ge})(Ye=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var rt;(function(de){function ge(z){return z instanceof E.RelativePattern||typeof z=="string"?z:X(z)?new E.RelativePattern(z.base,z.pattern):z}de.from=ge;function X(z){const we=z;return we&&typeof we.base=="string"&&typeof we.pattern=="string"}})(rt=e.GlobPattern||(e.GlobPattern={}));var mt;(function(de){function ge(X){if(X){if(Array.isArray(X))return X.map(ge);if(typeof X=="string")return X;{const z=X;return{language:z.language,scheme:z.scheme,pattern:typeof z.pattern=="undefined"?void 0:rt.from(z.pattern),exclusive:z.exclusive}}}else return}de.from=ge})(mt=e.LanguageSelector||(e.LanguageSelector={}));var ut;(function(de){function ge(z){return{start:z.start,end:z.end}}de.from=ge;function X(z){return new E.NotebookRange(z.start,z.end)}de.to=X})(ut=e.NotebookRange||(e.NotebookRange={}));var St;(function(de){function ge(z){return{timing:typeof z.runStartTime=="number"&&typeof z.runEndTime=="number"?{startTime:z.runStartTime,endTime:z.runEndTime}:void 0,executionOrder:z.executionOrder,success:z.lastRunSuccess}}de.to=ge;function X(z){return{lastRunSuccess:z.success,runStartTime:z.timing?.startTime,runEndTime:z.timing?.endTime,executionOrder:z.executionOrder}}de.from=X})(St=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Tt;(function(de){function ge(z){switch(z){case E.NotebookCellKind.Markup:return u.CellKind.Markup;case E.NotebookCellKind.Code:default:return u.CellKind.Code}}de.from=ge;function X(z){switch(z){case u.CellKind.Markup:return E.NotebookCellKind.Markup;case u.CellKind.Code:default:return E.NotebookCellKind.Code}}de.to=X})(Tt=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(de){function ge(z){const we={metadata:z.metadata??Object.create(null),cells:[]};for(let ke of z.cells)E.NotebookCellData.validate(ke),we.cells.push(Xe.from(ke));return we}de.from=ge;function X(z){const we=new E.NotebookData(z.cells.map(Xe.to));return(0,D.isEmptyObject)(z.metadata)||(we.metadata=z.metadata),we}de.to=X})(It=e.NotebookData||(e.NotebookData={}));var Xe;(function(de){function ge(z){return{cellKind:Tt.from(z.kind),language:z.languageId,mime:z.mime,source:z.value,metadata:z.metadata,internalMetadata:St.from(z.executionSummary??{}),outputs:z.outputs?z.outputs.map(Pe.from):[]}}de.from=ge;function X(z){return new E.NotebookCellData(Tt.to(z.cellKind),z.source,z.language,z.mime,z.outputs?z.outputs.map(Pe.to):void 0,z.metadata,z.internalMetadata?St.to(z.internalMetadata):void 0)}de.to=X})(Xe=e.NotebookCellData||(e.NotebookCellData={}));var vt;(function(de){function ge(z){return{mime:z.mime,valueBytes:M.VSBuffer.wrap(z.data)}}de.from=ge;function X(z){return new E.NotebookCellOutputItem(z.valueBytes.buffer,z.mime)}de.to=X})(vt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Pe;(function(de){function ge(z){return{outputId:z.id,items:z.items.map(vt.from),metadata:z.metadata}}de.from=ge;function X(z){const we=z.items.map(vt.to);return new E.NotebookCellOutput(we,z.outputId,z.metadata)}de.to=X})(Pe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Se;(function(de){function ge(ke){if(ke!=null){if(ke instanceof E.RelativePattern||typeof ke=="string")return ke;if(we(ke))return new E.RelativePattern(ke.base,ke.pattern);if(z(ke))return{include:rt.from(ke.include)||void 0,exclude:rt.from(ke.exclude)||void 0}}}de.from=ge;function X(ke){return typeof ke=="string"?ke:we(ke)?{base:ke.base,pattern:ke.pattern}:{include:ke.include,exclude:ke.exclude}}de.to=X;function z(ke){const Je=ke,xe=rt.from(Je.include);if(!(xe&&xe instanceof E.RelativePattern||typeof xe=="string"))return!1;const ct=rt.from(Je.exclude);return!!(ct&&ct instanceof E.RelativePattern||typeof ct=="string")}function we(ke){const Je=ke;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Se=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ce;(function(de){function ge(X){return{backgroundColor:X.backgroundColor,borderColor:X.borderColor,top:X.top?L.from(X.top):void 0}}de.from=ge})(Ce=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var te;(function(de){function ge(X,z,we){const ke=typeof X.command=="string"?{title:"",command:X.command}:X.command;return{alignment:X.alignment===E.NotebookCellStatusBarAlignment.Left?1:2,command:z.toInternal(ke,we),text:X.text,tooltip:X.tooltip,accessibilityInformation:X.accessibilityInformation,priority:X.priority}}de.from=ge})(te=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(de){function ge(X){return{transientOutputs:X?.transientOutputs??!1,transientCellMetadata:X?.transientCellMetadata??{},transientDocumentMetadata:X?.transientDocumentMetadata??{}}}de.from=ge})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var me;(function(de){function ge(z){return{uri:z.uri,provides:z.provides}}de.from=ge;function X(z){return new E.NotebookRendererScript(P.URI.revive(z.uri),z.provides)}de.to=X})(me=e.NotebookRendererScript||(e.NotebookRendererScript={}));var fe;(function(de){function ge(z){return{message:S.fromStrict(z.message)||"",type:0,expected:z.expectedOutput,actual:z.actualOutput,location:z.location?re.from(z.location):void 0}}de.from=ge;function X(z){const we=new E.TestMessage(typeof z.message=="string"?z.message:S.to(z.message));return we.actualOutput=z.actual,we.expectedOutput=z.expected,we.location=z.location?re.to(z.location):void 0,we}de.to=X})(fe=e.TestMessage||(e.TestMessage={}));var Ie;(function(de){let ge;(function(X){X.Delimiter="\0"})(ge||(ge={})),de.namespace=(X,z)=>X+"\0"+z,de.denamespace=X=>{const z=X.indexOf("\0");return{ctrlId:X.slice(0,z),tagId:X.slice(z+1)}}})(Ie=e.TestTag||(e.TestTag={}));var Be;(function(de){function ge(ke){const Je=(0,s.getPrivateApiFor)(ke).controllerId;return{extId:g.TestId.fromExtHostTestItem(ke,Je).toString(),label:ke.label,uri:ke.uri,tags:ke.tags.map(xe=>Ie.namespace(Je,xe.id)),range:h.from(ke.range)||null,description:ke.description||null,error:ke.error&&S.fromStrict(ke.error)||null}}de.from=ge;function X(ke){return{id:g.TestId.fromString(ke.extId).localId,label:ke.label,uri:P.URI.revive(ke.uri),tags:(ke.tags||[]).map(Je=>{const{tagId:xe}=Ie.denamespace(Je);return new E.TestTag(xe)}),range:h.to(ke.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:ke.description||void 0}}de.toPlain=X;function z(ke){const Je=g.TestId.fromString(ke.extId),xe=new s.TestItemImpl(Je.controllerId,Je.localId,ke.label,P.URI.revive(ke.uri));return xe.range=h.to(ke.range||void 0),xe.description=ke.description||void 0,xe}function we(ke){let Je;for(const xe of ke.tests){const ct=z(xe.item);(0,s.getPrivateApiFor)(ct).parent=Je,Je=ct}return Je}de.toItemFromContext=we})(Be=e.TestItem||(e.TestItem={})),function(de){function ge(z){return{id:z.id}}de.from=ge;function X(z){return new E.TestTag(z.id)}de.to=X}(Ie=e.TestTag||(e.TestTag={}));var Ne;(function(de){const ge=(z,we)=>{const ke={...Be.toPlain(z.item),parent:void 0,taskStates:z.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(xe=>xe.type===0).map(fe.to)})),children:z.children.map(Je=>we.get(Je)).filter(D.isDefined).map(Je=>ge(Je,we))};for(const Je of ke.children)Je.parent=ke;return ke};function X(z){const we=[],ke=new Map;for(const Je of z.items)ke.set(Je.item.extId,Je),z.request.targets.some(xe=>xe.controllerId===Je.controllerId&&xe.testIds.includes(Je.item.extId))&&we.push(Je);return{completedAt:z.completedAt,results:we.map(Je=>ge(Je,ke))}}de.to=X})(Ne=e.TestResults||(e.TestResults={}));var qe;(function(de){function ge(ke){return{covered:ke.covered,total:ke.covered}}function X(ke){return"line"in ke?i.from(ke):h.from(ke)}function z(ke){return"branches"in ke?{count:ke.executionCount,location:X(ke.location),type:1,branches:ke.branches.length?ke.branches.map(Je=>({count:Je.executionCount,location:Je.location&&X(Je.location)})):void 0}:{type:0,count:ke.executionCount,location:X(ke.location)}}de.fromDetailed=z;function we(ke){return{uri:ke.uri,statement:ge(ke.statementCoverage),branch:ke.branchCoverage&&ge(ke.branchCoverage),function:ke.functionCoverage&&ge(ke.functionCoverage),details:ke.detailedCoverage?.map(z)}}de.fromFile=we})(qe=e.TestCoverage||(e.TestCoverage={}));var it;(function(de){function ge(X){switch(X){case 1:return E.CodeActionTriggerKind.Invoke;case 2:return E.CodeActionTriggerKind.Automatic}}de.to=ge})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Le;(function(de){function ge(z){const we=new E.TypeHierarchyItem(H.to(z.kind),z.name,z.detail||"",P.URI.revive(z.uri),h.to(z.range),h.to(z.selectionRange));return we._sessionId=z._sessionId,we._itemId=z._itemId,we}de.to=ge;function X(z,we,ke){if(we=we??z._sessionId,ke=ke??z._itemId,we===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:ke,kind:H.from(z.kind),name:z.name,detail:z.detail??"",uri:z.uri,range:h.from(z.range),selectionRange:h.from(z.selectionRange),tags:z.tags?.map(W.from)}}de.from=X})(Le=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[170],Ee([0,1,2,16,7,8,231]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(P,t,y,n={timeout:1500,errors:3}){this._logService=P,this._documents=t,this._mainThreadBulkEdits=y,this._thresholds=n,this._callbacks=new F.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(t,y,n)=>{const s={dispose:this._callbacks.push([t,y,P])};return Array.isArray(n)&&n.push(s),s}}async $participateInSave(P,t){const y=d.URI.revive(P);let n=!1;const m=setTimeout(()=>n=!0,this._thresholds.timeout),s=[];try{for(let u of[...this._callbacks]){if(n)break;const g=this._documents.getDocument(y),I=await this._deliverEventAsyncAndBlameBadListeners(u,{document:g,reason:A.TextDocumentSaveReason.to(t)});s.push(I)}}finally{clearTimeout(m)}return s}_deliverEventAsyncAndBlameBadListeners([P,t,y],n){const m=this._badListeners.get(P);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,P,t,n).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const u=this._badListeners.get(P);this._badListeners.set(P,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,t,y,n){const m=[],s=Date.now(),{document:u,reason:g}=n,{version:I}=u,E=Object.freeze({document:u,reason:g,waitUntil(o){if(Object.isFrozen(m))throw(0,M.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(o))}});try{t.apply(y,[E])}catch(o){return Promise.reject(o)}return Object.freeze(m),new Promise((o,h)=>{const C=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(C),o(i)}).catch(i=>{clearTimeout(C),h(i)})}).then(o=>{const h={edits:[]};for(const C of o)if(Array.isArray(C)&&C.every(i=>i instanceof _.TextEdit))for(const{newText:i,newEol:p,range:a}of C)h.edits.push({_type:2,resource:u.uri,edit:{range:a&&A.Range.from(a),text:i,eol:p&&A.EndOfLine.from(p)}});if(h.edits.length!==0)return I===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(be[171],Ee([0,1,3,27,2,8,7]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(t,y,n,m,s){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter,this._config=0,n&&(this._config+=1),m&&(this._config+=2),s&&(this._config+=4);const u=(0,M.parse)(y),g=t(I=>{if(!n)for(let E of I.created){const o=_.URI.revive(E);u(o.fsPath)&&this._onDidCreate.fire(o)}if(!m)for(let E of I.changed){const o=_.URI.revive(E);u(o.fsPath)&&this._onDidChange.fire(o)}if(!s)for(let E of I.deleted){const o=_.URI.revive(E);u(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=F.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,g)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(t,y,n){this._logService=y,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,y,n,m){return new k(this._onFileSystemEvent.event,t,y,n,m)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,y){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:y.map(n=>({oldUri:_.URI.revive(n.source),newUri:_.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:y.map(n=>_.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:y.map(n=>_.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,y){return(n,m,s)=>{const u=function(I){n.call(m,I)};return u.extension=t,y.event(u,void 0,s)}}async $onWillRunFileOperation(t,y,n,m){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:y.map(s=>({oldUri:_.URI.revive(s.source),newUri:_.URI.revive(s.target)}))},n,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:y.map(s=>_.URI.revive(s.target))},n,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:y.map(s=>_.URI.revive(s.target))},n,m)}}async _fireWillEvent(t,y,n,m){const s=new Set,u=[];if(await t.fireAsync(y,m,async(I,E)=>{const o=Date.now(),h=await Promise.resolve(I);h instanceof F.WorkspaceEdit&&(u.push(h),s.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-o>n&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),m.isCancellationRequested||u.length===0)return;const g={edits:[]};for(let I of u){let{edits:E}=A.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);g.edits=g.edits.concat(E)}return{edit:g,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=D}),define(be[172],Ee([0,1,11,23,2,8,7,89]),function(oe,e,d,M,_,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(n,m,s,u){this.start=n,this.deletedCount=m,this.deletedItems=s,this.items=u}static asApiEvents(n){return n.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(s=>s.apiCell)}))}}class P{constructor(n,m,s){this.notebook=n,this._extHostDocument=m,this._cellData=s,this.handle=s.handle,this.uri=_.URI.revive(s.uri),this.cellKind=s.cellKind,this._outputs=s.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=s.internalMetadata??{},this._metadata=Object.freeze(s.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(s.internalMetadata??{}))}static asModelAddData(n,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return n._mime},set mime(s){n._mime=s},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(A.NotebookCellOutput.to)}setOutputItems(n,m,s){const u=s.map(A.NotebookCellOutputItem.to),g=this._outputs.find(I=>I.id===n);g&&(m||(g.items.length=0),g.items.push(...u))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=P;class t{constructor(n,m,s,u,g,I){this._proxy=n,this._textDocumentsAndEditors=m,this._textDocuments=s,this._emitter=u,this.uri=g,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=I.viewType,this._metadata=Object.freeze(I.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,I.cells]],!0),this._versionId=I.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===d.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(m){return m=n._validateIndex(m),n._cells[m].apiCell},getCells(m){return(m?n._getCells(m):n._cells).map(u=>u.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,m){this._versionId=n.versionId,this._isDirty=m;for(const s of n.rawEvents)s.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1):s.kind===k.NotebookCellsChangeType.Move?this._moveCell(s.index,s.newIdx):s.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(s.index,s.outputs):s.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems):s.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(s.index,s.language):s.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(s.index,s.mime):s.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(s.index,s.metadata):s.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(s.index,s.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let m=n.start|0,s=n.end|0;return m<0&&(m=0),s>this._cells.length&&(s=this._cells.length),n.with({start:m,end:s})}_getCells(n){n=this._validateRange(n);const m=[];for(let s=n.start;s<n.end;s++)m.push(this._cells[s]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,m){if(this._disposed)return;const s=[],u=[],g=[];n.reverse().forEach(I=>{const o=I[2].map(i=>{const p=new P(this,this._textDocumentsAndEditors,i);return m||u.push(P.asModelAddData(this.apiNotebook,i)),p}),h=new D(I[0],I[1],[],o),C=this._cells.splice(I[0],I[1],...o);for(const i of C)g.push(i.uri),h.deletedItems.push(i.apiCell);s.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:g}),m||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(s)}))}_moveCell(n,m){const s=this._cells.splice(n,1);this._cells.splice(m,0,...s);const u=[new D(n,1,s.map(g=>g.apiCell),[]),new D(m,0,[],s)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(u)}))}_setCellOutputs(n,m){const s=this._cells[n];s.setOutputs(m),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[s.apiCell]}))}_setCellOutputItems(n,m,s,u){const g=this._cells[n];g.setOutputItems(m,s,u),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_changeCellLanguage(n,m){const s=this._cells[n];s.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(s.uri,m)}_changeCellMime(n,m){const s=this._cells[n];s.apiCell.mime=m}_changeCellMetadata(n,m){const s=this._cells[n],u=s.apiCell.metadata;s.setMetadata(m);const g=s.apiCell.metadata;(0,M.equals)(u,g)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:s.apiCell}))}_changeCellInternalMetadata(n,m){const s=this._cells[n],u=s.internalMetadata;if(s.setInternalMetadata(m),u.runState!==m.runState){const g=m.runState??F.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:s.apiCell,state:g}))}}getCellFromApiCell(n){return this._cells.find(m=>m.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(m=>m.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(be[93],Ee([0,1,7,8,16]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:P})}replaceCells(D,P,t){this._throwIfFinalized(),!(D===P&&t.length===0)&&this._collectedEdits.push({editType:1,index:D,count:P-D,cells:t.map(M.NotebookCellData.from)})}}class F{constructor(D,P,t,y,n,m){this.id=D,this._proxy=P,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=y,this._viewColumn=m}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(P){if(!Array.isArray(P)||!P.every(d.NotebookRange.isNotebookRange))throw(0,_.illegalArgument)("selections");D._selections=P,D._trySetSelections(P)},get visibleRanges(){return D._visibleRanges},revealRange(P,t){D._proxy.$tryRevealRange(D.id,M.NotebookRange.from(P),t??d.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(P){const t=new A(this.document.version);return P(t),D._applyEdit(t.finalize())},setDecorations(P,t){return D.setDecorations(P,t)}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(M.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const P=[];let t=-1;for(let y=0;y<D.cellEdits.length;y++){if(t<0){P.push(D.cellEdits[y]),t++;continue}const m=P[t],s=D.cellEdits[y];if(m.editType===1&&s.editType===1&&m.index===s.index){m.cells.push(...D.cellEdits[y].cells),m.count+=D.cellEdits[y].count;continue}P.push(D.cellEdits[y]),t++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,P)}setDecorations(D,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return P.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(P),D.key)}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(be[173],Ee([0,1,8,146,126,21,53,16]),function(oe,e,d,M,_,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,m,s){const u=this._handles++,{title:g,location:I,cancellable:E}=m,o={label:(0,_.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(u,{location:d.ProgressLocation.from(I),title:g,source:o,cancellable:E},n).catch(k.onUnexpectedExternalError),this._withProgress(u,s,!!E)}_withProgress(n,m,s){let u;s&&(u=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,u));const g=E=>{this._proxy.$progressEnd(E),this._mapHandleToCancellationSource.delete(E),u&&u.dispose()};let I;try{I=m(new t(this._proxy,n),s&&u?u.token:A.CancellationToken.None)}catch(E){throw g(n),E}return I.then(E=>g(n),E=>g(n)),I}$acceptProgressCanceled(n){const m=this._mapHandleToCancellationSource.get(n);m&&(m.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=D;function P(y,n){return y.message=n.message,typeof n.increment=="number"&&(typeof y.increment=="number"?y.increment+=n.increment:y.increment=n.increment),y}class t extends M.Progress{constructor(n,m){super(s=>this.throttledReport(s));this._proxy=n,this._handle=m}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}$e([(0,F.throttle)(100,(y,n)=>P(y,n),()=>Object.create(null))],t.prototype,"throttledReport",null)}),define(be[94],Ee([0,1,42,16,54,8,7]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(n,m,s){const u=k._Keys.nextId();n.$registerTextEditorDecorationType(m.identifier,u,A.DecorationRenderOptions.from(s)),this.value=Object.freeze({key:u,dispose(){n.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=k,k._Keys=new _.IdGenerator("TextEditorDecorationType");class D{constructor(n,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,m){this._throwIfFinalized();let s=null;if(n instanceof F.Position)s=new F.Range(n,n);else if(n instanceof F.Range)s=n;else throw new Error("Unrecognized location");this._pushEdit(s,m,!1)}insert(n,m){this._throwIfFinalized(),this._pushEdit(new F.Range(n,n),m,!0)}delete(n){this._throwIfFinalized();let m=null;if(n instanceof F.Range)m=n;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(n,m,s){const u=this._document.validateRange(n);this._collectedEdits.push({range:u,text:m,forceMoveMarkers:s})}setEndOfLine(n){if(this._throwIfFinalized(),n!==F.EndOfLine.LF&&n!==F.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=D;class P{constructor(n,m,s,u){this._proxy=n,this._id=m,this._accept(s),this._logService=u;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(I){g._setTabSize(I)},get insertSpaces(){return g._insertSpaces},set insertSpaces(I){g._setInsertSpaces(I)},get cursorStyle(){return g._cursorStyle},set cursorStyle(I){g._setCursorStyle(I)},get lineNumbers(){return g._lineNumbers},set lineNumbers(I){g._setLineNumbers(I)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const m=Math.floor(n);return m>0?m:null}if(typeof n=="string"){const m=parseInt(n,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(n){const m=this._validateTabSize(n);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const m=this._validateInsertSpaces(n);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(n)})))}assign(n){const m={};let s=!1;if(typeof n.tabSize!="undefined"){const u=this._validateTabSize(n.tabSize);u==="auto"?(s=!0,m.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,s=!0,m.tabSize=u)}if(typeof n.insertSpaces!="undefined"){const u=this._validateInsertSpaces(n.insertSpaces);u==="auto"?(s=!0,m.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,s=!0,m.insertSpaces=u)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,s=!0,m.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,s=!0,m.lineNumbers=A.TextEditorLineNumbersStyle.from(n.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(n){n.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=P;class t{constructor(n,m,s,u,g,I,E,o){this.id=n,this._proxy=m,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new P(this._proxy,this.id,I,s),this._visibleRanges=E,this._viewColumn=o;const h=this;this.value=Object.freeze({get document(){return u.getValue()},set document(C){throw(0,M.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(C){if(!(C instanceof F.Selection))throw(0,M.illegalArgument)("selection");h._selections=[C],h._trySetSelection()},get selections(){return h._selections},set selections(C){if(!Array.isArray(C)||C.some(i=>!(i instanceof F.Selection)))throw(0,M.illegalArgument)("selections");h._selections=C,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(C){throw(0,M.readonly)("visibleRanges")},get options(){return h._options.value},set options(C){h._disposed||h._options.assign(C)},get viewColumn(){return h._viewColumn},set viewColumn(C){throw(0,M.readonly)("viewColumn")},edit(C,i={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const p=new D(u.getValue(),i);return C(p),h._applyEdit(p)},insertSnippet(C,i,p={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=h._selections.map(r=>A.Range.from(r));else if(i instanceof F.Position){const{lineNumber:r,column:v}=A.Position.from(i);a=[{startLineNumber:r,startColumn:v,endLineNumber:r,endColumn:v}]}else if(i instanceof F.Range)a=[A.Range.from(i)];else{a=[];for(const r of i)if(r instanceof F.Range)a.push(A.Range.from(r));else{const{lineNumber:v,column:l}=A.Position.from(r);a.push({startLineNumber:v,startColumn:l,endLineNumber:v,endColumn:l})}}return m.$tryInsertSnippet(n,C.value,a,p)},setDecorations(C,i){const p=i.length===0;p&&!h._hasDecorationsForKey.has(C.key)||(p?h._hasDecorationsForKey.delete(C.key):h._hasDecorationsForKey.add(C.key),h._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return m.$trySetDecorations(n,C.key,A.fromRangeOrRangeWithMessage(i));{const a=new Array(4*i.length);for(let r=0,v=i.length;r<v;r++){const l=i[r];a[4*r]=l.start.line+1,a[4*r+1]=l.start.character+1,a[4*r+2]=l.end.line+1,a[4*r+3]=l.end.character+1}return m.$trySetDecorationsFast(n,C.key,a)}}))},revealRange(C,i){h._runOnProxy(()=>m.$tryRevealRange(n,A.Range.from(C),i||F.TextEditorRevealType.Default))},show(C){m.$tryShowEditor(n,A.ViewColumn.from(C))},hide(){m.$tryHideEditor(n)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,d.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,d.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,d.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,d.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const m=n.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const s=m.edits.map(g=>g.range);s.sort((g,I)=>g.end.line===I.end.line?g.end.character===I.end.character?g.start.line===I.start.line?g.start.character-I.start.character:g.start.line-I.start.line:g.end.character-I.end.character:g.end.line-I.end.line);for(let g=0,I=s.length-1;g<I;g++){const E=s[g].end;if(s[g+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=m.edits.map(g=>({range:A.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,u,{setEndOfLine:typeof m.setEndOfLine=="number"?A.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=t}),define(be[174],Ee([0,1,129,24,2,3,6,162,12,7,10,14,8,21,159]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(E,o){if((0,t.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let h;return Array.isArray(E.highlights)&&(h=E.highlights.filter(C=>C.length===2&&typeof C[0]=="number"&&typeof C[1]=="number"),h=h.length?h:void 0),{label:E.label,highlights:h}}}class g{constructor(o,h,C){this._proxy=o,this.commands=h,this.logService=C,this.treeViews=new Map;function i(p){return p&&p.$treeViewId&&p.$treeItemHandle}h.registerArgumentProcessor({processArgument:p=>i(p)?this.convertArgument(p):Array.isArray(p)&&p.length>0?p.map(a=>i(a)?this.convertArgument(a):a):p})}registerTreeDataProvider(o,h,C){const i=this.createTreeView(o,{treeDataProvider:h},C);return{dispose:()=>i.dispose()}}createTreeView(o,h,C){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=h.dragAndDropController!==void 0,p=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,canDragAndDrop:i}),a=this.createExtHostTreeView(o,h,C);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(r){a.message=r},get title(){return a.title},set title(r){a.title=r},get description(){return a.description},set description(r){a.description=r},reveal:(r,v)=>a.reveal(r,v),dispose:async()=>{await p,this.treeViews.delete(o),a.dispose()}}}$getChildren(o,h){const C=this.treeViews.get(o);return C?C.getChildren(h):Promise.reject(new Error((0,d.localize)(0,null,o)))}async $onDrop(o,h,C){const i=this.treeViews.get(o);if(!i)return Promise.reject(new Error((0,d.localize)(1,null,o)));const p=s.TreeDataTransferConverter.toITreeDataTransfer(h);if(p.items.has(k.TREE_ITEM_DATA_TRANSFER_TYPE)){const r=JSON.parse(await p.items.get(k.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(v=>i.getExtensionElement(v)).filter(v=>!!v);r.length>0?p.items.set(k.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(r)}):p.items.delete(k.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(p,C)}async $hasResolve(o){const h=this.treeViews.get(o);if(!h)throw new Error((0,d.localize)(2,null,o));return h.hasResolve}$resolve(o,h,C){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(3,null,o));return i.resolveTreeItem(h,C)}$setExpanded(o,h,C){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(4,null,o));i.setExpanded(h,C)}$setSelection(o,h){const C=this.treeViews.get(o);if(!C)throw new Error((0,d.localize)(5,null,o));C.setSelection(h)}$setVisible(o,h){const C=this.treeViews.get(o);if(!C)throw new Error((0,d.localize)(6,null,o));C.setVisible(h)}createExtHostTreeView(o,h,C){const i=new I(o,h,this._proxy,this.commands.converter,this.logService,C);return this.treeViews.set(o,i),i}convertArgument(o){const h=this.treeViews.get(o.$treeViewId);return h?h.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=g;class I extends F.Disposable{constructor(o,h,C,i,p,a){super();if(this.viewId=o,this.proxy=C,this.commands=i,this.logService=p,this.extension=a,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,a.contributes&&a.contributes.views)for(const l in a.contributes.views)for(const c of a.contributes.views[l])c.id===o&&(this._title=c.name);this.dataProvider=h.treeDataProvider,this.dndController=h.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(l=>this._onDidChangeData.fire({message:!1,element:l}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let r,v;this._register(A.Event.debounce(this._onDidChangeData.event,(l,c)=>(l||(l={message:!1,elements:[]}),c.element!==!1&&(r||(r=new Promise(w=>v=w),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(c.element)?l.elements.push(...c.element):l.elements.push(c.element)),c.message&&(l.message=!0),l),200,!0)(({message:l,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=v;return r=null,this.refresh(c).then(()=>w())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,t.isUndefinedOrNull)(o))}async getChildren(o){const h=o?this.getExtensionElement(o):void 0;if(o&&!h)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let C=this.getChildrenNodes(o);return C||(C=await this.fetchChildrenNodes(h)),C?C.map(i=>i.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,h){h=h||{select:!0,focus:!1};const C=(0,t.isUndefinedOrNull)(h.select)?!0:h.select,i=(0,t.isUndefinedOrNull)(h.focus)?!1:h.focus,p=(0,t.isUndefinedOrNull)(h.expand)?!1:h.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(a=>this.resolveTreeNode(o,a[a.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:a.map(v=>v.item)},{select:C,focus:i,expand:p})),a=>this.logService.error(a)):this.proxy.$reveal(this.viewId,void 0,{select:C,focus:i,expand:p})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,h){const C=this.getExtensionElement(o);C&&(h?this._onDidExpandElement.fire(Object.freeze({element:C})):this._onDidCollapseElement.fire(Object.freeze({element:C})))}setSelection(o){(0,y.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,h){const C=this.getExtensionElement(h);if(!!C)return(0,D.asPromise)(()=>this.dndController?.onDrop(o,C))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,h){if(!this.dataProvider.resolveTreeItem)return;const C=this.elements.get(o);if(C){const i=this.nodes.get(C);if(i){const p=await this.dataProvider.resolveTreeItem(i.extensionItem,C,h)??i.extensionItem;return i.item.tooltip=this.getTooltip(p.tooltip),i.item.command=this.getCommand(i.disposableStore,p.command),i.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(h=>h?this.resolveUnknownParentChain(h).then(C=>this.resolveTreeNode(h,C[C.length-1]).then(i=>(C.push(i),C))):Promise.resolve([]))}resolveParent(o){const h=this.nodes.get(o);return h?Promise.resolve(h.parent?this.elements.get(h.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,h){const C=this.nodes.get(o);return C?Promise.resolve(C):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(i=>this.createHandle(o,i,h,!0)).then(i=>this.getChildren(h?h.item.handle:void 0).then(()=>{const p=this.getExtensionElement(i);if(p){const a=this.nodes.get(p);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(o){if(o){let h;if(typeof o=="string"){const C=this.getExtensionElement(o);h=C?this.nodes.get(C):void 0}else h=o;return h&&h.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const h=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const C=o?this.nodes.get(o):void 0,i=await this.dataProvider.getChildren(o);if(h.token.isCancellationRequested)return;const p=await Promise.all((0,y.coalesce)(i||[]).map(async a=>{const r=await this.dataProvider.getTreeItem(a);return r&&!h.token.isCancellationRequested?this.createAndRegisterTreeNode(a,r,C):null}));return h.token.isCancellationRequested?void 0:(0,y.coalesce)(p)}finally{h.dispose()}}refresh(o){if(o.some(C=>!C))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const C=this.getHandlesToRefresh(o);if(C.length)return this.refreshHandles(C)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const h=new Set,C=o.map(p=>this.nodes.get(p));for(const p of C)if(p&&!h.has(p.item.handle)){let a=p;for(;a&&a.parent&&C.findIndex(r=>a&&a.parent&&r&&r.item.handle===a.parent.item.handle)===-1;){const r=this.elements.get(a.parent.item.handle);a=r?this.nodes.get(r):void 0}a&&!a.parent&&h.add(p.item.handle)}const i=[];return h.forEach(p=>{const a=this.elements.get(p);if(a){const r=this.nodes.get(a);r&&(!r.parent||!h.has(r.parent.item.handle))&&i.push(p)}}),i}refreshHandles(o){const h={};return Promise.all(o.map(C=>this.refreshNode(C).then(i=>{i&&(h[C]=i.item)}))).then(()=>Object.keys(h).length?this.proxy.$refresh(this.viewId,h):void 0)}refreshNode(o){const h=this.getExtensionElement(o);if(h){const C=this.nodes.get(h);if(C)return this.clearChildren(h),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(i=>{if(i){const p=this.createTreeNode(h,i,C.parent);return this.updateNodeCache(h,p,C,C.parent),C.dispose(),p}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,h,C){const i=this.createTreeNode(o,h,C);if(h.id&&this.elements.has(i.item.handle))throw new Error((0,d.localize)(7,null,h.id));return this.addNodeToCache(o,i),this.addNodeToParentCache(i,C),i}getTooltip(o){return P.MarkdownString.isMarkdownString(o)?n.MarkdownString.from(o):o}getCommand(o,h){return h?this.commands.toInternal(h,o):void 0}createTreeNode(o,h,C){const i=new F.DisposableStore,p=this.createHandle(o,h,C),a=this.getLightIconPath(h);return{item:{handle:p,parentHandle:C?C.item.handle:void 0,label:u(h.label,this.extension),description:h.description,resourceUri:h.resourceUri,tooltip:this.getTooltip(h.tooltip),command:this.getCommand(i,h.command),contextValue:h.contextValue,icon:a,iconDark:this.getDarkIconPath(h)||a,themeIcon:this.getThemeIcon(h),collapsibleState:(0,t.isUndefinedOrNull)(h.collapsibleState)?P.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation},extensionItem:h,parent:C,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(o){return o.iconPath instanceof P.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:h,label:C,resourceUri:i},p,a){if(h)return`${I.ID_HANDLE_PREFIX}/${h}`;const r=u(C,this.extension),v=p?p.item.handle:I.LABEL_HANDLE_PREFIX;let l=r?r.label:i?(0,M.basename)(i):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const c=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,w=this.getChildrenNodes(p)||[];let f,S=0;do{if(f=`${v}/${S}:${l}`,a||!this.elements.has(f)||c===f)break;S++}while(S<=w.length);return f}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof P.ThemeIcon))return typeof o.iconPath=="string"||_.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof P.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return _.URI.isUri(o)?o:_.URI.file(o)}addNodeToCache(o,h){this.elements.set(h.item.handle,o),this.nodes.set(o,h)}updateNodeCache(o,h,C,i){this.elements.delete(h.item.handle),this.nodes.delete(o),h.item.handle!==C.item.handle&&this.elements.delete(C.item.handle),this.addNodeToCache(o,h);const p=this.getChildrenNodes(i)||[],a=p.filter(r=>r.item.handle===C.item.handle)[0];a&&p.splice(p.indexOf(a),1,h)}addNodeToParentCache(o,h){h?(h.children||(h.children=[]),h.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const h=this.nodes.get(o);if(h){if(h.children)for(const C of h.children){const i=this.elements.get(C.item.handle);i&&this.clear(i)}h.children=void 0}}else this.clearAll()}clear(o){const h=this.nodes.get(o);if(h){if(h.children)for(const C of h.children){const i=this.elements.get(C.item.handle);i&&this.clear(i)}this.nodes.delete(o),this.elements.delete(h.item.handle),h.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}I.LABEL_HANDLE_PREFIX="0",I.ID_HANDLE_PREFIX="1"}),define(be[175],Ee([0,1,12,3,6,10,49,8,90,68]),function(oe,e,d,M,_,A,F,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends _.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new F.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const m=this.diff[this.diff.length-1];if(m&&n[0]===1){if(m[0]===1&&m[1].extId===n[1].extId){(0,D.applyTestItemUpdate)(m[1],n[1]);return}if(m[0]===0&&m[1].item.extId===n[1].extId){(0,D.applyTestItemUpdate)(m[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,m){const s=this.tree.get(n);if(!!s){if((s.expandLevels===void 0||m>s.expandLevels)&&(s.expandLevels=m),s.expand===1){const u=this.resolveChildren(s);return u.isOpen()?this.expandChildren(s,m-1):u.wait().then(()=>this.expandChildren(s,m-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.expandChildren(s,m-1)):this.expandChildren(s,m-1)}}dispose(){for(const n of this.tree.values())(0,F.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,m){switch(m.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(n.fullId,m.id));break;case 0:this.upsertItem(m.item,n);break;case 4:for(const E of m.ops)this.onTestItemEvent(n,E);break;case 3:const{key:s,value:u,previous:g}=m,I=n.fullId.toString();switch(s){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(u,g,I);break;case"range":this.pushDiff([1,{extId:I,item:{range:k.Range.from(u)}}]);break;case"error":this.pushDiff([1,{extId:I,item:{error:k.MarkdownString.fromStrict(u)||null}}]);break;default:this.pushDiff([1,{extId:I,item:{[s]:u??null}}]);break}break;default:(0,A.assertNever)(m)}}upsertItem(n,m){if(!(n instanceof F.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const s=P.TestId.fromExtHostTestItem(n,this.root.id,m?.actual),u=(0,F.getPrivateApiFor)(n);u.parent&&u.parent!==m?.actual&&u.parent.children.delete(n.id);let g=this.tree.get(s.toString());if(!g){g={fullId:s,actual:n,parent:m?s.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(g.fullId.toString(),g),this.setItemParent(n,m),this.pushDiff([0,{parent:g.parent&&g.parent.toString(),controllerId:this.controllerId,expand:g.expand,item:k.TestItem.from(n)}]),this.connectItemAndChildren(n,g,m);return}if(g.actual===n){this.connectItem(n,g,m);return}const I=g.actual.children,E=g.actual,o=(0,F.diffTestItems)(E,n);(0,F.getPrivateApiFor)(E).listener=void 0,g.actual=n,g.expand=0;for(const[h,C]of o)this.onTestItemEvent(g,{op:3,key:h,value:C,previous:E[h]});this.connectItemAndChildren(n,g,m);for(const h of I)n.children.get(h.id)||this.removeItem(P.TestId.joinToString(s,h.id))}diffTagRefs(n,m,s){const u=new Set(m.map(g=>g.id));for(const g of n)u.delete(g.id)||this.incrementTagRefs(g);this.pushDiff([1,{extId:s,item:{tags:n.map(g=>k.TestTag.namespace(this.controllerId,g.id))}}]),u.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const m=this.tags.get(n.id);m?m.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const m=this.tags.get(n);m&&!--m.refCount&&(this.tags.delete(n),this.pushDiff([6,k.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,m){(0,F.getPrivateApiFor)(n).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(n,m,s){this.setItemParent(n,s);const u=(0,F.getPrivateApiFor)(n);u.parent=s?.actual,u.listener=g=>this.onTestItemEvent(m,g),this.updateExpandability(m)}connectItemAndChildren(n,m,s){this.connectItem(n,m,s);for(const u of n.children)this.upsertItem(u,m)}updateExpandability(n){let m;this._resolveHandler?n.resolveBarrier?m=n.resolveBarrier.isOpen()?3:2:m=n.actual.canResolveChildren?1:0:m=0,m!==n.expand&&(n.expand=m,this.pushDiff([1,{extId:n.fullId.toString(),expand:m}]),m===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,m){if(m<0)return;const s=[];for(const u of n.actual.children){const g=this.expand(P.TestId.joinToString(n.fullId,u.id),m);(0,d.isThenable)(g)&&s.push(g)}if(s.length)return Promise.all(s).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const g=new d.Barrier;return g.open(),g}n.expand=2,this.pushExpandStateUpdate(n);const m=n.resolveBarrier=new d.Barrier,s=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=g.stack||g.message||String(g))};let u;try{u=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(g){s(g)}return(0,d.isThenable)(u)?u.catch(s).then(()=>{m.open(),this.updateExpandability(n)}):(m.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const m=this.tree.get(n);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const s=[m];for(;s.length;){const u=s.pop();if(!!u){(0,F.getPrivateApiFor)(u.actual).listener=void 0;for(const g of u.actual.tags)this.decrementTagRefs(g.id);this.tree.delete(u.fullId.toString());for(const g of u.actual.children)s.push(this.tree.get(P.TestId.joinToString(u.fullId,g.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(be[176],Ee([0,1,4,142]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(M.IEnvironmentService)}),define(be[177],Ee([0,1,26,3,17]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class F{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let y of t.activationEvents)y==="onUri"&&(y=`onUri:${d.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(y)||this._activationMap.set(y,[]),this._activationMap.get(y).push(t)}}keepOnly(t){const y=new Set;t.forEach(n=>y.add(d.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>y.has(d.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,y){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=F._findLoopingExtensions(this._extensionDescriptions);if(y=y.concat(n.map(m=>m.identifier)),y.length>0){const m=new Set;y.forEach(s=>m.add(d.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!m.has(d.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(n)}static _findLoopingExtensions(t){const y=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(g){this._nodesSet.has(g)||(this._nodesSet.add(g),this._nodesArr.push(g))}addArc(g,I){this.addNode(g),this.addNode(I),this._arcs.has(g)?this._arcs.get(g).push(I):this._arcs.set(g,[I])}getArcs(g){return this._arcs.has(g)?this._arcs.get(g):[]}hasOnlyGoodArcs(g,I){const E=y.getArcs(g);for(let o=0;o<E.length;o++)if(!I.has(E[o]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let g of t){const I=d.ExtensionIdentifier.toKey(g.identifier);if(n.set(I,g),g.extensionDependencies)for(let E of g.extensionDependencies){const o=d.ExtensionIdentifier.toKey(E);y.addArc(I,o)}}let m=new Set;y.getNodes().filter(g=>y.getArcs(g).length===0).forEach(g=>m.add(g));let s=y.getNodes().filter(g=>!m.has(g)),u;do{u=!1;for(let g=0;g<s.length;g++){const I=s[g];y.hasOnlyGoodArcs(I,m)&&(s.splice(g,1),g--,m.add(I),u=!0)}}while(u);return s.map(g=>n.get(g))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const y=this._activationMap.get(t);return y?y.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const y=this._extensionsMap.get(d.ExtensionIdentifier.toKey(t));return y||void 0}}e.ExtensionDescriptionRegistry=F;var k;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(k||(k={}));function D(P,t){const y=P.isBuiltin?0:P.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(y!==n)return y-n;const m=_.posix.basename(P.extensionLocation.path),s=_.posix.basename(t.extensionLocation.path);return m<s?-1:m>s?1:0}}),define(be[178],Ee([0,1,22]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var _;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(_=e.MessageType||(e.MessageType={}));function A(k){const D=d.VSBuffer.alloc(1);switch(k){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=A;function F(k,D){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=F}),define(be[30],Ee([0,1,3,2,4,26,148]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,_.createDecorator)("extensionService");var k;(function(h){h[h.None=0]="None",h[h.LocalProcess=1]="LocalProcess",h[h.LocalWebWorker=2]="LocalWebWorker",h[h.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function D(h){switch(h){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=D;class P{constructor(C){this.dependency=C}}e.MissingExtensionDependency=P;var t;(function(h){h[h.LocalProcess=0]="LocalProcess",h[h.LocalWebWorker=1]="LocalWebWorker",h[h.Remote=2]="Remote"})(t=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(h){switch(h){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=y;class n{constructor(C,i,p,a){this.codeLoadingTime=C,this.activateCallTime=i,this.activateResolvedTime=p,this.activationReason=a}}e.ActivationTimes=n;class m{constructor(C,i){this.description=C,this.value=i}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var s;(function(h){h[h.Normal=0]="Normal",h[h.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function u(h){h.enableProposedApi||g(h)}e.checkProposedApiEnabled=u;function g(h){throw new Error(`[${h.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`)}e.throwProposedApiError=g;function I(h){return{type:h.isBuiltin?0:1,isBuiltin:h.isBuiltin||h.isUserBuiltin,identifier:{id:(0,F.getGalleryExtensionId)(h.publisher,h.name),uuid:h.uuid},manifest:h,location:h.extensionLocation}}e.toExtension=I;function E(h,C){return{identifier:new A.ExtensionIdentifier(h.identifier.id),isBuiltin:h.type===0,isUserBuiltin:h.type===1&&h.isBuiltin,isUnderDevelopment:!!C,extensionLocation:h.location,...h.manifest,uuid:h.identifier.uuid}}e.toExtensionDescription=E;class o{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(C){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(C){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(C){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(C){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(C,i){return Promise.resolve()}_onWillActivateExtension(C){}_onDidActivateExtension(C,i,p,a,r){}_onDidActivateExtensionError(C,i){}_onExtensionRuntimeError(C,i){}_onExtensionHostExit(C){}}e.NullExtensionService=o}),define(be[179],Ee([0,1,26,30,15]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class F{constructor(s,u,g,I){this.startup=s,this.codeLoadingTime=u,this.activateCallTime=g,this.activateResolvedTime=I}}e.ExtensionActivationTimes=F,F.NONE=new F(!1,-1,-1,-1);class k{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,u){return s===-1||u===-1?-1:u-s}build(){return new F(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=k;class D{constructor(s,u,g,I,E,o){this.activationFailed=s,this.activationFailedError=u,this.activationTimes=g,this.module=I,this.exports=E,this.subscriptions=o}}e.ActivatedExtension=D;class P extends D{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class t extends D{constructor(){super(!1,null,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class y extends D{constructor(s){super(!0,s,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=y;let n=class{constructor(s,u,g,I,E){this._logService=E,this._registry=s,this._resolvedExtensionsSet=new Set,u.forEach(o=>this._resolvedExtensionsSet.add(d.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,g.forEach(o=>this._hostExtensionsMap.set(d.ExtensionIdentifier.toKey(o),o)),this._host=I,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(s){const u=d.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(u)}getActivatedExtension(s){const u=d.ExtensionIdentifier.toKey(s),g=this._activatedExtensions.get(u);if(!g)throw new Error("Extension `"+s.value+"` is not known or not activated");return g}activateByEvent(s,u){if(this._alreadyActivatedEvents[s])return A;const g=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(g.map(I=>({id:I.identifier,reason:{startup:u,extensionId:I.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,u){const g=this._registry.getExtensionDescription(s);if(!g)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:g.identifier,reason:u}])}_handleActivateRequest(s,u,g){if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(s.id))){u[d.ExtensionIdentifier.toKey(s.id)]=s;return}const I=this._registry.getExtensionDescription(s.id);if(!I){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`);this._host.onExtensionActivationError(s.id,h,new M.MissingExtensionDependency(s.id.value)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(s.id),new y(h));return}const E=typeof I.extensionDependencies=="undefined"?[]:I.extensionDependencies;let o=!0;for(let h=0,C=E.length;h<C;h++){const i=E[h];if(this._resolvedExtensionsSet.has(d.ExtensionIdentifier.toKey(i)))continue;const p=this._activatedExtensions.get(d.ExtensionIdentifier.toKey(i));if(p&&!p.activationFailed)continue;if(p&&p.activationFailed){const l=I.displayName||I.identifier.value,c=this._registry.getExtensionDescription(i),w=c&&c.displayName||i,f=new Error(`Cannot activate the '${l}' extension because its dependency '${w}' failed to activate`);f.detail=p.activationFailedError,this._host.onExtensionActivationError(I.identifier,f,null),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(I.identifier),new y(f));return}if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(i))){o=!1,u[d.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(d.ExtensionIdentifier.toKey(i)),reason:s.reason};continue}const a=this._registry.getExtensionDescription(i);if(a){if(!a.main&&!a.browser)continue;o=!1,u[d.ExtensionIdentifier.toKey(i)]={id:a.identifier,reason:s.reason};continue}const r=I.displayName||I.identifier.value,v=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(I.identifier,v,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(I.identifier),new y(v));return}o?u[d.ExtensionIdentifier.toKey(I.identifier)]=s:g.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(E=>!this._activatedExtensions.has(d.ExtensionIdentifier.toKey(E.id))),s.length===0))return Promise.resolve(void 0);const u=Object.create(null),g=[];for(let E=0,o=s.length;E<o;E++)this._handleActivateRequest(s[E],u,g);for(let E=0,o=g.length;E<o;E++){const h=d.ExtensionIdentifier.toKey(g[E].id);u[h]&&delete u[h]}const I=Object.keys(u).map(E=>u[E]);return g.length===0?Promise.all(I.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(I).then(E=>this._activateExtensions(g))}_activateExtension(s,u){const g=d.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(g))return Promise.resolve(void 0);const I=this._activatingExtensions.get(g);if(I)return I;const E=this._host.actualActivateExtension(s,u).then(void 0,o=>{const h=new Error;return o&&o.name&&(h.name=o.name),o&&o.message?h.message=`Activating extension '${s.value}' failed: ${o.message}.`:h.message=`Activating extension '${s.value}' failed: ${o}.`,o&&o.stack&&(h.stack=o.stack),this._host.onExtensionActivationError(s,h,null),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(o),new y(o)}).then(o=>{this._activatedExtensions.set(g,o),this._activatingExtensions.delete(g)});return this._activatingExtensions.set(g,E),E}};n=$e([ze(4,_.ILogService)],n),e.ExtensionsActivator=n}),define(be[180],Ee([0,1,16]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,F)=>{this._actualOk=A,this._actualErr=F,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,d.onUnexpectedError)(A))}then(A,F){return this._ensureActual().then(A,F)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=M}),define(be[38],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(P,t){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=t,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const M=[];function _(D){const P=new d(!0,D);return M[P.nid]=P,P}e.createMainContextProxyIdentifier=_;function A(D){const P=new d(!1,D);return M[P.nid]=P,P}e.createExtHostContextProxyIdentifier=A;function F(D){return M[D].sid}e.getStringIdentifierForProxy=F;class k{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=k}),define(be[5],Ee([0,1,55,2,38]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var F;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(F=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(o){o.name="$ident";function h(i,p){return Object.defineProperty(i,o.name,{value:p,enumerable:!0}),i}o.mixin=h;function C(i){return i[o.name]}o.of=C})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(h){return h._id=m._n++,h}}e.IdObject=m,m._n=0;var s;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var g;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(g=e.WorkspaceEditType||(e.WorkspaceEditType={}));function I(o){if(o&&o.edits)for(const h of o.edits)typeof h.resource=="object"?h.resource=M.URI.revive(h.resource):(h.newUri=M.URI.revive(h.newUri),h.oldUri=M.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,d.revive)(h.metadata));return o}e.reviveWorkspaceEditDto=I;var E;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,_.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,_.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,_.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,_.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,_.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,_.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,_.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,_.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,_.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,_.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,_.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,_.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,_.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,_.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,_.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,_.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,_.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,_.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,_.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,_.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,_.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,_.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,_.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,_.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,_.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,_.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,_.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,_.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,_.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,_.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,_.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,_.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,_.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,_.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,_.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,_.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,_.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,_.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,_.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,_.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,_.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,_.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,_.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,_.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,_.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,_.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,_.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,_.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,_.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,_.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,_.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,_.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,_.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,_.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,_.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,_.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,_.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,_.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,_.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,_.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,_.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,_.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,_.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,_.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,_.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,_.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,_.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,_.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,_.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,_.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,_.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,_.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,_.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,_.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,_.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,_.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,_.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,_.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,_.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,_.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,_.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,_.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,_.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,_.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,_.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[69],Ee([0,1,5,3,4]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(k){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,D){return this._proxy.$getPassword(k,D)}store(k,D,P){return this._proxy.$setPassword(k,D,P)}delete(k,D){return this._proxy.$deletePassword(k,D)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,_.createDecorator)("IExtHostSecretState")}),define(be[70],Ee([0,1,4,15,5,13]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let F=class{constructor(D,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(_.MainContext.MainThreadTelemetry)}report(D,P,t){const y=this.getUsageKey(D,P);this._reportedUsages.has(y)||(this._reportedUsages.add(y),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:D}))}getUsageKey(D,P){return`${D}-${P.identifier.value}`}};F=$e([ze(0,A.IExtHostRpcService),ze(1,M.ILogService)],F),e.ExtHostApiDeprecationService=F,e.NullApiDeprecationService=Object.freeze(new class{report(k,D,P){}})}),define(be[181],Ee([0,1,3,5,7,26]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,P,t,y={}){const n=A.ExtensionIdentifier.toKey(D.identifier),m=this._inFlightRequests.get(n)||[],s=[...t].sort().join(" ");let u=m.find(g=>g.scopes===s);if(u)return u.result;{const g=this._getSession(D,n,P,t,y);u={scopes:s,result:g},m.push(u),this._inFlightRequests.set(n,m);try{await g}finally{const I=m.findIndex(E=>E.scopes===s);I>-1&&(m.splice(I),this._inFlightRequests.set(n,m))}return g}}async _getSession(D,P,t,y,n={}){await this._proxy.$ensureProvider(t);const m=D.displayName||D.name;return this._proxy.$getSession(t,y,P,m,n)}async removeSession(D,P){const t=this._authenticationProviders.get(D);return t?t.provider.removeSession(P):this._proxy.$removeSession(D,P)}registerAuthenticationProvider(D,P,t,y){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:P,provider:t,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===D)||this._providers.push({id:D,label:P});const n=t.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(D,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,P,y?.supportsMultipleAccounts??!1),new _.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(D);const m=this._providers.findIndex(s=>s.id===D);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,P){const t=this._authenticationProviders.get(D);if(t)return Promise.resolve(t.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,P){const t=this._authenticationProviders.get(D);if(t)return Promise.resolve(t.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,P){const t=this._authenticationProviders.get(D);if(t)return Promise.resolve(t.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,P){return this._onDidChangeSessions.fire({provider:{id:D,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=F}),define(be[182],Ee([0,1,5,13,8]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(k,D){this._extHostDocumentsAndEditors=D,this._proxy=k.getProxy(d.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const D=_.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};A=$e([ze(0,M.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(be[183],Ee([0,1,5]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(A){const F=A.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(k){return F.$writeText(k)}})}}e.ExtHostClipboard=M}),define(be[39],Ee([0,1,10,7,8,23,5,14,15,55,44,112,2,6,4,13,49,22,38,45]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g,I,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let h=class{constructor(v,l){this._commands=new Map,this._apiCommands=new Map,this._proxy=v.getProxy(F.MainContext.MainThreadCommands),this._logService=l,this.converter=new C(this,c=>{const w=this._apiCommands.get(c);return w?.result===p.Void?w:void 0},l),this._argumentProcessors=[{processArgument(c){return(0,P.revive)(c)}},{processArgument(c){return(0,A.cloneAndChange)(c,function(w){if(t.Range.isIRange(w))return _.Range.to(w);if(y.Position.isIPosition(w))return _.Position.to(w);if(t.Range.isIRange(w.range)&&n.URI.isUri(w.uri))return _.location.to(w);if(w instanceof I.VSBuffer)return w.buffer.buffer;if(!Array.isArray(w))return w})}}]}registerArgumentProcessor(v){this._argumentProcessors.push(v)}registerApiCommand(v){const l=this.registerCommand(!1,v.id,async(...c)=>{const w=v.args.map((S,R)=>{if(!S.validate(c[R]))throw new Error(`Invalid argument '${S.name}' when running '${v.id}', received: ${c[R]}`);return S.convert(c[R])}),f=await this.executeCommand(v.internalId,...w);return v.result.convert(f,c,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this._apiCommands.set(v.id,v),new M.Disposable(()=>{l.dispose(),this._apiCommands.delete(v.id)})}registerCommand(v,l,c,w,f,S){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:c,thisArg:w,description:f,extension:S}),v&&this._proxy.$registerCommand(l),new M.Disposable(()=>{this._commands.delete(l)&&v&&this._proxy.$unregisterCommand(l)})}executeCommand(v,...l){return this._logService.trace("ExtHostCommands#executeCommand",v),this._doExecuteCommand(v,l,!0)}async _doExecuteCommand(v,l,c){if(this._commands.has(v))return this._executeContributedCommand(v,l,!1);{let w=!1;const f=(0,A.cloneAndChange)(l,function(S){if(S instanceof M.Position)return _.Position.from(S);if(S instanceof M.Range)return _.Range.from(S);if(S instanceof M.Location)return _.location.from(S);if(M.NotebookRange.isNotebookRange(S))return _.NotebookRange.from(S);if(S instanceof ArrayBuffer)return w=!0,I.VSBuffer.wrap(new Uint8Array(S));if(S instanceof Uint8Array)return w=!0,I.VSBuffer.wrap(S);if(!Array.isArray(S))return S});try{const S=await this._proxy.$executeCommand(v,w?new E.SerializableObjectWithBuffers(f):f,c);return(0,P.revive)(S)}catch(S){if(S instanceof Error&&S.message==="$executeCommand:retry")return this._doExecuteCommand(v,l,!1);throw S}}}async _executeContributedCommand(v,l,c){const w=this._commands.get(v);if(!w)throw new Error("Unknown command");let{callback:f,thisArg:S,description:R}=w;if(R)for(let T=0;T<R.args.length;T++)try{(0,d.validateConstraint)(l[T],R.args[T].constraint)}catch(L){throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${R.args[T].name}' - ${R.args[T].description}`)}try{return await f.apply(S,l)}catch(T){if(v===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...l);L&&(v=L.command)}throw this._logService.error(T,v,w.extension?.identifier),c?new class extends Error{constructor(){super((0,o.toErrorMessage)(T));this.id=v,this.source=w.extension?.displayName??w.extension?.name}}:T}}$executeContributedCommand(v,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",v),this._commands.has(v)?(l=l.map(c=>this._argumentProcessors.reduce((w,f)=>f.processArgument(w),c)),this._executeContributedCommand(v,l,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this._logService.trace("ExtHostCommands#getCommands",v),this._proxy.$getCommands().then(l=>(v&&(l=l.filter(c=>c[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const v=Object.create(null);for(let[l,c]of this._commands){let{description:w}=c;w&&(v[l]=w)}return Promise.resolve(v)}};h=$e([ze(0,u.IExtHostRpcService),ze(1,D.ILogService)],h),e.ExtHostCommands=h,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class C{constructor(v,l,c){this._commands=v,this._lookupApiCommand=l,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(v,l){if(!v)return;const c={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return c;const w=this._lookupApiCommand(v.command);if(w)c.id=w.internalId,c.arguments=w.args.map((f,S)=>f.convert(v.arguments&&v.arguments[S]));else if((0,k.isNonEmptyArray)(v.arguments)){const f=++this._cachIdPool;this._cache.set(f,v),l.add((0,m.toDisposable)(()=>{this._cache.delete(f),this._logService.trace("CommandsConverter#DISPOSE",f)})),c.$ident=f,c.id=this.delegatingCommandId,c.arguments=[f],this._logService.trace("CommandsConverter#CREATE",v.command,f)}return c}fromInternal(v){const l=F.ObjectIdentifier.of(v);return typeof l=="number"?this._cache.get(l):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this._cache.get(v[0])}_executeConvertedCommand(...v){const l=this.getActualCommand(...v);return this._logService.trace("CommandsConverter#EXECUTE",v[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=C;class i{constructor(v,l,c,w){this.name=v,this.description=l,this.validate=c,this.convert=w}optional(){return new i(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,l){return new i(v??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",r=>n.URI.isUri(r),r=>r),i.Position=new i("position","A position in a text document",r=>M.Position.isPosition(r),_.Position.from),i.Range=new i("range","A range in a text document",r=>M.Range.isRange(r),_.Range.from),i.Selection=new i("selection","A selection in a text document",r=>M.Selection.isSelection(r),_.Selection.from),i.Number=new i("number","",r=>typeof r=="number",r=>r),i.String=new i("string","",r=>typeof r=="string",r=>r),i.CallHierarchyItem=new i("item","A call hierarchy item",r=>r instanceof M.CallHierarchyItem,_.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",r=>r instanceof M.TypeHierarchyItem,_.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",r=>r instanceof g.TestItemImpl,_.TestItem.from);class p{constructor(v,l){this.description=v,this.convert=l}}e.ApiCommandResult=p,p.Void=new p("no result",r=>r);class a{constructor(v,l,c,w,f){this.id=v,this.internalId=l,this.description=c,this.args=w,this.result=f}}e.ApiCommand=a}),define(be[184],Ee([0,1,8,7,59,39,14,81]),function(oe,e,d,M,_,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(d.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,m)=>{if((0,F.isFalsyOrEmpty)(n))return;class s extends M.SymbolInformation{static to(g){const I=new s(g.name,d.SymbolKind.to(g.kind),g.containerName||"",new M.Location(m[0],d.Range.to(g.range)));return I.detail=g.detail,I.range=I.location.range,I.selectionRange=d.Range.to(g.selectionRange),I.children=g.children?g.children.map(s.to):[],I}}return n.map(s.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(d.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(d.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(m=>M.Position.isPosition(m)),n=>n.map(d.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(m=>{let s;for(const u of m.reverse())s=new M.SelectionRange(d.Range.to(u),s);return s}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const m=[];if(Array.isArray(n))for(let s of n)m.push(...s[1].map(d.WorkspaceSymbol.to));return m})),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:d.Range.to(n.range),placeholder:n.text}})),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return d.WorkspaceEdit.to(n)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(d.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,k.decodeSemanticTokensDto)(n);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,k.decodeSemanticTokensDto)(n);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,m,s)=>{if(!n)return new M.CompletionList([]);const u=n.suggestions.map(g=>d.CompletionItem.to(g,s));return new M.CompletionList(u,n.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return d.SignatureHelp.to(n)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,m,s)=>t(u=>new M.CodeLens(d.Range.to(u.range),u.command&&s.fromInternal(u.command)))(n))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?d.Selection.from(n):d.Range.from(n)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,m,s)=>t(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(u.command)}else{const g=new M.CodeAction(u.title,u.kind?new M.CodeActionKind(u.kind):void 0);return u.edit&&(g.edit=d.WorkspaceEdit.to(u.edit)),u.command&&(g.command=s.fromInternal(u.command)),g.isPreferred=u.isPreferred,g}})(n))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(m=>new M.ColorInformation(d.Range.to(m.range),d.Color.to(m.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,d.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:d.Range.from(n.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(d.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(d.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(m=>d.NotebookExclusiveDocumentPattern.to(m))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(d.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class P{static register(m){D.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=P;function t(n){return m=>{if(Array.isArray(m))return m.map(n)}}function y(n){if(!Array.isArray(n))return;const m=[];for(const s of n)_.isLocationLink(s)?m.push(d.DefinitionLink.to(s)):m.push(d.location.to(s));return m}}),define(be[185],Ee([0,1,12,53,3,6,2,59,26,8,7,5]),function(oe,e,d,M,_,A,F,k,D,P,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(m,s,u){const g=m.getProxy(y.MainContext.MainThreadComments);class I{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,s.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const v=this._commentControllers.get(r.handle);return v||r}else if(r&&r.$mid===7){const v=this._commentControllers.get(r.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.commentThreadHandle);return l||r}else if(r&&r.$mid===8){const v=this._commentControllers.get(r.thread.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.thread.commentThreadHandle);return l?{thread:l,text:r.text}:r}else if(r&&r.$mid===9){const v=this._commentControllers.get(r.thread.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let c=r.commentUniqueId,w=l.getCommentByUniqueId(c);return w||r}else if(r&&r.$mid===10){const v=this._commentControllers.get(r.thread.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let c=r.text,w=r.commentUniqueId,f=l.getCommentByUniqueId(w);return f?(f.body=c,f):r}return r}})}createCommentController(r,v,l){const c=I.handlePool++,w=new o(r,c,v,l);this._commentControllers.set(w.handle,w);const f=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(r.identifier))||[];return f.push(w),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(r.identifier),f),w.value}$createCommentThreadTemplate(r,v,l){const c=this._commentControllers.get(r);!c||c.$createCommentThreadTemplate(v,l)}async $updateCommentThreadTemplate(r,v,l){const c=this._commentControllers.get(r);!c||c.$updateCommentThreadTemplate(v,l)}$deleteCommentThread(r,v){const l=this._commentControllers.get(r);l&&l.$deleteCommentThread(v)}$provideCommentingRanges(r,v,l){const c=this._commentControllers.get(r);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const w=u.getDocument(F.URI.revive(v));return(0,d.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(w,l)).then(f=>f?f.map(S=>P.Range.from(S)):void 0)}$toggleReaction(r,v,l,c,w){const f=this._commentControllers.get(r);return!f||!f.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const S=f.getCommentThread(v);if(S){const R=S.getCommentByUniqueId(c.uniqueIdInThread);if(f!==void 0&&R&&f.reactionHandler)return f.reactionHandler(R,i(w))}return Promise.resolve(void 0)})}dispose(){}}I.handlePool=0;class E{constructor(r,v,l,c,w,f,S){this._commentControllerHandle=v,this._id=l,this._uri=c,this._range=w,this._comments=f,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new _.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${r}.${this.handle}`),g.$createCommentThread(v,this.handle,this._id,this._uri,P.Range.from(this._range),S),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=f,this._localDisposables.push({dispose:()=>{g.$deleteCommentThread(v,this.handle)}});const R=this;this.value={get uri(){return R.uri},get range(){return R.range},set range(T){R.range=T},get comments(){return R.comments},set comments(T){R.comments=T},get collapsibleState(){return R.collapsibleState},set collapsibleState(T){R.collapsibleState=T},get canReply(){return R.canReply},set canReply(T){R.canReply=T},get contextValue(){return R.contextValue},set contextValue(T){R.contextValue=T},get label(){return R.label},set label(T){R.label=T},dispose:()=>{R.dispose()}}}set threadId(r){this._id=r}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(r){r.isEqual(this._range)||(this._range=r,this.modifications.range=r,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(r){this._canReply!==r&&(this._canReply=r,this.modifications.canReply=r,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(r){this._label=r,this.modifications.label=r,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(r){this._contextValue=r,this.modifications.contextValue=r,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(r){this._comments=r,this.modifications.comments=r,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(r){this._collapseState=r,this.modifications.collapsibleState=r,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const r=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),v={};r("range")&&(v.range=P.Range.from(this._range)),r("label")&&(v.label=this.label),r("contextValue")&&(v.contextValue=this.contextValue),r("comments")&&(v.comments=this._comments.map(l=>h(this,l,this._commentsMap))),r("collapsibleState")&&(v.collapseState=p(this._collapseState)),r("canReply")&&(v.canReply=this.canReply),this.modifications={},g.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,v)}getCommentByUniqueId(r){for(let v of this._commentsMap){let l=v[0],c=v[1];if(r===c)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(r=>r.dispose())}}E._handlePool=0,$e([(0,M.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(r,v,l,c){this._extension=r,this._handle=v,this._id=l,this._label=c,this._threads=new Map,g.$registerCommentController(this.handle,l,c);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(f){w.options=f},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(f){w.commentingRangeProvider=f},get reactionHandler(){return w.reactionHandler},set reactionHandler(f){w.reactionHandler=f},createCommentThread(f,S,R){return w.createCommentThread(f,S,R).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{g.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(r){this._commentingRangeProvider=r,g.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(r){this._reactionHandler=r,g.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this._options}set options(r){this._options=r,g.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(r,v,l,c){if(typeof r=="string"){const w=new E(this.id,this.handle,r,v,l,c,this._extension.identifier);return this._threads.set(w.handle,w),w}else{const w=new E(this.id,this.handle,void 0,r,v,l,this._extension.identifier);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(r,v){const l=new E(this.id,this.handle,void 0,F.URI.revive(r),P.Range.to(v),[],this._extension.identifier);return l.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(r,v){let l=this._threads.get(r);l&&(l.range=P.Range.to(v))}$deleteCommentThread(r){let v=this._threads.get(r);v&&v.dispose(),this._threads.delete(r)}getCommentThread(r){return this._threads.get(r)}dispose(){this._threads.forEach(r=>{r.dispose()}),this._localDisposables.forEach(r=>r.dispose())}}function h(a,r,v){let l=v.get(r);l||(l=++a.commentHandle,v.set(r,l));const c=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;return{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:l,body:P.MarkdownString.from(r.body),userName:r.author.name,userIconPath:c,label:r.label,commentReactions:r.reactions?r.reactions.map(w=>C(w)):void 0}}function C(a){return{label:a.label,iconPath:a.iconPath?P.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function i(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?F.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function p(a){if(a!==void 0)switch(a){case t.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new I}e.createExtHostComments=n}),define(be[95],Ee([0,1,2,5,7,4,13,15,14,9,17]),function(oe,e,d,M,_,A,F,k,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class vi{constructor(m,s){this._logService=s,this._provider=new Map,this._proxy=m.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,s){const u=vi._handlePool++;this._provider.set(u,{provider:m,extensionId:s}),this._proxy.$registerDecorationProvider(u,s.value);const g=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(I=>{if(!I){this._proxy.$onDidChange(u,null);return}let E=(0,D.asArray)(I);if(E.length<=vi._maxEventSize){this._proxy.$onDidChange(u,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,E.length);const o=E.map(i=>({uri:i,rank:(0,P.count)(i.path,"/")})),h=(0,D.groupBy)(o,(i,p)=>i.rank-p.rank||(0,P.compare)(i.uri.path,p.uri.path));let C=[];e:for(let i of h){let p;for(let a of i){let r=(0,t.dirname)(a.uri.path);if(p!==r&&(p=r,C.push(a.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(u,C)});return new _.Disposable(()=>{g?.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(m,s,u){if(!this._provider.has(m))return Object.create(null);const g=Object.create(null),{provider:I,extensionId:E}=this._provider.get(m);return await Promise.all(s.map(async o=>{try{const{uri:h,id:C}=o,i=await Promise.resolve(I.provideFileDecoration(d.URI.revive(h),u));if(!i)return;try{_.FileDecoration.validate(i),g[C]=[i.propagate,i.tooltip,i.badge,i.color]}catch(p){this._logService.warn(`INVALID decoration from extension '${E.value}': ${p}`)}}catch(h){this._logService.error(h)}})),g}};y._handlePool=0,y._maxEventSize=250,y=$e([ze(0,F.IExtHostRpcService),ze(1,k.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[186],Ee([0,1,124,83,2,5,7,8,3,15,20,37,104]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n){"use strict";var m,s,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class g{constructor(o,h,C,i,p,a){this._name=o,this._owner=h,this._maxDiagnosticsPerFile=C,m.set(this,void 0),s.set(this,void 0),u.set(this,void 0),this._isDisposed=!1,Ze(this,u,new n.SkipList((r,v)=>i.compare(r,v)),"f"),Ze(this,m,p,"f"),Ze(this,s,a,"f")}dispose(){this._isDisposed||(Re(this,s,"f").fire([...Re(this,u,"f").keys()]),Re(this,m,"f")&&Re(this,m,"f").$clear(this._owner),Re(this,u,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,h){if(!o){this.clear();return}this._checkDisposed();let C=[];if(_.URI.isUri(o)){if(!h){this.delete(o);return}Re(this,u,"f").set(o,h.slice()),C=[o]}else if(Array.isArray(o)){C=[];let p;o=[...o].sort(g._compareIndexedTuplesByUri);for(const a of o){const[r,v]=a;if((!p||r.toString()!==p.toString())&&(p&&Re(this,u,"f").get(p).length===0&&Re(this,u,"f").delete(p),p=r,C.push(r),Re(this,u,"f").set(r,[])),v){const l=Re(this,u,"f").get(r);l&&l.push(...v)}else{const l=Re(this,u,"f").get(r);l&&(l.length=0)}}}if(Re(this,s,"f").fire(C),!Re(this,m,"f"))return;const i=[];for(let p of C){let a=[];const r=Re(this,u,"f").get(p);if(r)if(r.length>this._maxDiagnosticsPerFile){a=[];const v=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(let c of r)if(c.severity===v[l]&&a.push(k.Diagnostic.from(c))===this._maxDiagnosticsPerFile)break e;a.push({severity:M.MarkerSeverity.Info,message:(0,d.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=r.map(v=>k.Diagnostic.from(v));i.push([p,a])}Re(this,m,"f").$changeMany(this._owner,i)}delete(o){this._checkDisposed(),Re(this,s,"f").fire([o]),Re(this,u,"f").delete(o),Re(this,m,"f")&&Re(this,m,"f").$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),Re(this,s,"f").fire([...Re(this,u,"f").keys()]),Re(this,u,"f").clear(),Re(this,m,"f")&&Re(this,m,"f").$clear(this._owner)}forEach(o,h){this._checkDisposed();for(let C of Re(this,u,"f").keys())o.apply(h,[C,this.get(C),this])}get(o){this._checkDisposed();const h=Re(this,u,"f").get(o);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(Re(this,u,"f").get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,h){return o[0].toString()<h[0].toString()?-1:o[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=g,m=new WeakMap,s=new WeakMap,u=new WeakMap;let I=class ti{constructor(o,h,C){this._logService=h,this._fileSystemInfoService=C,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,ti._mapper),this._proxy=o.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(o){const h=new t.ResourceMap;for(const C of o)h.set(C,C);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(o,h){const{_collections:C,_proxy:i,_onDidChangeDiagnostics:p,_logService:a,_fileSystemInfoService:r}=this,v=new class{$changeMany(w,f){i.$changeMany(w,f),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,w,f.length===0?"CLEARING":f)}$clear(w){i.$clear(w),a.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,w)}dispose(){i.dispose()}};let l;if(!h)h="_generated_diagnostic_collection_name_#"+ti._idPool++,l=h;else if(!C.has(h))l=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do l=h+ti._idPool++;while(C.has(l))}return new class extends g{constructor(){super(h,l,ti._maxDiagnosticsPerFile,r.extUri,v,p);C.set(l,this)}dispose(){super.dispose(),C.delete(l)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const h=new Map,C=[];for(const i of this._collections.values())i.forEach((p,a)=>{let r=h.get(p.toString());typeof r=="undefined"&&(r=C.length,h.set(p.toString(),r),C.push([p,[]])),C[r][1]=C[r][1].concat(...a)});return C}}_getDiagnostics(o){let h=[];for(let C of this._collections.values())C.has(o)&&(h=h.concat(C.get(o)));return h}$acceptMarkersChange(o){if(!this._mirrorCollection){const h="_generated_mirror",C=new g(h,h,ti._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(h,C),this._mirrorCollection=C}for(const[h,C]of o)this._mirrorCollection.set(_.URI.revive(h),C.map(k.Diagnostic.to))}};I._idPool=0,I._maxDiagnosticsPerFile=1e3,I=$e([ze(1,P.ILogService),ze(2,y.IExtHostFileSystemInfo)],I),e.ExtHostDiagnostics=I}),define(be[187],Ee([0,1,2,5]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class _{constructor(F){this._proxy=F.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(F){return this._proxy.$showOpenDialog(F).then(k=>k?k.map(D=>d.URI.revive(D)):void 0)}showSaveDialog(F){return this._proxy.$showSaveDialog(F).then(k=>k?d.URI.revive(k):void 0)}}e.ExtHostDialogs=_}),define(be[188],Ee([0,1,16,2,7,5,11,21,9]),function(oe,e,d,M,_,A,F,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(y,n,m){this._documentsAndEditors=n,this._logService=m,this._documentContentProviders=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,n){if(Object.keys(F.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const m=P._handlePool++;this._documentContentProviders.set(m,n),this._proxy.$registerTextContentProvider(m,y);let s;return typeof n.onDidChange=="function"&&(s=n.onDidChange(u=>{if(u.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(m,u).then(g=>{if(!g&&typeof g!="string")return;const I=this._documentsAndEditors.getDocument(u);if(!I)return;const E=(0,D.splitLines)(g);if(!I.equalLines(E))return this._proxy.$onVirtualDocumentChange(u,g)},d.onUnexpectedError)})),new _.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(y,n){const m=this._documentContentProviders.get(y);return m?Promise.resolve(m.provideTextDocumentContent(M.URI.revive(n),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(be[189],Ee([0,1,3,6,2,5,88,8,10,23,7]),function(oe,e,d,M,_,A,F,k,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(m,s){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=s,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const g of u)this._onDidRemoveDocument.fire(g.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const g of u)this._onDidAddDocument.fire(g.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const s=this._documentsAndEditors.getDocument(m);if(s)return s}getDocument(m){const s=this.getDocumentData(m);if(!s?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return s.document}ensureDocumentData(m){const s=this._documentsAndEditors.getDocument(m);if(s)return Promise.resolve(s);let u=this._documentLoader.get(m.toString());return u||(u=this._proxy.$tryOpenDocument(m).then(g=>{this._documentLoader.delete(m.toString());const I=_.URI.revive(g);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(I))},g=>(this._documentLoader.delete(m.toString()),Promise.reject(g))),this._documentLoader.set(m.toString(),u)),u}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(s=>_.URI.revive(s))}$acceptModelModeChanged(m,s){const u=_.URI.revive(m),g=this._documentsAndEditors.getDocument(u);if(!g)throw new Error("unknown document");this._onDidRemoveDocument.fire(g.document),g._acceptLanguageId(s),this._onDidAddDocument.fire(g.document)}$acceptModelSaved(m){const s=_.URI.revive(m),u=this._documentsAndEditors.getDocument(s);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(m,s){const u=_.URI.revive(m),g=this._documentsAndEditors.getDocument(u);if(!g)throw new Error("unknown document");g._acceptIsDirty(s),this._onDidChangeDocument.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,s,u){const g=_.URI.revive(m),I=this._documentsAndEditors.getDocument(g);if(!I)throw new Error("unknown document");I._acceptIsDirty(u),I.onEvents(s);let E;s.isUndoing?E=t.TextDocumentChangeReason.Undo:s.isRedoing&&(E=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:I.document,contentChanges:s.changes.map(o=>({range:k.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:E}))}setWordDefinitionFor(m,s){(0,F.setWordDefinitionFor)(m,s)}}e.ExtHostDocuments=y}),define(be[50],Ee([0,1,42,3,6,2,4,5,88,13,94,8,15,20,11,232,103]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class I{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(h,C){this._extHostRpc=h,this._logService=C,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const C=[],i=[],p=[];if(h.removedDocuments)for(const a of h.removedDocuments){const r=A.URI.revive(a),v=this._documents.get(r);v?.unref()&&(this._documents.delete(r),C.push(v.value))}if(h.addedDocuments)for(const a of h.addedDocuments){const r=A.URI.revive(a.uri);let v=this._documents.get(r);if(v&&r.scheme!==s.Schemas.vscodeNotebookCell&&r.scheme!==s.Schemas.vscodeInteractiveInput)throw new Error(`document '${r} already exists!'`);v||(v=new I(new D.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),r,a.lines,a.EOL,a.versionId,a.modeId,a.isDirty,a.notebook)),this._documents.set(r,v),i.push(v.value)),v.ref()}if(h.removedEditors)for(const a of h.removedEditors){const r=this._editors.get(a);this._editors.delete(a),r&&p.push(r)}if(h.addedEditors)for(const a of h.addedEditors){const r=A.URI.revive(a.documentUri);d.ok(this._documents.has(r),`document '${r}' does not exist`),d.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const v=this._documents.get(r).value,l=new t.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>v.document),a.selections.map(y.Selection.to),a.options,a.visibleRanges.map(c=>y.Range.to(c)),typeof a.editorPosition=="number"?y.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,l)}h.newActiveEditor!==void 0&&(d.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,_.dispose)(C),(0,_.dispose)(p),h.removedDocuments&&this._onDidRemoveDocuments.fire(C),h.addedDocuments&&this._onDidAddDocuments.fire(i),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const C=this._editors.get(this._activeEditorId);return h?C:C?.value}allEditors(){return[...this._editors.values()]}};E=$e([ze(0,P.IExtHostRpcService),ze(1,n.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[71],Ee([0,1,8,5,2,3,4,13,12]),function(oe,e,d,M,_,A,F,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,F.createDecorator)("IExtHostEditorTabs");let P=class{constructor(y){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=y.getProxy(M.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(y){let n=-1;this._tabs=y.map((s,u)=>(s.isActive&&(n=u),Object.freeze({label:s.label,viewColumn:d.ViewColumn.to(s.viewColumn),index:u,resource:_.URI.revive(s.resource),additionalResourcesAndViewIds:s.additionalResourcesAndViewIds.map(({resource:g,viewId:I})=>({resource:_.URI.revive(g),viewId:I})),viewId:s.editorId,isActive:s.isActive,move:async(g,I)=>{this._proxy.$moveTab(s,g,d.ViewColumn.from(I)),await(0,D.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(s),await(0,D.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((s,u)=>s.viewColumn===u.viewColumn?s.index-u.index:s.viewColumn-u.viewColumn);const m=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==m&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};P=$e([ze(0,k.IExtHostRpcService)],P),e.ExtHostEditorTabs=P}),define(be[190],Ee([0,1,2,5,6,7,8,233,9,22]),function(oe,e,d,M,_,A,F,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const s=this._schemes.indexOf(m);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),s=[];let u,g,I=14,E=14;for(const o of m){let h=u?(0,D.commonPrefixLength)(u,o):0;for(h===0?g=1:g=E;h<o.length;h++)h+1===o.length?(I=E,E=9):E+=1,s.push([g,o.toUpperCase().charCodeAt(h),E]),s.push([g,o.toLowerCase().charCodeAt(h),E]),g=E;u=o,E=I}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new k.StateMachine(s)}}provideDocumentLinks(m){this._initStateMachine();const s=[],u=k.LinkComputer.computeLinks({getLineContent(g){return m.lineAt(g-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const g of u){const I=F.DocumentLink.to(g);I.target&&s.push(I)}return s}}class y{constructor(m,s){this._extHostLanguageFeatures=s,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,s,u,g={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const I=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(I,u);let E=2;g.isCaseSensitive&&(E+=1024),g.isReadonly&&(E+=2048),typeof u.copy=="function"&&(E+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&(E+=4),this._proxy.$registerFileSystemProvider(I,s,E).catch(h=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${s}`),console.error(h)});const o=u.onDidChangeFile(h=>{const C=[];for(const i of h){let{uri:p,type:a}=i;if(p.scheme!==s)continue;let r;switch(a){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}C.push({resource:p,type:r})}this._proxy.$onFileSystemChange(I,C)});return(0,_.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(I),this._proxy.$unregisterProvider(I)})}static _asIStat(m){const{type:s,ctime:u,mtime:g,size:I,permissions:E}=m;return{type:s,ctime:u,mtime:g,size:I,permissions:E}}$stat(m,s){return Promise.resolve(this._getFsProvider(m).stat(d.URI.revive(s))).then(u=>y._asIStat(u))}$readdir(m,s){return Promise.resolve(this._getFsProvider(m).readDirectory(d.URI.revive(s)))}$readFile(m,s){return Promise.resolve(this._getFsProvider(m).readFile(d.URI.revive(s))).then(u=>P.VSBuffer.wrap(u))}$writeFile(m,s,u,g){return Promise.resolve(this._getFsProvider(m).writeFile(d.URI.revive(s),u.buffer,g))}$delete(m,s,u){return Promise.resolve(this._getFsProvider(m).delete(d.URI.revive(s),u))}$rename(m,s,u,g){return Promise.resolve(this._getFsProvider(m).rename(d.URI.revive(s),d.URI.revive(u),g))}$copy(m,s,u,g){const I=this._getFsProvider(m);if(!I.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(I.copy(d.URI.revive(s),d.URI.revive(u),g))}$mkdir(m,s){return Promise.resolve(this._getFsProvider(m).createDirectory(d.URI.revive(s)))}$watch(m,s,u,g){const I=this._getFsProvider(m).watch(d.URI.revive(u),g);this._watches.set(s,I)}$unwatch(m,s){const u=this._watches.get(s);u&&(u.dispose(),this._watches.delete(s))}$open(m,s,u){const g=this._getFsProvider(m);if(!g.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(g.open(d.URI.revive(s),u))}$close(m,s){const u=this._getFsProvider(m);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(s))}$read(m,s,u,g){const I=this._getFsProvider(m);if(!I.read)throw new Error('FileSystemProvider does not implement "read"');const E=P.VSBuffer.alloc(g);return Promise.resolve(I.read(s,u,E.buffer,0,g)).then(o=>E.slice(0,o))}$write(m,s,u,g){const I=this._getFsProvider(m);if(!I.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(I.write(s,u,g.buffer,0,g.byteLength))}_getFsProvider(m){const s=this._fsProvider.get(m);if(!s){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return s}}e.ExtHostFileSystem=y}),define(be[72],Ee([0,1,5,60,7,22,4,13,37]),function(oe,e,d,M,_,A,F,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Ut{constructor(y,n){const m=y.getProxy(d.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return m.$stat(s).catch(Ut._handleError)},readDirectory(s){return m.$readdir(s).catch(Ut._handleError)},createDirectory(s){return m.$mkdir(s).catch(Ut._handleError)},async readFile(s){return m.$readFile(s).then(u=>u.buffer).catch(Ut._handleError)},writeFile(s,u){return m.$writeFile(s,A.VSBuffer.wrap(u)).catch(Ut._handleError)},delete(s,u){return m.$delete(s,{recursive:!1,useTrash:!1,...u}).catch(Ut._handleError)},rename(s,u,g){return m.$rename(s,u,{overwrite:!1,...g}).catch(Ut._handleError)},copy(s,u,g){return m.$copy(s,u,{overwrite:!1,...g}).catch(Ut._handleError)},isWritableFileSystem(s){const u=n.getCapabilities(s);if(typeof u=="number")return!(u&2048)}})}static _handleError(y){if(!(y instanceof Error))throw new _.FileSystemError(String(y));if(y.name==="ENOPRO")throw _.FileSystemError.Unavailable(y.message);switch(y.name){case M.FileSystemProviderErrorCode.FileExists:throw _.FileSystemError.FileExists(y.message);case M.FileSystemProviderErrorCode.FileNotFound:throw _.FileSystemError.FileNotFound(y.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw _.FileSystemError.FileNotADirectory(y.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw _.FileSystemError.FileIsADirectory(y.message);case M.FileSystemProviderErrorCode.NoPermissions:throw _.FileSystemError.NoPermissions(y.message);case M.FileSystemProviderErrorCode.Unavailable:throw _.FileSystemError.Unavailable(y.message);default:throw new _.FileSystemError(y.message,y.name)}}};P=$e([ze(0,k.IExtHostRpcService),ze(1,D.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(be[191],Ee([0,1,2,39]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class _{constructor(F,k,D,P){this._extHostNotebooks=k,this._textDocumentsAndEditors=D,this._commands=P;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",y=>!0,y=>y),new M.ApiCommandArgument("resource","Interactive resource Uri",y=>!0,y=>y),new M.ApiCommandArgument("controllerId","Notebook controller Id",y=>!0,y=>y),new M.ApiCommandArgument("title","Interactive editor title",y=>!0,y=>y)],new M.ApiCommandResult("Notebook and input URI",y=>{if(y.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(y.notebookEditorId);return{notebookUri:d.URI.revive(y.notebookUri),inputUri:d.URI.revive(y.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:d.URI.revive(y.notebookUri),inputUri:d.URI.revive(y.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(F,k,D,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],modeId:D,uri:F,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=_}),define(be[192],Ee([0,1,6,5]),function(oe,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class _{constructor(F){this._handlePool=0,this._proxy=F.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,F),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=_}),define(be[193],Ee([0,1,2,23,8,7,5,9,44,14,10,234,6,81,54,64,194,16,3]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(U,Q){this._documents=U,this._provider=Q}async provideDocumentSymbols(U,Q){const ee=this._documents.getDocument(U),ae=await this._provider.provideDocumentSymbols(ee,Q);if(!(0,P.isFalsyOrEmpty)(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(_.DocumentSymbol.from):o._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(U){U=U.slice(0).sort((ae,K)=>{let se=ae.location.range.start.compareTo(K.location.range.start);return se===0&&(se=K.location.range.end.compareTo(ae.location.range.end)),se});const Q=[],ee=[];for(const ae of U){const K={name:ae.name||"!!MISSING: name!!",kind:_.SymbolKind.from(ae.kind),tags:ae.tags?.map(_.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:_.Range.from(ae.location.range),selectionRange:_.Range.from(ae.location.range),children:[]};for(;;){if(ee.length===0){ee.push(K),Q.push(K);break}const se=ee[ee.length-1];if(D.Range.containsRange(se.range,K.range)&&!D.Range.equalsRange(se.range,K.range)){se.children&&se.children.push(K),ee.push(K);break}ee.pop()}}return Q}}class h{constructor(U,Q,ee){this._documents=U,this._commands=Q,this._provider=ee,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(U,Q){const ee=this._documents.getDocument(U),ae=await this._provider.provideCodeLenses(ee,Q);if(!ae||Q.isCancellationRequested)return;const K=this._cache.add(ae),se=new n.DisposableStore;this._disposables.set(K,se);const he={cacheId:K,lenses:[]};for(let Ae=0;Ae<ae.length;Ae++)he.lenses.push({cacheId:[K,Ae],range:_.Range.from(ae[Ae].range),command:this._commands.toInternal(ae[Ae].command,se)});return he}async resolveCodeLens(U,Q){const ee=U.cacheId&&this._cache.get(...U.cacheId);if(!ee)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||ee.isResolved?ae=ee:ae=await this._provider.resolveCodeLens(ee,Q),ae||(ae=ee),Q.isCancellationRequested)return;const K=U.cacheId&&this._disposables.get(U.cacheId[0]);if(!!K)return U.command=this._commands.toInternal(ae.command??h._badCmd,K),U}releaseCodeLenses(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function C(Ve){return Array.isArray(Ve)?Ve.map(_.DefinitionLink.from):Ve?[_.DefinitionLink.from(Ve)]:[]}class i{constructor(U,Q){this._documents=U,this._provider=Q}async provideDefinition(U,Q,ee){const ae=this._documents.getDocument(U),K=_.Position.to(Q),se=await this._provider.provideDefinition(ae,K,ee);return C(se)}}class p{constructor(U,Q){this._documents=U,this._provider=Q}async provideDeclaration(U,Q,ee){const ae=this._documents.getDocument(U),K=_.Position.to(Q),se=await this._provider.provideDeclaration(ae,K,ee);return C(se)}}class a{constructor(U,Q){this._documents=U,this._provider=Q}async provideImplementation(U,Q,ee){const ae=this._documents.getDocument(U),K=_.Position.to(Q),se=await this._provider.provideImplementation(ae,K,ee);return C(se)}}class r{constructor(U,Q){this._documents=U,this._provider=Q}async provideTypeDefinition(U,Q,ee){const ae=this._documents.getDocument(U),K=_.Position.to(Q),se=await this._provider.provideTypeDefinition(ae,K,ee);return C(se)}}class v{constructor(U,Q){this._documents=U,this._provider=Q}async provideHover(U,Q,ee){const ae=this._documents.getDocument(U),K=_.Position.to(Q),se=await this._provider.provideHover(ae,K,ee);if(!(!se||(0,P.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=ae.getWordRangeAtPosition(K)),se.range||(se.range=new A.Range(K,K)),_.Hover.from(se)}}class l{constructor(U,Q){this._documents=U,this._provider=Q}async provideEvaluatableExpression(U,Q,ee){const ae=this._documents.getDocument(U),K=_.Position.to(Q),se=await this._provider.provideEvaluatableExpression(ae,K,ee);if(se)return _.EvaluatableExpression.from(se)}}class c{constructor(U,Q){this._documents=U,this._provider=Q}async provideInlineValues(U,Q,ee,ae){const K=this._documents.getDocument(U),se=await this._provider.provideInlineValues(K,_.Range.to(Q),_.InlineValueContext.to(ee),ae);if(Array.isArray(se))return se.map(he=>_.InlineValue.from(he))}}class w{constructor(U,Q){this._documents=U,this._provider=Q}async provideDocumentHighlights(U,Q,ee){const ae=this._documents.getDocument(U),K=_.Position.to(Q),se=await this._provider.provideDocumentHighlights(ae,K,ee);if(Array.isArray(se))return se.map(_.DocumentHighlight.from)}}class f{constructor(U,Q){this._documents=U,this._provider=Q}async provideLinkedEditingRanges(U,Q,ee){const ae=this._documents.getDocument(U),K=_.Position.to(Q),se=await this._provider.provideLinkedEditingRanges(ae,K,ee);if(se&&Array.isArray(se.ranges))return{ranges:(0,P.coalesce)(se.ranges.map(_.Range.from)),wordPattern:se.wordPattern}}}class S{constructor(U,Q){this._documents=U,this._provider=Q}async provideReferences(U,Q,ee,ae){const K=this._documents.getDocument(U),se=_.Position.to(Q),he=await this._provider.provideReferences(K,se,ee,ae);if(Array.isArray(he))return he.map(_.location.from)}}class R{constructor(U,Q,ee,ae,K,se,he){this._documents=U,this._commands=Q,this._diagnostics=ee,this._provider=ae,this._logService=K,this._extension=se,this._apiDeprecation=he,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(U,Q,ee,ae){const K=this._documents.getDocument(U),se=y.Selection.isISelection(Q)?_.Selection.to(Q):_.Range.to(Q),he=[];for(const st of this._diagnostics.getDiagnostics(U))if(se.intersection(st.range)&&he.push(st)>R._maxCodeActionsPerFile)break;const Ae={diagnostics:he,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:_.CodeActionTriggerKind.to(ee.trigger)},Ue=await this._provider.provideCodeActions(K,se,Ae,ae);if(!(0,P.isNonEmptyArray)(Ue)||ae.isCancellationRequested)return;const He=this._cache.add(Ue),Qe=new n.DisposableStore;this._disposables.set(He,Qe);const et=[];for(let st=0;st<Ue.length;st++){const ye=Ue[st];!ye||(R._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,Qe)})):(Ae.only&&(ye.kind?Ae.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[He,st],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,Qe),diagnostics:ye.diagnostics&&ye.diagnostics.map(_.Diagnostic.from),edit:ye.edit&&_.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:He,actions:et}}async resolveCodeAction(U,Q){const[ee,ae]=U,K=this._cache.get(ee,ae);if(!K||R._isCommand(K)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(K,Q)??K;return se?.edit?_.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}static _isCommand(U){return typeof U.command=="string"&&typeof U.title=="string"}}R._maxCodeActionsPerFile=1e3;class T{constructor(U,Q){this._documents=U,this._provider=Q}async provideDocumentFormattingEdits(U,Q,ee){const ae=this._documents.getDocument(U),K=await this._provider.provideDocumentFormattingEdits(ae,Q,ee);if(Array.isArray(K))return K.map(_.TextEdit.from)}}class L{constructor(U,Q){this._documents=U,this._provider=Q}async provideDocumentRangeFormattingEdits(U,Q,ee,ae){const K=this._documents.getDocument(U),se=_.Range.to(Q),he=await this._provider.provideDocumentRangeFormattingEdits(K,se,ee,ae);if(Array.isArray(he))return he.map(_.TextEdit.from)}}class b{constructor(U,Q){this._documents=U,this._provider=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,Q,ee,ae,K){const se=this._documents.getDocument(U),he=_.Position.to(Q),Ae=await this._provider.provideOnTypeFormattingEdits(se,he,ee,ae,K);if(Array.isArray(Ae))return Ae.map(_.TextEdit.from)}}class x{constructor(U,Q){this._provider=U,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(U,Q){const ee=F.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(U,Q);if((0,P.isNonEmptyArray)(ae))for(const K of ae){if(!K)continue;if(!K.name){this._logService.warn("INVALID SymbolInformation, lacks name",K);continue}const se=F.IdObject.mixin(_.WorkspaceSymbol.from(K));this._symbolCache.set(se._id,K),ee.symbols.push(se)}return ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee}async resolveWorkspaceSymbol(U,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return U;const ee=this._symbolCache.get(U._id);if(ee){const ae=await this._provider.resolveWorkspaceSymbol(ee,Q);return ae&&(0,M.mixin)(U,_.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(U){const Q=this._resultCache.get(U);if(Q){for(let[ee,ae]=Q;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete(U)}}}class ${constructor(U,Q,ee){this._documents=U,this._provider=Q,this._logService=ee}static supportsResolving(U){return typeof U.prepareRename=="function"}async provideRenameEdits(U,Q,ee,ae){const K=this._documents.getDocument(U),se=_.Position.to(Q);try{const he=await this._provider.provideRenameEdits(K,se,ee,ae);return he?_.WorkspaceEdit.from(he):void 0}catch(he){const Ae=$._asMessage(he);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(U,Q,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(U),K=_.Position.to(Q);try{const se=await this._provider.prepareRename(ae,K,ee);let he,Ae;if(A.Range.isRange(se)?(he=se,Ae=ae.getText(se)):(0,t.isObject)(se)&&(he=se.range,Ae=se.placeholder),!he||!Ae)return;if(he.start.line>K.line||he.end.line<K.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:_.Range.from(he),text:Ae}}catch(se){const he=$._asMessage(se);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class B{constructor(U,Q){this.resultId=U,this.tokens=Q}}class G{constructor(U,Q){this._documents=U,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(U,Q,ee){const ae=this._documents.getDocument(U),K=Q!==0?this._previousResults.get(Q):null;let se=typeof K?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,K.resultId,ee):await this._provider.provideDocumentSemanticTokens(ae,ee);return K&&this._previousResults.delete(Q),se?(se=G._fixProvidedSemanticTokens(se),this._send(G._convertToEdits(K,se),se)):null}async releaseDocumentSemanticColoring(U){this._previousResults.delete(U)}static _fixProvidedSemanticTokens(U){return G._isSemanticTokens(U)?G._isCorrectSemanticTokens(U)?U:new A.SemanticTokens(new Uint32Array(U.data),U.resultId):G._isSemanticTokensEdits(U)?G._isCorrectSemanticTokensEdits(U)?U:new A.SemanticTokensEdits(U.edits.map(Q=>new A.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),U.resultId):U}static _isSemanticTokens(U){return U&&!!U.data}static _isCorrectSemanticTokens(U){return U.data instanceof Uint32Array}static _isSemanticTokensEdits(U){return U&&Array.isArray(U.edits)}static _isCorrectSemanticTokensEdits(U){for(const Q of U.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(U,Q){if(!G._isSemanticTokens(Q)||!U||!U.tokens)return Q;const ee=U.tokens,ae=ee.length,K=Q.data,se=K.length;let he=0;const Ae=Math.min(ae,se);for(;he<Ae&&ee[he]===K[he];)he++;if(he===ae&&he===se)return new A.SemanticTokensEdits([],Q.resultId);let Ue=0;const He=Ae-he;for(;Ue<He&&ee[ae-Ue-1]===K[se-Ue-1];)Ue++;return new A.SemanticTokensEdits([{start:he,deleteCount:ae-he-Ue,data:K.subarray(he,se-Ue)}],Q.resultId)}_send(U,Q){if(G._isSemanticTokens(U)){const ee=this._nextResultId++;return this._previousResults.set(ee,new B(U.resultId,U.data)),(0,m.encodeSemanticTokensDto)({id:ee,type:"full",data:U.data})}if(G._isSemanticTokensEdits(U)){const ee=this._nextResultId++;return G._isSemanticTokens(Q)?this._previousResults.set(ee,new B(Q.resultId,Q.data)):this._previousResults.set(ee,new B(U.resultId)),(0,m.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(U.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=G;class H{constructor(U,Q){this._documents=U,this._provider=Q}async provideDocumentRangeSemanticTokens(U,Q,ee){const ae=this._documents.getDocument(U),K=await this._provider.provideDocumentRangeSemanticTokens(ae,_.Range.to(Q),ee);return K?this._send(K):null}_send(U){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:U.data})}}e.DocumentRangeSemanticTokensAdapter=H;class W{constructor(U,Q,ee,ae,K){this._documents=U,this._commands=Q,this._provider=ee,this._apiDeprecation=ae,this._extension=K,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}async provideCompletionItems(U,Q,ee,ae){const K=this._documents.getDocument(U),se=_.Position.to(Q),he=K.getWordRangeAtPosition(se)||new A.Range(se,se),Ae=he.with({end:se}),Ue=new g.StopWatch(!0),He=await this._provider.provideCompletionItems(K,se,ae,_.CompletionContext.to(ee));if(!He||ae.isCancellationRequested)return;const Qe=Array.isArray(He)?new A.CompletionList(He):He,et=W.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),st=new n.DisposableStore;this._disposables.set(et,st);const ye=[],nt={x:et,b:ye,a:{replace:_.Range.from(he),insert:_.Range.from(Ae)},c:Qe.isIncomplete||void 0,d:Ue.elapsed()};for(let q=0;q<Qe.items.length;q++){const Z=Qe.items[q],pe=this._convertCompletionItem(Z,[et,q],Ae,he);ye.push(pe)}return nt}async resolveCompletionItem(U,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...U);if(!ee)return;const ae=await this._provider.resolveCompletionItem(ee,Q);if(!!ae)return this._convertCompletionItem(ae,U)}releaseCompletionItems(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}_convertCompletionItem(U,Q,ee,ae){const K=this._disposables.get(Q[0]);if(!K)throw Error("DisposableStore is missing...");const se={x:Q,a:U.label,b:U.kind!==void 0?_.CompletionItemKind.from(U.kind):void 0,n:U.tags&&U.tags.map(_.CompletionItemTag.from),c:U.detail,d:typeof U.documentation=="undefined"?void 0:_.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters,l:U.additionalTextEdits&&U.additionalTextEdits.map(_.TextEdit.from),m:this._commands.toInternal(U.command,K)};U.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=U.textEdit.newText):typeof U.insertText=="string"?se.h=U.insertText:U.insertText instanceof A.SnippetString&&(se.h=U.insertText.value,se.i|=4);let he;return U.textEdit?he=U.textEdit.range:U.range&&(he=U.range),A.Range.isRange(he)?se.j=_.Range.from(he):he&&(!ee?.isEqual(he.inserting)||!ae?.isEqual(he.replacing))&&(se.j={insert:_.Range.from(he.inserting),replace:_.Range.from(he.replacing)}),se}}class ne{constructor(U,Q,ee){this._documents=U,this._provider=Q,this._commands=ee,this._cache=new u.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(U,Q,ee,ae){const K=this._documents.getDocument(U),se=_.Position.to(Q),he=await this._provider.provideInlineCompletionItems(K,se,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:_.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:ee.triggerKind},ae);if(!he||ae.isCancellationRequested)return;const Ae=(0,t.isArray)(he)?{items:he}:he,Ue=this._cache.add(Ae.items);let He;return{pid:Ue,items:Ae.items.map((Qe,et)=>{let st;return Qe.command&&(He||(He=new n.DisposableStore,this._disposables.set(Ue,He)),st=this._commands.toInternal(Qe.command,He)),{text:Qe.text,range:Qe.range?_.Range.from(Qe.range):void 0,command:st,idx:et}})}}disposeCompletions(U){this._cache.delete(U);const Q=this._disposables.get(U);Q&&Q.clear(),this._disposables.delete(U)}handleDidShowCompletionItem(U,Q){const ee=this._cache.get(U,Q);ee&&V.get(this._provider).fireOnDidShowCompletionItem({completionItem:ee})}}class V{constructor(){this._onDidShowCompletionItemEmitter=new E.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(U){let Q=V.map.get(U);return Q||(Q=new V,V.map.set(U,Q)),Q}fireOnDidShowCompletionItem(U){this._onDidShowCompletionItemEmitter.fire(U)}}e.InlineCompletionController=V,V.map=new WeakMap;class Y{constructor(U,Q){this._documents=U,this._provider=Q,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp(U,Q,ee,ae){const K=this._documents.getDocument(U),se=_.Position.to(Q),he=this.reviveContext(ee),Ae=await this._provider.provideSignatureHelp(K,se,ae,he);if(Ae){const Ue=this._cache.add([Ae]);return{..._.SignatureHelp.from(Ae),id:Ue}}}reviveContext(U){let Q;if(U.activeSignatureHelp){const ee=_.SignatureHelp.to(U.activeSignatureHelp),ae=this._cache.get(U.activeSignatureHelp.id,0);ae?(Q=ae,Q.activeSignature=ee.activeSignature,Q.activeParameter=ee.activeParameter):Q=ee}return{...U,activeSignatureHelp:Q}}releaseSignatureHelp(U){this._cache.delete(U)}}class j{constructor(U,Q){this._documents=U,this._provider=Q}async provideInlayHints(U,Q,ee){const ae=this._documents.getDocument(U),K=await this._provider.provideInlayHints(ae,_.Range.to(Q),ee);return K?{hints:K.map(_.InlayHint.from)}:void 0}}class le{constructor(U,Q){this._documents=U,this._provider=Q,this._cache=new u.Cache("DocumentLink")}async provideLinks(U,Q){const ee=this._documents.getDocument(U),ae=await this._provider.provideDocumentLinks(ee,Q);if(!(!Array.isArray(ae)||ae.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(le._validateLink).map(_.DocumentLink.from)};{const K=this._cache.add(ae),se={links:[],id:K};for(let he=0;he<ae.length;he++){if(!le._validateLink(ae[he]))continue;const Ae=_.DocumentLink.from(ae[he]);Ae.cacheId=[K,he],se.links.push(Ae)}return se}}}static _validateLink(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,Q){if(typeof this._provider.resolveDocumentLink!="function")return;const ee=this._cache.get(...U);if(!ee)return;const ae=await this._provider.resolveDocumentLink(ee,Q);if(!(!ae||!le._validateLink(ae)))return _.DocumentLink.from(ae)}releaseLinks(U){this._cache.delete(U)}}class re{constructor(U,Q){this._documents=U,this._provider=Q}async provideColors(U,Q){const ee=this._documents.getDocument(U),ae=await this._provider.provideDocumentColors(ee,Q);return Array.isArray(ae)?ae.map(se=>({color:_.Color.from(se.color),range:_.Range.from(se.range)})):[]}async provideColorPresentations(U,Q,ee){const ae=this._documents.getDocument(U),K=_.Range.to(Q.range),se=_.Color.to(Q.color),he=await this._provider.provideColorPresentations(se,{document:ae,range:K},ee);if(!!Array.isArray(he))return he.map(_.ColorPresentation.from)}}class ve{constructor(U,Q){this._documents=U,this._provider=Q}async provideFoldingRanges(U,Q,ee){const ae=this._documents.getDocument(U),K=await this._provider.provideFoldingRanges(ae,Q,ee);if(!!Array.isArray(K))return K.map(_.FoldingRange.from)}}class Fe{constructor(U,Q,ee){this._documents=U,this._provider=Q,this._logService=ee}async provideSelectionRanges(U,Q,ee){const ae=this._documents.getDocument(U),K=Q.map(_.Position.to),se=await this._provider.provideSelectionRanges(ae,K,ee);if(!(0,P.isNonEmptyArray)(se))return[];if(se.length!==K.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Ae=0;Ae<K.length;Ae++){const Ue=[];he.push(Ue);let He=K[Ae],Qe=se[Ae];for(;;){if(!Qe.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(_.SelectionRange.from(Qe)),!Qe.parent)break;He=Qe.range,Qe=Qe.parent}}return he}}class Me{constructor(U,Q){this._documents=U,this._provider=Q,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(U,Q,ee){const ae=this._documents.getDocument(U),K=_.Position.to(Q),se=await this._provider.prepareCallHierarchy(ae,K,ee);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Ae=>this._cacheAndConvertItem(he,Ae)):[this._cacheAndConvertItem(he,se)]}async provideCallsTo(U,Q,ee){const ae=this._itemFromCache(U,Q);if(!ae)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!K)return K.map(se=>({from:this._cacheAndConvertItem(U,se.from),fromRanges:se.fromRanges.map(he=>_.Range.from(he))}))}async provideCallsFrom(U,Q,ee){const ae=this._itemFromCache(U,Q);if(!ae)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!K)return K.map(se=>({to:this._cacheAndConvertItem(U,se.to),fromRanges:se.fromRanges.map(he=>_.Range.from(he))}))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,Q){const ee=this._cache.get(U),ae=_.CallHierarchyItem.from(Q,U,ee.size.toString(36));return ee.set(ae._itemId,Q),ae}_itemFromCache(U,Q){return this._cache.get(U)?.get(Q)}}class Oe{constructor(U,Q){this._documents=U,this._provider=Q,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(U,Q,ee){const ae=this._documents.getDocument(U),K=_.Position.to(Q),se=await this._provider.prepareTypeHierarchy(ae,K,ee);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Ae=>this._cacheAndConvertItem(he,Ae)):[this._cacheAndConvertItem(he,se)]}async provideSupertypes(U,Q,ee){const ae=this._itemFromCache(U,Q);if(!ae)throw new Error("missing type hierarchy item");const K=await this._provider.provideTypeHierarchySupertypes(ae,ee);if(!!K)return K.map(se=>this._cacheAndConvertItem(U,se))}async provideSubtypes(U,Q,ee){const ae=this._itemFromCache(U,Q);if(!ae)throw new Error("missing type hierarchy item");const K=await this._provider.provideTypeHierarchySubtypes(ae,ee);if(!!K)return K.map(se=>this._cacheAndConvertItem(U,se))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,Q){const ee=this._cache.get(U),ae=_.TypeHierarchyItem.from(Q,U,ee.size.toString(36));return ee.set(ae._itemId,Q),ae}_itemFromCache(U,Q){return this._cache.get(U)?.get(Q)}}class Ke{constructor(U,Q){this.adapter=U,this.extension=Q}}class je{constructor(U,Q,ee,ae,K,se,he){this._adapter=new Map,this._uriTransformer=Q,this._proxy=U.getProxy(F.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=K,this._logService=se,this._apiDeprecation=he}_transformDocumentSelector(U){return _.DocumentSelector.from(U,this._uriTransformer)}_createDisposable(U){return new A.Disposable(()=>{this._adapter.delete(U),this._proxy.$unregister(U)})}_nextHandle(){return je._handlePool++}_withAdapter(U,Q,ee,ae,K=!1){const se=this._adapter.get(U);if(!se)return Promise.resolve(ae);if(se.adapter instanceof Q){let he;se.extension&&(he=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${Q.name}'`));const Ae=ee(se.adapter,se.extension),Ue=se.extension;return Ue&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${Ue.identifier.value}] provider DONE after ${Date.now()-he}ms`),He=>{K&&He instanceof I.CancellationError||(this._logService.error(`[${Ue.identifier.value}] provider FAILED`),this._logService.error(He))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(U,Q){const ee=this._nextHandle();return this._adapter.set(ee,new Ke(U,Q)),ee}static _extLabel(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,Q,ee,ae){const K=this._addNewAdapter(new o(this._documents,ee),U),se=ae&&ae.label||je._extLabel(U);return this._proxy.$registerDocumentSymbolProvider(K,this._transformDocumentSelector(Q),se),this._createDisposable(K)}$provideDocumentSymbols(U,Q,ee){return this._withAdapter(U,o,ae=>ae.provideDocumentSymbols(d.URI.revive(Q),ee),void 0)}registerCodeLensProvider(U,Q,ee){const ae=this._nextHandle(),K=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ke(new h(this._documents,this._commands.converter,ee),U)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Q),K);let se=this._createDisposable(ae);if(K!==void 0){const he=ee.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(K));se=A.Disposable.from(se,he)}return se}$provideCodeLenses(U,Q,ee){return this._withAdapter(U,h,ae=>ae.provideCodeLenses(d.URI.revive(Q),ee),void 0)}$resolveCodeLens(U,Q,ee){return this._withAdapter(U,h,ae=>ae.resolveCodeLens(Q,ee),void 0)}$releaseCodeLenses(U,Q){this._withAdapter(U,h,ee=>Promise.resolve(ee.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider(U,Q,ee){const ae=this._addNewAdapter(new i(this._documents,ee),U);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDefinition(U,Q,ee,ae){return this._withAdapter(U,i,K=>K.provideDefinition(d.URI.revive(Q),ee,ae),[])}registerDeclarationProvider(U,Q,ee){const ae=this._addNewAdapter(new p(this._documents,ee),U);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDeclaration(U,Q,ee,ae){return this._withAdapter(U,p,K=>K.provideDeclaration(d.URI.revive(Q),ee,ae),[])}registerImplementationProvider(U,Q,ee){const ae=this._addNewAdapter(new a(this._documents,ee),U);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideImplementation(U,Q,ee,ae){return this._withAdapter(U,a,K=>K.provideImplementation(d.URI.revive(Q),ee,ae),[])}registerTypeDefinitionProvider(U,Q,ee){const ae=this._addNewAdapter(new r(this._documents,ee),U);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideTypeDefinition(U,Q,ee,ae){return this._withAdapter(U,r,K=>K.provideTypeDefinition(d.URI.revive(Q),ee,ae),[])}registerHoverProvider(U,Q,ee,ae){const K=this._addNewAdapter(new v(this._documents,ee),U);return this._proxy.$registerHoverProvider(K,this._transformDocumentSelector(Q)),this._createDisposable(K)}$provideHover(U,Q,ee,ae){return this._withAdapter(U,v,K=>K.provideHover(d.URI.revive(Q),ee,ae),void 0)}registerEvaluatableExpressionProvider(U,Q,ee,ae){const K=this._addNewAdapter(new l(this._documents,ee),U);return this._proxy.$registerEvaluatableExpressionProvider(K,this._transformDocumentSelector(Q)),this._createDisposable(K)}$provideEvaluatableExpression(U,Q,ee,ae){return this._withAdapter(U,l,K=>K.provideEvaluatableExpression(d.URI.revive(Q),ee,ae),void 0)}registerInlineValuesProvider(U,Q,ee,ae){const K=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new c(this._documents,ee),U);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(Q),K);let he=this._createDisposable(se);if(K!==void 0){const Ae=ee.onDidChangeInlineValues(Ue=>this._proxy.$emitInlineValuesEvent(K));he=A.Disposable.from(he,Ae)}return he}$provideInlineValues(U,Q,ee,ae,K){return this._withAdapter(U,c,se=>se.provideInlineValues(d.URI.revive(Q),ee,ae,K),void 0)}registerDocumentHighlightProvider(U,Q,ee){const ae=this._addNewAdapter(new w(this._documents,ee),U);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentHighlights(U,Q,ee,ae){return this._withAdapter(U,w,K=>K.provideDocumentHighlights(d.URI.revive(Q),ee,ae),void 0)}registerLinkedEditingRangeProvider(U,Q,ee){const ae=this._addNewAdapter(new f(this._documents,ee),U);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideLinkedEditingRanges(U,Q,ee,ae){return this._withAdapter(U,f,async K=>{const se=await K.provideLinkedEditingRanges(d.URI.revive(Q),ee,ae);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?je._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider(U,Q,ee){const ae=this._addNewAdapter(new S(this._documents,ee),U);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideReferences(U,Q,ee,ae,K){return this._withAdapter(U,S,se=>se.provideReferences(d.URI.revive(Q),ee,ae,K),void 0)}registerCodeActionProvider(U,Q,ee,ae){const K=new n.DisposableStore,se=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,U,this._apiDeprecation),U);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(Q),{providedKinds:ae?.providedCodeActionKinds?.map(he=>he.value),documentation:ae?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,K)}))},je._extLabel(U),Boolean(ee.resolveCodeAction)),K.add(this._createDisposable(se)),K}$provideCodeActions(U,Q,ee,ae,K){return this._withAdapter(U,R,se=>se.provideCodeActions(d.URI.revive(Q),ee,ae,K),void 0)}$resolveCodeAction(U,Q,ee){return this._withAdapter(U,R,ae=>ae.resolveCodeAction(Q,ee),void 0)}$releaseCodeActions(U,Q){this._withAdapter(U,R,ee=>Promise.resolve(ee.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider(U,Q,ee){const ae=this._addNewAdapter(new T(this._documents,ee),U);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Q),U.identifier,U.displayName||U.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(U,Q,ee,ae){return this._withAdapter(U,T,K=>K.provideDocumentFormattingEdits(d.URI.revive(Q),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider(U,Q,ee){const ae=this._addNewAdapter(new L(this._documents,ee),U);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Q),U.identifier,U.displayName||U.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(U,Q,ee,ae,K){return this._withAdapter(U,L,se=>se.provideDocumentRangeFormattingEdits(d.URI.revive(Q),ee,ae,K),void 0)}registerOnTypeFormattingEditProvider(U,Q,ee,ae){const K=this._addNewAdapter(new b(this._documents,ee),U);return this._proxy.$registerOnTypeFormattingSupport(K,this._transformDocumentSelector(Q),ae,U.identifier),this._createDisposable(K)}$provideOnTypeFormattingEdits(U,Q,ee,ae,K,se){return this._withAdapter(U,b,he=>he.provideOnTypeFormattingEdits(d.URI.revive(Q),ee,ae,K,se),void 0)}registerWorkspaceSymbolProvider(U,Q){const ee=this._addNewAdapter(new x(Q,this._logService),U);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(U,Q,ee){return this._withAdapter(U,x,ae=>ae.provideWorkspaceSymbols(Q,ee),{symbols:[]})}$resolveWorkspaceSymbol(U,Q,ee){return this._withAdapter(U,x,ae=>ae.resolveWorkspaceSymbol(Q,ee),void 0)}$releaseWorkspaceSymbols(U,Q){this._withAdapter(U,x,ee=>ee.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider(U,Q,ee){const ae=this._addNewAdapter(new $(this._documents,ee,this._logService),U);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Q),$.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits(U,Q,ee,ae,K){return this._withAdapter(U,$,se=>se.provideRenameEdits(d.URI.revive(Q),ee,ae,K),void 0)}$resolveRenameLocation(U,Q,ee,ae){return this._withAdapter(U,$,K=>K.resolveRenameLocation(d.URI.revive(Q),ee,ae),void 0)}registerDocumentSemanticTokensProvider(U,Q,ee,ae){const K=this._nextHandle(),se=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(K,new Ke(new G(this._documents,ee),U)),this._proxy.$registerDocumentSemanticTokensProvider(K,this._transformDocumentSelector(Q),ae,se);let he=this._createDisposable(K);if(se){const Ae=ee.onDidChangeSemanticTokens(Ue=>this._proxy.$emitDocumentSemanticTokensEvent(se));he=A.Disposable.from(he,Ae)}return he}$provideDocumentSemanticTokens(U,Q,ee,ae){return this._withAdapter(U,G,K=>K.provideDocumentSemanticTokens(d.URI.revive(Q),ee,ae),null,!0)}$releaseDocumentSemanticTokens(U,Q){this._withAdapter(U,G,ee=>ee.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider(U,Q,ee,ae){const K=this._addNewAdapter(new H(this._documents,ee),U);return this._proxy.$registerDocumentRangeSemanticTokensProvider(K,this._transformDocumentSelector(Q),ae),this._createDisposable(K)}$provideDocumentRangeSemanticTokens(U,Q,ee,ae){return this._withAdapter(U,H,K=>K.provideDocumentRangeSemanticTokens(d.URI.revive(Q),ee,ae),null,!0)}registerCompletionItemProvider(U,Q,ee,ae){const K=this._addNewAdapter(new W(this._documents,this._commands.converter,ee,this._apiDeprecation,U),U);return this._proxy.$registerSuggestSupport(K,this._transformDocumentSelector(Q),ae,W.supportsResolving(ee),`${U.identifier.value}(${ae.join("")})`),this._createDisposable(K)}$provideCompletionItems(U,Q,ee,ae,K){return this._withAdapter(U,W,se=>se.provideCompletionItems(d.URI.revive(Q),ee,ae,K),void 0)}$resolveCompletionItem(U,Q,ee){return this._withAdapter(U,W,ae=>ae.resolveCompletionItem(Q,ee),void 0)}$releaseCompletionItems(U,Q){this._withAdapter(U,W,ee=>ee.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider(U,Q,ee){const ae=this._addNewAdapter(new ne(this._documents,ee,this._commands.converter),U);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideInlineCompletions(U,Q,ee,ae,K){return this._withAdapter(U,ne,se=>se.provideInlineCompletions(d.URI.revive(Q),ee,ae,K),void 0)}$handleInlineCompletionDidShow(U,Q,ee){this._withAdapter(U,ne,async ae=>{ae.handleDidShowCompletionItem(Q,ee)},void 0)}$freeInlineCompletionsList(U,Q){this._withAdapter(U,ne,async ee=>{ee.disposeCompletions(Q)},void 0)}registerSignatureHelpProvider(U,Q,ee,ae){const K=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,se=this._addNewAdapter(new Y(this._documents,ee),U);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(Q),K),this._createDisposable(se)}$provideSignatureHelp(U,Q,ee,ae,K){return this._withAdapter(U,Y,se=>se.provideSignatureHelp(d.URI.revive(Q),ee,ae,K),void 0)}$releaseSignatureHelp(U,Q){this._withAdapter(U,Y,ee=>ee.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider(U,Q,ee){const ae=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,K=this._addNewAdapter(new j(this._documents,ee),U);this._proxy.$registerInlayHintsProvider(K,this._transformDocumentSelector(Q),ae);let se=this._createDisposable(K);if(ae!==void 0){const he=ee.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(ae));se=A.Disposable.from(se,he)}return se}$provideInlayHints(U,Q,ee,ae){return this._withAdapter(U,j,K=>K.provideInlayHints(d.URI.revive(Q),ee,ae),void 0)}registerDocumentLinkProvider(U,Q,ee){const ae=this._addNewAdapter(new le(this._documents,ee),U);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Q),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(U,Q,ee){return this._withAdapter(U,le,ae=>ae.provideLinks(d.URI.revive(Q),ee),void 0)}$resolveDocumentLink(U,Q,ee){return this._withAdapter(U,le,ae=>ae.resolveLink(Q,ee),void 0)}$releaseDocumentLinks(U,Q){this._withAdapter(U,le,ee=>ee.releaseLinks(Q),void 0)}registerColorProvider(U,Q,ee){const ae=this._addNewAdapter(new re(this._documents,ee),U);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentColors(U,Q,ee){return this._withAdapter(U,re,ae=>ae.provideColors(d.URI.revive(Q),ee),[])}$provideColorPresentations(U,Q,ee,ae){return this._withAdapter(U,re,K=>K.provideColorPresentations(d.URI.revive(Q),ee,ae),void 0)}registerFoldingRangeProvider(U,Q,ee){const ae=this._nextHandle(),K=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ke(new ve(this._documents,ee),U)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Q),K);let se=this._createDisposable(ae);if(K!==void 0){const he=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(K));se=A.Disposable.from(se,he)}return se}$provideFoldingRanges(U,Q,ee,ae){return this._withAdapter(U,ve,K=>K.provideFoldingRanges(d.URI.revive(Q),ee,ae),void 0)}registerSelectionRangeProvider(U,Q,ee){const ae=this._addNewAdapter(new Fe(this._documents,ee,this._logService),U);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideSelectionRanges(U,Q,ee,ae){return this._withAdapter(U,Fe,K=>K.provideSelectionRanges(d.URI.revive(Q),ee,ae),[])}registerCallHierarchyProvider(U,Q,ee){const ae=this._addNewAdapter(new Me(this._documents,ee),U);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareCallHierarchy(U,Q,ee,ae){return this._withAdapter(U,Me,K=>Promise.resolve(K.prepareSession(d.URI.revive(Q),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls(U,Q,ee,ae){return this._withAdapter(U,Me,K=>K.provideCallsTo(Q,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls(U,Q,ee,ae){return this._withAdapter(U,Me,K=>K.provideCallsFrom(Q,ee,ae),void 0)}$releaseCallHierarchy(U,Q){this._withAdapter(U,Me,ee=>Promise.resolve(ee.releaseSession(Q)),void 0)}registerTypeHierarchyProvider(U,Q,ee){const ae=this._addNewAdapter(new Oe(this._documents,ee),U);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareTypeHierarchy(U,Q,ee,ae){return this._withAdapter(U,Oe,K=>Promise.resolve(K.prepareSession(d.URI.revive(Q),ee,ae)),void 0)}$provideTypeHierarchySupertypes(U,Q,ee,ae){return this._withAdapter(U,Oe,K=>K.provideSupertypes(Q,ee,ae),void 0)}$provideTypeHierarchySubtypes(U,Q,ee,ae){return this._withAdapter(U,Oe,K=>K.provideSubtypes(Q,ee,ae),void 0)}$releaseTypeHierarchy(U,Q){this._withAdapter(U,Oe,ee=>Promise.resolve(ee.releaseSession(Q)),void 0)}static _serializeRegExp(U){return{pattern:U.source,flags:(0,k.regExpFlags)(U)}}static _serializeIndentationRule(U){return{decreaseIndentPattern:je._serializeRegExp(U.decreaseIndentPattern),increaseIndentPattern:je._serializeRegExp(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?je._serializeRegExp(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?je._serializeRegExp(U.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(U){return{beforeText:je._serializeRegExp(U.beforeText),afterText:U.afterText?je._serializeRegExp(U.afterText):void 0,previousLineText:U.previousLineText?je._serializeRegExp(U.previousLineText):void 0,action:U.action}}static _serializeOnEnterRules(U){return U.map(je._serializeOnEnterRule)}setLanguageConfiguration(U,Q,ee){let{wordPattern:ae}=ee;if(ae&&(0,k.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Q,ae):this._documents.setWordDefinitionFor(Q,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const K=this._nextHandle(),se={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?je._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?je._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?je._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(K,Q,se),this._createDisposable(K)}$setWordDefinitions(U){for(const Q of U)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=je,je._handlePool=0}),define(be[195],Ee([0,1,5,8,7,35,12,6]),function(oe,e,d,M,_,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(t,y,n,m){this._documents=y,this._commands=n,this._uriTransformer=m,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(d.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,y){await this._proxy.$changeLanguage(t,y);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,y){const n=t.version,m=M.Position.from(y),s=await this._proxy.$tokensAtPosition(t.uri,m),u={type:_.StandardTokenType.Other,range:t.getWordRangeAtPosition(y)??new _.Range(y.line,y.character,y.line,y.character)};if(!s)return u;const g={range:M.Range.to(s.range),type:M.TokenType.to(s.type)};return!g.range.contains(y)||n!==t.version?u:g}createLanguageStatusItem(t,y,n){const m=this._handlePool++,s=this._proxy,u=this._ids,g=`${t.identifier.value}/${y}`;if(u.has(g))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);u.add(g);const I={selector:n,id:y,name:t.displayName??t.name,severity:_.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let E,o=new k.DisposableStore;const h=()=>{E?.dispose(),E=(0,F.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(m,{id:g,name:I.name??t.displayName??t.name,source:t.displayName??t.name,selector:M.DocumentSelector.from(I.selector,this._uriTransformer),label:I.text,detail:I.detail??"",severity:I.severity===_.LanguageStatusSeverity.Error?A.default.Error:I.severity===_.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:I.command&&this._commands.toInternal(I.command,o),accessibilityInfo:I.accessibilityInformation})},0)},C={dispose(){o.dispose(),E?.dispose(),s.$removeLanguageStatus(m),u.delete(g)},get id(){return I.id},get name(){return I.name},set name(i){I.name=i,h()},get selector(){return I.selector},set selector(i){I.selector=i,h()},get text(){return I.text},set text(i){I.text=i,h()},get detail(){return I.detail},set detail(i){I.detail=i,h()},get severity(){return I.severity},set severity(i){I.severity=i,h()},get accessibilityInformation(){return I.accessibilityInformation},set accessibilityInformation(i){I.accessibilityInformation=i,h()},get command(){return I.command},set command(i){I.command=i,h()}};return h(),C}}e.ExtHostLanguages=D}),define(be[196],Ee([0,1,5,15,30]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(k){return k&&k.title}let F=class{constructor(D,P){this._logService=P,this._proxy=D.getProxy(d.MainContext.MainThreadMessageService)}showMessage(D,P,t,y,n){const m={extension:D};let s;typeof y=="string"||A(y)?s=[y,...n]:(m.modal=y?.modal,m.useCustom=y?.useCustom,m.detail=y?.detail,s=n),m.useCustom&&(0,_.checkProposedApiEnabled)(D);const u=[];for(let g=0;g<s.length;g++){const I=s[g];if(typeof I=="string")u.push({title:I,handle:g,isCloseAffordance:!1});else if(typeof I=="object"){let{title:E,isCloseAffordance:o}=I;u.push({title:E,isCloseAffordance:!!o,handle:g})}else this._logService.warn("Invalid message item:",I)}return this._proxy.$showMessage(P,t,m,u).then(g=>{if(typeof g=="number")return s[g]})}};F=$e([ze(1,M.ILogService)],F),e.ExtHostMessageService=F}),define(be[197],Ee([0,1,22,3,58,6,20,9,10,2,64,5,8,7,38,172,93]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class I{constructor(o,h,C,i,p){this._textDocumentsAndEditors=C,this._textDocuments=i,this._extensionStoragePaths=p,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=h.converter,h.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===12){const r=a.notebookEditor?.notebookUri,v=a.cell.handle,c=this._documents.get(r)?.getCell(v);if(c)return c.apiCell}return a}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const h=this._editors.get(o);if(!h)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return h}getIdByEditor(o){for(const[h,C]of this._editors)if(C.apiEditor===o)return h}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,h){const C=this._documents.get(o);if(!C&&!h)throw new Error(`NO notebook document for '${o}'`);return C}_getProviderData(o){const h=this._notebookContentProviders.get(o);if(!h)throw new Error(`NO provider for '${o}'`);return h}registerNotebookContentProvider(o,h,C,i,p){if((0,k.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(h))throw new Error(`Notebook provider for '${h}' already registered`);this._notebookContentProviders.set(h,{extension:o,provider:C});let a;return C.onDidChangeNotebookContentOptions&&(a=C.onDidChangeNotebookContentOptions(()=>{const r=n.NotebookDocumentContentOptions.from(C.options);this._notebookProxy.$updateNotebookProviderOptions(h,r)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},h,n.NotebookDocumentContentOptions.from(i),I._convertNotebookRegistrationData(o,p)),new m.Disposable(()=>{a?.dispose(),this._notebookContentProviders.delete(h),this._notebookProxy.$unregisterNotebookProvider(h)})}static _convertNotebookRegistrationData(o,h){if(!h)return;const C=h.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(h.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:h.displayName,filenamePattern:C,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,h,C){const i=I._notebookStatusBarItemProviderHandlePool++,p=typeof C.onDidChangeCellStatusBarItems=="function"?I._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,C),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,p,h);let a;return p!==void 0&&(a=C.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(p))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,p),a&&a.dispose()})}async createNotebookDocument(o){const h=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&n.NotebookData.from(o.content)});return P.URI.revive(h)}async openNotebookDocument(o){const h=this._documents.get(o);if(h)return h.apiNotebook;const C=await this._notebookDocumentsProxy.$tryOpenNotebook(o),i=this._documents.get(P.URI.revive(C));return(0,D.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(o,h){P.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let C;typeof h=="object"?C={position:n.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(n.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:C={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,C),p=i&&this._editors.get(i)?.apiEditor;if(p)return p;throw i?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,h,C,i){const p=this._notebookStatusBarItemProviders.get(o),a=P.URI.revive(h),r=this._documents.get(a);if(!r||!p)return;const v=r.getCellFromIndex(C);if(!v)return;const l=await p.provideCellStatusBarItems(v.apiCell,i);if(!l)return;const c=new A.DisposableStore,w=this._statusBarCache.add([c]),S=(Array.isArray(l)?l:[l]).map(R=>n.NotebookStatusBarItem.from(R,this._commandsConverter,c));return{cacheId:w,items:S}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,h,C,i,p){if((0,k.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,C),this._notebookProxy.$registerNotebookSerializer(a,{id:o.identifier,location:o.extensionLocation},h,n.NotebookDocumentContentOptions.from(i),I._convertNotebookRegistrationData(o,p)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(o,h,C){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const p=await i.deserializeNotebook(h.buffer,C);return new s.SerializableObjectWithBuffers(n.NotebookData.from(p))}async $notebookToData(o,h,C){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const p=await i.serializeNotebook(n.NotebookData.to(h.value),C);return d.VSBuffer.wrap(p)}async $openNotebook(o,h,C,i,p){const{provider:a}=this._getProviderData(o),r=await a.openNotebook(P.URI.revive(h),{backupId:C,untitledDocumentData:i?.buffer},p);return new s.SerializableObjectWithBuffers({metadata:r.metadata??Object.create(null),cells:r.cells.map(n.NotebookCellData.from)})}async $saveNotebook(o,h,C){const i=this.getNotebookDocument(P.URI.revive(h)),{provider:p}=this._getProviderData(o);return await p.saveNotebook(i.apiNotebook,C),!0}async $saveNotebookAs(o,h,C,i){const p=this.getNotebookDocument(P.URI.revive(h)),{provider:a}=this._getProviderData(o);return await a.saveNotebookAs(P.URI.revive(C),p.apiNotebook,i),!0}async $backupNotebook(o,h,C){const i=this.getNotebookDocument(P.URI.revive(h)),p=this._getProviderData(o),a=this._extensionStoragePaths.workspaceValue(p.extension)??this._extensionStoragePaths.globalValue(p.extension),r=String((0,_.hash)([i.uri.toString(),this._backupIdPool++])),v=P.URI.joinPath(a,r),l=await p.provider.backupNotebook(i.apiNotebook,{destination:v},C);return i.updateBackup(l),l.id}_createExtHostEditor(o,h,C){if(this._editors.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const i=new g.ExtHostNotebookEditor(h,this._notebookEditorsProxy,o,C.visibleRanges.map(n.NotebookRange.to),C.selections.map(n.NotebookRange.to),typeof C.viewColumn=="number"?n.ViewColumn.to(C.viewColumn):void 0);this._editors.set(h,i)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const C of o.value.removedDocuments){const i=P.URI.revive(C),p=this._documents.get(i);p&&(p.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(p.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===i.toString()&&this._editors.delete(a.id)}if(o.value.addedDocuments){const C=[];for(const i of o.value.addedDocuments){const p=P.URI.revive(i.uri);if(this._documents.has(p))throw new Error(`adding EXISTING notebook ${p} `);const a=this,r=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(v){a._onDidChangeNotebookCells.fire(v)},emitCellOutputsChange(v){a._onDidChangeCellOutputs.fire(v)},emitCellMetadataChange(v){a._onDidChangeCellMetadata.fire(v)},emitCellExecutionStateChange(v){a._onDidChangeCellExecutionState.fire(v)}},p,i);C.push(...i.cells.map(v=>u.ExtHostCell.asModelAddData(r.apiNotebook,v))),this._documents.get(p)?.dispose(),this._documents.set(p,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(o.value.addedEditors)for(const C of o.value.addedEditors){if(this._editors.has(C.id))return;const i=P.URI.revive(C.documentUri),p=this._documents.get(i);p&&this._createExtHostEditor(p,C.id,C)}const h=[];if(o.value.removedEditors)for(const C of o.value.removedEditors){const i=this._editors.get(C);i&&(this._editors.delete(C),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),h.push(i))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const C=new Set;this._visibleNotebookEditors.forEach(i=>C.add(i.id));for(const i of this._editors.values()){const p=C.has(i.id);i._acceptVisibility(p)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=I,I._notebookStatusBarItemProviderHandlePool=0}),define(be[198],Ee([0,1,3,54,15,5,13,8]),function(oe,e,d,M,_,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(y,n){const m=D._Keys.nextId();y.$registerNotebookEditorDecorationType(m,k.NotebookDecorationRenderOptions.from(n)),this.value={key:m,dispose(){y.$removeNotebookEditorDecorationType(m)}}}}D._Keys=new M.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(y,n,m){this._logService=y,this._extHostRpc=n,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(y){return new D(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),y).value}$acceptEditorPropertiesChanged(y,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,n);const m=this._notebooksAndEditors.getEditorById(y);n.visibleRanges&&m._acceptVisibleRanges(n.visibleRanges.ranges.map(k.NotebookRange.to)),n.selections&&m._acceptSelections(n.selections.selections.map(k.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const n in y)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(k.ViewColumn.to(y[n]))}};P=$e([ze(0,_.ILogService),ze(1,F.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(be[199],Ee([0,1,14,12,21,3,6,20,2,26,15,5,39,8,7,67,165,30,38]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(a,r,v,l,c){this._initData=r,this._extHostNotebook=v,this._commands=l,this._logService=c,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=a.getProxy(y.MainContext.MainThreadNotebookKernels);const w=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",f=>!0,f=>{if(f&&"notebookEditor"in f&&"id"in f){const S=this._extHostNotebook.getIdByEditor(f.notebookEditor);return{id:f.id,extension:f.extension,notebookEditorId:S}}else if(f&&"notebookEditor"in f){const S=this._extHostNotebook.getIdByEditor(f.notebookEditor);if(S===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${f.notebookEditor.document.uri.toString()}`);return{notebookEditorId:S}}return f})],n.ApiCommandResult.Void);this._commands.registerApiCommand(w)}createNotebookController(a,r,v,l,c,w){for(let Y of this._kernelData.values())if(Y.controller.id===r&&P.ExtensionIdentifier.equals(a.identifier,Y.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const f=this._handlePool++,S=this;this._logService.trace(`NotebookController[${f}], CREATED by ${a.identifier.value}, ${r}`);const R=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${a.identifier}'`);let T=!1;const L=new F.DisposableStore,b=new A.Emitter,x=new A.Emitter,$={id:`${a.identifier.value}/${r}`,notebookType:v,extensionId:a.identifier,extensionLocation:a.extensionLocation,label:l||a.identifier.value,preloads:w?w.map(m.NotebookRendererScript.from):[]};let B=c??R,G;this._proxy.$addKernel(f,$).catch(Y=>{console.log(Y),T=!0});let H=0;const W=()=>{if(T)return;const Y=++H;Promise.resolve().then(()=>{Y===H&&this._proxy.$updateKernel(f,$)})},ne=new k.ResourceMap,V={get id(){return r},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:b.event,get label(){return $.label},set label(Y){$.label=Y??a.displayName??a.name,W()},get detail(){return $.detail??""},set detail(Y){$.detail=Y,W()},get description(){return $.description??""},set description(Y){$.description=Y,W()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(Y){$.supportedLanguages=Y,W()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(Y){$.supportsExecutionOrder=Y,W()},get rendererScripts(){return $.preloads?$.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(Y){B=Y??R},get interruptHandler(){return G},set interruptHandler(Y){G=Y,$.supportsInterrupt=Boolean(Y),W()},createNotebookCellExecution(Y){if(T)throw new Error("notebook controller is DISPOSED");if(!ne.has(Y.notebook.uri))throw S._logService.trace(`NotebookController[${f}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${Y.notebook.uri.toString()}`);return S._createNotebookCellExecution(Y)},dispose:()=>{T||(this._logService.trace(`NotebookController[${f}], DISPOSED`),T=!0,this._kernelData.delete(f),L.dispose(),b.dispose(),x.dispose(),this._proxy.$removeKernel(f))},updateNotebookAffinity(Y,j){S._proxy.$updateNotebookPriority(f,Y.uri,j)},onDidReceiveMessage:x.event,postMessage(Y,j){return(0,I.checkProposedApiEnabled)(a),S._proxy.$postMessage(f,j&&S._extHostNotebook.getIdByEditor(j),Y)},asWebviewUri(Y){return(0,I.checkProposedApiEnabled)(a),(0,u.asWebviewUri)(Y,S._initData.remote)}};return this._kernelData.set(f,{extensionId:a.identifier,controller:V,onDidReceiveMessage:x,onDidChangeSelection:b,associatedNotebooks:ne}),V}$acceptNotebookAssociation(a,r,v){const l=this._kernelData.get(a);if(l){const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(r));v?l.associatedNotebooks.set(c.uri,!0):l.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${a}] ASSOCIATE notebook`,c.uri.toString(),v),l.onDidChangeSelection.fire({selected:v,notebook:c.apiNotebook})}}async $executeCells(a,r,v){const l=this._kernelData.get(a);if(!l)return;const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(r)),w=[];for(let f of v){const S=c.getCell(f);S&&w.push(S.apiCell)}try{this._logService.trace(`NotebookController[${a}] EXECUTE cells`,c.uri.toString(),w.length),await l.controller.executeHandler.call(l.controller,w,c.apiNotebook,l.controller)}catch(f){this._logService.error(`NotebookController[${a}] execute cells FAILED`,f),console.error(f)}}async $cancelCells(a,r,v){const l=this._kernelData.get(a);if(!l)return;const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(r));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,c.apiNotebook);else for(let w of v){const f=c.getCell(w);f&&this._activeExecutions.get(f.uri)?.cancel()}}$acceptKernelMessageFromRenderer(a,r,v){const l=this._kernelData.get(a);if(!l)return;const c=this._extHostNotebook.getEditorById(r);l.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:v}))}_createNotebookCellExecution(a){if(a.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this._extHostNotebook.getNotebookDocument(a.notebook.uri).getCellFromApiCell(a);if(!v)throw new Error("invalid cell");if(this._activeExecutions.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const l=new C(v.notebook,v,this._proxy);this._activeExecutions.set(v.uri,l);const c=l.onDidChangeState(()=>{l.state===h.Resolved&&(l.dispose(),c.dispose(),this._activeExecutions.delete(v.uri))});return l.asApiObject()}};o=$e([ze(4,t.ILogService)],o),e.ExtHostNotebookKernels=o;var h;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(h||(h={}));class C extends F.Disposable{constructor(a,r,v){super();this._document=a,this._cell=r,this._proxy=v,this._handle=C.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=h.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._collector=new i(10,l=>this.update(l)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(a){await this._collector.addItem(a)}async update(a){const r=Array.isArray(a)?a:[a];return this._proxy.$updateExecutions(new E.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===h.Init)throw new Error("Must call start before modifying cell output");if(this._state===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(a){let r=this._cell;if(a&&(r=this._document.getCellFromApiCell(a)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(a){return a.map(r=>{const v=s.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return v===r.items?m.NotebookCellOutput.from(r):m.NotebookCellOutput.from({items:v,id:r.id,metadata:r.metadata})})}async updateOutputs(a,r,v){const l=this.cellIndexToHandle(r),c=this.validateAndConvertOutputs((0,d.asArray)(a));return this.updateSoon({editType:g.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:l,append:v,outputs:c})}async updateOutputItems(a,r,v){return a=s.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(a),!0),this.updateSoon({editType:g.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:a.map(m.NotebookCellOutputItem.from),outputId:r.id,append:v})}asApiObject(){const a=this;return Object.freeze({get token(){return a._tokenSource.token},get cell(){return a._cell.apiCell},get executionOrder(){return a._executionOrder},set executionOrder(v){a._executionOrder=v,a.update([{editType:g.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,executionOrder:a._executionOrder}])},start(v){if(a._state===h.Resolved||a._state===h.Started)throw new Error("Cannot call start again");a._state=h.Started,a._onDidChangeState.fire(),a.update({editType:g.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,runStartTime:v})},end(v,l){if(a._state===h.Resolved)throw new Error("Cannot call resolve twice");a._state=h.Resolved,a._onDidChangeState.fire(),a.updateSoon({editType:g.CellExecutionUpdateType.Complete,executionHandle:a._handle,runEndTime:l,lastRunSuccess:v}),a._collector.flush(),a._proxy.$removeExecution(a._handle)},clearOutput(v){return a.verifyStateForOutput(),a.updateOutputs([],v,!1)},appendOutput(v,l){return a.verifyStateForOutput(),a.updateOutputs(v,l,!0)},replaceOutput(v,l){return a.verifyStateForOutput(),a.updateOutputs(v,l,!1)},appendOutputItems(v,l){return a.verifyStateForOutput(),a.updateOutputItems(v,l,!0)},replaceOutputItems(v,l){return a.verifyStateForOutput(),a.updateOutputItems(v,l,!1)}})}}C.HANDLE=0;class i{constructor(a,r){this.delay=a,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(a){return this.batch.push(a),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const a=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>a.complete())}}}),define(be[200],Ee([0,1,3,5,93]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(k,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=k.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(k,D,P){const t=this._extHostNotebook.getEditorById(k);this._rendererMessageEmitters.get(D)?.fire({editor:t.apiEditor,message:P})}createRendererMessaging(k,D){if(!k.contributes?.notebookRenderer?.some(n=>n.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);const P=!!k.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,m,s)=>{const u=P?n:g=>{const I={};t.set(I,g.editor),n({editor:I,message:g.message})};return this.getOrCreateEmitterFor(D).event(u,m,s)},postMessage:(n,m)=>{_.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,m]=[m,n]);const s=P?m:t.get(m),u=s&&_.ExtHostNotebookEditor.apiEditorsToExtHost.get(s);return this.proxy.$postMessage(u?.id,D,n)}}}getOrCreateEmitterFor(k){let D=this._rendererMessageEmitters.get(k);return D||(D=new d.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(k)}}),this._rendererMessageEmitters.set(k,D),D)}}e.ExtHostNotebookRenderers=A}),define(be[96],Ee([0,1,5,3,6,22,4,13]),function(oe,e,d,M,_,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends _.Disposable{constructor(s,u,g,I,E){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=E,this._id=E.$register(this.name,u,g,I),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?A.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(u=>this._proxy.$clear(u,s))}show(s,u){this.validate(),this._id.then(g=>this._proxy.$reveal(g,!!(typeof s=="boolean"?s:u)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class P extends D{constructor(s,u,g){super(s,!1,void 0,u,g)}append(s){super.append(s),this._id.then(u=>this._proxy.$append(u,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class t extends D{constructor(s,u,g){super(s,!0,u,void 0,g)}append(s){throw new Error("Not supported")}}class y{constructor(s,u){this.name=s,this._channel=u}append(s){this._channel.then(u=>u.append(s))}appendLine(s){this._channel.then(u=>u.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,u){this._channel.then(g=>g.show(s,u))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=y;let n=class{constructor(s){this._proxy=s.getProxy(d.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s,u){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new P(s,u.identifier.value,this._proxy)}createOutputChannelFromLogFile(s,u){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!u)throw new Error("illegal argument `file`. must not be falsy");return new t(s,u,this._proxy)}};n=$e([ze(0,k.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(be[201],Ee([0,1,12,21,3,6,5,2,7,16,14,35,47]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(s,u,g){const I=s.getProxy(F.MainContext.MainThreadQuickOpen);class E{constructor(l,c){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=c}showQuickPick(l,c,w,f=M.CancellationToken.None){this._onDidSelectItem=void 0;const S=Promise.resolve(l),R=++this._instances,T=I.$show(R,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},f),L={},b=T.then(()=>L);return Promise.race([b,S]).then(x=>{if(x!==L)return S.then($=>{const B=[];for(let G=0;G<$.length;G++){const H=$[G];let W,ne,V,Y,j;typeof H=="string"?W=H:(W=H.label,ne=H.description,V=H.detail,Y=H.picked,j=H.alwaysShow),B.push({label:W,description:ne,handle:G,detail:V,picked:Y,alwaysShow:j})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=G=>{w.onDidSelectItem($[G])}),I.$setItems(R,B),T.then(G=>{if(typeof G=="number")return $[G];if(Array.isArray(G))return G.map(H=>$[H])})})}).then(void 0,x=>{if(!(0,P.isPromiseCanceledError)(x))return I.$setError(R,x),Promise.reject(x)})}$onItemSelected(l){this._onDidSelectItem&&this._onDidSelectItem(l)}showInput(l,c=M.CancellationToken.None){return this._validateInput=l?l.validateInput:void 0,I.$input(l,typeof this._validateInput=="function",c).then(void 0,w=>{if(!(0,P.isPromiseCanceledError)(w))return Promise.reject(w)})}$validateInput(l){return this._validateInput?(0,d.asPromise)(()=>this._validateInput(l)):Promise.resolve(void 0)}async showWorkspaceFolderPick(l,c=M.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!w)return;const f=await this._workspace.getWorkspaceFolders2();if(!!f)return f.find(S=>S.uri.toString()===w.uri.toString())}createQuickPick(l,c){const w=new a(l,c,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(l){const c=new r(l,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(l,c){const w=this._sessions.get(l);w&&w._fireDidChangeValue(c)}$onDidAccept(l){const c=this._sessions.get(l);c&&c._fireDidAccept()}$onDidChangeActive(l,c){const w=this._sessions.get(l);w instanceof a&&w._fireDidChangeActive(c)}$onDidChangeSelection(l,c){const w=this._sessions.get(l);w instanceof a&&w._fireDidChangeSelection(c)}$onDidTriggerButton(l,c){const w=this._sessions.get(l);w&&w._fireDidTriggerButton(c)}$onDidTriggerItemButton(l,c,w){const f=this._sessions.get(l);f instanceof a&&f._fireDidTriggerItemButton(c,w)}$onDidHide(l){const c=this._sessions.get(l);c&&c._fireDidHide()}}class o{constructor(l,c){this._extensionId=l,this._onDidDispose=c,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new _.Emitter,this._onDidChangeValueEmitter=new _.Emitter,this._onDidTriggerButtonEmitter=new _.Emitter,this._onDidHideEmitter=new _.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((c,w)=>{const f=c===D.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(f,c)}),this.update({buttons:l.map((c,w)=>({...p(c),tooltip:c.tooltip,handle:c===D.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const c=this._handlesToButtons.get(l);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),I.$dispose(this._id))}update(l){if(!this._disposed){for(const c of Object.keys(l)){const w=l[c];this._pendingUpdate[c]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){I.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function h(v){if(v instanceof D.ThemeIcon)return{id:v.id};const l=i(v),c=C(v);return{dark:typeof l=="string"?k.URI.file(l):l,light:typeof c=="string"?k.URI.file(c):c}}function C(v){return typeof v=="object"&&"light"in v?v.light:v}function i(v){return typeof v=="object"&&"dark"in v?v.dark:v}function p(v){const l=h(v.iconPath);let c,w;return"id"in l?w=n.ThemeIcon.asClassName(l):c=l,{iconPath:c,iconClass:w}}class a extends o{constructor(l,c,w){super(l,w);this.enableProposedApi=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new _.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new _.Emitter,this._onDidTriggerItemButtonEmitter=new _.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((c,w)=>{this._handlesToItems.set(w,c),this._itemsToHandles.set(c,w)}),this.update({items:l.map((c,w)=>({label:c.label,description:c.description,handle:w,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow,buttons:c.buttons&&this.enableProposedApi?c.buttons.map((f,S)=>({...p(f),tooltip:f.tooltip,handle:S})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(l){const c=(0,t.coalesce)(l.map(w=>this._handlesToItems.get(w)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(l){const c=(0,t.coalesce)(l.map(w=>this._handlesToItems.get(w)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}_fireDidTriggerItemButton(l,c){const w=this._handlesToItems.get(l);if(!w||!w.buttons||!w.buttons.length)return;const f=w.buttons[c];f&&this._onDidTriggerItemButtonEmitter.fire({button:f,item:w})}}class r extends o{constructor(l,c){super(l,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,this.update({validationMessage:l,severity:l?y.default.Error:y.default.Ignore})}}return new E(u,g)}e.createExtHostQuickOpen=m}),define(be[202],Ee([0,1,2,3,53,6,12,5,14,108,15,26,30,47,8]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(l){if(l)return typeof l.iconPath=="string"?d.URI.file(l.iconPath):d.URI.isUri(l.iconPath)||m.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function g(l,c){if(!l.iconPath&&!c.iconPath)return 0;if(l.iconPath){if(!c.iconPath)return 1}else return-1;const w=typeof l.iconPath=="string"?l.iconPath:d.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,f=typeof c.iconPath=="string"?c.iconPath:d.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,P.comparePaths)(w,f)}function I(l,c){let w=0;if(l.strikeThrough!==c.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==c.faded)return l.faded?1:-1;if(l.tooltip!==c.tooltip)return(l.tooltip||"").localeCompare(c.tooltip||"");if(w=g(l,c),w!==0)return w;if(l.light&&c.light)w=g(l.light,c.light);else{if(l.light)return 1;if(c.light)return-1}if(w!==0)return w;if(l.dark&&c.dark)w=g(l.dark,c.dark);else{if(l.dark)return 1;if(c.dark)return-1}return w}function E(l,c){if(l.command!==c.command)return l.command<c.command?-1:1;if(l.title!==c.title)return l.title<c.title?-1:1;if(l.tooltip!==c.tooltip){if(l.tooltip!==void 0&&c.tooltip!==void 0)return l.tooltip<c.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(l.arguments===c.arguments)return 0;if(l.arguments)if(c.arguments){if(l.arguments.length!==c.arguments.length)return l.arguments.length-c.arguments.length}else return 1;else return-1;for(let w=0;w<l.arguments.length;w++){const f=l.arguments[w],S=c.arguments[w];if(f!==S)return f<S?-1:1}return 0}function o(l,c){let w=(0,P.comparePaths)(l.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(w!==0)return w;if(l.command&&c.command)w=E(l.command,c.command);else{if(l.command)return 1;if(c.command)return-1}if(w!==0)return w;if(l.decorations&&c.decorations)w=I(l.decorations,c.decorations);else{if(l.decorations)return 1;if(c.decorations)return-1}return w}function h(l,c){for(let w=0;w<l.length;w++)if(l[w]!==c[w])return!1;return!0}function C(l,c){return l.command===c.command&&l.title===c.title&&l.tooltip===c.tooltip&&(l.arguments&&c.arguments?h(l.arguments,c.arguments):l.arguments===c.arguments)}function i(l,c){return(0,D.equals)(l,c,C)}class p{constructor(c,w,f){this._extension=c,this._proxy=w,this._sourceControlHandle=f,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(c){if((0,n.checkProposedApiEnabled)(this._extension),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(c,w){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,c,w)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=p;class a{constructor(c,w,f,S,R){this._proxy=c,this._commands=w,this._sourceControlHandle=f,this._id=S,this._label=R,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=a._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,w){const f=this._resourceStatesCommandsMap.get(c);return f?(0,F.asPromise)(()=>this._commands.executeCommand(f.command,...f.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this._resourceStates].sort(o),f=(0,D.sortedDiff)(this._resourceSnapshot,c,o).map(T=>{const L=T.toInsert.map(b=>{const x=this._resourceHandlePool++;this._resourceStatesMap.set(x,b);const $=b.resourceUri;let B;if(b.command)if(b.command.command==="vscode.open"||b.command.command==="vscode.diff"){const ve=new A.DisposableStore;B=this._commands.converter.toInternal(b.command,ve),this._resourceStatesDisposablesMap.set(x,ve)}else this._resourceStatesCommandsMap.set(x,b.command);const G=u(b.decorations),H=b.decorations&&u(b.decorations.light)||G,W=b.decorations&&u(b.decorations.dark)||G,ne=[H,W],V=b.decorations&&b.decorations.tooltip||"",Y=b.decorations&&!!b.decorations.strikeThrough,j=b.decorations&&!!b.decorations.faded,le=b.contextValue||"";return{rawResource:[x,$,ne,V,Y,j,le,B],handle:x}});return{start:T.start,deleteCount:T.deleteCount,toInsert:L}}),S=f.map(({start:T,deleteCount:L,toInsert:b})=>[T,L,b.map(x=>x.rawResource)]),R=f.reverse();for(const{start:T,deleteCount:L,toInsert:b}of R){const x=b.map(B=>B.handle),$=this._handlesSnapshot.splice(T,L,...x);for(const B of $)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=c,S}dispose(){this._disposed=!0,this._onDidDispose.fire()}}a._handlePool=0;class r{constructor(c,w,f,S,R,T){this._extension=c,this._proxy=w,this._commands=f,this._id=S,this._label=R,this._rootUri=T,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new p(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,S,R,T)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=c;const w=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,n.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(c){(0,n.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=c;const w=c!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&i(this._statusBarCommands,c))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=c;const w=(c||[]).map(f=>this._commands.converter.toInternal(f,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(c,w){const f=new a(this._proxy,this._commands,this.handle,c,w),S=M.Event.once(f.onDidDispose)(()=>this.createdResourceGroups.delete(f));return this.createdResourceGroups.set(f,S),this.eventuallyAddResourceGroups(),f}eventuallyAddResourceGroups(){const c=[],w=[];for(const[f,S]of this.createdResourceGroups){S.dispose();const R=f.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(f),this.eventuallyUpdateResourceStates()});M.Event.once(f.onDidDispose)(()=>{this.updatedResourceGroups.delete(f),R.dispose(),this._groups.delete(f.handle),this._proxy.$unregisterGroup(this.handle,f.handle)}),c.push([f.handle,f.id,f.label,f.features]);const T=f._takeResourceStateSnapshot();T.length>0&&w.push([f.handle,T]),this._groups.set(f.handle,f)}this._proxy.$registerGroups(this.handle,c,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(w=>{const f=w._takeResourceStateSnapshot();f.length!==0&&c.push([w.handle,f])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,$e([(0,_.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),$e([(0,_.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let v=class Ui{constructor(c,w,f){this._commands=w,this.logService=f,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=c.getProxy(k.MainContext.MainThreadSCM),this._telemetry=c.getProxy(k.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===3){const R=this._sourceControls.get(S.sourceControlHandle);if(!R)return S;const T=R.getResourceGroup(S.groupHandle);return T?T.getResourceState(S.handle):S}else if(S&&S.$mid===4){const R=this._sourceControls.get(S.sourceControlHandle);return R?R.getResourceGroup(S.groupHandle):S}else if(S&&S.$mid===5){const R=this._sourceControls.get(S.handle);return R||S}return S}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,w,f,S){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,w,f,S),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const R=Ui._handlePool++,T=new r(c,this._proxy,this._commands,w,f,S);this._sourceControls.set(R,T);const L=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(c.identifier))||[];return L.push(T),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(c.identifier),L),T}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const w=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(c.identifier)),f=w&&w[w.length-1];return f&&f.inputBox}$provideOriginalResource(c,w,f){const S=d.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,S.toString());const R=this._sourceControls.get(c);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>R.quickDiffProvider.provideOriginalResource(S,f)).then(T=>T||null)}$onInputBoxValueChange(c,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const f=this._sourceControls.get(c);return f&&f.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(c,w,f,S){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,w,f);const R=this._sourceControls.get(c);if(!R)return Promise.resolve(void 0);const T=R.getResourceGroup(w);return T?T.$executeResourceCommand(f,S):Promise.resolve(void 0)}$validateInput(c,w,f){this.logService.trace("ExtHostSCM#$validateInput",c);const S=this._sourceControls.get(c);return!S||!S.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>S.inputBox.validateInput(w,f)).then(R=>{if(!R)return Promise.resolve(void 0);const T=s.MarkdownString.fromStrict(R.message);return T?Promise.resolve([T,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this._sourceControls.get(c)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};v._handlePool=0,v=$e([ze(2,t.ILogService)],v),e.ExtHostSCM=v});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[203],Ee([0,1,7,5,127,6,8,10]),function(oe,e,d,M,_,A,F,k){"use strict";var D,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class t{constructor(s,u,g,I,E=d.StatusBarAlignment.Left,o){D.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Ze(this,D,s,"f"),Ze(this,P,u,"f"),this._entryId=t.ID_GEN++,this._extension=g,this._id=I,this._alignment=E,this._priority=this.validatePriority(o)}validatePriority(s){if(!!(0,k.isNumber)(s))return s===Number.POSITIVE_INFINITY?Number.MAX_VALUE:s===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:s}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(s){this._text=s,this.update()}set name(s){this._name=s,this.update()}set tooltip(s){this._tooltip=s,this.update()}set color(s){this._color=s,this.update()}set backgroundColor(s){s&&!t.ALLOWED_BACKGROUND_COLORS.has(s.id)&&(s=void 0),this._backgroundColor=s,this.update()}set command(s){this._command?.fromApi!==s&&(this._internalCommandRegistration.clear(),typeof s=="string"?this._command={fromApi:s,internal:Re(this,P,"f").toInternal({title:"",command:s},this._internalCommandRegistration)}:s?this._command={fromApi:s,internal:Re(this,P,"f").toInternal(s,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(s){this._accessibilityInformation=s,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Re(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let s;this._extension?this._id?s=`${this._extension.identifier.value}.${this._id}`:s=this._extension.identifier.value:s=this._id;let u;this._name?u=this._name:u=(0,_.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=t.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const I=this._tooltip?F.MarkdownString.fromStrict(this._tooltip):void 0;Re(this,D,"f").$setEntry(this._entryId,s,u,this._text,I,this._command?.internal,g,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=t,D=new WeakMap,P=new WeakMap,t.ID_GEN=0,t.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class y{constructor(s){this._messages=[],this._item=s.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,_.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(s){const u={message:s};return this._messages.unshift(u),this._update(),new d.Disposable(()=>{const g=this._messages.indexOf(u);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(s,u){this._proxy=s.getProxy(M.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new y(this)}createStatusBarEntry(s,u,g,I){return new t(this._proxy,this._commands,s,u,g,I)}setStatusBarMessage(s,u){const g=this._statusMessage.setMessage(s);let I;return typeof u=="number"?I=setTimeout(()=>g.dispose(),u):typeof u!="undefined"&&u.then(()=>g.dispose(),()=>g.dispose()),new d.Disposable(()=>{g.dispose(),clearTimeout(I)})}}e.ExtHostStatusBar=n}),define(be[73],Ee([0,1,5,3,4]),function(oe,e,d,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(k){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,D){this._proxy.$registerExtensionStorageKeysToSync(k,D)}getValue(k,D,P){return this._proxy.$getValue(k,D).then(t=>t||P)}setValue(k,D,P){return this._proxy.$setValue(k,D,P)}$acceptValue(k,D,P){this._onDidChangeStorage.fire({shared:k,key:D,value:P})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,_.createDecorator)("IExtHostStorage")}),define(be[74],Ee([0,1,4,29,15,72,2]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let k=class{constructor(P,t,y){this._logService=t,this._extHostFileSystem=y,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(P){return F.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,t=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(F.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:F.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(P){if(this._value)return F.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return F.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=$e([ze(0,M.IExtHostInitDataService),ze(1,_.ILogService),ze(2,A.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(be[40],Ee([0,1,3,5,4,2,13,6,7,128,16,167,21,36,150,47,10,12]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,_.createDecorator)("IExtHostTerminalService");class E{constructor(l,c,w,f){this._proxy=l,this._id=c,this._creationOptions=w,this._name=f,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const S=this;this.value={get name(){return S._name||""},get processId(){return S._pidPromise},get creationOptions(){return S._creationOptions},get exitStatus(){return S._exitStatus},get state(){return S._state},sendText(R,T=!0){S._checkDisposed(),S._proxy.$sendText(S._id,R,T)},show(R){S._checkDisposed(),S._proxy.$show(S._id,R)},hide(){S._checkDisposed(),S._proxy.$hide(S._id)},dispose(){S._disposed||(S._disposed=!0,S._proxy.$dispose(S._id))},get dimensions(){if(!(S._cols===void 0||S._rows===void 0))return{columns:S._cols,rows:S._rows}}}}async create(l,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:(0,g.withNullAsUndefined)(l.shellPath),shellArgs:(0,g.withNullAsUndefined)(l.shellArgs),cwd:(0,g.withNullAsUndefined)(l.cwd),env:(0,g.withNullAsUndefined)(l.env),icon:(0,g.withNullAsUndefined)(a(l.iconPath)),color:u.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,g.withNullAsUndefined)(l.message),strictEnv:(0,g.withNullAsUndefined)(l.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(l.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(l.location,c?.resolvedExtHostIdentifier)})}async createExtensionTerminal(l,c,w,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:w,color:u.ThemeColor.isThemeColor(f)?f.id:void 0,location:this._serializeParentTerminal(l,c)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,c){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in l?{viewColumn:l.viewColumn,preserveFocus:l.preserveFocus}:void 0:l}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitCode(l){this._exitStatus=Object.freeze({code:l})}setDimensions(l,c){return l===this._cols&&c===this._rows||l===0||c===0?!1:(this._cols=l,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=E;class o{constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new d.Emitter,this._onProcessTitleChanged=new d.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new d.Emitter,this._onProcessShellTypeChanged=new d.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new d.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(l){return Promise.resolve("")}async updateProperty(l,c){Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput&&this._pty.handleInput(l)}resize(l,c){this._pty.setDimensions&&this._pty.setDimensions({columns:l,rows:c})}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(l){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose&&this._pty.onDidClose((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(c=>this._onProcessOverrideDimensions.fire(c&&{cols:c.columns,rows:c.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(c=>this._onProcessTitleChanged.fire(c)),this._pty.open(l||void 0),this._pty.setDimensions&&l&&this._pty.setDimensions(l),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=o;let h=1,C=class extends k.Disposable{constructor(l,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(l),this._register({dispose:()=>{for(const[w,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,c){const w=new E(this._proxy,(0,m.generateUuid)(),l,l.name),f=new o(l.pty);return w.createExtensionTerminal(l.location,this._serializeParentTerminal(l,c).resolvedExtHostIdentifier,a(l.iconPath),r(l.color)).then(S=>{const R=this._setupExtHostProcessListeners(S,f);this._terminalProcessDisposables[S]=R}),this._terminals.push(w),w.value}_serializeParentTerminal(l,c){if(c=c||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const w=l.location.parentTerminal;if(w){const f=this._terminals.find(S=>S.value===w);f&&(c.resolvedExtHostIdentifier=f._id)}}else l.location&&typeof l.location!="object"?c.location=l.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(l,c){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const f=new o(c),S=this._setupExtHostProcessListeners(l,f);this._terminalProcessDisposables[l]=S}async $acceptActiveTerminalChanged(l){const c=this._activeTerminal;if(l===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const w=this._getTerminalById(l);w&&(this._activeTerminal=w,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,c){const w=this._getTerminalById(l);w&&this._onDidWriteTerminalData.fire({terminal:w.value,data:c})}async $acceptTerminalDimensions(l,c,w){const f=this._getTerminalById(l);f&&f.setDimensions(c,w)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(l,c,w){this._terminalProcesses.get(l)?.resize(c,w)}async $acceptTerminalTitleChange(l,c){const w=this._getTerminalById(l);w&&(w.name=c)}async $acceptTerminalClosed(l,c){const w=this._getTerminalObjectIndexById(this._terminals,l);if(w!==null){const f=this._terminals.splice(w,1)[0];f.setExitCode(c),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(l,c,w,f){if(c){const T=this._getTerminalObjectIndexById(this._terminals,c);if(T!==null){this._terminals[T]._id=l,this._onDidOpenTerminal.fire(this.terminals[T]),this._terminals[T].isOpen=!0;return}}const S={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:A.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},R=new E(this._proxy,l,S,w);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(l,c){const w=this._getTerminalById(l);w&&w._setProcessId(c)}async $startExtensionTerminal(l,c){const w=this._getTerminalById(l);if(!w)return{message:(0,P.localize)(0,null,l)};w.isOpen||await new Promise(S=>{const R=this.onDidOpenTerminal(async T=>{T===w.value&&(R.dispose(),S())})});const f=this._terminalProcesses.get(l);f?f.startSendingEvents(c):this._extensionTerminalAwaitingStart[l]={initialDimensions:c}}_setupExtHostProcessListeners(l,c){const w=new k.DisposableStore;w.add(c.onProcessReady(S=>this._proxy.$sendProcessReady(l,S.pid,S.cwd))),w.add(c.onProcessTitleChanged(S=>this._proxy.$sendProcessTitle(l,S))),this._bufferer.startBuffering(l,c.onProcessData),w.add(c.onProcessExit(S=>this._onProcessExit(l,S))),c.onProcessOverrideDimensions&&w.add(c.onProcessOverrideDimensions(S=>this._proxy.$sendOverrideDimensions(l,S))),this._terminalProcesses.set(l,c);const f=this._extensionTerminalAwaitingStart[l];return f&&c instanceof o&&(c.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),w}$acceptProcessAckDataEvent(l,c){this._terminalProcesses.get(l)?.acknowledgeDataEvent(c)}$acceptProcessInput(l,c){this._terminalProcesses.get(l)?.input(c)}$acceptTerminalInteraction(l){const c=this._getTerminalById(l);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(l,c,w){try{this._terminalProcesses.get(l)?.resize(c,w)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(l,c){this._terminalProcesses.get(l)?.shutdown(c)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(c=>this._proxy.$sendProcessInitialCwd(l,c))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(c=>this._proxy.$sendProcessCwd(l,c))}$acceptProcessRequestLatency(l){return l}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,c,w){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,w),this._proxy.$registerProfileProvider(c,l.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(l,c){const w=new n.CancellationTokenSource().token,f=await this._profileProviders.get(l)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,c);return}this.createTerminalFromOptions(f.options,c)}}async $provideLinks(l,c){const w=this._getTerminalById(l);if(!w)return[];this._terminalLinkCache.delete(l);const f=this._terminalLinkCancellationSource.get(l);f&&f.dispose(!0);const S=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,S);const R=[],T={terminal:w.value,line:c},L=[];for(const $ of this._linkProviders)L.push(I.Promises.withAsyncBody(async B=>{S.token.onCancellationRequested(()=>B({provider:$,links:[]}));const G=await $.provideTerminalLinks(T,S.token)||[];S.token.isCancellationRequested||B({provider:$,links:G})}));const b=await Promise.all(L);if(S.token.isCancellationRequested)return[];const x=new Map;for(const $ of b)$&&$.links.length>0&&R.push(...$.links.map(B=>{const G={id:h++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return x.set(G.id,{provider:$.provider,link:B}),G}));return this._terminalLinkCache.set(l,x),R}$activateLink(l,c){const w=this._terminalLinkCache.get(l)?.get(c);!w||w.provider.handleTerminalLink(w.link)}_onProcessExit(l,c){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const w=this._terminalProcessDisposables[l];w&&(w.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,c)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,c){const w=this._getTerminalObjectIndexById(l,c);return w!==null?l[w]:null}_getTerminalObjectIndexById(l,c){let w=null;return l.some((f,S)=>f._id===c?(w=S,!0):!1),w}getEnvironmentVariableCollection(l){let c=this._environmentVariableCollections.get(l.identifier.value);return c||(c=new i,this._setEnvironmentVariableCollection(l.identifier.value,c)),c}_syncEnvironmentVariableCollection(l,c){const w=(0,y.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(l,c.persistent,w.length===0?void 0:w)}$initEnvironmentVariableCollections(l){l.forEach(c=>{const w=c[0],f=new i(c[1]);this._setEnvironmentVariableCollection(w,f)})}$acceptDefaultProfile(l,c){this._defaultProfile=l,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(l,c){this._environmentVariableCollections.set(l,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,c)})}};C=$e([ze(1,F.IExtHostRpcService)],C),e.BaseExtHostTerminalService=C;class i{constructor(l){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(l)}get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(l,c){this._setIfDiffers(l,{value:c,type:D.EnvironmentVariableMutatorType.Replace})}append(l,c){this._setIfDiffers(l,{value:c,type:D.EnvironmentVariableMutatorType.Append})}prepend(l,c){this._setIfDiffers(l,{value:c,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(l,c){const w=this.map.get(l);(!w||w.value!==c.value||w.type!==c.type)&&(this.map.set(l,c),this._onDidChangeCollection.fire())}get(l){return this.map.get(l)}forEach(l,c){this.map.forEach((w,f)=>l.call(c,f,w,this))}delete(l){this.map.delete(l),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=i;let p=class extends C{constructor(l){super(!1,l)}createTerminal(l,c,w){throw new t.NotSupportedError}createTerminalFromOptions(l,c){throw new t.NotSupportedError}};p=$e([ze(0,F.IExtHostRpcService)],p),e.WorkerExtHostTerminalService=p;function a(v){if(!(!v||typeof v=="string"))return"id"in v?{id:v.id,color:v.color}:v}function r(v){return u.ThemeColor.isThemeColor(v)?v:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[204],Ee([0,1,14,22,21,3,235,58,6,23,10,36,5,13,49,8,7,175,90,68]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g,I,E,o){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let C=class{constructor(T,L){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=T.getProxy(n.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new p(this.proxy),L.registerArgumentProcessor({processArgument:b=>b?.$mid===13?u.TestItem.toItemFromContext(b):b})}createTestController(T,L){if(this.controllers.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const b=new D.DisposableStore,x=b.add(new I.SingleUseTestCollection(T));x.root.label=L;const $=new Map,B=this.proxy,G={items:x.root.children,get label(){return L},set label(W){L=W,x.root.label=W,B.$updateControllerLabel(T,L)},get id(){return T},createRunProfile:(W,ne,V,Y,j)=>{let le=(0,k.hash)(W);for(;$.has(le);)le++;const re=new f(this.proxy,T,le,W,ne,V,Y,j);return $.set(le,re),re},createTestItem(W,ne,V){return new s.TestItemImpl(T,W,ne,V)},createTestRun:(W,ne,V=!0)=>this.runTracker.createTestRun(T,x,W,ne,V),set resolveHandler(W){x.resolveHandler=W},get resolveHandler(){return x.resolveHandler},dispose:()=>{b.dispose()}};G.createRunConfiguration=G.createRunProfile,B.$registerTestController(T,L),b.add((0,D.toDisposable)(()=>B.$unregisterTestController(T)));const H={controller:G,collection:x,profiles:$};return this.controllers.set(T,H),b.add((0,D.toDisposable)(()=>this.controllers.delete(T))),b.add(x.onDidGenerateDiff(W=>B.$publishDiff(T,W))),G}createTestObserver(){return this.observer.checkout()}async runTests(T,L=_.CancellationToken.None){const b=a(T);if(!b)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const x=this.controllers.get(b.controllerId);if(!x)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:T.include?.map($=>$.id)??[x.collection.root.id],profileGroup:S[b.kind],profileId:b.profileId,controllerId:b.controllerId}],exclude:T.exclude?.map($=>$.id)},L)}$provideFileCoverage(T,L,b){return(0,d.mapFind)(this.runTracker.trackers,$=>$.id===T?$.getCoverage(L):void 0)?.provideFileCoverage(b)??Promise.resolve([])}$resolveFileCoverage(T,L,b,x){return(0,d.mapFind)(this.runTracker.trackers,B=>B.id===T?B.getCoverage(L):void 0)?.resolveFileCoverage(b,x)??Promise.resolve([])}$configureRunProfile(T,L){this.controllers.get(T)?.profiles.get(L)?.configureHandler?.()}$publishTestResults(T){this.results=Object.freeze(T.map(L=>(0,P.deepFreeze)(u.TestResults.to(L))).concat(this.results).sort((L,b)=>b.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(T,L){const b=this.controllers.get(o.TestId.fromString(T).controllerId)?.collection;b&&(await b.expand(T,L<0?Infinity:L),b.flushDiff())}$acceptDiff(T){this.observer.applyDiff(T)}async $runControllerTests(T,L){const b=this.controllers.get(T.controllerId);if(!b)return;const{collection:x,profiles:$}=b,B=$.get(T.profileId);if(!B)return;const G=T.testIds.map(V=>x.tree.get(V)).filter(t.isDefined),H=T.excludeExtIds.map(V=>b.collection.tree.get(V)).filter(t.isDefined).filter(V=>G.some(Y=>Y.fullId.compare(V.fullId)===2));if(!G.length)return;const W=new g.TestRunRequest(G.some(V=>V.actual instanceof s.TestItemRootImpl)?void 0:G.map(V=>V.actual),H.map(V=>V.actual),B),ne=this.runTracker.prepareForMainThreadTestRun(W,r.fromInternal(T,b.collection),L);try{await B.runHandler(W,L)}finally{ne.isRunning&&!L.isCancellationRequested&&await A.Event.toPromise(ne.onEnd),ne.dispose()}}$cancelExtensionTestRun(T){T===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(T)}};C=$e([ze(0,m.IExtHostRpcService)],C),e.ExtHostTesting=C;class i extends D.Disposable{constructor(T,L,b){super();this.dto=T,this.proxy=L,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new _.CancellationTokenSource(b)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:x}of this.tasks.values())x.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(T){return this.tasks.get(T)?.coverage}createRun(T){const L=this.dto.id,b=this.dto.controllerId,x=(0,y.generateUuid)(),$=new v(this.proxy,L,x),B=ne=>(V,...Y)=>{if(H){console.warn(`Setting the state of test "${V.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(V)||(this.ensureTestIsKnown(V),ne(V,...Y))},G=(ne,V)=>{const Y=V instanceof Array?V.map(u.TestMessage.from):[u.TestMessage.from(V)];if(ne.uri&&ne.range){const j={range:u.Range.from(ne.range),uri:ne.uri};for(const le of Y)le.location=le.location||j}this.proxy.$appendTestMessagesInRun(L,x,o.TestId.fromExtHostTestItem(ne,b).toString(),Y)};let H=!1;const W={isPersisted:this.dto.isPersisted,token:this.cts.token,name:T,get coverageProvider(){return $.coverageProvider},set coverageProvider(ne){$.coverageProvider=ne},enqueued:B(ne=>{this.proxy.$updateTestStateInRun(L,x,o.TestId.fromExtHostTestItem(ne,b).toString(),1)}),skipped:B(ne=>{this.proxy.$updateTestStateInRun(L,x,o.TestId.fromExtHostTestItem(ne,b).toString(),5)}),started:B(ne=>{this.proxy.$updateTestStateInRun(L,x,o.TestId.fromExtHostTestItem(ne,b).toString(),2)}),errored:B((ne,V,Y)=>{G(ne,V),this.proxy.$updateTestStateInRun(L,x,o.TestId.fromExtHostTestItem(ne,b).toString(),6,Y)}),failed:B((ne,V,Y)=>{G(ne,V),this.proxy.$updateTestStateInRun(L,x,o.TestId.fromExtHostTestItem(ne,b).toString(),4,Y)}),passed:B((ne,V)=>{this.proxy.$updateTestStateInRun(L,x,o.TestId.fromExtHostTestItem(ne,this.dto.controllerId).toString(),3,V)}),appendOutput:(ne,V,Y)=>{H||(Y&&(this.dto.isIncluded(Y)?this.ensureTestIsKnown(Y):Y=void 0),this.proxy.$appendOutputToRun(L,x,M.VSBuffer.fromString(ne),V&&u.location.from(V),Y&&o.TestId.fromExtHostTestItem(Y,b).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(L,x),this.tasks.delete(x),this.isRunning||this.dispose())}};return this.tasks.set(x,{run:W,coverage:$}),this.proxy.$startedTestRunTask(L,{id:x,name:T,running:!0}),W}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(T){if(!(T instanceof s.TestItemImpl))throw new s.InvalidTestItemError(T.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(T,this.dto.controllerId).toString()))return;const L=[],b=this.dto.colllection.root;for(;;){const x=u.TestItem.from(T);if(L.unshift(x),this.sharedTestIds.has(x.extId)||(this.sharedTestIds.add(x.extId),T===b))break;T=T.parent||b}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,L)}}class p{constructor(T){this.proxy=T,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(T,L,b){return this.getTracker(T,L,b)}cancelRunById(T){for(const L of this.tracked.values())if(L.id===T){L.dispose();return}}cancelAllRuns(){for(const T of this.tracked.values())T.dispose()}createTestRun(T,L,b,x,$){const B=this.tracked.get(b);if(B)return B.createRun(x);const G=r.fromPublic(T,L,b,$),H=a(b);this.proxy.$startedExtensionTestRun({controllerId:T,profile:H&&{group:S[H.kind],id:H.profileId},exclude:b.exclude?.map(ne=>ne.id)??[],id:G.id,include:b.include?.map(ne=>ne.id)??[L.root.id],persist:$});const W=this.getTracker(b,G);return W.onEnd(()=>this.proxy.$finishedExtensionTestRun(G.id)),W.createRun(x)}getTracker(T,L,b){const x=new i(L,this.proxy,b);return this.tracked.set(T,x),x.onEnd(()=>this.tracked.delete(T)),x}}e.TestRunCoordinator=p;const a=R=>{if(!!R.profile){if(!(R.profile instanceof f))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class r{constructor(T,L,b,x,$,B){this.controllerId=T,this.id=L,this.isPersisted=$,this.colllection=B,this.includePrefix=b.map(G=>G+"\0"),this.excludePrefix=x.map(G=>G+"\0")}static fromPublic(T,L,b,x){return new r(T,(0,y.generateUuid)(),b.include?.map($=>o.TestId.fromExtHostTestItem($,T).toString())??[T],b.exclude?.map($=>o.TestId.fromExtHostTestItem($,T).toString())??[],x,L)}static fromInternal(T,L){return new r(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,L)}isIncluded(T){const L=o.TestId.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const b of this.excludePrefix)if(L===b||L.startsWith(b))return!1;for(const b of this.includePrefix)if(L===b||L.startsWith(b))return!0;return!1}}e.TestRunDto=r;class v{constructor(T,L,b){this.proxy=T,this.runId=L,this.taskId=b}set coverageProvider(T){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!T||(this._coverageProvider=T,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(T){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(T))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(L){throw this.fileCoverage=void 0,L}}async resolveFileCoverage(T,L){const b=await this.fileCoverage;let x=b?.[T];return!this._coverageProvider||!b||!x?[]:(x.detailedCoverage||(x=b[T]=await this._coverageProvider.resolveFileCoverage?.(x,L)??x),x.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class l extends E.IncrementalChangeCollector{constructor(T){super();this.emitter=T,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(T){this.added.add(T)}update(T){Object.assign(T.revived,u.TestItem.toPlain(T.item)),this.added.has(T)||this.updated.add(T)}remove(T){if(this.added.has(T)){this.added.delete(T);return}if(this.updated.delete(T),T.parent&&this.alreadyRemoved.has(T.parent)){this.alreadyRemoved.add(T.item.extId);return}this.removed.add(T)}getChangeEvent(){const{added:T,updated:L,removed:b}=this;return{get added(){return[...T].map(x=>x.revived)},get updated(){return[...L].map(x=>x.revived)},get removed(){return[...b].map(x=>x.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(T){return this.items.get(T)}getMirroredTestDataByReference(T){return this.items.get(T.id)}createItem(T,L){return{...T,revived:u.TestItem.toPlain(T.item),depth:L?L.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=c;class w{constructor(T){this.proxy=T}checkout(){this.current||(this.current=this.createObserverData());const T=this.current;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(L=>L.revived)},dispose:(0,F.once)(()=>{--T.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(T){return this.current?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.current?.tests.apply(T)}createObserverData(){const T=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:T}}}class f{constructor(T,L,b,x,$,B,G=!1,H=void 0){this.controllerId=L,this.profileId=b,this._label=x,this.kind=$,this.runHandler=B,this._isDefault=G,this._tag=H,h.set(this,void 0),Ze(this,h,T,"f");const W=S[$];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${$}`);Re(this,h,"f").$publishTestRunProfile({profileId:b,controllerId:L,tag:H?u.TestTag.namespace(this.controllerId,H.id):null,label:x,group:W,isDefault:G,hasConfigurationHandler:!1})}get label(){return this._label}set label(T){T!==this._label&&(this._label=T,Re(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:T}))}get isDefault(){return this._isDefault}set isDefault(T){T!==this._isDefault&&(this._isDefault=T,Re(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,Re(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:T?u.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(T){T!==this._configureHandler&&(this._configureHandler=T,Re(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!T}))}dispose(){Re(this,h,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=f,h=new WeakMap;const S={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(be[205],Ee([0,1,3,14,5,94,8,7]),function(oe,e,d,M,_,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(t,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(_.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const y=this._extHostDocumentsAndEditors.allEditors();return t?y:y.map(n=>n.value)}async showTextDocument(t,y,n){let m;typeof y=="number"?m={position:F.ViewColumn.from(y),preserveFocus:n}:typeof y=="object"?m={position:F.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?F.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:m={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(t.uri,m),u=s&&this._extHostDocumentsAndEditors.getEditor(s);if(u)return u.value;throw s?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,y){return new A.TextEditorDecorationType(this._proxy,t,y).value}$acceptEditorPropertiesChanged(t,y){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(y.options&&n._acceptOptions(y.options),y.selections){const m=y.selections.selections.map(F.Selection.to);n._acceptSelections(m)}if(y.visibleRanges){const m=M.coalesce(y.visibleRanges.map(F.Range.to));n._acceptVisibleRanges(m)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...y.options,lineNumbers:F.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const m=k.TextEditorSelectionChangeKind.fromValue(y.selections.source),s=y.selections.selections.map(F.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:s,kind:m})}if(y.visibleRanges){const m=M.coalesce(y.visibleRanges.map(F.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:m})}}$acceptEditorPositionData(t){for(const y in t){const n=this._extHostDocumentsAndEditors.getEditor(y);if(!n)throw new Error("Unknown text editor");const m=F.ViewColumn.to(t[y]);n.value.viewColumn!==m&&(n._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:m}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=D}),define(be[206],Ee([0,1,2,4,5,6,7]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class k{constructor(t,y){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(_.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const m=n.uri===void 0?void 0:d.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(D(m))?.get(n.handle)}return n}})}async $getTimeline(t,y,n,m,s){return this._providers.get(t)?.provideTimeline(d.URI.revive(y),n,m,s)}registerTimelineProvider(t,y,n,m){const s=new A.DisposableStore,u=this.convertTimelineItem(y.id,m,s).bind(this);let g;y.onDidChange&&(g=y.onDidChange(E=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:y.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...y,scheme:t,onDidChange:void 0,async provideTimeline(E,o,h,C){C?.resetCache&&(s.clear(),I.get(y.id)?.clear());const i=await y.provideTimeline(E,o,h);if(i==null)return;const p=u(E,C);return{...i,source:y.id,items:i.items.map(p)}},dispose(){for(const E of I.values())E.get(y.id)?.clear();g?.dispose(),s.dispose()}})}convertTimelineItem(t,y,n){return(m,s)=>{let u;if(s?.cacheResults){let g=this._itemsBySourceAndUriMap.get(t);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(t,g));const I=D(m);u=g.get(I),u===void 0&&(u=new Map,g.set(I,u))}return g=>{const{iconPath:I,...E}=g,o=`${t}|${g.id??g.timestamp}`;u?.set(o,g);let h,C,i;return g.iconPath&&(I instanceof F.ThemeIcon?i={id:I.id,color:I.color}:d.URI.isUri(I)?(h=I,C=I):{light:h,dark:C}=I),{...E,id:E.id??void 0,handle:o,source:t,command:g.command?y.toInternal(g.command,n):void 0,icon:h,iconDark:C,themeIcon:i,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=k;function D(P){return P?.toString()}}),define(be[207],Ee([0,1,6,11,2,5]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(D){this._openers=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,P,t,y){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const n=y.schemes.find(m=>!F.supportedSchemes.has(m));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,t),this._proxy.$registerUriOpener(P,y.schemes,D,y.label),(0,d.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(D,P,t){const y=this._openers.get(D);if(!y)throw new Error(`Unknown opener with id: ${D}`);const n=_.URI.revive(P);return y.canOpenExternalUri(n,t)}async $openUri(D,P,t){const y=this._openers.get(D);if(!y)throw new Error(`Unknown opener id: '${D}'`);return y.openExternalUri(_.URI.revive(P.resolvedUri),{sourceUri:_.URI.revive(P.sourceUri)},t)}}e.ExtHostUriOpeners=F,F.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(be[208],Ee([0,1,5,2,6,16,26]),function(oe,e,d,M,_,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(P,t){if(this.handles.has(F.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const y=k.HandlePool++;return this.handles.add(F.ExtensionIdentifier.toKey(P)),this.handlers.set(y,t),this._proxy.$registerUriHandler(y,P),(0,_.toDisposable)(()=>{this.handles.delete(F.ExtensionIdentifier.toKey(P)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(P,t){const y=this.handlers.get(P);if(!y)return Promise.resolve(void 0);try{y.handleUri(M.URI.revive(t))}catch(n){(0,A.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(P){return M.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=k,k.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[51],Ee([0,1,3,11,2,138,158,67,5]),function(oe,e,d,M,_,A,F,k,D){"use strict";var P,t,y,n,m,s,u,g,I,E,o,h;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class C{constructor(w,f,S,R,T,L,b){P.set(this,void 0),t.set(this,void 0),y.set(this,void 0),n.set(this,void 0),m.set(this,void 0),s.set(this,void 0),u.set(this,""),g.set(this,void 0),I.set(this,!1),E.set(this,!1),o.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,h.set(this,new d.Emitter),this._onDidDispose=Re(this,h,"f").event,Ze(this,P,w,"f"),Ze(this,t,f,"f"),Ze(this,g,S,"f"),Ze(this,n,R,"f"),Ze(this,m,T,"f"),Ze(this,s,L,"f"),Ze(this,o,i(L),"f"),Ze(this,y,b,"f")}dispose(){Ze(this,I,!0,"f"),Re(this,h,"f").fire(),Re(this,h,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(w){return Ze(this,E,!0,"f"),(0,k.asWebviewUri)(w,Re(this,n,"f").remote)}get cspSource(){const w=Re(this,s,"f").extensionLocation;if(w.scheme===M.Schemas.https||w.scheme===M.Schemas.http){let f=w.toString();return f.endsWith("/")||(f+="/"),f+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Re(this,u,"f")}set html(w){this.assertNotDisposed(),Re(this,u,"f")!==w&&(Ze(this,u,w,"f"),!Re(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(w)&&(Ze(this,E,!0,"f"),Re(this,y,"f").report("Webview vscode-resource: uris",Re(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Re(this,t,"f").$setHtml(Re(this,P,"f"),w))}get options(){return this.assertNotDisposed(),Re(this,g,"f")}set options(w){this.assertNotDisposed(),Re(this,t,"f").$setOptions(Re(this,P,"f"),r(Re(this,s,"f"),Re(this,m,"f"),w)),Ze(this,g,w,"f")}async postMessage(w){if(Re(this,I,"f"))return!1;const f=(0,F.serializeWebviewMessage)(w,{serializeBuffersForPostMessage:Re(this,o,"f")});return Re(this,t,"f").$postMessage(Re(this,P,"f"),f.message,...f.buffers)}assertNotDisposed(){if(Re(this,I,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=C,P=new WeakMap,t=new WeakMap,y=new WeakMap,n=new WeakMap,m=new WeakMap,s=new WeakMap,u=new WeakMap,g=new WeakMap,I=new WeakMap,E=new WeakMap,o=new WeakMap,h=new WeakMap;function i(c){try{const w=(0,A.normalizeVersion)((0,A.parseVersion)(c.engines.vscode));return!!w&&w.majorBase>=1&&w.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=i;class p{constructor(w,f,S,R,T){this.initData=f,this.workspace=S,this._logService=R,this._deprecationService=T,this._webviews=new Map,this._webviewProxy=w.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(w,f,...S){const R=this.getWebview(w);if(R){const{message:T}=(0,F.deserializeWebviewMessage)(f,S);R._onMessageEmitter.fire(T)}}$onMissingCsp(w,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(w,f,S){const R=new C(w,this._webviewProxy,v(f),this.initData,this.workspace,S,this._deprecationService);return this._webviews.set(w,R),R._onDidDispose(()=>{this._webviews.delete(w)}),R}deleteWebview(w){this._webviews.delete(w)}getWebview(w){return this._webviews.get(w)}}e.ExtHostWebviews=p;function a(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=a;function r(c,w,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||l(c,w)}}e.serializeWebviewOptions=r;function v(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(w=>_.URI.from(w))}}e.reviveOptions=v;function l(c,w){return[...(w?.getWorkspaceFolders()||[]).map(f=>f.uri),c.extensionLocation]}}),define(be[209],Ee([0,1,21,58,6,11,24,2,8,51,64,5,7]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(i,p){this.document=i,this._storagePath=p,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,p){await this.getEdit(i).undo(),p||this.disposeBackup()}async redo(i,p){await this.getEdit(i).redo(),p||this.disposeBackup()}disposeEdits(i){for(const p of i)this._edits.delete(p)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=h(this.document.uri)+this._backupCounter++;return(0,F.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const p=this._edits.get(i,0);if(!p)throw new Error("No edit found");return p}}class s{constructor(){this._documents=new Map}get(i,p){return this._documents.get(this.key(i,p))}add(i,p,a){const r=this.key(i,p.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${i} resource:${p.uri}`);const v=new m(p,a);return this._documents.set(r,v),v}delete(i,p){const a=this.key(i,p.uri);this._documents.delete(a)}key(i,p){return`${i}@@@${p}`}}var u;(function(C){C[C.Text=0]="Text",C[C.Custom=1]="Custom"})(u||(u={}));class g{constructor(){this._providers=new Map}addTextProvider(i,p,a){return this.add(0,i,p,a)}addCustomProvider(i,p,a){return this.add(1,i,p,a)}get(i){return this._providers.get(i)}add(i,p,a,r){if(this._providers.has(p))throw new Error(`Provider for viewType:${p} already registered`);return this._providers.set(p,{type:i,extension:a,provider:r}),new n.Disposable(()=>this._providers.delete(p))}}class I{constructor(i,p,a,r,v){this._extHostDocuments=p,this._extensionStoragePaths=a,this._extHostWebview=r,this._extHostWebviewPanels=v,this._editorProviders=new g,this._documents=new s,this._proxy=i.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,p,a,r){const v=new _.DisposableStore;return E(a)?(v.add(this._editorProviders.addTextProvider(p,i,a)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(i),p,r.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(i))):(v.add(this._editorProviders.addCustomProvider(p,i,a)),this.supportEditing(a)&&v.add(a.onDidChangeCustomDocument(l=>{const c=this.getCustomDocumentEntry(p,l.document.uri);if(o(l)){const w=c.addEdit(l);this._proxy.$onDidEdit(l.document.uri,p,w,l.label)}else this._proxy.$onContentChange(l.document.uri,p)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(i),p,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(v,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(p)}))}async $createCustomDocument(i,p,a,r,v){const l=this._editorProviders.get(p);if(!l)throw new Error(`No provider found for '${p}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${p}'`);const c=k.URI.revive(i),w=await l.provider.openCustomDocument(c,{backupId:a,untitledDocumentData:r?.buffer},v);let f;return this.supportEditing(l.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension)),this._documents.add(p,w,f),{editable:this.supportEditing(l.provider)}}async $disposeCustomDocument(i,p){const a=this._editorProviders.get(p);if(!a)throw new Error(`No provider found for '${p}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${p}'`);const r=k.URI.revive(i),{document:v}=this.getCustomDocumentEntry(p,r);this._documents.delete(p,v),v.dispose()}async $resolveWebviewEditor(i,p,a,r,v,l){const c=this._editorProviders.get(a);if(!c)throw new Error(`No provider found for '${a}'`);const w=D.ViewColumn.to(v),f=this._extHostWebview.createNewWebview(p,r.webviewOptions,c.extension),S=this._extHostWebviewPanels.createNewWebviewPanel(p,a,r.title,w,r.panelOptions,f),R=k.URI.revive(i);switch(c.type){case 1:{const{document:T}=this.getCustomDocumentEntry(a,R);return c.provider.resolveCustomEditor(T,S,l)}case 0:{const T=this._extHostDocuments.getDocument(R);return c.provider.resolveCustomTextEditor(T,S,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,p,a){this.getCustomDocumentEntry(p,i).disposeEdits(a)}async $onMoveCustomEditor(i,p,a){const r=this._editorProviders.get(a);if(!r)throw new Error(`No provider found for '${a}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const v=this._extHostWebviewPanels.getWebviewPanel(i);if(!v)throw new Error("No webview found");const l=k.URI.revive(p),c=this._extHostDocuments.getDocument(l);await r.provider.moveCustomTextEditor(c,v,d.CancellationToken.None)}async $undo(i,p,a,r){return this.getCustomDocumentEntry(p,i).undo(a,r)}async $redo(i,p,a,r){return this.getCustomDocumentEntry(p,i).redo(a,r)}async $revert(i,p,a){const r=this.getCustomDocumentEntry(p,i);await this.getCustomEditorProvider(p).revertCustomDocument(r.document,a),r.disposeBackup()}async $onSave(i,p,a){const r=this.getCustomDocumentEntry(p,i);await this.getCustomEditorProvider(p).saveCustomDocument(r.document,a),r.disposeBackup()}async $onSaveAs(i,p,a,r){const v=this.getCustomDocumentEntry(p,i);return this.getCustomEditorProvider(p).saveCustomDocumentAs(v.document,k.URI.revive(a),r)}async $backup(i,p,a){const r=this.getCustomDocumentEntry(p,i),l=await this.getCustomEditorProvider(p).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},a);return r.updateBackup(l),l.id}getCustomDocumentEntry(i,p){const a=this._documents.get(i,k.URI.revive(p));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(i){const a=this._editorProviders.get(i)?.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=I;function E(C){return typeof C.resolveCustomTextEditor=="function"}function o(C){return typeof C.undo=="function"&&typeof C.redo=="function"}function h(C){const i=C.scheme===A.Schemas.file||C.scheme===A.Schemas.untitled?C.fsPath:C.toString();return(0,M.hash)(i)+""}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[210],Ee([0,1,3,6,2,36,8,51,5,7]),function(oe,e,d,M,_,A,F,k,D,P){"use strict";var t,y,n,m,s,u,g,I,E,o,h,C,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class p extends M.Disposable{constructor(l,c,w,f,S,R,T){super();t.set(this,void 0),y.set(this,void 0),n.set(this,void 0),m.set(this,void 0),s.set(this,void 0),u.set(this,void 0),g.set(this,void 0),I.set(this,void 0),E.set(this,!0),o.set(this,!0),h.set(this,!1),C.set(this,this._register(new d.Emitter)),this.onDidDispose=Re(this,C,"f").event,i.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Re(this,i,"f").event,Ze(this,t,l,"f"),Ze(this,y,c,"f"),Ze(this,n,w,"f"),Ze(this,s,R,"f"),Ze(this,I,S,"f"),Ze(this,u,f,"f"),Ze(this,m,T,"f")}dispose(){Re(this,h,"f")||(Ze(this,h,!0,"f"),Re(this,C,"f").fire(),Re(this,y,"f").$disposeWebview(Re(this,t,"f")),Re(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Re(this,m,"f")}get viewType(){return this.assertNotDisposed(),Re(this,n,"f")}get title(){return this.assertNotDisposed(),Re(this,u,"f")}set title(l){this.assertNotDisposed(),Re(this,u,"f")!==l&&(Ze(this,u,l,"f"),Re(this,y,"f").$setTitle(Re(this,t,"f"),l))}get iconPath(){return this.assertNotDisposed(),Re(this,g,"f")}set iconPath(l){this.assertNotDisposed(),Re(this,g,"f")!==l&&(Ze(this,g,l,"f"),Re(this,y,"f").$setIconPath(Re(this,t,"f"),_.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Re(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Re(this,I,"f")=="number"&&Re(this,I,"f")<0))return Re(this,I,"f")}get active(){return this.assertNotDisposed(),Re(this,o,"f")}get visible(){return this.assertNotDisposed(),Re(this,E,"f")}_updateViewState(l){Re(this,h,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(Ze(this,o,l.active,"f"),Ze(this,E,l.visible,"f"),Ze(this,I,l.viewColumn,"f"),Re(this,i,"f").fire({webviewPanel:this}))}reveal(l,c){this.assertNotDisposed(),Re(this,y,"f").$reveal(Re(this,t,"f"),{viewColumn:l?F.ViewColumn.from(l):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Re(this,h,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,y=new WeakMap,n=new WeakMap,m=new WeakMap,s=new WeakMap,u=new WeakMap,g=new WeakMap,I=new WeakMap,E=new WeakMap,o=new WeakMap,h=new WeakMap,C=new WeakMap,i=new WeakMap;class a{constructor(l,c,w){this.webviews=c,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(l,c,w,f,S={}){const R=typeof f=="object"?f.viewColumn:f,T={viewColumn:F.ViewColumn.from(R),preserveFocus:typeof f=="object"&&!!f.preserveFocus},L=(0,k.shouldSerializeBuffersForPostMessage)(l),b=a.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(l),b,c,{title:w,panelOptions:r(S),webviewOptions:(0,k.serializeWebviewOptions)(l,this.workspace,S),serializeBuffersForPostMessage:L},T);const x=this.webviews.createNewWebview(b,S,l);return this.createNewWebviewPanel(b,c,w,R,S,x)}$onDidChangeWebviewPanelViewStates(l){const c=Object.keys(l);c.sort((w,f)=>{const S=l[w],R=l[f];return S.active?1:R.active?-1:+S.visible-+R.visible});for(const w of c){const f=this.getWebviewPanel(w);if(!f)continue;const S=l[w];f._updateViewState({active:S.active,visible:S.visible,viewColumn:F.ViewColumn.to(S.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,c,w){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:w,extension:l}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(l)}),new P.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(l,c,w,f){const S=this._serializers.get(c);if(!S)throw new Error(`No serializer found for '${c}'`);const{serializer:R,extension:T}=S,L=this.webviews.createNewWebview(l,w.webviewOptions,T),b=this.createNewWebviewPanel(l,c,w.title,f,w.panelOptions,L);await R.deserializeWebviewPanel(b,w.state)}createNewWebviewPanel(l,c,w,f,S,R){const T=new p(l,this._proxy,c,w,f,S,R);return this._webviewPanels.set(l,T),T}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=a;function r(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[211],Ee([0,1,3,6,51,5,7]),function(oe,e,d,M,_,A,F){"use strict";var k,D,P,t,y,n,m,s,u,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class I extends M.Disposable{constructor(h,C,i,p,a,r){super();k.set(this,void 0),D.set(this,void 0),P.set(this,void 0),t.set(this,void 0),y.set(this,!1),n.set(this,void 0),m.set(this,void 0),s.set(this,void 0),u.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Re(this,u,"f").event,g.set(this,this._register(new d.Emitter)),this.onDidDispose=Re(this,g,"f").event,Ze(this,P,i,"f"),Ze(this,m,p,"f"),Ze(this,k,h,"f"),Ze(this,D,C,"f"),Ze(this,t,a,"f"),Ze(this,n,r,"f")}dispose(){Re(this,y,"f")||(Ze(this,y,!0,"f"),Re(this,g,"f").fire(),Re(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Re(this,m,"f")}set title(h){this.assertNotDisposed(),Re(this,m,"f")!==h&&(Ze(this,m,h,"f"),Re(this,D,"f").$setWebviewViewTitle(Re(this,k,"f"),h))}get description(){return this.assertNotDisposed(),Re(this,s,"f")}set description(h){this.assertNotDisposed(),Re(this,s,"f")!==h&&(Ze(this,s,h,"f"),Re(this,D,"f").$setWebviewViewDescription(Re(this,k,"f"),h))}get visible(){return Re(this,n,"f")}get webview(){return Re(this,t,"f")}get viewType(){return Re(this,P,"f")}_setVisible(h){h===Re(this,n,"f")||Re(this,y,"f")||(Ze(this,n,h,"f"),Re(this,u,"f").fire())}show(h){this.assertNotDisposed(),Re(this,D,"f").$show(Re(this,k,"f"),!!h)}assertNotDisposed(){if(Re(this,y,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,D=new WeakMap,P=new WeakMap,t=new WeakMap,y=new WeakMap,n=new WeakMap,m=new WeakMap,s=new WeakMap,u=new WeakMap,g=new WeakMap;class E{constructor(h,C){this._extHostWebview=C,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,C,i,p){if(this._viewProviders.has(C))throw new Error(`View provider for '${C}' already registered`);return this._viewProviders.set(C,{provider:i,extension:h}),this._proxy.$registerWebviewViewProvider((0,_.toExtensionData)(h),C,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new F.Disposable(()=>{this._viewProviders.delete(C),this._proxy.$unregisterWebviewViewProvider(C)})}async $resolveWebviewView(h,C,i,p,a){const r=this._viewProviders.get(C);if(!r)throw new Error(`No view provider found for '${C}'`);const{provider:v,extension:l}=r,c=this._extHostWebview.createNewWebview(h,{},l),w=new I(h,this._proxy,C,i,c,!0);this._webviewViews.set(h,w),await v.resolveWebviewView(w,{state:p},a)}async $onDidChangeWebviewViewVisibility(h,C){this.getWebviewView(h)._setVisible(C)}async $disposeWebviewView(h){const C=this.getWebviewView(h);this._webviewViews.delete(h),C.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const C=this._webviewViews.get(h);if(!C)throw new Error("No webview found");return C}}e.ExtHostWebviewViews=E}),define(be[97],Ee([0,1,3,5,2,11,9,4,13]),function(oe,e,d,M,_,A,F,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class $i{constructor(y){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$i.InitialState,this._proxy=y.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,n){let m;if(typeof y=="string"){m=y;try{y=_.URI.parse(y)}catch(s){return Promise.reject(`Invalid uri - '${y}'`)}}return(0,F.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,m,n)}async asExternalUri(y,n){if((0,F.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(y,n);return _.URI.from(m)}};P.InitialState={focused:!0},P=$e([ze(0,D.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(be[212],Ee([0,1,15,5,29,13]),function(oe,e,d,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends d.AbstractLogger{constructor(D,P){super();this._proxy=D.getProxy(M.MainContext.MainThreadLog),this._logFile=P.logFile.toJSON(),this.setLevel(P.logLevel)}$setLevel(D){this.setLevel(D)}trace(D,...P){this.getLevel()<=d.LogLevel.Trace&&this._proxy.$log(this._logFile,d.LogLevel.Trace,Array.from(arguments))}debug(D,...P){this.getLevel()<=d.LogLevel.Debug&&this._proxy.$log(this._logFile,d.LogLevel.Debug,Array.from(arguments))}info(D,...P){this.getLevel()<=d.LogLevel.Info&&this._proxy.$log(this._logFile,d.LogLevel.Info,Array.from(arguments))}warn(D,...P){this.getLevel()<=d.LogLevel.Warning&&this._proxy.$log(this._logFile,d.LogLevel.Warning,Array.from(arguments))}error(D,...P){this.getLevel()<=d.LogLevel.Error&&this._proxy.$log(this._logFile,d.LogLevel.Error,Array.from(arguments))}critical(D,...P){this.getLevel()<=d.LogLevel.Critical&&this._proxy.$log(this._logFile,d.LogLevel.Critical,Array.from(arguments))}flush(){}};F=$e([ze(0,A.IExtHostRpcService),ze(1,_.IExtHostInitDataService)],F),e.ExtHostLogService=F}),define(be[213],Ee([0,1,12,22,21,16,3,6,109,180,38]),function(oe,e,d,M,_,A,F,k,D,P,t){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(S,R){try{return JSON.stringify(S,R)}catch(T){return"null"}}const m="$$ref$$",s={[m]:-1};class u{constructor(R,T){this.jsonString=R,this.referencedBuffers=T}}function g(S,R=null,T=!1){const L=[];return{jsonString:(T?n:JSON.stringify)(S,(x,$)=>{if(typeof $=="undefined")return s;if(typeof $=="object"){if($ instanceof M.VSBuffer){const B=L.push($)-1;return{[m]:B}}if(R)return R(x,$)}return $}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=g;function I(S,R,T){return JSON.parse(S,(L,b)=>{if(b){const x=b[m];if(typeof x=="number")return R[x];if(T&&b.$mid===1)return T.transformIncoming(b)}return b})}e.parseJsonAndRestoreBufferRefs=I;function E(S,R){return JSON.stringify(S,R)}function o(S){return S?(R,T)=>T&&T.$mid===1?S.transformOutgoing(T):T:null}var h;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var C;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(C=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},p=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class r extends k.Disposable{constructor(R,T=null,L=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new F.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=T,this._uriTransformer=L,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let b=0,x=t.ProxyIdentifier.count;b<x;b++)this._locals[b]=null,this._proxies[b]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(b=>this._receiveOneMessage(b))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,D.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:T,sid:L}=R;return this._proxies[T]||(this._proxies[T]=this._createProxy(T,L)),this._proxies[T]}_createProxy(R,T){let L={get:(b,x)=>(typeof x=="string"&&!b[x]&&x.charCodeAt(0)===36&&(b[x]=(...$)=>this._remoteCall(R,x,$)),x===a?T:b[x])};return new Proxy(Object.create(null),L)}set(R,T){return this._locals[R.nid]=T,T}assertRegistered(R){for(let T=0,L=R.length;T<L;T++){const b=R[T];if(!this._locals[b.nid])throw new Error(`Missing actor ${b.sid} (isMain: ${b.isMain})`)}}_receiveOneMessage(R){if(this._isDisposed)return;const T=R.byteLength,L=v.read(R,0),b=L.readUInt8(),x=L.readUInt32();switch(b){case 1:case 2:{let{rpcId:$,method:B,args:G}=c.deserializeRequestJSONArgs(L);this._uriTransformer&&(G=(0,D.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(T,x,$,B,G,b===2);break}case 3:case 4:{let{rpcId:$,method:B,args:G}=c.deserializeRequestMixedArgs(L);this._uriTransformer&&(G=(0,D.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(T,x,$,B,G,b===4);break}case 5:{this._logger&&this._logger.logIncoming(T,x,0,"ack"),this._onDidReceiveAcknowledge(x);break}case 6:{this._receiveCancel(T,x);break}case 7:{this._receiveReply(T,x,void 0);break}case 9:{let $=c.deserializeReplyOKJSON(L);this._uriTransformer&&($=(0,D.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(T,x,$);break}case 10:{const $=c.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply(T,x,$);break}case 8:{let $=c.deserializeReplyOKVSBuffer(L);this._receiveReply(T,x,$);break}case 11:{let $=c.deserializeReplyErrError(L);this._uriTransformer&&($=(0,D.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(T,x,$);break}case 12:{this._receiveReplyErr(T,x,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,T,L,b,x,$){this._logger&&this._logger.logIncoming(R,T,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(L)}.${b}(`,x);const B=String(T);let G,H;if($){const ne=new _.CancellationTokenSource;x.push(ne.token),G=this._invokeHandler(L,b,x),H=()=>ne.cancel()}else G=this._invokeHandler(L,b,x),H=i;this._cancelInvokedHandlers[B]=H;const W=c.serializeAcknowledged(T);this._logger&&this._logger.logOutgoing(W.byteLength,T,1,"ack"),this._protocol.send(W),G.then(ne=>{delete this._cancelInvokedHandlers[B];const V=c.serializeReplyOK(T,ne,this._uriReplacer);this._logger&&this._logger.logOutgoing(V.byteLength,T,1,"reply:",ne),this._protocol.send(V)},ne=>{delete this._cancelInvokedHandlers[B];const V=c.serializeReplyErr(T,ne);this._logger&&this._logger.logOutgoing(V.byteLength,T,1,"replyErr:",ne),this._protocol.send(V)})}_receiveCancel(R,T){this._logger&&this._logger.logIncoming(R,T,1,"receiveCancel");const L=String(T);this._cancelInvokedHandlers[L]&&this._cancelInvokedHandlers[L]()}_receiveReply(R,T,L){this._logger&&this._logger.logIncoming(R,T,0,"receiveReply:",L);const b=String(T);if(!this._pendingRPCReplies.hasOwnProperty(b))return;const x=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b],x.resolveOk(L)}_receiveReplyErr(R,T,L){this._logger&&this._logger.logIncoming(R,T,0,"receiveReplyErr:",L);const b=String(T);if(!this._pendingRPCReplies.hasOwnProperty(b))return;const x=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b];let $;L&&(L.$isError?($=new Error,$.name=L.name,$.message=L.message,$.stack=L.stack):$=L),x.resolveErr($)}_invokeHandler(R,T,L){try{return Promise.resolve(this._doInvokeHandler(R,T,L))}catch(b){return Promise.reject(b)}}_doInvokeHandler(R,T,L){const b=this._locals[R];if(!b)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(R));let x=b[T];if(typeof x!="function")throw new Error("Unknown method "+T+" on actor "+(0,t.getStringIdentifierForProxy)(R));return x.apply(b,L)}_remoteCall(R,T,L){if(this._isDisposed)return Promise.reject(A.canceled());let b=null;if(L.length>0&&_.CancellationToken.isCancellationToken(L[L.length-1])&&(b=L.pop()),b&&b.isCancellationRequested)return Promise.reject(A.canceled());const x=c.serializeRequestArguments(L,this._uriReplacer),$=++this._lastMessageId,B=String($),G=new P.LazyPromise;b&&b.onCancellationRequested(()=>{const W=c.serializeCancel($);this._logger&&this._logger.logOutgoing(W.byteLength,$,0,"cancel"),this._protocol.send(c.serializeCancel($))}),this._pendingRPCReplies[B]=G,this._onWillSendRequest($);const H=c.serializeRequest($,R,T,x,!!b);return this._logger&&this._logger.logOutgoing(H.byteLength,$,0,`request: ${(0,t.getStringIdentifierForProxy)(R)}.${T}(`,L),this._protocol.send(H),G}}e.RPCProtocol=r,y=p,r.UNRESPONSIVE_TIME=3*1e3;class v{constructor(R,T){this._buff=R,this._offset=T}static alloc(R,T,L){let b=new v(M.VSBuffer.alloc(L+1+4),0);return b.writeUInt8(R),b.writeUInt32(T),b}static read(R,T){return new v(R,T)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,L}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,L}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const T=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,T}static sizeMixedArray(R){let T=0;T+=1;for(let L=0,b=R.length;L<b;L++){const x=R[L];switch(T+=1,x.type){case 1:T+=this.sizeLongString(x.value);break;case 2:T+=this.sizeVSBuffer(x.value);break;case 3:T+=this.sizeUInt32,T+=this.sizeLongString(x.value);for(let $=0;$<x.buffers.length;++$)T+=this.sizeVSBuffer(x.buffers[$]);break;case 4:break}}return T}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let T=0,L=R.length;T<L;T++){const b=R[T];switch(b.type){case 1:this.writeUInt8(1),this.writeLongString(b.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(b.value);break;case 3:this.writeUInt8(3),this.writeUInt32(b.buffers.length),this.writeLongString(b.value);for(let x=0;x<b.buffers.length;++x)this.writeBuffer(b.buffers[x]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;let T=new Array(R);for(let L=0;L<R;L++)switch(this.readUInt8()){case 1:T[L]=this.readLongString();break;case 2:T[L]=this.readVSBuffer();break;case 3:const x=this.readUInt32(),$=this.readLongString(),B=[];for(let G=0;G<x;++G)B.push(this.readVSBuffer());T[L]=new t.SerializableObjectWithBuffers(I($,B,null));break;case 4:T[L]=void 0;break}return T}}v.sizeUInt32=4;var l;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(l||(l={}));class c{static _useMixedArgSerialization(R){for(let T=0,L=R.length;T<L;T++)if(R[T]instanceof M.VSBuffer||R[T]instanceof t.SerializableObjectWithBuffers||typeof R[T]=="undefined")return!0;return!1}static serializeRequestArguments(R,T){if(this._useMixedArgSerialization(R)){const L=[];for(let b=0,x=R.length;b<x;b++){const $=R[b];if($ instanceof M.VSBuffer)L[b]={type:2,value:$};else if(typeof $=="undefined")L[b]={type:4};else if($ instanceof t.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:G}=g($.value,T);L[b]={type:3,value:M.VSBuffer.fromString(B),buffers:G}}else L[b]={type:1,value:M.VSBuffer.fromString(E($,T))}}return{type:1,args:L}}return{type:0,args:E(R,T)}}static serializeRequest(R,T,L,b,x){switch(b.type){case 0:return this._requestJSONArgs(R,T,L,b.args,x);case 1:return this._requestMixedArgs(R,T,L,b.args,x)}}static _requestJSONArgs(R,T,L,b,x){const $=M.VSBuffer.fromString(L),B=M.VSBuffer.fromString(b);let G=0;G+=v.sizeUInt8(),G+=v.sizeShortString($),G+=v.sizeLongString(B);let H=v.alloc(x?2:1,R,G);return H.writeUInt8(T),H.writeShortString($),H.writeLongString(B),H.buffer}static deserializeRequestJSONArgs(R){const T=R.readUInt8(),L=R.readShortString(),b=R.readLongString();return{rpcId:T,method:L,args:JSON.parse(b)}}static _requestMixedArgs(R,T,L,b,x){const $=M.VSBuffer.fromString(L);let B=0;B+=v.sizeUInt8(),B+=v.sizeShortString($),B+=v.sizeMixedArray(b);let G=v.alloc(x?4:3,R,B);return G.writeUInt8(T),G.writeShortString($),G.writeMixedArray(b),G.buffer}static deserializeRequestMixedArgs(R){const T=R.readUInt8(),L=R.readShortString(),b=R.readMixedArray(),x=new Array(b.length);for(let $=0,B=b.length;$<B;$++){const G=b[$];typeof G=="string"?x[$]=JSON.parse(G):x[$]=G}return{rpcId:T,method:L,args:x}}static serializeAcknowledged(R){return v.alloc(5,R,0).buffer}static serializeCancel(R){return v.alloc(6,R,0).buffer}static serializeReplyOK(R,T,L){if(typeof T=="undefined")return this._serializeReplyOKEmpty(R);if(T instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(R,T);if(T instanceof t.SerializableObjectWithBuffers){const{jsonString:b,referencedBuffers:x}=g(T.value,L,!0);return this._serializeReplyOKJSONWithBuffers(R,b,x)}else return this._serializeReplyOKJSON(R,n(T,L))}static _serializeReplyOKEmpty(R){return v.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,T){let L=0;L+=v.sizeVSBuffer(T);let b=v.alloc(8,R,L);return b.writeVSBuffer(T),b.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,T){const L=M.VSBuffer.fromString(T);let b=0;b+=v.sizeLongString(L);let x=v.alloc(9,R,b);return x.writeLongString(L),x.buffer}static _serializeReplyOKJSONWithBuffers(R,T,L){const b=M.VSBuffer.fromString(T);let x=0;x+=v.sizeUInt32,x+=v.sizeLongString(b);for(const B of L)x+=v.sizeVSBuffer(B);let $=v.alloc(10,R,x);$.writeUInt32(L.length),$.writeLongString(b);for(const B of L)$.writeBuffer(B);return $.buffer}static deserializeReplyOKJSON(R){const T=R.readLongString();return JSON.parse(T)}static deserializeReplyOKJSONWithBuffers(R,T){const L=R.readUInt32(),b=R.readLongString(),x=[];for(let $=0;$<L;++$)x.push(R.readVSBuffer());return new t.SerializableObjectWithBuffers(I(b,x,T))}static serializeReplyErr(R,T){return T?this._serializeReplyErrEror(R,T):this._serializeReplyErrEmpty(R)}static _serializeReplyErrEror(R,T){const L=M.VSBuffer.fromString(n(A.transformErrorForSerialization(T),null));let b=0;b+=v.sizeLongString(L);let x=v.alloc(11,R,b);return x.writeLongString(L),x.buffer}static deserializeReplyErrError(R){const T=R.readLongString();return JSON.parse(T)}static _serializeReplyErrEmpty(R){return v.alloc(12,R,0).buffer}}var w;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var f;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(f||(f={}))}),define(be[214],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const d=function(A){const F=k=>{self.removeEventListener("message",F);const D=k.data;Object.defineProperties(self,{postMessage:{value(P,t){D.postMessage(P,t)}},onmessage:{get(){return D.onmessage},set(P){D.onmessage=P}}}),D.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",F)}.toString();class M extends EventTarget{constructor(A,F,k){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${d})('${F}'))`,P=new Blob([D],{type:"application/javascript"}),t=URL.createObjectURL(P),y=new MessageChannel,n=t,m={type:"_newWorker",id:n,port:y.port2,url:t,options:k};A(m,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:n};y.port1.postMessage(s),URL.revokeObjectURL(t),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(s){y.port1.onmessage=s}},onmessageerror:{get(){return y.port1.onmessageerror},set(s){y.port1.onmessageerror=s}}}),y.port1.addEventListener("messageerror",s=>{const u=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(u)}),y.port1.addEventListener("message",s=>{const u=new MessageEvent("message",{data:s.data});this.dispatchEvent(u)}),y.port1.start()}}e.NestedWorker=M}),define(be[215],Ee([0,1,4]),function(oe,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(be[216],Ee([0,1,11,17,25,2,4,63,48,176,215]),function(oe,e,d,M,_,A,F,k,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,F.createDecorator)("pathService");let y=class Wi{constructor(m,s,u,g){this.localUserHome=m,this.remoteAgentService=s,this.environmentService=u,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||_.OS)(),this.resolveUserHome=(async()=>{const I=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=I?.userHome||m})()}get defaultUriScheme(){return Wi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,s){if(m.remoteAuthority)return d.Schemas.vscodeRemote;const u=(0,k.getVirtualWorkspaceScheme)(s.getWorkspace());if(u)return u;const g=s.getWorkspace().folders[0];if(g)return g.uri.scheme;const I=s.getWorkspace().configuration;return I?I.scheme:d.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?M.win32:M.posix)}async fileURI(m){let s="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const g=m.indexOf("/",2);g===-1?(s=m.substring(2),m="/"):(s=m.substring(2,g),m=m.substring(g)||"/")}return A.URI.from({scheme:d.Schemas.file,authority:s,path:m,query:"",fragment:""})}};y=$e([ze(1,t.IRemoteAgentService),ze(2,P.IWorkbenchEnvironmentService),ze(3,D.IWorkspaceContextService)],y),e.AbstractPathService=y}),define(be[98],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(F,k){this.line=F,this.character=k}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,k){return new d(0,0)}with(F){return new d(0,0)}}e.Position=d;class M{constructor(F,k,D,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(F,k),this.end=new d(D,P)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new M(0,0,0,0)}with(F){return new M(0,0,0,0)}}e.Range=M;var _;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(_=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[41],Ee([0,1,14,27,23,43,9,4,17,16,98,10]),function(oe,e,d,M,_,A,F,k,D,P,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",m=" characters skipped \u27EB",s=(n.length+m.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var u;(function(W){W[W.file=0]="file",W[W.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(W){W[W.File=1]="File",W[W.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function I(W){return!!W.preview}e.resultIsMatch=I;function E(W){return!!W.resource}e.isFileMatch=E;function o(W){return!!W.message}e.isProgressMessage=o;var h;(function(W){W[W.Normal=0]="Normal",W[W.NewSearchStarted=1]="NewSearchStarted"})(h=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class C{constructor(ne){this.resource=ne,this.results=[]}}e.FileMatch=C;class i{constructor(ne,V,Y){this.ranges=V;const j=Array.isArray(V)?V:[V];if(Y&&Y.matchLines===1&&p(j)){ne=(0,F.getNLines)(ne,Y.matchLines);let le="",re=0,ve=0;const Fe=Math.floor(Y.charsPerLine/5),Me=[];for(const Oe of j){const Ke=Math.max(Oe.startColumn-Fe,0),je=Oe.startColumn+Y.charsPerLine;if(Ke>ve+Fe+s){const Ve=n+(Ke-ve)+m;le+=Ve+ne.slice(Ke,je),re+=Ke-(ve+Ve.length)}else le+=ne.slice(ve,je);Me.push(new r(0,Oe.startColumn-re,Oe.endColumn-re)),ve=je}this.preview={text:le,matches:Array.isArray(this.ranges)?Me:Me[0]}}else{const le=Array.isArray(V)?V[0].startLineNumber:V.startLineNumber;this.preview={text:ne,matches:(0,d.mapArrayOrNot)(V,re=>new a(re.startLineNumber-le,re.startColumn,re.endLineNumber-le,re.endColumn))}}}}e.TextSearchMatch=i;function p(W){const ne=W[0].startLineNumber;for(const V of W)if(V.startLineNumber!==ne||V.endLineNumber!==ne)return!1;return!0}class a{constructor(ne,V,Y,j){this.startLineNumber=ne,this.startColumn=V,this.endLineNumber=Y,this.endColumn=j}}e.SearchRange=a;class r extends a{constructor(ne,V,Y){super(ne,V,ne,Y)}}e.OneLineRange=r;var v;(function(W){W.Default="default",W.FileNames="fileNames",W.Type="type",W.Modified="modified",W.CountDescending="countDescending",W.CountAscending="countAscending"})(v=e.SearchSortOrder||(e.SearchSortOrder={}));function l(W,ne=!0){const V=W&&W.files&&W.files.exclude,Y=ne&&W&&W.search&&W.search.exclude;if(!V&&!Y)return;if(!V||!Y)return V||Y;let j=Object.create(null);return j=_.mixin(j,_.deepClone(V)),j=_.mixin(j,_.deepClone(Y),!0),j}e.getExcludes=l;function c(W,ne){return W.excludePattern&&M.match(W.excludePattern,ne)?!1:W.includePattern||W.usingSearchPaths?W.includePattern&&M.match(W.includePattern,ne)?!0:W.usingSearchPaths?!!W.folderQueries&&W.folderQueries.some(V=>{const Y=V.folder.fsPath;if(A.isEqualOrParent(ne,Y)){const j=D.relative(Y,ne);return!V.includePattern||!!M.match(V.includePattern,j)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var w;(function(W){W[W.unknownEncoding=1]="unknownEncoding",W[W.regexParseError=2]="regexParseError",W[W.globParseError=3]="globParseError",W[W.invalidLiteral=4]="invalidLiteral",W[W.rgProcessError=5]="rgProcessError",W[W.other=6]="other",W[W.canceled=7]="canceled"})(w=e.SearchErrorCode||(e.SearchErrorCode={}));class f extends Error{constructor(ne,V){super(ne);this.code=V}}e.SearchError=f;function S(W){const ne=W.message;if((0,P.isPromiseCanceledError)(W))return new f(ne,w.canceled);try{const V=JSON.parse(ne);return new f(V.message,V.code)}catch(V){return new f(ne,w.other)}}e.deserializeSearchError=S;function R(W){const ne={message:W.message,code:W.code};return new Error(JSON.stringify(ne))}e.serializeSearchError=R;function T(W){return W.type==="error"?!0:W.type==="success"}e.isSerializedSearchComplete=T;function L(W){return W.type==="success"}e.isSerializedSearchSuccess=L;function b(W){return!!W.path}e.isSerializedFileMatch=b;function x(W,ne){const V=W.searchPath?W.searchPath:W.relativePath;return(0,F.fuzzyContains)(V,ne)}e.isFilePatternMatch=x;class ${constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function B(W,ne){const V={...W||{},...ne||{}};return Object.keys(V).filter(Y=>{const j=V[Y];return typeof j=="boolean"&&j})}e.resolvePatternsForProvider=B;class G{constructor(ne,V){this._parsedIncludeExpression=null,this._excludeExpression={...ne.excludePattern||{},...V.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let Y=ne.includePattern;V.includePattern&&(Y?Y={...Y,...V.includePattern}:Y=V.includePattern),Y&&(this._parsedIncludeExpression=M.parse(Y))}matchesExcludesSync(ne,V,Y){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,V,Y))}includedInQuerySync(ne,V,Y){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,V,Y)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ne,V,Y))}includedInQuery(ne,V,Y){const j=this._parsedExcludeExpression(ne,V,Y),le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ne,V,Y):!0;return(0,y.isPromise)(j)?j.then(re=>re?!1:le()):le()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=G;function H(W){for(const ne in W)if(typeof W[ne]!="boolean")return!0;return!1}}),define(be[31],Ee([0,1,14,12,21,3,20,11,76,24,9,10,2,130,4,15,144,48,37,29,13,7,41,5]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g,I,E,o,h,C,i,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(R,T,L){return new P.ExtUri(b=>c(b,L)).isEqual(R,T)}function r(R,T,L){return a(R.uri,T.uri,L)?0:(0,t.compare)(R.uri.toString(),T.uri.toString())}function v(R,T,L){return R.index!==T.index?R.index<T.index?-1:1:a(R.uri,T.uri,L)?(0,t.compare)(R.name,T.name):(0,t.compare)(R.uri.toString(),T.uri.toString())}function l(R,T,L,b){const x=R.slice(0).sort((B,G)=>L(B,G,b)),$=T.slice(0).sort((B,G)=>L(B,G,b));return(0,d.delta)(x,$,(B,G)=>L(B,G,b))}function c(R,T){const L=T.getCapabilities(R.scheme);return!(L&&L&1024)}class w extends I.Workspace{constructor(T,L,b,x,$,B,G){super(T,b.map(H=>new I.WorkspaceFolder(H)),x,$,G);this._name=L,this._isUntitled=B,this._workspaceFolders=[],this._structure=F.TernarySearchTree.forUris(G),b.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(T,L,b,x){if(!T)return{workspace:null,added:[],removed:[]};const{id:$,name:B,folders:G,configuration:H,transient:W,isUntitled:ne}=T,V=[],Y=L;L?G.forEach((ve,Fe)=>{const Me=n.URI.revive(ve.uri),Oe=w._findFolder(b||L,Me,x);Oe?(Oe.name=ve.name,Oe.index=ve.index,V.push(Oe)):V.push({uri:Me,name:ve.name,index:Fe})}):V.push(...G.map(({uri:ve,name:Fe,index:Me})=>({uri:n.URI.revive(ve),name:Fe,index:Me}))),V.sort((ve,Fe)=>ve.index<Fe.index?-1:1);const j=new w($,B,V,!!W,H?n.URI.revive(H):null,!!ne,ve=>c(ve,x)),{added:le,removed:re}=l(Y?Y.workspaceFolders:[],j.workspaceFolders,r,x);return{workspace:j,added:le,removed:re}}static _findFolder(T,L,b){for(let x=0;x<T.folders.length;x++){const $=T.workspaceFolders[x];if(a($.uri,L,b))return $}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(T,L){return L&&this._structure.get(T)&&(T=(0,P.dirname)(T)),this._structure.findSubstr(T)}resolveWorkspaceFolder(T){return this._structure.get(T)}}let f=class{constructor(T,L,b,x){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=x,this._extHostFileSystemInfo=b,this._requestIdProvider=new D.Counter,this._barrier=new M.Barrier,this._proxy=T.getProxy(p.MainContext.MainThreadWorkspace),this._messageService=T.getProxy(p.MainContext.MainThreadMessageService);const $=L.workspace;this._confirmedWorkspace=$?new w($.id,$.name,[],!!$.transient,$.configuration?n.URI.revive($.configuration):null,!!$.isUntitled,B=>c(B,b)):void 0}$initializeWorkspace(T,L){this._trusted=L,this.$acceptWorkspaceData(T),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:k.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(T,L,b,...x){const $=[];if(Array.isArray(x)&&x.forEach(ne=>{n.URI.isUri(ne.uri)&&!$.some(V=>a(V.uri,ne.uri,this._extHostFileSystemInfo))&&$.push({uri:ne.uri,name:ne.name||(0,P.basenameOrAuthority)(ne.uri)})}),this._unconfirmedWorkspace||[L,b].some(ne=>typeof ne!="number"||ne<0)||b===0&&$.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(L+b>B.length)return!1;const G=B.slice(0);G.splice(L,b,...$.map(ne=>({uri:ne.uri,name:ne.name||(0,P.basenameOrAuthority)(ne.uri),index:void 0})));for(let ne=0;ne<G.length;ne++){const V=G[ne];if(G.some((Y,j)=>j!==ne&&a(V.uri,Y.uri,this._extHostFileSystemInfo)))return!1}G.forEach((ne,V)=>ne.index=V);const{added:H,removed:W}=l(B,G,v,this._extHostFileSystemInfo);if(H.length===0&&W.length===0)return!1;if(this._proxy){const ne=T.displayName||T.name;this._proxy.$updateWorkspaceFolders(ne,L,b,$).then(void 0,V=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(g.Severity.Error,(0,m.localize)(0,null,ne,V.toString()),{extension:T},[])})}return this.trySetWorkspaceFolders(G),!0}getWorkspaceFolder(T,L){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(T,L)}async getWorkspaceFolder2(T,L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(T,L)}async resolveWorkspaceFolder(T){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(T)}getPath(){if(!this._actualWorkspace)return;const{folders:T}=this._actualWorkspace;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,L){let b,x="";if(typeof T=="string"?(b=n.URI.file(T),x=T):typeof T!="undefined"&&(b=T,x=T.fsPath),!b)return x;const $=this.getWorkspaceFolder(b,!0);if(!$)return x;typeof L=="undefined"&&this._actualWorkspace&&(L=this._actualWorkspace.folders.length>1);let B=(0,P.relativePath)($.uri,b);return L&&$.name&&(B=`${$.name}/${B}`),B}trySetWorkspaceFolders(T){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:T,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:L,added:b,removed:x}=w.toExtHostWorkspace(T,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=L||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:b,removed:x}))}findFiles(T,L,b,x,$=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let B;if(L===null?B=!1:L&&(typeof L=="string"?B=L:B=L.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:G,folder:H}=S(T);return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)(G),(0,y.withUndefinedAsNull)(H),(0,y.withUndefinedAsNull)(B),(0,y.withUndefinedAsNull)(b),$).then(W=>Array.isArray(W)?W.map(ne=>n.URI.revive(ne)):[])}async findTextInFiles(T,L,b,x,$=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),G=typeof L.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:H,folder:W}=S(L.include),ne=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,V={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:G,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:H,excludePattern:ne},Y=!1;if(this._activeSearchCallbacks[B]=j=>{if(Y)return;const le=n.URI.revive(j.resource);j.results.forEach(re=>{(0,i.resultIsMatch)(re)?b({uri:le,preview:{text:re.preview.text,matches:(0,d.mapArrayOrNot)(re.preview.matches,ve=>new C.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,d.mapArrayOrNot)(re.ranges,ve=>new C.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):b({uri:le,text:re.text,lineNumber:re.lineNumber})})},$.isCancellationRequested)return{};try{const j=await this._proxy.$startTextSearch(T,(0,y.withUndefinedAsNull)(W),V,B,$);return delete this._activeSearchCallbacks[B],j||{}}catch(j){throw delete this._activeSearchCallbacks[B],j}}$handleTextSearchResult(T,L){this._activeSearchCallbacks[L]&&this._activeSearchCallbacks[L](T)}saveAll(T){return this._proxy.$saveAll(T)}resolveProxy(T){return this._proxy.$resolveProxy(T)}get trusted(){return this._trusted}requestWorkspaceTrust(T){return this._proxy.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};f=$e([ze(0,h.IExtHostRpcService),ze(1,o.IExtHostInitDataService),ze(2,E.IExtHostFileSystemInfo),ze(3,u.ILogService)],f),e.ExtHostWorkspace=f,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function S(R){let T,L;return R&&(typeof R=="string"?T=R:(T=R.pattern,L=R.baseFolder||n.URI.file(R.base))),{includePattern:T,folder:L}}}),define(be[32],Ee([0,1,23,3,31,5,7,147,62,10,12,4,13,15,2]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(p,a){if(a){const r=a.split(".");let v=p;for(let l=0;v&&l<r.length;l++)v=v[r[l]];return v}}function g(p){return p instanceof s.URI}function I(p){return p&&p.uri instanceof s.URI&&p.languageId&&typeof p.languageId=="string"}function E(p){return p&&!p.uri&&p.languageId&&typeof p.languageId=="string"}function o(p){return p&&p.uri instanceof s.URI&&(!p.name||typeof p.name=="string")&&(!p.index||typeof p.index=="number")}function h(p){if(g(p))return{resource:p};if(I(p))return{resource:p.uri,overrideIdentifier:p.languageId};if(E(p))return{overrideIdentifier:p.languageId};if(o(p))return{resource:p.uri};if(p===null)return{resource:null}}let C=class{constructor(a,r,v){this._proxy=a.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=v,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new i(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,r){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(a,r))}};C=$e([ze(0,n.IExtHostRpcService),ze(1,_.IExtHostWorkspace),ze(2,m.ILogService)],C),e.ExtHostConfiguration=C;class i{constructor(a,r,v,l){this._onDidChangeConfiguration=new M.Emitter,this._proxy=a,this._logService=l,this._extHostWorkspace=r,this._configuration=k.Configuration.parse(v),this._configurationScopes=this._toMap(v.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,r){const v={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,v))}getConfiguration(a,r,v){const l=h(r)||{},c=this._toReadonlyValue(a?u(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,l,v?.identifier);function w(S){if(S==null)return null;if(typeof S=="boolean")return S?1:4;switch(S){case F.ConfigurationTarget.Global:return 1;case F.ConfigurationTarget.Workspace:return 4;case F.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(S){return typeof u(c,S)!="undefined"},get:(S,R)=>{this._validateConfigurationAccess(a?`${a}.${S}`:S,l,v?.identifier);let T=u(c,S);if(typeof T=="undefined")T=R;else{let L;const b=(x,$)=>{let B;const G=()=>{L=L||(0,d.deepClone)(c),B=B||u(L,$)};return(0,P.isObject)(x)?new Proxy(x,{get:(H,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return G(),()=>B;if(L)return B=B||u(L,$),B[W];const ne=H[W];return typeof W=="string"?b(ne,`${$}.${W}`):ne},set:(H,W,ne)=>(G(),B&&(B[W]=ne),!0),deleteProperty:(H,W)=>(G(),B&&delete B[W],!0),defineProperty:(H,W,ne)=>(G(),B&&Object.defineProperty(B,W,ne),!0)}):x};T=b(T,S)}return T},update:(S,R,T,L)=>{S=a?`${a}.${S}`:S;const b=w(T);return R!==void 0?this._proxy.$updateConfigurationOption(b,S,R,l,L):this._proxy.$removeConfigurationOption(b,S,l,L)},inspect:S=>{S=a?`${a}.${S}`:S;const R=(0,d.deepClone)(this._configuration.inspect(S,l,this._extHostWorkspace.workspace));if(R)return{key:S,defaultValue:R.default?.value,globalValue:R.user?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof c=="object"&&(0,d.mixin)(f,c,!1),Object.freeze(f)}_toReadonlyValue(a){const r=v=>(0,P.isObject)(v)?new Proxy(v,{get:(l,c)=>r(l[c]),set:(l,c,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(l,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(l,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return r(a)}_validateConfigurationAccess(a,r,v){const l=D.OVERRIDE_PROPERTY_PATTERN.test(a)?4:this._configurationScopes.get(a),c=v?`[${v.value}] `:"";if(l===4){typeof r?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){r?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,r){const v=new k.ConfigurationChangeEvent(a,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,c)=>v.affectsConfiguration(l,h(c))})}_toMap(a){return a.reduce((r,v)=>(r.set(v[0],v[1]),r),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[99],Ee([0,1,2,12,3,5,7,31,50,32,21,40,13,29,4,11,25,15,70,166,16]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g,I,E,o,h){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function($){function B(H){if(H!=null)return H}$.from=B;function G(H){if(H!=null)return H}$.to=G})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var p;(function($){function B(H){if(H!=null)return H}$.from=B;function G(H){if(H!=null)return H}$.to=G})(p=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function($){function B(H){if(H!=null)return H}$.from=B;function G(H){if(H!=null)return H}$.to=G})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function($){function B(W){if(W){const ne=W;return ne&&!!ne.process}else return!1}$.is=B;function G(W){if(W==null)return;const ne={process:W.process,args:W.args};return W.options&&(ne.options=a.from(W.options)),ne}$.from=G;function H(W){if(W!=null)return new F.ProcessExecution(W.process,W.args,W.options)}$.to=H})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var v;(function($){function B(H){if(H!=null)return H}$.from=B;function G(H){if(H!=null)return H}$.to=G})(v=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function($){function B(W){if(W){const ne=W;return ne&&(!!ne.commandLine||!!ne.command)}else return!1}$.is=B;function G(W){if(W==null)return;const ne={};return W.commandLine!==void 0?ne.commandLine=W.commandLine:(ne.command=W.command,ne.args=W.args),W.options&&(ne.options=v.from(W.options)),ne}$.from=G;function H(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new F.ShellExecution(W.commandLine,W.options):new F.ShellExecution(W.command,W.args?W.args:[],W.options)}$.to=H})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function($){function B(W){if(W){let ne=W;return ne&&ne.customExecution==="customExecution"}else return!1}$.is=B;function G(W){return{customExecution:"customExecution"}}$.from=G;function H(W,ne){return ne.get(W)}$.to=H})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var w;(function($){function B(G,H){let W;return G.scope!==void 0&&typeof G.scope!="number"?W=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===F.TaskScope.Workspace&&H&&H.workspaceFile?W=H.workspaceFile:W=o.USER_TASKS_GROUP_KEY),{id:G._id,workspaceFolder:W}}$.from=B})(w=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function($){function B(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}$.from=B})(f=e.TaskGroupDTO||(e.TaskGroupDTO={}));var S;(function($){function B(W,ne){if(W==null)return[];const V=[];for(let Y of W){const j=G(Y,ne);j&&V.push(j)}return V}$.fromMany=B;function G(W,ne){if(W==null)return;let V;W.execution instanceof F.ProcessExecution?V=r.from(W.execution):W.execution instanceof F.ShellExecution?V=l.from(W.execution):W.execution&&W.execution instanceof F.CustomExecution&&(V=c.from(W.execution));const Y=i.from(W.definition);let j;return W.scope?typeof W.scope=="number"?j=W.scope:j=W.scope.uri:j=F.TaskScope.Workspace,!Y||!j?void 0:{_id:W._id,definition:Y,name:W.name,source:{extensionId:ne.identifier.value,label:W.source,scope:j},execution:V,isBackground:W.isBackground,group:f.from(W.group),presentationOptions:p.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}$.from=G;async function H(W,ne,V){if(W==null)return;let Y;r.is(W.execution)?Y=r.to(W.execution):l.is(W.execution)?Y=l.to(W.execution):c.is(W.execution)&&(Y=c.to(W._id,V));const j=i.to(W.definition);let le;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?le=W.source.scope:le=await ne.resolveWorkspaceFolder(d.URI.revive(W.source.scope)):le=F.TaskScope.Workspace),!j||!le)return;const re=new F.Task(j,le,W.name,W.source.label,Y,W.problemMatchers);return W.isBackground!==void 0&&(re.isBackground=W.isBackground),W.group!==void 0&&(re.group=F.TaskGroup.from(W.group._id),re.group&&W.group.isDefault&&(re.group=new F.TaskGroup(re.group.id,re.group.label),W.group.isDefault&&(re.group.isDefault=W.group.isDefault))),W.presentationOptions&&(re.presentationOptions=p.to(W.presentationOptions)),W._id&&(re._id=W._id),W.detail&&(re.detail=W.detail),re}$.to=H})(S=e.TaskDTO||(e.TaskDTO={}));var R;(function($){function B(H){return H}$.from=B;function G(H){if(!!H)return Object.assign(Object.create(null),H)}$.to=G})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class T{constructor(B,G,H){this._id=G,this._task=H,C.set(this,void 0),Ze(this,C,B,"f")}get task(){return this._task}terminate(){Re(this,C,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}C=new WeakMap;var L;(function($){function B(G){return{id:G._id,task:void 0}}$.from=B})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let b=class{constructor(B,G,H,W,ne,V,Y,j){this._onDidExecuteTask=new _.Emitter,this._onDidTerminateTask=new _.Emitter,this._onDidTaskProcessStarted=new _.Emitter,this._onDidTaskProcessEnded=new _.Emitter,this._proxy=B.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=W,this._configurationService=ne,this._terminalService=V,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Y,this._deprecationService=j,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,G,H){if(!H)return new F.Disposable(()=>{});const W=this.nextHandle();return this._handlers.set(W,{type:G,provider:H,extension:B}),this._proxy.$registerTaskProvider(W,G),new F.Disposable(()=>{this._handlers.delete(W),this._proxy.$unregisterTaskProvider(W)})}registerTaskSystem(B,G){this._proxy.$registerTaskSystem(B,G)}fetchTasks(B){return this._proxy.$fetchTasks(R.from(B)).then(async G=>{const H=[];for(let W of G){const ne=await S.to(W,this._workspaceProvider,this._providedCustomExecutions2);ne&&H.push(ne)}return H})}get taskExecutions(){const B=[];return this._taskExecutions.forEach(G=>B.push(G)),B}terminateTask(B){if(!(B instanceof T))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,G,H){const W=this._providedCustomExecutions2.get(B.id);if(W){if(this._activeCustomExecutions2.get(B.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(B.id,W),this._terminalService.attachPtyToTerminal(G,await W.callback(H))}this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const G=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:G})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const G=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:G,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const G=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:G,exitCode:B.exitCode})}$provideTasks(B,G){const H=this._handlers.get(B);if(!H)return Promise.reject(new Error("no handler found"));const W=[],ne=(0,M.asPromise)(()=>H.provider.provideTasks(t.CancellationToken.None)).then(V=>this.provideTasksInternal(G,W,H,V));return new Promise(V=>{ne.then(Y=>{Promise.all(W).then(()=>{V(Y)})})})}async $resolveTask(B,G){const H=this._handlers.get(B);if(!H)return Promise.reject(new Error("no handler found"));if(G.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${H.type}].`);const W=await S.to(G,this._workspaceProvider,this._providedCustomExecutions2);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const ne=await H.provider.resolveTask(W,t.CancellationToken.None);if(!ne)return;this.checkDeprecation(ne,H);const V=S.from(ne,H.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(ne.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(V.execution)&&await this.addCustomExecution(V,ne,!0),await this.resolveTaskInternal(V)}nextHandle(){return this._handleCounter++}async addCustomExecution(B,G,H){const W=await this._proxy.$createTaskId(B);!H&&!this._providedCustomExecutions2.has(W)&&this._notProvidedCustomExecutions.add(W),this._providedCustomExecutions2.set(W,G.execution)}async getTaskExecution(B,G){if(typeof B=="string"){const ne=this._taskExecutionPromises.get(B);if(!ne)throw new Error("Unexpected: The specified task is missing an execution");return ne}let H=this._taskExecutionPromises.get(B.id);if(H)return H;const W=new Promise(async(ne,V)=>{const Y=G||await S.to(B.task,this._workspaceProvider,this._providedCustomExecutions2);Y?ne(new T(this,B.id,Y)):V("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(B.id,W),W.then(ne=>(this._taskExecutions.set(B.id,ne),ne),ne=>Promise.reject(ne))}checkDeprecation(B,G){B._deprecated&&this._deprecationService.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let H=this._notProvidedCustomExecutions.values(),W=H.next();for(;!W.done;)!this._activeCustomExecutions2.has(W.value)&&this._lastStartedTask!==W.value&&(this._providedCustomExecutions2.delete(W.value),this._notProvidedCustomExecutions.delete(W.value)),W=H.next()}};b=$e([ze(0,n.IExtHostRpcService),ze(1,m.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,D.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,y.IExtHostTerminalService),ze(6,I.ILogService),ze(7,E.IExtHostApiDeprecationService)],b),e.ExtHostTaskBase=b;let x=class extends b{constructor(B,G,H,W,ne,V,Y,j){super(B,G,H,W,ne,V,Y,j);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(B,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const H=S.from(G,B);if(H===void 0)throw new Error("Task is not valid");if(c.is(H.execution))await this.addCustomExecution(H,G,!1);else throw new h.NotSupportedError;const W=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),G);return this._proxy.$executeTask(H).catch(ne=>{throw new Error(ne)}),W}provideTasksInternal(B,G,H,W){const ne=[];if(W)for(let V of W){this.checkDeprecation(V,H),(!V.definition||!B[V.definition.type])&&this._logService.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const Y=S.from(V,H.extension);Y&&c.is(Y.execution)?(ne.push(Y),G.push(this.addCustomExecution(Y,V,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ne,extension:H.extension}}async resolveTaskInternal(B){if(c.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,G,H){}};x=$e([ze(0,n.IExtHostRpcService),ze(1,m.IExtHostInitDataService),ze(2,k.IExtHostWorkspace),ze(3,D.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,y.IExtHostTerminalService),ze(6,I.ILogService),ze(7,E.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")}),define(be[217],Ee([0,1,14,52,27,78,20,11,17,24,9,10,2,111,134,85,48,92,216,41]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g,I,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(w,f,S,R){this.configurationService=w,this.workspaceContextService=f,this.editorGroupsService=S,this.pathService=R}text(w,f,S={}){w=this.getContentPattern(w,S);const R=this.configurationService.getValue(),T=f&&f.some(b=>!this.configurationService.getValue({resource:b}).search.useRipgrep);return{...this.commonQuery(f?.map(g.toWorkspaceFolder),S),type:2,contentPattern:w,previewOptions:S.previewOptions,maxFileSize:S.maxFileSize,usePCRE2:R.search.usePCRE2||T||!1,beforeContext:S.beforeContext,afterContext:S.afterContext,userDisabledExcludesAndIgnoreFiles:S.disregardExcludeSettings&&S.disregardIgnoreFiles}}getContentPattern(w,f){const S=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const R={...w,wordSeparators:S.editor.wordSeparators};return this.isCaseSensitive(w,f)&&(R.isCaseSensitive=!0),this.isMultiline(w)&&(R.isMultiline=!0),R}file(w,f={}){return{...this.commonQuery(w,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}handleIncludeExclude(w,f){return w?(w=Array.isArray(w)?w.map(r):r(w),f?this.parseSearchPaths(w):{pattern:i(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],f={}){const S=this.handleIncludeExclude(f.includePattern,f.expandPatterns),R=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),T=w.length>1,L=(S.searchPaths&&S.searchPaths.length?S.searchPaths.map($=>this.getFolderQueryForSearchPath($,f,R)):w.map($=>this.getFolderQueryForRoot($,f,R,T))).filter($=>!!$),b={_reason:f._reason,folderQueries:L,usingSearchPaths:!!(S.searchPaths&&S.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:R.pattern,includePattern:S.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const B=d.coalesce(d.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(W=>W.resource)))).filter(H=>(0,o.pathIncludedInQuery)(b,H.fsPath)),G=this.commonQueryFromFileList(B);return{...b,...G}}const x=f.extraFileResources&&f.extraFileResources.filter($=>(0,o.pathIncludedInQuery)(b,$.fsPath));return b.extraFileResources=x&&x.length?x:void 0,b}commonQueryFromFileList(w){const f=[],S=new F.ResourceMap,R={};let T=!1;return w.forEach(L=>{if(L.scheme===k.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(L)){const x=this.workspaceContextService.getWorkspaceFolder(L)?.uri??L.with({path:D.dirname(L.fsPath)});let $=S.get(x);$||(T=!0,$={folder:x,includePattern:{}},f.push($),S.set(x,$));const B=D.relative(x.fsPath,L.fsPath);(0,y.assertIsDefined)($.includePattern)[B.replace(/\\/g,"/")]=!0}else L.fsPath&&(T=!0,R[L.fsPath]=!0)}),{folderQueries:f,includePattern:R,usingSearchPaths:!0,excludePattern:T?void 0:{"**/*":!0}}}isCaseSensitive(w,f){if(f.isSmartCase){if(w.isRegExp){if(t.containsUppercaseCharacter(w.pattern,!0))return!0}else if(t.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,m.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const f=G=>D.isAbsolute(G)||/^\.\.?([\/\\]|$)/.test(G),R=(Array.isArray(w)?w:p(w)).map(G=>{const H=this.pathService.resolvedUserHome;return H?(0,A.untildify)(G,H.scheme===k.Schemas.file?H.fsPath:H.path):G}),T=M.groupBy(R,G=>f(G)?"searchPaths":"exprSegments"),L=(T.exprSegments||[]).map(G=>t.rtrim(G,"/")).map(G=>t.rtrim(G,"\\")).map(G=>(G[0]==="."&&(G="*"+G),a(G))),b={},x=this.expandSearchPathPatterns(T.searchPaths||[]);x&&x.length&&(b.searchPaths=x);const $=d.flatten(L),B=i(...$);return B&&(b.pattern=B),b}getExcludesForFolder(w,f){return f.disregardExcludeSettings?void 0:(0,o.getExcludes)(w,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const f=d.flatten(w.map(R=>{let{pathPortion:T,globPortion:L}=C(R);L&&(L=v(L));const b=this.expandOneSearchPath(T);return d.flatten(b.map(x=>this.resolveOneSearchPathPattern(x,L)))})),S=new Map;return f.forEach(R=>{const T=R.searchPath.toString(),L=S.get(T);L?R.pattern&&(L.pattern=L.pattern||{},L.pattern[R.pattern]=!0):S.set(T,{searchPath:R.searchPath,pattern:R.pattern?i(R.pattern):void 0})}),Array.from(S.values())}expandOneSearchPath(w){if(D.isAbsolute(w)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==k.Schemas.file?[{searchPath:f[0].uri.with({path:w})}]:[{searchPath:n.URI.file(D.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=r(w),w.startsWith("../")||w===".."){const R=D.posix.resolve(f.path,w);return[{searchPath:f.with({path:R})}]}const S=v(w);return[{searchPath:f,pattern:S}]}else{if(w==="./"||w===".\\")return[];{const f=w.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(T=>{const L=f.match(new RegExp(`^${t.escapeRegExpCharacters(T.name)}(?:/(.*)|$)`));return L?{match:L,folder:T}:null}).filter(y.isDefined);if(R.length)return R.map(T=>{const L=T.match[1];return{searchPath:T.folder.uri,pattern:L&&v(L)}});{const T=w.match(/\.[\/\\](.+)[\/\\]?/),L=T?T[1]:w,b=s.localize(0,null,L);throw new Error(b)}}}}resolveOneSearchPathPattern(w,f){const S=w.pattern&&f?`${w.pattern}/${f}`:w.pattern||f,R=[{searchPath:w.searchPath,pattern:S}];return S&&!S.endsWith("**")&&R.push({searchPath:w.searchPath,pattern:S+"/**"}),R}getFolderQueryForSearchPath(w,f,S){const R=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(w.searchPath),f,S,!1);return R?{...R,includePattern:w.pattern}:null}getFolderQueryForRoot(w,f,S,R){let T;const L=n.URI.isUri(w)?w:w.uri;if(S.searchPaths){const G=S.searchPaths.filter(H=>(0,P.isEqual)(H.searchPath,L))[0];if(G&&!G.pattern)return null;G&&(T=G.pattern)}const b=this.configurationService.getValue({resource:L}),$={...this.getExcludesForFolder(b,f)||{},...T||{}},B=n.URI.isUri(w)?(0,P.basename)(w):w.name;return{folder:L,folderName:R?B:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:b.files&&b.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!b.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!b.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!b.search.followSymlinks}}};h=$e([ze(0,u.IConfigurationService),ze(1,g.IWorkspaceContextService),ze(2,I.IEditorGroupsService),ze(3,E.IPathService)],h),e.QueryBuilder=h;function C(c){const w=c.match(/[\*\{\}\(\)\[\]\?]/);if(w){const f=w.index,S=c.substr(0,f).match(/[/|\\][^/\\]*$/);if(S){let R=c.substr(0,S.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:c.substr((S.index||0)+1)}}}return{pathPortion:c}}function i(...c){return c.length?c.reduce((w,f)=>(w[f]=!0,w),Object.create(null)):void 0}function p(c){return _.splitGlobAware(c,",").map(w=>w.trim()).filter(w=>!!w.length)}function a(c){return[`**/${c}/**`,`**/${c}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function r(c){return c.replace(/\\/g,"/")}function v(c){return r(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(c,w){c=d.distinct(c,R=>R.toString());const f=[],S=w.getWorkspace();return c&&c.forEach(R=>{let T;if(w.getWorkbenchState()===2)T=(0,P.relativePath)(S.folders[0].uri,R),T&&T!=="."&&(T="./"+T);else{const L=w.getWorkspaceFolder(R);if(L){const b=L.name;if(S.folders.filter($=>$.name===b).length===1){const $=(0,P.relativePath)(L.uri,R);$===""?T=`./${L.name}`:T=`./${L.name}/${$}`}else T=R.fsPath}}T&&f.push(T)}),f}e.resolveResourcesForSearchIncludes=l}),define(be[218],Ee([0,1,24,2,21,16,4,217,41,48]),function(oe,e,d,M,_,A,F,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function y(u,g){const I=g.activationEvents;if(!I)return Promise.resolve(void 0);const E=[],o=[];for(const r of I)if(/^workspaceContains:/.test(r)){const v=r.substr("workspaceContains:".length);v.indexOf("*")>=0||v.indexOf("?")>=0||u.forceUsingSearch?o.push(v):E.push(v)}if(E.length===0&&o.length===0)return Promise.resolve(void 0);let h;const C=new Promise((r,v)=>{h=r}),i=r=>h({activationEvent:r}),p=Promise.all(E.map(r=>n(u,r,i))).then(()=>{}),a=m(u,g.identifier,o,i);return Promise.all([p,a]).then(()=>{h(void 0)}),C}e.checkActivateWorkspaceContainsExtension=y;async function n(u,g,I){for(const E of u.folders)if(await u.exists(d.joinPath(M.URI.revive(E),g))){I(`workspaceContains:${g}`);return}}async function m(u,g,I,E){if(I.length===0)return Promise.resolve(void 0);const o=new _.CancellationTokenSource,h=u.checkExists(u.folders,I,o.token),C=setTimeout(async()=>{o.cancel(),E(`workspaceContainsTimeout:${I.join(",")}`)},t);let i=!1;try{i=await h}catch(p){A.isPromiseCanceledError(p)||A.onUnexpectedError(p)}o.dispose(),clearTimeout(C),i&&E(`workspaceContains:${I.join(",")}`)}function s(u,g,I,E){const o=u.get(F.IInstantiationService),h=u.get(D.ISearchService),i=o.createInstance(k.QueryBuilder).file(g.map(p=>(0,P.toWorkspaceFolder)(M.URI.revive(p))),{_reason:"checkExists",includePattern:I,exists:!0});return h.fileSearch(i,E).then(p=>!!p.limitHit,p=>A.isPromiseCanceledError(p)?!1:Promise.reject(p))}e.checkGlobFileExists=s});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,d,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!_:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(oe,d):_?_.value=d:e.set(oe,d),d},Re=this&&this.__classPrivateFieldGet||function(oe,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!M:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(oe):M?M.value:e.get(oe)};define(be[33],Ee([0,1,125,17,75,24,12,6,20,2,15,5,32,179,73,31,30,177,16,26,22,153,7,86,4,29,74,13,61,65,40,3,218,69,155,11]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g,I,E,o,h,C,i,p,a,r,v,l,c,w,f,S,R,T,L,b){"use strict";var x,$,B;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let G=class Hi extends k.Disposable{constructor(V,Y,j,le,re,ve,Fe,Me,Oe,Ke){super();this._onDidChangeRemoteConnectionData=this._register(new S.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Y,this._extHostContext=j,this._initData=Fe,this._extHostWorkspace=le,this._extHostConfiguration=re,this._logService=ve,this._extHostTunnelService=Oe,this._extHostTerminalService=Ke,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new F.Barrier,this._readyToStartExtensionHost=new F.Barrier,this._readyToRunExtensions=new F.Barrier,this._eagerExtensionsActivated=new F.Barrier,this._registry=new I.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new T.ExtHostSecretState(this._extHostContext),this._storagePath=Me,this._instaService=V.createChild(new c.ServiceCollection([s.IExtHostStorage,this._storage],[T.IExtHostSecretState,this._secretState]));const je=new Set;this._initData.hostExtensions.forEach(Ve=>je.add(o.ExtensionIdentifier.toKey(Ve))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ve,U,Q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ve,E.transformErrorForSerialization(U),Q)},actualActivateExtension:async(Ve,U)=>{if(je.has(o.ExtensionIdentifier.toKey(Ve)))return await this._mainThreadExtensionsProxy.$activateExtension(Ve,U),new m.HostExtension;const Q=this._registry.getExtensionDescription(Ve);return this._activateExtension(Q,U)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),_.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(V){E.onUnexpectedError(V)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let V=[];try{V=this._registry.getAllExtensionDescriptions().map(re=>re.identifier).filter(re=>this.isActivated(re)).map(re=>this._deactivate(re))}catch(Y){}await Promise.all(V)}isActivated(V){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(V):!1}_activateByEvent(V,Y){return this._activator.activateByEvent(V,Y)}_activateById(V,Y){return this._activator.activateById(V,Y)}activateByIdWithErrors(V,Y){return this._activateById(V,Y).then(()=>{const j=this._activator.getActivatedExtension(V);if(j.activationFailed)return Promise.reject(j.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(V=>this._registry)}getExtensionExports(V){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(V).exports:null}async _realPathExtensionUri(V){if(V.scheme!==b.Schemas.file)return V;const Y=await this._hostUtils.realpath(V.fsPath);return P.URI.file(Y)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const V=D.TernarySearchTree.forUris(Y=>A.extUriBiasedIgnorePathCase.ignorePathCasing(Y));for(const Y of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(Y)){const j=await this._realPathExtensionUri(Y.extensionLocation);V.set(j,Y)}return V})()),this._extensionPathIndex}_deactivate(V){let Y=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(V))return Y;const j=this._activator.getActivatedExtension(V);if(!j)return Y;try{typeof j.module.deactivate=="function"&&(Y=Promise.resolve(j.module.deactivate()).then(void 0,le=>(this._logService.error(le),Promise.resolve(void 0))))}catch(le){this._logService.error(le)}try{(0,k.dispose)(j.subscriptions)}catch(le){this._logService.error(le)}return Y}async _activateExtension(V,Y){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier),this._doActivateExtension(V,Y).then(j=>{const le=j.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(V.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,Y),this._logExtensionActivationTimes(V,Y,"success",le),j},j=>{throw this._logExtensionActivationTimes(V,Y,"failure"),j})}_logExtensionActivationTimes(V,Y,j,le){const re=H(V,Y);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...re,...le||{},outcome:j})}_doActivateExtension(V,Y){const j=H(V,Y);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",j);const le=this._getEntryPoint(V);if(!le)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${Y.startup}, activationEvent: '${Y.activationEvent}'${V.identifier.value!==Y.extensionId.value?`, root cause: ${Y.extensionId.value}`:""}`),this._logService.flush();const re=new m.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this._loadCommonJSModule(V.identifier,(0,A.joinPath)(V.extensionLocation,le),re),this._loadExtensionContext(V)]).then(ve=>(_.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),Hi._callActivate(this._logService,V.identifier,ve[0],ve[1],re))).then(ve=>(_.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),ve))}_loadExtensionContext(V){const Y=new C.ExtensionGlobalMemento(V,this._storage),j=new C.ExtensionMemento(V.identifier.value,!1,this._storage),le=new L.ExtensionSecrets(V,this._secretState),re=V.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ve=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([Y.whenReady,j.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let Me;return Object.freeze({globalState:Y,workspaceState:j,secrets:le,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Oe){return M.join(V.extensionLocation.fsPath,Oe)},get storagePath(){return Fe._storagePath.workspaceValue(V)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(V).fsPath},get logPath(){return M.join(Fe._initData.logsLocation.fsPath,V.identifier.value)},get logUri(){return P.URI.joinPath(Fe._initData.logsLocation,V.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(V)},get globalStorageUri(){return Fe._storagePath.globalValue(V)},get extensionMode(){return re},get extension(){return Me===void 0&&(Me=new W(Fe,V.identifier,V,ve)),Me},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(V),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(V)}})})}static _callActivate(V,Y,j,le,re){return j=j||{activate:void 0,deactivate:void 0},this._callActivateOptional(V,Y,j,le,re).then(ve=>new m.ActivatedExtension(!1,null,re.build(),j,ve,le.subscriptions))}static _callActivateOptional(V,Y,j,le,re){if(typeof j.activate=="function")try{re.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const ve=typeof global=="object"?global:self,Fe=j.activate.apply(ve,[le]);return re.activateCallStop(),re.activateResolveStart(),Promise.resolve(Fe).then(Me=>(re.activateResolveStop(),Me))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(j)}_activateOneStartupFinished(V,Y){this._activateById(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:Y}).then(void 0,j=>{this._logService.error(j)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(_.getMarks());for(const V of this._registry.getAllExtensionDescriptions())if(V.activationEvents)for(const Y of V.activationEvents)Y==="onStartupFinished"&&this._activateOneStartupFinished(V,Y)}_handleEagerExtensions(){const V=this._activateByEvent("*",!0).then(void 0,re=>{this._logService.error(re)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(re=>this._handleWorkspaceContainsEagerExtensions(re.added)));const Y=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],j=this._handleWorkspaceContainsEagerExtensions(Y),le=Promise.all([V,j]).then(()=>{});return Promise.race([le,(0,F.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),le}_handleWorkspaceContainsEagerExtensions(V){return V.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Y=>this._handleWorkspaceContainsEagerExtension(V,Y))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(V,Y){if(this.isActivated(Y.identifier))return;const j=!this._initData.remote.isRemote&&!!this._initData.remote.authority,le={folders:V.map(ve=>ve.uri),forceUsingSearch:j,exists:ve=>this._hostUtils.exists(ve.fsPath),checkExists:(ve,Fe,Me)=>this._mainThreadWorkspaceProxy.$checkExists(ve,Fe,Me)},re=await(0,R.checkActivateWorkspaceContainsExtension)(le,Y);if(!!re)return this._activateById(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:re.activationEvent}).then(void 0,ve=>this._logService.error(ve))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(V){throw console.error(V),V}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:Y}=this._initData.environment;if(!V||!Y)throw new Error(d.localize(0,null));const j=await this._loadCommonJSModule(null,Y,new m.ExtensionActivationTimesBuilder(!1));if(!j||typeof j.run!="function")throw new Error(d.localize(1,null,Y.toString()));return new Promise((le,re)=>{const ve=(Oe,Ke)=>{Oe?re(Oe):le(typeof Ke=="number"&&Ke>0?1:0)},Fe=(0,A.originalFSPath)(Y),Me=j.run(Fe,ve);Me&&Me.then&&Me.then(()=>{le(0)}).catch(Oe=>{re(Oe.toString())})})}async $extensionTestsExit(V){this._logService.info(`extension host terminating: test runner requested exit with code ${V}`),this._logService.info(`exiting with code ${V}`),this._logService.flush(),this._hostUtils.exit(V)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(V,Y){return this._resolvers[V]=Y,(0,k.toDisposable)(()=>{delete this._resolvers[V]})}async _activateAndGetResolver(V){const Y=V.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const j=V.substr(0,Y);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${j}`,!1),{authorityPrefix:j,resolver:this._resolvers[j]}}async $resolveAuthority(V,Y){const{authorityPrefix:j,resolver:le}=await this._activateAndGetResolver(V);if(!le)return{type:"error",error:{code:p.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${j}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(le)),_.mark(`code/extHost/willResolveAuthority/${j}`);const re=await le.resolve(V,{resolveAttempt:Y});_.mark(`code/extHost/didResolveAuthorityOK/${j}`);const ve={authority:V,host:re.host,port:re.port,connectionToken:re.connectionToken},Fe={extensionHostEnv:re.extensionHostEnv,isTrusted:re.isTrusted};return{type:"ok",value:{authority:ve,options:Fe,tunnelInformation:{environmentTunnels:re.environmentTunnels}}}}catch(re){if(_.mark(`code/extHost/didResolveAuthorityError/${j}`),re instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:re._code,message:re._message,detail:re._detail}};throw re}}async $getCanonicalURI(V,Y){const{authorityPrefix:j,resolver:le}=await this._activateAndGetResolver(V);if(!le)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${j}`);const re=P.URI.revive(Y);if(typeof le.getCanonicalURI=="undefined")return re;const ve=await(0,F.asPromise)(()=>le.getCanonicalURI(re));return ve||re}$startExtensionHost(V){return this._registry.keepOnly(V),this._startExtensionHost()}$activateByEvent(V,Y){return Y===1?this._activateByEvent(V,!1):this._readyToRunExtensions.wait().then(j=>this._activateByEvent(V,!1))}async $activate(V,Y){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(V)?(await this._activateById(V,Y),!0):!1}async $deltaExtensions(V,Y){V.forEach(le=>le.extensionLocation=P.URI.revive(le.extensionLocation));const j=await this.getExtensionPathIndex();return await Promise.all(Y.map(async le=>{const re=this._registry.getExtensionDescription(le);re&&j.delete(await this._realPathExtensionUri(re.extensionLocation))})),await Promise.all(V.map(async le=>{const re=await this._realPathExtensionUri(le.extensionLocation);j.set(re,le)})),this._registry.deltaExtensions(V,Y),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){let Y=h.VSBuffer.alloc(V),j=Math.random()%256;for(let le=0;le<V;le++)Y.writeUInt8(j,le);return Y}async $updateRemoteConnectionData(V){this._remoteConnectionData=V,this._onDidChangeRemoteConnectionData.fire()}};G=$e([ze(0,a.IInstantiationService),ze(1,e.IHostUtils),ze(2,l.IExtHostRpcService),ze(3,u.IExtHostWorkspace),ze(4,n.IExtHostConfiguration),ze(5,t.ILogService),ze(6,r.IExtHostInitDataService),ze(7,v.IExtensionStoragePaths),ze(8,w.IExtHostTunnelService),ze(9,f.IExtHostTerminalService)],G),e.AbstractExtHostExtensionService=G;function H(ne,V){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class W{constructor(V,Y,j,le){x.set(this,void 0),$.set(this,void 0),B.set(this,void 0),Ze(this,x,V,"f"),Ze(this,$,Y,"f"),Ze(this,B,j.identifier,"f"),this.id=j.identifier.value,this.extensionUri=j.extensionLocation,this.extensionPath=M.normalize((0,A.originalFSPath)(j.extensionLocation)),this.packageJSON=j,this.extensionKind=le}get isActive(){return Re(this,x,"f").isActivated(Re(this,B,"f"))}get exports(){if(this.packageJSON.api!=="none")return Re(this,x,"f").getExtensionExports(Re(this,B,"f"))}activate(){return Re(this,x,"f").activateByIdWithErrors(Re(this,B,"f"),{startup:!1,extensionId:Re(this,$,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,x=new WeakMap,$=new WeakMap,B=new WeakMap}),define(be[100],Ee([0,1,17,2,3,12,5,7,163,31,33,50,168,32,164,13,4,10,91,71]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g,I,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,g.createDecorator)("IExtHostDebugService");let h=class{constructor(c,w,f,S,R,T){this._workspaceService=w,this._extensionService=f,this._editorsService=S,this._configurationService=R,this._editorTabs=T,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new _.Emitter,this._onDidTerminateDebugSession=new _.Emitter,this._onDidChangeActiveDebugSession=new _.Emitter,this._onDidReceiveDebugSessionCustomEvent=new _.Emitter,this._debugServiceProxy=c.getProxy(F.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new _.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(L=>{L.onDidChange(b=>{this.registerAllDebugTypes(L)}),this.registerAllDebugTypes(L)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,w){const f=c;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let S=`debug:${encodeURIComponent(f.path||"")}`,R="?";return w&&(S+=`${R}session=${encodeURIComponent(w.id)}`,R="&"),S+=`${R}ref=${f.sourceReference}`,M.URI.parse(S)}else{if(f.path)return M.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const w=[];for(const f of c.getAllExtensionDescriptions())if(f.contributes){const S=f.contributes.debuggers;if(S&&S.length>0)for(const R of S)(0,s.isDebuggerMainContribution)(R)&&w.push(R.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(w=>c.push(w)),c}addBreakpoints(c){this.startBreakpoints();const w=c.filter(R=>{const T=R.id;return this._breakpoints.has(T)?!1:(this._breakpoints.set(T,R),!0)});this.fireBreakpointChanges(w,[],[]);const f=[],S=new Map;for(const R of w)if(R instanceof k.SourceBreakpoint){let T=S.get(R.location.uri.toString());T||(T={type:"sourceMulti",uri:R.location.uri,lines:[]},S.set(R.location.uri.toString(),T),f.push(T)),T.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof k.FunctionBreakpoint&&f.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(f)}removeBreakpoints(c){this.startBreakpoints();const w=c.filter(T=>this._breakpoints.delete(T.id));this.fireBreakpointChanges([],w,[]);const f=w.filter(T=>T instanceof k.SourceBreakpoint).map(T=>T.id),S=w.filter(T=>T instanceof k.FunctionBreakpoint).map(T=>T.id),R=w.filter(T=>T instanceof k.DataBreakpoint).map(T=>T.id);return this._debugServiceProxy.$unregisterBreakpoints(f,S,R)}startDebugging(c,w,f){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,w,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,debugUI:f.debugUI,suppressSaveBeforeStart:f.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,w,f){if(!w)return new k.Disposable(()=>{});const S=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:S,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,f,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,S),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(c,w,f){if(!f)return new k.Disposable(()=>{});if(!this.definesDebugType(c,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:S,factory:f}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,S),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==f),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(c,w){if(!w)return new k.Disposable(()=>{});const f=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:f,factory:w}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(S=>S.factory!==w)})}async $runInTerminal(c,w){return Promise.resolve(void 0)}async $substituteVariables(c,w){if(!this._variableResolver){const[R,T]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,T)}let f;const S=await this.getFolder(c);return S&&(f={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(f,w)}createDebugAdapter(c,w){if(c.type==="implementation")return new r(c.implementation)}createSignService(){}async $startDASession(c,w){const f=this,S=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(S.type),S).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const T=this.convertToDto(R),L=this.createDebugAdapter(T,S);if(!L)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const b=L;return this._debugAdapters.set(c,b),this.getDebugAdapterTrackers(S).then(x=>(x&&this._debugAdaptersTrackers.set(c,x),b.onMessage(async $=>{if($.type==="request"&&$.command==="handshake"){const B=$,G={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(B.arguments.value);G.body={signature:H},b.sendResponse(G)}else throw new Error("no signer")}catch(H){G.success=!1,G.message=H.message,b.sendResponse(G)}}else x&&x.onDidSendMessage&&x.onDidSendMessage($),$=(0,s.convertToVSCPaths)($,!0),f._debugServiceProxy.$acceptDAMessage(c,$)}),b.onError($=>{x&&x.onError&&x.onError($),this._debugServiceProxy.$acceptDAError(c,$.name,$.message,$.stack)}),b.onExit($=>{x&&x.onExit&&x.onExit((0,I.withNullAsUndefined)($),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,I.withNullAsUndefined)($),void 0)}),x&&x.onWillStartSession&&x.onWillStartSession(),b.startSession()))})}$sendDAMessage(c,w){w=(0,s.convertToDAPaths)(w,!1);const f=this._debugAdaptersTrackers.get(c);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(w);const S=this._debugAdapters.get(c);S&&S.sendMessage(w)}$stopDASession(c){const w=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),w&&w.onWillStopSession&&w.onWillStopSession();const f=this._debugAdapters.get(c);return this._debugAdapters.delete(c),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const w=[],f=[],S=[];if(c.added)for(const R of c.added){const T=R.id;if(T&&!this._breakpoints.has(T)){let L;if(R.type==="function")L=new k.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")L=new k.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const b=M.URI.revive(R.uri);L=new k.SourceBreakpoint(new k.Location(b,new k.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}L._id=T,this._breakpoints.set(T,L),w.push(L)}}if(c.removed)for(const R of c.removed){const T=this._breakpoints.get(R);T&&(this._breakpoints.delete(R),f.push(T))}if(c.changed){for(const R of c.changed)if(R.id){const T=this._breakpoints.get(R.id);if(T){if(T instanceof k.FunctionBreakpoint&&R.type==="function"){const L=T;L.enabled=R.enabled,L.condition=R.condition,L.hitCondition=R.hitCondition,L.logMessage=R.logMessage,L.functionName=R.functionName}else if(T instanceof k.SourceBreakpoint&&R.type==="source"){const L=T;L.enabled=R.enabled,L.condition=R.condition,L.hitCondition=R.hitCondition,L.logMessage=R.logMessage,L.location=new k.Location(M.URI.revive(R.uri),new k.Position(R.line,R.character))}S.push(T)}}}this.fireBreakpointChanges(w,f,S)}$provideDebugConfigurations(c,w,f){return(0,A.asPromise)(async()=>{const S=this.getConfigProviderByHandle(c);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(w);return S.provideDebugConfigurations(R,f)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(c,w,f,S){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(c);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const T=await this.getFolder(w);return R.resolveDebugConfiguration(T,f,S)})}$resolveDebugConfigurationWithSubstitutedVariables(c,w,f,S){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(c);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const T=await this.getFolder(w);return R.resolveDebugConfigurationWithSubstitutedVariables(T,f,S)})}async $provideDebugAdapter(c,w){const f=this.getAdapterDescriptorFactoryByHandle(c);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.getSession(w);return this.getAdapterDescriptor(f,S).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(c){const w=await this.getSession(c);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(c){const w=await this.getSession(c);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,w){const f=await this.getSession(c);f&&f._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(c,w){const S={session:await this.getSession(c),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(S)}convertToDto(c){if(c instanceof k.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof k.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const w=this._adapterFactories.filter(f=>f.type===c);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(c){const w=this._adapterFactories.filter(f=>f.handle===c);if(w.length>0)return w[0].factory}getConfigProviderByHandle(c){const w=this._configProviders.filter(f=>f.handle===c);if(w.length>0)return w[0].provider}definesDebugType(c,w){if(c.contributes){const f=c.contributes.debuggers;if(f&&f.length>0){for(const S of f)if(S.label&&S.type&&S.type===w)return!0}}return!1}getDebugAdapterTrackers(c){const f=c.configuration.type,S=this._trackerFactories.filter(R=>R.type===f||R.type==="*").map(R=>(0,A.asPromise)(()=>R.factory.createDebugAdapterTracker(c)).then(T=>T,T=>null));return Promise.race([Promise.all(S).then(R=>{const T=R.filter(L=>!!L);if(T.length>0)return new a(T)}),new Promise((R,T)=>{const L=setTimeout(()=>{clearTimeout(L),T(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(c,w){const f=w.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new k.DebugAdapterServer(f));if(c){const R=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>c.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,R))).then(T=>{if(T)return T})}const S=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,S))}daExecutableFromPackage(c,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,w,f){(c.length>0||w.length>0||f.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:w,changed:f}))}async getSession(c){if(c)if(typeof c=="string"){const w=this._debugSessions.get(c);if(w)return w}else{let w=this._debugSessions.get(c.id);if(!w){const f=await this.getFolder(c.folderUri),S=c.parent?this._debugSessions.get(c.parent):void 0;w=new C(this._debugServiceProxy,c.id,c.type,c.name,f,c.configuration,S),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(c){if(c){const w=M.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};h=$e([ze(0,u.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,y.IExtHostDocumentsAndEditors),ze(4,m.IExtHostConfiguration),ze(5,o.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class C{constructor(c,w,f,S,R,T,L){this._debugServiceProxy=c,this._id=w,this._type=f,this._name=S,this._workspaceFolder=R,this._configuration=T,this._parentSession=L}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,w)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=C;class i{constructor(c){this.value=Object.freeze({append(w){c.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=i;class p extends n.AbstractVariableResolverService{constructor(c,w,f,S,R){function T(){if(w){const L=w.activeEditor();if(L)return L.document.uri;const b=S.tabs.filter(x=>x.isActive);if(b.length>0){const x=b[0].resource;return x&&(x.primary||x.secondary)?x.primary??x.secondary:b[0].resource}}}super({getFolderUri:L=>{const b=c.filter(x=>x.name===L);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(L,b)=>f.getConfiguration(void 0,L).get(b),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const L=T();if(L)return d.normalize(L.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const L=T();if(L){const b=R.getWorkspaceFolder(L);if(b)return d.normalize(b.uri.fsPath)}}},getSelectedText:()=>{if(w){const L=w.activeEditor();if(L&&!L.selection.isEmpty)return L.document.getText(L.selection)}},getLineNumber:()=>{if(w){const L=w.activeEditor();if(L)return String(L.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=p;class a{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(w=>w.onError?w.onError(c):void 0)}onExit(c,w){this.trackers.forEach(f=>f.onExit?f.onExit(c,w):void 0)}}class r extends D.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let v=class extends h{constructor(c,w,f,S,R,T){super(c,w,f,S,R,T)}createVariableResolver(c,w,f){return new p(c,w,f,this._editorTabs)}};v=$e([ze(0,u.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,y.IExtHostDocumentsAndEditors),ze(4,m.IExtHostConfiguration),ze(5,o.IExtHostEditorTabs)],v),e.WorkerExtHostDebugService=v}),define(be[219],Ee([0,1,75,2,5,32,30,26,13,29,4,33,91,15]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(o,h,C,i,p,a,r){this._apiFactory=o,this._extensionRegistry=h,this._instaService=C,this._extHostConfiguration=i,this._extHostExtensionService=p,this._initData=a,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,h,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(g,h)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(I,h,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let h of o.nodeModuleName)this._factories.set(h,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(h=>o.alternativeModuleName(h))}};s=$e([ze(2,t.IInstantiationService),ze(3,A.IExtHostConfiguration),ze(4,y.IExtHostExtensionService),ze(5,P.IExtHostInitDataService),ze(6,m.ILogService)],s),e.RequireInterceptor=s;class u{constructor(o,h,C,i,p){this._apiFactory=o,this._extensionPaths=h,this._extensionRegistry=C,this._configProvider=i,this._logService=p,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,h){const C=this._extensionPaths.findSubstr(h);if(C){let i=this._extApiImpl.get(k.ExtensionIdentifier.toKey(C.identifier));return i||(i=this._apiFactory(C,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(C.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((p,a)=>i+=`	${a} -> ${p.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(F.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(o,h,C){this._extensionPaths=o,this.nodeModuleName="keytar",this._mainThreadTelemetry=h.getProxy(_.MainContext.MainThreadTelemetry);const{environment:i}=C,p=h.getProxy(_.MainContext.MainThreadKeytar);if(i.appRoot){let a=i.appRoot.fsPath;n.platform==="win32"&&(a=a.replace(/\\/g,"/")),a[a.length-1]==="/"&&(a=a.substr(0,a.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${a}/node_modules.asar/keytar`),this.alternativeNames.add(`${a}/node_modules/keytar`)}this._impl={getPassword:(a,r)=>p.$getPassword(a,r),setPassword:(a,r,v)=>p.$setPassword(a,r,v),deletePassword:(a,r)=>p.$deletePassword(a,r),findPassword:a=>p.$findPassword(a),findCredentials(a){return p.$findCredentials(a)}}}load(o,h){const C=this._extensionPaths.findSubstr(h);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:C?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(o){const h=o.length;if(h<=7||!this.alternativeNames)return;const C=h-7;if((o.charAt(C)==="/"||o.charAt(C)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};g=$e([ze(1,D.IExtHostRpcService),ze(2,P.IExtHostInitDataService)],g);let I=class{constructor(o,h,C){this._extensionPaths=o,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=C.getProxy(_.MainContext.MainThreadTelemetry);const i=C.getProxy(_.MainContext.MainThreadWindow);this._impl=(p,a)=>{const r=M.URI.parse(p);return a?this.callOriginal(p,a):r.scheme==="http"||r.scheme==="https"?i.$openUri(r,p,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?i.$openUri(r,p,{}):this.callOriginal(p,a)}}load(o,h,C){const i=this._extensionPaths.findSubstr(h);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=C(o),this._impl}callOriginal(o,h){return this.sendNoForwardTelemetry(),this._original(o,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};I=$e([ze(2,D.IExtHostRpcService)],I)}),define(be[220],Ee([0,1,12,16,75,6,2,5,213,15,57,61,29,143,13,66,33,40]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(h,C,i,p){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new D.RPCProtocol(h,null,p),C=E._transform(C,this._rpcProtocol);const a=new y.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());a.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...C}),a.set(s.IExtHostRpcService,new s.ExtHostRpcService(this._rpcProtocol)),a.set(u.IURITransformerService,new u.URITransformerService(p)),a.set(g.IHostUtils,i);const r=new m.InstantiationService(a,!0),v=r.invokeFunction(f=>f.get(I.IExtHostTerminalService));this._disposables.add(v),this._logService=r.invokeFunction(f=>f.get(P.ILogService)),_.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",C),this._extensionService=r.invokeFunction(f=>f.get(g.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const l=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(S,R)=>{let T="",L,b;for(const x of R)T+=`
	at ${x.toString()}`,b=x.getFileName(),!L&&b&&(L=f.findSubstr(F.URI.file(b)));return l.set(S,L),`${S.name||"Error"}: ${S.message||""}${T}`}});const c=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),w=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(f=>{const S=M.transformErrorForSerialization(f),R=l.get(f);R?c.$onExtensionRuntimeError(R.identifier,S):w.$onUnexpectedError(S)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const C=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,d.timeout)(4e3),C]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,C){h.extensions.forEach(p=>p.extensionLocation=F.URI.revive(C.transformIncomingURIs(p.extensionLocation))),h.environment.appRoot=F.URI.revive(C.transformIncomingURIs(h.environment.appRoot));const i=h.environment.extensionDevelopmentLocationURI;return i&&(h.environment.extensionDevelopmentLocationURI=i.map(p=>F.URI.revive(C.transformIncomingURIs(p)))),h.environment.extensionTestsLocationURI=F.URI.revive(C.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=F.URI.revive(C.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=F.URI.revive(C.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=F.URI.revive(C.transformIncomingURIs(h.logsLocation)),h.logFile=F.URI.revive(C.transformIncomingURIs(h.logFile)),h.workspace=C.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=E}),define(be[221],Ee([0,1,17,21,45,27,24,194,41]),function(oe,e,d,M,_,A,F,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(n,m,s){this.config=n,this.provider=m,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&A.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&A.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const m=this.config.folderQueries||[];return new Promise((s,u)=>{const g=I=>{this.resultCount++,n(I)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(I=>{const E=I.toString(),o=d.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,o)||this.matchFile(g,{base:I,basename:o})}),Promise.all(m.map(I=>this.searchInFolder(I,g))).then(I=>{s({limitHit:this.isLimitHit,stats:I[0]||void 0})},I=>{u(new Error((0,_.toErrorMessage)(I)))})})}async searchInFolder(n,m){const s=new M.CancellationTokenSource,u=this.getSearchOptionsForFolder(n),g=this.initDirectoryTree(),I=new D.QueryGlobTester(this.config,n),E=!I.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(s),o=k.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,s.token),C=o.elapsed(),i=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(p=>{const a=d.posix.relative(n.folder.path,p.path);if(E){const r=d.basename(p.path);this.matchFile(m,{base:n.folder,relativePath:a,basename:r});return}this.addDirectoryEntries(g,n.folder,a,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,I,m),{providerTime:C,postProcessTime:i.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(n){const m=(0,D.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),s=(0,D.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:s,includes:m,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},m,s,u){if(s===this.filePattern){const I=d.basename(this.filePattern);this.matchFile(u,{base:m,relativePath:this.filePattern,basename:I})}function g(I){const E=d.basename(I),o=d.dirname(I);let h=n[o];h||(h=n[o]=[],g(o)),h.push({base:m,relativePath:I,basename:E})}g(s)}matchDirectoryTree({rootEntries:n,pathToEntries:m},s,u){const g=this,I=this.filePattern;function E(o){const h=A.hasSiblingFn(()=>o.map(C=>C.basename));for(let C=0,i=o.length;C<i;C++){const p=o[C],{relativePath:a,basename:r}=p;if(s.matchesExcludesSync(a,r,I!==r?h:void 0))continue;const v=m[a];if(v)E(v);else{if(a===I)continue;g.matchFile(u,p)}if(g.isLimitHit)break}}E(n)}matchFile(n,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(m))}}class t{constructor(){this.sessions=new Map}fileSearch(n,m,s,u){const g=this.getSessionTokenSource(n.cacheKey),I=new P(n,m,g&&g.token);let E=0;const o=h=>{E+=h.length,s(h.map(C=>this.rawMatchToSearchItem(C)))};return this.doSearch(I,t.BATCH_SIZE,o,u).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:h.stats}}))}clearCache(n){const m=this.getSessionTokenSource(n);m&&m.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:F.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,m,s,u){u.onCancellationRequested(()=>{n.cancel()});const g=E=>{E&&(I.push(E),m>0&&I.length>=m&&(s(I),I=[]))};let I=[];return n.search(g).then(E=>(I.length&&s(I),E),E=>(I.length&&s(I),Promise.reject(E)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(be[222],Ee([0,1,14,21,45,27,11,17,24,10,2,41]),function(oe,e,d,M,_,A,F,k,D,P,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(o,h,C,i){this.query=o,this.provider=h,this.fileUtils=C,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,h){const C=this.query.folderQueries||[],i=new M.CancellationTokenSource;return h.onCancellationRequested(()=>i.cancel()),new Promise((p,a)=>{this.collector=new s(o);let r=!1;const v=(l,c)=>{if(!r&&!this.isLimitHit){const w=this.resultSize(l);g(l)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,r=!0,i.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const f=this.resultSize(l);this.resultCount+=f,(f>0||!g(l))&&this.collector.add(l,c)}};Promise.all(C.map((l,c)=>this.searchInFolder(l,w=>v(w,c),i.token))).then(l=>{i.dispose(),this.collector.flush();const c=l.some(w=>!!w&&!!w.limitHit);p({limitHit:this.isLimitHit||c,messages:(0,d.flatten)(l.map(w=>w?.message?(0,P.isArray)(w.message)?w.message:[w.message]:[])),stats:{type:this.processType}})},l=>{i.dispose();const c=(0,_.toErrorMessage)(l);a(new Error(c))})})}resultSize(o){return g(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,h){const C=Array.isArray(o.ranges)?o.ranges:[o.ranges],i=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:C.slice(0,h),preview:{matches:i.slice(0,h),text:o.preview.text},uri:o.uri}}async searchInFolder(o,h,C){const i=new y.QueryGlobTester(this.query,o),p=[],a={report:l=>{if(!this.validateProviderResult(l))return;const c=o.folder.scheme===F.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(l.uri))):void 0,w=D.relativePath(o.folder,l.uri);if(w){const f=i.includedInQuery(w,k.basename(w),c);(0,P.isPromise)(f)?p.push(f.then(S=>{S&&h(l)})):f&&h(l)}}},r=this.getSearchOptionsForFolder(o),v=await this.provider.provideTextSearchResults(m(this.query.contentPattern),r,a,C);return p.length&&await Promise.all(p),v}validateProviderResult(o){if(g(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const h=(0,y.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),C=(0,y.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),i={folder:t.URI.from(o.folder),excludes:C,includes:h,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function m(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class s{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new I(512,h=>this.sendItems(h))}add(o,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!D.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(u(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=s;function u(E){return g(E)?{preview:{matches:(0,d.mapArrayOrNot)(E.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:E.preview.text},ranges:(0,d.mapArrayOrNot)(E.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function g(E){return!!E.preview}e.extensionResultIsMatch=g;class I{constructor(o,h){this.maxBatchSize=o,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,h){!o||this.addItemToBatch(o,h)}addItems(o,h){!o||this.addItemsToBatch(o,h)}addItemToBatch(o,h){this.batch.push(o),this.batchSize+=h,this.onUpdate()}addItemsToBatch(o,h){this.batch=this.batch.concat(o),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<I.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},I.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=I,I.TIMEOUT=4e3,I.START_BATCH_AFTER_COUNT=50}),define(be[101],Ee([0,1,6,5,4,221,13,66,15,2,222]),function(oe,e,d,M,_,A,F,k,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,_.createDecorator)("IExtHostSearch");let y=class{constructor(u,g,I){this.extHostRpc=u,this._uriTransformer=g,this._logService=I,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,g){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const I=this._handlePool++;return this._textSearchProvider.set(I,g),this._proxy.$registerTextSearchProvider(I,this._transformScheme(u)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}registerFileSearchProvider(u,g){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const I=this._handlePool++;return this._fileSearchProvider.set(I,g),this._proxy.$registerFileSearchProvider(I,this._transformScheme(u)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}$provideFileSearchResults(u,g,I,E){const o=n(I),h=this._fileSearchProvider.get(u);if(h)return this._fileSearchManager.fileSearch(o,h,C=>{this._proxy.$handleFileMatch(u,g,C.map(i=>i.resource))},E);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,g,I,E){const o=this._textSearchProvider.get(u);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const h=n(I);return this.createTextSearchManager(h,o).search(i=>this._proxy.$handleTextMatch(u,g,i),E)}$enableExtensionHostSearch(){}createTextSearchManager(u,g){return new t.TextSearchManager(u,g,{readdir:I=>Promise.resolve([]),toCanonicalName:I=>I},"textSearchProvider")}};y=$e([ze(0,F.IExtHostRpcService),ze(1,k.IURITransformerService),ze(2,D.ILogService)],y),e.ExtHostSearch=y;function n(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(m),extraFileResources:s.extraFileResources&&s.extraFileResources.map(u=>P.URI.revive(u))}}e.reviveQuery=n;function m(s){return{...s,folder:P.URI.revive(s.folder)}}}),define(be[223],Ee([0,1,21,16,3,35,2,117,80,113,56,60,5,184,183,39,185,32,186,187,188,170,189,50,33,190,171,193,195,196,96,173,201,202,203,73,40,205,174,8,7,208,51,97,31,30,52,160,192,63,95,99,100,101,15,66,13,29,197,157,65,70,181,206,156,74,72,211,209,210,182,37,204,207,69,71,87,199,98,200,11,145,198,154,191]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g,I,E,o,h,C,i,p,a,r,v,l,c,w,f,S,R,T,L,b,x,$,B,G,H,W,ne,V,Y,j,le,re,ve,Fe,Me,Oe,Ke,je,Ve,U,Q,ee,ae,K,se,he,Ae,Ue,He,Qe,et,st,ye,nt,q,Z,pe,We,Ye,rt,mt,ut,St,Tt,It,Xe,vt,Pe,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(te){const ue=te.get(ee.IExtHostInitDataService),me=te.get(Z.IExtHostFileSystemInfo),fe=te.get(et.IExtHostConsumerFileSystem),Ie=te.get(a.IExtHostExtensionService),Be=te.get(Y.IExtHostWorkspace),Ne=te.get(mt.IExtHostTelemetry),qe=te.get(I.IExtHostConfiguration),it=te.get(U.IURITransformerService),Le=te.get(Q.IExtHostRpcService),de=te.get(b.IExtHostStorage),ge=te.get(Qe.IExtensionStoragePaths),X=te.get(Ve.ILogService),z=te.get(se.IExtHostTunnelService),we=te.get(he.IExtHostApiDeprecationService),ke=te.get(V.IExtHostWindow),Je=te.get(Ye.IExtHostSecretState),xe=te.get(rt.IExtHostEditorTabs);Le.set(n.ExtHostContext.ExtHostFileSystemInfo,me),Le.set(n.ExtHostContext.ExtHostLogService,X),Le.set(n.ExtHostContext.ExtHostWorkspace,Be),Le.set(n.ExtHostContext.ExtHostConfiguration,qe),Le.set(n.ExtHostContext.ExtHostExtensionService,Ie),Le.set(n.ExtHostContext.ExtHostStorage,de),Le.set(n.ExtHostContext.ExtHostTunnelService,z),Le.set(n.ExtHostContext.ExtHostWindow,ke),Le.set(n.ExtHostContext.ExtHostSecretState,Je),Le.set(n.ExtHostContext.ExtHostTelemetry,Ne),Le.set(n.ExtHostContext.ExtHostEditorTabs,xe);const ct=Le.set(n.ExtHostContext.ExtHostDecorations,te.get(Me.IExtHostDecorations)),pt=Le.set(n.ExtHostContext.ExtHostDocumentsAndEditors,te.get(p.IExtHostDocumentsAndEditors)),dt=Le.set(n.ExtHostContext.ExtHostCommands,te.get(u.IExtHostCommands)),ht=Le.set(n.ExtHostContext.ExtHostTerminalService,te.get(x.IExtHostTerminalService)),ft=Le.set(n.ExtHostContext.ExtHostDebugService,te.get(Ke.IExtHostDebugService)),_t=Le.set(n.ExtHostContext.ExtHostSearch,te.get(je.IExtHostSearch)),yt=Le.set(n.ExtHostContext.ExtHostTask,te.get(Oe.IExtHostTask)),Pt=Le.set(n.ExtHostContext.ExtHostOutputService,te.get(f.IExtHostOutputService)),Nt=Le.set(n.ExtHostContext.ExtHostUrls,new W.ExtHostUrls(Le)),Ct=Le.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Le,pt)),xt=Le.set(n.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(Le,pt,X)),$t=Le.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new C.ExtHostDocumentSaveParticipant(X,Ct,Le.getProxy(n.MainContext.MainThreadBulkEdits))),bt=Le.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Le,dt,pt,Ct,ge)),Qt=Le.set(n.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(X,bt)),zt=Le.set(n.ExtHostContext.ExtHostNotebookEditors,new vt.ExtHostNotebookEditors(X,Le,bt)),ii=Le.set(n.ExtHostContext.ExtHostNotebookKernels,new ut.ExtHostNotebookKernels(Le,ue,bt,dt,X)),ni=Le.set(n.ExtHostContext.ExtHostNotebookRenderers,new Tt.ExtHostNotebookRenderers(Le,bt)),At=Le.set(n.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(Le,pt)),Yt=Le.set(n.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Le.getProxy(n.MainContext.MainThreadTreeViews),dt,X)),ri=Le.set(n.ExtHostContext.ExtHostEditorInsets,new re.ExtHostEditorInsets(Le.getProxy(n.MainContext.MainThreadEditorInsets),At,ue)),Jt=Le.set(n.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Le,X,me)),Wt=Le.set(n.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(Le,Ct,dt.converter,it)),gt=Le.set(n.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(Le,it,Ct,dt,Jt,X,we)),si=Le.set(n.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Le,gt)),Mt=Le.set(n.ExtHostContext.ExtHostFileSystemEventService,new v.ExtHostFileSystemEventService(Le,X,pt)),Vt=Le.set(n.ExtHostContext.ExtHostQuickOpen,(0,R.createExtHostQuickOpen)(Le,Be,dt)),Xt=Le.set(n.ExtHostContext.ExtHostSCM,new T.ExtHostSCM(Le,dt,X)),oi=Le.set(n.ExtHostContext.ExtHostComments,(0,g.createExtHostComments)(Le,dt,Ct)),di=Le.set(n.ExtHostContext.ExtHostProgress,new S.ExtHostProgress(Le.getProxy(n.MainContext.MainThreadProgress))),wi=Le.set(n.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(Le)),hi=Le.set(n.ExtHostContext.ExtHostTheming,new K.ExtHostTheming(Le)),Zt=Le.set(n.ExtHostContext.ExtHostAuthentication,new Ae.ExtHostAuthentication(Le)),bi=Le.set(n.ExtHostContext.ExtHostTimeline,new Ue.ExtHostTimeline(Le,dt)),jt=Le.set(n.ExtHostContext.ExtHostWebviews,new ne.ExtHostWebviews(Le,{remote:ue.remote},Be,X,we)),qt=Le.set(n.ExtHostContext.ExtHostWebviewPanels,new nt.ExtHostWebviewPanels(Le,jt,Be)),Ei=Le.set(n.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(Le,Ct,ge,jt,qt)),_i=Le.set(n.ExtHostContext.ExtHostWebviewViews,new st.ExtHostWebviewViews(Le,jt)),Gt=Le.set(n.ExtHostContext.ExtHostTesting,new pe.ExtHostTesting(Le,dt)),yi=Le.set(n.ExtHostContext.ExtHostUriOpeners,new We.ExtHostUriOpeners(Le));Le.set(n.ExtHostContext.ExtHostInteractive,new Se.ExtHostInteractive(Le,bt,pt,dt));const ei=(0,le.values)(n.ExtHostContext);Le.assertRegistered(ei);const Si=new q.ExtHostBulkEdits(Le,pt),Di=new s.ExtHostClipboard(Le),Kt=new w.ExtHostMessageService(Le,X),fi=new o.ExtHostDialogs(Le),Ht=new L.ExtHostStatusBar(Le,dt.converter);return m.ExtHostApiCommands.register(dt),function(Te,ai,Ft){const wt=function(){let J=!Te.isUnderDevelopment;function ce(De){J||(X.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function De(at){if(Array.isArray(at))at.forEach(De);else if(typeof at=="string")ce(at);else{const Et=at;typeof Et.scheme=="undefined"&&ce(at),!Te.enableProposedApi&&typeof Et.exclusive=="boolean"&&(0,j.throwProposedApiError)(Te)}return at}}(),Ci={getSession(J,ce,De){return(De?.forceNewSession||De?.silent)&&(0,j.checkProposedApiEnabled)(Te),Zt.getSession(Te,J,ce,De)},async hasSession(J,ce){return(0,j.checkProposedApiEnabled)(Te),!!await Zt.getSession(Te,J,ce,{solelyCheckExistence:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(J,ce,De,at){return Zt.registerAuthenticationProvider(J,ce,De,at)}},ki={registerCommand(J,ce,De){return dt.registerCommand(!0,J,ce,De,void 0,Te)},registerTextEditorCommand(J,ce,De){return dt.registerCommand(!0,J,(...at)=>{const Et=At.getActiveTextEditor();if(!Et){X.warn("Cannot execute "+J+" because there is no active text editor.");return}return Et.edit(kt=>{ce.apply(De,[Et,kt,...at])}).then(kt=>{kt||X.warn("Edits from command "+J+" were not applied.")},kt=>{X.warn("An error occurred while running command "+J,kt)})},void 0,void 0,Te)},registerDiffInformationCommand:(J,ce,De)=>((0,j.checkProposedApiEnabled)(Te),dt.registerCommand(!0,J,async(...at)=>{const Et=pt.activeEditor(!0);if(!Et){X.warn("Cannot execute "+J+" because there is no active text editor.");return}const kt=await At.getDiffInformation(Et.id);ce.apply(De,[kt,...at])},void 0,void 0,Te)),executeCommand(J,...ce){return dt.executeCommand(J,...ce)},getCommands(J=!1){return dt.getCommands(J)}},mi={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return Di.value},get shell(){return ht.getDefaultShell(!1)},get isTelemetryEnabled(){return Ne.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ne.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,ce){return ke.openUri(J,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===ue.environment.appUriScheme)return Nt.createAppUri(J);try{return await ke.asExternalUri(J,{allowTunneling:!!ue.remote.authority})}catch(ce){if((0,Xe.matchesScheme)(J,It.Schemas.http)||(0,Xe.matchesScheme)(J,It.Schemas.https))return J;throw ce}},get remoteName(){return(0,Fe.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,j.checkProposedApiEnabled)(Te),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=ue.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Ii={createTestController(J,ce){return Gt.createTestController(J,ce)},createTestObserver(){return(0,j.checkProposedApiEnabled)(Te),Gt.createTestObserver()},runTests(J){return(0,j.checkProposedApiEnabled)(Te),Gt.runTests(J)},get onDidChangeTestResults(){return(0,j.checkProposedApiEnabled)(Te),Gt.onResultsChanged},get testResults(){return(0,j.checkProposedApiEnabled)(Te),Gt.results}},Pi={getExtension(J){const ce=ai.getExtensionDescription(J);if(ce)return new a.Extension(Ie,Te.identifier,ce,gi)},get all(){return ai.getAllExtensionDescriptions().map(J=>new a.Extension(Ie,Te.identifier,J,gi))},get onDidChange(){return ai.onDidChange}},Ti={createDiagnosticCollection(J){return Jt.createDiagnosticCollection(Te.identifier,J)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:J=>Jt.getDiagnostics(J),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(J,ce){return Wt.changeLanguage(J.uri,ce)},match(J,ce){return(0,t.score)(G.LanguageSelector.from(J),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(J,ce,De){return gt.registerCodeActionProvider(Te,wt(J),ce,De)},registerCodeLensProvider(J,ce){return gt.registerCodeLensProvider(Te,wt(J),ce)},registerDefinitionProvider(J,ce){return gt.registerDefinitionProvider(Te,wt(J),ce)},registerDeclarationProvider(J,ce){return gt.registerDeclarationProvider(Te,wt(J),ce)},registerImplementationProvider(J,ce){return gt.registerImplementationProvider(Te,wt(J),ce)},registerTypeDefinitionProvider(J,ce){return gt.registerTypeDefinitionProvider(Te,wt(J),ce)},registerHoverProvider(J,ce){return gt.registerHoverProvider(Te,wt(J),ce,Te.identifier)},registerEvaluatableExpressionProvider(J,ce){return gt.registerEvaluatableExpressionProvider(Te,wt(J),ce,Te.identifier)},registerInlineValuesProvider(J,ce){return gt.registerInlineValuesProvider(Te,wt(J),ce,Te.identifier)},registerDocumentHighlightProvider(J,ce){return gt.registerDocumentHighlightProvider(Te,wt(J),ce)},registerLinkedEditingRangeProvider(J,ce){return gt.registerLinkedEditingRangeProvider(Te,wt(J),ce)},registerReferenceProvider(J,ce){return gt.registerReferenceProvider(Te,wt(J),ce)},registerRenameProvider(J,ce){return gt.registerRenameProvider(Te,wt(J),ce)},registerDocumentSymbolProvider(J,ce,De){return gt.registerDocumentSymbolProvider(Te,wt(J),ce,De)},registerWorkspaceSymbolProvider(J){return gt.registerWorkspaceSymbolProvider(Te,J)},registerDocumentFormattingEditProvider(J,ce){return gt.registerDocumentFormattingEditProvider(Te,wt(J),ce)},registerDocumentRangeFormattingEditProvider(J,ce){return gt.registerDocumentRangeFormattingEditProvider(Te,wt(J),ce)},registerOnTypeFormattingEditProvider(J,ce,De,...at){return gt.registerOnTypeFormattingEditProvider(Te,wt(J),ce,[De].concat(at))},registerDocumentSemanticTokensProvider(J,ce,De){return gt.registerDocumentSemanticTokensProvider(Te,wt(J),ce,De)},registerDocumentRangeSemanticTokensProvider(J,ce,De){return gt.registerDocumentRangeSemanticTokensProvider(Te,wt(J),ce,De)},registerSignatureHelpProvider(J,ce,De,...at){return typeof De=="object"?gt.registerSignatureHelpProvider(Te,wt(J),ce,De):gt.registerSignatureHelpProvider(Te,wt(J),ce,typeof De=="undefined"?[]:[De,...at])},registerCompletionItemProvider(J,ce,...De){return gt.registerCompletionItemProvider(Te,wt(J),ce,De)},registerInlineCompletionItemProvider(J,ce){return(0,j.checkProposedApiEnabled)(Te),gt.registerInlineCompletionsProvider(Te,wt(J),ce)},registerDocumentLinkProvider(J,ce){return gt.registerDocumentLinkProvider(Te,wt(J),ce)},registerColorProvider(J,ce){return gt.registerColorProvider(Te,wt(J),ce)},registerFoldingRangeProvider(J,ce){return gt.registerFoldingRangeProvider(Te,wt(J),ce)},registerSelectionRangeProvider(J,ce){return gt.registerSelectionRangeProvider(Te,J,ce)},registerCallHierarchyProvider(J,ce){return gt.registerCallHierarchyProvider(Te,J,ce)},registerTypeHierarchyProvider(J,ce){return gt.registerTypeHierarchyProvider(Te,J,ce)},setLanguageConfiguration:(J,ce)=>gt.setLanguageConfiguration(Te,J,ce),getTokenInformationAtPosition(J,ce){return(0,j.checkProposedApiEnabled)(Te),Wt.tokenAtPosition(J,ce)},registerInlayHintsProvider(J,ce){return(0,j.checkProposedApiEnabled)(Te),gt.registerInlayHintsProvider(Te,J,ce)},createLanguageStatusItem(J,ce){return(0,j.checkProposedApiEnabled)(Te),Wt.createLanguageStatusItem(Te,J,ce)}},li={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(J,ce,De){const at=await(F.URI.isUri(J)?Promise.resolve(pi.openTextDocument(J)):Promise.resolve(J));return At.showTextDocument(at,ce,De)},createTextEditorDecorationType(J){return At.createTextEditorDecorationType(Te,J)},onDidChangeActiveTextEditor(J,ce,De){return At.onDidChangeActiveTextEditor(J,ce,De)},onDidChangeVisibleTextEditors(J,ce,De){return At.onDidChangeVisibleTextEditors(J,ce,De)},onDidChangeTextEditorSelection(J,ce,De){return At.onDidChangeTextEditorSelection(J,ce,De)},onDidChangeTextEditorOptions(J,ce,De){return At.onDidChangeTextEditorOptions(J,ce,De)},onDidChangeTextEditorVisibleRanges(J,ce,De){return At.onDidChangeTextEditorVisibleRanges(J,ce,De)},onDidChangeTextEditorViewColumn(J,ce,De){return At.onDidChangeTextEditorViewColumn(J,ce,De)},onDidCloseTerminal(J,ce,De){return ht.onDidCloseTerminal(J,ce,De)},onDidOpenTerminal(J,ce,De){return ht.onDidOpenTerminal(J,ce,De)},onDidChangeActiveTerminal(J,ce,De){return ht.onDidChangeActiveTerminal(J,ce,De)},onDidChangeTerminalDimensions(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),ht.onDidChangeTerminalDimensions(J,ce,De)},onDidChangeTerminalState(J,ce,De){return ht.onDidChangeTerminalState(J,ce,De)},onDidWriteTerminalData(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),ht.onDidWriteTerminalData(J,ce,De)},get state(){return ke.state},onDidChangeWindowState(J,ce,De){return ke.onDidChangeWindowState(J,ce,De)},showInformationMessage(J,...ce){return Kt.showMessage(Te,A.default.Info,J,ce[0],ce.slice(1))},showWarningMessage(J,...ce){return Kt.showMessage(Te,A.default.Warning,J,ce[0],ce.slice(1))},showErrorMessage(J,...ce){return Kt.showMessage(Te,A.default.Error,J,ce[0],ce.slice(1))},showQuickPick(J,ce,De){return Vt.showQuickPick(J,!!Te.enableProposedApi,ce,De)},showWorkspaceFolderPick(J){return Vt.showWorkspaceFolderPick(J)},showInputBox(J,ce){return Vt.showInput(J,ce)},showOpenDialog(J){return fi.showOpenDialog(J)},showSaveDialog(J){return fi.showSaveDialog(J)},createStatusBarItem(J,ce,De){let at,Et,kt;return typeof J=="string"?(at=J,Et=ce,kt=De):(Et=J,kt=ce),Ht.createStatusBarEntry(Te,at,Et,kt)},setStatusBarMessage(J,ce){return Ht.setStatusBarMessage(J,ce)},withScmProgress(J){return we.report("window.withScmProgress",Te,"Use 'withProgress' instead."),di.withProgress(Te,{location:H.ProgressLocation.SourceControl},(ce,De)=>J({report(at){}}))},withProgress(J,ce){return di.withProgress(Te,J,ce)},createOutputChannel(J){return Pt.createOutputChannel(J,Te)},createWebviewPanel(J,ce,De,at){return qt.createWebviewPanel(Te,J,ce,De,at)},createWebviewTextEditorInset(J,ce,De,at){return(0,j.checkProposedApiEnabled)(Te),ri.createWebviewEditorInset(J,ce,De,at,Te)},createTerminal(J,ce,De){return typeof J=="object"?("location"in J&&(0,j.checkProposedApiEnabled)(Te),"pty"in J?ht.createExtensionTerminal(J):ht.createTerminalFromOptions(J)):ht.createTerminal(J,ce,De)},registerTerminalLinkProvider(J){return ht.registerLinkProvider(J)},registerTerminalProfileProvider(J,ce){return ht.registerProfileProvider(Te,J,ce)},registerTreeDataProvider(J,ce){return Yt.registerTreeDataProvider(J,ce,Te)},createTreeView(J,ce){return Yt.createTreeView(J,ce,Te)},registerWebviewPanelSerializer:(J,ce)=>qt.registerWebviewPanelSerializer(Te,J,ce),registerCustomEditorProvider:(J,ce,De={})=>Ei.registerCustomEditorProvider(Te,J,ce,De),registerFileDecorationProvider(J){return ct.registerFileDecorationProvider(J,Te.identifier)},registerUriHandler(J){return Nt.registerUriHandler(Te.identifier,J)},createQuickPick(){return Vt.createQuickPick(Te.identifier,!!Te.enableProposedApi)},createInputBox(){return Vt.createInputBox(Te.identifier)},get activeColorTheme(){return hi.activeColorTheme},onDidChangeActiveColorTheme(J,ce,De){return hi.onDidChangeActiveColorTheme(J,ce,De)},registerWebviewViewProvider(J,ce,De){return _i.registerWebviewViewProvider(Te,J,ce,De?.webviewOptions)},get activeNotebookEditor(){return(0,j.checkProposedApiEnabled)(Te),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeActiveNotebookEditor(J,ce,De)},get visibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Te),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),zt.onDidChangeNotebookEditorSelection(J,ce,De)},onDidChangeNotebookEditorVisibleRanges(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),zt.onDidChangeNotebookEditorVisibleRanges(J,ce,De)},showNotebookDocument(J,ce){return(0,j.checkProposedApiEnabled)(Te),bt.showNotebookDocument(J,ce)},registerExternalUriOpener(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),yi.registerExternalUriOpener(Te.identifier,J,ce,De)},get tabs(){return(0,j.checkProposedApiEnabled)(Te),xe.tabs},get activeTab(){return(0,j.checkProposedApiEnabled)(Te),xe.activeTab},get onDidChangeTabs(){return(0,j.checkProposedApiEnabled)(Te),xe.onDidChangeTabs},get onDidChangeActiveTab(){return(0,j.checkProposedApiEnabled)(Te),xe.onDidChangeActiveTab},getInlineCompletionItemController(J){return(0,j.checkProposedApiEnabled)(Te),l.InlineCompletionController.get(J)}},pi={get rootPath(){return we.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Be.getPath()},set rootPath(J){throw M.readonly()},getWorkspaceFolder(J){return Be.getWorkspaceFolder(J)},get workspaceFolders(){return Be.getWorkspaceFolders()},get name(){return Be.name},set name(J){throw M.readonly()},get workspaceFile(){return Be.workspaceFile},set workspaceFile(J){throw M.readonly()},updateWorkspaceFolders:(J,ce,...De)=>Be.updateWorkspaceFolders(Te,J,ce||0,...De),onDidChangeWorkspaceFolders:function(J,ce,De){return Be.onDidChangeWorkspace(J,ce,De)},asRelativePath:(J,ce)=>Be.getRelativePath(J,ce),findFiles:(J,ce,De,at)=>Be.findFiles(G.GlobPattern.from(J),G.GlobPattern.from(ce),De,Te.identifier,at),findTextInFiles:(J,ce,De,at)=>{let Et,kt;return typeof ce=="object"?(Et=ce,kt=De):(Et={},kt=ce,at=De),Be.findTextInFiles(J,Et||{},kt,Te.identifier,at)},saveAll:J=>Be.saveAll(J),applyEdit(J){return Si.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,ce,De,at)=>Mt.createFileSystemWatcher(G.GlobPattern.from(J),ce,De,at),get textDocuments(){return Ct.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw M.readonly()},openTextDocument(J){let ce;const De=J;if(typeof J=="string")ce=Promise.resolve(F.URI.file(J));else if(F.URI.isUri(J))ce=Promise.resolve(J);else if(!De||typeof De=="object")ce=Ct.createDocumentData(De);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(at=>Ct.ensureDocumentData(at).then(Et=>Et.document))},onDidOpenTextDocument:(J,ce,De)=>Ct.onDidAddDocument(J,ce,De),onDidCloseTextDocument:(J,ce,De)=>Ct.onDidRemoveDocument(J,ce,De),onDidChangeTextDocument:(J,ce,De)=>Ct.onDidChangeDocument(J,ce,De),onDidSaveTextDocument:(J,ce,De)=>Ct.onDidSaveDocument(J,ce,De),onWillSaveTextDocument:(J,ce,De)=>$t.getOnWillSaveTextDocumentEvent(Te)(J,ce,De),get notebookDocuments(){return bt.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,ce){let De;if(F.URI.isUri(J))De=J,await bt.openNotebookDocument(J);else if(typeof J=="string")De=F.URI.revive(await bt.createNotebookDocument({viewType:J,content:ce}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(De).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(J,ce,De,at){return bt.registerNotebookSerializer(Te,J,ce,De,Te.enableProposedApi?at:void 0)},registerNotebookContentProvider:(J,ce,De,at)=>((0,j.checkProposedApiEnabled)(Te),bt.registerNotebookContentProvider(Te,J,ce,De,Te.enableProposedApi?at:void 0)),onDidChangeConfiguration:(J,ce,De)=>Ft.onDidChangeConfiguration(J,ce,De),getConfiguration(J,ce){return ce=arguments.length===1?void 0:ce,Ft.getConfiguration(J,ce,Te)},registerTextDocumentContentProvider(J,ce){return xt.registerTextDocumentContentProvider(J,ce)},registerTaskProvider:(J,ce)=>(we.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Te,J,ce)),registerFileSystemProvider(J,ce,De){return si.registerFileSystemProvider(Te.identifier,J,ce,De)},get fs(){return fe.value},registerFileSearchProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Te),_t.registerFileSearchProvider(J,ce)),registerTextSearchProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Te),_t.registerTextSearchProvider(J,ce)),registerRemoteAuthorityResolver:(J,ce)=>((0,j.checkProposedApiEnabled)(Te),Ie.registerRemoteAuthorityResolver(J,ce)),registerResourceLabelFormatter:J=>((0,j.checkProposedApiEnabled)(Te),wi.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,ce,De)=>Mt.onDidCreateFile(J,ce,De),onDidDeleteFiles:(J,ce,De)=>Mt.onDidDeleteFile(J,ce,De),onDidRenameFiles:(J,ce,De)=>Mt.onDidRenameFile(J,ce,De),onWillCreateFiles:(J,ce,De)=>Mt.getOnWillCreateFileEvent(Te)(J,ce,De),onWillDeleteFiles:(J,ce,De)=>Mt.getOnWillDeleteFileEvent(Te)(J,ce,De),onWillRenameFiles:(J,ce,De)=>Mt.getOnWillRenameFileEvent(Te)(J,ce,De),openTunnel:J=>((0,j.checkProposedApiEnabled)(Te),z.openTunnel(Te,J).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,j.checkProposedApiEnabled)(Te),z.getTunnels()},onDidChangeTunnels:(J,ce,De)=>((0,j.checkProposedApiEnabled)(Te),z.onDidChangeTunnels(J,ce,De)),registerPortAttributesProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Te),z.registerPortsAttributesProvider(J,ce)),registerTimelineProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Te),bi.registerTimelineProvider(J,ce,Te.identifier,dt.converter)),get isTrusted(){return Be.trusted},requestWorkspaceTrust:J=>((0,j.checkProposedApiEnabled)(Te),Be.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,ce,De)=>Be.onDidGrantWorkspaceTrust(J,ce,De)},Ai={get inputBox(){return we.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),Xt.getLastInputBox(Te)},createSourceControl(J,ce,De){return Xt.createSourceControl(Te,J,ce,De)}},Ri={createCommentController(J,ce){return oi.createCommentController(Te,J,ce)}},Fi={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(J,ce,De){return ft.onDidStartDebugSession(J,ce,De)},onDidTerminateDebugSession(J,ce,De){return ft.onDidTerminateDebugSession(J,ce,De)},onDidChangeActiveDebugSession(J,ce,De){return ft.onDidChangeActiveDebugSession(J,ce,De)},onDidReceiveDebugSessionCustomEvent(J,ce,De){return ft.onDidReceiveDebugSessionCustomEvent(J,ce,De)},onDidChangeBreakpoints(J,ce,De){return ft.onDidChangeBreakpoints(J,ce,De)},registerDebugConfigurationProvider(J,ce,De){return ft.registerDebugConfigurationProvider(J,ce,De||H.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,ce){return ft.registerDebugAdapterDescriptorFactory(Te,J,ce)},registerDebugAdapterTrackerFactory(J,ce){return ft.registerDebugAdapterTrackerFactory(J,ce)},startDebugging(J,ce,De){return!De||typeof De=="object"&&"configuration"in De?ft.startDebugging(J,ce,{parentSession:De}):ft.startDebugging(J,ce,De||{})},stopDebugging(J){return ft.stopDebugging(J)},addBreakpoints(J){return ft.addBreakpoints(J)},removeBreakpoints(J){return ft.removeBreakpoints(J)},asDebugSourceUri(J,ce){return ft.asDebugSourceUri(J,ce)}},Mi={registerTaskProvider:(J,ce)=>yt.registerTaskProvider(Te,J,ce),fetchTasks:J=>yt.fetchTasks(J),executeTask:J=>yt.executeTask(Te,J),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(J,ce,De)=>yt.onDidStartTask(J,ce,De),onDidEndTask:(J,ce,De)=>yt.onDidEndTask(J,ce,De),onDidStartTaskProcess:(J,ce,De)=>yt.onDidStartTaskProcess(J,ce,De),onDidEndTaskProcess:(J,ce,De)=>yt.onDidEndTaskProcess(J,ce,De)},Li={createNotebookController(J,ce,De,at,Et){return ii.createNotebookController(Te,J,ce,De,at,Te.enableProposedApi?Et:void 0)},registerNotebookCellStatusBarItemProvider:(J,ce)=>bt.registerNotebookCellStatusBarItemProvider(Te,J,ce),get onDidSaveNotebookDocument(){return(0,j.checkProposedApiEnabled)(Te),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return(0,j.checkProposedApiEnabled)(Te),zt.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return ni.createRendererMessaging(Te,J)},onDidChangeNotebookDocumentMetadata(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),Qt.onDidChangeNotebookDocumentMetadata(J,ce,De)},onDidChangeNotebookCells(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeNotebookCells(J,ce,De)},onDidChangeNotebookCellExecutionState(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeNotebookCellExecutionState(J,ce,De)},onDidChangeCellOutputs(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeCellOutputs(J,ce,De)},onDidChangeCellMetadata(J,ce,De){return(0,j.checkProposedApiEnabled)(Te),bt.onDidChangeCellMetadata(J,ce,De)},createConcatTextDocument(J,ce){return(0,j.checkProposedApiEnabled)(Te),new He.ExtHostNotebookConcatDocument(bt,Ct,J,ce)}};return{version:ue.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:Ti,notebooks:Li,scm:Ai,tasks:Mi,tests:Ii,window:li,workspace:pi,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:H.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:_.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestions,Hover:H.Hover,IndentAction:P.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:n.UIKind,Uri:F.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,InlayHint:H.InlayHint,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:St.TextSearchCompleteMessageType,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ce}),define(be[224],Ee([0,1,57,96,31,95,32,39,50,40,99,100,101,73,65,70,97,72,37,69,87,71]),function(oe,e,d,M,_,A,F,k,D,P,t,y,n,m,s,u,g,I,E,o,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService),(0,d.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,d.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration),(0,d.registerSingleton)(I.IExtHostConsumerFileSystem,I.ExtHostConsumerFileSystem),(0,d.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,d.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,d.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,d.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,d.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,d.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,d.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,d.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,d.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,d.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow),(0,d.registerSingleton)(_.IExtHostWorkspace,_.ExtHostWorkspace),(0,d.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,d.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,d.registerSingleton)(C.IExtHostEditorTabs,C.ExtHostEditorTabs)}),define(be[225],Ee([0,1,223,33,219,7,12,5,11]),function(oe,e,d,M,_,A,F,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var P;(function(s){const u=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(I,...E)=>{E.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const o=E.slice(0,-1).join(","),h=E.pop().toString();return`(function anonymous(${o}) {${h}
})`}});function g(...I){return u?self.eval(u.createScript("",...I)):new Function(...I)}s.create=g})(P||(P={}));class t extends _.RequireInterceptor{_installInterceptor(){}getModule(u,g){for(let I of this._alternatives){let E=I(u);if(E){u=E;break}}if(this._factories.has(u))return this._factories.get(u).load(u,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class y extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const u=this._extHostContext.getProxy(k.MainContext.MainThreadConsole);m(u,this._initData.environment.isExtensionDevelopmentDebug);const g=this._instaService.invokeFunction(d.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,g,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(u){return u.browser}async _loadCommonJSModule(u,g,I){g=g.with({path:n(g.path,".js")}),u&&performance.mark(`code/extHost/willFetchExtensionCode/${u.value}`);const E=await fetch(D.FileAccess.asBrowserUri(g).toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u.value}`),E.status!==200)throw new Error(E.statusText);const o=await E.text(),h=`${g.toString(!0)}#vscode-extension`,C=`${o}
//# sourceURL=${h}`;let i;try{i=P.create(y._ttpExtensionScripts?.createScript("module")??"module",y._ttpExtensionScripts?.createScript("exports")??"exports",y._ttpExtensionScripts?.createScript("require")??"require",y._ttpExtensionScripts?.createScript(C)??C)}catch(v){throw console.error(u?`Loading code for extension ${u.value} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${g.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}const p={},a={exports:p},r=v=>{const l=this._fakeModules.getModule(v,g);if(l===void 0)throw new Error(`Cannot load module '${v}'`);return l};try{return I.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u.value}`),i(a,p,r),a.exports!==p?a.exports:p}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u.value}`),I.codeLoadingStop()}}async $setRemoteEnvironment(u){}async _waitForDebuggerAttachment(u=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+u;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,F.timeout)(10)}}e.ExtHostExtensionService=y,y._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:s=>s});function n(s,u){return s.endsWith(u)?s:s+u}function m(s,u){g("info","log"),g("log","log"),g("warn","warn"),g("error","error");function g(o,h){const C=console[o];console[o]=function(){s.$logExtensionHostMessage({type:"__$console",severity:h,arguments:E(arguments)}),u&&C.apply(console,arguments)}}const I=1e5;function E(o){const h=[],C=[];if(o.length)for(let i=0;i<o.length;i++){if(typeof o[i]=="undefined")o[i]="undefined";else if(o[i]instanceof Error){const p=o[i];p.stack?o[i]=p.stack:o[i]=p.toString()}C.push(o[i])}try{const i=JSON.stringify(C,function(p,a){if(a&&typeof a=="object"){if(h.indexOf(a)!==-1)return"[Circular]";h.push(a)}return a});return i.length>I?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(be[226],Ee([0,1,57,15,33,74,225,212]),function(oe,e,d,M,_,A,F,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(_.IExtHostExtensionService,F.ExtHostExtensionService),(0,d.registerSingleton)(M.ILogService,k.ExtHostLogService),(0,d.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths)}),define(be[236],Ee([0,1,22,3,178,220,214,17,75,11,2,224,226]),function(oe,e,d,M,_,A,F,k,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const m=fetch.bind(self);if(self.fetch=function(o,h){return o instanceof Request||/^file:/i.test(String(o))&&(o=P.FileAccess.asBrowserUri(t.URI.parse(String(o))).toString(!0)),m(o,h)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,h,C,i,p){return/^file:/i.test(h.toString())&&(h=P.FileAccess.asBrowserUri(t.URI.parse(h.toString())).toString(!0)),super.open(o,h,C??!0,i,p)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:C=>C}),h=self.Worker;Worker=function(C,i){/^file:/i.test(C.toString())&&(C=P.FileAccess.asBrowserUri(t.URI.parse(C.toString())).toString(!0));const a=`(${function(c){function w(T){return typeof T=="string"||T instanceof URL?String(T).replace(/^file:\/\//i,"vscode-file://vscode-app"):T}const f=fetch.bind(self);self.fetch=function(T,L){return T instanceof Request?f(T,L):f(w(T),L)},self.XMLHttpRequest=class extends XMLHttpRequest{open(T,L,b,x,$){return super.open(T,w(L),b??!0,x,$)}};const S=importScripts.bind(self);self.importScripts=(...T)=>{S(...T.map(w))};const R=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:T=>T}):void 0;S(R?R.createScriptURL(c):c)}.toString()}('${C}'))`;i=i||{},i.name=i.name||k.basename(C.toString());const r=new Blob([a],{type:"application/javascript"}),v=URL.createObjectURL(r);return new h(o?o.createScriptURL(v):v,i)}}else self.Worker=class extends F.NestedWorker{constructor(o,h){super(n,o,{name:k.basename(o.toString()),...h})}};const s=new class{exit(o){y()}async exists(o){return!0}async realpath(o){return o}};class u{constructor(){const h=new MessageChannel,C=new M.Emitter;let i=!1;n(h.port2,[h.port2]),h.port1.onmessage=p=>{const{data:a}=p;if(!(a instanceof ArrayBuffer)){console.warn("UNKNOWN data received",a);return}const r=d.VSBuffer.wrap(new Uint8Array(a,0,a.byteLength));if((0,_.isMessageOfType)(r,2)){i=!0,I("received terminate message from renderer");return}C.fire(r)},this.protocol={onMessage:C.event,send:p=>{if(!i){const a=p.buffer.buffer.slice(p.buffer.byteOffset,p.buffer.byteOffset+p.buffer.byteLength);h.port1.postMessage(a,[a])}}}}}function g(o){return new Promise(h=>{const C=o.onMessage(i=>{C.dispose();const p=JSON.parse(i.toString());o.send((0,_.createMessageOfType)(0)),h({protocol:o,initData:p})});o.send((0,_.createMessageOfType)(1))})}let I=o=>y();function E(){const o=new u;D.mark("code/extHost/willConnectToRenderer"),g(o.protocol).then(h=>{D.mark("code/extHost/didWaitForInitData");const C=new A.ExtensionHostMain(h.protocol,h.initData,s,null);I=i=>C.terminate(i)})}e.create=E})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/97018d742e4ce3dfbcdb0a02c42c16c6c152e4e1/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
